(************** Content-type: application/mathematica **************
                     CreatedBy='Mathematica 5.0'

                    Mathematica-Compatible Notebook

This notebook can be used with any Mathematica-compatible
application, such as Mathematica, MathReader or Publicon. The data
for the notebook starts with the line containing stars above.

To get the notebook into a Mathematica-compatible application, do
one of the following:

* Save the data starting with the line of stars above into a file
  with a name ending in .nb, then open the file inside the
  application;

* Copy the data starting with the line of stars above to the
  clipboard, then use the Paste menu command inside the application.

Data for notebooks contains only printable 7-bit ASCII and can be
sent directly in email or through ftp in text mode.  Newlines can be
CR, LF or CRLF (Unix, Macintosh or MS-DOS style).

NOTE: If you modify the data for this notebook not in a Mathematica-
compatible application, you must delete the line below containing
the word CacheID, otherwise Mathematica-compatible applications may
try to use invalid cache data.

For more information on notebooks and Mathematica-compatible 
applications, contact Wolfram Research:
  web: http://www.wolfram.com
  email: info@wolfram.com
  phone: +1-217-398-0700 (U.S.)

Notebook reader applications are available free of charge from 
Wolfram Research.
*******************************************************************)

(*CacheID: 232*)


(*NotebookFileLineBreakTest
NotebookFileLineBreakTest*)
(*NotebookOptionsPosition[   1387270,      45874]*)
(*NotebookOutlinePosition[   1494437,      48158]*)
(*  CellTagsIndexPosition[   1492525,      48098]*)
(*WindowFrame->Normal*)



Notebook[{

Cell[CellGroupData[{
Cell["Getting Started", "Section",
  Evaluatable->False,
  AspectRatioFixed->True,
  CellTags->{"Getting Started", "b:18"}],

Cell[BoxData[{
    \(\(Off[General::spell];\)\), "\n", 
    \(\(Off[General::spell1];\)\)}], "Input",
  CellLabel->"In[1]:=",
  CellTags->"b:18"],

Cell[TextData[{
  "This notebook illustrates the tools provided in the linear control package \
(ControlL) including a few new functions contained in Version 3.0. ControlL \
is contained in the directory ProPac. ProPac can be placed anywhwere you \
like, but a search path must be defined for it. It is most convenient to \
place ProPac in the AddOns\\Applications directiory, i.e, C:\\Program \
Files\\Wolfram Research\\",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  "\\5.0\\AddOns\\Applications. Once ProPac is loaded all of the functions in \
Dynamics as well as other packages included in TSi ProPac will be available \
for use and loaded as when needed."
}], "Text",
  Evaluatable->False,
  CellHorizontalScrolling->False,
  AspectRatioFixed->True,
  CellTags->{"Getting Started", "b:18"}],

Cell[TextData[{
  "In ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  " 3 and above ProPac can be loaded with the command"
}], "Text",
  Evaluatable->False,
  CellHorizontalScrolling->False,
  AspectRatioFixed->True,
  CellTags->{"Getting Started", "b:18"}],

Cell[CellGroupData[{

Cell["<<ProPac`", "Input",
  CellLabel->"In[3]:=",
  PageWidth->Infinity,
  AspectRatioFixed->True,
  CellTags->{"Getting Started", "b:18"}],

Cell[BoxData[
    \("\n    This is ProPac - Development Version 3.xx\n \n ProPac has been \
successfully loaded. It contains several packages\n for multibody dynamics, \
linear control and nonlinear control.\n The package names are:\n    GeoTools\n\
    Dynamics\n    ControlL\n    ControlN\n    DifferentialForms\n    \
ObserverTools\n    NDTools\n    VSCTools\n    MatlabInterface\n    MEXTools\n \
Appropriate packages will be loaded automatically as required.\n To obtain a \
list of functions in a package and links to function\n declarations, enter:\n \
   ?ProPac`PackageName`*\n Help is also available in the Help Browser under \
Add-ons."\)], "Print",
  CellLabel->"From In[3]:=",
  CellTags->{"Getting Started", "b:18"}]
}, Open  ]],

Cell[TextData[{
  "With ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  " 2.2 use the command ProPac`Master`."
}], "Text",
  CellTags->{"Getting Started", "b:18"}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Basics of The Linear Package", "Section",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["What's in the Package", "Subsection",
  Evaluatable->False,
  AspectRatioFixed->True,
  CellTags->{"What's in the Package", "b:19.0"}],

Cell["\<\

We will demonstrate some of the functions in the linear control systems \
package ControL. First, load ProPac\
\>", "Text",
  Evaluatable->False,
  AspectRatioFixed->True,
  CellTags->{"What's in the Package", "b:19.0"}],

Cell[CellGroupData[{

Cell[BoxData[
    \(<< ProPac`\)], "Input",
  CellLabel->"In[4]:=",
  PageWidth->Infinity,
  AspectRatioFixed->True,
  CellTags->{"What's in the Package", "b:19.0"}],

Cell[BoxData[
    \("\n    This is ProPac - Development Version 3.xx\n \n ProPac has been \
successfully loaded. It contains several packages\n for multibody dynamics, \
linear control and nonlinear control.\n The package names are:\n    GeoTools\n\
    Dynamics\n    ControlL\n    ControlN\n    DifferentialForms\n    \
ObserverTools\n    NDTools\n    VSCTools\n    MatlabInterface\n    MEXTools\n \
Appropriate packages will be loaded automatically as required.\n To obtain a \
list of functions in a package and links to function\n declarations, enter:\n \
   ?ProPac`PackageName`*\n Help is also available in the Help Browser under \
Add-ons."\)], "Print",
  CellLabel->"From In[4]:=",
  CellTags->{"What's in the Package", "b:19.0"}]
}, Open  ]],

Cell["\<\
To obtain a list of functions available in the linear package ControlL:\
\>", "Text",
  Evaluatable->False,
  AspectRatioFixed->True,
  CellTags->{"What's in the Package", "b:19.0"}],

Cell[CellGroupData[{

Cell[BoxData[
    \(\(?ProPac`ControlL`*\)\)], "Input",
  CellLabel->"In[5]:=",
  CellTags->{"b:19.0", "What's in the Package"}],

Cell[BoxData[GridBox[{
        {
          StyleBox["ProPac`ControlL`",
            FontFamily->"Helvetica",
            FontSize->12,
            FontWeight->"Bold"]},
        {GridBox[{
              {
                ButtonBox[
                  StyleBox["AlgebraicRiccatiEquation",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3266692339-2979739", 
                    "ProPac`ControlL`AlgebraicRiccatiEquation"},
                  ButtonFrame->"None",
                  ButtonNote->"ProPac`ControlL`"], 
                ButtonBox[
                  StyleBox["LaurentSeries",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3266692339-2979739", 
                    "ProPac`ControlL`LaurentSeries"},
                  ButtonFrame->"None",
                  ButtonNote->"ProPac`ControlL`"], 
                ButtonBox[
                  StyleBox["ObservableRealization",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3266692339-2979739", 
                    "ProPac`ControlL`ObservableRealization"},
                  ButtonFrame->"None",
                  ButtonNote->"ProPac`ControlL`"]},
              {
                ButtonBox[
                  StyleBox["AssociatedHankelMatrix",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3266692339-2979739", 
                    "ProPac`ControlL`AssociatedHankelMatrix"},
                  ButtonFrame->"None",
                  ButtonNote->"ProPac`ControlL`"], 
                ButtonBox[
                  StyleBox["LeastCommonDenominator",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3266692339-2979739", 
                    "ProPac`ControlL`LeastCommonDenominator"},
                  ButtonFrame->"None",
                  ButtonNote->"ProPac`ControlL`"], 
                ButtonBox[
                  StyleBox["PolePlace",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3266692339-2979739", 
                    "ProPac`ControlL`PolePlace"},
                  ButtonFrame->"None",
                  ButtonNote->"ProPac`ControlL`"]},
              {
                ButtonBox[
                  StyleBox["BlockCompanionMatrix",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3266692339-2979739", 
                    "ProPac`ControlL`BlockCompanionMatrix"},
                  ButtonFrame->"None",
                  ButtonNote->"ProPac`ControlL`"], 
                ButtonBox[
                  StyleBox["LinearControl",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3266692339-2979739", 
                    "ProPac`ControlL`LinearControl"},
                  ButtonFrame->"None",
                  ButtonNote->"ProPac`ControlL`"], 
                ButtonBox[
                  StyleBox["Poles",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3266692339-2979739", 
                    "ProPac`ControlL`Poles"},
                  ButtonFrame->"None",
                  ButtonNote->"ProPac`ControlL`"]},
              {
                ButtonBox[
                  StyleBox["Bode",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3266692339-2979739", 
                    "ProPac`ControlL`Bode"},
                  ButtonFrame->"None",
                  ButtonNote->"ProPac`ControlL`"], 
                ButtonBox[
                  StyleBox["LQE",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3266692339-2979739", 
                    "ProPac`ControlL`LQE"},
                  ButtonFrame->"None",
                  ButtonNote->"ProPac`ControlL`"], 
                ButtonBox[
                  StyleBox["PoleZeroPlot",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3266692339-2979739", 
                    "ProPac`ControlL`PoleZeroPlot"},
                  ButtonFrame->"None",
                  ButtonNote->"ProPac`ControlL`"]},
              {
                ButtonBox[
                  StyleBox["ColorNyquist",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3266692339-2979739", 
                    "ProPac`ControlL`ColorNyquist"},
                  ButtonFrame->"None",
                  ButtonNote->"ProPac`ControlL`"], 
                ButtonBox[
                  StyleBox["LQR",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3266692339-2979739", 
                    "ProPac`ControlL`LQR"},
                  ButtonFrame->"None",
                  ButtonNote->"ProPac`ControlL`"], 
                ButtonBox[
                  StyleBox["RandomMatrix",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3266692339-2979739", 
                    "ProPac`ControlL`RandomMatrix"},
                  ButtonFrame->"None",
                  ButtonNote->"ProPac`ControlL`"]},
              {
                ButtonBox[
                  StyleBox["ControllabilityMatrix",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3266692339-2979739", 
                    "ProPac`ControlL`ControllabilityMatrix"},
                  ButtonFrame->"None",
                  ButtonNote->"ProPac`ControlL`"], 
                ButtonBox[
                  StyleBox["LyapunovEquation",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3266692339-2979739", 
                    "ProPac`ControlL`LyapunovEquation"},
                  ButtonFrame->"None",
                  ButtonNote->"ProPac`ControlL`"], 
                ButtonBox[
                  StyleBox["RangeSpace",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3266692339-2979739", 
                    "ProPac`ControlL`RangeSpace"},
                  ButtonFrame->"None",
                  ButtonNote->"ProPac`ControlL`"]},
              {
                ButtonBox[
                  StyleBox["ControllablePair",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3266692339-2979739", 
                    "ProPac`ControlL`ControllablePair"},
                  ButtonFrame->"None",
                  ButtonNote->"ProPac`ControlL`"], 
                ButtonBox[
                  StyleBox["MatrixRank",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3266692339-2979739", 
                    "ProPac`ControlL`MatrixRank"},
                  ButtonFrame->"None",
                  ButtonNote->"ProPac`ControlL`"], 
                ButtonBox[
                  StyleBox["RelativeDegree",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3266692339-2979739", 
                    "ProPac`ControlL`RelativeDegree"},
                  ButtonFrame->"None",
                  ButtonNote->"ProPac`ControlL`"]},
              {
                ButtonBox[
                  StyleBox["ControllableRealization",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3266692339-2979739", 
                    "ProPac`ControlL`ControllableRealization"},
                  ButtonFrame->"None",
                  ButtonNote->"ProPac`ControlL`"], 
                ButtonBox[
                  StyleBox["MatrixTrace",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3266692339-2979739", 
                    "ProPac`ControlL`MatrixTrace"},
                  ButtonFrame->"None",
                  ButtonNote->"ProPac`ControlL`"], 
                ButtonBox[
                  StyleBox["RootLocus",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3266692339-2979739", 
                    "ProPac`ControlL`RootLocus"},
                  ButtonFrame->"None",
                  ButtonNote->"ProPac`ControlL`"]},
              {
                ButtonBox[
                  StyleBox["DecouplingControl",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3266692339-2979739", 
                    "ProPac`ControlL`DecouplingControl"},
                  ButtonFrame->"None",
                  ButtonNote->"ProPac`ControlL`"], 
                ButtonBox[
                  StyleBox["McMillanDegree",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3266692339-2979739", 
                    "ProPac`ControlL`McMillanDegree"},
                  ButtonFrame->"None",
                  ButtonNote->"ProPac`ControlL`"], 
                ButtonBox[
                  StyleBox["StateSpaceToTransferFunction",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3266692339-2979739", 
                    "ProPac`ControlL`StateSpaceToTransferFunction"},
                  ButtonFrame->"None",
                  ButtonNote->"ProPac`ControlL`"]},
              {
                ButtonBox[
                  StyleBox["InverseNyquist",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3266692339-2979739", 
                    "ProPac`ControlL`InverseNyquist"},
                  ButtonFrame->"None",
                  ButtonNote->"ProPac`ControlL`"], 
                ButtonBox[
                  StyleBox["MinimalRealization",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3266692339-2979739", 
                    "ProPac`ControlL`MinimalRealization"},
                  ButtonFrame->"None",
                  ButtonNote->"ProPac`ControlL`"], 
                ButtonBox[
                  StyleBox["TaylorLinearize",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3266692339-2979739", 
                    "ProPac`ControlL`TaylorLinearize"},
                  ButtonFrame->"None",
                  ButtonNote->"ProPac`ControlL`"]},
              {
                ButtonBox[
                  StyleBox["Jacobian",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3266692339-2979739", 
                    "ProPac`ControlL`Jacobian"},
                  ButtonFrame->"None",
                  ButtonNote->"ProPac`ControlL`"], 
                ButtonBox[
                  StyleBox["Nyquist",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3266692339-2979739", 
                    "ProPac`ControlL`Nyquist"},
                  ButtonFrame->"None",
                  ButtonNote->"ProPac`ControlL`"], 
                ButtonBox[
                  StyleBox["Until",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3266692339-2979739", 
                    "ProPac`ControlL`Until"},
                  ButtonFrame->"None",
                  ButtonNote->"ProPac`ControlL`"]},
              {
                ButtonBox[
                  StyleBox["KalmanDecomposition",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3266692339-2979739", 
                    "ProPac`ControlL`KalmanDecomposition"},
                  ButtonFrame->"None",
                  ButtonNote->"ProPac`ControlL`"], 
                ButtonBox[
                  StyleBox["ObservabilityMatrix",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3266692339-2979739", 
                    "ProPac`ControlL`ObservabilityMatrix"},
                  ButtonFrame->"None",
                  ButtonNote->"ProPac`ControlL`"], 
                ButtonBox[
                  StyleBox["Zeros",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3266692339-2979739", 
                    "ProPac`ControlL`Zeros"},
                  ButtonFrame->"None",
                  ButtonNote->"ProPac`ControlL`"]},
              {
                ButtonBox[
                  StyleBox["Kernel",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3266692339-2979739", 
                    "ProPac`ControlL`Kernel"},
                  ButtonFrame->"None",
                  ButtonNote->"ProPac`ControlL`"], 
                ButtonBox[
                  StyleBox["ObservablePair",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3266692339-2979739", 
                    "ProPac`ControlL`ObservablePair"},
                  ButtonFrame->"None",
                  ButtonNote->"ProPac`ControlL`"], ""}
              },
            RowMinHeight->{1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1.05}]}
        },
      RowSpacings->{2, 3},
      ColumnAlignments->{Left},
      ColumnsEqual->True]], "Print",
  CellMargins->{{20, Inherited}, {Inherited, Inherited}},
  ShowCellLabel->False,
  CellFrameMargins->{{Inherited, Inherited}, {14, 14}},
  Background->RGBColor[0.964706, 0.929412, 0.839216],
  ButtonBoxOptions->{Active->True},
  CellTags->{"b:19.0", "What's in the Package"}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Linearization", "Subsection",
  Evaluatable->False,
  AspectRatioFixed->True,
  CellTags->{"Linearization", "i:1", "b:19.1"}],

Cell["Define a nonlinear system:", "Text",
  Evaluatable->False,
  AspectRatioFixed->True,
  CellTags->{"Linearization", "i:1", "b:19.1"}],

Cell[CellGroupData[{

Cell[BoxData[
    \(f = {x1\^2\ Sin[x1] - x2 + u1\ u2, \(-x2\) + x2\^3 + u1 + 
          3\ u2}\)], "Input",
  CellLabel->"In[6]:=",
  PageWidth->Infinity,
  AspectRatioFixed->True,
  CellTags->{"Linearization", "i:1", "b:19.1"}],

Cell[BoxData[
    \({u1\ u2 - x2 + x1\^2\ Sin[x1], u1 + 3\ u2 - x2 + x2\^3}\)], "Output",
  CellLabel->"Out[6]=",
  CellTags->{"Linearization", "i:1", "b:19.1"}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(g = {x1 + x2, x2 + u2\^2}\)], "Input",
  CellLabel->"In[7]:=",
  PageWidth->Infinity,
  AspectRatioFixed->True,
  CellTags->{"Linearization", "i:1", "b:19.1"}],

Cell[BoxData[
    \({x1 + x2, u2\^2 + x2}\)], "Output",
  CellLabel->"Out[7]=",
  CellTags->{"Linearization", "i:1", "b:19.1"}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(x = {x1, x2}\)], "Input",
  CellLabel->"In[8]:=",
  PageWidth->Infinity,
  AspectRatioFixed->True,
  CellTags->{"Linearization", "i:1", "b:19.1"}],

Cell[BoxData[
    \({x1, x2}\)], "Output",
  CellLabel->"Out[8]=",
  CellTags->{"Linearization", "i:1", "b:19.1"}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(u = {u1, u2}\)], "Input",
  CellLabel->"In[9]:=",
  PageWidth->Infinity,
  AspectRatioFixed->True,
  CellTags->{"Linearization", "i:1", "b:19.1"}],

Cell[BoxData[
    \({u1, u2}\)], "Output",
  CellLabel->"Out[9]=",
  CellTags->{"Linearization", "i:1", "b:19.1"}]
}, Open  ]],

Cell["\<\
Now, linearize it about the equilibrium point x=(0,0), u=(0,0)\
\>", "Text",
  Evaluatable->False,
  AspectRatioFixed->True,
  CellTags->{"Linearization", "i:1", "b:19.1"}],

Cell[CellGroupData[{

Cell[BoxData[
    \({A1, B1, C1, D1} = 
      TaylorLinearize[f, g, x, {0, 0}, u, {0, 0}]\)], "Input",
  CellLabel->"In[10]:=",
  PageWidth->Infinity,
  AspectRatioFixed->True,
  CellTags->{"Linearization", "i:1", "b:19.1"}],

Cell[BoxData[
    \("  *** LinearControl successfully loaded ***"\)], "Print",
  CellLabel->"From In[10]:=",
  CellTags->{"Linearization", "i:1", "b:19.1"}],

Cell[BoxData[
    \({{{0, \(-1\)}, {0, \(-1\)}}, {{0, 0}, {1, 3}}, {{1, 1}, {0, 1}}, {{0, 
          0}, {0, 0}}}\)], "Output",
  CellLabel->"Out[10]=",
  CellTags->{"Linearization", "i:1", "b:19.1"}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Poles & Zeros", "Subsection",
  CellTags->{"Poles and Zeros", "i:2", "b:19.2"}],

Cell[TextData[{
  "The functions ",
  StyleBox["Poles",
    FontFamily->"Courier New"],
  " and ",
  StyleBox["Zeros",
    FontFamily->"Courier New"],
  " compute, respectively, the system poles and (transmission) zeros from its \
transfer matrix.  ",
  StyleBox["Poles",
    FontFamily->"Courier New"],
  " computes the roots of the least common denominator of minors of all \
orders and ",
  StyleBox["Zeros",
    FontFamily->"Courier New"],
  " computes the roots of the greatest common multiple of minors of order \
k=Rank[G[s]]. Hence these are the poles and zeros of a minimal realization of \
G[s]."
}], "Text",
  CellTags->{"Poles and Zeros", "i:2", "b:19.2"}],

Cell[BoxData[{
    \(G[s_] := {{\((s - 1)\)*\((s + 2)\), 
            0, \((s - 1)\)^2}, {\(-\((s + 1)\)\)*\((s + 2)\), \((s - 
                  1)\)*\((s + 1)\), \((s - 1)\)*\((s + 1)\)}}/\((\((s + 
                1)\)*\((s + 2)\)*\((s - 1)\))\)\), "\n", 
    \(H[s_] := {{s - 1, s}, {\(-6\), 
            s - 2}}/\((1.25*\((s + 1)\)*\((s + 2)\))\)\)}], "Input",
  CellLabel->"In[11]:=",
  CellTags->{"Poles and Zeros", "i:2", "b:19.2"}],

Cell[CellGroupData[{

Cell[BoxData[
    \(G[s] // MatrixForm\)], "Input",
  CellLabel->"In[13]:=",
  CellTags->{"Poles and Zeros", "i:2", "b:19.2"}],

Cell[BoxData[
    TagBox[
      RowBox[{"(", "\[NoBreak]", GridBox[{
            {\(1\/\(1 + s\)\), 
              "0", \(\(\(-1\) + s\)\/\(\((1 + s)\)\ \((2 + s)\)\)\)},
            {\(\(\(-1\) - 
                    s\)\/\(\((\(-1\) + s)\)\ \((1 + s)\)\)\), \(1\/\(2 + 
                    s\)\), \(1\/\(2 + s\)\)}
            }], "\[NoBreak]", ")"}],
      Function[ BoxForm`e$, 
        MatrixForm[ BoxForm`e$]]]], "Output",
  CellLabel->"Out[13]//MatrixForm=",
  CellTags->{"Poles and Zeros", "i:2", "b:19.2"}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(H[s] // MatrixForm\)], "Input",
  CellLabel->"In[14]:=",
  CellTags->{"Poles and Zeros", "i:2", "b:19.2"}],

Cell[BoxData[
    TagBox[
      RowBox[{"(", "\[NoBreak]", GridBox[{
            {\(\(0.8`\ \((\(-1\) + s)\)\)\/\(\((1 + s)\)\ \((2 + 
                        s)\)\)\), \(\(0.8`\ s\)\/\(\((1 + s)\)\ \((2 + 
                        s)\)\)\)},
            {\(-\(4.800000000000001`\/\(\((1 + s)\)\ \((2 + 
                          s)\)\)\)\), \(\(0.8`\ \((\(-2\) + s)\)\)\/\(\((1 + 
                        s)\)\ \((2 + s)\)\)\)}
            }], "\[NoBreak]", ")"}],
      Function[ BoxForm`e$, 
        MatrixForm[ BoxForm`e$]]]], "Output",
  CellLabel->"Out[14]//MatrixForm=",
  CellTags->{"Poles and Zeros", "i:2", "b:19.2"}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Poles[G, s]\)], "Input",
  CellLabel->"In[15]:=",
  CellTags->{"Poles and Zeros", "i:2", "b:19.2"}],

Cell[BoxData[
    \({{\(-2\), 2}, {\(-1\), 1}, {1, 1}}\)], "Output",
  CellLabel->"Out[15]=",
  CellTags->{"Poles and Zeros", "i:2", "b:19.2"}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Poles[H, s]\)], "Input",
  CellLabel->"In[16]:=",
  CellTags->{"Poles and Zeros", "i:2", "b:19.2"}],

Cell[BoxData[
    \({{\(-2\), 1}, {\(-1\), 1}}\)], "Output",
  CellLabel->"Out[16]=",
  CellTags->{"Poles and Zeros", "i:2", "b:19.2"}]
}, Open  ]],

Cell[BoxData[{
    \(G[s_] := {{\((s - 1)\)*\((s + 2)\), 
            0, \((s - 1)\)^2}, {\(-\((s + 1)\)\)*\((s + 2)\), \((s - 
                  1)\)*\((s + 1)\), \((s - 1)\)*\((s + 1)\)}}/\((\((s + 
                1)\)*\((s + 2)\)*\((s - 1)\))\)\), "\n", 
    \(H[s_] := {{s - 1, s}, {\(-6\), 
            s - 2}}/\((1.25*\((s + 1)\)*\((s + 2)\))\)\), "\n", 
    \(K[s_] := {{s - 1, 4}, {4.5, 2*\((s - 1)\)}}/\((s + 2)\)\)}], "Input",
  CellLabel->"In[17]:=",
  CellTags->{"Poles and Zeros", "i:2", "b:19.2"}],

Cell[CellGroupData[{

Cell[BoxData[
    \(G[s] // MatrixForm\)], "Input",
  CellLabel->"In[20]:=",
  CellTags->{"Poles and Zeros", "i:2", "b:19.2"}],

Cell[BoxData[
    TagBox[
      RowBox[{"(", "\[NoBreak]", GridBox[{
            {\(1\/\(1 + s\)\), 
              "0", \(\(\(-1\) + s\)\/\(\((1 + s)\)\ \((2 + s)\)\)\)},
            {\(\(\(-1\) - 
                    s\)\/\(\((\(-1\) + s)\)\ \((1 + s)\)\)\), \(1\/\(2 + 
                    s\)\), \(1\/\(2 + s\)\)}
            }], "\[NoBreak]", ")"}],
      Function[ BoxForm`e$, 
        MatrixForm[ BoxForm`e$]]]], "Output",
  CellLabel->"Out[20]//MatrixForm=",
  CellTags->{"Poles and Zeros", "i:2", "b:19.2"}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(H[s] // MatrixForm\)], "Input",
  CellLabel->"In[21]:=",
  CellTags->{"Poles and Zeros", "i:2", "b:19.2"}],

Cell[BoxData[
    TagBox[
      RowBox[{"(", "\[NoBreak]", GridBox[{
            {\(\(0.8`\ \((\(-1\) + s)\)\)\/\(\((1 + s)\)\ \((2 + 
                        s)\)\)\), \(\(0.8`\ s\)\/\(\((1 + s)\)\ \((2 + 
                        s)\)\)\)},
            {\(-\(4.800000000000001`\/\(\((1 + s)\)\ \((2 + 
                          s)\)\)\)\), \(\(0.8`\ \((\(-2\) + s)\)\)\/\(\((1 + 
                        s)\)\ \((2 + s)\)\)\)}
            }], "\[NoBreak]", ")"}],
      Function[ BoxForm`e$, 
        MatrixForm[ BoxForm`e$]]]], "Output",
  CellLabel->"Out[21]//MatrixForm=",
  CellTags->{"Poles and Zeros", "i:2", "b:19.2"}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(K[s] // MatrixForm\)], "Input",
  CellLabel->"In[22]:=",
  CellTags->{"Poles and Zeros", "i:2", "b:19.2"}],

Cell[BoxData[
    TagBox[
      RowBox[{"(", "\[NoBreak]", GridBox[{
            {\(\(\(-1\) + s\)\/\(2 + s\)\), \(4\/\(2 + s\)\)},
            {\(4.5`\/\(2 + s\)\), \(\(2\ \((\(-1\) + s)\)\)\/\(2 + s\)\)}
            }], "\[NoBreak]", ")"}],
      Function[ BoxForm`e$, 
        MatrixForm[ BoxForm`e$]]]], "Output",
  CellLabel->"Out[22]//MatrixForm=",
  CellTags->{"Poles and Zeros", "i:2", "b:19.2"}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Zeros[G, s]\)], "Input",
  CellLabel->"In[23]:=",
  CellTags->{"Poles and Zeros", "i:2", "b:19.2"}],

Cell[BoxData[
    \({{1, 1}}\)], "Output",
  CellLabel->"Out[23]=",
  CellTags->{"Poles and Zeros", "i:2", "b:19.2"}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Zeros[H, s]\)], "Input",
  CellLabel->"In[24]:=",
  CellTags->{"Poles and Zeros", "i:2", "b:19.2"}],

Cell[BoxData[
    \({}\)], "Output",
  CellLabel->"Out[24]=",
  CellTags->{"Poles and Zeros", "i:2", "b:19.2"}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Zeros[K, s]\)], "Input",
  CellLabel->"In[25]:=",
  CellTags->{"Poles and Zeros", "i:2", "b:19.2"}],

Cell[BoxData[
    \({{4, 1}}\)], "Output",
  CellLabel->"Out[25]=",
  CellTags->{"Poles and Zeros", "i:2", "b:19.2"}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["State Space to Transfer Function and Back", "Subsection",
  Evaluatable->False,
  AspectRatioFixed->True,
  CellTags->{"State Space to Transfer Function and Back", "i:3", "b:19.3"}],

Cell["Convert the state space description to a transfer function:", "Text",
  Evaluatable->False,
  AspectRatioFixed->True,
  CellTags->{"State Space to Transfer Function and Back", "i:3", "b:19.3"}],

Cell[CellGroupData[{

Cell[BoxData[{
    \(G1[s_] := StateSpaceToTransferFunction[A1, B1, C1, D1, s]\), "\n", 
    \(G1[s]\)}], "Input",
  CellLabel->"In[26]:=",
  PageWidth->Infinity,
  AspectRatioFixed->True,
  CellTags->{"State Space to Transfer Function and Back", "i:3", "b:19.3"}],

Cell[BoxData[
    \({{\(\(-1\) + s\)\/\(s\ \((1 + s)\)\), \(3\ \((\(-1\) + s)\)\)\/\(s\ \
\((1 + s)\)\)}, {1\/\(1 + s\), 3\/\(1 + s\)}}\)], "Output",
  CellLabel->"Out[27]=",
  CellTags->{"State Space to Transfer Function and Back", "i:3", "b:19.3"}]
}, Open  ]],

Cell["\<\
Now, convert back to state space by finding a controllable realization:\
\>", "Text",
  Evaluatable->False,
  AspectRatioFixed->True,
  CellTags->{"State Space to Transfer Function and Back", "i:3", "b:19.3"}],

Cell[CellGroupData[{

Cell[BoxData[
    \({A2, B2, C2} = ControllableRealization[G1, s]\)], "Input",
  CellLabel->"In[28]:=",
  PageWidth->Infinity,
  AspectRatioFixed->True,
  CellTags->{"State Space to Transfer Function and Back", "i:3", "b:19.3"}],

Cell[BoxData[
    \({{{0, 0, 1, 0}, {0, 0, 0, 1}, {0, 0, \(-1\), 0}, {0, 0, 
          0, \(-1\)}}, {{0, 0}, {0, 0}, {1, 0}, {0, 1}}, {{\(-1\), \(-3\), 1, 
          3}, {0, 0, 1, 3}}}\)], "Output",
  CellLabel->"Out[28]=",
  CellTags->{"State Space to Transfer Function and Back", "i:3", "b:19.3"}]
}, Open  ]],

Cell["Is the controllable realization observable?", "Text",
  Evaluatable->False,
  AspectRatioFixed->True,
  CellTags->{"State Space to Transfer Function and Back", "i:3", "b:19.3"}],

Cell[CellGroupData[{

Cell[BoxData[
    \(ObservablePair[A2, C2]\)], "Input",
  CellLabel->"In[29]:=",
  PageWidth->Infinity,
  AspectRatioFixed->True,
  CellTags->{"State Space to Transfer Function and Back", "i:3", "b:19.3"}],

Cell[BoxData[
    \(False\)], "Output",
  CellLabel->"Out[29]=",
  CellTags->{"State Space to Transfer Function and Back", "i:3", "b:19.3"}]
}, Open  ]],

Cell["Let's construct a transfer function for this realization", "Text",
  Evaluatable->False,
  AspectRatioFixed->True,
  CellTags->{"State Space to Transfer Function and Back", "i:3", "b:19.3"}],

Cell[CellGroupData[{

Cell[BoxData[{
    \(G2[s_] := StateSpaceToTransferFunction[A2, B2, C2, s]\), "\n", 
    \(G2[s]\)}], "Input",
  CellLabel->"In[30]:=",
  PageWidth->Infinity,
  AspectRatioFixed->True,
  CellTags->{"State Space to Transfer Function and Back", "i:3", "b:19.3"}],

Cell[BoxData[
    \({{\(\(-1\) + s\)\/\(s\ \((1 + s)\)\), \(3\ \((\(-1\) + s)\)\)\/\(s\ \
\((1 + s)\)\)}, {1\/\(1 + s\), 3\/\(1 + s\)}}\)], "Output",
  CellLabel->"Out[31]=",
  CellTags->{"State Space to Transfer Function and Back", "i:3", "b:19.3"}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Minimal Realization", "Subsection",
  CellTags->{"Minimal Realization", "i:4", "b:19.4"}],

Cell["\<\
The function MinimalRealization can be used to construct a minimal (or \
irreducible) realization. It always retuns the system parameters in Jordan \
form. \
\>", "Text",
  CellTags->{"Minimal Realization", "i:4", "b:19.4"}],

Cell[BoxData[
    \(\(H[s_] := 
        Together[
          Outer[Times, {1, 1, 1}, {1, 0, 0}]/\((s + p)\)^3 + 
            Outer[Times, {0, 1, 0}, {0, 1, 0}]/\((s + p)\)^3 + 
            Outer[Times, {1, 0, 1}, {1, 0, 0}]/\((s + p)\)^2 + 
            Outer[Times, {2, 5, 2}, {0, 0, 1}]/\((s + p)\)^2 + 
            Outer[Times, {2, 2, 3}, {\(-1\), \(-1\), 0}]/\((s + 
                  p)\)];\)\)], "Input",
  CellLabel->"In[32]:=",
  CellTags->{"Minimal Realization", "i:4", "b:19.4"}],

Cell[CellGroupData[{

Cell[BoxData[{
    \(H[s] // MatrixForm\), "\n", 
    \(\({AA, BB, CC, DD} = MinimalRealization[H, s];\)\), "\n", 
    \(AA // MatrixForm\), "\n", 
    \(BB // MatrixForm\), "\n", 
    \(CC // MatrixForm\), "\n", 
    \(DD // MatrixForm\)}], "Input",
  CellLabel->"In[33]:=",
  CellTags->{"Minimal Realization", "i:4", "b:19.4"}],

Cell[BoxData[
    TagBox[
      RowBox[{"(", "\[NoBreak]", GridBox[{
            {\(\(1 + p - 2\ p\^2 + s - 4\ p\ s - 
                    2\ s\^2\)\/\((p + s)\)\^3\), \(-\(2\/\(p + 
                      s\)\)\), \(2\/\((p + s)\)\^2\)},
            {\(\(1 - 2\ p\^2 - 4\ p\ s - 2\ s\^2\)\/\((p + s)\)\^3\), \(\(1 - 
                    2\ p\^2 - 4\ p\ s - 
                    2\ s\^2\)\/\((p + s)\)\^3\), \(5\/\((p + s)\)\^2\)},
            {\(\(1 + p - 3\ p\^2 + s - 6\ p\ s - 
                    3\ s\^2\)\/\((p + s)\)\^3\), \(-\(3\/\(p + 
                      s\)\)\), \(2\/\((p + s)\)\^2\)}
            }], "\[NoBreak]", ")"}],
      Function[ BoxForm`e$, 
        MatrixForm[ BoxForm`e$]]]], "Output",
  CellLabel->"Out[33]//MatrixForm=",
  CellTags->{"Minimal Realization", "i:4", "b:19.4"}],

Cell[BoxData[
    \("Eliminating nonobservable states."\)], "Print",
  CellLabel->"From In[33]:=",
  CellTags->{"Minimal Realization", "i:4", "b:19.4"}],

Cell[BoxData[
    TagBox[
      RowBox[{"(", "\[NoBreak]", GridBox[{
            {\(-p\), "1", "0", "0", "0", "0"},
            {"0", \(-p\), "1", "0", "0", "0"},
            {"0", "0", \(-p\), "0", "0", "0"},
            {"0", "0", "0", \(-p\), "1", "0"},
            {"0", "0", "0", "0", \(-p\), "1"},
            {"0", "0", "0", "0", "0", \(-p\)}
            }], "\[NoBreak]", ")"}],
      Function[ BoxForm`e$, 
        MatrixForm[ BoxForm`e$]]]], "Output",
  CellLabel->"Out[35]//MatrixForm=",
  CellTags->{"Minimal Realization", "i:4", "b:19.4"}],

Cell[BoxData[
    TagBox[
      RowBox[{"(", "\[NoBreak]", GridBox[{
            {"0", "0", \(-2\)},
            {"0", "0", "2"},
            {"1", "0", "0"},
            {"0", "0", "2"},
            {"0", "0", "3"},
            {"0", "1", "0"}
            }], "\[NoBreak]", ")"}],
      Function[ BoxForm`e$, 
        MatrixForm[ BoxForm`e$]]]], "Output",
  CellLabel->"Out[36]//MatrixForm=",
  CellTags->{"Minimal Realization", "i:4", "b:19.4"}],

Cell[BoxData[
    TagBox[
      RowBox[{"(", "\[NoBreak]", GridBox[{
            {"1", "1", \(-2\), "0", "0", \(-2\)},
            {"1", "0", \(-2\), "1", "0", \(-2\)},
            {"1", "1", \(-3\), "0", "0", \(-3\)}
            }], "\[NoBreak]", ")"}],
      Function[ BoxForm`e$, 
        MatrixForm[ BoxForm`e$]]]], "Output",
  CellLabel->"Out[37]//MatrixForm=",
  CellTags->{"Minimal Realization", "i:4", "b:19.4"}],

Cell[BoxData[
    TagBox[
      RowBox[{"(", "\[NoBreak]", GridBox[{
            {"0", "0", "0"},
            {"0", "0", "0"},
            {"0", "0", "0"}
            }], "\[NoBreak]", ")"}],
      Function[ BoxForm`e$, 
        MatrixForm[ BoxForm`e$]]]], "Output",
  CellLabel->"Out[38]//MatrixForm=",
  CellTags->{"Minimal Realization", "i:4", "b:19.4"}]
}, Open  ]],

Cell[BoxData[
    \(\(H[s_] := 
        N[Together[
            Outer[Times, {1, 1, 1}, {1, 0, 0}]/\((s + p)\)^3 + 
              Outer[Times, {0, 1, 0}, {0, 1, 0}]/\((s + p)\)^3 + 
              Outer[Times, {1, 0, 1}, {1, 0, 0}]/\((s + p)\)^2 + 
              Outer[Times, {2, 5, 2}, {0, 0, 1}]/\((s + p)\)^2 + 
              Outer[Times, {2, 2, 3}, {\(-1\), \(-1\), 0}]/\((s + 
                    p)\)]];\)\)], "Input",
  CellLabel->"In[39]:=",
  CellTags->{"Minimal Realization", "i:4", "b:19.4"}],

Cell[CellGroupData[{

Cell[BoxData[{
    \(H[s] // MatrixForm\), "\n", 
    \(\({AA, BB, CC, DD} = MinimalRealization[H, s];\)\), "\n", 
    \(AA // MatrixForm\), "\n", 
    \(BB // MatrixForm\), "\n", 
    \(CC // MatrixForm\), "\n", 
    \(DD // MatrixForm\)}], "Input",
  CellLabel->"In[40]:=",
  CellTags->{"Minimal Realization", "i:4", "b:19.4"}],

Cell[BoxData[
    TagBox[
      RowBox[{"(", "\[NoBreak]", GridBox[{
            {\(\(\(\(1.`\)\(\[InvisibleSpace]\)\) + p - 2.`\ p\^2 + s - 
                    4.`\ p\ s - 
                    2.`\ s\^2\)\/\((p + s)\)\^3\), \(-\(2.`\/\(p + 
                      s\)\)\), \(2.`\/\((p + s)\)\^2\)},
            {\(\(\(\(1.`\)\(\[InvisibleSpace]\)\) - 2.`\ p\^2 - 4.`\ p\ s - 
                    2.`\ s\^2\)\/\((p + s)\)\^3\), \(\(\(\(1.`\)\(\
\[InvisibleSpace]\)\) - 2.`\ p\^2 - 4.`\ p\ s - 
                    2.`\ s\^2\)\/\((p + s)\)\^3\), \(5.`\/\((p + s)\)\^2\)},
            {\(\(\(\(1.`\)\(\[InvisibleSpace]\)\) + p - 3.`\ p\^2 + s - 
                    6.`\ p\ s - 
                    3.`\ s\^2\)\/\((p + s)\)\^3\), \(-\(3.`\/\(p + 
                      s\)\)\), \(2.`\/\((p + s)\)\^2\)}
            }], "\[NoBreak]", ")"}],
      Function[ BoxForm`e$, 
        MatrixForm[ BoxForm`e$]]]], "Output",
  CellLabel->"Out[40]//MatrixForm=",
  CellTags->{"Minimal Realization", "i:4", "b:19.4"}],

Cell[BoxData[
    \("Eliminating nonobservable states."\)], "Print",
  CellLabel->"From In[40]:=",
  CellTags->{"Minimal Realization", "i:4", "b:19.4"}],

Cell[BoxData[
    TagBox[
      RowBox[{"(", "\[NoBreak]", GridBox[{
            {\(-p\), "1", "0", "0", "0", "0"},
            {"0", \(-p\), "1", "0", "0", "0"},
            {"0", "0", \(-p\), "0", "0", "0"},
            {"0", "0", "0", \(-p\), "1", "0"},
            {"0", "0", "0", "0", \(-p\), "1"},
            {"0", "0", "0", "0", "0", \(-p\)}
            }], "\[NoBreak]", ")"}],
      Function[ BoxForm`e$, 
        MatrixForm[ BoxForm`e$]]]], "Output",
  CellLabel->"Out[42]//MatrixForm=",
  CellTags->{"Minimal Realization", "i:4", "b:19.4"}],

Cell[BoxData[
    TagBox[
      RowBox[{"(", "\[NoBreak]", GridBox[{
            {"0", "0", \(-2\)},
            {"0", "0", "2"},
            {"1", "0", "0"},
            {"0", "0", "2"},
            {"0", "0", "3"},
            {"0", "1", "0"}
            }], "\[NoBreak]", ")"}],
      Function[ BoxForm`e$, 
        MatrixForm[ BoxForm`e$]]]], "Output",
  CellLabel->"Out[43]//MatrixForm=",
  CellTags->{"Minimal Realization", "i:4", "b:19.4"}],

Cell[BoxData[
    TagBox[
      RowBox[{"(", "\[NoBreak]", GridBox[{
            {"1", "1", \(-2\), "0", "0", \(-2\)},
            {"1", "0", \(-2\), "1", "0", \(-2\)},
            {"1", "1", \(-3\), "0", "0", \(-3\)}
            }], "\[NoBreak]", ")"}],
      Function[ BoxForm`e$, 
        MatrixForm[ BoxForm`e$]]]], "Output",
  CellLabel->"Out[44]//MatrixForm=",
  CellTags->{"Minimal Realization", "i:4", "b:19.4"}],

Cell[BoxData[
    TagBox[
      RowBox[{"(", "\[NoBreak]", GridBox[{
            {"0", "0", "0"},
            {"0", "0", "0"},
            {"0", "0", "0"}
            }], "\[NoBreak]", ")"}],
      Function[ BoxForm`e$, 
        MatrixForm[ BoxForm`e$]]]], "Output",
  CellLabel->"Out[45]//MatrixForm=",
  CellTags->{"Minimal Realization", "i:4", "b:19.4"}]
}, Open  ]],

Cell[BoxData[
    \(G[s_] := {{1/\((\((s + 2)\)^3\ \((s + 5)\))\), 
          1/\((s + 5)\)}, {1/\((s + 2)\), 0}}\)], "Input",
  CellLabel->"In[46]:=",
  CellTags->{"Minimal Realization", "i:4", "b:19.4"}],

Cell[CellGroupData[{

Cell[BoxData[
    \(G[s] // MatrixForm\)], "Input",
  CellLabel->"In[47]:=",
  CellTags->{"Minimal Realization", "i:4", "b:19.4"}],

Cell[BoxData[
    TagBox[
      RowBox[{"(", "\[NoBreak]", GridBox[{
            {\(1\/\(\((2 + s)\)\^3\ \((5 + s)\)\)\), \(1\/\(5 + s\)\)},
            {\(1\/\(2 + s\)\), "0"}
            }], "\[NoBreak]", ")"}],
      Function[ BoxForm`e$, 
        MatrixForm[ BoxForm`e$]]]], "Output",
  CellLabel->"Out[47]//MatrixForm=",
  CellTags->{"Minimal Realization", "i:4", "b:19.4"}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
    \(\({AA, BB, CC, DD} = MinimalRealization[G, s];\)\), "\n", 
    \(AA // MatrixForm\), "\n", 
    \(BB // MatrixForm\), "\n", 
    \(CC // MatrixForm\), "\n", 
    \(DD // MatrixForm\)}], "Input",
  CellLabel->"In[48]:=",
  CellTags->{"Minimal Realization", "i:4", "b:19.4"}],

Cell[BoxData[
    TagBox[
      RowBox[{"(", "\[NoBreak]", GridBox[{
            {\(-2\), "1", "0", "0"},
            {"0", \(-2\), "1", "0"},
            {"0", "0", \(-2\), "0"},
            {"0", "0", "0", \(-5\)}
            }], "\[NoBreak]", ")"}],
      Function[ BoxForm`e$, 
        MatrixForm[ BoxForm`e$]]]], "Output",
  CellLabel->"Out[49]//MatrixForm=",
  CellTags->{"Minimal Realization", "i:4", "b:19.4"}],

Cell[BoxData[
    TagBox[
      RowBox[{"(", "\[NoBreak]", GridBox[{
            {"0", "0"},
            {"0", "0"},
            {"1", "0"},
            {"1", \(-27\)}
            }], "\[NoBreak]", ")"}],
      Function[ BoxForm`e$, 
        MatrixForm[ BoxForm`e$]]]], "Output",
  CellLabel->"Out[50]//MatrixForm=",
  CellTags->{"Minimal Realization", "i:4", "b:19.4"}],

Cell[BoxData[
    TagBox[
      RowBox[{"(", "\[NoBreak]", GridBox[{
            {\(1\/3\), \(-\(1\/9\)\), \(1\/27\), \(-\(730\/27\)\)},
            {"0", "0", "1", "0"}
            }], "\[NoBreak]", ")"}],
      Function[ BoxForm`e$, 
        MatrixForm[ BoxForm`e$]]]], "Output",
  CellLabel->"Out[51]//MatrixForm=",
  CellTags->{"Minimal Realization", "i:4", "b:19.4"}],

Cell[BoxData[
    TagBox[
      RowBox[{"(", "\[NoBreak]", GridBox[{
            {"0", "0"},
            {"0", "0"}
            }], "\[NoBreak]", ")"}],
      Function[ BoxForm`e$, 
        MatrixForm[ BoxForm`e$]]]], "Output",
  CellLabel->"Out[52]//MatrixForm=",
  CellTags->{"Minimal Realization", "i:4", "b:19.4"}]
}, Open  ]],

Cell[BoxData[
    \(G[s_] := 
      Together[{{1 + 1/\((\((s + 2)\)^3*\((s + 5)\))\), 
            1/\((s + 5)\)}, {1/\((s + 2)\), 1}}]\)], "Input",
  CellLabel->"In[53]:=",
  CellTags->{"Minimal Realization", "i:4", "b:19.4"}],

Cell[CellGroupData[{

Cell[BoxData[
    \(G[s] // MatrixForm\)], "Input",
  CellLabel->"In[54]:=",
  CellTags->{"Minimal Realization", "i:4", "b:19.4"}],

Cell[BoxData[
    TagBox[
      RowBox[{"(", "\[NoBreak]", GridBox[{
            {\(\(41 + 68\ s + 42\ s\^2 + 11\ s\^3 + 
                    s\^4\)\/\(\((2 + s)\)\^3\ \((5 + s)\)\)\), \(1\/\(5 + 
                    s\)\)},
            {\(1\/\(2 + s\)\), "1"}
            }], "\[NoBreak]", ")"}],
      Function[ BoxForm`e$, 
        MatrixForm[ BoxForm`e$]]]], "Output",
  CellLabel->"Out[54]//MatrixForm=",
  CellTags->{"Minimal Realization", "i:4", "b:19.4"}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
    \(\({AA, BB, CC, DD} = MinimalRealization[G, s];\)\), "\n", 
    \(AA // MatrixForm\), "\n", 
    \(BB // MatrixForm\), "\n", 
    \(CC // MatrixForm\), "\n", 
    \(DD // MatrixForm\)}], "Input",
  CellLabel->"In[55]:=",
  CellTags->{"Minimal Realization", "i:4", "b:19.4"}],

Cell[BoxData[
    TagBox[
      RowBox[{"(", "\[NoBreak]", GridBox[{
            {\(-2\), "1", "0", "0"},
            {"0", \(-2\), "1", "0"},
            {"0", "0", \(-2\), "0"},
            {"0", "0", "0", \(-5\)}
            }], "\[NoBreak]", ")"}],
      Function[ BoxForm`e$, 
        MatrixForm[ BoxForm`e$]]]], "Output",
  CellLabel->"Out[56]//MatrixForm=",
  CellTags->{"Minimal Realization", "i:4", "b:19.4"}],

Cell[BoxData[
    TagBox[
      RowBox[{"(", "\[NoBreak]", GridBox[{
            {"0", "0"},
            {"0", "0"},
            {"1", "0"},
            {"1", \(-27\)}
            }], "\[NoBreak]", ")"}],
      Function[ BoxForm`e$, 
        MatrixForm[ BoxForm`e$]]]], "Output",
  CellLabel->"Out[57]//MatrixForm=",
  CellTags->{"Minimal Realization", "i:4", "b:19.4"}],

Cell[BoxData[
    TagBox[
      RowBox[{"(", "\[NoBreak]", GridBox[{
            {\(1\/3\), \(-\(1\/9\)\), \(1\/27\), \(-\(730\/27\)\)},
            {"0", "0", "1", "0"}
            }], "\[NoBreak]", ")"}],
      Function[ BoxForm`e$, 
        MatrixForm[ BoxForm`e$]]]], "Output",
  CellLabel->"Out[58]//MatrixForm=",
  CellTags->{"Minimal Realization", "i:4", "b:19.4"}],

Cell[BoxData[
    TagBox[
      RowBox[{"(", "\[NoBreak]", GridBox[{
            {"1", "0"},
            {"0", "1"}
            }], "\[NoBreak]", ")"}],
      Function[ BoxForm`e$, 
        MatrixForm[ BoxForm`e$]]]], "Output",
  CellLabel->"Out[59]//MatrixForm=",
  CellTags->{"Minimal Realization", "i:4", "b:19.4"}]
}, Open  ]],

Cell["\<\
MinimalRealization can also be used with systems defined in state space form.\
\
\>", "Text",
  CellTags->{"Minimal Realization", "i:4", "b:19.4"}],

Cell[CellGroupData[{

Cell[BoxData[
    \(\({Anew, Bnew, Cnew, Dnew} = 
        MinimalRealization[AA, BB, CC, DD];\)\)], "Input",
  CellLabel->"In[60]:=",
  CellTags->{"Minimal Realization", "i:4", "b:19.4"}],

Cell[BoxData[
    \("System is controllable."\)], "Print",
  CellLabel->"From In[60]:=",
  CellTags->{"Minimal Realization", "i:4", "b:19.4"}],

Cell[BoxData[
    \("Decompose into controllable/uncontrollable parts."\)], "Print",
  CellLabel->"From In[60]:=",
  CellTags->{"Minimal Realization", "i:4", "b:19.4"}],

Cell[BoxData[
    \("Divide controllable part into observable/unobservable parts."\)], \
"Print",
  CellLabel->"From In[60]:=",
  CellTags->{"Minimal Realization", "i:4", "b:19.4"}],

Cell[BoxData[
    \("System is observable."\)], "Print",
  CellLabel->"From In[60]:=",
  CellTags->{"Minimal Realization", "i:4", "b:19.4"}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
    \(Anew // MatrixForm\), "\n", 
    \(Bnew // MatrixForm\), "\n", 
    \(Cnew // MatrixForm\), "\n", 
    \(Dnew // MatrixForm\)}], "Input",
  CellLabel->"In[61]:=",
  CellTags->{"Minimal Realization", "i:4", "b:19.4"}],

Cell[BoxData[
    TagBox[
      RowBox[{"(", "\[NoBreak]", GridBox[{
            {\(-5\), "0", "0", "0"},
            {"0", \(-2\), "1", "0"},
            {"0", "0", \(-2\), "1"},
            {"0", "0", "0", \(-2\)}
            }], "\[NoBreak]", ")"}],
      Function[ BoxForm`e$, 
        MatrixForm[ BoxForm`e$]]]], "Output",
  CellLabel->"Out[61]//MatrixForm=",
  CellTags->{"Minimal Realization", "i:4", "b:19.4"}],

Cell[BoxData[
    TagBox[
      RowBox[{"(", "\[NoBreak]", GridBox[{
            {"1", \(-27\)},
            {"0", "0"},
            {"0", "0"},
            {"1", "0"}
            }], "\[NoBreak]", ")"}],
      Function[ BoxForm`e$, 
        MatrixForm[ BoxForm`e$]]]], "Output",
  CellLabel->"Out[62]//MatrixForm=",
  CellTags->{"Minimal Realization", "i:4", "b:19.4"}],

Cell[BoxData[
    TagBox[
      RowBox[{"(", "\[NoBreak]", GridBox[{
            {\(-\(730\/27\)\), \(1\/3\), \(-\(1\/9\)\), \(1\/27\)},
            {"0", "0", "0", "1"}
            }], "\[NoBreak]", ")"}],
      Function[ BoxForm`e$, 
        MatrixForm[ BoxForm`e$]]]], "Output",
  CellLabel->"Out[63]//MatrixForm=",
  CellTags->{"Minimal Realization", "i:4", "b:19.4"}],

Cell[BoxData[
    TagBox[
      RowBox[{"(", "\[NoBreak]", GridBox[{
            {"1", "0"},
            {"0", "1"}
            }], "\[NoBreak]", ")"}],
      Function[ BoxForm`e$, 
        MatrixForm[ BoxForm`e$]]]], "Output",
  CellLabel->"Out[64]//MatrixForm=",
  CellTags->{"Minimal Realization", "i:4", "b:19.4"}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Controllability, Observability and Pole Placement", "Subsection",
  Evaluatable->False,
  AspectRatioFixed->True,
  CellTags->{"Controllability", "i:5", "b:19.5"}],

Cell["\<\
Check the controllability and observability of the original linearized model.\
\
\>", "Text",
  Evaluatable->False,
  AspectRatioFixed->True,
  CellTags->{"Controllability", "i:5", "b:19.5"}],

Cell[CellGroupData[{

Cell[BoxData[
    \(ControllablePair[A1, B1]\)], "Input",
  CellLabel->"In[65]:=",
  PageWidth->Infinity,
  AspectRatioFixed->True,
  CellTags->{"Controllability", "i:5", "b:19.5"}],

Cell[BoxData[
    \(True\)], "Output",
  CellLabel->"Out[65]=",
  CellTags->{"Controllability", "i:5", "b:19.5"}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(ObservablePair[A1, C1]\)], "Input",
  CellLabel->"In[66]:=",
  PageWidth->Infinity,
  AspectRatioFixed->True,
  CellTags->{"Controllability", "i:5", "b:19.5"}],

Cell[BoxData[
    \(True\)], "Output",
  CellLabel->"Out[66]=",
  CellTags->{"Controllability", "i:5", "b:19.5"}]
}, Open  ]],

Cell["\<\
Since the system is controllable, we can place the poles, at say (-2,-2), \
using state feedback. First, lets do it using both controls\
\>", "Text",
  Evaluatable->False,
  AspectRatioFixed->True,
  CellTags->{"Controllability", "i:5", "b:19.5"}],

Cell[CellGroupData[{

Cell[BoxData[
    \(PolePlace[A1, B1, {\(-2\), \(-2\)}]\)], "Input",
  CellLabel->"In[67]:=",
  PageWidth->Infinity,
  AspectRatioFixed->True,
  CellTags->{"Controllability", "i:5", "b:19.5"}],

Cell[BoxData[
    \({{\(-4\), 3}, {0, 0}}\)], "Output",
  CellLabel->"Out[67]=",
  CellTags->{"Controllability", "i:5", "b:19.5"}]
}, Open  ]],

Cell["Now, do it using only the second control (port 2):", "Text",
  Evaluatable->False,
  AspectRatioFixed->True,
  CellTags->{"Controllability", "i:5", "b:19.5"}],

Cell[CellGroupData[{

Cell[BoxData[
    \(PolePlace[A1, B1, 2, {\(-2\), \(-2\)}]\)], "Input",
  CellLabel->"In[68]:=",
  PageWidth->Infinity,
  AspectRatioFixed->True,
  CellTags->{"Controllability", "i:5", "b:19.5"}],

Cell[BoxData[
    \({{0, 0}, {\(-\(4\/3\)\), 1}}\)], "Output",
  CellLabel->"Out[68]=",
  CellTags->{"Controllability", "i:5", "b:19.5"}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Kalman Reduction & Minimal (Irreducible) Realizations", "Subsection",
  CellTags->{"Kalman Form", "i:6", "b:19.6"}],

Cell["\<\
KalmanDecomposition - transforms a state space description to a canonical \
form identifying the four parts: controllable & observable, controllable & \
not observable, not controllable & observable, not controllable & not \
observable. An option (IrreducibleRealization->True) returns only the minimal \
(or irreducible) system, i.e., the controllable & observable part. \
\>", "Text",
  CellTags->{"Kalman Form", "i:6", "b:19.6"}],

Cell[BoxData[{
    \(\(AA = {{1, 1, 0}, {0, 1, 0}, {0, 1, 1}};\)\), "\n", 
    \(\(BB = {{0, 1}, {1, 0}, {0, 1}};\)\), "\n", 
    \(CC = {{1, 1, 1}}; DD = {{0, 0}};\)}], "Input",
  CellLabel->"In[69]:=",
  CellTags->{"Kalman Form", "i:6", "b:19.6"}],

Cell[CellGroupData[{

Cell[BoxData[{
    \(\({Anew, Bnew, Cnew, Dnew} = 
        KalmanDecomposition[AA, BB, CC, DD];\)\), "\n", 
    \(Anew // MatrixForm\), "\n", 
    \(Bnew // MatrixForm\), "\n", 
    \(Cnew // MatrixForm\), "\n", 
    \(Dnew // MatrixForm\)}], "Input",
  CellLabel->"In[72]:=",
  CellTags->{"Kalman Form", "i:6", "b:19.6"}],

Cell[BoxData[
    \("Decompose into controllable/uncontrollable parts."\)], "Print",
  CellLabel->"From In[72]:=",
  CellTags->{"Kalman Form", "i:6", "b:19.6"}],

Cell[BoxData[
    \("Divide controllable part into observable/unobservable parts."\)], \
"Print",
  CellLabel->"From In[72]:=",
  CellTags->{"Kalman Form", "i:6", "b:19.6"}],

Cell[BoxData[
    \("System is observable."\)], "Print",
  CellLabel->"From In[72]:=",
  CellTags->{"Kalman Form", "i:6", "b:19.6"}],

Cell[BoxData[
    \("Divide uncontrollable part into observable/unobservable parts."\)], \
"Print",
  CellLabel->"From In[72]:=",
  CellTags->{"Kalman Form", "i:6", "b:19.6"}],

Cell[BoxData[
    TagBox[
      RowBox[{"(", "\[NoBreak]", GridBox[{
            {"1", "1", "0"},
            {"0", "1", "0"},
            {"0", "0", "1"}
            }], "\[NoBreak]", ")"}],
      Function[ BoxForm`e$, 
        MatrixForm[ BoxForm`e$]]]], "Output",
  CellLabel->"Out[73]//MatrixForm=",
  CellTags->{"Kalman Form", "i:6", "b:19.6"}],

Cell[BoxData[
    TagBox[
      RowBox[{"(", "\[NoBreak]", GridBox[{
            {"0", "1"},
            {"1", "0"},
            {"0", "0"}
            }], "\[NoBreak]", ")"}],
      Function[ BoxForm`e$, 
        MatrixForm[ BoxForm`e$]]]], "Output",
  CellLabel->"Out[74]//MatrixForm=",
  CellTags->{"Kalman Form", "i:6", "b:19.6"}],

Cell[BoxData[
    TagBox[
      RowBox[{"(", "\[NoBreak]", GridBox[{
            {"2", "1", "0"}
            }], "\[NoBreak]", ")"}],
      Function[ BoxForm`e$, 
        MatrixForm[ BoxForm`e$]]]], "Output",
  CellLabel->"Out[75]//MatrixForm=",
  CellTags->{"Kalman Form", "i:6", "b:19.6"}],

Cell[BoxData[
    TagBox[
      RowBox[{"(", "\[NoBreak]", GridBox[{
            {"0", "0"}
            }], "\[NoBreak]", ")"}],
      Function[ BoxForm`e$, 
        MatrixForm[ BoxForm`e$]]]], "Output",
  CellLabel->"Out[76]//MatrixForm=",
  CellTags->{"Kalman Form", "i:6", "b:19.6"}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
    \(Anew\), "\n", 
    \(Bnew\), "\n", 
    \(Cnew\), "\n", 
    \(Dnew\)}], "Input",
  CellLabel->"In[77]:=",
  CellTags->{"Kalman Form", "i:6", "b:19.6"}],

Cell[BoxData[
    \({{1, 1, 0}, {0, 1, 0}, {0, 0, 1}}\)], "Output",
  CellLabel->"Out[77]=",
  CellTags->{"Kalman Form", "i:6", "b:19.6"}],

Cell[BoxData[
    \({{0, 1}, {1, 0}, {0, 0}}\)], "Output",
  CellLabel->"Out[78]=",
  CellTags->{"Kalman Form", "i:6", "b:19.6"}],

Cell[BoxData[
    \({{2, 1, 0}}\)], "Output",
  CellLabel->"Out[79]=",
  CellTags->{"Kalman Form", "i:6", "b:19.6"}],

Cell[BoxData[
    \({{0, 0}}\)], "Output",
  CellLabel->"Out[80]=",
  CellTags->{"Kalman Form", "i:6", "b:19.6"}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
    \(\({Anew, Bnew, Cnew, Dnew} = 
        KalmanDecomposition[AA, BB, CC, DD, 
          IrreducibleRealization -> True];\)\), "\n", 
    \(Anew // MatrixForm\), "\n", 
    \(Bnew // MatrixForm\), "\n", 
    \(Cnew // MatrixForm\), "\n", 
    \(Dnew // MatrixForm\)}], "Input",
  CellLabel->"In[81]:=",
  CellTags->{"Kalman Form", "i:6", "b:19.6"}],

Cell[BoxData[
    \("Decompose into controllable/uncontrollable parts."\)], "Print",
  CellLabel->"From In[81]:=",
  CellTags->{"Kalman Form", "i:6", "b:19.6"}],

Cell[BoxData[
    \("Divide controllable part into observable/unobservable parts."\)], \
"Print",
  CellLabel->"From In[81]:=",
  CellTags->{"Kalman Form", "i:6", "b:19.6"}],

Cell[BoxData[
    \("System is observable."\)], "Print",
  CellLabel->"From In[81]:=",
  CellTags->{"Kalman Form", "i:6", "b:19.6"}],

Cell[BoxData[
    \("Divide uncontrollable part into observable/unobservable parts."\)], \
"Print",
  CellLabel->"From In[81]:=",
  CellTags->{"Kalman Form", "i:6", "b:19.6"}],

Cell[BoxData[
    TagBox[
      RowBox[{"(", "\[NoBreak]", GridBox[{
            {"1", "1", "0"},
            {"0", "1", "0"},
            {"0", "0", "1"}
            }], "\[NoBreak]", ")"}],
      Function[ BoxForm`e$, 
        MatrixForm[ BoxForm`e$]]]], "Output",
  CellLabel->"Out[82]//MatrixForm=",
  CellTags->{"Kalman Form", "i:6", "b:19.6"}],

Cell[BoxData[
    TagBox[
      RowBox[{"(", "\[NoBreak]", GridBox[{
            {"0", "1"},
            {"1", "0"},
            {"0", "0"}
            }], "\[NoBreak]", ")"}],
      Function[ BoxForm`e$, 
        MatrixForm[ BoxForm`e$]]]], "Output",
  CellLabel->"Out[83]//MatrixForm=",
  CellTags->{"Kalman Form", "i:6", "b:19.6"}],

Cell[BoxData[
    TagBox[
      RowBox[{"(", "\[NoBreak]", GridBox[{
            {"2", "1", "0"}
            }], "\[NoBreak]", ")"}],
      Function[ BoxForm`e$, 
        MatrixForm[ BoxForm`e$]]]], "Output",
  CellLabel->"Out[84]//MatrixForm=",
  CellTags->{"Kalman Form", "i:6", "b:19.6"}],

Cell[BoxData[
    TagBox[
      RowBox[{"(", "\[NoBreak]", GridBox[{
            {"0", "0"}
            }], "\[NoBreak]", ")"}],
      Function[ BoxForm`e$, 
        MatrixForm[ BoxForm`e$]]]], "Output",
  CellLabel->"Out[85]//MatrixForm=",
  CellTags->{"Kalman Form", "i:6", "b:19.6"}]
}, Open  ]],

Cell[BoxData[{
    \(\(AA = {{0, \(-1\), 1}, {1, \(-2\), 1}, {0, 1, \(-1\)}};\)\), "\n", 
    \(\(BB = {{1, 0}, {1, 1}, {1, 2}};\)\), "\n", 
    \(CC = {{0, 1, 0}}; DD = {{0, 0}};\)}], "Input",
  CellLabel->"In[86]:=",
  CellTags->{"Kalman Form", "i:6", "b:19.6"}],

Cell[CellGroupData[{

Cell[BoxData[{
    \(\({Anew, Bnew, Cnew, Dnew} = 
        KalmanDecomposition[AA, BB, CC, DD];\)\), "\n", 
    \(Anew // MatrixForm\), "\n", 
    \(Bnew // MatrixForm\), "\n", 
    \(Cnew // MatrixForm\), "\n", 
    \(Dnew // MatrixForm\)}], "Input",
  CellLabel->"In[89]:=",
  CellTags->{"Kalman Form", "i:6", "b:19.6"}],

Cell[BoxData[
    \("Decompose into controllable/uncontrollable parts."\)], "Print",
  CellLabel->"From In[89]:=",
  CellTags->{"Kalman Form", "i:6", "b:19.6"}],

Cell[BoxData[
    \("Divide controllable part into observable/unobservable parts."\)], \
"Print",
  CellLabel->"From In[89]:=",
  CellTags->{"Kalman Form", "i:6", "b:19.6"}],

Cell[BoxData[
    \("Divide uncontrollable part into observable/unobservable parts."\)], \
"Print",
  CellLabel->"From In[89]:=",
  CellTags->{"Kalman Form", "i:6", "b:19.6"}],

Cell[BoxData[
    \("System is observable."\)], "Print",
  CellLabel->"From In[89]:=",
  CellTags->{"Kalman Form", "i:6", "b:19.6"}],

Cell[BoxData[
    TagBox[
      RowBox[{"(", "\[NoBreak]", GridBox[{
            {\(-1\), "1", "5"},
            {"0", "0", "2"},
            {"0", "0", \(-2\)}
            }], "\[NoBreak]", ")"}],
      Function[ BoxForm`e$, 
        MatrixForm[ BoxForm`e$]]]], "Output",
  CellLabel->"Out[90]//MatrixForm=",
  CellTags->{"Kalman Form", "i:6", "b:19.6"}],

Cell[BoxData[
    TagBox[
      RowBox[{"(", "\[NoBreak]", GridBox[{
            {"1", "0"},
            {"1", "1"},
            {"0", "0"}
            }], "\[NoBreak]", ")"}],
      Function[ BoxForm`e$, 
        MatrixForm[ BoxForm`e$]]]], "Output",
  CellLabel->"Out[91]//MatrixForm=",
  CellTags->{"Kalman Form", "i:6", "b:19.6"}],

Cell[BoxData[
    TagBox[
      RowBox[{"(", "\[NoBreak]", GridBox[{
            {"0", "1", \(-2\)}
            }], "\[NoBreak]", ")"}],
      Function[ BoxForm`e$, 
        MatrixForm[ BoxForm`e$]]]], "Output",
  CellLabel->"Out[92]//MatrixForm=",
  CellTags->{"Kalman Form", "i:6", "b:19.6"}],

Cell[BoxData[
    TagBox[
      RowBox[{"(", "\[NoBreak]", GridBox[{
            {"0", "0"}
            }], "\[NoBreak]", ")"}],
      Function[ BoxForm`e$, 
        MatrixForm[ BoxForm`e$]]]], "Output",
  CellLabel->"Out[93]//MatrixForm=",
  CellTags->{"Kalman Form", "i:6", "b:19.6"}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
    \(\({Anew, Bnew, Cnew, Dnew} = 
        KalmanDecomposition[AA, BB, CC, DD, 
          IrreducibleRealization -> True];\)\), "\n", 
    \(Anew // MatrixForm\), "\n", 
    \(Bnew // MatrixForm\), "\n", 
    \(Cnew // MatrixForm\), "\n", 
    \(Dnew // MatrixForm\)}], "Input",
  CellLabel->"In[94]:=",
  CellTags->{"Kalman Form", "i:6", "b:19.6"}],

Cell[BoxData[
    \("Decompose into controllable/uncontrollable parts."\)], "Print",
  CellLabel->"From In[94]:=",
  CellTags->{"Kalman Form", "i:6", "b:19.6"}],

Cell[BoxData[
    \("Divide controllable part into observable/unobservable parts."\)], \
"Print",
  CellLabel->"From In[94]:=",
  CellTags->{"Kalman Form", "i:6", "b:19.6"}],

Cell[BoxData[
    \("Divide uncontrollable part into observable/unobservable parts."\)], \
"Print",
  CellLabel->"From In[94]:=",
  CellTags->{"Kalman Form", "i:6", "b:19.6"}],

Cell[BoxData[
    \("System is observable."\)], "Print",
  CellLabel->"From In[94]:=",
  CellTags->{"Kalman Form", "i:6", "b:19.6"}],

Cell[BoxData[
    TagBox[
      RowBox[{"(", "\[NoBreak]", GridBox[{
            {\(-1\), "1", "5"},
            {"0", "0", "2"},
            {"0", "0", \(-2\)}
            }], "\[NoBreak]", ")"}],
      Function[ BoxForm`e$, 
        MatrixForm[ BoxForm`e$]]]], "Output",
  CellLabel->"Out[95]//MatrixForm=",
  CellTags->{"Kalman Form", "i:6", "b:19.6"}],

Cell[BoxData[
    TagBox[
      RowBox[{"(", "\[NoBreak]", GridBox[{
            {"1", "0"},
            {"1", "1"},
            {"0", "0"}
            }], "\[NoBreak]", ")"}],
      Function[ BoxForm`e$, 
        MatrixForm[ BoxForm`e$]]]], "Output",
  CellLabel->"Out[96]//MatrixForm=",
  CellTags->{"Kalman Form", "i:6", "b:19.6"}],

Cell[BoxData[
    TagBox[
      RowBox[{"(", "\[NoBreak]", GridBox[{
            {"0", "1", \(-2\)}
            }], "\[NoBreak]", ")"}],
      Function[ BoxForm`e$, 
        MatrixForm[ BoxForm`e$]]]], "Output",
  CellLabel->"Out[97]//MatrixForm=",
  CellTags->{"Kalman Form", "i:6", "b:19.6"}],

Cell[BoxData[
    TagBox[
      RowBox[{"(", "\[NoBreak]", GridBox[{
            {"0", "0"}
            }], "\[NoBreak]", ")"}],
      Function[ BoxForm`e$, 
        MatrixForm[ BoxForm`e$]]]], "Output",
  CellLabel->"Out[98]//MatrixForm=",
  CellTags->{"Kalman Form", "i:6", "b:19.6"}]
}, Open  ]],

Cell[BoxData[{
    \(\(AA = {{0, \(-1\), 1}, {1, \(-2\), 1}, {0, 1, \(-1\)}};\)\), "\n", 
    \(\(BB = {{1, 0}, {1, 1}, {1, 2}};\)\), "\n", 
    \(CC = {{0, 1, 0}}; DD = {{0, 0}};\)}], "Input",
  CellLabel->"In[99]:=",
  CellTags->{"Kalman Form", "i:6", "b:19.6"}],

Cell[CellGroupData[{

Cell[BoxData[{
    \(\({Anew, Bnew, Cnew, Dnew} = 
        MinimalRealization[AA, BB, CC, DD];\)\), "\n", 
    \(Anew // MatrixForm\), "\n", 
    \(Bnew // MatrixForm\), "\n", 
    \(Cnew // MatrixForm\), "\n", 
    \(Dnew // MatrixForm\)}], "Input",
  CellLabel->"In[102]:=",
  CellTags->{"Kalman Form", "i:6", "b:19.6"}],

Cell[BoxData[
    \("Decompose into controllable/uncontrollable parts."\)], "Print",
  CellLabel->"From In[102]:=",
  CellTags->{"Kalman Form", "i:6", "b:19.6"}],

Cell[BoxData[
    \("Divide controllable part into observable/unobservable parts."\)], \
"Print",
  CellLabel->"From In[102]:=",
  CellTags->{"Kalman Form", "i:6", "b:19.6"}],

Cell[BoxData[
    TagBox[
      RowBox[{"(", "\[NoBreak]", GridBox[{
            {\(-1\)}
            }], "\[NoBreak]", ")"}],
      Function[ BoxForm`e$, 
        MatrixForm[ BoxForm`e$]]]], "Output",
  CellLabel->"Out[103]//MatrixForm=",
  CellTags->{"Kalman Form", "i:6", "b:19.6"}],

Cell[BoxData[
    TagBox[
      RowBox[{"(", "\[NoBreak]", GridBox[{
            {"1", "0"}
            }], "\[NoBreak]", ")"}],
      Function[ BoxForm`e$, 
        MatrixForm[ BoxForm`e$]]]], "Output",
  CellLabel->"Out[104]//MatrixForm=",
  CellTags->{"Kalman Form", "i:6", "b:19.6"}],

Cell[BoxData[
    TagBox[
      RowBox[{"(", "\[NoBreak]", GridBox[{
            {"1"}
            }], "\[NoBreak]", ")"}],
      Function[ BoxForm`e$, 
        MatrixForm[ BoxForm`e$]]]], "Output",
  CellLabel->"Out[105]//MatrixForm=",
  CellTags->{"Kalman Form", "i:6", "b:19.6"}],

Cell[BoxData[
    TagBox[
      RowBox[{"(", "\[NoBreak]", GridBox[{
            {"0", "0"}
            }], "\[NoBreak]", ")"}],
      Function[ BoxForm`e$, 
        MatrixForm[ BoxForm`e$]]]], "Output",
  CellLabel->"Out[106]//MatrixForm=",
  CellTags->{"Kalman Form", "i:6", "b:19.6"}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Another Example: lateral aircraft dynamics", "Subsection",
  Evaluatable->False,
  AspectRatioFixed->True,
  CellTags->{"Another Example", "b:19.7"}],

Cell["\<\
The following model is representaive of the linearized lateral dynamics of an \
aircraft:\
\>", "Text",
  Evaluatable->False,
  AspectRatioFixed->True,
  CellTags->{"Another Example", "b:19.7"}],

Cell[CellGroupData[{

Cell[BoxData[
    \(AA = {{\(-10\), 0, \(-10\), 0}, {0, \(- .7\), 9, 
          0}, {0, \(-1\), \(- .7\), 0}, {1, 0, 0, 0}}\)], "Input",
  CellLabel->"In[107]:=",
  PageWidth->Infinity,
  AspectRatioFixed->True,
  CellTags->{"Another Example", "b:19.7"}],

Cell[BoxData[
    \({{\(-10\), 0, \(-10\), 0}, {0, \(-0.7`\), 9, 0}, {0, \(-1\), \(-0.7`\), 
        0}, {1, 0, 0, 0}}\)], "Output",
  CellLabel->"Out[107]=",
  CellTags->{"Another Example", "b:19.7"}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(BB = {{20, 2.8}, {0, \(-3.13\)}, {0, 0}, {0, 0}}\)], "Input",
  CellLabel->"In[108]:=",
  PageWidth->Infinity,
  AspectRatioFixed->True,
  CellTags->{"Another Example", "b:19.7"}],

Cell[BoxData[
    \({{20, 2.8`}, {0, \(-3.13`\)}, {0, 0}, {0, 0}}\)], "Output",
  CellLabel->"Out[108]=",
  CellTags->{"Another Example", "b:19.7"}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(CC = {{0, 0, 1, 0}, {0, 0, 0, 1}}\)], "Input",
  CellLabel->"In[109]:=",
  PageWidth->Infinity,
  AspectRatioFixed->True,
  CellTags->{"Another Example", "b:19.7"}],

Cell[BoxData[
    \({{0, 0, 1, 0}, {0, 0, 0, 1}}\)], "Output",
  CellLabel->"Out[109]=",
  CellTags->{"Another Example", "b:19.7"}]
}, Open  ]],

Cell["Lets test controllability and observability:", "Text",
  Evaluatable->False,
  AspectRatioFixed->True,
  CellTags->{"Another Example", "b:19.7"}],

Cell[CellGroupData[{

Cell[BoxData[
    \(ControllablePair[AA, BB]\)], "Input",
  CellLabel->"In[110]:=",
  PageWidth->Infinity,
  AspectRatioFixed->True,
  CellTags->{"Another Example", "b:19.7"}],

Cell[BoxData[
    \(True\)], "Output",
  CellLabel->"Out[110]=",
  CellTags->{"Another Example", "b:19.7"}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(ObservablePair[AA, CC]\)], "Input",
  CellLabel->"In[111]:=",
  PageWidth->Infinity,
  AspectRatioFixed->True,
  CellTags->{"Another Example", "b:19.7"}],

Cell[BoxData[
    \(True\)], "Output",
  CellLabel->"Out[111]=",
  CellTags->{"Another Example", "b:19.7"}]
}, Open  ]],

Cell["Now, we can obtain the transfer function.", "Text",
  Evaluatable->False,
  AspectRatioFixed->True,
  CellTags->{"Another Example", "b:19.7"}],

Cell[BoxData[
    \(K[s_] := StateSpaceToTransferFunction[AA, BB, CC, s]\)], "Input",
  CellLabel->"In[112]:=",
  PageWidth->Infinity,
  AspectRatioFixed->True,
  CellTags->{"Another Example", "b:19.7"}],

Cell[CellGroupData[{

Cell[BoxData[
    \(K[s]\)], "Input",
  CellLabel->"In[113]:=",
  PageWidth->Infinity,
  AspectRatioFixed->True,
  CellTags->{"Another Example", "b:19.7"}],

Cell[BoxData[
    \({{0, \(31.299999999999997`\ s + 3.13`\ s\^2\)\/\(94.9`\ s + \
23.490000000000002`\ s\^2 + 11.4`\ s\^3 + s\^4\)}, {\(20.`\ \((\(\(9.49`\)\(\
\[InvisibleSpace]\)\) + 1.4`\ s + s\^2)\)\)\/\(94.9`\ s + 23.490000000000002`\
\ s\^2 + 11.4`\ s\^3 + s\^4\), \(\(-4.727999999999998`\) + \
3.9199999999999995`\ s + 2.8`\ s\^2\)\/\(94.9`\ s + 23.490000000000002`\ s\^2 \
+ 11.4`\ s\^3 + s\^4\)}}\)], "Output",
  CellLabel->"Out[113]=",
  CellTags->{"Another Example", "b:19.7"}]
}, Open  ]],

Cell["\<\
We can obtain the McMillan degree and generate a Laurent series.\
\>", "Text",
  Evaluatable->False,
  AspectRatioFixed->True,
  CellTags->{"Another Example", "b:19.7"}],

Cell[CellGroupData[{

Cell[BoxData[
    \(McMillanDegree[K, s]\)], "Input",
  CellLabel->"In[114]:=",
  PageWidth->Infinity,
  AspectRatioFixed->True,
  CellTags->{"Another Example", "b:19.7"}],

Cell[BoxData[
    \(4\)], "Output",
  CellLabel->"Out[114]=",
  CellTags->{"Another Example", "b:19.7"}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(LaurentSeries[K, s, 3]\)], "Input",
  CellLabel->"In[115]:=",
  PageWidth->Infinity,
  AspectRatioFixed->True,
  CellTags->{"Another Example", "b:19.7"}],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{
        RowBox[{"{", 
          RowBox[{"0", ",", 
            InterpretationBox[
              
              RowBox[{\(3.13`\ \((1\/s)\)\^2\), 
                "-", \(4.382000000000001`\ \((1\/s)\)\^3\), "+", 
                InterpretationBox[\(O[1\/s]\^4\),
                  SeriesData[ 
                    Power[ s, -1], 0, {}, 2, 4, 1],
                  Editable->False]}],
              SeriesData[ 
                Power[ s, -1], 0, {3.1299999999999999, -4.3820000000000006}, 
                2, 4, 1],
              Editable->False]}], "}"}], ",", 
        RowBox[{"{", 
          RowBox[{
            InterpretationBox[
              
              RowBox[{\(20.`\ \((1\/s)\)\^2\), "-", \(200.`\ \((1\/s)\)\^3\), 
                "+", 
                InterpretationBox[\(O[1\/s]\^4\),
                  SeriesData[ 
                    Power[ s, -1], 0, {}, 2, 4, 1],
                  Editable->False]}],
              SeriesData[ 
                Power[ s, -1], 0, {.2*^2, -.2*^3}, 2, 4, 1],
              Editable->False], ",", 
            InterpretationBox[
              
              RowBox[{\(2.8`\ \((1\/s)\)\^2\), "-", \(28.`\ \((1\/s)\)\^3\), 
                "+", 
                InterpretationBox[\(O[1\/s]\^4\),
                  SeriesData[ 
                    Power[ s, -1], 0, {}, 2, 4, 1],
                  Editable->False]}],
              SeriesData[ 
                Power[ s, -1], 0, {2.7999999999999998, -28.0}, 2, 4, 1],
              Editable->False]}], "}"}]}], "}"}]], "Output",
  CellLabel->"Out[115]=",
  CellTags->{"Another Example", "b:19.7"}]
}, Open  ]],

Cell["\<\
We can construct controllable or observable realizations from this transfer \
function.\
\>", "Text",
  Evaluatable->False,
  AspectRatioFixed->True,
  CellTags->{"Another Example", "b:19.7"}],

Cell[CellGroupData[{

Cell[BoxData[
    \(ControllableRealization[K, s]\)], "Input",
  CellLabel->"In[116]:=",
  PageWidth->Infinity,
  AspectRatioFixed->True,
  CellTags->{"Another Example", "b:19.7"}],

Cell[BoxData[
    \({{{0, 0, 1, 0, 0, 0, 0, 0}, {0, 0, 0, 1, 0, 0, 0, 0}, {0, 0, 0, 0, 1, 
          0, 0, 0}, {0, 0, 0, 0, 0, 1, 0, 0}, {0, 0, 0, 0, 0, 0, 1, 0}, {0, 
          0, 0, 0, 0, 0, 0, 1}, {0, 0, \(-94.9`\), 
          0, \(-23.490000000000002`\), 0, \(-11.4`\), 0}, {0, 0, 
          0, \(-94.9`\), 0, \(-23.490000000000002`\), 0, \(-11.4`\)}}, {{0, 
          0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {1, 0}, {0, 1}}, {{0, 
          0, 0, 31.299999999999997`, 0, 3.13`, 0, 
          0}, {189.8`, \(-4.727999999999997`\), 28.`, 3.919999999999999`, 
          20.`, 2.8`, 0, 0}}}\)], "Output",
  CellLabel->"Out[116]=",
  CellTags->{"Another Example", "b:19.7"}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(ObservableRealization[K, s]\)], "Input",
  CellLabel->"In[117]:=",
  PageWidth->Infinity,
  AspectRatioFixed->True,
  CellTags->{"Another Example", "b:19.7"}],

Cell[BoxData[
    \({{{0, 0, 1, 0, 0, 0, 0, 0}, {0, 0, 0, 1, 0, 0, 0, 0}, {0, 0, 0, 0, 1, 
          0, 0, 0}, {0, 0, 0, 0, 0, 1, 0, 0}, {0, 0, 0, 0, 0, 0, 1, 0}, {0, 
          0, 0, 0, 0, 0, 0, 1}, {0, 0, \(-94.9`\), 
          0, \(-23.490000000000002`\), 0, \(-11.4`\), 0}, {0, 0, 
          0, \(-94.9`\), 0, \(-23.490000000000002`\), 0, \(-11.4`\)}}, {{0, 
          0}, {0, 0}, {0, 3.13`}, {20.`, 
          2.8`}, {0, \(-4.382000000000001`\)}, {\(-200.`\), \(-28.`\)}, {0, \
\(-23.568900000000003`\)}, {2000.`, 248.7`}}, {{1, 0, 0, 0, 0, 0, 0, 0}, {0, 
          1, 0, 0, 0, 0, 0, 0}}}\)], "Output",
  CellLabel->"Out[117]=",
  CellTags->{"Another Example", "b:19.7"}]
}, Open  ]],

Cell["\<\
Now, let's look at a SISO system whose input is the first control and output \
is the second output:\
\>", "Text",
  Evaluatable->False,
  AspectRatioFixed->True,
  CellTags->{"Another Example", "b:19.7"}],

Cell[BoxData[
    \(K1[s_] := 
      StateSpaceToTransferFunction[AA, 
        BB\[LeftDoubleBracket]{1, 2, 3, 4}, {1}\[RightDoubleBracket], 
        CC\[LeftDoubleBracket]{2}, {1, 2, 3, 4}\[RightDoubleBracket], 
        s]\)], "Input",
  CellLabel->"In[118]:=",
  PageWidth->Infinity,
  AspectRatioFixed->True,
  CellTags->{"Another Example", "b:19.7"}],

Cell[CellGroupData[{

Cell[BoxData[
    \(K1[s]\)], "Input",
  CellLabel->"In[119]:=",
  PageWidth->Infinity,
  AspectRatioFixed->True,
  CellTags->{"Another Example", "b:19.7"}],

Cell[BoxData[
    \({{\(20.`\ \((\(\(9.49`\)\(\[InvisibleSpace]\)\) + 1.4`\ s + s\^2)\)\)\/\
\(94.9`\ s + 23.490000000000002`\ s\^2 + 11.4`\ s\^3 + s\^4\)}}\)], "Output",
  CellLabel->"Out[119]=",
  CellTags->{"Another Example", "b:19.7"}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(McMillanDegree[K1, s]\)], "Input",
  CellLabel->"In[120]:=",
  PageWidth->Infinity,
  AspectRatioFixed->True,
  CellTags->{"Another Example", "b:19.7"}],

Cell[BoxData[
    \(2\)], "Output",
  CellLabel->"Out[120]=",
  CellTags->{"Another Example", "b:19.7"}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(ObservableRealization[K1, s]\)], "Input",
  CellLabel->"In[121]:=",
  PageWidth->Infinity,
  AspectRatioFixed->True,
  CellTags->{"Another Example", "b:19.7"}],

Cell[BoxData[
    \({{{0, 1, 0, 0}, {0, 0, 1, 0}, {0, 0, 0, 
          1}, {0, \(-94.9`\), \(-23.490000000000002`\), \(-11.4`\)}}, {{0}, \
{20.`}, {\(-200.`\)}, {2000.`}}, {{1, 0, 0, 0}}}\)], "Output",
  CellLabel->"Out[121]=",
  CellTags->{"Another Example", "b:19.7"}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(ControllablePair[AA, 
      BB\[LeftDoubleBracket]{1, 2, 3, 
          4}, {1}\[RightDoubleBracket]]\)], "Input",
  CellLabel->"In[122]:=",
  PageWidth->Infinity,
  AspectRatioFixed->True,
  CellTags->{"Another Example", "b:19.7"}],

Cell[BoxData[
    \(False\)], "Output",
  CellLabel->"Out[122]=",
  CellTags->{"Another Example", "b:19.7"}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(ControllabilityMatrix[AA, 
      BB\[LeftDoubleBracket]{1, 2, 3, 
          4}, {1}\[RightDoubleBracket]]\)], "Input",
  CellLabel->"In[123]:=",
  CellTags->{"Another Example", "b:19.7"}],

Cell[BoxData[
    \({{20, \(-200.`\), 2000.`, \(-20000.`\)}, {0, 0.`, 0.`, 0.`}, {0, 0.`, 
        0.`, 0.`}, {0, 20.`, \(-200.`\), 2000.`}}\)], "Output",
  CellLabel->"Out[123]=",
  CellTags->{"Another Example", "b:19.7"}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(ObservablePair[AA, 
      CC\[LeftDoubleBracket]{2}, {1, 2, 3, 
          4}\[RightDoubleBracket]]\)], "Input",
  CellLabel->"In[124]:=",
  PageWidth->Infinity,
  AspectRatioFixed->True,
  CellTags->{"Another Example", "b:19.7"}],

Cell[BoxData[
    \(True\)], "Output",
  CellLabel->"Out[124]=",
  CellTags->{"Another Example", "b:19.7"}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(ObservabilityMatrix[AA, 
      CC\[LeftDoubleBracket]{2}, {1, 2, 3, 
          4}\[RightDoubleBracket]]\)], "Input",
  CellLabel->"In[125]:=",
  CellTags->{"Another Example", "b:19.7"}],

Cell[BoxData[
    \({{0, 0, 0, 1}, {1.`, 0.`, 0.`, 0.`}, {\(-10.`\), 0.`, \(-10.`\), 
        0.`}, {100.`, 10.`, 107.`, 0.`}}\)], "Output",
  CellLabel->"Out[125]=",
  CellTags->{"Another Example", "b:19.7"}]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Graphics Functions", "Section",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["Introduction", "Subsection",
  Evaluatable->False,
  AspectRatioFixed->True,
  CellTags->{"Introduction", "b:20.0"}],

Cell["\<\
In the following paragraphs we will illustrate the use of graphics functions \
that produce Bode, Nyquist, and root locus plots, and a surface plot \
illustrating the singularities of a rational transefer function.\
\>", "Text",
  Evaluatable->False,
  AspectRatioFixed->True,
  CellTags->{"Introduction", "b:20.0"}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Bode Plot", "Subsection",
  Evaluatable->False,
  AspectRatioFixed->True,
  CellTags->{"Bode plot", "i:9", "b:20.1"}],

Cell["Now, define a transfer function", "Text",
  Evaluatable->False,
  AspectRatioFixed->True,
  CellTags->{"Bode plot", "i:9", "b:20.1"}],

Cell[BoxData[
    \(G[s_] := \(\((s + 10)\)\ \((s + 4)\)\)\/\(\((s + 5)\)\ \((s\^2 + 2\ s + \
2)\)\ \((s\^2 + 1\ s + 1)\)\)\)], "Input",
  CellLabel->"In[126]:=",
  PageWidth->Infinity,
  AspectRatioFixed->True,
  CellTags->{"Bode plot", "i:9", "b:20.1"}],

Cell["\<\
The Bode plot of G over the frquency range .01 to 10 radians per second is \
obtained by invoking the function:\
\>", "Text",
  Evaluatable->False,
  AspectRatioFixed->True,
  CellTags->{"Bode plot", "i:9", "b:20.1"}],

Cell[CellGroupData[{

Cell[BoxData[
    \(Bode[G, s,  .01, 10]\)], "Input",
  CellLabel->"In[127]:=",
  PageWidth->Infinity,
  AspectRatioFixed->True,
  CellTags->{"Bode plot", "i:9", "b:20.1"}],

Cell[CellGroupData[{

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .33333 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.658728 0.317462 0.266206 0.00450947 [
[.0238 -0.0125 -14.25 -13.1875 ]
[.0238 -0.0125 14.25 0 ]
[.2457 -0.0125 -14.25 -13.1875 ]
[.2457 -0.0125 14.25 0 ]
[.34127 -0.0125 -11.1875 -13.1875 ]
[.34127 -0.0125 11.1875 0 ]
[.56316 -0.0125 -11.1875 -13.1875 ]
[.56316 -0.0125 11.1875 0 ]
[.65873 -0.0125 -5.0625 -13.1875 ]
[.65873 -0.0125 5.0625 0 ]
[.88062 -0.0125 -5.0625 -13.1875 ]
[.88062 -0.0125 5.0625 0 ]
[.97619 -0.0125 -8.125 -13.1875 ]
[.97619 -0.0125 8.125 0 ]
[ 0 0 -0.125 0 ]
[.5 -0.0125 -23.4375 -26.375 ]
[.5 -0.0125 23.4375 -13.1875 ]
[-0.0125 .04073 -18 -4.5 ]
[-0.0125 .04073 0 4.5 ]
[-0.0125 .08583 -18 -4.5 ]
[-0.0125 .08583 0 4.5 ]
[-0.0125 .13092 -18 -4.5 ]
[-0.0125 .13092 0 4.5 ]
[-0.0125 .17602 -18 -4.5 ]
[-0.0125 .17602 0 4.5 ]
[-0.0125 .22111 -18 -4.5 ]
[-0.0125 .22111 0 4.5 ]
[-0.0125 .26621 -6 -4.5 ]
[-0.0125 .26621 0 4.5 ]
[-0.0125 .3113 -12 -4.5 ]
[-0.0125 .3113 0 4.5 ]
[ 0 0 -0.125 0 ]
[-0.01875 .16667 -40.375 -6.59375 ]
[-0.01875 .16667 -18 6.59375 ]
[.0238 .34583 -14.25 0 ]
[.0238 .34583 14.25 13.1875 ]
[.2457 .34583 -14.25 0 ]
[.2457 .34583 14.25 13.1875 ]
[.34127 .34583 -11.1875 0 ]
[.34127 .34583 11.1875 13.1875 ]
[.56316 .34583 -11.1875 0 ]
[.56316 .34583 11.1875 13.1875 ]
[.65873 .34583 -5.0625 0 ]
[.65873 .34583 5.0625 13.1875 ]
[.88062 .34583 -5.0625 0 ]
[.88062 .34583 5.0625 13.1875 ]
[.97619 .34583 -8.125 0 ]
[.97619 .34583 8.125 13.1875 ]
[ 0 .33333 .125 0 ]
[.5 .34583 -25.9063 13.1875 ]
[.5 .34583 25.9063 24.625 ]
[ 1 0 .125 0 ]
[1.0125 .16667 0 -6.59375 ]
[1.0125 .16667 10.125 6.59375 ]
[ 0 -0.0005 0 0 ]
[ 1 .33383 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
.75 g
.25 Mabswid
[ ] 0 setdash
.0238 0 m
.0238 .33333 L
s
.18253 0 m
.18253 .33333 L
s
.34127 0 m
.34127 .33333 L
s
.5 0 m
.5 .33333 L
s
.65873 0 m
.65873 .33333 L
s
.81746 0 m
.81746 .33333 L
s
.97619 0 m
.97619 .33333 L
s
0 .04073 m
1 .04073 L
s
0 .08583 m
1 .08583 L
s
0 .13092 m
1 .13092 L
s
0 .17602 m
1 .17602 L
s
0 .22111 m
1 .22111 L
s
0 .26621 m
1 .26621 L
s
0 .3113 m
1 .3113 L
s
0 g
.0238 0 m
.0238 .00625 L
s
gsave
.0238 -0.0125 -75.25 -17.1875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 21.1875 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(0.01) show
87.500 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.2457 0 m
.2457 .00625 L
s
gsave
.2457 -0.0125 -75.25 -17.1875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 21.1875 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(0.05) show
87.500 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.34127 0 m
.34127 .00625 L
s
gsave
.34127 -0.0125 -72.1875 -17.1875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 21.1875 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(0.1) show
81.375 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.56316 0 m
.56316 .00625 L
s
gsave
.56316 -0.0125 -72.1875 -17.1875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 21.1875 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(0.5) show
81.375 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.65873 0 m
.65873 .00625 L
s
gsave
.65873 -0.0125 -66.0625 -17.1875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 21.1875 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(1) show
69.125 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.88062 0 m
.88062 .00625 L
s
gsave
.88062 -0.0125 -66.0625 -17.1875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 21.1875 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
69.125 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.97619 0 m
.97619 .00625 L
s
gsave
.97619 -0.0125 -69.125 -17.1875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 21.1875 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(10) show
75.250 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.001 w
.11937 0 m
.11937 .00375 L
s
.17527 0 m
.17527 .00375 L
s
.21494 0 m
.21494 .00375 L
s
.27084 0 m
.27084 .00375 L
s
.29209 0 m
.29209 .00375 L
s
.3105 0 m
.3105 .00375 L
s
.32674 0 m
.32674 .00375 L
s
.43683 0 m
.43683 .00375 L
s
.49273 0 m
.49273 .00375 L
s
.5324 0 m
.5324 .00375 L
s
.5883 0 m
.5883 .00375 L
s
.60955 0 m
.60955 .00375 L
s
.62796 0 m
.62796 .00375 L
s
.6442 0 m
.6442 .00375 L
s
.75429 0 m
.75429 .00375 L
s
.8102 0 m
.8102 .00375 L
s
.84986 0 m
.84986 .00375 L
s
.90576 0 m
.90576 .00375 L
s
.92701 0 m
.92701 .00375 L
s
.94543 0 m
.94543 .00375 L
s
.96166 0 m
.96166 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
gsave
.5 -0.0125 -84.4375 -30.375 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 21.1875 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(rad) show
%%IncludeResource: font Mathematica2Mono
%%IncludeFont: Mathematica2Mono
/Mathematica2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
81.375 13.313 moveto
(\\220) show
87.500 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(sec) show
105.875 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 .04073 m
.00625 .04073 L
s
[(-50)] -0.0125 .04073 1 0 Mshowa
0 .08583 m
.00625 .08583 L
s
[(-40)] -0.0125 .08583 1 0 Mshowa
0 .13092 m
.00625 .13092 L
s
[(-30)] -0.0125 .13092 1 0 Mshowa
0 .17602 m
.00625 .17602 L
s
[(-20)] -0.0125 .17602 1 0 Mshowa
0 .22111 m
.00625 .22111 L
s
[(-10)] -0.0125 .22111 1 0 Mshowa
0 .26621 m
.00625 .26621 L
s
[(0)] -0.0125 .26621 1 0 Mshowa
0 .3113 m
.00625 .3113 L
s
[(10)] -0.0125 .3113 1 0 Mshowa
.125 Mabswid
0 .04975 m
.00375 .04975 L
s
0 .05877 m
.00375 .05877 L
s
0 .06779 m
.00375 .06779 L
s
0 .07681 m
.00375 .07681 L
s
0 .09485 m
.00375 .09485 L
s
0 .10387 m
.00375 .10387 L
s
0 .11288 m
.00375 .11288 L
s
0 .1219 m
.00375 .1219 L
s
0 .13994 m
.00375 .13994 L
s
0 .14896 m
.00375 .14896 L
s
0 .15798 m
.00375 .15798 L
s
0 .167 m
.00375 .167 L
s
0 .18504 m
.00375 .18504 L
s
0 .19405 m
.00375 .19405 L
s
0 .20307 m
.00375 .20307 L
s
0 .21209 m
.00375 .21209 L
s
0 .23013 m
.00375 .23013 L
s
0 .23915 m
.00375 .23915 L
s
0 .24817 m
.00375 .24817 L
s
0 .25719 m
.00375 .25719 L
s
0 .27523 m
.00375 .27523 L
s
0 .28424 m
.00375 .28424 L
s
0 .29326 m
.00375 .29326 L
s
0 .30228 m
.00375 .30228 L
s
0 .03171 m
.00375 .03171 L
s
0 .02269 m
.00375 .02269 L
s
0 .01368 m
.00375 .01368 L
s
0 .00466 m
.00375 .00466 L
s
0 .32032 m
.00375 .32032 L
s
0 .32934 m
.00375 .32934 L
s
.25 Mabswid
0 0 m
0 .33333 L
s
gsave
-0.01875 .16667 -101.375 -10.5938 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 21.1875 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(dB) show
81.375 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.0238 .32708 m
.0238 .33333 L
s
gsave
.0238 .34583 -75.25 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 21.1875 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(0.01) show
87.500 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.2457 .32708 m
.2457 .33333 L
s
gsave
.2457 .34583 -75.25 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 21.1875 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(0.05) show
87.500 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.34127 .32708 m
.34127 .33333 L
s
gsave
.34127 .34583 -72.1875 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 21.1875 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(0.1) show
81.375 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.56316 .32708 m
.56316 .33333 L
s
gsave
.56316 .34583 -72.1875 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 21.1875 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(0.5) show
81.375 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.65873 .32708 m
.65873 .33333 L
s
gsave
.65873 .34583 -66.0625 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 21.1875 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(1) show
69.125 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.88062 .32708 m
.88062 .33333 L
s
gsave
.88062 .34583 -66.0625 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 21.1875 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
69.125 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.97619 .32708 m
.97619 .33333 L
s
gsave
.97619 .34583 -69.125 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 21.1875 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(10) show
75.250 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.001 w
.11937 .32958 m
.11937 .33333 L
s
.17527 .32958 m
.17527 .33333 L
s
.21494 .32958 m
.21494 .33333 L
s
.27084 .32958 m
.27084 .33333 L
s
.29209 .32958 m
.29209 .33333 L
s
.3105 .32958 m
.3105 .33333 L
s
.32674 .32958 m
.32674 .33333 L
s
.43683 .32958 m
.43683 .33333 L
s
.49273 .32958 m
.49273 .33333 L
s
.5324 .32958 m
.5324 .33333 L
s
.5883 .32958 m
.5883 .33333 L
s
.60955 .32958 m
.60955 .33333 L
s
.62796 .32958 m
.62796 .33333 L
s
.6442 .32958 m
.6442 .33333 L
s
.75429 .32958 m
.75429 .33333 L
s
.8102 .32958 m
.8102 .33333 L
s
.84986 .32958 m
.84986 .33333 L
s
.90576 .32958 m
.90576 .33333 L
s
.92701 .32958 m
.92701 .33333 L
s
.94543 .32958 m
.94543 .33333 L
s
.96166 .32958 m
.96166 .33333 L
s
.25 Mabswid
0 .33333 m
1 .33333 L
s
gsave
.5 .34583 -86.9063 9.1875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 19.4375 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 12.625 moveto
%%IncludeResource: font Helvetica-Bold
%%IncludeFont: Helvetica-Bold
/Helvetica-Bold findfont 8.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 12.625 moveto
%%IncludeResource: font Helvetica-Bold
%%IncludeFont: Helvetica-Bold
/Helvetica-Bold findfont 8.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(MAGNITUDE) show
110.813 12.625 moveto
%%IncludeResource: font Helvetica-Bold
%%IncludeFont: Helvetica-Bold
/Helvetica-Bold findfont 8.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.99375 .04073 m
1 .04073 L
s
.99375 .08583 m
1 .08583 L
s
.99375 .13092 m
1 .13092 L
s
.99375 .17602 m
1 .17602 L
s
.99375 .22111 m
1 .22111 L
s
.99375 .26621 m
1 .26621 L
s
.99375 .3113 m
1 .3113 L
s
.125 Mabswid
.99625 .04975 m
1 .04975 L
s
.99625 .05877 m
1 .05877 L
s
.99625 .06779 m
1 .06779 L
s
.99625 .07681 m
1 .07681 L
s
.99625 .09485 m
1 .09485 L
s
.99625 .10387 m
1 .10387 L
s
.99625 .11288 m
1 .11288 L
s
.99625 .1219 m
1 .1219 L
s
.99625 .13994 m
1 .13994 L
s
.99625 .14896 m
1 .14896 L
s
.99625 .15798 m
1 .15798 L
s
.99625 .167 m
1 .167 L
s
.99625 .18504 m
1 .18504 L
s
.99625 .19405 m
1 .19405 L
s
.99625 .20307 m
1 .20307 L
s
.99625 .21209 m
1 .21209 L
s
.99625 .23013 m
1 .23013 L
s
.99625 .23915 m
1 .23915 L
s
.99625 .24817 m
1 .24817 L
s
.99625 .25719 m
1 .25719 L
s
.99625 .27523 m
1 .27523 L
s
.99625 .28424 m
1 .28424 L
s
.99625 .29326 m
1 .29326 L
s
.99625 .30228 m
1 .30228 L
s
.99625 .03171 m
1 .03171 L
s
.99625 .02269 m
1 .02269 L
s
.99625 .01368 m
1 .01368 L
s
.99625 .00466 m
1 .00466 L
s
.99625 .32032 m
1 .32032 L
s
.99625 .32934 m
1 .32934 L
s
.25 Mabswid
1 0 m
1 .33333 L
s
gsave
1.0125 .16667 -61 -10.5938 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 21.1875 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.125 13.313 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .33333 L
0 .33333 L
closepath
clip
newpath
.5 Mabswid
.02381 .32051 m
.13457 .32052 L
.1907 .32053 L
.2357 .32055 L
.26792 .32058 L
.29222 .3206 L
.31139 .32064 L
.32976 .32068 L
.34688 .32072 L
.36216 .32078 L
.3769 .32084 L
.40011 .32097 L
.42342 .32115 L
.44176 .32135 L
.47208 .32178 L
.48668 .32207 L
.49898 .32234 L
.53756 .32349 L
.57 .32468 L
.57673 .32491 L
.5835 .32511 L
.58903 .32525 L
.59207 .32531 L
.59485 .32535 L
.59647 .32537 L
.59799 .32539 L
.60079 .3254 L
.60234 .3254 L
.60375 .32539 L
.60529 .32538 L
.6069 .32535 L
.60836 .32533 L
.60992 .32529 L
.6127 .32521 L
.61594 .32507 L
.61884 .32491 L
.62341 .32457 L
.62824 .32409 L
.63311 .32345 L
.63749 .32273 L
.64576 .32092 L
.65419 .31841 L
.66829 .31253 L
.68076 .30557 L
.69133 .29845 L
.73027 .26511 L
.75954 .23551 L
.7851 .20825 L
.8059 .1857 L
.82504 .16492 L
Mistroke
.84125 .14739 L
.85524 .13236 L
.86871 .11799 L
.88054 .10545 L
.8921 .0933 L
.90238 .08256 L
.9116 .073 L
.92077 .06355 L
.92907 .05506 L
.9366 .0474 L
.94418 .03973 L
.95111 .03277 L
.95812 .02578 L
.96454 .0194 L
.97046 .01357 L
.97619 .00794 L
Mfstroke
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  CellLabel->"From In[127]:=",
  ImageSize->{522, 174},
  ImageMargins->{{0, 0}, {0, 1}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40008:0000[Q000`40O003h00Oogooogoo37oo003o
OoooOol<Ool00?mooomoo`aoo`00ogooogoo37oo003oOolCOol00`00Oomoo`3eOol00?moo`5oo`@0
009oo`D0009oo`@0009oo`03001oogoo009oo`<000Aoo`<000=oo`<00>9oo`00ogoo0Woo00<007oo
Ool00Woo10000Woo00@007ooOol000=oo`03001oogoo00Eoo`04001oogoo0005Ool00`00Oomoo`3S
Ool00?moo`9oo`03001oogoo00Eoo`04001oogoo0002Ool01@00Oomoogoo000017oo0`000goo1000
0Woo00<007ooOol0hgoo003oOol1Ool40003Ool30003Ool30004Ool01000Oomoogoo10000goo0P00
17oo0`00hWoo003oOol@Ool00`00Oomoo`02Ool00`00Oomoo`3cOol00?moo`moo`8000Eoo`03001o
ogoo0?9oo`00ogooogoo37oo003oOoooOol<Ool00?mooomoo`aoo`00ogooogoo37oo003oOoooOol<
Ool00?mooomoo`aoo`00ogooogoo37oo003oOoooOol<Ool006Qoo`8000Aoo`8000Aoo`8000=oo`D0
03Eoo`8000Aoo`8000Aoo`8000Aoo`80011oo`8000Aoo`8000=oo`D003aoo`8000Aoo`8000Aoo`80
01Moo`D004Qoo`8001Yoo`D0009oo`80051oo`00Igoo00@007ooOol000Qoo`04001oogoo0004Ool0
0`00Oomoo`0dOol01000Oomoo`0027oo00@007ooOol0009oo`04001oogoo000>Ool01000Oomoo`00
2Woo00<007ooOol0>goo00@007ooOol000Qoo`04001oogoo000HOol00`00Oomoo`17Ool01000Oomo
o`006goo00D007ooOomoo`00009oo`03001oogoo04eoo`00Igoo00@007ooOol000Qoo`04001oogoo
0004Ool00`00Oomoo`0dOol01000Oomoo`0027oo00@007ooOol000Eoo`03001oogoo00aoo`04001o
ogoo000:Ool00`00Oomoo`0kOol01000Oomoo`002goo00<007ooOol05Woo00<007ooOol0BWoo00<0
07ooOol06Goo00D007ooOomoo`00009oo`03001oogoo04eoo`00Igoo00@007ooOol000Qoo`04001o
ogoo0004Ool00`00Oomoo`0dOol01000Oomoo`0027oo00@007ooOol000=oo`8000moo`04001oogoo
000:Ool00`00Oomoo`0kOol01000Oomoo`002Goo0P006Goo00<007ooOol0B7oo0P0077oo00D007oo
Oomoo`00009oo`03001oogoo04eoo`00Igoo00@007ooOol000Qoo`04001oogoo0004Ool00`00Oomo
o`0dOol01000Oomoo`0027oo00@007ooOol000=oo`03001oogoo00ioo`04001oogoo000:Ool00`00
Oomoo`0kOol01000Oomoo`002Goo00<007ooOol067oo00<007ooOol0B7oo00<007ooOol06goo00D0
07ooOomoo`00009oo`03001oogoo04eoo`00J7oo0P002Woo0P0017oo0P00=goo0P002Woo0P0017oo
0`003goo0P002Woo0P00?Woo0P002Woo0`005goo0P00BWoo0`006Woo0P0017oo0P00D7oo003oOooo
Ool<Ool00?mooomoo`aoo`00ogooogoo37oo003oOoooOol<Ool00?mooomoo`aoo`00ogooogoo37oo
001ZOooo001F001;Ool006Yoo`03001oogoo00Eoo`03001oogoo01ioo`03001oogoo011oo`03001o
oekg00Yoo`03001oogoo00Qoo`03001oogoo00Eoo`03001oogoo00Aoo`03001oogoo00Aoo`03001o
ogoo009oo`03001oogoo009oo`03001oogoo01ioo`03001oogoo011oo`03001ooekg00Yoo`03001o
ogoo00Qoo`03001oogoo00Eoo`03001oogoo00Aoo`03001oogoo00Aoo`03001oogoo009oo`03001o
ogoo009oo`03001oogoo01ioo`03001oogoo011oo`03001ooekg00Yoo`03001oogoo00Qoo`03001o
ogoo00Eoo`03001oogoo00Eoo`03001oogoo00=oo`03001oogoo009oo`03001oogoo009oo`03001o
ogoo00Eoo`03001oogoo04Uoo`00JWoo0P001Woo00<007ooOol0<goo00=NmgooOol04goo00<007oo
Ool07Goo00<007ooOol0<goo00=NmgooOol04goo00<007ooOol07Goo00<007ooOol0<goo00=Nmgoo
Ool04goo00<007ooOol07Goo00<007ooOol017oo0P00Bgoo001ZOol00`00Oomoo`05Ool00ekgOomo
o`0cOol00ekgOomoo`0cOol00ekgOomoo`0cOol00ekgOomoo`0cOol00ekgOomoo`0cOol00ekgOomo
o`0cOol00`00Oomoo`05Ool00`00Oomoo`19Ool006Yoo`03001oogoo00Eoo`03G_Moogoo03=oo`03
G_Moogoo03=oo`03G_Moogoo03=oo`03G_Moogoo03=oo`03G_Moogoo03=oo`03G_Moogoo039oo`03
001Nmgoo00Ioo`03001oogoo04Uoo`00JWoo0P001Woo00=NmgooOol0<goo00=NmgooOol0<goo00=N
mgooOol0<goo00=NmgooOol0<goo00=NmgooOol0<goo00=NmgooOol0<Goo00<007ooG_L01Woo0P00
Bgoo001ZOol00`00Oomoo`05Ool00ekgOomoo`0cOol00ekgOomoo`0cOol00ekgOomoo`0cOol00ekg
Oomoo`0cOol00ekgOomoo`0cOol00ekgOomoo`0`Ool01000Oomooekg1goo00<007ooOol0BGoo001Z
Ool00`00Oomoo`05Ool00ekgOomoo`0cOol00ekgOomoo`0cOol00ekgOomoo`0cOol00ekgOomoo`0c
Ool00ekgOomoo`0cOol00ekgOomoo`0_Ool01@00OomoogooG_L01goo00<007ooOol0BGoo001ZOol2
0006Ool00ekgOomoo`0cOol00ekgOomoo`0cOol00ekgOomoo`0cOol00ekgOomoo`0cOol00ekgOomo
o`0cOol00ekgOomoo`0^Ool00`00Oomoo`02Ool00ekgOomoo`04Ool2001;Ool006Yoo`03001oogoo
00Eoo`03G_Moogoo03=oo`03G_Moogoo03=oo`03G_Moogoo03=oo`03G_Moogoo03=oo`03G_Moogoo
03=oo`03G_Moogoo02eoo`03001oogoo00=oo`03G_Moogoo00Eoo`03001oogoo04Uoo`00JWoo00<0
07ooOol01Goo00=NmgooOol0<goo00=NmgooOol0<goo00=NmgooOol0<goo00=NmgooOol0<goo00=N
mgooOol0<goo00=NmgooOol0;7oo00<007ooOol017oo00=NmgooOol01Goo00<007ooOol0BGoo001Z
Ool20006Ool00ekgOomoo`0cOol00ekgOomoo`0cOol00ekgOomoo`0cOol00ekgOomoo`0cOol00ekg
Oomoo`0cOol00ekgOomoo`0[Ool00`00Oomoo`05Ool00ekgOomoo`04Ool2001;Ool005aoo`8000Ao
o`8000Ioo`03001oogoo00Eoo`03G_Moogoo03=oo`03G_Moogoo03=oo`03G_Moogoo03=oo`03G_Mo
ogoo03=oo`03G_Moogoo03=oo`03G_Moogoo02Yoo`03001oogoo00Ioo`03G_Moogoo00Eoo`03001o
ogoo04Uoo`00Fgoo00@007ooOol0009oo`04001oogoo0005Ool00`00Oomoo`05Ool00ekgOomoo`0c
Ool00ekgOomoo`0cOol00ekgOomoo`0cOol00ekgOomoo`0cOol00ekgOomoo`0cOol00ekgOomoo`0Y
Ool00`00Oomoo`07Ool00ekgOomoo`05Ool00`00Oomoo`19Ool005ioo`04001oogoo0002Ool00`00
Oomoo`03Ool3003oG_LoG_L00`00G_MNm`0>G_L3001;Ool005Eoo`@000=oo`8000=oo`04001oogoo
0005Ool00`00Oomoo`05Ool00ekgOomoo`0cOol00ekgOomoo`0cOol00ekgOomoo`0cOol00ekgOomo
o`0cOol00ekgOomoo`0cOol00ekgOomoo`0WOol00`00Oomoo`09Ool00ekgOomoo`05Ool00`00Oomo
o`19Ool005aoo`03001oogoo009oo`04001oogoo0005Ool00`00Oomoo`05Ool00ekgOomoo`0cOol0
0ekgOomoo`0cOol00ekgOomoo`0cOol00ekgOomoo`0cOol00ekgOomoo`0cOol00ekgOomoo`0VOol0
0`00Oomoo`0:Ool00ekgOomoo`05Ool00`00Oomoo`19Ool005aoo`<000=oo`8000Ioo`8000Ioo`03
G_Moogoo03=oo`03G_Moogoo03=oo`03G_Moogoo03=oo`03G_Moogoo03=oo`03G_Moogoo03=oo`03
G_Moogoo02Eoo`03001oogoo00]oo`03G_Moogoo00Aoo`8004]oo`00JWoo00<007ooOol01Goo00=N
mgooOol0<goo00=NmgooOol0<goo00=NmgooOol0<goo00=NmgooOol0<goo00=NmgooOol0<goo00=N
mgooOol097oo00<007ooOol037oo00=NmgooOol01Goo00<007ooOol0BGoo001ZOol00`00Oomoo`05
Ool00ekgOomoo`0cOol00ekgOomoo`0cOol00ekgOomoo`0cOol00ekgOomoo`0cOol00ekgOomoo`0c
Ool00ekgOomoo`0SOol00`00Oomoo`0=Ool00ekgOomoo`05Ool00`00Oomoo`19Ool006Yoo`8000Io
o`03G_Moogoo03=oo`03G_Moogoo03=oo`03G_Moogoo03=oo`03G_Moogoo03=oo`03G_Moogoo03=o
o`03G_Moogoo029oo`03001oogoo00ioo`03G_Moogoo00Aoo`8004]oo`00JWoo00<007ooOol01Goo
00=NmgooOol0<goo00=NmgooOol0<goo00=NmgooOol0<goo00=NmgooOol0<goo00=NmgooOol0<goo
00=NmgooOol08Goo00<007ooOol03goo00=NmgooOol01Goo00<007ooOol0BGoo001ZOol00`00Oomo
o`05Ool00ekgOomoo`0cOol00ekgOomoo`0cOol00ekgOomoo`0cOol00ekgOomoo`0cOol00ekgOomo
o`0cOol00ekgOomoo`0POol00`00Oomoo`0@Ool00ekgOomoo`05Ool00`00Oomoo`19Ool006Yoo`80
00Ioo`03G_Moogoo03=oo`03G_Moogoo03=oo`03G_Moogoo03=oo`03G_Moogoo03=oo`03G_Moogoo
03=oo`03G_Moogoo01moo`03001oogoo015oo`03G_Moogoo00Aoo`8004]oo`00JWoo00<007ooOol0
1Goo00=NmgooOol0<goo00=NmgooOol0<goo00=NmgooOol0<goo00=NmgooOol0<goo00=NmgooOol0
<goo00=NmgooOol07Woo00<007ooOol04Woo00=NmgooOol01Goo00<007ooOol0BGoo001ZOol00`00
Oomoo`05Ool00ekgOomoo`0cOol00ekgOomoo`0cOol00ekgOomoo`0cOol00ekgOomoo`0cOol00ekg
Oomoo`0cOol00ekgOomoo`0MOol00`00Oomoo`0COol00ekgOomoo`05Ool00`00Oomoo`19Ool006Yo
o`8000Ioo`03G_Moogoo03=oo`03G_Moogoo03=oo`03G_Moogoo03=oo`03G_Moogoo03=oo`03G_Mo
ogoo03=oo`03G_Moogoo01aoo`03001oogoo01Aoo`03G_Moogoo00Aoo`8004]oo`00GGoo0`000Woo
0P001Woo00<007ooOol01Goo00=NmgooOol0<goo00=NmgooOol0<goo00=NmgooOol0<goo00=Nmgoo
Ool0<goo00=NmgooOol0<goo00=NmgooOol06goo00<007ooOol05Goo00=NmgooOol01Goo00<007oo
Ool0BGoo001NOol01000Oomoo`000Woo00<007ooOol00goo00<007ooOol01Goo00=NmgooOol0<goo
00=NmgooOol0<goo00=NmgooOol0<goo00=NmgooOol0<goo00=NmgooOol0<goo00=NmgooOol06Woo
00<007ooOol05Woo00=NmgooOol01Goo00<007ooOol0BGoo001KOol500001Goo001oogoo00001Goo
0`00oekg<5kg00<005kgG_L07Ekg0`00Bgoo001EOol40002Ool01000Oomoo`000Woo00@007ooOol0
00Eoo`03001oogoo00Eoo`03G_Moogoo03=oo`03G_Moogoo03=oo`03G_Moogoo03=oo`03G_Moogoo
03=oo`03G_Moogoo03=oo`03G_Moogoo01Qoo`03001oogoo01Qoo`03G_Moogoo00Eoo`03001oogoo
04Uoo`00G7oo00<007oo00000Woo00@007ooOol000Eoo`03001oogoo00Eoo`03G_Moogoo03=oo`03
G_Moogoo03=oo`03G_Moogoo03=oo`03G_Moogoo03=oo`03G_Moogoo03=oo`03G_Moogoo01Qoo`03
001oogoo01Qoo`03G_Moogoo00Eoo`03001oogoo04Uoo`00GGoo0P000goo0P001Woo0P001Woo00=N
mgooOol0<goo00=NmgooOol0<goo00=NmgooOol0<goo00=NmgooOol0<goo00=NmgooOol0<goo00=N
mgooOol05goo00<007ooOol06Goo00=NmgooOol017oo0P00Bgoo001ZOol00`00Oomoo`05Ool00ekg
Oomoo`0cOol00ekgOomoo`0cOol00ekgOomoo`0cOol00ekgOomoo`0cOol00ekgOomoo`0cOol00ekg
Oomoo`0FOol00`00Oomoo`0JOol00ekgOomoo`05Ool00`00Oomoo`19Ool006Yoo`03001oogoo00Eo
o`03G_Moogoo03=oo`03G_Moogoo03=oo`03G_Moogoo03=oo`03G_Moogoo03=oo`03G_Moogoo03=o
o`03G_Moogoo01Eoo`03001oogoo01]oo`03G_Moogoo00Eoo`03001oogoo04Uoo`00JWoo0P001Woo
00=NmgooOol0<goo00=NmgooOol0<goo00=NmgooOol0<goo00=NmgooOol0<goo00=NmgooOol0<goo
00=NmgooOol057oo00<007ooOol077oo00=NmgooOol017oo0P00Bgoo001ZOol00`00Oomoo`05Ool0
0ekgOomoo`0cOol00ekgOomoo`0cOol00ekgOomoo`0cOol00ekgOomoo`0cOol00ekgOomoo`0cOol0
0ekgOomoo`0COol00`00Oomoo`0MOol00ekgOomoo`05Ool00`00Oomoo`19Ool006Yoo`03001oogoo
00Eoo`03G_Moogoo03=oo`03G_Moogoo03=oo`03G_Moogoo03=oo`03G_Moogoo03=oo`03G_Moogoo
03=oo`03G_Moogoo019oo`03001oogoo01ioo`03G_Moogoo00Eoo`03001oogoo04Uoo`00JWoo00<0
07ooOol01Goo00=NmgooOol0<goo00=NmgooOol0<goo00=NmgooOol0<goo00=NmgooOol0<goo00=N
mgooOol0<goo00=NmgooOol04Goo00<007ooOol07goo00=NmgooOol01Goo00<007ooOol0BGoo001Z
Ool20006Ool00ekgOomoo`0cOol00ekgOomoo`0cOol00ekgOomoo`0cOol00ekgOomoo`0cOol00ekg
Oomoo`0cOol00ekgOomoo`0@Ool00`00Oomoo`0POol00ekgOomoo`04Ool2001;Ool006Yoo`03001o
ogoo00Eoo`03G_Moogoo03=oo`03G_Moogoo03=oo`03G_Moogoo03=oo`03G_Moogoo03=oo`03G_Mo
ogoo03=oo`03G_Moogoo00moo`03001oogoo025oo`03G_Moogoo00Eoo`03001oogoo04Uoo`00JWoo
00<007ooOol01Goo00=NmgooOol0<goo00=NmgooOol0<goo00=NmgooOol0<goo00=NmgooOol0<goo
00=NmgooOol0<goo00=NmgooOol03Woo00<007ooOol08Woo00=NmgooOol01Goo00<007ooOol0BGoo
001ZOol20006Ool00ekgOomoo`0cOol00ekgOomoo`0cOol00ekgOomoo`0cOol00ekgOomoo`0cOol0
0ekgOomoo`0cOol00ekgOomoo`0=Ool00`00Oomoo`0SOol00ekgOomoo`04Ool2001;Ool005aoo`80
00Aoo`8000Ioo`03001oogoo00Eoo`03G_Moogoo03=oo`03G_Moogoo03=oo`03G_Moogoo03=oo`03
G_Moogoo03=oo`03G_Moogoo03=oo`03G_Moogoo00aoo`03001oogoo02Aoo`03G_Moogoo00Eoo`03
001oogoo04Uoo`00Fgoo00@007ooOol0009oo`04001oogoo0005Ool00`00Oomoo`05Ool00ekgOomo
o`0cOol00ekgOomoo`0cOol00ekgOomoo`0cOol00ekgOomoo`0cOol00ekgOomoo`0cOol00ekgOomo
o`0;Ool00`00Oomoo`0UOol00ekgOomoo`05Ool00`00Oomoo`19Ool005eoo`05001oogooOol00002
Ool00`00Oomoo`03Ool3003oG_LQG_L00`00G_MNm`0/G_L3001;Ool005Eoo`@000Eoo`04001oogoo
0002Ool00`00Oomoo`03Ool00`00Oomoo`05Ool00ekgOomoo`0cOol00ekgOomoo`0cOol00ekgOomo
o`0cOol00ekgOomoo`0cOol00ekgOomoo`0cOol00ekgOomoo`09Ool00`00Oomoo`0WOol00ekgOomo
o`05Ool00`00Oomoo`19Ool005]oo`04001oogoo0002Ool01000Oomoo`001Goo00<007ooOol01Goo
00=NmgooOol0<goo00=NmgooOol0<goo00=NmgooOol0<goo00=NmgooOol0<goo00=NmgooOol0<goo
00=NmgooOol027oo00<007ooOol0:7oo00=NmgooOol01Goo00<007ooOol0BGoo001LOol20004Ool2
0006Ool20006Ool00ekgOomoo`0cOol00ekgOomoo`0cOol00ekgOomoo`0cOol00ekgOomoo`0cOol0
0ekgOomoo`0cOol00ekgOomoo`07Ool00`00Oomoo`0YOol00ekgOomoo`04Ool2001;Ool006Yoo`03
001oogoo00Eoo`03G_Moogoo03=oo`03G_Moogoo03=oo`03G_Moogoo03=oo`03G_Moogoo03=oo`03
G_Moogoo03=oo`03G_Moogoo00Ioo`03001oogoo02Yoo`03G_Moogoo00Eoo`03001oogoo04Uoo`00
JWoo00<007ooOol01Goo00=NmgooOol0<goo00=NmgooOol0<goo00=NmgooOol0<goo00=NmgooOol0
<goo00=NmgooOol0<goo00=NmgooOol01Goo00<007ooOol0:goo00=NmgooOol01Goo00<007ooOol0
BGoo001ZOol20006Ool00ekgOomoo`0cOol00ekgOomoo`0cOol00ekgOomoo`0cOol00ekgOomoo`0c
Ool00ekgOomoo`0cOol00ekgOomoo`04Ool00`00Oomoo`0/Ool00ekgOomoo`04Ool2001;Ool006Yo
o`03001oogoo00Eoo`03G_Moogoo03=oo`03G_Moogoo03=oo`03G_Moogoo03=oo`03G_Moogoo03=o
o`03G_Moogoo03=oo`03G_Moogoo00=oo`03001oogoo02eoo`03G_Moogoo00Eoo`03001oogoo04Uo
o`00JWoo00<007ooOol01Goo00=NmgooOol0<goo00=NmgooOol0<goo00=NmgooOol0<goo00=Nmgoo
Ool0<goo00=NmgooOol0<goo00=NmgooOol00Woo00<007ooOol0;Woo00=NmgooOol01Goo00<007oo
Ool0BGoo001ZOol20006Ool00ekgOomoo`0cOol00ekgOomoo`0cOol00ekgOomoo`0cOol00ekgOomo
o`0cOol00ekgOomoo`0cOol00ekgOomoo`02Ool00`00Oomoo`0^Ool00ekgOomoo`04Ool2001;Ool0
03moo`P002=oo`03001oogoo00Eoo`03G_Moogoo03=oo`03G_Moogoo03=oo`03G_Moogoo03=oo`03
G_Moogoo03=oo`03G_Moogoo03=oo`05G_MoogooOol0000aOol00ekgOomoo`05Ool00`00Oomoo`19
Ool003ioo`04001oogoo0002Ool01000Oomoo`008Woo00<007ooOol01Goo00=NmgooOol0<goo00=N
mgooOol0<goo00=NmgooOol0<goo00=NmgooOol0<goo00=NmgooOol0<goo00ANmgooOol0039oo`03
G_Moogoo00Eoo`03001oogoo04Uoo`00?Woo00@007ooOol0009oo`04001oogoo000ROol20006Ool0
0ekgOomoo`0cOol00ekgOomoo`0cOol00ekgOomoo`0cOol00ekgOomoo`0cOol00ekgOomoo`0cOol0
0ekgOol0000cOol00ekgOomoo`04Ool2001;Ool003moo`<0009oo`<001Aoo`@000=oo`8000Ioo`03
001oogoo00Eoo`03G_Moogoo03=oo`03G_Moogoo03=oo`03G_Moogoo03=oo`03G_Moogoo03=oo`03
G_Moogoo03=oo`03G_L007oo03=oo`03G_Moogoo00Eoo`03001oogoo04Uoo`00@Goo00@007ooOol0
009oo`03001oogoo015oo`03001oogoo00=oo`04001oogoo0005Ool00`00Oomoo`05Ool00ekgOomo
o`0cOol00ekgOomoo`0cOol00ekgOomoo`0cOol00ekgOomoo`0cOol00ekgOomoo`0cOol00`00Oomo
o`0cOol00ekgOomoo`05Ool00`00Oomoo`19Ool0041oo`800003Ool00000008001Eoo`03001oogoo
009oo`04001oogoo0005Ool3003oG_LCG_L00`00G_MNm`0jG_L3001;Ool005Eoo`@000Aoo`05001o
ogooOol00002Ool00`00Oomoo`03Ool00`00Oomoo`05Ool00ekgOomoo`0cOol00ekgOomoo`0cOol0
0ekgOomoo`0cOol00ekgOomoo`0cOol00ekgOomoo`0aOol00`00OomNm`0eOol00ekgOomoo`05Ool0
0`00Oomoo`19Ool005]oo`04001oogoo0002Ool01000Oomoo`001Goo00<007ooOol01Goo00=Nmgoo
Ool0<goo00=NmgooOol0<goo00=NmgooOol0<goo00=NmgooOol0<goo00=NmgooOol0<7oo00@007oo
OomNmcEoo`03G_Moogoo00Eoo`03001oogoo04Uoo`00G7oo0P0017oo0P001Woo0P001Woo00=Nmgoo
Ool0<goo00=NmgooOol0<goo00=NmgooOol0<goo00=NmgooOol0<goo00=NmgooOol0;goo00D007oo
Oomooekg03Eoo`03G_Moogoo00Aoo`8004]oo`00JWoo00<007ooOol01Goo00=NmgooOol0<goo00=N
mgooOol0<goo00=NmgooOol0<goo00=NmgooOol0<goo00=NmgooOol0;Woo00<007ooOol00Woo00=N
mgooOol0<goo00=NmgooOol01Goo00<007ooOol0BGoo001ZOol00`00Oomoo`05Ool00ekgOomoo`0c
Ool00ekgOomoo`0cOol00ekgOomoo`0cOol00ekgOomoo`0cOol00ekgOomoo`0]Ool00`00Oomoo`03
Ool00ekgOomoo`0cOol00ekgOomoo`05Ool00`00Oomoo`19Ool006Yoo`8000Ioo`03G_Moogoo03=o
o`03G_Moogoo03=oo`03G_Moogoo03=oo`03G_Moogoo03=oo`03G_Moogoo02aoo`03001oogoo00Ao
o`03G_Moogoo03=oo`03G_Moogoo00Aoo`8004]oo`00JWoo00<007ooOol01Goo00=NmgooOol0<goo
00=NmgooOol0<goo00=NmgooOol0<goo00=NmgooOol0<goo00=NmgooOol0:goo00<007ooOol01Goo
00=NmgooOol0<goo00=NmgooOol01Goo00<007ooOol0BGoo001ZOol00`00Oomoo`05Ool00ekgOomo
o`0cOol00ekgOomoo`0cOol00ekgOomoo`0cOol00ekgOomoo`0cOol00ekgOomoo`0[Ool00`00Oomo
o`05Ool00ekgOomoo`0cOol00ekgOomoo`05Ool00`00Oomoo`19Ool006Yoo`8000Ioo`03G_Moogoo
03=oo`03G_Moogoo03=oo`03G_Moogoo03=oo`03G_Moogoo03=oo`03G_Moogoo02Yoo`03001oogoo
00Ioo`03G_Moogoo03=oo`03G_Moogoo00Aoo`8004]oo`00JWoo00<007ooOol01Goo00=NmgooOol0
<goo00=NmgooOol0<goo00=NmgooOol0<goo00=NmgooOol0<goo00=NmgooOol0:Goo00<007ooOol0
1goo00=NmgooOol0<goo00=NmgooOol01Goo00<007ooOol0BGoo001ZOol00`00Oomoo`05Ool00ekg
Oomoo`0cOol00ekgOomoo`0cOol00ekgOomoo`0cOol00ekgOomoo`0cOol00ekgOomoo`0XOol00`00
Oomoo`08Ool00ekgOomoo`0cOol00ekgOomoo`05Ool00`00Oomoo`19Ool006Yoo`8000Ioo`03G_Mo
ogoo03=oo`03G_Moogoo03=oo`03G_Moogoo03=oo`03G_Moogoo03=oo`03G_Moogoo02Moo`03001o
ogoo00Uoo`03G_Moogoo03=oo`03G_Moogoo00Aoo`8004]oo`00Fgoo1@000Woo0P001Woo00<007oo
Ool01Goo00=NmgooOol0<goo00=NmgooOol0<goo00=NmgooOol0<goo00=NmgooOol0<goo00=Nmgoo
Ool09Woo00<007ooOol02Woo00=NmgooOol0<goo00=NmgooOol01Goo00<007ooOol0BGoo001MOol0
1@00Oomoogoo00000Woo00<007ooOol00goo00<007ooOol01Goo00=NmgooOol0<goo00=NmgooOol0
<goo00=NmgooOol0<goo00=NmgooOol0<goo00=NmgooOol09Goo00<007ooOol02goo00=NmgooOol0
<goo00=NmgooOol01Goo00<007ooOol0BGoo001MOol01@00Oomoogoo00000Woo00<007ooOol00goo
0`00oekg1Ekg00<005kgG_L0B5kg0`00Bgoo001EOol40004Ool01@00Oomoogoo00000Woo00<007oo
Ool00goo00<007ooOol01Goo00=NmgooOol0<goo00=NmgooOol0<goo00=NmgooOol0<goo00=Nmgoo
Ool0<goo00=NmgooOol097oo00<007ooOol037oo00=NmgooOol0<goo00=NmgooOol01Goo00<007oo
Ool0BGoo001MOol01@00Oomoogoo00000Woo00<007ooOol00goo00<007ooOol01Goo00=NmgooOol0
<goo00=NmgooOol0<goo00=NmgooOol0<goo00=NmgooOol0<goo00=NmgooOol08goo00<007ooOol0
3Goo00=NmgooOol0<goo00=NmgooOol01Goo00<007ooOol0BGoo001LOol20004Ool20006Ool20006
Ool00ekgOomoo`0cOol00ekgOomoo`0cOol00ekgOomoo`0cOol00ekgOomoo`0cOol00ekgOomoo`0R
Ool00`00Oomoo`0>Ool00ekgOomoo`0cOol00ekgOomoo`04Ool2001;Ool006Yoo`03001oogoo00Eo
o`03G_Moogoo03=oo`03G_Moogoo03=oo`03G_Moogoo03=oo`03G_Moogoo03=oo`03G_Moogoo025o
o`03001oogoo00moo`03G_Moogoo03=oo`03G_Moogoo00Eoo`03001oogoo04Uoo`00JWoo00<007oo
Ool01Goo00=NmgooOol0<goo00=NmgooOol0<goo00=NmgooOol0<goo00=NmgooOol0<goo00=Nmgoo
Ool087oo00<007ooOol047oo00=NmgooOol0<goo00=NmgooOol01Goo00<007ooOol0BGoo001ZOol0
0`00Oomoo`05Ool00ekgOomoo`0cOol00ekgOomoo`0cOol00ekgOomoo`0cOol00ekgOomoo`0cOol0
0ekgOomoo`0OOol00`00Oomoo`0AOol00ekgOomoo`0cOol00ekgOomoo`05Ool00`00Oomoo`19Ool0
06Yoo`8000Ioo`03G_Moogoo03=oo`03G_Moogoo03=oo`03G_Moogoo03=oo`03G_Moogoo03=oo`03
G_Moogoo01ioo`03001oogoo019oo`03G_Moogoo03=oo`03G_Moogoo00Aoo`8004]oo`00JWoo00<0
07ooOol01Goo00=NmgooOol0<goo00=NmgooOol0<goo00=NmgooOol0<goo00=NmgooOol0<goo00=N
mgooOol07Goo00<007ooOol04goo00=NmgooOol0<goo00=NmgooOol01Goo00<007ooOol0BGoo001Z
Ool00`00Oomoo`05Ool00ekgOomoo`0cOol00ekgOomoo`0cOol00ekgOomoo`0cOol00ekgOomoo`0c
Ool00ekgOomoo`0LOol00`00Oomoo`0DOol00ekgOomoo`0cOol00ekgOomoo`05Ool00`00Oomoo`19
Ool006Yoo`8000Ioo`03G_Moogoo03=oo`03G_Moogoo03=oo`03G_Moogoo03=oo`03G_Moogoo03=o
o`03G_Moogoo01]oo`03001oogoo01Eoo`03G_Moogoo03=oo`03G_Moogoo00Aoo`8004]oo`00JWoo
00<007ooOol01Goo00=NmgooOol0<goo00=NmgooOol0<goo00=NmgooOol0<goo00=NmgooOol0<goo
00=NmgooOol06Woo00<007ooOol05Woo00=NmgooOol0<goo00=NmgooOol01Goo00<007ooOol0BGoo
001ZOol00`00Oomoo`05Ool00ekgOomoo`0cOol00ekgOomoo`0cOol00ekgOomoo`0cOol00ekgOomo
o`0cOol00ekgOomoo`0IOol00`00Oomoo`0GOol00ekgOomoo`0cOol00ekgOomoo`05Ool00`00Oomo
o`19Ool006Yoo`8000Ioo`03G_Moogoo03=oo`03G_Moogoo03=oo`03G_Moogoo03=oo`03G_Moogoo
03=oo`03G_Moogoo01Qoo`03001oogoo01Qoo`03G_Moogoo03=oo`03G_Moogoo00Aoo`8004]oo`00
HWoo0P001Woo00<007ooOol01Goo00=NmgooOol0<goo00=NmgooOol0<goo00=NmgooOol0<goo00=N
mgooOol0<goo00=NmgooOol05goo00<007ooOol06Goo00=NmgooOol0<goo00=NmgooOol01Goo00<0
07ooOol0BGoo001QOol01000Oomoo`001Goo00<007ooOol01Goo00=NmgooOol0<goo00=NmgooOol0
<goo00=NmgooOol0<goo00=NmgooOol0<goo00=NmgooOol05Woo00<007ooOol06Woo00=NmgooOol0
<goo00=NmgooOol01Goo00<007ooOol0BGoo001QOol01000Oomoo`001Goo0`00mEkg00<005kgG_L0
Eekg0`00Bgoo001QOol01000Oomoo`001Goo00<007ooOol01Goo00=NmgooOol0<goo00=NmgooOol0
<goo00=NmgooOol0<goo00=NmgooOol0<goo00=NmgooOol057oo00<007ooOol077oo00=NmgooOol0
<goo00=NmgooOol01Goo00<007ooOol0BGoo001QOol01000Oomoo`001Goo00<007ooOol01Goo00=N
mgooOol0<goo00=NmgooOol0<goo00=NmgooOol0<goo00=NmgooOol0<goo00=NmgooOol04Woo0P00
7goo00=NmgooOol0<goo00=NmgooOol01Goo00<007ooOol0BGoo001ROol20006Ool20006Ool00ekg
Oomoo`0cOol00ekgOomoo`0cOol00ekgOomoo`0cOol00ekgOomoo`0cOol00ekgOomoo`0AOol00`00
Oomoo`0OOol00ekgOomoo`0cOol00ekgOomoo`04Ool2001;Ool006Yoo`03001oogoo00Eoo`03G_Mo
ogoo03=oo`03G_Moogoo03=oo`03G_Moogoo03=oo`03G_Moogoo03=oo`03G_Moogoo011oo`03001o
ogoo021oo`03G_Moogoo03=oo`03G_Moogoo00Eoo`03001oogoo04Uoo`00JWoo00<007ooOol01Goo
00=NmgooOol0<goo00=NmgooOol0<goo00=NmgooOol0<goo00=NmgooOol0<goo00=NmgooOol03goo
00<007ooOol08Goo00=NmgooOol0<goo00=NmgooOol01Goo00<007ooOol0BGoo001ZOol20006Ool0
0ekgOomoo`0cOol00ekgOomoo`0cOol00ekgOomoo`0cOol00ekgOomoo`0cOol00ekgOomoo`0>Ool0
0`00Oomoo`0ROol00ekgOomoo`0cOol00ekgOomoo`04Ool2001;Ool006Yoo`03001oogoo00Eoo`03
G_Moogoo03=oo`03G_Moogoo03=oo`03G_Moogoo03=oo`03G_Moogoo03=oo`03G_Moogoo00eoo`03
001oogoo02=oo`03G_Moogoo03=oo`03G_Moogoo00Eoo`03001oogoo04Uoo`00JWoo00<007ooOol0
1Goo00=NmgooOol0<goo00=NmgooOol0<goo00=NmgooOol0<goo00=NmgooOol0<goo00=NmgooOol0
2goo0P009Woo00=NmgooOol0<goo00=NmgooOol01Goo00<007ooOol0BGoo001ZOol20006Ool00ekg
Oomoo`0cOol00ekgOomoo`0cOol00ekgOomoo`0cOol00ekgOomoo`0cOol00ekgOomoo`0:Ool00`00
Oomoo`0VOol00ekgOomoo`0cOol00ekgOomoo`04Ool2001;Ool006Yoo`03001oogoo00Eoo`03G_Mo
ogoo03=oo`03G_Moogoo03=oo`03G_Moogoo03=oo`03G_Moogoo03=oo`03G_Moogoo00Uoo`03001o
ogoo02Moo`03G_Moogoo03=oo`03G_Moogoo00Eoo`03001oogoo04Uoo`00JWoo00<007ooOol01Goo
00=NmgooOol0<goo00=NmgooOol0<goo00=NmgooOol0<goo00=NmgooOol0<goo00=NmgooOol027oo
00<007ooOol0:7oo00=NmgooOol0<goo00=NmgooOol01Goo00<007ooOol0BGoo001ZOol20006Ool0
0ekgOomoo`0cOol00ekgOomoo`0cOol00ekgOomoo`0cOol00ekgOomoo`0cOol00ekgOomoo`06Ool2
000[Ool00ekgOomoo`0cOol00ekgOomoo`04Ool2001;Ool005]oo`D0009oo`8000Ioo`03001oogoo
00Eoo`03G_Moogoo03=oo`03G_Moogoo03=oo`03G_Moogoo03=oo`03G_Moogoo03=oo`03G_Moogoo
00Eoo`03001oogoo02]oo`03G_Moogoo03=oo`03G_Moogoo00Eoo`03001oogoo04Uoo`00GGoo00D0
07ooOomoo`00009oo`03001oogoo00=oo`03001oogoo00Eoo`03G_Moogoo03=oo`03G_Moogoo03=o
o`03G_Moogoo03=oo`03G_Moogoo03=oo`03G_Moogoo00=oo`8002ioo`03G_Moogoo03=oo`03G_Mo
ogoo00Eoo`03001oogoo04Uoo`00GGoo00D007ooOomoo`00009oo`03001oogoo00=oo`<00>5Nm`80
06aNm`<004]oo`00GGoo00D007ooOomoo`00009oo`03001oogoo00=oo`03001oogoo00Eoo`03G_Mo
ogoo03=oo`03G_Moogoo03=oo`03G_Moogoo03=oo`03G_Moogoo03=oo`04G_Moogoo000bOol00ekg
Oomoo`0cOol00ekgOomoo`05Ool00`00Oomoo`19Ool005eoo`05001oogooOol00002Ool00`00Oomo
o`03Ool00`00Oomoo`05Ool00ekgOomoo`0cOol00ekgOomoo`0cOol00ekgOomoo`0cOol00ekgOomo
o`0cOol00ekg0000000cOol00ekgOomoo`0cOol00ekgOomoo`05Ool00`00Oomoo`19Ool005aoo`80
00Aoo`8000Ioo`8000Iooh/001Moo`03G_Moogoo02ioo`H003Eoo`03G_Moogoo03=oo`03G_Moogoo
00Aoo`8004]oo`00JWoo00<007ooOol01Goo00=NmgooOol0<goo00=NmgooOol0<goo00=NmgooOol0
77oo:P006Goo1@001Goo00=NmgooOol0<goo00=NmgooOol0<goo00=NmgooOol01Goo00<007ooOol0
BGoo001ZOol00`00Oomoo`05Ool00`00Oomoo`0cOol00ekgOomoo`0COol00`00Oomoo`0MOol00`00
Oomoo`0cOol00ekgOomoo`0@OolI000:Ool00`00Oomoo`0cOol00ekgOomoo`0COol00`00Oomoo`0M
Ool00`00Oomoo`05Ool00`00Oomoo`19Ool006Yoo`8000Ioo`03001oogoo01ioo`03001oogoo011o
o`03001ooekg00Yoo`03001oogoo00Qoo`03001oogoo00Eoo`03001oogoo00Aoo`03001oogoo00Ao
o`03001oogoo009oo`03001oogoo009oo`03001oogoo01ioo`03001oogoo011oo`03001ooekg00Yo
o`03001oogoo00Qoo`03001oogoo00Eoo`03001oogoo00Aoo`03001oogoo00Aoo`03001oogoo009o
o`03001oogoo009oo`03001oogoo01ioo`03001oogoo011oo`03001ooekg00Yoo`03001oogoo00Qo
o`03001oogoo00Eoo`03001oogoo00Eoo`03001oogoo00=oo`03001oogoo009oo`03001oogoo009o
o`03001oogoo00Aoo`8004]oo`00JWoo00<007ooOol01Goo00<007ooOol07Woo00<007ooOol047oo
00<007ooG_L02Woo00<007ooOol027oo00<007ooOol01Goo00<007ooOol017oo00<007ooOol017oo
00<007ooOol00Woo00<007ooOol00Woo00<007ooOol07Woo00<007ooOol047oo00<007ooG_L02Woo
00<007ooOol027oo00<007ooOol01Goo00<007ooOol017oo00<007ooOol017oo00<007ooOol00Woo
00<007ooOol00Woo00<007ooOol07Woo00<007ooOol047oo00<007ooG_L02Woo00<007ooOol027oo
00<007ooOol01Goo00<007ooOol01Goo00<007ooOol00goo00<007ooOol00Woo00<007ooOol00Woo
00<007ooOol01Goo00<007ooOol0BGoo001ZOooo001F001;Ool00?mooomoo`aoo`00ogooogoo37oo
003oOoooOol<Ool00?mooomoo`aoo`00ogooogoo37oo003oOoooOol<Ool00?mooomoo`aoo`00ogoo
ogoo37oo001XOol20004Ool20004Ool20003Ool5000eOol20004Ool20004Ool20004Ool2000@Ool2
0004Ool20003Ool5000lOol20004Ool20004Ool2000GOol50018Ool2000JOol50002Ool2001@Ool0
06Moo`04001oogoo0008Ool01000Oomoo`0017oo00<007ooOol0=7oo00@007ooOol000Qoo`04001o
ogoo0002Ool01000Oomoo`003Woo00@007ooOol000Yoo`03001oogoo03]oo`04001oogoo0008Ool0
1000Oomoo`0067oo00<007ooOol0Agoo00@007ooOol001]oo`05001oogooOol00002Ool00`00Oomo
o`1=Ool006Moo`04001oogoo0008Ool01000Oomoo`0017oo00<007ooOol0=7oo00@007ooOol000Qo
o`04001oogoo0005Ool00`00Oomoo`0<Ool01000Oomoo`002Woo00<007ooOol0>goo00@007ooOol0
00]oo`03001oogoo01Ioo`03001oogoo04Yoo`03001oogoo01Uoo`05001oogooOol00002Ool00`00
Oomoo`1=Ool006Moo`04001oogoo0008Ool01000Oomoo`0017oo00<007ooOol0=7oo00@007ooOol0
00Qoo`04001oogoo0003Ool2000?Ool01000Oomoo`002Woo00<007ooOol0>goo00@007ooOol000Uo
o`8001Uoo`03001oogoo04Qoo`8001aoo`05001oogooOol00002Ool00`00Oomoo`1=Ool006Moo`04
001oogoo0008Ool01000Oomoo`0017oo00<007ooOol0=7oo00@007ooOol000Qoo`04001oogoo0003
Ool00`00Oomoo`0>Ool01000Oomoo`002Woo00<007ooOol0>goo00@007ooOol000Uoo`03001oogoo
01Qoo`03001oogoo04Qoo`03001oogoo01]oo`05001oogooOol00002Ool00`00Oomoo`1=Ool006Qo
o`8000Yoo`8000Aoo`8003Moo`8000Yoo`8000Aoo`<000moo`8000Yoo`8003ioo`8000Yoo`<001Mo
o`8004Yoo`<001Yoo`8000Aoo`80051oo`00ogooogoo37oo003oOoooOol<Ool00?mooomoo`aoo`00
ogooogoo37oo003oOoooOol<Ool00?mooomoo`aoo`00oGoo00L007oo001oo`00Ool00003Ool00`00
Ool000020003Ool01000Oomoo`000Woo00@007ooOol000Aoo`8000=oo`@0009oo`@00=ioo`00oGoo
00H007oo001oo`00Ool60003Ool01@00Oomoo`00Ool00P000Woo00@007ooOol000=oo`04001oogoo
0002Ool01`00Oomoogoo001oo`000>5oo`00oGoo0P0000=oo`0000000Woo00D007oo001oo`00009o
o`80009oo`04001oo`000002Ool01000Oomoo`000goo00@007ooOol0009oo`07001oogooOol007oo
0000hGoo003mOol200000goo00000002Ool01@00Ool007oo00001Woo0P0000Eoo`00Oomoo`00009o
o`05001oogooOol00002Ool01000Oomoo`000goo00<007oo00000`00gWoo003mOol200000goo0000
0002Ool01@00Ool007oo00000goo00<007ooOol00P0000Eoo`00Oomoo`00009oo`05001oogooOol0
0002Ool01000Oomoo`000goo00<007oo0000hGoo003mOol200000goo00000003Ool01000Oomoogoo
0`000goo00@007ooOol0009oo`H00005Ool007ooOol00002Ool40002Ool4003NOol00?mooomoo`ao
o`00ogooogoo37oo0000\
\>"],
  ImageRangeCache->{{{0, 521}, {173, 0}} -> {-3.05992, -78.9839, 0.00925201, \
0.651332}},
  CellTags->{"Bode plot", "i:9", "b:20.1"}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .33333 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.65873 0.31746 0.326544 0.00108242 [
[.02381 -0.0125 -14.25 -13.1875 ]
[.02381 -0.0125 14.25 0 ]
[.2457 -0.0125 -14.25 -13.1875 ]
[.2457 -0.0125 14.25 0 ]
[.34127 -0.0125 -11.1875 -13.1875 ]
[.34127 -0.0125 11.1875 0 ]
[.56317 -0.0125 -11.1875 -13.1875 ]
[.56317 -0.0125 11.1875 0 ]
[.65873 -0.0125 -5.0625 -13.1875 ]
[.65873 -0.0125 5.0625 0 ]
[.88063 -0.0125 -5.0625 -13.1875 ]
[.88063 -0.0125 5.0625 0 ]
[.97619 -0.0125 -8.125 -13.1875 ]
[.97619 -0.0125 8.125 0 ]
[ 0 0 -0.125 0 ]
[.5 -0.0125 -23.4375 -26.375 ]
[.5 -0.0125 23.4375 -13.1875 ]
[-0.0125 .00182 -24 -4.5 ]
[-0.0125 .00182 0 4.5 ]
[-0.0125 .05594 -24 -4.5 ]
[-0.0125 .05594 0 4.5 ]
[-0.0125 .11006 -24 -4.5 ]
[-0.0125 .11006 0 4.5 ]
[-0.0125 .16418 -24 -4.5 ]
[-0.0125 .16418 0 4.5 ]
[-0.0125 .2183 -24 -4.5 ]
[-0.0125 .2183 0 4.5 ]
[-0.0125 .27242 -18 -4.5 ]
[-0.0125 .27242 0 4.5 ]
[-0.0125 .32654 -6 -4.5 ]
[-0.0125 .32654 0 4.5 ]
[ 0 0 -0.125 0 ]
[-0.01875 .16667 -52.5 -6.59375 ]
[-0.01875 .16667 -24 6.59375 ]
[.02381 .34583 -14.25 0 ]
[.02381 .34583 14.25 13.1875 ]
[.2457 .34583 -14.25 0 ]
[.2457 .34583 14.25 13.1875 ]
[.34127 .34583 -11.1875 0 ]
[.34127 .34583 11.1875 13.1875 ]
[.56317 .34583 -11.1875 0 ]
[.56317 .34583 11.1875 13.1875 ]
[.65873 .34583 -5.0625 0 ]
[.65873 .34583 5.0625 13.1875 ]
[.88063 .34583 -5.0625 0 ]
[.88063 .34583 5.0625 13.1875 ]
[.97619 .34583 -8.125 0 ]
[.97619 .34583 8.125 13.1875 ]
[ 0 .33333 .125 0 ]
[.5 .34583 -15.7813 13.1875 ]
[.5 .34583 15.7813 24.625 ]
[ 1 0 .125 0 ]
[1.0125 .16667 0 -6.59375 ]
[1.0125 .16667 10.125 6.59375 ]
[ 0 -0.0005 0 0 ]
[ 1 .33383 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
.75 g
.25 Mabswid
[ ] 0 setdash
.02381 0 m
.02381 .33333 L
s
.18254 0 m
.18254 .33333 L
s
.34127 0 m
.34127 .33333 L
s
.5 0 m
.5 .33333 L
s
.65873 0 m
.65873 .33333 L
s
.81746 0 m
.81746 .33333 L
s
.97619 0 m
.97619 .33333 L
s
0 .00182 m
1 .00182 L
s
0 .05594 m
1 .05594 L
s
0 .11006 m
1 .11006 L
s
0 .16418 m
1 .16418 L
s
0 .2183 m
1 .2183 L
s
0 .27242 m
1 .27242 L
s
0 .32654 m
1 .32654 L
s
0 g
.02381 0 m
.02381 .00625 L
s
gsave
.02381 -0.0125 -75.25 -17.1875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 21.1875 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(0.01) show
87.500 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.2457 0 m
.2457 .00625 L
s
gsave
.2457 -0.0125 -75.25 -17.1875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 21.1875 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(0.05) show
87.500 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.34127 0 m
.34127 .00625 L
s
gsave
.34127 -0.0125 -72.1875 -17.1875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 21.1875 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(0.1) show
81.375 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.56317 0 m
.56317 .00625 L
s
gsave
.56317 -0.0125 -72.1875 -17.1875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 21.1875 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(0.5) show
81.375 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.65873 0 m
.65873 .00625 L
s
gsave
.65873 -0.0125 -66.0625 -17.1875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 21.1875 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(1) show
69.125 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.88063 0 m
.88063 .00625 L
s
gsave
.88063 -0.0125 -66.0625 -17.1875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 21.1875 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
69.125 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.97619 0 m
.97619 .00625 L
s
gsave
.97619 -0.0125 -69.125 -17.1875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 21.1875 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(10) show
75.250 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.001 w
.11937 0 m
.11937 .00375 L
s
.17528 0 m
.17528 .00375 L
s
.21494 0 m
.21494 .00375 L
s
.27084 0 m
.27084 .00375 L
s
.29209 0 m
.29209 .00375 L
s
.3105 0 m
.3105 .00375 L
s
.32674 0 m
.32674 .00375 L
s
.43683 0 m
.43683 .00375 L
s
.49274 0 m
.49274 .00375 L
s
.5324 0 m
.5324 .00375 L
s
.5883 0 m
.5883 .00375 L
s
.60955 0 m
.60955 .00375 L
s
.62797 0 m
.62797 .00375 L
s
.6442 0 m
.6442 .00375 L
s
.7543 0 m
.7543 .00375 L
s
.8102 0 m
.8102 .00375 L
s
.84986 0 m
.84986 .00375 L
s
.90576 0 m
.90576 .00375 L
s
.92702 0 m
.92702 .00375 L
s
.94543 0 m
.94543 .00375 L
s
.96166 0 m
.96166 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
gsave
.5 -0.0125 -84.4375 -30.375 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 21.1875 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(rad) show
%%IncludeResource: font Mathematica2Mono
%%IncludeFont: Mathematica2Mono
/Mathematica2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
81.375 13.313 moveto
(\\220) show
87.500 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(sec) show
105.875 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 .00182 m
.00625 .00182 L
s
[(-300)] -0.0125 .00182 1 0 Mshowa
0 .05594 m
.00625 .05594 L
s
[(-250)] -0.0125 .05594 1 0 Mshowa
0 .11006 m
.00625 .11006 L
s
[(-200)] -0.0125 .11006 1 0 Mshowa
0 .16418 m
.00625 .16418 L
s
[(-150)] -0.0125 .16418 1 0 Mshowa
0 .2183 m
.00625 .2183 L
s
[(-100)] -0.0125 .2183 1 0 Mshowa
0 .27242 m
.00625 .27242 L
s
[(-50)] -0.0125 .27242 1 0 Mshowa
0 .32654 m
.00625 .32654 L
s
[(0)] -0.0125 .32654 1 0 Mshowa
.125 Mabswid
0 .01264 m
.00375 .01264 L
s
0 .02347 m
.00375 .02347 L
s
0 .03429 m
.00375 .03429 L
s
0 .04511 m
.00375 .04511 L
s
0 .06676 m
.00375 .06676 L
s
0 .07759 m
.00375 .07759 L
s
0 .08841 m
.00375 .08841 L
s
0 .09924 m
.00375 .09924 L
s
0 .12088 m
.00375 .12088 L
s
0 .13171 m
.00375 .13171 L
s
0 .14253 m
.00375 .14253 L
s
0 .15336 m
.00375 .15336 L
s
0 .17501 m
.00375 .17501 L
s
0 .18583 m
.00375 .18583 L
s
0 .19665 m
.00375 .19665 L
s
0 .20748 m
.00375 .20748 L
s
0 .22913 m
.00375 .22913 L
s
0 .23995 m
.00375 .23995 L
s
0 .25077 m
.00375 .25077 L
s
0 .2616 m
.00375 .2616 L
s
0 .28325 m
.00375 .28325 L
s
0 .29407 m
.00375 .29407 L
s
0 .3049 m
.00375 .3049 L
s
0 .31572 m
.00375 .31572 L
s
.25 Mabswid
0 0 m
0 .33333 L
s
gsave
-0.01875 .16667 -113.5 -10.5938 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 21.1875 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(deg) show
87.500 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .32708 m
.02381 .33333 L
s
gsave
.02381 .34583 -75.25 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 21.1875 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(0.01) show
87.500 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.2457 .32708 m
.2457 .33333 L
s
gsave
.2457 .34583 -75.25 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 21.1875 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(0.05) show
87.500 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.34127 .32708 m
.34127 .33333 L
s
gsave
.34127 .34583 -72.1875 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 21.1875 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(0.1) show
81.375 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.56317 .32708 m
.56317 .33333 L
s
gsave
.56317 .34583 -72.1875 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 21.1875 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(0.5) show
81.375 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.65873 .32708 m
.65873 .33333 L
s
gsave
.65873 .34583 -66.0625 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 21.1875 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(1) show
69.125 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.88063 .32708 m
.88063 .33333 L
s
gsave
.88063 .34583 -66.0625 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 21.1875 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
69.125 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.97619 .32708 m
.97619 .33333 L
s
gsave
.97619 .34583 -69.125 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 21.1875 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(10) show
75.250 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.001 w
.11937 .32958 m
.11937 .33333 L
s
.17528 .32958 m
.17528 .33333 L
s
.21494 .32958 m
.21494 .33333 L
s
.27084 .32958 m
.27084 .33333 L
s
.29209 .32958 m
.29209 .33333 L
s
.3105 .32958 m
.3105 .33333 L
s
.32674 .32958 m
.32674 .33333 L
s
.43683 .32958 m
.43683 .33333 L
s
.49274 .32958 m
.49274 .33333 L
s
.5324 .32958 m
.5324 .33333 L
s
.5883 .32958 m
.5883 .33333 L
s
.60955 .32958 m
.60955 .33333 L
s
.62797 .32958 m
.62797 .33333 L
s
.6442 .32958 m
.6442 .33333 L
s
.7543 .32958 m
.7543 .33333 L
s
.8102 .32958 m
.8102 .33333 L
s
.84986 .32958 m
.84986 .33333 L
s
.90576 .32958 m
.90576 .33333 L
s
.92702 .32958 m
.92702 .33333 L
s
.94543 .32958 m
.94543 .33333 L
s
.96166 .32958 m
.96166 .33333 L
s
.25 Mabswid
0 .33333 m
1 .33333 L
s
gsave
.5 .34583 -76.7813 9.1875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 19.4375 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 12.625 moveto
%%IncludeResource: font Helvetica-Bold
%%IncludeFont: Helvetica-Bold
/Helvetica-Bold findfont 8.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 12.625 moveto
%%IncludeResource: font Helvetica-Bold
%%IncludeFont: Helvetica-Bold
/Helvetica-Bold findfont 8.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(PHASE) show
90.563 12.625 moveto
%%IncludeResource: font Helvetica-Bold
%%IncludeFont: Helvetica-Bold
/Helvetica-Bold findfont 8.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.99375 .00182 m
1 .00182 L
s
.99375 .05594 m
1 .05594 L
s
.99375 .11006 m
1 .11006 L
s
.99375 .16418 m
1 .16418 L
s
.99375 .2183 m
1 .2183 L
s
.99375 .27242 m
1 .27242 L
s
.99375 .32654 m
1 .32654 L
s
.125 Mabswid
.99625 .01264 m
1 .01264 L
s
.99625 .02347 m
1 .02347 L
s
.99625 .03429 m
1 .03429 L
s
.99625 .04511 m
1 .04511 L
s
.99625 .06676 m
1 .06676 L
s
.99625 .07759 m
1 .07759 L
s
.99625 .08841 m
1 .08841 L
s
.99625 .09924 m
1 .09924 L
s
.99625 .12088 m
1 .12088 L
s
.99625 .13171 m
1 .13171 L
s
.99625 .14253 m
1 .14253 L
s
.99625 .15336 m
1 .15336 L
s
.99625 .17501 m
1 .17501 L
s
.99625 .18583 m
1 .18583 L
s
.99625 .19665 m
1 .19665 L
s
.99625 .20748 m
1 .20748 L
s
.99625 .22913 m
1 .22913 L
s
.99625 .23995 m
1 .23995 L
s
.99625 .25077 m
1 .25077 L
s
.99625 .2616 m
1 .2616 L
s
.99625 .28325 m
1 .28325 L
s
.99625 .29407 m
1 .29407 L
s
.99625 .3049 m
1 .3049 L
s
.99625 .31572 m
1 .31572 L
s
.25 Mabswid
1 0 m
1 .33333 L
s
gsave
1.0125 .16667 -61 -10.5938 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 21.1875 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.125 13.313 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.5 Mabswid
.02381 .3254 m
.35428 .31387 L
.44343 .30199 L
.49712 .28945 L
.53567 .2759 L
.56576 .26103 L
.59045 .24458 L
.61137 .22652 L
.62954 .20716 L
.64559 .18728 L
.65997 .16789 L
.67298 .14986 L
.68487 .13365 L
.69582 .11937 L
.70596 .10688 L
.71541 .09601 L
.72425 .08652 L
.73256 .07824 L
.7404 .07098 L
.74781 .0646 L
.75485 .05898 L
.76154 .054 L
.76792 .04959 L
.77403 .04566 L
.77987 .04216 L
.78547 .03902 L
.79086 .0362 L
.79604 .03366 L
.80104 .03137 L
.80586 .02929 L
.81052 .02741 L
.81502 .0257 L
.81939 .02415 L
.82362 .02273 L
.82772 .02143 L
.83171 .02025 L
.83558 .01916 L
.83935 .01817 L
.84301 .01726 L
.84659 .01642 L
.85007 .01565 L
.85346 .01494 L
.85678 .01429 L
.86001 .01369 L
.86318 .01314 L
.86627 .01263 L
.86929 .01216 L
.87225 .01174 L
.87515 .01134 L
.87798 .01098 L
Mistroke
.88076 .01065 L
.88349 .01034 L
.88616 .01006 L
.88878 .00981 L
.89135 .00958 L
.89388 .00937 L
.89636 .00917 L
.89879 .009 L
.90119 .00884 L
.90354 .0087 L
.90585 .00857 L
.90813 .00846 L
.91037 .00836 L
.91257 .00828 L
.91474 .0082 L
.91687 .00814 L
.91897 .00808 L
.92104 .00804 L
.92308 .008 L
.92509 .00797 L
.92707 .00795 L
.92903 .00794 L
.93095 .00794 L
.93285 .00794 L
.93473 .00795 L
.93657 .00796 L
.9384 .00798 L
.9402 .008 L
.94197 .00803 L
.94373 .00807 L
.94546 .0081 L
.94717 .00815 L
.94886 .00819 L
.95053 .00824 L
.95218 .0083 L
.95381 .00835 L
.95542 .00841 L
.95701 .00847 L
.95858 .00854 L
.96014 .0086 L
.96168 .00867 L
.9632 .00875 L
.96471 .00882 L
.9662 .00889 L
.96767 .00897 L
.96913 .00905 L
.97057 .00913 L
.972 .00921 L
.97341 .0093 L
.97481 .00938 L
Mistroke
.97619 .00947 L
Mfstroke
0 0 m
1 0 L
1 .33333 L
0 .33333 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  CellLabel->"From In[127]:=",
  ImageSize->{522, 174},
  ImageMargins->{{0, 0}, {0, 1}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40008:0000[Q000`40O003h00Oogooogoo37oo003o
OoooOol<Ool00?mooomoo`aoo`00ogooogoo37oo003oOolIOol00`00Oomoo`3_Ool00?moo`Moo`@0
009oo`D0009oo`@0009oo`03001oogoo009oo`<000Aoo`<000=oo`<00=aoo`00ogoo27oo00<007oo
Ool00Woo10000Woo00@007ooOol000=oo`03001oogoo00Eoo`04001oogoo0005Ool00`00Oomoo`3M
Ool00?moo`Qoo`03001oogoo00Eoo`04001oogoo0002Ool01@00Oomoogoo000017oo0`000goo1000
0Woo00<007ooOol0gGoo003oOol7Ool40003Ool30003Ool30004Ool01000Oomoogoo10000goo0P00
17oo0`00g7oo003oOolFOol00`00Oomoo`02Ool00`00Oomoo`3]Ool00?mooaEoo`8000Eoo`03001o
ogoo0>aoo`00ogooogoo37oo003oOoooOol<Ool00?mooomoo`aoo`00ogooogoo37oo003oOoooOol<
Ool00?mooomoo`aoo`00ogooogoo37oo003oOoooOol<Ool006ioo`8000Aoo`8000Aoo`8000=oo`D0
03Eoo`8000Aoo`8000Aoo`8000Aoo`80011oo`8000Aoo`8000=oo`D003aoo`8000Aoo`8000Aoo`80
01Moo`D004Qoo`8001Yoo`D0009oo`8004Yoo`00KGoo00@007ooOol000Qoo`04001oogoo0004Ool0
0`00Oomoo`0dOol01000Oomoo`0027oo00@007ooOol0009oo`04001oogoo000>Ool01000Oomoo`00
2Woo00<007ooOol0>goo00@007ooOol000Qoo`04001oogoo000HOol00`00Oomoo`17Ool01000Oomo
o`006goo00D007ooOomoo`00009oo`03001oogoo04Moo`00KGoo00@007ooOol000Qoo`04001oogoo
0004Ool00`00Oomoo`0dOol01000Oomoo`0027oo00@007ooOol000Eoo`03001oogoo00aoo`04001o
ogoo000:Ool00`00Oomoo`0kOol01000Oomoo`002goo00<007ooOol05Woo00<007ooOol0BWoo00<0
07ooOol06Goo00D007ooOomoo`00009oo`03001oogoo04Moo`00KGoo00@007ooOol000Qoo`04001o
ogoo0004Ool00`00Oomoo`0dOol01000Oomoo`0027oo00@007ooOol000=oo`8000moo`04001oogoo
000:Ool00`00Oomoo`0kOol01000Oomoo`002Goo0P006Goo00<007ooOol0B7oo0P0077oo00D007oo
Oomoo`00009oo`03001oogoo04Moo`00KGoo00@007ooOol000Qoo`04001oogoo0004Ool00`00Oomo
o`0dOol01000Oomoo`0027oo00@007ooOol000=oo`03001oogoo00ioo`04001oogoo000:Ool00`00
Oomoo`0kOol01000Oomoo`002Goo00<007ooOol067oo00<007ooOol0B7oo00<007ooOol06goo00D0
07ooOomoo`00009oo`03001oogoo04Moo`00KWoo0P002Woo0P0017oo0P00=goo0P002Woo0P0017oo
0`003goo0P002Woo0P00?Woo0P002Woo0`005goo0P00BWoo0`006Woo0P0017oo0P00BWoo003oOooo
Ool<Ool00?mooomoo`aoo`00ogooogoo37oo003oOoooOol<Ool00?mooomoo`aoo`00G7oo0P0017oo
0P0017oo0P00ogooXGoo001KOol01000Oomoo`000Woo00@007ooOol0009oo`04001oogoo0005Oooo
001F0015Ool005eoo`05001oogooOol00002Ool01000Oomoo`000Woo00<007ooOol00goo0`001Ekg
00<005kgG_L07Ukg00<005kgG_L045kg00<005kgG_L02Ukg00<005kgG_L025kg00<005kgG_L01Ekg
00<005kgG_L015kg00<005kgG_L015kg00<005kgG_L00Ukg00<005kgG_L00Ukg00<005kgG_L07Ukg
00<005kgG_L045kg00<005kgG_L02Ukg00<005kgG_L025kg00<005kgG_L01Ekg00<005kgG_L01Ekg
00<005kgG_L00ekg00<005kgG_L00Ukg00<005kgG_L00Ukg00<005kgG_L07Ukg00<005kgG_L045kg
00<005kgG_L02Ukg00<005kgG_L025kg00<005kgG_L01Ekg00<005kgG_L01Ekg00<005kgG_L00ekg
00<005kgG_L00Ukg00<005kgG_L00Ukg00<005kgG_L00ekg0`00AGoo001EOol40005Ool01000Oomo
o`000Woo00@007ooOol0009oo`03001oogoo00=oo`03001oogoo00Eoo`03001oogoo03=oo`03G_Mo
ogoo01=oo`03001oogoo01eoo`03001oogoo03=oo`03G_Moogoo01=oo`03001oogoo01eoo`03001o
ogoo03=oo`03G_Moogoo01=oo`03001oogoo01eoo`03001oogoo00Eoo`03001oogoo04=oo`00Fgoo
00@007ooOol0009oo`04001oogoo0002Ool01000Oomoo`001Goo00<007ooOol01Goo00=NmgooOol0
<goo00=NmgooOol0<goo00=NmgooOol0<goo00=NmgooOol0<goo00=NmgooOol0<goo00=NmgooOol0
5Woo7P001goo00<007ooOol0@goo001LOol20004Ool20004Ool20006Ool20006Ool00ekgOomoo`0c
Ool00ekgOomoo`0cOol00ekgOomoo`0cOol00ekgOomoo`0cOol00ekgOomoo`0cOol00ekgOomoo`0>
Ool8000MOol00ekgOomoo`04Ool20015Ool0071oo`03001oogoo00Eoo`03G_Moogoo03=oo`03G_Mo
ogoo03=oo`03G_Moogoo03=oo`03G_Moogoo03=oo`03G_Moogoo03=oo`03G_Moogoo00Qoo`H002Eo
o`03G_Moogoo00Eoo`03001oogoo04=oo`00L7oo00<007ooOol01Goo00=NmgooOol0<goo00=Nmgoo
Ool0<goo00=NmgooOol0<goo00=NmgooOol0<goo00=NmgooOol0<goo00=NmgooOol01Goo0`00:goo
00=NmgooOol01Goo00<007ooOol0@goo001`Ool00`00Oomoo`05Ool00ekgOomoo`0cOol00ekgOomo
o`0cOol00ekgOomoo`0cOol00ekgOomoo`0cOol00ekgOomoo`0cOol015kgOomoogoo1000;Woo00=N
mgooOol01Goo00<007ooOol0@goo001`Ool20006Ool00ekgOomoo`0cOol00ekgOomoo`0cOol00ekg
Oomoo`0cOol00ekgOomoo`0cOol00ekgOomoo`0cOol015kg00000000<Woo00=NmgooOol017oo0P00
AGoo001`Ool00`00Oomoo`05Ool00ekgOomoo`0cOol00ekgOomoo`0cOol00ekgOomoo`0cOol00ekg
Oomoo`0cOol00ekgOomoo`0aOol3000eOol00ekgOomoo`05Ool00`00Oomoo`13Ool0071oo`03001o
ogoo00Eoo`03G_Moogoo03=oo`03G_Moogoo03=oo`03G_Moogoo03=oo`03G_Moogoo03=oo`03G_Mo
ogoo02moo`80009oo`03G_Moogoo03=oo`03G_Moogoo00Eoo`03001oogoo04=oo`00L7oo00<007oo
Ool01Goo00=NmgooOol0<goo00=NmgooOol0<goo00=NmgooOol0<goo00=NmgooOol0<goo00=Nmgoo
Ool0;Woo00<007ooOol00Woo00=NmgooOol0<goo00=NmgooOol01Goo00<007ooOol0@goo001`Ool2
0006Ool00ekgOomoo`0cOol00ekgOomoo`0cOol00ekgOomoo`0cOol00ekgOomoo`0cOol00ekgOomo
o`0ZOol40005Ool00ekgOomoo`0cOol00ekgOomoo`04Ool20015Ool0071oo`03001oogoo00Eoo`03
G_Moogoo03=oo`03G_Moogoo03=oo`03G_Moogoo03=oo`03G_Moogoo03=oo`03G_Moogoo02Qoo`80
00Uoo`03G_Moogoo03=oo`03G_Moogoo00Eoo`03001oogoo04=oo`00L7oo00<007ooOol01Goo00=N
mgooOol0<goo00=NmgooOol0<goo00=NmgooOol0<goo00=NmgooOol0<goo00=NmgooOol09goo00<0
07ooOol02Goo00=NmgooOol0<goo00=NmgooOol01Goo00<007ooOol0@goo001`Ool20006Ool00ekg
Oomoo`0cOol00ekgOomoo`0cOol00ekgOomoo`0cOol00ekgOomoo`0cOol00ekgOomoo`0VOol00`00
Oomoo`0:Ool00ekgOomoo`0cOol00ekgOomoo`04Ool20015Ool0071oo`03001oogoo00Eoo`03G_Mo
ogoo03=oo`03G_Moogoo03=oo`03G_Moogoo03=oo`03G_Moogoo03=oo`03G_Moogoo02Aoo`8000eo
o`03G_Moogoo03=oo`03G_Moogoo00Eoo`03001oogoo04=oo`00Fgoo10000goo0P0017oo0P001Woo
00<007ooOol01Goo00=NmgooOol0<goo00=NmgooOol0<goo00=NmgooOol0<goo00=NmgooOol0<goo
00=NmgooOol08Woo0P003goo00=NmgooOol0<goo00=NmgooOol01Goo00<007ooOol0@goo001KOol0
0`00Oomoo`03Ool01000Oomoo`000Woo00@007ooOol000Eoo`03001oogoo00Eoo`03G_Moogoo03=o
o`03G_Moogoo03=oo`03G_Moogoo03=oo`03G_Moogoo03=oo`03G_Moogoo025oo`03001oogoo00mo
o`03G_Moogoo03=oo`03G_Moogoo00Eoo`03001oogoo04=oo`00G7oo00<007ooOol01Goo00@007oo
Ool0009oo`03001oogoo00=oo`<00?mNm`5Nm`03001Nmekg04aNm`<004Eoo`00EGoo100017oo00<0
07ooOol00Woo0P000goo00@007ooOol000Eoo`03001oogoo00Eoo`03G_Moogoo03=oo`03G_Moogoo
03=oo`03G_Moogoo03=oo`03G_Moogoo03=oo`03G_Moogoo01ioo`8001=oo`03G_Moogoo03=oo`03
G_Moogoo00Eoo`03001oogoo04=oo`00Fgoo00@007ooOol000=oo`03001oogoo009oo`04001oogoo
0005Ool00`00Oomoo`05Ool00ekgOomoo`0cOol00ekgOomoo`0cOol00ekgOomoo`0cOol00ekgOomo
o`0cOol00ekgOomoo`0MOol00`00Oomoo`0COol00ekgOomoo`0cOol00ekgOomoo`05Ool00`00Oomo
o`13Ool005aoo`8000Aoo`<000=oo`8000Ioo`03001oogoo00Eoo`03G_Moogoo03=oo`03G_Moogoo
03=oo`03G_Moogoo03=oo`03G_Moogoo03=oo`03G_Moogoo01aoo`03001oogoo01Aoo`03G_Moogoo
03=oo`03G_Moogoo00Eoo`03001oogoo04=oo`00L7oo0P001Woo00=NmgooOol0<goo00=NmgooOol0
<goo00=NmgooOol0<goo00=NmgooOol0<goo00=NmgooOol06Woo0P005goo00=NmgooOol0<goo00=N
mgooOol017oo0P00AGoo001`Ool00`00Oomoo`05Ool00ekgOomoo`0cOol00ekgOomoo`0cOol00ekg
Oomoo`0cOol00ekgOomoo`0cOol00ekgOomoo`0IOol00`00Oomoo`0GOol00ekgOomoo`0cOol00ekg
Oomoo`05Ool00`00Oomoo`13Ool0071oo`03001oogoo00Eoo`03G_Moogoo03=oo`03G_Moogoo03=o
o`03G_Moogoo03=oo`03G_Moogoo03=oo`03G_Moogoo01Qoo`03001oogoo01Qoo`03G_Moogoo03=o
o`03G_Moogoo00Eoo`03001oogoo04=oo`00L7oo00<007ooOol01Goo00=NmgooOol0<goo00=Nmgoo
Ool0<goo00=NmgooOol0<goo00=NmgooOol0<goo00=NmgooOol05goo00<007ooOol06Goo00=Nmgoo
Ool0<goo00=NmgooOol01Goo00<007ooOol0@goo001`Ool20006Ool00ekgOomoo`0cOol00ekgOomo
o`0cOol00ekgOomoo`0cOol00ekgOomoo`0cOol00ekgOomoo`0FOol00`00Oomoo`0JOol00ekgOomo
o`0cOol00ekgOomoo`04Ool20015Ool0071oo`03001oogoo00Eoo`03G_Moogoo03=oo`03G_Moogoo
03=oo`03G_Moogoo03=oo`03G_Moogoo03=oo`03G_Moogoo01Eoo`03001oogoo01]oo`03G_Moogoo
03=oo`03G_Moogoo00Eoo`03001oogoo04=oo`00L7oo00<007ooOol01Goo00=NmgooOol0<goo00=N
mgooOol0<goo00=NmgooOol0<goo00=NmgooOol0<goo00=NmgooOol05Goo00<007ooOol06goo00=N
mgooOol0<goo00=NmgooOol01Goo00<007ooOol0@goo001`Ool20006Ool00ekgOomoo`0cOol00ekg
Oomoo`0cOol00ekgOomoo`0cOol00ekgOomoo`0cOol00ekgOomoo`0DOol00`00Oomoo`0LOol00ekg
Oomoo`0cOol00ekgOomoo`04Ool20015Ool0071oo`03001oogoo00Eoo`03G_Moogoo03=oo`03G_Mo
ogoo03=oo`03G_Moogoo03=oo`03G_Moogoo03=oo`03G_Moogoo01=oo`03001oogoo01eoo`03G_Mo
ogoo03=oo`03G_Moogoo00Eoo`03001oogoo04=oo`00L7oo00<007ooOol01Goo00=NmgooOol0<goo
00=NmgooOol0<goo00=NmgooOol0<goo00=NmgooOol0<goo00=NmgooOol04Woo00<007ooOol07Woo
00=NmgooOol0<goo00=NmgooOol01Goo00<007ooOol0@goo001`Ool00`00Oomoo`05Ool00ekgOomo
o`0cOol00ekgOomoo`0cOol00ekgOomoo`0cOol00ekgOomoo`0cOol00ekgOomoo`0AOol00`00Oomo
o`0OOol00ekgOomoo`0cOol00ekgOomoo`05Ool00`00Oomoo`13Ool0071oo`8000Ioo`03G_Moogoo
03=oo`03G_Moogoo03=oo`03G_Moogoo03=oo`03G_Moogoo03=oo`03G_Moogoo011oo`03001oogoo
021oo`03G_Moogoo03=oo`03G_Moogoo00Aoo`8004Eoo`00L7oo00<007ooOol01Goo00=NmgooOol0
<goo00=NmgooOol0<goo00=NmgooOol0<goo00=NmgooOol0<goo00=NmgooOol03goo00<007ooOol0
8Goo00=NmgooOol0<goo00=NmgooOol01Goo00<007ooOol0@goo001KOol40003Ool20004Ool20006
Ool00`00Oomoo`05Ool00ekgOomoo`0cOol00ekgOomoo`0cOol00ekgOomoo`0cOol00ekgOomoo`0c
Ool00ekgOomoo`0>Ool00`00Oomoo`0ROol00ekgOomoo`0cOol00ekgOomoo`05Ool00`00Oomoo`13
Ool005]oo`03001oogoo00=oo`04001oogoo0002Ool01000Oomoo`001Goo00<007ooOol01Goo00=N
mgooOol0<goo00=NmgooOol0<goo00=NmgooOol0<goo00=NmgooOol0<goo00=NmgooOol03Goo00<0
07ooOol08goo00=NmgooOol0<goo00=NmgooOol01Goo00<007ooOol0@goo001LOol00`00Oomoo`02
Ool01000Oomoo`000Woo00@007ooOol000Eoo`<00>aNm`03001Nmekg061Nm`<004Eoo`00EGoo1000
17oo00D007ooOomoo`00009oo`04001oogoo0002Ool00`00Oomoo`03Ool00`00Oomoo`05Ool00ekg
Oomoo`0cOol00ekgOomoo`0cOol00ekgOomoo`0cOol00ekgOomoo`0cOol00ekgOomoo`0;Ool00`00
Oomoo`0UOol00ekgOomoo`0cOol00ekgOomoo`05Ool00`00Oomoo`13Ool005]oo`04001oogoo0002
Ool01000Oomoo`000Woo00@007ooOol000Eoo`03001oogoo00Eoo`03G_Moogoo03=oo`03G_Moogoo
03=oo`03G_Moogoo03=oo`03G_Moogoo03=oo`03G_Moogoo00]oo`03001oogoo02Eoo`03G_Moogoo
03=oo`03G_Moogoo00Eoo`03001oogoo04=oo`00G7oo0P0017oo0P0017oo0P001Woo0P001Woo00=N
mgooOol0<goo00=NmgooOol0<goo00=NmgooOol0<goo00=NmgooOol0<goo00=NmgooOol02Woo00<0
07ooOol09Woo00=NmgooOol0<goo00=NmgooOol017oo0P00AGoo001`Ool00`00Oomoo`05Ool00ekg
Oomoo`0cOol00ekgOomoo`0cOol00ekgOomoo`0cOol00ekgOomoo`0cOol00ekgOomoo`09Ool00`00
Oomoo`0WOol00ekgOomoo`0cOol00ekgOomoo`05Ool00`00Oomoo`13Ool0071oo`03001oogoo00Eo
o`03G_Moogoo03=oo`03G_Moogoo03=oo`03G_Moogoo03=oo`03G_Moogoo03=oo`03G_Moogoo00Qo
o`03001oogoo02Qoo`03G_Moogoo03=oo`03G_Moogoo00Eoo`03001oogoo04=oo`00L7oo00<007oo
Ool01Goo00=NmgooOol0<goo00=NmgooOol0<goo00=NmgooOol0<goo00=NmgooOol0<goo00=Nmgoo
Ool027oo00<007ooOol0:7oo00=NmgooOol0<goo00=NmgooOol01Goo00<007ooOol0@goo001`Ool2
0006Ool00ekgOomoo`0cOol00ekgOomoo`0cOol00ekgOomoo`0cOol00ekgOomoo`0cOol00ekgOomo
o`07Ool00`00Oomoo`0YOol00ekgOomoo`0cOol00ekgOomoo`04Ool20015Ool0071oo`03001oogoo
00Eoo`03G_Moogoo03=oo`03G_Moogoo03=oo`03G_Moogoo03=oo`03G_Moogoo03=oo`03G_Moogoo
00Ioo`03001oogoo02Yoo`03G_Moogoo03=oo`03G_Moogoo00Eoo`03001oogoo04=oo`00L7oo00<0
07ooOol01Goo00=NmgooOol0<goo00=NmgooOol0<goo00=NmgooOol0<goo00=NmgooOol0<goo00=N
mgooOol01Goo00<007ooOol0:goo00=NmgooOol0<goo00=NmgooOol01Goo00<007ooOol0@goo001`
Ool00`00Oomoo`05Ool00ekgOomoo`0cOol00ekgOomoo`0cOol00ekgOomoo`0cOol00ekgOomoo`0c
Ool00ekgOomoo`04Ool00`00Oomoo`0/Ool00ekgOomoo`0cOol00ekgOomoo`05Ool00`00Oomoo`13
Ool0071oo`8000Ioo`03G_Moogoo03=oo`03G_Moogoo03=oo`03G_Moogoo03=oo`03G_Moogoo03=o
o`03G_Moogoo00Aoo`03001oogoo02aoo`03G_Moogoo03=oo`03G_Moogoo00Aoo`8004Eoo`00L7oo
00<007ooOol01Goo00=NmgooOol0<goo00=NmgooOol0<goo00=NmgooOol0<goo00=NmgooOol0<goo
00=NmgooOol00goo00<007ooOol0;Goo00=NmgooOol0<goo00=NmgooOol01Goo00<007ooOol0@goo
001`Ool00`00Oomoo`05Ool00ekgOomoo`0cOol00ekgOomoo`0cOol00ekgOomoo`0cOol00ekgOomo
o`0cOol00ekgOomoo`02Ool00`00Oomoo`0^Ool00ekgOomoo`0cOol00ekgOomoo`05Ool00`00Oomo
o`13Ool0071oo`8000Ioo`03G_Moogoo03=oo`03G_Moogoo03=oo`03G_Moogoo03=oo`03G_Moogoo
03=oo`05G_MoogooOol0000aOol00ekgOomoo`0cOol00ekgOomoo`04Ool20015Ool004Aoo`<002Uo
o`03001oogoo00Eoo`03G_Moogoo03=oo`03G_Moogoo03=oo`03G_Moogoo03=oo`03G_Moogoo03=o
o`05G_MoogooOol0000aOol00ekgOomoo`0cOol00ekgOomoo`05Ool00`00Oomoo`13Ool004Moo`03
001oogoo015oo`D0009oo`8000Aoo`8000Ioo`03001oogoo00Eoo`03G_Moogoo03=oo`03G_Moogoo
03=oo`03G_Moogoo03=oo`03G_Moogoo03=oo`04G_Moogoo000bOol00ekgOomoo`0cOol00ekgOomo
o`05Ool00`00Oomoo`13Ool003Uoo`@0009oo`<000=oo`<001Eoo`05001oogooOol00002Ool01000
Oomoo`000Woo00<007ooOol00goo00<007ooOol01Goo00=NmgooOol0<goo00=NmgooOol0<goo00=N
mgooOol0<goo00=NmgooOol0<goo00=Nmgoo0000<goo00=NmgooOol0<goo00=NmgooOol01Goo00<0
07ooOol0@goo000hOol01000Oomoo`000Woo00<007ooOol00goo00@007ooOol001Eoo`03001oogoo
00Aoo`04001oogoo0002Ool00`00Oomoo`03Ool3003OG_L00`00G_MNm`1]G_L30015Ool003Qoo`04
001oogoo0002Ool40002Ool01000Oomoo`003Goo100017oo00<007ooOol00Woo0P000goo00@007oo
Ool000Eoo`03001oogoo00Eoo`03G_Moogoo03=oo`03G_Moogoo03=oo`03G_Moogoo03=oo`03G_Mo
ogoo03=oo`03G_L007oo03=oo`03G_Moogoo03=oo`03G_Moogoo00Eoo`03001oogoo04=oo`00>Goo
0`000goo0P0017oo100057oo00<007ooOol00Woo00<007ooOol00Woo00@007ooOol000Eoo`03001o
ogoo00Eoo`03G_Moogoo03=oo`03G_Moogoo03=oo`03G_Moogoo03=oo`03G_Moogoo03=oo`03001o
ogoo03=oo`03G_Moogoo03=oo`03G_Moogoo00Eoo`03001oogoo04=oo`00>goo00<007ooOol07Woo
0P0017oo0`000goo0P001Woo00<007ooOol01Goo00=NmgooOol0<goo00=NmgooOol0<goo00=Nmgoo
Ool0<goo00=NmgooOol0<goo00<007ooOol0<goo00=NmgooOol0<goo00=NmgooOol01Goo00<007oo
Ool0@goo000jOol2000dOol20006Ool00ekgOomoo`0cOol00ekgOomoo`0cOol00ekgOomoo`0cOol0
0ekgOomoo`0bOol00`00G_Moo`0dOol00ekgOomoo`0cOol00ekgOomoo`04Ool20015Ool0071oo`03
001oogoo00Eoo`03G_Moogoo03=oo`03G_Moogoo03=oo`03G_Moogoo03=oo`03G_Moogoo035oo`03
001ooekg03Eoo`03G_Moogoo03=oo`03G_Moogoo00Eoo`03001oogoo04=oo`00L7oo00<007ooOol0
1Goo00=NmgooOol0<goo00=NmgooOol0<goo00=NmgooOol0<goo00=NmgooOol0<7oo00@007ooOomN
mcEoo`03G_Moogoo03=oo`03G_Moogoo00Eoo`03001oogoo04=oo`00L7oo0P001Woo00=NmgooOol0
<goo00=NmgooOol0<goo00=NmgooOol0<goo00=NmgooOol0<7oo00@007ooOomNmcEoo`03G_Moogoo
03=oo`03G_Moogoo00Aoo`8004Eoo`00L7oo00<007ooOol01Goo00=NmgooOol0<goo00=NmgooOol0
<goo00=NmgooOol0<goo00=NmgooOol0;goo00D007ooOomooekg03Eoo`03G_Moogoo03=oo`03G_Mo
ogoo00Eoo`03001oogoo04=oo`00L7oo00<007ooOol01Goo00=NmgooOol0<goo00=NmgooOol0<goo
00=NmgooOol0<goo00=NmgooOol0;Woo00<007ooOol00Woo00=NmgooOol0<goo00=NmgooOol0<goo
00=NmgooOol01Goo00<007ooOol0@goo001`Ool00`00Oomoo`05Ool00ekgOomoo`0cOol00ekgOomo
o`0cOol00ekgOomoo`0cOol00ekgOomoo`0]Ool00`00Oomoo`03Ool00ekgOomoo`0cOol00ekgOomo
o`0cOol00ekgOomoo`05Ool00`00Oomoo`13Ool0071oo`8000Ioo`03G_Moogoo03=oo`03G_Moogoo
03=oo`03G_Moogoo03=oo`03G_Moogoo02aoo`03001oogoo00Aoo`03G_Moogoo03=oo`03G_Moogoo
03=oo`03G_Moogoo00Aoo`8004Eoo`00L7oo00<007ooOol01Goo00=NmgooOol0<goo00=NmgooOol0
<goo00=NmgooOol0<goo00=NmgooOol0;7oo00<007ooOol017oo00=NmgooOol0<goo00=NmgooOol0
<goo00=NmgooOol01Goo00<007ooOol0@goo001`Ool00`00Oomoo`05Ool00ekgOomoo`0cOol00ekg
Oomoo`0cOol00ekgOomoo`0cOol00ekgOomoo`0[Ool00`00Oomoo`05Ool00ekgOomoo`0cOol00ekg
Oomoo`0cOol00ekgOomoo`05Ool00`00Oomoo`13Ool0071oo`03001oogoo00Eoo`03G_Moogoo03=o
o`03G_Moogoo03=oo`03G_Moogoo03=oo`03G_Moogoo02Yoo`03001oogoo00Ioo`03G_Moogoo03=o
o`03G_Moogoo03=oo`03G_Moogoo00Eoo`03001oogoo04=oo`00L7oo0P001Woo00=NmgooOol0<goo
00=NmgooOol0<goo00=NmgooOol0<goo00=NmgooOol0:Goo00<007ooOol01goo00=NmgooOol0<goo
00=NmgooOol0<goo00=NmgooOol017oo0P00AGoo001KOol50002Ool20004Ool20006Ool00`00Oomo
o`05Ool00ekgOomoo`0cOol00ekgOomoo`0cOol00ekgOomoo`0cOol00ekgOomoo`0XOol00`00Oomo
o`08Ool00ekgOomoo`0cOol00ekgOomoo`0cOol00ekgOomoo`05Ool00`00Oomoo`13Ool005eoo`05
001oogooOol00002Ool01000Oomoo`000Woo00<007ooOol00goo00<007ooOol01Goo00=NmgooOol0
<goo00=NmgooOol0<goo00=NmgooOol0<goo00=NmgooOol09goo00<007ooOol02Goo00=NmgooOol0
<goo00=NmgooOol0<goo00=NmgooOol01Goo00<007ooOol0@goo001MOol01@00Oomoogoo00000Woo
00@007ooOol0009oo`03001oogoo00=oo`<00=1Nm`03001Nmekg07aNm`<004Eoo`00EGoo100017oo
00D007ooOomoo`00009oo`04001oogoo0002Ool00`00Oomoo`03Ool00`00Oomoo`05Ool00ekgOomo
o`0cOol00ekgOomoo`0cOol00ekgOomoo`0cOol00ekgOomoo`0UOol00`00Oomoo`0;Ool00ekgOomo
o`0cOol00ekgOomoo`0cOol00ekgOomoo`05Ool00`00Oomoo`13Ool005eoo`05001oogooOol00002
Ool01000Oomoo`000Woo00<007ooOol00goo00<007ooOol01Goo00=NmgooOol0<goo00=NmgooOol0
<goo00=NmgooOol0<goo00=NmgooOol097oo00<007ooOol037oo00=NmgooOol0<goo00=NmgooOol0
<goo00=NmgooOol01Goo00<007ooOol0@goo001LOol20004Ool20004Ool20006Ool00`00Oomoo`05
Ool00ekgOomoo`0cOol00ekgOomoo`0cOol00ekgOomoo`0cOol00ekgOomoo`0SOol00`00Oomoo`0=
Ool00ekgOomoo`0cOol00ekgOomoo`0cOol00ekgOomoo`05Ool00`00Oomoo`13Ool0071oo`8000Io
o`03G_Moogoo03=oo`03G_Moogoo03=oo`03G_Moogoo03=oo`03G_Moogoo029oo`03001oogoo00io
o`03G_Moogoo03=oo`03G_Moogoo03=oo`03G_Moogoo00Aoo`8004Eoo`00L7oo00<007ooOol01Goo
00=NmgooOol0<goo00=NmgooOol0<goo00=NmgooOol0<goo00=NmgooOol08Goo00<007ooOol03goo
00=NmgooOol0<goo00=NmgooOol0<goo00=NmgooOol01Goo00<007ooOol0@goo001`Ool00`00Oomo
o`05Ool00ekgOomoo`0cOol00ekgOomoo`0cOol00ekgOomoo`0cOol00ekgOomoo`0OOol2000BOol0
0ekgOomoo`0cOol00ekgOomoo`0cOol00ekgOomoo`05Ool00`00Oomoo`13Ool0071oo`03001oogoo
00Eoo`03G_Moogoo03=oo`03G_Moogoo03=oo`03G_Moogoo03=oo`03G_Moogoo01ioo`03001oogoo
019oo`03G_Moogoo03=oo`03G_Moogoo03=oo`03G_Moogoo00Eoo`03001oogoo04=oo`00L7oo0P00
1Woo00=NmgooOol0<goo00=NmgooOol0<goo00=NmgooOol0<goo00=NmgooOol07Goo00<007ooOol0
4goo00=NmgooOol0<goo00=NmgooOol0<goo00=NmgooOol017oo0P00AGoo001`Ool00`00Oomoo`05
Ool00ekgOomoo`0cOol00ekgOomoo`0cOol00ekgOomoo`0cOol00ekgOomoo`0LOol00`00Oomoo`0D
Ool00ekgOomoo`0cOol00ekgOomoo`0cOol00ekgOomoo`05Ool00`00Oomoo`13Ool0071oo`03001o
ogoo00Eoo`03G_Moogoo03=oo`03G_Moogoo03=oo`03G_Moogoo03=oo`03G_Moogoo01]oo`03001o
ogoo01Eoo`03G_Moogoo03=oo`03G_Moogoo03=oo`03G_Moogoo00Eoo`03001oogoo04=oo`00L7oo
00<007ooOol01Goo00=NmgooOol0<goo00=NmgooOol0<goo00=NmgooOol0<goo00=NmgooOol06Goo
0P0067oo00=NmgooOol0<goo00=NmgooOol0<goo00=NmgooOol01Goo00<007ooOol0@goo001`Ool2
0006Ool00ekgOomoo`0cOol00ekgOomoo`0cOol00ekgOomoo`0cOol00ekgOomoo`0HOol00`00Oomo
o`0HOol00ekgOomoo`0cOol00ekgOomoo`0cOol00ekgOomoo`04Ool20015Ool0071oo`03001oogoo
00Eoo`03G_Moogoo03=oo`03G_Moogoo03=oo`03G_Moogoo03=oo`03G_Moogoo01Moo`03001oogoo
01Uoo`03G_Moogoo03=oo`03G_Moogoo03=oo`03G_Moogoo00Eoo`03001oogoo04=oo`00L7oo00<0
07ooOol01Goo00=NmgooOol0<goo00=NmgooOol0<goo00=NmgooOol0<goo00=NmgooOol05Goo0P00
77oo00=NmgooOol0<goo00=NmgooOol0<goo00=NmgooOol01Goo00<007ooOol0@goo001`Ool20006
Ool00ekgOomoo`0cOol00ekgOomoo`0cOol00ekgOomoo`0cOol00ekgOomoo`0COol2000NOol00ekg
Oomoo`0cOol00ekgOomoo`0cOol00ekgOomoo`04Ool20015Ool0071oo`03001oogoo00Eoo`03G_Mo
ogoo03=oo`03G_Moogoo03=oo`03G_Moogoo03=oo`03G_Moogoo015oo`80021oo`03G_Moogoo03=o
o`03G_Moogoo03=oo`03G_Moogoo00Eoo`03001oogoo04=oo`00HWoo0P0017oo0P001Woo00<007oo
Ool01Goo00=NmgooOol0<goo00=NmgooOol0<goo00=NmgooOol0<goo00=NmgooOol03goo0P008Woo
00=NmgooOol0<goo00=NmgooOol0<goo00=NmgooOol01Goo00<007ooOol0@goo001QOol01000Oomo
o`000Woo00@007ooOol000Eoo`03001oogoo00Eoo`03G_Moogoo03=oo`03G_Moogoo03=oo`03G_Mo
ogoo03=oo`03G_Moogoo00eoo`8002Aoo`03G_Moogoo03=oo`03G_Moogoo03=oo`03G_Moogoo00Eo
o`03001oogoo04=oo`00I7oo00@007ooOol0009oo`03001oogoo00=oo`<00;ENm`8009QNm`<004Eo
o`00Fgoo10000goo0P000goo00@007ooOol000Eoo`03001oogoo00Eoo`03G_Moogoo03=oo`03G_Mo
ogoo03=oo`03G_Moogoo03=oo`03G_Moogoo00Qoo`<002Qoo`03G_Moogoo03=oo`03G_Moogoo03=o
o`03G_Moogoo00Eoo`03001oogoo04=oo`00HWoo00<007ooOol00Woo00@007ooOol000Eoo`03001o
ogoo00Eoo`03G_Moogoo03=oo`03G_Moogoo03=oo`03G_Moogoo03=oo`03G_Moogoo00Ioo`8002]o
o`03G_Moogoo03=oo`03G_Moogoo03=oo`03G_Moogoo00Eoo`03001oogoo04=oo`00HWoo0`000goo
0P001Woo00<007ooOol01Goo00=NmgooOol0<goo00=NmgooOol0<goo00=NmgooOol0<goo00=Nmgoo
Ool00goo0`00;Goo00=NmgooOol0<goo00=NmgooOol0<goo00=NmgooOol01Goo00<007ooOol0@goo
001`Ool20006Ool00ekgOomoo`0cOol00ekgOomoo`0cOol00ekgOomoo`0cOol00ekgOomoo`03000`
Ool00ekgOomoo`0cOol00ekgOomoo`0cOol00ekgOomoo`04Ool20015Ool0071oo`03001oogoo00Eo
o`03G_Moogoo03=oo`03G_Moogoo03=oo`03G_Moogoo03=oo`03G_L0000003=oo`03G_Moogoo03=o
o`03G_Moogoo03=oo`03G_Moogoo00Eoo`03001oogoo04=oo`00L7oo00<007ooOol01Goo00=Nmgoo
Ool0<goo00=NmgooOol0<goo00=NmgooOol0<7oo1000=Goo00=NmgooOol0<goo00=NmgooOol0<goo
00=NmgooOol01Goo00<007ooOol0@goo001`Ool20006Ool00ekgOomoo`0cOol00ekgOomoo`0cOol0
0ekgOomoo`0/Ool40003Ool00ekgOomoo`0cOol00ekgOomoo`0cOol00ekgOomoo`0cOol00ekgOomo
o`04Ool20015Ool0071oo`03001oogoo00Eoo`03G_Moogoo03=oo`03G_Moogoo03=oo`03G_Moogoo
02Moo`D000Moo`03G_Moogoo03=oo`03G_Moogoo03=oo`03G_Moogoo03=oo`03G_Moogoo00Eoo`03
001oogoo04=oo`00L7oo00<007ooOol01Goo00=NmgooOol0<goo00=NmgooOol0<goo00=NmgooOol0
8goo100037oo00=NmgooOol0<goo00=NmgooOol0<goo00=NmgooOol0<goo00=NmgooOol01Goo00<0
07ooOol0@goo001`Ool00`00Oomoo`05Ool00ekgOomoo`0cOol00ekgOomoo`0cOol00ekgOomoo`0M
Ool6000@Ool00ekgOomoo`0cOol00ekgOomoo`0cOol00ekgOomoo`0cOol00ekgOomoo`05Ool00`00
Oomoo`13Ool0071oo`8000Ioo`03G_Moogoo03=oo`03G_Moogoo03=oo`03G_Moogoo01Eoo`P001Io
o`03G_Moogoo03=oo`03G_Moogoo03=oo`03G_Moogoo03=oo`03G_Moogoo00Aoo`8004Eoo`00L7oo
00<007ooOol01Goo00=NmgooOol0<goo00=NmgooOol0<goo00=NmgooOol03Woo1`007Woo00=Nmgoo
Ool0<goo00=NmgooOol0<goo00=NmgooOol0<goo00=NmgooOol01Goo00<007ooOol0@goo001`Ool0
0`00Oomoo`05Ool00ekgOomoo`0cOol00ekgOomoo`0cOol00ekgOomoo`06Ool8000UOol00ekgOomo
o`0cOol00ekgOomoo`0cOol00ekgOomoo`0cOol00ekgOomoo`05Ool00`00Oomoo`13Ool0071oo`03
001oogoo00Eoo`03G_Moogoo03=oo`03G_Moogoo02Yooa8002eoo`03G_Moogoo03=oo`03G_Moogoo
03=oo`03G_Moogoo03=oo`03G_Moogoo00Eoo`03001oogoo04=oo`00L7oo0P001Woo00=NmgooOol0
<goo00=NmgooOol03Woo70002Goo00=NmgooOol0<goo00=NmgooOol0<goo00=NmgooOol0<goo00=N
mgooOol0<goo00=NmgooOol017oo0P00AGoo001XOol20006Ool00`00Oomoo`05Ool00ekgOomoo`0X
OolL000UOol00ekgOomoo`0cOol00ekgOomoo`0cOol00ekgOomoo`0cOol00ekgOomoo`0cOol00ekg
Oomoo`05Ool00`00Oomoo`13Ool006Moo`04001oogoo0005Ool00`00Oomoo`05Ool00ekgOomoo`0<
OolL000;Ool00ekgOomoo`0cOol00ekgOomoo`0cOol00ekgOomoo`0cOol00ekgOomoo`0cOol00ekg
Oomoo`0cOol00ekgOomoo`05Ool00`00Oomoo`13Ool006Moo`04001oogoo0005Ool30005G_L?000m
G_L00`00G_MNm`0MG_L00`00G_MNm`19G_L00`00G_MNm`0MG_L00`00G_MNm`19G_L00`00G_MNm`0M
G_L00`00G_MNm`03G_L30015Ool006Moo`04001oogoo0005Ool00`00Oomoo`05Ool00`00Oomoo`0N
Ool00`00Oomoo`0@Ool00`00OomNm`0:Ool00`00Oomoo`08Ool00`00Oomoo`05Ool00`00Oomoo`04
Ool00`00Oomoo`04Ool00`00Oomoo`02Ool00`00Oomoo`02Ool00`00Oomoo`0NOol00`00Oomoo`0@
Ool00`00OomNm`0:Ool00`00Oomoo`08Ool00`00Oomoo`05Ool00`00Oomoo`05Ool00`00Oomoo`03
Ool00`00Oomoo`02Ool00`00Oomoo`02Ool00`00Oomoo`0NOol00`00Oomoo`0@Ool00`00OomNm`0:
Ool00`00Oomoo`08Ool00`00Oomoo`05Ool00`00Oomoo`05Ool00`00Oomoo`03Ool00`00Oomoo`02
Ool00`00Oomoo`02Ool00`00Oomoo`05Ool00`00Oomoo`13Ool006Moo`04001oogoo0005Ool00`00
Oomoo`05Ool00`00Oomoo`0NOol00`00Oomoo`0@Ool00`00OomNm`0:Ool00`00Oomoo`08Ool00`00
Oomoo`05Ool00`00Oomoo`04Ool00`00Oomoo`04Ool00`00Oomoo`02Ool00`00Oomoo`02Ool00`00
Oomoo`0NOol00`00Oomoo`0@Ool00`00OomNm`0:Ool00`00Oomoo`08Ool00`00Oomoo`05Ool00`00
Oomoo`05Ool00`00Oomoo`03Ool00`00Oomoo`02Ool00`00Oomoo`02Ool00`00Oomoo`0NOol00`00
Oomoo`0@Ool00`00OomNm`0:Ool00`00Oomoo`08Ool00`00Oomoo`05Ool00`00Oomoo`05Ool00`00
Oomoo`03Ool00`00Oomoo`02Ool00`00Oomoo`02Ool00`00Oomoo`05Ool00`00Oomoo`13Ool006Qo
o`8000Ioool005H004Eoo`00ogooogoo37oo003oOoooOol<Ool00?mooomoo`aoo`00ogooogoo37oo
003oOoooOol<Ool00?mooomoo`aoo`00ogooogoo37oo003oOoooOol<Ool006ioo`8000Aoo`8000Ao
o`8000=oo`D003Eoo`8000Aoo`8000Aoo`8000Aoo`80011oo`8000Aoo`8000=oo`D003aoo`8000Ao
o`8000Aoo`8001Moo`D004Qoo`8001Yoo`D0009oo`8004Yoo`00KGoo00@007ooOol000Qoo`04001o
ogoo0004Ool00`00Oomoo`0dOol01000Oomoo`0027oo00@007ooOol0009oo`04001oogoo000>Ool0
1000Oomoo`002Woo00<007ooOol0>goo00@007ooOol000Qoo`04001oogoo000HOol00`00Oomoo`17
Ool01000Oomoo`006goo00D007ooOomoo`00009oo`03001oogoo04Moo`00KGoo00@007ooOol000Qo
o`04001oogoo0004Ool00`00Oomoo`0dOol01000Oomoo`0027oo00@007ooOol000Eoo`03001oogoo
00aoo`04001oogoo000:Ool00`00Oomoo`0kOol01000Oomoo`002goo00<007ooOol05Woo00<007oo
Ool0BWoo00<007ooOol06Goo00D007ooOomoo`00009oo`03001oogoo04Moo`00KGoo00@007ooOol0
00Qoo`04001oogoo0004Ool00`00Oomoo`0dOol01000Oomoo`0027oo00@007ooOol000=oo`8000mo
o`04001oogoo000:Ool00`00Oomoo`0kOol01000Oomoo`002Goo0P006Goo00<007ooOol0B7oo0P00
77oo00D007ooOomoo`00009oo`03001oogoo04Moo`00KGoo00@007ooOol000Qoo`04001oogoo0004
Ool00`00Oomoo`0dOol01000Oomoo`0027oo00@007ooOol000=oo`03001oogoo00ioo`04001oogoo
000:Ool00`00Oomoo`0kOol01000Oomoo`002Goo00<007ooOol067oo00<007ooOol0B7oo00<007oo
Ool06goo00D007ooOomoo`00009oo`03001oogoo04Moo`00KWoo0P002Woo0P0017oo0P00=goo0P00
2Woo0P0017oo0`003goo0P002Woo0P00?Woo0P002Woo0`005goo0P00BWoo0`006Woo0P0017oo0P00
BWoo003oOoooOol<Ool00?mooomoo`aoo`00ogooogoo37oo003oOoooOol<Ool00?mooomoo`aoo`00
ogooogoo37oo003oOol>Ool00`00Oomoo`02Ool01P00Oomoo`00Ool000=oo`03001oo`000080009o
o`@00>Aoo`00ogoo3Woo00<007ooOol00Woo00D007ooOol007oo00D00004Ool007oo0002Ool00`00
Oomoo`3UOol00?moo`ioo`<0009oo`04001oogoo0002Ool00`00Ool00003Ool20002Ool00`00Oomo
o`3UOol00?moo`ioo`05001oogoo001oo`040002Ool00`00Ool00002Ool20003Ool4003TOol00?mo
o`ioo`06001oogoo001oo`000Woo00H007ooOol007oo0002Ool00`00Ool00002Ool00`00Oomoo`3U
Ool00?moo`ioo`@00005Ool007ooOol00003Ool01000Oomoogoo0`000Woo1000i7oo003oOoooOol<
Ool00?mooomoo`aoo`00\
\>"],
  ImageRangeCache->{{{0, 521}, {173, 0}} -> {-3.11603, -384.798, 0.00925206, \
2.71351}},
  CellTags->{"Bode plot", "i:9", "b:20.1"}]
}, Open  ]],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{
        TagBox[\(\[SkeletonIndicator]  Graphics  \[SkeletonIndicator]\),
          False,
          Editable->False], ",", 
        TagBox[\(\[SkeletonIndicator]  Graphics  \[SkeletonIndicator]\),
          False,
          Editable->False]}], "}"}]], "Output",
  CellLabel->"Out[127]=",
  CellTags->{"Bode plot", "i:9", "b:20.1"}]
}, Open  ]],

Cell["\<\
Bode can also be used with the PlotPoints option when finer resolution is \
required.\
\>", "Text",
  CellTags->{"Bode plot", "i:9", "b:20.1"}],

Cell[CellGroupData[{

Cell[BoxData[
    \(\(\(\t\)\(G[
        s_] := \(\((s + 10)\)\ \((s + 4)\)\)\/\(s\ \((s\^2 +  .1\ s + 2)\)\ \
\((s\^2 +  .1\ s + 1)\)\)\n
    Bode[G, s,  .2, 10, PlotPoints \[Rule] 1000]\)\)\)], "Input",
  CellLabel->"In[128]:=",
  CellTags->{"Bode plot", "i:9", "b:20.1"}],

Cell[CellGroupData[{

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .33333 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.415627 0.560564 0.172201 0.00292893 [
[.02381 -0.0125 -11.1875 -13.1875 ]
[.02381 -0.0125 11.1875 0 ]
[.24688 -0.0125 -11.1875 -13.1875 ]
[.24688 -0.0125 11.1875 0 ]
[.41563 -0.0125 -5.0625 -13.1875 ]
[.41563 -0.0125 5.0625 0 ]
[.58437 -0.0125 -5.0625 -13.1875 ]
[.58437 -0.0125 5.0625 0 ]
[.80744 -0.0125 -5.0625 -13.1875 ]
[.80744 -0.0125 5.0625 0 ]
[.97619 -0.0125 -8.125 -13.1875 ]
[.97619 -0.0125 8.125 0 ]
[ 0 0 -0.125 0 ]
[.5 -0.0125 -23.4375 -26.375 ]
[.5 -0.0125 23.4375 -13.1875 ]
[-0.0125 .05504 -18 -4.5 ]
[-0.0125 .05504 0 4.5 ]
[-0.0125 .11362 -18 -4.5 ]
[-0.0125 .11362 0 4.5 ]
[-0.0125 .1722 -6 -4.5 ]
[-0.0125 .1722 0 4.5 ]
[-0.0125 .23078 -12 -4.5 ]
[-0.0125 .23078 0 4.5 ]
[-0.0125 .28936 -12 -4.5 ]
[-0.0125 .28936 0 4.5 ]
[ 0 0 -0.125 0 ]
[-0.01875 .16667 -40.375 -6.59375 ]
[-0.01875 .16667 -18 6.59375 ]
[.02381 .34583 -11.1875 0 ]
[.02381 .34583 11.1875 13.1875 ]
[.24688 .34583 -11.1875 0 ]
[.24688 .34583 11.1875 13.1875 ]
[.41563 .34583 -5.0625 0 ]
[.41563 .34583 5.0625 13.1875 ]
[.58437 .34583 -5.0625 0 ]
[.58437 .34583 5.0625 13.1875 ]
[.80744 .34583 -5.0625 0 ]
[.80744 .34583 5.0625 13.1875 ]
[.97619 .34583 -8.125 0 ]
[.97619 .34583 8.125 13.1875 ]
[ 0 .33333 .125 0 ]
[.5 .34583 -25.9063 13.1875 ]
[.5 .34583 25.9063 24.625 ]
[ 1 0 .125 0 ]
[1.0125 .16667 0 -6.59375 ]
[1.0125 .16667 10.125 6.59375 ]
[ 0 -0.0005 0 0 ]
[ 1 .33383 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
.75 g
.25 Mabswid
[ ] 0 setdash
.13534 0 m
.13534 .33333 L
s
.27549 0 m
.27549 .33333 L
s
.41563 0 m
.41563 .33333 L
s
.55577 0 m
.55577 .33333 L
s
.69591 0 m
.69591 .33333 L
s
.83605 0 m
.83605 .33333 L
s
.97619 0 m
.97619 .33333 L
s
0 .05504 m
1 .05504 L
s
0 .11362 m
1 .11362 L
s
0 .1722 m
1 .1722 L
s
0 .23078 m
1 .23078 L
s
0 .28936 m
1 .28936 L
s
0 g
.02381 0 m
.02381 .00625 L
s
gsave
.02381 -0.0125 -72.1875 -17.1875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 21.1875 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(0.2) show
81.375 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.24688 0 m
.24688 .00625 L
s
gsave
.24688 -0.0125 -72.1875 -17.1875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 21.1875 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(0.5) show
81.375 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.41563 0 m
.41563 .00625 L
s
gsave
.41563 -0.0125 -66.0625 -17.1875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 21.1875 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(1) show
69.125 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.58437 0 m
.58437 .00625 L
s
gsave
.58437 -0.0125 -66.0625 -17.1875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 21.1875 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
69.125 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.80744 0 m
.80744 .00625 L
s
gsave
.80744 -0.0125 -66.0625 -17.1875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 21.1875 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
69.125 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.97619 0 m
.97619 .00625 L
s
gsave
.97619 -0.0125 -69.125 -17.1875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 21.1875 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(10) show
75.250 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.001 w
.12252 0 m
.12252 .00375 L
s
.19256 0 m
.19256 .00375 L
s
.29127 0 m
.29127 .00375 L
s
.32879 0 m
.32879 .00375 L
s
.3613 0 m
.3613 .00375 L
s
.38998 0 m
.38998 .00375 L
s
.68308 0 m
.68308 .00375 L
s
.75312 0 m
.75312 .00375 L
s
.85183 0 m
.85183 .00375 L
s
.88936 0 m
.88936 .00375 L
s
.92187 0 m
.92187 .00375 L
s
.95054 0 m
.95054 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
gsave
.5 -0.0125 -84.4375 -30.375 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 21.1875 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(rad) show
%%IncludeResource: font Mathematica2Mono
%%IncludeFont: Mathematica2Mono
/Mathematica2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
81.375 13.313 moveto
(\\220) show
87.500 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(sec) show
105.875 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 .05504 m
.00625 .05504 L
s
[(-40)] -0.0125 .05504 1 0 Mshowa
0 .11362 m
.00625 .11362 L
s
[(-20)] -0.0125 .11362 1 0 Mshowa
0 .1722 m
.00625 .1722 L
s
[(0)] -0.0125 .1722 1 0 Mshowa
0 .23078 m
.00625 .23078 L
s
[(20)] -0.0125 .23078 1 0 Mshowa
0 .28936 m
.00625 .28936 L
s
[(40)] -0.0125 .28936 1 0 Mshowa
.125 Mabswid
0 .06969 m
.00375 .06969 L
s
0 .08433 m
.00375 .08433 L
s
0 .09898 m
.00375 .09898 L
s
0 .12827 m
.00375 .12827 L
s
0 .14291 m
.00375 .14291 L
s
0 .15756 m
.00375 .15756 L
s
0 .18685 m
.00375 .18685 L
s
0 .20149 m
.00375 .20149 L
s
0 .21613 m
.00375 .21613 L
s
0 .24542 m
.00375 .24542 L
s
0 .26007 m
.00375 .26007 L
s
0 .27471 m
.00375 .27471 L
s
0 .0404 m
.00375 .0404 L
s
0 .02575 m
.00375 .02575 L
s
0 .01111 m
.00375 .01111 L
s
0 .304 m
.00375 .304 L
s
0 .31865 m
.00375 .31865 L
s
0 .33329 m
.00375 .33329 L
s
.25 Mabswid
0 0 m
0 .33333 L
s
gsave
-0.01875 .16667 -101.375 -10.5938 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 21.1875 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(dB) show
81.375 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .32708 m
.02381 .33333 L
s
gsave
.02381 .34583 -72.1875 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 21.1875 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(0.2) show
81.375 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.24688 .32708 m
.24688 .33333 L
s
gsave
.24688 .34583 -72.1875 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 21.1875 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(0.5) show
81.375 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.41563 .32708 m
.41563 .33333 L
s
gsave
.41563 .34583 -66.0625 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 21.1875 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(1) show
69.125 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.58437 .32708 m
.58437 .33333 L
s
gsave
.58437 .34583 -66.0625 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 21.1875 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
69.125 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.80744 .32708 m
.80744 .33333 L
s
gsave
.80744 .34583 -66.0625 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 21.1875 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
69.125 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.97619 .32708 m
.97619 .33333 L
s
gsave
.97619 .34583 -69.125 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 21.1875 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(10) show
75.250 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.001 w
.12252 .32958 m
.12252 .33333 L
s
.19256 .32958 m
.19256 .33333 L
s
.29127 .32958 m
.29127 .33333 L
s
.32879 .32958 m
.32879 .33333 L
s
.3613 .32958 m
.3613 .33333 L
s
.38998 .32958 m
.38998 .33333 L
s
.68308 .32958 m
.68308 .33333 L
s
.75312 .32958 m
.75312 .33333 L
s
.85183 .32958 m
.85183 .33333 L
s
.88936 .32958 m
.88936 .33333 L
s
.92187 .32958 m
.92187 .33333 L
s
.95054 .32958 m
.95054 .33333 L
s
.25 Mabswid
0 .33333 m
1 .33333 L
s
gsave
.5 .34583 -86.9063 9.1875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 19.4375 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 12.625 moveto
%%IncludeResource: font Helvetica-Bold
%%IncludeFont: Helvetica-Bold
/Helvetica-Bold findfont 8.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 12.625 moveto
%%IncludeResource: font Helvetica-Bold
%%IncludeFont: Helvetica-Bold
/Helvetica-Bold findfont 8.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(MAGNITUDE) show
110.813 12.625 moveto
%%IncludeResource: font Helvetica-Bold
%%IncludeFont: Helvetica-Bold
/Helvetica-Bold findfont 8.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.99375 .05504 m
1 .05504 L
s
.99375 .11362 m
1 .11362 L
s
.99375 .1722 m
1 .1722 L
s
.99375 .23078 m
1 .23078 L
s
.99375 .28936 m
1 .28936 L
s
.125 Mabswid
.99625 .06969 m
1 .06969 L
s
.99625 .08433 m
1 .08433 L
s
.99625 .09898 m
1 .09898 L
s
.99625 .12827 m
1 .12827 L
s
.99625 .14291 m
1 .14291 L
s
.99625 .15756 m
1 .15756 L
s
.99625 .18685 m
1 .18685 L
s
.99625 .20149 m
1 .20149 L
s
.99625 .21613 m
1 .21613 L
s
.99625 .24542 m
1 .24542 L
s
.99625 .26007 m
1 .26007 L
s
.99625 .27471 m
1 .27471 L
s
.99625 .0404 m
1 .0404 L
s
.99625 .02575 m
1 .02575 L
s
.99625 .01111 m
1 .01111 L
s
.99625 .304 m
1 .304 L
s
.99625 .31865 m
1 .31865 L
s
.99625 .33329 m
1 .33329 L
s
.25 Mabswid
1 0 m
1 .33333 L
s
gsave
1.0125 .16667 -61 -10.5938 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 21.1875 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.125 13.313 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 .33333 L
0 .33333 L
closepath
clip
newpath
.5 Mabswid
.02381 .29094 m
.06648 .28716 L
.10582 .28394 L
.13774 .28159 L
.16494 .27985 L
.19089 .27847 L
.21351 .27757 L
.2191 .2774 L
.22503 .27724 L
.23004 .27713 L
.23544 .27704 L
.23793 .277 L
.24057 .27697 L
.24304 .27695 L
.24528 .27693 L
.24658 .27693 L
.24778 .27692 L
.24846 .27692 L
.24908 .27692 L
.24943 .27692 L
.2498 .27692 L
.25015 .27692 L
.25047 .27692 L
.25105 .27692 L
.2516 .27692 L
.25219 .27692 L
.25253 .27692 L
.25283 .27692 L
.25344 .27692 L
.2541 .27692 L
.2553 .27693 L
.25638 .27694 L
.25755 .27694 L
.25964 .27696 L
.26211 .27699 L
.26435 .27703 L
.26891 .27712 L
.27362 .27724 L
.28201 .27754 L
.28957 .27791 L
.29772 .27844 L
.3049 .27902 L
.31966 .28062 L
.33306 .28267 L
.34655 .2855 L
.35886 .28899 L
.37015 .29325 L
.38162 .29906 L
.39216 .30633 L
.4029 .31619 L
Mistroke
.40809 .32133 L
.41058 .3234 L
.41174 .32417 L
.41281 .32473 L
.41335 .32496 L
.41393 .32515 L
.4142 .32522 L
.4145 .32529 L
.41467 .32532 L
.41483 .32534 L
.41513 .32537 L
.41541 .32539 L
.41566 .3254 L
.41595 .32539 L
.41624 .32537 L
.4165 .32534 L
.41674 .3253 L
.41729 .32517 L
.41787 .32499 L
.41848 .32474 L
.41956 .32418 L
.42198 .32243 L
.43079 .31397 L
.43984 .30633 L
.44824 .30117 L
.45271 .29914 L
.45686 .29768 L
.45883 .29713 L
.46091 .29664 L
.46267 .29632 L
.46458 .29605 L
.46561 .29594 L
.46612 .2959 L
.46659 .29587 L
.467 .29584 L
.46746 .29582 L
.46792 .29581 L
.46817 .2958 L
.4684 .2958 L
.46864 .29579 L
.46877 .29579 L
.4689 .29579 L
.46915 .29579 L
.46929 .2958 L
.46942 .2958 L
.46965 .2958 L
.4699 .29581 L
.47035 .29582 L
.47088 .29585 L
.47143 .29589 L
Mistroke
.47243 .29598 L
.47337 .29609 L
.47423 .29622 L
.47614 .2966 L
.4779 .29707 L
.47956 .29762 L
.48322 .29924 L
.48656 .30127 L
.49352 .30679 L
.49532 .30807 L
.49581 .30836 L
.49633 .30862 L
.49677 .30879 L
.49702 .30887 L
.49725 .30894 L
.49747 .30898 L
.49758 .309 L
.4977 .30902 L
.49792 .30904 L
.49812 .30904 L
.49823 .30904 L
.49835 .30904 L
.49856 .30902 L
.49868 .309 L
.49881 .30897 L
.49905 .30892 L
.49925 .30885 L
.49946 .30877 L
.49984 .30858 L
.5003 .30829 L
.50071 .30797 L
.50153 .30716 L
.5024 .30608 L
.50396 .30368 L
.50743 .29699 L
.51362 .28453 L
.52005 .2732 L
.52609 .26403 L
.53234 .25564 L
.53821 .24854 L
.54374 .24238 L
.54948 .23641 L
.55488 .23111 L
.56049 .22589 L
.56578 .22119 L
.57076 .21693 L
.57595 .21265 L
.58084 .20874 L
.58546 .20515 L
.59028 .2015 L
Mistroke
.59483 .19813 L
.59957 .19469 L
.60406 .1915 L
.6083 .18855 L
.61273 .18552 L
.61692 .18269 L
.62088 .18006 L
.62503 .17734 L
.62896 .1748 L
.63307 .17218 L
.63696 .16972 L
.64064 .16742 L
.64451 .16504 L
.64817 .1628 L
.652 .16048 L
.65564 .1583 L
.65908 .15625 L
.6627 .15412 L
.66613 .15212 L
.66938 .15023 L
.6728 .14826 L
.67604 .14641 L
.67944 .14448 L
.68268 .14265 L
.68575 .14093 L
.68897 .13914 L
.69203 .13744 L
.69494 .13584 L
.69801 .13416 L
.70092 .13258 L
.70397 .13092 L
.70688 .12936 L
.70965 .12788 L
.71256 .12632 L
.71532 .12486 L
.71823 .12332 L
.721 .12187 L
.72363 .12049 L
.72641 .11904 L
.72904 .11767 L
.73156 .11638 L
.7342 .11501 L
.73672 .11372 L
.73937 .11237 L
.7419 .11108 L
.7443 .10987 L
.74683 .10859 L
.74925 .10737 L
.75179 .1061 L
.75421 .10489 L
Mistroke
.75652 .10374 L
.75895 .10253 L
.76127 .10139 L
.76348 .1003 L
.76581 .09915 L
.76803 .09806 L
.77037 .09692 L
.7726 .09584 L
.77473 .0948 L
.77697 .09372 L
.77911 .09268 L
.78116 .0917 L
.78331 .09067 L
.78537 .08968 L
.78754 .08865 L
.78961 .08766 L
.79158 .08673 L
.79366 .08574 L
.79565 .0848 L
.79775 .08381 L
.79975 .08287 L
.80166 .08198 L
.80368 .08103 L
.80561 .08013 L
.80745 .07928 L
.80939 .07838 L
.81124 .07752 L
.8132 .07662 L
.81507 .07575 L
.81685 .07493 L
.81874 .07407 L
.82054 .07324 L
.82226 .07246 L
.82408 .07163 L
.82582 .07084 L
.82765 .07001 L
.8294 .06921 L
.83108 .06846 L
.83284 .06766 L
.83454 .0669 L
.83632 .0661 L
.83803 .06533 L
.83966 .0646 L
.84138 .06383 L
.84303 .0631 L
.8446 .0624 L
.84627 .06166 L
.84786 .06095 L
.84954 .06021 L
.85115 .0595 L
Mistroke
.85268 .05882 L
.85431 .05811 L
.85586 .05743 L
.8575 .05671 L
.85907 .05602 L
.86058 .05536 L
.86216 .05467 L
.86368 .05401 L
.86513 .05338 L
.86667 .05272 L
.86814 .05208 L
.86969 .05141 L
.87117 .05077 L
.8726 .05016 L
.8741 .04951 L
.87554 .04889 L
.87691 .0483 L
.87837 .04768 L
.87976 .04708 L
.88123 .04646 L
.88264 .04586 L
.88399 .04528 L
.88541 .04468 L
.88678 .0441 L
.88822 .04349 L
.8896 .0429 L
.89093 .04234 L
.89232 .04175 L
.89366 .04119 L
.89494 .04065 L
.8963 .04008 L
.8976 .03954 L
.89897 .03896 L
.90029 .03842 L
.90155 .03789 L
.90288 .03734 L
.90415 .0368 L
.9055 .03624 L
.90679 .03571 L
.90803 .0352 L
.90934 .03465 L
.91059 .03414 L
.91179 .03364 L
.91306 .03312 L
.91428 .03262 L
.91556 .03209 L
.9168 .03158 L
.91798 .0311 L
.91923 .03059 L
.92042 .0301 L
Mistroke
.92157 .02963 L
.92278 .02913 L
.92394 .02866 L
.92517 .02816 L
.92635 .02768 L
.92748 .02722 L
.92868 .02674 L
.92982 .02627 L
.93103 .02578 L
.93219 .02531 L
.93331 .02487 L
.93448 .02439 L
.93561 .02394 L
.93669 .0235 L
.93784 .02304 L
.93893 .0226 L
.94009 .02214 L
.9412 .02169 L
.94227 .02127 L
.9434 .02082 L
.94448 .02038 L
.94552 .01997 L
.94661 .01953 L
.94767 .01912 L
.94878 .01867 L
.94985 .01825 L
.95087 .01784 L
.95195 .01742 L
.95299 .017 L
.95409 .01657 L
.95515 .01615 L
.95616 .01576 L
.95722 .01533 L
.95825 .01493 L
.95923 .01455 L
.96027 .01414 L
.96127 .01374 L
.96233 .01333 L
.96334 .01293 L
.96431 .01255 L
.96534 .01215 L
.96633 .01177 L
.96737 .01136 L
.96837 .01097 L
.96933 .0106 L
.97035 .0102 L
.97133 .00982 L
.97226 .00946 L
.97325 .00907 L
.9742 .00871 L
Mistroke
.97521 .00832 L
.97617 .00794 L
.97619 .00794 L
Mfstroke
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  CellLabel->"From In[128]:=",
  ImageSize->{517.125, 172.375},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`4000850000[1000`40O003h00Oogooogoo1goo003o
OoooOol7Ool00?mooomoo`Moo`00ogooogoo1goo003oOolAOol00`00Oomoo`3bOol00?eoo`@0009o
o`D0009oo`@000=oo`03001oogoo009oo`<000Aoo`<000=oo`<00=moo`00oWoo00<007ooOol00Woo
10000Woo00@007ooOol000Aoo`03001oogoo00Eoo`04001oogoo0005Ool00`00Oomoo`3POol00?io
o`03001oogoo00Eoo`04001oogoo0002Ool00`00Oomoo`02Ool00`00Oomoo`02Ool30003Ool40002
Ool00`00Oomoo`3POol00?eoo`@000=oo`<000=oo`<000Eoo`04001oogooOol40003Ool20004Ool3
003OOol00?moo`eoo`03001oogoo00=oo`03001oogoo0?1oo`00ogoo37oo0P001Woo00<007ooOol0
kgoo003oOoooOol7Ool00?mooomoo`Moo`00ogooogoo1goo003oOoooOol7Ool00?mooomoo`Moo`00
ogooogoo1goo003oOoooOol7Ool006]oo`8000Aoo`8000=oo`@003aoo`8000Aoo`8000Aoo`8002mo
o`D003Aoo`@004Qoo`8003=oo`D0009oo`8004moo`00JWoo00@007ooOol000Qoo`03001oogoo03ao
o`04001oogoo0008Ool01000Oomoo`00<7oo00<007ooOol0=7oo00<007ooOol0B7oo00@007ooOol0
03Aoo`05001oogooOol00002Ool00`00Oomoo`1<Ool006Yoo`04001oogoo0009Ool00`00Oomoo`0k
Ool01000Oomoo`002goo00<007ooOol0;Woo00<007ooOol0=Goo00<007ooOol0BWoo00<007ooOol0
<Woo00D007ooOomoo`00009oo`03001oogoo04aoo`00JWoo00@007ooOol000Yoo`03001oogoo03Yo
o`04001oogoo0009Ool2000aOol00`00Oomoo`0fOol00`00Oomoo`17Ool2000eOol01@00Oomoogoo
00000Woo00<007ooOol0C7oo001ZOol01000Oomoo`0027oo00@007ooOol003]oo`04001oogoo0009
Ool00`00Oomoo`0`Ool00`00Oomoo`0dOol01000Oomoo`00B7oo00<007ooOol0=7oo00D007ooOomo
o`00009oo`03001oogoo04aoo`00Jgoo0P002Woo0P00?Goo0P002Woo0`00;goo0P00=goo0P00BGoo
0`00<goo0P0017oo0P00Cgoo003oOoooOol7Ool00?mooomoo`Moo`00ogooogoo1goo003oOoooOol7
Ool00?mooomoo`Moo`00ogooogoo1goo003oOoooOol7Ool006Yoool0058004Yoo`00JWoo00<007oo
Ool01Goo00<007ooOol07Woo00D007ooOomooekg019oo`03001oogoo011oo`03001oogoo00Ioo`03
G_Moogoo00=oo`03001oogoo00Uoo`03001oogoo00Qoo`03001oogoo00Moo`03001oogoo00Eoo`03
001oogoo02aoo`03G_Moogoo00Moo`03001oogoo01ioo`03001oogoo009oo`03G_Moogoo011oo`03
001oogoo00moo`03001oogoo00Moo`03G_Moogoo009oo`03001oogoo00Yoo`03001oogoo00Moo`03
001oogoo00Moo`03001oogoo00Ioo`03001oogoo00Eoo`03001oogoo04Qoo`00JWoo00<007ooOol0
1Goo00<007ooOol08Woo00=NmgooOol08goo00<007ooOol01Woo00=NmgooOol0;7oo00<007ooOol0
;7oo00=NmgooOol01goo00<007ooOol08goo00=NmgooOol08Woo00<007ooOol01goo00=NmgooOol0
:goo0P001goo00<007ooOol0B7oo001ZOol2000[Ool00ekgOomoo`0/Ool00ekgOomoo`0/Ool00ekg
Oomoo`0/Ool00ekgOomoo`0]Ool00ekgOomoo`0/Ool00ekgOomoo`0YOol300000ekgOomoo`03Ool3
001:Ool006Yoo`03001oogoo02Yoo`03G_Moogoo02aoo`03G_Moogoo02aoo`03G_Moogoo02aoo`03
G_Moogoo02eoo`03G_Moogoo02aoo`03G_Moogoo02Ioo`@0009oo`03G_Moogoo00Eoo`03001oogoo
04Qoo`00JWoo00<007ooOol0:Woo00=NmgooOol0;7oo00=NmgooOol0;7oo00=NmgooOol0;7oo00=N
mgooOol0;Goo00=NmgooOol0;7oo00=NmgooOol097oo0`001Goo00=NmgooOol01Goo00<007ooOol0
B7oo001ZOol00`00Oomoo`0ZOol00ekgOomoo`0/Ool00ekgOomoo`0/Ool00ekgOomoo`0/Ool00ekg
Oomoo`0]Ool00ekgOomoo`0/Ool00ekgOomoo`0QOol40007Ool00ekgOomoo`05Ool00`00Oomoo`18
Ool006Yoo`03001oogoo02Yoo`03G_Moogoo02aoo`03G_Moogoo02aoo`03G_Moogoo02aoo`03G_Mo
ogoo02eoo`03G_Moogoo02aoo`03G_Moogoo01moo`<000Yoo`03G_Moogoo00Eoo`03001oogoo04Qo
o`00JWoo0P00:goo00=NmgooOol0;7oo00=NmgooOol0;7oo00=NmgooOol0;7oo00=NmgooOol0;Goo
00=NmgooOol0;7oo00=NmgooOol07Goo0P003Goo00=NmgooOol00goo0`00BWoo001ZOol00`00Oomo
o`0ZOol00ekgOomoo`0/Ool00ekgOomoo`0/Ool00ekgOomoo`0/Ool00ekgOomoo`0]Ool00ekgOomo
o`0/Ool00ekgOomoo`0JOol3000?Ool00ekgOomoo`05Ool00`00Oomoo`18Ool006Yoo`03001oogoo
02Yoo`03G_Moogoo02aoo`03G_Moogoo02aoo`03G_Moogoo02aoo`03G_Moogoo02eoo`03G_Moogoo
02aoo`03G_Moogoo01Moo`<0019oo`03G_Moogoo00Eoo`03001oogoo04Qoo`00JWoo00<007ooOol0
:Woo00=NmgooOol0;7oo00=NmgooOol0;7oo00=NmgooOol0;7oo00=NmgooOol0;Goo00=NmgooOol0
;7oo00=NmgooOol05Goo0`0057oo00=NmgooOol01Goo00<007ooOol0B7oo001ZOol00`00Oomoo`0Z
Ool00ekgOomoo`0/Ool00ekgOomoo`0/Ool00ekgOomoo`0/Ool00ekgOomoo`0]Ool00ekgOomoo`0/
Ool00ekgOomoo`0COol3000FOol00ekgOomoo`05Ool00`00Oomoo`18Ool006Yoo`8002]oo`03G_Mo
ogoo02aoo`03G_Moogoo02aoo`03G_Moogoo02aoo`03G_Moogoo02eoo`03G_Moogoo02aoo`03G_Mo
ogoo011oo`<001Uoo`03G_Moogoo00=oo`<004Yoo`00JWoo00<007ooOol0:Woo00=NmgooOol0;7oo
00=NmgooOol0;7oo00=NmgooOol0;7oo00=NmgooOol0;Goo00=NmgooOol0;7oo00=NmgooOol03Woo
0`006goo00=NmgooOol01Goo00<007ooOol0B7oo001ZOol00`00Oomoo`0ZOol00ekgOomoo`0/Ool0
0ekgOomoo`0/Ool00ekgOomoo`0/Ool00ekgOomoo`0]Ool00ekgOomoo`0/Ool00ekgOomoo`0<Ool3
000MOol00ekgOomoo`05Ool00`00Oomoo`18Ool005eoo`<0009oo`8000Ioo`03001oogoo02Yoo`03
G_Moogoo02aoo`03G_Moogoo02aoo`03G_Moogoo02aoo`03G_Moogoo02eoo`03G_Moogoo02aoo`03
G_Moogoo00Uoo`<0021oo`03G_Moogoo00Eoo`03001oogoo04Qoo`00GWoo00@007ooOol0009oo`03
001oogoo00=oo`03001oogoo02Yoo`03G_Moogoo02aoo`03G_Moogoo02aoo`03G_Moogoo02aoo`03
G_Moogoo02eoo`03G_Moogoo02aoo`03G_Moogoo00Moo`<0029oo`03G_Moogoo00Eoo`03001oogoo
04Qoo`00Fgoo1@0000Eoo`00Oomoo`0000Eoo`<00?mNmamNm`8002]Nm`<004Yoo`00EGoo10000Woo
00@007ooOol0009oo`04001oogoo0005Ool00`00Oomoo`0ZOol00ekgOomoo`0/Ool00ekgOomoo`0/
Ool00ekgOomoo`0/Ool00ekgOomoo`0]Ool00ekgOomoo`0/Ool00ekgOomoo`02Ool3000WOol00ekg
Oomoo`05Ool00`00Oomoo`18Ool005aoo`03001oo`00009oo`04001oogoo0005Ool00`00Oomoo`0Z
Ool00ekgOomoo`0/Ool00ekgOomoo`0/Ool00ekgOomoo`0/Ool00ekgOomoo`0]Ool00ekgOomoo`0/
Ool00ekgOomoo`03000YOol00ekgOomoo`05Ool00`00Oomoo`18Ool005eoo`8000=oo`8000Ioo`03
001oogoo02Yoo`03G_Moogoo02aoo`03G_Moogoo02aoo`03G_Moogoo02aoo`03G_Moogoo02eoo`03
G_Moogoo02aoo`04G_L00000000[Ool00ekgOomoo`05Ool00`00Oomoo`18Ool006Yoo`03001oogoo
02Yoo`03G_Moogoo02aoo`03G_Moogoo02aoo`03G_Moogoo02aoo`03G_Moogoo02eoo`03G_Moogoo
02]oo`8002ioo`03G_Moogoo00Eoo`03001oogoo04Qoo`00JWoo0P00:goo00=NmgooOol0;7oo00=N
mgooOol0;7oo00=NmgooOol0;7oo00=NmgooOol0;Goo00=NmgooOol0:7oo0`0000=ooekgOol0;Goo
00=NmgooOol00goo0`00BWoo001ZOol00`00Oomoo`0ZOol00ekgOomoo`0/Ool00ekgOomoo`0/Ool0
0ekgOomoo`0/Ool00ekgOomoo`0]Ool00ekgOomoo`0VOol30003Ool00ekgOomoo`0/Ool00ekgOomo
o`05Ool00`00Oomoo`18Ool006Yoo`03001oogoo02Yoo`03G_Moogoo02aoo`03G_Moogoo02aoo`03
G_Moogoo02aoo`03G_Moogoo02eoo`03G_Moogoo02Aoo`<000Eoo`03G_Moogoo02aoo`03G_Moogoo
00Eoo`03001oogoo04Qoo`00JWoo00<007ooOol0:Woo00=NmgooOol0;7oo00=NmgooOol0;7oo00=N
mgooOol0;7oo00=NmgooOol0;Goo00=NmgooOol08Woo0P0027oo00=NmgooOol0;7oo00=NmgooOol0
1Goo00<007ooOol0B7oo001ZOol00`00Oomoo`0ZOol00ekgOomoo`0/Ool00ekgOomoo`0/Ool00ekg
Oomoo`0/Ool00ekgOomoo`0]Ool00ekgOomoo`0POol2000:Ool00ekgOomoo`0/Ool00ekgOomoo`05
Ool00`00Oomoo`18Ool006Yoo`8002]oo`03G_Moogoo02aoo`03G_Moogoo02aoo`03G_Moogoo02ao
o`03G_Moogoo02eoo`03G_Moogoo01ioo`8000aoo`03G_Moogoo02aoo`03G_Moogoo00=oo`<004Yo
o`00JWoo00<007ooOol0:Woo00=NmgooOol0;7oo00=NmgooOol0;7oo00=NmgooOol0;7oo00=Nmgoo
Ool0;Goo00=NmgooOol06goo0`003Woo00=NmgooOol0;7oo00=NmgooOol01Goo00<007ooOol0B7oo
001ZOol00`00Oomoo`0ZOol00ekgOomoo`0/Ool00ekgOomoo`0/Ool00ekgOomoo`0/Ool00ekgOomo
o`0]Ool00ekgOomoo`0JOol2000@Ool00ekgOomoo`0/Ool00ekgOomoo`05Ool00`00Oomoo`18Ool0
06Yoo`03001oogoo02Yoo`03G_Moogoo02aoo`03G_Moogoo02aoo`03G_Moogoo02aoo`03G_Moogoo
02eoo`03G_Moogoo01Qoo`80019oo`03G_Moogoo02aoo`03G_Moogoo00Eoo`03001oogoo04Qoo`00
JWoo00<007ooOol0:Woo00=NmgooOol0;7oo00=NmgooOol0;7oo00=NmgooOol0;7oo00=NmgooOol0
;Goo00=NmgooOol05Woo0P0057oo00=NmgooOol0;7oo00=NmgooOol01Goo00<007ooOol0B7oo001Z
Ool2000[Ool00ekgOomoo`0/Ool00ekgOomoo`0/Ool00ekgOomoo`0/Ool00ekgOomoo`0]Ool00ekg
Oomoo`0COol3000FOol00ekgOomoo`0/Ool00ekgOomoo`03Ool3001:Ool006Yoo`03001oogoo02Yo
o`03G_Moogoo02aoo`03G_Moogoo02aoo`03G_Moogoo02aoo`03G_Moogoo02eoo`03G_Moogoo019o
o`8001Qoo`03G_Moogoo02aoo`03G_Moogoo00Eoo`03001oogoo04Qoo`00JWoo00<007ooOol0:Woo
00=NmgooOol0;7oo00=NmgooOol0;7oo00=NmgooOol0;7oo00=NmgooOol0;Goo00=NmgooOol03goo
0`006Woo00=NmgooOol0;7oo00=NmgooOol01Goo00<007ooOol0B7oo001KOol40003Ool20006Ool0
0`00Oomoo`0ZOol00ekgOomoo`0/Ool00ekgOomoo`0/Ool00ekgOomoo`0/Ool00ekgOomoo`0]Ool0
0ekgOomoo`0>Ool00`00Oomoo`0KOol00ekgOomoo`0/Ool00ekgOomoo`05Ool00`00Oomoo`18Ool0
05]oo`03001oogoo00=oo`04001oogoo0005Ool00`00Oomoo`0ZOol00ekgOomoo`0/Ool00ekgOomo
o`0/Ool00ekgOomoo`0/Ool00ekgOomoo`0]Ool00ekgOomoo`0;Ool3000NOol00ekgOomoo`0/Ool0
0ekgOomoo`05Ool00`00Oomoo`18Ool005aoo`03001oogoo009oo`04001oogoo0005Ool3003cG_L2
001FG_L3001:Ool005Eoo`@000Aoo`05001oogooOol00002Ool00`00Oomoo`03Ool00`00Oomoo`0Z
Ool00ekgOomoo`0/Ool00ekgOomoo`0/Ool00ekgOomoo`0/Ool00ekgOomoo`0]Ool00ekgOomoo`08
Ool2000ROol00ekgOomoo`0/Ool00ekgOomoo`05Ool00`00Oomoo`18Ool005]oo`04001oogoo0002
Ool01000Oomoo`001Goo00<007ooOol0:Woo00=NmgooOol0;7oo00=NmgooOol0;7oo00=NmgooOol0
;7oo00=NmgooOol0;Goo00=NmgooOol01Woo0P0097oo00=NmgooOol0;7oo00=NmgooOol01Goo00<0
07ooOol0B7oo001LOol20004Ool20006Ool00`00Oomoo`0ZOol00ekgOomoo`0/Ool00ekgOomoo`0/
Ool00ekgOomoo`0/Ool00ekgOomoo`0]Ool00ekgOomoo`04Ool2000VOol00ekgOomoo`0/Ool00ekg
Oomoo`05Ool00`00Oomoo`18Ool006Yoo`03001oogoo02Yoo`03G_Moogoo02aoo`03G_Moogoo02ao
o`03G_Moogoo02aoo`03G_Moogoo02eoo`03G_Moogoo009oo`8002Qoo`03G_Moogoo02aoo`03G_Mo
ogoo00Eoo`03001oogoo04Qoo`00JWoo0P00:goo00=NmgooOol0;7oo00=NmgooOol0;7oo00=Nmgoo
Ool0;7oo00=NmgooOol0;Goo00=NmgooOol00P00:Woo00=NmgooOol0;7oo00=NmgooOol00goo0`00
BWoo001ZOol00`00Oomoo`0ZOol00ekgOomoo`0/Ool00ekgOomoo`0/Ool00ekgOomoo`0/Ool00ekg
Oomoo`0]Ool00ekg0000000/Ool00ekgOomoo`0/Ool00ekgOomoo`05Ool00`00Oomoo`18Ool006Yo
o`03001oogoo02Yoo`03G_Moogoo02aoo`03G_Moogoo02aoo`03G_Moogoo02aoo`03G_Moogoo02ao
o`8002ioo`03G_Moogoo02aoo`03G_Moogoo00Eoo`03001oogoo04Qoo`00JWoo00<007ooOol0:Woo
00=NmgooOol0;7oo00=NmgooOol0;7oo00=NmgooOol0;7oo00=NmgooOol0:Woo0P0000=ooekgOol0
;Goo00=NmgooOol0;7oo00=NmgooOol01Goo00<007ooOol0B7oo001ZOol00`00Oomoo`0ZOol00ekg
Oomoo`0/Ool00ekgOomoo`0/Ool00ekgOomoo`0/Ool00ekgOomoo`0YOol01@00OomoogooG_L0;Woo
00=NmgooOol0;7oo00=NmgooOol01Goo00<007ooOol0B7oo001ZOol2000[Ool00ekgOomoo`0/Ool0
0ekgOomoo`0/Ool00ekgOomoo`0/Ool00ekgOomoo`0WOol20004Ool00ekgOomoo`0/Ool00ekgOomo
o`0/Ool00ekgOomoo`03Ool3001:Ool006Yoo`03001oogoo02Yoo`03G_Moogoo02aoo`03G_Moogoo
02aoo`03G_Moogoo02aoo`03G_Moogoo02Ioo`03001oogoo00Aoo`03G_Moogoo02aoo`03G_Moogoo
02aoo`03G_Moogoo00Eoo`03001oogoo04Qoo`00JWoo00<007ooOol0:Woo00=NmgooOol0;7oo00=N
mgooOol0;7oo00=NmgooOol0;7oo00=NmgooOol097oo0P001goo00=NmgooOol0;7oo00=NmgooOol0
;7oo00=NmgooOol01Goo00<007ooOol0B7oo001ZOol00`00Oomoo`0ZOol00ekgOomoo`0/Ool00ekg
Oomoo`0/Ool00ekgOomoo`0/Ool00ekgOomoo`0QOol30009Ool00ekgOomoo`0/Ool00ekgOomoo`0/
Ool00ekgOomoo`05Ool00`00Oomoo`18Ool006Yoo`03001oogoo02Yoo`03G_Moogoo02aoo`03G_Mo
ogoo02aoo`03G_Moogoo02aoo`03G_Moogoo021oo`03001oogoo00Yoo`03G_Moogoo02aoo`03G_Mo
ogoo02aoo`03G_Moogoo00Eoo`03001oogoo04Qoo`00JWoo0P00:goo00=NmgooOol0;7oo00=Nmgoo
Ool0;7oo00=NmgooOol0;7oo00=NmgooOol07goo00<007ooOol02goo00=NmgooOol0;7oo00=Nmgoo
Ool0;7oo00=NmgooOol00goo0`00BWoo000oOol8000SOol00`00Oomoo`0ZOol00ekgOomoo`0/Ool0
0ekgOomoo`0/Ool00ekgOomoo`0/Ool00ekgOomoo`0MOol2000>Ool00ekgOomoo`0/Ool00ekgOomo
o`0/Ool00ekgOomoo`05Ool00`00Oomoo`18Ool003ioo`04001oogoo0002Ool01000Oomoo`008Woo
00<007ooOol0:Woo00=NmgooOol0;7oo00=NmgooOol0;7oo00=NmgooOol0;7oo00=NmgooOol06goo
0P0047oo00=NmgooOol0;7oo00=NmgooOol0;7oo00=NmgooOol01Goo00<007ooOol0B7oo000nOol0
1000Oomoo`000Woo00@007ooOol001Yoo`8000Ioo`03001oogoo02Yoo`03G_Moogoo02aoo`03G_Mo
ogoo02aoo`03G_Moogoo02aoo`03G_Moogoo01Yoo`03001oogoo011oo`03G_Moogoo02aoo`03G_Mo
ogoo02aoo`03G_Moogoo00Eoo`03001oogoo04Qoo`00?goo0`000Woo0`006Woo00@007ooOol000Eo
o`03001oogoo02Yoo`03G_Moogoo02aoo`03G_Moogoo02aoo`03G_Moogoo02aoo`03G_Moogoo01Uo
o`03001oogoo015oo`03G_Moogoo02aoo`03G_Moogoo02aoo`03G_Moogoo00Eoo`03001oogoo04Qo
o`00@Goo00@007ooOol0009oo`03001oogoo01Moo`04001oogoo0005Ool3003@G_L3001hG_L3001:
Ool0041oo`800003Ool00000008001Yoo`04001oogoo0005Ool00`00Oomoo`0ZOol00ekgOomoo`0/
Ool00ekgOomoo`0/Ool00ekgOomoo`0/Ool00ekgOomoo`0EOol00`00Oomoo`0EOol00ekgOomoo`0/
Ool00ekgOomoo`0/Ool00ekgOomoo`05Ool00`00Oomoo`18Ool0065oo`04001oogoo0005Ool00`00
Oomoo`0ZOol00ekgOomoo`0/Ool00ekgOomoo`0/Ool00ekgOomoo`0/Ool00ekgOomoo`0COol2000H
Ool00ekgOomoo`0/Ool00ekgOomoo`0/Ool00ekgOomoo`05Ool00`00Oomoo`18Ool0069oo`8000Io
o`03001oogoo02Yoo`03G_Moogoo02aoo`03G_Moogoo02aoo`03G_Moogoo02aoo`03G_Moogoo019o
o`03001oogoo01Qoo`03G_Moogoo02aoo`03G_Moogoo02aoo`03G_Moogoo00Eoo`03001oogoo04Qo
o`00JWoo0P00:goo00=NmgooOol0;7oo00=NmgooOol0;7oo00=NmgooOol0;7oo00=NmgooOol04Goo
00<007ooOol06Goo00=NmgooOol0;7oo00=NmgooOol0;7oo00=NmgooOol00goo0`00BWoo001ZOol0
0`00Oomoo`0ZOol00ekgOomoo`0/Ool00ekgOomoo`0/Ool00ekgOomoo`0/Ool00ekgOomoo`0?Ool2
000LOol00ekgOomoo`0/Ool00ekgOomoo`0/Ool00ekgOomoo`05Ool00`00Oomoo`18Ool006Yoo`03
001oogoo02Yoo`03G_Moogoo02aoo`03G_Moogoo02aoo`03G_Moogoo02aoo`03G_Moogoo00ioo`03
001oogoo01aoo`03G_Moogoo02aoo`03G_Moogoo02aoo`03G_Moogoo00Eoo`03001oogoo04Qoo`00
JWoo00<007ooOol0:Woo00=NmgooOol0;7oo00=NmgooOol0;7oo00=NmgooOol0;7oo00=NmgooOol0
37oo0P007goo00=NmgooOol0;7oo00=NmgooOol0;7oo00=NmgooOol01Goo00<007ooOol0B7oo001Z
Ool00`00Oomoo`0ZOol00ekgOomoo`0/Ool00ekgOomoo`0/Ool00ekgOomoo`0/Ool00ekgOomoo`0;
Ool00`00Oomoo`0OOol00ekgOomoo`0/Ool00ekgOomoo`0/Ool00ekgOomoo`05Ool00`00Oomoo`18
Ool006Yoo`8002]oo`03G_Moogoo02aoo`03G_Moogoo02aoo`03G_Moogoo02aoo`03G_Moogoo00Uo
o`80029oo`03G_Moogoo02aoo`03G_Moogoo02aoo`03G_Moogoo00=oo`<004Yoo`00JWoo00<007oo
Ool0:Woo00=NmgooOol0;7oo00=NmgooOol0;7oo00=NmgooOol0;7oo00=NmgooOol027oo00<007oo
Ool08Woo00=NmgooOol0;7oo00=NmgooOol0;7oo00=NmgooOol01Goo00<007ooOol0B7oo001ZOol0
0`00Oomoo`0ZOol00ekgOomoo`0/Ool00ekgOomoo`0/Ool00ekgOomoo`0/Ool00ekgOomoo`07Ool0
0`00Oomoo`0SOol00ekgOomoo`0/Ool00ekgOomoo`0/Ool00ekgOomoo`05Ool00`00Oomoo`18Ool0
06Yoo`03001oogoo02Yoo`03G_Moogoo02aoo`03G_Moogoo02aoo`03G_Moogoo02aoo`03G_Moogoo
00Ioo`03001oogoo02Aoo`03G_Moogoo02aoo`03G_Moogoo02aoo`03G_Moogoo00Eoo`03001oogoo
04Qoo`00JWoo00<007ooOol0:Woo00=NmgooOol0;7oo00=NmgooOol0;7oo00=NmgooOol0;7oo00=N
mgooOol017oo0P009goo00=NmgooOol0;7oo00=NmgooOol0;7oo00=NmgooOol01Goo00<007ooOol0
B7oo001ZOol2000[Ool00ekgOomoo`0/Ool00ekgOomoo`0/Ool00ekgOomoo`0/Ool00ekgOomoo`03
Ool00`00Oomoo`0WOol00ekgOomoo`0/Ool00ekgOomoo`0/Ool00ekgOomoo`03Ool3001:Ool006Yo
o`03001oogoo02Yoo`03G_Moogoo02aoo`03G_Moogoo02aoo`03G_Moogoo02aoo`03G_Moogoo00=o
o`03001oogoo02Moo`03G_Moogoo02aoo`03G_Moogoo02aoo`03G_Moogoo00Eoo`03001oogoo04Qo
o`00JWoo00<007ooOol0:Woo00=NmgooOol0;7oo00=NmgooOol0;7oo00=NmgooOol0;7oo00ANmgoo
Oomoo`8002Yoo`03G_Moogoo02aoo`03G_Moogoo02aoo`03G_Moogoo00Eoo`03001oogoo04Qoo`00
Fgoo10000goo0P001Woo00<007ooOol0:Woo00=NmgooOol0;7oo00=NmgooOol0;7oo00=NmgooOol0
;7oo00ANmgooOol002aoo`03G_Moogoo02aoo`03G_Moogoo02aoo`03G_Moogoo00Eoo`03001oogoo
04Qoo`00Fgoo00<007ooOol00goo00@007ooOol000Eoo`03001oogoo02Yoo`03G_Moogoo02aoo`03
G_Moogoo02aoo`03G_Moogoo02aoo`03G_Moo`0002eoo`03G_Moogoo02aoo`03G_Moogoo02aoo`03
G_Moogoo00Eoo`03001oogoo04Qoo`00G7oo00<007ooOol00Woo00@007ooOol000Eoo`<00;MNm`80
099Nm`<004Yoo`00GGoo00D007ooOomoo`00009oo`03001oogoo00=oo`03001oogoo02Yoo`03G_Mo
ogoo02aoo`03G_Moogoo02aoo`03G_Moogoo02]oo`03001Nmgoo02ioo`03G_Moogoo02aoo`03G_Mo
ogoo02aoo`03G_Moogoo00Eoo`03001oogoo04Qoo`00Fgoo00@007ooOol0009oo`04001oogoo0005
Ool00`00Oomoo`0ZOol00ekgOomoo`0/Ool00ekgOomoo`0/Ool00ekgOomoo`0ZOol00`00OomNm`0_
Ool00ekgOomoo`0/Ool00ekgOomoo`0/Ool00ekgOomoo`05Ool00`00Oomoo`18Ool005aoo`8000Ao
o`8000Ioo`03001oogoo02Yoo`03G_Moogoo02aoo`03G_Moogoo02aoo`03G_Moogoo02Uoo`04001o
ogooG_L_Ool00ekgOomoo`0/Ool00ekgOomoo`0/Ool00ekgOomoo`05Ool00`00Oomoo`18Ool006Yo
o`03001oogoo02Yoo`03G_Moogoo02aoo`03G_Moogoo02aoo`03G_Moogoo02Qoo`05001oogooOomN
m`0_Ool00ekgOomoo`0/Ool00ekgOomoo`0/Ool00ekgOomoo`05Ool00`00Oomoo`18Ool006Yoo`80
02]oo`03G_Moogoo02aoo`03G_Moogoo02aoo`03G_Moogoo02Moo`03001oogoo009oo`03G_Moogoo
02eoo`03G_Moogoo02aoo`03G_Moogoo02aoo`03G_Moogoo00=oo`<004Yoo`00JWoo00<007ooOol0
:Woo00=NmgooOol0;7oo00=NmgooOol0;7oo00=NmgooOol09goo00<007ooOol00Woo00=NmgooOol0
;Goo00=NmgooOol0;7oo00=NmgooOol0;7oo00=NmgooOol01Goo00<007ooOol0B7oo001ZOol00`00
Oomoo`0ZOol00ekgOomoo`0/Ool00ekgOomoo`0/Ool00ekgOomoo`0VOol00`00Oomoo`03Ool00ekg
Oomoo`0]Ool00ekgOomoo`0/Ool00ekgOomoo`0/Ool00ekgOomoo`05Ool00`00Oomoo`18Ool006Yo
o`03001oogoo02Yoo`03G_Moogoo02aoo`03G_Moogoo02aoo`03G_Moogoo02Ioo`03001oogoo00=o
o`03G_Moogoo02eoo`03G_Moogoo02aoo`03G_Moogoo02aoo`03G_Moogoo00Eoo`03001oogoo04Qo
o`00JWoo00<007ooOol0:Woo00=NmgooOol0;7oo00=NmgooOol0;7oo00=NmgooOol09Goo00<007oo
Ool017oo00=NmgooOol0;Goo00=NmgooOol0;7oo00=NmgooOol0;7oo00=NmgooOol01Goo00<007oo
Ool0B7oo001ZOol2000[Ool00ekgOomoo`0/Ool00ekgOomoo`0/Ool00ekgOomoo`0TOol00`00Oomo
o`05Ool00ekgOomoo`0]Ool00ekgOomoo`0/Ool00ekgOomoo`0/Ool00ekgOomoo`03Ool3001:Ool0
06Yoo`03001oogoo02Yoo`03G_Moogoo02aoo`03G_Moogoo02aoo`03G_Moogoo02=oo`03001oogoo
00Ioo`03G_Moogoo02eoo`03G_Moogoo02aoo`03G_Moogoo02aoo`03G_Moogoo00Eoo`03001oogoo
04Qoo`00JWoo00<007ooOol0:Woo00=NmgooOol0;7oo00=NmgooOol0;7oo00=NmgooOol08Woo00<0
07ooOol01goo00=NmgooOol0;Goo00=NmgooOol0;7oo00=NmgooOol0;7oo00=NmgooOol01Goo00<0
07ooOol0B7oo001ZOol00`00Oomoo`0ZOol00ekgOomoo`0/Ool00ekgOomoo`0/Ool00ekgOomoo`0Q
Ool00`00Oomoo`08Ool00ekgOomoo`0]Ool00ekgOomoo`0/Ool00ekgOomoo`0/Ool00ekgOomoo`05
Ool00`00Oomoo`18Ool006Yoo`03001oogoo02Yoo`03G_Moogoo02aoo`03G_Moogoo02aoo`03G_Mo
ogoo021oo`03001oogoo00Uoo`03G_Moogoo02eoo`03G_Moogoo02aoo`03G_Moogoo02aoo`03G_Mo
ogoo00Eoo`03001oogoo04Qoo`00JWoo0P00:goo00=NmgooOol0;7oo00=NmgooOol0;7oo00=Nmgoo
Ool07goo00<007ooOol02Woo00=NmgooOol0;Goo00=NmgooOol0;7oo00=NmgooOol0;7oo00=Nmgoo
Ool00goo0`00BWoo001ZOol00`00Oomoo`0ZOol00ekgOomoo`0<Ool]000ROol00ekgOomoo`0OOol0
0`00Oomoo`0:Ool00ekgOomoo`0]Ool00ekgOomoo`0/Ool00ekgOomoo`0/Ool00ekgOomoo`05Ool0
0`00Oomoo`18Ool006Yoo`03001oogoo02Iooa<0021oo`03G_Moogoo00Yoo`D001eoo`03G_Moogoo
01ioo`03001oogoo00]oo`03G_Moogoo02eoo`03G_Moogoo02aoo`03G_Moogoo02aoo`03G_Moogoo
00Eoo`03001oogoo04Qoo`00GGoo0`000Woo0P001Woo00<007ooOol06Woo300017oo00=NmgooOol0
;7oo00=NmgooOol03goo10006Goo00=NmgooOol07Woo00<007ooOol02goo00=NmgooOol0;Goo00=N
mgooOol0;7oo00=NmgooOol0;7oo00=NmgooOol01Goo00<007ooOol0B7oo001NOol01000Oomoo`00
0Woo00<007ooOol00goo00<007ooOol03Goo3@0047oo00=NmgooOol0;7oo00=NmgooOol04goo1000
5Goo00=NmgooOol07Goo00<007ooOol037oo00=NmgooOol0;Goo00=NmgooOol0;7oo00=NmgooOol0
;7oo00=NmgooOol01Goo00<007ooOol0B7oo001KOol500001Goo001oogoo00001Goo0`001Ekg2000
IUkg1000<Ekg00<005kgG_L0X5kg0`00BWoo001KOol01000Oomoo`000Woo00@007ooOol000Eoo`03
001oogoo02Yoo`03G_Moogoo02aoo`03G_Moogoo01]oo`<000ioo`03G_Moogoo01aoo`03001oogoo
00eoo`03G_Moogoo02eoo`03G_Moogoo02aoo`03G_Moogoo02aoo`03G_Moogoo00Eoo`03001oogoo
04Qoo`00G7oo00<007oo00000Woo00@007ooOol000Eoo`03001oogoo02Yoo`03G_Moogoo02aoo`03
G_Moogoo01ioo`8000aoo`03G_Moogoo00eoo`H000Uoo`03001oogoo00eoo`03G_Moogoo02eoo`03
G_Moogoo02aoo`03G_Moogoo02aoo`03G_Moogoo00Eoo`03001oogoo04Qoo`00GGoo0P000goo0P00
1Woo00<007ooOol0:Woo00=NmgooOol0;7oo00=NmgooOol087oo0P002Woo00=NmgooOol02Woo0`00
1Woo0P001goo00<007ooOol03Goo00=NmgooOol0;Goo00=NmgooOol0;7oo00=NmgooOol0;7oo00=N
mgooOol01Goo00<007ooOol0B7oo001ZOol00`00Oomoo`0ZOol00ekgOomoo`0/Ool00ekgOomoo`0R
Ool00`00Oomoo`07Ool00ekgOomoo`08Ool2000;Ool00`00Oomoo`03Ool00`00Oomoo`0>Ool00ekg
Oomoo`0]Ool00ekgOomoo`0/Ool00ekgOomoo`0/Ool00ekgOomoo`05Ool00`00Oomoo`18Ool006Yo
o`8002]oo`03G_Moogoo02aoo`03G_Moogoo02=oo`8000Moo`03G_Moogoo00Moo`03001oogoo00ao
o`8000=oo`03001oogoo00ioo`03G_Moogoo02eoo`03G_Moogoo02aoo`03G_Moogoo02aoo`03G_Mo
ogoo00=oo`<004Yoo`00JWoo00<007ooOol0:Woo00=NmgooOol0;7oo00=NmgooOol09Goo00<007oo
Ool017oo00=NmgooOol01Woo00<007ooOol03goo100047oo00=NmgooOol0;Goo00=NmgooOol0;7oo
00=NmgooOol0;7oo00=NmgooOol01Goo00<007ooOol0B7oo001ZOol00`00Oomoo`0ZOol00ekgOomo
o`0/Ool00ekgOomoo`0VOol00`00Oomoo`03Ool00ekgOomoo`04Ool2000COol00`00Oomoo`0@Ool0
0ekgOomoo`0]Ool00ekgOomoo`0/Ool00ekgOomoo`0/Ool00ekgOomoo`05Ool00`00Oomoo`18Ool0
06Yoo`03001oogoo02Yoo`03G_Moogoo02aoo`03G_Moogoo02Moo`03001oogoo009oo`03G_Moogoo
009oo`8002Qoo`03G_Moogoo02eoo`03G_Moogoo02aoo`03G_Moogoo02aoo`03G_Moogoo00Eoo`03
001oogoo04Qoo`00JWoo00<007ooOol0:Woo00=NmgooOol0;7oo00=NmgooOol0:7oo00D007ooOomo
oekg00=oo`03001oogoo02Qoo`03G_Moogoo02eoo`03G_Moogoo02aoo`03G_Moogoo02aoo`03G_Mo
ogoo00Eoo`03001oogoo04Qoo`00JWoo0P00:goo00=NmgooOol0;7oo00=NmgooOol0:Goo00@007oo
OomNm`=oo`03001oogoo02Qoo`03G_Moogoo02eoo`03G_Moogoo02aoo`03G_Moogoo02aoo`03G_Mo
ogoo00=oo`<004Yoo`00JWoo00<007ooOol0:Woo00=NmgooOol0;7oo00=NmgooOol0:Woo0P0000AN
mgooOol002]oo`03G_Moogoo02eoo`03G_Moogoo02aoo`03G_Moogoo02aoo`03G_Moogoo00Eoo`03
001oogoo04Qoo`00JWoo00<007ooOol0:Woo00=NmgooOol0;7oo00=NmgooOol0:goo1000;7oo00=N
mgooOol0;Goo00=NmgooOol0;7oo00=NmgooOol0;7oo00=NmgooOol01Goo00<007ooOol0B7oo001Z
Ool00`00Oomoo`05Ool00`00Oomoo`0NOol01@00OomoogooG_L04Woo00<007ooOol047oo00<007oo
Ool01Woo00=NmgooOol00goo00<007ooOol02Goo00<007ooOol027oo00<007ooOol01goo00<007oo
Ool01Goo00<007ooOol0;7oo00=NmgooOol01goo00<007ooOol07Woo00<007ooOol00Woo00=Nmgoo
Ool047oo00<007ooOol03goo00<007ooOol01goo00=NmgooOol00Woo00<007ooOol02Woo00<007oo
Ool01goo00<007ooOol01goo00<007ooOol01Woo00<007ooOol01Goo00<007ooOol0B7oo001ZOol0
0`00Oomoo`05Ool00`00Oomoo`0NOol01@00OomoogooG_L04Woo00<007ooOol047oo00<007ooOol0
1Woo00=NmgooOol00goo00<007ooOol02Goo00<007ooOol027oo00<007ooOol01goo00<007ooOol0
1Goo00<007ooOol0;7oo00=NmgooOol01goo00<007ooOol07Woo00<007ooOol00Woo00=NmgooOol0
47oo00<007ooOol03goo00<007ooOol01goo00=NmgooOol00Woo00<007ooOol02Woo00<007ooOol0
1goo00<007ooOol01goo00<007ooOol01Woo00<007ooOol01Goo00<007ooOol0B7oo001ZOooo001B
001:Ool00?mooomoo`Moo`00ogooogoo1goo003oOoooOol7Ool00?mooomoo`Moo`00ogooogoo1goo
003oOoooOol7Ool00?mooomoo`Moo`00ogooogoo1goo001[Ool20004Ool20003Ool4000lOol20004
Ool20004Ool2000_Ool5000dOol40018Ool2000cOol50002Ool2001?Ool006Yoo`04001oogoo0008
Ool00`00Oomoo`0lOol01000Oomoo`0027oo00@007ooOol0031oo`03001oogoo03Aoo`03001oogoo
04Qoo`04001oogoo000dOol01@00Oomoogoo00000Woo00<007ooOol0C7oo001ZOol01000Oomoo`00
2Goo00<007ooOol0>goo00@007ooOol000]oo`03001oogoo02ioo`03001oogoo03Eoo`03001oogoo
04Yoo`03001oogoo039oo`05001oogooOol00002Ool00`00Oomoo`1<Ool006Yoo`04001oogoo000:
Ool00`00Oomoo`0jOol01000Oomoo`002Goo0P00<Goo00<007ooOol0=Woo00<007ooOol0Agoo0P00
=Goo00D007ooOomoo`00009oo`03001oogoo04aoo`00JWoo00@007ooOol000Qoo`04001oogoo000k
Ool01000Oomoo`002Goo00<007ooOol0<7oo00<007ooOol0=7oo00@007ooOol004Qoo`03001oogoo
03Aoo`05001oogooOol00002Ool00`00Oomoo`1<Ool006]oo`8000Yoo`8003eoo`8000Yoo`<002mo
o`8003Moo`8004Uoo`<003=oo`8000Aoo`8004moo`00ogooogoo1goo003oOoooOol7Ool00?mooomo
o`Moo`00ogooogoo1goo003oOoooOol7Ool00?mooomoo`Moo`00ngoo00L007oo001oo`00Ool00003
Ool00`00Ool000020003Ool01000Oomoo`000Woo00@007ooOol000Aoo`8000=oo`@0009oo`@00=]o
o`00ngoo00H007oo001oo`00Ool60003Ool01@00Oomoo`00Ool00P000Woo00@007ooOol000=oo`04
001oogoo0002Ool01`00Oomoogoo001oo`000=ioo`00ngoo0P0000=oo`0000000Woo00D007oo001o
o`00009oo`80009oo`04001oo`000002Ool01000Oomoo`000goo00@007ooOol0009oo`07001oogoo
Ool007oo0000gWoo003kOol200000goo00000002Ool01@00Ool007oo00001Woo0P0000Eoo`00Oomo
o`00009oo`05001oogooOol00002Ool01000Oomoo`000goo00<007oo00000`00fgoo003kOol20000
0goo00000002Ool01@00Ool007oo00000goo00<007ooOol00P0000Eoo`00Oomoo`00009oo`05001o
ogooOol00002Ool01000Oomoo`000goo00<007oo0000gWoo003kOol200000goo00000003Ool01000
Oomoogoo0`000goo00@007ooOol0009oo`H00005Ool007ooOol00002Ool40002Ool4003KOol00?mo
oomoo`Moo`00ogooogoo1goo0000\
\>"],
  ImageRangeCache->{{{0, 516.125}, {171.375, 0}} -> {-1.30579, -89.8677, \
0.00531039, 1.01635}},
  CellTags->{"Bode plot", "i:9", "b:20.1"}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .33333 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.415627 0.560564 0.410757 0.000999676 [
[.02381 -0.0125 -11.1875 -13.1875 ]
[.02381 -0.0125 11.1875 0 ]
[.24688 -0.0125 -11.1875 -13.1875 ]
[.24688 -0.0125 11.1875 0 ]
[.41563 -0.0125 -5.0625 -13.1875 ]
[.41563 -0.0125 5.0625 0 ]
[.58437 -0.0125 -5.0625 -13.1875 ]
[.58437 -0.0125 5.0625 0 ]
[.80744 -0.0125 -5.0625 -13.1875 ]
[.80744 -0.0125 5.0625 0 ]
[.97619 -0.0125 -8.125 -13.1875 ]
[.97619 -0.0125 8.125 0 ]
[ 0 0 -0.125 0 ]
[.5 -0.0125 -23.4375 -26.375 ]
[.5 -0.0125 23.4375 -13.1875 ]
[-0.0125 .01089 -24 -4.5 ]
[-0.0125 .01089 0 4.5 ]
[-0.0125 .06087 -24 -4.5 ]
[-0.0125 .06087 0 4.5 ]
[-0.0125 .11085 -24 -4.5 ]
[-0.0125 .11085 0 4.5 ]
[-0.0125 .16084 -24 -4.5 ]
[-0.0125 .16084 0 4.5 ]
[-0.0125 .21082 -24 -4.5 ]
[-0.0125 .21082 0 4.5 ]
[-0.0125 .26081 -24 -4.5 ]
[-0.0125 .26081 0 4.5 ]
[-0.0125 .31079 -24 -4.5 ]
[-0.0125 .31079 0 4.5 ]
[ 0 0 -0.125 0 ]
[-0.01875 .16667 -52.5 -6.59375 ]
[-0.01875 .16667 -24 6.59375 ]
[.02381 .34583 -11.1875 0 ]
[.02381 .34583 11.1875 13.1875 ]
[.24688 .34583 -11.1875 0 ]
[.24688 .34583 11.1875 13.1875 ]
[.41563 .34583 -5.0625 0 ]
[.41563 .34583 5.0625 13.1875 ]
[.58437 .34583 -5.0625 0 ]
[.58437 .34583 5.0625 13.1875 ]
[.80744 .34583 -5.0625 0 ]
[.80744 .34583 5.0625 13.1875 ]
[.97619 .34583 -8.125 0 ]
[.97619 .34583 8.125 13.1875 ]
[ 0 .33333 .125 0 ]
[.5 .34583 -15.7813 13.1875 ]
[.5 .34583 15.7813 24.625 ]
[ 1 0 .125 0 ]
[1.0125 .16667 0 -6.59375 ]
[1.0125 .16667 10.125 6.59375 ]
[ 0 -0.0005 0 0 ]
[ 1 .33383 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
.75 g
.25 Mabswid
[ ] 0 setdash
.13534 0 m
.13534 .33333 L
s
.27549 0 m
.27549 .33333 L
s
.41563 0 m
.41563 .33333 L
s
.55577 0 m
.55577 .33333 L
s
.69591 0 m
.69591 .33333 L
s
.83605 0 m
.83605 .33333 L
s
.97619 0 m
.97619 .33333 L
s
0 .01089 m
1 .01089 L
s
0 .06087 m
1 .06087 L
s
0 .11085 m
1 .11085 L
s
0 .16084 m
1 .16084 L
s
0 .21082 m
1 .21082 L
s
0 .26081 m
1 .26081 L
s
0 .31079 m
1 .31079 L
s
0 g
.02381 0 m
.02381 .00625 L
s
gsave
.02381 -0.0125 -72.1875 -17.1875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 21.1875 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(0.2) show
81.375 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.24688 0 m
.24688 .00625 L
s
gsave
.24688 -0.0125 -72.1875 -17.1875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 21.1875 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(0.5) show
81.375 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.41563 0 m
.41563 .00625 L
s
gsave
.41563 -0.0125 -66.0625 -17.1875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 21.1875 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(1) show
69.125 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.58437 0 m
.58437 .00625 L
s
gsave
.58437 -0.0125 -66.0625 -17.1875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 21.1875 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
69.125 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.80744 0 m
.80744 .00625 L
s
gsave
.80744 -0.0125 -66.0625 -17.1875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 21.1875 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
69.125 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.97619 0 m
.97619 .00625 L
s
gsave
.97619 -0.0125 -69.125 -17.1875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 21.1875 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(10) show
75.250 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.001 w
.12252 0 m
.12252 .00375 L
s
.19256 0 m
.19256 .00375 L
s
.29127 0 m
.29127 .00375 L
s
.32879 0 m
.32879 .00375 L
s
.3613 0 m
.3613 .00375 L
s
.38998 0 m
.38998 .00375 L
s
.68308 0 m
.68308 .00375 L
s
.75312 0 m
.75312 .00375 L
s
.85183 0 m
.85183 .00375 L
s
.88936 0 m
.88936 .00375 L
s
.92187 0 m
.92187 .00375 L
s
.95054 0 m
.95054 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
gsave
.5 -0.0125 -84.4375 -30.375 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 21.1875 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(rad) show
%%IncludeResource: font Mathematica2Mono
%%IncludeFont: Mathematica2Mono
/Mathematica2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
81.375 13.313 moveto
(\\220) show
87.500 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(sec) show
105.875 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 .01089 m
.00625 .01089 L
s
[(-400)] -0.0125 .01089 1 0 Mshowa
0 .06087 m
.00625 .06087 L
s
[(-350)] -0.0125 .06087 1 0 Mshowa
0 .11085 m
.00625 .11085 L
s
[(-300)] -0.0125 .11085 1 0 Mshowa
0 .16084 m
.00625 .16084 L
s
[(-250)] -0.0125 .16084 1 0 Mshowa
0 .21082 m
.00625 .21082 L
s
[(-200)] -0.0125 .21082 1 0 Mshowa
0 .26081 m
.00625 .26081 L
s
[(-150)] -0.0125 .26081 1 0 Mshowa
0 .31079 m
.00625 .31079 L
s
[(-100)] -0.0125 .31079 1 0 Mshowa
.125 Mabswid
0 .02088 m
.00375 .02088 L
s
0 .03088 m
.00375 .03088 L
s
0 .04088 m
.00375 .04088 L
s
0 .05087 m
.00375 .05087 L
s
0 .07087 m
.00375 .07087 L
s
0 .08086 m
.00375 .08086 L
s
0 .09086 m
.00375 .09086 L
s
0 .10086 m
.00375 .10086 L
s
0 .12085 m
.00375 .12085 L
s
0 .13085 m
.00375 .13085 L
s
0 .14084 m
.00375 .14084 L
s
0 .15084 m
.00375 .15084 L
s
0 .17083 m
.00375 .17083 L
s
0 .18083 m
.00375 .18083 L
s
0 .19083 m
.00375 .19083 L
s
0 .20082 m
.00375 .20082 L
s
0 .22082 m
.00375 .22082 L
s
0 .23082 m
.00375 .23082 L
s
0 .24081 m
.00375 .24081 L
s
0 .25081 m
.00375 .25081 L
s
0 .2708 m
.00375 .2708 L
s
0 .2808 m
.00375 .2808 L
s
0 .2908 m
.00375 .2908 L
s
0 .30079 m
.00375 .30079 L
s
0 .00089 m
.00375 .00089 L
s
0 .32079 m
.00375 .32079 L
s
0 .33078 m
.00375 .33078 L
s
.25 Mabswid
0 0 m
0 .33333 L
s
gsave
-0.01875 .16667 -113.5 -10.5938 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 21.1875 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(deg) show
87.500 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02381 .32708 m
.02381 .33333 L
s
gsave
.02381 .34583 -72.1875 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 21.1875 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(0.2) show
81.375 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.24688 .32708 m
.24688 .33333 L
s
gsave
.24688 .34583 -72.1875 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 21.1875 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(0.5) show
81.375 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.41563 .32708 m
.41563 .33333 L
s
gsave
.41563 .34583 -66.0625 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 21.1875 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(1) show
69.125 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.58437 .32708 m
.58437 .33333 L
s
gsave
.58437 .34583 -66.0625 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 21.1875 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
69.125 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.80744 .32708 m
.80744 .33333 L
s
gsave
.80744 .34583 -66.0625 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 21.1875 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
69.125 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.97619 .32708 m
.97619 .33333 L
s
gsave
.97619 .34583 -69.125 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 21.1875 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(10) show
75.250 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.001 w
.12252 .32958 m
.12252 .33333 L
s
.19256 .32958 m
.19256 .33333 L
s
.29127 .32958 m
.29127 .33333 L
s
.32879 .32958 m
.32879 .33333 L
s
.3613 .32958 m
.3613 .33333 L
s
.38998 .32958 m
.38998 .33333 L
s
.68308 .32958 m
.68308 .33333 L
s
.75312 .32958 m
.75312 .33333 L
s
.85183 .32958 m
.85183 .33333 L
s
.88936 .32958 m
.88936 .33333 L
s
.92187 .32958 m
.92187 .33333 L
s
.95054 .32958 m
.95054 .33333 L
s
.25 Mabswid
0 .33333 m
1 .33333 L
s
gsave
.5 .34583 -76.7813 9.1875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 19.4375 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 12.625 moveto
%%IncludeResource: font Helvetica-Bold
%%IncludeFont: Helvetica-Bold
/Helvetica-Bold findfont 8.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 12.625 moveto
%%IncludeResource: font Helvetica-Bold
%%IncludeFont: Helvetica-Bold
/Helvetica-Bold findfont 8.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(PHASE) show
90.563 12.625 moveto
%%IncludeResource: font Helvetica-Bold
%%IncludeFont: Helvetica-Bold
/Helvetica-Bold findfont 8.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.99375 .01089 m
1 .01089 L
s
.99375 .06087 m
1 .06087 L
s
.99375 .11085 m
1 .11085 L
s
.99375 .16084 m
1 .16084 L
s
.99375 .21082 m
1 .21082 L
s
.99375 .26081 m
1 .26081 L
s
.99375 .31079 m
1 .31079 L
s
.125 Mabswid
.99625 .02088 m
1 .02088 L
s
.99625 .03088 m
1 .03088 L
s
.99625 .04088 m
1 .04088 L
s
.99625 .05087 m
1 .05087 L
s
.99625 .07087 m
1 .07087 L
s
.99625 .08086 m
1 .08086 L
s
.99625 .09086 m
1 .09086 L
s
.99625 .10086 m
1 .10086 L
s
.99625 .12085 m
1 .12085 L
s
.99625 .13085 m
1 .13085 L
s
.99625 .14084 m
1 .14084 L
s
.99625 .15084 m
1 .15084 L
s
.99625 .17083 m
1 .17083 L
s
.99625 .18083 m
1 .18083 L
s
.99625 .19083 m
1 .19083 L
s
.99625 .20082 m
1 .20082 L
s
.99625 .22082 m
1 .22082 L
s
.99625 .23082 m
1 .23082 L
s
.99625 .24081 m
1 .24081 L
s
.99625 .25081 m
1 .25081 L
s
.99625 .2708 m
1 .2708 L
s
.99625 .2808 m
1 .2808 L
s
.99625 .2908 m
1 .2908 L
s
.99625 .30079 m
1 .30079 L
s
.99625 .00089 m
1 .00089 L
s
.99625 .32079 m
1 .32079 L
s
.99625 .33078 m
1 .33078 L
s
.25 Mabswid
1 0 m
1 .33333 L
s
gsave
1.0125 .16667 -61 -10.5938 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 21.1875 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.125 13.313 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.5 Mabswid
.02381 .32302 m
.03546 .32312 L
.04657 .32322 L
.0572 .32332 L
.06738 .32342 L
.07716 .32352 L
.08656 .32361 L
.0956 .32371 L
.10433 .3238 L
.11275 .3239 L
.12089 .32399 L
.12877 .32408 L
.1364 .32416 L
.1438 .32425 L
.15098 .32433 L
.15795 .32441 L
.16473 .32449 L
.17133 .32457 L
.17775 .32464 L
.18401 .32472 L
.19011 .32479 L
.19606 .32485 L
.20187 .32492 L
.20754 .32498 L
.21309 .32504 L
.21851 .32509 L
.22381 .32514 L
.229 .32519 L
.23409 .32523 L
.23906 .32527 L
.24394 .3253 L
.24872 .32533 L
.25341 .32536 L
.25802 .32538 L
.26253 .32539 L
.26697 .3254 L
.27132 .3254 L
.2756 .32539 L
.2798 .32538 L
.28393 .32536 L
.288 .32533 L
.292 .32529 L
.29593 .32524 L
.2998 .32519 L
.30361 .32512 L
.30736 .32504 L
.31105 .32494 L
.31469 .32484 L
.31828 .32472 L
.32181 .32458 L
Mistroke
.32529 .32442 L
.32872 .32425 L
.33211 .32405 L
.33545 .32384 L
.33874 .32359 L
.34199 .32332 L
.3452 .32302 L
.34837 .32268 L
.35149 .32231 L
.35458 .32189 L
.35762 .32142 L
.36063 .3209 L
.3636 .32032 L
.36654 .31966 L
.36944 .31892 L
.37231 .31809 L
.37514 .31714 L
.37794 .31607 L
.38071 .31483 L
.38345 .31342 L
.38616 .31177 L
.38884 .30986 L
.39149 .30761 L
.39411 .30494 L
.3967 .30176 L
.39926 .29792 L
.4018 .29325 L
.40432 .28757 L
.4068 .28066 L
.40926 .27236 L
.4117 .26268 L
.41411 .25192 L
.4165 .24074 L
.41887 .22996 L
.42121 .22024 L
.42353 .21188 L
.42583 .20489 L
.42811 .19912 L
.43036 .19435 L
.4326 .19039 L
.43481 .18707 L
.43701 .18425 L
.43918 .18183 L
.44134 .17972 L
.44348 .17787 L
.4456 .17621 L
.4477 .17471 L
.44978 .17335 L
.45184 .17208 L
.45389 .17088 L
Mistroke
.45592 .16975 L
.45793 .16865 L
.45993 .16758 L
.46191 .16652 L
.46388 .16545 L
.46583 .16437 L
.46776 .16325 L
.46968 .16207 L
.47158 .16083 L
.47347 .15949 L
.47534 .15804 L
.4772 .15643 L
.47905 .15464 L
.48088 .15262 L
.4827 .1503 L
.4845 .14761 L
.4863 .14446 L
.48807 .14071 L
.48984 .13622 L
.49159 .13078 L
.49333 .1242 L
.49506 .11627 L
.49677 .10695 L
.49848 .09645 L
.50017 .0853 L
.50185 .07433 L
.50352 .06425 L
.50518 .0555 L
.50682 .04816 L
.50846 .04211 L
.51008 .03714 L
.51169 .03306 L
.5133 .02967 L
.51489 .02685 L
.51647 .02447 L
.51804 .02245 L
.5196 .02073 L
.52115 .01924 L
.5227 .01794 L
.52423 .01681 L
.52575 .01582 L
.52726 .01495 L
.52877 .01417 L
.53026 .01349 L
.53175 .01287 L
.53322 .01232 L
.53469 .01183 L
.53615 .01139 L
.5376 .01099 L
.53904 .01064 L
Mistroke
.54047 .01031 L
.5419 .01002 L
.54331 .00976 L
.54472 .00953 L
.54612 .00932 L
.54751 .00913 L
.5489 .00896 L
.55027 .0088 L
.55164 .00867 L
.553 .00855 L
.55436 .00844 L
.5557 .00834 L
.55704 .00826 L
.55837 .00819 L
.5597 .00813 L
.56101 .00808 L
.56232 .00803 L
.56362 .008 L
.56492 .00797 L
.56621 .00795 L
.56749 .00794 L
.56877 .00794 L
.57003 .00794 L
.5713 .00794 L
.57255 .00795 L
.5738 .00797 L
.57504 .00799 L
.57628 .00802 L
.57751 .00805 L
.57873 .00808 L
.57995 .00812 L
.58116 .00816 L
.58237 .0082 L
.58357 .00825 L
.58476 .0083 L
.58595 .00836 L
.58713 .00842 L
.58831 .00848 L
.58948 .00854 L
.59065 .0086 L
.59181 .00867 L
.59296 .00874 L
.59411 .00881 L
.59525 .00888 L
.59639 .00896 L
.59752 .00904 L
.59865 .00912 L
.59977 .0092 L
.60089 .00928 L
.602 .00936 L
Mistroke
.60311 .00945 L
.60421 .00954 L
.60531 .00963 L
.6064 .00971 L
.60749 .00981 L
.60857 .0099 L
.60965 .00999 L
.61072 .01009 L
.61179 .01018 L
.61285 .01028 L
.61391 .01038 L
.61497 .01048 L
.61602 .01057 L
.61706 .01068 L
.6181 .01078 L
.61914 .01088 L
.62017 .01098 L
.6212 .01109 L
.62222 .01119 L
.62324 .0113 L
.62425 .0114 L
.62527 .01151 L
.62627 .01161 L
.62727 .01172 L
.62827 .01183 L
.62927 .01194 L
.63026 .01205 L
.63124 .01216 L
.63222 .01227 L
.6332 .01238 L
.63418 .01249 L
.63515 .0126 L
.63611 .01272 L
.63708 .01283 L
.63803 .01294 L
.63899 .01305 L
.63994 .01317 L
.64089 .01328 L
.64183 .0134 L
.64277 .01351 L
.64371 .01363 L
.64464 .01374 L
.64557 .01386 L
.6465 .01397 L
.64742 .01409 L
.64834 .01421 L
.64925 .01432 L
.65017 .01444 L
.65108 .01456 L
.65198 .01467 L
Mistroke
.65288 .01479 L
.65378 .01491 L
.65468 .01503 L
.65557 .01515 L
.65646 .01526 L
.65734 .01538 L
.65823 .0155 L
.6591 .01562 L
.65998 .01574 L
.66085 .01586 L
.66172 .01598 L
.66259 .01609 L
.66345 .01621 L
.66431 .01633 L
.66517 .01645 L
.66603 .01657 L
.66688 .01669 L
.66773 .01681 L
.66857 .01693 L
.66941 .01705 L
.67025 .01717 L
.67109 .01729 L
.67193 .01741 L
.67276 .01753 L
.67358 .01765 L
.67441 .01777 L
.67523 .01789 L
.67605 .01801 L
.67687 .01813 L
.67768 .01825 L
.6785 .01837 L
.67931 .01849 L
.68011 .01861 L
.68092 .01873 L
.68172 .01885 L
.68251 .01897 L
.68331 .01909 L
.6841 .01921 L
.68489 .01933 L
.68568 .01945 L
.68647 .01957 L
.68725 .01969 L
.68803 .01981 L
.68881 .01993 L
.68959 .02005 L
.69036 .02017 L
.69113 .02029 L
.6919 .02041 L
.69266 .02053 L
.69343 .02065 L
Mistroke
.69419 .02077 L
.69495 .02088 L
.6957 .021 L
.69646 .02112 L
.69721 .02124 L
.69796 .02136 L
.6987 .02148 L
.69945 .0216 L
.70019 .02172 L
.70093 .02184 L
.70167 .02196 L
.70241 .02207 L
.70314 .02219 L
.70387 .02231 L
.7046 .02243 L
.70533 .02255 L
.70605 .02267 L
.70677 .02278 L
.70749 .0229 L
.70821 .02302 L
.70893 .02314 L
.70964 .02326 L
.71035 .02337 L
.71106 .02349 L
.71177 .02361 L
.71248 .02373 L
.71318 .02384 L
.71388 .02396 L
.71458 .02408 L
.71528 .02419 L
.71598 .02431 L
.71667 .02443 L
.71736 .02454 L
.71805 .02466 L
.71874 .02478 L
.71943 .02489 L
.72011 .02501 L
.72079 .02513 L
.72147 .02524 L
.72215 .02536 L
.72283 .02547 L
.7235 .02559 L
.72417 .0257 L
.72485 .02582 L
.72551 .02594 L
.72618 .02605 L
.72685 .02617 L
.72751 .02628 L
.72817 .02639 L
.72883 .02651 L
Mistroke
.72949 .02662 L
.73015 .02674 L
.7308 .02685 L
.73145 .02697 L
.7321 .02708 L
.73275 .02719 L
.7334 .02731 L
.73405 .02742 L
.73469 .02753 L
.73533 .02765 L
.73598 .02776 L
.73661 .02787 L
.73725 .02799 L
.73789 .0281 L
.73852 .02821 L
.73915 .02832 L
.73979 .02844 L
.74041 .02855 L
.74104 .02866 L
.74167 .02877 L
.74229 .02888 L
.74292 .029 L
.74354 .02911 L
.74416 .02922 L
.74477 .02933 L
.74539 .02944 L
.74601 .02955 L
.74662 .02966 L
.74723 .02977 L
.74784 .02988 L
.74845 .02999 L
.74906 .0301 L
.74966 .03021 L
.75027 .03032 L
.75087 .03043 L
.75147 .03054 L
.75207 .03065 L
.75267 .03076 L
.75327 .03087 L
.75386 .03098 L
.75446 .03109 L
.75505 .0312 L
.75564 .03131 L
.75623 .03142 L
.75682 .03152 L
.7574 .03163 L
.75799 .03174 L
.75857 .03185 L
.75915 .03196 L
.75974 .03206 L
Mistroke
.76032 .03217 L
.76089 .03228 L
.76147 .03239 L
.76205 .03249 L
.76262 .0326 L
.76319 .03271 L
.76377 .03281 L
.76434 .03292 L
.7649 .03303 L
.76547 .03313 L
.76604 .03324 L
.7666 .03334 L
.76717 .03345 L
.76773 .03355 L
.76829 .03366 L
.76885 .03377 L
.76941 .03387 L
.76997 .03398 L
.77052 .03408 L
.77108 .03418 L
.77163 .03429 L
.77218 .03439 L
.77273 .0345 L
.77328 .0346 L
.77383 .03471 L
.77438 .03481 L
.77492 .03491 L
.77547 .03502 L
.77601 .03512 L
.77656 .03522 L
.7771 .03533 L
.77764 .03543 L
.77817 .03553 L
.77871 .03563 L
.77925 .03574 L
.77978 .03584 L
.78032 .03594 L
.78085 .03604 L
.78138 .03615 L
.78191 .03625 L
.78244 .03635 L
.78297 .03645 L
.7835 .03655 L
.78402 .03665 L
.78455 .03675 L
.78507 .03685 L
.78559 .03695 L
.78612 .03706 L
.78664 .03716 L
.78716 .03726 L
Mistroke
.78767 .03736 L
.78819 .03746 L
.78871 .03756 L
.78922 .03766 L
.78973 .03775 L
.79025 .03785 L
.79076 .03795 L
.79127 .03805 L
.79178 .03815 L
.79229 .03825 L
.79279 .03835 L
.7933 .03845 L
.79381 .03855 L
.79431 .03864 L
.79481 .03874 L
.79532 .03884 L
.79582 .03894 L
.79632 .03903 L
.79682 .03913 L
.79731 .03923 L
.79781 .03933 L
.79831 .03942 L
.7988 .03952 L
.79929 .03962 L
.79979 .03971 L
.80028 .03981 L
.80077 .03991 L
.80126 .04 L
.80175 .0401 L
.80224 .04019 L
.80272 .04029 L
.80321 .04039 L
.8037 .04048 L
.80418 .04058 L
.80466 .04067 L
.80514 .04077 L
.80563 .04086 L
.80611 .04096 L
.80659 .04105 L
.80706 .04115 L
.80754 .04124 L
.80802 .04133 L
.80849 .04143 L
.80897 .04152 L
.80944 .04162 L
.80991 .04171 L
.81039 .0418 L
.81086 .0419 L
.81133 .04199 L
.8118 .04208 L
Mistroke
.81226 .04218 L
.81273 .04227 L
.8132 .04236 L
.81366 .04245 L
.81413 .04255 L
.81459 .04264 L
.81506 .04273 L
.81552 .04282 L
.81598 .04291 L
.81644 .04301 L
.8169 .0431 L
.81736 .04319 L
.81781 .04328 L
.81827 .04337 L
.81873 .04346 L
.81918 .04355 L
.81964 .04364 L
.82009 .04373 L
.82054 .04382 L
.82099 .04391 L
.82145 .044 L
.8219 .04409 L
.82235 .04418 L
.82279 .04427 L
.82324 .04436 L
.82369 .04445 L
.82413 .04454 L
.82458 .04463 L
.82502 .04472 L
.82547 .04481 L
.82591 .0449 L
.82635 .04499 L
.82679 .04508 L
.82723 .04516 L
.82767 .04525 L
.82811 .04534 L
.82855 .04543 L
.82899 .04552 L
.82942 .0456 L
.82986 .04569 L
.83029 .04578 L
.83073 .04587 L
.83116 .04595 L
.83159 .04604 L
.83202 .04613 L
.83246 .04622 L
.83289 .0463 L
.83331 .04639 L
.83374 .04648 L
.83417 .04656 L
Mistroke
.8346 .04665 L
.83503 .04673 L
.83545 .04682 L
.83588 .04691 L
.8363 .04699 L
.83672 .04708 L
.83715 .04716 L
.83757 .04725 L
.83799 .04733 L
.83841 .04742 L
.83883 .0475 L
.83925 .04759 L
.83967 .04767 L
.84008 .04776 L
.8405 .04784 L
.84092 .04793 L
.84133 .04801 L
.84175 .04809 L
.84216 .04818 L
.84258 .04826 L
.84299 .04834 L
.8434 .04843 L
.84381 .04851 L
.84422 .04859 L
.84463 .04868 L
.84504 .04876 L
.84545 .04884 L
.84586 .04893 L
.84627 .04901 L
.84667 .04909 L
.84708 .04917 L
.84748 .04926 L
.84789 .04934 L
.84829 .04942 L
.84869 .0495 L
.8491 .04958 L
.8495 .04967 L
.8499 .04975 L
.8503 .04983 L
.8507 .04991 L
.8511 .04999 L
.8515 .05007 L
.8519 .05015 L
.85229 .05023 L
.85269 .05032 L
.85308 .0504 L
.85348 .05048 L
.85387 .05056 L
.85427 .05064 L
.85466 .05072 L
Mistroke
.85505 .0508 L
.85545 .05088 L
.85584 .05096 L
.85623 .05104 L
.85662 .05112 L
.85701 .0512 L
.8574 .05127 L
.85779 .05135 L
.85817 .05143 L
.85856 .05151 L
.85895 .05159 L
.85933 .05167 L
.85972 .05175 L
.8601 .05183 L
.86049 .0519 L
.86087 .05198 L
.86125 .05206 L
.86164 .05214 L
.86202 .05222 L
.8624 .05229 L
.86278 .05237 L
.86316 .05245 L
.86354 .05253 L
.86392 .0526 L
.86429 .05268 L
.86467 .05276 L
.86505 .05284 L
.86543 .05291 L
.8658 .05299 L
.86618 .05307 L
.86655 .05314 L
.86692 .05322 L
.8673 .0533 L
.86767 .05337 L
.86804 .05345 L
.86842 .05352 L
.86879 .0536 L
.86916 .05368 L
.86953 .05375 L
.8699 .05383 L
.87027 .0539 L
.87063 .05398 L
.871 .05405 L
.87137 .05413 L
.87174 .0542 L
.8721 .05428 L
.87247 .05435 L
.87283 .05443 L
.8732 .0545 L
.87356 .05458 L
Mistroke
.87392 .05465 L
.87429 .05472 L
.87465 .0548 L
.87501 .05487 L
.87537 .05495 L
.87573 .05502 L
.87609 .05509 L
.87645 .05517 L
.87681 .05524 L
.87717 .05531 L
.87753 .05539 L
.87789 .05546 L
.87824 .05553 L
.8786 .05561 L
.87896 .05568 L
.87931 .05575 L
.87967 .05582 L
.88002 .0559 L
.88037 .05597 L
.88073 .05604 L
.88108 .05611 L
.88143 .05619 L
.88178 .05626 L
.88214 .05633 L
.88249 .0564 L
.88284 .05647 L
.88319 .05654 L
.88354 .05662 L
.88389 .05669 L
.88423 .05676 L
.88458 .05683 L
.88493 .0569 L
.88528 .05697 L
.88562 .05704 L
.88597 .05711 L
.88631 .05718 L
.88666 .05725 L
.887 .05733 L
.88735 .0574 L
.88769 .05747 L
.88803 .05754 L
.88838 .05761 L
.88872 .05768 L
.88906 .05775 L
.8894 .05782 L
.88974 .05789 L
.89008 .05795 L
.89042 .05802 L
.89076 .05809 L
.8911 .05816 L
Mistroke
.89144 .05823 L
.89177 .0583 L
.89211 .05837 L
.89245 .05844 L
.89278 .05851 L
.89312 .05858 L
.89346 .05864 L
.89379 .05871 L
.89412 .05878 L
.89446 .05885 L
.89479 .05892 L
.89513 .05899 L
.89546 .05905 L
.89579 .05912 L
.89612 .05919 L
.89645 .05926 L
.89678 .05932 L
.89711 .05939 L
.89744 .05946 L
.89777 .05953 L
.8981 .05959 L
.89843 .05966 L
.89876 .05973 L
.89909 .0598 L
.89941 .05986 L
.89974 .05993 L
.90007 .06 L
.90039 .06006 L
.90072 .06013 L
.90104 .06019 L
.90137 .06026 L
.90169 .06033 L
.90202 .06039 L
.90234 .06046 L
.90266 .06053 L
.90299 .06059 L
.90331 .06066 L
.90363 .06072 L
.90395 .06079 L
.90427 .06085 L
.90459 .06092 L
.90491 .06098 L
.90523 .06105 L
.90555 .06111 L
.90587 .06118 L
.90619 .06124 L
.9065 .06131 L
.90682 .06137 L
.90714 .06144 L
.90746 .0615 L
Mistroke
.90777 .06157 L
.90809 .06163 L
.9084 .0617 L
.90872 .06176 L
.90903 .06182 L
.90935 .06189 L
.90966 .06195 L
.90997 .06202 L
.91029 .06208 L
.9106 .06214 L
.91091 .06221 L
.91122 .06227 L
.91153 .06233 L
.91185 .0624 L
.91216 .06246 L
.91247 .06252 L
.91278 .06259 L
.91309 .06265 L
.91339 .06271 L
.9137 .06277 L
.91401 .06284 L
.91432 .0629 L
.91463 .06296 L
.91493 .06302 L
.91524 .06309 L
.91555 .06315 L
.91585 .06321 L
.91616 .06327 L
.91646 .06333 L
.91677 .0634 L
.91707 .06346 L
.91738 .06352 L
.91768 .06358 L
.91798 .06364 L
.91829 .0637 L
.91859 .06377 L
.91889 .06383 L
.91919 .06389 L
.91949 .06395 L
.91979 .06401 L
.92009 .06407 L
.9204 .06413 L
.92069 .06419 L
.92099 .06425 L
.92129 .06431 L
.92159 .06438 L
.92189 .06444 L
.92219 .0645 L
.92249 .06456 L
.92278 .06462 L
Mistroke
.92308 .06468 L
.92338 .06474 L
.92367 .0648 L
.92397 .06486 L
.92426 .06492 L
.92456 .06498 L
.92485 .06504 L
.92515 .06509 L
.92544 .06515 L
.92574 .06521 L
.92603 .06527 L
.92632 .06533 L
.92662 .06539 L
.92691 .06545 L
.9272 .06551 L
.92749 .06557 L
.92778 .06563 L
.92807 .06569 L
.92836 .06574 L
.92865 .0658 L
.92894 .06586 L
.92923 .06592 L
.92952 .06598 L
.92981 .06604 L
.9301 .06609 L
.93039 .06615 L
.93068 .06621 L
.93096 .06627 L
.93125 .06633 L
.93154 .06638 L
.93182 .06644 L
.93211 .0665 L
.9324 .06656 L
.93268 .06662 L
.93297 .06667 L
.93325 .06673 L
.93354 .06679 L
.93382 .06684 L
.9341 .0669 L
.93439 .06696 L
.93467 .06702 L
.93495 .06707 L
.93524 .06713 L
.93552 .06719 L
.9358 .06724 L
.93608 .0673 L
.93636 .06736 L
.93664 .06741 L
.93692 .06747 L
.9372 .06752 L
Mistroke
.93748 .06758 L
.93776 .06764 L
.93804 .06769 L
.93832 .06775 L
.9386 .0678 L
.93888 .06786 L
.93916 .06792 L
.93943 .06797 L
.93971 .06803 L
.93999 .06808 L
.94026 .06814 L
.94054 .06819 L
.94082 .06825 L
.94109 .0683 L
.94137 .06836 L
.94164 .06841 L
.94192 .06847 L
.94219 .06852 L
.94247 .06858 L
.94274 .06863 L
.94301 .06869 L
.94329 .06874 L
.94356 .0688 L
.94383 .06885 L
.9441 .06891 L
.94438 .06896 L
.94465 .06902 L
.94492 .06907 L
.94519 .06912 L
.94546 .06918 L
.94573 .06923 L
.946 .06929 L
.94627 .06934 L
.94654 .06939 L
.94681 .06945 L
.94708 .0695 L
.94735 .06955 L
.94762 .06961 L
.94789 .06966 L
.94815 .06971 L
.94842 .06977 L
.94869 .06982 L
.94896 .06987 L
.94922 .06993 L
.94949 .06998 L
.94975 .07003 L
.95002 .07009 L
.95029 .07014 L
.95055 .07019 L
.95082 .07024 L
Mistroke
.95108 .0703 L
.95135 .07035 L
.95161 .0704 L
.95187 .07045 L
.95214 .07051 L
.9524 .07056 L
.95266 .07061 L
.95293 .07066 L
.95319 .07071 L
.95345 .07077 L
.95371 .07082 L
.95397 .07087 L
.95423 .07092 L
.9545 .07097 L
.95476 .07103 L
.95502 .07108 L
.95528 .07113 L
.95554 .07118 L
.9558 .07123 L
.95606 .07128 L
.95631 .07133 L
.95657 .07139 L
.95683 .07144 L
.95709 .07149 L
.95735 .07154 L
.95761 .07159 L
.95786 .07164 L
.95812 .07169 L
.95838 .07174 L
.95863 .07179 L
.95889 .07184 L
.95915 .07189 L
.9594 .07194 L
.95966 .07199 L
.95991 .07204 L
.96017 .07209 L
.96042 .07214 L
.96068 .07219 L
.96093 .07225 L
.96118 .0723 L
.96144 .07234 L
.96169 .07239 L
.96194 .07244 L
.9622 .07249 L
.96245 .07254 L
.9627 .07259 L
.96295 .07264 L
.96321 .07269 L
.96346 .07274 L
.96371 .07279 L
Mistroke
.96396 .07284 L
.96421 .07289 L
.96446 .07294 L
.96471 .07299 L
.96496 .07304 L
.96521 .07309 L
.96546 .07314 L
.96571 .07318 L
.96596 .07323 L
.96621 .07328 L
.96646 .07333 L
.9667 .07338 L
.96695 .07343 L
.9672 .07348 L
.96745 .07352 L
.96769 .07357 L
.96794 .07362 L
.96819 .07367 L
.96843 .07372 L
.96868 .07377 L
.96893 .07381 L
.96917 .07386 L
.96942 .07391 L
.96966 .07396 L
.96991 .07401 L
.97015 .07405 L
.9704 .0741 L
.97064 .07415 L
.97088 .0742 L
.97113 .07424 L
.97137 .07429 L
.97161 .07434 L
.97186 .07439 L
.9721 .07443 L
.97234 .07448 L
.97259 .07453 L
.97283 .07457 L
.97307 .07462 L
.97331 .07467 L
.97355 .07472 L
.97379 .07476 L
.97403 .07481 L
.97427 .07486 L
.97451 .0749 L
.97475 .07495 L
.97499 .075 L
.97523 .07504 L
.97547 .07509 L
.97571 .07513 L
.97595 .07518 L
Mistroke
.97619 .07523 L
Mfstroke
0 0 m
1 0 L
1 .33333 L
0 .33333 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  CellLabel->"From In[128]:=",
  ImageSize->{517.125, 172.375},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`4000850000[1000`40O003h00Oogooogoo1goo003o
OoooOol7Ool00?mooomoo`Moo`00ogooogoo1goo003oOolGOol00`00Oomoo`3/Ool00?moo`Aoo`@0
009oo`D0009oo`@000=oo`03001oogoo009oo`<000Aoo`<000=oo`<00=Uoo`00ogoo1Goo00<007oo
Ool00Woo10000Woo00@007ooOol000Aoo`03001oogoo00Eoo`04001oogoo0005Ool00`00Oomoo`3J
Ool00?moo`Eoo`03001oogoo00Eoo`04001oogoo0002Ool00`00Oomoo`02Ool00`00Oomoo`02Ool3
0003Ool40002Ool00`00Oomoo`3JOol00?moo`Aoo`@000=oo`<000=oo`<000Eoo`04001oogooOol4
0003Ool20004Ool3003IOol00?mooa=oo`03001oogoo00=oo`03001oogoo0>Yoo`00ogoo4Woo0P00
1Woo00<007ooOol0jGoo003oOoooOol7Ool00?mooomoo`Moo`00ogooogoo1goo003oOoooOol7Ool0
0?mooomoo`Moo`00ogooogoo1goo003oOoooOol7Ool0075oo`8000Aoo`8000=oo`@003aoo`8000Ao
o`8000Aoo`8002moo`D003Aoo`@004Qoo`8003=oo`D0009oo`8004Uoo`00L7oo00@007ooOol000Qo
o`03001oogoo03aoo`04001oogoo0008Ool01000Oomoo`00<7oo00<007ooOol0=7oo00<007ooOol0
B7oo00@007ooOol003Aoo`05001oogooOol00002Ool00`00Oomoo`16Ool0071oo`04001oogoo0009
Ool00`00Oomoo`0kOol01000Oomoo`002goo00<007ooOol0;Woo00<007ooOol0=Goo00<007ooOol0
BWoo00<007ooOol0<Woo00D007ooOomoo`00009oo`03001oogoo04Ioo`00L7oo00@007ooOol000Yo
o`03001oogoo03Yoo`04001oogoo0009Ool2000aOol00`00Oomoo`0fOol00`00Oomoo`17Ool2000e
Ool01@00Oomoogoo00000Woo00<007ooOol0AWoo001`Ool01000Oomoo`0027oo00@007ooOol003]o
o`04001oogoo0009Ool00`00Oomoo`0`Ool00`00Oomoo`0dOol01000Oomoo`00B7oo00<007ooOol0
=7oo00D007ooOomoo`00009oo`03001oogoo04Ioo`00LGoo0P002Woo0P00?Goo0P002Woo0`00;goo
0P00=goo0P00BGoo0`00<goo0P0017oo0P00BGoo003oOoooOol7Ool00?mooomoo`Moo`00ogooogoo
1goo003oOoooOol7Ool00?mooomoo`Moo`00ogooogoo1goo003oOoooOol7Ool0071oool0058004Ao
o`00GGoo0`000Woo0P0017oo0P001Woo00<007ooOol01Goo00<007ooOol07Woo00D007ooOomooekg
01=oo`03001oogoo00moo`03001oogoo00Ioo`03G_Moogoo00=oo`03001oogoo00Uoo`03001oogoo
00Qoo`03001oogoo00Moo`03001oogoo00Eoo`03001oogoo02eoo`03G_Moogoo00Ioo`03001oogoo
01ioo`03001oogoo009oo`03G_Moogoo011oo`03001oogoo00moo`03001oogoo00Moo`03G_Moogoo
009oo`03001oogoo00Yoo`03001oogoo00Qoo`03001oogoo00Ioo`03001oogoo00Ioo`03001oogoo
00Eoo`03001oogoo049oo`00GWoo00@007ooOol0009oo`04001oogoo0002Ool00`00Oomoo`03Ool0
0`00Oomoo`05Ool00`00Oomoo`0ROol00ekgOomoo`0SOol00`00Oomoo`06Ool00ekgOomoo`0/Ool0
0`00Oomoo`0]Ool:000UOol00ekgOomoo`0ROol00`00Oomoo`07Ool00ekgOomoo`0/Ool00`00Oomo
o`05Ool00`00Oomoo`12Ool005]oo`D00005Ool007ooOol00002Ool01000Oomoo`001Goo0`00/Ekg
1`002Ukg3@00O5kg0`00A7oo001EOol40002Ool01000Oomoo`000Woo00@007ooOol0009oo`04001o
ogoo0005Ool00`00Oomoo`0ZOol00ekgOomoo`0/Ool00ekgOomoo`0/Ool00ekgOomoo`0SOol40006
Ool00ekgOomoo`0DOol9000?Ool00ekgOomoo`0/Ool00ekgOomoo`0/Ool00ekgOomoo`05Ool00`00
Oomoo`12Ool005aoo`03001oo`00009oo`04001oogoo0002Ool01000Oomoo`001Goo00<007ooOol0
:Woo00=NmgooOol0;7oo00=NmgooOol0;7oo00=NmgooOol08Woo0P002Goo00=NmgooOol077oo2000
27oo00=NmgooOol0;7oo00=NmgooOol0;7oo00=NmgooOol01Goo00<007ooOol0@Woo001MOol20003
Ool20004Ool20006Ool00`00Oomoo`0ZOol00ekgOomoo`0/Ool00ekgOomoo`0/Ool00ekgOomoo`0Q
Ool00`00Oomoo`09Ool00ekgOomoo`0SOol800000gooG_Moo`0]Ool00ekgOomoo`0/Ool00ekgOomo
o`05Ool00`00Oomoo`12Ool0071oo`8002]oo`03G_Moogoo02aoo`03G_Moogoo02aoo`03G_Moogoo
021oo`03001oogoo00Yoo`03G_Moogoo02Yoo`L002Yoo`03G_Moogoo02aoo`03G_Moogoo00Aoo`80
04Aoo`00L7oo00<007ooOol0:Woo00=NmgooOol0;7oo00=NmgooOol0;7oo00=NmgooOol07goo00<0
07ooOol02goo00=NmgooOol0;7oo00ANmgooOomoo`L002Aoo`03G_Moogoo02aoo`03G_Moogoo00Eo
o`03001oogoo049oo`00L7oo00<007ooOol0:Woo00=NmgooOol0;7oo00=NmgooOol0;7oo00=Nmgoo
Ool07goo00<007ooOol02goo00=NmgooOol0;7oo00=NmgooOol01goo1`007Woo00=NmgooOol0;7oo
00=NmgooOol01Goo00<007ooOol0@Woo001`Ool2000[Ool00ekgOomoo`0/Ool00ekgOomoo`0/Ool0
0ekgOomoo`0NOol00`00Oomoo`0<Ool00ekgOomoo`0/Ool00ekgOomoo`0=Ool6000IOol00ekgOomo
o`0/Ool00ekgOomoo`04Ool20014Ool0071oo`03001oogoo02Yoo`03G_Moogoo02aoo`03G_Moogoo
02aoo`03G_Moogoo01ioo`03001oogoo00aoo`03G_Moogoo02aoo`03G_Moogoo019oo`L001=oo`03
G_Moogoo02aoo`03G_Moogoo00Eoo`03001oogoo049oo`00L7oo00<007ooOol0:Woo00=NmgooOol0
;7oo00=NmgooOol0;7oo00=NmgooOol07Goo00<007ooOol03Goo00=NmgooOol0;7oo00=NmgooOol0
67oo1P003Woo00=NmgooOol0;7oo00=NmgooOol01Goo00<007ooOol0@Woo001`Ool2000[Ool00ekg
Oomoo`0/Ool00ekgOomoo`0/Ool00ekgOomoo`0MOol00`00Oomoo`0=Ool00ekgOomoo`0/Ool00ekg
Oomoo`0MOol60009Ool00ekgOomoo`0/Ool00ekgOomoo`04Ool20014Ool0071oo`03001oogoo02Yo
o`03G_Moogoo02aoo`03G_Moogoo02aoo`03G_Moogoo01eoo`03001oogoo00eoo`03G_Moogoo02ao
o`03G_Moogoo029oo`H000Aoo`03G_Moogoo02aoo`03G_Moogoo00Eoo`03001oogoo049oo`00L7oo
00<007ooOol0:Woo00=NmgooOol0;7oo00=NmgooOol0;7oo00=NmgooOol077oo00<007ooOol03Woo
00=NmgooOol0;7oo00=NmgooOol09goo1P00;Woo00=NmgooOol01Goo00<007ooOol0@Woo001`Ool0
0`00Oomoo`0ZOol00ekgOomoo`0/Ool00ekgOomoo`0/Ool00ekgOomoo`0LOol00`00Oomoo`0>Ool0
0ekgOomoo`0/Ool00ekgOomoo`0/Ool6000YOol00ekgOomoo`05Ool00`00Oomoo`12Ool0071oo`80
02]oo`03G_Moogoo02aoo`03G_Moogoo02aoo`03G_Moogoo01aoo`03001oogoo00ioo`03G_Moogoo
02aoo`03G_Moogoo02aoo`03G_Moogoo009oo`H002Aoo`03G_Moogoo00Aoo`8004Aoo`00G7oo0P00
17oo0P0017oo0P001Woo00<007ooOol0:Woo00=NmgooOol0;7oo00=NmgooOol0;7oo00=NmgooOol0
77oo00<007ooOol03Woo00=NmgooOol0;7oo00=NmgooOol0;7oo00=NmgooOol01goo1P007goo00=N
mgooOol01Goo00<007ooOol0@Woo001KOol01000Oomoo`000Woo00@007ooOol0009oo`04001oogoo
0005Ool00`00Oomoo`0ZOol00ekgOomoo`0/Ool00ekgOomoo`0/Ool00ekgOomoo`0LOol00`00Oomo
o`0>Ool00ekgOomoo`0/Ool00ekgOomoo`0/Ool00ekgOomoo`0<Ool5000KOol00ekgOomoo`05Ool0
0`00Oomoo`12Ool005eoo`03001oogoo00Aoo`04001oogoo0002Ool00`00Oomoo`03Ool3002VG_L0
0`00G_MNm`21G_L5000LG_L30014Ool005Eoo`@000Eoo`04001oogooOol20003Ool01000Oomoo`00
1Goo00<007ooOol0:Woo00=NmgooOol0;7oo00=NmgooOol0;7oo00=NmgooOol06goo00<007ooOol0
3goo00=NmgooOol0;7oo00=NmgooOol0;7oo00=NmgooOol05Goo1P004Goo00=NmgooOol01Goo00<0
07ooOol0@Woo001KOol01000Oomoo`000goo00<007ooOol00Woo00@007ooOol000Eoo`03001oogoo
02Yoo`03G_Moogoo02aoo`03G_Moogoo02aoo`03G_Moogoo01]oo`03001oogoo00moo`03G_Moogoo
02aoo`03G_Moogoo02aoo`03G_Moogoo01Yoo`H000aoo`03G_Moogoo00Eoo`03001oogoo049oo`00
G7oo0P0017oo0`000goo0P001Woo00<007ooOol0:Woo00=NmgooOol0;7oo00=NmgooOol0;7oo00=N
mgooOol06Woo00<007ooOol047oo00=NmgooOol0;7oo00=NmgooOol0;7oo00=NmgooOol07goo1P00
1goo00=NmgooOol01Goo00<007ooOol0@Woo001`Ool2000[Ool00ekgOomoo`0/Ool00ekgOomoo`0/
Ool00ekgOomoo`0JOol00`00Oomoo`0@Ool00ekgOomoo`0/Ool00ekgOomoo`0/Ool00ekgOomoo`0T
Ool60002Ool00ekgOomoo`04Ool20014Ool0071oo`03001oogoo02Yoo`03G_Moogoo02aoo`03G_Mo
ogoo02aoo`03G_Moogoo01Yoo`03001oogoo011oo`03G_Moogoo02aoo`03G_Moogoo02aoo`03G_Mo
ogoo02Uoo`@000Moo`03001oogoo049oo`00L7oo00<007ooOol0:Woo00=NmgooOol0;7oo00=Nmgoo
Ool0;7oo00=NmgooOol06Woo00<007ooOol047oo00=NmgooOol0;7oo00=NmgooOol0;7oo00=Nmgoo
Ool0;7oo00=NmgooOol01Goo00<007ooOol0@Woo001`Ool2000[Ool00ekgOomoo`0/Ool00ekgOomo
o`0/Ool00ekgOomoo`0JOol00`00Oomoo`0@Ool00ekgOomoo`0/Ool00ekgOomoo`0/Ool00ekgOomo
o`0/Ool00ekgOomoo`04Ool20014Ool0071oo`03001oogoo02Yoo`03G_Moogoo02aoo`03G_Moogoo
02aoo`03G_Moogoo01Yoo`03001oogoo011oo`03G_Moogoo02aoo`03G_Moogoo02aoo`03G_Moogoo
02aoo`03G_Moogoo00Eoo`03001oogoo049oo`00L7oo00<007ooOol0:Woo00=NmgooOol0;7oo00=N
mgooOol0;7oo00=NmgooOol06Woo00<007ooOol047oo00=NmgooOol0;7oo00=NmgooOol0;7oo00=N
mgooOol0;7oo00=NmgooOol01Goo00<007ooOol0@Woo001`Ool2000[Ool00ekgOomoo`0/Ool00ekg
Oomoo`0/Ool00ekgOomoo`0IOol00`00Oomoo`0AOol00ekgOomoo`0/Ool00ekgOomoo`0/Ool00ekg
Oomoo`0/Ool00ekgOomoo`04Ool20014Ool0071oo`03001oogoo02Yoo`03G_Moogoo02aoo`03G_Mo
ogoo02aoo`03G_Moogoo01Uoo`03001oogoo015oo`03G_Moogoo02aoo`03G_Moogoo02aoo`03G_Mo
ogoo02aoo`03G_Moogoo00Eoo`03001oogoo049oo`00L7oo00<007ooOol0:Woo00=NmgooOol0;7oo
00=NmgooOol0;7oo00=NmgooOol06Goo00<007ooOol04Goo00=NmgooOol0;7oo00=NmgooOol0;7oo
00=NmgooOol0;7oo00=NmgooOol01Goo00<007ooOol0@Woo001`Ool00`00Oomoo`0ZOol00ekgOomo
o`0/Ool00ekgOomoo`0/Ool00ekgOomoo`0IOol00`00Oomoo`0AOol00ekgOomoo`0/Ool00ekgOomo
o`0/Ool00ekgOomoo`0/Ool00ekgOomoo`05Ool00`00Oomoo`12Ool0071oo`8002]oo`03G_Moogoo
02aoo`03G_Moogoo02aoo`03G_Moogoo01Uoo`03001oogoo015oo`03G_Moogoo02aoo`03G_Moogoo
02aoo`03G_Moogoo02aoo`03G_Moogoo00Aoo`8004Aoo`00G7oo0P0017oo0P0017oo0P001Woo00<0
07ooOol0:Woo00=NmgooOol0;7oo00=NmgooOol0;7oo00=NmgooOol06Goo00<007ooOol04Goo00=N
mgooOol0;7oo00=NmgooOol0;7oo00=NmgooOol0;7oo00=NmgooOol01Goo00<007ooOol0@Woo001K
Ool01000Oomoo`000Woo00@007ooOol0009oo`04001oogoo0005Ool00`00Oomoo`0ZOol00ekgOomo
o`0/Ool00ekgOomoo`0/Ool00ekgOomoo`0IOol00`00Oomoo`0AOol00ekgOomoo`0/Ool00ekgOomo
o`0/Ool00ekgOomoo`0/Ool00ekgOomoo`05Ool00`00Oomoo`12Ool005eoo`05001oogooOol00002
Ool01000Oomoo`000Woo00<007ooOol00goo0`00Y5kg00<005kgG_L0Y5kg0`00A7oo001EOol40005
Ool01000Oomoo`000Woo00@007ooOol0009oo`03001oogoo00=oo`03001oogoo02Yoo`03G_Moogoo
02aoo`03G_Moogoo02aoo`03G_Moogoo01Qoo`03001oogoo019oo`03G_Moogoo02aoo`03G_Moogoo
02aoo`03G_Moogoo02aoo`03G_Moogoo00Eoo`03001oogoo049oo`00Fgoo00@007ooOol0009oo`04
001oogoo0002Ool01000Oomoo`001Goo00<007ooOol0:Woo00=NmgooOol0;7oo00=NmgooOol0;7oo
00=NmgooOol067oo00<007ooOol04Woo00=NmgooOol0;7oo00=NmgooOol0;7oo00=NmgooOol0;7oo
00=NmgooOol01Goo00<007ooOol0@Woo001LOol20004Ool20004Ool20006Ool2000[Ool00ekgOomo
o`0/Ool00ekgOomoo`0/Ool00ekgOomoo`0HOol00`00Oomoo`0BOol00ekgOomoo`0/Ool00ekgOomo
o`0/Ool00ekgOomoo`0/Ool00ekgOomoo`04Ool20014Ool0071oo`03001oogoo02Yoo`03G_Moogoo
02aoo`03G_Moogoo02aoo`03G_Moogoo01Qoo`03001oogoo019oo`03G_Moogoo02aoo`03G_Moogoo
02aoo`03G_Moogoo02aoo`03G_Moogoo00Eoo`03001oogoo049oo`00L7oo00<007ooOol0:Woo00=N
mgooOol0;7oo00=NmgooOol0;7oo00=NmgooOol067oo00<007ooOol04Woo00=NmgooOol0;7oo00=N
mgooOol0;7oo00=NmgooOol0;7oo00=NmgooOol01Goo00<007ooOol0@Woo001`Ool00`00Oomoo`0Z
Ool00ekgOomoo`0/Ool00ekgOomoo`0/Ool00ekgOomoo`0GOol00`00Oomoo`0COol00ekgOomoo`0/
Ool00ekgOomoo`0/Ool00ekgOomoo`0/Ool00ekgOomoo`05Ool00`00Oomoo`12Ool0071oo`8002]o
o`03G_Moogoo02aoo`03G_Moogoo02aoo`03G_Moogoo01Moo`03001oogoo01=oo`03G_Moogoo02ao
o`03G_Moogoo02aoo`03G_Moogoo02aoo`03G_Moogoo00Aoo`8004Aoo`00L7oo00<007ooOol0:Woo
00=NmgooOol0;7oo00=NmgooOol0;7oo00=NmgooOol05Woo00<007ooOol057oo00=NmgooOol0;7oo
00=NmgooOol0;7oo00=NmgooOol0;7oo00=NmgooOol01Goo00<007ooOol0@Woo001`Ool00`00Oomo
o`0ZOol00ekgOomoo`0/Ool00ekgOomoo`0/Ool00ekgOomoo`0FOol00`00Oomoo`0DOol00ekgOomo
o`0/Ool00ekgOomoo`0/Ool00ekgOomoo`0/Ool00ekgOomoo`05Ool00`00Oomoo`12Ool0071oo`80
02]oo`03G_Moogoo02aoo`03G_Moogoo02aoo`03G_Moogoo01Ioo`03001oogoo01Aoo`03G_Moogoo
02aoo`03G_Moogoo02aoo`03G_Moogoo02aoo`03G_Moogoo00Aoo`8004Aoo`00L7oo00<007ooOol0
:Woo00=NmgooOol0;7oo00=NmgooOol0;7oo00=NmgooOol05Goo00<007ooOol05Goo00=NmgooOol0
;7oo00=NmgooOol0;7oo00=NmgooOol0;7oo00=NmgooOol01Goo00<007ooOol0@Woo001`Ool00`00
Oomoo`0ZOol00ekgOomoo`0/Ool00ekgOomoo`0/Ool00ekgOomoo`0EOol00`00Oomoo`0EOol00ekg
Oomoo`0/Ool00ekgOomoo`0/Ool00ekgOomoo`0/Ool00ekgOomoo`05Ool00`00Oomoo`12Ool0071o
o`8002]oo`03G_Moogoo02aoo`03G_Moogoo02aoo`03G_Moogoo01Aoo`03001oogoo01Ioo`03G_Mo
ogoo02aoo`03G_Moogoo02aoo`03G_Moogoo02aoo`03G_Moogoo00Aoo`8004Aoo`00L7oo00<007oo
Ool0:Woo00=NmgooOol0;7oo00=NmgooOol0;7oo00=NmgooOol04goo00<007ooOol05goo00=Nmgoo
Ool0;7oo00=NmgooOol0;7oo00=NmgooOol0;7oo00=NmgooOol01Goo00<007ooOol0@Woo0014Ool3
000DOol40003Ool20004Ool20006Ool00`00Oomoo`0ZOol00ekgOomoo`0/Ool00ekgOomoo`0/Ool0
0ekgOomoo`0BOol2000IOol00ekgOomoo`0/Ool00ekgOomoo`0/Ool00ekgOomoo`0/Ool00ekgOomo
o`05Ool00`00Oomoo`12Ool004Moo`03001oogoo015oo`03001oogoo00=oo`04001oogoo0002Ool0
1000Oomoo`001Goo00<007ooOol0:Woo00=NmgooOol0;7oo00=NmgooOol0;7oo00=NmgooOol04Goo
0P006Woo00=NmgooOol0;7oo00=NmgooOol0;7oo00=NmgooOol0;7oo00=NmgooOol01Goo00<007oo
Ool0@Woo000iOol40002Ool30003Ool3000DOol00`00Oomoo`05Ool01000Oomoo`000Woo00<007oo
Ool00goo0`00Vekg00<005kgG_L0[Ekg0`00A7oo000hOol01000Oomoo`000Woo00<007ooOol00goo
00@007ooOol000eoo`@000Aoo`03001oogoo009oo`8000=oo`04001oogoo0005Ool00`00Oomoo`0Z
Ool00ekgOomoo`0/Ool00ekgOomoo`0/Ool00ekgOomoo`0>Ool2000MOol00ekgOomoo`0/Ool00ekg
Oomoo`0/Ool00ekgOomoo`0/Ool00ekgOomoo`05Ool00`00Oomoo`12Ool003Qoo`04001oogoo0002
Ool40002Ool01000Oomoo`004goo00@007ooOol000=oo`03001oogoo009oo`04001oogoo0005Ool0
0`00Oomoo`0ZOol00ekgOomoo`0/Ool00ekgOomoo`0/Ool00ekgOomoo`0<Ool2000OOol00ekgOomo
o`0/Ool00ekgOomoo`0/Ool00ekgOomoo`0/Ool00ekgOomoo`05Ool00`00Oomoo`12Ool003Uoo`<0
00=oo`8000Aoo`@001=oo`8000Aoo`<000=oo`8000Ioo`8002]oo`03G_Moogoo02aoo`03G_Moogoo
02aoo`03G_Moogoo00Yoo`80025oo`03G_Moogoo02aoo`03G_Moogoo02aoo`03G_Moogoo02aoo`03
G_Moogoo00Aoo`8004Aoo`00>goo00<007ooOol0<Woo00<007ooOol0:Woo00=NmgooOol0;7oo00=N
mgooOol0;7oo00=NmgooOol027oo0`008Woo00=NmgooOol0;7oo00=NmgooOol0;7oo00=NmgooOol0
;7oo00=NmgooOol01Goo00<007ooOol0@Woo000jOol2000dOol00`00Oomoo`0ZOol00ekgOomoo`0/
Ool00ekgOomoo`0/Ool00ekgOomoo`07Ool2000TOol00ekgOomoo`0/Ool00ekgOomoo`0/Ool00ekg
Oomoo`0/Ool00ekgOomoo`05Ool00`00Oomoo`12Ool0071oo`8002]oo`03G_Moogoo02aoo`03G_Mo
ogoo02aoo`03G_Moogoo00Ioo`03001oogoo02Aoo`03G_Moogoo02aoo`03G_Moogoo02aoo`03G_Mo
ogoo02aoo`03G_Moogoo00Aoo`8004Aoo`00L7oo00<007ooOol0:Woo00=NmgooOol0;7oo00=Nmgoo
Ool0;7oo00=NmgooOol01Goo00<007ooOol09Goo00=NmgooOol0;7oo00=NmgooOol0;7oo00=Nmgoo
Ool0;7oo00=NmgooOol01Goo00<007ooOol0@Woo001`Ool00`00Oomoo`0ZOol00ekgOomoo`0/Ool0
0ekgOomoo`0/Ool00ekgOomoo`05Ool00`00Oomoo`0UOol00ekgOomoo`0/Ool00ekgOomoo`0/Ool0
0ekgOomoo`0/Ool00ekgOomoo`05Ool00`00Oomoo`12Ool0071oo`03001oogoo02Yoo`03G_Moogoo
02aoo`03G_Moogoo02aoo`03G_Moogoo00Aoo`03001oogoo02Ioo`03G_Moogoo02aoo`03G_Moogoo
02aoo`03G_Moogoo02aoo`03G_Moogoo00Eoo`03001oogoo049oo`00L7oo0P00:goo00=NmgooOol0
;7oo00=NmgooOol0;7oo00=NmgooOol00goo00<007ooOol09goo00=NmgooOol0;7oo00=NmgooOol0
;7oo00=NmgooOol0;7oo00=NmgooOol017oo0P00A7oo001`Ool00`00Oomoo`0ZOol00ekgOomoo`0/
Ool00ekgOomoo`0/Ool00ekgOomoo`02Ool00`00Oomoo`0XOol00ekgOomoo`0/Ool00ekgOomoo`0/
Ool00ekgOomoo`0/Ool00ekgOomoo`05Ool00`00Oomoo`12Ool0071oo`03001oogoo02Yoo`03G_Mo
ogoo02aoo`03G_Moogoo02aoo`03G_Moogoo009oo`03001oogoo02Qoo`03G_Moogoo02aoo`03G_Mo
ogoo02aoo`03G_Moogoo02aoo`03G_Moogoo00Eoo`03001oogoo049oo`00L7oo0P00:goo00=Nmgoo
Ool0;7oo00=NmgooOol0;7oo00=NmgooOol00Woo00<007ooOol0:7oo00=NmgooOol0;7oo00=Nmgoo
Ool0;7oo00=NmgooOol0;7oo00=NmgooOol017oo0P00A7oo001`Ool00`00Oomoo`0ZOol00ekgOomo
o`0/Ool00ekgOomoo`0/Ool01EkgOomoogoo0000:goo00=NmgooOol0;7oo00=NmgooOol0;7oo00=N
mgooOol0;7oo00=NmgooOol01Goo00<007ooOol0@Woo001KOol40003Ool20004Ool20006Ool00`00
Oomoo`0ZOol00ekgOomoo`0/Ool00ekgOomoo`0/Ool01EkgOomoogoo0000:goo00=NmgooOol0;7oo
00=NmgooOol0;7oo00=NmgooOol0;7oo00=NmgooOol01Goo00<007ooOol0@Woo001KOol00`00Oomo
o`03Ool01000Oomoo`000Woo00@007ooOol000Eoo`03001oogoo02Yoo`03G_Moogoo02aoo`03G_Mo
ogoo02aoo`04G_Moogoo000/Ool00ekgOomoo`0/Ool00ekgOomoo`0/Ool00ekgOomoo`0/Ool00ekg
Oomoo`05Ool00`00Oomoo`12Ool005aoo`03001oogoo009oo`04001oogoo0002Ool01000Oomoo`00
1Goo0`00Rekg00<005kgG_L0_Ekg0`00A7oo001EOol40004Ool01@00Oomoogoo00000Woo00@007oo
Ool0009oo`03001oogoo00=oo`03001oogoo02Yoo`03G_Moogoo02aoo`03G_Moogoo02aoo`04G_Mo
ogoo000/Ool00ekgOomoo`0/Ool00ekgOomoo`0/Ool00ekgOomoo`0/Ool00ekgOomoo`05Ool00`00
Oomoo`12Ool005]oo`04001oogoo0002Ool01000Oomoo`000Woo00@007ooOol000Eoo`03001oogoo
02Yoo`03G_Moogoo02aoo`03G_Moogoo02aoo`03G_Moo`0002eoo`03G_Moogoo02aoo`03G_Moogoo
02aoo`03G_Moogoo02aoo`03G_Moogoo00Eoo`03001oogoo049oo`00G7oo0P0017oo0P0017oo0P00
1Woo0P00:goo00=NmgooOol0;7oo00=NmgooOol0;7oo00=Nmgoo0000;Goo00=NmgooOol0;7oo00=N
mgooOol0;7oo00=NmgooOol0;7oo00=NmgooOol017oo0P00A7oo001`Ool00`00Oomoo`0ZOol00ekg
Oomoo`0/Ool00ekgOomoo`0/Ool00ekgOol0000]Ool00ekgOomoo`0/Ool00ekgOomoo`0/Ool00ekg
Oomoo`0/Ool00ekgOomoo`05Ool00`00Oomoo`12Ool0071oo`03001oogoo02Yoo`03G_Moogoo02ao
o`03G_Moogoo02aoo`03G_Moo`0002eoo`03G_Moogoo02aoo`03G_Moogoo02aoo`03G_Moogoo02ao
o`03G_Moogoo00Eoo`03001oogoo049oo`00L7oo0P00:goo00=NmgooOol0;7oo00=NmgooOol0;7oo
00=Nmgoo0000;Goo00=NmgooOol0;7oo00=NmgooOol0;7oo00=NmgooOol0;7oo00=NmgooOol017oo
0P00A7oo001`Ool00`00Oomoo`0ZOol00ekgOomoo`0/Ool00ekgOomoo`0/Ool00ekgOol0000]Ool0
0ekgOomoo`0/Ool00ekgOomoo`0/Ool00ekgOomoo`0/Ool00ekgOomoo`05Ool00`00Oomoo`12Ool0
071oo`03001oogoo02Yoo`03G_Moogoo02aoo`03G_Moogoo02aoo`03G_L007oo02eoo`03G_Moogoo
02aoo`03G_Moogoo02aoo`03G_Moogoo02aoo`03G_Moogoo00Eoo`03001oogoo049oo`00L7oo00<0
07ooOol0:Woo00=NmgooOol0;7oo00=NmgooOol0;7oo00=Nm`00Ool0;Goo00=NmgooOol0;7oo00=N
mgooOol0;7oo00=NmgooOol0;7oo00=NmgooOol01Goo00<007ooOol0@Woo001`Ool2000[Ool00ekg
Oomoo`0/Ool00ekgOomoo`0/Ool00ekg001oo`0]Ool00ekgOomoo`0/Ool00ekgOomoo`0/Ool00ekg
Oomoo`0/Ool00ekgOomoo`04Ool20014Ool0071oo`03001oogoo02Yoo`03G_Moogoo02aoo`03G_Mo
ogoo02aoo`03G_L007oo02eoo`03G_Moogoo02aoo`03G_Moogoo02aoo`03G_Moogoo02aoo`03G_Mo
ogoo00Eoo`03001oogoo049oo`00L7oo00<007ooOol0:Woo00=NmgooOol0;7oo00=NmgooOol0;7oo
00<007ooOol0;Goo00=NmgooOol0;7oo00=NmgooOol0;7oo00=NmgooOol0;7oo00=NmgooOol01Goo
00<007ooOol0@Woo001`Ool2000[Ool00ekgOomoo`0/Ool00ekgOomoo`0/Ool00`00Oomoo`0]Ool0
0ekgOomoo`0/Ool00ekgOomoo`0/Ool00ekgOomoo`0/Ool00ekgOomoo`04Ool20014Ool005]oo`D0
009oo`8000Aoo`8000Ioo`03001oogoo02Yoo`03G_Moogoo02aoo`03G_Moogoo02aoo`03001oogoo
02eoo`03G_Moogoo02aoo`03G_Moogoo02aoo`03G_Moogoo02aoo`03G_Moogoo00Eoo`03001oogoo
049oo`00GGoo00D007ooOomoo`00009oo`04001oogoo0002Ool00`00Oomoo`03Ool00`00Oomoo`0Z
Ool00ekgOomoo`0/Ool00ekgOomoo`0[Ool00`00G_Moo`0^Ool00ekgOomoo`0/Ool00ekgOomoo`0/
Ool00ekgOomoo`0/Ool00ekgOomoo`05Ool00`00Oomoo`12Ool005eoo`03001oogoo00Aoo`04001o
ogoo0002Ool00`00Oomoo`03Ool30027G_L00`00G_MNm`31G_L30014Ool005Eoo`@000Aoo`03001o
ogoo009oo`8000=oo`04001oogoo0005Ool00`00Oomoo`0ZOol00ekgOomoo`0/Ool00ekgOomoo`0[
Ool00`00G_Moo`0^Ool00ekgOomoo`0/Ool00ekgOomoo`0/Ool00ekgOomoo`0/Ool00ekgOomoo`05
Ool00`00Oomoo`12Ool005eoo`03001oogoo009oo`03001oogoo009oo`04001oogoo0005Ool00`00
Oomoo`0ZOol00ekgOomoo`0/Ool00ekgOomoo`0[Ool00`00G_Moo`0^Ool00ekgOomoo`0/Ool00ekg
Oomoo`0/Ool00ekgOomoo`0/Ool00ekgOomoo`05Ool00`00Oomoo`12Ool005aoo`8000Aoo`<000=o
o`8000Ioo`03001oogoo02Yoo`03G_Moogoo02aoo`03G_Moogoo02Yoo`03001ooekg02moo`03G_Mo
ogoo02aoo`03G_Moogoo02aoo`03G_Moogoo02aoo`03G_Moogoo00Eoo`03001oogoo049oo`00L7oo
0P00:goo00=NmgooOol0;7oo00=NmgooOol0:Woo00<007ooG_L0;goo00=NmgooOol0;7oo00=Nmgoo
Ool0;7oo00=NmgooOol0;7oo00=NmgooOol017oo0P00A7oo001`Ool00`00Oomoo`0ZOol00ekgOomo
o`0/Ool00ekgOomoo`0ZOol00`00OomNm`0_Ool00ekgOomoo`0/Ool00ekgOomoo`0/Ool00ekgOomo
o`0/Ool00ekgOomoo`05Ool00`00Oomoo`12Ool0071oo`03001oogoo02Yoo`03G_Moogoo02aoo`03
G_Moogoo02Uoo`04001oogooG_L_Ool00ekgOomoo`0/Ool00ekgOomoo`0/Ool00ekgOomoo`0/Ool0
0ekgOomoo`05Ool00`00Oomoo`12Ool0071oo`8002]oo`03G_Moogoo02aoo`03G_Moogoo02Uoo`04
001oogooG_L_Ool00ekgOomoo`0/Ool00ekgOomoo`0/Ool00ekgOomoo`0/Ool00ekgOomoo`04Ool2
0014Ool0071oo`03001oogoo02Yoo`03G_Moogoo02aoo`03G_Moogoo02Uoo`04001oogooG_L_Ool0
0ekgOomoo`0/Ool00ekgOomoo`0/Ool00ekgOomoo`0/Ool00ekgOomoo`05Ool00`00Oomoo`12Ool0
071oo`03001oogoo02Yoo`03G_Moogoo02aoo`03G_Moogoo02Uoo`04001oogooG_L_Ool00ekgOomo
o`0/Ool00ekgOomoo`0/Ool00ekgOomoo`0/Ool00ekgOomoo`05Ool00`00Oomoo`12Ool0071oo`80
02]oo`03G_Moogoo02aoo`03G_Moogoo02Qoo`05001oogooOomNm`0_Ool00ekgOomoo`0/Ool00ekg
Oomoo`0/Ool00ekgOomoo`0/Ool00ekgOomoo`04Ool20014Ool0071oo`03001oogoo02Yoo`03G_Mo
ogoo02aoo`03G_Moogoo02Qoo`05001oogooOomNm`0_Ool00ekgOomoo`0/Ool00ekgOomoo`0/Ool0
0ekgOomoo`0/Ool00ekgOomoo`05Ool00`00Oomoo`12Ool0071oo`03001oogoo02Yoo`03G_Moogoo
02aoo`03G_Moogoo02Moo`03001oogoo009oo`03G_Moogoo02eoo`03G_Moogoo02aoo`03G_Moogoo
02aoo`03G_Moogoo02aoo`03G_Moogoo00Eoo`03001oogoo049oo`00L7oo00<007ooOol0:Woo00=N
mgooOol0;7oo00=NmgooOol09goo00<007ooOol00Woo00=NmgooOol0;Goo00=NmgooOol0;7oo00=N
mgooOol0;7oo00=NmgooOol0;7oo00=NmgooOol01Goo00<007ooOol0@Woo001`Ool2000[Ool00ekg
Oomoo`0/Ool00ekgOomoo`0VOol00`00Oomoo`03Ool00ekgOomoo`0]Ool00ekgOomoo`0/Ool00ekg
Oomoo`0/Ool00ekgOomoo`0/Ool00ekgOomoo`04Ool20014Ool005]oo`D0009oo`8000Aoo`8000Io
o`03001oogoo02Yoo`03G_Moogoo02aoo`03G_Moogoo02Eoo`03001oogoo00Aoo`03G_Moogoo02eo
o`03G_Moogoo02aoo`03G_Moogoo02aoo`03G_Moogoo02aoo`03G_Moogoo00Eoo`03001oogoo049o
o`00GGoo00D007ooOomoo`00009oo`04001oogoo0002Ool00`00Oomoo`03Ool00`00Oomoo`0ZOol0
0ekgOomoo`0/Ool00ekgOomoo`0TOol00`00Oomoo`05Ool00ekgOomoo`0]Ool00ekgOomoo`0/Ool0
0ekgOomoo`0/Ool00ekgOomoo`0/Ool00ekgOomoo`05Ool00`00Oomoo`12Ool005eoo`05001oogoo
Ool00002Ool01000Oomoo`000Woo00<007ooOol00goo0`00Oekg00<005kgG_L0bEkg0`00A7oo001E
Ool40004Ool01@00Oomoogoo00000Woo00@007ooOol0009oo`03001oogoo00=oo`03001oogoo02Yo
o`03G_Moogoo02aoo`03G_Moogoo025oo`8000Uoo`03G_Moogoo02eoo`03G_Moogoo02aoo`03G_Mo
ogoo02aoo`03G_Moogoo02aoo`03G_Moogoo00Eoo`03001oogoo049oo`00GGoo00D007ooOomoo`00
009oo`04001oogoo0002Ool00`00Oomoo`03Ool00`00Oomoo`0ZOol00ekgOomoo`0/Ool00ekgOomo
o`0OOol2000;Ool00ekgOomoo`0]Ool00ekgOomoo`0/Ool00ekgOomoo`0/Ool00ekgOomoo`0/Ool0
0ekgOomoo`05Ool00`00Oomoo`12Ool005aoo`8000Aoo`8000Aoo`8000Ioo`8002]oo`03G_Moogoo
02aoo`03G_Moogoo01Yoo`D000eoo`03G_Moogoo02eoo`03G_Moogoo02aoo`03G_Moogoo02aoo`03
G_Moogoo02aoo`03G_Moogoo00Aoo`8004Aoo`00L7oo00<007ooOol01Goo7@0027oo00=NmgooOol0
;7oo00=NmgooOol04Woo20004Woo00=NmgooOol0;Goo00=NmgooOol0;7oo00=NmgooOol0;7oo00=N
mgooOol0;7oo00=NmgooOol01Goo00<007ooOol0@Woo001`Ool00`00Oomoo`0ROom<000JOol00ekg
Oomoo`0]Ool00ekgOomoo`0/Ool00ekgOomoo`0/Ool00ekgOomoo`0/Ool00ekgOomoo`05Ool00`00
Oomoo`12Ool0071oo`03001oogoo00Eoo`03001oogoo01ioo`05001oogooOomNm`0COol00`00Oomo
o`0?Ool00`00Oomoo`06Ool00ekgOomoo`03Ool00`00Oomoo`09Ool00`00Oomoo`08Ool00`00Oomo
o`07Ool00`00Oomoo`05Ool00`00Oomoo`0]Ool00ekgOomoo`06Ool00`00Oomoo`0NOol00`00Oomo
o`02Ool00ekgOomoo`0@Ool00`00Oomoo`0?Ool00`00Oomoo`07Ool00ekgOomoo`02Ool00`00Oomo
o`0:Ool00`00Oomoo`08Ool00`00Oomoo`06Ool00`00Oomoo`06Ool00`00Oomoo`05Ool00`00Oomo
o`12Ool0071oo`8000Ioo`03001oogoo01ioo`05001oogooOomNm`0COol00`00Oomoo`0?Ool00`00
Oomoo`06Ool00ekgOomoo`03Ool00`00Oomoo`09Ool00`00Oomoo`08Ool00`00Oomoo`07Ool00`00
Oomoo`05Ool00`00Oomoo`0]Ool00ekgOomoo`06Ool00`00Oomoo`0NOol00`00Oomoo`02Ool00ekg
Oomoo`0@Ool00`00Oomoo`0?Ool00`00Oomoo`07Ool00ekgOomoo`02Ool00`00Oomoo`0:Ool00`00
Oomoo`08Ool00`00Oomoo`06Ool00`00Oomoo`06Ool00`00Oomoo`04Ool20014Ool0071oool00580
04Aoo`00ogooogoo1goo003oOoooOol7Ool00?mooomoo`Moo`00ogooogoo1goo003oOoooOol7Ool0
0?mooomoo`Moo`00ogooogoo1goo003oOoooOol7Ool0075oo`8000Aoo`8000=oo`@003aoo`8000Ao
o`8000Aoo`8002moo`D003Aoo`@004Qoo`8003=oo`D0009oo`8004Uoo`00L7oo00@007ooOol000Qo
o`03001oogoo03aoo`04001oogoo0008Ool01000Oomoo`00<7oo00<007ooOol0=7oo00<007ooOol0
B7oo00@007ooOol003Aoo`05001oogooOol00002Ool00`00Oomoo`16Ool0071oo`04001oogoo0009
Ool00`00Oomoo`0kOol01000Oomoo`002goo00<007ooOol0;Woo00<007ooOol0=Goo00<007ooOol0
BWoo00<007ooOol0<Woo00D007ooOomoo`00009oo`03001oogoo04Ioo`00L7oo00@007ooOol000Yo
o`03001oogoo03Yoo`04001oogoo0009Ool2000aOol00`00Oomoo`0fOol00`00Oomoo`17Ool2000e
Ool01@00Oomoogoo00000Woo00<007ooOol0AWoo001`Ool01000Oomoo`0027oo00@007ooOol003]o
o`04001oogoo0009Ool00`00Oomoo`0`Ool00`00Oomoo`0dOol01000Oomoo`00B7oo00<007ooOol0
=7oo00D007ooOomoo`00009oo`03001oogoo04Ioo`00LGoo0P002Woo0P00?Goo0P002Woo0`00;goo
0P00=goo0P00BGoo0`00<goo0P0017oo0P00BGoo003oOoooOol7Ool00?mooomoo`Moo`00ogooogoo
1goo003oOoooOol7Ool00?mooomoo`Moo`00ogooogoo1goo003oOol<Ool00`00Oomoo`02Ool01P00
Oomoo`00Ool000=oo`03001oo`000080009oo`@00>5oo`00ogoo37oo00<007ooOol00Woo00D007oo
Ool007oo00D00004Ool007oo0002Ool00`00Oomoo`3ROol00?moo`aoo`<0009oo`04001oogoo0002
Ool00`00Ool00003Ool20002Ool00`00Oomoo`3ROol00?moo`aoo`05001oogoo001oo`040002Ool0
0`00Ool00002Ool20003Ool4003QOol00?moo`aoo`06001oogoo001oo`000Woo00H007ooOol007oo
0002Ool00`00Ool00002Ool00`00Oomoo`3ROol00?moo`aoo`@00005Ool007ooOol00003Ool01000
Oomoogoo0`000Woo1000hGoo003oOoooOol7Ool00?mooomoo`Moo`00\
\>"],
  ImageRangeCache->{{{0, 516.125}, {171.375, 0}} -> {-1.33799, -501.935, \
0.00531039, 2.97778}},
  CellTags->{"Bode plot", "i:9", "b:20.1"}]
}, Open  ]],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{
        TagBox[\(\[SkeletonIndicator]  Graphics  \[SkeletonIndicator]\),
          False,
          Editable->False], ",", 
        TagBox[\(\[SkeletonIndicator]  Graphics  \[SkeletonIndicator]\),
          False,
          Editable->False]}], "}"}]], "Output",
  CellLabel->"Out[129]=",
  CellTags->{"Bode plot", "i:9", "b:20.1"}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Nyquist Plot", "Subsection",
  Evaluatable->False,
  AspectRatioFixed->True,
  CellTags->{"Nyquist Plot", "i:10", "b:20.2"}],

Cell["\<\
The Nyquist plot of G over the frequency range -20 to +20 radians per second \
is obtained from:\
\>", "Text",
  Evaluatable->False,
  AspectRatioFixed->True,
  CellTags->{"Nyquist Plot", "i:10", "b:20.2"}],

Cell[BoxData[
    \(G[s_] := \(\((s + 10)\)\ \((s + 4)\)\)\/\(\((s + 5)\)\ \((s\^2 + 2\ s + \
2)\)\ \((s\^2 + 1\ s + 1)\)\)\)], "Input",
  CellLabel->"In[130]:=",
  PageWidth->Infinity,
  AspectRatioFixed->True,
  CellTags->{"Nyquist Plot", "i:10", "b:20.2"}],

Cell[CellGroupData[{

Cell[BoxData[
    \(Nyquist[G, s, \(-20\), \(+20\)]\)], "Input",
  CellLabel->"In[131]:=",
  PageWidth->Infinity,
  AspectRatioFixed->True,
  CellTags->{"Nyquist Plot", "i:10", "b:20.2"}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.433906 0.135597 0.308889 0.0651981 [
[.02711 -0.0125 -6 -9 ]
[.02711 -0.0125 6 0 ]
[.16271 -0.0125 -6 -9 ]
[.16271 -0.0125 6 0 ]
[.29831 -0.0125 -6 -9 ]
[.29831 -0.0125 6 0 ]
[.43391 -0.0125 -3 -9 ]
[.43391 -0.0125 3 0 ]
[.5695 -0.0125 -3 -9 ]
[.5695 -0.0125 3 0 ]
[.7051 -0.0125 -3 -9 ]
[.7051 -0.0125 3 0 ]
[.8407 -0.0125 -3 -9 ]
[.8407 -0.0125 3 0 ]
[.9763 -0.0125 -3 -9 ]
[.9763 -0.0125 3 0 ]
[ 0 0 -0.125 0 ]
[.5 -0.0125 -17.3125 -22.1875 ]
[.5 -0.0125 17.3125 -9 ]
[-0.0125 .0481 -12 -4.5 ]
[-0.0125 .0481 0 4.5 ]
[-0.0125 .17849 -12 -4.5 ]
[-0.0125 .17849 0 4.5 ]
[-0.0125 .30889 -6 -4.5 ]
[-0.0125 .30889 0 4.5 ]
[-0.0125 .43928 -6 -4.5 ]
[-0.0125 .43928 0 4.5 ]
[-0.0125 .56968 -6 -4.5 ]
[-0.0125 .56968 0 4.5 ]
[ 0 0 -0.125 0 ]
[-0.01875 .30902 -46.625 -6.59375 ]
[-0.01875 .30902 -12 6.59375 ]
[ 0 .61803 .125 0 ]
[.5 .63053 -5.0625 0 ]
[.5 .63053 5.0625 13.1875 ]
[ 1 0 .125 0 ]
[1.0125 .30902 0 -6.59375 ]
[1.0125 .30902 10.125 6.59375 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 .5 r
.25 Mabswid
[ ] 0 setdash
.16271 0 m
.16271 .61803 L
s
.29831 0 m
.29831 .61803 L
s
.43391 0 m
.43391 .61803 L
s
.5695 0 m
.5695 .61803 L
s
.7051 0 m
.7051 .61803 L
s
.8407 0 m
.8407 .61803 L
s
0 .0481 m
1 .0481 L
s
0 .17849 m
1 .17849 L
s
0 .30889 m
1 .30889 L
s
0 .43928 m
1 .43928 L
s
0 .56968 m
1 .56968 L
s
0 g
.02711 0 m
.02711 .00625 L
s
[(-3)] .02711 -0.0125 0 1 Mshowa
.16271 0 m
.16271 .00625 L
s
[(-2)] .16271 -0.0125 0 1 Mshowa
.29831 0 m
.29831 .00625 L
s
[(-1)] .29831 -0.0125 0 1 Mshowa
.43391 0 m
.43391 .00625 L
s
[(0)] .43391 -0.0125 0 1 Mshowa
.5695 0 m
.5695 .00625 L
s
[(1)] .5695 -0.0125 0 1 Mshowa
.7051 0 m
.7051 .00625 L
s
[(2)] .7051 -0.0125 0 1 Mshowa
.8407 0 m
.8407 .00625 L
s
[(3)] .8407 -0.0125 0 1 Mshowa
.9763 0 m
.9763 .00625 L
s
[(4)] .9763 -0.0125 0 1 Mshowa
.125 Mabswid
.05423 0 m
.05423 .00375 L
s
.08135 0 m
.08135 .00375 L
s
.10847 0 m
.10847 .00375 L
s
.13559 0 m
.13559 .00375 L
s
.18983 0 m
.18983 .00375 L
s
.21695 0 m
.21695 .00375 L
s
.24407 0 m
.24407 .00375 L
s
.27119 0 m
.27119 .00375 L
s
.32543 0 m
.32543 .00375 L
s
.35255 0 m
.35255 .00375 L
s
.37967 0 m
.37967 .00375 L
s
.40679 0 m
.40679 .00375 L
s
.46103 0 m
.46103 .00375 L
s
.48815 0 m
.48815 .00375 L
s
.51526 0 m
.51526 .00375 L
s
.54238 0 m
.54238 .00375 L
s
.59662 0 m
.59662 .00375 L
s
.62374 0 m
.62374 .00375 L
s
.65086 0 m
.65086 .00375 L
s
.67798 0 m
.67798 .00375 L
s
.73222 0 m
.73222 .00375 L
s
.75934 0 m
.75934 .00375 L
s
.78646 0 m
.78646 .00375 L
s
.81358 0 m
.81358 .00375 L
s
.86782 0 m
.86782 .00375 L
s
.89494 0 m
.89494 .00375 L
s
.92206 0 m
.92206 .00375 L
s
.94918 0 m
.94918 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
gsave
.5 -0.0125 -78.3125 -26.1875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 21.1875 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(Re) show
%%IncludeResource: font Mathematica2Mono
%%IncludeFont: Mathematica2Mono
/Mathematica2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
75.250 13.313 moveto
(@) show
81.375 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
%%IncludeResource: font Mathematica2Mono
%%IncludeFont: Mathematica2Mono
/Mathematica2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
87.500 13.313 moveto
(D) show
93.625 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 .0481 m
.00625 .0481 L
s
[(-4)] -0.0125 .0481 1 0 Mshowa
0 .17849 m
.00625 .17849 L
s
[(-2)] -0.0125 .17849 1 0 Mshowa
0 .30889 m
.00625 .30889 L
s
[(0)] -0.0125 .30889 1 0 Mshowa
0 .43928 m
.00625 .43928 L
s
[(2)] -0.0125 .43928 1 0 Mshowa
0 .56968 m
.00625 .56968 L
s
[(4)] -0.0125 .56968 1 0 Mshowa
.125 Mabswid
0 .0807 m
.00375 .0807 L
s
0 .11329 m
.00375 .11329 L
s
0 .14589 m
.00375 .14589 L
s
0 .21109 m
.00375 .21109 L
s
0 .24369 m
.00375 .24369 L
s
0 .27629 m
.00375 .27629 L
s
0 .34149 m
.00375 .34149 L
s
0 .37409 m
.00375 .37409 L
s
0 .40669 m
.00375 .40669 L
s
0 .47188 m
.00375 .47188 L
s
0 .50448 m
.00375 .50448 L
s
0 .53708 m
.00375 .53708 L
s
0 .0155 m
.00375 .0155 L
s
0 .60228 m
.00375 .60228 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
gsave
-0.01875 .30902 -107.625 -10.5938 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 21.1875 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(Im) show
%%IncludeResource: font Mathematica2Mono
%%IncludeFont: Mathematica2Mono
/Mathematica2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
75.250 13.313 moveto
(@) show
81.375 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
%%IncludeResource: font Mathematica2Mono
%%IncludeFont: Mathematica2Mono
/Mathematica2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
87.500 13.313 moveto
(D) show
93.625 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02711 .61178 m
.02711 .61803 L
s
.16271 .61178 m
.16271 .61803 L
s
.29831 .61178 m
.29831 .61803 L
s
.43391 .61178 m
.43391 .61803 L
s
.5695 .61178 m
.5695 .61803 L
s
.7051 .61178 m
.7051 .61803 L
s
.8407 .61178 m
.8407 .61803 L
s
.9763 .61178 m
.9763 .61803 L
s
.125 Mabswid
.05423 .61428 m
.05423 .61803 L
s
.08135 .61428 m
.08135 .61803 L
s
.10847 .61428 m
.10847 .61803 L
s
.13559 .61428 m
.13559 .61803 L
s
.18983 .61428 m
.18983 .61803 L
s
.21695 .61428 m
.21695 .61803 L
s
.24407 .61428 m
.24407 .61803 L
s
.27119 .61428 m
.27119 .61803 L
s
.32543 .61428 m
.32543 .61803 L
s
.35255 .61428 m
.35255 .61803 L
s
.37967 .61428 m
.37967 .61803 L
s
.40679 .61428 m
.40679 .61803 L
s
.46103 .61428 m
.46103 .61803 L
s
.48815 .61428 m
.48815 .61803 L
s
.51526 .61428 m
.51526 .61803 L
s
.54238 .61428 m
.54238 .61803 L
s
.59662 .61428 m
.59662 .61803 L
s
.62374 .61428 m
.62374 .61803 L
s
.65086 .61428 m
.65086 .61803 L
s
.67798 .61428 m
.67798 .61803 L
s
.73222 .61428 m
.73222 .61803 L
s
.75934 .61428 m
.75934 .61803 L
s
.78646 .61428 m
.78646 .61803 L
s
.81358 .61428 m
.81358 .61803 L
s
.86782 .61428 m
.86782 .61803 L
s
.89494 .61428 m
.89494 .61803 L
s
.92206 .61428 m
.92206 .61803 L
s
.94918 .61428 m
.94918 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
gsave
.5 .63053 -66.0625 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 21.1875 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.125 13.313 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.99375 .0481 m
1 .0481 L
s
.99375 .17849 m
1 .17849 L
s
.99375 .30889 m
1 .30889 L
s
.99375 .43928 m
1 .43928 L
s
.99375 .56968 m
1 .56968 L
s
.125 Mabswid
.99625 .0807 m
1 .0807 L
s
.99625 .11329 m
1 .11329 L
s
.99625 .14589 m
1 .14589 L
s
.99625 .21109 m
1 .21109 L
s
.99625 .24369 m
1 .24369 L
s
.99625 .27629 m
1 .27629 L
s
.99625 .34149 m
1 .34149 L
s
.99625 .37409 m
1 .37409 L
s
.99625 .40669 m
1 .40669 L
s
.99625 .47188 m
1 .47188 L
s
.99625 .50448 m
1 .50448 L
s
.99625 .53708 m
1 .53708 L
s
.99625 .0155 m
1 .0155 L
s
.99625 .60228 m
1 .60228 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
gsave
1.0125 .30902 -61 -10.5938 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 21.1875 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.125 13.313 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 .30889 m
1 .30889 L
s
.43391 0 m
.43391 .61803 L
s
0 0 0 r
.5 Mabswid
.43391 .30888 m
.43391 .30888 L
.43392 .30887 L
.43392 .30887 L
.43393 .30886 L
.43395 .30884 L
.43398 .30881 L
.43405 .30873 L
.43424 .30853 L
.43441 .30833 L
.43475 .30787 L
.43499 .30749 L
.43531 .30683 L
.43551 .30629 L
.43569 .30563 L
.43577 .30523 L
.4358 .30499 L
.43583 .30473 L
.43586 .30447 L
.43587 .30422 L
.43588 .3039 L
.43587 .30358 L
.43585 .30326 L
.43582 .30288 L
.43577 .3025 L
.43571 .30212 L
.43561 .30164 L
.43546 .30107 L
.43507 .2999 L
.43441 .29843 L
.43332 .29656 L
.43189 .29462 L
.42964 .29213 L
.42665 .28942 L
.42282 .28652 L
.41067 .27959 L
.40048 .27525 L
.38489 .27016 L
.37475 .26756 L
.36183 .26489 L
.34736 .26262 L
.33202 .26092 L
.31348 .25971 L
.29361 .25937 L
.26884 .2602 L
.23867 .26305 L
.22223 .26546 L
.20338 .26898 L
.16702 .27827 L
.13022 .29166 L
Mistroke
.09661 .30864 L
.06529 .33114 L
.04155 .35729 L
.02773 .38473 L
.02381 .41791 L
.03598 .45692 L
.07026 .49843 L
.1174 .53152 L
.1861 .56249 L
.23121 .57661 L
.284 .58876 L
.38556 .60174 L
.48491 .60332 L
.57177 .5962 L
.6564 .58113 L
.69948 .56993 L
.73635 .55812 L
.80035 .53157 L
.85494 .50058 L
.89001 .47434 L
.91976 .44557 L
.94279 .41584 L
.95807 .38867 L
.96788 .36349 L
.97343 .34091 L
.97619 .31503 L
.97537 .29067 L
.97139 .26709 L
.96341 .24154 L
.95194 .21709 L
.93765 .19446 L
.91552 .1676 L
.88357 .13812 L
.84449 .11049 L
.79933 .08571 L
.74304 .06205 L
.68032 .04254 L
.60068 .02576 L
.55134 .01917 L
.50369 .01532 L
.40915 .01472 L
.35468 .01869 L
.30462 .02536 L
.20952 .04747 L
.16226 .06449 L
.12438 .0824 L
.07279 .11713 L
.03827 .15687 L
.02502 .19084 L
.02581 .22613 L
Mistroke
.04107 .25979 L
.06917 .28995 L
.10227 .3124 L
.13501 .32813 L
.168 .33981 L
.19761 .34755 L
.2281 .35325 L
.2577 .35676 L
.28292 .35822 L
.30397 .35835 L
.32073 .3577 L
.33673 .35641 L
.35265 .3544 L
.36509 .35227 L
.38698 .34702 L
.4014 .34217 L
.41126 .33791 L
.42458 .32999 L
.42875 .32651 L
.43132 .32384 L
.43289 .32184 L
.43405 .32001 L
.43488 .31834 L
.43536 .31705 L
.43554 .31642 L
.43566 .31589 L
.43575 .31539 L
.43579 .31513 L
.43582 .31489 L
.43586 .31449 L
.43587 .31416 L
.43588 .31383 L
.43587 .31365 L
.43587 .3135 L
.43585 .31323 L
.43583 .31298 L
.4358 .31278 L
.43577 .31258 L
.43569 .31216 L
.43561 .31183 L
.43529 .31091 L
.43512 .31054 L
.43498 .31028 L
.43472 .30986 L
.43422 .30922 L
.43405 .30904 L
.43398 .30897 L
.43395 .30894 L
.43393 .30892 L
.43392 .30891 L
Mistroke
.43392 .3089 L
.43391 .3089 L
.43391 .3089 L
Mfstroke
0 1 0 r
.29831 .30889 m
.29831 .30889 L
.29831 .30889 L
.29831 .30889 L
.29831 .30889 L
.29831 .30889 L
.29831 .30889 L
.29831 .30889 L
.29831 .30889 L
.29831 .30889 L
.29831 .30889 L
.29831 .30889 L
.29831 .30889 L
.29831 .30889 L
.29831 .30889 L
.29831 .30889 L
.29831 .30889 L
.29831 .30889 L
.29831 .30889 L
.29831 .30889 L
.29831 .30889 L
.29831 .30889 L
.29831 .30889 L
.29831 .30889 L
.29831 .30889 L
s
1 0 0 r
.29831 .30889 m
.29831 .30889 L
.29831 .30889 L
.29831 .30889 L
.29831 .30889 L
.29831 .30889 L
.29831 .30889 L
.29831 .30889 L
.29831 .30889 L
.29831 .30889 L
.29831 .30889 L
.29831 .30889 L
.29831 .30889 L
.29831 .30889 L
.29831 .30889 L
.29831 .30889 L
.29831 .30889 L
.29831 .30889 L
.29831 .30889 L
.29831 .30889 L
.29831 .30889 L
.29831 .30889 L
.29831 .30889 L
.29831 .30889 L
.29831 .30889 L
s
0 0 1 r
.43391 .30889 m
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
Mistroke
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
Mistroke
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
Mistroke
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
Mistroke
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
Mistroke
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
Mistroke
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
Mistroke
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
Mistroke
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
Mistroke
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
Mistroke
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
Mistroke
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
Mistroke
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
Mistroke
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
Mistroke
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
Mistroke
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
Mistroke
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
Mistroke
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
.43391 .30889 L
Mistroke
.43391 .30889 L
Mfstroke
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  CellLabel->"From In[131]:=",
  ImageSize->{288, 177.938},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004P0000/A000`40O003h00Oogoo8Goo003oOolQ
Ool00:9oo`80009oo`<000=oo`80079oo`00XWoo00<007ooOol017oo00D007ooOomoo`00079oo`00
Tgoo0`000Woo00<007ooOol00`0017oo00<007ooOol00Woo0`000goo00<007ooOol0L7oo002DOol0
1000Oomoo`000Woo00<007ooOol01Goo00D007ooOomoo`00009oo`05001oogooOol0001bOol009Ao
o`<000=oo`@000Aoo`05001oogooOol00002Ool01@00Oomoogoo0000LWoo002DOol01000Oomoo`00
0goo0P001Goo00<007ooOol00Woo10000Woo00<007ooOol0L7oo002DOol01000Oomoo`002Woo00<0
07ooOol027oo00<007ooOol0L7oo002COol4000;Ool20008Ool2001bOol00?moob5oo`00ogoo8Goo
003oOolQOol00?moob5oo`00?7oo0P006goo10006Woo1@005Woo0P006goo1@006Goo10006goo0P00
7Goo0`004Woo000kOol01000Oomoo`006Woo00<007ooOol07Goo00<007ooOol05Goo00@007ooOol0
01aoo`03001oogoo01Uoo`03001oogoo01]oo`04001oogoo000MOol00`00Oomoo`0AOol003eoo`03
001oogoo01Yoo`03001oogoo01aoo`03001oogoo01Eoo`04001oogoo000LOol00`00Oomoo`0JOol0
0`00Oomoo`0LOol00`00Oomoo`0IOol5000BOol003Eoo`@000Eoo`03001oogoo019oo`@000Aoo`03
001oogoo01=oo`@000Aoo`03001oogoo01Eoo`04001oogoo000LOol00`00Oomoo`0KOol00`00Oomo
o`0LOol00`00Oomoo`0HOol01000Oomoo`004goo000kOol01000Oomoo`006Woo00@007ooOol001ao
o`03001oogoo01Eoo`04001oogoo000LOol00`00Oomoo`0IOol01000Oomoo`006Woo00@007ooOol0
01]oo`03001oo`0001=oo`00?7oo0P0077oo0P0077oo0P0067oo0P0077oo0P0077oo0P0077oo0P00
7Goo0P004goo003oOolQOol00?moob5oo`00ogoo8Goo003oOolQOol00?moob5oo`00=7oog@003goo
000dOol00`00Oomoo`03Ool00`00Oomoo`0KOol00`00Oomoo`0KOol00`00Oomoo`0JOol00`00Oomo
o`0KOol00`00Oomoo`0KOol00`00Oomoo`0KOol00`00Oomoo`0KOol00`00Oomoo`02Ool00`00Oomo
o`0=Ool003Aoo`03001oogoo025oo`0300moogoo01]oo`0300moogoo01Yoo`03001oogoo01]oo`03
00moogoo01]oo`0300moogoo01]oo`0300moogoo021oo`03001oogoo00eoo`00=7oo0P008Woo00<0
3gooOol06goo00<03gooOol047oo7`002Goo00<03gooOol06goo00<03gooOol06goo00<03gooOol0
7goo0P003goo000dOol00`00Oomoo`0QOol00`0?Oomoo`0KOol00`0?Oomoo`04Ool<000:Ool00`00
Oomoo`0BOol;000LOol00`0?Oomoo`0KOol00`0?Oomoo`0POol00`00Oomoo`0=Ool003Aoo`03001o
ogoo025oo`0300moogoo01Yoo`P001Ioo`03001oogoo01]oo`0300moo`0000L001Aoo`0300moogoo
01]oo`0300moogoo021oo`03001oogoo00eoo`00=7oo00<007ooOol08Goo00<03gooOol05Woo1000
00=oo`0?Ool06goo00<007ooOol06goo00<03gooOol01goo100047oo00<03gooOol06goo00<03goo
Ool087oo00<007ooOol03Goo000dOol00`00Oomoo`0QOol00`0?Oomoo`0BOol40005Ool00`0?Oomo
o`0JOol00`00Oomoo`0KOol00`0?Oomoo`0;Ool5000;Ool00`0?Oomoo`0KOol00`0?Oomoo`0POol0
0`00Oomoo`0=Ool002ioo`<000=oo`03001oogoo025oo`0300moogoo00ioo`@000Uoo`0300moogoo
01Yoo`03001oogoo01]oo`0300moogoo011oo`@000Moo`0300moogoo01]oo`0300moogoo021oo`03
001oogoo00eoo`00;goo00<007ooOol00Woo00<007ooOol08Goo00<03gooOol02Woo10003Goo00<0
3gooOol06Woo00<007ooOol06goo00<03gooOol057oo10000goo00<03gooOol06goo00<03gooOol0
87oo00<007ooOol03Goo000/Ool50003Ool2000[00l4000^00l00`0000l03`0f00l3001000l2000?
Ool002Ioo`@0009oo`04001oogoo0004Ool00`00Oomoo`0QOol00`0?Oomoo`04Ool2000EOol00`0?
Oomoo`0JOol00`00Oomoo`0KOol00`0?Oomoo`0KOol4000JOol00`0?Oomoo`0POol00`00Oomoo`0=
Ool002eoo`03001oo`0000Aoo`03001oogoo025oo`0400moogooOol3000GOol00`0?Oomoo`0JOol0
0`00Oomoo`0KOol00`0?Oomoo`0KOol0100?Oomoogoo0`005goo00<03gooOol087oo00<007ooOol0
3Goo000^Ool20004Ool00`00Oomoo`0QOol0100?Ool000006Woo00<03gooOol06Woo00<007ooOol0
6goo00<03gooOol06goo00<03gooOol017oo0`0057oo00<03gooOol087oo00<007ooOol03Goo000d
Ool00`00Oomoo`0POol3000LOol00`0?Oomoo`0JOol00`00Oomoo`0KOol00`0?Oomoo`0KOol00`0?
Oomoo`07Ool2000BOol00`0?Oomoo`0POol00`00Oomoo`0=Ool003Aoo`03001oogoo01ioo`800003
Ool03goo01aoo`0300moogoo01Yoo`03001oogoo01]oo`0300moogoo01]oo`0300moogoo00Uoo`<0
00moo`0300moogoo021oo`03001oogoo00eoo`00=7oo00<007ooOol077oo0P000goo00<03gooOol0
6goo00<03gooOol06Woo00<007ooOol06goo00<03gooOol06goo00<03gooOol037oo0`0037oo00<0
3gooOol087oo00<007ooOol03Goo000dOol2000KOol20005Ool00`0?Oomoo`0KOol00`0?Oomoo`0J
Ool00`00Oomoo`0KOol00`0?Oomoo`0KOol00`0?Oomoo`0?Ool2000:Ool00`0?Oomoo`0OOol2000?
Ool003Aoo`03001oogoo01Qoo`8000Moo`0300moogoo01]oo`0300moogoo01Yoo`03001oogoo01]o
o`0300moogoo01]oo`0300moogoo015oo`8000Qoo`0300moogoo021oo`03001oogoo00eoo`00=7oo
00<007ooOol05Woo0P002Goo00<03gooOol06goo00<03gooOol06Woo00<007ooOol06goo00<03goo
Ool06goo00<03gooOol04goo0P001Woo00<03gooOol087oo00<007ooOol03Goo000dOol00`00Oomo
o`0EOol00`00Oomoo`09Ool00`0?Oomoo`0KOol00`0?Oomoo`0JOol00`00Oomoo`0KOol00`0?Oomo
o`0KOol00`0?Oomoo`0EOol20004Ool00`0?Oomoo`0POol00`00Oomoo`0=Ool003Aoo`03001oogoo
01=oo`8000aoo`0300moogoo01]oo`0300moogoo01Yoo`03001oogoo01]oo`0300moogoo01]oo`03
00moogoo01Moo`05001oogooOol03`0ROol00`00Oomoo`0=Ool003Aoo`03001oogoo015oo`8000io
o`0300moogoo01]oo`0300moogoo01Yoo`03001oogoo01]oo`0300moogoo01]oo`0300moogoo01Qo
o`800003Ool03goo025oo`03001oogoo00eoo`00=7oo00<007ooOol047oo00<007ooOol03Woo00<0
3gooOol06goo00<03gooOol06Woo00<007ooOol06goo00<03gooOol06goo00<03gooOol06Woo0P00
8Woo00<007ooOol03Goo000dOol2000?Ool2000AOol00`0?Oomoo`0KOol00`0?Oomoo`0JOol00`00
Oomoo`0KOol00`0?Oomoo`0KOol00`0?Oomoo`0KOol00`0?001oo`0OOol2000?Ool003Aoo`03001o
ogoo00eoo`03001oogoo015oo`0300moogoo01]oo`0300moogoo01Yoo`03001oogoo01]oo`0300mo
ogoo01]oo`0300moogoo01]oo`0300moo`00021oo`03001oogoo00eoo`00=7oo00<007ooOol037oo
00<007ooOol04Woo00<03gooOol06goo00<03gooOol06Woo00<007ooOol06goo00<03gooOol06goo
00<03gooOol06goo00<03gooOol00P007Woo00<007ooOol03Goo000dOol00`00Oomoo`0;Ool00`00
Oomoo`0COol00`0?Oomoo`0KOol00`0?Oomoo`0JOol00`00Oomoo`0KOol00`0?Oomoo`0KOol00`0?
Oomoo`0KOol00`0?Oomoo`02Ool00`00Oomoo`0KOol00`00Oomoo`0=Ool003Aoo`03001oogoo00Yo
o`03001oogoo01Aoo`0300moogoo01]oo`0300moogoo01Yoo`03001oogoo01]oo`0300moogoo01]o
o`0300moogoo01]oo`0300moogoo00=oo`03001oogoo01Yoo`03001oogoo00eoo`00=7oo00<007oo
Ool02Goo00<007ooOol05Goo00<03gooOol06goo00<03gooOol06Woo00<007ooOol06goo00<03goo
Ool06goo00<03gooOol06goo00<03gooOol017oo0P006Woo00<007ooOol03Goo000dOol00`00Oomo
o`09Ool00`00Oomoo`0EOol00`0?Oomoo`0KOol00`0?Oomoo`0JOol00`00Oomoo`0KOol00`0?Oomo
o`0KOol00`0?Oomoo`0KOol00`0?Oomoo`06Ool00`00Oomoo`0GOol00`00Oomoo`0=Ool003Aoo`03
001oogoo00Qoo`03001oogoo01Ioo`0300moogoo01]oo`0300moogoo01Yoo`03001oogoo01]oo`03
00moogoo01]oo`0300moogoo01]oo`0300moogoo00Moo`03001oogoo01Ioo`03001oogoo00eoo`00
=7oo0P0027oo00<007ooOol05goo00<03gooOol06goo00<03gooOol06Woo00<007ooOol06goo00<0
3gooOol06goo00<03gooOol06goo00<03gooOol027oo00<007ooOol057oo0P003goo000dOol00`00
Oomoo`06Ool00`00Oomoo`0HOol00`0?Oomoo`0KOol00`0?Oomoo`0JOol00`00Oomoo`0KOol00`0?
Oomoo`0KOol00`0?Oomoo`0KOol00`0?Oomoo`09Ool2000EOol00`00Oomoo`0=Ool003Aoo`03001o
ogoo00Eoo`03001oogoo01Uoo`0300moogoo01]oo`0300moogoo01Yoo`03001oogoo01]oo`0300mo
ogoo01]oo`0300moogoo01]oo`0300moogoo00]oo`03001oogoo019oo`03001oogoo00eoo`00=7oo
00<007ooOol01Goo00<007ooOol06Goo00<03gooOol06goo00<03gooOol06Woo00<007ooOol06goo
00<03gooOol06goo00<03gooOol06goo00<03gooOol037oo00<007ooOol04Goo00<007ooOol03Goo
000dOol00`00Oomoo`04Ool00`00Oomoo`0JOol00`0?Oomoo`0KOol00`0?Oomoo`0JOol00`00Oomo
o`0KOol00`0?Oomoo`0KOol00`0?Oomoo`0KOol00`0?Oomoo`0=Ool00`00Oomoo`0@Ool00`00Oomo
o`0=Ool002aoo`@000Aoo`03001oogoo00Aoo`03001oogoo01Yoo`0300moogoo01]oo`0300moogoo
01Yoo`03001oogoo01]oo`0300moogoo01]oo`0300moogoo01]oo`0300moogoo00ioo`03001oogoo
00moo`03001oogoo00eoo`00;7oo00<007ooOol01Goo00<007ooOol00goo00<007ooOol06goo00<0
3gooOol06goo00<03gooOol06Woo00<007ooOol06goo00<03gooOol06goo00<03gooOol06goo00<0
3gooOol03goo00<007ooOol03Woo00<007ooOol03Goo000]Ool00`00Oomoo`04Ool2000400l00`00
00l03`1F00l00`0000l03`1Y00l00`0000l03`0=00l2000?Ool002Ioo`@000Aoo`03001oogoo00=o
o`03001oogoo00=oo`03001oogoo01]oo`0300moogoo01]oo`0300moogoo01Yoo`03001oogoo01]o
o`0300moogoo01]oo`0300moogoo01]oo`0300moogoo011oo`03001oogoo00eoo`03001oogoo00eo
o`00;7oo00@007ooOol000Aoo`03001oogoo009oo`03001oogoo01aoo`0300moogoo01]oo`0300mo
ogoo01Yoo`03001oogoo01]oo`0300moogoo01]oo`0300moogoo01]oo`0300moogoo015oo`03001o
ogoo00aoo`03001oogoo00eoo`00;Goo0P001Goo00<007ooOol00Woo00<007ooOol077oo00<03goo
Ool06goo00<03gooOol06Woo00<007ooOol06goo00<03gooOol06goo00<03gooOol06goo00<03goo
Ool04Woo00<007ooOol02goo00<007ooOol03Goo000dOol00`00Oomoo`02Ool00`00Oomoo`0LOol0
0`0?Oomoo`0KOol00`0?Oomoo`0JOol00`00Oomoo`0KOol00`0?Oomoo`0KOol00`0?Oomoo`0KOol0
0`0?Oomoo`0COol00`00Oomoo`0:Ool00`00Oomoo`0=Ool003Aoo`03001oogoo009oo`03001oogoo
01aoo`0300moogoo01]oo`0300moogoo01Yoo`03001oogoo01]oo`0300moogoo01]oo`0300moogoo
01]oo`0300moogoo01=oo`03001oogoo00Yoo`03001oogoo00eoo`00=7oo00<007ooOol00Woo00<0
07ooOol077oo00<03gooOol06goo00<03gooOol06Woo00<007ooOol06goo00<03gooOol06goo00<0
3gooOol06goo00<03gooOol057oo00<007ooOol02Goo00<007ooOol03Goo000dOol20004Ool00`00
Oomoo`0KOol00`0?Oomoo`0KOol00`0?Oomoo`0JOol00`00Oomoo`0KOol00`0?Oomoo`0KOol00`0?
Oomoo`0KOol00`0?Oomoo`0DOol00`00Oomoo`08Ool2000?Ool003Aoo`03001oogoo00=oo`03001o
ogoo01]oo`0300moogoo01]oo`0300moogoo01Yoo`03001oogoo01]oo`0300moogoo01]oo`0300mo
ogoo01]oo`0300moogoo01Eoo`03001oogoo00Qoo`03001oogoo00eoo`00=7oo00<007ooOol00goo
00<007ooOol06goo00<03gooOol06goo00<03gooOol06Woo00<007ooOol06goo00<03gooOol06goo
00<03gooOol06goo00<03gooOol05Goo00<007ooOol027oo00<007ooOol03Goo000dOol00`00Oomo
o`03Ool00`00Oomoo`0KOol00`0?Oomoo`0KOol00`0?Oomoo`0JOol00`00Oomoo`0KOol00`0?Oomo
o`0KOol00`0?Oomoo`0KOol00`0?Oomoo`0FOol00`00Oomoo`07Ool00`00Oomoo`0=Ool003Aoo`03
001oogoo00=oo`03001oogoo01]oo`0300moogoo01]oo`0300moogoo01Yoo`03001oogoo01]oo`03
00moogoo01]oo`0300moogoo01]oo`0300moogoo01Ioo`03001oogoo00Moo`03001oogoo00eoo`00
=7oo00<007ooOol017oo00<007ooOol06Woo00<03gooOol06goo00<03gooOol06Woo00<007ooOol0
6goo00<03gooOol06goo00<03gooOol06goo00<03gooOol05goo00<007ooOol01Woo00<007ooOol0
3Goo000dOol00`00Oomoo`04Ool00`00Oomoo`0JOol00`0?Oomoo`0KOol00`0?Oomoo`0JOol00`00
Oomoo`0KOol00`0?Oomoo`0KOol00`0?Oomoo`0KOol00`0?Oomoo`0GOol00`00Oomoo`06Ool00`00
Oomoo`0=Ool003Aoo`8000Eoo`03001oogoo01Yoo`0300moogoo01]oo`0300moogoo01Yoo`03001o
ogoo01]oo`0300moogoo01]oo`0300moogoo01]oo`0300moogoo01Qoo`03001oogoo00Aoo`8000mo
o`00=7oo00<007ooOol01Goo00<007ooOol06Goo00<03gooOol06goo00<03gooOol06Woo00<007oo
Ool06goo00<03gooOol06goo00<03gooOol06goo00<03gooOol067oo00<007ooOol01Goo00<007oo
Ool03Goo000dOol00`00Oomoo`05Ool00`00Oomoo`0IOol00`0?Oomoo`0KOol00`0?Oomoo`0JOol0
0`00Oomoo`0KOol00`0?Oomoo`0KOol00`0?Oomoo`0KOol00`0?Oomoo`0IOol00`00Oomoo`04Ool0
0`00Oomoo`0=Ool003Aoo`03001oogoo00Ioo`03001oogoo01Qoo`0300moogoo01]oo`0300moogoo
01Yoo`03001oogoo01]oo`0300moogoo01]oo`0300moogoo01]oo`0300moogoo01Uoo`03001oogoo
00Aoo`03001oogoo00eoo`00=7oo00<007ooOol01Woo00<007ooOol067oo00<03gooOol037oo6`00
4Goo00<007ooOol06goo00<03gooOol06goo00<03gooOol06goo00<03gooOol06Woo00<007ooOol0
0goo00<007ooOol03Goo000dOol00`00Oomoo`07Ool00`00Oomoo`0GOol00`0?Oomoo`09Ool3000?
Ool00`0?Oomoo`09Ool6000;Ool00`00Oomoo`0KOol00`0?Oomoo`0KOol00`0?Oomoo`0KOol00`0?
Oomoo`0JOol00`00Oomoo`03Ool00`00Oomoo`0=Ool003Aoo`03001oogoo00Qoo`03001oogoo01Io
o`0300moogoo00Eoo`@0019oo`0300moogoo00moo`<000Qoo`03001oogoo01]oo`0300moogoo01]o
o`0300moogoo01]oo`0300moogoo01Yoo`03001oogoo00=oo`03001oogoo00eoo`00=7oo0P002Woo
00<007ooOol05Goo00@03gooOomoo`@001Ioo`0300moogoo019oo`8000Ioo`03001oogoo01]oo`03
00moogoo01]oo`0300moogoo01]oo`0300moogoo01Yoo`03001oogoo009oo`8000moo`00=7oo00<0
07ooOol02Woo00<007ooOol057oo10006Woo00<03gooOol057oo0P0017oo00<007ooOol06goo00<0
3gooOol06goo00<03gooOol06goo00<03gooOol06goo00<007ooOol00Woo00<007ooOol03Goo000d
Ool00`00Oomoo`0;Ool00`00Oomoo`0AOol200000`0?Oomoo`0KOol00`0?Oomoo`0FOol20002Ool0
0`00Oomoo`0KOol00`0?Oomoo`0KOol00`0?Oomoo`0KOol00`0?Oomoo`0KOol00`00Oomoo`02Ool0
0`00Oomoo`0=Ool003Aoo`03001oogoo00aoo`03001oogoo00eoo`<0009oo`0300moogoo01]oo`03
00moogoo01Qoo`<001eoo`0300moogoo01]oo`0300moogoo01]oo`0300moogoo01]oo`03001oogoo
009oo`03001oogoo00eoo`004Woo0P000goo0`000goo0P005Goo00<007ooOol03Goo0P002Woo0`00
1Goo00<03gooOol06goo00<03gooOol06Goo0P007Goo00<03gooOol06goo00<03gooOol06goo00<0
3gooOol06goo00<007ooOol00Woo00<007ooOol03Goo000BOol00`00Oomoo`05Ool01@00Oomoogoo
00005Goo00<007ooOol03goo00<007ooOol01Goo0P0027oo00<03gooOol06goo00<03gooOol06Woo
0P0077oo00<03gooOol06goo00<03gooOol06goo00<03gooOol06goo00<007ooOol00Woo00<007oo
Ool03Goo0005Ool300001goo000007oo001oo`0000=oo`03001oogoo00=oo`<000=oo`03001oogoo
00aoo`8000Eoo`03001oogoo011oo`04001oogooOol3000:Ool00`0?Oomoo`0KOol00`0?Oomoo`0J
Ool2000LOol00`0?Oomoo`0KOol00`0?Oomoo`0KOol00`0?Oomoo`0KOol00`00Oomoo`02Ool00`00
Oomoo`0=Ool000Ioo`09001oogooOol007oo001oo`0000=oo`03001oogoo009oo`04001oogoo0003
Ool00`00Oomoo`0;Ool01000Oomoo`0017oo00<007ooOol04Goo0`003Goo00<03gooOol06goo00=l
07ooOol06Woo00<0000OOol06goo00<03gooOol06goo00<03gooOol06goo00<03gooOol06goo00<0
07ooOol00Woo00<007ooOol03Goo0006Ool02@00Oomoogoo001oo`00Ool00003Ool00`00Oomoo`02
Ool01000Oomoo`000goo00<007ooOol02goo00@007ooOol000Aoomd000moo`001Woo00<007ooOol0
0`0000=oo`00Ool00goo00<007ooOol00goo10000Woo00<007ooOol02goo00@007ooOol000Aoo`03
001oogoo00moo`03001oogoo009oo`8000]oo`0300moogoo01]oo`0300moogoo01Yoo`8001aoo`03
00moogoo01]oo`0300moogoo01]oo`0300moogoo01]oo`03001oogoo009oo`03001oogoo00eoo`00
1Woo00<007ooOol02Goo00<007ooOol02Goo00<007ooOol02goo00@007ooOol000Aoo`03001oogoo
00ioo`03001oogoo00Eoo`8000Uoo`0300moogoo01]oo`0300moogoo01Yoo`8001aoo`0300moogoo
01]oo`0300moogoo01]oo`0300moogoo01]oo`03001oogoo009oo`03001oogoo00eoo`001Goo0`00
2Woo0P002Goo0P003Woo0P001Goo00<007ooOol037oo0P002Woo0P001goo00<03gooOol06goo00<0
3gooOol06Goo0P007Goo00<03gooOol06goo00<03gooOol06goo00<03gooOol06goo00<007ooOol0
0Woo00<007ooOol03Goo000dOol00`00Oomoo`0;Ool00`00Oomoo`0<Ool30004Ool00`0?Oomoo`0K
Ool00`0?Oomoo`0HOol00`00Ool0000MOol00`0?Oomoo`0KOol00`0?Oomoo`0KOol00`0?Oomoo`0J
Ool00`00Oomoo`03Ool00`00Oomoo`0=Ool003Aoo`03001oogoo00Yoo`03001oogoo011oo`@00003
00moogoo01]oo`0300moogoo01Ioo`80009oo`03001oogoo01]oo`0300moogoo01]oo`0300moogoo
01]oo`0300moogoo01Yoo`03001oogoo00=oo`03001oogoo00eoo`00=7oo00<007ooOol02Goo00<0
07ooOol05Goo0`006goo00<03gooOol05Goo00<007ooOol00Woo00<007ooOol06goo00<03gooOol0
6goo00<03gooOol06goo00<03gooOol06Woo00<007ooOol00goo00<007ooOol03Goo000dOol20009
Ool00`00Oomoo`0FOol00`0?Oomoo`03000HOol00`0?Oomoo`0BOol30005Ool00`00Oomoo`0KOol0
0`0?Oomoo`0KOol00`0?Oomoo`0KOol00`0?Oomoo`0JOol00`00Oomoo`02Ool2000?Ool003Aoo`03
001oogoo00Qoo`03001oogoo01Ioo`0300moogoo00=oo`D001=oo`0300moogoo00ioo`@000Qoo`03
001oogoo01]oo`0300moogoo01]oo`0300moogoo01]oo`0300moogoo01Yoo`03001oogoo00=oo`03
001oogoo00eoo`00=7oo00<007ooOol01goo00<007ooOol05goo00<03gooOol027oo1`0037oo00<0
3gooOol02goo0`0037oo00<007ooOol06goo00<03gooOol06goo00<03gooOol06goo00<03gooOol0
6Woo00<007ooOol00goo00<007ooOol03Goo000dOol00`00Oomoo`06Ool00`00Oomoo`0HOol00`0?
Oomoo`0?OolJ000?Ool00`00Oomoo`0KOol00`0?Oomoo`0KOol00`0?Oomoo`0KOol00`0?Oomoo`0I
Ool00`00Oomoo`04Ool00`00Oomoo`0=Ool003Aoo`03001oogoo00Eoo`03001oogoo01Uoo`0300mo
ogoo01]oo`0300moogoo01Yoo`03001oogoo01]oo`0300moogoo01]oo`0300moogoo01]oo`0300mo
ogoo01Uoo`03001oogoo00Aoo`03001oogoo00eoo`00=7oo00<007ooOol01Goo00<007ooOol06Goo
00<03gooOol06goo00<03gooOol06Woo00<007ooOol06goo00<03gooOol06goo00<03gooOol06goo
00<03gooOol06Goo00<007ooOol017oo00<007ooOol03Goo000dOol00`00Oomoo`04Ool00`00Oomo
o`0JOol00`0?Oomoo`0KOol00`0?Oomoo`0JOol00`00Oomoo`0KOol00`0?Oomoo`0KOol00`0?Oomo
o`0KOol00`0?Oomoo`0IOol00`00Oomoo`04Ool00`00Oomoo`0=Ool003Aoo`8000Eoo`03001oogoo
01Yoo`0300moogoo01]oo`0300moogoo01Yoo`03001oogoo01]oo`0300moogoo01]oo`0300moogoo
01]oo`0300moogoo01Qoo`03001oogoo00Aoo`8000moo`00=7oo00<007ooOol00goo00<007ooOol0
6goo00<03gooOol06goo00<03gooOol06Woo00<007ooOol06goo00<03gooOol06goo00<03gooOol0
6goo00<03gooOol067oo00<007ooOol01Goo00<007ooOol03Goo000dOol00`00Oomoo`03Ool00`00
Oomoo`0KOol00`0?Oomoo`0KOol00`0?Oomoo`0JOol00`00Oomoo`0KOol00`0?Oomoo`0KOol00`0?
Oomoo`0KOol00`0?Oomoo`0GOol00`00Oomoo`06Ool00`00Oomoo`0=Ool003Aoo`03001oogoo00=o
o`03001oogoo01]oo`0300moogoo01]oo`0300moogoo01Yoo`03001oogoo01]oo`0300moogoo01]o
o`0300moogoo01]oo`0300moogoo01Moo`03001oogoo00Ioo`03001oogoo00eoo`00=7oo00<007oo
Ool00goo00<007ooOol06goo00<03gooOol06goo00<03gooOol06Woo00<007ooOol06goo00<03goo
Ool06goo00<03gooOol06goo00<03gooOol05Woo00<007ooOol01goo00<007ooOol03Goo000dOol0
0`00Oomoo`03Ool00`00Oomoo`0KOol00`0?Oomoo`0KOol00`0?Oomoo`0JOol00`00Oomoo`0KOol0
0`0?Oomoo`0KOol00`0?Oomoo`0KOol00`0?Oomoo`0FOol00`00Oomoo`07Ool00`00Oomoo`0=Ool0
03Aoo`03001oogoo009oo`03001oogoo01aoo`0300moogoo01]oo`0300moogoo01Yoo`03001oogoo
01]oo`0300moogoo01]oo`0300moogoo01]oo`0300moogoo01Eoo`03001oogoo00Qoo`03001oogoo
00eoo`00=7oo0P000goo00<007ooOol077oo00<03gooOol06goo00<03gooOol06Woo00<007ooOol0
6goo00<03gooOol06goo00<03gooOol06goo00<03gooOol057oo00<007ooOol027oo0P003goo000d
Ool00`00Oomoo`02Ool00`00Oomoo`0LOol00`0?Oomoo`0KOol00`0?Oomoo`0JOol00`00Oomoo`0K
Ool00`0?Oomoo`0KOol00`0?Oomoo`0KOol00`0?Oomoo`0DOol00`00Oomoo`09Ool00`00Oomoo`0=
Ool003Aoo`03001oogoo009oo`03001oogoo01aoo`0300moogoo01]oo`0300moogoo01Yoo`03001o
ogoo01]oo`0300moogoo01]oo`0300moogoo01]oo`0300moogoo01=oo`03001oogoo00Yoo`03001o
ogoo00eoo`00=7oo00<007ooOol00Woo00<007ooOol077oo00<03gooOol06goo00<03gooOol06Woo
00<007ooOol06goo00<03gooOol06goo00<03gooOol06goo00<03gooOol04Woo00<007ooOol02goo
00<007ooOol03Goo000dOol00`00Oomoo`02Ool00`00Oomoo`0LOol00`0?Oomoo`0KOol00`0?Oomo
o`0JOol00`00Oomoo`0KOol00`0?Oomoo`0KOol00`0?Oomoo`0KOol00`0?Oomoo`0BOol00`00Oomo
o`0;Ool00`00Oomoo`0=Ool002aoo`@000Aoo`03001oogoo00=oo`03001oogoo01]oo`0300moogoo
01]oo`0300moogoo01Yoo`03001oogoo01]oo`0300moogoo01]oo`0300moogoo01]oo`0300moogoo
015oo`03001oogoo00aoo`03001oogoo00eoo`00;7oo00<007ooOol01Goo00<007ooOol00goo00<0
07ooOol06goo00<03gooOol06goo00<03gooOol06Woo00<007ooOol06goo00<03gooOol06goo00<0
3gooOol06goo00<03gooOol047oo00<007ooOol03Goo00<007ooOol03Goo000]Ool00`00Oomoo`04
Ool2000400l00`0000l03`1F00l00`0000l03`1Y00l00`0000l03`0=00l2000?Ool002ioo`03001o
ogoo00=oo`03001oogoo00Aoo`03001oogoo01Yoo`0300moogoo01]oo`0300moogoo01Yoo`03001o
ogoo01]oo`0300moogoo01]oo`0300moogoo01]oo`0300moogoo00moo`03001oogoo00ioo`03001o
ogoo00eoo`00;7oo00@007ooOol000Aoo`03001oogoo00Aoo`03001oogoo01Yoo`0300moogoo01]o
o`0300moogoo01Yoo`03001oogoo01]oo`0300moogoo01]oo`0300moogoo01]oo`0300moogoo00io
o`03001oogoo00moo`03001oogoo00eoo`00;Goo0P001Goo00<007ooOol01Goo00<007ooOol06Goo
00<03gooOol06goo00<03gooOol06Woo00<007ooOol06goo00<03gooOol06goo00<03gooOol06goo
00<03gooOol03Goo00<007ooOol047oo00<007ooOol03Goo000dOol00`00Oomoo`05Ool00`00Oomo
o`0IOol00`0?Oomoo`0KOol00`0?Oomoo`0JOol00`00Oomoo`0KOol00`0?Oomoo`0KOol00`0?Oomo
o`0KOol00`0?Oomoo`0<Ool00`00Oomoo`0AOol00`00Oomoo`0=Ool003Aoo`03001oogoo00Ioo`03
001oogoo01Qoo`0300moogoo01]oo`0300moogoo01Yoo`03001oogoo01]oo`0300moogoo01]oo`03
00moogoo01]oo`0300moogoo00]oo`03001oogoo019oo`03001oogoo00eoo`00=7oo00<007ooOol0
1goo00<007ooOol05goo00<03gooOol06goo00<03gooOol06Woo00<007ooOol06goo00<03gooOol0
6goo00<03gooOol06goo00<03gooOol02Woo00<007ooOol04goo00<007ooOol03Goo000dOol20008
Ool00`00Oomoo`0GOol00`0?Oomoo`0KOol00`0?Oomoo`0JOol00`00Oomoo`0KOol00`0?Oomoo`0K
Ool00`0?Oomoo`0KOol00`0?Oomoo`09Ool00`00Oomoo`0COol2000?Ool003Aoo`03001oogoo00Qo
o`03001oogoo01Ioo`0300moogoo01]oo`0300moogoo01Yoo`03001oogoo01]oo`0300moogoo01]o
o`0300moogoo01]oo`0300moogoo00Qoo`03001oogoo01Eoo`03001oogoo00eoo`00=7oo00<007oo
Ool02Goo00<007ooOol05Goo00<03gooOol06goo00<03gooOol06Woo00<007ooOol06goo00<03goo
Ool06goo00<03gooOol06goo00<03gooOol01goo00<007ooOol05Woo00<007ooOol03Goo000dOol0
0`00Oomoo`0:Ool00`00Oomoo`0DOol00`0?Oomoo`0KOol00`0?Oomoo`0JOol00`00Oomoo`0KOol0
0`0?Oomoo`0KOol00`0?Oomoo`0KOol00`0?Oomoo`05Ool2000IOol00`00Oomoo`0=Ool003Aoo`03
001oogoo00Yoo`03001oogoo01Aoo`0300moogoo01]oo`0300moogoo01Yoo`03001oogoo01]oo`03
00moogoo01]oo`0300moogoo01]oo`0300moogoo00Aoo`03001oogoo01Uoo`03001oogoo00eoo`00
=7oo00<007ooOol02goo00<007ooOol04goo00<03gooOol06goo00<03gooOol06Woo00<007ooOol0
6goo00<03gooOol06goo00<03gooOol06goo00<03gooOol00goo00<007ooOol06Woo00<007ooOol0
3Goo000dOol00`00Oomoo`0<Ool00`00Oomoo`0BOol00`0?Oomoo`0KOol00`0?Oomoo`0JOol00`00
Oomoo`0KOol00`0?Oomoo`0KOol00`0?Oomoo`0KOol0100?Oomoogoo0P007Goo00<007ooOol03Goo
000dOol00`00Oomoo`0=Ool2000BOol00`0?Oomoo`0KOol00`0?Oomoo`0JOol00`00Oomoo`0KOol0
0`0?Oomoo`0KOol00`0?Oomoo`0KOol0100?Oomoo`007goo00<007ooOol03Goo000dOol2000@Ool0
0`00Oomoo`0?Ool00`0?Oomoo`0KOol00`0?Oomoo`0JOol00`00Oomoo`0KOol00`0?Oomoo`0KOol0
0`0?Oomoo`0KOol00`0?0000000OOol2000?Ool003Aoo`03001oogoo011oo`03001oogoo00ioo`03
00moogoo01]oo`0300moogoo01Yoo`03001oogoo01]oo`0300moogoo01]oo`0300moogoo01Yoo`80
029oo`03001oogoo00eoo`00=7oo00<007ooOol04Goo0P003Woo00<03gooOol06goo00<03gooOol0
6Woo00<007ooOol06goo00<03gooOol06goo00<03gooOol06Goo00<007oo00l08Woo00<007ooOol0
3Goo000dOol00`00Oomoo`0COol00`00Oomoo`0;Ool00`0?Oomoo`0KOol00`0?Oomoo`0JOol00`00
Oomoo`0KOol00`0?Oomoo`0KOol00`0?Oomoo`0GOol20002Ool00`0?Oomoo`0POol00`00Oomoo`0=
Ool003Aoo`03001oogoo01Aoo`03001oogoo00Yoo`0300moogoo01]oo`0300moogoo01Yoo`03001o
ogoo01]oo`0300moogoo01]oo`0300moogoo01Eoo`8000Aoo`0300moogoo021oo`03001oogoo00eo
o`00=7oo00<007ooOol05Goo0P002Woo00<03gooOol06goo00<03gooOol06Woo00<007ooOol06goo
00<03gooOol06goo00<03gooOol04goo0P001Woo00<03gooOol087oo00<007ooOol03Goo000dOol0
0`00Oomoo`0GOol20008Ool00`0?Oomoo`0KOol00`0?Oomoo`0JOol00`00Oomoo`0KOol00`0?Oomo
o`0KOol00`0?Oomoo`0AOol20008Ool00`0?Oomoo`0POol00`00Oomoo`0=Ool003Aoo`8001Yoo`80
00Ioo`0300moogoo01]oo`0300moogoo01Yoo`03001oogoo01]oo`0300moogoo01]oo`0300moogoo
00ioo`<000Yoo`0300moogoo01moo`8000moo`00=7oo00<007ooOol06goo0`000goo00<03gooOol0
6goo00<03gooOol06Woo00<007ooOol06goo00<03gooOol06goo00<03gooOol037oo0P003Goo00<0
3gooOol087oo00<007ooOol03Goo000dOol00`00Oomoo`0NOol200000goo00moo`0LOol00`0?Oomo
o`0JOol00`00Oomoo`0KOol00`0?Oomoo`0KOol00`0?Oomoo`09Ool3000?Ool00`0?Oomoo`0POol0
0`00Oomoo`0=Ool003Aoo`03001oogoo021oo`<001aoo`0300moogoo01Yoo`03001oogoo01]oo`03
00moogoo01]oo`0300moogoo00Ioo`<0019oo`0300moogoo021oo`03001oogoo00eoo`00=7oo00<0
07ooOol08Goo00@03goo000001Yoo`0300moogoo01Yoo`03001oogoo01]oo`0300moogoo01]oo`03
00moogoo00=oo`<001Eoo`0300moogoo021oo`03001oogoo00eoo`00;Woo0`000goo00<007ooOol0
8Goo00@03gooOomoo`<001Moo`0300moogoo01Yoo`03001oogoo01]oo`0300moogoo01]oo`0400mo
ogooOol2000HOol00`0?Oomoo`0POol00`00Oomoo`0=Ool002moo`03001oogoo009oo`03001oogoo
025oo`0300moogoo00Aoo`<001Aoo`0300moogoo01Yoo`03001oogoo01]oo`0300moogoo01]oo`04
00l00000000JOol00`0?Oomoo`0POol00`00Oomoo`0=Ool002aoo`D000=oo`8002`03`@002d03`03
00003`0?03H03`@003l03`8000moo`00;7oo00@007ooOol000Aoo`03001oogoo025oo`0300moogoo
00]oo`<000eoo`0300moogoo01Yoo`03001oogoo01]oo`0300moogoo01=oo`D000=oo`0300moogoo
01]oo`0300moogoo021oo`03001oogoo00eoo`00;Goo00<007oo000017oo00<007ooOol08Goo00<0
3gooOol03Woo10002Goo00<03gooOol06Woo00<007ooOol06goo00<03gooOol03Woo1@0027oo00<0
3gooOol06goo00<03gooOol087oo00<007ooOol03Goo000^Ool20004Ool00`00Oomoo`0QOol00`0?
Oomoo`0BOol40005Ool00`0?Oomoo`0JOol00`00Oomoo`0KOol00`0?Oomoo`0:Ool4000=Ool00`0?
Oomoo`0KOol00`0?Oomoo`0POol00`00Oomoo`0=Ool003Aoo`03001oogoo025oo`0300moogoo01Io
o`D0000300moogoo01Yoo`03001oogoo01]oo`0300moogoo00Eoo`D0015oo`0300moogoo01]oo`03
00moogoo021oo`03001oogoo00eoo`00=7oo00<007ooOol08Goo00<03gooOol06goo20005Goo00<0
07ooOol06goo00@03gooOomoo`@001Ioo`0300moogoo01]oo`0300moogoo021oo`03001oogoo00eo
o`00=7oo00<007ooOol08Goo00<03gooOol06goo00<03gooOol01Goo20003Goo00<007ooOol04goo
30006Woo00<03gooOol06goo00<03gooOol087oo00<007ooOol03Goo000dOol2000ROol00`0?Oomo
o`0KOol00`0?Oomoo`0=OolS0008Ool00`0?Oomoo`0KOol00`0?Oomoo`0KOol00`0?Oomoo`0OOol2
000?Ool003Aoo`03001oogoo025oo`0300moogoo01]oo`0300moogoo01Yoo`03001oogoo01]oo`03
00moogoo01]oo`0300moogoo01]oo`0300moogoo021oo`03001oogoo00eoo`00=7oo00<007ooOol0
0goo00<007ooOol06goo00<007ooOol06goo00<007ooOol06Woo00<007ooOol06goo00<007ooOol0
6goo00<007ooOol06goo00<007ooOol06goo00<007ooOol00Woo00<007ooOol03Goo000dOol00`00
Oomoo`03Ool00`00Oomoo`03Ool00`00Oomoo`03Ool00`00Oomoo`03Ool00`00Oomoo`03Ool00`00
Oomoo`03Ool00`00Oomoo`03Ool00`00Oomoo`03Ool00`00Oomoo`03Ool00`00Oomoo`03Ool00`00
Oomoo`03Ool00`00Oomoo`03Ool00`00Oomoo`02Ool00`00Oomoo`03Ool00`00Oomoo`03Ool00`00
Oomoo`03Ool00`00Oomoo`03Ool00`00Oomoo`03Ool00`00Oomoo`03Ool00`00Oomoo`03Ool00`00
Oomoo`03Ool00`00Oomoo`03Ool00`00Oomoo`03Ool00`00Oomoo`03Ool00`00Oomoo`03Ool00`00
Oomoo`03Ool00`00Oomoo`03Ool00`00Oomoo`03Ool00`00Oomoo`03Ool00`00Oomoo`03Ool00`00
Oomoo`03Ool00`00Oomoo`03Ool00`00Oomoo`03Ool00`00Oomoo`03Ool00`00Oomoo`03Ool00`00
Oomoo`03Ool00`00Oomoo`02Ool00`00Oomoo`0=Ool003Aoomd000moo`00ogoo8Goo003oOolQOol0
0?moob5oo`00ogoo8Goo003oOolQOol00?moob5oo`00ogoo8Goo003oOolQOol00?moob5oo`00ogoo
8Goo003oOolQOol00?moob5oo`00ogoo8Goo003oOolQOol00?moob5oo`00\
\>"],
  ImageRangeCache->{{{0, 287}, {176.938, 0}} -> {-4.95415, -6.4753, \
0.0334994, 0.0696711}},
  CellTags->{"Nyquist Plot", "i:10", "b:20.2"}],

Cell[BoxData[
    TagBox[\(\[SkeletonIndicator]  Graphics  \[SkeletonIndicator]\),
      False,
      Editable->False]], "Output",
  CellLabel->"Out[131]=",
  CellTags->{"Nyquist Plot", "i:10", "b:20.2"}]
}, Open  ]],

Cell["Similarly, the inverse Nyquist plot can be obtained:", "Text",
  Evaluatable->False,
  AspectRatioFixed->True,
  CellTags->{"Nyquist Plot", "i:10", "b:20.2"}],

Cell[CellGroupData[{

Cell[BoxData[
    \(InverseNyquist[G, s, \(-20\), \(+20\)]\)], "Input",
  CellLabel->"In[132]:=",
  PageWidth->Infinity,
  AspectRatioFixed->True,
  CellTags->{"Nyquist Plot", "i:10", "b:20.2"}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.024188 0.000501694 0.309017 4.22255e-005 [
[.02419 -0.0125 -3 -9 ]
[.02419 -0.0125 3 0 ]
[.14961 -0.0125 -9 -9 ]
[.14961 -0.0125 9 0 ]
[.27504 -0.0125 -9 -9 ]
[.27504 -0.0125 9 0 ]
[.40046 -0.0125 -9 -9 ]
[.40046 -0.0125 9 0 ]
[.52588 -0.0125 -12 -9 ]
[.52588 -0.0125 12 0 ]
[.65131 -0.0125 -12 -9 ]
[.65131 -0.0125 12 0 ]
[.77673 -0.0125 -12 -9 ]
[.77673 -0.0125 12 0 ]
[.90215 -0.0125 -12 -9 ]
[.90215 -0.0125 12 0 ]
[ 0 0 -0.125 0 ]
[.5 -0.0125 -23.4375 -22.1875 ]
[.5 -0.0125 23.4375 -9 ]
[-0.0125 .05566 -30 -4.5 ]
[-0.0125 .05566 0 4.5 ]
[-0.0125 .14012 -30 -4.5 ]
[-0.0125 .14012 0 4.5 ]
[-0.0125 .22457 -30 -4.5 ]
[-0.0125 .22457 0 4.5 ]
[-0.0125 .30902 -6 -4.5 ]
[-0.0125 .30902 0 4.5 ]
[-0.0125 .39347 -24 -4.5 ]
[-0.0125 .39347 0 4.5 ]
[-0.0125 .47792 -24 -4.5 ]
[-0.0125 .47792 0 4.5 ]
[-0.0125 .56237 -24 -4.5 ]
[-0.0125 .56237 0 4.5 ]
[ 0 0 -0.125 0 ]
[-0.01875 .30902 -76.875 -6.59375 ]
[-0.01875 .30902 -30 6.59375 ]
[ 0 .61803 .125 0 ]
[.5 .63053 -5.0625 0 ]
[.5 .63053 5.0625 13.1875 ]
[ 1 0 .125 0 ]
[1.0125 .30902 0 -6.59375 ]
[1.0125 .30902 10.125 6.59375 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.02419 0 m
.02419 .00625 L
s
[(0)] .02419 -0.0125 0 1 Mshowa
.14961 0 m
.14961 .00625 L
s
[(250)] .14961 -0.0125 0 1 Mshowa
.27504 0 m
.27504 .00625 L
s
[(500)] .27504 -0.0125 0 1 Mshowa
.40046 0 m
.40046 .00625 L
s
[(750)] .40046 -0.0125 0 1 Mshowa
.52588 0 m
.52588 .00625 L
s
[(1000)] .52588 -0.0125 0 1 Mshowa
.65131 0 m
.65131 .00625 L
s
[(1250)] .65131 -0.0125 0 1 Mshowa
.77673 0 m
.77673 .00625 L
s
[(1500)] .77673 -0.0125 0 1 Mshowa
.90215 0 m
.90215 .00625 L
s
[(1750)] .90215 -0.0125 0 1 Mshowa
.125 Mabswid
.04927 0 m
.04927 .00375 L
s
.07436 0 m
.07436 .00375 L
s
.09944 0 m
.09944 .00375 L
s
.12453 0 m
.12453 .00375 L
s
.1747 0 m
.1747 .00375 L
s
.19978 0 m
.19978 .00375 L
s
.22487 0 m
.22487 .00375 L
s
.24995 0 m
.24995 .00375 L
s
.30012 0 m
.30012 .00375 L
s
.3252 0 m
.3252 .00375 L
s
.35029 0 m
.35029 .00375 L
s
.37537 0 m
.37537 .00375 L
s
.42554 0 m
.42554 .00375 L
s
.45063 0 m
.45063 .00375 L
s
.47571 0 m
.47571 .00375 L
s
.5008 0 m
.5008 .00375 L
s
.55097 0 m
.55097 .00375 L
s
.57605 0 m
.57605 .00375 L
s
.60114 0 m
.60114 .00375 L
s
.62622 0 m
.62622 .00375 L
s
.67639 0 m
.67639 .00375 L
s
.70148 0 m
.70148 .00375 L
s
.72656 0 m
.72656 .00375 L
s
.75164 0 m
.75164 .00375 L
s
.80181 0 m
.80181 .00375 L
s
.8269 0 m
.8269 .00375 L
s
.85198 0 m
.85198 .00375 L
s
.87707 0 m
.87707 .00375 L
s
.92724 0 m
.92724 .00375 L
s
.95232 0 m
.95232 .00375 L
s
.97741 0 m
.97741 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
gsave
.5 -0.0125 -84.4375 -26.1875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 21.1875 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(Re) show
%%IncludeResource: font Mathematica2Mono
%%IncludeFont: Mathematica2Mono
/Mathematica2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
75.250 13.313 moveto
(@) show
81.375 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(1) show
%%IncludeResource: font Mathematica2Mono
%%IncludeFont: Mathematica2Mono
/Mathematica2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
87.500 13.313 moveto
(\\220) show
93.625 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
%%IncludeResource: font Mathematica2Mono
%%IncludeFont: Mathematica2Mono
/Mathematica2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
99.750 13.313 moveto
(D) show
105.875 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 .05566 m
.00625 .05566 L
s
[(-6000)] -0.0125 .05566 1 0 Mshowa
0 .14012 m
.00625 .14012 L
s
[(-4000)] -0.0125 .14012 1 0 Mshowa
0 .22457 m
.00625 .22457 L
s
[(-2000)] -0.0125 .22457 1 0 Mshowa
0 .30902 m
.00625 .30902 L
s
[(0)] -0.0125 .30902 1 0 Mshowa
0 .39347 m
.00625 .39347 L
s
[(2000)] -0.0125 .39347 1 0 Mshowa
0 .47792 m
.00625 .47792 L
s
[(4000)] -0.0125 .47792 1 0 Mshowa
0 .56237 m
.00625 .56237 L
s
[(6000)] -0.0125 .56237 1 0 Mshowa
.125 Mabswid
0 .07678 m
.00375 .07678 L
s
0 .09789 m
.00375 .09789 L
s
0 .119 m
.00375 .119 L
s
0 .16123 m
.00375 .16123 L
s
0 .18234 m
.00375 .18234 L
s
0 .20345 m
.00375 .20345 L
s
0 .24568 m
.00375 .24568 L
s
0 .26679 m
.00375 .26679 L
s
0 .2879 m
.00375 .2879 L
s
0 .33013 m
.00375 .33013 L
s
0 .35124 m
.00375 .35124 L
s
0 .37236 m
.00375 .37236 L
s
0 .41458 m
.00375 .41458 L
s
0 .43569 m
.00375 .43569 L
s
0 .45681 m
.00375 .45681 L
s
0 .49903 m
.00375 .49903 L
s
0 .52014 m
.00375 .52014 L
s
0 .54126 m
.00375 .54126 L
s
0 .03455 m
.00375 .03455 L
s
0 .01344 m
.00375 .01344 L
s
0 .58348 m
.00375 .58348 L
s
0 .6046 m
.00375 .6046 L
s
.25 Mabswid
0 0 m
0 .61803 L
s
gsave
-0.01875 .30902 -137.875 -10.5938 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 21.1875 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(Im) show
%%IncludeResource: font Mathematica2Mono
%%IncludeFont: Mathematica2Mono
/Mathematica2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
75.250 13.313 moveto
(@) show
81.375 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(1) show
%%IncludeResource: font Mathematica2Mono
%%IncludeFont: Mathematica2Mono
/Mathematica2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
87.500 13.313 moveto
(\\220) show
93.625 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
%%IncludeResource: font Mathematica2Mono
%%IncludeFont: Mathematica2Mono
/Mathematica2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
99.750 13.313 moveto
(D) show
105.875 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02419 .61178 m
.02419 .61803 L
s
.14961 .61178 m
.14961 .61803 L
s
.27504 .61178 m
.27504 .61803 L
s
.40046 .61178 m
.40046 .61803 L
s
.52588 .61178 m
.52588 .61803 L
s
.65131 .61178 m
.65131 .61803 L
s
.77673 .61178 m
.77673 .61803 L
s
.90215 .61178 m
.90215 .61803 L
s
.125 Mabswid
.04927 .61428 m
.04927 .61803 L
s
.07436 .61428 m
.07436 .61803 L
s
.09944 .61428 m
.09944 .61803 L
s
.12453 .61428 m
.12453 .61803 L
s
.1747 .61428 m
.1747 .61803 L
s
.19978 .61428 m
.19978 .61803 L
s
.22487 .61428 m
.22487 .61803 L
s
.24995 .61428 m
.24995 .61803 L
s
.30012 .61428 m
.30012 .61803 L
s
.3252 .61428 m
.3252 .61803 L
s
.35029 .61428 m
.35029 .61803 L
s
.37537 .61428 m
.37537 .61803 L
s
.42554 .61428 m
.42554 .61803 L
s
.45063 .61428 m
.45063 .61803 L
s
.47571 .61428 m
.47571 .61803 L
s
.5008 .61428 m
.5008 .61803 L
s
.55097 .61428 m
.55097 .61803 L
s
.57605 .61428 m
.57605 .61803 L
s
.60114 .61428 m
.60114 .61803 L
s
.62622 .61428 m
.62622 .61803 L
s
.67639 .61428 m
.67639 .61803 L
s
.70148 .61428 m
.70148 .61803 L
s
.72656 .61428 m
.72656 .61803 L
s
.75164 .61428 m
.75164 .61803 L
s
.80181 .61428 m
.80181 .61803 L
s
.8269 .61428 m
.8269 .61803 L
s
.85198 .61428 m
.85198 .61803 L
s
.87707 .61428 m
.87707 .61803 L
s
.92724 .61428 m
.92724 .61803 L
s
.95232 .61428 m
.95232 .61803 L
s
.97741 .61428 m
.97741 .61803 L
s
.25 Mabswid
0 .61803 m
1 .61803 L
s
gsave
.5 .63053 -66.0625 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 21.1875 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.125 13.313 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.99375 .05566 m
1 .05566 L
s
.99375 .14012 m
1 .14012 L
s
.99375 .22457 m
1 .22457 L
s
.99375 .30902 m
1 .30902 L
s
.99375 .39347 m
1 .39347 L
s
.99375 .47792 m
1 .47792 L
s
.99375 .56237 m
1 .56237 L
s
.125 Mabswid
.99625 .07678 m
1 .07678 L
s
.99625 .09789 m
1 .09789 L
s
.99625 .119 m
1 .119 L
s
.99625 .16123 m
1 .16123 L
s
.99625 .18234 m
1 .18234 L
s
.99625 .20345 m
1 .20345 L
s
.99625 .24568 m
1 .24568 L
s
.99625 .26679 m
1 .26679 L
s
.99625 .2879 m
1 .2879 L
s
.99625 .33013 m
1 .33013 L
s
.99625 .35124 m
1 .35124 L
s
.99625 .37236 m
1 .37236 L
s
.99625 .41458 m
1 .41458 L
s
.99625 .43569 m
1 .43569 L
s
.99625 .45681 m
1 .45681 L
s
.99625 .49903 m
1 .49903 L
s
.99625 .52014 m
1 .52014 L
s
.99625 .54126 m
1 .54126 L
s
.99625 .03455 m
1 .03455 L
s
.99625 .01344 m
1 .01344 L
s
.99625 .58348 m
1 .58348 L
s
.99625 .6046 m
1 .6046 L
s
.25 Mabswid
1 0 m
1 .61803 L
s
gsave
1.0125 .30902 -61 -10.5938 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 21.1875 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.125 13.313 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 .30902 m
1 .30902 L
s
.5 Mabswid
.97619 .60332 m
.79763 .5325 L
.62303 .46921 L
.47867 .42179 L
.35827 .38601 L
.25057 .35729 L
.16737 .33751 L
.1012 .32352 L
.0586 .31546 L
.03529 .31136 L
.02897 .31024 L
.02525 .30952 L
.02441 .30932 L
.02412 .30924 L
.02395 .30918 L
.02389 .30915 L
.02385 .30913 L
.02383 .30912 L
.02382 .30911 L
.02382 .3091 L
.02381 .30909 L
.02381 .30908 L
.02381 .30907 L
.02381 .30907 L
.02382 .30906 L
.02382 .30906 L
.02383 .30905 L
.02384 .30905 L
.02386 .30904 L
.02388 .30903 L
.02392 .30903 L
.02396 .30902 L
.024 .30902 L
.02404 .30901 L
.02407 .30901 L
.02409 .30901 L
.02411 .30901 L
.02413 .30901 L
.02415 .30901 L
.02417 .30901 L
.02418 .30901 L
.02419 .30901 L
.02421 .30901 L
.02422 .30901 L
.02424 .30901 L
.02425 .30901 L
.02426 .30901 L
.02427 .30901 L
.02428 .30901 L
.02429 .30901 L
Mistroke
.0243 .30901 L
.02431 .30901 L
.02431 .30902 L
.02431 .30902 L
.02431 .30902 L
.02431 .30902 L
.02431 .30902 L
.02431 .30902 L
.02431 .30902 L
.0243 .30902 L
.02429 .30902 L
.02428 .30902 L
.02427 .30902 L
.02425 .30902 L
.02424 .30903 L
.02423 .30903 L
.02421 .30903 L
.0242 .30903 L
.02419 .30903 L
.02418 .30903 L
.02417 .30903 L
.02416 .30903 L
.02414 .30903 L
.02413 .30903 L
.02411 .30903 L
.02409 .30902 L
.02407 .30902 L
.02403 .30902 L
.02398 .30902 L
.02393 .30901 L
.0239 .309 L
.02388 .309 L
.02386 .30899 L
.02385 .30899 L
.02384 .30898 L
.02383 .30898 L
.02382 .30897 L
.02381 .30897 L
.02381 .30896 L
.02381 .30895 L
.02381 .30895 L
.02381 .30894 L
.02382 .30893 L
.02382 .30893 L
.02385 .30891 L
.02388 .30889 L
.02393 .30886 L
.02408 .30881 L
.02471 .30864 L
.02576 .30841 L
Mistroke
.03644 .30648 L
.0604 .30225 L
.1046 .29384 L
.16715 .28057 L
.25572 .25945 L
.36225 .2309 L
.48383 .19463 L
.63322 .1453 L
.79597 .08617 L
.97619 .01472 L
Mfstroke
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  CellLabel->"From In[132]:=",
  ImageSize->{288, 177.938},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004P0000/A000`40O003h00Oogoo8Goo003oOolQ
Ool00?moob5oo`00ogoo8Goo003oOolQOol00?moob5oo`00ogoo8Goo003oOolQOol00?moob5oo`00
ogoo8Goo003oOolQOol00:]oo`8000ioo`<000=oo`8005eoo`00Zgoo00<007ooOol01goo00<007oo
Ool01Woo00D007ooOomoo`0005eoo`00W7oo0`000Woo00<007ooOol00`0017oo00@007ooOomoo`D0
009oo`03001oogoo00=oo`<000=oo`03001oogoo05]oo`00WGoo00@007ooOol0009oo`03001oogoo
00Eoo`03001oogoo00=oo`03001oogoo009oo`03001oogoo009oo`04001oogoo0003Ool00`00Oomo
o`1KOol009eoo`<000=oo`@000Aoo`03001oogoo00=oo`03001oogoo009oo`03001oogoo009oo`04
001oogoo0003Ool00`00Oomoo`1KOol009eoo`04001oogoo0003Ool20005Ool00`00Oomoo`03Ool0
0`00Oomoo`03Ool00`00Oomoo`02Ool40002Ool00`00Oomoo`1KOol009eoo`04001oogoo000:Ool0
0`00Oomoo`03Ool00`00Oomoo`03Ool00`00Oomoo`08Ool00`00Oomoo`1KOol009aoo`@000]oo`80
00=oo`8000Ioo`03001oogoo00Ioo`8005eoo`00ogoo8Goo003oOolQOol00?moob5oo`00E7oo0P00
3goo10000goo0P0017oo0P002Woo0P0017oo0P0017oo0P0037oo00<007ooOol00Woo0P0017oo0P00
1Woo1@000Woo0P0017oo0P0017oo0P000goo1@0000=oo`0000000P000goo0P0017oo0P0017oo1@00
0Woo0P0017oo0P0017oo0P000goo1@000goo00<007ooOol00Woo0P0017oo0P005goo001COol01000
Oomoo`003Woo00<007ooOol00goo00@007ooOol0009oo`04001oogoo0008Ool01000Oomoo`000Woo
00@007ooOol0009oo`04001oogoo000;Ool01@00Oomoogoo00000Woo00@007ooOol0009oo`03001o
ogoo00Eoo`05001oogooOol00002Ool01000Oomoo`000Woo00@007ooOol0009oo`03001oogoo009o
o`05001oogooOol00005Ool01000Oomoo`000Woo00@007ooOol000Eoo`05001oogooOol00002Ool0
1000Oomoo`000Woo00@007ooOol0009oo`03001oogoo009oo`03001oogoo00=oo`05001oogooOol0
0002Ool01000Oomoo`000Woo00<007ooOol057oo001COol01000Oomoo`003goo00<007ooOol01Goo
00@007ooOol0009oo`03001oogoo00Uoo`04001oogoo0002Ool01000Oomoo`000Woo00<007ooOol0
2Goo00<007ooOol017oo00@007ooOol0009oo`03001oogoo00Eoo`05001oogooOol00002Ool01000
Oomoo`000Woo00@007ooOol0009oo`03001oogoo009oo`03001oogoo009oo`03001oogoo00Eoo`04
001oogoo0002Ool00`00Oomoo`03Ool00`00Oomoo`04Ool01000Oomoo`000Woo00@007ooOol0009o
o`03001oogoo009oo`03001oogoo00=oo`03001oogoo00Aoo`04001oogoo0002Ool00`00Oomoo`0D
Ool005=oo`04001oogoo000@Ool00`00Oomoo`02Ool20003Ool01000Oomoo`002Goo0P000goo00@0
07ooOol0009oo`04001oogoo000<Ool01000Oomoogoo0P000goo00@007ooOol000Moo`05001oogoo
Ool00002Ool01000Oomoo`000Woo00@007ooOol0009oo`03001oogoo009oo`03001oogoo00=oo`03
001oogoo009oo`8000=oo`04001oogoo0005Ool00`00Oomoo`02Ool20003Ool01000Oomoo`000Woo
00@007ooOol000Aoo`03001oogoo00Aoo`04001oogooOol20003Ool01000Oomoo`005Woo001COol0
1000Oomoo`003Woo00@007ooOol000=oo`03001oogoo009oo`04001oogoo0009Ool00`00Oomoo`02
Ool01000Oomoo`000Woo00@007ooOol000Uoo`04001oogoo0003Ool00`00Oomoo`02Ool01000Oomo
o`001goo00D007ooOomoo`00009oo`04001oogoo0002Ool01000Oomoo`000Woo00<007ooOol00Woo
00D007ooOomoo`00009oo`05001oogooOol00004Ool01000Oomoo`001Goo00<007ooOol00Woo00<0
07ooOol00Woo00@007ooOol0009oo`04001oogoo0004Ool01@00Oomoogoo00000Woo00D007ooOomo
o`0000Aoo`04001oogoo000FOol005Aoo`80011oo`8000Aoo`<000=oo`8000Yoo`<000=oo`8000Ao
o`8000Yoo`@000=oo`<000=oo`8000Moo`8000Aoo`8000Aoo`8000Aoo`8000Aoo`8000Aoo`8000Ao
o`<000=oo`8000Eoo`8000Aoo`<000=oo`8000Aoo`8000Aoo`8000=oo`@000=oo`<000=oo`8001Mo
o`00ogoo8Goo003oOolQOol00?moob5oo`00ogoo8Goo003oOolQOol0051ool<000eoo`00D7oo00<0
07ooOol00Woo00<007ooOol05Goo00<007ooOol05Goo00<007ooOol05Woo00<007ooOol05Goo00<0
07ooOol05Goo00<007ooOol05Woo00<007ooOol05Goo00<007ooOol047oo00<007ooOol02goo001@
Ool2002jOol20003Ool2000=Ool0051oo`03001oogoo0;Moo`8000Ioo`03001oogoo00]oo`00D7oo
00<007ooOol0]7oo0`0027oo00<007ooOol02goo001@Ool00`00Oomoo`2bOol2000;Ool00`00Oomo
o`0;Ool0051oo`800;1oo`<000aoo`8000eoo`00D7oo00<007ooOol0[Goo0P0047oo00<007ooOol0
2goo000gOol30004Ool20004Ool20004Ool20004Ool00`00Oomoo`2ZOol3000BOol00`00Oomoo`0;
Ool003Moo`04001oogoo0002Ool01000Oomoo`000Woo00@007ooOol0009oo`04001oogoo0003Ool0
0`00Oomoo`2XOol2000EOol00`00Oomoo`0;Ool003Moo`04001oogoo0002Ool01000Oomoo`000Woo
00@007ooOol0009oo`04001oogoo0003Ool2002VOol3000FOol2000=Ool0035oo`@0009oo`<000=o
o`04001oogoo0002Ool01000Oomoo`000Woo00@007ooOol000=oo`03001oogoo0:=oo`8001Yoo`03
001oogoo00]oo`00>7oo00<007ooOol00Woo00@007ooOol0009oo`04001oogoo0002Ool01000Oomo
o`000goo00<007ooOol0X7oo0`0077oo00<007ooOol02goo000hOol30003Ool20004Ool20004Ool2
0004Ool00`00Oomoo`2NOol2000OOol00`00Oomoo`0;Ool0051oo`8009aoo`<0021oo`8000eoo`00
D7oo00<007ooOol0VGoo0P0097oo00<007ooOol02goo001@Ool00`00Oomoo`2FOol3000VOol00`00
Oomoo`0;Ool0051oo`03001oogoo09Aoo`8002Uoo`03001oogoo00]oo`00D7oo00<007ooOol0TGoo
0`00:goo00<007ooOol02goo001@Ool2002?Ool3000]Ool2000=Ool0051oo`03001oogoo08aoo`80
035oo`03001oogoo00]oo`00D7oo00<007ooOol0RGoo0`00<goo00<007ooOol02goo001@Ool00`00
Oomoo`27Ool2000fOol00`00Oomoo`0;Ool0051oo`8008Eoo`<003Moo`8000eoo`00D7oo00<007oo
Ool0PWoo0P00>goo00<007ooOol02goo000iOol30002Ool20004Ool20004Ool20004Ool00`00Oomo
o`1oOol3000mOol00`00Oomoo`0;Ool003Yoo`04001oogoo0002Ool01000Oomoo`000Woo00@007oo
Ool0009oo`05001oogooOol0001nOol30010Ool00`00Oomoo`0;Ool003Moo`D00005Ool007ooOol0
0002Ool01000Oomoo`000Woo00@007ooOol000=oo`8007]oo`80049oo`8000eoo`00<Goo10000Woo
00@007ooOol0009oo`04001oogoo0002Ool01000Oomoo`000Woo00@007ooOol000=oo`03001oogoo
07Moo`<004Eoo`03001oogoo00]oo`00>7oo00<007oo00000Woo00@007ooOol0009oo`04001oogoo
0002Ool01000Oomoo`000goo00<007ooOol0M7oo0`00B7oo00<007ooOol02goo000iOol20003Ool2
0004Ool20004Ool20004Ool00`00Oomoo`1`Ool4001;Ool00`00Oomoo`0;Ool0051oo`8006ioo`<0
04ioo`8000eoo`00D7oo00<007ooOol0JWoo0`00DWoo00<007ooOol02goo001@Ool00`00Oomoo`1W
Ool3001EOol00`00Oomoo`0;Ool0051oo`03001oogoo06Aoo`<005Qoo`03001oogoo00]oo`00D7oo
0P00HGoo1000FWoo0P003Goo001@Ool00`00Oomoo`1MOol3001OOol00`00Oomoo`0;Ool0051oo`03
001oogoo05Yoo`<0069oo`03001oogoo00]oo`00D7oo00<007ooOol0EWoo1000IGoo00<007ooOol0
2goo001@Ool2001DOol3001XOol2000=Ool0051oo`03001oogoo051oo`<006aoo`03001oogoo00]o
o`00=goo10000goo0P0017oo0P0017oo0P0017oo00<007ooOol0C7oo1000Kgoo00<007ooOol02goo
000gOol00`00Oomoo`03Ool01000Oomoo`000Woo00@007ooOol0009oo`04001oogoo0003Ool00`00
Oomoo`19Ool3001cOol00`00Oomoo`0;Ool003Qoo`03001oogoo009oo`04001oogoo0002Ool01000
Oomoo`000Woo00@007ooOol000=oo`8004Ioo`@007Eoo`8000eoo`00<Goo100017oo00D007ooOomo
o`00009oo`04001oogoo0002Ool01000Oomoo`000Woo00D007ooOomoo`0004Aoo`<007Yoo`03001o
ogoo00]oo`00=goo00@007ooOol0009oo`04001oogoo0002Ool01000Oomoo`000Woo00@007ooOol0
00=oo`03001oogoo03moo`<007eoo`03001oogoo00]oo`00>7oo0P0017oo0P0017oo0P0017oo0P00
17oo00<007ooOol0>goo1000P7oo00<007ooOol02goo001@Ool2000iOol30023Ool2000=Ool0051o
o`03001oogoo03Eoo`<008Moo`03001oogoo00]oo`00D7oo00<007ooOol0<Goo1000RWoo00<007oo
Ool02goo001@Ool00`00Oomoo`0]Ool4002>Ool00`00Oomoo`0;Ool0051oo`8002Yoo`@0095oo`80
00eoo`00D7oo00<007ooOol097oo1@00UWoo00<007ooOol02goo001@Ool00`00Oomoo`0POol4002K
Ool00`00Oomoo`0;Ool0051oo`03001oogoo01aoo`@009moo`03001oogoo00]oo`00D7oo0P006Goo
1000XWoo0P003Goo000AOol2000>Ool30003Ool2000WOol00`00Oomoo`0DOol4002WOol00`00Oomo
o`0;Ool0015oo`03001oogoo00Moo`03001oogoo00Ioo`05001oogooOol0000WOol00`00Oomoo`0>
Ool6002[Ool00`00Oomoo`0;Ool000Aoo`<00007Ool00000Ool007oo00000goo00@007ooOomoo`D0
009oo`03001oogoo00=oo`<000=oo`03001oogoo01moo`8000Aoo`03001oogoo00Moo`L00;5oo`03
001oogoo00]oo`001Goo00T007ooOomoo`00Ool007oo00000goo00<007ooOol00goo00<007ooOol0
0Woo00<007ooOol00Woo00@007ooOol000=oo`03001oogoo01ioo`04001oogoo0003Ool00`00Oomo
o`02Ool5002hOol00`00Oomoo`0;Ool000Eoo`09001oogooOol007oo001oo`0000=oo`03001oogoo
00=oo`03001oogoo009oo`03001oogoo009oo`04001oogoo0003Ool00`00Oomoo`0NOol01000Oomo
o`000goo``003Goo0005Ool00`00Oomoo`0300000goo001oo`03Ool00`00Oomoo`03Ool00`00Oomo
o`03Ool00`00Oomoo`02Ool40002Ool00`00Oomoo`0NOol01000Oomoo`000goo00<007ooOol01Woo
1`00/Woo00<007ooOol02goo0005Ool00`00Oomoo`09Ool00`00Oomoo`03Ool00`00Oomoo`03Ool0
0`00Oomoo`08Ool00`00Oomoo`0NOol01000Oomoo`000goo00<007ooOol03Goo1P00[7oo00<007oo
Ool02goo0004Ool3000:Ool20003Ool20006Ool00`00Oomoo`06Ool2000QOol20004Ool00`00Oomo
o`0COol4002XOol00`00Oomoo`0;Ool0051oo`8001Qoo`@00:=oo`8000eoo`00D7oo00<007ooOol0
6goo1@00Wgoo00<007ooOol02goo001@Ool00`00Oomoo`0POol4002KOol00`00Oomoo`0;Ool0051o
o`03001oogoo02Aoo`@009Moo`03001oogoo00]oo`00D7oo0P00:Goo1000TWoo0P003Goo001@Ool0
0`00Oomoo`0/Ool4002?Ool00`00Oomoo`0;Ool0051oo`03001oogoo031oo`@008]oo`03001oogoo
00]oo`00D7oo00<007ooOol0=7oo1000Qgoo00<007ooOol02goo001@Ool2000iOol40022Ool2000=
Ool0051oo`03001oogoo03aoo`@007moo`03001oogoo00]oo`00=goo10000goo0P0017oo0P0017oo
0P0017oo00<007ooOol0@7oo1000Ngoo00<007ooOol02goo000gOol00`00Oomoo`03Ool01000Oomo
o`000Woo00@007ooOol0009oo`04001oogoo0003Ool00`00Oomoo`14Ool4001gOol00`00Oomoo`0;
Ool003Qoo`03001oogoo009oo`04001oogoo0002Ool01000Oomoo`000Woo00@007ooOol000=oo`80
04Uoo`<007=oo`8000eoo`00>Goo00D007ooOomoo`00009oo`04001oogoo0002Ool01000Oomoo`00
0Woo00D007ooOomoo`0004eoo`<0075oo`03001oogoo00]oo`00=goo00@007ooOol0009oo`04001o
ogoo0002Ool01000Oomoo`000Woo00@007ooOol000=oo`03001oogoo04ioo`@006eoo`03001oogoo
00]oo`00>7oo0P0017oo0P0017oo0P0017oo0P0017oo00<007ooOol0DWoo0`00JWoo00<007ooOol0
2goo001@Ool2001FOol4001UOol2000=Ool0051oo`03001oogoo05Uoo`<006=oo`03001oogoo00]o
o`00D7oo00<007ooOol0G7oo0`00H7oo00<007ooOol02goo001@Ool00`00Oomoo`1OOol2001NOol0
0`00Oomoo`0;Ool0051oo`80069oo`<005Yoo`8000eoo`00D7oo00<007ooOol0I7oo0`00F7oo00<0
07ooOol02goo001@Ool00`00Oomoo`1WOol3001EOol00`00Oomoo`0;Ool0051oo`03001oogoo06Yo
o`<0059oo`03001oogoo00]oo`00D7oo0P00KWoo0P00Cgoo0P003Goo001@Ool00`00Oomoo`1_Ool3
001=Ool00`00Oomoo`0;Ool003Uoo`<0009oo`8000Aoo`8000Aoo`8000Aoo`03001oogoo079oo`<0
04Yoo`03001oogoo00]oo`00>Woo00@007ooOol0009oo`04001oogoo0002Ool01000Oomoo`000Woo
00D007ooOomoo`0007Moo`<004Moo`03001oogoo00]oo`00=goo1@0000Eoo`00Oomoo`00009oo`04
001oogoo0002Ool01000Oomoo`000goo0P00NGoo0`00@goo0P003Goo000gOol01000Oomoo`000Woo
00@007ooOol0009oo`04001oogoo0002Ool01000Oomoo`000goo00<007ooOol0Ngoo0`00@Goo00<0
07ooOol02goo000hOol00`00Ool00002Ool01000Oomoo`000Woo00@007ooOol0009oo`04001oogoo
0003Ool00`00Oomoo`1nOol2000oOol00`00Oomoo`0;Ool003Uoo`8000=oo`8000Aoo`8000Aoo`80
00Aoo`03001oogoo081oo`<003aoo`03001oogoo00]oo`00D7oo0P00Q7oo0`00>7oo0P003Goo001@
Ool00`00Oomoo`26Ool3000fOol00`00Oomoo`0;Ool0051oo`03001oogoo08Uoo`<003=oo`03001o
ogoo00]oo`00D7oo00<007ooOol0S7oo0`00<7oo00<007ooOol02goo001@Ool2002@Ool2000]Ool2
000=Ool0051oo`03001oogoo095oo`<002]oo`03001oogoo00]oo`00D7oo00<007ooOol0U7oo0`00
:7oo00<007ooOol02goo001@Ool00`00Oomoo`2GOol3000UOol00`00Oomoo`0;Ool0051oo`03001o
ogoo09Yoo`8002=oo`03001oogoo00]oo`00D7oo0P00WGoo0`007goo0P003Goo001@Ool00`00Oomo
o`2OOol2000NOol00`00Oomoo`0;Ool003Moo`<000Aoo`8000Aoo`8000Aoo`8000Aoo`03001oogoo
0:5oo`8001aoo`03001oogoo00]oo`00=goo00@007ooOol0009oo`04001oogoo0002Ool01000Oomo
o`000Woo00@007ooOol000=oo`03001oogoo0:=oo`<001Uoo`03001oogoo00]oo`00=goo00@007oo
Ool0009oo`04001oogoo0002Ool01000Oomoo`000Woo00@007ooOol000=oo`800:Moo`8001Ioo`80
00eoo`00=goo0`000goo00@007ooOol0009oo`04001oogoo0002Ool01000Oomoo`000goo00<007oo
Ool0Z7oo0`0057oo00<007ooOol02goo000hOol00`00Oomoo`02Ool01000Oomoo`000Woo00@007oo
Ool0009oo`04001oogoo0003Ool00`00Oomoo`2[Ool2000BOol00`00Oomoo`0;Ool003Qoo`<000=o
o`8000Aoo`8000Aoo`8000Aoo`03001oogoo0:eoo`<000moo`03001oogoo00]oo`00D7oo0P00/Goo
0P0037oo0P003Goo001@Ool00`00Oomoo`2bOol2000;Ool00`00Oomoo`0;Ool0051oo`03001oogoo
0;Aoo`<000Qoo`03001oogoo00]oo`00D7oo00<007ooOol0]goo0P001Woo00<007ooOol02goo001@
Ool2002jOol20003Ool2000=Ool0051oo`03001oogoo009oo`03001oogoo01Eoo`03001oogoo01Eo
o`03001oogoo01Ioo`03001oogoo01Eoo`03001oogoo01Eoo`03001oogoo01Ioo`03001oogoo01Eo
o`03001oogoo011oo`03001oogoo00]oo`00D7oo``003Goo003oOolQOol00?moob5oo`00ogoo8Goo
003oOolQOol00?moob5oo`00ogoo8Goo003oOolQOol00?moob5oo`00ogoo8Goo003oOolQOol00?mo
ob5oo`00ogoo8Goo003oOolQOol00?moob5oo`00ogoo8Goo003oOolQOol00?moob5oo`00ogoo8Goo
003oOolQOol00?moob5oo`00ogoo8Goo003oOolQOol00?moob5oo`00ogoo8Goo0000\
\>"],
  ImageRangeCache->{{{0, 287}, {176.938, 0}} -> {-875.701, -11352.8, 10.2778, \
122.113}},
  CellTags->{"Nyquist Plot", "i:10", "b:20.2"}],

Cell[BoxData[
    TagBox[\(\[SkeletonIndicator]  Graphics  \[SkeletonIndicator]\),
      False,
      Editable->False]], "Output",
  CellLabel->"Out[132]=",
  CellTags->{"Nyquist Plot", "i:10", "b:20.2"}]
}, Open  ]],

Cell["\<\
We can also get a color version of the same plot. For variety, we choose a \
frequency range of -4 to +4 radians per second and specify a frequency \
increment of 0.01.\
\>", "Text",
  Evaluatable->False,
  AspectRatioFixed->True,
  CellTags->{"Nyquist Plot", "i:10", "b:20.2"}],

Cell[CellGroupData[{

Cell[BoxData[
    \(ND = ColorNyquist[G, s, \(-4. \), \(+4. \),  .01]\)], "Input",
  CellLabel->"In[133]:=",
  PageWidth->Infinity,
  AspectRatioFixed->True,
  CellTags->{"Nyquist Plot", "i:10", "b:20.2"}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: 1.4104 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.438894 0.671621 0.705202 0.671621 [
[ 0 0 0 0 ]
[ 1 1.4104 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
% Start of sub-graphic
p
0.0238095 0.033581 0.853978 1.37682 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.433984 0.135552 0.809017 0.170266 [
[.02733 -0.0125 -6 -9 ]
[.02733 -0.0125 6 0 ]
[.16288 -0.0125 -6 -9 ]
[.16288 -0.0125 6 0 ]
[.29843 -0.0125 -6 -9 ]
[.29843 -0.0125 6 0 ]
[.43398 -0.0125 -3 -9 ]
[.43398 -0.0125 3 0 ]
[.56954 -0.0125 -3 -9 ]
[.56954 -0.0125 3 0 ]
[.70509 -0.0125 -3 -9 ]
[.70509 -0.0125 3 0 ]
[.84064 -0.0125 -3 -9 ]
[.84064 -0.0125 3 0 ]
[.97619 -0.0125 -3 -9 ]
[.97619 -0.0125 3 0 ]
[ 0 0 -0.125 0 ]
[.5 -0.0125 -17.3125 -22.1875 ]
[.5 -0.0125 17.3125 -9 ]
[-0.0125 .12795 -12 -4.5 ]
[-0.0125 .12795 0 4.5 ]
[-0.0125 .46849 -12 -4.5 ]
[-0.0125 .46849 0 4.5 ]
[-0.0125 .80902 -6 -4.5 ]
[-0.0125 .80902 0 4.5 ]
[-0.0125 1.14955 -6 -4.5 ]
[-0.0125 1.14955 0 4.5 ]
[-0.0125 1.49008 -6 -4.5 ]
[-0.0125 1.49008 0 4.5 ]
[ 0 0 -0.125 0 ]
[-0.01875 .80902 -46.625 -6.59375 ]
[-0.01875 .80902 -12 6.59375 ]
[ 0 1.61803 .125 0 ]
[.5 1.63053 -5.0625 0 ]
[.5 1.63053 5.0625 13.1875 ]
[ 1 0 .125 0 ]
[1.0125 .80902 0 -6.59375 ]
[1.0125 .80902 10.125 6.59375 ]
[.5 1.63053 -103.75 13.1875 ]
[.5 1.63053 103.75 35.6875 ]
[ 0 0 0 0 ]
[ 1 1.61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.02733 0 m
.02733 .00625 L
s
[(-3)] .02733 -0.0125 0 1 Mshowa
.16288 0 m
.16288 .00625 L
s
[(-2)] .16288 -0.0125 0 1 Mshowa
.29843 0 m
.29843 .00625 L
s
[(-1)] .29843 -0.0125 0 1 Mshowa
.43398 0 m
.43398 .00625 L
s
[(0)] .43398 -0.0125 0 1 Mshowa
.56954 0 m
.56954 .00625 L
s
[(1)] .56954 -0.0125 0 1 Mshowa
.70509 0 m
.70509 .00625 L
s
[(2)] .70509 -0.0125 0 1 Mshowa
.84064 0 m
.84064 .00625 L
s
[(3)] .84064 -0.0125 0 1 Mshowa
.97619 0 m
.97619 .00625 L
s
[(4)] .97619 -0.0125 0 1 Mshowa
.125 Mabswid
.05444 0 m
.05444 .00375 L
s
.08155 0 m
.08155 .00375 L
s
.10866 0 m
.10866 .00375 L
s
.13577 0 m
.13577 .00375 L
s
.18999 0 m
.18999 .00375 L
s
.2171 0 m
.2171 .00375 L
s
.24421 0 m
.24421 .00375 L
s
.27132 0 m
.27132 .00375 L
s
.32554 0 m
.32554 .00375 L
s
.35265 0 m
.35265 .00375 L
s
.37976 0 m
.37976 .00375 L
s
.40687 0 m
.40687 .00375 L
s
.46109 0 m
.46109 .00375 L
s
.4882 0 m
.4882 .00375 L
s
.51532 0 m
.51532 .00375 L
s
.54243 0 m
.54243 .00375 L
s
.59665 0 m
.59665 .00375 L
s
.62376 0 m
.62376 .00375 L
s
.65087 0 m
.65087 .00375 L
s
.67798 0 m
.67798 .00375 L
s
.7322 0 m
.7322 .00375 L
s
.75931 0 m
.75931 .00375 L
s
.78642 0 m
.78642 .00375 L
s
.81353 0 m
.81353 .00375 L
s
.86775 0 m
.86775 .00375 L
s
.89486 0 m
.89486 .00375 L
s
.92197 0 m
.92197 .00375 L
s
.94908 0 m
.94908 .00375 L
s
.00022 0 m
.00022 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
gsave
.5 -0.0125 -78.3125 -26.1875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 21.1875 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(Re) show
%%IncludeResource: font Mathematica2Mono
%%IncludeFont: Mathematica2Mono
/Mathematica2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
75.250 13.313 moveto
(@) show
81.375 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
%%IncludeResource: font Mathematica2Mono
%%IncludeFont: Mathematica2Mono
/Mathematica2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
87.500 13.313 moveto
(D) show
93.625 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 .12795 m
.00625 .12795 L
s
[(-4)] -0.0125 .12795 1 0 Mshowa
0 .46849 m
.00625 .46849 L
s
[(-2)] -0.0125 .46849 1 0 Mshowa
0 .80902 m
.00625 .80902 L
s
[(0)] -0.0125 .80902 1 0 Mshowa
0 1.14955 m
.00625 1.14955 L
s
[(2)] -0.0125 1.14955 1 0 Mshowa
0 1.49008 m
.00625 1.49008 L
s
[(4)] -0.0125 1.49008 1 0 Mshowa
.125 Mabswid
0 .21309 m
.00375 .21309 L
s
0 .29822 m
.00375 .29822 L
s
0 .38335 m
.00375 .38335 L
s
0 .55362 m
.00375 .55362 L
s
0 .63875 m
.00375 .63875 L
s
0 .72388 m
.00375 .72388 L
s
0 .89415 m
.00375 .89415 L
s
0 .97928 m
.00375 .97928 L
s
0 1.06442 m
.00375 1.06442 L
s
0 1.23468 m
.00375 1.23468 L
s
0 1.31981 m
.00375 1.31981 L
s
0 1.40495 m
.00375 1.40495 L
s
0 .04282 m
.00375 .04282 L
s
0 1.57521 m
.00375 1.57521 L
s
.25 Mabswid
0 0 m
0 1.61803 L
s
gsave
-0.01875 .80902 -107.625 -10.5938 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 21.1875 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(Im) show
%%IncludeResource: font Mathematica2Mono
%%IncludeFont: Mathematica2Mono
/Mathematica2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
75.250 13.313 moveto
(@) show
81.375 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
%%IncludeResource: font Mathematica2Mono
%%IncludeFont: Mathematica2Mono
/Mathematica2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
87.500 13.313 moveto
(D) show
93.625 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.02733 1.61178 m
.02733 1.61803 L
s
.16288 1.61178 m
.16288 1.61803 L
s
.29843 1.61178 m
.29843 1.61803 L
s
.43398 1.61178 m
.43398 1.61803 L
s
.56954 1.61178 m
.56954 1.61803 L
s
.70509 1.61178 m
.70509 1.61803 L
s
.84064 1.61178 m
.84064 1.61803 L
s
.97619 1.61178 m
.97619 1.61803 L
s
.125 Mabswid
.05444 1.61428 m
.05444 1.61803 L
s
.08155 1.61428 m
.08155 1.61803 L
s
.10866 1.61428 m
.10866 1.61803 L
s
.13577 1.61428 m
.13577 1.61803 L
s
.18999 1.61428 m
.18999 1.61803 L
s
.2171 1.61428 m
.2171 1.61803 L
s
.24421 1.61428 m
.24421 1.61803 L
s
.27132 1.61428 m
.27132 1.61803 L
s
.32554 1.61428 m
.32554 1.61803 L
s
.35265 1.61428 m
.35265 1.61803 L
s
.37976 1.61428 m
.37976 1.61803 L
s
.40687 1.61428 m
.40687 1.61803 L
s
.46109 1.61428 m
.46109 1.61803 L
s
.4882 1.61428 m
.4882 1.61803 L
s
.51532 1.61428 m
.51532 1.61803 L
s
.54243 1.61428 m
.54243 1.61803 L
s
.59665 1.61428 m
.59665 1.61803 L
s
.62376 1.61428 m
.62376 1.61803 L
s
.65087 1.61428 m
.65087 1.61803 L
s
.67798 1.61428 m
.67798 1.61803 L
s
.7322 1.61428 m
.7322 1.61803 L
s
.75931 1.61428 m
.75931 1.61803 L
s
.78642 1.61428 m
.78642 1.61803 L
s
.81353 1.61428 m
.81353 1.61803 L
s
.86775 1.61428 m
.86775 1.61803 L
s
.89486 1.61428 m
.89486 1.61803 L
s
.92197 1.61428 m
.92197 1.61803 L
s
.94908 1.61428 m
.94908 1.61803 L
s
.00022 1.61428 m
.00022 1.61803 L
s
.25 Mabswid
0 1.61803 m
1 1.61803 L
s
gsave
.5 1.63053 -66.0625 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 21.1875 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.125 13.313 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.99375 .12795 m
1 .12795 L
s
.99375 .46849 m
1 .46849 L
s
.99375 .80902 m
1 .80902 L
s
.99375 1.14955 m
1 1.14955 L
s
.99375 1.49008 m
1 1.49008 L
s
.125 Mabswid
.99625 .21309 m
1 .21309 L
s
.99625 .29822 m
1 .29822 L
s
.99625 .38335 m
1 .38335 L
s
.99625 .55362 m
1 .55362 L
s
.99625 .63875 m
1 .63875 L
s
.99625 .72388 m
1 .72388 L
s
.99625 .89415 m
1 .89415 L
s
.99625 .97928 m
1 .97928 L
s
.99625 1.06442 m
1 1.06442 L
s
.99625 1.23468 m
1 1.23468 L
s
.99625 1.31981 m
1 1.31981 L
s
.99625 1.40495 m
1 1.40495 L
s
.99625 .04282 m
1 .04282 L
s
.99625 1.57521 m
1 1.57521 L
s
.25 Mabswid
1 0 m
1 1.61803 L
s
gsave
1.0125 .80902 -61 -10.5938 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 21.1875 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.125 13.313 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.5 1.63053 -164.75 9.1875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 30.5 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding WindowsANSIEncoding def
        currentdict
    end

    newfontname exch definefont pop
} def

63.000 17.438 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
%%BeginResource: font Courier-MISO
%%BeginFont: Courier-MISO
/Courier /Courier-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-MISO
%%IncludeFont: Courier-MISO
/Courier-MISO findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 17.438 moveto
%%IncludeResource: font Courier-MISO
%%IncludeFont: Courier-MISO
/Courier-MISO findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(G) show
%%IncludeResource: font Mathematica2Mono
%%IncludeFont: Mathematica2Mono
/Mathematica2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
69.125 17.438 moveto
(@) show
75.250 17.438 moveto
%%IncludeResource: font Courier-MISO
%%IncludeFont: Courier-MISO
/Courier-MISO findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(s) show
%%IncludeResource: font Mathematica2Mono
%%IncludeFont: Mathematica2Mono
/Mathematica2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
81.375 17.438 moveto
(D) show
87.500 17.438 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(=) show
93.625 17.438 moveto
%%IncludeResource: font Courier-MISO
%%IncludeFont: Courier-MISO
/Courier-MISO findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
%%IncludeResource: font Mathematica2Mono
%%IncludeFont: Mathematica2Mono
/Mathematica2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
141.500 11.500 moveto
(H) show
147.625 11.500 moveto
%%IncludeResource: font Courier-Italic
%%IncludeFont: Courier-Italic
%%BeginResource: font Courier-Italic-MISO
%%BeginFont: Courier-Italic-MISO
/Courier-Italic /Courier-Italic-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Italic-MISO
%%IncludeFont: Courier-Italic-MISO
/Courier-Italic-MISO findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(s) show
156.188 11.500 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(+) show
164.750 11.500 moveto
%%IncludeResource: font Courier-MISO
%%IncludeFont: Courier-MISO
/Courier-MISO findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
%%IncludeResource: font Mathematica2Mono
%%IncludeFont: Mathematica2Mono
/Mathematica2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
170.875 11.500 moveto
(L) show
179.500 11.500 moveto
(H) show
185.625 11.500 moveto
%%IncludeResource: font Courier-Italic-MISO
%%IncludeFont: Courier-Italic-MISO
/Courier-Italic-MISO findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(s) show
194.188 11.500 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(+) show
202.750 11.500 moveto
%%IncludeResource: font Courier-MISO
%%IncludeFont: Courier-MISO
/Courier-MISO findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(10) show
%%IncludeResource: font Mathematica2Mono
%%IncludeFont: Mathematica2Mono
/Mathematica2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
215.000 11.500 moveto
(L) show
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
97.938 17.438 moveto
(\\200\\200\\200\\200\\200\\200\\200\\200\\200\\200\\200\\200\\200\\200\\200\\\
200\\200\\200\\200\\200\\200\\200\\200\\200\\200\\200\\200\\200\\200\\200\\\
200\\200) show
169.938 17.438 moveto
(\\200\\200\\200\\200\\200\\200\\200\\200\\200\\200\\200\\200\\200\\200\\200\\\
200\\200\\200\\200\\200\\200\\200\\200\\200\\200\\200\\200\\200\\200\\200\\\
200\\200) show
241.938 17.438 moveto
(\\200\\200\\200\\200\\200\\200\\200\\200) show
259.938 17.438 moveto
(\\200) show
262.188 17.438 moveto
(\\200) show
%%IncludeResource: font Mathematica2Mono
%%IncludeFont: Mathematica2Mono
/Mathematica2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
99.313 23.688 moveto
(H) show
105.438 23.688 moveto
%%IncludeResource: font Courier-Italic-MISO
%%IncludeFont: Courier-Italic-MISO
/Courier-Italic-MISO findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(s) show
114.000 23.688 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(+) show
122.563 23.688 moveto
%%IncludeResource: font Courier-MISO
%%IncludeFont: Courier-MISO
/Courier-MISO findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
%%IncludeResource: font Mathematica2Mono
%%IncludeFont: Mathematica2Mono
/Mathematica2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
128.688 23.688 moveto
(L) show
137.313 23.688 moveto
(H) show
143.438 23.688 moveto
%%IncludeResource: font Courier-Italic-MISO
%%IncludeFont: Courier-Italic-MISO
/Courier-Italic-MISO findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(s) show
149.563 21.125 moveto
%%IncludeResource: font Courier-MISO
%%IncludeFont: Courier-MISO
/Courier-MISO findfont 7.125 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
156.813 23.688 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(+) show
165.375 23.688 moveto
%%IncludeResource: font Courier-Italic-MISO
%%IncludeFont: Courier-Italic-MISO
/Courier-Italic-MISO findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(s) show
173.938 23.688 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(+) show
182.500 23.688 moveto
%%IncludeResource: font Courier-MISO
%%IncludeFont: Courier-MISO
/Courier-MISO findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(1) show
%%IncludeResource: font Mathematica2Mono
%%IncludeFont: Mathematica2Mono
/Mathematica2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
188.625 23.688 moveto
(L) show
197.250 23.688 moveto
(H) show
203.375 23.688 moveto
%%IncludeResource: font Courier-Italic-MISO
%%IncludeFont: Courier-Italic-MISO
/Courier-Italic-MISO findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(s) show
209.500 21.125 moveto
%%IncludeResource: font Courier-MISO
%%IncludeFont: Courier-MISO
/Courier-MISO findfont 7.125 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
216.750 23.688 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(+) show
225.313 23.688 moveto
%%IncludeResource: font Courier-MISO
%%IncludeFont: Courier-MISO
/Courier-MISO findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
233.938 23.688 moveto
%%IncludeResource: font Courier-Italic-MISO
%%IncludeFont: Courier-Italic-MISO
/Courier-Italic-MISO findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(s) show
242.500 23.688 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(+) show
251.063 23.688 moveto
%%IncludeResource: font Courier-MISO
%%IncludeFont: Courier-MISO
/Courier-MISO findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
%%IncludeResource: font Mathematica2Mono
%%IncludeFont: Mathematica2Mono
/Mathematica2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
257.188 23.688 moveto
(L) show
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 1.61803 L
0 1.61803 L
closepath
clip
newpath
.75 g
.5 Mabswid
.43398 .80902 m
0 0 rlineto s
.43398 .80902 m
1 .99952 L
s
.43398 .80902 m
0 0 rlineto s
.43398 .80902 m
1 1.2195 L
s
.43398 .80902 m
0 0 rlineto s
.43398 .80902 m
1 1.51999 L
s
.43398 .80902 m
0 0 rlineto s
.43398 .80902 m
.80584 1.61803 L
s
.43398 .80902 m
0 0 rlineto s
.43398 .80902 m
.60656 1.61803 L
s
.43398 .80902 m
0 0 rlineto s
.43398 .80902 m
.43398 1.61803 L
s
.43398 .80902 m
0 0 rlineto s
.43398 .80902 m
.26141 1.61803 L
s
.43398 .80902 m
0 0 rlineto s
.43398 .80902 m
.06213 1.61803 L
s
.43398 .80902 m
0 0 rlineto s
.43398 .80902 m
0 1.35414 L
s
.43398 .80902 m
0 0 rlineto s
.43398 .80902 m
0 1.12375 L
s
.43398 .80902 m
0 0 rlineto s
.43398 .80902 m
0 .95508 L
s
.43398 .80902 m
0 0 rlineto s
.43398 .80902 m
0 .80902 L
s
.43398 .80902 m
0 0 rlineto s
.43398 .80902 m
0 .66295 L
s
.43398 .80902 m
0 0 rlineto s
.43398 .80902 m
0 .49429 L
s
.43398 .80902 m
0 0 rlineto s
.43398 .80902 m
0 .26389 L
s
.43398 .80902 m
0 0 rlineto s
.43398 .80902 m
.06213 0 L
s
.43398 .80902 m
0 0 rlineto s
.43398 .80902 m
.26141 0 L
s
.43398 .80902 m
0 0 rlineto s
.43398 .80902 m
.43398 0 L
s
.43398 .80902 m
0 0 rlineto s
.43398 .80902 m
.60656 0 L
s
.43398 .80902 m
0 0 rlineto s
.43398 .80902 m
.80584 0 L
s
.43398 .80902 m
0 0 rlineto s
.43398 .80902 m
1 .09805 L
s
.43398 .80902 m
0 0 rlineto s
.43398 .80902 m
1 .39854 L
s
.43398 .80902 m
0 0 rlineto s
.43398 .80902 m
1 .61851 L
s
.43398 .80902 m
0 0 rlineto s
.43398 .80902 m
1 .80902 L
s
.52887 .80902 m
.52812 .82395 L
.52589 .83866 L
.52221 .85289 L
.51713 .86644 L
.51075 .87907 L
.50315 .89061 L
.49447 .90085 L
.48483 .90965 L
.47438 .91686 L
.46331 .92237 L
.45176 .92609 L
.43994 .92797 L
.42803 .92797 L
.4162 .92609 L
.40466 .92237 L
.39358 .91686 L
.38314 .90965 L
.3735 .90085 L
.36482 .89061 L
.35722 .87907 L
.35083 .86644 L
.34576 .85289 L
.34208 .83866 L
.33985 .82395 L
.3391 .80902 L
.33985 .79408 L
.34208 .77938 L
.34576 .76514 L
.35083 .7516 L
.35722 .73896 L
.36482 .72743 L
.3735 .71718 L
.38314 .70838 L
.39358 .70117 L
.40466 .69566 L
.4162 .69194 L
.42803 .69007 L
.43994 .69007 L
.45176 .69194 L
.46331 .69566 L
.47438 .70117 L
.48483 .70838 L
.49447 .71718 L
.50315 .72743 L
.51075 .73896 L
.51713 .7516 L
.52221 .76514 L
.52589 .77938 L
.52812 .79408 L
Mistroke
.52887 .80902 L
Mfstroke
.62376 .80902 m
.62226 .83889 L
.61779 .8683 L
.61043 .89677 L
.60028 .92385 L
.58751 .94913 L
.57232 .97219 L
.55495 .99269 L
.53567 1.01028 L
.51479 1.0247 L
.49263 1.03572 L
.46954 1.04317 L
.4459 1.04692 L
.42207 1.04692 L
.39842 1.04317 L
.37534 1.03572 L
.35318 1.0247 L
.3323 1.01028 L
.31302 .99269 L
.29565 .97219 L
.28046 .94913 L
.26769 .92385 L
.25754 .89677 L
.25017 .8683 L
.24571 .83889 L
.24421 .80902 L
.24571 .77914 L
.25017 .74974 L
.25754 .72127 L
.26769 .69418 L
.28046 .66891 L
.29565 .64584 L
.31302 .62535 L
.3323 .60775 L
.35318 .59333 L
.37534 .58231 L
.39842 .57487 L
.42207 .57112 L
.4459 .57112 L
.46954 .57487 L
.49263 .58231 L
.51479 .59333 L
.53567 .60775 L
.55495 .62535 L
.57232 .64584 L
.58751 .66891 L
.60028 .69418 L
.61043 .72127 L
.61779 .74974 L
.62226 .77914 L
Mistroke
.62376 .80902 L
Mfstroke
.71864 .80902 m
.7164 .85383 L
.7097 .89794 L
.69865 .94064 L
.68343 .98127 L
.66428 1.01918 L
.64149 1.05378 L
.61543 1.08452 L
.58651 1.11091 L
.55519 1.13255 L
.52195 1.14908 L
.48732 1.16024 L
.45186 1.16587 L
.41611 1.16587 L
.38064 1.16024 L
.34602 1.14908 L
.31278 1.13255 L
.28146 1.11091 L
.25254 1.08452 L
.22648 1.05378 L
.20369 1.01918 L
.18454 .98127 L
.16932 .94064 L
.15827 .89794 L
.15157 .85383 L
.14933 .80902 L
.15157 .7642 L
.15827 .7201 L
.16932 .67739 L
.18454 .63676 L
.20369 .59885 L
.22648 .56425 L
.25254 .53351 L
.28146 .50712 L
.31278 .48549 L
.34602 .46896 L
.38064 .45779 L
.41611 .45216 L
.45186 .45216 L
.48732 .45779 L
.52195 .46896 L
.55519 .48549 L
.58651 .50712 L
.61543 .53351 L
.64149 .56425 L
.66428 .59885 L
.68343 .63676 L
.69865 .67739 L
.7097 .7201 L
.7164 .7642 L
Mistroke
.71864 .80902 L
Mfstroke
.81353 .80902 m
.81054 .86877 L
.8016 .92758 L
.78688 .98452 L
.76658 1.03869 L
.74104 1.08924 L
.71066 1.13537 L
.67591 1.17635 L
.63735 1.21155 L
.59559 1.24039 L
.55127 1.26243 L
.5051 1.27732 L
.45782 1.28482 L
.41015 1.28482 L
.36286 1.27732 L
.3167 1.26243 L
.27238 1.24039 L
.23061 1.21155 L
.19205 1.17635 L
.15731 1.13537 L
.12693 1.08924 L
.10139 1.03869 L
.08109 .98452 L
.06636 .92758 L
.05743 .86877 L
.05444 .80902 L
.05743 .74927 L
.06636 .69046 L
.08109 .63352 L
.10139 .57934 L
.12693 .52879 L
.15731 .48266 L
.19205 .44168 L
.23061 .40649 L
.27238 .37765 L
.3167 .35561 L
.36286 .34072 L
.41015 .33321 L
.45782 .33321 L
.5051 .34072 L
.55127 .35561 L
.59559 .37765 L
.63735 .40649 L
.67591 .44168 L
.71066 .48266 L
.74104 .52879 L
.76658 .57934 L
.78688 .63352 L
.8016 .69046 L
.81054 .74927 L
Mistroke
.81353 .80902 L
Mfstroke
.90841 .80902 m
.90467 .88371 L
.89351 .95722 L
.8751 1.02839 L
.84973 1.09611 L
.81781 1.1593 L
.77983 1.21696 L
.7364 1.26819 L
.6882 1.31218 L
.63599 1.34823 L
.58059 1.37578 L
.52288 1.39439 L
.46377 1.40377 L
.40419 1.40377 L
.34508 1.39439 L
.28738 1.37578 L
.23198 1.34823 L
.17977 1.31218 L
.13157 1.26819 L
.08814 1.21696 L
.05016 1.1593 L
.01824 1.09611 L
s
.01824 1.09611 m
0 1.04743 L
s
0 .57061 m
.01824 .52193 L
.05016 .45874 L
.08814 .40107 L
.13157 .34984 L
.17977 .30586 L
.23198 .2698 L
.28738 .24225 L
.34508 .22364 L
.40419 .21426 L
.46377 .21426 L
.52288 .22364 L
.58059 .24225 L
.63599 .2698 L
.6882 .30586 L
.7364 .34984 L
.77983 .40107 L
.81781 .45874 L
.84973 .52193 L
.8751 .58964 L
.89351 .66082 L
.90467 .73433 L
.90841 .80902 L
s
1 .87492 m
.99881 .89864 L
.98541 .98686 L
.96332 1.07227 L
.93288 1.15353 L
.89457 1.22935 L
.849 1.29855 L
.79688 1.36002 L
.73904 1.41281 L
.67639 1.45607 L
.60991 1.48913 L
.54066 1.51147 L
.46973 1.52272 L
.39824 1.52272 L
.32731 1.51147 L
.25806 1.48913 L
.19158 1.45607 L
.12893 1.41281 L
.07109 1.36002 L
.01897 1.29855 L
s
.01897 1.29855 m
0 1.26974 L
s
0 .34829 m
.01897 .31949 L
.07109 .25801 L
.12893 .20522 L
.19158 .16196 L
.25806 .1289 L
.32731 .10657 L
.39824 .09531 L
.46973 .09531 L
.54066 .10657 L
.60991 .1289 L
.67639 .16196 L
.73904 .20522 L
.79688 .25801 L
.849 .31949 L
.89457 .38868 L
.93288 .46451 L
.96332 .54576 L
.98541 .63117 L
.99881 .71939 L
s
.99881 .71939 m
1 .74312 L
s
1 1.24267 m
.97134 1.29941 L
.91817 1.38014 L
.85736 1.45186 L
.78988 1.51344 L
.71679 1.56392 L
.63923 1.60249 L
s
.63923 1.60249 m
.59103 1.61803 L
s
.27694 1.61803 m
.22873 1.60249 L
.15118 1.56392 L
.07809 1.51344 L
.01061 1.45186 L
s
.01061 1.45186 m
0 1.43935 L
s
0 .17869 m
.01061 .16618 L
.07809 .10459 L
.15118 .05412 L
.22873 .01555 L
s
.22873 .01555 m
.27694 0 L
s
.59103 0 m
.63923 .01555 L
.71679 .05412 L
.78988 .10459 L
.85736 .16618 L
.91817 .2379 L
.97134 .31863 L
s
.97134 .31863 m
1 .37536 L
s
1 1.4425 m
.98734 1.46173 L
.91785 1.54369 L
.84072 1.61407 L
s
.84072 1.61407 m
.83499 1.61803 L
s
.03298 1.61803 m
.02724 1.61407 L
s
.02724 1.61407 m
0 1.58921 L
s
0 .02882 m
.02724 .00396 L
s
.02724 .00396 m
.03298 0 L
s
.83499 0 m
.84072 .00396 L
.91785 .07434 L
.98734 .15631 L
s
.98734 .15631 m
1 .17554 L
s
1 1.60996 m
.99316 1.61803 L
s
.99316 0 m
1 .00807 L
s
.75 0 0 r
.008 w
.43551 .80283 m
.43551 .80277 L
s
.75 0 .004 r
.43551 .80277 m
.43552 .80271 L
s
.75 0 .007 r
.43552 .80271 m
.43553 .80265 L
s
.75 0 .011 r
.43553 .80265 m
.43554 .80258 L
s
.75 0 .015 r
.43554 .80258 m
.43555 .80252 L
s
.75 0 .018 r
.43555 .80252 m
.43556 .80246 L
s
.75 0 .022 r
.43556 .80246 m
.43557 .80239 L
s
.75 0 .026 r
.43557 .80239 m
.43557 .80232 L
s
.75 0 .029 r
.43557 .80232 m
.43558 .80226 L
s
.75 0 .033 r
.43558 .80226 m
.43559 .80219 L
s
.75 0 .037 r
.43559 .80219 m
.4356 .80212 L
s
.75 0 .04 r
.4356 .80212 m
.43561 .80205 L
s
.75 0 .044 r
.43561 .80205 m
.43562 .80198 L
s
.75 0 .048 r
.43562 .80198 m
.43563 .8019 L
s
.75 0 .051 r
.43563 .8019 m
.43563 .80183 L
s
.75 0 .055 r
.43563 .80183 m
.43564 .80176 L
s
.75 0 .059 r
.43564 .80176 m
.43565 .80168 L
s
.75 0 .062 r
.43565 .80168 m
.43566 .80161 L
s
.75 0 .066 r
.43566 .80161 m
.43567 .80153 L
s
.75 0 .069 r
.43567 .80153 m
.43568 .80145 L
s
.75 0 .073 r
.43568 .80145 m
.43568 .80137 L
s
.75 0 .077 r
.43568 .80137 m
.43569 .80129 L
s
.75 0 .08 r
.43569 .80129 m
.4357 .80121 L
s
.75 0 .084 r
.4357 .80121 m
.43571 .80113 L
s
.75 0 .088 r
.43571 .80113 m
.43572 .80104 L
s
.75 0 .091 r
.43572 .80104 m
.43573 .80096 L
s
.75 0 .095 r
.43573 .80096 m
.43573 .80087 L
s
.75 0 .099 r
.43573 .80087 m
.43574 .80079 L
s
.75 0 .102 r
.43574 .80079 m
.43575 .8007 L
s
.75 0 .106 r
.43575 .8007 m
.43576 .80061 L
s
.75 0 .11 r
.43576 .80061 m
.43577 .80052 L
s
.75 0 .113 r
.43577 .80052 m
.43577 .80043 L
s
.75 0 .117 r
.43577 .80043 m
.43578 .80034 L
s
.75 0 .121 r
.43578 .80034 m
.43579 .80024 L
s
.75 0 .124 r
.43579 .80024 m
.4358 .80015 L
s
.75 0 .128 r
.4358 .80015 m
.4358 .80005 L
s
.75 0 .132 r
.4358 .80005 m
.43581 .79995 L
s
.75 0 .135 r
.43581 .79995 m
.43582 .79985 L
s
.75 0 .139 r
.43582 .79985 m
.43582 .79975 L
s
.75 0 .143 r
.43582 .79975 m
.43583 .79965 L
s
.75 0 .146 r
.43583 .79965 m
.43584 .79955 L
s
.75 0 .15 r
.43584 .79955 m
.43585 .79944 L
s
.75 0 .154 r
.43585 .79944 m
.43585 .79933 L
s
.75 0 .157 r
.43585 .79933 m
.43586 .79923 L
s
.75 0 .161 r
.43586 .79923 m
.43586 .79912 L
s
.75 0 .165 r
.43586 .79912 m
.43587 .79901 L
s
.75 0 .168 r
.43587 .79901 m
.43588 .79889 L
s
.75 0 .172 r
.43588 .79889 m
.43588 .79878 L
s
.75 0 .176 r
.43588 .79878 m
.43589 .79866 L
s
.75 0 .179 r
.43589 .79866 m
.43589 .79855 L
s
.75 0 .183 r
.43589 .79855 m
.4359 .79843 L
s
.75 0 .186 r
.4359 .79843 m
.4359 .79831 L
s
.75 0 .19 r
.4359 .79831 m
.43591 .79818 L
s
.75 0 .194 r
.43591 .79818 m
.43591 .79806 L
s
.75 0 .197 r
.43591 .79806 m
.43592 .79793 L
s
.75 0 .201 r
.43592 .79793 m
.43592 .7978 L
s
.75 0 .205 r
.43592 .7978 m
.43593 .79767 L
s
.75 0 .208 r
.43593 .79767 m
.43593 .79754 L
s
.75 0 .212 r
.43593 .79754 m
.43593 .79741 L
s
.75 0 .216 r
.43593 .79741 m
.43594 .79727 L
s
.75 0 .219 r
.43594 .79727 m
.43594 .79714 L
s
.75 0 .223 r
.43594 .79714 m
.43594 .797 L
s
.75 0 .227 r
.43594 .797 m
.43595 .79685 L
s
.75 0 .23 r
.43595 .79685 m
.43595 .79671 L
s
.75 0 .234 r
.43595 .79671 m
.43595 .79656 L
s
.75 0 .238 r
.43595 .79656 m
.43595 .79642 L
s
.75 0 .241 r
.43595 .79642 m
.43595 .79627 L
s
.75 0 .245 r
.43595 .79627 m
.43595 .79611 L
s
.75 0 .249 r
.43595 .79611 m
.43595 .79596 L
s
.75 0 .252 r
.43595 .79596 m
.43595 .7958 L
s
.75 0 .256 r
.43595 .7958 m
.43595 .79564 L
s
.75 0 .26 r
.43595 .79564 m
.43595 .79548 L
s
.75 0 .263 r
.43595 .79548 m
.43595 .79532 L
s
.75 0 .267 r
.43595 .79532 m
.43595 .79515 L
s
.75 0 .271 r
.43595 .79515 m
.43594 .79498 L
s
.75 0 .274 r
.43594 .79498 m
.43594 .79481 L
s
.75 0 .278 r
.43594 .79481 m
.43594 .79463 L
s
.75 0 .282 r
.43594 .79463 m
.43593 .79446 L
s
.75 0 .285 r
.43593 .79446 m
.43593 .79428 L
s
.75 0 .289 r
.43593 .79428 m
.43592 .79409 L
s
.75 0 .292 r
.43592 .79409 m
.43592 .79391 L
s
.75 0 .296 r
.43592 .79391 m
.43591 .79372 L
s
.75 0 .3 r
.43591 .79372 m
.43591 .79353 L
s
.75 0 .303 r
.43591 .79353 m
.4359 .79334 L
s
.75 0 .307 r
.4359 .79334 m
.43589 .79314 L
s
.75 0 .311 r
.43589 .79314 m
.43588 .79294 L
s
.75 0 .314 r
.43588 .79294 m
.43587 .79273 L
s
.75 0 .318 r
.43587 .79273 m
.43586 .79253 L
s
.75 0 .322 r
.43586 .79253 m
.43585 .79232 L
s
.75 0 .325 r
.43585 .79232 m
.43584 .79211 L
s
.75 0 .329 r
.43584 .79211 m
.43582 .79189 L
s
.75 0 .333 r
.43582 .79189 m
.43581 .79167 L
s
.75 0 .336 r
.43581 .79167 m
.43579 .79145 L
s
.75 0 .34 r
.43579 .79145 m
.43578 .79122 L
s
.75 0 .344 r
.43578 .79122 m
.43576 .79099 L
s
.75 0 .347 r
.43576 .79099 m
.43574 .79075 L
s
.75 0 .351 r
.43574 .79075 m
.43572 .79052 L
s
.75 0 .355 r
.43572 .79052 m
.4357 .79028 L
s
.75 0 .358 r
.4357 .79028 m
.43568 .79003 L
s
.75 0 .362 r
.43568 .79003 m
.43566 .78978 L
s
.75 0 .366 r
.43566 .78978 m
.43563 .78953 L
s
.75 0 .369 r
.43563 .78953 m
.43561 .78927 L
s
.75 0 .373 r
.43561 .78927 m
.43558 .78901 L
s
.75 0 .377 r
.43558 .78901 m
.43555 .78874 L
s
.75 0 .38 r
.43555 .78874 m
.43553 .78847 L
s
.75 0 .384 r
.43553 .78847 m
.43549 .7882 L
s
.75 0 .388 r
.43549 .7882 m
.43546 .78792 L
s
.75 0 .391 r
.43546 .78792 m
.43543 .78764 L
s
.75 0 .395 r
.43543 .78764 m
.43539 .78735 L
s
.75 0 .399 r
.43539 .78735 m
.43536 .78706 L
s
.75 0 .402 r
.43536 .78706 m
.43532 .78676 L
s
.75 0 .406 r
.43532 .78676 m
.43528 .78646 L
s
.75 0 .409 r
.43528 .78646 m
.43523 .78615 L
s
.75 0 .413 r
.43523 .78615 m
.43519 .78584 L
s
.75 0 .417 r
.43519 .78584 m
.43514 .78552 L
s
.75 0 .42 r
.43514 .78552 m
.43509 .7852 L
s
.75 0 .424 r
.43509 .7852 m
.43504 .78487 L
s
.75 0 .428 r
.43504 .78487 m
.43499 .78453 L
s
.75 0 .431 r
.43499 .78453 m
.43494 .78419 L
s
.75 0 .435 r
.43494 .78419 m
.43488 .78385 L
s
.75 0 .439 r
.43488 .78385 m
.43482 .7835 L
s
.75 0 .442 r
.43482 .7835 m
.43476 .78314 L
s
.75 0 .446 r
.43476 .78314 m
.43469 .78278 L
s
.75 0 .45 r
.43469 .78278 m
.43462 .78241 L
s
.75 0 .453 r
.43462 .78241 m
.43455 .78204 L
s
.75 0 .457 r
.43455 .78204 m
.43448 .78166 L
s
.75 0 .461 r
.43448 .78166 m
.4344 .78127 L
s
.75 0 .464 r
.4344 .78127 m
.43432 .78088 L
s
.75 0 .468 r
.43432 .78088 m
.43424 .78048 L
s
.75 0 .472 r
.43424 .78048 m
.43415 .78007 L
s
.75 0 .475 r
.43415 .78007 m
.43406 .77966 L
s
.75 0 .479 r
.43406 .77966 m
.43397 .77924 L
s
.75 0 .483 r
.43397 .77924 m
.43387 .77881 L
s
.75 0 .486 r
.43387 .77881 m
.43377 .77837 L
s
.75 0 .49 r
.43377 .77837 m
.43367 .77793 L
s
.75 0 .494 r
.43367 .77793 m
.43356 .77748 L
s
.75 0 .497 r
.43356 .77748 m
.43345 .77703 L
s
.75 0 .501 r
.43345 .77703 m
.43333 .77656 L
s
.75 0 .505 r
.43333 .77656 m
.43321 .77609 L
s
.75 0 .508 r
.43321 .77609 m
.43308 .77561 L
s
.75 0 .512 r
.43308 .77561 m
.43295 .77512 L
s
.75 0 .516 r
.43295 .77512 m
.43281 .77462 L
s
.75 0 .519 r
.43281 .77462 m
.43267 .77412 L
s
.75 0 .523 r
.43267 .77412 m
.43252 .7736 L
s
.75 0 .527 r
.43252 .7736 m
.43237 .77308 L
s
.75 0 .53 r
.43237 .77308 m
.43221 .77255 L
s
.75 0 .534 r
.43221 .77255 m
.43205 .77201 L
s
.75 0 .537 r
.43205 .77201 m
.43188 .77146 L
s
.75 0 .541 r
.43188 .77146 m
.4317 .7709 L
s
.75 0 .545 r
.4317 .7709 m
.43152 .77033 L
s
.75 0 .548 r
.43152 .77033 m
.43133 .76975 L
s
.75 0 .552 r
.43133 .76975 m
.43113 .76917 L
s
.75 0 .556 r
.43113 .76917 m
.43093 .76857 L
s
.75 0 .559 r
.43093 .76857 m
.43072 .76796 L
s
.75 0 .563 r
.43072 .76796 m
.4305 .76734 L
s
.75 0 .567 r
.4305 .76734 m
.43027 .76671 L
s
.75 0 .57 r
.43027 .76671 m
.43003 .76608 L
s
.75 0 .574 r
.43003 .76608 m
.42979 .76543 L
s
.75 0 .578 r
.42979 .76543 m
.42954 .76477 L
s
.75 0 .581 r
.42954 .76477 m
.42927 .7641 L
s
.75 0 .585 r
.42927 .7641 m
.429 .76341 L
s
.75 0 .589 r
.429 .76341 m
.42872 .76272 L
s
.75 0 .592 r
.42872 .76272 m
.42843 .76201 L
s
.75 0 .596 r
.42843 .76201 m
.42813 .7613 L
s
.75 0 .6 r
.42813 .7613 m
.42781 .76057 L
s
.75 0 .603 r
.42781 .76057 m
.42749 .75983 L
s
.75 0 .607 r
.42749 .75983 m
.42715 .75908 L
s
.75 0 .611 r
.42715 .75908 m
.4268 .75831 L
s
.75 0 .614 r
.4268 .75831 m
.42644 .75754 L
s
.75 0 .618 r
.42644 .75754 m
.42607 .75675 L
s
.75 0 .622 r
.42607 .75675 m
.42568 .75595 L
s
.75 0 .625 r
.42568 .75595 m
.42528 .75513 L
s
.75 0 .629 r
.42528 .75513 m
.42486 .7543 L
s
.75 0 .633 r
.42486 .7543 m
.42443 .75346 L
s
.75 0 .636 r
.42443 .75346 m
.42399 .75261 L
s
.75 0 .64 r
.42399 .75261 m
.42352 .75174 L
s
.75 0 .644 r
.42352 .75174 m
.42305 .75086 L
s
.75 0 .647 r
.42305 .75086 m
.42255 .74997 L
s
.75 0 .651 r
.42255 .74997 m
.42204 .74906 L
s
.75 0 .654 r
.42204 .74906 m
.42151 .74814 L
s
.75 0 .658 r
.42151 .74814 m
.42096 .7472 L
s
.75 0 .662 r
.42096 .7472 m
.42039 .74626 L
s
.75 0 .665 r
.42039 .74626 m
.4198 .74529 L
s
.75 0 .669 r
.4198 .74529 m
.41919 .74432 L
s
.75 0 .673 r
.41919 .74432 m
.41856 .74333 L
s
.75 0 .676 r
.41856 .74333 m
.4179 .74232 L
s
.75 0 .68 r
.4179 .74232 m
.41723 .7413 L
s
.75 0 .684 r
.41723 .7413 m
.41653 .74027 L
s
.75 0 .687 r
.41653 .74027 m
.4158 .73922 L
s
.75 0 .691 r
.4158 .73922 m
.41505 .73816 L
s
.75 0 .695 r
.41505 .73816 m
.41427 .73709 L
s
.75 0 .698 r
.41427 .73709 m
.41347 .736 L
s
.75 0 .702 r
.41347 .736 m
.41264 .7349 L
s
.75 0 .706 r
.41264 .7349 m
.41178 .73378 L
s
.75 0 .709 r
.41178 .73378 m
.41088 .73266 L
s
.75 0 .713 r
.41088 .73266 m
.40996 .73151 L
s
.75 0 .717 r
.40996 .73151 m
.40901 .73036 L
s
.75 0 .72 r
.40901 .73036 m
.40802 .72919 L
s
.75 0 .724 r
.40802 .72919 m
.407 .72801 L
s
.75 0 .728 r
.407 .72801 m
.40594 .72682 L
s
.75 0 .731 r
.40594 .72682 m
.40484 .72562 L
s
.75 0 .735 r
.40484 .72562 m
.40371 .7244 L
s
.75 0 .739 r
.40371 .7244 m
.40254 .72317 L
s
.75 0 .742 r
.40254 .72317 m
.40133 .72194 L
s
.75 0 .746 r
.40133 .72194 m
.40008 .72069 L
s
.75 0 .75 r
.40008 .72069 m
.39878 .71943 L
s
.747 0 .75 r
.39878 .71943 m
.39744 .71817 L
s
.743 0 .75 r
.39744 .71817 m
.39605 .7169 L
s
.739 0 .75 r
.39605 .7169 m
.39462 .71562 L
s
.736 0 .75 r
.39462 .71562 m
.39314 .71433 L
s
.732 0 .75 r
.39314 .71433 m
.39161 .71304 L
s
.729 0 .75 r
.39161 .71304 m
.39002 .71174 L
s
.725 0 .75 r
.39002 .71174 m
.38838 .71044 L
s
.721 0 .75 r
.38838 .71044 m
.38669 .70914 L
s
.718 0 .75 r
.38669 .70914 m
.38494 .70783 L
s
.714 0 .75 r
.38494 .70783 m
.38313 .70653 L
s
.71 0 .75 r
.38313 .70653 m
.38126 .70523 L
s
.707 0 .75 r
.38126 .70523 m
.37933 .70393 L
s
.703 0 .75 r
.37933 .70393 m
.37733 .70263 L
s
.699 0 .75 r
.37733 .70263 m
.37527 .70135 L
s
.696 0 .75 r
.37527 .70135 m
.37314 .70007 L
s
.692 0 .75 r
.37314 .70007 m
.37093 .6988 L
s
.688 0 .75 r
.37093 .6988 m
.36866 .69754 L
s
.685 0 .75 r
.36866 .69754 m
.36632 .6963 L
s
.681 0 .75 r
.36632 .6963 m
.36389 .69507 L
s
.677 0 .75 r
.36389 .69507 m
.36139 .69387 L
s
.674 0 .75 r
.36139 .69387 m
.35881 .69269 L
s
.67 0 .75 r
.35881 .69269 m
.35615 .69153 L
s
.666 0 .75 r
.35615 .69153 m
.3534 .6904 L
s
.663 0 .75 r
.3534 .6904 m
.35056 .68931 L
s
.659 0 .75 r
.35056 .68931 m
.34764 .68825 L
s
.655 0 .75 r
.34764 .68825 m
.34462 .68723 L
s
.652 0 .75 r
.34462 .68723 m
.34151 .68625 L
s
.648 0 .75 r
.34151 .68625 m
.33831 .68532 L
s
.644 0 .75 r
.33831 .68532 m
.33501 .68444 L
s
.641 0 .75 r
.33501 .68444 m
.33161 .68362 L
s
.637 0 .75 r
.33161 .68362 m
.3281 .68286 L
s
.633 0 .75 r
.3281 .68286 m
.3245 .68216 L
s
.63 0 .75 r
.3245 .68216 m
.32079 .68154 L
s
.626 0 .75 r
.32079 .68154 m
.31696 .681 L
s
.623 0 .75 r
.31696 .681 m
.31303 .68054 L
s
.619 0 .75 r
.31303 .68054 m
.30899 .68017 L
s
.615 0 .75 r
.30899 .68017 m
.30484 .6799 L
s
.612 0 .75 r
.30484 .6799 m
.30057 .67973 L
s
.608 0 .75 r
.30057 .67973 m
.29618 .67967 L
s
.604 0 .75 r
.29618 .67967 m
.29168 .67973 L
s
.601 0 .75 r
.29168 .67973 m
.28706 .67993 L
s
.597 0 .75 r
.28706 .67993 m
.28231 .68025 L
s
.593 0 .75 r
.28231 .68025 m
.27745 .68072 L
s
.59 0 .75 r
.27745 .68072 m
.27247 .68135 L
s
.586 0 .75 r
.27247 .68135 m
.26737 .68214 L
s
.582 0 .75 r
.26737 .68214 m
.26214 .6831 L
s
.579 0 .75 r
.26214 .6831 m
.25679 .68425 L
s
.575 0 .75 r
.25679 .68425 m
.25133 .68559 L
s
.571 0 .75 r
.25133 .68559 m
.24574 .68714 L
s
.568 0 .75 r
.24574 .68714 m
.24004 .68891 L
s
.564 0 .75 r
.24004 .68891 m
.23422 .69091 L
s
.56 0 .75 r
.23422 .69091 m
.22828 .69315 L
s
.557 0 .75 r
.22828 .69315 m
.22224 .69565 L
s
.553 0 .75 r
.22224 .69565 m
.21609 .69842 L
s
.549 0 .75 r
.21609 .69842 m
.20983 .70147 L
s
.546 0 .75 r
.20983 .70147 m
.20348 .70481 L
s
.542 0 .75 r
.20348 .70481 m
.19703 .70847 L
s
.538 0 .75 r
.19703 .70847 m
.1905 .71246 L
s
.535 0 .75 r
.1905 .71246 m
.18388 .71678 L
s
.531 0 .75 r
.18388 .71678 m
.17719 .72146 L
s
.527 0 .75 r
.17719 .72146 m
.17044 .72651 L
s
.524 0 .75 r
.17044 .72651 m
.16363 .73194 L
s
.52 0 .75 r
.16363 .73194 m
.15677 .73777 L
s
.516 0 .75 r
.15677 .73777 m
.14989 .74402 L
s
.513 0 .75 r
.14989 .74402 m
.14298 .75071 L
s
.509 0 .75 r
.14298 .75071 m
.13606 .75783 L
s
.506 0 .75 r
.13606 .75783 m
.12915 .76542 L
s
.502 0 .75 r
.12915 .76542 m
.12226 .77348 L
s
.498 0 .75 r
.12226 .77348 m
.11542 .78203 L
s
.495 0 .75 r
.11542 .78203 m
.10863 .79108 L
s
.491 0 .75 r
.10863 .79108 m
.10192 .80064 L
s
.487 0 .75 r
.10192 .80064 m
.09531 .81072 L
s
.484 0 .75 r
.09531 .81072 m
.08882 .82134 L
s
.48 0 .75 r
.08882 .82134 m
.08247 .8325 L
s
.476 0 .75 r
.08247 .8325 m
.07629 .84421 L
s
.473 0 .75 r
.07629 .84421 m
.07031 .85647 L
s
.469 0 .75 r
.07031 .85647 m
.06455 .86929 L
s
.465 0 .75 r
.06455 .86929 m
.05904 .88268 L
s
.462 0 .75 r
.05904 .88268 m
.05381 .89662 L
s
.458 0 .75 r
.05381 .89662 m
.04889 .91112 L
s
.454 0 .75 r
.04889 .91112 m
.04432 .92617 L
s
.451 0 .75 r
.04432 .92617 m
.04011 .94177 L
s
.447 0 .75 r
.04011 .94177 m
.03631 .9579 L
s
.443 0 .75 r
.03631 .9579 m
.03295 .97455 L
s
.44 0 .75 r
.03295 .97455 m
.03006 .9917 L
s
.436 0 .75 r
.03006 .9917 m
.02767 1.00933 L
s
.432 0 .75 r
.02767 1.00933 m
.02582 1.02741 L
s
.429 0 .75 r
.02582 1.02741 m
.02454 1.04592 L
s
.425 0 .75 r
.02454 1.04592 m
.02386 1.06483 L
s
.421 0 .75 r
.02386 1.06483 m
.02381 1.0841 L
s
.418 0 .75 r
.02381 1.0841 m
.02442 1.10369 L
s
.414 0 .75 r
.02442 1.10369 m
.02571 1.12356 L
s
.41 0 .75 r
.02571 1.12356 m
.02772 1.14367 L
s
.407 0 .75 r
.02772 1.14367 m
.03046 1.16396 L
s
.403 0 .75 r
.03046 1.16396 m
.03395 1.18437 L
s
.399 0 .75 r
.03395 1.18437 m
.03822 1.20487 L
s
.396 0 .75 r
.03822 1.20487 m
.04327 1.22538 L
s
.392 0 .75 r
.04327 1.22538 m
.04912 1.24585 L
s
.388 0 .75 r
.04912 1.24585 m
.05577 1.26621 L
s
.385 0 .75 r
.05577 1.26621 m
.06322 1.28641 L
s
.381 0 .75 r
.06322 1.28641 m
.07148 1.30637 L
s
.378 0 .75 r
.07148 1.30637 m
.08054 1.32604 L
s
.374 0 .75 r
.08054 1.32604 m
.09039 1.34534 L
s
.37 0 .75 r
.09039 1.34534 m
.10102 1.36421 L
s
.367 0 .75 r
.10102 1.36421 m
.11241 1.3826 L
s
.363 0 .75 r
.11241 1.3826 m
.12453 1.40044 L
s
.359 0 .75 r
.12453 1.40044 m
.13736 1.41766 L
s
.356 0 .75 r
.13736 1.41766 m
.15088 1.43423 L
s
.352 0 .75 r
.15088 1.43423 m
.16504 1.45007 L
s
.348 0 .75 r
.16504 1.45007 m
.17981 1.46514 L
s
.345 0 .75 r
.17981 1.46514 m
.19515 1.4794 L
s
.341 0 .75 r
.19515 1.4794 m
.21102 1.4928 L
s
.337 0 .75 r
.21102 1.4928 m
.22738 1.50532 L
s
.334 0 .75 r
.22738 1.50532 m
.24417 1.51691 L
s
.33 0 .75 r
.24417 1.51691 m
.26135 1.52755 L
s
.326 0 .75 r
.26135 1.52755 m
.27888 1.53722 L
s
.323 0 .75 r
.27888 1.53722 m
.29669 1.5459 L
s
.319 0 .75 r
.29669 1.5459 m
.31475 1.55358 L
s
.315 0 .75 r
.31475 1.55358 m
.33299 1.56026 L
s
.312 0 .75 r
.33299 1.56026 m
.35139 1.56594 L
s
.308 0 .75 r
.35139 1.56594 m
.36987 1.57061 L
s
.304 0 .75 r
.36987 1.57061 m
.38841 1.57429 L
s
.301 0 .75 r
.38841 1.57429 m
.40695 1.57699 L
s
.297 0 .75 r
.40695 1.57699 m
.42544 1.57872 L
s
.293 0 .75 r
.42544 1.57872 m
.44386 1.57951 L
s
.29 0 .75 r
.44386 1.57951 m
.46216 1.57937 L
s
.286 0 .75 r
.46216 1.57937 m
.4803 1.57834 L
s
.282 0 .75 r
.4803 1.57834 m
.49825 1.57644 L
s
.279 0 .75 r
.49825 1.57644 m
.51597 1.57369 L
s
.275 0 .75 r
.51597 1.57369 m
.53344 1.57014 L
s
.272 0 .75 r
.53344 1.57014 m
.55064 1.56582 L
s
.268 0 .75 r
.55064 1.56582 m
.56753 1.56076 L
s
.264 0 .75 r
.56753 1.56076 m
.5841 1.55499 L
s
.261 0 .75 r
.5841 1.55499 m
.60032 1.54856 L
s
.257 0 .75 r
.60032 1.54856 m
.61619 1.5415 L
s
.253 0 .75 r
.61619 1.5415 m
.63168 1.53384 L
s
.25 0 .75 r
.63168 1.53384 m
.64679 1.52562 L
s
.246 0 .75 r
.64679 1.52562 m
.6615 1.51688 L
s
.242 0 .75 r
.6615 1.51688 m
.67582 1.50765 L
s
.239 0 .75 r
.67582 1.50765 m
.68972 1.49796 L
s
.235 0 .75 r
.68972 1.49796 m
.70322 1.48786 L
s
.231 0 .75 r
.70322 1.48786 m
.7163 1.47736 L
s
.228 0 .75 r
.7163 1.47736 m
.72897 1.46651 L
s
.224 0 .75 r
.72897 1.46651 m
.74122 1.45533 L
s
.22 0 .75 r
.74122 1.45533 m
.75306 1.44385 L
s
.217 0 .75 r
.75306 1.44385 m
.7645 1.43209 L
s
.213 0 .75 r
.7645 1.43209 m
.77553 1.4201 L
s
.209 0 .75 r
.77553 1.4201 m
.78617 1.40788 L
s
.206 0 .75 r
.78617 1.40788 m
.79641 1.39546 L
s
.202 0 .75 r
.79641 1.39546 m
.80626 1.38287 L
s
.198 0 .75 r
.80626 1.38287 m
.81574 1.37012 L
s
.195 0 .75 r
.81574 1.37012 m
.82484 1.35724 L
s
.191 0 .75 r
.82484 1.35724 m
.83358 1.34423 L
s
.187 0 .75 r
.83358 1.34423 m
.84196 1.33113 L
s
.184 0 .75 r
.84196 1.33113 m
.85 1.31795 L
s
.18 0 .75 r
.85 1.31795 m
.8577 1.30469 L
s
.176 0 .75 r
.8577 1.30469 m
.86507 1.29137 L
s
.173 0 .75 r
.86507 1.29137 m
.87211 1.27801 L
s
.169 0 .75 r
.87211 1.27801 m
.87885 1.26462 L
s
.165 0 .75 r
.87885 1.26462 m
.88529 1.2512 L
s
.162 0 .75 r
.88529 1.2512 m
.89143 1.23777 L
s
.158 0 .75 r
.89143 1.23777 m
.89728 1.22434 L
s
.154 0 .75 r
.89728 1.22434 m
.90286 1.2109 L
s
.151 0 .75 r
.90286 1.2109 m
.90818 1.19747 L
s
.147 0 .75 r
.90818 1.19747 m
.91323 1.18406 L
s
.144 0 .75 r
.91323 1.18406 m
.91804 1.17067 L
s
.14 0 .75 r
.91804 1.17067 m
.9226 1.1573 L
s
.136 0 .75 r
.9226 1.1573 m
.92693 1.14396 L
s
.133 0 .75 r
.92693 1.14396 m
.93103 1.13065 L
s
.129 0 .75 r
.93103 1.13065 m
.93491 1.11737 L
s
.125 0 .75 r
.93491 1.11737 m
.93857 1.10413 L
s
.122 0 .75 r
.93857 1.10413 m
.94203 1.09093 L
s
.118 0 .75 r
.94203 1.09093 m
.9453 1.07776 L
s
.114 0 .75 r
.9453 1.07776 m
.94837 1.06464 L
s
.111 0 .75 r
.94837 1.06464 m
.95125 1.05156 L
s
.107 0 .75 r
.95125 1.05156 m
.95395 1.03851 L
s
.103 0 .75 r
.95395 1.03851 m
.95647 1.02551 L
s
.1 0 .75 r
.95647 1.02551 m
.95882 1.01254 L
s
.096 0 .75 r
.95882 1.01254 m
.96101 .99962 L
s
.092 0 .75 r
.96101 .99962 m
.96303 .98673 L
s
.089 0 .75 r
.96303 .98673 m
.9649 .97387 L
s
.085 0 .75 r
.9649 .97387 m
.96661 .96105 L
s
.081 0 .75 r
.96661 .96105 m
.96818 .94826 L
s
.078 0 .75 r
.96818 .94826 m
.96959 .9355 L
s
.074 0 .75 r
.96959 .9355 m
.97086 .92277 L
s
.07 0 .75 r
.97086 .92277 m
.972 .91007 L
s
.067 0 .75 r
.972 .91007 m
.97299 .89738 L
s
.063 0 .75 r
.97299 .89738 m
.97384 .88472 L
s
.059 0 .75 r
.97384 .88472 m
.97456 .87208 L
s
.056 0 .75 r
.97456 .87208 m
.97515 .85945 L
s
.052 0 .75 r
.97515 .85945 m
.97561 .84683 L
s
.048 0 .75 r
.97561 .84683 m
.97593 .83422 L
s
.045 0 .75 r
.97593 .83422 m
.97613 .82162 L
s
.041 0 .75 r
.97613 .82162 m
.97619 .80902 L
s
.038 0 .75 r
.97619 .80902 m
.97613 .79642 L
s
.034 0 .75 r
.97613 .79642 m
.97593 .78381 L
s
.03 0 .75 r
.97593 .78381 m
.97561 .7712 L
s
.027 0 .75 r
.97561 .7712 m
.97515 .75859 L
s
.023 0 .75 r
.97515 .75859 m
.97456 .74596 L
s
.019 0 .75 r
.97456 .74596 m
.97384 .73331 L
s
.016 0 .75 r
.97384 .73331 m
.97299 .72065 L
s
.012 0 .75 r
.97299 .72065 m
.972 .70797 L
s
.008 0 .75 r
.972 .70797 m
.97086 .69526 L
s
.005 0 .75 r
.97086 .69526 m
.96959 .68253 L
s
.001 0 .75 r
.96959 .68253 m
.96818 .66977 L
s
0 .003 .75 r
.96818 .66977 m
.96661 .65698 L
s
0 .006 .75 r
.96661 .65698 m
.9649 .64416 L
s
0 .01 .75 r
.9649 .64416 m
.96303 .63131 L
s
0 .014 .75 r
.96303 .63131 m
.96101 .61842 L
s
0 .017 .75 r
.96101 .61842 m
.95882 .60549 L
s
0 .021 .75 r
.95882 .60549 m
.95647 .59253 L
s
0 .025 .75 r
.95647 .59253 m
.95395 .57952 L
s
0 .028 .75 r
.95395 .57952 m
.95125 .56648 L
s
0 .032 .75 r
.95125 .56648 m
.94837 .55339 L
s
0 .036 .75 r
.94837 .55339 m
.9453 .54027 L
s
0 .039 .75 r
.9453 .54027 m
.94203 .52711 L
s
0 .043 .75 r
.94203 .52711 m
.93857 .5139 L
s
0 .047 .75 r
.93857 .5139 m
.93491 .50066 L
s
0 .05 .75 r
.93491 .50066 m
.93103 .48739 L
s
0 .054 .75 r
.93103 .48739 m
.92693 .47408 L
s
0 .058 .75 r
.92693 .47408 m
.9226 .46074 L
s
0 .061 .75 r
.9226 .46074 m
.91804 .44737 L
s
0 .065 .75 r
.91804 .44737 m
.91323 .43397 L
s
0 .069 .75 r
.91323 .43397 m
.90818 .42056 L
s
0 .072 .75 r
.90818 .42056 m
.90286 .40713 L
s
0 .076 .75 r
.90286 .40713 m
.89728 .3937 L
s
0 .079 .75 r
.89728 .3937 m
.89143 .38026 L
s
0 .083 .75 r
.89143 .38026 m
.88529 .36683 L
s
0 .087 .75 r
.88529 .36683 m
.87885 .35341 L
s
0 .09 .75 r
.87885 .35341 m
.87211 .34002 L
s
0 .094 .75 r
.87211 .34002 m
.86507 .32666 L
s
0 .098 .75 r
.86507 .32666 m
.8577 .31335 L
s
0 .101 .75 r
.8577 .31335 m
.85 .30009 L
s
0 .105 .75 r
.85 .30009 m
.84196 .2869 L
s
0 .109 .75 r
.84196 .2869 m
.83358 .2738 L
s
0 .112 .75 r
.83358 .2738 m
.82484 .2608 L
s
0 .116 .75 r
.82484 .2608 m
.81574 .24792 L
s
0 .12 .75 r
.81574 .24792 m
.80626 .23517 L
s
0 .123 .75 r
.80626 .23517 m
.79641 .22257 L
s
0 .127 .75 r
.79641 .22257 m
.78617 .21016 L
s
0 .131 .75 r
.78617 .21016 m
.77553 .19794 L
s
0 .134 .75 r
.77553 .19794 m
.7645 .18594 L
s
0 .138 .75 r
.7645 .18594 m
.75306 .17419 L
s
0 .142 .75 r
.75306 .17419 m
.74122 .16271 L
s
0 .145 .75 r
.74122 .16271 m
.72897 .15153 L
s
0 .149 .75 r
.72897 .15153 m
.7163 .14067 L
s
0 .153 .75 r
.7163 .14067 m
.70322 .13018 L
s
0 .156 .75 r
.70322 .13018 m
.68972 .12007 L
s
0 .16 .75 r
.68972 .12007 m
.67582 .11039 L
s
0 .164 .75 r
.67582 .11039 m
.6615 .10116 L
s
0 .167 .75 r
.6615 .10116 m
.64679 .09242 L
s
0 .171 .75 r
.64679 .09242 m
.63168 .0842 L
s
0 .175 .75 r
.63168 .0842 m
.61619 .07654 L
s
0 .178 .75 r
.61619 .07654 m
.60032 .06947 L
s
0 .182 .75 r
.60032 .06947 m
.5841 .06304 L
s
0 .186 .75 r
.5841 .06304 m
.56753 .05728 L
s
0 .189 .75 r
.56753 .05728 m
.55064 .05221 L
s
0 .193 .75 r
.55064 .05221 m
.53344 .04789 L
s
0 .197 .75 r
.53344 .04789 m
.51597 .04434 L
s
0 .2 .75 r
.51597 .04434 m
.49825 .0416 L
s
0 .204 .75 r
.49825 .0416 m
.4803 .0397 L
s
0 .207 .75 r
.4803 .0397 m
.46216 .03866 L
s
0 .211 .75 r
.46216 .03866 m
.44386 .03852 L
s
0 .215 .75 r
.44386 .03852 m
.42544 .03931 L
s
0 .218 .75 r
.42544 .03931 m
.40695 .04104 L
s
0 .222 .75 r
.40695 .04104 m
.38841 .04374 L
s
0 .226 .75 r
.38841 .04374 m
.36987 .04742 L
s
0 .229 .75 r
.36987 .04742 m
.35139 .0521 L
s
0 .233 .75 r
.35139 .0521 m
.33299 .05777 L
s
0 .237 .75 r
.33299 .05777 m
.31475 .06445 L
s
0 .24 .75 r
.31475 .06445 m
.29669 .07214 L
s
0 .244 .75 r
.29669 .07214 m
.27888 .08082 L
s
0 .248 .75 r
.27888 .08082 m
.26135 .09049 L
s
0 .251 .75 r
.26135 .09049 m
.24417 .10113 L
s
0 .255 .75 r
.24417 .10113 m
.22738 .11272 L
s
0 .259 .75 r
.22738 .11272 m
.21102 .12523 L
s
0 .262 .75 r
.21102 .12523 m
.19515 .13864 L
s
0 .266 .75 r
.19515 .13864 m
.17981 .15289 L
s
0 .27 .75 r
.17981 .15289 m
.16504 .16797 L
s
0 .273 .75 r
.16504 .16797 m
.15088 .18381 L
s
0 .277 .75 r
.15088 .18381 m
.13736 .20037 L
s
0 .281 .75 r
.13736 .20037 m
.12453 .2176 L
s
0 .284 .75 r
.12453 .2176 m
.11241 .23543 L
s
0 .288 .75 r
.11241 .23543 m
.10102 .25382 L
s
0 .292 .75 r
.10102 .25382 m
.09039 .2727 L
s
0 .295 .75 r
.09039 .2727 m
.08054 .292 L
s
0 .299 .75 r
.08054 .292 m
.07148 .31166 L
s
0 .303 .75 r
.07148 .31166 m
.06322 .33163 L
s
0 .306 .75 r
.06322 .33163 m
.05577 .35182 L
s
0 .31 .75 r
.05577 .35182 m
.04912 .37219 L
s
0 .314 .75 r
.04912 .37219 m
.04327 .39265 L
s
0 .317 .75 r
.04327 .39265 m
.03822 .41317 L
s
0 .321 .75 r
.03822 .41317 m
.03395 .43366 L
s
0 .324 .75 r
.03395 .43366 m
.03046 .45408 L
s
0 .328 .75 r
.03046 .45408 m
.02772 .47437 L
s
0 .332 .75 r
.02772 .47437 m
.02571 .49447 L
s
0 .335 .75 r
.02571 .49447 m
.02442 .51434 L
s
0 .339 .75 r
.02442 .51434 m
.02381 .53393 L
s
0 .343 .75 r
.02381 .53393 m
.02386 .5532 L
s
0 .346 .75 r
.02386 .5532 m
.02454 .57211 L
s
0 .35 .75 r
.02454 .57211 m
.02582 .59062 L
s
0 .354 .75 r
.02582 .59062 m
.02767 .60871 L
s
0 .357 .75 r
.02767 .60871 m
.03006 .62634 L
s
0 .361 .75 r
.03006 .62634 m
.03295 .64349 L
s
0 .365 .75 r
.03295 .64349 m
.03631 .66014 L
s
0 .368 .75 r
.03631 .66014 m
.04011 .67626 L
s
0 .372 .75 r
.04011 .67626 m
.04432 .69186 L
s
0 .376 .75 r
.04432 .69186 m
.04889 .70691 L
s
0 .379 .75 r
.04889 .70691 m
.05381 .72142 L
s
0 .383 .75 r
.05381 .72142 m
.05904 .73536 L
s
0 .387 .75 r
.05904 .73536 m
.06455 .74874 L
s
0 .39 .75 r
.06455 .74874 m
.07031 .76156 L
s
0 .394 .75 r
.07031 .76156 m
.07629 .77383 L
s
0 .398 .75 r
.07629 .77383 m
.08247 .78554 L
s
0 .401 .75 r
.08247 .78554 m
.08882 .7967 L
s
0 .405 .75 r
.08882 .7967 m
.09531 .80731 L
s
0 .409 .75 r
.09531 .80731 m
.10192 .8174 L
s
0 .412 .75 r
.10192 .8174 m
.10863 .82696 L
s
0 .416 .75 r
.10863 .82696 m
.11542 .83601 L
s
0 .42 .75 r
.11542 .83601 m
.12226 .84455 L
s
0 .423 .75 r
.12226 .84455 m
.12915 .85262 L
s
0 .427 .75 r
.12915 .85262 m
.13606 .8602 L
s
0 .431 .75 r
.13606 .8602 m
.14298 .86733 L
s
0 .434 .75 r
.14298 .86733 m
.14989 .87401 L
s
0 .438 .75 r
.14989 .87401 m
.15677 .88026 L
s
0 .441 .75 r
.15677 .88026 m
.16363 .88609 L
s
0 .445 .75 r
.16363 .88609 m
.17044 .89153 L
s
0 .449 .75 r
.17044 .89153 m
.17719 .89658 L
s
0 .452 .75 r
.17719 .89658 m
.18388 .90126 L
s
0 .456 .75 r
.18388 .90126 m
.1905 .90558 L
s
0 .46 .75 r
.1905 .90558 m
.19703 .90956 L
s
0 .463 .75 r
.19703 .90956 m
.20348 .91322 L
s
0 .467 .75 r
.20348 .91322 m
.20983 .91657 L
s
0 .471 .75 r
.20983 .91657 m
.21609 .91962 L
s
0 .474 .75 r
.21609 .91962 m
.22224 .92238 L
s
0 .478 .75 r
.22224 .92238 m
.22828 .92488 L
s
0 .482 .75 r
.22828 .92488 m
.23422 .92712 L
s
0 .485 .75 r
.23422 .92712 m
.24004 .92912 L
s
0 .489 .75 r
.24004 .92912 m
.24574 .93089 L
s
0 .493 .75 r
.24574 .93089 m
.25133 .93244 L
s
0 .496 .75 r
.25133 .93244 m
.25679 .93378 L
s
0 .5 .75 r
.25679 .93378 m
.26214 .93493 L
s
0 .504 .75 r
.26214 .93493 m
.26737 .9359 L
s
0 .507 .75 r
.26737 .9359 m
.27247 .93669 L
s
0 .511 .75 r
.27247 .93669 m
.27745 .93731 L
s
0 .515 .75 r
.27745 .93731 m
.28231 .93778 L
s
0 .518 .75 r
.28231 .93778 m
.28706 .93811 L
s
0 .522 .75 r
.28706 .93811 m
.29168 .9383 L
s
0 .526 .75 r
.29168 .9383 m
.29618 .93836 L
s
0 .529 .75 r
.29618 .93836 m
.30057 .93831 L
s
0 .533 .75 r
.30057 .93831 m
.30484 .93814 L
s
0 .537 .75 r
.30484 .93814 m
.30899 .93786 L
s
0 .54 .75 r
.30899 .93786 m
.31303 .9375 L
s
0 .544 .75 r
.31303 .9375 m
.31696 .93704 L
s
0 .547 .75 r
.31696 .93704 m
.32079 .93649 L
s
0 .551 .75 r
.32079 .93649 m
.3245 .93587 L
s
0 .555 .75 r
.3245 .93587 m
.3281 .93518 L
s
0 .558 .75 r
.3281 .93518 m
.33161 .93442 L
s
0 .562 .75 r
.33161 .93442 m
.33501 .93359 L
s
0 .566 .75 r
.33501 .93359 m
.33831 .93271 L
s
0 .569 .75 r
.33831 .93271 m
.34151 .93178 L
s
0 .573 .75 r
.34151 .93178 m
.34462 .93081 L
s
0 .577 .75 r
.34462 .93081 m
.34764 .92979 L
s
0 .58 .75 r
.34764 .92979 m
.35056 .92873 L
s
0 .584 .75 r
.35056 .92873 m
.3534 .92763 L
s
0 .588 .75 r
.3534 .92763 m
.35615 .9265 L
s
0 .591 .75 r
.35615 .9265 m
.35881 .92535 L
s
0 .595 .75 r
.35881 .92535 m
.36139 .92416 L
s
0 .599 .75 r
.36139 .92416 m
.36389 .92296 L
s
0 .602 .75 r
.36389 .92296 m
.36632 .92174 L
s
0 .606 .75 r
.36632 .92174 m
.36866 .92049 L
s
0 .61 .75 r
.36866 .92049 m
.37093 .91924 L
s
0 .613 .75 r
.37093 .91924 m
.37314 .91797 L
s
0 .617 .75 r
.37314 .91797 m
.37527 .91669 L
s
0 .621 .75 r
.37527 .91669 m
.37733 .9154 L
s
0 .624 .75 r
.37733 .9154 m
.37933 .91411 L
s
0 .628 .75 r
.37933 .91411 m
.38126 .91281 L
s
0 .632 .75 r
.38126 .91281 m
.38313 .91151 L
s
0 .635 .75 r
.38313 .91151 m
.38494 .9102 L
s
0 .639 .75 r
.38494 .9102 m
.38669 .9089 L
s
0 .643 .75 r
.38669 .9089 m
.38838 .9076 L
s
0 .646 .75 r
.38838 .9076 m
.39002 .90629 L
s
0 .65 .75 r
.39002 .90629 m
.39161 .905 L
s
0 .654 .75 r
.39161 .905 m
.39314 .90371 L
s
0 .657 .75 r
.39314 .90371 m
.39462 .90242 L
s
0 .661 .75 r
.39462 .90242 m
.39605 .90114 L
s
0 .665 .75 r
.39605 .90114 m
.39744 .89987 L
s
0 .668 .75 r
.39744 .89987 m
.39878 .8986 L
s
0 .672 .75 r
.39878 .8986 m
.40008 .89734 L
s
0 .675 .75 r
.40008 .89734 m
.40133 .8961 L
s
0 .679 .75 r
.40133 .8961 m
.40254 .89486 L
s
0 .683 .75 r
.40254 .89486 m
.40371 .89363 L
s
0 .686 .75 r
.40371 .89363 m
.40484 .89242 L
s
0 .69 .75 r
.40484 .89242 m
.40594 .89121 L
s
0 .694 .75 r
.40594 .89121 m
.407 .89002 L
s
0 .697 .75 r
.407 .89002 m
.40802 .88884 L
s
0 .701 .75 r
.40802 .88884 m
.40901 .88767 L
s
0 .705 .75 r
.40901 .88767 m
.40996 .88652 L
s
0 .708 .75 r
.40996 .88652 m
.41088 .88538 L
s
0 .712 .75 r
.41088 .88538 m
.41178 .88425 L
s
0 .716 .75 r
.41178 .88425 m
.41264 .88313 L
s
0 .719 .75 r
.41264 .88313 m
.41347 .88203 L
s
0 .723 .75 r
.41347 .88203 m
.41427 .88094 L
s
0 .727 .75 r
.41427 .88094 m
.41505 .87987 L
s
0 .73 .75 r
.41505 .87987 m
.4158 .87881 L
s
0 .734 .75 r
.4158 .87881 m
.41653 .87776 L
s
0 .738 .75 r
.41653 .87776 m
.41723 .87673 L
s
0 .741 .75 r
.41723 .87673 m
.4179 .87571 L
s
0 .745 .75 r
.4179 .87571 m
.41856 .87471 L
s
0 .749 .75 r
.41856 .87471 m
.41919 .87372 L
s
0 .75 .748 r
.41919 .87372 m
.4198 .87274 L
s
0 .75 .744 r
.4198 .87274 m
.42039 .87178 L
s
0 .75 .74 r
.42039 .87178 m
.42096 .87083 L
s
0 .75 .737 r
.42096 .87083 m
.42151 .86989 L
s
0 .75 .733 r
.42151 .86989 m
.42204 .86897 L
s
0 .75 .729 r
.42204 .86897 m
.42255 .86807 L
s
0 .75 .726 r
.42255 .86807 m
.42305 .86717 L
s
0 .75 .722 r
.42305 .86717 m
.42352 .86629 L
s
0 .75 .719 r
.42352 .86629 m
.42399 .86542 L
s
0 .75 .715 r
.42399 .86542 m
.42443 .86457 L
s
0 .75 .711 r
.42443 .86457 m
.42486 .86373 L
s
0 .75 .708 r
.42486 .86373 m
.42528 .8629 L
s
0 .75 .704 r
.42528 .8629 m
.42568 .86209 L
s
0 .75 .7 r
.42568 .86209 m
.42607 .86129 L
s
0 .75 .697 r
.42607 .86129 m
.42644 .8605 L
s
0 .75 .693 r
.42644 .8605 m
.4268 .85972 L
s
0 .75 .689 r
.4268 .85972 m
.42715 .85896 L
s
0 .75 .686 r
.42715 .85896 m
.42749 .8582 L
s
0 .75 .682 r
.42749 .8582 m
.42781 .85746 L
s
0 .75 .678 r
.42781 .85746 m
.42813 .85674 L
s
0 .75 .675 r
.42813 .85674 m
.42843 .85602 L
s
0 .75 .671 r
.42843 .85602 m
.42872 .85531 L
s
0 .75 .667 r
.42872 .85531 m
.429 .85462 L
s
0 .75 .664 r
.429 .85462 m
.42927 .85394 L
s
0 .75 .66 r
.42927 .85394 m
.42954 .85327 L
s
0 .75 .656 r
.42954 .85327 m
.42979 .85261 L
s
0 .75 .653 r
.42979 .85261 m
.43003 .85196 L
s
0 .75 .649 r
.43003 .85196 m
.43027 .85132 L
s
0 .75 .645 r
.43027 .85132 m
.4305 .85069 L
s
0 .75 .642 r
.4305 .85069 m
.43072 .85007 L
s
0 .75 .638 r
.43072 .85007 m
.43093 .84947 L
s
0 .75 .634 r
.43093 .84947 m
.43113 .84887 L
s
0 .75 .631 r
.43113 .84887 m
.43133 .84828 L
s
0 .75 .627 r
.43133 .84828 m
.43152 .8477 L
s
0 .75 .623 r
.43152 .8477 m
.4317 .84714 L
s
0 .75 .62 r
.4317 .84714 m
.43188 .84658 L
s
0 .75 .616 r
.43188 .84658 m
.43205 .84603 L
s
0 .75 .612 r
.43205 .84603 m
.43221 .84549 L
s
0 .75 .609 r
.43221 .84549 m
.43237 .84495 L
s
0 .75 .605 r
.43237 .84495 m
.43252 .84443 L
s
0 .75 .601 r
.43252 .84443 m
.43267 .84392 L
s
0 .75 .598 r
.43267 .84392 m
.43281 .84341 L
s
0 .75 .594 r
.43281 .84341 m
.43295 .84292 L
s
0 .75 .591 r
.43295 .84292 m
.43308 .84243 L
s
0 .75 .587 r
.43308 .84243 m
.43321 .84195 L
s
0 .75 .583 r
.43321 .84195 m
.43333 .84147 L
s
0 .75 .58 r
.43333 .84147 m
.43345 .84101 L
s
0 .75 .576 r
.43345 .84101 m
.43356 .84055 L
s
0 .75 .572 r
.43356 .84055 m
.43367 .8401 L
s
0 .75 .569 r
.43367 .8401 m
.43377 .83966 L
s
0 .75 .565 r
.43377 .83966 m
.43387 .83922 L
s
0 .75 .561 r
.43387 .83922 m
.43397 .8388 L
s
0 .75 .558 r
.43397 .8388 m
.43406 .83838 L
s
0 .75 .554 r
.43406 .83838 m
.43415 .83796 L
s
0 .75 .55 r
.43415 .83796 m
.43424 .83756 L
s
0 .75 .547 r
.43424 .83756 m
.43432 .83716 L
s
0 .75 .543 r
.43432 .83716 m
.4344 .83676 L
s
0 .75 .539 r
.4344 .83676 m
.43448 .83638 L
s
0 .75 .536 r
.43448 .83638 m
.43455 .836 L
s
0 .75 .532 r
.43455 .836 m
.43462 .83562 L
s
0 .75 .528 r
.43462 .83562 m
.43469 .83525 L
s
0 .75 .525 r
.43469 .83525 m
.43476 .83489 L
s
0 .75 .521 r
.43476 .83489 m
.43482 .83453 L
s
0 .75 .517 r
.43482 .83453 m
.43488 .83418 L
s
0 .75 .514 r
.43488 .83418 m
.43494 .83384 L
s
0 .75 .51 r
.43494 .83384 m
.43499 .8335 L
s
0 .75 .506 r
.43499 .8335 m
.43504 .83317 L
s
0 .75 .503 r
.43504 .83317 m
.43509 .83284 L
s
0 .75 .499 r
.43509 .83284 m
.43514 .83252 L
s
0 .75 .495 r
.43514 .83252 m
.43519 .8322 L
s
0 .75 .492 r
.43519 .8322 m
.43523 .83189 L
s
0 .75 .488 r
.43523 .83189 m
.43528 .83158 L
s
0 .75 .484 r
.43528 .83158 m
.43532 .83128 L
s
0 .75 .481 r
.43532 .83128 m
.43536 .83098 L
s
0 .75 .477 r
.43536 .83098 m
.43539 .83069 L
s
0 .75 .474 r
.43539 .83069 m
.43543 .8304 L
s
0 .75 .47 r
.43543 .8304 m
.43546 .83011 L
s
0 .75 .466 r
.43546 .83011 m
.43549 .82984 L
s
0 .75 .463 r
.43549 .82984 m
.43553 .82956 L
s
0 .75 .459 r
.43553 .82956 m
.43555 .82929 L
s
0 .75 .455 r
.43555 .82929 m
.43558 .82903 L
s
0 .75 .452 r
.43558 .82903 m
.43561 .82876 L
s
0 .75 .448 r
.43561 .82876 m
.43563 .82851 L
s
0 .75 .444 r
.43563 .82851 m
.43566 .82825 L
s
0 .75 .441 r
.43566 .82825 m
.43568 .828 L
s
0 .75 .437 r
.43568 .828 m
.4357 .82776 L
s
0 .75 .433 r
.4357 .82776 m
.43572 .82752 L
s
0 .75 .43 r
.43572 .82752 m
.43574 .82728 L
s
0 .75 .426 r
.43574 .82728 m
.43576 .82705 L
s
0 .75 .422 r
.43576 .82705 m
.43578 .82681 L
s
0 .75 .419 r
.43578 .82681 m
.43579 .82659 L
s
0 .75 .415 r
.43579 .82659 m
.43581 .82636 L
s
0 .75 .411 r
.43581 .82636 m
.43582 .82615 L
s
0 .75 .408 r
.43582 .82615 m
.43584 .82593 L
s
0 .75 .404 r
.43584 .82593 m
.43585 .82572 L
s
0 .75 .4 r
.43585 .82572 m
.43586 .82551 L
s
0 .75 .397 r
.43586 .82551 m
.43587 .8253 L
s
0 .75 .393 r
.43587 .8253 m
.43588 .8251 L
s
0 .75 .389 r
.43588 .8251 m
.43589 .8249 L
s
0 .75 .386 r
.43589 .8249 m
.4359 .8247 L
s
0 .75 .382 r
.4359 .8247 m
.43591 .8245 L
s
0 .75 .378 r
.43591 .8245 m
.43591 .82431 L
s
0 .75 .375 r
.43591 .82431 m
.43592 .82413 L
s
0 .75 .371 r
.43592 .82413 m
.43592 .82394 L
s
0 .75 .367 r
.43592 .82394 m
.43593 .82376 L
s
0 .75 .364 r
.43593 .82376 m
.43593 .82358 L
s
0 .75 .36 r
.43593 .82358 m
.43594 .8234 L
s
0 .75 .357 r
.43594 .8234 m
.43594 .82323 L
s
0 .75 .353 r
.43594 .82323 m
.43594 .82305 L
s
0 .75 .349 r
.43594 .82305 m
.43595 .82288 L
s
0 .75 .346 r
.43595 .82288 m
.43595 .82272 L
s
0 .75 .342 r
.43595 .82272 m
.43595 .82255 L
s
0 .75 .338 r
.43595 .82255 m
.43595 .82239 L
s
0 .75 .335 r
.43595 .82239 m
.43595 .82223 L
s
0 .75 .331 r
.43595 .82223 m
.43595 .82207 L
s
0 .75 .327 r
.43595 .82207 m
.43595 .82192 L
s
0 .75 .324 r
.43595 .82192 m
.43595 .82177 L
s
0 .75 .32 r
.43595 .82177 m
.43595 .82162 L
s
0 .75 .316 r
.43595 .82162 m
.43595 .82147 L
s
0 .75 .313 r
.43595 .82147 m
.43595 .82132 L
s
0 .75 .309 r
.43595 .82132 m
.43595 .82118 L
s
0 .75 .305 r
.43595 .82118 m
.43594 .82104 L
s
0 .75 .302 r
.43594 .82104 m
.43594 .8209 L
s
0 .75 .298 r
.43594 .8209 m
.43594 .82076 L
s
0 .75 .294 r
.43594 .82076 m
.43593 .82062 L
s
0 .75 .291 r
.43593 .82062 m
.43593 .82049 L
s
0 .75 .287 r
.43593 .82049 m
.43593 .82036 L
s
0 .75 .283 r
.43593 .82036 m
.43592 .82023 L
s
0 .75 .28 r
.43592 .82023 m
.43592 .8201 L
s
0 .75 .276 r
.43592 .8201 m
.43591 .81998 L
s
0 .75 .272 r
.43591 .81998 m
.43591 .81985 L
s
0 .75 .269 r
.43591 .81985 m
.4359 .81973 L
s
0 .75 .265 r
.4359 .81973 m
.4359 .81961 L
s
0 .75 .261 r
.4359 .81961 m
.43589 .81949 L
s
0 .75 .258 r
.43589 .81949 m
.43589 .81937 L
s
0 .75 .254 r
.43589 .81937 m
.43588 .81925 L
s
0 .75 .251 r
.43588 .81925 m
.43588 .81914 L
s
0 .75 .247 r
.43588 .81914 m
.43587 .81903 L
s
0 .75 .243 r
.43587 .81903 m
.43586 .81892 L
s
0 .75 .24 r
.43586 .81892 m
.43586 .81881 L
s
0 .75 .236 r
.43586 .81881 m
.43585 .8187 L
s
0 .75 .232 r
.43585 .8187 m
.43585 .81859 L
s
0 .75 .229 r
.43585 .81859 m
.43584 .81849 L
s
0 .75 .225 r
.43584 .81849 m
.43583 .81838 L
s
0 .75 .221 r
.43583 .81838 m
.43582 .81828 L
s
0 .75 .218 r
.43582 .81828 m
.43582 .81818 L
s
0 .75 .214 r
.43582 .81818 m
.43581 .81808 L
s
0 .75 .21 r
.43581 .81808 m
.4358 .81798 L
s
0 .75 .207 r
.4358 .81798 m
.4358 .81789 L
s
0 .75 .203 r
.4358 .81789 m
.43579 .81779 L
s
0 .75 .199 r
.43579 .81779 m
.43578 .8177 L
s
0 .75 .196 r
.43578 .8177 m
.43577 .81761 L
s
0 .75 .192 r
.43577 .81761 m
.43577 .81751 L
s
0 .75 .188 r
.43577 .81751 m
.43576 .81742 L
s
0 .75 .185 r
.43576 .81742 m
.43575 .81733 L
s
0 .75 .181 r
.43575 .81733 m
.43574 .81725 L
s
0 .75 .177 r
.43574 .81725 m
.43573 .81716 L
s
0 .75 .174 r
.43573 .81716 m
.43573 .81707 L
s
0 .75 .17 r
.43573 .81707 m
.43572 .81699 L
s
0 .75 .166 r
.43572 .81699 m
.43571 .81691 L
s
0 .75 .163 r
.43571 .81691 m
.4357 .81682 L
s
0 .75 .159 r
.4357 .81682 m
.43569 .81674 L
s
0 .75 .155 r
.43569 .81674 m
.43568 .81666 L
s
0 .75 .152 r
.43568 .81666 m
.43568 .81658 L
s
0 .75 .148 r
.43568 .81658 m
.43567 .81651 L
s
0 .75 .144 r
.43567 .81651 m
.43566 .81643 L
s
0 .75 .141 r
.43566 .81643 m
.43565 .81635 L
s
0 .75 .137 r
.43565 .81635 m
.43564 .81628 L
s
0 .75 .133 r
.43564 .81628 m
.43563 .8162 L
s
0 .75 .13 r
.43563 .8162 m
.43563 .81613 L
s
0 .75 .126 r
.43563 .81613 m
.43562 .81606 L
s
0 .75 .123 r
.43562 .81606 m
.43561 .81599 L
s
0 .75 .119 r
.43561 .81599 m
.4356 .81592 L
s
0 .75 .115 r
.4356 .81592 m
.43559 .81585 L
s
0 .75 .112 r
.43559 .81585 m
.43558 .81578 L
s
0 .75 .108 r
.43558 .81578 m
.43557 .81571 L
s
0 .75 .104 r
.43557 .81571 m
.43557 .81564 L
s
0 .75 .101 r
.43557 .81564 m
.43556 .81558 L
s
0 .75 .097 r
.43556 .81558 m
.43555 .81551 L
s
0 .75 .093 r
.43555 .81551 m
.43554 .81545 L
s
0 .75 .09 r
.43554 .81545 m
.43553 .81539 L
s
0 .75 .086 r
.43553 .81539 m
.43552 .81532 L
s
0 .75 .082 r
.43552 .81532 m
.43551 .81526 L
s
0 .75 .079 r
.43551 .81526 m
.43551 .8152 L
s
0 1 0 r
.001 w
.29843 .80902 m
.29843 .80902 L
.29843 .80902 L
.29843 .80902 L
.29843 .80902 L
.29843 .80902 L
.29843 .80902 L
.29843 .80902 L
.29843 .80902 L
.29843 .80902 L
.29843 .80902 L
.29843 .80902 L
.29843 .80902 L
.29843 .80902 L
.29843 .80902 L
.29843 .80902 L
.29843 .80902 L
.29843 .80902 L
.29843 .80902 L
.29843 .80902 L
.29843 .80902 L
.29843 .80902 L
.29843 .80902 L
.29843 .80902 L
.29843 .80902 L
.29843 .80902 L
.29843 .80902 L
.29843 .80902 L
.29843 .80902 L
.29843 .80902 L
.29843 .80902 L
.29843 .80902 L
.29843 .80902 L
.29843 .80902 L
.29843 .80902 L
.29843 .80902 L
.29843 .80902 L
.29843 .80902 L
.29843 .80902 L
.29843 .80902 L
.29843 .80902 L
.29843 .80902 L
.29843 .80902 L
.29843 .80902 L
.29843 .80902 L
.29843 .80902 L
.29843 .80902 L
.29843 .80902 L
.29843 .80902 L
.29843 .80902 L
Mistroke
.29843 .80902 L
Mfstroke
1 0 0 r
.0005 w
.29843 .80902 m
.29843 .80902 L
.29843 .80902 L
.29843 .80902 L
.29843 .80902 L
.29843 .80902 L
.29843 .80902 L
.29843 .80902 L
.29843 .80902 L
.29843 .80902 L
.29843 .80902 L
.29843 .80902 L
.29843 .80902 L
.29843 .80902 L
.29843 .80902 L
.29843 .80902 L
.29843 .80902 L
.29843 .80902 L
.29843 .80902 L
.29843 .80902 L
.29843 .80902 L
.29843 .80902 L
.29843 .80902 L
.29843 .80902 L
.29843 .80902 L
.29843 .80902 L
.29843 .80902 L
.29843 .80902 L
.29843 .80902 L
.29843 .80902 L
.29843 .80902 L
.29843 .80902 L
.29843 .80902 L
.29843 .80902 L
.29843 .80902 L
.29843 .80902 L
.29843 .80902 L
.29843 .80902 L
.29843 .80902 L
.29843 .80902 L
.29843 .80902 L
.29843 .80902 L
.29843 .80902 L
.29843 .80902 L
.29843 .80902 L
.29843 .80902 L
.29843 .80902 L
.29843 .80902 L
.29843 .80902 L
.29843 .80902 L
Mistroke
.29843 .80902 L
Mfstroke
0 0 1 r
.004 w
.43398 .80902 m
.43398 .80902 L
.43398 .80902 L
.43398 .80902 L
.43398 .80902 L
.43398 .80902 L
.43398 .80902 L
.43398 .80902 L
.43398 .80902 L
.43398 .80902 L
.43398 .80902 L
.43398 .80902 L
.43398 .80902 L
.43398 .80902 L
.43398 .80902 L
.43398 .80902 L
.43398 .80902 L
.43398 .80902 L
.43398 .80902 L
.43398 .80902 L
.43398 .80902 L
.43398 .80902 L
.43398 .80902 L
.43398 .80902 L
.43398 .80902 L
.43398 .80902 L
.43398 .80902 L
.43398 .80902 L
.43398 .80902 L
.43398 .80902 L
.43398 .80902 L
.43398 .80902 L
.43398 .80902 L
.43398 .80902 L
.43398 .80902 L
.43398 .80902 L
.43398 .80902 L
.43398 .80902 L
.43398 .80902 L
.43398 .80902 L
.43398 .80902 L
.43398 .80902 L
.43398 .80902 L
.43398 .80902 L
.43398 .80902 L
.43398 .80902 L
.43398 .80902 L
.43398 .80902 L
.43398 .80902 L
.43398 .80902 L
Mistroke
.43398 .80902 L
Mfstroke
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.909028 0.369391 0.97619 0.705202 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.47619 0.000312461 0.00624922 [
[ 0 0 0 0 ]
[ 1 5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 5 L
0 5 L
closepath
clip
newpath
.75 0 0 r
.02381 .00031 m
.02381 .00656 L
.5 .00656 L
.5 .00031 L
F
0 g
gsave
.52381 .00344 -61 -10.5938 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 21.1875 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.313 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(-) show
69.125 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4.) show
81.375 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.75 0 .004 r
.02381 .00656 m
.02381 .01281 L
.5 .01281 L
.5 .00656 L
F
.75 0 .007 r
.02381 .01281 m
.02381 .01906 L
.5 .01906 L
.5 .01281 L
F
.75 0 .011 r
.02381 .01906 m
.02381 .02531 L
.5 .02531 L
.5 .01906 L
F
.75 0 .015 r
.02381 .02531 m
.02381 .03156 L
.5 .03156 L
.5 .02531 L
F
.75 0 .018 r
.02381 .03156 m
.02381 .03781 L
.5 .03781 L
.5 .03156 L
F
.75 0 .022 r
.02381 .03781 m
.02381 .04406 L
.5 .04406 L
.5 .03781 L
F
.75 0 .026 r
.02381 .04406 m
.02381 .05031 L
.5 .05031 L
.5 .04406 L
F
.75 0 .029 r
.02381 .05031 m
.02381 .05656 L
.5 .05656 L
.5 .05031 L
F
.75 0 .033 r
.02381 .05656 m
.02381 .0628 L
.5 .0628 L
.5 .05656 L
F
.75 0 .037 r
.02381 .0628 m
.02381 .06905 L
.5 .06905 L
.5 .0628 L
F
.75 0 .04 r
.02381 .06905 m
.02381 .0753 L
.5 .0753 L
.5 .06905 L
F
.75 0 .044 r
.02381 .0753 m
.02381 .08155 L
.5 .08155 L
.5 .0753 L
F
.75 0 .048 r
.02381 .08155 m
.02381 .0878 L
.5 .0878 L
.5 .08155 L
F
.75 0 .051 r
.02381 .0878 m
.02381 .09405 L
.5 .09405 L
.5 .0878 L
F
.75 0 .055 r
.02381 .09405 m
.02381 .1003 L
.5 .1003 L
.5 .09405 L
F
.75 0 .059 r
.02381 .1003 m
.02381 .10655 L
.5 .10655 L
.5 .1003 L
F
.75 0 .062 r
.02381 .10655 m
.02381 .1128 L
.5 .1128 L
.5 .10655 L
F
.75 0 .066 r
.02381 .1128 m
.02381 .11905 L
.5 .11905 L
.5 .1128 L
F
.75 0 .07 r
.02381 .11905 m
.02381 .1253 L
.5 .1253 L
.5 .11905 L
F
.75 0 .073 r
.02381 .1253 m
.02381 .13155 L
.5 .13155 L
.5 .1253 L
F
.75 0 .077 r
.02381 .13155 m
.02381 .1378 L
.5 .1378 L
.5 .13155 L
F
.75 0 .081 r
.02381 .1378 m
.02381 .14404 L
.5 .14404 L
.5 .1378 L
F
.75 0 .084 r
.02381 .14404 m
.02381 .15029 L
.5 .15029 L
.5 .14404 L
F
.75 0 .088 r
.02381 .15029 m
.02381 .15654 L
.5 .15654 L
.5 .15029 L
F
.75 0 .092 r
.02381 .15654 m
.02381 .16279 L
.5 .16279 L
.5 .15654 L
F
.75 0 .095 r
.02381 .16279 m
.02381 .16904 L
.5 .16904 L
.5 .16279 L
F
.75 0 .099 r
.02381 .16904 m
.02381 .17529 L
.5 .17529 L
.5 .16904 L
F
.75 0 .103 r
.02381 .17529 m
.02381 .18154 L
.5 .18154 L
.5 .17529 L
F
.75 0 .106 r
.02381 .18154 m
.02381 .18779 L
.5 .18779 L
.5 .18154 L
F
.75 0 .11 r
.02381 .18779 m
.02381 .19404 L
.5 .19404 L
.5 .18779 L
F
.75 0 .113 r
.02381 .19404 m
.02381 .20029 L
.5 .20029 L
.5 .19404 L
F
.75 0 .117 r
.02381 .20029 m
.02381 .20654 L
.5 .20654 L
.5 .20029 L
F
.75 0 .121 r
.02381 .20654 m
.02381 .21279 L
.5 .21279 L
.5 .20654 L
F
.75 0 .124 r
.02381 .21279 m
.02381 .21904 L
.5 .21904 L
.5 .21279 L
F
.75 0 .128 r
.02381 .21904 m
.02381 .22528 L
.5 .22528 L
.5 .21904 L
F
.75 0 .132 r
.02381 .22528 m
.02381 .23153 L
.5 .23153 L
.5 .22528 L
F
.75 0 .135 r
.02381 .23153 m
.02381 .23778 L
.5 .23778 L
.5 .23153 L
F
.75 0 .139 r
.02381 .23778 m
.02381 .24403 L
.5 .24403 L
.5 .23778 L
F
.75 0 .143 r
.02381 .24403 m
.02381 .25028 L
.5 .25028 L
.5 .24403 L
F
.75 0 .146 r
.02381 .25028 m
.02381 .25653 L
.5 .25653 L
.5 .25028 L
F
.75 0 .15 r
.02381 .25653 m
.02381 .26278 L
.5 .26278 L
.5 .25653 L
F
.75 0 .154 r
.02381 .26278 m
.02381 .26903 L
.5 .26903 L
.5 .26278 L
F
.75 0 .157 r
.02381 .26903 m
.02381 .27528 L
.5 .27528 L
.5 .26903 L
F
.75 0 .161 r
.02381 .27528 m
.02381 .28153 L
.5 .28153 L
.5 .27528 L
F
.75 0 .165 r
.02381 .28153 m
.02381 .28778 L
.5 .28778 L
.5 .28153 L
F
.75 0 .168 r
.02381 .28778 m
.02381 .29403 L
.5 .29403 L
.5 .28778 L
F
.75 0 .172 r
.02381 .29403 m
.02381 .30027 L
.5 .30027 L
.5 .29403 L
F
.75 0 .176 r
.02381 .30027 m
.02381 .30652 L
.5 .30652 L
.5 .30027 L
F
.75 0 .179 r
.02381 .30652 m
.02381 .31277 L
.5 .31277 L
.5 .30652 L
F
.75 0 .183 r
.02381 .31277 m
.02381 .31902 L
.5 .31902 L
.5 .31277 L
F
.75 0 .187 r
.02381 .31902 m
.02381 .32527 L
.5 .32527 L
.5 .31902 L
F
.75 0 .19 r
.02381 .32527 m
.02381 .33152 L
.5 .33152 L
.5 .32527 L
F
.75 0 .194 r
.02381 .33152 m
.02381 .33777 L
.5 .33777 L
.5 .33152 L
F
.75 0 .198 r
.02381 .33777 m
.02381 .34402 L
.5 .34402 L
.5 .33777 L
F
.75 0 .201 r
.02381 .34402 m
.02381 .35027 L
.5 .35027 L
.5 .34402 L
F
.75 0 .205 r
.02381 .35027 m
.02381 .35652 L
.5 .35652 L
.5 .35027 L
F
.75 0 .209 r
.02381 .35652 m
.02381 .36277 L
.5 .36277 L
.5 .35652 L
F
.75 0 .212 r
.02381 .36277 m
.02381 .36902 L
.5 .36902 L
.5 .36277 L
F
.75 0 .216 r
.02381 .36902 m
.02381 .37527 L
.5 .37527 L
.5 .36902 L
F
.75 0 .22 r
.02381 .37527 m
.02381 .38151 L
.5 .38151 L
.5 .37527 L
F
.75 0 .223 r
.02381 .38151 m
.02381 .38776 L
.5 .38776 L
.5 .38151 L
F
.75 0 .227 r
.02381 .38776 m
.02381 .39401 L
.5 .39401 L
.5 .38776 L
F
.75 0 .231 r
.02381 .39401 m
.02381 .40026 L
.5 .40026 L
.5 .39401 L
F
.75 0 .234 r
.02381 .40026 m
.02381 .40651 L
.5 .40651 L
.5 .40026 L
F
.75 0 .238 r
.02381 .40651 m
.02381 .41276 L
.5 .41276 L
.5 .40651 L
F
.75 0 .242 r
.02381 .41276 m
.02381 .41901 L
.5 .41901 L
.5 .41276 L
F
.75 0 .245 r
.02381 .41901 m
.02381 .42526 L
.5 .42526 L
.5 .41901 L
F
.75 0 .249 r
.02381 .42526 m
.02381 .43151 L
.5 .43151 L
.5 .42526 L
F
.75 0 .253 r
.02381 .43151 m
.02381 .43776 L
.5 .43776 L
.5 .43151 L
F
.75 0 .256 r
.02381 .43776 m
.02381 .44401 L
.5 .44401 L
.5 .43776 L
F
.75 0 .26 r
.02381 .44401 m
.02381 .45026 L
.5 .45026 L
.5 .44401 L
F
.75 0 .264 r
.02381 .45026 m
.02381 .45651 L
.5 .45651 L
.5 .45026 L
F
.75 0 .267 r
.02381 .45651 m
.02381 .46275 L
.5 .46275 L
.5 .45651 L
F
.75 0 .271 r
.02381 .46275 m
.02381 .469 L
.5 .469 L
.5 .46275 L
F
.75 0 .275 r
.02381 .469 m
.02381 .47525 L
.5 .47525 L
.5 .469 L
F
.75 0 .278 r
.02381 .47525 m
.02381 .4815 L
.5 .4815 L
.5 .47525 L
F
.75 0 .282 r
.02381 .4815 m
.02381 .48775 L
.5 .48775 L
.5 .4815 L
F
.75 0 .286 r
.02381 .48775 m
.02381 .494 L
.5 .494 L
.5 .48775 L
F
.75 0 .289 r
.02381 .494 m
.02381 .50025 L
.5 .50025 L
.5 .494 L
F
.75 0 .293 r
.02381 .50025 m
.02381 .5065 L
.5 .5065 L
.5 .50025 L
F
.75 0 .297 r
.02381 .5065 m
.02381 .51275 L
.5 .51275 L
.5 .5065 L
F
.75 0 .3 r
.02381 .51275 m
.02381 .519 L
.5 .519 L
.5 .51275 L
F
.75 0 .304 r
.02381 .519 m
.02381 .52525 L
.5 .52525 L
.5 .519 L
F
.75 0 .308 r
.02381 .52525 m
.02381 .5315 L
.5 .5315 L
.5 .52525 L
F
.75 0 .311 r
.02381 .5315 m
.02381 .53775 L
.5 .53775 L
.5 .5315 L
F
.75 0 .315 r
.02381 .53775 m
.02381 .54399 L
.5 .54399 L
.5 .53775 L
F
.75 0 .318 r
.02381 .54399 m
.02381 .55024 L
.5 .55024 L
.5 .54399 L
F
.75 0 .322 r
.02381 .55024 m
.02381 .55649 L
.5 .55649 L
.5 .55024 L
F
.75 0 .326 r
.02381 .55649 m
.02381 .56274 L
.5 .56274 L
.5 .55649 L
F
.75 0 .329 r
.02381 .56274 m
.02381 .56899 L
.5 .56899 L
.5 .56274 L
F
.75 0 .333 r
.02381 .56899 m
.02381 .57524 L
.5 .57524 L
.5 .56899 L
F
.75 0 .337 r
.02381 .57524 m
.02381 .58149 L
.5 .58149 L
.5 .57524 L
F
.75 0 .34 r
.02381 .58149 m
.02381 .58774 L
.5 .58774 L
.5 .58149 L
F
.75 0 .344 r
.02381 .58774 m
.02381 .59399 L
.5 .59399 L
.5 .58774 L
F
.75 0 .348 r
.02381 .59399 m
.02381 .60024 L
.5 .60024 L
.5 .59399 L
F
.75 0 .351 r
.02381 .60024 m
.02381 .60649 L
.5 .60649 L
.5 .60024 L
F
.75 0 .355 r
.02381 .60649 m
.02381 .61274 L
.5 .61274 L
.5 .60649 L
F
.75 0 .359 r
.02381 .61274 m
.02381 .61899 L
.5 .61899 L
.5 .61274 L
F
.75 0 .362 r
.02381 .61899 m
.02381 .62523 L
.5 .62523 L
.5 .61899 L
F
.75 0 .366 r
.02381 .62523 m
.02381 .63148 L
.5 .63148 L
.5 .62523 L
F
.75 0 .37 r
.02381 .63148 m
.02381 .63773 L
.5 .63773 L
.5 .63148 L
F
.75 0 .373 r
.02381 .63773 m
.02381 .64398 L
.5 .64398 L
.5 .63773 L
F
.75 0 .377 r
.02381 .64398 m
.02381 .65023 L
.5 .65023 L
.5 .64398 L
F
.75 0 .381 r
.02381 .65023 m
.02381 .65648 L
.5 .65648 L
.5 .65023 L
F
.75 0 .384 r
.02381 .65648 m
.02381 .66273 L
.5 .66273 L
.5 .65648 L
F
.75 0 .388 r
.02381 .66273 m
.02381 .66898 L
.5 .66898 L
.5 .66273 L
F
.75 0 .392 r
.02381 .66898 m
.02381 .67523 L
.5 .67523 L
.5 .66898 L
F
.75 0 .395 r
.02381 .67523 m
.02381 .68148 L
.5 .68148 L
.5 .67523 L
F
.75 0 .399 r
.02381 .68148 m
.02381 .68773 L
.5 .68773 L
.5 .68148 L
F
.75 0 .403 r
.02381 .68773 m
.02381 .69398 L
.5 .69398 L
.5 .68773 L
F
.75 0 .406 r
.02381 .69398 m
.02381 .70022 L
.5 .70022 L
.5 .69398 L
F
.75 0 .41 r
.02381 .70022 m
.02381 .70647 L
.5 .70647 L
.5 .70022 L
F
.75 0 .414 r
.02381 .70647 m
.02381 .71272 L
.5 .71272 L
.5 .70647 L
F
.75 0 .417 r
.02381 .71272 m
.02381 .71897 L
.5 .71897 L
.5 .71272 L
F
.75 0 .421 r
.02381 .71897 m
.02381 .72522 L
.5 .72522 L
.5 .71897 L
F
.75 0 .425 r
.02381 .72522 m
.02381 .73147 L
.5 .73147 L
.5 .72522 L
F
.75 0 .428 r
.02381 .73147 m
.02381 .73772 L
.5 .73772 L
.5 .73147 L
F
.75 0 .432 r
.02381 .73772 m
.02381 .74397 L
.5 .74397 L
.5 .73772 L
F
.75 0 .436 r
.02381 .74397 m
.02381 .75022 L
.5 .75022 L
.5 .74397 L
F
.75 0 .439 r
.02381 .75022 m
.02381 .75647 L
.5 .75647 L
.5 .75022 L
F
.75 0 .443 r
.02381 .75647 m
.02381 .76272 L
.5 .76272 L
.5 .75647 L
F
.75 0 .447 r
.02381 .76272 m
.02381 .76897 L
.5 .76897 L
.5 .76272 L
F
.75 0 .45 r
.02381 .76897 m
.02381 .77522 L
.5 .77522 L
.5 .76897 L
F
.75 0 .454 r
.02381 .77522 m
.02381 .78146 L
.5 .78146 L
.5 .77522 L
F
.75 0 .458 r
.02381 .78146 m
.02381 .78771 L
.5 .78771 L
.5 .78146 L
F
.75 0 .461 r
.02381 .78771 m
.02381 .79396 L
.5 .79396 L
.5 .78771 L
F
.75 0 .465 r
.02381 .79396 m
.02381 .80021 L
.5 .80021 L
.5 .79396 L
F
.75 0 .469 r
.02381 .80021 m
.02381 .80646 L
.5 .80646 L
.5 .80021 L
F
.75 0 .472 r
.02381 .80646 m
.02381 .81271 L
.5 .81271 L
.5 .80646 L
F
.75 0 .476 r
.02381 .81271 m
.02381 .81896 L
.5 .81896 L
.5 .81271 L
F
.75 0 .48 r
.02381 .81896 m
.02381 .82521 L
.5 .82521 L
.5 .81896 L
F
.75 0 .483 r
.02381 .82521 m
.02381 .83146 L
.5 .83146 L
.5 .82521 L
F
.75 0 .487 r
.02381 .83146 m
.02381 .83771 L
.5 .83771 L
.5 .83146 L
F
.75 0 .491 r
.02381 .83771 m
.02381 .84396 L
.5 .84396 L
.5 .83771 L
F
.75 0 .494 r
.02381 .84396 m
.02381 .85021 L
.5 .85021 L
.5 .84396 L
F
.75 0 .498 r
.02381 .85021 m
.02381 .85646 L
.5 .85646 L
.5 .85021 L
F
.75 0 .502 r
.02381 .85646 m
.02381 .8627 L
.5 .8627 L
.5 .85646 L
F
.75 0 .505 r
.02381 .8627 m
.02381 .86895 L
.5 .86895 L
.5 .8627 L
F
.75 0 .509 r
.02381 .86895 m
.02381 .8752 L
.5 .8752 L
.5 .86895 L
F
.75 0 .513 r
.02381 .8752 m
.02381 .88145 L
.5 .88145 L
.5 .8752 L
F
.75 0 .516 r
.02381 .88145 m
.02381 .8877 L
.5 .8877 L
.5 .88145 L
F
.75 0 .52 r
.02381 .8877 m
.02381 .89395 L
.5 .89395 L
.5 .8877 L
F
.75 0 .523 r
.02381 .89395 m
.02381 .9002 L
.5 .9002 L
.5 .89395 L
F
.75 0 .527 r
.02381 .9002 m
.02381 .90645 L
.5 .90645 L
.5 .9002 L
F
.75 0 .531 r
.02381 .90645 m
.02381 .9127 L
.5 .9127 L
.5 .90645 L
F
.75 0 .534 r
.02381 .9127 m
.02381 .91895 L
.5 .91895 L
.5 .9127 L
F
.75 0 .538 r
.02381 .91895 m
.02381 .9252 L
.5 .9252 L
.5 .91895 L
F
.75 0 .542 r
.02381 .9252 m
.02381 .93145 L
.5 .93145 L
.5 .9252 L
F
.75 0 .545 r
.02381 .93145 m
.02381 .9377 L
.5 .9377 L
.5 .93145 L
F
.75 0 .549 r
.02381 .9377 m
.02381 .94394 L
.5 .94394 L
.5 .9377 L
F
.75 0 .553 r
.02381 .94394 m
.02381 .95019 L
.5 .95019 L
.5 .94394 L
F
.75 0 .556 r
.02381 .95019 m
.02381 .95644 L
.5 .95644 L
.5 .95019 L
F
.75 0 .56 r
.02381 .95644 m
.02381 .96269 L
.5 .96269 L
.5 .95644 L
F
.75 0 .564 r
.02381 .96269 m
.02381 .96894 L
.5 .96894 L
.5 .96269 L
F
.75 0 .567 r
.02381 .96894 m
.02381 .97519 L
.5 .97519 L
.5 .96894 L
F
.75 0 .571 r
.02381 .97519 m
.02381 .98144 L
.5 .98144 L
.5 .97519 L
F
.75 0 .575 r
.02381 .98144 m
.02381 .98769 L
.5 .98769 L
.5 .98144 L
F
.75 0 .578 r
.02381 .98769 m
.02381 .99394 L
.5 .99394 L
.5 .98769 L
F
.75 0 .582 r
.02381 .99394 m
.02381 1.00019 L
.5 1.00019 L
.5 .99394 L
F
.75 0 .586 r
.02381 1.00019 m
.02381 1.00644 L
.5 1.00644 L
.5 1.00019 L
F
.75 0 .589 r
.02381 1.00644 m
.02381 1.01269 L
.5 1.01269 L
.5 1.00644 L
F
.75 0 .593 r
.02381 1.01269 m
.02381 1.01894 L
.5 1.01894 L
.5 1.01269 L
F
.75 0 .597 r
.02381 1.01894 m
.02381 1.02518 L
.5 1.02518 L
.5 1.01894 L
F
.75 0 .6 r
.02381 1.02518 m
.02381 1.03143 L
.5 1.03143 L
.5 1.02518 L
F
.75 0 .604 r
.02381 1.03143 m
.02381 1.03768 L
.5 1.03768 L
.5 1.03143 L
F
.75 0 .608 r
.02381 1.03768 m
.02381 1.04393 L
.5 1.04393 L
.5 1.03768 L
F
.75 0 .611 r
.02381 1.04393 m
.02381 1.05018 L
.5 1.05018 L
.5 1.04393 L
F
.75 0 .615 r
.02381 1.05018 m
.02381 1.05643 L
.5 1.05643 L
.5 1.05018 L
F
.75 0 .619 r
.02381 1.05643 m
.02381 1.06268 L
.5 1.06268 L
.5 1.05643 L
F
.75 0 .622 r
.02381 1.06268 m
.02381 1.06893 L
.5 1.06893 L
.5 1.06268 L
F
.75 0 .626 r
.02381 1.06893 m
.02381 1.07518 L
.5 1.07518 L
.5 1.06893 L
F
.75 0 .63 r
.02381 1.07518 m
.02381 1.08143 L
.5 1.08143 L
.5 1.07518 L
F
.75 0 .633 r
.02381 1.08143 m
.02381 1.08768 L
.5 1.08768 L
.5 1.08143 L
F
.75 0 .637 r
.02381 1.08768 m
.02381 1.09393 L
.5 1.09393 L
.5 1.08768 L
F
.75 0 .641 r
.02381 1.09393 m
.02381 1.10017 L
.5 1.10017 L
.5 1.09393 L
F
.75 0 .644 r
.02381 1.10017 m
.02381 1.10642 L
.5 1.10642 L
.5 1.10017 L
F
.75 0 .648 r
.02381 1.10642 m
.02381 1.11267 L
.5 1.11267 L
.5 1.10642 L
F
.75 0 .652 r
.02381 1.11267 m
.02381 1.11892 L
.5 1.11892 L
.5 1.11267 L
F
.75 0 .655 r
.02381 1.11892 m
.02381 1.12517 L
.5 1.12517 L
.5 1.11892 L
F
.75 0 .659 r
.02381 1.12517 m
.02381 1.13142 L
.5 1.13142 L
.5 1.12517 L
F
.75 0 .663 r
.02381 1.13142 m
.02381 1.13767 L
.5 1.13767 L
.5 1.13142 L
F
.75 0 .666 r
.02381 1.13767 m
.02381 1.14392 L
.5 1.14392 L
.5 1.13767 L
F
.75 0 .67 r
.02381 1.14392 m
.02381 1.15017 L
.5 1.15017 L
.5 1.14392 L
F
.75 0 .674 r
.02381 1.15017 m
.02381 1.15642 L
.5 1.15642 L
.5 1.15017 L
F
.75 0 .677 r
.02381 1.15642 m
.02381 1.16267 L
.5 1.16267 L
.5 1.15642 L
F
.75 0 .681 r
.02381 1.16267 m
.02381 1.16892 L
.5 1.16892 L
.5 1.16267 L
F
.75 0 .685 r
.02381 1.16892 m
.02381 1.17517 L
.5 1.17517 L
.5 1.16892 L
F
.75 0 .688 r
.02381 1.17517 m
.02381 1.18141 L
.5 1.18141 L
.5 1.17517 L
F
.75 0 .692 r
.02381 1.18141 m
.02381 1.18766 L
.5 1.18766 L
.5 1.18141 L
F
.75 0 .696 r
.02381 1.18766 m
.02381 1.19391 L
.5 1.19391 L
.5 1.18766 L
F
.75 0 .699 r
.02381 1.19391 m
.02381 1.20016 L
.5 1.20016 L
.5 1.19391 L
F
.75 0 .703 r
.02381 1.20016 m
.02381 1.20641 L
.5 1.20641 L
.5 1.20016 L
F
.75 0 .707 r
.02381 1.20641 m
.02381 1.21266 L
.5 1.21266 L
.5 1.20641 L
F
.75 0 .71 r
.02381 1.21266 m
.02381 1.21891 L
.5 1.21891 L
.5 1.21266 L
F
.75 0 .714 r
.02381 1.21891 m
.02381 1.22516 L
.5 1.22516 L
.5 1.21891 L
F
.75 0 .718 r
.02381 1.22516 m
.02381 1.23141 L
.5 1.23141 L
.5 1.22516 L
F
.75 0 .721 r
.02381 1.23141 m
.02381 1.23766 L
.5 1.23766 L
.5 1.23141 L
F
.75 0 .725 r
.02381 1.23766 m
.02381 1.24391 L
.5 1.24391 L
.5 1.23766 L
F
.75 0 .729 r
.02381 1.24391 m
.02381 1.25016 L
.5 1.25016 L
.5 1.24391 L
F
.75 0 .732 r
.02381 1.25016 m
.02381 1.25641 L
.5 1.25641 L
.5 1.25016 L
F
.75 0 .736 r
.02381 1.25641 m
.02381 1.26265 L
.5 1.26265 L
.5 1.25641 L
F
.75 0 .739 r
.02381 1.26265 m
.02381 1.2689 L
.5 1.2689 L
.5 1.26265 L
F
.75 0 .743 r
.02381 1.2689 m
.02381 1.27515 L
.5 1.27515 L
.5 1.2689 L
F
.75 0 .747 r
.02381 1.27515 m
.02381 1.2814 L
.5 1.2814 L
.5 1.27515 L
F
.75 0 .75 r
.02381 1.2814 m
.02381 1.28765 L
.5 1.28765 L
.5 1.2814 L
F
.746 0 .75 r
.02381 1.28765 m
.02381 1.2939 L
.5 1.2939 L
.5 1.28765 L
F
.742 0 .75 r
.02381 1.2939 m
.02381 1.30015 L
.5 1.30015 L
.5 1.2939 L
F
.739 0 .75 r
.02381 1.30015 m
.02381 1.3064 L
.5 1.3064 L
.5 1.30015 L
F
.735 0 .75 r
.02381 1.3064 m
.02381 1.31265 L
.5 1.31265 L
.5 1.3064 L
F
.731 0 .75 r
.02381 1.31265 m
.02381 1.3189 L
.5 1.3189 L
.5 1.31265 L
F
.728 0 .75 r
.02381 1.3189 m
.02381 1.32515 L
.5 1.32515 L
.5 1.3189 L
F
.724 0 .75 r
.02381 1.32515 m
.02381 1.3314 L
.5 1.3314 L
.5 1.32515 L
F
.72 0 .75 r
.02381 1.3314 m
.02381 1.33765 L
.5 1.33765 L
.5 1.3314 L
F
.717 0 .75 r
.02381 1.33765 m
.02381 1.34389 L
.5 1.34389 L
.5 1.33765 L
F
.713 0 .75 r
.02381 1.34389 m
.02381 1.35014 L
.5 1.35014 L
.5 1.34389 L
F
.709 0 .75 r
.02381 1.35014 m
.02381 1.35639 L
.5 1.35639 L
.5 1.35014 L
F
.706 0 .75 r
.02381 1.35639 m
.02381 1.36264 L
.5 1.36264 L
.5 1.35639 L
F
.702 0 .75 r
.02381 1.36264 m
.02381 1.36889 L
.5 1.36889 L
.5 1.36264 L
F
.698 0 .75 r
.02381 1.36889 m
.02381 1.37514 L
.5 1.37514 L
.5 1.36889 L
F
.695 0 .75 r
.02381 1.37514 m
.02381 1.38139 L
.5 1.38139 L
.5 1.37514 L
F
.691 0 .75 r
.02381 1.38139 m
.02381 1.38764 L
.5 1.38764 L
.5 1.38139 L
F
.687 0 .75 r
.02381 1.38764 m
.02381 1.39389 L
.5 1.39389 L
.5 1.38764 L
F
.684 0 .75 r
.02381 1.39389 m
.02381 1.40014 L
.5 1.40014 L
.5 1.39389 L
F
.68 0 .75 r
.02381 1.40014 m
.02381 1.40639 L
.5 1.40639 L
.5 1.40014 L
F
.676 0 .75 r
.02381 1.40639 m
.02381 1.41264 L
.5 1.41264 L
.5 1.40639 L
F
.673 0 .75 r
.02381 1.41264 m
.02381 1.41889 L
.5 1.41889 L
.5 1.41264 L
F
.669 0 .75 r
.02381 1.41889 m
.02381 1.42513 L
.5 1.42513 L
.5 1.41889 L
F
.665 0 .75 r
.02381 1.42513 m
.02381 1.43138 L
.5 1.43138 L
.5 1.42513 L
F
.662 0 .75 r
.02381 1.43138 m
.02381 1.43763 L
.5 1.43763 L
.5 1.43138 L
F
.658 0 .75 r
.02381 1.43763 m
.02381 1.44388 L
.5 1.44388 L
.5 1.43763 L
F
.654 0 .75 r
.02381 1.44388 m
.02381 1.45013 L
.5 1.45013 L
.5 1.44388 L
F
.651 0 .75 r
.02381 1.45013 m
.02381 1.45638 L
.5 1.45638 L
.5 1.45013 L
F
.647 0 .75 r
.02381 1.45638 m
.02381 1.46263 L
.5 1.46263 L
.5 1.45638 L
F
.643 0 .75 r
.02381 1.46263 m
.02381 1.46888 L
.5 1.46888 L
.5 1.46263 L
F
.64 0 .75 r
.02381 1.46888 m
.02381 1.47513 L
.5 1.47513 L
.5 1.46888 L
F
.636 0 .75 r
.02381 1.47513 m
.02381 1.48138 L
.5 1.48138 L
.5 1.47513 L
F
.632 0 .75 r
.02381 1.48138 m
.02381 1.48763 L
.5 1.48763 L
.5 1.48138 L
F
.629 0 .75 r
.02381 1.48763 m
.02381 1.49388 L
.5 1.49388 L
.5 1.48763 L
F
.625 0 .75 r
.02381 1.49388 m
.02381 1.50012 L
.5 1.50012 L
.5 1.49388 L
F
.621 0 .75 r
.02381 1.50012 m
.02381 1.50637 L
.5 1.50637 L
.5 1.50012 L
F
.618 0 .75 r
.02381 1.50637 m
.02381 1.51262 L
.5 1.51262 L
.5 1.50637 L
F
.614 0 .75 r
.02381 1.51262 m
.02381 1.51887 L
.5 1.51887 L
.5 1.51262 L
F
.61 0 .75 r
.02381 1.51887 m
.02381 1.52512 L
.5 1.52512 L
.5 1.51887 L
F
.607 0 .75 r
.02381 1.52512 m
.02381 1.53137 L
.5 1.53137 L
.5 1.52512 L
F
.603 0 .75 r
.02381 1.53137 m
.02381 1.53762 L
.5 1.53762 L
.5 1.53137 L
F
.599 0 .75 r
.02381 1.53762 m
.02381 1.54387 L
.5 1.54387 L
.5 1.53762 L
F
.596 0 .75 r
.02381 1.54387 m
.02381 1.55012 L
.5 1.55012 L
.5 1.54387 L
F
.592 0 .75 r
.02381 1.55012 m
.02381 1.55637 L
.5 1.55637 L
.5 1.55012 L
F
.588 0 .75 r
.02381 1.55637 m
.02381 1.56262 L
.5 1.56262 L
.5 1.55637 L
F
.585 0 .75 r
.02381 1.56262 m
.02381 1.56887 L
.5 1.56887 L
.5 1.56262 L
F
.581 0 .75 r
.02381 1.56887 m
.02381 1.57512 L
.5 1.57512 L
.5 1.56887 L
F
.577 0 .75 r
.02381 1.57512 m
.02381 1.58136 L
.5 1.58136 L
.5 1.57512 L
F
.574 0 .75 r
.02381 1.58136 m
.02381 1.58761 L
.5 1.58761 L
.5 1.58136 L
F
.57 0 .75 r
.02381 1.58761 m
.02381 1.59386 L
.5 1.59386 L
.5 1.58761 L
F
.566 0 .75 r
.02381 1.59386 m
.02381 1.60011 L
.5 1.60011 L
.5 1.59386 L
F
.563 0 .75 r
.02381 1.60011 m
.02381 1.60636 L
.5 1.60636 L
.5 1.60011 L
F
.559 0 .75 r
.02381 1.60636 m
.02381 1.61261 L
.5 1.61261 L
.5 1.60636 L
F
.556 0 .75 r
.02381 1.61261 m
.02381 1.61886 L
.5 1.61886 L
.5 1.61261 L
F
.552 0 .75 r
.02381 1.61886 m
.02381 1.62511 L
.5 1.62511 L
.5 1.61886 L
F
.548 0 .75 r
.02381 1.62511 m
.02381 1.63136 L
.5 1.63136 L
.5 1.62511 L
F
.545 0 .75 r
.02381 1.63136 m
.02381 1.63761 L
.5 1.63761 L
.5 1.63136 L
F
.541 0 .75 r
.02381 1.63761 m
.02381 1.64386 L
.5 1.64386 L
.5 1.63761 L
F
.537 0 .75 r
.02381 1.64386 m
.02381 1.65011 L
.5 1.65011 L
.5 1.64386 L
F
.534 0 .75 r
.02381 1.65011 m
.02381 1.65636 L
.5 1.65636 L
.5 1.65011 L
F
.53 0 .75 r
.02381 1.65636 m
.02381 1.6626 L
.5 1.6626 L
.5 1.65636 L
F
.526 0 .75 r
.02381 1.6626 m
.02381 1.66885 L
.5 1.66885 L
.5 1.6626 L
F
.523 0 .75 r
.02381 1.66885 m
.02381 1.6751 L
.5 1.6751 L
.5 1.66885 L
F
.519 0 .75 r
.02381 1.6751 m
.02381 1.68135 L
.5 1.68135 L
.5 1.6751 L
F
.515 0 .75 r
.02381 1.68135 m
.02381 1.6876 L
.5 1.6876 L
.5 1.68135 L
F
.512 0 .75 r
.02381 1.6876 m
.02381 1.69385 L
.5 1.69385 L
.5 1.6876 L
F
.508 0 .75 r
.02381 1.69385 m
.02381 1.7001 L
.5 1.7001 L
.5 1.69385 L
F
.504 0 .75 r
.02381 1.7001 m
.02381 1.70635 L
.5 1.70635 L
.5 1.7001 L
F
.501 0 .75 r
.02381 1.70635 m
.02381 1.7126 L
.5 1.7126 L
.5 1.70635 L
F
.497 0 .75 r
.02381 1.7126 m
.02381 1.71885 L
.5 1.71885 L
.5 1.7126 L
F
.493 0 .75 r
.02381 1.71885 m
.02381 1.7251 L
.5 1.7251 L
.5 1.71885 L
F
.49 0 .75 r
.02381 1.7251 m
.02381 1.73135 L
.5 1.73135 L
.5 1.7251 L
F
.486 0 .75 r
.02381 1.73135 m
.02381 1.7376 L
.5 1.7376 L
.5 1.73135 L
F
.482 0 .75 r
.02381 1.7376 m
.02381 1.74384 L
.5 1.74384 L
.5 1.7376 L
F
.479 0 .75 r
.02381 1.74384 m
.02381 1.75009 L
.5 1.75009 L
.5 1.74384 L
F
.475 0 .75 r
.02381 1.75009 m
.02381 1.75634 L
.5 1.75634 L
.5 1.75009 L
F
.471 0 .75 r
.02381 1.75634 m
.02381 1.76259 L
.5 1.76259 L
.5 1.75634 L
F
.468 0 .75 r
.02381 1.76259 m
.02381 1.76884 L
.5 1.76884 L
.5 1.76259 L
F
.464 0 .75 r
.02381 1.76884 m
.02381 1.77509 L
.5 1.77509 L
.5 1.76884 L
F
.46 0 .75 r
.02381 1.77509 m
.02381 1.78134 L
.5 1.78134 L
.5 1.77509 L
F
.457 0 .75 r
.02381 1.78134 m
.02381 1.78759 L
.5 1.78759 L
.5 1.78134 L
F
.453 0 .75 r
.02381 1.78759 m
.02381 1.79384 L
.5 1.79384 L
.5 1.78759 L
F
.449 0 .75 r
.02381 1.79384 m
.02381 1.80009 L
.5 1.80009 L
.5 1.79384 L
F
.446 0 .75 r
.02381 1.80009 m
.02381 1.80634 L
.5 1.80634 L
.5 1.80009 L
F
.442 0 .75 r
.02381 1.80634 m
.02381 1.81259 L
.5 1.81259 L
.5 1.80634 L
F
.438 0 .75 r
.02381 1.81259 m
.02381 1.81884 L
.5 1.81884 L
.5 1.81259 L
F
.435 0 .75 r
.02381 1.81884 m
.02381 1.82508 L
.5 1.82508 L
.5 1.81884 L
F
.431 0 .75 r
.02381 1.82508 m
.02381 1.83133 L
.5 1.83133 L
.5 1.82508 L
F
.427 0 .75 r
.02381 1.83133 m
.02381 1.83758 L
.5 1.83758 L
.5 1.83133 L
F
.424 0 .75 r
.02381 1.83758 m
.02381 1.84383 L
.5 1.84383 L
.5 1.83758 L
F
.42 0 .75 r
.02381 1.84383 m
.02381 1.85008 L
.5 1.85008 L
.5 1.84383 L
F
.416 0 .75 r
.02381 1.85008 m
.02381 1.85633 L
.5 1.85633 L
.5 1.85008 L
F
.413 0 .75 r
.02381 1.85633 m
.02381 1.86258 L
.5 1.86258 L
.5 1.85633 L
F
.409 0 .75 r
.02381 1.86258 m
.02381 1.86883 L
.5 1.86883 L
.5 1.86258 L
F
.405 0 .75 r
.02381 1.86883 m
.02381 1.87508 L
.5 1.87508 L
.5 1.86883 L
F
.402 0 .75 r
.02381 1.87508 m
.02381 1.88133 L
.5 1.88133 L
.5 1.87508 L
F
.398 0 .75 r
.02381 1.88133 m
.02381 1.88758 L
.5 1.88758 L
.5 1.88133 L
F
.394 0 .75 r
.02381 1.88758 m
.02381 1.89383 L
.5 1.89383 L
.5 1.88758 L
F
.391 0 .75 r
.02381 1.89383 m
.02381 1.90007 L
.5 1.90007 L
.5 1.89383 L
F
.387 0 .75 r
.02381 1.90007 m
.02381 1.90632 L
.5 1.90632 L
.5 1.90007 L
F
.383 0 .75 r
.02381 1.90632 m
.02381 1.91257 L
.5 1.91257 L
.5 1.90632 L
F
.38 0 .75 r
.02381 1.91257 m
.02381 1.91882 L
.5 1.91882 L
.5 1.91257 L
F
.376 0 .75 r
.02381 1.91882 m
.02381 1.92507 L
.5 1.92507 L
.5 1.91882 L
F
.372 0 .75 r
.02381 1.92507 m
.02381 1.93132 L
.5 1.93132 L
.5 1.92507 L
F
.369 0 .75 r
.02381 1.93132 m
.02381 1.93757 L
.5 1.93757 L
.5 1.93132 L
F
.365 0 .75 r
.02381 1.93757 m
.02381 1.94382 L
.5 1.94382 L
.5 1.93757 L
F
.361 0 .75 r
.02381 1.94382 m
.02381 1.95007 L
.5 1.95007 L
.5 1.94382 L
F
.358 0 .75 r
.02381 1.95007 m
.02381 1.95632 L
.5 1.95632 L
.5 1.95007 L
F
.354 0 .75 r
.02381 1.95632 m
.02381 1.96257 L
.5 1.96257 L
.5 1.95632 L
F
.351 0 .75 r
.02381 1.96257 m
.02381 1.96882 L
.5 1.96882 L
.5 1.96257 L
F
.347 0 .75 r
.02381 1.96882 m
.02381 1.97507 L
.5 1.97507 L
.5 1.96882 L
F
.343 0 .75 r
.02381 1.97507 m
.02381 1.98131 L
.5 1.98131 L
.5 1.97507 L
F
.34 0 .75 r
.02381 1.98131 m
.02381 1.98756 L
.5 1.98756 L
.5 1.98131 L
F
.336 0 .75 r
.02381 1.98756 m
.02381 1.99381 L
.5 1.99381 L
.5 1.98756 L
F
.332 0 .75 r
.02381 1.99381 m
.02381 2.00006 L
.5 2.00006 L
.5 1.99381 L
F
.329 0 .75 r
.02381 2.00006 m
.02381 2.00631 L
.5 2.00631 L
.5 2.00006 L
F
.325 0 .75 r
.02381 2.00631 m
.02381 2.01256 L
.5 2.01256 L
.5 2.00631 L
F
.321 0 .75 r
.02381 2.01256 m
.02381 2.01881 L
.5 2.01881 L
.5 2.01256 L
F
.318 0 .75 r
.02381 2.01881 m
.02381 2.02506 L
.5 2.02506 L
.5 2.01881 L
F
.314 0 .75 r
.02381 2.02506 m
.02381 2.03131 L
.5 2.03131 L
.5 2.02506 L
F
.31 0 .75 r
.02381 2.03131 m
.02381 2.03756 L
.5 2.03756 L
.5 2.03131 L
F
.307 0 .75 r
.02381 2.03756 m
.02381 2.04381 L
.5 2.04381 L
.5 2.03756 L
F
.303 0 .75 r
.02381 2.04381 m
.02381 2.05006 L
.5 2.05006 L
.5 2.04381 L
F
.299 0 .75 r
.02381 2.05006 m
.02381 2.05631 L
.5 2.05631 L
.5 2.05006 L
F
.296 0 .75 r
.02381 2.05631 m
.02381 2.06255 L
.5 2.06255 L
.5 2.05631 L
F
.292 0 .75 r
.02381 2.06255 m
.02381 2.0688 L
.5 2.0688 L
.5 2.06255 L
F
.288 0 .75 r
.02381 2.0688 m
.02381 2.07505 L
.5 2.07505 L
.5 2.0688 L
F
.285 0 .75 r
.02381 2.07505 m
.02381 2.0813 L
.5 2.0813 L
.5 2.07505 L
F
.281 0 .75 r
.02381 2.0813 m
.02381 2.08755 L
.5 2.08755 L
.5 2.0813 L
F
.277 0 .75 r
.02381 2.08755 m
.02381 2.0938 L
.5 2.0938 L
.5 2.08755 L
F
.274 0 .75 r
.02381 2.0938 m
.02381 2.10005 L
.5 2.10005 L
.5 2.0938 L
F
.27 0 .75 r
.02381 2.10005 m
.02381 2.1063 L
.5 2.1063 L
.5 2.10005 L
F
.266 0 .75 r
.02381 2.1063 m
.02381 2.11255 L
.5 2.11255 L
.5 2.1063 L
F
.263 0 .75 r
.02381 2.11255 m
.02381 2.1188 L
.5 2.1188 L
.5 2.11255 L
F
.259 0 .75 r
.02381 2.1188 m
.02381 2.12505 L
.5 2.12505 L
.5 2.1188 L
F
.255 0 .75 r
.02381 2.12505 m
.02381 2.1313 L
.5 2.1313 L
.5 2.12505 L
F
.252 0 .75 r
.02381 2.1313 m
.02381 2.13755 L
.5 2.13755 L
.5 2.1313 L
F
.248 0 .75 r
.02381 2.13755 m
.02381 2.14379 L
.5 2.14379 L
.5 2.13755 L
F
.244 0 .75 r
.02381 2.14379 m
.02381 2.15004 L
.5 2.15004 L
.5 2.14379 L
F
.241 0 .75 r
.02381 2.15004 m
.02381 2.15629 L
.5 2.15629 L
.5 2.15004 L
F
.237 0 .75 r
.02381 2.15629 m
.02381 2.16254 L
.5 2.16254 L
.5 2.15629 L
F
.233 0 .75 r
.02381 2.16254 m
.02381 2.16879 L
.5 2.16879 L
.5 2.16254 L
F
.23 0 .75 r
.02381 2.16879 m
.02381 2.17504 L
.5 2.17504 L
.5 2.16879 L
F
.226 0 .75 r
.02381 2.17504 m
.02381 2.18129 L
.5 2.18129 L
.5 2.17504 L
F
.222 0 .75 r
.02381 2.18129 m
.02381 2.18754 L
.5 2.18754 L
.5 2.18129 L
F
.219 0 .75 r
.02381 2.18754 m
.02381 2.19379 L
.5 2.19379 L
.5 2.18754 L
F
.215 0 .75 r
.02381 2.19379 m
.02381 2.20004 L
.5 2.20004 L
.5 2.19379 L
F
.211 0 .75 r
.02381 2.20004 m
.02381 2.20629 L
.5 2.20629 L
.5 2.20004 L
F
.208 0 .75 r
.02381 2.20629 m
.02381 2.21254 L
.5 2.21254 L
.5 2.20629 L
F
.204 0 .75 r
.02381 2.21254 m
.02381 2.21879 L
.5 2.21879 L
.5 2.21254 L
F
.2 0 .75 r
.02381 2.21879 m
.02381 2.22503 L
.5 2.22503 L
.5 2.21879 L
F
.197 0 .75 r
.02381 2.22503 m
.02381 2.23128 L
.5 2.23128 L
.5 2.22503 L
F
.193 0 .75 r
.02381 2.23128 m
.02381 2.23753 L
.5 2.23753 L
.5 2.23128 L
F
.189 0 .75 r
.02381 2.23753 m
.02381 2.24378 L
.5 2.24378 L
.5 2.23753 L
F
.186 0 .75 r
.02381 2.24378 m
.02381 2.25003 L
.5 2.25003 L
.5 2.24378 L
F
.182 0 .75 r
.02381 2.25003 m
.02381 2.25628 L
.5 2.25628 L
.5 2.25003 L
F
.178 0 .75 r
.02381 2.25628 m
.02381 2.26253 L
.5 2.26253 L
.5 2.25628 L
F
.175 0 .75 r
.02381 2.26253 m
.02381 2.26878 L
.5 2.26878 L
.5 2.26253 L
F
.171 0 .75 r
.02381 2.26878 m
.02381 2.27503 L
.5 2.27503 L
.5 2.26878 L
F
.167 0 .75 r
.02381 2.27503 m
.02381 2.28128 L
.5 2.28128 L
.5 2.27503 L
F
.164 0 .75 r
.02381 2.28128 m
.02381 2.28753 L
.5 2.28753 L
.5 2.28128 L
F
.16 0 .75 r
.02381 2.28753 m
.02381 2.29378 L
.5 2.29378 L
.5 2.28753 L
F
.156 0 .75 r
.02381 2.29378 m
.02381 2.30002 L
.5 2.30002 L
.5 2.29378 L
F
.153 0 .75 r
.02381 2.30002 m
.02381 2.30627 L
.5 2.30627 L
.5 2.30002 L
F
.149 0 .75 r
.02381 2.30627 m
.02381 2.31252 L
.5 2.31252 L
.5 2.30627 L
F
.145 0 .75 r
.02381 2.31252 m
.02381 2.31877 L
.5 2.31877 L
.5 2.31252 L
F
.142 0 .75 r
.02381 2.31877 m
.02381 2.32502 L
.5 2.32502 L
.5 2.31877 L
F
.138 0 .75 r
.02381 2.32502 m
.02381 2.33127 L
.5 2.33127 L
.5 2.32502 L
F
.135 0 .75 r
.02381 2.33127 m
.02381 2.33752 L
.5 2.33752 L
.5 2.33127 L
F
.131 0 .75 r
.02381 2.33752 m
.02381 2.34377 L
.5 2.34377 L
.5 2.33752 L
F
.127 0 .75 r
.02381 2.34377 m
.02381 2.35002 L
.5 2.35002 L
.5 2.34377 L
F
.124 0 .75 r
.02381 2.35002 m
.02381 2.35627 L
.5 2.35627 L
.5 2.35002 L
F
.12 0 .75 r
.02381 2.35627 m
.02381 2.36252 L
.5 2.36252 L
.5 2.35627 L
F
.116 0 .75 r
.02381 2.36252 m
.02381 2.36877 L
.5 2.36877 L
.5 2.36252 L
F
.113 0 .75 r
.02381 2.36877 m
.02381 2.37502 L
.5 2.37502 L
.5 2.36877 L
F
.109 0 .75 r
.02381 2.37502 m
.02381 2.38126 L
.5 2.38126 L
.5 2.37502 L
F
.105 0 .75 r
.02381 2.38126 m
.02381 2.38751 L
.5 2.38751 L
.5 2.38126 L
F
.102 0 .75 r
.02381 2.38751 m
.02381 2.39376 L
.5 2.39376 L
.5 2.38751 L
F
.098 0 .75 r
.02381 2.39376 m
.02381 2.40001 L
.5 2.40001 L
.5 2.39376 L
F
.094 0 .75 r
.02381 2.40001 m
.02381 2.40626 L
.5 2.40626 L
.5 2.40001 L
F
.091 0 .75 r
.02381 2.40626 m
.02381 2.41251 L
.5 2.41251 L
.5 2.40626 L
F
.087 0 .75 r
.02381 2.41251 m
.02381 2.41876 L
.5 2.41876 L
.5 2.41251 L
F
.083 0 .75 r
.02381 2.41876 m
.02381 2.42501 L
.5 2.42501 L
.5 2.41876 L
F
.08 0 .75 r
.02381 2.42501 m
.02381 2.43126 L
.5 2.43126 L
.5 2.42501 L
F
.076 0 .75 r
.02381 2.43126 m
.02381 2.43751 L
.5 2.43751 L
.5 2.43126 L
F
.072 0 .75 r
.02381 2.43751 m
.02381 2.44376 L
.5 2.44376 L
.5 2.43751 L
F
.069 0 .75 r
.02381 2.44376 m
.02381 2.45001 L
.5 2.45001 L
.5 2.44376 L
F
.065 0 .75 r
.02381 2.45001 m
.02381 2.45626 L
.5 2.45626 L
.5 2.45001 L
F
.061 0 .75 r
.02381 2.45626 m
.02381 2.4625 L
.5 2.4625 L
.5 2.45626 L
F
.058 0 .75 r
.02381 2.4625 m
.02381 2.46875 L
.5 2.46875 L
.5 2.4625 L
F
.054 0 .75 r
.02381 2.46875 m
.02381 2.475 L
.5 2.475 L
.5 2.46875 L
F
.05 0 .75 r
.02381 2.475 m
.02381 2.48125 L
.5 2.48125 L
.5 2.475 L
F
.047 0 .75 r
.02381 2.48125 m
.02381 2.4875 L
.5 2.4875 L
.5 2.48125 L
F
.043 0 .75 r
.02381 2.4875 m
.02381 2.49375 L
.5 2.49375 L
.5 2.4875 L
F
.039 0 .75 r
.02381 2.49375 m
.02381 2.5 L
.5 2.5 L
.5 2.49375 L
F
.036 0 .75 r
.02381 2.5 m
.02381 2.50625 L
.5 2.50625 L
.5 2.5 L
F
.032 0 .75 r
.02381 2.50625 m
.02381 2.5125 L
.5 2.5125 L
.5 2.50625 L
F
.028 0 .75 r
.02381 2.5125 m
.02381 2.51875 L
.5 2.51875 L
.5 2.5125 L
F
.025 0 .75 r
.02381 2.51875 m
.02381 2.525 L
.5 2.525 L
.5 2.51875 L
F
.021 0 .75 r
.02381 2.525 m
.02381 2.53125 L
.5 2.53125 L
.5 2.525 L
F
.017 0 .75 r
.02381 2.53125 m
.02381 2.5375 L
.5 2.5375 L
.5 2.53125 L
F
.014 0 .75 r
.02381 2.5375 m
.02381 2.54374 L
.5 2.54374 L
.5 2.5375 L
F
.01 0 .75 r
.02381 2.54374 m
.02381 2.54999 L
.5 2.54999 L
.5 2.54374 L
F
.006 0 .75 r
.02381 2.54999 m
.02381 2.55624 L
.5 2.55624 L
.5 2.54999 L
F
.003 0 .75 r
.02381 2.55624 m
.02381 2.56249 L
.5 2.56249 L
.5 2.55624 L
F
0 .001 .75 r
.02381 2.56249 m
.02381 2.56874 L
.5 2.56874 L
.5 2.56249 L
F
0 .005 .75 r
.02381 2.56874 m
.02381 2.57499 L
.5 2.57499 L
.5 2.56874 L
F
0 .008 .75 r
.02381 2.57499 m
.02381 2.58124 L
.5 2.58124 L
.5 2.57499 L
F
0 .012 .75 r
.02381 2.58124 m
.02381 2.58749 L
.5 2.58749 L
.5 2.58124 L
F
0 .016 .75 r
.02381 2.58749 m
.02381 2.59374 L
.5 2.59374 L
.5 2.58749 L
F
0 .019 .75 r
.02381 2.59374 m
.02381 2.59999 L
.5 2.59999 L
.5 2.59374 L
F
0 .023 .75 r
.02381 2.59999 m
.02381 2.60624 L
.5 2.60624 L
.5 2.59999 L
F
0 .027 .75 r
.02381 2.60624 m
.02381 2.61249 L
.5 2.61249 L
.5 2.60624 L
F
0 .03 .75 r
.02381 2.61249 m
.02381 2.61874 L
.5 2.61874 L
.5 2.61249 L
F
0 .034 .75 r
.02381 2.61874 m
.02381 2.62498 L
.5 2.62498 L
.5 2.61874 L
F
0 .038 .75 r
.02381 2.62498 m
.02381 2.63123 L
.5 2.63123 L
.5 2.62498 L
F
0 .041 .75 r
.02381 2.63123 m
.02381 2.63748 L
.5 2.63748 L
.5 2.63123 L
F
0 .045 .75 r
.02381 2.63748 m
.02381 2.64373 L
.5 2.64373 L
.5 2.63748 L
F
0 .049 .75 r
.02381 2.64373 m
.02381 2.64998 L
.5 2.64998 L
.5 2.64373 L
F
0 .052 .75 r
.02381 2.64998 m
.02381 2.65623 L
.5 2.65623 L
.5 2.64998 L
F
0 .056 .75 r
.02381 2.65623 m
.02381 2.66248 L
.5 2.66248 L
.5 2.65623 L
F
0 .06 .75 r
.02381 2.66248 m
.02381 2.66873 L
.5 2.66873 L
.5 2.66248 L
F
0 .063 .75 r
.02381 2.66873 m
.02381 2.67498 L
.5 2.67498 L
.5 2.66873 L
F
0 .067 .75 r
.02381 2.67498 m
.02381 2.68123 L
.5 2.68123 L
.5 2.67498 L
F
0 .07 .75 r
.02381 2.68123 m
.02381 2.68748 L
.5 2.68748 L
.5 2.68123 L
F
0 .074 .75 r
.02381 2.68748 m
.02381 2.69373 L
.5 2.69373 L
.5 2.68748 L
F
0 .078 .75 r
.02381 2.69373 m
.02381 2.69998 L
.5 2.69998 L
.5 2.69373 L
F
0 .081 .75 r
.02381 2.69998 m
.02381 2.70622 L
.5 2.70622 L
.5 2.69998 L
F
0 .085 .75 r
.02381 2.70622 m
.02381 2.71247 L
.5 2.71247 L
.5 2.70622 L
F
0 .089 .75 r
.02381 2.71247 m
.02381 2.71872 L
.5 2.71872 L
.5 2.71247 L
F
0 .092 .75 r
.02381 2.71872 m
.02381 2.72497 L
.5 2.72497 L
.5 2.71872 L
F
0 .096 .75 r
.02381 2.72497 m
.02381 2.73122 L
.5 2.73122 L
.5 2.72497 L
F
0 .1 .75 r
.02381 2.73122 m
.02381 2.73747 L
.5 2.73747 L
.5 2.73122 L
F
0 .103 .75 r
.02381 2.73747 m
.02381 2.74372 L
.5 2.74372 L
.5 2.73747 L
F
0 .107 .75 r
.02381 2.74372 m
.02381 2.74997 L
.5 2.74997 L
.5 2.74372 L
F
0 .111 .75 r
.02381 2.74997 m
.02381 2.75622 L
.5 2.75622 L
.5 2.74997 L
F
0 .114 .75 r
.02381 2.75622 m
.02381 2.76247 L
.5 2.76247 L
.5 2.75622 L
F
0 .118 .75 r
.02381 2.76247 m
.02381 2.76872 L
.5 2.76872 L
.5 2.76247 L
F
0 .122 .75 r
.02381 2.76872 m
.02381 2.77497 L
.5 2.77497 L
.5 2.76872 L
F
0 .125 .75 r
.02381 2.77497 m
.02381 2.78121 L
.5 2.78121 L
.5 2.77497 L
F
0 .129 .75 r
.02381 2.78121 m
.02381 2.78746 L
.5 2.78746 L
.5 2.78121 L
F
0 .133 .75 r
.02381 2.78746 m
.02381 2.79371 L
.5 2.79371 L
.5 2.78746 L
F
0 .136 .75 r
.02381 2.79371 m
.02381 2.79996 L
.5 2.79996 L
.5 2.79371 L
F
0 .14 .75 r
.02381 2.79996 m
.02381 2.80621 L
.5 2.80621 L
.5 2.79996 L
F
0 .144 .75 r
.02381 2.80621 m
.02381 2.81246 L
.5 2.81246 L
.5 2.80621 L
F
0 .147 .75 r
.02381 2.81246 m
.02381 2.81871 L
.5 2.81871 L
.5 2.81246 L
F
0 .151 .75 r
.02381 2.81871 m
.02381 2.82496 L
.5 2.82496 L
.5 2.81871 L
F
0 .155 .75 r
.02381 2.82496 m
.02381 2.83121 L
.5 2.83121 L
.5 2.82496 L
F
0 .158 .75 r
.02381 2.83121 m
.02381 2.83746 L
.5 2.83746 L
.5 2.83121 L
F
0 .162 .75 r
.02381 2.83746 m
.02381 2.84371 L
.5 2.84371 L
.5 2.83746 L
F
0 .166 .75 r
.02381 2.84371 m
.02381 2.84996 L
.5 2.84996 L
.5 2.84371 L
F
0 .169 .75 r
.02381 2.84996 m
.02381 2.85621 L
.5 2.85621 L
.5 2.84996 L
F
0 .173 .75 r
.02381 2.85621 m
.02381 2.86245 L
.5 2.86245 L
.5 2.85621 L
F
0 .177 .75 r
.02381 2.86245 m
.02381 2.8687 L
.5 2.8687 L
.5 2.86245 L
F
0 .18 .75 r
.02381 2.8687 m
.02381 2.87495 L
.5 2.87495 L
.5 2.8687 L
F
0 .184 .75 r
.02381 2.87495 m
.02381 2.8812 L
.5 2.8812 L
.5 2.87495 L
F
0 .188 .75 r
.02381 2.8812 m
.02381 2.88745 L
.5 2.88745 L
.5 2.8812 L
F
0 .191 .75 r
.02381 2.88745 m
.02381 2.8937 L
.5 2.8937 L
.5 2.88745 L
F
0 .195 .75 r
.02381 2.8937 m
.02381 2.89995 L
.5 2.89995 L
.5 2.8937 L
F
0 .199 .75 r
.02381 2.89995 m
.02381 2.9062 L
.5 2.9062 L
.5 2.89995 L
F
0 .202 .75 r
.02381 2.9062 m
.02381 2.91245 L
.5 2.91245 L
.5 2.9062 L
F
0 .206 .75 r
.02381 2.91245 m
.02381 2.9187 L
.5 2.9187 L
.5 2.91245 L
F
0 .21 .75 r
.02381 2.9187 m
.02381 2.92495 L
.5 2.92495 L
.5 2.9187 L
F
0 .213 .75 r
.02381 2.92495 m
.02381 2.9312 L
.5 2.9312 L
.5 2.92495 L
F
0 .217 .75 r
.02381 2.9312 m
.02381 2.93745 L
.5 2.93745 L
.5 2.9312 L
F
0 .221 .75 r
.02381 2.93745 m
.02381 2.94369 L
.5 2.94369 L
.5 2.93745 L
F
0 .224 .75 r
.02381 2.94369 m
.02381 2.94994 L
.5 2.94994 L
.5 2.94369 L
F
0 .228 .75 r
.02381 2.94994 m
.02381 2.95619 L
.5 2.95619 L
.5 2.94994 L
F
0 .232 .75 r
.02381 2.95619 m
.02381 2.96244 L
.5 2.96244 L
.5 2.95619 L
F
0 .235 .75 r
.02381 2.96244 m
.02381 2.96869 L
.5 2.96869 L
.5 2.96244 L
F
0 .239 .75 r
.02381 2.96869 m
.02381 2.97494 L
.5 2.97494 L
.5 2.96869 L
F
0 .243 .75 r
.02381 2.97494 m
.02381 2.98119 L
.5 2.98119 L
.5 2.97494 L
F
0 .246 .75 r
.02381 2.98119 m
.02381 2.98744 L
.5 2.98744 L
.5 2.98119 L
F
0 .25 .75 r
.02381 2.98744 m
.02381 2.99369 L
.5 2.99369 L
.5 2.98744 L
F
0 .254 .75 r
.02381 2.99369 m
.02381 2.99994 L
.5 2.99994 L
.5 2.99369 L
F
0 .257 .75 r
.02381 2.99994 m
.02381 3.00619 L
.5 3.00619 L
.5 2.99994 L
F
0 .261 .75 r
.02381 3.00619 m
.02381 3.01244 L
.5 3.01244 L
.5 3.00619 L
F
0 .265 .75 r
.02381 3.01244 m
.02381 3.01869 L
.5 3.01869 L
.5 3.01244 L
F
0 .268 .75 r
.02381 3.01869 m
.02381 3.02493 L
.5 3.02493 L
.5 3.01869 L
F
0 .272 .75 r
.02381 3.02493 m
.02381 3.03118 L
.5 3.03118 L
.5 3.02493 L
F
0 .276 .75 r
.02381 3.03118 m
.02381 3.03743 L
.5 3.03743 L
.5 3.03118 L
F
0 .279 .75 r
.02381 3.03743 m
.02381 3.04368 L
.5 3.04368 L
.5 3.03743 L
F
0 .283 .75 r
.02381 3.04368 m
.02381 3.04993 L
.5 3.04993 L
.5 3.04368 L
F
0 .286 .75 r
.02381 3.04993 m
.02381 3.05618 L
.5 3.05618 L
.5 3.04993 L
F
0 .29 .75 r
.02381 3.05618 m
.02381 3.06243 L
.5 3.06243 L
.5 3.05618 L
F
0 .294 .75 r
.02381 3.06243 m
.02381 3.06868 L
.5 3.06868 L
.5 3.06243 L
F
0 .297 .75 r
.02381 3.06868 m
.02381 3.07493 L
.5 3.07493 L
.5 3.06868 L
F
0 .301 .75 r
.02381 3.07493 m
.02381 3.08118 L
.5 3.08118 L
.5 3.07493 L
F
0 .305 .75 r
.02381 3.08118 m
.02381 3.08743 L
.5 3.08743 L
.5 3.08118 L
F
0 .308 .75 r
.02381 3.08743 m
.02381 3.09368 L
.5 3.09368 L
.5 3.08743 L
F
0 .312 .75 r
.02381 3.09368 m
.02381 3.09993 L
.5 3.09993 L
.5 3.09368 L
F
0 .316 .75 r
.02381 3.09993 m
.02381 3.10617 L
.5 3.10617 L
.5 3.09993 L
F
0 .319 .75 r
.02381 3.10617 m
.02381 3.11242 L
.5 3.11242 L
.5 3.10617 L
F
0 .323 .75 r
.02381 3.11242 m
.02381 3.11867 L
.5 3.11867 L
.5 3.11242 L
F
0 .327 .75 r
.02381 3.11867 m
.02381 3.12492 L
.5 3.12492 L
.5 3.11867 L
F
0 .33 .75 r
.02381 3.12492 m
.02381 3.13117 L
.5 3.13117 L
.5 3.12492 L
F
0 .334 .75 r
.02381 3.13117 m
.02381 3.13742 L
.5 3.13742 L
.5 3.13117 L
F
0 .338 .75 r
.02381 3.13742 m
.02381 3.14367 L
.5 3.14367 L
.5 3.13742 L
F
0 .341 .75 r
.02381 3.14367 m
.02381 3.14992 L
.5 3.14992 L
.5 3.14367 L
F
0 .345 .75 r
.02381 3.14992 m
.02381 3.15617 L
.5 3.15617 L
.5 3.14992 L
F
0 .349 .75 r
.02381 3.15617 m
.02381 3.16242 L
.5 3.16242 L
.5 3.15617 L
F
0 .352 .75 r
.02381 3.16242 m
.02381 3.16867 L
.5 3.16867 L
.5 3.16242 L
F
0 .356 .75 r
.02381 3.16867 m
.02381 3.17492 L
.5 3.17492 L
.5 3.16867 L
F
0 .36 .75 r
.02381 3.17492 m
.02381 3.18116 L
.5 3.18116 L
.5 3.17492 L
F
0 .363 .75 r
.02381 3.18116 m
.02381 3.18741 L
.5 3.18741 L
.5 3.18116 L
F
0 .367 .75 r
.02381 3.18741 m
.02381 3.19366 L
.5 3.19366 L
.5 3.18741 L
F
0 .371 .75 r
.02381 3.19366 m
.02381 3.19991 L
.5 3.19991 L
.5 3.19366 L
F
0 .374 .75 r
.02381 3.19991 m
.02381 3.20616 L
.5 3.20616 L
.5 3.19991 L
F
0 .378 .75 r
.02381 3.20616 m
.02381 3.21241 L
.5 3.21241 L
.5 3.20616 L
F
0 .382 .75 r
.02381 3.21241 m
.02381 3.21866 L
.5 3.21866 L
.5 3.21241 L
F
0 .385 .75 r
.02381 3.21866 m
.02381 3.22491 L
.5 3.22491 L
.5 3.21866 L
F
0 .389 .75 r
.02381 3.22491 m
.02381 3.23116 L
.5 3.23116 L
.5 3.22491 L
F
0 .393 .75 r
.02381 3.23116 m
.02381 3.23741 L
.5 3.23741 L
.5 3.23116 L
F
0 .396 .75 r
.02381 3.23741 m
.02381 3.24366 L
.5 3.24366 L
.5 3.23741 L
F
0 .4 .75 r
.02381 3.24366 m
.02381 3.24991 L
.5 3.24991 L
.5 3.24366 L
F
0 .404 .75 r
.02381 3.24991 m
.02381 3.25616 L
.5 3.25616 L
.5 3.24991 L
F
0 .407 .75 r
.02381 3.25616 m
.02381 3.2624 L
.5 3.2624 L
.5 3.25616 L
F
0 .411 .75 r
.02381 3.2624 m
.02381 3.26865 L
.5 3.26865 L
.5 3.2624 L
F
0 .415 .75 r
.02381 3.26865 m
.02381 3.2749 L
.5 3.2749 L
.5 3.26865 L
F
0 .418 .75 r
.02381 3.2749 m
.02381 3.28115 L
.5 3.28115 L
.5 3.2749 L
F
0 .422 .75 r
.02381 3.28115 m
.02381 3.2874 L
.5 3.2874 L
.5 3.28115 L
F
0 .426 .75 r
.02381 3.2874 m
.02381 3.29365 L
.5 3.29365 L
.5 3.2874 L
F
0 .429 .75 r
.02381 3.29365 m
.02381 3.2999 L
.5 3.2999 L
.5 3.29365 L
F
0 .433 .75 r
.02381 3.2999 m
.02381 3.30615 L
.5 3.30615 L
.5 3.2999 L
F
0 .437 .75 r
.02381 3.30615 m
.02381 3.3124 L
.5 3.3124 L
.5 3.30615 L
F
0 .44 .75 r
.02381 3.3124 m
.02381 3.31865 L
.5 3.31865 L
.5 3.3124 L
F
0 .444 .75 r
.02381 3.31865 m
.02381 3.3249 L
.5 3.3249 L
.5 3.31865 L
F
0 .448 .75 r
.02381 3.3249 m
.02381 3.33115 L
.5 3.33115 L
.5 3.3249 L
F
0 .451 .75 r
.02381 3.33115 m
.02381 3.3374 L
.5 3.3374 L
.5 3.33115 L
F
0 .455 .75 r
.02381 3.3374 m
.02381 3.34364 L
.5 3.34364 L
.5 3.3374 L
F
0 .459 .75 r
.02381 3.34364 m
.02381 3.34989 L
.5 3.34989 L
.5 3.34364 L
F
0 .462 .75 r
.02381 3.34989 m
.02381 3.35614 L
.5 3.35614 L
.5 3.34989 L
F
0 .466 .75 r
.02381 3.35614 m
.02381 3.36239 L
.5 3.36239 L
.5 3.35614 L
F
0 .47 .75 r
.02381 3.36239 m
.02381 3.36864 L
.5 3.36864 L
.5 3.36239 L
F
0 .473 .75 r
.02381 3.36864 m
.02381 3.37489 L
.5 3.37489 L
.5 3.36864 L
F
0 .477 .75 r
.02381 3.37489 m
.02381 3.38114 L
.5 3.38114 L
.5 3.37489 L
F
0 .481 .75 r
.02381 3.38114 m
.02381 3.38739 L
.5 3.38739 L
.5 3.38114 L
F
0 .484 .75 r
.02381 3.38739 m
.02381 3.39364 L
.5 3.39364 L
.5 3.38739 L
F
0 .488 .75 r
.02381 3.39364 m
.02381 3.39989 L
.5 3.39989 L
.5 3.39364 L
F
0 .491 .75 r
.02381 3.39989 m
.02381 3.40614 L
.5 3.40614 L
.5 3.39989 L
F
0 .495 .75 r
.02381 3.40614 m
.02381 3.41239 L
.5 3.41239 L
.5 3.40614 L
F
0 .499 .75 r
.02381 3.41239 m
.02381 3.41864 L
.5 3.41864 L
.5 3.41239 L
F
0 .502 .75 r
.02381 3.41864 m
.02381 3.42488 L
.5 3.42488 L
.5 3.41864 L
F
0 .506 .75 r
.02381 3.42488 m
.02381 3.43113 L
.5 3.43113 L
.5 3.42488 L
F
0 .51 .75 r
.02381 3.43113 m
.02381 3.43738 L
.5 3.43738 L
.5 3.43113 L
F
0 .513 .75 r
.02381 3.43738 m
.02381 3.44363 L
.5 3.44363 L
.5 3.43738 L
F
0 .517 .75 r
.02381 3.44363 m
.02381 3.44988 L
.5 3.44988 L
.5 3.44363 L
F
0 .521 .75 r
.02381 3.44988 m
.02381 3.45613 L
.5 3.45613 L
.5 3.44988 L
F
0 .524 .75 r
.02381 3.45613 m
.02381 3.46238 L
.5 3.46238 L
.5 3.45613 L
F
0 .528 .75 r
.02381 3.46238 m
.02381 3.46863 L
.5 3.46863 L
.5 3.46238 L
F
0 .532 .75 r
.02381 3.46863 m
.02381 3.47488 L
.5 3.47488 L
.5 3.46863 L
F
0 .535 .75 r
.02381 3.47488 m
.02381 3.48113 L
.5 3.48113 L
.5 3.47488 L
F
0 .539 .75 r
.02381 3.48113 m
.02381 3.48738 L
.5 3.48738 L
.5 3.48113 L
F
0 .543 .75 r
.02381 3.48738 m
.02381 3.49363 L
.5 3.49363 L
.5 3.48738 L
F
0 .546 .75 r
.02381 3.49363 m
.02381 3.49988 L
.5 3.49988 L
.5 3.49363 L
F
0 .55 .75 r
.02381 3.49988 m
.02381 3.50612 L
.5 3.50612 L
.5 3.49988 L
F
0 .554 .75 r
.02381 3.50612 m
.02381 3.51237 L
.5 3.51237 L
.5 3.50612 L
F
0 .557 .75 r
.02381 3.51237 m
.02381 3.51862 L
.5 3.51862 L
.5 3.51237 L
F
0 .561 .75 r
.02381 3.51862 m
.02381 3.52487 L
.5 3.52487 L
.5 3.51862 L
F
0 .565 .75 r
.02381 3.52487 m
.02381 3.53112 L
.5 3.53112 L
.5 3.52487 L
F
0 .568 .75 r
.02381 3.53112 m
.02381 3.53737 L
.5 3.53737 L
.5 3.53112 L
F
0 .572 .75 r
.02381 3.53737 m
.02381 3.54362 L
.5 3.54362 L
.5 3.53737 L
F
0 .576 .75 r
.02381 3.54362 m
.02381 3.54987 L
.5 3.54987 L
.5 3.54362 L
F
0 .579 .75 r
.02381 3.54987 m
.02381 3.55612 L
.5 3.55612 L
.5 3.54987 L
F
0 .583 .75 r
.02381 3.55612 m
.02381 3.56237 L
.5 3.56237 L
.5 3.55612 L
F
0 .587 .75 r
.02381 3.56237 m
.02381 3.56862 L
.5 3.56862 L
.5 3.56237 L
F
0 .59 .75 r
.02381 3.56862 m
.02381 3.57487 L
.5 3.57487 L
.5 3.56862 L
F
0 .594 .75 r
.02381 3.57487 m
.02381 3.58111 L
.5 3.58111 L
.5 3.57487 L
F
0 .598 .75 r
.02381 3.58111 m
.02381 3.58736 L
.5 3.58736 L
.5 3.58111 L
F
0 .601 .75 r
.02381 3.58736 m
.02381 3.59361 L
.5 3.59361 L
.5 3.58736 L
F
0 .605 .75 r
.02381 3.59361 m
.02381 3.59986 L
.5 3.59986 L
.5 3.59361 L
F
0 .609 .75 r
.02381 3.59986 m
.02381 3.60611 L
.5 3.60611 L
.5 3.59986 L
F
0 .612 .75 r
.02381 3.60611 m
.02381 3.61236 L
.5 3.61236 L
.5 3.60611 L
F
0 .616 .75 r
.02381 3.61236 m
.02381 3.61861 L
.5 3.61861 L
.5 3.61236 L
F
0 .62 .75 r
.02381 3.61861 m
.02381 3.62486 L
.5 3.62486 L
.5 3.61861 L
F
0 .623 .75 r
.02381 3.62486 m
.02381 3.63111 L
.5 3.63111 L
.5 3.62486 L
F
0 .627 .75 r
.02381 3.63111 m
.02381 3.63736 L
.5 3.63736 L
.5 3.63111 L
F
0 .631 .75 r
.02381 3.63736 m
.02381 3.64361 L
.5 3.64361 L
.5 3.63736 L
F
0 .634 .75 r
.02381 3.64361 m
.02381 3.64986 L
.5 3.64986 L
.5 3.64361 L
F
0 .638 .75 r
.02381 3.64986 m
.02381 3.65611 L
.5 3.65611 L
.5 3.64986 L
F
0 .642 .75 r
.02381 3.65611 m
.02381 3.66235 L
.5 3.66235 L
.5 3.65611 L
F
0 .645 .75 r
.02381 3.66235 m
.02381 3.6686 L
.5 3.6686 L
.5 3.66235 L
F
0 .649 .75 r
.02381 3.6686 m
.02381 3.67485 L
.5 3.67485 L
.5 3.6686 L
F
0 .653 .75 r
.02381 3.67485 m
.02381 3.6811 L
.5 3.6811 L
.5 3.67485 L
F
0 .656 .75 r
.02381 3.6811 m
.02381 3.68735 L
.5 3.68735 L
.5 3.6811 L
F
0 .66 .75 r
.02381 3.68735 m
.02381 3.6936 L
.5 3.6936 L
.5 3.68735 L
F
0 .664 .75 r
.02381 3.6936 m
.02381 3.69985 L
.5 3.69985 L
.5 3.6936 L
F
0 .667 .75 r
.02381 3.69985 m
.02381 3.7061 L
.5 3.7061 L
.5 3.69985 L
F
0 .671 .75 r
.02381 3.7061 m
.02381 3.71235 L
.5 3.71235 L
.5 3.7061 L
F
0 .675 .75 r
.02381 3.71235 m
.02381 3.7186 L
.5 3.7186 L
.5 3.71235 L
F
0 .678 .75 r
.02381 3.7186 m
.02381 3.72485 L
.5 3.72485 L
.5 3.7186 L
F
0 .682 .75 r
.02381 3.72485 m
.02381 3.7311 L
.5 3.7311 L
.5 3.72485 L
F
0 .686 .75 r
.02381 3.7311 m
.02381 3.73735 L
.5 3.73735 L
.5 3.7311 L
F
0 .689 .75 r
.02381 3.73735 m
.02381 3.74359 L
.5 3.74359 L
.5 3.73735 L
F
0 .693 .75 r
.02381 3.74359 m
.02381 3.74984 L
.5 3.74984 L
.5 3.74359 L
F
0 .696 .75 r
.02381 3.74984 m
.02381 3.75609 L
.5 3.75609 L
.5 3.74984 L
F
0 .7 .75 r
.02381 3.75609 m
.02381 3.76234 L
.5 3.76234 L
.5 3.75609 L
F
0 .704 .75 r
.02381 3.76234 m
.02381 3.76859 L
.5 3.76859 L
.5 3.76234 L
F
0 .707 .75 r
.02381 3.76859 m
.02381 3.77484 L
.5 3.77484 L
.5 3.76859 L
F
0 .711 .75 r
.02381 3.77484 m
.02381 3.78109 L
.5 3.78109 L
.5 3.77484 L
F
0 .715 .75 r
.02381 3.78109 m
.02381 3.78734 L
.5 3.78734 L
.5 3.78109 L
F
0 .718 .75 r
.02381 3.78734 m
.02381 3.79359 L
.5 3.79359 L
.5 3.78734 L
F
0 .722 .75 r
.02381 3.79359 m
.02381 3.79984 L
.5 3.79984 L
.5 3.79359 L
F
0 .726 .75 r
.02381 3.79984 m
.02381 3.80609 L
.5 3.80609 L
.5 3.79984 L
F
0 .729 .75 r
.02381 3.80609 m
.02381 3.81234 L
.5 3.81234 L
.5 3.80609 L
F
0 .733 .75 r
.02381 3.81234 m
.02381 3.81859 L
.5 3.81859 L
.5 3.81234 L
F
0 .737 .75 r
.02381 3.81859 m
.02381 3.82483 L
.5 3.82483 L
.5 3.81859 L
F
0 .74 .75 r
.02381 3.82483 m
.02381 3.83108 L
.5 3.83108 L
.5 3.82483 L
F
0 .744 .75 r
.02381 3.83108 m
.02381 3.83733 L
.5 3.83733 L
.5 3.83108 L
F
0 .748 .75 r
.02381 3.83733 m
.02381 3.84358 L
.5 3.84358 L
.5 3.83733 L
F
0 .75 .749 r
.02381 3.84358 m
.02381 3.84983 L
.5 3.84983 L
.5 3.84358 L
F
0 .75 .745 r
.02381 3.84983 m
.02381 3.85608 L
.5 3.85608 L
.5 3.84983 L
F
0 .75 .741 r
.02381 3.85608 m
.02381 3.86233 L
.5 3.86233 L
.5 3.85608 L
F
0 .75 .738 r
.02381 3.86233 m
.02381 3.86858 L
.5 3.86858 L
.5 3.86233 L
F
0 .75 .734 r
.02381 3.86858 m
.02381 3.87483 L
.5 3.87483 L
.5 3.86858 L
F
0 .75 .73 r
.02381 3.87483 m
.02381 3.88108 L
.5 3.88108 L
.5 3.87483 L
F
0 .75 .727 r
.02381 3.88108 m
.02381 3.88733 L
.5 3.88733 L
.5 3.88108 L
F
0 .75 .723 r
.02381 3.88733 m
.02381 3.89358 L
.5 3.89358 L
.5 3.88733 L
F
0 .75 .719 r
.02381 3.89358 m
.02381 3.89983 L
.5 3.89983 L
.5 3.89358 L
F
0 .75 .716 r
.02381 3.89983 m
.02381 3.90607 L
.5 3.90607 L
.5 3.89983 L
F
0 .75 .712 r
.02381 3.90607 m
.02381 3.91232 L
.5 3.91232 L
.5 3.90607 L
F
0 .75 .708 r
.02381 3.91232 m
.02381 3.91857 L
.5 3.91857 L
.5 3.91232 L
F
0 .75 .705 r
.02381 3.91857 m
.02381 3.92482 L
.5 3.92482 L
.5 3.91857 L
F
0 .75 .701 r
.02381 3.92482 m
.02381 3.93107 L
.5 3.93107 L
.5 3.92482 L
F
0 .75 .697 r
.02381 3.93107 m
.02381 3.93732 L
.5 3.93732 L
.5 3.93107 L
F
0 .75 .694 r
.02381 3.93732 m
.02381 3.94357 L
.5 3.94357 L
.5 3.93732 L
F
0 .75 .69 r
.02381 3.94357 m
.02381 3.94982 L
.5 3.94982 L
.5 3.94357 L
F
0 .75 .686 r
.02381 3.94982 m
.02381 3.95607 L
.5 3.95607 L
.5 3.94982 L
F
0 .75 .683 r
.02381 3.95607 m
.02381 3.96232 L
.5 3.96232 L
.5 3.95607 L
F
0 .75 .679 r
.02381 3.96232 m
.02381 3.96857 L
.5 3.96857 L
.5 3.96232 L
F
0 .75 .675 r
.02381 3.96857 m
.02381 3.97482 L
.5 3.97482 L
.5 3.96857 L
F
0 .75 .672 r
.02381 3.97482 m
.02381 3.98106 L
.5 3.98106 L
.5 3.97482 L
F
0 .75 .668 r
.02381 3.98106 m
.02381 3.98731 L
.5 3.98731 L
.5 3.98106 L
F
0 .75 .664 r
.02381 3.98731 m
.02381 3.99356 L
.5 3.99356 L
.5 3.98731 L
F
0 .75 .661 r
.02381 3.99356 m
.02381 3.99981 L
.5 3.99981 L
.5 3.99356 L
F
0 .75 .657 r
.02381 3.99981 m
.02381 4.00606 L
.5 4.00606 L
.5 3.99981 L
F
0 .75 .653 r
.02381 4.00606 m
.02381 4.01231 L
.5 4.01231 L
.5 4.00606 L
F
0 .75 .65 r
.02381 4.01231 m
.02381 4.01856 L
.5 4.01856 L
.5 4.01231 L
F
0 .75 .646 r
.02381 4.01856 m
.02381 4.02481 L
.5 4.02481 L
.5 4.01856 L
F
0 .75 .642 r
.02381 4.02481 m
.02381 4.03106 L
.5 4.03106 L
.5 4.02481 L
F
0 .75 .639 r
.02381 4.03106 m
.02381 4.03731 L
.5 4.03731 L
.5 4.03106 L
F
0 .75 .635 r
.02381 4.03731 m
.02381 4.04356 L
.5 4.04356 L
.5 4.03731 L
F
0 .75 .631 r
.02381 4.04356 m
.02381 4.04981 L
.5 4.04981 L
.5 4.04356 L
F
0 .75 .628 r
.02381 4.04981 m
.02381 4.05606 L
.5 4.05606 L
.5 4.04981 L
F
0 .75 .624 r
.02381 4.05606 m
.02381 4.0623 L
.5 4.0623 L
.5 4.05606 L
F
0 .75 .62 r
.02381 4.0623 m
.02381 4.06855 L
.5 4.06855 L
.5 4.0623 L
F
0 .75 .617 r
.02381 4.06855 m
.02381 4.0748 L
.5 4.0748 L
.5 4.06855 L
F
0 .75 .613 r
.02381 4.0748 m
.02381 4.08105 L
.5 4.08105 L
.5 4.0748 L
F
0 .75 .609 r
.02381 4.08105 m
.02381 4.0873 L
.5 4.0873 L
.5 4.08105 L
F
0 .75 .606 r
.02381 4.0873 m
.02381 4.09355 L
.5 4.09355 L
.5 4.0873 L
F
0 .75 .602 r
.02381 4.09355 m
.02381 4.0998 L
.5 4.0998 L
.5 4.09355 L
F
0 .75 .598 r
.02381 4.0998 m
.02381 4.10605 L
.5 4.10605 L
.5 4.0998 L
F
0 .75 .595 r
.02381 4.10605 m
.02381 4.1123 L
.5 4.1123 L
.5 4.10605 L
F
0 .75 .591 r
.02381 4.1123 m
.02381 4.11855 L
.5 4.11855 L
.5 4.1123 L
F
0 .75 .588 r
.02381 4.11855 m
.02381 4.1248 L
.5 4.1248 L
.5 4.11855 L
F
0 .75 .584 r
.02381 4.1248 m
.02381 4.13105 L
.5 4.13105 L
.5 4.1248 L
F
0 .75 .58 r
.02381 4.13105 m
.02381 4.1373 L
.5 4.1373 L
.5 4.13105 L
F
0 .75 .577 r
.02381 4.1373 m
.02381 4.14354 L
.5 4.14354 L
.5 4.1373 L
F
0 .75 .573 r
.02381 4.14354 m
.02381 4.14979 L
.5 4.14979 L
.5 4.14354 L
F
0 .75 .569 r
.02381 4.14979 m
.02381 4.15604 L
.5 4.15604 L
.5 4.14979 L
F
0 .75 .566 r
.02381 4.15604 m
.02381 4.16229 L
.5 4.16229 L
.5 4.15604 L
F
0 .75 .562 r
.02381 4.16229 m
.02381 4.16854 L
.5 4.16854 L
.5 4.16229 L
F
0 .75 .558 r
.02381 4.16854 m
.02381 4.17479 L
.5 4.17479 L
.5 4.16854 L
F
0 .75 .555 r
.02381 4.17479 m
.02381 4.18104 L
.5 4.18104 L
.5 4.17479 L
F
0 .75 .551 r
.02381 4.18104 m
.02381 4.18729 L
.5 4.18729 L
.5 4.18104 L
F
0 .75 .547 r
.02381 4.18729 m
.02381 4.19354 L
.5 4.19354 L
.5 4.18729 L
F
0 .75 .544 r
.02381 4.19354 m
.02381 4.19979 L
.5 4.19979 L
.5 4.19354 L
F
0 .75 .54 r
.02381 4.19979 m
.02381 4.20604 L
.5 4.20604 L
.5 4.19979 L
F
0 .75 .536 r
.02381 4.20604 m
.02381 4.21229 L
.5 4.21229 L
.5 4.20604 L
F
0 .75 .533 r
.02381 4.21229 m
.02381 4.21854 L
.5 4.21854 L
.5 4.21229 L
F
0 .75 .529 r
.02381 4.21854 m
.02381 4.22478 L
.5 4.22478 L
.5 4.21854 L
F
0 .75 .525 r
.02381 4.22478 m
.02381 4.23103 L
.5 4.23103 L
.5 4.22478 L
F
0 .75 .522 r
.02381 4.23103 m
.02381 4.23728 L
.5 4.23728 L
.5 4.23103 L
F
0 .75 .518 r
.02381 4.23728 m
.02381 4.24353 L
.5 4.24353 L
.5 4.23728 L
F
0 .75 .514 r
.02381 4.24353 m
.02381 4.24978 L
.5 4.24978 L
.5 4.24353 L
F
0 .75 .511 r
.02381 4.24978 m
.02381 4.25603 L
.5 4.25603 L
.5 4.24978 L
F
0 .75 .507 r
.02381 4.25603 m
.02381 4.26228 L
.5 4.26228 L
.5 4.25603 L
F
0 .75 .503 r
.02381 4.26228 m
.02381 4.26853 L
.5 4.26853 L
.5 4.26228 L
F
0 .75 .5 r
.02381 4.26853 m
.02381 4.27478 L
.5 4.27478 L
.5 4.26853 L
F
0 .75 .496 r
.02381 4.27478 m
.02381 4.28103 L
.5 4.28103 L
.5 4.27478 L
F
0 .75 .492 r
.02381 4.28103 m
.02381 4.28728 L
.5 4.28728 L
.5 4.28103 L
F
0 .75 .489 r
.02381 4.28728 m
.02381 4.29353 L
.5 4.29353 L
.5 4.28728 L
F
0 .75 .485 r
.02381 4.29353 m
.02381 4.29978 L
.5 4.29978 L
.5 4.29353 L
F
0 .75 .481 r
.02381 4.29978 m
.02381 4.30602 L
.5 4.30602 L
.5 4.29978 L
F
0 .75 .478 r
.02381 4.30602 m
.02381 4.31227 L
.5 4.31227 L
.5 4.30602 L
F
0 .75 .474 r
.02381 4.31227 m
.02381 4.31852 L
.5 4.31852 L
.5 4.31227 L
F
0 .75 .47 r
.02381 4.31852 m
.02381 4.32477 L
.5 4.32477 L
.5 4.31852 L
F
0 .75 .467 r
.02381 4.32477 m
.02381 4.33102 L
.5 4.33102 L
.5 4.32477 L
F
0 .75 .463 r
.02381 4.33102 m
.02381 4.33727 L
.5 4.33727 L
.5 4.33102 L
F
0 .75 .459 r
.02381 4.33727 m
.02381 4.34352 L
.5 4.34352 L
.5 4.33727 L
F
0 .75 .456 r
.02381 4.34352 m
.02381 4.34977 L
.5 4.34977 L
.5 4.34352 L
F
0 .75 .452 r
.02381 4.34977 m
.02381 4.35602 L
.5 4.35602 L
.5 4.34977 L
F
0 .75 .448 r
.02381 4.35602 m
.02381 4.36227 L
.5 4.36227 L
.5 4.35602 L
F
0 .75 .445 r
.02381 4.36227 m
.02381 4.36852 L
.5 4.36852 L
.5 4.36227 L
F
0 .75 .441 r
.02381 4.36852 m
.02381 4.37477 L
.5 4.37477 L
.5 4.36852 L
F
0 .75 .437 r
.02381 4.37477 m
.02381 4.38101 L
.5 4.38101 L
.5 4.37477 L
F
0 .75 .434 r
.02381 4.38101 m
.02381 4.38726 L
.5 4.38726 L
.5 4.38101 L
F
0 .75 .43 r
.02381 4.38726 m
.02381 4.39351 L
.5 4.39351 L
.5 4.38726 L
F
0 .75 .426 r
.02381 4.39351 m
.02381 4.39976 L
.5 4.39976 L
.5 4.39351 L
F
0 .75 .423 r
.02381 4.39976 m
.02381 4.40601 L
.5 4.40601 L
.5 4.39976 L
F
0 .75 .419 r
.02381 4.40601 m
.02381 4.41226 L
.5 4.41226 L
.5 4.40601 L
F
0 .75 .415 r
.02381 4.41226 m
.02381 4.41851 L
.5 4.41851 L
.5 4.41226 L
F
0 .75 .412 r
.02381 4.41851 m
.02381 4.42476 L
.5 4.42476 L
.5 4.41851 L
F
0 .75 .408 r
.02381 4.42476 m
.02381 4.43101 L
.5 4.43101 L
.5 4.42476 L
F
0 .75 .404 r
.02381 4.43101 m
.02381 4.43726 L
.5 4.43726 L
.5 4.43101 L
F
0 .75 .401 r
.02381 4.43726 m
.02381 4.44351 L
.5 4.44351 L
.5 4.43726 L
F
0 .75 .397 r
.02381 4.44351 m
.02381 4.44976 L
.5 4.44976 L
.5 4.44351 L
F
0 .75 .393 r
.02381 4.44976 m
.02381 4.45601 L
.5 4.45601 L
.5 4.44976 L
F
0 .75 .39 r
.02381 4.45601 m
.02381 4.46225 L
.5 4.46225 L
.5 4.45601 L
F
0 .75 .386 r
.02381 4.46225 m
.02381 4.4685 L
.5 4.4685 L
.5 4.46225 L
F
0 .75 .383 r
.02381 4.4685 m
.02381 4.47475 L
.5 4.47475 L
.5 4.4685 L
F
0 .75 .379 r
.02381 4.47475 m
.02381 4.481 L
.5 4.481 L
.5 4.47475 L
F
0 .75 .375 r
.02381 4.481 m
.02381 4.48725 L
.5 4.48725 L
.5 4.481 L
F
0 .75 .372 r
.02381 4.48725 m
.02381 4.4935 L
.5 4.4935 L
.5 4.48725 L
F
0 .75 .368 r
.02381 4.4935 m
.02381 4.49975 L
.5 4.49975 L
.5 4.4935 L
F
0 .75 .364 r
.02381 4.49975 m
.02381 4.506 L
.5 4.506 L
.5 4.49975 L
F
0 .75 .361 r
.02381 4.506 m
.02381 4.51225 L
.5 4.51225 L
.5 4.506 L
F
0 .75 .357 r
.02381 4.51225 m
.02381 4.5185 L
.5 4.5185 L
.5 4.51225 L
F
0 .75 .353 r
.02381 4.5185 m
.02381 4.52475 L
.5 4.52475 L
.5 4.5185 L
F
0 .75 .35 r
.02381 4.52475 m
.02381 4.531 L
.5 4.531 L
.5 4.52475 L
F
0 .75 .346 r
.02381 4.531 m
.02381 4.53725 L
.5 4.53725 L
.5 4.531 L
F
0 .75 .342 r
.02381 4.53725 m
.02381 4.54349 L
.5 4.54349 L
.5 4.53725 L
F
0 .75 .339 r
.02381 4.54349 m
.02381 4.54974 L
.5 4.54974 L
.5 4.54349 L
F
0 .75 .335 r
.02381 4.54974 m
.02381 4.55599 L
.5 4.55599 L
.5 4.54974 L
F
0 .75 .331 r
.02381 4.55599 m
.02381 4.56224 L
.5 4.56224 L
.5 4.55599 L
F
0 .75 .328 r
.02381 4.56224 m
.02381 4.56849 L
.5 4.56849 L
.5 4.56224 L
F
0 .75 .324 r
.02381 4.56849 m
.02381 4.57474 L
.5 4.57474 L
.5 4.56849 L
F
0 .75 .32 r
.02381 4.57474 m
.02381 4.58099 L
.5 4.58099 L
.5 4.57474 L
F
0 .75 .317 r
.02381 4.58099 m
.02381 4.58724 L
.5 4.58724 L
.5 4.58099 L
F
0 .75 .313 r
.02381 4.58724 m
.02381 4.59349 L
.5 4.59349 L
.5 4.58724 L
F
0 .75 .309 r
.02381 4.59349 m
.02381 4.59974 L
.5 4.59974 L
.5 4.59349 L
F
0 .75 .306 r
.02381 4.59974 m
.02381 4.60599 L
.5 4.60599 L
.5 4.59974 L
F
0 .75 .302 r
.02381 4.60599 m
.02381 4.61224 L
.5 4.61224 L
.5 4.60599 L
F
0 .75 .298 r
.02381 4.61224 m
.02381 4.61849 L
.5 4.61849 L
.5 4.61224 L
F
0 .75 .295 r
.02381 4.61849 m
.02381 4.62473 L
.5 4.62473 L
.5 4.61849 L
F
0 .75 .291 r
.02381 4.62473 m
.02381 4.63098 L
.5 4.63098 L
.5 4.62473 L
F
0 .75 .287 r
.02381 4.63098 m
.02381 4.63723 L
.5 4.63723 L
.5 4.63098 L
F
0 .75 .284 r
.02381 4.63723 m
.02381 4.64348 L
.5 4.64348 L
.5 4.63723 L
F
0 .75 .28 r
.02381 4.64348 m
.02381 4.64973 L
.5 4.64973 L
.5 4.64348 L
F
0 .75 .276 r
.02381 4.64973 m
.02381 4.65598 L
.5 4.65598 L
.5 4.64973 L
F
0 .75 .273 r
.02381 4.65598 m
.02381 4.66223 L
.5 4.66223 L
.5 4.65598 L
F
0 .75 .269 r
.02381 4.66223 m
.02381 4.66848 L
.5 4.66848 L
.5 4.66223 L
F
0 .75 .265 r
.02381 4.66848 m
.02381 4.67473 L
.5 4.67473 L
.5 4.66848 L
F
0 .75 .262 r
.02381 4.67473 m
.02381 4.68098 L
.5 4.68098 L
.5 4.67473 L
F
0 .75 .258 r
.02381 4.68098 m
.02381 4.68723 L
.5 4.68723 L
.5 4.68098 L
F
0 .75 .254 r
.02381 4.68723 m
.02381 4.69348 L
.5 4.69348 L
.5 4.68723 L
F
0 .75 .251 r
.02381 4.69348 m
.02381 4.69973 L
.5 4.69973 L
.5 4.69348 L
F
0 .75 .247 r
.02381 4.69973 m
.02381 4.70597 L
.5 4.70597 L
.5 4.69973 L
F
0 .75 .243 r
.02381 4.70597 m
.02381 4.71222 L
.5 4.71222 L
.5 4.70597 L
F
0 .75 .24 r
.02381 4.71222 m
.02381 4.71847 L
.5 4.71847 L
.5 4.71222 L
F
0 .75 .236 r
.02381 4.71847 m
.02381 4.72472 L
.5 4.72472 L
.5 4.71847 L
F
0 .75 .232 r
.02381 4.72472 m
.02381 4.73097 L
.5 4.73097 L
.5 4.72472 L
F
0 .75 .229 r
.02381 4.73097 m
.02381 4.73722 L
.5 4.73722 L
.5 4.73097 L
F
0 .75 .225 r
.02381 4.73722 m
.02381 4.74347 L
.5 4.74347 L
.5 4.73722 L
F
0 .75 .221 r
.02381 4.74347 m
.02381 4.74972 L
.5 4.74972 L
.5 4.74347 L
F
0 .75 .218 r
.02381 4.74972 m
.02381 4.75597 L
.5 4.75597 L
.5 4.74972 L
F
0 .75 .214 r
.02381 4.75597 m
.02381 4.76222 L
.5 4.76222 L
.5 4.75597 L
F
0 .75 .21 r
.02381 4.76222 m
.02381 4.76847 L
.5 4.76847 L
.5 4.76222 L
F
0 .75 .207 r
.02381 4.76847 m
.02381 4.77472 L
.5 4.77472 L
.5 4.76847 L
F
0 .75 .203 r
.02381 4.77472 m
.02381 4.78096 L
.5 4.78096 L
.5 4.77472 L
F
0 .75 .199 r
.02381 4.78096 m
.02381 4.78721 L
.5 4.78721 L
.5 4.78096 L
F
0 .75 .196 r
.02381 4.78721 m
.02381 4.79346 L
.5 4.79346 L
.5 4.78721 L
F
0 .75 .192 r
.02381 4.79346 m
.02381 4.79971 L
.5 4.79971 L
.5 4.79346 L
F
0 .75 .188 r
.02381 4.79971 m
.02381 4.80596 L
.5 4.80596 L
.5 4.79971 L
F
0 .75 .185 r
.02381 4.80596 m
.02381 4.81221 L
.5 4.81221 L
.5 4.80596 L
F
0 .75 .181 r
.02381 4.81221 m
.02381 4.81846 L
.5 4.81846 L
.5 4.81221 L
F
0 .75 .178 r
.02381 4.81846 m
.02381 4.82471 L
.5 4.82471 L
.5 4.81846 L
F
0 .75 .174 r
.02381 4.82471 m
.02381 4.83096 L
.5 4.83096 L
.5 4.82471 L
F
0 .75 .17 r
.02381 4.83096 m
.02381 4.83721 L
.5 4.83721 L
.5 4.83096 L
F
0 .75 .167 r
.02381 4.83721 m
.02381 4.84346 L
.5 4.84346 L
.5 4.83721 L
F
0 .75 .163 r
.02381 4.84346 m
.02381 4.84971 L
.5 4.84971 L
.5 4.84346 L
F
0 .75 .159 r
.02381 4.84971 m
.02381 4.85596 L
.5 4.85596 L
.5 4.84971 L
F
0 .75 .156 r
.02381 4.85596 m
.02381 4.8622 L
.5 4.8622 L
.5 4.85596 L
F
0 .75 .152 r
.02381 4.8622 m
.02381 4.86845 L
.5 4.86845 L
.5 4.8622 L
F
0 .75 .148 r
.02381 4.86845 m
.02381 4.8747 L
.5 4.8747 L
.5 4.86845 L
F
0 .75 .145 r
.02381 4.8747 m
.02381 4.88095 L
.5 4.88095 L
.5 4.8747 L
F
0 .75 .141 r
.02381 4.88095 m
.02381 4.8872 L
.5 4.8872 L
.5 4.88095 L
F
0 .75 .137 r
.02381 4.8872 m
.02381 4.89345 L
.5 4.89345 L
.5 4.8872 L
F
0 .75 .134 r
.02381 4.89345 m
.02381 4.8997 L
.5 4.8997 L
.5 4.89345 L
F
0 .75 .13 r
.02381 4.8997 m
.02381 4.90595 L
.5 4.90595 L
.5 4.8997 L
F
0 .75 .126 r
.02381 4.90595 m
.02381 4.9122 L
.5 4.9122 L
.5 4.90595 L
F
0 .75 .123 r
.02381 4.9122 m
.02381 4.91845 L
.5 4.91845 L
.5 4.9122 L
F
0 .75 .119 r
.02381 4.91845 m
.02381 4.9247 L
.5 4.9247 L
.5 4.91845 L
F
0 .75 .115 r
.02381 4.9247 m
.02381 4.93095 L
.5 4.93095 L
.5 4.9247 L
F
0 .75 .112 r
.02381 4.93095 m
.02381 4.9372 L
.5 4.9372 L
.5 4.93095 L
F
0 .75 .108 r
.02381 4.9372 m
.02381 4.94344 L
.5 4.94344 L
.5 4.9372 L
F
0 .75 .104 r
.02381 4.94344 m
.02381 4.94969 L
.5 4.94969 L
.5 4.94344 L
F
0 .75 .101 r
.02381 4.94969 m
.02381 4.95594 L
.5 4.95594 L
.5 4.94969 L
F
0 .75 .097 r
.02381 4.95594 m
.02381 4.96219 L
.5 4.96219 L
.5 4.95594 L
F
0 .75 .093 r
.02381 4.96219 m
.02381 4.96844 L
.5 4.96844 L
.5 4.96219 L
F
0 .75 .09 r
.02381 4.96844 m
.02381 4.97469 L
.5 4.97469 L
.5 4.96844 L
F
0 .75 .086 r
.02381 4.97469 m
.02381 4.98094 L
.5 4.98094 L
.5 4.97469 L
F
0 .75 .082 r
.02381 4.98094 m
.02381 4.98719 L
.5 4.98719 L
.5 4.98094 L
F
0 .75 .079 r
.02381 4.98719 m
.02381 4.99344 L
.5 4.99344 L
.5 4.98719 L
F
0 .75 .075 r
.02381 4.99344 m
.02381 4.99969 L
.5 4.99969 L
.5 4.99344 L
F
0 g
gsave
.52381 4.99656 -61 -10.5938 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 21.1875 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4.) show
75.250 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
MathSubEnd
P
% End of sub-graphic
0 0 m
1 0 L
1 1.4104 L
0 1.4104 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  CellLabel->"From In[133]:=",
  ImageSize->{273.188, 385.25},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004A0001PA000`40O003h00Oogoo4Woo003oOolB
Ool00?mooa9oo`00ogoo4Woo003oOolBOol00?mooa9oo`00ogoo4Woo003oOolBOol00?mooa9oo`00
ogoo4Woo003oOolBOol00?mooa9oo`00ogoo4Woo003oOolBOol00?mooa9oo`00ogoo4Woo003oOolB
Ool00?mooa9oo`00ogoo4Woo003oOolBOol00?mooa9oo`00ogoo4Woo003oOolBOol00?mooa9oo`00
ogoo4Woo003oOolBOol00?mooa9oo`00ogoo4Woo003oOolBOol00?mooa9oo`00ogoo4Woo003oOolB
Ool00?mooa9oo`00ogoo4Woo003oOolBOol00?mooa9oo`00ogoo4Woo003oOolBOol00?mooa9oo`00
ogoo4Woo003oOolBOol00?mooa9oo`00ogoo4Woo003oOolBOol00?mooa9oo`00ogoo4Woo003oOolB
Ool0081oo`80009oo`<000=oo`8008Eoo`00P7oo00<007ooOol017oo00D007ooOomoo`0008Eoo`00
LGoo0`000Woo00<007ooOol00`0017oo00<007ooOol00Woo0`000goo00<007ooOol0Pgoo001bOol0
1000Oomoo`000Woo00<007ooOol01Goo00D007ooOomoo`00009oo`05001oogooOol00025Ool0079o
o`<000=oo`@000Aoo`05001oogooOol00002Ool01@00Oomoogoo0000QGoo001bOol01000Oomoo`00
0goo0P001Goo00<007ooOol00Woo10000Woo00<007ooOol0Pgoo001bOol01000Oomoo`002Woo00<0
07ooOol027oo00<007ooOol0Pgoo001aOol4000;Ool20008Ool20025Ool00?mooa9oo`00ogoo4Woo
003oOolBOol003eoo`80015oo`@0011oo`D000eoo`80011oo`D000moo`@0015oo`8001=oo`<004Qo
o`00?7oo00@007ooOol0011oo`03001oogoo01=oo`03001oogoo00aoo`04001oogoo000AOol00`00
Oomoo`0?Ool00`00Oomoo`0AOol01000Oomoo`004goo00<007ooOol0Agoo000nOol00`00Oomoo`0@
Ool00`00Oomoo`0BOol00`00Oomoo`0<Ool01000Oomoo`004Goo00<007ooOol047oo00<007ooOol0
4Woo00<007ooOol03goo1@00B7oo000fOol40005Ool00`00Oomoo`08Ool40004Ool00`00Oomoo`09
Ool40004Ool00`00Oomoo`0<Ool01000Oomoo`004Goo00<007ooOol04Goo00<007ooOol04Woo00<0
07ooOol03Woo00@007ooOol004Uoo`00?7oo00@007ooOol0011oo`04001oogoo000BOol00`00Oomo
o`0<Ool01000Oomoo`004Goo00<007ooOol03goo00@007ooOol0011oo`04001oogoo000AOol00`00
Ool00019Ool003eoo`80019oo`80019oo`8000moo`80015oo`80019oo`80019oo`8001=oo`8004Uo
o`00ogoo4Woo003oOolBOol00?mooa9oo`00ogoo4Woo000gOonC0017Ool003Moo`05001oogooG_L0
0004Ool00ekgOomoo`0<Ool00`00Oomoo`09Ool4G_L4Ool00`00Oomoo`0AOol00ekgOomoo`0@Ool0
0`00Oomoo`02Ool4G_L;Ool00`00Oomoo`0<Ool00ekgOomoo`02Ool00`00G_Moo`0AOol01000Oomo
o`00Agoo000gOol00`00OomNm`07Ool00ekgOomoo`0EOol2G_L2Ool00ekgOomoo`0GOol00ekgOomo
o`0FOol00ekgOomoo`02G_LGOol00ekgOomoo`05Ool00ekgOomoo`0BOol00`00Oomoo`15Ool003Mo
o`03001Nmgoo00Moo`03G_Moogoo01=oo`9Nm`Eoo`03G_Moogoo01Ioo`03G_Moogoo01Eoo`03G_Mo
ogoo00=oo`9NmaEoo`03G_Moogoo00Ioo`03G_Moogoo015oo`03001oogoo04Eoo`00=goo00=Nmgoo
Ool027oo00=NmgooOol047oo0Ukg1goo00=NmgooOol05Woo00=NmgooOol05Goo00=NmgooOol01Goo
0Ukg4Woo00=NmgooOol027oo00=NmgooOol047oo00<007ooOol0AGoo000gOol00`00Oomoo`08Ool0
0ekgOomoo`0>Ool2G_L9Ool00ekgOomoo`0DOol70=LCOol00ekgOomoo`07Ool2G_L@Ool00ekgOomo
o`09Ool00ekgOomoo`0?Ool00`00Oomoo`15Ool003Moo`8000Yoo`03G_Moogoo00]oo`9Nm`]oo`03
G_Moogoo00ioo`D0m`040=MoogooG_L4Ool80=L;Ool00ekgOomoo`09Ool2G_L=Ool00ekgOomoo`0;
Ool00ekgOomoo`0>Ool00`00Oomoo`15Ool003Moo`03001oogoo00Uoo`03G_Moogoo00Uoo`9Nm`io
o`03G_Moogoo00Qoo`D0m`Qoo`03G_Moogoo00Yoo`D0e`Ioo`03G_Moogoo00]oo`9Nm`]oo`03G_Mo
ogoo00aoo`03G_Moogoo00eoo`03001oogoo04Eoo`00=goo00<007ooOol02Woo00=NmgooOol01Woo
0Ukg47oo00=NmgooOol01Goo0`3g3Goo00=NmgooOol03goo0P3G0goo00=NmgooOol03Woo0Ukg27oo
00=NmgooOol03Woo00=NmgooOol037oo00<007ooOol0AGoo000gOol00`00Oomoo`0:Ool00ekgOomo
o`04Ool2G_LBOol00ekgOomoo`03Ool20?L@Ool00ekgOomoo`0AOol30;L00ekgOomoo`0@Ool2G_L6
Ool00ekgOomoo`0?Ool00ekgOomoo`0;Ool00`00Oomoo`15Ool003Moo`03001oogoo00]oo`03G_Mo
ogoo009oo`03G_Moogoo019oo`03G_Moogoo00<0ma9oo`03G_Moogoo01Aoo`80]a=oo`03G_Moogoo
009oo`03G_Moogoo015oo`03G_Moogoo00Yoo`03001oogoo04Eoo`00=goo00<007ooOol02goo00EN
mgooOomooekg01Eoo`03G_L0m`3g01Eoo`03G_Moogoo01Aoo`04G_Moo`2g0;LBOol01EkgOomoogoo
G_L057oo00=NmgooOol02Goo00<007ooOol0AGoo000gOol00`00Oomoo`0<Ool3G_LEOol20?L00ekg
Oomoo`0DOol00ekgOomoo`0COol00ekgOomoo`02Ool30;L@Ool2G_L00gooG_Moo`0DOol00ekgOomo
o`08Ool00`00Oomoo`15Ool003Moo`03001oogoo00aoo`03G_Moogoo01Aoo`040AMoogooG_LFOol0
0ekgOomoo`0COol00ekgOomoo`05Ool20;L@Ool00ekgOomoo`0EOol00ekgOomoo`07Ool00`00Oomo
o`15Ool003Moo`03001oogoo00Yoo`9Nm`03OomNmgoo019oo`815`=oo`03G_Moogoo00YooaANm`ao
o`03G_Moogoo00Moo`80]`ioo`=NmaEoo`03G_Moogoo00Moo`03001oogoo04Eoo`00=goo00<007oo
Ool02Goo00ENmgooOomooekg015oo`815`Eoo`03G_Moogoo00=oo`MNm`Yoo`03G_Moogoo00Moo`MN
m`Eoo`03G_Moogoo00Uoo`030;Moogoo00Yoo`05G_MoogooOomNm`0EOol00ekgOomoo`05Ool00ekg
001oo`16Ool0039oo`<0009oo`03001oogoo00Qoo`03G_Moogoo009oo`03G_Moogoo00ioo`030AMo
ogoo00Ioo`03G_Moogoo009Nma5oo`03G_Moogoo00ioo`9Nm`=oo`03G_Moogoo00Yoo`030;Moogoo
00Uoo`03G_Moogoo009oo`03G_Moogoo01=oo`03G_Moogoo00=oo`03G_Moo`0004Moo`00<goo00D0
07ooOomoo`0000Uoo`03G_Moogoo00Aoo`03G_Moogoo00aoo`030AMoogoo00Moo`=Nma=oo`03G_Mo
ogoo011oo`=Nm`ioo`80]`Qoo`03G_Moogoo00Aoo`03G_Moogoo01=oo`03G_Moogoo009oo`03G_Mo
o`0004Moo`00<7oo1@000Woo0P001goo00=NmgooOol01Goo00=NmgooOol02goo00<15gooOol01Woo
0ekg5Goo00=NmgooOol04Woo0ekg3Woo00<0UgooOol01Goo00=NmgooOol01Goo00=NmgooOol04goo
00ENmgooOomNmgoo008004Moo`00:Woo10000Woo00@007ooOol000=oo`03001oogoo00Eoo`03G_Mo
ogoo00Moo`03G_Moogoo00Uoo`030AMoogoo00Aoo`=Nm`9oo`03G_Moogoo01=oo`03G_Moogoo019o
o`03G_Moogoo00=Nm`aoo`0309Moogoo00=oo`03G_Moogoo00Moo`03G_Moogoo01=oo`9Nm`=oo`03
001oogoo04Eoo`00<Goo00<007oo00000goo00<007ooOol00goo0Ukg2Woo00=NmgooOol027oo00<1
5gooOol00goo0Ukg1Goo00=NmgooOol04goo00=NmgooOol04Woo00=NmgooOol00goo0Ukg2goo0P2G
0goo00=NmgooOol027oo0Ukg4goo00=NmgooOol00Woo00<007ooOol0AGoo000bOol20003Ool00`00
Oomoo`02Ool00ekgOomoo`0;Ool00ekgOomoo`06Ool0104GOomoogoo0ekg27oo00=NmgooOol04Woo
00=NmgooOol04Woo00=NmgooOol01Goo0ekg2Woo00<0UgooG_L03Goo00=NmgooOol03goo00=Nmgoo
G_L00goo00<007ooOol0AGoo000gOol01@00OomoogooG_L03Woo00=NmgooOol01Goo00<15gooOol0
0Ukg2goo00=NmgooOol04Woo00=NmgooOol04Goo00=NmgooOol02Goo0Ukg2Goo00<0UekgOol03Goo
00=NmgooOol03Woo00ANmgooOomNm`9oo`03001oogoo04Eoo`00=goo00@007ooOomNma1oo`03G_Mo
ogoo009oo`815`03OomNmekg00eoo`03G_Moogoo019oo`03G_Moogoo015oo`03G_Moogoo00]oo`9N
m`Moo`03G_L0Ugoo00ioo`03G_Moogoo00aoo`03G_Moogoo009oo`03G_Moo`0004Moo`00=goo00<0
07ooG_L04Goo00ENmgooOomoo`4G009oo`03G_Moogoo00eoo`03G_Moogoo019oo`03G_Moogoo015o
o`03G_Moogoo00eoo`03G_Moogoo00Aoo`03G_Moo`2G00moo`03G_Moogoo00Yoo`03G_Moogoo00Ao
o`03G_L007oo04Ioo`00=goo00<005kgOol04Woo00ANmgoo0AMoo`9Nma5oo`03G_Moogoo015oo`03
G_Moogoo015oo`03G_Moogoo00ioo`9Nm`Aoo`04G_Moogoo09L?Ool00ekgOomoo`08Ool00ekgOomo
o`06Ool00`00Oomoo`15Ool003Moo`03G_Moogoo019oo`04G_Moo`4GG_LCOol00ekgOomoo`0AOol0
0ekgOomoo`0@Ool00ekgOomoo`0AOol015kgOomooekg17oo00<0UgooOol03Goo00=NmgooOol01goo
00=NmgooOol01Woo00<007ooOol0AGoo000gOol00`00Oomoo`0COol00`4GG_Moo`0COol00ekgOomo
o`0AOol00ekgOomoo`0@Ool00ekgOomoo`0BOol00ekgOomNm`05Ool00`2GOomoo`0=Ool00ekgOomo
o`05Ool00ekgOomoo`07Ool00`00Oomoo`15Ool003Moo`03001oogoo019oo`030AMNmgoo01Aoo`03
G_Moogoo015oo`03G_Moogoo011oo`03G_Moogoo01=oo`9Nm`Eoo`0309Moogoo00ioo`03G_Moogoo
00=oo`03G_Moogoo00Qoo`03001oogoo04Eoo`00=goo00<007ooOol04Goo00@15gooOomNmaAoo`03
G_Moogoo015oo`03G_Moogoo011oo`03G_Moogoo01=oo`03G_Mooekg00Eoo`0309Moogoo00eoo`03
G_Moogoo009oo`03G_Moogoo00Uoo`03001oogoo04Eoo`00=goo00<007ooOol047oo00D15gooOomo
oekg01Eoo`03G_Moogoo011oo`03G_Moogoo011oo`03G_Moogoo019oo`05G_MoogooOomNm`05Ool2
09L>Ool015kgOomooekg37oo00<007ooOol0AGoo000gOol2000@Ool00`4gOomoo`02Ool00ekgOomo
o`0COol00ekgOomoo`08OolAG_L9Ool00ekgOomoo`0COol00ekgOomoo`02Ool00ekgOomoo`03Ool0
0`2GOomoo`0=Ool00ekgOomNm`0<Ool00`00Oomoo`15Ool003Moo`03001oogoo00ioo`03G_L1=goo
00Aoo`03G_Moogoo019oo`03G_Moogoo009oo`INm`Qoo`03G_Moogoo00Ioo`INm`=oo`03G_Moogoo
019oo`03G_Moogoo00Aoo`03G_Moogoo00=oo`0309Moogoo00eoo`03G_Moogoo00]oo`03001oogoo
04Eoo`00=goo00<007ooOol03Goo00=Nm`4gOol01Goo00=NmgooOol04Woo00=NmgooG_L00Ukg3Woo
00=NmgooOol037oo0Ukg00=ooekgOol04goo00=NmgooOol01Goo00=NmgooOol00goo00<0MgooOol0
2goo00=NmgooG_L037oo00<007ooOol0AGoo000gOol00`00Oomoo`0;Ool2G_L00goo0CMoo`06Ool0
0ekgOomoo`0@Ool3G_LAOol00ekgOomoo`0>Ool3G_LBOol00ekgOomoo`07Ool2G_L4Ool00`1gOomo
o`09Ool01EkgOomoogooG_L02goo00<007ooOol0:goo2U`147oo000gOol00`00Oomoo`0:Ool015kg
Oomoo`4g27oo00=NmgooOol03Woo0Ukg0Woo00=NmgooOol03goo00=NmgooOol03goo00ANmgooG_MN
ma1oo`03G_Moogoo00Uoo`05G_MoogooOol0M`0:Ool00ekgOomoo`03Ool00ekgOomoo`08Ool00`00
Oomoo`0[Ool:G08@Ool003Moo`03001oogoo00Uoo`05G_MoogooOol1=`09Ool00ekgOomoo`0;Ool2
G_L4Ool00ekgOomoo`0?Ool00ekgOomoo`0>Ool00ekgOomoo`02Ool2G_L>Ool00ekgOomoo`0:Ool0
1EkgOomoogoo07L02Goo00=NmgooOol00goo00=NmgooOol027oo00<007ooOol0:goo2U`347oo000g
Ool00`00Oomoo`08Ool01EkgOomoogoo0CL02Woo00=NmgooOol02Goo0Ukg1Woo00=NmgooOol03goo
00=NmgooOol03Woo00=NmgooOol017oo0Ukg2goo00=NmgooOol037oo00ENmgooOomoo`1g00Moo`03
G_Moogoo00Eoo`03G_Moogoo00Moo`03001oogoo02]oo`YL111oo`00=goo00=NmgooOol01goo00EN
mgooOomoo`4g00aoo`03G_Moogoo00Ioo`9Nm`Qoo`03G_Moogoo00moo`03G_Moogoo00ioo`03G_Mo
ogoo00Ioo`9Nm`Uoo`03G_Moogoo00eoo`05G_MoogooOol0M`05Ool00ekgOomoo`07Ool00ekgOomo
o`06Ool00`00Oomoo`0[Ool:G0D@Ool003Moo`03001Nmgoo00Ioo`05G_MoogooOol1=`0=Ool00ekg
Oomoo`04Ool2G_L;Ool00ekgOomoo`0>Ool00ekgOomoo`0>Ool00ekgOomoo`08Ool2G_L6Ool00ekg
Oomoo`0?Ool015kgOomoo`1g17oo00=NmgooOol027oo00=NmgooOol01Woo00<007ooOol0:goo2U`6
47oo000gOol00`00OomNm`05Ool00ekgOomoo`02Ool00`4gOomoo`0<Ool015kgOomoogoo0Ukg3Goo
00=NmgooOol03Woo00=NmgooOol03Woo00=NmgooOol02Woo0Ukg17oo00=NmgooOol047oo00ANmgoo
Ool0M`9oo`03G_Moogoo00Yoo`03G_Moogoo00Eoo`03001oogoo02]oo`YL1a1oo`00=goo00<007oo
G_L017oo00=NmgooOol00Woo00<1=gooOol03Goo00ANmgooOomNm`moo`03G_Moogoo00ioo`03G_Mo
ogoo00eoo`03G_Moogoo00eoo`04G_MoogooG_LDOol00ekgOol0M`02Ool00ekgOomoo`0;Ool00ekg
Oomoo`04Ool00`00Oomoo`0[Ool:G0P@Ool003Moo`04001oogooG_L3Ool00ekgOomoo`02Ool00`4g
Oomoo`0>Ool2G_L@Ool00ekgOomoo`0>Ool00ekgOomoo`0=Ool00ekgOomoo`0>Ool3G_LDOol01Ekg
Oomoo`1gG_L03Woo00=NmgooOol017oo00<007ooOol0:goo2U`947oo000gOol20002Ool00ekgOomN
m`05Ool00`4gOomoo`0=Ool2G_LAOol00ekgOomoo`0>Ool00ekgOomoo`0=Ool00ekgOomoo`0?Ool3
G_LDOol015kgOomNm`1g3goo00=NmgooOol00goo00<007ooOol0:goo2U`:47oo000gOol00`00Oomo
o`02Ool00ekgOomoo`03Ool00`4gOomoo`0=Ool015kgOomooekg4Goo00=NmgooOol03Goo00=Nmgoo
Ool03Goo00=NmgooOol03goo00ANmgooOomNmaAoo`03G_Moo`1g011oo`03G_Moogoo009oo`03001o
ogoo02]oo`YL2a1oo`00=goo00L007ooOomooekgOomNm`04Ool00`4gOomoo`0<Ool01EkgOomoogoo
G_L04Goo00=NmgooOol03Goo00=NmgooOol037oo00=NmgooOol03goo00=NmgooOol00Woo00=Nmgoo
Ool04Goo0Ukg00=oo`1gOol03Woo00=NmgooOol00Woo00<007ooOol0:goo2U`<47oo000gOol01000
Oomooekg0Woo00=NmgooOol00Woo00<1=gooOol02goo00=NmgooOol00Woo00=NmgooOol03goo00=N
mgooOol03Goo00=NmgooOol037oo00=NmgooOol03goo00=NmgooOol00goo00=NmgooOol03goo00EN
mgooOomNm`1g011oo`05G_MoogooOol0000]Ool:G0d@Ool003Moo`03001ooekg00Aoo`04G_Moogoo
0CL=Ool00ekgOomoo`04Ool00ekgOomoo`0>Ool00ekgOomoo`0=Ool00ekgOomoo`0<Ool00ekgOomo
o`0>Ool00ekgOomoo`05Ool00ekgOomoo`0=Ool00ekgOomoo`02Ool00ekg07Moo`0>Ool01EkgOomo
ogoo0000;Goo2U`>47oo000gOol00`00G_Moo`05Ool00ekgOol1=`0;Ool2G_L7Ool00ekgOomoo`0?
Ool00ekgOomoo`05Ool>G_L8Ool00ekgOomoo`0>Ool00ekgOomoo`06Ool00ekgOomoo`0;Ool00ekg
Oomoo`03Ool00ekg07Moo`0?Ool015kgOomoo`00;Goo2U`?47oo000gOol00`00G_Moo`06Ool00`4g
Oomoo`09Ool00ekgOomoo`08Ool00ekgOomoo`0>Ool00ekgOomoo`05G_L7Ool00ekgOomoo`04Ool5
G_L3Ool00ekgOomoo`0>Ool00ekgOomoo`07Ool00ekgOomoo`09Ool00ekgOomoo`05Ool00ekg07Mo
o`0>Ool015kgOomoo`00;Goo2U`@47oo000gOol00ekgOomoo`06Ool00`4gG_Moo`08Ool00ekgOomo
o`09Ool00ekgOomoo`0>Ool3G_L<Ool00ekgOomoo`09Ool3G_L@Ool00ekgOomoo`09Ool00ekgOomo
o`08Ool00ekgOomoo`06Ool00`1GOomoo`0>Ool00ekgOol0000]Ool:G14@Ool003Moo`03001oogoo
00Eoo`030CMooekg00Qoo`03G_Moogoo00]oo`03G_Moogoo00aoo`9Nm`ioo`03G_Moogoo00]oo`9N
m`moo`03G_Moogoo00Yoo`03G_Moogoo00Ioo`03G_Moogoo00Moo`03G_L0Egoo00ioo`03G_Moo`00
02eoo`YL4Q1oo`00=goo00<007ooOol01Goo00@1=gooOomNm`Ioo`03G_Moogoo00aoo`03G_Moogoo
00Yoo`9Nm`03OomNmgoo00eoo`03G_Moogoo00]oo`04G_MooekgG_L<Ool00ekgOomoo`0<Ool00ekg
Oomoo`04Ool00ekgOomoo`09Ool00`1GOomoo`0>Ool00ekg001oo`0/Ool:G1<@Ool003Moo`03001o
ogoo00Aoo`030CMoogoo009oo`03G_Moogoo009oo`03G_Moogoo00ioo`03G_Moogoo00Moo`9Nm`Ao
o`03G_Moogoo00]oo`03G_Moogoo00]oo`04G_MoogooOol2G_L:Ool00ekgOomoo`0=Ool00ekgOomo
o`02Ool00ekgOomoo`0;Ool00`1GOomoo`0=Ool00ekg001oo`0/Ool:G1@@Ool003Moo`03001oogoo
00Aoo`030EMoogoo00=oo`04G_MoogooG_LAOol00ekgOomoo`05Ool2G_L6Ool00ekgOomoo`0;Ool0
0ekgOomoo`0;Ool00ekgOomoo`03Ool2G_L7Ool00ekgOomoo`0?Ool015kgOomooekg3Woo00<0Eekg
Ool03Woo00<007ooOol0:goo2U`E47oo000gOol00`00Oomoo`04Ool00`5GOomoo`04Ool00ekgOomN
m`0BOol00ekgOomoo`02Ool2G_L8Ool00ekgOomoo`0;Ool00ekgOomoo`0:Ool00ekgOomoo`06Ool2
G_L5Ool00ekgOomoo`0?Ool015kgOomooekg3goo00<0EgooOol03Goo00<007ooOol0:goo2U`F47oo
000gOol20005Ool00`5GOomoo`04Ool2G_LCOol00ekgOomoo`02G_L:Ool00ekgOomoo`0;Ool00ekg
Oomoo`0:Ool00ekgOomoo`08Ool2G_L2Ool00ekgOomoo`0AOol2G_L@Ool00`1GG_Moo`0=Ool00`00
Oomoo`0[Ool:G1L@Ool003Moo`03001oogoo00Aoo`030EMoogoo00Aoo`9NmaAoo`9Nm`eoo`03G_Mo
ogoo00Yoo`03G_Moogoo00Yoo`03G_Moogoo00Yoo`03G_Mooekg01=oo`9Nma5oo`0305Moogoo00ao
o`03001oogoo02]oo`YL5a1oo`00=goo00<007ooOol017oo00<1EgooOol00goo00ANmgooOomNma9o
o`9Nm`ioo`03G_Moogoo00Yoo`03G_Moogoo00Yoo`03G_Moogoo00]oo`9Nma9oo`04G_MoogooG_L@
Ool00`1GG_Moo`0<Ool00`00Oomoo`0[Ool:E1L@Ool003Moo`03001oogoo00=oo`030EMoogoo00=o
o`03G_Moogoo009oo`03G_Moogoo00ioo`03G_Mooekg00ioo`03G_Moogoo00Yoo`03G_Moogoo00Uo
o`03G_Moogoo00aoo`03G_Mooekg015oo`05G_MoogooOomNm`0@Ool00`1GOomoo`09Ool2G_L00`00
Oomoo`0[Ool:D1L@Ool003Moo`03001oogoo00=oo`030EMoogoo00=oo`03G_Moogoo00=oo`03G_Mo
ogoo00aoo`05G_MoogooOomNm`0=Ool00ekgOomoo`0:Ool00ekgOomoo`09Ool00ekgOomoo`0<Ool0
15kgOomooekg3goo00=NmgooOol00Woo00=NmgooOol03Woo00<0EekgOol027oo00ANmgooOol002eo
o`Y<5a1oo`00=goo00<007ooOol00goo00<1EgooOol00Woo00=NmgooOol017oo00=NmgooOol02goo
00=NmgooOol00Woo00=NmgooOol02goo00=NmgooOol02Woo00=NmgooOol02Goo00=NmgooOol02goo
00=NmgooOol00Woo00=NmgooOol02goo00=NmgooOol017oo00=NmgooOol03Woo00<0EgooOol01Woo
00ENmgooOomoo`0002eoo`Y85a1oo`00=goo00<007ooOol00Woo00<1EgooOol00goo00=NmgooOol0
1Goo00=NmgooOol027oo0Ukg1Woo00=NmgooOol02goo00=NmgooOol02Goo00=NmgooOol02Goo00=N
mgooOol02goo00=NmgooOol00goo0Ukg2Woo00=NmgooOol01Woo00=NmgooOol03Goo00<0EekgOol0
17oo0Ukg17oo00<007ooOol0:goo2T@G47oo000gOol00`00Oomoo`02Ool00`5GOomoo`02Ool00ekg
Oomoo`07Ool00ekgOomoo`06Ool00ekgOomoo`06Ool00ekgOomoo`0;Ool00ekgOomoo`09Ool00ekg
Oomoo`09Ool00ekgOomoo`0:Ool00ekgOomoo`06Ool00ekgOomoo`06Ool00ekgOomoo`07Ool00ekg
Oomoo`0=Ool00`1GG_Moo`03Ool00ekgOomoo`04Ool00`00Oomoo`0[Ool:@1L@Ool003Moo`03001o
ogoo009oo`030EMoogoo009oo`03G_Moogoo00Qoo`03G_Moogoo00Aoo`03G_Moogoo00Qoo`03G_Mo
ogoo00Yoo`03G_Moogoo00Uoo`03G_Moogoo00Qoo`03G_Moogoo00]oo`03G_Moogoo00Moo`03G_Mo
ogoo00Eoo`03G_Moogoo00Qoo`03G_Moogoo00aoo`0305Mooekg009oo`03G_Moogoo00Eoo`03001o
ogoo02]oo`Xl5a1oo`00=goo00<007ooOol00Woo00D1EgooOomooekg00aoo`03G_Moogoo009oo`03
G_Moogoo00Uoo`03G_Moogoo00Yoo`03G_Moogoo00Uoo`03G_Moogoo00Qoo`03G_Moogoo00Yoo`03
G_Moogoo00Uoo`03G_Moogoo00=oo`03G_Moogoo00Yoo`03G_Moogoo00aoo`0405MNmekgG_L8Ool0
0`00Oomoo`0[Ool:>1L@Ool0031oo`@000=oo`03001oogoo009oo`050EMoogooOomNm`0<Ool01Ekg
OomoogooG_L03Goo00=NmgooOol02Woo00=NmgooG_L04Ekg0Woo00=NmgooOol02Woo00=NmgooOol0
2Woo00ENmgooOomooekg00eoo`03G_Moogoo00aoo`0303MNmekg00Uoo`03001oogoo02]oo`Xd5a1o
o`00<7oo00<007ooOol017oo00<007ooOol00Woo00@1EgooOomNm`ioo`03G_Mooekg00ioo`03G_Mo
ogoo00Yoo`9Nm`Uoo`03G_Moogoo00Ioo`=Nm`]oo`03G_Moogoo00]oo`04G_MoogooG_L?Ool00ekg
Oomoo`0;Ool00ekg03MNm`09Ool00`00Oomoo`0[Ool:<1L@Ool0035oo`03001oogoo00=oo`80009o
o`040EMoogooG_L@Ool2G_L?Ool00ekgOomoo`06Ool4G_L:Ool00ekgOomoo`08Ool3G_L9Ool00ekg
Oomoo`0<Ool2G_L@Ool00ekgOomoo`09Ool2G_L00goo03MNm`08Ool2000]Ool:;1L@Ool002Yoo`@0
00Aoo`03001oogoo009oo`05001oogooOol1E`02Ool00ekgOomoo`0>Ool2G_L?Ool00ekgOomoo`04
Ool2G_L3Ool00ekgOomoo`08Ool00ekgOomoo`07Ool015kgOomoogoo0Ukg1Woo00=NmgooOol03Woo
00=NmgooOol03goo00=NmgooOol01goo00MNmgooOomoo`0gOomNm`08Ool00`00Oomoo`0[Ool::1L@
Ool0031oo`04001oogoo0003Ool01`00Oomoogoo0EMooekg011oo`04G_MoogooG_L?Ool015kgOomo
ogoo0Ukg1Goo00=NmgooOol027oo00=NmgooOol01goo00=NmgooOol00goo0Ukg17oo00=NmgooOol0
3Goo00=NmgooG_L047oo00=NmgooOol01Goo0Ukg17oo00<0=gooG_L027oo00<007ooOol0:goo2R@G
47oo000aOol20004Ool01`00Oomoogoo0EMooekg00moo`05G_MoogooOomNm`0?Ool015kgOomooekg
27oo00=NmgooOol01goo00=NmgooOol01goo00=NmgooOol01Goo00ENmgooOomooekg00ioo`05G_Mo
ogooOomNm`0@Ool00ekgOomoo`03Ool00ekgOomoo`05Ool00`0gOomNm`07Ool00`00Oomoo`0[Ool:
81L@Ool003Moo`06G_MoogooOol1Eekg47oo00=NmgooOol00Woo00=NmgooOol03Goo0Ukg2Goo00=N
mgooOol01goo00=NmgooOol01goo00=NmgooOol01Woo0ekg3Woo00=NmgooOol00Woo00=NmgooOol0
3Woo00=NmgooOol00Woo00=NmgooOol01Woo00<0=gooG_L01goo00<007ooOol0:goo2Q`G47oo000g
Ool01P00G_MNmgoo0EMNm`moo`03G_Moogoo00Aoo`03G_Moogoo00]oo`9Nm`Yoo`03G_Moogoo00Mo
o`03G_Moogoo00Moo`03G_Moogoo00Qoo`03G_Moogoo00]oo`03G_Moogoo00Aoo`03G_Moogoo00io
o`04G_MooekgG_L:Ool00`0gG_Moo`06Ool00`00Oomoo`0[Ool:61L@Ool003Moo`05001oogooG_L1
E`0@Ool00ekgOomoo`05Ool00ekgOomoo`09Ool00ekgOomNm`0:Ool00ekgOomoo`07Ool00ekgOomo
o`06Ool00ekgOomoo`08Ool00ekgOomNm`0<Ool00ekgOomoo`04Ool00ekgOomoo`0>Ool2G_L<Ool0
0`0gOomNm`06Ool00`00Oomoo`0[Ool:51L@Ool003Moo`05001oogooOol1E`0?Ool00ekgOomoo`07
Ool00ekgOomoo`07Ool01EkgOomoogooG_L02Woo00=NmgooOol01Woo00=NmgooOol01Woo00=Nmgoo
Ool027oo00ANmgooOomNm`Yoo`03G_Moogoo00Ioo`03G_Moogoo00eoo`9Nm`aoo`0303Mooekg00Io
o`03001oogoo02]oo`X@5a1oo`00=goo00D007ooOomNm`5G009Nm`eoo`03G_Moogoo00Moo`03G_Mo
ogoo00Eoo`9Nm`Aoo`03G_Moogoo00Qoo`03G_Moogoo00Ioo`03G_Moogoo00Ioo`03G_Moogoo00Mo
o`03G_Moogoo009oo`9Nm`Moo`03G_Moogoo00Moo`03G_Moogoo00]oo`9Nm`03OomNmgoo00]oo`04
03MoogooG_L5Ool00`00Oomoo`0[Ool:31L@Ool003Moo`05001oogooG_L1E`02Ool00ekgOomoo`09
Ool00ekgOomoo`09Ool00ekgOomoo`03Ool00ekgOomoo`05Ool00ekgOomoo`07Ool00ekgOomoo`06
Ool00ekgOomoo`06Ool00ekgOomoo`07Ool00ekgOomoo`04Ool00ekgOomoo`03Ool00ekgOomoo`09
Ool00ekgOomoo`09Ool01EkgOomoogooG_L03Goo00<0=gooG_L01Goo00<007ooOol0:goo2PPG47oo
000gOol01@00OomNmgoo0EL00goo0Ukg27oo00=NmgooOol02goo00ENmgooOomooekg00Qoo`03G_Mo
ogoo00Moo`03G_Moogoo00Ioo`03G_Moogoo00Eoo`03G_Moogoo00Moo`03G_Moogoo00Ioo`03G_Mo
ogoo009oo`03G_Moogoo00Yoo`03G_Moogoo00Ioo`9Nm`Eoo`03G_Moogoo00Yoo`0403MoogooG_L4
Ool00`00Oomoo`0[Ool:11L@Ool003Moo`05001ooekgOol1E`05Ool00ekgOomoo`05Ool00ekgOomo
o`0<Ool00ekgOomNm`0:Ool00ekgOomoo`06Ool00ekgOomoo`06Ool00ekgOomoo`05Ool00ekgOomo
o`07Ool00ekgOomoo`07Ool015kgOomooekg3Goo00=NmgooOol01Goo00=NmgooOol01Goo00=Nmgoo
Ool02Woo00@0=gooOomNm`Aoo`03001oogoo02]oo`X05a1oo`00=goo00D005kgOomoo`5g00Ioo`03
G_Moogoo00=oo`03G_Moogoo00ioo`9Nm`Yoo`03G_Moogoo00Moo`03G_Moogoo00Eoo`03G_Moogoo
00Eoo`03G_Moogoo00Ioo`03G_Moogoo00Qoo`03G_Mooekg00moo`03G_Moogoo00=oo`03G_Moogoo
00Moo`03G_Moogoo00Yoo`0303Mooekg00Aoo`03001oogoo02]oo`X05a1oo`00=goo00D005kgOomo
o`5g00Moo`9Nm`=oo`03G_Moogoo00ioo`03G_Moogoo00Yoo`03G_Moogoo00Ioo`03G_Moogoo00Eo
o`03G_Moogoo00Eoo`03G_Moogoo00Ioo`03G_Moogoo00Uoo`03G_Moogoo00ioo`04G_MoogooOol2
G_L:Ool00ekgOomoo`0:Ool00`0gOomNm`04Ool00`00Oomoo`0[Ool:03L@Ool003Moo`05G_Moogoo
Ool1M`09Ool00ekgOomNm`0@Ool00ekgOomNm`0;Ool00ekgOomoo`06Ool00ekgOomoo`05Ool00ekg
Oomoo`05Ool00ekgOomoo`05Ool00ekgOomoo`09Ool00ekgOomNm`0@Ool00ekgOomNm`0<Ool00ekg
Oomoo`0:Ool0100gOomooekg0goo00<007ooOol0:goo2P1G47oo000gOol01EkgOomoogoo0GL02Woo
0Ukg3goo00ENmgooOomooekg00]oo`03G_Moogoo00Eoo`03G_Moogoo009oo`INm`Aoo`03G_Moogoo
00Ioo`03G_Moogoo00Uoo`04G_MoogooG_L?Ool2G_L>Ool00ekgOomoo`09Ool0100GOomooekg0goo
00<007ooOol0:goo2P1g47oo000gOol01@00Oomoogoo0GL02Woo0ekg3Woo00=NmgooOol00Woo00=N
mgooOol027oo00=NmgooOol01Woo15kg0goo00=NmgooOol01Ekg27oo00=NmgooOol027oo00ENmgoo
Oomooekg00ioo`=Nm`ioo`03G_Moogoo00Uoo`0401MoogooG_L3Ool00`00Oomoo`0[Ool:09L@Ool0
03Moo`05001oogooOol1M`0:Ool015kgOomooekg37oo00=NmgooOol017oo00=NmgooOol027oo00=N
mgooOol00Woo15kg1Woo00=NmgooOol017oo0ekg1Goo00=NmgooOol027oo00=NmgooOol00goo00=N
mgooOol02Woo00ANmgooOomNm`moo`03G_Moogoo00Qoo`0401MoogooG_L3Ool00`00Oomoo`0[Ool:
0;L@Ool003Moo`05001oogooOol1M`09Ool00ekgOomoo`02Ool2G_L:Ool00ekgOomoo`04Ool00ekg
Oomoo`08Ool00ekgOomoo`02G_L3Ool00ekgOomoo`04Ool00ekgOomoo`04Ool00ekgOomoo`02G_L3
Ool00ekgOomoo`07Ool00ekgOomoo`04Ool00ekgOomoo`09Ool00ekgOomoo`02Ool00ekgOomoo`0<
Ool00ekgOomoo`09Ool0100GOomooekg0Woo00<007ooOol0:goo2P3G47oo000gOol01@00Oomoogoo
0GL02Goo00=NmgooOol017oo00=NmgooOol01Woo00=NmgooOol01Woo00=NmgooOol027oo0Ukg1Goo
00=NmgooOol017oo00=NmgooOol017oo00=NmgooOol00Woo0ekg2Goo00=NmgooOol01Woo00=Nmgoo
Ool01Woo0Ukg1Goo00=NmgooOol037oo00=NmgooOol02Goo00@05gooOomNm`9oo`03001oogoo02]o
o`X0ma1oo`00=goo00D007ooOomoo`5g00Qoo`03G_Moogoo00Ioo`03G_Moogoo00Aoo`03G_Moogoo
00Qoo`03G_Moogoo00Ioo`9Nm`Ioo`03G_Moogoo00Aoo`03G_Moogoo00=oo`03G_Moogoo00Eoo`03
G_Moogoo00Moo`03G_Moogoo00Ioo`03G_Moogoo00Eoo`03G_Moogoo00Eoo`03G_Moogoo00eoo`03
G_Moogoo00Qoo`0401MoogooG_L2Ool00`00Oomoo`0[Ool:0AL@Ool003Moo`05001oogooOol1M`08
Ool00ekgOomoo`07Ool2G_L4Ool00ekgOomoo`09Ool00ekgOomoo`04Ool00ekgOomNm`07Ool00ekg
Oomoo`03Ool00ekgOomoo`03Ool00ekgOomoo`04Ool00ekgOomNm`07Ool00ekgOomoo`08Ool00ekg
Oomoo`02Ool2G_L9Ool00ekgOomoo`0<Ool00ekgOomoo`08Ool0100GOomooekg0Woo00<007ooOol0
:goo2P4g47oo000gOol00`00Oomoo`02Ool00`5gOomoo`05Ool00ekgOomoo`09Ool015kgOomooekg
3Goo00=NmgooOol00Woo00ENmgooOomooekg00Ioo`03G_Moogoo00=oo`03G_Moogoo00=oo`03G_Mo
ogoo00Aoo`04G_MoogooG_L5Ool00ekgOomoo`09Ool01EkgOomoogooG_L02goo00=NmgooOol037oo
00=NmgooOol027oo00@05gooOomoo`9Nm`03001oogoo02]oo`X1Ea1oo`00=goo00<007ooOol00Woo
00<1MgooOol017oo00=NmgooOol02goo0ekg3Goo00ENmgooOomooekg00Aoo`03G_Moogoo00Aoo`03
G_Moogoo00=oo`03G_Moogoo00=oo`03G_Moogoo00=oo`03G_Moogoo009oo`05G_MoogooOomNm`0=
Ool00ekgOomNm`0=Ool00ekgOomoo`0;Ool00ekgOomoo`08Ool00`0GOomNm`02G_L00goo001oo`0/
Ool:0GL@Ool003Moo`03001oogoo009oo`030GMoogoo00Aoo`03G_Moogoo00aoo`9Nm`ioo`03G_Mo
oekg00Ioo`03G_Moogoo00=oo`03G_Moogoo00=oo`03G_Moogoo00=oo`03G_Moogoo00=oo`03G_Mo
ogoo00=oo`03G_Mooekg00ioo`9Nm`ioo`03G_Moogoo00aoo`03G_Moogoo00Ioo`9Nm`0601Moogoo
G_Moo`00;Goo2P6G47oo000gOol20003Ool00`5gOomoo`04Ool00ekgOomoo`0<Ool00ekgOomNm`0>
Ool00ekgOomoo`05Ool00ekgOomoo`03Ool00ekgOomoo`03Ool00ekgOomoo`02Ool00ekgOomoo`03
Ool00ekgOomoo`05Ool2G_L=Ool00ekgOomNm`0>Ool00ekgOomoo`0<Ool00ekgOomoo`03Ool3G_L2
Ool01P0GOomooekgOol002eoo`X1]a1oo`00=goo00<007ooOol00Woo00<1MgooOol00goo00=Nmgoo
Ool03Goo00=NmgooOol00Ukg2goo00=NmgooG_L01goo00=NmgooOol00goo00=NmgooOol00Woo00=N
mgooOol00Woo00=NmgooOol00goo00=NmgooOol01Goo0Ukg37oo00ANmgooOomNm`ioo`03G_Moogoo
00aoo`03G_Moogoo00=Nm`Eoo`0601MoogooG_Moo`00;Goo2P7G47oo000gOol00`00Oomoo`02Ool0
0`5gOomoo`03Ool00ekgOomoo`0<Ool00ekgOomoo`03Ool00ekgOomoo`07Ool01EkgOomoogooG_L0
1Woo00=NmgooOol00goo00=NmgooOol00Woo00=NmgooOol00Woo00=NmgooOol00goo00=NmgooOol0
17oo00ANmgooOomNm`Uoo`9Nm`Aoo`03G_Moogoo00aoo`03G_Moogoo00]oo`=Nm`Qoo`0601Moogoo
G_Moo`00;Goo2P7g47oo000gOol2G_L4Ool00`5gOomoo`02Ool00ekgOomoo`0<Ool00ekgOomoo`04
Ool2G_L7Ool01EkgOomoogooG_L01goo00=NmgooOol00Woo00=NmgooOol00Woo00=NmgooOol00Woo
00=NmgooOol00Woo00=NmgooOol017oo00ENmgooOomooekg00Qoo`03G_Moogoo00Aoo`03G_Moogoo
00aoo`03G_Moogoo00Qoo`=Nm`03OomNmgoo00Qoo`0601MoogooOomNm`00;Goo2P8G47oo000gOol0
0`00OomNm`02G_L00goo0GMoo`03Ool00ekgOomoo`0;Ool00ekgOomoo`07Ool00ekgOomoo`03Ool0
0ekgOomoo`03Ool00ekgOomoo`04Ool00ekgOomoo`02Ool00ekgOomoo`02Ool01EkgOomoogooG_L0
1Goo00=NmgooOol017oo00=NmgooOol00Woo00=NmgooOol017oo00=NmgooOol01Woo00=NmgooOol0
2goo00=NmgooOol01Woo0Ukg17oo00=NmgooOol01goo00H05gooOomooekg000]Ool:0SL@Ool003Mo
o`03001oogoo009oo`03G_L1Mekg009oo`03G_Moogoo00aoo`03G_Moogoo00Qoo`05G_MoogooOomN
m`07Ool00ekgOomoo`04Ool00ekgOomoo`02Ool01EkgOomoogooG_L00goo00=NmgooOol00Woo00=N
mgooOol017oo00=NmgooOol00goo00=NmgooOol00Woo0Ukg2Goo00=NmgooOol02goo00=NmgooOol0
0goo0ekg1Woo00=NmgooOol01goo00H05gooOomooekg000]Ool:0WL@Ool003Moo`03001oogoo00=o
o`030GMooekg009Nm`ioo`03G_Moogoo00Uoo`03G_M85dPG00985`I<5`9@5`Eoo`03G_Moogoo009o
o`05G_MoogooOomNm`03Ool00ekgOomoo`02Ool00ekgOomoo`03Ool00ekgOomoo`05Ool015kgOomo
oekg2goo00=NmgooOol037oo00=NmgooG_L00Ukg2Goo00=NmgooOol027oo00D05gooOomNm`0002eo
o`X2Ua1oo`00=goo00<007ooOol017oo00<1MgooOol015kg2Woo00=NmgooOol01goo00I45dPGB1M8
5gooG_L:Ool2D1L01E@GOomoogooG_L00goo00=NmgooOol00Ukg0goo00ENmgooOomooekg00Eoo`03
G_Moogoo00Ioo`=Nm`eoo`03G_Moogoo00Yoo`=Nm`aoo`03G_Moogoo00Qoo`0501MoogooG_L0000]
Ool:0[L@Ool003Moo`03001oogoo00Aoo`040IMoogooG_L3Ool2G_L8Ool00ekgOomoo`06Ool2A1L4
Ool3G_L8Ool00ekgOomD5`02E1L017ooG_Moogoo15kg00=ooekgG_L00ekg0goo00=NmgooOol00Woo
00=NmgooOol01goo0Ukg3Woo00=NmgooOol01goo0ekg00=ooekgOol037oo00=NmgooOol027oo00D0
5gooOomNm`0002eoo`X2ea1oo`00=goo00<007ooOol017oo00@1UgooOomNm`Eoo`=Nm`Eoo`03G_Mo
ogoo00=oo`=45`Ioo`04G_MoogooG_L8Ool00ekgOomoo`03F1L2G_L00gooG_Moo`02Ool025kgOomo
oekgOomNmgooG_L5Ool00ekgOomoo`06Ool00ekgOomNm`0>Ool00ekgOomoo`04Ool3G_L4Ool00ekg
Oomoo`0<Ool00ekgOomoo`07Ool01@0GOomoogoo0000;Goo2P;g47oo000gOol00`00Oomoo`04Ool0
106GOomooekg27oo0ekg0Woo00=NmgooOol00Woo00=45gooOol01Woo00=NmgooOol00Woo00=Nmgoo
Ool01Woo00ANmgooOomoo`9H5`=oo`04G_MoogooG_L2Ool00ekgOomoo`02G_L4Ool00ekgOomoo`05
Ool2G_L2Ool00ekgOomoo`0<Ool015kgOomoogoo0ekg1goo00=NmgooOol037oo00=NmgooOol01goo
00D05gooOomoo`0002eoo`X2ma1oo`00=goo00<007ooOol017oo00@1UgooOomNm`]oo`=Nm`9oo`03
@1M45goo00Qoo`03G_Moogoo00=oo`9Nm`Moo`04G_MooekgOol2G1L2Ool015kgOomooekg0Woo00IN
mgooOomNmgooG_L2Ool00ekgOomoo`05Ool00ekgOomoo`03Ool00ekgOomoo`0<Ool3G_L:Ool00ekg
Oomoo`0<Ool00ekgOomoo`07Ool01@0GOomoogoo0000;Goo2P;f47oo000gOol20006Ool00`6GG_Mo
o`0<Ool01EkgOomNmd0GG_L02Woo00=NmgooOol01Goo00=NmgooOol01Goo00ANmgooOomoo`9L5`05
OomNmgooOomNm`02Ool015kgOomooekg0Woo0Ukg1goo00=NmgooOol017oo00=NmgooOol02Goo15kg
3Goo00=NmgooOol02goo00=NmgooOol01goo00D05gooOomoo`0002eoo`X2mA1oo`00=goo00<007oo
Ool01Goo00<1UekgOol037oo00=Nmd0G@1L00Woo0ekg1goo00=NmgooOol01Woo00=NmgooOol00goo
0Ukg0goo00ANme`GG1MNm`9oo`06G_MoogooG_Mooekg0goo0Ukg1Goo0Ukg1goo00=NmgooOol01Woo
0ekg0goo00=NmgooOol02goo00=NmgooOol02goo00=NmgooOol01goo00D05gooOomoo`0002eoo`X2
m11oo`00=goo00<007ooOol01Woo00<1UgooOol02goo00=05gooOol01Goo0ekg0goo00=NmgooOol0
27oo0Ukg0Woo00ANmgooOomNm`=oo`08G_ML5U`FG_MooekgOomNm`9oo`07G_MoogooOomNmgooG_L0
0goo00=NmgooOol01goo00=NmgooOol00goo0ekg1Woo00=NmgooOol02goo00=NmgooOol02goo00=N
mgooOol01goo00D05gooOomoo`0002eoo`X2la1oo`00=goo00<007ooOol01Woo00<1UgooOol02Woo
00=05gooOol02Goo15kg37oo0Ukg17oo00]NmgooOomNmgooG1ENmgooG_Mooekg009oo`04G_Moogoo
G_L2Ool015kgOomNmekg2goo00=NmgooG_L00Ukg2Goo00=NmgooOol02goo00=NmgooOol02goo00=N
mgooOol01goo00D05gooOomoo`0002eoo`X2lQ1oo`00=goo00<007ooOol01Woo00=Nm`6GOol02Goo
00=05ekgOol03Goo0ekg2goo0Ukg17oo00aNmgooOomNmgooG1EooekgOomNmgooG_L2Ool00ekgOomo
o`02Ool00ekgOomoo`0:Ool3G_L=Ool00ekgOomoo`0:Ool00ekgOomoo`0;Ool00ekgOomoo`07Ool0
1@0GOomoogoo0000;Goo2P;a47oo000gOol00`00Oomoo`06Ool00ekg0IMoo`08Ool00d0GOomNm`0>
Ool00ekgOomoo`03G_L8Ool00ekgOomNm`04Ool03EkgOomNmgooG1AL4ekgOomNmgooG_Mooekg00Ao
o`9Nm`Uoo`=Nm`03OomNmgoo00eoo`03G_Moogoo00Yoo`03G_Moogoo00]oo`03G_Moogoo00Moo`05
01MoogooOol0000]Ool:0_0@Ool003Moo`03001oogoo00Ioo`03G_Moo`6G00Moo`04@1MoogooG_L=
Ool00ekgOomoo`04Ool3G_L5Ool015kgOomooekg0goo00=NmgooOol00Ukg00EL4ekgG_Mooekg009o
o`03G_Moogoo009Nm`03OomNmgoo00Ioo`9Nm`Aoo`03G_Moogoo00aoo`03G_Moogoo00Yoo`03G_Mo
ogoo00]oo`03G_Moogoo00Moo`0501MoogooOol0000]Ool:0^l@Ool003Moo`03001oogoo00Ioo`03
G_Moo`6G00Ioo`05?1MoogooOomNm`0=Ool00ekgOomoo`07Ool2G_L2Ool00ekgOomoo`02Ool2G_L2
Ool02ekgOomNmgooG19L3ekgOomNmgooG_L00Woo00ENmgooOomooekg00Aoo`=Nm`Moo`03G_Moogoo
00]oo`03G_Moogoo00Yoo`03G_Moogoo00]oo`03G_Moogoo00Qoo`0401Moogoo000]Ool:0^h@Ool0
03Moo`03001oogoo00Ioo`03G_Moo`6G00Eoo`03?1Moogoo009oo`03G_Moogoo00]oo`03G_Moogoo
00Uoo`=Nm`Ioo`08G_MoogooG_MooekgG11L3`9Nm`05OomNmgooOomNm`05Ool4G_L:Ool00ekgOomo
o`0;Ool00ekgOomoo`0:Ool00ekgOomoo`0<Ool00ekgOomoo`07Ool0100GOomoo`00;Goo2P;]47oo
000GOol20002Ool30003Ool2000DOol00`00Oomoo`05Ool01EkgOomoogoo0IL017oo00<l5gooOol0
0Woo00=NmgooOol02goo00=NmgooOol02goo15kg17oo0Ukg00EooekgG_MNme`>00=Nm`03OomNmekg
00Aoo`=Nm`eoo`03G_Moogoo00]oo`03G_Moogoo00]oo`03G_Moogoo00]oo`03G_Moogoo00Moo`04
01Moogoo000]Ool:0^`@Ool001Moo`03001oogoo00Aoo`05001oogooOol0000DOol00`00Oomoo`05
Ool01EkgOomoogoo0IL00goo00<l5gooOol00goo00=NmgooOol02goo00=NmgooOol02goo00ANmgoo
Oomoo`=Nm`=oo`05G_MooekgG_ML3002G_L00gooG_Moo`02Ool3G_L2Ool00ekgOomoo`0;Ool00ekg
Oomoo`0;Ool00ekgOomoo`0;Ool00ekgOomoo`0;Ool00ekgOomoo`07Ool010@GOomoo`00;Goo2P;[
47oo000:Ool300001goo000007oo001oo`0000=oo`03001oogoo009oo`<000=oo`03001oogoo00ao
o`8000Aoo`03001oogoo00Eoo`03G_Moogoo009oo`030IMooc`G00Ioo`03G_Moogoo00]oo`03G_Mo
ogoo00]oo`03G_Moogoo00Aoo`=Nm`05OomNmekgG_ML2@03G_L017ooG_MNmekg1Goo00=NmgooOol0
2goo00=NmgooOol02goo00=NmgooOol02goo00=NmgooOol02goo00=NmgooOol01goo00@45gooOol0
02eoo`X2jQ1oo`002goo00T007ooOomoo`00Ool007oo00000goo00D007ooOomoo`00009oo`05001o
ogooOol0000=Ool01000Oomoo`000goo00<007ooOol01Goo00=NmgooOol00goo00<1]gooOol01Goo
00=NmgooOol02goo00=NmgooOol02goo00=NmgooOol01goo15kg00<07ekgG_L00Ukg27oo00=Nmgoo
Ool02goo00=NmgooOol02goo00=NmgooOol02goo00=NmgooOol02goo00=NmgooOol01goo00@45goo
Ool002eoo`X2jA1oo`002goo00T007ooOomoo`00Ool007oo00000goo00D007ooOomoo`00009oo`05
001oogooOol0000=Ool01000Oomoo`000goo3Ukg00<1]ekgG_L06ekg00=l05kgG_L04Ekg00<2hUkg
G_L0C5kg00@45ekgG_L002eoo`X2j11oo`002goo00<007ooOol00`0000=oo`00Ool00goo00<007oo
Ool00Woo10000Woo00<007ooOol02goo00@007ooOol000=oo`03001oogoo00Eoo`03G_Moogoo009o
o`03?1Moo`6g00Ioo`03G_Moogoo00]oo`03G_Moogoo00]oo`03G_Moogoo00Moo`ANm`030^9Nmekg
009Nm`Qoo`03G_Moogoo00]oo`03G_Moogoo00]oo`03G_Moogoo00]oo`03G_Moogoo00]oo`03G_Mo
ogoo00Moo`0411Moogoo000]Ool:0^L@Ool000]oo`03001oogoo00Uoo`03001oogoo00Qoo`03001o
ogoo00]oo`04001oogoo0003Ool00`00Oomoo`05Ool01EkgOomoogoo?1L00goo00<1]gooOol00goo
00=NmgooOol02goo00=NmgooOol02goo00=NmgooOol017oo0ekg00EooekgG_MNm`;Z00=Nm`04OomN
mekgG_L5Ool00ekgOomoo`0;Ool00ekgOomoo`0;Ool00ekgOomoo`0;Ool00ekgOomoo`0;Ool00ekg
Oomoo`07Ool010@GOomoo`00;Goo2P;V47oo000:Ool3000:Ool20008Ool2000>Ool20004Ool00`00
Oomoo`05Ool01EkgOomoogoo?1L00goo00<1]gooOol00goo00=NmgooOol02goo00=NmgooOol02goo
00ANmgooOomoo`=Nm`=oo`05G_MooekgG_L2kP02G_L00gooG_Moo`02Ool3G_L2Ool00ekgOomoo`0;
Ool00ekgOomoo`0;Ool00ekgOomoo`0;Ool00ekgOomoo`0;Ool00ekgOomoo`07Ool010@GOomoo`00
;Goo2P;U47oo000gOol00`00Oomoo`05Ool015kgOomooc`G1Goo00<1]gooOol00Woo00=NmgooOol0
2goo00=NmgooOol02goo15kg17oo0Ukg00EooekgG_L2lP;`00=Nm`03OomNmekg00Aoo`=Nm`eoo`03
G_Moogoo00]oo`03G_Moogoo00Yoo`03G_Moogoo00aoo`03G_Moogoo00Moo`0411Moogoo000]Ool:
0^@@Ool003Moo`03001oogoo00Ioo`03G_Mooc`G00Ioo`050KMoogooOomNm`0=Ool00ekgOomoo`09
Ool3G_L6Ool01ekgOomooekgOomNm`;b00=Nm`05OomNmgooOomNm`04Ool00ekgOomNm`02G_L:Ool0
0ekgOomoo`0;Ool00ekgOomoo`0:Ool00ekgOomoo`0<Ool00ekgOomoo`07Ool010@GOomoo`00;Goo
2P;S17oo0`002Goo000gOol00`00Oomoo`06Ool00ekgOoll5`07Ool0106gOomooekg3Goo00=Nmgoo
Ool01Woo0ekg0goo00ANmgooOomoo`9Nm`9oo`05G_MooekgOol2m002G_L017ooG_Mooekg0Woo0Ukg
0Woo00=NmgooOol00Woo0ekg1Woo00=NmgooOol037oo00=NmgooOol02Woo00=NmgooOol02goo00=N
mgooOol01goo00D45gooOomoo`0002eoo`X2hPEoo`03001oogoo00Qoo`00=goo00<007ooOol01Woo
00=Nmgoo?1L027oo00<1]gooG_L03Woo00=NmgooOol00Woo0ekg1Woo00ANmgooOomNm`=oo`06G_Mo
ogooG_L2mP;e0Ukg00EooekgOomooekg00=oo`03G_Mooekg00Moo`=Nm`=oo`03G_Moogoo00aoo`03
G_Moogoo00Yoo`03G_Moogoo00]oo`03G_Moogoo00Moo`0511MoogooOol00017Ool003Moo`03001o
ogoo00Ioo`03G_Lh5goo00Uoo`030KMNmgoo00eoo`03G_Mooekg009Nm`Uoo`03G_Mooekg00Aoo`0=
G_MooekgOol2mWooG_MooekgOomNmgooG_L017oo0Ukg2Woo15kg3Woo00=NmgooOol02Woo00=Nmgoo
Ool02goo00=NmgooOol01goo00D45gooOomoo`0004Moo`00=goo00<007ooOol01Woo00<h5gooOol0
2Woo00<1egooOol02goo0ekg37oo0Ukg17oo00ANmgooOomNm`82m`06OomNmgooG_Mooekg0Woo00AN
mgooOomoo`=Nm`aoo`=Nm`aoo`03G_Moogoo00Yoo`03G_Moogoo00]oo`03G_Moogoo00Moo`0511Mo
ogooOol00017Ool003Moo`03001oogoo00Ioo`03>1Moogoo00]oo`030MMoogoo00Moo`=Nm`03OomN
mgoo00]oo`03G_Mooekg00=oo`04G_MoogooG_L20_L01EkgOomNmgooG_L00Woo00ANmgooOomNm`9o
o`04G_MoogooG_L:Ool015kgOomoogoo0ekg27oo00=NmgooOol02goo00=NmgooOol02goo00=Nmgoo
Ool01goo00D45gooOomoo`0004Moo`00=goo00<007ooOol01Goo00<h5ekgOol037oo00=Nm`7GOol0
0goo15kg1Goo00=NmgooOol027oo00ANmgooOomNm`9oo`0<G_MoogooOomNm`;GOomNmgooG_Mooekg
0Woo00ANmgooOomoo`9Nm`Aoo`03G_Moogoo00Moo`03G_Moogoo00Aoo`=Nm`Eoo`03G_Moogoo00]o
o`03G_Moogoo00]oo`03G_Moogoo00Moo`0511MoogooOol00017Ool003Moo`8000Ioo`03>1MNmgoo
00aoo`04G_Moo`7G0ML2G_L9Ool00ekgOomoo`06Ool2G_L4Ool2G_L3Ool015kg0]Mooekg0Woo00IN
mgooOomNmgooG_L4Ool00ekgOomoo`03Ool2G_L7Ool00ekgOomoo`07Ool3G_L2Ool00ekgOomoo`0;
Ool00ekgOomoo`0;Ool00ekgOomoo`07Ool01@PGOomoogoo0000Agoo000gOol00`00Oomoo`05Ool0
0cPGOomNm`0<Ool3G_L00goo0MMoo`09Ool00ekgOomoo`05Ool00ekgOomoo`04Ool3G_L2Ool20[L0
1GooG_MoogooG_L00Woo00ENmgooOomNmgoo00=Nm`Moo`03G_Moogoo00Aoo`03G_Moogoo00Yoo`=N
m`aoo`03G_Moogoo00aoo`03G_Moogoo00Moo`0521MoogooOol00017Ool003Moo`03001oogoo00Ao
o`04>1MoogooG_L9Ool4G_L4Ool20ML8Ool00ekgOomoo`03Ool2G_L7Ool00ekgOomoo`020YL3Ool0
15kgOomooekg0Woo00=NmgooOol00Ukg0goo00=NmgooOol01Goo0Ukg0goo00=NmgooOol03Goo1Ekg
27oo00=NmgooOol037oo00=NmgooOol01goo00D85gooOomoo`0004Moo`00=goo00<007ooOol017oo
00@h5gooOomNm`Ioo`=Nm`Aoo`03G_Moogoo00=oo`030ML1mgoo00Ioo`05G_MoogooOomNm`08Ool0
1EkgOomoo`9g0YL00Ukg0Woo00ANmgooOomNm`9oo`03G_Mooekg009Nm`Aoo`03G_Moogoo00Ioo`04
G_MoogooG_L>Ool00ekgOomoo`03Ool3G_L5Ool00ekgOomoo`0<Ool00ekgOomoo`07Ool01@PGOomo
ogoo0000Agoo000gOol00`00Oomoo`04Ool013PGOomooekg0goo0ekg1goo00=NmgooOol01Goo0P7g
1Goo00ANmgooOomNm`Qoo`03G_Moo`9g0082M`03OomNmgoo009Nm`=oo`03G_Moogoo009Nm`9oo`03
G_Moogoo00=oo`03G_Moogoo00Ioo`03G_Mooekg00ioo`03G_Moogoo00Ioo`=Nm`9oo`03G_Moogoo
00]oo`03G_Moogoo00Qoo`0521MoogooOol00017Ool003Moo`03001oogoo00Aoo`03>1Moogoo00AN
m`Yoo`03G_Moogoo00Moo`<1m`9oo`=Nm`Qoo`04G_L2E`9G0WL2Ool015kgOomoogoo2Ekg0goo00=N
mgooOol00goo00=NmgooOol01Woo0Ukg3Woo00=NmgooOol02Goo0ekg3Goo00=NmgooOol027oo00D8
5gooOomNm`0004Moo`00=goo00<007ooOol00goo00<h5gooG_L00Ukg3Woo00=NmgooOol02Goo0P7g
108G0Woo108g0P9G1Goo00ENmgooOomooekg00=oo`05G_MoogooOomNm`03Ool00ekgOomoo`03Ool0
0ekgOomoo`06Ool00ekgOomNm`0<Ool00ekgOomoo`0<Ool4G_L:Ool00ekgOomoo`08Ool01@PGOomo
oekg0000Agoo000gOol00`00Oomoo`02Ool00ekg>1MNm`02Ool00ekgOomoo`0<Ool00ekgOomoo`09
Ool2G_L01WooG_Moogoo0QL2=`Aoo`03G_Moogoo00=oo`03G_Moogoo009oo`05G_MoogooOomNm`03
Ool00ekgOomoo`02Ool00ekgOomoo`03Ool00ekgOomoo`04Ool015kgOomoogoo0Ukg2Woo00=Nmgoo
Ool02goo00=NmgooOol00Woo0ekg1goo00=NmgooOol01goo00H85gooOomooekg0017Ool003Moo`03
001ooekg009Nm`03Oolh5goo00=oo`03G_Moogoo00]oo`03G_Moogoo00Qoo`03G_Moogoo009oo`03
G_Moogoo00Aoo`03G_Moogoo00Aoo`03G_Moogoo009oo`05G_MoogooOomNm`03Ool00ekgOomoo`02
Ool00ekgOomoo`04Ool00ekgOomoo`03Ool00ekgOomoo`03Ool00ekgOomoo`07Ool00ekgOomoo`0;
Ool00ekgOomoo`05Ool3G_L4Ool00ekgOomoo`07Ool01PPGOomoogooG_L004Moo`00=goo0Ukg17oo
00<h5gooOol00Woo00=NmgooOol037oo00=NmgooOol01Woo00=NmgooOol017oo00=NmgooOol00Woo
00=NmgooOol017oo00=NmgooOol00Woo00=NmgooOol00Woo00ENmgooOomooekg00Eoo`03G_Moogoo
00Aoo`05G_MoogooOomNm`07Ool00ekgOomoo`05Ool00ekgOomoo`0<Ool00ekgOomoo`08Ool3G_L0
0gooG_Moo`08Ool01PPGOomoogooG_L004Moo`00=goo00<007ooOol00goo00<h5gooOol00Woo00=N
mgooOol037oo00=NmgooOol017oo0Ukg1goo00ENmgooOomooekg00Moo`03G_Moogoo009oo`03G_Mo
ogoo009oo`03G_Moogoo009oo`03G_Moogoo009oo`03G_Moogoo00Eoo`04G_MoogooG_L8Ool2G_L5
Ool00ekgOomoo`0<Ool00ekgOomoo`0;Ool3G_L8Ool01PPGOomoogooG_L004Moo`00=goo00<007oo
Ool00Woo00<h5gooOol00goo00=NmgooOol037oo00=NmgooOol00goo00=NmgooOol027oo00=Nmgoo
G_L01goo00=NmgooOol00goo00=NmgooOol00Woo00=NmgooOol00Woo00=NmgooOol00goo00=Nmgoo
Ool017oo00=NmgooG_L02goo00=NmgooOol00Woo00=NmgooOol02goo00=NmgooOol037oo00=Nmgoo
Ool00ekg1Goo00H85gooOomNmgoo0017Ool003Moo`8000=oo`03>1Moogoo00Aoo`03G_Moogoo00ao
o`03G_Moogoo009Nm`aoo`9Nm`Moo`03G_Moogoo00=oo`03G_Moogoo009oo`03G_Moogoo009oo`03
G_Moogoo00=oo`03G_Moogoo00Eoo`03G_Moogoo00]oo`9Nm`03OomNmgoo00eoo`03G_Moogoo00ao
o`03G_Moogoo00=oo`=Nm`9oo`0621MoogooG_Moo`00Agoo000gOol00`00Oomoo`02Ool00cPGOomo
o`04Ool00ekgOomoo`0<Ool00ekgOomNm`0>Ool2G_L6Ool00ekgOomoo`03Ool00ekgOomoo`03Ool0
0ekgOomoo`02Ool00ekgOomoo`03Ool00ekgOomoo`04Ool00ekgOomNm`0>Ool2G_L>Ool00ekgOomo
o`0<Ool00ekgOomoo`06Ool2G_L01PPGOomooekgOol004Moo`00=goo00<007ooOol00Woo00<d5goo
Ool017oo00=NmgooOol03Goo00=NmgooOol037oo00ANmgooOomNm`Eoo`03G_Moogoo00=oo`03G_Mo
ogoo00=oo`03G_Moogoo00=oo`03G_Moogoo00=oo`03G_Moogoo009oo`05G_MoogooOomNm`0=Ool2
G_L>Ool00ekgOomoo`0<Ool00ekgOomoo`08Ool01PPGG_MNmekgOol004Moo`00=goo00<007ooOol0
0Woo00<d5gooOol01Goo00=NmgooOol02Woo0ekg3Goo00=NmgooOol00Woo00ENmgooOomooekg00Io
o`03G_Moogoo00=oo`03G_Moogoo00=oo`03G_Moogoo00=oo`05G_MoogooOomNm`04Ool00ekgOomo
o`0;Ool015kgOomNmekg2goo00=NmgooOol037oo00=NmgooOol027oo00@85gooOomoo`9Nm`03001o
ogoo04Eoo`00=goo00D007ooOomooc@G00Qoo`03G_Moogoo00Uoo`05G_MoogooOomNm`0;Ool00ekg
Oomoo`04Ool015kgOomooekg1Woo00=NmgooOol00goo00=NmgooOol00goo00=NmgooOol017oo00=N
mgooG_L01Woo00=NmgooOol02Goo00=NmgooOol00Woo00=NmgooOol027oo00=NmgooOol037oo00=N
mgooOol027oo00@<5gooOomNm`9oo`03001oogoo04Eoo`00=goo00D007ooOomooc@G00Qoo`03G_Mo
ogoo00Moo`9Nm`Aoo`03G_Moogoo00Uoo`03G_Moogoo00Eoo`9Nm`Moo`03G_Moogoo00=oo`03G_Mo
ogoo00=oo`03G_Moogoo00Aoo`9Nm`Qoo`03G_Moogoo00Qoo`03G_Moogoo00=oo`03G_Moogoo00Io
o`03G_Moogoo00eoo`03G_Moogoo00Qoo`0431MoogooG_L2Ool00`00Oomoo`15Ool003Moo`05001o
ogooOold5`09Ool00ekgOomoo`05Ool00ekgOomoo`05Ool00ekgOomoo`07Ool00ekgOomoo`07Ool2
G_L5Ool00ekgOomoo`04Ool00ekgOomoo`03Ool00ekgOomoo`03Ool3G_L9Ool00ekgOomoo`06Ool0
0ekgOomoo`05Ool2G_L6Ool00ekgOomoo`0=Ool00ekgOomoo`08Ool010`GOomooekg0Woo00<007oo
Ool0AGoo000gOol01@00Oomoogoo=1L02Goo00=NmgooOol017oo00=NmgooOol01goo00=NmgooOol0
1Goo00=NmgooOol027oo00=NmgooG_L017oo00=NmgooOol017oo00=NmgooOol017oo00ENmgooOomo
oekg009oo`03G_Moogoo00Qoo`03G_Moogoo00Aoo`03G_Moogoo00Qoo`03G_Moogoo00=oo`03G_Mo
ogoo00aoo`03G_Moogoo00Uoo`0431MoogooG_L2Ool00`00Oomoo`15Ool003Moo`05001oogooOold
5`0:Ool015kgOomoogoo0Ukg2Woo00=NmgooOol017oo00=NmgooOol027oo00ANmgooOomoo`9Nm`9o
o`03G_Moogoo00Aoo`03G_Moogoo00Aoo`04G_MooekgG_L4Ool00ekgOomoo`07Ool00ekgOomoo`04
Ool00ekgOomoo`09Ool2G_L2Ool00ekgOomoo`0=Ool00ekgOomoo`08Ool010`GOomooekg0goo00<0
07ooOol0AGoo000gOol01@00Oomoogoo=1L02Woo00ANmgooOomNm`eoo`03G_Moogoo009oo`03G_Mo
ogoo00Uoo`03G_Moogoo00=oo`=Nm`Ioo`03G_Moogoo00Aoo`9Nm`Ioo`03G_Moogoo00Qoo`03G_Mo
ogoo009oo`03G_Moogoo00aoo`03G_Mooekg00moo`03G_Moogoo00Qoo`0431MoogooG_L3Ool00`00
Oomoo`15Ool003Moo`05G_MoogooOold5`0:Ool00ekgOomNm`0>Ool01EkgOomoogooG_L02goo00=N
mgooOol01Woo3ekg27oo00=NmgooOol027oo00ENmgooOomooekg00moo`03G_Moogoo00eoo`03G_Mo
ogoo00Uoo`0431MoogooG_L3Ool00`00Oomoo`15Ool003Moo`05G_MoogooOold5`0:Ool2G_L@Ool0
15kgOomooekg2goo00=NmgooOol01Goo00=NmgooOol01Goo00=NmgooOol017oo00=NmgooOol01Woo
00=NmgooOol02Goo00=NmgooG_L047oo0ekg3Goo00=NmgooOol02Goo00@<5gooOomNm`=oo`03001o
ogoo04Eoo`00=goo00D005kgOomooc@G00Uoo`03G_Mooekg015oo`9Nm`]oo`03G_Moogoo00Ioo`03
G_Moogoo00Eoo`03G_Moogoo00Eoo`03G_Moogoo00Eoo`03G_Moogoo00Yoo`03G_Moogoo00ioo`05
G_MoogooOomNm`0;Ool00ekgOomoo`0:Ool00``GOomNm`04Ool00`00Oomoo`15Ool003Moo`05001N
mgooOold5`07Ool2G_L3Ool00ekgOomoo`0>Ool2G_L;Ool00ekgOomoo`06Ool00ekgOomoo`05Ool0
0ekgOomoo`05Ool00ekgOomoo`06Ool00ekgOomoo`08Ool2G_L@Ool00ekgOomoo`02Ool2G_L9Ool0
0ekgOomoo`0:Ool00``GOomNm`04Ool00`00Oomoo`15Ool003Moo`05001NmgooOold5`06Ool00ekg
Oomoo`03Ool00ekgOomoo`0=Ool00ekgOomNm`0:Ool00ekgOomoo`07Ool00ekgOomoo`05Ool00ekg
Oomoo`05Ool00ekgOomoo`06Ool00ekgOomoo`08Ool00ekgOomNm`0>Ool00ekgOomoo`05Ool00ekg
Oomoo`06Ool00ekgOomoo`09Ool010`GOomooekg17oo00<007ooOol0AGoo000gOol01@00OomNmgoo
=1L01Goo00=NmgooOol01Goo00=NmgooOol02goo00ENmgooOomooekg00Uoo`03G_Moogoo00Ioo`03
G_Moogoo00Ioo`03G_Moogoo00Eoo`03G_Moogoo00Moo`03G_Moogoo00Ioo`05G_MoogooOomNm`0=
Ool00ekgOomoo`06Ool00ekgOomoo`04Ool00ekgOomoo`0:Ool010`GOomooekg17oo00<007ooOol0
AGoo000gOol01@00OomNmgoo=1L00goo0Ukg27oo00=NmgooOol02goo00=NmgooOol00Woo00=Nmgoo
Ool01Goo00=NmgooOol01goo00=NmgooOol01Woo00=NmgooOol01Goo00=NmgooOol01goo00=Nmgoo
Ool01Goo00=NmgooOol00goo00=NmgooOol02Goo00=NmgooOol027oo0Ukg17oo00=NmgooOol02Woo
00<<5gooG_L01Goo00<007ooOol0AGoo000gOol01@00Oomooekg=1L00Woo00=NmgooOol02Goo00=N
mgooOol02Goo00=NmgooOol017oo00=NmgooOol017oo00=NmgooOol01goo00=NmgooOol01Woo00=N
mgooOol01Woo00=NmgooOol01goo00=NmgooOol00goo00=NmgooOol01Goo00=NmgooOol027oo00=N
mgooOol02Woo00ANmgooOomNm`eoo`0331Mooekg00Eoo`03001oogoo04Eoo`00=goo00D007ooOomN
mc@G009Nm`eoo`03G_Moogoo00Moo`03G_Moogoo00Ioo`03G_Moogoo009oo`03G_Moogoo00Qoo`03
G_Moogoo00Ioo`03G_Moogoo00Ioo`03G_Moogoo00Moo`03G_Moogoo009oo`03G_Moogoo00Ioo`03
G_Moogoo00Moo`03G_Moogoo00aoo`=Nm`aoo`0331Mooekg00Ioo`03001oogoo04Eoo`00=goo00D0
07ooOomooc@G00moo`03G_Moogoo00Ioo`03G_Moogoo00Qoo`05G_MoogooOomNm`0:Ool00ekgOomo
o`06Ool00ekgOomoo`06Ool00ekgOomoo`08Ool015kgOomooekg2Woo00=NmgooOol01Woo00=Nmgoo
Ool03Woo00=NmgooOol02Woo00<<5gooG_L01Woo00<007ooOol0AGoo000gOol01@00Oomooekg=1L0
47oo00=NmgooOol017oo00=NmgooOol02Woo00=NmgooG_L02Woo00=NmgooOol01goo00=NmgooOol0
1Woo00=NmgooOol027oo00=NmgooG_L037oo00=NmgooOol017oo00=NmgooOol03Woo00=NmgooG_L0
2goo00<<5ekgOol01Woo00<007ooOol0AGoo000gOol01P00G_MNmgoo=1MNma1oo`03G_Moogoo00=o
o`03G_Moogoo00]oo`9Nm`Yoo`03G_Moogoo00Moo`03G_Moogoo00Moo`03G_Moogoo00Moo`9Nm`io
o`03G_Moogoo009oo`03G_Moogoo00moo`03G_Moogoo009Nm`Uoo`0331MNmgoo00Ioo`03001oogoo
04Eoo`00=goo00INmgooOomooc@GG_L@Ool00ekgOomoo`02Ool00ekgOomoo`0=Ool3G_L8Ool00ekg
Oomoo`07Ool00ekgOomoo`07Ool00ekgOomoo`05Ool2G_L00gooG_Moo`0>Ool01EkgOomoogooG_L0
47oo00=NmgooOol00goo00=NmgooOol01Goo00<@5gooG_L01goo00<007ooOol0AGoo000`Ool40003
Ool01`00Oomoogoo=1Mooekg011oo`04G_MoogooG_L?Ool015kgOomoogoo0Ukg1Woo00=NmgooOol0
1goo00=NmgooOol01goo00=NmgooOol00goo0Ukg17oo00=NmgooOol037oo00ANmgooOomNma5oo`03
G_Moogoo00Aoo`9Nm`Eoo`0341MNmgoo00Moo`03001oogoo04Eoo`00<7oo00<007ooOol017oo00L0
07ooOomooc@GOomNm`0AOol2G_L@Ool00ekgOomoo`03Ool2G_L3Ool00ekgOomoo`08Ool00ekgOomo
o`07Ool015kgOomoogoo0Ukg1Woo00=NmgooOol03Goo0Ukg4Goo00=NmgooOol01goo00MNmgooOomo
oa0GOomNm`08Ool00`00Oomoo`15Ool0035oo`03001oogoo00=oo`80009oo`04=1MoogooG_L@Ool2
G_L?Ool00ekgOomoo`06Ool4G_L:Ool00ekgOomoo`07Ool4G_L8Ool00ekgOomoo`0=Ool2G_LAOol0
0ekgOomoo`08Ool01EkgOomooa0GG_L027oo0P00Agoo000bOol00`00Oomoo`02Ool00`00Oomoo`02
Ool00c@GOomNm`0?Ool00ekgOomNm`0?Ool00ekgOomoo`09Ool2G_L9Ool00ekgOomoo`06Ool3G_L;
Ool00ekgOomoo`0;Ool015kgOomooekg3goo00=NmgooOol02Woo0Ukg00<@5ekgOol027oo00<007oo
Ool0AGoo000`Ool01000Oomoo`000goo00<007ooOol00Woo00@`5gooOomNm`ioo`04G_MoogooG_L=
Ool00ekgOomoo`0:Ool00ekgOomNm`03G_L5Ool00ekgOomoo`02Ool4G_L2Ool00ekgOomoo`09Ool0
0ekgOomoo`0;Ool01EkgOomoogooG_L03Woo00=NmgooOol02goo00<@5ekgG_L02Goo00<007ooOol0
AGoo000aOol20004Ool00`00Oomoo`02Ool01C0GOomoogooG_L037oo00=NmgooOol00Woo00=Nmgoo
Ool02Woo00=NmgooOol02Woo00=NmgooOol00goo2Ukg1Woo00=NmgooOol02Woo00=NmgooOol02Goo
00=NmgooOol00Woo00=NmgooOol02goo00=NmgooOol037oo00<@5ekgG_L02Goo00<007ooOol0AGoo
000gOol00`00Oomoo`02Ool01C0GOomoogooG_L02goo00=NmgooOol017oo00=NmgooOol027oo00=N
mgooOol02Woo00=NmgooOol02Goo00=NmgooOol027oo00=NmgooOol02Woo00=NmgooOol027oo00=N
mgooOol017oo00=NmgooOol02Goo00=NmgooOol037oo00@@5gooG_Moo`9Nm`Moo`03001oogoo04Eo
o`00=goo00<007ooOol00Woo00<`5gooOol00Woo00=NmgooOol01goo00=NmgooOol01Woo00=Nmgoo
Ool01goo00=NmgooOol02Woo00=NmgooOol02Goo00=NmgooOol027oo00=NmgooOol02goo00=Nmgoo
Ool01Woo00=NmgooOol01Woo00=NmgooOol027oo00=NmgooOol037oo00<@5ekgOol00goo00=Nmgoo
Ool017oo00<007ooOol0AGoo000gOol00`00Oomoo`02Ool00c0GOomoo`02Ool00ekgOomoo`06Ool0
0ekgOomoo`08Ool00ekgOomoo`05Ool00ekgOomoo`0;Ool00ekgOomoo`09Ool00ekgOomoo`09Ool0
0ekgOomoo`0:Ool00ekgOomoo`05Ool00ekgOomoo`08Ool00ekgOomoo`06Ool00ekgOomoo`0=Ool0
0a0GG_Moo`04Ool2G_L4Ool00`00Oomoo`15Ool003Moo`03001oogoo00=oo`03<1Moogoo009oo`03
G_Moogoo00Eoo`03G_Moogoo00Uoo`9Nm`Eoo`03G_Moogoo00]oo`03G_Moogoo00Uoo`03G_Moogoo
00Uoo`03G_Moogoo00]oo`03G_Moogoo009oo`9Nm`aoo`03G_Moogoo00Aoo`03G_Moogoo00ioo`03
41Moogoo00Ioo`05G_MoogooOol00017Ool003Moo`03001oogoo00=oo`03<1Moogoo00=oo`03G_Mo
ogoo00=oo`03G_Moogoo00aoo`05G_MoogooOomNm`0=Ool00ekgOomoo`0:Ool00ekgOomoo`09Ool0
0ekgOomoo`0;Ool01EkgOomoogooG_L03Woo00=NmgooOol00goo00=NmgooOol03Woo00<@5ekgOol0
27oo00ANmgooOol004Moo`00=goo00<007ooOol00goo00<`5gooOol00goo00=NmgooOol00Woo00=N
mgooOol03Woo00ANmgooOomNm`eoo`03G_Moogoo00Yoo`03G_Moogoo00Uoo`03G_Moogoo00aoo`03
G_Mooekg011oo`03G_Moogoo009oo`03G_Moogoo00ioo`0341Moogoo00Uoo`9Nm`03001oogoo04Eo
o`00=goo00<007ooOol017oo00<`5gooOol00goo00ANmgooOomNma9oo`9Nm`ioo`03G_Moogoo00Yo
o`03G_Moogoo00Uoo`03G_Moogoo00aoo`9Nma9oo`04G_MoogooG_L@Ool00a0GG_Moo`0<Ool00`00
Oomoo`15Ool003Moo`03001oogoo00Aoo`03<1Moogoo00Aoo`9NmaAoo`03G_Moogoo00aoo`03G_Mo
ogoo00Yoo`03G_Moogoo00Yoo`03G_Moogoo00]oo`03G_Moogoo019oo`9Nma5oo`0341Moogoo00ao
o`03001oogoo04Eoo`00=goo00<007ooOol017oo00<`5gooOol017oo0Ukg57oo0ekg37oo00=Nmgoo
Ool02Woo00=NmgooOol02Woo00=NmgooOol02Goo0Ukg00=ooekgOol04Woo0Ukg47oo00<D5ekgOol0
3Goo00<007ooOol0AGoo000gOol20005Ool00c0GOomoo`04Ool2G_LCOol01EkgOomoogooG_L02Woo
00=NmgooOol02goo00=NmgooOol02Woo00=NmgooOol027oo00ENmgooOomooekg01=oo`9Nma1oo`03
51Moogoo00eoo`03001oogoo04Eoo`00=goo00<007ooOol017oo00<`5gooOol00goo00ANmgooOomN
ma9oo`03G_Moogoo009oo`03G_Moogoo00Moo`03G_Moogoo00]oo`03G_Moogoo00Yoo`03G_Moogoo
00Moo`03G_Moogoo00=oo`03G_Moogoo00moo`04G_MoogooG_L>Ool00a@GG_Moo`0>Ool00`00Oomo
o`15Ool003Moo`03001oogoo00Aoo`03<1Moogoo009oo`03G_Moogoo009oo`03G_Moogoo00ioo`03
G_Moogoo00Aoo`9Nm`Moo`03G_Moogoo00]oo`03G_Moogoo00]oo`03G_Moogoo00Aoo`9Nm`Ioo`03
G_Moogoo00ioo`03G_Moogoo009oo`03G_Moogoo00]oo`0351Moogoo00eoo`03G_L007oo04Ioo`00
=goo00<007ooOol01Goo00@`5gooOomNm`Eoo`03G_Moogoo00ioo`03G_Moogoo00Ioo`9Nm`Eoo`03
G_Moogoo00]oo`03G_Moogoo00]oo`03G_Moogoo009oo`9Nm`Uoo`03G_Moogoo00aoo`03G_Moogoo
00Aoo`03G_Moogoo00Uoo`0351Moogoo00ioo`03G_L007oo04Ioo`00=goo00<007ooOol01Goo00@`
5gooOomNm`Ioo`03G_Moogoo00aoo`03G_Moogoo00Uoo`=Nm`03OomNmgoo00eoo`03G_Moogoo00]o
o`03G_Mooekg009Nm`]oo`03G_Moogoo00aoo`03G_Moogoo00Eoo`03G_Moogoo00Moo`03G_LD5goo
00ioo`03G_Moo`0004Moo`00=goo00=NmgooOol01Woo00<`5ekgOol01goo00=NmgooOol02goo00=N
mgooOol037oo15kg37oo00=NmgooOol02Goo15kg3goo00=NmgooOol02Woo00=NmgooOol01Woo00=N
mgooOol01goo00<D5gooOol03Woo00=Nmgoo0000Agoo000gOol00`00G_Moo`06Ool00c0GOomoo`08
Ool00ekgOomoo`09Ool00ekgOomoo`0>Ool00ekgOomoo`05G_L7Ool00ekgOomoo`04Ool5G_L2Ool0
0ekgOomoo`0>Ool00ekgOomoo`09Ool00ekgOomoo`08Ool00ekgOomoo`05Ool00ekg51Moo`0>Ool0
15kgOomoo`00Agoo000gOol00`00G_Moo`05Ool00ekgOol`5`0:Ool2G_L9Ool00ekgOomoo`0>Ool0
0ekgOomoo`05Ool>G_L8Ool00ekgOomoo`0>Ool00ekgOomoo`07Ool00ekgOomoo`0:Ool00ekgOomo
o`03Ool00ekg51Moo`0?Ool015kgOomoo`00Agoo000gOol00`00OomNm`04Ool015kgOomooc0G37oo
00=NmgooOol01Goo00=NmgooOol03goo00=NmgooOol037oo00=NmgooOol037oo00=NmgooOol03Woo
00=NmgooOol01Goo0Ukg3Woo00=NmgooOol00Woo00=Nma@GOol03Woo00ENmgooOomoo`0004Moo`00
=goo00@007ooOomNm`9oo`03G_Moogoo009oo`03<1Moogoo00Yoo`03G_Moogoo00Aoo`03G_Moogoo
00ioo`03G_Moogoo00eoo`03G_Moogoo00aoo`03G_Moogoo00ioo`03G_Moogoo00Aoo`03G_Moogoo
00moo`05G_MoogooG_LD5`0@Ool01EkgOomoogoo0000Agoo000gOol01`00OomoogooG_Mooekg00Ao
o`03<1Moogoo00]oo`9Nm`=oo`03G_Moogoo00moo`03G_Moogoo00eoo`03G_Moogoo00aoo`03G_Mo
ogoo00moo`03G_Moogoo009oo`03G_Moogoo011oo`05G_MooekgOolD5`0?Ool00ekgOomoo`02Ool0
0`00Oomoo`15Ool003Moo`03001oogoo009oo`03G_Moogoo00=oo`03<1Moogoo00eoo`04G_Moogoo
G_LAOol00ekgOomoo`0=Ool00ekgOomoo`0<Ool00ekgOomoo`0?Ool01EkgOomoogooG_L057oo00=N
mgoo51L047oo00=NmgooOol00Woo00<007ooOol0AGoo000gOol20002Ool00ekgOomNm`05Ool00c0G
Oomoo`0=Ool3G_LAOol00ekgOomoo`0=Ool00ekgOomoo`0=Ool00ekgOomoo`0?Ool3G_LDOol015kg
OomNma@G3goo00=NmgooOol00goo00<007ooOol0AGoo000gOol01000Oomooekg0goo00=NmgooOol0
0Woo00</5gooOol03Woo0Ukg47oo00=NmgooOol03Woo00=NmgooOol03Goo00=NmgooOol03goo00=N
mgooOol04goo00ENmgooOolD5ekg00ioo`03G_Moogoo00Aoo`03001oogoo04Eoo`00=goo00<007oo
G_L017oo00=NmgooOol00Woo00</5gooOol03Woo00=NmgooG_L03goo00=NmgooOol03Woo00=Nmgoo
Ool03Goo00=NmgooOol03Goo0Ukg00=ooekgOol04goo00INmgooOolD5gooG_L=Ool00ekgOomoo`04
Ool00`00Oomoo`15Ool003Moo`03001ooekg00Eoo`03G_Moogoo009oo`03;1Moogoo00aoo`04G_Mo
ogooOol2G_L=Ool00ekgOomoo`0>Ool00ekgOomoo`0=Ool00ekgOomoo`0;Ool2G_L3Ool00ekgOomo
o`0AOol015kgOomooa@G0Woo00=NmgooOol02Woo00=NmgooOol01Goo00<007ooOol0AGoo000gOol0
0`00G_Moo`06Ool01EkgOomoogoo;1L03Woo00=NmgooOol00goo00=NmgooOol02Woo00=NmgooOol0
3Woo00=NmgooOol03Woo00=NmgooOol02Goo00=NmgooOol017oo00=NmgooOol03goo00ENmgooOomo
oa@G00=oo`03G_Moogoo00Qoo`03G_Moogoo00Ioo`03001oogoo04Eoo`00=goo00=NmgooOol01goo
00ENmgooOomoob`G00aoo`03G_Moogoo00Eoo`9Nm`Yoo`03G_Moogoo00ioo`03G_Moogoo00ioo`03
G_Moogoo00Moo`9Nm`Moo`03G_Moogoo00ioo`05G_MoogooOolH5`05Ool00ekgOomoo`07Ool00ekg
Oomoo`06Ool00`00Oomoo`15Ool003Moo`03001oogoo00Qoo`04G_Moogoo;1L<Ool00ekgOomoo`07
Ool2G_L7Ool00ekgOomoo`0?Ool00ekgOomoo`0>Ool00ekgOomoo`05Ool2G_L:Ool00ekgOomoo`0<
Ool00ekgOomoo`02Ool00aPGOomoo`04Ool00ekgOomoo`05Ool00ekgOomoo`07Ool00`00Oomoo`15
Ool003Moo`03001oogoo00Uoo`04G_Moogoo;1L:Ool00ekgOomoo`0:Ool2G_L5Ool00ekgOomoo`0?
Ool00ekgOomoo`0>Ool00ekgOomoo`03Ool2G_L<Ool00ekgOomoo`0;Ool015kgOomoogoo0QPG1goo
00=NmgooOol017oo00=NmgooOol027oo00<007ooOol0AGoo000gOol00`00Oomoo`0:Ool015kgOomo
ob`G2Goo00=NmgooOol037oo0ekg0Woo00=NmgooOol03goo00=NmgooOol03Woo00=NmgooOol00ekg
3goo00=NmgooOol02Goo00ENmgooOomooaPG00Yoo`03G_Moogoo00=oo`03G_Moogoo00Qoo`03001o
ogoo04Eoo`00=goo00<007ooOol02goo00ANmgooOol/5`Moo`03G_Moogoo011oo`=Nma5oo`03G_Mo
ogoo00moo`9Nma9oo`03G_Moogoo00Qoo`03G_Moogoo009oo`0361Moogoo00Uoo`05G_MoogooOomN
m`0;Ool00`00Oomoo`15Ool003Moo`03001oogoo00aoo`03G_Moob`G00Moo`03G_Moogoo015oo`03
G_Mooekg009Nm`ioo`03G_Moogoo00aoo`ANma=oo`03G_Moogoo00Moo`03G_Moogoo009oo`0361Mo
ogoo00]oo`03G_Mooekg00aoo`03001oogoo04Eoo`00=goo00<007ooOol03Goo00=Nmgoo;1L01Goo
00=NmgooOol04Woo00=NmgooOol00Woo1Ekg2Goo00=NmgooOol01Woo1Ukg0goo00=NmgooOol04Woo
00=NmgooOol01Goo00=NmgooOol00Woo00<H5gooOol03Goo00=NmgooOol02goo00<007ooOol0AGoo
000gOol00`00Oomoo`0>Ool00ekg;1Moo`04Ool00ekgOomoo`0BOol00ekgOomoo`07OolBG_L9Ool0
0ekgOomoo`0BOol00ekgOomoo`04Ool00ekgOomoo`02Ool00aPGOomoo`0=Ool2G_L=Ool00`00Oomo
o`15Ool003Moo`80011oo`03G_L/5goo009oo`03G_Moogoo01=oo`03G_Moogoo011oo`03G_Moogoo
00moo`03G_Moogoo01=oo`03G_Moogoo009oo`03G_Moogoo00=oo`0361Moogoo00aoo`04G_Moogoo
G_L<Ool00`00Oomoo`15Ool003Moo`03001oogoo011oo`05G_L/5gooOomNm`0EOol00ekgOomoo`0@
Ool00ekgOomoo`0@Ool00ekgOomoo`0BOol01EkgOomoogooG_L01Goo00<H5gooOol037oo00=Nmgoo
Ool00Woo00=NmgooOol02Goo00<007ooOol0AGoo000gOol00`00Oomoo`0AOol015kg;1Mooekg57oo
00=NmgooOol04Goo00=NmgooOol047oo00=NmgooOol04goo0ekg1Goo00<H5gooOol03Goo00=Nmgoo
Ool00goo00=NmgooOol027oo00<007ooOol0AGoo000gOol00`00Oomoo`0BOol00b`GG_Moo`0DOol0
0ekgOomoo`0AOol00ekgOomoo`0@Ool00ekgOomoo`0COol00ekgOomoo`04Ool00aPGOomoo`0=Ool0
0ekgOomoo`05Ool00ekgOomoo`07Ool00`00Oomoo`15Ool003Moo`03001oogoo01=oo`03;1MNmekg
01=oo`03G_Moogoo015oo`03G_Moogoo011oo`03G_Moogoo015oo`9Nm`03OomNmgoo00=oo`0361Mo
ogoo00eoo`03G_Moogoo00Ioo`03G_Moogoo00Moo`03001oogoo04Eoo`00=goo00=NmgooOol04Woo
00ENmgoo;1Mooekg019oo`03G_Moogoo015oo`03G_Moogoo011oo`03G_Moogoo011oo`05G_Moogoo
OomNm`03Ool00aPGOomoo`0=Ool00ekgOomoo`08Ool00ekgOomoo`06Ool00`00Oomoo`15Ool003Mo
o`03001Nmekg019oo`05G_Moogoo;1Moo`02G_L@Ool00ekgOomoo`0AOol00ekgOomoo`0AOol00ekg
Oomoo`0=Ool2G_L5Ool00ekgOolL5`0?Ool00ekgOomoo`0:Ool00ekgOomoo`04Ool00ekg001oo`16
Ool003Moo`04001oogooG_L@Ool00ekgOomoo`02Ool2;1L00gooG_Moo`0=Ool00ekgOomoo`0BOol0
0ekgOomoo`0AOol00ekgOomoo`0<Ool00ekgOomoo`05Ool00ekg71Moo`0>Ool00ekgOomoo`0<Ool0
0ekgOomoo`03Ool00ekg001oo`16Ool003Moo`05001oogooOomNm`0?Ool00ekgOomoo`04Ool012`G
OomNmekg37oo00=NmgooOol04Woo00=NmgooOol04Goo00=NmgooOol02Woo0Ukg27oo00<L5gooOol0
3Goo00=NmgooOol03Woo00MNmgooOomooekgOol00017Ool003Moo`03001oogoo009oo`03G_Moogoo
00]oo`03G_Moogoo00Ioo`03;1Moogoo009Nm`Yoo`03G_Moogoo019oo`03G_Moogoo015oo`03G_Mo
ogoo00Qoo`9Nm`Yoo`0371MNmgoo00aoo`03G_Moogoo00moo`04G_MoogooG_L2Ool00`00Oomoo`15
Ool0039oo`<0009oo`03001oogoo00=oo`03G_Moogoo00Yoo`03G_Moogoo00Moo`04:1MoogooOol2
G_L8Ool00ekgOomoo`0BOol00ekgOomoo`0BOol00ekgOomoo`05Ool2G_L:Ool271L00gooG_Moo`0;
Ool00ekgOomoo`0AOol2G_L3Ool00`00Oomoo`15Ool003=oo`05001oogooOol00006Ool2G_L9Ool0
0ekgOomoo`09Ool00bPGOomoo`02Ool2G_L5Ool00ekgOomoo`0COol00ekgOomoo`0BOol00ekgOomo
o`03Ool2G_L;Ool00a`GOomoo`02Ool00ekgOomoo`07Ool2G_LDOol2G_L3Ool00`00Oomoo`15Ool0
031oo`D0009oo`8000Moo`03G_Moogoo00Ioo`03G_Moogoo00Yoo`03:1Moogoo00=oo`=Nm`9oo`03
G_Moogoo01=oo`03G_Moogoo019oo`03G_Moogoo00=Nm`aoo`0371Moogoo00=oo`03G_Moogoo00Io
o`03G_Moogoo01Aoo`04G_MooekgOol20017Ool0031oo`04001oogoo0003Ool00`00Oomoo`07Ool0
0ekgOomoo`04Ool00ekgOomoo`0<Ool00bPGOomoo`05Ool3G_LEOol00ekgOomoo`0BOol3G_L=Ool2
71L7Ool00ekgOomoo`04Ool00ekgOomoo`0DOol01ekgOomoogooG_Moo`0004Moo`00<Goo00<007oo
00000goo00<007ooOol027oo00=NmgooOol00goo00=NmgooOol03Goo00<X5gooOol01Woo1Ekg4Goo
00=NmgooOol03Woo1Ekg3Woo00<L5gooOol01goo00=NmgooOol00goo00=NmgooOol057oo00=Nmgoo
Ool00Woo00=Nmgoo0000Agoo000bOol20003Ool00`00Oomoo`09Ool01EkgOomoogooG_L04Goo0RPG
1Woo00=NmgooOol00Woo15kg3Goo00=NmgooOol02Woo15kg1Goo00=NmgooOol02Woo00<L5gooOol0
2Goo00ENmgooOomooekg01Ioo`03G_Moogoo00Aoo`03G_L007oo04Ioo`00=goo00<007ooOol02Woo
00ANmgooOomNma=oo`03:1Moogoo009oo`03G_Moogoo00Moo`ENm`Qoo`03G_Moogoo00Eoo`ENm`Uo
o`03G_Moogoo00Qoo`8L5`aoo`04G_MoogooG_LFOol00ekgOomoo`06Ool00`00Oomoo`15Ool003Mo
o`03001oogoo00]oo`=NmaAoo`8X5`9oo`03G_Moogoo00aooa1Nm`ioo`03G_Moogoo00Eoo`<L5`mo
o`9NmaIoo`03G_Moogoo00Moo`03001oogoo04Eoo`00=goo00<007ooOol037oo0Ukg5Woo0RPG00=N
mgooOol057oo00=NmgooOol04goo00=NmgooOol00goo0Q`G4Goo0Ukg5goo00=NmgooOol01goo00<0
07ooOol0AGoo000gOol00`00Oomoo`0<Ool00ekgOomNm`0GOol2:1LEOol00ekgOomoo`0COol015kg
Oomoogoo0R0G4Woo00ANmgooOomNmaEoo`03G_Moogoo00Qoo`03001oogoo04Eoo`00=goo00<007oo
Ool02goo00ENmgooOomooekg01Eoo`03G_Moogoo008X5a=oo`03G_Moogoo01Aoo`<P5a=oo`05G_Mo
ogooOomNm`0DOol00ekgOomoo`09Ool00`00Oomoo`15Ool003Moo`03001oogoo00]oo`03G_Moogoo
009oo`9Nma=oo`03G_Moogoo009oo`<X5a1oo`03G_Moogoo019oo`8P5`03G_Moogoo015oo`9Nm`Ao
o`03G_Moogoo015oo`03G_Moogoo00Yoo`03001oogoo04Eoo`00=goo00<007ooOol02Woo00=Nmgoo
Ool01Goo00=NmgooOol047oo00=NmgooOol01Goo00<X5b@G91L03Goo00=NmgooOol047oo0R0G0Woo
00=NmgooOol047oo00=NmgooOol01Goo00=NmgooOol03goo00=NmgooOol02goo00<007ooOol0AGoo
000gOol00`00Oomoo`0:Ool00ekgOomoo`06Ool2G_L@Ool00ekgOomoo`08Ool291L;Ool00ekgOomo
o`0=Ool381L4Ool00ekgOomoo`0>Ool2G_L8Ool00ekgOomoo`0>Ool00ekgOomoo`0<Ool00`00Oomo
o`15Ool003Moo`8000Yoo`03G_Moogoo00Uoo`9Nm`ioo`03G_Moogoo00Yoo`HT5`Eoo`03G_Moogoo
00Qoo`DP5`Qoo`03G_Moogoo00]oo`9Nm`]oo`03G_Moogoo00aoo`03G_Moogoo00eoo`03001oogoo
04Eoo`00=goo00<007ooOol02Goo00=NmgooOol02goo0Ukg2goo00=NmgooOol04Goo3R@G0R0G3Goo
00=NmgooOol02Goo0Ukg3Goo00=NmgooOol02Woo0Ukg47oo00<007ooOol0AGoo000gOol00ekgOomo
o`08Ool00ekgOomoo`0>Ool3G_L8Ool00ekgOomoo`0FOol00ekgOomoo`0EOol00ekgOomoo`06Ool3
G_L@Ool00ekgOomoo`08Ool00ekgOomoo`0@Ool00`00Oomoo`15Ool003Moo`03001Nmgoo00Qoo`03
G_Moogoo015oo`9Nm`Ioo`03G_Moogoo01Ioo`03G_Moogoo01Eoo`03G_Moogoo00Aoo`9Nma=oo`03
G_Moogoo00Moo`03G_Moogoo015oo`03001oogoo04Eoo`00=goo00<007ooG_L01goo00=NmgooOol0
57oo0ekg0goo00=NmgooOol05Woo00=NmgooOol05Goo00ANmgooOomoo`=NmaIoo`03G_Moogoo00Eo
o`03G_Moogoo019oo`03001oogoo04Eoo`00=goo00@007ooOomNm`Ioo`03G_Moogoo01Moo`=NmaUo
o`03G_Moogoo01Ioo`=NmaUoo`03G_Moogoo00Aoo`03G_Moogoo01=oo`03001oogoo04Eoo`00=goo
00D007ooOomooekg00=oo`05001NmgooOol00003Ool01@00Oomoogoo00000goo00D007ooOomoo`00
00=oo`06001oogooOol007oo0Ukg00D007ooOomoo`0000=oo`05001oogooOol00003Ool01@00Oomo
ogoo00000goo00ENmgooOomoo`00009oo`05001oogooOol00003Ool01@00Oomoogoo00000goo00D0
05kgG_Moo`0000=oo`05001oogooOol00003Ool01@00Oomoogoo00000goo00D007ooOomoo`00009o
o`03G_L007oo009oo`05G_MoogooOol00003Ool01@00Oomoogoo00000goo00P007ooOomoo`00OomN
m`00Agoo000gOol500001Ekg00000000G_L0700000ANm`00G_MNmaH00003G_L0000001<0009Nm`03
001Nm`0001/00005G_L00000001Nm`0F00000ekg001oo`16Ool00?mooa9oo`00ogoo4Woo003oOolB
Ool00?mooa9oo`00ogoo4Woo003oOolBOol00?mooa9oo`00ogoo4Woo003oOolBOol00?mooa9oo`00
ogoo4Woo003oOolBOol00?mooa9oo`00ogoo4Woo003oOolBOol004=oo`03001oogoo01Moo`03001o
ogoo00Uoo`03001oogoo02eoo`03001oogoo00Uoo`03001oogoo03Ioo`03001oogoo031oo`00@Woo
00<007ooOol02goo00<007ooOol02goo00<007ooOol01goo00<007ooOol047oo00<007ooOol03Woo
00<007ooOol02goo00<007ooOol01goo00<007ooOol047oo00<007ooOol05goo00<007ooOol02goo
00<007ooOol0;goo0011Ool00`00Oomoo`02Ool30007Ool00`00Oomoo`05Ool20005Ool00`00Oomo
o`05Ool00`00Oomoo`02Ool3000<Ool00`00Oomoo`04Ool30007Ool00`00Oomoo`04Ool50003Ool0
0`00Oomoo`05Ool00`00Oomoo`02Ool3000<Ool00`00Oomoo`04Ool40004Ool30008Ool00`00Oomo
o`04Ool40004Ool00`00Oomoo`0^Ool0045oo`03001oogoo00Aoo`8000Aoo`D000Aoo`04001oogoo
0004Ool00`00Oomoo`05Ool00`00Oomoo`04Ool20009Ool50006Ool20004Ool50006Ool00`00Oomo
o`03Ool00`00Oomoo`05Ool00`00Oomoo`04Ool20009Ool50004Ool00`00Oomoo`07Ool20005Ool5
0004Ool00`00Oomoo`05Ool00`00Oomoo`0^Ool0045oo`03001oogoo00=oo`03001oogoo00Ioo`03
001oogoo00Moo`03001oogoo009oo`03001oogoo00Eoo`03001oogoo00=oo`03001oogoo00]oo`03
001oogoo00Eoo`03001oogoo00Ioo`03001oogoo00Ioo`03001oogoo00=oo`03001oogoo00Eoo`03
001oogoo00=oo`03001oogoo00]oo`03001oogoo00Eoo`03001oogoo00Eoo`03001oogoo00Moo`03
001oogoo00Eoo`03001oogoo00Aoo`03001oogoo02ioo`00@Goo00<007ooOol00goo0`001Woo00<0
07ooOol01Goo0P001Goo00<007ooOol01Goo00<007ooOol00goo0`000Woo0P001goo00<007ooOol0
1Goo0`001Woo00<007ooOol01Woo00<007ooOol00goo00<007ooOol01Goo00<007ooOol00goo0`00
0Woo0P001goo00<007ooOol01Woo00<007ooOol017oo0`001goo00<007ooOol01Woo00<007ooOol0
0goo00<007ooOol0;Woo0012Ool00`00Oomoo`0COol00`00Oomoo`03Ool00`00Oomoo`07Ool00`00
Oomoo`07Ool00`00Oomoo`0POol00`00Oomoo`02Ool00`00Oomoo`07Ool00`00Oomoo`07Ool00`00
Oomoo`0=Ool01000Oomoo`005Woo00@007ooOol000=oo`03001oogoo02moo`0097oo0P0027oo0P00
4goo00<007ooOol04Woo0`000Woo00<007ooOol02Goo00<007ooOol01goo00<007ooOol07Woo0P00
0goo00<007ooOol02Goo00<007ooOol01goo00<007ooOol03Goo0P0067oo0P000goo00<007ooOol0
<7oo000TOol00`00Oomoo`08Ool00`00Oomoo`10Ool2000jOol2001QOol001aoo`8000Ioo`04001o
ogooOol30004Ool00`00Oomoo`02Ool4003IOol001]oo`04001oogoo0005Ool00`00Oomoo`04Ool0
1@00Oomoogoo00003Goo@00027oo@00027oo40000Woo0P0000=oo`000000;Goo000KOol00`00Ool0
00020004Ool01000Oomoogoo0`0017oo00<007ooOol00Woo1000fGoo000KOol00`00Oomoo`06Ool0
1000Oomoogoo10000goo00<007ooOol0ggoo000KOol00`00Oomoo`06Ool00`00Oomoo`08Ool00`00
Oomoo`0kOol00`00Oomoo`0GOol00`00Oomoo`09Ool00`00Oomoo`0MOol00`00Oomoo`1KOol001ao
o`<000Eoo`8000Qoo`8003aoo`03001oogoo00aoo`03001oogoo00Yoo`03001oogoo00Moo`03001o
ogoo00aoo`03001oogoo011oo`03001oogoo05Yoo`00Jgoo00<007ooOol00Woo0`0027oo00<007oo
Ool01Goo0`000goo00<007ooOol01Goo00<007ooOol00Woo0`0027oo00<007ooOol00goo1@000Woo
0P001Goo00<007ooOol0FGoo001[Ool00`00Oomoo`04Ool20005Ool50006Ool00`00Oomoo`02Ool0
0`00Oomoo`05Ool00`00Oomoo`04Ool20005Ool50005Ool01@00Oomoogoo00000Woo00<007ooOol0
0Woo00<007ooOol0FGoo001[Ool00`00Oomoo`03Ool00`00Oomoo`07Ool00`00Oomoo`03Ool50003
Ool00`00Oomoo`05Ool00`00Oomoo`03Ool00`00Oomoo`07Ool00`00Oomoo`05Ool01@00Oomoogoo
00000Woo00<007ooOol00Woo00<007ooOol0FGoo001[Ool00`00Oomoo`03Ool30007Ool00`00Oomo
o`03Ool01000Oomoo`0017oo00<007ooOol01Goo00<007ooOol00goo0`001goo00<007ooOol01Goo
00D007ooOomoo`00009oo`03001oogoo009oo`03001oogoo05Uoo`00K7oo00<007ooOol04goo00<0
07oo00000goo00<007ooOol01goo00<007ooOol057oo00D007ooOomoo`00009oo`05001oogooOol0
001LOol006eoo`03001oogoo01=oo`80009oo`03001oogoo00Uoo`03001oogoo019oo`8000Aoo`80
00=oo`03001oogoo05]oo`00ogoo4Woo003oOolBOol00?mooa9oo`00ogoo4Woo003oOolBOol00?mo
oa9oo`00ogoo4Woo003oOolBOol00?mooa9oo`00ogoo4Woo003oOolBOol00?mooa9oo`00ogoo4Woo
003oOolBOol00?mooa9oo`00ogoo4Woo003oOolBOol00?mooa9oo`00ogoo4Woo003oOolBOol00?mo
oa9oo`00ogoo4Woo003oOolBOol00?mooa9oo`00ogoo4Woo003oOolBOol00?mooa9oo`00ogoo4Woo
003oOolBOol00?mooa9oo`00ogoo4Woo003oOolBOol00?mooa9oo`00ogoo4Woo003oOolBOol00?mo
oa9oo`00ogoo4Woo003oOolBOol00?mooa9oo`00ogoo4Woo003oOolBOol00?mooa9oo`00ogoo4Woo
003oOolBOol00001\
\>"],
  ImageRangeCache->{{{0, 272.188}, {384.25, 0}} -> {-0.653492, -1.05099, \
0.00547031, 0.00547031}, {{6.4375, 232.438}, {374.875, 9.3125}} -> {-6.02516, \
-7.46955, 0.0506047, 0.0402874}, {{247.375, 265.688}, {283.5, 192.125}} -> \
{-28.4786, -882.252, 0.114912, 8.75631}},
  CellTags->{"Nyquist Plot", "i:10", "b:20.2"}],

Cell[BoxData[
    TagBox[\(\[SkeletonIndicator]  Graphics  \[SkeletonIndicator]\),
      False,
      Editable->False]], "Output",
  CellLabel->"Out[133]=",
  CellTags->{"Nyquist Plot", "i:10", "b:20.2"}]
}, Open  ]],

Cell["\<\
ColorNyquist has several options. PlotRange can be used when the transfer \
function has poles on the imaginary axis in order to obtain a visible plot. \
SensitivityPeak, Bandwidth and Margins place circles on the plot that help \
analyze performanc and stability margins.\
\>", "Text",
  CellTags->{"Nyquist Plot", "i:10", "b:20.2"}],

Cell[CellGroupData[{

Cell[BoxData[{
    \(G5[s_] :=  .2\ \((s + 1)\)\ \(\(\((s^2 + Sqrt[9]\  + 9)\)/\((\ 
            s \((s^2\  + \ 2\ s\  + \ 2)\) \((s^2 + 2  s + 
                  4)\))\)\)\(\ \)\)\), "\n", 
    \(ColorNyquist[G5, s, \(-3\), 3,  .02, 
      PlotRange \[Rule] {{\(-1.25\),  .25}, {\(-1.5\), 1.5}}, 
      SensitivityPeak -> 1.5, Bandwidth -> True, Margins -> True]\)}], "Input",\

  CellLabel->"In[134]:=",
  CellTags->{"Nyquist Plot", "i:10", "b:20.2"}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: 1.4104 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.438894 0.671621 0.705202 0.671621 [
[ 0 0 0 0 ]
[ 1 1.4104 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
% Start of sub-graphic
p
0.0238095 0.033581 0.853978 1.37682 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.833333 0.666667 0.809017 0.539345 [
[.03333 -0.0125 -12 -9 ]
[.03333 -0.0125 12 0 ]
[.16667 -0.0125 -6 -9 ]
[.16667 -0.0125 6 0 ]
[.3 -0.0125 -12 -9 ]
[.3 -0.0125 12 0 ]
[.43333 -0.0125 -12 -9 ]
[.43333 -0.0125 12 0 ]
[.56667 -0.0125 -12 -9 ]
[.56667 -0.0125 12 0 ]
[.7 -0.0125 -12 -9 ]
[.7 -0.0125 12 0 ]
[.83333 -0.0125 -3 -9 ]
[.83333 -0.0125 3 0 ]
[.96667 -0.0125 -9 -9 ]
[.96667 -0.0125 9 0 ]
[ 0 0 -0.125 0 ]
[.5 -0.0125 -17.3125 -22.1875 ]
[.5 -0.0125 17.3125 -9 ]
[-0.0125 .26967 -12 -4.5 ]
[-0.0125 .26967 0 4.5 ]
[-0.0125 .53934 -24 -4.5 ]
[-0.0125 .53934 0 4.5 ]
[-0.0125 .80902 -6 -4.5 ]
[-0.0125 .80902 0 4.5 ]
[-0.0125 1.07869 -18 -4.5 ]
[-0.0125 1.07869 0 4.5 ]
[-0.0125 1.34836 -6 -4.5 ]
[-0.0125 1.34836 0 4.5 ]
[-0.0125 1.61803 -18 -4.5 ]
[-0.0125 1.61803 0 4.5 ]
[ 0 0 -0.125 0 ]
[-0.01875 .80902 -58.625 -6.59375 ]
[-0.01875 .80902 -24 6.59375 ]
[ 0 1.61803 .125 0 ]
[.5 1.63053 -5.0625 0 ]
[.5 1.63053 5.0625 13.1875 ]
[ 1 0 .125 0 ]
[1.0125 .80902 0 -6.59375 ]
[1.0125 .80902 10.125 6.59375 ]
[.5 1.63053 -93.375 13.1875 ]
[.5 1.63053 93.375 37.3125 ]
[ 0 0 0 0 ]
[ 1 1.61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.03333 0 m
.03333 .00625 L
s
[(-1.2)] .03333 -0.0125 0 1 Mshowa
.16667 0 m
.16667 .00625 L
s
[(-1)] .16667 -0.0125 0 1 Mshowa
.3 0 m
.3 .00625 L
s
[(-0.8)] .3 -0.0125 0 1 Mshowa
.43333 0 m
.43333 .00625 L
s
[(-0.6)] .43333 -0.0125 0 1 Mshowa
.56667 0 m
.56667 .00625 L
s
[(-0.4)] .56667 -0.0125 0 1 Mshowa
.7 0 m
.7 .00625 L
s
[(-0.2)] .7 -0.0125 0 1 Mshowa
.83333 0 m
.83333 .00625 L
s
[(0)] .83333 -0.0125 0 1 Mshowa
.96667 0 m
.96667 .00625 L
s
[(0.2)] .96667 -0.0125 0 1 Mshowa
.125 Mabswid
.06667 0 m
.06667 .00375 L
s
.1 0 m
.1 .00375 L
s
.13333 0 m
.13333 .00375 L
s
.2 0 m
.2 .00375 L
s
.23333 0 m
.23333 .00375 L
s
.26667 0 m
.26667 .00375 L
s
.33333 0 m
.33333 .00375 L
s
.36667 0 m
.36667 .00375 L
s
.4 0 m
.4 .00375 L
s
.46667 0 m
.46667 .00375 L
s
.5 0 m
.5 .00375 L
s
.53333 0 m
.53333 .00375 L
s
.6 0 m
.6 .00375 L
s
.63333 0 m
.63333 .00375 L
s
.66667 0 m
.66667 .00375 L
s
.73333 0 m
.73333 .00375 L
s
.76667 0 m
.76667 .00375 L
s
.8 0 m
.8 .00375 L
s
.86667 0 m
.86667 .00375 L
s
.9 0 m
.9 .00375 L
s
.93333 0 m
.93333 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
gsave
.5 -0.0125 -78.3125 -26.1875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 21.1875 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(Re) show
%%IncludeResource: font Mathematica2Mono
%%IncludeFont: Mathematica2Mono
/Mathematica2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
75.250 13.313 moveto
(@) show
81.375 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
%%IncludeResource: font Mathematica2Mono
%%IncludeFont: Mathematica2Mono
/Mathematica2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
87.500 13.313 moveto
(D) show
93.625 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 .26967 m
.00625 .26967 L
s
[(-1)] -0.0125 .26967 1 0 Mshowa
0 .53934 m
.00625 .53934 L
s
[(-0.5)] -0.0125 .53934 1 0 Mshowa
0 .80902 m
.00625 .80902 L
s
[(0)] -0.0125 .80902 1 0 Mshowa
0 1.07869 m
.00625 1.07869 L
s
[(0.5)] -0.0125 1.07869 1 0 Mshowa
0 1.34836 m
.00625 1.34836 L
s
[(1)] -0.0125 1.34836 1 0 Mshowa
0 1.61803 m
.00625 1.61803 L
s
[(1.5)] -0.0125 1.61803 1 0 Mshowa
.125 Mabswid
0 .05393 m
.00375 .05393 L
s
0 .10787 m
.00375 .10787 L
s
0 .1618 m
.00375 .1618 L
s
0 .21574 m
.00375 .21574 L
s
0 .32361 m
.00375 .32361 L
s
0 .37754 m
.00375 .37754 L
s
0 .43148 m
.00375 .43148 L
s
0 .48541 m
.00375 .48541 L
s
0 .59328 m
.00375 .59328 L
s
0 .64721 m
.00375 .64721 L
s
0 .70115 m
.00375 .70115 L
s
0 .75508 m
.00375 .75508 L
s
0 .86295 m
.00375 .86295 L
s
0 .91689 m
.00375 .91689 L
s
0 .97082 m
.00375 .97082 L
s
0 1.02475 m
.00375 1.02475 L
s
0 1.13262 m
.00375 1.13262 L
s
0 1.18656 m
.00375 1.18656 L
s
0 1.24049 m
.00375 1.24049 L
s
0 1.29443 m
.00375 1.29443 L
s
0 1.4023 m
.00375 1.4023 L
s
0 1.45623 m
.00375 1.45623 L
s
0 1.51017 m
.00375 1.51017 L
s
0 1.5641 m
.00375 1.5641 L
s
.25 Mabswid
0 0 m
0 1.61803 L
s
gsave
-0.01875 .80902 -119.625 -10.5938 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 21.1875 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(Im) show
%%IncludeResource: font Mathematica2Mono
%%IncludeFont: Mathematica2Mono
/Mathematica2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
75.250 13.313 moveto
(@) show
81.375 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(g) show
%%IncludeResource: font Mathematica2Mono
%%IncludeFont: Mathematica2Mono
/Mathematica2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
87.500 13.313 moveto
(D) show
93.625 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.03333 1.61178 m
.03333 1.61803 L
s
.16667 1.61178 m
.16667 1.61803 L
s
.3 1.61178 m
.3 1.61803 L
s
.43333 1.61178 m
.43333 1.61803 L
s
.56667 1.61178 m
.56667 1.61803 L
s
.7 1.61178 m
.7 1.61803 L
s
.83333 1.61178 m
.83333 1.61803 L
s
.96667 1.61178 m
.96667 1.61803 L
s
.125 Mabswid
.06667 1.61428 m
.06667 1.61803 L
s
.1 1.61428 m
.1 1.61803 L
s
.13333 1.61428 m
.13333 1.61803 L
s
.2 1.61428 m
.2 1.61803 L
s
.23333 1.61428 m
.23333 1.61803 L
s
.26667 1.61428 m
.26667 1.61803 L
s
.33333 1.61428 m
.33333 1.61803 L
s
.36667 1.61428 m
.36667 1.61803 L
s
.4 1.61428 m
.4 1.61803 L
s
.46667 1.61428 m
.46667 1.61803 L
s
.5 1.61428 m
.5 1.61803 L
s
.53333 1.61428 m
.53333 1.61803 L
s
.6 1.61428 m
.6 1.61803 L
s
.63333 1.61428 m
.63333 1.61803 L
s
.66667 1.61428 m
.66667 1.61803 L
s
.73333 1.61428 m
.73333 1.61803 L
s
.76667 1.61428 m
.76667 1.61803 L
s
.8 1.61428 m
.8 1.61803 L
s
.86667 1.61428 m
.86667 1.61803 L
s
.9 1.61428 m
.9 1.61803 L
s
.93333 1.61428 m
.93333 1.61803 L
s
.25 Mabswid
0 1.61803 m
1 1.61803 L
s
gsave
.5 1.63053 -66.0625 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 21.1875 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.125 13.313 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.99375 0 m
1 0 L
s
.99375 .26967 m
1 .26967 L
s
.99375 .53934 m
1 .53934 L
s
.99375 .80902 m
1 .80902 L
s
.99375 1.07869 m
1 1.07869 L
s
.99375 1.34836 m
1 1.34836 L
s
.125 Mabswid
.99625 .05393 m
1 .05393 L
s
.99625 .10787 m
1 .10787 L
s
.99625 .1618 m
1 .1618 L
s
.99625 .21574 m
1 .21574 L
s
.99625 .32361 m
1 .32361 L
s
.99625 .37754 m
1 .37754 L
s
.99625 .43148 m
1 .43148 L
s
.99625 .48541 m
1 .48541 L
s
.99625 .59328 m
1 .59328 L
s
.99625 .64721 m
1 .64721 L
s
.99625 .70115 m
1 .70115 L
s
.99625 .75508 m
1 .75508 L
s
.99625 .86295 m
1 .86295 L
s
.99625 .91689 m
1 .91689 L
s
.99625 .97082 m
1 .97082 L
s
.99625 1.02475 m
1 1.02475 L
s
.99625 1.13262 m
1 1.13262 L
s
.99625 1.18656 m
1 1.18656 L
s
.99625 1.24049 m
1 1.24049 L
s
.99625 1.29443 m
1 1.29443 L
s
.99625 1.4023 m
1 1.4023 L
s
.99625 1.45623 m
1 1.45623 L
s
.99625 1.51017 m
1 1.51017 L
s
.99625 1.5641 m
1 1.5641 L
s
.25 Mabswid
1 0 m
1 1.61803 L
s
gsave
1.0125 .80902 -61 -10.5938 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 21.1875 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.125 13.313 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.5 1.63053 -154.375 9.1875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 32.125 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding WindowsANSIEncoding def
        currentdict
    end

    newfontname exch definefont pop
} def

63.000 19.063 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
%%BeginResource: font Courier-MISO
%%BeginFont: Courier-MISO
/Courier /Courier-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-MISO
%%IncludeFont: Courier-MISO
/Courier-MISO findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 19.063 moveto
%%IncludeResource: font Courier-MISO
%%IncludeFont: Courier-MISO
/Courier-MISO findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(G) show
%%IncludeResource: font Mathematica2Mono
%%IncludeFont: Mathematica2Mono
/Mathematica2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
69.125 19.063 moveto
(@) show
75.250 19.063 moveto
%%IncludeResource: font Courier-MISO
%%IncludeFont: Courier-MISO
/Courier-MISO findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(s) show
%%IncludeResource: font Mathematica2Mono
%%IncludeFont: Mathematica2Mono
/Mathematica2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
81.375 19.063 moveto
(D) show
87.500 19.063 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(=) show
93.625 19.063 moveto
%%IncludeResource: font Courier-MISO
%%IncludeFont: Courier-MISO
/Courier-MISO findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
118.250 13.125 moveto
%%IncludeResource: font Courier-MISO
%%IncludeFont: Courier-MISO
/Courier-MISO findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(0.2) show
%%IncludeResource: font Mathematica2Mono
%%IncludeFont: Mathematica2Mono
/Mathematica2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
139.125 13.125 moveto
(H) show
145.250 13.125 moveto
%%IncludeResource: font Courier-Italic
%%IncludeFont: Courier-Italic
%%BeginResource: font Courier-Italic-MISO
%%BeginFont: Courier-Italic-MISO
/Courier-Italic /Courier-Italic-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Italic-MISO
%%IncludeFont: Courier-Italic-MISO
/Courier-Italic-MISO findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(s) show
153.813 13.125 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(+) show
162.375 13.125 moveto
%%IncludeResource: font Courier-MISO
%%IncludeFont: Courier-MISO
/Courier-MISO findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(1) show
%%IncludeResource: font Mathematica2Mono
%%IncludeFont: Mathematica2Mono
/Mathematica2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
168.500 13.125 moveto
(L) show
177.125 13.125 moveto
(H) show
183.250 13.125 moveto
%%IncludeResource: font Courier-Italic-MISO
%%IncludeFont: Courier-Italic-MISO
/Courier-Italic-MISO findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(s) show
189.375 9.688 moveto
%%IncludeResource: font Courier-MISO
%%IncludeFont: Courier-MISO
/Courier-MISO findfont 7.125 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
196.625 13.125 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(+) show
205.188 13.125 moveto
%%IncludeResource: font Courier-MISO
%%IncludeFont: Courier-MISO
/Courier-MISO findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(12) show
%%IncludeResource: font Mathematica2Mono
%%IncludeFont: Mathematica2Mono
/Mathematica2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
217.438 13.125 moveto
(L) show
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
97.938 19.063 moveto
(\\200\\200\\200\\200\\200\\200\\200\\200\\200\\200\\200\\200\\200\\200\\200\\\
200\\200\\200\\200\\200\\200\\200\\200\\200\\200\\200\\200\\200\\200\\200\\\
200\\200) show
169.938 19.063 moveto
(\\200\\200\\200\\200\\200\\200\\200\\200\\200\\200\\200\\200\\200\\200\\200\\\
200) show
205.938 19.063 moveto
(\\200\\200\\200\\200\\200\\200\\200\\200) show
223.938 19.063 moveto
(\\200\\200\\200\\200) show
232.938 19.063 moveto
(\\200\\200) show
237.438 19.063 moveto
(\\200\\200) show
241.438 19.063 moveto
(\\200) show
99.313 25.313 moveto
%%IncludeResource: font Courier-Italic-MISO
%%IncludeFont: Courier-Italic-MISO
/Courier-Italic-MISO findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(s) show
%%IncludeResource: font Mathematica2Mono
%%IncludeFont: Mathematica2Mono
/Mathematica2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
107.938 25.313 moveto
(H) show
114.063 25.313 moveto
%%IncludeResource: font Courier-Italic-MISO
%%IncludeFont: Courier-Italic-MISO
/Courier-Italic-MISO findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(s) show
120.188 22.750 moveto
%%IncludeResource: font Courier-MISO
%%IncludeFont: Courier-MISO
/Courier-MISO findfont 7.125 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
127.438 25.313 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(+) show
136.000 25.313 moveto
%%IncludeResource: font Courier-MISO
%%IncludeFont: Courier-MISO
/Courier-MISO findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
144.625 25.313 moveto
%%IncludeResource: font Courier-Italic-MISO
%%IncludeFont: Courier-Italic-MISO
/Courier-Italic-MISO findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(s) show
153.188 25.313 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(+) show
161.750 25.313 moveto
%%IncludeResource: font Courier-MISO
%%IncludeFont: Courier-MISO
/Courier-MISO findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
%%IncludeResource: font Mathematica2Mono
%%IncludeFont: Mathematica2Mono
/Mathematica2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
167.875 25.313 moveto
(L) show
176.500 25.313 moveto
(H) show
182.625 25.313 moveto
%%IncludeResource: font Courier-Italic-MISO
%%IncludeFont: Courier-Italic-MISO
/Courier-Italic-MISO findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(s) show
188.750 22.750 moveto
%%IncludeResource: font Courier-MISO
%%IncludeFont: Courier-MISO
/Courier-MISO findfont 7.125 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
196.000 25.313 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(+) show
204.563 25.313 moveto
%%IncludeResource: font Courier-MISO
%%IncludeFont: Courier-MISO
/Courier-MISO findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
213.188 25.313 moveto
%%IncludeResource: font Courier-Italic-MISO
%%IncludeFont: Courier-Italic-MISO
/Courier-Italic-MISO findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(s) show
221.750 25.313 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(+) show
230.313 25.313 moveto
%%IncludeResource: font Courier-MISO
%%IncludeFont: Courier-MISO
/Courier-MISO findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
%%IncludeResource: font Mathematica2Mono
%%IncludeFont: Mathematica2Mono
/Mathematica2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
236.438 25.313 moveto
(L) show
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 1.61803 L
0 1.61803 L
closepath
clip
newpath
.75 g
.5 Mabswid
.83333 .80902 m
0 0 rlineto s
.83333 .80902 m
1 .84515 L
s
.83333 .80902 m
0 0 rlineto s
.83333 .80902 m
1 .88686 L
s
.83333 .80902 m
0 0 rlineto s
.83333 .80902 m
1 .94385 L
s
.83333 .80902 m
0 0 rlineto s
.83333 .80902 m
1 1.04256 L
s
.83333 .80902 m
0 0 rlineto s
.83333 .80902 m
1 1.31223 L
s
.83333 .80902 m
0 0 rlineto s
.83333 .80902 m
.83333 1.61803 L
s
.83333 .80902 m
0 0 rlineto s
.83333 .80902 m
.56538 1.61803 L
s
.83333 .80902 m
0 0 rlineto s
.83333 .80902 m
.25598 1.61803 L
s
.83333 .80902 m
0 0 rlineto s
.83333 .80902 m
0 1.4832 L
s
.83333 .80902 m
0 0 rlineto s
.83333 .80902 m
0 1.19826 L
s
.83333 .80902 m
0 0 rlineto s
.83333 .80902 m
0 .98966 L
s
.83333 .80902 m
0 0 rlineto s
.83333 .80902 m
0 .80902 L
s
.83333 .80902 m
0 0 rlineto s
.83333 .80902 m
0 .62837 L
s
.83333 .80902 m
0 0 rlineto s
.83333 .80902 m
0 .41978 L
s
.83333 .80902 m
0 0 rlineto s
.83333 .80902 m
0 .13484 L
s
.83333 .80902 m
0 0 rlineto s
.83333 .80902 m
.25598 0 L
s
.83333 .80902 m
0 0 rlineto s
.83333 .80902 m
.56538 0 L
s
.83333 .80902 m
0 0 rlineto s
.83333 .80902 m
.83333 0 L
s
.83333 .80902 m
0 0 rlineto s
.83333 .80902 m
1 .3058 L
s
.83333 .80902 m
0 0 rlineto s
.83333 .80902 m
1 .57547 L
s
.83333 .80902 m
0 0 rlineto s
.83333 .80902 m
1 .67418 L
s
.83333 .80902 m
0 0 rlineto s
.83333 .80902 m
1 .73117 L
s
.83333 .80902 m
0 0 rlineto s
.83333 .80902 m
1 .77289 L
s
.83333 .80902 m
0 0 rlineto s
.83333 .80902 m
1 .80902 L
s
.96667 .80902 m
.96562 .82254 L
.96248 .83584 L
.9573 .84873 L
.95017 .86098 L
.9412 .87242 L
.93053 .88286 L
.91832 .89213 L
.90478 .90009 L
.8901 .90662 L
.87454 .91161 L
.85832 .91498 L
.84171 .91667 L
.82496 .91667 L
.80835 .91498 L
.79213 .91161 L
.77656 .90662 L
.76189 .90009 L
.74834 .89213 L
.73614 .88286 L
.72546 .87242 L
.71649 .86098 L
.70936 .84873 L
.70419 .83584 L
.70105 .82254 L
.7 .80902 L
.70105 .7955 L
.70419 .78219 L
.70936 .76931 L
.71649 .75705 L
.72546 .74561 L
.73614 .73518 L
.74834 .7259 L
.76189 .71794 L
.77656 .71141 L
.79213 .70643 L
.80835 .70306 L
.82496 .70136 L
.84171 .70136 L
.85832 .70306 L
.87454 .70643 L
.8901 .71141 L
.90478 .71794 L
.91832 .7259 L
.93053 .73518 L
.9412 .74561 L
.95017 .75705 L
.9573 .76931 L
.96248 .78219 L
.96562 .7955 L
Mistroke
.96667 .80902 L
Mfstroke
1 .97719 m
.97622 .99117 L
.94687 1.00422 L
.91574 1.0142 L
.8833 1.02093 L
.85008 1.02433 L
.81659 1.02433 L
.78336 1.02093 L
.75093 1.0142 L
.71979 1.00422 L
.69045 .99117 L
.66335 .97525 L
.63894 .9567 L
.6176 .93582 L
.59965 .91295 L
.58539 .88844 L
.57504 .86267 L
.56877 .83606 L
.56667 .80902 L
.56877 .78198 L
.57504 .75537 L
.58539 .7296 L
.59965 .70508 L
.6176 .68221 L
.63894 .66133 L
.66335 .64279 L
.69045 .62686 L
.71979 .61381 L
.75093 .60384 L
.78336 .5971 L
.81659 .5937 L
.85008 .5937 L
.8833 .5971 L
.91574 .60384 L
.94687 .61381 L
.97622 .62686 L
s
.97622 .62686 m
1 .64084 L
s
1 1.10299 m
.95694 1.11679 L
.90829 1.12689 L
.85845 1.13199 L
.80822 1.13199 L
.75838 1.12689 L
.70973 1.11679 L
.66302 1.10183 L
.619 1.08225 L
.57836 1.05836 L
.54175 1.03054 L
.50973 .99923 L
.48281 .96492 L
.46142 .92814 L
.4459 .88949 L
.43649 .84958 L
.43333 .80902 L
.43649 .76846 L
.4459 .72854 L
.46142 .68989 L
.48281 .65312 L
.50973 .61881 L
.54175 .58749 L
.57836 .55967 L
.619 .53579 L
.66302 .51621 L
.70973 .50125 L
.75838 .49114 L
.80822 .48605 L
.85845 .48605 L
.90829 .49114 L
.95694 .50125 L
s
.95694 .50125 m
1 .51504 L
s
1 1.21878 m
.99814 1.21937 L
.93327 1.23285 L
.86682 1.23964 L
.79985 1.23964 L
.7334 1.23285 L
.66852 1.21937 L
.60625 1.19943 L
.54756 1.17332 L
.49337 1.14147 L
.44455 1.10438 L
.40186 1.06263 L
.36597 1.01688 L
.33745 .96785 L
.31676 .91632 L
.30421 .8631 L
.3 .80902 L
.30421 .75494 L
.31676 .70171 L
.33745 .65018 L
.36597 .60115 L
.40186 .5554 L
.44455 .51365 L
.49337 .47656 L
.54756 .44471 L
.60625 .41861 L
.66852 .39866 L
.7334 .38518 L
.79985 .37839 L
.86682 .37839 L
.93327 .38518 L
.99814 .39866 L
s
.99814 .39866 m
1 .39925 L
s
1 1.33014 m
.95825 1.33881 L
.87519 1.3473 L
.79147 1.3473 L
.70841 1.33881 L
.62732 1.32196 L
.54948 1.29703 L
.47612 1.2644 L
.40838 1.22459 L
.34735 1.17822 L
.29399 1.12604 L
.24913 1.06885 L
.21348 1.00756 L
.18761 .94315 L
.17192 .87661 L
.16667 .80902 L
.17192 .74142 L
.18761 .67489 L
.21348 .61047 L
.24913 .54919 L
.29399 .492 L
.34735 .43981 L
.40838 .39344 L
.47612 .35363 L
.54948 .321 L
.62732 .29607 L
.70841 .27923 L
.79147 .27074 L
.87519 .27074 L
.95825 .27923 L
s
.95825 .27923 m
1 .2879 L
s
1 1.44128 m
.98324 1.44477 L
.88357 1.45495 L
.7831 1.45495 L
.68343 1.44477 L
.58612 1.42455 L
.49271 1.39463 L
.40467 1.35548 L
.32339 1.3077 L
.25016 1.25207 L
.18612 1.18944 L
.13229 1.12081 L
.08951 1.04727 L
.05847 .96997 L
.03964 .89013 L
.03333 .80902 L
.03964 .7279 L
.05847 .64806 L
.08951 .57076 L
.13229 .49722 L
.18612 .42859 L
.25016 .36597 L
.32339 .31033 L
.40467 .26256 L
.49271 .2234 L
.58612 .19348 L
.68343 .17327 L
.7831 .16308 L
.88357 .16308 L
.98324 .17327 L
s
.98324 .17327 m
1 .17675 L
s
1 1.55157 m
.89194 1.56261 L
.77473 1.56261 L
.65844 1.55072 L
.54492 1.52714 L
.43594 1.49224 L
.33323 1.44655 L
.2384 1.39082 L
.15296 1.32591 L
.07825 1.25284 L
.01545 1.17278 L
s
.01545 1.17278 m
0 1.14622 L
s
0 .47181 m
.01545 .44525 L
.07825 .36519 L
.15296 .29213 L
.2384 .22722 L
.33323 .17148 L
.43594 .1258 L
.54492 .09089 L
.65844 .06731 L
.77473 .05542 L
.89194 .05542 L
s
.89194 .05542 m
1 .06647 L
s
.46719 1.61803 m
.37917 1.58984 L
.26178 1.53763 L
.15341 1.47393 L
.05577 1.39975 L
s
.05577 1.39975 m
0 1.34521 L
s
0 .27282 m
.05577 .21829 L
.15341 .1441 L
.26178 .0804 L
.37917 .0282 L
s
.37917 .0282 m
.46719 0 L
s
.17218 1.61803 m
.06842 1.55705 L
s
.06842 1.55705 m
0 1.50506 L
s
0 .11297 m
.06842 .06099 L
s
.06842 .06099 m
.17218 0 L
s
.75 0 0 r
.008 w
.83511 .8045 m
.83516 .80418 L
s
.75 0 .01 r
.83516 .80418 m
.8352 .80383 L
s
.75 0 .019 r
.8352 .80383 m
.83524 .80348 L
s
.75 0 .029 r
.83524 .80348 m
.83527 .8031 L
s
.75 0 .039 r
.83527 .8031 m
.8353 .80271 L
s
.75 0 .049 r
.8353 .80271 m
.83531 .8023 L
s
.75 0 .059 r
.83531 .8023 m
.83531 .80188 L
s
.75 0 .068 r
.83531 .80188 m
.8353 .80143 L
s
.75 0 .078 r
.8353 .80143 m
.83528 .80097 L
s
.75 0 .088 r
.83528 .80097 m
.83525 .80048 L
s
.75 0 .098 r
.83525 .80048 m
.8352 .79998 L
s
.75 0 .107 r
.8352 .79998 m
.83513 .79945 L
s
.75 0 .117 r
.83513 .79945 m
.83505 .79891 L
s
.75 0 .127 r
.83505 .79891 m
.83494 .79834 L
s
.75 0 .137 r
.83494 .79834 m
.83482 .79775 L
s
.75 0 .146 r
.83482 .79775 m
.83467 .79713 L
s
.75 0 .156 r
.83467 .79713 m
.83449 .79649 L
s
.75 0 .166 r
.83449 .79649 m
.83429 .79583 L
s
.75 0 .176 r
.83429 .79583 m
.83406 .79514 L
s
.75 0 .185 r
.83406 .79514 m
.83379 .79443 L
s
.75 0 .195 r
.83379 .79443 m
.8335 .79369 L
s
.75 0 .205 r
.8335 .79369 m
.83316 .79293 L
s
.75 0 .214 r
.83316 .79293 m
.83278 .79214 L
s
.75 0 .224 r
.83278 .79214 m
.83236 .79133 L
s
.75 0 .234 r
.83236 .79133 m
.83189 .79049 L
s
.75 0 .244 r
.83189 .79049 m
.83137 .78962 L
s
.75 0 .254 r
.83137 .78962 m
.8308 .78873 L
s
.75 0 .263 r
.8308 .78873 m
.83017 .78782 L
s
.75 0 .273 r
.83017 .78782 m
.82948 .78688 L
s
.75 0 .283 r
.82948 .78688 m
.82872 .78592 L
s
.75 0 .292 r
.82872 .78592 m
.8279 .78494 L
s
.75 0 .302 r
.8279 .78494 m
.827 .78394 L
s
.75 0 .312 r
.827 .78394 m
.82603 .78292 L
s
.75 0 .322 r
.82603 .78292 m
.82497 .78189 L
s
.75 0 .332 r
.82497 .78189 m
.82383 .78084 L
s
.75 0 .341 r
.82383 .78084 m
.82259 .77977 L
s
.75 0 .351 r
.82259 .77977 m
.82126 .7787 L
s
.75 0 .361 r
.82126 .7787 m
.81983 .77762 L
s
.75 0 .37 r
.81983 .77762 m
.8183 .77654 L
s
.75 0 .38 r
.8183 .77654 m
.81665 .77546 L
s
.75 0 .39 r
.81665 .77546 m
.8149 .77439 L
s
.75 0 .4 r
.8149 .77439 m
.81302 .77333 L
s
.75 0 .409 r
.81302 .77333 m
.81102 .77228 L
s
.75 0 .419 r
.81102 .77228 m
.8089 .77125 L
s
.75 0 .429 r
.8089 .77125 m
.80665 .77025 L
s
.75 0 .439 r
.80665 .77025 m
.80426 .76928 L
s
.75 0 .448 r
.80426 .76928 m
.80174 .76835 L
s
.75 0 .458 r
.80174 .76835 m
.79908 .76747 L
s
.75 0 .468 r
.79908 .76747 m
.79628 .76664 L
s
.75 0 .478 r
.79628 .76664 m
.79333 .76587 L
s
.75 0 .488 r
.79333 .76587 m
.79025 .76517 L
s
.75 0 .497 r
.79025 .76517 m
.78702 .76455 L
s
.75 0 .507 r
.78702 .76455 m
.78365 .76402 L
s
.75 0 .517 r
.78365 .76402 m
.78014 .76359 L
s
.75 0 .527 r
.78014 .76359 m
.77649 .76326 L
s
.75 0 .536 r
.77649 .76326 m
.77271 .76304 L
s
.75 0 .546 r
.77271 .76304 m
.7688 .76295 L
s
.75 0 .556 r
.7688 .76295 m
.76475 .76299 L
s
.75 0 .565 r
.76475 .76299 m
.76059 .76318 L
s
.75 0 .575 r
.76059 .76318 m
.75631 .76351 L
s
.75 0 .585 r
.75631 .76351 m
.75192 .76401 L
s
.75 0 .595 r
.75192 .76401 m
.74744 .76467 L
s
.75 0 .605 r
.74744 .76467 m
.74287 .76552 L
s
.75 0 .614 r
.74287 .76552 m
.73821 .76654 L
s
.75 0 .624 r
.73821 .76654 m
.73349 .76776 L
s
.75 0 .634 r
.73349 .76776 m
.72871 .76919 L
s
.75 0 .644 r
.72871 .76919 m
.72389 .77081 L
s
.75 0 .653 r
.72389 .77081 m
.71904 .77265 L
s
.75 0 .663 r
.71904 .77265 m
.71417 .77471 L
s
.75 0 .673 r
.71417 .77471 m
.7093 .77698 L
s
.75 0 .683 r
.7093 .77698 m
.70444 .77949 L
s
.75 0 .692 r
.70444 .77949 m
.6996 .78221 L
s
.75 0 .702 r
.6996 .78221 m
.69481 .78517 L
s
.75 0 .712 r
.69481 .78517 m
.69008 .78836 L
s
.75 0 .721 r
.69008 .78836 m
.68543 .79178 L
s
.75 0 .731 r
.68543 .79178 m
.68086 .79543 L
s
.75 0 .741 r
.68086 .79543 m
.6764 .7993 L
s
.749 0 .75 r
.6764 .7993 m
.67206 .8034 L
s
.739 0 .75 r
.67206 .8034 m
.66786 .80773 L
s
.73 0 .75 r
.66786 .80773 m
.6638 .81227 L
s
.72 0 .75 r
.6638 .81227 m
.65992 .81702 L
s
.71 0 .75 r
.65992 .81702 m
.65621 .82198 L
s
.701 0 .75 r
.65621 .82198 m
.6527 .82713 L
s
.691 0 .75 r
.6527 .82713 m
.64939 .83249 L
s
.681 0 .75 r
.64939 .83249 m
.64629 .83802 L
s
.671 0 .75 r
.64629 .83802 m
.64343 .84373 L
s
.661 0 .75 r
.64343 .84373 m
.6408 .84961 L
s
.652 0 .75 r
.6408 .84961 m
.63841 .85565 L
s
.642 0 .75 r
.63841 .85565 m
.63628 .86183 L
s
.632 0 .75 r
.63628 .86183 m
.6344 .86815 L
s
.623 0 .75 r
.6344 .86815 m
.63279 .8746 L
s
.613 0 .75 r
.63279 .8746 m
.63145 .88117 L
s
.603 0 .75 r
.63145 .88117 m
.63037 .88785 L
s
.593 0 .75 r
.63037 .88785 m
.62956 .89462 L
s
.584 0 .75 r
.62956 .89462 m
.62903 .90148 L
s
.574 0 .75 r
.62903 .90148 m
.62875 .90842 L
s
.564 0 .75 r
.62875 .90842 m
.62875 .91543 L
s
.554 0 .75 r
.62875 .91543 m
.629 .9225 L
s
.545 0 .75 r
.629 .9225 m
.6295 .92962 L
s
.535 0 .75 r
.6295 .92962 m
.63026 .9368 L
s
.525 0 .75 r
.63026 .9368 m
.63125 .94402 L
s
.515 0 .75 r
.63125 .94402 m
.63246 .95128 L
s
.506 0 .75 r
.63246 .95128 m
.6339 .95858 L
s
.496 0 .75 r
.6339 .95858 m
.63555 .96592 L
s
.486 0 .75 r
.63555 .96592 m
.63739 .9733 L
s
.476 0 .75 r
.63739 .9733 m
.63941 .98072 L
s
.466 0 .75 r
.63941 .98072 m
.6416 .98819 L
s
.457 0 .75 r
.6416 .98819 m
.64394 .99571 L
s
.447 0 .75 r
.64394 .99571 m
.64643 1.00329 L
s
.437 0 .75 r
.64643 1.00329 m
.64905 1.01095 L
s
.427 0 .75 r
.64905 1.01095 m
.65177 1.0187 L
s
.418 0 .75 r
.65177 1.0187 m
.6546 1.02655 L
s
.408 0 .75 r
.6546 1.02655 m
.65751 1.03453 L
s
.398 0 .75 r
.65751 1.03453 m
.66049 1.04266 L
s
.388 0 .75 r
.66049 1.04266 m
.66352 1.05097 L
s
.379 0 .75 r
.66352 1.05097 m
.66659 1.05948 L
s
.369 0 .75 r
.66659 1.05948 m
.6697 1.06824 L
s
.359 0 .75 r
.6697 1.06824 m
.67281 1.07729 L
s
.349 0 .75 r
.67281 1.07729 m
.67594 1.08666 L
s
.34 0 .75 r
.67594 1.08666 m
.67905 1.09642 L
s
.33 0 .75 r
.67905 1.09642 m
.68214 1.10662 L
s
.32 0 .75 r
.68214 1.10662 m
.68521 1.11733 L
s
.31 0 .75 r
.68521 1.11733 m
.68823 1.12863 L
s
.301 0 .75 r
.68823 1.12863 m
.6912 1.14061 L
s
.291 0 .75 r
.6912 1.14061 m
.69412 1.15337 L
s
.281 0 .75 r
.69412 1.15337 m
.69697 1.16704 L
s
.272 0 .75 r
.69697 1.16704 m
.69974 1.18175 L
s
.262 0 .75 r
.69974 1.18175 m
.70244 1.19767 L
s
.252 0 .75 r
.70244 1.19767 m
.70505 1.215 L
s
.242 0 .75 r
.70505 1.215 m
.70756 1.23397 L
s
.232 0 .75 r
.70756 1.23397 m
.70998 1.25486 L
s
.223 0 .75 r
.70998 1.25486 m
.7123 1.27802 L
s
.213 0 .75 r
.7123 1.27802 m
.71451 1.30386 L
s
.203 0 .75 r
.71451 1.30386 m
.7166 1.33293 L
s
.194 0 .75 r
.7166 1.33293 m
.71859 1.36588 L
s
.184 0 .75 r
.71859 1.36588 m
.72046 1.40357 L
s
.174 0 .75 r
.72046 1.40357 m
.72221 1.44711 L
s
.164 0 .75 r
.72221 1.44711 m
.72383 1.498 L
s
.154 0 .75 r
.72383 1.498 m
.72534 1.55826 L
s
.145 0 .75 r
.72534 1.55826 m
0 0 rlineto s
.72534 1.55826 m
.72647 1.61803 L
s
.135 0 .75 r
.125 0 .75 r
.115 0 .75 r
.106 0 .75 r
.096 0 .75 r
.086 0 .75 r
0 .001 .75 r
0 .011 .75 r
0 .021 .75 r
0 .031 .75 r
0 .041 .75 r
0 .05 .75 r
0 .06 .75 r
.72647 0 m
.72534 .05977 L
s
0 .07 .75 r
.72534 .05977 m
.72383 .12003 L
s
0 .079 .75 r
.72383 .12003 m
.72221 .17092 L
s
0 .089 .75 r
.72221 .17092 m
.72046 .21447 L
s
0 .099 .75 r
.72046 .21447 m
.71859 .25215 L
s
0 .109 .75 r
.71859 .25215 m
.7166 .2851 L
s
0 .119 .75 r
.7166 .2851 m
.71451 .31417 L
s
0 .128 .75 r
.71451 .31417 m
.7123 .34002 L
s
0 .138 .75 r
.7123 .34002 m
.70998 .36317 L
s
0 .148 .75 r
.70998 .36317 m
.70756 .38407 L
s
0 .158 .75 r
.70756 .38407 m
.70505 .40303 L
s
0 .167 .75 r
.70505 .40303 m
.70244 .42036 L
s
0 .177 .75 r
.70244 .42036 m
.69974 .43628 L
s
0 .187 .75 r
.69974 .43628 m
.69697 .451 L
s
0 .197 .75 r
.69697 .451 m
.69412 .46466 L
s
0 .206 .75 r
.69412 .46466 m
.6912 .47743 L
s
0 .216 .75 r
.6912 .47743 m
.68823 .48941 L
s
0 .226 .75 r
.68823 .48941 m
.68521 .50071 L
s
0 .235 .75 r
.68521 .50071 m
.68214 .51142 L
s
0 .245 .75 r
.68214 .51142 m
.67905 .52162 L
s
0 .255 .75 r
.67905 .52162 m
.67594 .53137 L
s
0 .265 .75 r
.67594 .53137 m
.67281 .54075 L
s
0 .275 .75 r
.67281 .54075 m
.6697 .54979 L
s
0 .284 .75 r
.6697 .54979 m
.66659 .55855 L
s
0 .294 .75 r
.66659 .55855 m
.66352 .56706 L
s
0 .304 .75 r
.66352 .56706 m
.66049 .57537 L
s
0 .314 .75 r
.66049 .57537 m
.65751 .5835 L
s
0 .323 .75 r
.65751 .5835 m
.6546 .59148 L
s
0 .333 .75 r
.6546 .59148 m
.65177 .59934 L
s
0 .343 .75 r
.65177 .59934 m
.64905 .60708 L
s
0 .352 .75 r
.64905 .60708 m
.64643 .61474 L
s
0 .362 .75 r
.64643 .61474 m
.64394 .62233 L
s
0 .372 .75 r
.64394 .62233 m
.6416 .62985 L
s
0 .382 .75 r
.6416 .62985 m
.63941 .63731 L
s
0 .392 .75 r
.63941 .63731 m
.63739 .64473 L
s
0 .401 .75 r
.63739 .64473 m
.63555 .65211 L
s
0 .411 .75 r
.63555 .65211 m
.6339 .65945 L
s
0 .421 .75 r
.6339 .65945 m
.63246 .66675 L
s
0 .43 .75 r
.63246 .66675 m
.63125 .67401 L
s
0 .44 .75 r
.63125 .67401 m
.63026 .68123 L
s
0 .45 .75 r
.63026 .68123 m
.6295 .68841 L
s
0 .46 .75 r
.6295 .68841 m
.629 .69554 L
s
0 .469 .75 r
.629 .69554 m
.62875 .70261 L
s
0 .479 .75 r
.62875 .70261 m
.62875 .70962 L
s
0 .489 .75 r
.62875 .70962 m
.62903 .71656 L
s
0 .499 .75 r
.62903 .71656 m
.62956 .72342 L
s
0 .508 .75 r
.62956 .72342 m
.63037 .73019 L
s
0 .518 .75 r
.63037 .73019 m
.63145 .73686 L
s
0 .528 .75 r
.63145 .73686 m
.63279 .74343 L
s
0 .538 .75 r
.63279 .74343 m
.6344 .74988 L
s
0 .547 .75 r
.6344 .74988 m
.63628 .7562 L
s
0 .557 .75 r
.63628 .7562 m
.63841 .76239 L
s
0 .567 .75 r
.63841 .76239 m
.6408 .76842 L
s
0 .577 .75 r
.6408 .76842 m
.64343 .7743 L
s
0 .587 .75 r
.64343 .7743 m
.64629 .78001 L
s
0 .596 .75 r
.64629 .78001 m
.64939 .78555 L
s
0 .606 .75 r
.64939 .78555 m
.6527 .7909 L
s
0 .616 .75 r
.6527 .7909 m
.65621 .79606 L
s
0 .626 .75 r
.65621 .79606 m
.65992 .80102 L
s
0 .635 .75 r
.65992 .80102 m
.6638 .80577 L
s
0 .645 .75 r
.6638 .80577 m
.66786 .81031 L
s
0 .655 .75 r
.66786 .81031 m
.67206 .81463 L
s
0 .665 .75 r
.67206 .81463 m
.6764 .81873 L
s
0 .674 .75 r
.6764 .81873 m
.68086 .82261 L
s
0 .684 .75 r
.68086 .82261 m
.68543 .82625 L
s
0 .694 .75 r
.68543 .82625 m
.69008 .82967 L
s
0 .703 .75 r
.69008 .82967 m
.69481 .83286 L
s
0 .713 .75 r
.69481 .83286 m
.6996 .83582 L
s
0 .723 .75 r
.6996 .83582 m
.70444 .83855 L
s
0 .733 .75 r
.70444 .83855 m
.7093 .84105 L
s
0 .742 .75 r
.7093 .84105 m
.71417 .84333 L
s
0 .75 .748 r
.71417 .84333 m
.71904 .84538 L
s
0 .75 .738 r
.71904 .84538 m
.72389 .84722 L
s
0 .75 .728 r
.72389 .84722 m
.72871 .84885 L
s
0 .75 .719 r
.72871 .84885 m
.73349 .85027 L
s
0 .75 .709 r
.73349 .85027 m
.73821 .85149 L
s
0 .75 .699 r
.73821 .85149 m
.74287 .85252 L
s
0 .75 .689 r
.74287 .85252 m
.74744 .85336 L
s
0 .75 .68 r
.74744 .85336 m
.75192 .85403 L
s
0 .75 .67 r
.75192 .85403 m
.75631 .85452 L
s
0 .75 .66 r
.75631 .85452 m
.76059 .85486 L
s
0 .75 .65 r
.76059 .85486 m
.76475 .85504 L
s
0 .75 .641 r
.76475 .85504 m
.7688 .85508 L
s
0 .75 .631 r
.7688 .85508 m
.77271 .85499 L
s
0 .75 .621 r
.77271 .85499 m
.77649 .85478 L
s
0 .75 .611 r
.77649 .85478 m
.78014 .85445 L
s
0 .75 .601 r
.78014 .85445 m
.78365 .85401 L
s
0 .75 .592 r
.78365 .85401 m
.78702 .85348 L
s
0 .75 .582 r
.78702 .85348 m
.79025 .85286 L
s
0 .75 .572 r
.79025 .85286 m
.79333 .85216 L
s
0 .75 .563 r
.79333 .85216 m
.79628 .8514 L
s
0 .75 .553 r
.79628 .8514 m
.79908 .85057 L
s
0 .75 .543 r
.79908 .85057 m
.80174 .84969 L
s
0 .75 .533 r
.80174 .84969 m
.80426 .84876 L
s
0 .75 .524 r
.80426 .84876 m
.80665 .84779 L
s
0 .75 .514 r
.80665 .84779 m
.8089 .84679 L
s
0 .75 .504 r
.8089 .84679 m
.81102 .84576 L
s
0 .75 .494 r
.81102 .84576 m
.81302 .84471 L
s
0 .75 .484 r
.81302 .84471 m
.8149 .84364 L
s
0 .75 .475 r
.8149 .84364 m
.81665 .84257 L
s
0 .75 .465 r
.81665 .84257 m
.8183 .84149 L
s
0 .75 .455 r
.8183 .84149 m
.81983 .84041 L
s
0 .75 .446 r
.81983 .84041 m
.82126 .83933 L
s
0 .75 .436 r
.82126 .83933 m
.82259 .83826 L
s
0 .75 .426 r
.82259 .83826 m
.82383 .8372 L
s
0 .75 .416 r
.82383 .8372 m
.82497 .83615 L
s
0 .75 .406 r
.82497 .83615 m
.82603 .83511 L
s
0 .75 .397 r
.82603 .83511 m
.827 .83409 L
s
0 .75 .387 r
.827 .83409 m
.8279 .83309 L
s
0 .75 .377 r
.8279 .83309 m
.82872 .83211 L
s
0 .75 .367 r
.82872 .83211 m
.82948 .83115 L
s
0 .75 .358 r
.82948 .83115 m
.83017 .83021 L
s
0 .75 .348 r
.83017 .83021 m
.8308 .8293 L
s
0 .75 .338 r
.8308 .8293 m
.83137 .82841 L
s
0 .75 .328 r
.83137 .82841 m
.83189 .82755 L
s
0 .75 .319 r
.83189 .82755 m
.83236 .82671 L
s
0 .75 .309 r
.83236 .82671 m
.83278 .82589 L
s
0 .75 .299 r
.83278 .82589 m
.83316 .8251 L
s
0 .75 .289 r
.83316 .8251 m
.8335 .82434 L
s
0 .75 .28 r
.8335 .82434 m
.83379 .8236 L
s
0 .75 .27 r
.83379 .8236 m
.83406 .82289 L
s
0 .75 .26 r
.83406 .82289 m
.83429 .8222 L
s
0 .75 .25 r
.83429 .8222 m
.83449 .82154 L
s
0 .75 .241 r
.83449 .82154 m
.83467 .8209 L
s
0 .75 .231 r
.83467 .8209 m
.83482 .82029 L
s
0 .75 .221 r
.83482 .82029 m
.83494 .8197 L
s
0 .75 .212 r
.83494 .8197 m
.83505 .81913 L
s
0 .75 .202 r
.83505 .81913 m
.83513 .81858 L
s
0 .75 .192 r
.83513 .81858 m
.8352 .81805 L
s
0 .75 .182 r
.8352 .81805 m
.83525 .81755 L
s
0 .75 .172 r
.83525 .81755 m
.83528 .81707 L
s
0 .75 .163 r
.83528 .81707 m
.8353 .8166 L
s
0 .75 .153 r
.8353 .8166 m
.83531 .81616 L
s
0 .75 .143 r
.83531 .81616 m
.83531 .81573 L
s
0 .75 .133 r
.83531 .81573 m
.8353 .81532 L
s
0 .75 .124 r
.8353 .81532 m
.83527 .81493 L
s
0 .75 .114 r
.83527 .81493 m
.83524 .81456 L
s
0 .75 .104 r
.83524 .81456 m
.8352 .8142 L
s
0 .75 .095 r
.8352 .8142 m
.83516 .81386 L
s
0 .75 .085 r
.83516 .81386 m
.83511 .81353 L
s
0 1 0 r
.001 w
.61111 .80902 m
.60761 .85408 L
.59715 .89844 L
.5799 .94138 L
.55614 .98224 L
.52623 1.02036 L
.49065 1.05515 L
.44997 1.08607 L
.40481 1.11261 L
.3559 1.13436 L
.30401 1.15098 L
.24995 1.16221 L
.19457 1.16787 L
.13876 1.16787 L
.08339 1.16221 L
.02933 1.15098 L
s
.02933 1.15098 m
0 1.14159 L
s
0 .47645 m
.02933 .46705 L
.08339 .45582 L
.13876 .45016 L
.19457 .45016 L
.24995 .45582 L
.30401 .46705 L
.3559 .48367 L
.40481 .50543 L
.44997 .53197 L
.49065 .56288 L
.52623 .59767 L
.55614 .6358 L
.5799 .67665 L
.59715 .7196 L
.60761 .76395 L
.61111 .80902 L
s
1 0 0 r
.0005 w
1 1.16419 m
.99286 1.17647 L
.92942 1.25735 L
.85394 1.33115 L
.76764 1.39672 L
.67185 1.45303 L
.5681 1.49917 L
.45801 1.53443 L
.34333 1.55826 L
.22587 1.57026 L
.10747 1.57026 L
s
.10747 1.57026 m
0 1.55928 L
s
0 .05876 m
.10747 .04777 L
.22587 .04777 L
.34333 .05978 L
.45801 .0836 L
.5681 .11886 L
.67185 .16501 L
.76764 .22131 L
.85394 .28688 L
.92942 .36068 L
.99286 .44156 L
s
.99286 .44156 m
1 .45384 L
s
0 0 1 r
.004 w
1 1.33014 m
.95825 1.33881 L
.87519 1.3473 L
.79147 1.3473 L
.70841 1.33881 L
.62732 1.32196 L
.54948 1.29703 L
.47612 1.2644 L
.40838 1.22459 L
.34735 1.17822 L
.29399 1.12604 L
.24913 1.06885 L
.21348 1.00756 L
.18761 .94315 L
.17192 .87661 L
.16667 .80902 L
.17192 .74142 L
.18761 .67489 L
.21348 .61047 L
.24913 .54919 L
.29399 .492 L
.34735 .43981 L
.40838 .39344 L
.47612 .35363 L
.54948 .321 L
.62732 .29607 L
.70841 .27923 L
.79147 .27074 L
.87519 .27074 L
.95825 .27923 L
s
.95825 .27923 m
1 .2879 L
s
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.909028 0.369391 0.97619 0.705202 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.47619 0.000833056 0.0166611 [
[ 0 0 0 0 ]
[ 1 5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 5 L
0 5 L
closepath
clip
newpath
.75 0 0 r
.02381 .00083 m
.02381 .01749 L
.5 .01749 L
.5 .00083 L
F
0 g
gsave
.52381 .00916 -61 -10.5938 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 21.1875 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.313 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(-) show
69.125 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(3) show
75.250 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.75 0 .01 r
.02381 .01749 m
.02381 .03416 L
.5 .03416 L
.5 .01749 L
F
.75 0 .02 r
.02381 .03416 m
.02381 .05082 L
.5 .05082 L
.5 .03416 L
F
.75 0 .029 r
.02381 .05082 m
.02381 .06748 L
.5 .06748 L
.5 .05082 L
F
.75 0 .039 r
.02381 .06748 m
.02381 .08414 L
.5 .08414 L
.5 .06748 L
F
.75 0 .049 r
.02381 .08414 m
.02381 .1008 L
.5 .1008 L
.5 .08414 L
F
.75 0 .059 r
.02381 .1008 m
.02381 .11746 L
.5 .11746 L
.5 .1008 L
F
.75 0 .068 r
.02381 .11746 m
.02381 .13412 L
.5 .13412 L
.5 .11746 L
F
.75 0 .078 r
.02381 .13412 m
.02381 .15078 L
.5 .15078 L
.5 .13412 L
F
.75 0 .088 r
.02381 .15078 m
.02381 .16744 L
.5 .16744 L
.5 .15078 L
F
.75 0 .098 r
.02381 .16744 m
.02381 .18411 L
.5 .18411 L
.5 .16744 L
F
.75 0 .108 r
.02381 .18411 m
.02381 .20077 L
.5 .20077 L
.5 .18411 L
F
.75 0 .117 r
.02381 .20077 m
.02381 .21743 L
.5 .21743 L
.5 .20077 L
F
.75 0 .127 r
.02381 .21743 m
.02381 .23409 L
.5 .23409 L
.5 .21743 L
F
.75 0 .137 r
.02381 .23409 m
.02381 .25075 L
.5 .25075 L
.5 .23409 L
F
.75 0 .147 r
.02381 .25075 m
.02381 .26741 L
.5 .26741 L
.5 .25075 L
F
.75 0 .157 r
.02381 .26741 m
.02381 .28407 L
.5 .28407 L
.5 .26741 L
F
.75 0 .166 r
.02381 .28407 m
.02381 .30073 L
.5 .30073 L
.5 .28407 L
F
.75 0 .176 r
.02381 .30073 m
.02381 .31739 L
.5 .31739 L
.5 .30073 L
F
.75 0 .186 r
.02381 .31739 m
.02381 .33406 L
.5 .33406 L
.5 .31739 L
F
.75 0 .196 r
.02381 .33406 m
.02381 .35072 L
.5 .35072 L
.5 .33406 L
F
.75 0 .205 r
.02381 .35072 m
.02381 .36738 L
.5 .36738 L
.5 .35072 L
F
.75 0 .215 r
.02381 .36738 m
.02381 .38404 L
.5 .38404 L
.5 .36738 L
F
.75 0 .225 r
.02381 .38404 m
.02381 .4007 L
.5 .4007 L
.5 .38404 L
F
.75 0 .235 r
.02381 .4007 m
.02381 .41736 L
.5 .41736 L
.5 .4007 L
F
.75 0 .245 r
.02381 .41736 m
.02381 .43402 L
.5 .43402 L
.5 .41736 L
F
.75 0 .254 r
.02381 .43402 m
.02381 .45068 L
.5 .45068 L
.5 .43402 L
F
.75 0 .264 r
.02381 .45068 m
.02381 .46734 L
.5 .46734 L
.5 .45068 L
F
.75 0 .274 r
.02381 .46734 m
.02381 .48401 L
.5 .48401 L
.5 .46734 L
F
.75 0 .284 r
.02381 .48401 m
.02381 .50067 L
.5 .50067 L
.5 .48401 L
F
.75 0 .293 r
.02381 .50067 m
.02381 .51733 L
.5 .51733 L
.5 .50067 L
F
.75 0 .303 r
.02381 .51733 m
.02381 .53399 L
.5 .53399 L
.5 .51733 L
F
.75 0 .313 r
.02381 .53399 m
.02381 .55065 L
.5 .55065 L
.5 .53399 L
F
.75 0 .323 r
.02381 .55065 m
.02381 .56731 L
.5 .56731 L
.5 .55065 L
F
.75 0 .333 r
.02381 .56731 m
.02381 .58397 L
.5 .58397 L
.5 .56731 L
F
.75 0 .342 r
.02381 .58397 m
.02381 .60063 L
.5 .60063 L
.5 .58397 L
F
.75 0 .352 r
.02381 .60063 m
.02381 .61729 L
.5 .61729 L
.5 .60063 L
F
.75 0 .362 r
.02381 .61729 m
.02381 .63396 L
.5 .63396 L
.5 .61729 L
F
.75 0 .372 r
.02381 .63396 m
.02381 .65062 L
.5 .65062 L
.5 .63396 L
F
.75 0 .382 r
.02381 .65062 m
.02381 .66728 L
.5 .66728 L
.5 .65062 L
F
.75 0 .391 r
.02381 .66728 m
.02381 .68394 L
.5 .68394 L
.5 .66728 L
F
.75 0 .401 r
.02381 .68394 m
.02381 .7006 L
.5 .7006 L
.5 .68394 L
F
.75 0 .411 r
.02381 .7006 m
.02381 .71726 L
.5 .71726 L
.5 .7006 L
F
.75 0 .421 r
.02381 .71726 m
.02381 .73392 L
.5 .73392 L
.5 .71726 L
F
.75 0 .43 r
.02381 .73392 m
.02381 .75058 L
.5 .75058 L
.5 .73392 L
F
.75 0 .44 r
.02381 .75058 m
.02381 .76724 L
.5 .76724 L
.5 .75058 L
F
.75 0 .45 r
.02381 .76724 m
.02381 .78391 L
.5 .78391 L
.5 .76724 L
F
.75 0 .46 r
.02381 .78391 m
.02381 .80057 L
.5 .80057 L
.5 .78391 L
F
.75 0 .47 r
.02381 .80057 m
.02381 .81723 L
.5 .81723 L
.5 .80057 L
F
.75 0 .479 r
.02381 .81723 m
.02381 .83389 L
.5 .83389 L
.5 .81723 L
F
.75 0 .489 r
.02381 .83389 m
.02381 .85055 L
.5 .85055 L
.5 .83389 L
F
.75 0 .499 r
.02381 .85055 m
.02381 .86721 L
.5 .86721 L
.5 .85055 L
F
.75 0 .509 r
.02381 .86721 m
.02381 .88387 L
.5 .88387 L
.5 .86721 L
F
.75 0 .518 r
.02381 .88387 m
.02381 .90053 L
.5 .90053 L
.5 .88387 L
F
.75 0 .528 r
.02381 .90053 m
.02381 .91719 L
.5 .91719 L
.5 .90053 L
F
.75 0 .538 r
.02381 .91719 m
.02381 .93386 L
.5 .93386 L
.5 .91719 L
F
.75 0 .548 r
.02381 .93386 m
.02381 .95052 L
.5 .95052 L
.5 .93386 L
F
.75 0 .558 r
.02381 .95052 m
.02381 .96718 L
.5 .96718 L
.5 .95052 L
F
.75 0 .567 r
.02381 .96718 m
.02381 .98384 L
.5 .98384 L
.5 .96718 L
F
.75 0 .577 r
.02381 .98384 m
.02381 1.0005 L
.5 1.0005 L
.5 .98384 L
F
.75 0 .587 r
.02381 1.0005 m
.02381 1.01716 L
.5 1.01716 L
.5 1.0005 L
F
.75 0 .597 r
.02381 1.01716 m
.02381 1.03382 L
.5 1.03382 L
.5 1.01716 L
F
.75 0 .607 r
.02381 1.03382 m
.02381 1.05048 L
.5 1.05048 L
.5 1.03382 L
F
.75 0 .616 r
.02381 1.05048 m
.02381 1.06714 L
.5 1.06714 L
.5 1.05048 L
F
.75 0 .626 r
.02381 1.06714 m
.02381 1.08381 L
.5 1.08381 L
.5 1.06714 L
F
.75 0 .636 r
.02381 1.08381 m
.02381 1.10047 L
.5 1.10047 L
.5 1.08381 L
F
.75 0 .646 r
.02381 1.10047 m
.02381 1.11713 L
.5 1.11713 L
.5 1.10047 L
F
.75 0 .655 r
.02381 1.11713 m
.02381 1.13379 L
.5 1.13379 L
.5 1.11713 L
F
.75 0 .665 r
.02381 1.13379 m
.02381 1.15045 L
.5 1.15045 L
.5 1.13379 L
F
.75 0 .675 r
.02381 1.15045 m
.02381 1.16711 L
.5 1.16711 L
.5 1.15045 L
F
.75 0 .685 r
.02381 1.16711 m
.02381 1.18377 L
.5 1.18377 L
.5 1.16711 L
F
.75 0 .695 r
.02381 1.18377 m
.02381 1.20043 L
.5 1.20043 L
.5 1.18377 L
F
.75 0 .704 r
.02381 1.20043 m
.02381 1.21709 L
.5 1.21709 L
.5 1.20043 L
F
.75 0 .714 r
.02381 1.21709 m
.02381 1.23376 L
.5 1.23376 L
.5 1.21709 L
F
.75 0 .724 r
.02381 1.23376 m
.02381 1.25042 L
.5 1.25042 L
.5 1.23376 L
F
.75 0 .734 r
.02381 1.25042 m
.02381 1.26708 L
.5 1.26708 L
.5 1.25042 L
F
.75 0 .743 r
.02381 1.26708 m
.02381 1.28374 L
.5 1.28374 L
.5 1.26708 L
F
.747 0 .75 r
.02381 1.28374 m
.02381 1.3004 L
.5 1.3004 L
.5 1.28374 L
F
.737 0 .75 r
.02381 1.3004 m
.02381 1.31706 L
.5 1.31706 L
.5 1.3004 L
F
.727 0 .75 r
.02381 1.31706 m
.02381 1.33372 L
.5 1.33372 L
.5 1.31706 L
F
.717 0 .75 r
.02381 1.33372 m
.02381 1.35038 L
.5 1.35038 L
.5 1.33372 L
F
.708 0 .75 r
.02381 1.35038 m
.02381 1.36704 L
.5 1.36704 L
.5 1.35038 L
F
.698 0 .75 r
.02381 1.36704 m
.02381 1.38371 L
.5 1.38371 L
.5 1.36704 L
F
.688 0 .75 r
.02381 1.38371 m
.02381 1.40037 L
.5 1.40037 L
.5 1.38371 L
F
.678 0 .75 r
.02381 1.40037 m
.02381 1.41703 L
.5 1.41703 L
.5 1.40037 L
F
.668 0 .75 r
.02381 1.41703 m
.02381 1.43369 L
.5 1.43369 L
.5 1.41703 L
F
.659 0 .75 r
.02381 1.43369 m
.02381 1.45035 L
.5 1.45035 L
.5 1.43369 L
F
.649 0 .75 r
.02381 1.45035 m
.02381 1.46701 L
.5 1.46701 L
.5 1.45035 L
F
.639 0 .75 r
.02381 1.46701 m
.02381 1.48367 L
.5 1.48367 L
.5 1.46701 L
F
.629 0 .75 r
.02381 1.48367 m
.02381 1.50033 L
.5 1.50033 L
.5 1.48367 L
F
.62 0 .75 r
.02381 1.50033 m
.02381 1.51699 L
.5 1.51699 L
.5 1.50033 L
F
.61 0 .75 r
.02381 1.51699 m
.02381 1.53366 L
.5 1.53366 L
.5 1.51699 L
F
.6 0 .75 r
.02381 1.53366 m
.02381 1.55032 L
.5 1.55032 L
.5 1.53366 L
F
.59 0 .75 r
.02381 1.55032 m
.02381 1.56698 L
.5 1.56698 L
.5 1.55032 L
F
.58 0 .75 r
.02381 1.56698 m
.02381 1.58364 L
.5 1.58364 L
.5 1.56698 L
F
.571 0 .75 r
.02381 1.58364 m
.02381 1.6003 L
.5 1.6003 L
.5 1.58364 L
F
.561 0 .75 r
.02381 1.6003 m
.02381 1.61696 L
.5 1.61696 L
.5 1.6003 L
F
.551 0 .75 r
.02381 1.61696 m
.02381 1.63362 L
.5 1.63362 L
.5 1.61696 L
F
.541 0 .75 r
.02381 1.63362 m
.02381 1.65028 L
.5 1.65028 L
.5 1.63362 L
F
.532 0 .75 r
.02381 1.65028 m
.02381 1.66694 L
.5 1.66694 L
.5 1.65028 L
F
.522 0 .75 r
.02381 1.66694 m
.02381 1.68361 L
.5 1.68361 L
.5 1.66694 L
F
.512 0 .75 r
.02381 1.68361 m
.02381 1.70027 L
.5 1.70027 L
.5 1.68361 L
F
.502 0 .75 r
.02381 1.70027 m
.02381 1.71693 L
.5 1.71693 L
.5 1.70027 L
F
.492 0 .75 r
.02381 1.71693 m
.02381 1.73359 L
.5 1.73359 L
.5 1.71693 L
F
.483 0 .75 r
.02381 1.73359 m
.02381 1.75025 L
.5 1.75025 L
.5 1.73359 L
F
.473 0 .75 r
.02381 1.75025 m
.02381 1.76691 L
.5 1.76691 L
.5 1.75025 L
F
.463 0 .75 r
.02381 1.76691 m
.02381 1.78357 L
.5 1.78357 L
.5 1.76691 L
F
.453 0 .75 r
.02381 1.78357 m
.02381 1.80023 L
.5 1.80023 L
.5 1.78357 L
F
.443 0 .75 r
.02381 1.80023 m
.02381 1.81689 L
.5 1.81689 L
.5 1.80023 L
F
.434 0 .75 r
.02381 1.81689 m
.02381 1.83356 L
.5 1.83356 L
.5 1.81689 L
F
.424 0 .75 r
.02381 1.83356 m
.02381 1.85022 L
.5 1.85022 L
.5 1.83356 L
F
.414 0 .75 r
.02381 1.85022 m
.02381 1.86688 L
.5 1.86688 L
.5 1.85022 L
F
.404 0 .75 r
.02381 1.86688 m
.02381 1.88354 L
.5 1.88354 L
.5 1.86688 L
F
.395 0 .75 r
.02381 1.88354 m
.02381 1.9002 L
.5 1.9002 L
.5 1.88354 L
F
.385 0 .75 r
.02381 1.9002 m
.02381 1.91686 L
.5 1.91686 L
.5 1.9002 L
F
.375 0 .75 r
.02381 1.91686 m
.02381 1.93352 L
.5 1.93352 L
.5 1.91686 L
F
.365 0 .75 r
.02381 1.93352 m
.02381 1.95018 L
.5 1.95018 L
.5 1.93352 L
F
.355 0 .75 r
.02381 1.95018 m
.02381 1.96684 L
.5 1.96684 L
.5 1.95018 L
F
.346 0 .75 r
.02381 1.96684 m
.02381 1.98351 L
.5 1.98351 L
.5 1.96684 L
F
.336 0 .75 r
.02381 1.98351 m
.02381 2.00017 L
.5 2.00017 L
.5 1.98351 L
F
.326 0 .75 r
.02381 2.00017 m
.02381 2.01683 L
.5 2.01683 L
.5 2.00017 L
F
.316 0 .75 r
.02381 2.01683 m
.02381 2.03349 L
.5 2.03349 L
.5 2.01683 L
F
.307 0 .75 r
.02381 2.03349 m
.02381 2.05015 L
.5 2.05015 L
.5 2.03349 L
F
.297 0 .75 r
.02381 2.05015 m
.02381 2.06681 L
.5 2.06681 L
.5 2.05015 L
F
.287 0 .75 r
.02381 2.06681 m
.02381 2.08347 L
.5 2.08347 L
.5 2.06681 L
F
.277 0 .75 r
.02381 2.08347 m
.02381 2.10013 L
.5 2.10013 L
.5 2.08347 L
F
.267 0 .75 r
.02381 2.10013 m
.02381 2.11679 L
.5 2.11679 L
.5 2.10013 L
F
.258 0 .75 r
.02381 2.11679 m
.02381 2.13346 L
.5 2.13346 L
.5 2.11679 L
F
.248 0 .75 r
.02381 2.13346 m
.02381 2.15012 L
.5 2.15012 L
.5 2.13346 L
F
.238 0 .75 r
.02381 2.15012 m
.02381 2.16678 L
.5 2.16678 L
.5 2.15012 L
F
.228 0 .75 r
.02381 2.16678 m
.02381 2.18344 L
.5 2.18344 L
.5 2.16678 L
F
.218 0 .75 r
.02381 2.18344 m
.02381 2.2001 L
.5 2.2001 L
.5 2.18344 L
F
.209 0 .75 r
.02381 2.2001 m
.02381 2.21676 L
.5 2.21676 L
.5 2.2001 L
F
.199 0 .75 r
.02381 2.21676 m
.02381 2.23342 L
.5 2.23342 L
.5 2.21676 L
F
.189 0 .75 r
.02381 2.23342 m
.02381 2.25008 L
.5 2.25008 L
.5 2.23342 L
F
.179 0 .75 r
.02381 2.25008 m
.02381 2.26674 L
.5 2.26674 L
.5 2.25008 L
F
.17 0 .75 r
.02381 2.26674 m
.02381 2.28341 L
.5 2.28341 L
.5 2.26674 L
F
.16 0 .75 r
.02381 2.28341 m
.02381 2.30007 L
.5 2.30007 L
.5 2.28341 L
F
.15 0 .75 r
.02381 2.30007 m
.02381 2.31673 L
.5 2.31673 L
.5 2.30007 L
F
.14 0 .75 r
.02381 2.31673 m
.02381 2.33339 L
.5 2.33339 L
.5 2.31673 L
F
.13 0 .75 r
.02381 2.33339 m
.02381 2.35005 L
.5 2.35005 L
.5 2.33339 L
F
.121 0 .75 r
.02381 2.35005 m
.02381 2.36671 L
.5 2.36671 L
.5 2.35005 L
F
.111 0 .75 r
.02381 2.36671 m
.02381 2.38337 L
.5 2.38337 L
.5 2.36671 L
F
.101 0 .75 r
.02381 2.38337 m
.02381 2.40003 L
.5 2.40003 L
.5 2.38337 L
F
.091 0 .75 r
.02381 2.40003 m
.02381 2.41669 L
.5 2.41669 L
.5 2.40003 L
F
.082 0 .75 r
.02381 2.41669 m
.02381 2.43336 L
.5 2.43336 L
.5 2.41669 L
F
.072 0 .75 r
.02381 2.43336 m
.02381 2.45002 L
.5 2.45002 L
.5 2.43336 L
F
.062 0 .75 r
.02381 2.45002 m
.02381 2.46668 L
.5 2.46668 L
.5 2.45002 L
F
.052 0 .75 r
.02381 2.46668 m
.02381 2.48334 L
.5 2.48334 L
.5 2.46668 L
F
.042 0 .75 r
.02381 2.48334 m
.02381 2.5 L
.5 2.5 L
.5 2.48334 L
F
.033 0 .75 r
.02381 2.5 m
.02381 2.51666 L
.5 2.51666 L
.5 2.5 L
F
.023 0 .75 r
.02381 2.51666 m
.02381 2.53332 L
.5 2.53332 L
.5 2.51666 L
F
.013 0 .75 r
.02381 2.53332 m
.02381 2.54998 L
.5 2.54998 L
.5 2.53332 L
F
.003 0 .75 r
.02381 2.54998 m
.02381 2.56664 L
.5 2.56664 L
.5 2.54998 L
F
0 .007 .75 r
.02381 2.56664 m
.02381 2.58331 L
.5 2.58331 L
.5 2.56664 L
F
0 .016 .75 r
.02381 2.58331 m
.02381 2.59997 L
.5 2.59997 L
.5 2.58331 L
F
0 .026 .75 r
.02381 2.59997 m
.02381 2.61663 L
.5 2.61663 L
.5 2.59997 L
F
0 .036 .75 r
.02381 2.61663 m
.02381 2.63329 L
.5 2.63329 L
.5 2.61663 L
F
0 .046 .75 r
.02381 2.63329 m
.02381 2.64995 L
.5 2.64995 L
.5 2.63329 L
F
0 .055 .75 r
.02381 2.64995 m
.02381 2.66661 L
.5 2.66661 L
.5 2.64995 L
F
0 .065 .75 r
.02381 2.66661 m
.02381 2.68327 L
.5 2.68327 L
.5 2.66661 L
F
0 .075 .75 r
.02381 2.68327 m
.02381 2.69993 L
.5 2.69993 L
.5 2.68327 L
F
0 .085 .75 r
.02381 2.69993 m
.02381 2.71659 L
.5 2.71659 L
.5 2.69993 L
F
0 .095 .75 r
.02381 2.71659 m
.02381 2.73326 L
.5 2.73326 L
.5 2.71659 L
F
0 .104 .75 r
.02381 2.73326 m
.02381 2.74992 L
.5 2.74992 L
.5 2.73326 L
F
0 .114 .75 r
.02381 2.74992 m
.02381 2.76658 L
.5 2.76658 L
.5 2.74992 L
F
0 .124 .75 r
.02381 2.76658 m
.02381 2.78324 L
.5 2.78324 L
.5 2.76658 L
F
0 .134 .75 r
.02381 2.78324 m
.02381 2.7999 L
.5 2.7999 L
.5 2.78324 L
F
0 .143 .75 r
.02381 2.7999 m
.02381 2.81656 L
.5 2.81656 L
.5 2.7999 L
F
0 .153 .75 r
.02381 2.81656 m
.02381 2.83322 L
.5 2.83322 L
.5 2.81656 L
F
0 .163 .75 r
.02381 2.83322 m
.02381 2.84988 L
.5 2.84988 L
.5 2.83322 L
F
0 .173 .75 r
.02381 2.84988 m
.02381 2.86654 L
.5 2.86654 L
.5 2.84988 L
F
0 .183 .75 r
.02381 2.86654 m
.02381 2.88321 L
.5 2.88321 L
.5 2.86654 L
F
0 .192 .75 r
.02381 2.88321 m
.02381 2.89987 L
.5 2.89987 L
.5 2.88321 L
F
0 .202 .75 r
.02381 2.89987 m
.02381 2.91653 L
.5 2.91653 L
.5 2.89987 L
F
0 .212 .75 r
.02381 2.91653 m
.02381 2.93319 L
.5 2.93319 L
.5 2.91653 L
F
0 .222 .75 r
.02381 2.93319 m
.02381 2.94985 L
.5 2.94985 L
.5 2.93319 L
F
0 .232 .75 r
.02381 2.94985 m
.02381 2.96651 L
.5 2.96651 L
.5 2.94985 L
F
0 .241 .75 r
.02381 2.96651 m
.02381 2.98317 L
.5 2.98317 L
.5 2.96651 L
F
0 .251 .75 r
.02381 2.98317 m
.02381 2.99983 L
.5 2.99983 L
.5 2.98317 L
F
0 .261 .75 r
.02381 2.99983 m
.02381 3.01649 L
.5 3.01649 L
.5 2.99983 L
F
0 .271 .75 r
.02381 3.01649 m
.02381 3.03316 L
.5 3.03316 L
.5 3.01649 L
F
0 .28 .75 r
.02381 3.03316 m
.02381 3.04982 L
.5 3.04982 L
.5 3.03316 L
F
0 .29 .75 r
.02381 3.04982 m
.02381 3.06648 L
.5 3.06648 L
.5 3.04982 L
F
0 .3 .75 r
.02381 3.06648 m
.02381 3.08314 L
.5 3.08314 L
.5 3.06648 L
F
0 .31 .75 r
.02381 3.08314 m
.02381 3.0998 L
.5 3.0998 L
.5 3.08314 L
F
0 .32 .75 r
.02381 3.0998 m
.02381 3.11646 L
.5 3.11646 L
.5 3.0998 L
F
0 .329 .75 r
.02381 3.11646 m
.02381 3.13312 L
.5 3.13312 L
.5 3.11646 L
F
0 .339 .75 r
.02381 3.13312 m
.02381 3.14978 L
.5 3.14978 L
.5 3.13312 L
F
0 .349 .75 r
.02381 3.14978 m
.02381 3.16644 L
.5 3.16644 L
.5 3.14978 L
F
0 .359 .75 r
.02381 3.16644 m
.02381 3.18311 L
.5 3.18311 L
.5 3.16644 L
F
0 .368 .75 r
.02381 3.18311 m
.02381 3.19977 L
.5 3.19977 L
.5 3.18311 L
F
0 .378 .75 r
.02381 3.19977 m
.02381 3.21643 L
.5 3.21643 L
.5 3.19977 L
F
0 .388 .75 r
.02381 3.21643 m
.02381 3.23309 L
.5 3.23309 L
.5 3.21643 L
F
0 .398 .75 r
.02381 3.23309 m
.02381 3.24975 L
.5 3.24975 L
.5 3.23309 L
F
0 .408 .75 r
.02381 3.24975 m
.02381 3.26641 L
.5 3.26641 L
.5 3.24975 L
F
0 .417 .75 r
.02381 3.26641 m
.02381 3.28307 L
.5 3.28307 L
.5 3.26641 L
F
0 .427 .75 r
.02381 3.28307 m
.02381 3.29973 L
.5 3.29973 L
.5 3.28307 L
F
0 .437 .75 r
.02381 3.29973 m
.02381 3.31639 L
.5 3.31639 L
.5 3.29973 L
F
0 .447 .75 r
.02381 3.31639 m
.02381 3.33306 L
.5 3.33306 L
.5 3.31639 L
F
0 .457 .75 r
.02381 3.33306 m
.02381 3.34972 L
.5 3.34972 L
.5 3.33306 L
F
0 .466 .75 r
.02381 3.34972 m
.02381 3.36638 L
.5 3.36638 L
.5 3.34972 L
F
0 .476 .75 r
.02381 3.36638 m
.02381 3.38304 L
.5 3.38304 L
.5 3.36638 L
F
0 .486 .75 r
.02381 3.38304 m
.02381 3.3997 L
.5 3.3997 L
.5 3.38304 L
F
0 .496 .75 r
.02381 3.3997 m
.02381 3.41636 L
.5 3.41636 L
.5 3.3997 L
F
0 .505 .75 r
.02381 3.41636 m
.02381 3.43302 L
.5 3.43302 L
.5 3.41636 L
F
0 .515 .75 r
.02381 3.43302 m
.02381 3.44968 L
.5 3.44968 L
.5 3.43302 L
F
0 .525 .75 r
.02381 3.44968 m
.02381 3.46634 L
.5 3.46634 L
.5 3.44968 L
F
0 .535 .75 r
.02381 3.46634 m
.02381 3.48301 L
.5 3.48301 L
.5 3.46634 L
F
0 .545 .75 r
.02381 3.48301 m
.02381 3.49967 L
.5 3.49967 L
.5 3.48301 L
F
0 .554 .75 r
.02381 3.49967 m
.02381 3.51633 L
.5 3.51633 L
.5 3.49967 L
F
0 .564 .75 r
.02381 3.51633 m
.02381 3.53299 L
.5 3.53299 L
.5 3.51633 L
F
0 .574 .75 r
.02381 3.53299 m
.02381 3.54965 L
.5 3.54965 L
.5 3.53299 L
F
0 .584 .75 r
.02381 3.54965 m
.02381 3.56631 L
.5 3.56631 L
.5 3.54965 L
F
0 .593 .75 r
.02381 3.56631 m
.02381 3.58297 L
.5 3.58297 L
.5 3.56631 L
F
0 .603 .75 r
.02381 3.58297 m
.02381 3.59963 L
.5 3.59963 L
.5 3.58297 L
F
0 .613 .75 r
.02381 3.59963 m
.02381 3.61629 L
.5 3.61629 L
.5 3.59963 L
F
0 .623 .75 r
.02381 3.61629 m
.02381 3.63296 L
.5 3.63296 L
.5 3.61629 L
F
0 .633 .75 r
.02381 3.63296 m
.02381 3.64962 L
.5 3.64962 L
.5 3.63296 L
F
0 .642 .75 r
.02381 3.64962 m
.02381 3.66628 L
.5 3.66628 L
.5 3.64962 L
F
0 .652 .75 r
.02381 3.66628 m
.02381 3.68294 L
.5 3.68294 L
.5 3.66628 L
F
0 .662 .75 r
.02381 3.68294 m
.02381 3.6996 L
.5 3.6996 L
.5 3.68294 L
F
0 .672 .75 r
.02381 3.6996 m
.02381 3.71626 L
.5 3.71626 L
.5 3.6996 L
F
0 .682 .75 r
.02381 3.71626 m
.02381 3.73292 L
.5 3.73292 L
.5 3.71626 L
F
0 .691 .75 r
.02381 3.73292 m
.02381 3.74958 L
.5 3.74958 L
.5 3.73292 L
F
0 .701 .75 r
.02381 3.74958 m
.02381 3.76624 L
.5 3.76624 L
.5 3.74958 L
F
0 .711 .75 r
.02381 3.76624 m
.02381 3.78291 L
.5 3.78291 L
.5 3.76624 L
F
0 .721 .75 r
.02381 3.78291 m
.02381 3.79957 L
.5 3.79957 L
.5 3.78291 L
F
0 .73 .75 r
.02381 3.79957 m
.02381 3.81623 L
.5 3.81623 L
.5 3.79957 L
F
0 .74 .75 r
.02381 3.81623 m
.02381 3.83289 L
.5 3.83289 L
.5 3.81623 L
F
0 .75 .75 r
.02381 3.83289 m
.02381 3.84955 L
.5 3.84955 L
.5 3.83289 L
F
0 .75 .74 r
.02381 3.84955 m
.02381 3.86621 L
.5 3.86621 L
.5 3.84955 L
F
0 .75 .73 r
.02381 3.86621 m
.02381 3.88287 L
.5 3.88287 L
.5 3.86621 L
F
0 .75 .721 r
.02381 3.88287 m
.02381 3.89953 L
.5 3.89953 L
.5 3.88287 L
F
0 .75 .711 r
.02381 3.89953 m
.02381 3.91619 L
.5 3.91619 L
.5 3.89953 L
F
0 .75 .701 r
.02381 3.91619 m
.02381 3.93286 L
.5 3.93286 L
.5 3.91619 L
F
0 .75 .691 r
.02381 3.93286 m
.02381 3.94952 L
.5 3.94952 L
.5 3.93286 L
F
0 .75 .682 r
.02381 3.94952 m
.02381 3.96618 L
.5 3.96618 L
.5 3.94952 L
F
0 .75 .672 r
.02381 3.96618 m
.02381 3.98284 L
.5 3.98284 L
.5 3.96618 L
F
0 .75 .662 r
.02381 3.98284 m
.02381 3.9995 L
.5 3.9995 L
.5 3.98284 L
F
0 .75 .652 r
.02381 3.9995 m
.02381 4.01616 L
.5 4.01616 L
.5 3.9995 L
F
0 .75 .642 r
.02381 4.01616 m
.02381 4.03282 L
.5 4.03282 L
.5 4.01616 L
F
0 .75 .633 r
.02381 4.03282 m
.02381 4.04948 L
.5 4.04948 L
.5 4.03282 L
F
0 .75 .623 r
.02381 4.04948 m
.02381 4.06614 L
.5 4.06614 L
.5 4.04948 L
F
0 .75 .613 r
.02381 4.06614 m
.02381 4.08281 L
.5 4.08281 L
.5 4.06614 L
F
0 .75 .603 r
.02381 4.08281 m
.02381 4.09947 L
.5 4.09947 L
.5 4.08281 L
F
0 .75 .593 r
.02381 4.09947 m
.02381 4.11613 L
.5 4.11613 L
.5 4.09947 L
F
0 .75 .584 r
.02381 4.11613 m
.02381 4.13279 L
.5 4.13279 L
.5 4.11613 L
F
0 .75 .574 r
.02381 4.13279 m
.02381 4.14945 L
.5 4.14945 L
.5 4.13279 L
F
0 .75 .564 r
.02381 4.14945 m
.02381 4.16611 L
.5 4.16611 L
.5 4.14945 L
F
0 .75 .554 r
.02381 4.16611 m
.02381 4.18277 L
.5 4.18277 L
.5 4.16611 L
F
0 .75 .545 r
.02381 4.18277 m
.02381 4.19943 L
.5 4.19943 L
.5 4.18277 L
F
0 .75 .535 r
.02381 4.19943 m
.02381 4.21609 L
.5 4.21609 L
.5 4.19943 L
F
0 .75 .525 r
.02381 4.21609 m
.02381 4.23276 L
.5 4.23276 L
.5 4.21609 L
F
0 .75 .515 r
.02381 4.23276 m
.02381 4.24942 L
.5 4.24942 L
.5 4.23276 L
F
0 .75 .505 r
.02381 4.24942 m
.02381 4.26608 L
.5 4.26608 L
.5 4.24942 L
F
0 .75 .496 r
.02381 4.26608 m
.02381 4.28274 L
.5 4.28274 L
.5 4.26608 L
F
0 .75 .486 r
.02381 4.28274 m
.02381 4.2994 L
.5 4.2994 L
.5 4.28274 L
F
0 .75 .476 r
.02381 4.2994 m
.02381 4.31606 L
.5 4.31606 L
.5 4.2994 L
F
0 .75 .466 r
.02381 4.31606 m
.02381 4.33272 L
.5 4.33272 L
.5 4.31606 L
F
0 .75 .457 r
.02381 4.33272 m
.02381 4.34938 L
.5 4.34938 L
.5 4.33272 L
F
0 .75 .447 r
.02381 4.34938 m
.02381 4.36604 L
.5 4.36604 L
.5 4.34938 L
F
0 .75 .437 r
.02381 4.36604 m
.02381 4.38271 L
.5 4.38271 L
.5 4.36604 L
F
0 .75 .427 r
.02381 4.38271 m
.02381 4.39937 L
.5 4.39937 L
.5 4.38271 L
F
0 .75 .417 r
.02381 4.39937 m
.02381 4.41603 L
.5 4.41603 L
.5 4.39937 L
F
0 .75 .408 r
.02381 4.41603 m
.02381 4.43269 L
.5 4.43269 L
.5 4.41603 L
F
0 .75 .398 r
.02381 4.43269 m
.02381 4.44935 L
.5 4.44935 L
.5 4.43269 L
F
0 .75 .388 r
.02381 4.44935 m
.02381 4.46601 L
.5 4.46601 L
.5 4.44935 L
F
0 .75 .378 r
.02381 4.46601 m
.02381 4.48267 L
.5 4.48267 L
.5 4.46601 L
F
0 .75 .368 r
.02381 4.48267 m
.02381 4.49933 L
.5 4.49933 L
.5 4.48267 L
F
0 .75 .359 r
.02381 4.49933 m
.02381 4.51599 L
.5 4.51599 L
.5 4.49933 L
F
0 .75 .349 r
.02381 4.51599 m
.02381 4.53266 L
.5 4.53266 L
.5 4.51599 L
F
0 .75 .339 r
.02381 4.53266 m
.02381 4.54932 L
.5 4.54932 L
.5 4.53266 L
F
0 .75 .329 r
.02381 4.54932 m
.02381 4.56598 L
.5 4.56598 L
.5 4.54932 L
F
0 .75 .32 r
.02381 4.56598 m
.02381 4.58264 L
.5 4.58264 L
.5 4.56598 L
F
0 .75 .31 r
.02381 4.58264 m
.02381 4.5993 L
.5 4.5993 L
.5 4.58264 L
F
0 .75 .3 r
.02381 4.5993 m
.02381 4.61596 L
.5 4.61596 L
.5 4.5993 L
F
0 .75 .29 r
.02381 4.61596 m
.02381 4.63262 L
.5 4.63262 L
.5 4.61596 L
F
0 .75 .28 r
.02381 4.63262 m
.02381 4.64928 L
.5 4.64928 L
.5 4.63262 L
F
0 .75 .271 r
.02381 4.64928 m
.02381 4.66594 L
.5 4.66594 L
.5 4.64928 L
F
0 .75 .261 r
.02381 4.66594 m
.02381 4.68261 L
.5 4.68261 L
.5 4.66594 L
F
0 .75 .251 r
.02381 4.68261 m
.02381 4.69927 L
.5 4.69927 L
.5 4.68261 L
F
0 .75 .241 r
.02381 4.69927 m
.02381 4.71593 L
.5 4.71593 L
.5 4.69927 L
F
0 .75 .232 r
.02381 4.71593 m
.02381 4.73259 L
.5 4.73259 L
.5 4.71593 L
F
0 .75 .222 r
.02381 4.73259 m
.02381 4.74925 L
.5 4.74925 L
.5 4.73259 L
F
0 .75 .212 r
.02381 4.74925 m
.02381 4.76591 L
.5 4.76591 L
.5 4.74925 L
F
0 .75 .202 r
.02381 4.76591 m
.02381 4.78257 L
.5 4.78257 L
.5 4.76591 L
F
0 .75 .192 r
.02381 4.78257 m
.02381 4.79923 L
.5 4.79923 L
.5 4.78257 L
F
0 .75 .183 r
.02381 4.79923 m
.02381 4.81589 L
.5 4.81589 L
.5 4.79923 L
F
0 .75 .173 r
.02381 4.81589 m
.02381 4.83256 L
.5 4.83256 L
.5 4.81589 L
F
0 .75 .163 r
.02381 4.83256 m
.02381 4.84922 L
.5 4.84922 L
.5 4.83256 L
F
0 .75 .153 r
.02381 4.84922 m
.02381 4.86588 L
.5 4.86588 L
.5 4.84922 L
F
0 .75 .143 r
.02381 4.86588 m
.02381 4.88254 L
.5 4.88254 L
.5 4.86588 L
F
0 .75 .134 r
.02381 4.88254 m
.02381 4.8992 L
.5 4.8992 L
.5 4.88254 L
F
0 .75 .124 r
.02381 4.8992 m
.02381 4.91586 L
.5 4.91586 L
.5 4.8992 L
F
0 .75 .114 r
.02381 4.91586 m
.02381 4.93252 L
.5 4.93252 L
.5 4.91586 L
F
0 .75 .104 r
.02381 4.93252 m
.02381 4.94918 L
.5 4.94918 L
.5 4.93252 L
F
0 .75 .095 r
.02381 4.94918 m
.02381 4.96584 L
.5 4.96584 L
.5 4.94918 L
F
0 .75 .085 r
.02381 4.96584 m
.02381 4.98251 L
.5 4.98251 L
.5 4.96584 L
F
0 .75 .075 r
.02381 4.98251 m
.02381 4.99917 L
.5 4.99917 L
.5 4.98251 L
F
0 g
gsave
.52381 4.99084 -61 -10.5938 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 21.1875 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(3) show
69.125 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
MathSubEnd
P
% End of sub-graphic
0 0 m
1 0 L
1 1.4104 L
0 1.4104 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  CellLabel->"From In[134]:=",
  ImageSize->{294.188, 414.875},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004V0001WQ000`40O003h00Oogoo9goo003oOolW
Ool00?moobMoo`00ogoo9goo003oOolWOol00?moobMoo`00ogoo9goo003oOolWOol00?moobMoo`00
ogoo9goo003oOolWOol00?moobMoo`00ogoo9goo003oOolWOol00?moobMoo`00ogoo9goo003oOolW
Ool00?moobMoo`00ogoo9goo003oOolWOol00?moobMoo`00ogoo9goo003oOolWOol00?moobMoo`00
ogoo9goo003oOolWOol00?moobMoo`00ogoo9goo003oOolWOol00?moobMoo`00ogoo9goo003oOolW
Ool00?moobMoo`00ogoo9goo003oOolWOol00?moobMoo`00ogoo9goo003oOolWOol00?moobMoo`00
ogoo9goo003oOolWOol009Uoo`80009oo`<000=oo`80085oo`00VGoo00<007ooOol017oo00D007oo
Oomoo`00085oo`00RWoo0`000Woo00<007ooOol00`0017oo00<007ooOol00Woo0`000goo00<007oo
Ool0Ogoo002;Ool01000Oomoo`000Woo00<007ooOol01Goo00D007ooOomoo`00009oo`05001oogoo
Ool00021Ool008]oo`<000=oo`@000Aoo`05001oogooOol00002Ool01@00Oomoogoo0000PGoo002;
Ool01000Oomoo`000goo0P001Goo00<007ooOol00Woo10000Woo00<007ooOol0Ogoo002;Ool01000
Oomoo`002Woo00<007ooOol027oo00<007ooOol0Ogoo002:Ool4000;Ool20008Ool20021Ool00?mo
obMoo`00ogoo9goo003oOolWOol004Eoo`D0009oo`8000=oo`@000aoo`D000eoo`8000Aoo`8000Ao
o`8000Uoo`8000Aoo`8000=oo`<000Qoo`8000Aoo`8000Eoo`<000Moo`8000Aoo`8000=oo`@000Yo
o`8000moo`8000Aoo`8000=oo`@003Ioo`00Agoo00<007ooOol01goo00<007ooOol03goo00<007oo
Ool037oo00@007ooOol000Qoo`04001oogoo0007Ool01000Oomoo`0027oo00@007ooOol000Ioo`04
001oogoo000;Ool00`00Oomoo`05Ool01000Oomoo`0027oo00<007ooOol02Woo00@007ooOol000eo
o`04001oogoo0008Ool00`00Oomoo`0gOol004Moo`03001oogoo00Qoo`03001oogoo00ioo`03001o
ogoo00aoo`04001oogoo0008Ool01000Oomoo`001goo00@007ooOol000Qoo`04001oogoo0006Ool0
1000Oomoo`0027oo1@001Woo00@007ooOol000Uoo`03001oogoo00Uoo`04001oogoo000=Ool01000
Oomoo`002Goo00<007ooOol0=Woo000oOol40004Ool00`00Oomoo`09Ool00`00Oomoo`05Ool40004
Ool00`00Oomoo`06Ool40002Ool01000Oomoo`002Goo0P000Woo10000Woo00@007ooOol000Qoo`<0
0003Ool000000080009oo`04001oogoo0008Ool01@00Oomoo`00Ool010000Woo00@007ooOol000Yo
o`03001oogoo00Qoo`04001oogoo000=Ool01000Oomoo`002Woo00<007ooOol0=Goo0017Ool00`00
Oomoo`07Ool01000Oomoo`003Woo00<007ooOol037oo00@007ooOol000Qoo`04001oogoo0007Ool0
1000Oomoo`002Goo00<007ooOol01Woo00@007ooOol000Uoo`03001oo`0000Moo`04001oogoo0008
Ool01000Oomoo`002Goo00@007ooOol000eoo`04001oogoo0008Ool01000Oomoo`00=Woo0016Ool2
000:Ool2000>Ool2000?Ool2000:Ool20009Ool2000:Ool30007Ool2000;Ool20008Ool2000:Ool2
000;Ool2000?Ool2000:Ool2000gOol00?moobMoo`00ogoo9goo003oOolWOol00?moobMoo`00A7oo
Z`00=goo0014Ool00`00Oomoo`03Ool00`00Oomoo`03Ool00`00Oomoo`02Ool00`00Oomoo`03Ool0
1000Oomoogoo0Ukg1Goo00<007ooOol00goo00<007ooOol00Woo00=NmgooOol00goo00<007ooOol0
0goo00<007ooOol00Woo00<007ooOol00goo00<007ooOol00goo00H005kgG_MNmgoo0005Ool00`00
Oomoo`03Ool00`00Oomoo`02Ool00ekgOomoo`03Ool00`00Oomoo`03Ool00`00Oomoo`02Ool00`00
Oomoo`03Ool01P00Oomoogoo03L000Eoo`03001oogoo00=oo`03001oogoo009oo`03G_Moogoo00=o
o`03001oogoo00=oo`03001oogoo009oo`03001oogoo00=oo`03001oogoo00=oo`03001oogoo03Eo
o`00A7oo00<007ooOol05Woo0Ukg4Woo00=NmgooOol067oo0ekg5Woo00=NmgooOol05goo00<0=goo
Ool03goo00=NmgooOol06Woo00<007ooOol0=Goo0014Ool00`00Oomoo`0EOol00ekgOomoo`0COol0
0ekgOomoo`0DOol3G_LIOol00ekgOomoo`0GOol00`0gOomoo`0?Ool00ekgOomoo`0JOol00`00Oomo
o`0eOol004Aoo`03001oogoo01=oo`9NmaMoo`03G_Moogoo011oo`=Nmaaoo`03G_Moogoo01Moo`03
03Moogoo00moo`03G_Moogoo01Yoo`03001oogoo03Eoo`00A7oo00<007ooOol04Goo0Ukg6Woo00=N
mgooOol037oo0ekg87oo00=NmgooOol05Woo00<0=gooOol03goo00=NmgooOol06Woo00<007ooOol0
=Goo0014Ool00`00Oomoo`0?Ool2G_LLOol00ekgOomoo`0:Ool2G_LSOol00ekgOomoo`0FOol00`0g
Oomoo`0?Ool00ekgOomoo`0JOol00`00Oomoo`0eOol004Aoo`03001oogoo00ioo`03G_Moogoo01eo
o`03G_Moogoo00Moo`9NmbEoo`03G_Moogoo01Ioo`0303Moogoo00moo`03G_Moogoo01Yoo`03001o
ogoo03Eoo`00A7oo00<007ooOol02goo7W`01Woo00=NmgooOol017oo0Ukg:7oo00=NmgooOol05Goo
00<0=gooOol03goo00=NmgooOol06Woo00<007ooOol0=Goo0014Ool20003Ool9O0000ekgOomoo`0K
Ool:O0000gooG_MNm`0ZOol00ekgOomoo`0EOol0100gOomoogoo7Ekg3Goo0P00=goo0014Ool5O007
Ool00ekgOomoo`0TOol00ekgOomNm`07O00VOol00ekgOomoo`0?Ool6G_L0101GG_MNmekg3Woo00=N
mgooOol037oo2Ukg17oo00<007ooOol0=Goo0014Ool00`00Oomoo`08Ool00ekgOomoo`0UOol2G_L8
Ool5O00ROol00ekgOomoo`07Ool7G_L6Ool00`1GOomoo`0?Ool00ekgOomoo`0FOol4G_L00`00Oomo
o`0eOol004Aoo`03001oogoo00Ioo`9NmbIoo`9Nm`03OomNmgoo00aoo`El01eoo`03G_Moogoo009o
o`ENm`eoo`0305Moogoo00moo`03G_Moogoo01Yoo`03001oogoo03Eoo`00A7oo00<007ooOol01Goo
00=NmgooOol097oo0Ukg17oo00=NmgooOol03goo1G`067oo1Ekg4Woo00<0EgooOol03goo00=Nmgoo
Ool06Woo00<007ooOol0=Goo0014Ool00`00Oomoo`04Ool00ekgOomoo`0SOol2G_L7Ool00ekgOomo
o`0COol4O00@Ool6G_LEOol00`1GOomoo`0?Ool00ekgOomoo`0JOol00`00Oomoo`0eOol004Aoo`03
001oogoo009oo`9NmbAoo`9Nm`Yoo`03G_Moogoo01Ioo`=l00Uoo`ANm`Eoo`03G_Moogoo01=oo`03
05Moogoo00moo`03G_Moogoo01Yoo`03001oogoo03Eoo`00A7oo00D007ooOomooekg02Aoo`9Nm`ao
o`03G_Moogoo01Uoo`=l00=oo`=Nm`Uoo`03G_Moogoo01=oo`0305Moogoo00moo`03G_Moogoo01Yo
o`03001oogoo03Eoo`00A7oo00@007ooOomNmb=oo`9Nm`moo`03G_Moogoo01]oo`=l00eoo`03G_Mo
ogoo019oo`0305Moogoo00moo`03G_Moogoo01Yoo`03001oogoo03Eoo`00A7oo00<005kgG_L08Woo
0Ukg4Woo00=NmgooOol05Woo15kg0goo0g`02Woo00=NmgooOol04Woo00<0EgooOol03goo00=Nmgoo
Ool06Goo0P00=goo0014Ool00ekgOomoo`0POol2G_LDOol00ekgOomoo`0COol3G_L:Ool3O007Ool0
0ekgOomoo`0BOol00`1GOomoo`0?Ool00ekgOomoo`0JOol00`00Oomoo`0eOol004Aoo`03001oogoo
01ioo`9NmaMoo`03G_Moogoo00moo`=Nma1oo`=l00Eoo`03G_Moogoo015oo`0305Moogoo00moo`03
G_Moogoo01Yoo`03001oogoo03Eoo`00A7oo00<007ooOol077oo0Ukg6Woo00=NmgooOol02goo0ekg
5Woo0W`00goo00=NmgooOol04Goo00<0EgooOol03goo00=NmgooOol06Woo00<007ooOol0=Goo0014
Ool00`00Oomoo`0JOol2G_LMOol00ekgOomoo`08Ool2G_LKOol2O0000gooG_Moo`0BOol00`1GOomo
o`0?Ool00ekgOomoo`0JOol00`00Oomoo`0eOol004Aoo`03G_Moogoo01Qoo`9Nmamoo`03G_Moogoo
00Ioo`9Nmamoo`9l0003G_Moogoo011oo`0305Moogoo00moo`03G_Moogoo01Yoo`03001oogoo03Eo
o`00A7oo00<005kgOol05goo00=NmgooOol087oo00=NmgooOol00goo0Ukg8goo0g`047oo00<0Egoo
Ool03goo00=NmgooOol06Woo00<007ooOol0=Goo0014Ool01000OomNmekg5Goo00=NmgooOol08Woo
00=NmgooOol00Ukg9Goo00=NmgooOol00W`03Woo00<0EgooOol03goo00=NmgooOol06Woo00<007oo
Ool0=Goo0014Ool01@00OomoogooG_L04Woo0Ukg9Goo0ekg:7oo00ANmgooOomoo`9l00aoo`0305Mo
ogoo00moo`03G_Moogoo01Yoo`03001oogoo03Eoo`00A7oo0P000goo00=NmgooOol03Woo00=Nmgoo
Ool097oo0ekg:Goo00=NmgooOol00goo0W`02Woo00<0EgooOol03goo00=NmgooOol06Goo0P00=goo
0014Ool00`00Oomoo`03Ool00ekgOomoo`0<Ool00ekgOomoo`0SOol2G_L3Ool00ekgOomoo`0VOol0
0ekgOomoo`05Ool2O008Ool00`1GOomNm`0QG_L;Ool00`00Oomoo`0eOol004Aoo`03001oogoo00Ao
o`9Nm`]oo`03G_Moogoo029oo`9Nm`Ioo`03G_Moogoo02Ioo`03G_Moogoo00Ioo`9l00INm`0305MN
mgoo00moo`03G_Moogoo00moo`YNm`03Ool007oo03Ioo`00A7oo00<007ooOol01Woo00=NmgooOol0
1goo00=NmgooOol08Goo0Ukg27oo00=NmgooOol09Woo00=NmgooOol00Woo15kg0Woo0W`017oo00<0
EgooOol03goo00=NmgooOol06Goo00=Nm`00Ool0=Woo0014Ool00`00Oomoo`07Ool00ekgOomoo`04
Ool2G_LROol2G_L;Ool00ekgOomoo`0UOol5G_L8Ool2O002Ool00`1GOomoo`0?Ool00ekgOomoo`0J
Ool00`00Oomoo`0eOol004Aoo`03001oogoo00Qoo`03G_Moogoo009oo`03G_Moogoo021oo`9Nm`io
o`03G_Moogoo025oo`ENm`eoo`03O01oo`1G015oo`03G_Moogoo01Yoo`03001oogoo03Eoo`00A7oo
00<007ooOol02Goo00ANmgooOomNmb9oo`03G_Moogoo00ioo`03G_Moogoo01eoo`ANm`Aoo`03G_Mo
ogoo00aoo`9l015oo`03G_Moogoo01Yoo`03001oogoo03Eoo`00A7oo00<007ooOol02Woo0Ukg8Goo
0Ukg4Woo00=NmgooOol06Goo0ekg27oo00=NmgooOol037oo00@0EgooO01l00moo`03G_Moogoo01Yo
o`03001oogoo03Eoo`00A7oo00<007ooOol02Goo0Ukg00=ooekgOol07Goo0Ukg5Goo00=NmgooOol0
5Goo0ekg2goo00=NmgooOol037oo00@0EgooOomoo`9l00eoo`03G_Moogoo01Yoo`03001oogoo03Eo
o`00A7oo00<007ooOol027oo00=NmgooOol00Woo00=NmgooOol06Goo0Ukg5goo00=NmgooOol04Goo
15kg3goo00=NmgooOol02goo00<0MgooOol00goo0W`02goo00=NmgooOol06Woo00<007ooOol0=Goo
0014Ool20008Ool00ekgOomoo`04Ool00ekgOomoo`0FOol2G_LJOol00ekgOomoo`0=Ool3G_LCOol0
0ekgOomoo`0;Ool00`1gOomoo`05Ool00g`0Oomoo`08Ool00ekgOomoo`0IOol2000gOol004Aoo`03
001oogoo00Ioo`03G_Moogoo00Ioo`9NmaEoo`03G_Moogoo01]oo`03G_Moogoo00Uoo`=NmaIoo`03
G_Moogoo00]oo`0307Moogoo00Ioo`03O01oogoo00Moo`03G_Moogoo01Yoo`03001oogoo03Eoo`00
A7oo00<007ooOol01Goo00=NmgooOol02Goo00=NmgooOol047oo0Ukg7goo00=NmgooOol01Woo0Ukg
6Woo00=NmgooOol02Woo00<0MgooOol01goo0W`01goo00=NmgooOol06Woo00<007ooOol0=Goo0014
Ool00`00Oomoo`04Ool00ekgOomoo`0;Ool00ekgOomoo`0>Ool00ekgOomoo`0OOol00ekgOomoo`03
Ool3G_LLOol00ekgOomoo`0:Ool00`1gOomoo`09Ool00g`0Oomoo`04Ool00ekgOomoo`0JOol00`00
Oomoo`0eOol004Aoo`03001oogoo00=oo`03G_Moogoo00eoo`03G_Moogoo00aoo`03G_Moogoo025o
o`03G_Moogoo009Nmamoo`03G_Moogoo00Yoo`0307Moogoo00Yoo`03O01oogoo00=oo`03G_Moogoo
01Yoo`03001oogoo03Eoo`00A7oo00@007ooOomoo`9Nma5oo`9Nm`Yoo`9NmbAoo`=Nmb9oo`03G_Mo
ogoo00Uoo`0307Moogoo00]oo`03O01oogoo009oo`03G_Moogoo01Yoo`03001oogoo03Eoo`00A7oo
00@007ooOomNmaEoo`03G_Moogoo00Ioo`03G_Moogoo029oo`9Nm`03OomNmgoo029oo`03G_Moogoo
00Uoo`0307Moogoo00aoo`9l009oo`03G_Moogoo01Yoo`03001oogoo03Eoo`00?Goo1@000Woo00<0
07ooG_L05goo00=NmgooOol017oo00=NmgooOol08Goo0Ukg17oo00=NmgooOol087oo00=NmgooOol0
2Goo00<0MgooOol03Woo00=l07ooG_L077oo00<007ooOol0=Goo000oOol00`00Oomoo`02Ool00`00
G_Moo`0HOol015kgOomoogoo0Ukg8Woo0Ukg1goo00=NmgooOol087oo00=NmgooOol027oo00<0Mgoo
Ool03goo00=l05kgOol06goo00<007ooOol0=Goo000oOol00`00Oomoo`02Ool00ekg001oo`0IOol3
G_LSOol00ekgOomoo`08Ool00ekgOomoo`0OOol00ekgOomoo`08Ool00`1gOomoo`03OolL01l=Ool2
000gOol003Moo`@000Aoo`03001oogoo009oo`03001oogoo01Yoo`9Nmb5oo`9Nm`]oo`03G_Moogoo
01moo`03G_Moogoo00Aoo`X07`eoo`03G_Ml07`000aoo`T07`Eoo`03001oogoo01Uoo`]L015oo`00
?goo00<007ooOol00Woo00<007ooOol067oo0Ukg0Woo00=NmgooOol07Goo00=NmgooOol037oo00=N
mgooOol07goo00=Nmgoo01l00`0O17oo00<0MgooOol047oo00ANmgooOoml01Aoo`@07`03Ool007oo
01Yoo`]L0A5oo`00?Woo0P0017oo00<007ooOol05goo00=NmgooOol00goo00=NmgooOol06Woo0Ukg
47oo00=NmgooOol077oo100O27oo00<0MgooOol047oo00ENmgooOomoog`001Moo`0301l007oo01Yo
o`]L0PQoo`03001oogoo00Ioo`00A7oo00<007ooOol05Woo00=NmgooOol01Goo0Ukg67oo0Ukg4Woo
00=NmgooOol067oo100O0Woo00=NmgooOol01goo00<0MgooOol047oo00=NmgooOol00Woo00=l07oo
Ool05Goo00<007ooOol06Goo2e`34Goo0014Ool00`00Oomoo`0EOol00ekgOomoo`08Ool00ekgOomo
o`0DOol00ekgOomoo`0COol00ekgOomoo`0COol401l7Ool00ekgOomoo`05Ool00`1gOomoo`0AOol0
0ekgOomoo`03Ool00g`0Oomoo`0DOol00`00Oomoo`0IOol;G0@AOol004Aoo`03001oogoo01Aoo`03
G_Moogoo00Yoo`03G_Moogoo015oo`9NmaMoo`03G_Moogoo00moo`<07`]oo`03G_Moogoo00Eoo`03
07Moogoo015oo`03G_Moogoo00Aoo`03O01oogoo01=oo`03001oogoo01Uoo`]L1A5oo`00A7oo00<0
07ooOol04goo00=NmgooOol037oo00=NmgooOol03goo00=NmgooOol067oo00=NmgooOol02Woo100O
3Woo00=NmgooOol01Goo00<0UgooOol04Goo00=NmgooOol01Goo00=l07ooOol04Woo00<007ooOol0
6Goo2e`64Goo0014Ool00`00Oomoo`0BOol00ekgOomoo`0>Ool00ekgOomoo`0=Ool00ekgOomoo`0I
Ool00ekgOomoo`08Ool201lCOol00ekgOomoo`04Ool00`2GOomoo`0AOol00ekgOomoo`06Ool00g`0
Oomoo`0@Ool00ekg001oo`0JOol;G0LAOol004Aoo`80019oo`03G_Moogoo011oo`9Nm`]oo`9Nmaeo
o`03G_Moogoo00Eoo`807aEoo`03G_Moogoo00Aoo`0309Moogoo015oo`03G_Moogoo00Moo`9l011o
o`03G_L007oo01Yoo`]L215oo`00A7oo00<007ooOol047oo00=NmgooOol04goo00=NmgooOol01goo
00=NmgooOol07Woo00=NmgooOol00Woo0P0O5goo00=NmgooOol017oo00<0UgooOol04Goo00=Nmgoo
Ool02Goo00=l07ooOol03Goo00=Nm`00Ool06Woo2e`94Goo0014Ool00`00Oomoo`0?Ool00ekgOomo
o`0EOol00ekgOomoo`05Ool00ekgOomoo`0OOol00ekgOomoo`0201lJOol00ekgOomoo`03Ool00`2G
Oomoo`0AOol00ekgOomoo`0:Ool00g`0Oomoo`0;Ool00ekgOol0000KOol;G0XAOol004Aoo`03001o
ogoo00ioo`03G_Moogoo01Moo`03G_Moogoo009oo`9Nmb=oo`807aaoo`03G_Moogoo00=oo`0309Mo
ogoo015oo`03G_Moogoo00]oo`03O01oogoo00Yoo`03G_Moo`0001]oo`]L2a5oo`00A7oo00<007oo
Ool03Goo00=NmgooOol06Goo0Ukg00=ooekgOol08Woo0P0O00=ooekgOol06goo00=NmgooOol00goo
00<0UgooOol04Goo00=NmgooOol037oo00=l07ooOol02Goo00=Nmgoo00006goo2e`<4Goo0014Ool0
0`00Oomoo`0<Ool00ekgOomoo`0LOol00ekgOomoo`0POol201l3Ool00ekgOomoo`0KOol00ekgOomo
o`02Ool00`2GOomoo`0AOol00ekgOomoo`0=Ool00g`0Oomoo`07Ool015kgOomoo`006goo2e`=4Goo
0014Ool00`00Oomoo`0;Ool00ekgOomoo`0KOol2G_L00gooG_Moo`0NOol201l6Ool00ekgOomoo`0J
Ool00ekgOomoo`02Ool00`2GOomoo`0AOol00ekgOomoo`0>Ool00g`0Oomoo`06Ool015kgOomoo`00
6goo2e`>4Goo0014Ool00`00Oomoo`0:Ool00ekgOomoo`0KOol00ekgOomoo`02Ool00ekgOomoo`0J
Ool201l9Ool00ekgOomoo`0IOol00ekgOomoo`02Ool00`2GOomoo`0AOol00ekgOomoo`0?Ool00g`0
Oomoo`05Ool015kgOomoo`006goo2e`?4Goo0014Ool00`00Oomoo`09Ool00ekgOomoo`0KOol00ekg
Oomoo`04Ool2G_LIOol00`0OOomoo`0:Ool00ekgOomoo`0IOol01EkgOomoogoo09L04goo00=Nmgoo
Ool03goo00=l07ooOol017oo00ENmgooOomoo`0001]oo`]L3a5oo`00A7oo0P002Goo00=NmgooOol0
6goo00=NmgooOol01goo00=NmgooOol057oo0P0O3Goo00=NmgooOol06Goo00ANmgooOol0U`YooaIN
m`Moo`03O01oogoo00=oo`03G_Moogoo008001]oo`]L415oo`00A7oo00<007ooOol027oo00=Nmgoo
Ool06Woo00=NmgooOol02Goo00=NmgooOol04Goo0P0O47oo00=NmgooOol067oo00ANmgooOol0]`9o
o`QNm`Yoo`03G_Moogoo00Uoo`MNm`03Ooml07oo00=oo`05G_MoogooOol0000KOol;G18AOol004Ao
o`03001oogoo00Moo`03G_Moogoo01Yoo`03G_Moogoo00]oo`03G_Moogoo00ioo`807a=oo`03G_Mo
ogoo01Qoo`9Nm`030;MNmekg019oo`03G_Moogoo011oo`9Nm`04O01NmgooG_L4Ool00`00Oomoo`0I
Ool;G1<AOol004Aoo`03001oogoo00Ioo`03G_Moogoo01Yoo`03G_Moogoo00eoo`9Nm`eoo`0301mo
ogoo01=oo`03G_Moogoo01Eoo`ANm`03Ool0]goo01=oo`03G_Moogoo019oo`03O01ooekg00=Nm`9o
o`03001oogoo01Uoo`]L515oo`00A7oo00<007ooOol01Goo00=NmgooOol06Woo00=NmgooOol047oo
00=NmgooOol027oo0P0O5goo00=NmgooOol04Goo0ekg0goo00=Nmgoo0;L057oo00=NmgooOol04goo
00=l07ooG_L00Woo0Ukg00<007ooOol06Goo2e`D4Goo0014Ool00`00Oomoo`05Ool00ekgOomoo`0I
Ool00ekgOomoo`0BOol00ekgOomoo`06Ool00`0OOomoo`0HOol00ekgOomoo`0=Ool3G_L7Ool00ekg
0;Moo`0COol00ekgOomoo`0DOol00g`0Oomoo`03Ool00`00Oomoo`0IOol;G1DAOol004Aoo`03001o
ogoo00Aoo`03G_Moogoo01Uoo`03G_Moogoo01Aoo`03G_Moogoo00Aoo`0301moogoo01Yoo`03G_Mo
ogoo00Qoo`ANm`Yoo`030;Moogoo01=oo`03G_Moogoo01Aoo`03O01oogoo00=oo`03001oogoo01Uo
o`]L5Q5oo`00A7oo0Ukg17oo00=NmgooOol06Goo00=NmgooOol05Woo00ANmgooOomoo`807aeoo`03
G_Moogoo00Eoo`=Nm`ioo`030;Moogoo01=oo`03G_Moogoo01Aoo`03G_Ml07oo00=oo`03001oogoo
01Uoo`]L5a5oo`00A7oo00H007ooG_MNmgooG_LKOol00ekgOomoo`0HOol2G_L00`0OOomoo`0NOol0
0ekgOomoo`02Ool2G_LAOol00`2gG_Moo`0COol00ekgOomoo`0COol015kgOomoog`00goo00<007oo
Ool06Goo2e`G4Goo0014Ool20002Ool2G_LJOol00ekgOomoo`0IOol201l00ekgOomoo`0OOol4G_LC
Ool00`2gG_Moo`0COol00ekgOomoo`0COol01UkgOomoogooO01oo`8001]oo`]H5a5oo`00A7oo00H0
07ooOomooekgOol2G_LGOol00ekgOomoo`0IOol01@0OOomoogooG_L07goo0Ukg5Woo00<0]ekgOol0
4goo00=NmgooOol04Woo00=NmgooOol00Woo00Al07ooOol001]oo`]D5a5oo`00A7oo00@007ooOomN
m`Aoo`9NmaAoo`03G_Moogoo01Uoo`0301moogoo00=oo`03G_Moogoo01Yoo`9Nm`9oo`03G_Moogoo
019oo`040;MoogooG_LCOol00ekgOomoo`0BOol00ekgOomoo`03Ool00g`0Ool0000KOol;D1LAOol0
04Aoo`03001ooekg00Moo`9Nm`Qooa83h1=oo`0301moogoo00Eoo`9NmaQoo`9Nm`Eoo`03G_Moogoo
015oo`040=MoogooG_LCOol00ekgOomoo`0BOol00ekgOomoo`04Ool00g`0001oo`0JOol;C1LAOol0
04Aoo`03001ooekg00Uoo`P3h0Uoo`03G_Moogoo00Ioo`P3h0Yoo`0301moogoo00Qoo`03G_Moogoo
01Aoo`03G_Moogoo00Ioo`03G_Moogoo011oo`040=MoogooG_LCOol00ekgOomoo`0AOol00ekgOomo
o`06Ool00`00Oomoo`0IOol;B1LAOol004Aoo`03001Nmgoo00Eoo`@3h09oo`=Nm`]oo`03G_Moogoo
00moo`@3h0Eoo`0301moogoo00Yoo`03G_Moogoo015oo`9Nm`Uoo`03G_Moogoo011oo`050=Moogoo
OomNm`0BOol00ekgOomoo`0AOol00ekgOomoo`06Ool00`00Oomoo`0IOol;A1LAOol004Aoo`04001N
mgooOol40n09Ool2G_L8Ool00ekgOomoo`0DOol40n000`0OOomoo`0<Ool00ekgOomoo`0?Ool00ekg
Oomoo`0:Ool00ekgOomoo`0?Ool01@3GOomoogooG_L04Woo00=NmgooOol04Goo00=NmgooOol01Woo
00<007ooOol06Goo2d0G4Goo0014Ool015kgOol3h0?P3goo0Ukg1Goo00=NmgooOol067oo00@07`?P
0n03h0eoo`9Nm`eoo`9Nm`ioo`03G_Moogoo00eoo`030=Moogoo009oo`03G_Moogoo011oo`03G_Mo
ogoo011oo`03G_Moogoo00Moo`03001oogoo01Uoo`/l5a5oo`00A7oo0P?P4goo0Ukg0Woo00=Nmgoo
Ool067oo00<07gooOol00Woo0`?P37oo00=NmgooOol02Goo00=NmgooOol03Woo00=NmgooOol03Goo
00<0egooOol00goo00=NmgooOol03goo00=NmgooOol047oo00=NmgooOol01goo00<007ooOol06Goo
2cPG4Goo0014Ool2000EOol3G_LIOol00`0OOomoo`06Ool20n0;Ool00ekgOomoo`07Ool00ekgOomo
o`0@Ool00ekgOomoo`0<Ool00`3GOomoo`03Ool00ekgOomoo`08Ool@G_L:Ool00ekgOomoo`06Ool2
000KOol;=1LAOol004Aoo`03001oogoo01Eoo`=NmaMoo`0301moogoo00Uoo`83h0Yoo`03G_Moogoo
00Aoo`9NmaAoo`03G_Moogoo00]oo`030?Moogoo00=oo`04G_MoogooOol7G_L7Ool00ekgOomoo`06
Ool6G_L3Ool00ekgOomoo`08Ool00`00Oomoo`0IOol;<1LAOol004Aoo`03001oogoo01Aoo`04G_Mo
ogooOol2G_LDOol00`0OOomoo`0<Ool20n09Ool2G_L3Ool00ekgOomoo`0DOol00ekgOomoo`0:Ool0
0`3gOomoo`04Ool4G_L>Ool00ekgOomoo`0<Ool4G_L:Ool00`00Oomoo`0IOol;;1LAOol004Aoo`03
001oogoo01=oo`03G_Moogoo00Aoo`9Nma5oo`0301moogoo00moo`83h0Uoo`03G_Mooekg01Qoo`03
G_Moogoo00Uoo`030?Moogoo00ANm`03OomNmgoo00moo`03G_Moogoo00moo`ENm`Ioo`03001oogoo
01Uoo`//5a5oo`00A7oo00<007ooOol04goo00=NmgooOol01Woo0ekg3Woo00<07gooOol04Goo0P?P
1goo0Ukg6Woo00=NmgooOol01goo00ANm`3gG_MNm`Eoo`03G_Moogoo00ioo`03G_Moogoo00ioo`03
G_Moogoo00=oo`ANm`9oo`03001oogoo01Uoo`/T5a5oo`00A7oo00<007ooOol04Woo00=NmgooOol0
2Woo0Ukg2goo00<07gooOol057oo0P?P17oo00ANmgooOomNmaYoo`03G_Moogoo00Aoo`9Nm`03Ool0
mgoo00Moo`03G_Moogoo00eoo`03G_Moogoo00ioo`03G_Moogoo00Moo`9Nm`03001oogoo01Uoo`/P
5a5oo`00A7oo00<007ooOol04Woo00=NmgooOol037oo0Ukg27oo00<07gooOol05goo0P?P00=ooekg
Ool00goo0Ukg67oo00=NmgooOol00Woo0Ukg0Woo00<15gooOol01goo00=NmgooOol03Goo00=Nmgoo
Ool03Woo00=NmgooOol02Goo00<007ooOol06Goo2a`G4Goo000bOol20004Ool20004Ool20004Ool0
0`00Oomoo`0AOol00ekgOomoo`0?Ool2G_L5Ool00`0OOomoo`0JOol20n06Ool00ekgOomoo`0FOol0
15kgOomNmekg17oo00<15gooOol01goo00=NmgooOol03Goo00=NmgooOol03Goo00=NmgooOol02Woo
00<007ooOol06Goo2aPG4Goo000aOol01000Oomoo`0027oo00@007ooOol000=oo`03001oogoo011o
o`03G_Moogoo019oo`9Nm`9oo`0301moogoo01Yoo`04G_Moogoo0n06Ool00ekgOomoo`0EOol2G_L6
Ool00`4GOomoo`08Ool00ekgOomoo`0<Ool00ekgOomoo`0=Ool00ekgOomoo`0:Ool00`00Oomoo`0I
Ool;61LAOol0035oo`04001oogoo000;Ool01000Oomoogoo0P004Goo00=NmgooOol057oo0Ukg00<0
7gooOol067oo0Ukg17oo0P?P1Goo00=NmgooOol04Woo0Ukg00=ooekgOol017oo00<15gooOol02Goo
00=NmgooOol037oo00=NmgooOol03Goo00=NmgooOol02Goo0P006goo2a@G4Goo000[Ool40002Ool0
1000Oomoo`002Goo0P0017oo00<007ooOol03goo00=NmgooOol05Woo00<07ekgG_L067oo00=Nmgoo
Ool01Woo00<3h7ooOol00goo00=NmgooOol03goo0Ukg17oo00=NmgooOol00Woo00<15gooOol02Goo
00=NmgooOol037oo00=NmgooOol037oo00=NmgooOol02goo00<007ooOol06Goo2a0G4Goo000aOol0
1000Oomoo`002Goo00<007ooOol00goo00<007ooOol03Woo00=NmgooOol05Woo00@07gooOomoo`=N
maAoo`03G_Moogoo00Qoo`030n1oogoo00=oo`9Nm`eoo`9Nm`Moo`05G_MoogooOol1=`0<Ool00ekg
Oomoo`0;Ool00ekgOomoo`0<Ool00ekgOomoo`0;Ool00`00Oomoo`0IOol;31LAOol0039oo`8000Yo
o`<000=oo`03001oogoo00ioo`03G_Moogoo01Eoo`0301moogoo00Eoo`9Nma5oo`03G_Moogoo00Yo
o`83h0Eoo`03G_Moogoo00Qoo`9Nm`Yoo`03G_Moo`4g00eoo`03G_Moogoo00]oo`03G_Moogoo00ao
o`03G_Moogoo00]oo`03001oogoo01Uoo`/85a5oo`00A7oo00<007ooOol03Goo00=NmgooOol05Woo
00<07gooOol01goo0Ukg3Woo00=NmgooOol03Goo00<3h7ooOol00goo00=NmgooOol01Woo00=Nmgoo
Ool02Woo00=Nmgoo0CL03Goo00=NmgooOol02goo00=NmgooOol02goo00=NmgooOol037oo00<007oo
Ool06Goo2`@G4Goo0014Ool00`00Oomoo`0=Ool00ekgOomoo`0EOol00`0OOomoo`0:Ool2G_L;Ool0
0ekgOomoo`0?Ool00`?POomoo`03Ool00ekgOomoo`04Ool00ekgOomoo`0<Ool00ekg0CMoo`0=Ool0
0ekgOomoo`0:Ool00ekgOomoo`0;Ool00ekgOomoo`0<Ool00`00Oomoo`0IOol;01LAOol004Aoo`03
001oogoo00aoo`03G_Moogoo01Ioo`0301moogoo00aoo`9Nm`Uoo`03G_Moogoo011oo`030n1oogoo
00=oo`9Nm`=oo`03G_Moogoo00eoo`030EMNmgoo00eoo`03G_Moogoo00Yoo`03G_Moogoo00]oo`03
G_Moogoo00aoo`03001oogoo01Uoo`/05a5oo`00A7oo00<007ooOol037oo00=NmgooOol05Goo00<0
7gooOol03goo0Ukg1Woo00=NmgooOol04Woo00<3h7ooOol017oo0ekg47oo00<1EekgOol03Goo00=N
mgooOol02Woo00=NmgooOol02Woo00=NmgooOol037oo00=Nm`00Ool06Woo2`0g4Goo0014Ool00`00
Oomoo`0;Ool00ekgOomoo`0EOol00`0OOomoo`0BOol2G_L3Ool00ekgOomoo`0DOol00`?POomoo`03
Ool2G_LAOol00`5GOomNm`0>Ool00ekgOomoo`09Ool00ekgOomoo`0:Ool00ekgOomoo`0<Ool00ekg
001oo`0JOol;05LAOol004Aoo`8000aoo`03G_Moogoo01Eoo`0301moogoo01Aoo`=NmaQoo`050n1o
ogooOomNm`02Ool00ekgOomoo`0=Ool01@5GOomoogooG_L03Goo00=NmgooOol02Goo00=NmgooOol0
2Woo00=NmgooOol02goo00=Nm`0000006goo2`1g4Goo0014Ool00`00Oomoo`0:Ool00ekgOomoo`0E
Ool00`0OOomoo`0GOol3G_LGOol00`?POomNm`04Ool2G_L=Ool00`5GOomoo`02Ool00ekgOomoo`0:
Ool00ekgOomNm`0FG_L=Ool015kgOomoo`006goo2`2G4Goo0014Ool00`00Oomoo`0:Ool00ekgOomo
o`0EOol00`0OOomoo`0FOol015kgOomoogoo0Ukg5Woo00<3h7ooOol01Goo00=NmgooOol02Woo00<1
EgooOol00Woo00=NmgooOol01goo1Ekg2Woo00=NmgooOol02Goo15kg2Goo00ENmgooOomoo`0001]o
o`/0]a5oo`00A7oo00<007ooOol02Woo00=NmgooOol057oo00<07gooOol05Woo00=NmgooOol017oo
0Ukg4goo00=Nm`?POol01goo00=NmgooOol027oo00<1MgooOol017oo00=NmgooOol017oo0Ukg17oo
00=NmgooOol027oo00=NmgooOol02Goo00ANmgooOomoo`=Nm`Ioo`05G_MoogooOol0000KOol;0=LA
Ool004Aoo`03001oogoo00Uoo`03G_Moogoo01Eoo`0301moogoo01Ioo`03G_Moogoo00Ioo`9Nma1o
o`04G_Moogoo0n08Ool00ekgOomoo`07Ool00`5gOomoo`05Ool00ekgOomoo`03G_L6Ool00ekgOomo
o`08Ool00ekgOomoo`08Ool00ekgOomoo`05Ool3G_L2Ool00ekgOomoo`02Ool00`00Oomoo`0IOol;
0?LAOol004Aoo`03001oogoo00Uoo`03G_Moogoo01Aoo`0301moogoo01Ioo`03G_Moogoo00Uoo`9N
m`eoo`03G_Moogoo009oo`030n1oogoo00Ioo`9Nm`Ioo`030GMoogoo00Ioo`=Nm`Uoo`03G_Moogoo
00Qoo`03G_Moogoo00Qoo`03G_Moogoo00Qoo`9Nm`Eoo`03001oogoo01Uoo`/15a5oo`00A7oo0ekg
2Goo00=NmgooOol057oo00<07gooOol05Goo00=NmgooOol037oo0Ukg2Woo00=NmgooOol017oo00<3
h7ooOol01goo00=NmgooOol00goo00<1MgooOol01Goo0ekg2goo00=NmgooOol01goo00=NmgooOol0
27oo00=NmgooOol027oo00ANmgooG_MNm`=oo`03001oogoo01Uoo`/1=a5oo`00A7oo00<007ooOol0
15kg17oo00=NmgooOol05Goo00<07gooOol05Goo00=NmgooOol03Woo0Ukg1goo00=NmgooOol01Goo
00<3h7ooOol027oo00=NmgooOol00Woo00<1UgooOol017oo00ENmgooOomooekg00Yoo`03G_Moogoo
00Moo`03G_Moogoo00Moo`03G_Moogoo00Uoo`05G_MoogooOomNm`02Ool00`00Oomoo`0IOol;0ELA
Ool004Aoo`03001oogoo00Aoo`ENmaIoo`0301moogoo01Eoo`03G_Moogoo015oo`=Nm`=oo`03G_Mo
ogoo00Moo`030n1oogoo00Qoo`05G_MoogooOol1U`04Ool2G_L4Ool00ekgOomoo`08Ool00ekgOomo
o`07Ool00ekgOomoo`07Ool00ekgOomoo`08Ool00ekgOomoo`03Ool2G_L00`00Oomoo`0IOol;0GLA
Ool004Aoo`03001oogoo00Moo`03G_Mooekg00=Nma9oo`0301moogoo01Eoo`03G_Moogoo01Aoo`9N
m`03OomNmgoo00Uoo`030n1oogoo00Qoo`03G_Moo`6G00Aoo`03G_Moogoo00Eoo`03G_Moogoo00Qo
o`03G_Moogoo00Ioo`03G_Moogoo00Moo`03G_Moogoo00Moo`03G_Moogoo00Ioo`03001oogoo01Uo
o`/1Ua5oo`00A7oo0P0027oo00=NmgooOol00goo1Ekg37oo00<07gooOol05Goo00=NmgooOol05goo
0Ukg2Woo00<3h7ooOol02Goo00ANm`6gOomoo`9Nm`Uoo`03G_Moogoo00Moo`03G_Moogoo00Ioo`03
G_Moogoo00Ioo`03G_Moogoo00Qoo`03G_Moogoo00Eoo`8001]oo`/1]a5oo`00A7oo00<007ooOol0
1goo00=NmgooOol027oo1Ekg1goo00<07gooOol05Goo00=NmgooOol05Woo00=NmgooOol00Ukg2Goo
00<3h7ooOol02Goo00<1]ekgG_L037oo00=NmgooOol01Woo00=NmgooOol01Woo00=NmgooOol01Woo
00=NmgooOol01goo00=NmgooOol01goo00<007ooOol06Goo2`6g4Goo0014Ool00`00Oomoo`07Ool0
0ekgOomoo`0=Ool4G_L3Ool00`0OOomoo`0DOol00ekgOomoo`0FOol00ekgOomoo`03Ool2G_L7Ool0
0`?POomoo`09Ool00`6gOomNm`0<Ool00ekgOomoo`07Ool00ekgOomoo`05Ool00ekgOomoo`06Ool0
0ekgOomoo`06Ool00ekgOomoo`08Ool00`00Oomoo`0IOol;0MLAOol004Aoo`03001oogoo00Ioo`03
G_Moogoo019oo`9Nm`0301mNmekg01Eoo`03G_Moogoo01Ioo`03G_Moogoo00Eoo`9Nm`Ioo`030n1o
ogoo00Moo`050KMoogooOomNm`0<Ool00ekgOomoo`06Ool00ekgOomoo`05Ool00ekgOomoo`05Ool0
0ekgOomoo`06Ool00ekgOomoo`09Ool00`00Oomoo`0IOol;0OLAOol004Aoo`03001oogoo00Ioo`03
G_Moogoo01Aoo`0301moogoo00ANma5oo`03G_Moogoo01Eoo`03G_Moogoo00Qoo`9Nm`Aoo`030n1o
ogoo00Ioo`03G_L1egoo00=oo`9Nm`]oo`03G_Moogoo00Eoo`03G_Moogoo00Eoo`03G_Moogoo00Eo
o`03G_Moogoo00Ioo`03G_Moogoo00Uoo`03001oogoo01Uoo`/25a5oo`00A7oo00<007ooOol01Woo
00=NmgooOol057oo00<07gooOol017oo1Ekg2goo00=NmgooOol05Goo00=NmgooOol02goo0ekg0Woo
00<3h7ooOol01Goo00=Nm`7GOol01Goo00=NmgooOol027oo00=NmgooOol01Woo00=NmgooOol017oo
00=NmgooOol01Goo00=NmgooOol01Goo00=NmgooOol02Goo00=Nm`00Ool06Woo2`8g4Goo0014Ool0
0`00Oomoo`06Ool00ekgOomoo`0COol00`0OOomoo`0:Ool4G_L7Ool00ekgOomoo`0EOol00ekgOomo
o`0>Ool2G_L00`?POomoo`04Ool00ekgOol1e`07Ool00ekgOomoo`08Ool00ekgOomoo`05Ool00ekg
Oomoo`04Ool00ekgOomoo`04Ool00ekgOomoo`05Ool00ekgOomoo`08Ool2G_L00goo001oo`0JOol;
0ULAOol004Aoo`03001oogoo00Eoo`03G_Moogoo01Aoo`0301moogoo00ioo`ENm`9oo`03G_Moogoo
01Aoo`03G_Moogoo015oo`03G_L3h7oo00=oo`04G_Moogoo0ML8Ool00ekgOomoo`08Ool00ekgOomo
o`04Ool00ekgOomoo`04Ool00ekgOomoo`04Ool00ekgOomoo`04Ool00ekgOomoo`08Ool01EkgOomo
ogoo00006goo2`9g4Goo0014Ool00`00Oomoo`05Ool00ekgOomoo`0DOol00`0OOomoo`0COol4G_LE
Ool00ekgOomoo`0BOol01@?PG_MNmgooG_L00goo00<1mgooOol01goo0Ukg2Goo00=NmgooOol017oo
00=NmgooOol00goo00=NmgooOol00goo00=NmgooOol01Goo00=NmgooOol01goo00=NmgooOol00Woo
00<007ooOol06Goo2`:G4Goo0014Ool20006Ool00ekgOomoo`0DOol00`0OOomoo`0DOol00ekgOomo
o`05G_L?Ool00ekgOomoo`0DOol010?POomNmekg0goo00<1mgooOol02Goo00=NmgooOol01Woo00=N
mgooOol017oo3Ekg1Woo00=NmgooOol01goo00=NmgooOol00Woo0P006goo2`:g4Goo0014Ool00`00
Oomoo`05Ool00ekgOomoo`0COol00`0OOomoo`0EOol00ekgOomoo`05Ool4G_L;Ool00ekgOomoo`0D
Ool010?PG_Moogoo0Ukg00=oo`7gOol02goo00=NmgooOol01Woo00=NmgooOol015kg1Goo00=Nmgoo
Ool00goo1Ekg00=ooekgOol01goo0Ukg1Woo00<007ooOol06Goo2`;G4Goo0014Ool00`00Oomoo`04
Ool00ekgOomoo`0DOol00`0OOomoo`0EOol00ekgOomoo`09Ool5G_L6Ool00ekgOomoo`0EOol00`?P
Oomoo`02Ool00ekg0OMoo`0<Ool00ekgOomoo`06Ool2G_L4Ool00ekgOomoo`02Ool00ekgOomoo`02
Ool00ekgOomoo`03Ool2G_L7Ool00ekgOomoo`06Ool00`00Oomoo`0IOol;0_LAOol004Aoo`03001o
ogoo00Aoo`03G_Moogoo01Aoo`0301moogoo01Aoo`03G_Moogoo00moo`INmaMoo`03G_L3h7oo00Ao
o`040OMNmekgG_L;Ool2G_L5Ool2G_L5Ool00ekgOomoo`02Ool00ekgOomoo`02Ool00ekgOomoo`03
Ool00ekgOomNm`05Ool00ekgOomoo`07Ool00`00Oomoo`0IOol;0_LAOol004Aoo`03001oogoo00Ao
o`03G_Moogoo01Aoo`0301moogoo01Aoo`03G_Moogoo01Aoo`ANmaAoo`03G_L3h7oo00Aoo`040QMo
ogooOol2G_L;Ool00ekgOomoo`02G_L2Ool00ekgOomoo`02Ool00ekgOomoo`02Ool00ekgOomoo`02
Ool00ekgOomoo`02Ool015kgOomoogoo0Ukg0Woo00=NmgooOol027oo00<007ooOol06Goo2`;f4Goo
0014Ool00`00Oomoo`04Ool00ekgOomoo`0COol00`0OOomoo`0EOol00ekgOomoo`0DOol015kgOomo
ogoo1Ekg3Woo00ANmgooOol3h0Aoo`030QMoogoo00=oo`9Nm`Yoo`9Nm`Eoo`03G_Moogoo009oo`05
G_MoogooOomNm`03Ool00ekgOomoo`02Ool00ekgOomoo`04Ool2G_L:Ool00ekg001oo`0JOol;0_DA
Ool004Aoo`03001oogoo00Aoo`03G_Moogoo01=oo`0301moogoo01Eoo`03G_Moogoo01=oo`03G_Mo
ogoo00Moo`ANm`Yoo`04G_Moogoo0n04Ool00`8GOomoo`05Ool2G_L8Ool2G_L6Ool01EkgOomoogoo
G_L00goo00ENmgooOomooekg00Aoo`03G_Moogoo00=oo`03G_Mooekg00Qoo`9Nm`03Ool007oo01Yo
o`/2m15oo`00A7oo00<007ooOol017oo00=NmgooOol04goo00<07gooOol057oo00=NmgooOol057oo
00=NmgooOol02goo1Ekg17oo00ENmgooOomoo`?P00Aoo`030SMoogoo00Moo`9Nm`Aoo`9Nm`9oo`9N
m`Aoo`05G_MoogooOomNm`03Ool01EkgOomoogooG_L00goo00=NmgooOol00goo00ANmgooOomoo`9N
m`Aoo`9Nm`=oo`03001oogoo01Uoo`/2la5oo`00A7oo00<007ooOol017oo00=NmgooOol04goo00<0
7gooOol057oo00=NmgooOol057oo00=NmgooOol047oo1Ekg0goo00<3h7ooOol00goo00<2=gooOol0
27oo0Ukg00=ooekgOol01Goo00=NmgooOol00Woo00ENmgooOomooekg009oo`04G_MoogooG_L3Ool0
0ekgOomoo`02Ool2G_L5Ool00ekgOomoo`02G_L5Ool00`00Oomoo`0IOol;0_8AOol004Aoo`8000Eo
o`03G_Moogoo01=oo`0301moogoo01Aoo`03G_Moogoo01Aoo`03G_Moogoo01Aoo`ENm`030n1oogoo
009oo`030SMoogoo00Yoo`9Nm`Moo`03G_Moogoo009oo`04G_MoogooG_L2Ool015kgOomooekg0goo
00ENmgooOomooekg00Moo`=Nm`Ioo`8001]oo`/2lA5oo`00A7oo00<007ooOol017oo00=NmgooOol0
4goo00<07gooOol057oo00=NmgooOol04goo00=NmgooOol05Goo00=NmgooOol00Woo00H3h5kgG_MN
mgoo0UL<Ool015kgOomNmekg0goo00=L4e`BG1800U`A0U`@00ANmgooOomNm`9oo`04G_MoogooG_L2
Ool01EkgOomoogooG_L01Woo0Ukg00=ooekgOol01goo00<007ooOol06Goo2`;`4Goo0014Ool00`00
Oomoo`03Ool00ekgOomoo`0DOol00`0OOomoo`0DOol00ekgOomoo`0COol00ekgOomoo`0DOol00ekg
Oomoo`03Ool010?POomoogoo0Ukg00<2EekgG_L027oo00ENmgooOomooe`D00=L4`Aoo`04G_Mooe`?
G0l2G0h01WooG_MooekgOomNm`9oo`05G_MoogooOomNm`05Ool2G_L4Ool00ekgOomoo`05Ool00`00
Oomoo`0IOol;0^lAOol004Aoo`03001oogoo00=oo`03G_Moogoo01Aoo`0301moogoo01Aoo`03G_Mo
ogoo01=oo`03G_Moogoo01Aoo`03G_Moogoo00=oo`030n1oogoo00=oo`030UMoogoo00ANm`Aoo`04
G_ML5E`EG1@4Ool2G_L3Ool2G_L2Ool2G0d01e`<OomNmgooG_Mooekg009oo`9Nm`Aoo`9Nm`Ioo`03
G_Moogoo00=oo`9Nm`03001oogoo01Uoo`/2kQ5oo`00A7oo00<007ooOol00goo00=NmgooOol04goo
00<07gooOol05Goo00=NmgooOol04goo00=NmgooOol057oo00=NmgooOol00goo00<3h7ooOol017oo
00<2MgooOol00goo0ekg0U`F2Goo0Ukg0goo00eNmgooG_Mooe`<G0]NmgooG_MooekgOomNm`04Ool2
G_L9Ool5G_L2Ool00`00Oomoo`0IOol;0^dAOol001Qoo`80009oo`<000=oo`80021oo`03001oogoo
00=oo`03G_Moogoo01=oo`0301moogoo01Aoo`03G_Moogoo01Aoo`03G_Moogoo01Aoo`03G_Moogoo
00=oo`030n1oogoo00Aoo`030WMoogoo00Eoo`03G1Iooekg00ENm`Ioo`9Nm`9oo`0;G_MooekgOomL
2U`9G_MooekgOomNm`02Ool3G_L6Ool6G_L6Ool00`00Oomoo`0IOol;0^dAOol001Qoo`03001oogoo
00Aoo`05001oogooOol0000POol00`00Oomoo`03Ool00ekgOomoo`0COol00`0OOomoo`0DOol00ekg
Oomoo`0DOol00ekgOomoo`0DOol00ekgOomoo`04Ool00`?POomoo`04Ool00`9gOomoo`02Ool2G1L0
0gooG_Moo`05Ool4G_L4Ool2G_L00gooG_Moo`02G_L01U`8G_MNmgooG_Moo`9Nm`Eoo`ANm`Ioo`03
G_Moogoo00=oo`03001oogoo01Uoo`/2k15oo`002Woo0`0000Moo`00001oo`00Ool00004Ool00`00
Oomoo`02Ool30003Ool00`00Oomoo`0HOol20004Ool00`00Oomoo`03Ool00ekgOomoo`0COol00`0O
Oomoo`0DOol00ekgOomoo`0DOol00ekgOomoo`0COol00ekgOomoo`05Ool00`?POomoo`04Ool010:G
Oomoogoo0U`G0Woo00=NmgooOol027oo1Ekg00=ooekgG_L00ekg00=L1U`5G_L00ekg0Woo1Ekg2Woo
00=NmgooOol00goo00<007ooOol06Goo2`;[4Goo000;Ool02@00Oomoogoo001oo`00Ool00004Ool0
1@00Oomoogoo00000Woo00D007ooOomoo`0001Uoo`04001oogoo0003Ool00`00Oomoo`03Ool00ekg
Oomoo`0COol00`0OOomoo`0DOol00ekgOomoo`0DOol00ekgOomoo`0COol00ekgOomoo`05Ool00`?P
Oomoo`05Ool20YL00e`GOomoo`02Ool00ekgOomoo`0=Ool7G_L00e`3G_MNm`04G_L?Ool00ekgOomo
o`03Ool00`00Oomoo`0IOol;0^XAOol000]oo`09001oogooOol007oo001oo`0000Aoo`05001oogoo
Ool00002Ool01@00Oomoogoo00006Goo00@007ooOol000=ooaaNm`0301mNmekg04UNm`030n1Nmekg
00INm`030YMNmekg03INm`03001oogoo01Uoo`/2jA5oo`002goo00<007ooOol00`0000=oo`00Ool0
17oo00<007ooOol00Woo10000Woo00<007ooOol05goo00@007ooOol000=oo`03001oogoo00=oo`03
G_Moogoo01=oo`0301moogoo01Aoo`03G_Moogoo01Aoo`03G_Moogoo01=oo`03G_Moogoo00Eoo`03
0n1oogoo00Eoo`03F1ML5`:g00Aoo`03G_Moogoo00eoo`MNm`030^9Nmekg00ANm`moo`03G_Moogoo
00=oo`03001oogoo01Uoo`/2j15oo`002goo00<007ooOol02Woo00<007ooOol027oo00<007ooOol0
5goo00@007ooOol000=oo`03001oogoo00=oo`03G_Moogoo01=oo`0301moogoo01Aoo`03G_Moogoo
01Aoo`03G_Moogoo01=oo`03G_Moogoo00Eoo`030n1oogoo00Aoo`04F1MoogooOol20[L2Ool00ekg
Oomoo`08Ool5G_L00gooG_MNm`03G_L00`;X0^ENm`03G_L2Ool5G_L:Ool00ekgOomoo`03Ool00`00
Oomoo`0IOol;0^LAOol000Yoo`<000]oo`8000Qoo`8001Yoo`8000Aoo`03001oogoo00=oo`03G_Mo
ogoo01=oo`0301moogoo01Aoo`03G_Moogoo01Aoo`03G_Moogoo01Aoo`03G_Moogoo00Aoo`030n1o
ogoo00Aoo`03F1Moogoo009oo`040]MoogooG_L6Ool4G_L4Ool2G_L00gooG_Moo`02G_L01P;XG_MN
mgooG_Moo`9Nm`Eoo`ANm`Ioo`03G_Moogoo00=oo`03001oogoo01Uoo`/2iQ5oo`00A7oo00<007oo
Ool00goo00=NmgooOol04goo00<07gooOol057oo00=NmgooOol057oo00=NmgooOol057oo00=Nmgoo
Ool00goo00<3h7ooOol017oo00=D5gooOol017oo0P;G00=ooekgG_L015kg1Woo0Ukg0Woo00]Nmgoo
G_Moo`;/0^]NmgooG_Mooekg009oo`=Nm`Ioo`INm`Ioo`03001oogoo01Uoo`/2iA5oo`00A7oo00<0
07ooOol00goo00=NmgooOol04goo00<07gooOol05Goo00=NmgooOol04goo00=NmgooOol057oo00=N
mgooOol00goo00<3h7ooOol017oo00=D5gooOol00goo0ekg0P;g2Goo0Ukg0goo00eNmgooG_Moo`;]
0^aNmgooG_MooekgOomNm`04Ool2G_L9Ool5G_L2Ool00`00Oomoo`0IOol;0^@AOol004Aoo`03001o
ogoo00=oo`03G_Moogoo01Aoo`0301moogoo01Aoo`03G_Moogoo01=oo`03G_Moogoo01Aoo`03G_Mo
ogoo00=oo`030n1oogoo00=oo`03E1Moogoo00ANm`Aoo`03G_L2m`;g00Eoo`9Nm`=oo`9Nm`9oo`09
0_02k`;^OomNmgooG_Mooekg009oo`9Nm`Aoo`9Nm`Ioo`03G_Moogoo00=oo`9Nm`03001oogoo01Uo
o`/2h`=oo`8000aoo`00A7oo00<007ooOol00goo00=NmgooOol057oo00<07gooOol057oo00=Nmgoo
Ool04goo00=NmgooOol057oo00=NmgooOol00goo00@3h7ooOomoo`9Nm`03D1MNmekg00Qoo`04G_Mo
ogoo0_L30_H00ekgOomoo`02Ool015kgOol2lP;a0P;`00IooekgOomNmgooG_L2Ool01EkgOomoogoo
G_L01Goo0Ukg17oo00=NmgooOol01Goo00<007ooOol06Goo2`;R0Woo00@007ooOol000]oo`00A7oo
00<007ooOol017oo00=NmgooOol04goo00<07gooOol057oo00=NmgooOol04goo00=NmgooOol05Goo
00=NmgooOol00Woo00H3h5kgG_MNmgooD1L<Ool015kgOomNmekg0Woo0P;e0P;d0P;c0P;b00ANmgoo
OomNm`9oo`04G_MoogooG_L2Ool01EkgOomoogooG_L01Woo0Ukg00=ooekgOol01goo00<007ooOol0
6Goo2P;R1Goo00<007ooOol02Woo0014Ool20005Ool00ekgOomoo`0COol00`0OOomoo`0DOol00ekg
Oomoo`0DOol00ekgOomoo`0DOol5G_L00`?POomoo`02Ool00e0GOomoo`0:Ool2G_L7Ool00ekgOomo
o`02Ool015kgOomooekg0Woo00ANmgooOomNm`=oo`05G_MoogooOomNm`07Ool3G_L6Ool2000gOol0
04Aoo`03001oogoo00Aoo`03G_Moogoo01=oo`0301moogoo01Aoo`03G_Moogoo01Aoo`03G_Moogoo
011oo`ENm`=oo`030n1oogoo00=oo`03C1Moogoo00Qoo`9Nm`03OomNmgoo00Eoo`03G_Moogoo009o
o`05G_MoogooOomNm`02Ool015kgOomooekg0goo00=NmgooOol00Woo0Ukg1Goo00=NmgooOol00Ukg
1Goo00<007ooOol0=Goo0014Ool00`00Oomoo`04Ool00ekgOomoo`0COol00`0OOomoo`0DOol00ekg
Oomoo`0DOol00ekgOomoo`0;Ool5G_L4Ool01EkgOomoogoo0n0017oo00=<5gooOol01goo0Ukg17oo
00ANmgooOomoo`9Nm`Aoo`05G_MoogooOomNm`03Ool01EkgOomoogooG_L00goo00=NmgooOol00goo
00=NmgooOol00Woo00=NmgooOol00Woo0Ukg0goo00<007ooOol0=Goo0014Ool00`00Oomoo`04Ool0
0ekgOomoo`0COol00`0OOomoo`0EOol00ekgOomoo`0COol00ekgOomoo`07Ool4G_L:Ool015kgOomo
o`?P17oo00=<5gooOol01Goo0Ukg1goo00=NmgooG_L01Woo00ENmgooOomooekg00=oo`05G_Moogoo
OomNm`04Ool00ekgOomoo`03Ool015kgOomooekg1goo0Ukg00=oo`00Ool0=Woo0014Ool00`00Oomo
o`04Ool00ekgOomoo`0COol00`0OOomoo`0EOol00ekgOomoo`0DOol015kgOomoogoo1Ekg3Woo00AN
mgooOol3h0Aoo`03B1Moogoo00=oo`9Nm`Yoo`03G_Moogoo00Aoo`03G_Moogoo009oo`05G_Moogoo
OomNm`03Ool00ekgOomoo`02Ool00ekgOomoo`04Ool2G_L:Ool00ekg001oo`0fOol004Aoo`03001o
ogoo00Aoo`03G_Moogoo01Aoo`0301moogoo01Aoo`03G_Moogoo01Aoo`ANmaAoo`03G_L3h7oo00Ao
o`04B1MoogooOol2G_L;Ool015kgOomNmekg0goo00=NmgooOol00Woo00=NmgooOol00Woo00=Nmgoo
Ool00Woo00=NmgooOol00Woo00=NmgooOol00Woo0Ukg00=ooekgOol02Goo00<007ooOol0=Goo0014
Ool00`00Oomoo`04Ool00ekgOomoo`0DOol00`0OOomoo`0DOol00ekgOomoo`0?Ool6G_LGOol00ekg
0n1oo`04Ool014PGG_MNmekg2goo0Ukg17oo0ekg1Goo00=NmgooOol00Woo00=NmgooOol00Woo00=N
mgooOol00goo00ANmgooG_MNm`Aoo`03G_Moogoo00Moo`03001oogoo03Eoo`00A7oo00<007ooOol0
17oo00=NmgooOol057oo00<07gooOol05Goo00=NmgooOol02Goo1Ekg1Woo00=NmgooOol05Goo00<3
h7ooOol00Woo00=NmdPGOol037oo00=NmgooOol01Woo0Ukg17oo00=NmgooOol00Woo00=NmgooOol0
0Woo00=NmgooOol00goo0Ukg1goo00=NmgooOol01Woo00<007ooOol0=Goo0014Ool00`00Oomoo`05
Ool00ekgOomoo`0COol00`0OOomoo`0EOol00ekgOomoo`05Ool4G_L;Ool00ekgOomoo`0DOol010?P
G_Moogoo0Ukg00=oodPGOol02goo00=NmgooOol01Woo00=NmgooOol015kg1Goo00=NmgooOol00goo
1Ekg00=ooekgOol01goo0Ukg1Woo00<007ooOol0=Goo0014Ool20006Ool00ekgOomoo`0DOol00`0O
Oomoo`0DOol00ekgOomoo`05G_L?Ool00ekgOomoo`0DOol010?POomNmekg0goo00=45gooOol02Goo
00=NmgooOol01Woo00=NmgooOol017oo3Ekg1Woo00=NmgooOol01goo00=NmgooOol00Woo0P00=goo
0014Ool00`00Oomoo`05Ool00ekgOomoo`0DOol00`0OOomoo`0COol4G_LEOol00ekgOomoo`0BOol0
1@?PG_MNmgooG_L00goo00=45gooOol01goo0Ukg2Goo00=NmgooOol017oo00=NmgooOol00goo00=N
mgooOol00goo00=NmgooOol01Goo00=NmgooOol01goo00=NmgooOol00Woo00<007ooOol0=Goo0014
Ool00`00Oomoo`05Ool00ekgOomoo`0DOol00`0OOomoo`0>Ool5G_L2Ool00ekgOomoo`0DOol00ekg
Oomoo`0AOol00ekg0n1oo`02Ool01EkgOomoogooA1L027oo00=NmgooOol027oo00=NmgooOol017oo
00=NmgooOol017oo00=NmgooOol017oo00=NmgooOol017oo00=NmgooOol027oo00ENmgooOomoo`00
03Moo`00A7oo00<007ooOol01Woo00=NmgooOol04goo00<07gooOol02Woo15kg1goo00=NmgooOol0
5Goo00=NmgooOol03Woo0Ukg00<3h7ooOol00goo00ANmgooOom45`Moo`03G_Moogoo00Qoo`03G_Mo
ogoo00Eoo`03G_Moogoo00Aoo`03G_Moogoo00Aoo`03G_Moogoo00Eoo`03G_Moogoo00Qoo`9Nm`03
Ool007oo03Ioo`00A7oo00<007ooOol01Woo00=NmgooOol057oo00<07gooOol017oo1Ekg2goo00=N
mgooOol05Goo00=NmgooOol02goo0ekg0Woo00<3h7ooOol017oo00=Nmgoo@1L01Woo00=NmgooOol0
27oo00=NmgooOol01Woo00=NmgooOol017oo00=NmgooOol01Goo00=NmgooOol01Goo00=NmgooOol0
2Goo00=Nm`00Ool0=Woo0014Ool00`00Oomoo`06Ool00ekgOomoo`0DOol00`0OOomoo`04G_LAOol0
0ekgOomoo`0EOol00ekgOomoo`08Ool2G_L4Ool00`?POomoo`06Ool00ekg@1Moo`03Ool2G_L;Ool0
0ekgOomoo`05Ool00ekgOomoo`05Ool00ekgOomoo`05Ool00ekgOomoo`06Ool00ekgOomoo`09Ool0
0`00Oomoo`0eOol004Aoo`03001oogoo00Ioo`03G_Moogoo019oo`9Nm`0301mNmekg01Eoo`03G_Mo
ogoo01Ioo`03G_Moogoo00Eoo`9Nm`Ioo`030n1oogoo00Moo`05@1MoogooOomNm`0<Ool00ekgOomo
o`06Ool00ekgOomoo`05Ool00ekgOomoo`05Ool00ekgOomoo`06Ool00ekgOomoo`09Ool00`00Oomo
o`0eOol004Aoo`03001oogoo00Moo`03G_Moogoo00eoo`ANm`=oo`0301moogoo01Aoo`03G_Moogoo
01Ioo`03G_Moogoo00=oo`9Nm`Moo`030n1oogoo00Uoo`03?1Mooekg00aoo`03G_Moogoo00Moo`03
G_Moogoo00Eoo`03G_Moogoo00Ioo`03G_Moogoo00Ioo`03G_Moogoo00Qoo`03001oogoo03Eoo`00
A7oo00<007ooOol01goo00=NmgooOol027oo1Ekg1goo00<07gooOol05Goo00=NmgooOol05Woo00=N
mgooOol00Ukg2Goo00<3h7ooOol02Goo00<l5ekgG_L037oo00=NmgooOol01Woo00=NmgooOol01Woo
00=NmgooOol01Woo00=NmgooOol01goo00=NmgooOol01goo00<007ooOol0=Goo0014Ool20008Ool0
0ekgOomoo`03Ool5G_L<Ool00`0OOomoo`0EOol00ekgOomoo`0GOol2G_L:Ool00`?POomoo`09Ool0
15kg?1Moogoo0Ukg2Goo00=NmgooOol01goo00=NmgooOol01Woo00=NmgooOol01Woo00=NmgooOol0
27oo00=NmgooOol01Goo0P00=goo0014Ool00`00Oomoo`07Ool00ekgOomNm`03G_LBOol00`0OOomo
o`0EOol00ekgOomoo`0DOol2G_L00gooG_Moo`09Ool00`?POomoo`08Ool00ekgOoll5`04Ool00ekg
Oomoo`05Ool00ekgOomoo`08Ool00ekgOomoo`06Ool00ekgOomoo`07Ool00ekgOomoo`07Ool00ekg
Oomoo`06Ool00`00Oomoo`0eOol004Aoo`03001oogoo00Aoo`ENmaIoo`0301moogoo01Eoo`03G_Mo
ogoo015oo`=Nm`=oo`03G_Moogoo00Moo`030n1oogoo00Qoo`05G_MoogooOolh5`04Ool00ekgOomo
o`03Ool00ekgOomoo`08Ool00ekgOomoo`07Ool00ekgOomoo`07Ool00ekgOomoo`08Ool00ekgOomo
o`05Ool00`00Oomoo`0eOol004Aoo`03001oogoo00ANm`Aoo`03G_Moogoo01Eoo`0301moogoo01Eo
o`03G_Moogoo00ioo`9Nm`Moo`03G_Moogoo00Eoo`030n1oogoo00Qoo`03G_Moogoo009oo`03>1Mo
ogoo00=oo`9Nm`=oo`03G_Moogoo00Qoo`03G_Moogoo00Moo`03G_Moogoo00Moo`03G_Moogoo00Uo
o`03G_Moogoo009oo`9Nm`03001oogoo03Eoo`00A7oo0ekg2Goo00=NmgooOol057oo00<07gooOol0
5Goo00=NmgooOol037oo0Ukg2Woo00=NmgooOol017oo00<3h7ooOol01goo00=NmgooOol00goo00<h
5gooOol01Goo0ekg2goo00=NmgooOol01goo00=NmgooOol027oo00=NmgooOol027oo00=NmgooG_L0
0Ukg0Woo00<007ooOol0=Goo0014Ool00`00Oomoo`09Ool00ekgOomoo`0DOol00`0OOomoo`0FOol0
0ekgOomoo`09Ool2G_L=Ool00ekgOomoo`02Ool00`?POomoo`06Ool2G_L6Ool00cPGOomoo`06Ool3
G_L9Ool00ekgOomoo`08Ool00ekgOomoo`08Ool00ekgOomoo`08Ool2G_L5Ool00`00Oomoo`0eOol0
04Aoo`03001oogoo00Uoo`03G_Moogoo01Eoo`0301moogoo01Ioo`03G_Moogoo00Ioo`9Nma1oo`04
G_Moogoo0n08Ool00ekgOomoo`07Ool00c@GOomoo`05Ool00ekgOomoo`03G_L6Ool00ekgOomoo`08
Ool00ekgOomoo`08Ool00ekgOomoo`05Ool3G_L2Ool00ekgOomoo`02Ool00`00Oomoo`0eOol004Ao
o`03001oogoo00Yoo`03G_Moogoo01Aoo`0301moogoo01Ioo`03G_Moogoo00Aoo`9Nma=oo`03G_L3
h7oo00Moo`03G_Moogoo00Qoo`03=1Moogoo00Aoo`03G_Moogoo00Aoo`9Nm`Aoo`03G_Moogoo00Qo
o`03G_Moogoo00Uoo`04G_MoogooOol3G_L6Ool01EkgOomoogoo0000=goo0014Ool00`00Oomoo`0:
Ool00ekgOomoo`0EOol00`0OOomoo`0FOol015kgOomoogoo0Ukg5Goo00=Nm`?POol01Woo00=Nmgoo
Ool02Goo00<d5gooOol00goo00=NmgooOol01goo1Ekg2Woo00=NmgooOol02Goo15kg2Goo00ENmgoo
Oomoo`0003Moo`00A7oo00<007ooOol02Woo00=NmgooOol05Goo00<07gooOol05goo0ekg5goo00<3
h5kgOol017oo0Ukg3Goo00<d5gooOol00Woo00=NmgooOol02Woo1ekg1Goo00=NmgooOol017oo1Ukg
3Goo00ANmgooOol003Moo`00A7oo0P0037oo00=NmgooOol05Goo00<07gooOol057oo0ekg67oo00@3
h7ooOomNm`=oo`03G_Moogoo00eoo`05=1MoogooOomNm`0=Ool00ekgOomoo`04Ool<G_L6Ool00ekg
Oomoo`0;Ool00ekg0000000gOol004Aoo`03001oogoo00]oo`03G_Moogoo01Eoo`0301moogoo019o
o`9Nm`=oo`03G_Moogoo01Aoo`030n1oogoo009oo`03G_Mooekg015oo`03<1Mooekg00ioo`03G_Mo
ogoo00Uoo`03G_Moogoo00Yoo`03G_Moogoo00aoo`03G_L007oo03Ioo`00A7oo00<007ooOol037oo
00=NmgooOol05Goo00<07gooOol03goo0Ukg1Woo00=NmgooOol04Woo00<3h7ooOol017oo0Ukg4Goo
00<`5ekgOol03Goo00=NmgooOol02Woo00=NmgooOol02Woo00=NmgooOol037oo00=Nm`00Ool0=Woo
0014Ool00`00Oomoo`0<Ool00ekgOomoo`0FOol00`0OOomoo`0<Ool2G_L9Ool00ekgOomoo`0@Ool0
0`?POomoo`03Ool2G_L2Ool00ekgOomoo`0>Ool00c0GG_Moo`0=Ool00ekgOomoo`0:Ool00ekgOomo
o`0;Ool00ekgOomoo`0<Ool00`00Oomoo`0eOol004Aoo`03001oogoo00eoo`03G_Moogoo01Eoo`03
01moogoo00Yoo`9Nm`]oo`03G_Moogoo00moo`030n1oogoo00=oo`03G_Moogoo00=oo`9Nm`ioo`03
G_L`5goo00eoo`03G_Moogoo00Yoo`03G_Moogoo00]oo`03G_Moogoo00aoo`03001oogoo03Eoo`00
A7oo00<007ooOol03Goo00=NmgooOol05Woo00<07gooOol01goo0Ukg3Woo00=NmgooOol03Goo00<3
h7ooOol00goo00=NmgooOol01Woo00=NmgooOol02Woo00=Nmgoo;1L03Goo00=NmgooOol02goo00=N
mgooOol02goo00=NmgooOol037oo00<007ooOol0=Goo0014Ool00`00Oomoo`0>Ool00ekgOomoo`0E
Ool00`0OOomoo`05Ool2G_LAOol00ekgOomoo`0:Ool20n05Ool00ekgOomoo`08Ool2G_L:Ool00ekg
Ool/5`0=Ool00ekgOomoo`0;Ool00ekgOomoo`0<Ool00ekgOomoo`0;Ool00`00Oomoo`0eOol0039o
o`8000Aoo`8000Aoo`8000Aoo`03001oogoo00ioo`03G_Moogoo01Ioo`0401moogooOol3G_LDOol0
0ekgOomoo`08Ool00`?POomoo`03Ool2G_L=Ool2G_L7Ool01EkgOomoogoo;1L037oo00=NmgooOol0
2goo00=NmgooOol037oo00=NmgooOol02goo00<007ooOol0=Goo000aOol01000Oomoo`0027oo00@0
07ooOol000=oo`03001oogoo00moo`03G_Moogoo01Ioo`0301mNmekg01Qoo`03G_Moogoo00Ioo`03
0n1oogoo00=oo`03G_Moogoo00moo`9Nm`Aoo`03G_Moogoo009oo`03;1Moogoo00Uoo`03G_Moogoo
00aoo`03G_Moogoo00aoo`03G_Moogoo00]oo`03001oogoo03Eoo`00<Goo00@007ooOol000]oo`04
001oogooOol2000AOol00ekgOomoo`0DOol2G_L00`0OOomoo`0HOol00ekgOomoo`03Ool20n05Ool0
0ekgOomoo`0BOol015kgOomooekg1Goo00</5gooOol02Goo00=NmgooOol037oo00=NmgooOol03Goo
00=NmgooOol02Goo0P00=goo000aOol01000Oomoo`002Goo0P0017oo00<007ooOol047oo00=Nmgoo
Ool04Woo0Ukg0Woo00<07gooOol06Goo0Ukg0Woo00<3h7ooOol017oo00=NmgooOol057oo0ekg1Woo
00<X5gooOol027oo00=NmgooOol037oo00=NmgooOol03Goo00=NmgooOol02Woo00<007ooOol0=Goo
000aOol01000Oomoo`002Goo00<007ooOol00goo00<007ooOol04Goo00=NmgooOol03goo0Ukg1Goo
00<07gooOol06Woo0P?P1Woo00=NmgooOol05Woo0ekg1Goo00<X5gooOol01goo00=NmgooOol03Goo
00=NmgooOol03Goo00=NmgooOol02Woo00<007ooOol0=Goo000bOol2000:Ool30003Ool00`00Oomo
o`0BOol00ekgOomoo`0<Ool2G_L8Ool00`0OOomoo`0GOol20n000gooG_Moo`03Ool2G_LHOol015kg
Oomoogoo0Ukg0goo00<X5gooOol01goo00=NmgooOol03Goo00=NmgooOol03Woo00=NmgooOol02Goo
00<007ooOol0=Goo0014Ool00`00Oomoo`0BOol00ekgOomoo`0:Ool2G_L;Ool00`0OOomoo`0DOol2
0n04Ool015kgOomooekg6Woo00=NmgooOol00goo0ekg00=oobPGOol01goo00=NmgooOol03Goo00=N
mgooOol03Woo00=NmgooOol027oo00=Nm`00Ool0=Woo0014Ool00`00Oomoo`0COol00ekgOomoo`06
Ool3G_L>Ool00`0OOomoo`0BOol00`?POomoo`05Ool2G_LJOol00ekgOomoo`07Ool015kg:1MNmekg
1Goo00=NmgooOol03Woo00=NmgooOol03Woo00=NmgooOol017oo15kg00=oo`00Ool0=Woo0014Ool0
0`00Oomoo`0COol00ekgOomoo`04Ool2G_LAOol00`0OOomoo`0@Ool20n08Ool3G_LHOol00ekgOomo
o`09Ool00b@GOomoo`04G_L00gooG_Moo`0?Ool00ekgOomoo`0?Ool00ekgOomNm`03G_L5Ool00`00
Oomoo`0eOol004Aoo`03001oogoo01Aoo`04G_MoogooOol2G_LDOol00`0OOomoo`0=Ool20n08Ool2
G_L3Ool00ekgOomoo`0DOol00ekgOomoo`0:Ool00b@GOomoo`04Ool4G_L>Ool00ekgOomoo`0=Ool4
G_L9Ool00`00Oomoo`0eOol004Aoo`03001oogoo01Eoo`=NmaMoo`0301moogoo00Yoo`83h0Uoo`03
G_Moogoo00Aoo`03G_Moogoo01=oo`03G_Moogoo00]oo`0391Moogoo00=oo`04G_MoogooOol6G_L8
Ool00ekgOomoo`07Ool6G_L2Ool00ekgOomoo`08Ool00`00Oomoo`0eOol004Aoo`8001Eoo`=NmaUo
o`0301moogoo00Ioo`<3h0Yoo`03G_Moogoo00Ioo`9Nma9oo`03G_Moogoo00aoo`0391Moogoo00=o
o`03G_Moogoo00Mooa9Nm`Uoo`03G_Moogoo00Ioo`8003Moo`00A7oo0P?P4goo0Ukg0Woo00=Nmgoo
Ool067oo00<07gooOol00Woo0`?P37oo00=NmgooOol02Goo00=NmgooOol03Woo00=NmgooOol03Goo
00<T5gooOol00goo00=NmgooOol03goo00=NmgooOol047oo00=NmgooOol01goo00<007ooOol0=Goo
0014Ool015kgOol3h0?P3goo0Ukg1Goo00=NmgooOol067oo00@07`?P0n03h0eoo`9Nm`eoo`9Nm`io
o`03G_Moogoo00eoo`0391Moogoo009oo`03G_Moogoo011oo`03G_Moogoo011oo`03G_Moogoo00Mo
o`03001oogoo03Eoo`00A7oo00@005kgOomoo`@3h0Uoo`9Nm`Qoo`03G_Moogoo01Aoo`@3h00301mo
ogoo00aoo`03G_Moogoo00moo`03G_Moogoo00Yoo`03G_Moogoo00moo`0581MoogooOomNm`0BOol0
0ekgOomoo`0AOol00ekgOomoo`06Ool00`00Oomoo`0eOol004Aoo`03001Nmgoo00Eoo`@3h09oo`=N
m`]oo`03G_Moogoo00moo`@3h0Eoo`0301moogoo00Yoo`03G_Moogoo015oo`9Nm`Uoo`03G_Moogoo
011oo`0581MoogooOomNm`0BOol00ekgOomoo`0AOol00ekgOomoo`06Ool00`00Oomoo`0eOol004Ao
o`03001ooekg00Uoo`L3h0Yoo`03G_Moogoo00Moo`L3h0Yoo`0301moogoo00Qoo`03G_Moogoo01Ao
o`03G_Moogoo00Ioo`03G_Moogoo011oo`0481MoogooG_LCOol00ekgOomoo`0AOol00ekgOomoo`06
Ool00`00Oomoo`0eOol004Aoo`03001ooekg00Moo`9Nm`Mooa@3h19oo`0301moogoo00Eoo`9NmaQo
o`9Nm`Eoo`03G_Moogoo015oo`0481MoogooG_LCOol00ekgOomoo`0BOol00ekgOomoo`04Ool00g`0
001oo`0fOol004Aoo`04001oogooG_L4Ool2G_LDOol00ekgOomoo`0IOol00`0OOomoo`03Ool00ekg
Oomoo`0JOol2G_L2Ool00ekgOomoo`0BOol0120GOomooekg4goo00=NmgooOol04Woo00=NmgooOol0
0goo00=l07oo0000=goo0014Ool01P00OomoogooG_Moo`9NmaMoo`03G_Moogoo01Uoo`0501moogoo
OomNm`0OOol2G_LFOol00b0GG_Moo`0COol00ekgOomoo`0BOol00ekgOomoo`02Ool017`0Oomoo`00
=goo0014Ool20002Ool2G_LJOol00ekgOomoo`0IOol201l00ekgOomoo`0OOol4G_LCOol00b0GG_Mo
o`0COol00ekgOomoo`0COol01UkgOomoogooO01oo`8003Moo`00A7oo00H007ooG_MNmgooG_LKOol0
0ekgOomoo`0HOol2G_L00`0OOomoo`0NOol00ekgOomoo`02Ool2G_LAOol00b0GG_Moo`0COol00ekg
Oomoo`0COol015kgOomoog`00goo00<007ooOol0=Goo0014Ool2G_L4Ool00ekgOomoo`0IOol00ekg
Oomoo`0FOol01EkgOomoogoo01l07Woo00=NmgooOol01Goo0ekg3Woo00<P5gooOol04goo00=Nmgoo
Ool057oo00=Nmg`0Ool00goo00<007ooOol0=Goo0014Ool00`00Oomoo`04Ool00ekgOomoo`0IOol0
0ekgOomoo`0DOol00ekgOomoo`03Ool201lLOol00ekgOomoo`08Ool2G_L<Ool00b0GOomoo`0COol0
0ekgOomoo`0DOol00g`0Oomoo`03Ool00`00Oomoo`0eOol004Aoo`03001oogoo00Eoo`03G_Moogoo
01Uoo`03G_Moogoo019oo`03G_Moogoo00Ioo`0301moogoo01Qoo`03G_Moogoo00]oo`=Nm`Uoo`03
G_LP5goo01=oo`03G_Moogoo01Aoo`03O01oogoo00=oo`03001oogoo03Eoo`00A7oo00<007ooOol0
1Goo00=NmgooOol06Woo00=NmgooOol047oo00=NmgooOol027oo0P0O5goo00=NmgooOol03goo0Ukg
1Woo00=Nmgoo71L057oo00=NmgooOol04goo00=l07ooG_L017oo00<007ooOol0=Goo0014Ool00`00
Oomoo`06Ool00ekgOomoo`0JOol00ekgOomoo`0=Ool2G_L=Ool00`0OOomoo`0COol00ekgOomoo`0B
Ool4G_L2Ool00ekgOolL5`0DOol00ekgOomoo`0BOol01G`0OomooekgOol00ekg00<007ooOol0=Goo
0014Ool00`00Oomoo`07Ool00ekgOomoo`0JOol00ekgOomoo`0;Ool00ekgOomoo`0>Ool201lCOol0
0ekgOomoo`0FOol4G_L00a`GG_Moo`0BOol00ekgOomoo`0AOol00ekgO01Nm`03G_L3Ool00`00Oomo
o`0eOol004Aoo`03001oogoo00Qoo`03G_Moogoo01Yoo`03G_Moogoo00Uoo`03G_Moogoo015oo`80
7a1oo`03G_Moogoo01Qoo`05G_Moogoo71Moo`08G_L;Ool00ekgOomoo`09Ool8G_L00g`0Oomoo`02
Ool01EkgOomoogoo0000=goo0014Ool20009Ool00ekgOomoo`0KOol00ekgOomoo`07Ool00ekgOomo
o`0DOol00`0OOomoo`0<Ool00ekgOomoo`0IOol015kgOomooa`G2Goo5ekg1goo00=l07ooOol00goo
00=NmgooOol00P00=goo0014Ool00`00Oomoo`09Ool00ekgOomoo`0KOol00ekgOomoo`04Ool2G_LH
Ool201l<Ool00ekgOomoo`0IOol015kgOomooa`G57oo00=NmgooOol03goo00=l07ooOol017oo00EN
mgooOomoo`0003Moo`00A7oo00<007ooOol02Woo00=NmgooOol06goo00=NmgooOol00Woo00=Nmgoo
Ool06Woo0P0O2Goo00=NmgooOol06Goo00=NmgooOol00Woo00<L5gooOol04Goo00=NmgooOol03goo
00=l07ooOol01Goo00ANmgooOol003Moo`00A7oo00<007ooOol02goo00=NmgooOol06goo00ANmgoo
OomNmamoo`807`Ioo`03G_Moogoo01Yoo`03G_Moogoo009oo`0371Moogoo015oo`03G_Moogoo00io
o`03O01oogoo00Ioo`04G_Moogoo000gOol004Aoo`03001oogoo00aoo`03G_Moogoo01]oo`9Nmb9o
o`0301moogoo009oo`03G_Moogoo01]oo`03G_Moogoo009oo`0371Moogoo015oo`03G_Moogoo00eo
o`03O01oogoo00Moo`04G_Moogoo000gOol004Aoo`03001oogoo00eoo`03G_Moogoo01Uoo`ANmb9o
o`807`9oo`03G_Moogoo01Yoo`03G_Moogoo00=oo`0371Moogoo015oo`03G_Moogoo00aoo`03O01o
ogoo00Uoo`03G_Moo`0003Moo`00A7oo00<007ooOol03Woo00=NmgooOol05goo00=NmgooOol00Woo
00=NmgooOol08Goo0P0O7Goo00=NmgooOol00goo00<H5gooOol04Goo00=NmgooOol02goo00=l07oo
Ool02Woo00=Nmgoo0000=goo0014Ool00`00Oomoo`0?Ool00ekgOomoo`0EOol00ekgOomoo`04Ool0
0ekgOomoo`0POol015kgOol07`0O6goo00=NmgooOol00goo00<H5gooOol04Goo00=NmgooOol02Woo
00=l07ooOol02goo00=Nmgoo0000=goo0014Ool00`00Oomoo`0@Ool00ekgOomoo`0COol00ekgOomo
o`06Ool00ekgOomoo`0OOol015kgOomoogoo0P0O67oo00=NmgooOol017oo00<H5gooOol04Goo00=N
mgooOol02Goo00=l07ooOol03Goo00=Nm`00Ool0=Woo0014Ool2000BOol00ekgOomoo`0@Ool2G_L:
Ool00ekgOomoo`0MOol00ekgOomoo`04Ool201lFOol00ekgOomoo`04Ool00aPGOomoo`0AOol00ekg
Oomoo`07Ool2O00@Ool00ekg001oo`0fOol004Aoo`03001oogoo019oo`03G_Moogoo00ioo`03G_Mo
ogoo00]oo`9Nmaaoo`03G_Moogoo00Moo`<07a=oo`03G_Moogoo00Aoo`0361Moogoo015oo`03G_Mo
ogoo00Ioo`03O01oogoo011oo`03G_L007oo03Ioo`00A7oo00<007ooOol04goo00=NmgooOol037oo
00=NmgooOol03Woo00=NmgooOol06Goo00=NmgooOol02Woo100O3Woo00=NmgooOol01Goo00<H5goo
Ool04Goo00=NmgooOol01Goo00=l07ooOol04Woo00<007ooOol0=Goo0014Ool00`00Oomoo`0DOol0
0ekgOomoo`0:Ool00ekgOomoo`0@Ool00ekgOomoo`0GOol00ekgOomoo`0?Ool301l;Ool00ekgOomo
o`05Ool00aPGOomoo`0AOol00ekgOomoo`04Ool00g`0Oomoo`0COol00`00Oomoo`0eOol004Aoo`03
001oogoo01Eoo`03G_Moogoo00Qoo`03G_Moogoo019oo`9NmaIoo`03G_Moogoo01=oo`@07`Moo`03
G_Moogoo00Eoo`0361Moogoo015oo`03G_Moogoo00=oo`03O01oogoo01Aoo`03001oogoo03Eoo`00
A7oo00<007ooOol05Woo00=NmgooOol01Goo0Ukg5goo0Ukg4goo00=NmgooOol067oo100O0Woo00=N
mgooOol01goo00<H5gooOol047oo00=NmgooOol00Woo00=l07ooOol05Goo00<007ooOol0=Goo0014
Ool00`00Oomoo`0GOol00ekgOomoo`03Ool00ekgOomoo`0IOol2G_LAOol00ekgOomoo`0LOol401l8
Ool00aPGOomoo`0@Ool01EkgOomoogooO0005goo00<07`00Ool0=Woo000mOol50002Ool00`00Oomo
o`0HOol2G_L2Ool00ekgOomoo`0LOol00ekgOomoo`0=Ool00ekgOomoo`0OOol00ekgOol07`0301l4
Ool00aPGOomoo`0@Ool015kgOomoog`057oo100O00=oo`00Ool0=Woo000oOol00`00Oomoo`02Ool0
0`00Oomoo`0JOol2G_LPOol2G_L<Ool00ekgOomoo`0OOol00ekgOomoo`04Ool901l>Ool00ekgO01l
000<Ool901l5Ool00`00Oomoo`0eOol003moo`03001oogoo009oo`03G_L007oo01Uoo`=Nmb9oo`9N
m`Yoo`03G_Moogoo01moo`03G_Moogoo00Qoo`0361Moogoo009ooad07`eoo`8003Moo`00?goo00<0
07ooOol00Woo00<005kgOol067oo00ANmgooOomoo`9Nmb9oo`9Nm`Moo`03G_Moogoo021oo`03G_Mo
ogoo00Qoo`0361Moogoo00moo`03O01Nmgoo01]oo`03001oogoo03Eoo`00?goo00<007ooOol00Woo
00<007ooG_L05goo00=NmgooOol017oo00=NmgooOol08Goo0Ukg17oo00=NmgooOol087oo00=Nmgoo
Ool02Goo00<H5gooOol03Woo00=l07ooG_L077oo00<007ooOol0=Goo000nOol20004Ool01000Oomo
oekg5Goo00=NmgooOol01Woo00=NmgooOol08Woo0Ukg00=ooekgOol08Woo00=NmgooOol02Goo00<D
5gooOol037oo0W`00Woo00=NmgooOol06Woo00<007ooOol0=Goo0014Ool01@00OomoogooG_L04Woo
0Ukg2Woo0Ukg97oo0ekg8Woo00=NmgooOol02Goo00<D5gooOol02goo00=l07ooOol00Woo00=Nmgoo
Ool06Woo00<007ooOol0=Goo0014Ool00`00Oomoo`02Ool2G_L?Ool00ekgOomoo`0<Ool00ekgOomo
o`0QOol00ekgOomoo`02G_LOOol00ekgOomoo`0:Ool00a@GOomoo`0:Ool00g`0Oomoo`03Ool00ekg
Oomoo`0JOol00`00Oomoo`0eOol004Aoo`03001oogoo00Aoo`03G_Moogoo00]oo`03G_Moogoo00io
o`03G_Moogoo01moo`03G_Moogoo00=oo`=Nmaaoo`03G_Moogoo00Yoo`0351Moogoo00Uoo`03O01o
ogoo00Aoo`03G_Moogoo01Yoo`03001oogoo03Eoo`00A7oo00<007ooOol01Goo00=NmgooOol02Goo
00=NmgooOol047oo0Ukg7goo00=NmgooOol01Woo0Ukg6Woo00=NmgooOol02Woo00<D5gooOol01goo
0W`01goo00=NmgooOol06Woo00<007ooOol0=Goo0014Ool00`00Oomoo`06Ool00ekgOomoo`06Ool2
G_LEOol00ekgOomoo`0KOol00ekgOomoo`09Ool3G_LFOol00ekgOomoo`0;Ool00a@GOomoo`06Ool0
0g`0Oomoo`07Ool00ekgOomoo`0JOol00`00Oomoo`0eOol004Aoo`03001oogoo00Moo`03G_Moogoo
00Aoo`03G_Moogoo01Ioo`9NmaYoo`03G_Moogoo00eoo`=Nma=oo`03G_Moogoo00]oo`0351Moogoo
00Eoo`03O01oogoo00Qoo`03G_Moogoo01Yoo`03001oogoo03Eoo`00A7oo0P002Goo00=NmgooOol0
0Woo00=NmgooOol06Goo0Ukg5goo00=NmgooOol04Goo0ekg47oo00=NmgooOol02goo00<D5gooOol0
0goo0W`02goo00=NmgooOol06Goo0P00=goo0014Ool00`00Oomoo`09Ool2G_L00gooG_Moo`0MOol2
G_LEOol00ekgOomoo`0DOol4G_L;Ool00ekgOomoo`0<Ool011@GOomoogoo0W`03Goo00=NmgooOol0
6Woo00<007ooOol0=Goo0014Ool00`00Oomoo`0:Ool2G_LQOol00ekgOomoo`0AOol00ekgOomoo`0I
Ool3G_L8Ool00ekgOomoo`0<Ool011@GOoml07`03goo00=NmgooOol06Woo00<007ooOol0=Goo0014
Ool00`00Oomoo`09Ool015kgOomooekg8Goo0Ukg47oo00=NmgooOol07Goo0ekg1Goo00=NmgooOol0
37oo00<D5g`0Ool047oo00=NmgooOol06Woo00<007ooOol0=Goo0014Ool00`00Oomoo`08Ool00ekg
Oomoo`02Ool00ekgOomoo`0POol2G_L>Ool00ekgOomoo`0POol4G_L00gooG_Moo`0<Ool2O0000a@G
Oomoo`0?Ool00ekgOomoo`0JOol00`00Oomoo`0eOol004Aoo`03001oogoo00Moo`03G_Moogoo00Ao
o`03G_Moogoo025oo`9Nm`]oo`03G_Moogoo02Eoo`ANm`Uoo`9l009oo`0351Moogoo00moo`03G_Mo
ogoo01Yoo`03001oogoo03Eoo`00A7oo00<007ooOol01Woo00=NmgooOol01Woo0Ukg8goo0Ukg27oo
00=NmgooOol09Woo00ANmgooOomoo`ANm`=oo`9l00Aoo`0351Moogoo00moo`03G_Moogoo01Uoo`03
G_L007oo03Ioo`00A7oo00<007ooOol017oo0Ukg2goo00=NmgooOol08Woo0Ukg1Woo00=NmgooOol0
9Woo00=NmgooOol01Goo00=Nmg`0O0001Ukg00<D5ekgOol03goo00=NmgooOol03goo2Ukg00=oo`00
Ool0=Woo0014Ool00`00Oomoo`03Ool00ekgOomoo`0<Ool00ekgOomoo`0SOol2G_L3Ool00ekgOomo
o`0VOol00ekgOomoo`05Ool2O008Ool00a@GOomNm`0QG_L;Ool00`00Oomoo`0eOol004Aoo`8000=o
o`03G_Moogoo00ioo`03G_Moogoo02Aoo`=NmbUoo`03G_Moogoo00=oo`9l00Yoo`0351Moogoo00mo
o`03G_Moogoo01Uoo`8003Moo`00A7oo00D007ooOomooekg019oo`9NmbEoo`=NmbQoo`04G_Moogoo
Ool2O00<Ool00a@GOomoo`0?Ool00ekgOomoo`0JOol00`00Oomoo`0eOol004Aoo`04001ooekgG_LE
Ool00ekgOomoo`0ROol00ekgOomoo`02G_LUOol00ekgOomoo`02O00>Ool00a@GOomoo`0?Ool00ekg
Oomoo`0JOol00`00Oomoo`0eOol004Aoo`03001Nmgoo01Moo`03G_Moogoo021oo`03G_Moogoo00=o
o`9Nmb=oo`=l011oo`0351Moogoo00moo`03G_Moogoo01Yoo`03001oogoo03Eoo`00A7oo00=Nmgoo
Ool067oo0Ukg7goo00=NmgooOol01Woo0Ukg7goo0W`000=NmgooOol047oo00<D5gooOol03goo00=N
mgooOol06Woo00<007ooOol0=Goo0014Ool00`00Oomoo`0JOol2G_LMOol00ekgOomoo`08Ool2G_LK
Ool2O0000gooG_Moo`0BOol00a@GOomoo`0?Ool00ekgOomoo`0JOol00`00Oomoo`0eOol004Aoo`03
001oogoo01aoo`9NmaYoo`03G_Moogoo00]oo`=NmaIoo`9l00=oo`03G_Moogoo015oo`0351Moogoo
00moo`03G_Moogoo01Yoo`03001oogoo03Eoo`00A7oo00<007ooOol07Woo0Ukg5goo00=NmgooOol0
3goo0ekg47oo0g`01Goo00=NmgooOol04Goo00<@5gooOol03goo00=NmgooOol06Woo00<007ooOol0
=Goo0014Ool00ekgOomoo`0POol2G_LDOol00ekgOomoo`0COol3G_L:Ool3O007Ool00ekgOomoo`0B
Ool00a0GOomoo`0?Ool00ekgOomoo`0JOol00`00Oomoo`0eOol004Aoo`03001Nmgoo029oo`9Nma9o
o`03G_Moogoo01Ioo`ANm`=oo`=l00Yoo`03G_Moogoo019oo`0341Moogoo00moo`03G_Moogoo01Uo
o`8003Moo`00A7oo00@007ooG_MNmb=oo`9Nm`moo`03G_Moogoo01]oo`=l00eoo`03G_Moogoo019o
o`0341Moogoo00moo`03G_Moogoo01Yoo`03001oogoo03Eoo`00A7oo00D007ooOomooekg02Aoo`9N
m`aoo`03G_Moogoo01Uoo`=l00=oo`=Nm`Uoo`03G_Moogoo01=oo`0341Moogoo00moo`03G_Moogoo
01Yoo`03001oogoo03Eoo`00A7oo00<007ooOol00Woo00=NmgooOol08goo0Ukg2Woo00=NmgooOol0
5Woo0g`02Goo15kg1Goo00=NmgooOol04goo00<@5gooOol03goo00=NmgooOol06Woo00<007ooOol0
=Goo0014Ool00`00Oomoo`03Ool2G_LUOol2G_L7Ool00ekgOomoo`0COol4O00@Ool6G_LEOol00a0G
Oomoo`0?Ool00ekgOomoo`0JOol00`00Oomoo`0eOol004Aoo`03001oogoo00Eoo`03G_Moogoo02Ao
o`9Nm`Aoo`03G_Moogoo00moo`El01Qoo`ENma9oo`0341Moogoo00moo`03G_Moogoo01Yoo`03001o
ogoo03Eoo`00A7oo00<007ooOol01Woo00=NmgooOol09Goo0Ukg00=ooekgOol037oo1G`07Goo00=N
mgooOol00Woo1Ekg3Goo00<@5gooOol03goo00=NmgooOol06Woo00<007ooOol0=Goo0014Ool00`00
Oomoo`07Ool2G_LWOol2G_L8Ool5O00ROol00ekgOomoo`07Ool7G_L6Ool00a0GOomoo`0?Ool00ekg
Oomoo`0FOol4G_L00`00Oomoo`0eOol004Aoo`El00Moo`03G_Moogoo02Aoo`03G_Mooekg00Ml02Io
o`03G_Moogoo00moo`INm`0441MNmekgG_L>Ool00ekgOomoo`0<Ool:G_L4Ool00`00Oomoo`0eOol0
04Aoo`8000=oo`Ul0003G_Moogoo01]oo`Yl0003OomNmekg02Yoo`03G_Moogoo01Eoo`0441Moogoo
OolMG_L=Ool2000gOol004Aoo`03001oogoo00]ooail00Ioo`03G_Moogoo00Aoo`9NmbQoo`03G_Mo
ogoo01Eoo`0341Moogoo00moo`03G_Moogoo01Yoo`03001oogoo03Eoo`00A7oo00<007ooOol03Woo
00=NmgooOol07Goo00=NmgooOol01goo0Ukg9Goo00=NmgooOol05Woo00<@5gooOol03goo00=Nmgoo
Ool06Woo00<007ooOol0=Goo0014Ool00`00Oomoo`0?Ool2G_LLOol00ekgOomoo`0:Ool2G_LSOol0
0ekgOomoo`0FOol00a0GOomoo`0?Ool00ekgOomoo`0JOol00`00Oomoo`0eOol004Aoo`03001oogoo
015oo`9NmaYoo`03G_Moogoo00aoo`=Nmb1oo`03G_Moogoo01Ioo`0341Moogoo00moo`03G_Moogoo
01Yoo`03001oogoo03Eoo`00A7oo00<007ooOol04goo0Ukg5goo00=NmgooOol047oo0ekg77oo00=N
mgooOol05goo00<@5gooOol03goo00=NmgooOol06Woo00<007ooOol0=Goo0014Ool00`00Oomoo`0E
Ool00ekgOomoo`0COol00ekgOomoo`0DOol3G_LIOol00ekgOomoo`0GOol00a0GOomoo`0?Ool00ekg
Oomoo`0JOol00`00Oomoo`0eOol0035oo`D0009oo`8000Aoo`8000Aoo`03001oogoo01Ioo`9Nma9o
o`03G_Moogoo01Qoo`=NmaIoo`03G_Moogoo01Moo`0341Moogoo00moo`03G_Moogoo01Yoo`03001o
ogoo03Eoo`00<goo00<007ooOol01goo00@007ooOol000=oo`03001oogoo00=oo`03001oogoo00=o
o`03001oogoo009oo`03001oogoo00=oo`04001oogooOol2G_L5Ool00`00Oomoo`03Ool00`00Oomo
o`02Ool00ekgOomoo`03Ool00`00Oomoo`03Ool00`00Oomoo`02Ool00`00Oomoo`03Ool00`00Oomo
o`03Ool01P00G_MNmekgOol000Eoo`03001oogoo00=oo`03001oogoo009oo`03G_Moogoo00=oo`03
001oogoo00=oo`03001oogoo009oo`03001oogoo00=oo`06001oogooOol@5`001Goo00<007ooOol0
0goo00<007ooOol00Woo00=NmgooOol00goo00<007ooOol00goo00<007ooOol00Woo00<007ooOol0
0goo00<007ooOol00goo00<007ooOol0=Goo000cOol00`00Oomoo`0:Ool01000Oomoogoo7@0000=N
m`000000300000=Nm`0000007`000Ukg400000=Nm`000000600000<@5`0000003`0000=Nm`000000
6`00=goo000cOol00`00Oomoo`08Ool2003VOol003=oo`03001oogoo00Qoo`03001oogoo0>Eoo`00
<Woo0P002Woo0`00iGoo003oOolWOol00?moobMoo`00ogoo9goo003oOolWOol00?moobMoo`00ogoo
9goo003oOolWOol00?moobMoo`00ogoo9goo003oOolWOol00?moobMoo`00ogoo9goo003oOolWOol0
06moo`03001oogoo03Eoo`03001oogoo00Uoo`03001oogoo03Ioo`03001oogoo03Moo`00KWoo00<0
07ooOol047oo00<007ooOol05goo00<007ooOol02Woo00<007ooOol01goo00<007ooOol04Goo00<0
07ooOol05Woo00<007ooOol02goo00<007ooOol0=Woo001SOol30007Ool00`00Oomoo`02Ool3000<
Ool00`00Oomoo`04Ool40004Ool30008Ool00`00Oomoo`03Ool40004Ool00`00Oomoo`05Ool00`00
Oomoo`02Ool3000=Ool00`00Oomoo`03Ool40005Ool30007Ool00`00Oomoo`06Ool30003Ool00`00
Oomoo`0eOol006Eoo`8000Ioo`03001oogoo00Aoo`8000Uoo`D000Aoo`03001oogoo00Moo`8000Eo
o`D000=oo`03001oogoo00Eoo`03001oogoo00Eoo`03001oogoo00Aoo`8000Yoo`D000=oo`03001o
ogoo00Qoo`8000Aoo`D000Moo`03001oogoo009oo`03001oogoo03Eoo`00I7oo00<007ooOol01Woo
00<007ooOol00goo00<007ooOol02goo00<007ooOol01Goo00<007ooOol01Goo00<007ooOol01goo
00<007ooOol017oo00<007ooOol017oo00<007ooOol01Goo00<007ooOol00goo00<007ooOol037oo
00<007ooOol017oo00<007ooOol01Woo00<007ooOol01Woo00<007ooOol017oo1@000goo00<007oo
Ool0=Goo001TOol30006Ool00`00Oomoo`03Ool30002Ool20007Ool00`00Oomoo`06Ool00`00Oomo
o`04Ool30007Ool00`00Oomoo`05Ool00`00Oomoo`03Ool00`00Oomoo`05Ool00`00Oomoo`03Ool3
0002Ool20008Ool00`00Oomoo`05Ool00`00Oomoo`05Ool30006Ool00`00Oomoo`04Ool01000Oomo
o`0017oo00<007ooOol0=Goo0017Ool20008Ool2000KOol00`00Oomoo`07Ool00`00Oomoo`0=Ool0
1000Oomoo`005Goo00@007ooOol000=oo`03001oogoo00Moo`03001oogoo00Moo`03001oogoo00eo
o`04001oogoo000GOol00`00Ool00003Ool00`00Oomoo`0fOol004Moo`03001oogoo00Qoo`03001o
ogoo01Yoo`03001oogoo00Moo`03001oogoo00eoo`8001Moo`8000=oo`03001oogoo00Uoo`03001o
ogoo00Moo`03001oogoo00eoo`8001Uoo`80009oo`03001oogoo03Moo`00@7oo0P001Goo00@007oo
Oomoo`<000Aoo`03001oogoo009oo`@001eoo`80049oo`8006Qoo`00?goo00@007ooOol000Aoo`03
001oogoo00Aoo`05001oogooOol0000>Oom00008OolP0004Ool@0002Ool800000goo00000008000d
Ool003moo`03001oo`00008000=oo`04001oogooOol30004Ool00`00Oomoo`02Ool4003;Ool003mo
o`03001oogoo00Eoo`04001oogooOol40003Ool00`00Oomoo`3AOol003moo`03001oogoo00Eoo`03
001oogoo00Qoo`03001oogoo03Uoo`03001oogoo01Moo`03001oogoo00Uoo`03001oogoo029oo`03
001oogoo04Yoo`00@7oo0`0017oo0P0027oo0P00>Woo00<007ooOol02goo00<007ooOol02goo00<0
07ooOol01goo00<007ooOol047oo00<007ooOol04Goo00<007ooOol0BGoo001gOol20004Ool20003
Ool40006Ool00`00Oomoo`02Ool30007Ool00`00Oomoo`04Ool50003Ool00`00Oomoo`05Ool00`00
Oomoo`02Ool3000<Ool00`00Oomoo`04Ool500000goo000000020004Ool00`00Oomoo`18Ool007Io
o`04001oogoo0008Ool00`00Oomoo`07Ool00`00Oomoo`04Ool20004Ool50006Ool00`00Oomoo`03
Ool00`00Oomoo`05Ool00`00Oomoo`04Ool20009Ool50006Ool01@00Oomoogoo00001goo00<007oo
Ool0B7oo001fOol01000Oomoo`002Goo00<007ooOol01Woo00<007ooOol00goo00<007ooOol01Woo
00<007ooOol01Woo00<007ooOol00goo00<007ooOol01Goo00<007ooOol00goo00<007ooOol02goo
00<007ooOol01Woo00<007ooOol00Woo00<007ooOol017oo00<007ooOol0B7oo001fOol01000Oomo
o`002Woo00<007ooOol01Goo00<007ooOol00goo0`001Woo00<007ooOol01Woo00<007ooOol00goo
00<007ooOol01Goo00<007ooOol00goo0`002goo00<007ooOol01Woo00<007ooOol00goo00<007oo
Ool00goo00<007ooOol0B7oo001fOol01000Oomoo`0027oo00@007ooOol000Moo`03001oogoo01Ao
o`03001oogoo009oo`03001oogoo00Moo`03001oogoo00Moo`80011oo`05001oogooOol00002Ool0
1@00Oomoogoo0000Bgoo001gOol2000:Ool20009Ool00`00Oomoo`0BOol20003Ool00`00Oomoo`09
Ool00`00Oomoo`06Ool00`00Oomoo`0>Ool20004Ool20003Ool00`00Oomoo`1:Ool00;ioo`03001o
ogoo06Eoo`00_Goo0P00Igoo003oOolWOol00?moobMoo`00ogoo9goo003oOolWOol00?moobMoo`00
ogoo9goo003oOolWOol00?moobMoo`00ogoo9goo003oOolWOol00?moobMoo`00ogoo9goo003oOolW
Ool00?moobMoo`00ogoo9goo003oOolWOol00?moobMoo`00ogoo9goo003oOolWOol00?moobMoo`00
ogoo9goo003oOolWOol00?moobMoo`00ogoo9goo003oOolWOol00?moobMoo`00ogoo9goo003oOolW
Ool00?moobMoo`00ogoo9goo003oOolWOol00?moobMoo`00ogoo9goo003oOolWOol00?moobMoo`00
ogoo9goo003oOolWOol00?moobMoo`00ogoo9goo0000\
\>"],
  ImageRangeCache->{{{0, 293.188}, {413.875, 0}} -> {-0.653492, -1.05093, \
0.00507849, 0.00507849}, {{6.9375, 250.375}, {403.813, 10}} -> {-1.8587, \
-2.18263, 0.00885518, 0.0109456}, {{266.5, 286.188}, {305.375, 206.938}} -> \
{-28.477, -330.832, 0.106668, 3.04867}},
  CellTags->{"Nyquist Plot", "i:10", "b:20.2"}],

Cell[BoxData[
    TagBox[\(\[SkeletonIndicator]  Graphics  \[SkeletonIndicator]\),
      False,
      Editable->False]], "Output",
  CellLabel->"Out[135]=",
  CellTags->{"Nyquist Plot", "i:10", "b:20.2"}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Root Locus", "Subsection",
  Evaluatable->False,
  AspectRatioFixed->True,
  CellTags->{"Root Locus", "i:11", "b:20.3"}],

Cell["\<\
To compute the root locus plot for values of the gain k ranging from 0 to 40 \
in steps of nominally unit length (40 steps). Actually, the gain is changed \
in a nonlinear fashion to achieve more uniform spacing of the computed \
points. The gain can be roughly estimated from the color scale. \
\>", "Text",
  Evaluatable->False,
  AspectRatioFixed->True,
  CellTags->{"Root Locus", "i:11", "b:20.3"}],

Cell[CellGroupData[{

Cell[BoxData[
    \(RootLocus[G, s, k, 0, \(+40. \), 1. ]\)], "Input",
  CellLabel->"In[136]:=",
  PageWidth->Infinity,
  AspectRatioFixed->True,
  CellTags->{"Root Locus", "i:11", "b:20.3"}],

Cell[BoxData[
    \("\n                Zeros in green, Open loop poles in red\n"\)], "Print",\

  CellLabel->"From In[136]:=",
  CellTags->{"Root Locus", "i:11", "b:20.3"}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: 1.4104 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.438894 0.671621 0.705202 0.671621 [
[ 0 0 0 0 ]
[ 1 1.4104 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
% Start of sub-graphic
p
0.0238095 0.033581 0.853978 1.37682 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.777239 0.0706581 0.809017 0.176047 [
[.07066 -0.0125 -9 -9 ]
[.07066 -0.0125 9 0 ]
[.21197 -0.0125 -6 -9 ]
[.21197 -0.0125 6 0 ]
[.35329 -0.0125 -6 -9 ]
[.35329 -0.0125 6 0 ]
[.49461 -0.0125 -6 -9 ]
[.49461 -0.0125 6 0 ]
[.63592 -0.0125 -6 -9 ]
[.63592 -0.0125 6 0 ]
[.77724 -0.0125 -3 -9 ]
[.77724 -0.0125 3 0 ]
[.91856 -0.0125 -3 -9 ]
[.91856 -0.0125 3 0 ]
[ 0 0 -0.125 0 ]
[.5 -0.0125 -17.3125 -22.1875 ]
[.5 -0.0125 17.3125 -9 ]
[-0.0125 .10483 -12 -4.5 ]
[-0.0125 .10483 0 4.5 ]
[-0.0125 .45692 -12 -4.5 ]
[-0.0125 .45692 0 4.5 ]
[-0.0125 .80902 -6 -4.5 ]
[-0.0125 .80902 0 4.5 ]
[-0.0125 1.16111 -6 -4.5 ]
[-0.0125 1.16111 0 4.5 ]
[-0.0125 1.5132 -6 -4.5 ]
[-0.0125 1.5132 0 4.5 ]
[ 0 0 -0.125 0 ]
[-0.01875 .80902 -46.625 -6.59375 ]
[-0.01875 .80902 -12 6.59375 ]
[ 0 1.61803 .125 0 ]
[.5 1.63053 -5.0625 0 ]
[.5 1.63053 5.0625 13.1875 ]
[ 1 0 .125 0 ]
[1.0125 .80902 0 -6.59375 ]
[1.0125 .80902 10.125 6.59375 ]
[.5 1.63053 -103.75 13.1875 ]
[.5 1.63053 103.75 35.6875 ]
[ 0 0 0 0 ]
[ 1 1.61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.07066 0 m
.07066 .00625 L
s
[(-10)] .07066 -0.0125 0 1 Mshowa
.21197 0 m
.21197 .00625 L
s
[(-8)] .21197 -0.0125 0 1 Mshowa
.35329 0 m
.35329 .00625 L
s
[(-6)] .35329 -0.0125 0 1 Mshowa
.49461 0 m
.49461 .00625 L
s
[(-4)] .49461 -0.0125 0 1 Mshowa
.63592 0 m
.63592 .00625 L
s
[(-2)] .63592 -0.0125 0 1 Mshowa
.77724 0 m
.77724 .00625 L
s
[(0)] .77724 -0.0125 0 1 Mshowa
.91856 0 m
.91856 .00625 L
s
[(2)] .91856 -0.0125 0 1 Mshowa
.125 Mabswid
.10599 0 m
.10599 .00375 L
s
.14132 0 m
.14132 .00375 L
s
.17665 0 m
.17665 .00375 L
s
.2473 0 m
.2473 .00375 L
s
.28263 0 m
.28263 .00375 L
s
.31796 0 m
.31796 .00375 L
s
.38862 0 m
.38862 .00375 L
s
.42395 0 m
.42395 .00375 L
s
.45928 0 m
.45928 .00375 L
s
.52994 0 m
.52994 .00375 L
s
.56526 0 m
.56526 .00375 L
s
.60059 0 m
.60059 .00375 L
s
.67125 0 m
.67125 .00375 L
s
.70658 0 m
.70658 .00375 L
s
.74191 0 m
.74191 .00375 L
s
.81257 0 m
.81257 .00375 L
s
.8479 0 m
.8479 .00375 L
s
.88323 0 m
.88323 .00375 L
s
.03533 0 m
.03533 .00375 L
s
.95388 0 m
.95388 .00375 L
s
.98921 0 m
.98921 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
gsave
.5 -0.0125 -78.3125 -26.1875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 21.1875 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(Re) show
%%IncludeResource: font Mathematica2Mono
%%IncludeFont: Mathematica2Mono
/Mathematica2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
75.250 13.313 moveto
(@) show
81.375 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(s) show
%%IncludeResource: font Mathematica2Mono
%%IncludeFont: Mathematica2Mono
/Mathematica2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
87.500 13.313 moveto
(D) show
93.625 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 .10483 m
.00625 .10483 L
s
[(-4)] -0.0125 .10483 1 0 Mshowa
0 .45692 m
.00625 .45692 L
s
[(-2)] -0.0125 .45692 1 0 Mshowa
0 .80902 m
.00625 .80902 L
s
[(0)] -0.0125 .80902 1 0 Mshowa
0 1.16111 m
.00625 1.16111 L
s
[(2)] -0.0125 1.16111 1 0 Mshowa
0 1.5132 m
.00625 1.5132 L
s
[(4)] -0.0125 1.5132 1 0 Mshowa
.125 Mabswid
0 .19285 m
.00375 .19285 L
s
0 .28088 m
.00375 .28088 L
s
0 .3689 m
.00375 .3689 L
s
0 .54495 m
.00375 .54495 L
s
0 .63297 m
.00375 .63297 L
s
0 .72099 m
.00375 .72099 L
s
0 .89704 m
.00375 .89704 L
s
0 .98506 m
.00375 .98506 L
s
0 1.07309 m
.00375 1.07309 L
s
0 1.24913 m
.00375 1.24913 L
s
0 1.33716 m
.00375 1.33716 L
s
0 1.42518 m
.00375 1.42518 L
s
0 .01681 m
.00375 .01681 L
s
0 1.60123 m
.00375 1.60123 L
s
.25 Mabswid
0 0 m
0 1.61803 L
s
gsave
-0.01875 .80902 -107.625 -10.5938 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 21.1875 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(Im) show
%%IncludeResource: font Mathematica2Mono
%%IncludeFont: Mathematica2Mono
/Mathematica2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
75.250 13.313 moveto
(@) show
81.375 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(s) show
%%IncludeResource: font Mathematica2Mono
%%IncludeFont: Mathematica2Mono
/Mathematica2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
87.500 13.313 moveto
(D) show
93.625 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.07066 1.61178 m
.07066 1.61803 L
s
.21197 1.61178 m
.21197 1.61803 L
s
.35329 1.61178 m
.35329 1.61803 L
s
.49461 1.61178 m
.49461 1.61803 L
s
.63592 1.61178 m
.63592 1.61803 L
s
.77724 1.61178 m
.77724 1.61803 L
s
.91856 1.61178 m
.91856 1.61803 L
s
.125 Mabswid
.10599 1.61428 m
.10599 1.61803 L
s
.14132 1.61428 m
.14132 1.61803 L
s
.17665 1.61428 m
.17665 1.61803 L
s
.2473 1.61428 m
.2473 1.61803 L
s
.28263 1.61428 m
.28263 1.61803 L
s
.31796 1.61428 m
.31796 1.61803 L
s
.38862 1.61428 m
.38862 1.61803 L
s
.42395 1.61428 m
.42395 1.61803 L
s
.45928 1.61428 m
.45928 1.61803 L
s
.52994 1.61428 m
.52994 1.61803 L
s
.56526 1.61428 m
.56526 1.61803 L
s
.60059 1.61428 m
.60059 1.61803 L
s
.67125 1.61428 m
.67125 1.61803 L
s
.70658 1.61428 m
.70658 1.61803 L
s
.74191 1.61428 m
.74191 1.61803 L
s
.81257 1.61428 m
.81257 1.61803 L
s
.8479 1.61428 m
.8479 1.61803 L
s
.88323 1.61428 m
.88323 1.61803 L
s
.03533 1.61428 m
.03533 1.61803 L
s
.95388 1.61428 m
.95388 1.61803 L
s
.98921 1.61428 m
.98921 1.61803 L
s
.25 Mabswid
0 1.61803 m
1 1.61803 L
s
gsave
.5 1.63053 -66.0625 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 21.1875 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.125 13.313 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.99375 .10483 m
1 .10483 L
s
.99375 .45692 m
1 .45692 L
s
.99375 .80902 m
1 .80902 L
s
.99375 1.16111 m
1 1.16111 L
s
.99375 1.5132 m
1 1.5132 L
s
.125 Mabswid
.99625 .19285 m
1 .19285 L
s
.99625 .28088 m
1 .28088 L
s
.99625 .3689 m
1 .3689 L
s
.99625 .54495 m
1 .54495 L
s
.99625 .63297 m
1 .63297 L
s
.99625 .72099 m
1 .72099 L
s
.99625 .89704 m
1 .89704 L
s
.99625 .98506 m
1 .98506 L
s
.99625 1.07309 m
1 1.07309 L
s
.99625 1.24913 m
1 1.24913 L
s
.99625 1.33716 m
1 1.33716 L
s
.99625 1.42518 m
1 1.42518 L
s
.99625 .01681 m
1 .01681 L
s
.99625 1.60123 m
1 1.60123 L
s
.25 Mabswid
1 0 m
1 1.61803 L
s
gsave
1.0125 .80902 -61 -10.5938 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 21.1875 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.125 13.313 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.5 1.63053 -164.75 9.1875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 30.5 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding WindowsANSIEncoding def
        currentdict
    end

    newfontname exch definefont pop
} def

63.000 17.438 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
%%BeginResource: font Courier-MISO
%%BeginFont: Courier-MISO
/Courier /Courier-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-MISO
%%IncludeFont: Courier-MISO
/Courier-MISO findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 17.438 moveto
%%IncludeResource: font Courier-MISO
%%IncludeFont: Courier-MISO
/Courier-MISO findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(G) show
%%IncludeResource: font Mathematica2Mono
%%IncludeFont: Mathematica2Mono
/Mathematica2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
69.125 17.438 moveto
(@) show
75.250 17.438 moveto
%%IncludeResource: font Courier-MISO
%%IncludeFont: Courier-MISO
/Courier-MISO findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(s) show
%%IncludeResource: font Mathematica2Mono
%%IncludeFont: Mathematica2Mono
/Mathematica2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
81.375 17.438 moveto
(D) show
87.500 17.438 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(=) show
93.625 17.438 moveto
%%IncludeResource: font Courier-MISO
%%IncludeFont: Courier-MISO
/Courier-MISO findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
%%IncludeResource: font Mathematica2Mono
%%IncludeFont: Mathematica2Mono
/Mathematica2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
141.500 11.500 moveto
(H) show
147.625 11.500 moveto
%%IncludeResource: font Courier-Italic
%%IncludeFont: Courier-Italic
%%BeginResource: font Courier-Italic-MISO
%%BeginFont: Courier-Italic-MISO
/Courier-Italic /Courier-Italic-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Italic-MISO
%%IncludeFont: Courier-Italic-MISO
/Courier-Italic-MISO findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(s) show
156.188 11.500 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(+) show
164.750 11.500 moveto
%%IncludeResource: font Courier-MISO
%%IncludeFont: Courier-MISO
/Courier-MISO findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
%%IncludeResource: font Mathematica2Mono
%%IncludeFont: Mathematica2Mono
/Mathematica2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
170.875 11.500 moveto
(L) show
179.500 11.500 moveto
(H) show
185.625 11.500 moveto
%%IncludeResource: font Courier-Italic-MISO
%%IncludeFont: Courier-Italic-MISO
/Courier-Italic-MISO findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(s) show
194.188 11.500 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(+) show
202.750 11.500 moveto
%%IncludeResource: font Courier-MISO
%%IncludeFont: Courier-MISO
/Courier-MISO findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(10) show
%%IncludeResource: font Mathematica2Mono
%%IncludeFont: Mathematica2Mono
/Mathematica2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
215.000 11.500 moveto
(L) show
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
97.938 17.438 moveto
(\\200\\200\\200\\200\\200\\200\\200\\200\\200\\200\\200\\200\\200\\200\\200\\\
200\\200\\200\\200\\200\\200\\200\\200\\200\\200\\200\\200\\200\\200\\200\\\
200\\200) show
169.938 17.438 moveto
(\\200\\200\\200\\200\\200\\200\\200\\200\\200\\200\\200\\200\\200\\200\\200\\\
200\\200\\200\\200\\200\\200\\200\\200\\200\\200\\200\\200\\200\\200\\200\\\
200\\200) show
241.938 17.438 moveto
(\\200\\200\\200\\200\\200\\200\\200\\200) show
259.938 17.438 moveto
(\\200) show
262.188 17.438 moveto
(\\200) show
%%IncludeResource: font Mathematica2Mono
%%IncludeFont: Mathematica2Mono
/Mathematica2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
99.313 23.688 moveto
(H) show
105.438 23.688 moveto
%%IncludeResource: font Courier-Italic-MISO
%%IncludeFont: Courier-Italic-MISO
/Courier-Italic-MISO findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(s) show
114.000 23.688 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(+) show
122.563 23.688 moveto
%%IncludeResource: font Courier-MISO
%%IncludeFont: Courier-MISO
/Courier-MISO findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
%%IncludeResource: font Mathematica2Mono
%%IncludeFont: Mathematica2Mono
/Mathematica2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
128.688 23.688 moveto
(L) show
137.313 23.688 moveto
(H) show
143.438 23.688 moveto
%%IncludeResource: font Courier-Italic-MISO
%%IncludeFont: Courier-Italic-MISO
/Courier-Italic-MISO findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(s) show
149.563 21.125 moveto
%%IncludeResource: font Courier-MISO
%%IncludeFont: Courier-MISO
/Courier-MISO findfont 7.125 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
156.813 23.688 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(+) show
165.375 23.688 moveto
%%IncludeResource: font Courier-Italic-MISO
%%IncludeFont: Courier-Italic-MISO
/Courier-Italic-MISO findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(s) show
173.938 23.688 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(+) show
182.500 23.688 moveto
%%IncludeResource: font Courier-MISO
%%IncludeFont: Courier-MISO
/Courier-MISO findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(1) show
%%IncludeResource: font Mathematica2Mono
%%IncludeFont: Mathematica2Mono
/Mathematica2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
188.625 23.688 moveto
(L) show
197.250 23.688 moveto
(H) show
203.375 23.688 moveto
%%IncludeResource: font Courier-Italic-MISO
%%IncludeFont: Courier-Italic-MISO
/Courier-Italic-MISO findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(s) show
209.500 21.125 moveto
%%IncludeResource: font Courier-MISO
%%IncludeFont: Courier-MISO
/Courier-MISO findfont 7.125 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
216.750 23.688 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(+) show
225.313 23.688 moveto
%%IncludeResource: font Courier-MISO
%%IncludeFont: Courier-MISO
/Courier-MISO findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
233.938 23.688 moveto
%%IncludeResource: font Courier-Italic-MISO
%%IncludeFont: Courier-Italic-MISO
/Courier-Italic-MISO findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(s) show
242.500 23.688 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(+) show
251.063 23.688 moveto
%%IncludeResource: font Courier-MISO
%%IncludeFont: Courier-MISO
/Courier-MISO findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
%%IncludeResource: font Mathematica2Mono
%%IncludeFont: Mathematica2Mono
/Mathematica2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
257.188 23.688 moveto
(L) show
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 1.61803 L
0 1.61803 L
closepath
clip
newpath
.75 g
.5 Mabswid
.77724 .80902 m
0 0 rlineto s
.77724 .80902 m
1 .95773 L
s
.77724 .80902 m
0 0 rlineto s
.77724 .80902 m
1 1.12946 L
s
.77724 .80902 m
0 0 rlineto s
.77724 .80902 m
1 1.36403 L
s
.77724 .80902 m
0 0 rlineto s
.77724 .80902 m
.96471 1.61803 L
s
.77724 .80902 m
0 0 rlineto s
.77724 .80902 m
.86424 1.61803 L
s
.77724 .80902 m
0 0 rlineto s
.77724 .80902 m
.77724 1.61803 L
s
.77724 .80902 m
0 0 rlineto s
.77724 .80902 m
.69023 1.61803 L
s
.77724 .80902 m
0 0 rlineto s
.77724 .80902 m
.58977 1.61803 L
s
.77724 .80902 m
0 0 rlineto s
.77724 .80902 m
.45253 1.61803 L
s
.77724 .80902 m
0 0 rlineto s
.77724 .80902 m
.21483 1.61803 L
s
.77724 .80902 m
0 0 rlineto s
.77724 .80902 m
0 1.3279 L
s
.77724 .80902 m
0 0 rlineto s
.77724 .80902 m
0 .80902 L
s
.77724 .80902 m
0 0 rlineto s
.77724 .80902 m
0 .29013 L
s
.77724 .80902 m
0 0 rlineto s
.77724 .80902 m
.21483 0 L
s
.77724 .80902 m
0 0 rlineto s
.77724 .80902 m
.45253 0 L
s
.77724 .80902 m
0 0 rlineto s
.77724 .80902 m
.58977 0 L
s
.77724 .80902 m
0 0 rlineto s
.77724 .80902 m
.69023 0 L
s
.77724 .80902 m
0 0 rlineto s
.77724 .80902 m
.77724 0 L
s
.77724 .80902 m
0 0 rlineto s
.77724 .80902 m
.86424 0 L
s
.77724 .80902 m
0 0 rlineto s
.77724 .80902 m
.96471 0 L
s
.77724 .80902 m
0 0 rlineto s
.77724 .80902 m
1 .254 L
s
.77724 .80902 m
0 0 rlineto s
.77724 .80902 m
1 .48858 L
s
.77724 .80902 m
0 0 rlineto s
.77724 .80902 m
1 .6603 L
s
.77724 .80902 m
0 0 rlineto s
.77724 .80902 m
1 .80902 L
s
.91856 .80902 m
.91744 .85315 L
.91412 .89658 L
.90863 .93863 L
.90108 .97864 L
.89157 1.01597 L
.88025 1.05004 L
.86732 1.08031 L
.85296 1.1063 L
.83741 1.1276 L
.82091 1.14388 L
.80372 1.15487 L
.78611 1.16042 L
.76837 1.16042 L
.75076 1.15487 L
.73357 1.14388 L
.71707 1.1276 L
.70152 1.1063 L
.68716 1.08031 L
.67422 1.05004 L
.66291 1.01597 L
.6534 .97864 L
.64585 .93863 L
.64036 .89658 L
.63704 .85315 L
.63592 .80902 L
.63704 .76489 L
.64036 .72145 L
.64585 .6794 L
.6534 .63939 L
.66291 .60206 L
.67422 .56799 L
.68716 .53772 L
.70152 .51173 L
.71707 .49043 L
.73357 .47416 L
.75076 .46316 L
.76837 .45762 L
.78611 .45762 L
.80372 .46316 L
.82091 .47416 L
.83741 .49043 L
.85296 .51173 L
.86732 .53772 L
.88025 .56799 L
.89157 .60206 L
.90108 .63939 L
.90863 .6794 L
.91412 .72145 L
.91744 .76489 L
Mistroke
.91856 .80902 L
Mfstroke
1 1.24068 m
.98327 1.29107 L
.9574 1.3516 L
.92868 1.40358 L
.89758 1.44618 L
.86458 1.47874 L
.8302 1.50073 L
.79499 1.51181 L
.75949 1.51181 L
.72428 1.50073 L
.6899 1.47874 L
.6569 1.44618 L
.6258 1.40358 L
.59708 1.3516 L
.57121 1.29107 L
.54858 1.22293 L
.52957 1.14826 L
.51445 1.06825 L
.50349 .98414 L
.49684 .89727 L
.49461 .80902 L
.49684 .72076 L
.50349 .63389 L
.51445 .54979 L
.52957 .46977 L
.54858 .39511 L
.57121 .32697 L
.59708 .26643 L
.6258 .21445 L
.6569 .17185 L
.6899 .1393 L
.72428 .1173 L
.75949 .10622 L
.79499 .10622 L
.8302 .1173 L
.86458 .1393 L
.89758 .17185 L
.92868 .21445 L
.9574 .26643 L
.98327 .32697 L
s
.98327 .32697 m
1 .37736 L
s
.50493 1.61803 m
.46819 1.53209 L
.43426 1.42988 L
.40573 1.31788 L
.38306 1.19786 L
.36661 1.0717 L
.35663 .9414 L
.35329 .80902 L
.35663 .67663 L
.36661 .54633 L
.38306 .42017 L
.40573 .30015 L
.43426 .18815 L
.46819 .08594 L
s
.46819 .08594 m
.50493 0 L
s
.31514 1.61803 m
.28189 1.48751 L
.25167 1.32747 L
.22973 1.15927 L
.21643 .98553 L
.21197 .80902 L
.21643 .6325 L
.22973 .45877 L
.25167 .29056 L
.28189 .13053 L
s
.28189 .13053 m
.31514 0 L
s
.15067 1.61803 m
.12028 1.45709 L
.09286 1.24683 L
.07623 1.02966 L
.07066 .80902 L
.07623 .58837 L
.09286 .37121 L
.12028 .16095 L
s
.12028 .16095 m
.15067 0 L
s
.75 0 0 r
.012 w
.42395 .80902 Mdot
.70658 .63297 Mdot
.70658 .98506 Mdot
.74191 .65656 Mdot
.74191 .96148 Mdot
.75 0 .073 r
.42395 .80902 Mdot
.70643 .63304 Mdot
.70643 .98499 Mdot
.74206 .65626 Mdot
.74206 .96177 Mdot
.75 0 .146 r
.42395 .80902 Mdot
.70541 .63343 Mdot
.70541 .9846 Mdot
.74308 .65433 Mdot
.74308 .9637 Mdot
.75 0 .219 r
.42397 .80902 Mdot
.70288 .63392 Mdot
.70288 .98411 Mdot
.7456 .64983 Mdot
.7456 .9682 Mdot
.75 0 .292 r
.42399 .80902 Mdot
.69875 .63358 Mdot
.69875 .98446 Mdot
.74972 .64297 Mdot
.74972 .97507 Mdot
.75 0 .366 r
.42403 .80902 Mdot
.69346 .63165 Mdot
.69346 .98638 Mdot
.75499 .63434 Mdot
.75499 .98369 Mdot
.75 0 .439 r
.42408 .80902 Mdot
.68753 .62808 Mdot
.68753 .98996 Mdot
.7609 .6244 Mdot
.7609 .99363 Mdot
.75 0 .512 r
.42416 .80902 Mdot
.68132 .62316 Mdot
.68132 .99487 Mdot
.76707 .61345 Mdot
.76707 1.00458 Mdot
.75 0 .585 r
.42426 .80902 Mdot
.67505 .61727 Mdot
.67505 1.00076 Mdot
.77329 .60174 Mdot
.77329 1.01629 Mdot
.75 0 .658 r
.4244 .80902 Mdot
.66881 .61073 Mdot
.66881 1.00731 Mdot
.77945 .58947 Mdot
.77945 1.02856 Mdot
.75 0 .731 r
.42457 .80902 Mdot
.66267 .60378 Mdot
.66267 1.01426 Mdot
.78551 .5768 Mdot
.78551 1.04123 Mdot
.696 0 .75 r
.42477 .80902 Mdot
.65664 .59659 Mdot
.65664 1.02145 Mdot
.79144 .56384 Mdot
.79144 1.05419 Mdot
.623 0 .75 r
.42501 .80902 Mdot
.65072 .58928 Mdot
.65072 1.02875 Mdot
.79724 .55069 Mdot
.79724 1.06734 Mdot
.549 0 .75 r
.4253 .80902 Mdot
.6449 .58194 Mdot
.6449 1.03609 Mdot
.80291 .53739 Mdot
.80291 1.08064 Mdot
.476 0 .75 r
.42564 .80902 Mdot
.63918 .57463 Mdot
.63918 1.04341 Mdot
.80847 .52401 Mdot
.80847 1.09403 Mdot
.403 0 .75 r
.42603 .80902 Mdot
.63354 .56738 Mdot
.63354 1.05065 Mdot
.81391 .51055 Mdot
.81391 1.10748 Mdot
.33 0 .75 r
.42648 .80902 Mdot
.62798 .56022 Mdot
.62798 1.05781 Mdot
.81925 .49706 Mdot
.81925 1.12098 Mdot
.257 0 .75 r
.42699 .80902 Mdot
.62248 .55318 Mdot
.62248 1.06486 Mdot
.82449 .48354 Mdot
.82449 1.13449 Mdot
.184 0 .75 r
.42756 .80902 Mdot
.61705 .54625 Mdot
.61705 1.07178 Mdot
.82964 .47001 Mdot
.82964 1.14802 Mdot
.111 0 .75 r
.42819 .80902 Mdot
.61166 .53945 Mdot
.61166 1.07859 Mdot
.83471 .45648 Mdot
.83471 1.16155 Mdot
.038 0 .75 r
.4289 .80902 Mdot
.60631 .53277 Mdot
.60631 1.08526 Mdot
.83971 .44296 Mdot
.83971 1.17508 Mdot
0 .036 .75 r
.42968 .80902 Mdot
.60099 .52622 Mdot
.60099 1.09181 Mdot
.84463 .42944 Mdot
.84463 1.18859 Mdot
0 .109 .75 r
.43054 .80902 Mdot
.5957 .51979 Mdot
.5957 1.09824 Mdot
.84949 .41594 Mdot
.84949 1.2021 Mdot
0 .182 .75 r
.43149 .80902 Mdot
.59043 .51348 Mdot
.59043 1.10455 Mdot
.85429 .40245 Mdot
.85429 1.21558 Mdot
0 .255 .75 r
.43251 .80902 Mdot
.58517 .50728 Mdot
.58517 1.11076 Mdot
.85904 .38898 Mdot
.85904 1.22905 Mdot
0 .328 .75 r
.43362 .80902 Mdot
.57993 .50117 Mdot
.57993 1.11686 Mdot
.86373 .37553 Mdot
.86373 1.24251 Mdot
0 .401 .75 r
.43482 .80902 Mdot
.57469 .49515 Mdot
.57469 1.12288 Mdot
.86837 .3621 Mdot
.86837 1.25594 Mdot
0 .474 .75 r
.43611 .80902 Mdot
.56945 .48921 Mdot
.56945 1.12882 Mdot
.87296 .34868 Mdot
.87296 1.26935 Mdot
0 .548 .75 r
.43749 .80902 Mdot
.56421 .48334 Mdot
.56421 1.1347 Mdot
.87751 .33529 Mdot
.87751 1.28274 Mdot
0 .621 .75 r
.43895 .80902 Mdot
.55898 .47751 Mdot
.55898 1.14053 Mdot
.88201 .32192 Mdot
.88201 1.29612 Mdot
0 .694 .75 r
.4405 .80902 Mdot
.55373 .47172 Mdot
.55373 1.14632 Mdot
.88648 .30857 Mdot
.88648 1.30947 Mdot
0 .75 .733 r
.44214 .80902 Mdot
.54849 .46594 Mdot
.54849 1.15209 Mdot
.89091 .29523 Mdot
.89091 1.3228 Mdot
0 .75 .66 r
.44384 .80902 Mdot
.54324 .46018 Mdot
.54324 1.15786 Mdot
.8953 .28192 Mdot
.8953 1.33612 Mdot
0 .75 .587 r
.44562 .80902 Mdot
.53799 .4544 Mdot
.53799 1.16363 Mdot
.89966 .26862 Mdot
.89966 1.34941 Mdot
0 .75 .514 r
.44746 .80902 Mdot
.53275 .4486 Mdot
.53275 1.16943 Mdot
.90399 .25535 Mdot
.90399 1.36269 Mdot
0 .75 .441 r
.44934 .80902 Mdot
.52751 .44277 Mdot
.52751 1.17527 Mdot
.90828 .24209 Mdot
.90828 1.37595 Mdot
0 .75 .367 r
.45126 .80902 Mdot
.52229 .43688 Mdot
.52229 1.18115 Mdot
.91255 .22885 Mdot
.91255 1.38919 Mdot
0 .75 .294 r
.45319 .80902 Mdot
.51708 .43095 Mdot
.51708 1.18708 Mdot
.91679 .21562 Mdot
.91679 1.40241 Mdot
0 .75 .221 r
.45513 .80902 Mdot
.5119 .42496 Mdot
.5119 1.19307 Mdot
.921 .20242 Mdot
.921 1.41562 Mdot
0 .75 .148 r
.45706 .80902 Mdot
.50675 .41891 Mdot
.50675 1.19912 Mdot
.92518 .18922 Mdot
.92518 1.42881 Mdot
0 .75 .075 r
.45896 .80902 Mdot
.50164 .41281 Mdot
.50164 1.20522 Mdot
.92934 .17605 Mdot
.92934 1.44199 Mdot
0 1 0 r
.0125 w
.07066 .80902 Mdot
.49461 .80902 Mdot
1 0 0 r
.42395 .80902 Mdot
.70658 .63297 Mdot
.70658 .98506 Mdot
.74191 .65656 Mdot
.74191 .96148 Mdot
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.909028 0.369391 0.97619 0.705202 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.00980392 0.490196 0.0024975 0.124875 [
[ 0 0 0 0 ]
[ 1 5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 5 L
0 5 L
closepath
clip
newpath
.75 0 0 r
.0098 .0025 m
.0098 .12737 L
.5 .12737 L
.5 .0025 L
F
0 g
gsave
.52451 .06494 -61 -10.5938 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 21.1875 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(0) show
69.125 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.75 0 .075 r
.0098 .12737 m
.0098 .25225 L
.5 .25225 L
.5 .12737 L
F
.75 0 .15 r
.0098 .25225 m
.0098 .37712 L
.5 .37712 L
.5 .25225 L
F
.75 0 .225 r
.0098 .37712 m
.0098 .502 L
.5 .502 L
.5 .37712 L
F
.75 0 .3 r
.0098 .502 m
.0098 .62687 L
.5 .62687 L
.5 .502 L
F
.75 0 .375 r
.0098 .62687 m
.0098 .75175 L
.5 .75175 L
.5 .62687 L
F
.75 0 .45 r
.0098 .75175 m
.0098 .87662 L
.5 .87662 L
.5 .75175 L
F
.75 0 .525 r
.0098 .87662 m
.0098 1.0015 L
.5 1.0015 L
.5 .87662 L
F
.75 0 .6 r
.0098 1.0015 m
.0098 1.12637 L
.5 1.12637 L
.5 1.0015 L
F
.75 0 .675 r
.0098 1.12637 m
.0098 1.25125 L
.5 1.25125 L
.5 1.12637 L
F
.75 0 .75 r
.0098 1.25125 m
.0098 1.37612 L
.5 1.37612 L
.5 1.25125 L
F
.675 0 .75 r
.0098 1.37612 m
.0098 1.501 L
.5 1.501 L
.5 1.37612 L
F
.6 0 .75 r
.0098 1.501 m
.0098 1.62587 L
.5 1.62587 L
.5 1.501 L
F
.525 0 .75 r
.0098 1.62587 m
.0098 1.75075 L
.5 1.75075 L
.5 1.62587 L
F
.45 0 .75 r
.0098 1.75075 m
.0098 1.87562 L
.5 1.87562 L
.5 1.75075 L
F
.375 0 .75 r
.0098 1.87562 m
.0098 2.0005 L
.5 2.0005 L
.5 1.87562 L
F
.3 0 .75 r
.0098 2.0005 m
.0098 2.12537 L
.5 2.12537 L
.5 2.0005 L
F
.225 0 .75 r
.0098 2.12537 m
.0098 2.25025 L
.5 2.25025 L
.5 2.12537 L
F
.15 0 .75 r
.0098 2.25025 m
.0098 2.37512 L
.5 2.37512 L
.5 2.25025 L
F
.075 0 .75 r
.0098 2.37512 m
.0098 2.5 L
.5 2.5 L
.5 2.37512 L
F
0 0 .75 r
.0098 2.5 m
.0098 2.62488 L
.5 2.62488 L
.5 2.5 L
F
0 .075 .75 r
.0098 2.62488 m
.0098 2.74975 L
.5 2.74975 L
.5 2.62488 L
F
0 .15 .75 r
.0098 2.74975 m
.0098 2.87463 L
.5 2.87463 L
.5 2.74975 L
F
0 .225 .75 r
.0098 2.87463 m
.0098 2.9995 L
.5 2.9995 L
.5 2.87463 L
F
0 .3 .75 r
.0098 2.9995 m
.0098 3.12438 L
.5 3.12438 L
.5 2.9995 L
F
0 .375 .75 r
.0098 3.12438 m
.0098 3.24925 L
.5 3.24925 L
.5 3.12438 L
F
0 .45 .75 r
.0098 3.24925 m
.0098 3.37413 L
.5 3.37413 L
.5 3.24925 L
F
0 .525 .75 r
.0098 3.37413 m
.0098 3.499 L
.5 3.499 L
.5 3.37413 L
F
0 .6 .75 r
.0098 3.499 m
.0098 3.62388 L
.5 3.62388 L
.5 3.499 L
F
0 .675 .75 r
.0098 3.62388 m
.0098 3.74875 L
.5 3.74875 L
.5 3.62388 L
F
0 .75 .75 r
.0098 3.74875 m
.0098 3.87363 L
.5 3.87363 L
.5 3.74875 L
F
0 .75 .675 r
.0098 3.87363 m
.0098 3.9985 L
.5 3.9985 L
.5 3.87363 L
F
0 .75 .6 r
.0098 3.9985 m
.0098 4.12338 L
.5 4.12338 L
.5 3.9985 L
F
0 .75 .525 r
.0098 4.12338 m
.0098 4.24825 L
.5 4.24825 L
.5 4.12338 L
F
0 .75 .45 r
.0098 4.24825 m
.0098 4.37313 L
.5 4.37313 L
.5 4.24825 L
F
0 .75 .375 r
.0098 4.37313 m
.0098 4.498 L
.5 4.498 L
.5 4.37313 L
F
0 .75 .3 r
.0098 4.498 m
.0098 4.62288 L
.5 4.62288 L
.5 4.498 L
F
0 .75 .225 r
.0098 4.62288 m
.0098 4.74775 L
.5 4.74775 L
.5 4.62288 L
F
0 .75 .15 r
.0098 4.74775 m
.0098 4.87263 L
.5 4.87263 L
.5 4.74775 L
F
0 .75 .075 r
.0098 4.87263 m
.0098 4.9975 L
.5 4.9975 L
.5 4.87263 L
F
0 g
gsave
.52451 4.93506 -61 -10.5938 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 21.1875 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(40.) show
81.375 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
MathSubEnd
P
% End of sub-graphic
0 0 m
1 0 L
1 1.4104 L
0 1.4104 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  CellLabel->"From In[136]:=",
  ImageSize->{318.188, 448.75},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004n0001`1000`40O003h00Oogoo?goo003oOolo
Ool00?moocmoo`00ogoo?goo003oOoloOol00?moocmoo`00ogoo?goo003oOoloOol00?moocmoo`00
ogoo?goo003oOoloOol00?moocmoo`00ogoo?goo003oOoloOol00?moocmoo`00ogoo?goo003oOolo
Ool00?moocmoo`00ogoo?goo003oOoloOol00?moocmoo`00ogoo?goo003oOoloOol00?moocmoo`00
ogoo?goo003oOoloOol00?moocmoo`00ogoo?goo003oOoloOol00?moocmoo`00ogoo?goo003oOolo
Ool00?moocmoo`00WGoo0P002Goo0P00U7oo002MOol00`00Oomoo`09Ool00`00Oomoo`2BOol008io
o`<0009oo`03001oogoo00<000Aoo`03001oogoo009oo`<000Aoo`03001oogoo099oo`00Sgoo00@0
07ooOol0009oo`03001oogoo00Eoo`03001oogoo00Eoo`05001oogooOol0002DOol008moo`<000=o
o`@000Aoo`03001oogoo009oo`<000Aoo`03001oogoo099oo`00Sgoo00@007ooOol000=oo`8000Eo
o`03001oogoo009oo`@000=oo`03001oogoo099oo`00Sgoo00@007ooOol000Yoo`03001oogoo00Uo
o`03001oogoo099oo`00SWoo10002goo0P002Goo0P00U7oo003oOoloOol00?moocmoo`00ogoo?goo
0016Ool50002Ool2000GOol2000IOol3000KOol3000HOol4000FOol2000IOol4001;Ool004Qoo`05
001oogooOol00002Ool00`00Oomoo`0COol01000Oomoo`0067oo00@007ooOol001]oo`03001oogoo
01Moo`03001oogoo01Ioo`04001oogoo000HOol00`00Oomoo`1<Ool004Qoo`05001oogooOol00002
Ool00`00Oomoo`0COol01000Oomoo`0067oo00@007ooOol001Qoo`D001Uoo`03001oogoo01Eoo`04
001oogoo000IOol00`00Oomoo`1;Ool0041oo`@000Aoo`05001oogooOol00002Ool00`00Oomoo`0=
Ool40003Ool2000COol40002Ool3000COol40002Ool01000Oomoo`004goo100017oo00<007ooOol0
57oo00@007ooOol001Yoo`03001oogoo04Yoo`00B7oo00D007ooOomoo`00009oo`03001oogoo01=o
o`04001oogoo000IOol00`00Oomoo`0IOol00`00Ool0000IOol01000Oomoo`005Goo00@007ooOol0
01Qoo`04001oogoo001;Ool004Moo`8000Aoo`8001Moo`8001Yoo`<001Yoo`8001Yoo`8001Moo`80
01Yoo`8004aoo`00ogoo?goo003oOoloOol00?moocmoo`00ogoo?goo003oOoloOol003UoolX003]o
o`00>Goo00<007ooOol017oo00<007ooOol01Goo00<007ooOol017oo00<007ooOol017oo00<007oo
G_L017oo00<007ooOol017oo00<005kgOol017oo00<007ooOol017oo00<007ooOol017oo00=Nmgoo
Ool017oo00<007ooOol017oo00<007ooOol017oo00<007ooOol00goo00=Nm`00Ool01Goo00@007oo
OomNm`Aoo`03001oogoo00Aoo`03001oogoo009oo`03G_Moo`0000Ioo`03001oogoo00Aoo`05001o
ogooOomNm`02Ool00`00Oomoo`04Ool00`00Oomoo`04Ool00ekgOomoo`04Ool00`00Oomoo`04Ool0
1000Oomooekg0goo00<007ooOol017oo00<007ooOol017oo00@007ooOomNm`Aoo`03001oo`0003]o
o`00>Goo00<007ooOol077oo00=NmgooOol02Woo00=NmgooOol047oo00=NmgooOol06Woo00=Nmgoo
Ool01Woo00=NmgooOol03goo00=NmgooOol04Goo00=NmgooOol03Woo00=NmgooOol03Woo00=Nmgoo
Ool04Woo00=NmgooOol017oo00<007ooOol0>Goo000iOol2000LOol00ekgOomoo`0<Ool00ekgOomo
o`0?Ool00ekgOomoo`0JOol00ekgOomoo`06Ool00ekgOomoo`0@Ool00ekgOomoo`0@Ool00ekgOomo
o`0>Ool00ekgOomoo`0>Ool00ekgOomoo`0AOol00ekgOomoo`04Ool2000kOol003Uoo`03001oogoo
01]oo`03G_Moogoo00eoo`03G_Moogoo00ioo`03G_Moogoo01]oo`03G_Moogoo00Aoo`03G_Moogoo
015oo`03G_Moogoo011oo`03G_Moogoo00ioo`03G_Moogoo00ioo`03G_Moogoo015oo`03G_Moogoo
00Eoo`03001oogoo03Uoo`00>Goo00<007ooOol06goo00=NmgooOol03Goo00=NmgooOol03Woo00=N
mgooOol06goo00=NmgooOol017oo00=NmgooOol04Goo00=NmgooOol04Goo00=NmgooOol03Goo00=N
mgooOol03Goo00=NmgooOol04Woo00=NmgooOol01Goo00<007ooOol0>Goo000iOol00`00Oomoo`0K
Ool00ekgOomoo`0>Ool00ekgOomoo`0<Ool00ekgOomoo`0LOol00ekgOomoo`03Ool00ekgOomoo`0B
Ool00ekgOomoo`0AOol00ekgOomoo`0=Ool00ekgOomoo`0=Ool00ekgOomoo`0BOol00ekgOomoo`05
Ool00`00Oomoo`0iOol003Uoo`03001oogoo01Yoo`03G_Moogoo011oo`03G_Moogoo00]oo`03G_Mo
ogoo01eoo`03G_Moogoo009oo`03G_Moogoo01=oo`03G_Moogoo011oo`03G_Moogoo00eoo`03G_Mo
ogoo00eoo`03G_Moogoo015oo`03G_Moogoo00Ioo`03001oogoo03Uoo`00>Goo00<007ooOol06Woo
00=NmgooOol04Goo00=NmgooOol02Woo00=NmgooOol07Goo00ENmgooOomooekg01Ioo`03G_Moogoo
011oo`03G_Moogoo00eoo`03G_Moogoo00eoo`03G_Moogoo015oo`03G_Moogoo00Ioo`03001oogoo
03Uoo`00>Goo00<007ooOol06Woo00=NmgooOol04Goo00=NmgooOol02Woo00=NmgooOol07Woo00AN
mgooOomNmaIoo`03G_Moogoo011oo`03G_Moogoo00eoo`03G_Moogoo00eoo`03G_Moogoo015oo`03
G_Moogoo00Ioo`03001oogoo03Uoo`00>Goo00<007ooOol06Woo00=NmgooOol04Woo00=NmgooOol0
27oo00=NmgooOol07goo00=NmgooG_L05goo00=NmgooOol047oo00=NmgooOol03Goo00=NmgooOol0
3Goo00=NmgooOol04Goo00=NmgooOol01Woo00<007ooOol0>Goo000iOol00`00Oomoo`0JOol00ekg
Oomoo`0COol00ekgOomoo`07Ool00ekgOomoo`0OOol00ekgOomNm`0HOol00ekgOomoo`0?Ool00ekg
Oomoo`0=Ool00ekgOomoo`0=Ool00ekgOomoo`0@Ool00ekgOomoo`07Ool00`00Oomoo`0iOol003Uo
o`03001oogoo01Uoo`03G_Moogoo01Aoo`03G_Moogoo00Moo`03G_Moogoo021oo`03G_Moogoo01Mo
o`03G_Moogoo00moo`03G_Moogoo00eoo`03G_Moogoo00eoo`03G_Moogoo011oo`03G_Moogoo00Mo
o`03001oogoo03Uoo`00>Goo00<007ooOol06Goo00=NmgooOol05Goo00=NmgooOol01Goo00=Nmgoo
Ool08Goo00=NmgooOol05goo00=NmgooOol03goo00=NmgooOol03Goo00=NmgooOol03Goo00=Nmgoo
Ool047oo00=NmgooOol01goo00<007ooOol0>Goo000iOol00`00Oomoo`0IOol00ekgOomoo`0FOol0
0ekgOomoo`04Ool00ekgOomoo`0POol00ekgOomNm`0HOol00ekgOomoo`0?Ool00ekgOomoo`0=Ool0
0ekgOomoo`0=Ool00ekgOomoo`0@Ool00ekgOomoo`07Ool00`00Oomoo`0iOol003Uoo`03001oogoo
01Uoo`03G_Moogoo01Ioo`03G_Moogoo00Aoo`03G_Moogoo021oo`03G_Mooekg01Qoo`03G_Moogoo
011oo`03G_Moogoo00aoo`03G_Moogoo00aoo`03G_Moogoo011oo`03G_Moogoo00Qoo`03001oogoo
03Uoo`00>Goo00<007ooOol067oo00=NmgooOol067oo00=NmgooOol00goo00=NmgooOol07goo00AN
mgooOomNmaUoo`03G_Moogoo00moo`03G_Moogoo00aoo`03G_Moogoo00aoo`03G_Moogoo011oo`03
G_Moogoo00Qoo`03001oogoo03Uoo`00>Goo00<007ooOol067oo00=NmgooOol06Goo00ENmgooOomo
oekg029oo`05G_MoogooOomNm`0HOol00ekgOomoo`0?Ool00ekgOomoo`0<Ool00ekgOomoo`0<Ool0
0ekgOomoo`0@Ool00ekgOomoo`08Ool00`00Oomoo`0iOol003Uoo`03001oogoo01Qoo`03G_Moogoo
01Yoo`04G_MoogooG_LROol01EkgOomoogooG_L067oo00=NmgooOol03goo00=NmgooOol037oo00=N
mgooOol037oo00=NmgooOol047oo00=NmgooOol027oo00<007ooOol0>Goo000dOol30002Ool00`00
Oomoo`0HOol00ekgOomoo`0JOol015kgOomooekg8Goo00=NmgooOol00goo00=NmgooOol05Goo00=N
mgooOol03goo00=NmgooOol037oo00=NmgooOol037oo00=NmgooOol047oo00=NmgooOol027oo00<0
07ooOol0>Goo000eOol01@00Oomoogoo00006Woo00=NmgooOol06goo00=NmgooG_L08Goo00=Nmgoo
Ool00goo00=NmgooOol05Woo00=NmgooOol03Woo00=NmgooOol037oo00=NmgooOol037oo00=Nmgoo
Ool03goo00=NmgooOol02Goo00<007ooOol0>Goo000bOol50002Ool3000GOol00ekgOomoo`0MOol0
0ekgOomoo`0POol00ekgOomoo`03Ool00ekgOomoo`0FOol00ekgOomoo`0>Ool00ekgOomoo`08Ool:
G_L9Ool00ekgOomoo`0?Ool00ekgOomoo`07Ool3000kOol002aoo`@0009oo`04001oogoo0003Ool0
0`00Oomoo`0GOol00ekgOomoo`0MOol00ekgOomoo`0OOol00ekgOomoo`05Ool00ekgOomoo`0EOol0
0ekgOomoo`0>Ool00ekgOomoo`04Ool4G_L4Ool00ekgOomoo`03Ool4G_L5Ool00ekgOomoo`0?Ool0
0ekgOomoo`09Ool00`00Oomoo`0iOol003=oo`03001oo`0000=oo`03001oogoo01Moo`03G_Moogoo
01eoo`9Nmb1oo`03G_Moogoo00Eoo`03G_Moogoo01Eoo`03G_Moogoo00ioo`04G_MoogooOol3G_L8
Ool00ekgOomoo`07Ool2G_L3Ool00ekgOomoo`0?Ool00ekgOomoo`09Ool00`00Oomoo`0iOol003Ao
o`8000=oo`03001oogoo01Moo`03G_Moogoo01eoo`03G_Mooekg01moo`03G_Moogoo00Ioo`03G_Mo
ogoo01Aoo`03G_Moogoo00moo`03G_Mooekg00]oo`03G_Moogoo00Uoo`=Nma5oo`03G_Moogoo00Yo
o`03001oogoo03Uoo`00>Goo00<007ooOol05goo00=NmgooOol077oo00ANmgooOomNmaioo`03G_Mo
ogoo00Moo`03G_Moogoo01Eoo`03G_Moogoo00ioo`9Nm`aoo`03G_Moogoo00]oo`03G_Moogoo00mo
o`03G_Moogoo00Yoo`03001oogoo03Uoo`00>Goo00<007ooOol05Woo00=NmgooOol07Goo00ENmgoo
Oomooekg01eoo`03G_Moogoo00Moo`03G_Moogoo01Eoo`03G_Moogoo00eoo`9Nm`eoo`03G_Moogoo
00]oo`9Nma1oo`03G_Moogoo00Yoo`03001oogoo03Uoo`00>Goo00<007ooOol05Woo00=NmgooOol0
7Goo00=NmgooOol00Woo00=NmgooOol06Woo00=NmgooOol027oo00=NmgooOol057oo00=NmgooOol0
37oo00=NmgooG_L03Goo00=NmgooOol02goo00ANmgooG_MNm`ioo`03G_Moogoo00Yoo`03001oogoo
03Uoo`00>Goo00<007ooOol05Woo00=NmgooOol07Goo00=NmgooOol00goo00=NmgooOol067oo00=N
mgooOol02Goo00=NmgooOol057oo00=NmgooOol02goo00ANmgooOomNm`eoo`03G_Moogoo00]oo`05
G_MoogooOomNm`0<Ool00ekgOomoo`0;Ool00`00Oomoo`0iOol003Uoo`03001oogoo01Ioo`03G_Mo
ogoo01aoo`03G_Moogoo00Aoo`03G_Moogoo01Qoo`03G_Moogoo00Yoo`03G_Moogoo01Aoo`03G_Mo
ogoo00Uoo`05G_MoogooOomNm`0=Ool00ekgOomoo`0;Ool00ekgOomoo`02Ool00ekgOomoo`09Ool0
0ekgOomoo`0;Ool00`00Oomoo`0iOol003Uoo`03001oogoo01Eoo`03G_Moogoo01eoo`03G_Moogoo
00Eoo`03G_Moogoo01Moo`03G_Moogoo00Yoo`03G_Moogoo01Aoo`03G_Moogoo00Qoo`03G_Moogoo
009oo`03G_Moogoo00]oo`03G_Moogoo00]oo`03G_Moogoo00=oo`03G_Moogoo00Qoo`03G_Moogoo
00]oo`03001oogoo03Uoo`00>Goo00<007ooOol05Goo00=NmgooOol07Goo00=NmgooOol01Woo00=N
mgooOol05Goo00=NmgooOol02goo00=NmgooOol057oo00=NmgooOol01Woo0Ukg1Goo00=NmgooOol0
2goo00=NmgooOol02goo00=NmgooOol017oo00=NmgooOol01goo00=NmgooOol02goo00<007ooOol0
>Goo000iOol00`00Oomoo`0EOol00ekgOomoo`0MOol00ekgOomoo`06Ool00ekgOomoo`0EOol00ekg
Oomoo`0<Ool00ekgOomoo`0COol00ekgOomoo`05Ool00ekgOomoo`05Ool00ekgOomoo`0;Ool00ekg
Oomoo`0;Ool00ekgOomoo`05Ool00ekgOomoo`05Ool00ekgOomoo`0<Ool00`00Oomoo`0iOol003Uo
o`03001oogoo01Eoo`03G_Moogoo01eoo`03G_Moogoo00Moo`03G_Moogoo01Aoo`03G_Moogoo00ao
o`03G_Moogoo01Aoo`03G_Moogoo00=oo`03G_Moogoo00Ioo`03G_Moogoo00]oo`03G_Moogoo00]o
o`03G_Moogoo00Ioo`03G_Moogoo00Aoo`03G_Moogoo00aoo`03001oogoo03Uoo`00>Goo00<007oo
Ool05Goo00=NmgooOol077oo00=NmgooOol02Goo00=NmgooOol04Woo00=NmgooOol03Woo00=Nmgoo
Ool04goo00=NmgooOol00Woo00=NmgooOol027oo00=NmgooOol02Woo00=NmgooOol02Woo00=Nmgoo
Ool027oo00=NmgooOol00goo00=NmgooOol037oo00<007ooOol0>Goo000iOol00`00Oomoo`0EOol0
0ekgOomoo`0LOol00ekgOomoo`09Ool00ekgOomoo`0BOol00ekgOomoo`0>Ool00ekgOomoo`0COol0
1EkgOomoogooG_L02goo00=NmgooOol02Woo00=NmgooOol02Woo00=NmgooOol02Goo00=NmgooOol0
0Woo00<2hWooOol037oo00<007ooOol0>Goo000iOol00`00Oomoo`0EOol00ekgOomoo`0LOol00ekg
Oomoo`0:Ool00ekgOomoo`0AOol00ekgOomoo`0>Ool00ekgOomoo`0COol01EkgOomoogooG_L02goo
00=NmgooOol02Woo00=NmgooOol02Woo00=NmgooOol02Goo00=NmgooOol00Woo00<2hWooOol037oo
00<007ooOol0>Goo000iOol00`00Oomoo`0DOol00ekgOomoo`0MOol00ekgOomoo`0;Ool00ekgOomo
o`0?Ool00ekgOomoo`0@Ool00ekgOomoo`0BOol015kgOomooekg37oo00=NmgooOol02Woo00=Nmgoo
Ool02Woo00=NmgooOol02Woo00ANmgooOol2i0moo`03001oogoo03Uoo`00>Goo0P005Goo00=Nmgoo
Ool07Goo00=NmgooOol037oo00=NmgooOol03Woo00=NmgooOol047oo00=NmgooOol04goo0Ukg3Goo
00=NmgooOol02Woo00=NmgooOol02Woo00=NmgooOol02goo00=Nmgoo0^@03Woo0P00>goo000iOol0
0`00Oomoo`0DOol00ekgOomoo`0MOol00ekgOomoo`0<Ool00ekgOomoo`0>Ool00ekgOomoo`0AOol0
0ekgOomoo`0BOol2G_L=Ool00ekgOomoo`0:Ool00ekgOomoo`0:Ool00ekgOomoo`0;Ool00ekgOomN
m`0?Ool00`00Oomoo`0iOol003Uoo`03001oogoo01Aoo`03G_Moogoo01aoo`03G_Moogoo00ioo`03
G_Moogoo00eoo`03G_Moogoo015oo`03G_Moogoo019oo`03G_Moogoo00aoo`03G_Moogoo00Yoo`03
G_Moogoo00Yoo`03G_Moogoo00aoo`030^MNmgoo00ioo`03001oogoo03Uoo`00>Goo00<007ooOol0
57oo00=NmgooOol077oo00=NmgooOol03goo00=NmgooOol02goo00=NmgooOol04Woo00=NmgooOol0
4Goo0Ukg3Woo00=NmgooOol02Woo00=NmgooOol02Woo00=NmgooOol037oo00<2iekgOol03Woo00<0
07ooOol0>Goo000iOol00`00Oomoo`0DOol00ekgOomoo`0LOol00ekgOomoo`0?Ool00ekgOomoo`0;
Ool00ekgOomoo`0COol00ekgOomoo`0@Ool00ekgOomNm`0=Ool00ekgOomoo`0:Ool00ekgOomoo`0:
Ool00ekgOomoo`0<Ool2G_L?Ool00`00Oomoo`0iOol003Uoo`03001oogoo01Aoo`03G_Moogoo01ao
o`03G_Moogoo011oo`03G_Moogoo00Yoo`03G_Moogoo01=oo`03G_Moogoo00moo`04G_MoogooG_L>
Ool00ekgOomoo`09Ool00ekgOomoo`09Ool00ekgOomoo`0<Ool010;YG_Mooekg3Woo00<007ooOol0
>Goo000iOol00`00Oomoo`0DOol00ekgOomoo`0LOol00ekgOomoo`0AOol00ekgOomoo`09Ool00ekg
Oomoo`0DOol00ekgOomoo`0=Ool01EkgOomoogooG_L03Woo00=NmgooOol02Goo00=NmgooOol02Goo
00=NmgooOol037oo00D2jEkgOomooekg00eoo`03001oogoo03Uoo`00>Goo00<007ooOol04goo00=N
mgooOol077oo00=NmgooOol04Woo00=NmgooOol027oo00=NmgooOol05Goo00=NmgooOol03Goo00EN
mgooOomooekg00ioo`03G_Moogoo00Uoo`03G_Moogoo00Uoo`03G_Moogoo00]oo`030^]Nmgoo009o
o`03G_Moogoo00]oo`03001oogoo03Uoo`00>Goo00<007ooOol04goo00=NmgooOol077oo00=Nmgoo
Ool04goo00=NmgooOol01goo00=NmgooOol05Goo00=NmgooOol037oo00=NmgooOol00goo00=Nmgoo
Ool02goo00=NmgooOol02Goo00=NmgooOol02Goo00=NmgooOol02goo00<2jekgOol00goo00=Nmgoo
Ool02Woo00<007ooOol0>Goo000iOol00`00Oomoo`0COol00ekgOomoo`0LOol00ekgOomoo`0DOol0
0ekgOomoo`06Ool00ekgOomoo`0FOol00ekgOomoo`0;Ool00ekgOomoo`03Ool00ekgOomoo`0;Ool0
0ekgOomoo`09Ool00ekgOomoo`09Ool00ekgOomoo`0<Ool00ekgOomoo`02Ool00ekgOomoo`0:Ool0
0`00Oomoo`0iOol003Uoo`03001oogoo01=oo`03G_Moogoo01aoo`03G_Moogoo01Aoo`03G_Moogoo
00Ioo`03G_Moogoo01Ioo`03G_Moogoo00Yoo`03G_Moogoo00Aoo`03G_Moogoo00]oo`03G_Moogoo
00Uoo`03G_Moogoo00Uoo`03G_Moogoo00]oo`030^iNmgoo00Aoo`03G_Moogoo00Uoo`03001oogoo
03Uoo`00>Goo00<007ooOol04goo00=NmgooOol077oo00=NmgooOol05Goo00=NmgooOol017oo00=N
mgooOol067oo00=NmgooOol027oo00=NmgooOol01Goo00=NmgooOol02goo00=NmgooOol02Goo00=N
mgooOol02Goo00=NmgooOol02goo00<2kUkgOol01Goo00=NmgooOol027oo00<007ooOol0>Goo000i
Ool00`00Oomoo`0COol00ekgOomoo`0KOol00ekgOomoo`0GOol00ekgOomoo`03Ool00ekgOomoo`0H
Ool00ekgOomoo`08Ool00ekgOomoo`05Ool00ekgOomoo`0;Ool00ekgOomoo`09Ool00ekgOomoo`09
Ool00ekgOomoo`0;Ool00ekgOomoo`05Ool00ekgOomoo`08Ool00`00Oomoo`0iOol003Uoo`03001o
ogoo01=oo`03G_Moogoo01]oo`03G_Moogoo01Qoo`03G_Moogoo009oo`03G_Moogoo01Qoo`03G_Mo
ogoo00Moo`03G_Moogoo00Moo`03G_Moogoo00Yoo`03G_Moogoo00Uoo`03G_Moogoo00Uoo`03G_Mo
ogoo00Yoo`030_1Nmgoo00Moo`03G_Moogoo00Moo`03001oogoo03Uoo`00>Goo00<007ooOol04goo
00=NmgooOol06goo00=NmgooOol067oo00=NmgooOol00Woo00=NmgooOol06Goo00=NmgooOol01Woo
00=NmgooOol01goo00=NmgooOol02Woo00=NmgooOol02Goo00=NmgooOol02Goo00=NmgooOol02Woo
00<2l5kgOol01goo00=NmgooOol01goo00<007ooOol0>Goo000iOol00`00Oomoo`0BOol00ekgOomo
o`0LOol00ekgOomoo`0IOol01EkgOomoogooG_L06goo00=NmgooOol01Goo00=NmgooOol027oo00=N
mgooOol02goo00=NmgooOol027oo00=NmgooOol027oo00=NmgooOol02Woo00<2lWooG_L02Goo00=N
mgooOol01Goo00=Nm`00Ool0>Woo000iOol00`00Oomoo`0BOol00ekgOomoo`0LOol00ekgOomoo`0J
Ool00ekgOomNm`0MOol00ekgOomoo`04Ool00ekgOomoo`08Ool00ekgOomoo`0;Ool00ekgOomoo`08
Ool00ekgOomoo`08Ool00ekgOomoo`0:Ool00`;bG_Moo`09Ool00ekgOomoo`05Ool00ekg001oo`0j
Ool003Uoo`03001oogoo019oo`03G_Moogoo01aoo`03G_Moogoo01Yoo`03G_Mooekg01eoo`03G_Mo
ogoo00=oo`03G_Moogoo00Yoo`03G_Moogoo00Yoo`03G_Moogoo00Qoo`03G_Moogoo00Qoo`03G_Mo
ogoo00]oo`03G_Moogoo00Uoo`03G_Moogoo00=oo`03G_Moo`0003]oo`00>Goo0P004goo00=Nmgoo
Ool06goo00=NmgooOol077oo0Ukg7Goo00=NmgooOol00goo00=NmgooOol02Woo00=NmgooOol02Woo
00=NmgooOol027oo00=NmgooOol027oo00=NmgooOol02Goo00<2mGooG_L02goo00=NmgooOol00goo
00=Nm`000000>goo000iOol00`00Oomoo`0BOol00ekgOomoo`0KOol00ekgOomoo`0MOol00ekgOomo
o`0LOol01EkgOomoogooG_L03Goo00=NmgooOol02Woo00=NmgooOol027oo00=NmgooOol027oo00=N
mgooOol02Goo00<2mGooG_L037oo00=NmgooOol00Woo00=Nmgoo0000>goo000iOol00ekgOomoo`0B
Ool00ekgOomoo`0KOol00ekgOomoo`0LOol2G_LNOol01EkgOomoogooG_L03Goo00=NmgooOol02Woo
00=NmgooOol027oo00=NmgooOol027oo00=NmgooOol02Woo00=NmgooOol02goo00ENmgooOomooekg
009oo`03001oogoo03Uoo`00>Goo00<005kgG_L04Woo00=NmgooOol06goo00=NmgooOol077oo00=N
mgooG_L07Woo00=NmgooG_L03Woo00=NmgooOol02Woo00=NmgooOol027oo00=NmgooOol027oo00=N
mgooOol027oo00<2mgooG_L03Goo00ENmgooOomooekg009oo`03001oogoo03Uoo`00>Goo00@007oo
OomNma5oo`03G_Moogoo01]oo`03G_Moogoo01aoo`04G_MoogooG_LMOol00ekgOomNm`0?Ool00ekg
Oomoo`09Ool00ekgOomoo`08Ool00ekgOomoo`08Ool00ekgOomoo`08Ool00`;gOomNm`0>Ool00ekg
OomNm`03Ool00`00Oomoo`0iOol003Uoo`04001oogooOol2G_L?Ool00ekgOomoo`0KOol00ekgOomo
o`0LOol01EkgOomoogooG_L077oo00=NmgooG_L03goo00=NmgooOol02Goo00=NmgooOol027oo00=N
mgooOol027oo00=NmgooOol01goo00@2egooOomNm`ioo`03G_Mooekg00=oo`03001oogoo03Uoo`00
>Goo00<007ooOol00goo00=NmgooOol02goo00=NmgooOol06goo00=NmgooOol07Goo00ENmgooOomo
oekg01eoo`03G_Moogoo00ioo`03G_Moogoo00Yoo`03G_Moogoo00Moo`03G_Moogoo00Moo`03G_Mo
ogoo00Qoo`030]Mooekg011oo`9Nm`=oo`03001oogoo03Uoo`00>Goo00<007ooOol017oo0Ukg2goo
00=NmgooOol06goo00=NmgooOol077oo00=NmgooOol00goo00=NmgooOol06Woo00=NmgooOol03Woo
00=NmgooOol02Woo00=NmgooOol01goo00=NmgooOol01goo00=NmgooOol02Woo00=NmgooOol03Woo
00=NmgooOol00Woo00<007ooOol06goo2U`017oo00@007ooOol000aoo`00>Goo00<007ooOol01Woo
00=NmgooOol027oo00=NmgooOol06goo00=NmgooOol077oo00=NmgooOol017oo00=NmgooOol067oo
00=NmgooG_L047oo00=NmgooOol02Goo00=NmgooOol01goo00=NmgooOol01goo00=NmgooOol01goo
00@2MgooOomNma1oo`9Nm`=oo`03001oogoo01]oo`YL00Aoo`04001oogoo000<Ool003Uoo`03001o
ogoo00Moo`9Nm`Qoo`03G_Moogoo01]oo`03G_Moogoo01aoo`03G_Moogoo00Aoo`03G_Moogoo01Qo
o`03G_Mooekg011oo`03G_Moogoo00Uoo`03G_Moogoo00Moo`03G_Moogoo00Moo`03G_Moogoo00Mo
o`040WMoogooG_L?Ool00ekgOomNm`03Ool00`00Oomoo`0KOol:G004Ool01000Oomoo`0037oo000i
Ool00`00Oomoo`09Ool00ekgOomoo`05Ool00ekgOomoo`0KOol00ekgOomoo`0LOol00ekgOomoo`05
Ool00ekgOomoo`0GOol00ekgOomNm`0@Ool00ekgOomoo`09Ool00ekgOomoo`07Ool00ekgOomoo`07
Ool00ekgOomoo`0:Ool00ekgOomoo`0=Ool00ekgOomNm`03Ool00`00Oomoo`0KOol:G084Ool01000
Oomoo`0037oo000iOol00`00Oomoo`0:Ool2G_L5Ool00ekgOomoo`0KOol00ekgOomoo`0LOol00ekg
Oomoo`06Ool00ekgOomoo`0EOol01EkgOomoogooG_L03goo00=NmgooOol02Goo00=NmgooOol01goo
00=NmgooOol01goo00=NmgooOol01Woo00@2=gooOomNma1oo`04G_MoogooG_L2Ool00`00Oomoo`0K
Ool:G085Ool2000=Ool003Uoo`03001oogoo00aoo`03G_Moogoo009oo`03G_Moogoo01]oo`03G_Mo
ogoo01]oo`03G_Moogoo00Moo`03G_Moogoo01Eoo`05G_MoogooOomNm`0@Ool00ekgOomoo`08Ool0
0ekgOomoo`07Ool00ekgOomoo`07Ool00ekgOomoo`06Ool0108gOomooekg3goo00ENmgooOomooekg
009oo`03001oogoo01]oo`YL11Aoo`00>Goo00<007ooOol03Goo0Ukg0Woo00=NmgooOol06Woo00=N
mgooOol077oo00=NmgooOol027oo00=NmgooOol057oo00=NmgooOol00Woo00=NmgooOol03Goo00=N
mgooOol027oo00=NmgooOol01goo00=NmgooOol01goo00=NmgooOol01Woo00@1mgooOomNm`moo`03
G_Moogoo009oo`03G_Moo`0001eoo`YL11Aoo`00>Goo00<007ooOol03goo0Ukg7Goo00=NmgooOol0
77oo00=NmgooOol02Goo00=NmgooOol04Woo00=NmgooOol00goo00=NmgooOol03Goo00=NmgooOol0
27oo00=NmgooOol01goo00=NmgooOol01goo00=NmgooOol01Woo00@1mgooOomNm`ioo`03G_Moogoo
00=oo`03G_Moo`0001eoo`YL11Aoo`00>Goo00<007ooOol047oo0Ukg77oo00=NmgooOol077oo00=N
mgooOol02Woo00=NmgooOol04Goo00=NmgooOol00goo00=NmgooOol03Goo00=NmgooOol027oo00=N
mgooOol01goo00=NmgooOol01goo00=NmgooOol027oo00=NmgooOol03Goo00=NmgooOol00goo00=N
mgoo00007Goo2U`757oo000iOol00`00Oomoo`0@Ool00ekgOomNm`0KOol00ekgOomoo`0KOol00ekg
Oomoo`0;Ool00ekgOomoo`0@Ool00ekgOomoo`05Ool00ekgOomoo`0<Ool00ekgOomoo`09Ool00ekg
Oomoo`06Ool00ekgOomoo`06Ool00ekgOomoo`06Ool0106GOomooekg3Woo00=NmgooOol01Goo00=N
m`00Ool077oo2U`757oo000iOol00`00Oomoo`0@Ool00ekgOomoo`02G_LIOol00ekgOomoo`0KOol0
0ekgOomoo`0<Ool00ekgOomoo`0?Ool00ekgOomoo`05Ool00ekgOomoo`0=Ool00ekgOomoo`08Ool0
0ekgOomoo`06Ool00ekgOomoo`06Ool00ekgOomoo`06Ool0106GOomooekg3Woo00=NmgooOol01Goo
00=Nm`00Ool077oo2U`757oo000iOol2000AOol00ekgOomoo`02Ool00ekgOomoo`0FOol00ekgOomo
o`0KOol00ekgOomoo`0=Ool00ekgOomoo`0>Ool00ekgOomoo`06Ool00ekgOomoo`0<Ool00ekgOomo
o`08Ool00ekgOomoo`06Ool00ekgOomoo`06Ool00ekgOomoo`09Ool00ekgOomoo`0<Ool00ekgOomo
o`05Ool2000MOol:G0TDOol003Uoo`03001oogoo011oo`03G_Moogoo00=oo`9NmaEoo`03G_Moogoo
01aoo`03G_Moogoo00eoo`03G_Moogoo00eoo`03G_Moogoo00Moo`03G_Moogoo00aoo`03G_Moogoo
00Qoo`03G_Moogoo00Ioo`03G_Moogoo00Ioo`03G_Moogoo00Eoo`040EMoogooG_L>Ool00ekgOomo
o`07Ool00`00Oomoo`0KOol:G0TDOol003Uoo`03001oogoo011oo`03G_Moogoo00Eoo`03G_Moogoo
019oo`03G_Moogoo01aoo`03G_Moogoo00ioo`03G_Moogoo00aoo`03G_Moogoo00Moo`03G_Moogoo
00aoo`03G_Moogoo00Qoo`03G_Moogoo00Ioo`03G_Moogoo00Ioo`03G_Moogoo00Eoo`040EMoogoo
G_L>Ool00ekgOomoo`07Ool00`00Oomoo`0KOol:G0/DOol003Uoo`03001oogoo011oo`03G_Moogoo
00Ioo`9Nma9oo`03G_Moogoo01]oo`03G_Moogoo011oo`03G_Moogoo00]oo`03G_Moogoo00Qoo`03
G_Moogoo00aoo`03G_Moogoo00Moo`03G_Moogoo00Ioo`03G_Moogoo00Ioo`03G_Moogoo00Aoo`05
0AMoogooOomNm`0=Ool00ekgOomoo`08Ool00`00Oomoo`0KOol:G0/DOol003Uoo`03001oogoo011o
o`03G_Moogoo00Qoo`03G_Moogoo00moo`03G_Moogoo01]oo`03G_Moogoo011oo`03G_Moogoo00Yo
o`03G_Moogoo00Uoo`03G_Moogoo00aoo`03G_Moogoo00Moo`03G_Moogoo00Ioo`03G_Moogoo00Io
o`03G_Moogoo00Aoo`050AMoogooOomNm`0=Ool00ekgOomoo`08Ool00`00Oomoo`0KOol:G0/DOol0
03Uoo`03001oogoo011oo`03G_Moogoo00Uoo`9Nm`moo`03G_Moogoo01]oo`03G_Moogoo015oo`03
G_Moogoo00Uoo`03G_Moogoo00Yoo`03G_Moogoo00]oo`03G_Moogoo00Moo`03G_Moogoo00Ioo`03
G_Moogoo00Ioo`03G_Moogoo00Moo`03G_Moogoo00aoo`03G_Moogoo00Qoo`03001oogoo01]oo`YL
3QAoo`00>Goo00<007ooOol047oo00=NmgooOol02goo00=NmgooOol037oo00=NmgooOol06goo00=N
mgooOol04Woo00=NmgooOol027oo00=NmgooOol02Woo00=NmgooOol02goo00=NmgooOol01goo00=N
mgooOol01Woo00=NmgooOol01Woo00=NmgooOol00goo00D0]gooOomooekg00eoo`03G_Moogoo00Uo
o`03001oogoo01]oo`YL3QAoo`00>Goo00<007ooOol047oo00=NmgooOol037oo0Ukg37oo00=Nmgoo
Ool06goo00=NmgooOol04Woo00=NmgooOol01goo00=NmgooOol02goo00=NmgooOol02goo00=Nmgoo
Ool01goo00=NmgooOol01Woo00=NmgooOol01Goo00=NmgooOol017oo00D0]gooOomooekg00eoo`03
G_Moogoo00Uoo`03001oogoo01]oo`YL3QAoo`00>Goo00<007ooOol03goo00=NmgooOol03goo00=N
mgooOol027oo00=NmgooOol06goo00=NmgooOol057oo00<2hWooOol01Woo00=NmgooOol037oo00=N
mgooOol02goo00=NmgooOol01goo00=NmgooOol01Goo00=NmgooOol01Goo00=NmgooOol027oo00=N
mgooOol02Woo00=NmgooOol02Woo00<007ooOol06goo2U`@57oo000iOol00`00Oomoo`0?Ool00ekg
Oomoo`0@Ool2G_L8Ool00ekgOomoo`0KOol00ekgOomoo`0DOol00`;R0^Aoo`06Ool00ekgOomoo`0<
Ool00ekgOomoo`0;Ool00ekgOomoo`07Ool00ekgOomoo`05Ool00ekgOomoo`05Ool00ekgOomoo`03
Ool00`1gOomoo`02Ool00ekgOomoo`0:Ool00ekgOomoo`0:Ool00`00Oomoo`0KOol:G10DOol003Uo
o`03001oogoo00moo`03G_Moogoo019oo`03G_Moogoo00Eoo`03G_Moogoo01]oo`03G_Moogoo01Eo
o`030^ANmgoo00Eoo`03G_Moogoo00eoo`03G_Moogoo00Yoo`03G_Moogoo00Moo`03G_Moogoo00Eo
o`03G_Moogoo00Eoo`03G_Moogoo00=oo`0507MoogooOomNm`0=Ool00ekgOomoo`0:Ool00`00Oomo
o`0KOol:G1<DOol003Uoo`03001oogoo00moo`03G_Moogoo01=oo`9Nm`Eoo`03G_Moogoo01]oo`03
G_Moogoo01Ioo`030^Moogoo00=oo`03G_Moogoo00ioo`03G_Moogoo00Yoo`03G_Moogoo00Moo`03
G_Moogoo00Eoo`03G_Moogoo00Eoo`03G_Moogoo00Moo`03G_Moogoo00Yoo`03G_Moogoo00]oo`03
001oogoo01]oo`YL4aAoo`00>Goo00<007ooOol03goo00=NmgooOol05Goo00=NmgooOol00Woo00=N
mgooOol06goo00=NmgooOol05Woo00<2i`;YOol00goo00=NmgooOol03goo00=NmgooOol02Woo00=N
mgooOol01Woo00=NmgooOol01Goo00=NmgooOol01Goo00=NmgooOol00Woo00<0=gooOol00Woo00=N
mgooOol02Woo00=NmgooOol02goo00<007ooOol06goo2U`C57oo000iOol00`00Oomoo`0?Ool00ekg
Oomoo`0FOol2G_L2Ool00ekgOomoo`0KOol00ekgOomoo`0GOol00`;Y0^]oo`02Ool00ekgOomoo`0?
Ool00ekgOomoo`0:Ool00ekgOomoo`06Ool00ekgOomoo`05Ool00ekgOomoo`05Ool00ekgOomoo`02
Ool00`0gOomoo`02Ool00ekgOomoo`09Ool00ekgOomoo`0<Ool00`00Oomoo`0KOol:G1DDOol003Uo
o`03001oogoo00moo`03G_Moogoo01Qoo`03G_Mooekg01eoo`03G_Moogoo01Qoo`050^/2kWooOomN
m`0AOol00ekgOomoo`0:Ool00ekgOomoo`06Ool00ekgOomoo`05Ool00ekgOomoo`05Ool01EkgOomo
ogoo11L017oo00=NmgooOol02Woo00=NmgooOol037oo00<007ooOol06goo2U`E57oo000bOol40003
Ool00`00Oomoo`0?Ool00ekgOomoo`0IOol2G_LLOol00ekgOomoo`0JOol00`;^0_1Nm`0COol00ekg
Oomoo`09Ool00ekgOomoo`06Ool00ekgOomoo`05Ool00ekgOomoo`05Ool01EkgOomoogoo11L017oo
00=NmgooOol02Woo00=NmgooOol037oo00<007ooOol06goo2U`E57oo000bOol00`00Oomoo`04Ool0
0`00Oomoo`0?Ool00ekgOomoo`0IOol00ekgOomNm`0KOol00ekgOomoo`0KOol00`;`G_Moo`0BOol0
0ekgOomoo`0:Ool00ekgOomoo`05Ool00ekgOomoo`05Ool00ekgOomoo`05Ool00ekgOomoo`06Ool0
0ekgOomoo`09Ool00ekgOomoo`0=Ool00`00Oomoo`0KOol:G1LDOol003=oo`03001oogoo00=oo`<0
00moo`03G_Moogoo01Uoo`03G_Moogoo009NmaUoo`03G_Moogoo01]oo`03G_L2lWoo01=oo`03G_Mo
ogoo00Uoo`03G_Moogoo00Ioo`03G_Moogoo00Aoo`03G_Moogoo00Aoo`05G_MoogooOol<5`05Ool0
0ekgOomoo`09Ool00ekgOomoo`0;Ool3000MOol:G1LDOol002aoo`@000Aoo`03001oogoo009oo`03
001oogoo00moo`03G_Moogoo01Uoo`03G_Moogoo009oo`03G_Moogoo01Ioo`03G_Moogoo01aoo`03
0_9oo`;e019oo`03G_Moogoo00Uoo`03G_Moogoo00Ioo`04G_MoogooOol7G_L3Ool01EkgOomoogoo
31L017oo00=NmgooOol02Goo00=NmgooOol03Woo00<007ooOol06goo2U@G57oo000bOol01000Oomo
o`000goo00<007ooOol03goo00=NmgooOol06Goo00=NmgooOol00goo0Ukg5Woo00=NmgooOol06goo
00ENmgooG_L2m@;g015oo`03G_Moogoo00Uoo`03G_Moogoo00Ioo`04G_MooekgG_L3Ool015kgOomo
ogoo0Ukg00=ooekgOol01goo00=NmgooOol02Goo00=NmgooOol03Woo00<007ooOol06goo2U@G57oo
000cOol20004Ool00`00Oomoo`0?Ool00ekgOomoo`0IOol00ekgOomoo`05Ool00ekgOomoo`0COol0
0ekgOomoo`0KOol01UkgOomooekg0_L2ea5oo`03G_Moogoo00Qoo`03G_Moogoo00Ioo`9Nm`Eoo`03
G_Moogoo00=oo`9Nm`9oo`0351Moogoo00=oo`03G_Moogoo00Uoo`03G_Moogoo00ioo`03001oogoo
01]oo`YD5aAoo`00>Goo00<007ooOol03goo00=NmgooOol06Goo00=NmgooOol01Woo0Ukg4goo00=N
mgooOol06goo00MNmgooOomNmgoo0]L2M`0@Ool00ekgOomoo`09Ool00ekgOomoo`03Ool3G_L6Ool0
0ekgOomoo`04Ool3G_L00a@GOomoo`03Ool00ekgOomoo`08Ool00ekgOomoo`0?Ool00`00Oomoo`0K
Ool:C1LDOol003Uoo`03001oogoo00ioo`03G_Moogoo01Yoo`03G_Moogoo00Qoo`03G_Moogoo011o
o`03G_Moogoo01]oo`08G_MoogooOomNmgoo0WL2=a1oo`03G_Moogoo00Qoo`03G_Moogoo009oo`04
G_MoogooG_L6Ool00ekgOomoo`04Ool015kgOolP5ekg17oo00=NmgooOol02Goo00=NmgooOol03goo
00<007ooOol06goo2T`G57oo000iOol00`00Oomoo`0>Ool00ekgOomoo`0JOol00ekgOomoo`09Ool2
G_L?Ool00ekgOomoo`0KOol00ekgOomoo`03Ool00ekgOol2=`0@Ool00ekgOomoo`08Ool01EkgOomo
ogooG_L00goo00=NmgooOol017oo00=NmgooOol017oo00ENmgoo81Mooekg00=oo`03G_Moogoo00Qo
o`03G_Moogoo011oo`03001oogoo01]oo`Y<5aAoo`00>Goo00<007ooOol03Woo00=NmgooOol06Woo
00=NmgooOol02goo00=NmgooOol037oo00=NmgooOol06goo00=NmgooOol00goo00ANmgooOol1m`mo
o`03G_Moogoo00Qoo`04G_MoogooG_L4Ool00ekgOomoo`04Ool00ekgOomoo`04Ool00ekgOomoo`02
Ool015kgOomooekg2Woo00=NmgooOol047oo00<007ooOol06goo2T0G57oo000iOol00`00Oomoo`0>
Ool00ekgOomoo`0JOol00ekgOomoo`0<Ool2G_L<Ool00ekgOomoo`0KOol00ekgOomoo`04Ool015kg
Ool1m`6G3goo00=NmgooOol027oo0Ukg1Goo00=NmgooOol017oo00=NmgooOol017oo00=NmbPGOol0
0goo00=NmgooG_L02Woo00=NmgooOol03goo00=Nm`00Ool077oo2T0G57oo000iOol00`00Oomoo`0>
Ool00ekgOomoo`0JOol00ekgOomoo`0>Ool00ekgOomoo`09Ool00ekgOomoo`0KOol00ekgOomoo`05
Ool015kgOol1U`5G3Woo00=NmgooOol027oo00=NmgooOol017oo00=NmgooOol017oo00=NmgooOol0
17oo00=NmbPGOol00goo00=NmgooG_L02Goo00=NmgooOol047oo00=Nm`00Ool077oo2SPG57oo000i
Ool00`00Oomoo`0>Ool00ekgOomoo`0IOol00ekgOomoo`0@Ool2G_L9Ool00ekgOomoo`0KOol00ekg
Oomoo`05Ool01EkgOomoo`5G0AL03Woo00=NmgooOol01goo00=NmgooOol01Goo00=NmgooOol00goo
00=NmgooOol00goo00=NmgooOol01Goo00=NmgooOol027oo00=NmgooOol03goo00=Nmgoo00007Goo
2SPG57oo000iOol00`00Oomoo`0>Ool00ekgOomoo`0IOol00ekgOomoo`0BOol00ekgOomoo`06Ool0
0ekgOomoo`0JOol00ekgOomoo`07Ool01EkgOomoo`4G0;L03Goo00=NmgooOol01Woo0Ukg1goo00=N
mgooOol00goo00=NmgooOol00goo00=Nmc0GOol01Goo0Ukg27oo00=NmgooOol03goo00ANmgooOol0
01eoo`Xh5aAoo`00>Goo00<007ooOol03Woo00=NmgooOol06Goo00=NmgooOol04goo0Ukg1Woo00=N
mgooOol06Woo00=NmgooOol027oo00ANmgooOol0]`eoo`03G_Moogoo00Eoo`04G_MoogooG_L6Ool0
0ekgOomoo`03Ool00ekgOomoo`03Ool00ekg<1Moo`05Ool2G_L8Ool00ekgOomoo`0>Ool01EkgOomo
ogoo00007Goo2R`G57oo000iOol00`00Oomoo`0>Ool00ekgOomoo`0IOol00ekgOomoo`0EOol00ekg
Oomoo`03Ool00ekgOomoo`0JOol00ekgOomoo`09Ool015kgOomoo`1g3Goo00=NmgooOol017oo00AN
mgooOomNm`Ioo`03G_Moogoo00=oo`03G_Moogoo00=oo`03G_Moogoo00Eoo`03G_Mooekg00Moo`03
G_Moogoo00ioo`05G_MoogooOol0000MOol:;1LDOol003Uoo`03001oogoo00ioo`03G_Moogoo01Uo
o`03G_Moogoo01Ioo`9Nm`9oo`03G_Moogoo01]oo`03G_Moogoo00Uoo`05G_Moogoo07L0=`0<Ool0
0ekgOomoo`03Ool01EkgOomoogooG_L01Woo00=NmgooOol00goo00=NmgooOol00goo00<l5gooOol0
17oo00ANmgooOomNm`Ioo`03G_Moogoo00ioo`03G_Moogoo009oo`03001oogoo01]oo`X/5aAoo`00
>Goo00<007ooOol03Woo00=NmgooOol06Goo00=NmgooOol067oo00=NmgooG_L07Goo00=NmgooOol0
2Woo00ENmgooOol0=`@G00aoo`03G_Moogoo009oo`05G_MoogooOomNm`06Ool00ekgOomoo`03Ool0
0ekgOomoo`03Ool00c`GOomoo`04Ool01EkgOomoogooG_L01Goo00=NmgooOol03Goo00=NmgooOol0
0goo00<007ooOol06goo2R@G57oo000iOol00`00Oomoo`0>Ool00ekgOomoo`0IOol00ekgOomoo`0I
Ool2G_LMOol00ekgOomoo`0;Ool015kgOomoo`@G37oo00ENmgooOomooekg00Aoo`03G_Moogoo00Ao
o`03G_Moogoo00=oo`03G_Moogoo009oo`03A1MNmgoo00Eoo`05G_MoogooOomNm`04Ool00ekgOomo
o`0>Ool00ekgOomoo`03Ool00`00Oomoo`0KOol:91LDOol003Uoo`03001oogoo00ioo`03G_Moogoo
01Uoo`03G_Moogoo01Yoo`9Nma]oo`03G_Moogoo00aoo`05G_MoogooOol<5`0;Ool01EkgOomoogoo
G_L01Goo00=NmgooOol00goo00=NmgooOol00goo00=NmgooOol00Woo00=45ekgOol01Goo00=Nmgoo
Ool00Woo00ENmgooOomooekg00moo`03G_Moogoo00Aoo`03001oogoo01]oo`XL5aAoo`00>Goo0P00
3goo00=NmgooOol06Goo00=NmgooOol06Woo00ANmgooG_MNmaUoo`03G_Moogoo00eoo`05G_Moogoo
31LD5`0;Ool00ekgOomNm`06Ool00ekgOomoo`03Ool00ekgOomoo`03Ool00ekgOomoo`03Ool00ekg
Oomoo`03Ool00ekgOomoo`03Ool015kgOomooekg3goo00=NmgooOol017oo0P007Goo2Q`G57oo000i
Ool00`00Oomoo`0>Ool00ekgOomoo`0IOol00ekgOomoo`0JOol01EkgOomoogooG_L067oo00=Nmgoo
Ool03Woo00ENmgooOolD5b0G00Yoo`03G_Mooekg00Ioo`03G_Moogoo00Aoo`03G_Moogoo009oo`06
G_MoogooC1Mooekg1Woo00=NmgooOol017oo00=NmgooG_L03goo00=NmgooOol01Goo00<007ooOol0
6goo2Q`G57oo000iOol00`00Oomoo`0=Ool00ekgOomoo`0JOol00ekgOomoo`0JOol00ekgOomoo`02
Ool2G_LFOol00ekgOomoo`0>Ool01EkgOomoogoo81L02goo00=NmgooOol01Goo00=NmgooOol017oo
00=NmgooOol00Woo00INmgooOom<5gooG_L6Ool00ekgOomoo`04Ool00ekgOomNm`0>Ool00ekgOomo
o`06Ool00`00Oomoo`0KOol:41LDOol003Uoo`03001oogoo00eoo`03G_Moogoo01Yoo`03G_Moogoo
01Yoo`03G_Moogoo00Aoo`03G_Moogoo01=oo`03G_Moogoo00moo`05G_MoogooOolX5`0:Ool00ekg
Oomoo`06Ool00ekgOomoo`03Ool00ekgOomoo`02Ool00ekgOomH5`02Ool00ekgOomoo`04Ool00ekg
Oomoo`05Ool00ekgOomoo`0<Ool00ekgOomoo`07Ool00`00Oomoo`0KOol:41LDOol003Uoo`03001o
ogoo00eoo`03G_Moogoo01Yoo`03G_Moogoo01Yoo`03G_Moogoo00Eoo`9Nma=oo`03G_Moogoo011o
o`06G_Moogoo:1Mooc0G1goo0Ukg27oo00=NmgooOol00goo00=NmgooOol00Woo00=NmgooF1L00Woo
00=NmgooOol00goo00=NmgooOol01Woo00=NmgooOol02goo00=NmgooOol027oo00<007ooOol06goo
2Q0G57oo000iOol00`00Oomoo`0=Ool00ekgOomoo`0JOol00ekgOomoo`0JOol00ekgOomoo`07Ool0
0ekgOomoo`0@Ool00ekgOomoo`0AOol01EkgOomoogoo<1L01goo00=NmgooG_L01goo00=NmgooOol0
0goo00=NmgooOol00Woo00=NmgooOol00Woo00=NmgooOol00goo00=NmgooOol01Goo00=NmgooG_L0
37oo00=NmgooOol027oo00<007ooOol06goo2PPG57oo000iOol00`00Oomoo`0=Ool00ekgOomoo`0J
Ool00ekgOomoo`0JOol00ekgOomoo`08Ool2G_L?Ool00ekgOomoo`0BOol00ekgOomoo`02Ool00c`G
Oomoo`04Ool00ekgOomNm`07Ool00ekgOomoo`03Ool00ekgOomoo`02Ool00ekgG1Moo`02Ool00ekg
Oomoo`03Ool00ekgOomoo`05Ool00ekgOomNm`0;Ool00ekgOomoo`09Ool00`00Oomoo`0KOol:21LD
Ool003Uoo`03001oogoo00eoo`03G_Moogoo01Yoo`03G_Moogoo01Uoo`03G_Moogoo00]oo`03G_Mo
ogoo00aoo`03G_Moogoo01=oo`06G_MoogooOoll5d@G17oo00ENmgooOomooekg00Ioo`03G_Moogoo
00=oo`03G_Moogoo009oo`03G_ML5goo009oo`03G_Moogoo00=oo`03G_Moogoo00Eoo`04G_Moogoo
G_L9Ool00ekgOomoo`0:Ool00`00Oomoo`0KOol:01LDOol003Uoo`03001oogoo00eoo`03G_Moogoo
01Yoo`03G_Moogoo01Uoo`03G_Moogoo00aoo`9Nm`aoo`03G_Moogoo01Aoo`05G_MoogooOom45`04
Ool01EkgOomoogooG_L01goo00=NmgooOol00Woo00=NmgooOol00Woo00=NmgooOol00Woo00=Nmgoo
Ool00goo00=NmgooOol017oo00ENmgooOomooekg00Uoo`03G_Moogoo00Yoo`03001oogoo01]oo`X0
5aAoo`00>Goo00<007ooOol03Goo00=NmgooOol06Woo00=NmgooOol06Goo00=NmgooOol03Woo00=N
mgooOol02Goo00=NmgooOol057oo00=NmgooOol00Woo00E<5gooOomooekg00=oo`03G_Moogoo00Eo
o`03G_Moogoo009oo`03G_Moogoo009oo`03G1Eoogoo009oo`03G_Moogoo009oo`03G_Moogoo00Eo
o`05G_MoogooOomNm`08Ool00ekgOomoo`0;Ool00`00Oomoo`0KOol:01LDOol003Uoo`03001oogoo
00eoo`03G_Moogoo01Uoo`03G_Moogoo01Yoo`03G_Moogoo00moo`9Nm`Uoo`03G_Moogoo01Eoo`08
G_MoogooOom<5ePGOomNm`Eoo`03G_Moogoo00Aoo`03G_Moogoo009oo`03G_Moogoo009oo`03G1Eo
ogoo009oo`03G_Moogoo009oo`03G_Moogoo00Aoo`03G_Moogoo00=oo`03G_Moogoo00Aoo`03G_Mo
ogoo00aoo`03001oogoo01]oo`X0EaAoo`00>Goo00<007ooOol03Goo00=NmgooOol06Goo00=Nmgoo
Ool06Woo00=NmgooOol04Goo00=NmgooOol01Woo00=NmgooOol05Woo00MNmgooOomooePGG1MNm`05
Ool00ekgOomoo`04Ool00ekgOomoo`03Ool01EkgOomooe`BG_L00goo00=NmgooOol00goo00=Nmgoo
Ool017oo00=NmgooOol00goo00=NmgooOol017oo00=NmgooOol037oo00<007ooOol06goo2P1G57oo
000iOol00`00Oomoo`0=Ool00ekgOomoo`0IOol00ekgOomoo`0JOol00ekgOomoo`0BOol2G_L6Ool0
0ekgOomoo`0FOol00ekgOomoo`02Ool00e`GG_Moo`05Ool00ekgOomoo`04Ool00ekgOomoo`02Ool0
1EkgOomooe`BG_L00goo00=NmgooOol00goo00=NmgooOol017oo00=NmgooOol00goo00=NmgooOol0
0goo00=NmgooOol03Goo00<007ooOol06goo2P1G57oo000iOol00`00Oomoo`0=Ool00ekgOomoo`0I
Ool00ekgOomoo`0JOol00ekgOomoo`0DOol00ekgOomoo`03Ool00ekgOomoo`0GOol01ekgOomoogoo
G_Mooe`E00Eoo`03G_Moogoo00Aoo`03G_Moogoo009oo`05G_ML47ooOomNm`03Ool00ekgOomoo`02
Ool00ekgOomoo`04Ool00ekgOomoo`04Ool00ekgOomoo`02Ool00ekgOomoo`0>Ool00`00Oomoo`0K
Ool:09LDOol003Uoo`03001oogoo00eoo`03G_Moogoo01Uoo`03G_Moogoo01Yoo`03G_Moogoo01Eo
o`9Nm`9oo`03G_Moogoo01Uoo`07G_MoogooG_Mooe`EG18017oo00=NmgooOol017oo00=NmgooOol0
0Woo00ENme`@Oomooekg00=oo`03G_Moogoo009oo`03G_Moogoo00Aoo`03G_Moogoo00Eoo`04G_Mo
ogooG_LAOol00`00Oomoo`0KOol:09LDOol003Uoo`03001oogoo00eoo`03G_Moogoo01Uoo`03G_Mo
ogoo01Yoo`03G_Moogoo01Moo`03G_Mooekg01]oo`04G_MoogooG_L2Ool00e`BG11oo`03Ool00ekg
Oomoo`03Ool00ekgOomoo`02Ool01EkgOomoogooG_L00goo00=NmgooOol00Woo00=NmgooOol00goo
00=NmgooOol01Woo00ANmgooOomNma5oo`03001oogoo01]oo`X0maAoo`00>Goo00<007ooOol03Goo
00=NmgooOol06Goo00=NmgooOol06Woo00=NmgooOol067oo0Ukg77oo00=NmgooG_L00goo00=L45`>
Ool00Woo00=NmgooOol017oo00ENmgooOomooe`>00=oo`05G_MoogooOomNm`04Ool00ekgOomoo`03
Ool00ekgOomoo`06Ool00ekgOomNm`0BOol00`00Oomoo`0KOol:0?LDOol003Uoo`03001oogoo00eo
o`03G_Moogoo01Uoo`03G_Moogoo01Yoo`03G_Moogoo01Uoo`9Nmaaoo`03G_Moogoo00=oo`06G0io
oe`;G0Ul05kg1Goo00ENmgooOomooe`>00=oo`05G_MoogooOomNm`03Ool00ekgOomoo`04Ool00ekg
Oomoo`06Ool2G_LCOol00`00Oomoo`0KOol:0?LDOol003Uoo`8000ioo`03G_Moogoo01Uoo`03G_Mo
ogoo01Yoo`03G_Moogoo01Uoo`04G_MooekgG_LJOol2G_L6Ool015`;G0Ul05kg1Goo00ENmgooOomL
2ekg00=oo`05G_MoogooOomNm`03Ool00ekgOomoo`03Ool00ekgOomoo`08Ool00ekgOomoo`0@Ool2
000MOol:0CLDOol003Uoo`03001oogoo00eoo`03G_Moogoo01Uoo`03G_Moogoo01Yoo`03G_Moogoo
01Uoo`05G_MoogooOomNm`0IOol2G_L7Ool00e`7OomNm`05Ool01EkgOomL2E`;G_L00goo00ENmgoo
Oomooekg00=oo`03G_Moogoo00=oo`03G_Moogoo00Moo`9Nma=oo`03001oogoo01]oo`X1=aAoo`00
>Goo00<007ooOol03Goo00=NmgooOol06Goo00=NmgooOol06Goo00=NmgooOol06Woo00=NmgooOol0
0Woo0Ukg5goo00=NmgooG_L02Goo00=NmgooOol00Woo00=NmgooG0T00Woo00ANmgooOomNm`9oo`03
G_Moogoo009oo`03G_Moogoo009oo`03G_Moogoo00Moo`03G_Mooekg01=oo`03001oogoo01]oo`X1
=aAoo`00>Goo00<007ooOol03Goo00=NmgooOol06Goo00=NmgooOol06Goo00=NmgooOol06Woo00=N
mgooOol017oo00=NmgooOol057oo00ANmgooOomNm`Qoo`03G_Moogoo00=oo`05G0MoogooOomNm`02
Ool015kgOomooekg17oo00=NmgooOol00Woo00=NmgooOol01Woo00ANmgooOomNma=oo`03001oogoo
01]oo`X1MaAoo`00>Goo00<007ooOol03Goo00=NmgooOol06Goo00=NmgooOol06Goo00=NmgooOol0
6Woo00=NmgooOol01Goo0Ukg57oo00ANmgooOomNm`Uoo`06G_MoogooOoml05`70goo00ANmgooOomN
m`9oo`05G_MoogooOomNm`05Ool00ekgOomoo`06Ool015kgOomooekg4goo00<007ooOol06goo2P5g
57oo000iOol00`00Oomoo`0=Ool00ekgOomoo`0IOol00ekgOomoo`0IOol00ekgOomoo`0JOol00ekg
Oomoo`07Ool00ekgOomoo`0@Ool00ekgOomoo`02Ool00ekgOomoo`06Ool01UkgOomoogooO01L10=o
o`04G_MoogooG_L2Ool01EkgOomoogooG_L017oo00=NmgooOol01Woo00ENmgooOomooekg01=oo`03
001oogoo01]oo`X1eaAoo`00>Goo00<007ooOol03Goo00=NmgooOol06Goo00=NmgooOol06Goo00=N
mgooOol06Woo00=NmgooOol027oo0Ukg47oo00=NmgooOol00goo00=NmgooOol01Goo00=NmgooOol0
0Woo00ENmgooOomooekg009oo`04G_MoogooG_L3Ool00ekgOomoo`02Ool00ekgOomoo`05Ool00ekg
Oomoo`03Ool00ekgOomoo`0>Ool2G_L00`00Oomoo`0KOol:0MLDOol003Uoo`03001oogoo00eoo`03
G_Moogoo01Uoo`03G_Moogoo01Uoo`03G_Moogoo01Yoo`03G_Moogoo00Yoo`03G_Moogoo00eoo`03
G_Moogoo00=oo`03G_Moogoo00Ioo`03G_Moogoo009oo`04G_MoogooG_L2Ool015kgOomooekg0goo
00ENmgooOomooekg00Qoo`03G_Moogoo00=oo`03G_Moogoo00eoo`04G_Moogoo000MOol:0MLDOol0
03Uoo`03001oogoo00eoo`03G_Moogoo01Uoo`03G_Moogoo01Uoo`03G_Moogoo01Yoo`03G_Moogoo
00]oo`9Nm`eoo`03G_Moogoo00Aoo`03G_Moogoo00Eoo`03G_Moogoo009oo`04G_MoogooG_L2Ool0
15kgOomooekg0Woo00=NmgooOol00Woo00=NmgooOol01Goo00=NmgooOol017oo00=NmgooOol02goo
0Ukg0goo00<007ooOol06goo2P8G57oo000iOol00`00Oomoo`0=Ool00ekgOomoo`0IOol00ekgOomo
o`0IOol00ekgOomoo`0IOol00ekgOomoo`0>Ool00ekgOomoo`0:Ool00ekgOomoo`05Ool00ekgOomo
o`05Ool01EkgOomoogooG_L00Woo00ANmgooOomNm`9oo`04G_MoogooG_L4Ool00ekgOomoo`04Ool0
0ekgOomoo`05Ool00ekgOomoo`0:Ool00ekgOomoo`03Ool00`00Oomoo`0KOol:0QLDOol003Uoo`03
001oogoo00eoo`03G_Moogoo01Uoo`03G_Moogoo01Uoo`03G_Moogoo01Uoo`03G_Moogoo00moo`9N
m`Yoo`03G_Moogoo00Ioo`03G_Moogoo00Aoo`05G_MoogooOomNm`02Ool015kgOomooekg0Woo00AN
mgooOomNm`=oo`03G_Moogoo00Eoo`03G_Moogoo00Eoo`03G_Moogoo00Qoo`9Nm`Ioo`03001oogoo
01]oo`X25aAoo`00>Goo00<007ooOol03Goo00=NmgooOol06Goo00=NmgooOol06Goo00=NmgooOol0
6Goo00=NmgooOol04Goo00=NmgooOol01goo00=NmgooOol01Woo00=NmgooOol017oo00=NmgooOol0
0Woo00=NmgooG_L00Woo00ANmgooOomNm`9oo`05G_MoogooOomNm`06Ool00ekgOomoo`06Ool00ekg
Oomoo`07Ool00ekgOomoo`06Ool00`00Oomoo`0KOol:0WLDOol003Uoo`03001oogoo00eoo`03G_Mo
ogoo01Uoo`03G_Moogoo01Uoo`03G_Moogoo01Uoo`03G_Moogoo019oo`9Nm`Moo`03G_Moogoo00Mo
o`03G_Moogoo00Aoo`05G_MoogooOomNm`02Ool01EkgOomNmgooG_L00Woo00ENmgooOomooekg00Io
o`03G_Moogoo00Moo`03G_Moogoo00Eoo`9Nm`Uoo`03001oogoo01]oo`X2MaAoo`00>Goo00<007oo
Ool037oo00=NmgooOol06Woo00=NmgooOol06Goo00=NmgooOol06Goo00=NmgooOol057oo00=Nmgoo
Ool00goo00=NmgooOol02Goo00=NmgooOol00goo00ENmgooOomooekg009oo`05G_MooekgOomNm`02
Ool01EkgOomoogooG_L01Goo00=NmgooOol027oo00=NmgooOol017oo00=NmgooOol02Goo00<007oo
Ool06goo2P:g57oo000iOol00`00Oomoo`0<Ool00ekgOomoo`0JOol00ekgOomoo`0IOol00ekgOomo
o`0IOol00ekgOomoo`0EOol2G_L3Ool00ekgOomoo`09Ool00ekgOomoo`04Ool015kgOomooekg0Woo
00ENmgooG_Mooekg009oo`05G_MoogooOomNm`05Ool00ekgOomoo`09Ool015kgOomoogoo0Ukg37oo
00<007ooOol06goo2P:g57oo000iOol00`00Oomoo`0<Ool00ekgOomoo`0JOol00ekgOomoo`0IOol0
0ekgOomoo`0IOol00ekgOomoo`0GOol015kgOomooekg37oo00=NmgooOol00goo00ANmgooOomNm`9o
o`05G_MooekgOomNm`02Ool015kgOomooekg1Goo00=NmgooOol02Woo00ANmgooOomNm`ioo`03001o
ogoo01]oo`X2]aAoo`00>Goo00<007ooOol037oo00=NmgooOol06Woo00=NmgooOol06Goo00=Nmgoo
Ool06Goo00=NmgooOol067oo0ekg3Goo00=NmgooOol00Woo00eNmgooOomooekgOomNmgooG_Mooekg
OomNm`03Ool00ekgOomoo`02Ool00ekgOomoo`0;Ool3G_L?Ool00`00Oomoo`0KOol:0_LDOol003Uo
o`8000eoo`03G_Moogoo01Yoo`03G_Moogoo01Uoo`03G_Moogoo01Uoo`03G_Moogoo01Yoo`03G_Mo
ogoo00]oo`03G_Moogoo00=oo`0<G_MoogooG_MooekgOomNmgooG_Mooekg0Woo00=NmgooOol00goo
00=NmgooOol02goo00=NmgooOol03Woo0P007Goo2P;g57oo000iOol00`00Oomoo`0<Ool00ekgOomo
o`0IOol00ekgOomoo`0JOol00ekgOomoo`0IOol00ekgOomoo`0JOol3G_L<Ool00ekgOomoo`02Ool0
35kgOomooekgOomNmgooG_MooekgOomNm`9oo`03G_Moogoo009oo`03G_Moogoo00Yoo`=Nma5oo`03
001oogoo01]oo`X2maAoo`00>Goo00<007ooOol037oo00=NmgooOol06Goo00=NmgooOol06Woo00=N
mgooOol06Goo00=NmgooOol06Woo00ANmgooOomNm`aoo`03G_Moogoo009oo`0=G_MooekgOomNmgoo
G_MooekgOomNmgooG_L017oo00=NmgooOol02Woo00ANmgooOomNma5oo`03001oogoo01]oo`X2mAAo
o`00>Goo00<007ooOol037oo00=NmgooOol06Goo00=NmgooOol06Woo00=NmgooOol06Goo00=Nmgoo
Ool06Woo00ANmgooOomoo`9Nm`]oo`05G_MoogooOomNm`02Ool2G_L027ooG_MooekgOomNmgooG_L4
Ool00ekgOomoo`08Ool2G_L3Ool00ekgOomoo`0?Ool00`00Oomoo`0KOol:0_DDOol003Uoo`03001o
ogoo00aoo`03G_Moogoo01Uoo`03G_Moogoo01Yoo`03G_Moogoo01Uoo`03G_Moogoo01Yoo`03G_Mo
ogoo00=oo`03G_Moogoo00Qoo`05G_MoogooOomNm`02Ool00ekgOomNm`02G_L01GooG_MoogooG_L0
0goo00=NmgooOol027oo00=NmgooOol00goo00=NmgooOol03goo00<007ooOol06goo2P;c57oo000i
Ool00`00Oomoo`0<Ool00ekgOomoo`0IOol00ekgOomoo`0IOol00ekgOomoo`0JOol00ekgOomoo`0I
Ool00ekgOomoo`05Ool2G_L9Ool025kgOomoogooG_MooekgOol3G_L017ooG_Mooekg0goo00=Nmgoo
Ool01goo0Ukg1goo00=NmgooOol03Woo00<007ooOol06goo2P;c57oo000iOol00`00Oomoo`0<Ool0
0ekgOomoo`0IOol00ekgOomoo`0IOol00ekgOomoo`0JOol00ekgOomoo`0IOol00ekgOomoo`07Ool0
0ekgOomoo`07Ool01ekgOomooekgOomNmgoo00=Nm`04OomNmgooG_L2Ool00ekgOomoo`07Ool00ekg
Oomoo`07Ool00ekgOomoo`0>Ool00`00Oomoo`0KOol:0_<DOol003Uoo`03001oogoo00aoo`03G_Mo
ogoo01Uoo`03G_Moogoo01Uoo`03G_Moogoo01Yoo`03G_Moogoo01Uoo`03G_Moogoo00Qoo`9Nm`Mo
o`04G_MoogooOol2G_L01GooG_MNmekgOol00Ukg0goo00=NmgooOol01Goo0Ukg2Woo00=NmgooOol0
3Woo00<007ooOol06goo2P;`57oo000iOol00`00Oomoo`0<Ool00ekgOomoo`0IOol00ekgOomoo`0I
Ool00ekgOomoo`0JOol00ekgOomoo`0IOol00ekgOomoo`0:Ool00ekgOomoo`05Ool01EkgOomooekg
Ool01Ekg00EooekgOomooekg00Moo`03G_Moogoo00Yoo`03G_Moogoo00ioo`03001oogoo01]oo`X2
l1Aoo`00>Goo00<007ooOol037oo00=NmgooOol06Goo00=NmgooOol06Goo00=NmgooOol06Goo00=N
mgooOol06Woo00=NmgooOol02goo0Ukg1Woo00ANmgooG_Moo`ENm`04OomNmgooG_L6Ool2G_L=Ool0
0ekgOomoo`0>Ool00`00Oomoo`0KOol:0_0DOol003Uoo`03001oogoo00aoo`03G_Moogoo01Uoo`03
G_Moogoo01Uoo`03G_Moogoo01Uoo`03G_Moogoo01Yoo`03G_Moogoo00eoo`03G_Moogoo00=oo`03
G_Moogoo00MNm`9oo`03G_Moogoo00=oo`03G_Moogoo00eoo`03G_Moogoo00ioo`03001oogoo01]o
o`X2kQAoo`00>Goo00<007ooOol037oo00=NmgooOol06Goo00=NmgooOol06Goo00=NmgooOol06Goo
00=NmgooOol06Woo00=NmgooOol03Woo0Ukg17oo00=NmgooG_L01Ukg00=ooekgOol00goo0Ukg47oo
00=NmgooOol03Woo00<007ooOol06goo2P;^57oo000iOol00`00Oomoo`0<Ool00ekgOomoo`0IOol0
0ekgOomoo`0IOol00ekgOomoo`0IOol00ekgOomoo`0JOol00ekgOomoo`0@Ool00ekgOomoo`02Ool0
0ekgOomNm`04G_L00gooG_Moo`03Ool00ekgOomoo`0@Ool00ekgOomoo`0>Ool00`00Oomoo`0KOol:
0^/DOol003Uoo`03001oogoo00aoo`03G_Moogoo01Uoo`03G_Moogoo01Uoo`03G_Moogoo01Uoo`03
G_Moogoo01Yoo`03G_Moogoo015oo`9Nm`=oo`INm`04OomNmgooOol2G_LCOol00ekgOomoo`0>Ool0
0`00Oomoo`0KOol:0^/DOol001Qoo`8000Uoo`8001Aoo`03001oogoo00aoo`03G_Moogoo01Uoo`03
G_Moogoo01Uoo`03G_Moogoo01Uoo`03G_Moogoo01Yoo`03G_Moogoo01=oo`03G_Moogoo00MNm`9o
o`03G_Moogoo01=oo`03G_Moogoo00ioo`03001oogoo01]oo`X2jaAoo`0067oo00<007ooOol02Goo
00<007ooOol04Woo00<007ooOol037oo00=NmgooOol06Goo00=NmgooOol06Goo00=NmgooOol06Goo
00=NmgooOol06Woo00=NmgooOol057oo0Ukg00=ooekgG_L00ekg00=ooekgG_L05Woo00=NmgooOol0
3Woo00<007ooOol06goo2P;Y57oo000;Ool300001goo000007oo001oo`0000=oo`04001oogooOol3
0005Ool00`00Oomoo`0<Ool20004Ool00`00Oomoo`0<Ool00ekgOomoo`0IOol00ekgOomoo`0IOol0
0ekgOomoo`0IOol00ekgOomoo`0JOol00ekgOomoo`0FOol00ekgOomNm`02G_L00gooG_Moo`0GOol0
0ekgOomoo`0>Ool00`00Oomoo`0KOol:0^TDOol000aoo`09001oogooOol007oo001oo`0000=oo`03
001oogoo00Aoo`03001oogoo009oo`03001oogoo00]oo`04001oogoo0003Ool00`00Oomoo`0<Ool0
0ekgOomoo`0IOol00ekgOomoo`0IOol00ekgOomoo`0IOol00ekgOomoo`0JOol00ekgOomoo`0GOol5
G_LIOol00ekgOomoo`0>Ool00`00Oomoo`0KOol:0^TDOol000aoo`09001oogooOol007oo001oo`00
00=oo`04001oogooOol30005Ool00`00Oomoo`0;Ool01000Oomoo`000goo3Ukg00<3h5kgG_L0A5kg
00Ql004G0SL2m`;`0^T2i0;R1Ukg00<3h5kgG_L0Hekg00<007ooOol06goo2P;W57oo000<Ool00`00
Oomoo`0300000goo001oo`03Ool01000Oomoogoo100017oo00<007ooOol02goo00@007ooOol000=o
o`03001oogoo00]oo`030n1Nmgoo01Yoo`03G_Moogoo01Uoo`03G_Moogoo00]oo`08O0015`8g0_L2
l0;Y0^@2hPIoo`030n1oogoo01Yoo`03G_Moogoo01Moo`ENmaUoo`03G_Moogoo00ioo`03001oogoo
01]oo`X2iaAoo`0037oo00<007ooOol02Goo00<007ooOol02Goo00<007ooOol02goo00@007ooOol0
00=oo`03001oogoo00aoo`03G_Moogoo01Uoo`03G_Moogoo01Uoo`03G_Moogoo01Uoo`03G_Moogoo
01Yoo`03G_Moogoo01Ioo`03G_Mooekg009Nm`03OomNmgoo01Moo`03G_Moogoo00ioo`03001oogoo
01]oo`X2i1Aoo`002goo0`002Woo0P002Goo0P003Woo0P0017oo00<007ooOol037oo00=NmgooOol0
6Goo00=NmgooOol06Goo00=NmgooOol06Goo00=NmgooOol06Woo00=NmgooOol057oo0Ukg00=ooekg
G_L00ekg00=ooekgG_L05Woo00=NmgooOol03Woo00<007ooOol06goo2P;T57oo000iOol00`00Oomo
o`0<Ool00ekgOomoo`0IOol00ekgOomoo`0IOol00ekgOomoo`0IOol00ekgOomoo`0JOol00ekgOomo
o`0COol00ekgOomoo`07G_L2Ool00ekgOomoo`0COol00ekgOomoo`0>Ool00`00Oomoo`0KOol:0^@6
Ool3000;Ool003Uoo`03001oogoo00aoo`03G_Moogoo01Uoo`03G_Moogoo01Uoo`03G_Moogoo01Uo
o`03G_Moogoo01Yoo`03G_Moogoo015oo`9Nm`=oo`INm`04OomNmgooOol2G_LCOol00ekgOomoo`0>
Ool00`00Oomoo`0KOol:0^87Ool01000Oomoo`002Goo000iOol00`00Oomoo`0<Ool00ekgOomoo`0I
Ool00ekgOomoo`0IOol00ekgOomoo`0IOol00ekgOomoo`0JOol00ekgOomoo`0@Ool00ekgOomoo`02
Ool00ekgOomNm`04G_L00gooG_Moo`03Ool00ekgOomoo`0@Ool00ekgOomoo`0>Ool00`00Oomoo`0K
Ool:0^84Ool500000goo001oo`08Ool003Uoo`03001oogoo00aoo`03G_Moogoo01Uoo`03G_Moogoo
01Uoo`03G_Moogoo01Uoo`03G_Moogoo01Yoo`03G_Moogoo00ioo`9Nm`Aoo`03G_Mooekg00INm`03
OomNmgoo00=oo`9Nma1oo`03G_Moogoo00ioo`03001oogoo01]oo`X2hPAoo`04001oogoo0002Ool0
0`00Oomoo`07Ool003Uoo`03001oogoo00aoo`03G_Moogoo01Uoo`03G_Moogoo01Uoo`03G_Moogoo
01Uoo`03G_Moogoo01Yoo`03G_Moogoo00eoo`03G_Moogoo00=oo`03G_Moogoo00MNm`9oo`03G_Mo
ogoo00=oo`03G_Moogoo00eoo`03G_Moogoo00ioo`03001oogoo03Uoo`00>Goo00<007ooOol037oo
00=NmgooOol06Goo00=NmgooOol06Goo00=NmgooOol06Goo00=NmgooOol06Woo00=NmgooOol02goo
0Ukg1Woo00ANmgooG_Moo`ENm`04OomNmgooG_L6Ool2G_L=Ool00ekgOomoo`0>Ool00`00Oomoo`0i
Ool003Uoo`03001oogoo00aoo`03G_Moogoo01Uoo`03G_Moogoo01Uoo`03G_Moogoo01Yoo`03G_Mo
ogoo01Uoo`03G_Moogoo00Yoo`03G_Moogoo00Eoo`05G_MoogooG_Moo`05G_L01GooG_MoogooG_L0
1goo00=NmgooOol02Woo00=NmgooOol03Woo00<007ooOol0>Goo000iOol00`00Oomoo`0<Ool00ekg
Oomoo`0IOol00ekgOomoo`0IOol00ekgOomoo`0JOol00ekgOomoo`0IOol00ekgOomoo`08Ool2G_L7
Ool015kgOomoogoo0Ukg00EooekgG_MNmgoo009Nm`=oo`03G_Moogoo00Eoo`9Nm`Yoo`03G_Moogoo
00ioo`03001oogoo03Uoo`00>Goo00<007ooOol037oo00=NmgooOol06Goo00=NmgooOol06Goo00=N
mgooOol06Woo00=NmgooOol06Goo00=NmgooOol01goo00=NmgooOol01goo00MNmgooOomNmgooG_Mo
o`03G_L017ooG_Mooekg0Woo00=NmgooOol01goo00=NmgooOol01goo00=NmgooOol03Woo00<007oo
Ool0>Goo000iOol00`00Oomoo`0<Ool00ekgOomoo`0IOol00ekgOomoo`0IOol00ekgOomoo`0JOol0
0ekgOomoo`0IOol00ekgOomoo`05Ool2G_L9Ool025kgOomoogooG_MooekgOol3G_L017ooG_Mooekg
0goo00=NmgooOol01goo0Ukg1Woo00=NmgooOol03goo00<007ooOol0>Goo000iOol00`00Oomoo`0<
Ool00ekgOomoo`0IOol00ekgOomoo`0JOol00ekgOomoo`0IOol00ekgOomoo`0JOol00ekgOomoo`03
Ool00ekgOomoo`08Ool01EkgOomoogooG_L00Woo00=NmgooG_L00Ukg00EooekgOomooekg00=oo`03
G_Moogoo00Qoo`03G_Moogoo00=oo`03G_Moogoo00moo`03001oogoo03Uoo`00>Goo00<007ooOol0
37oo00=NmgooOol06Goo00=NmgooOol06Woo00=NmgooOol06Goo00=NmgooOol06Woo00ANmgooOomo
o`9Nm`]oo`05G_MoogooOomNm`02Ool2G_L027ooG_MooekgOomNmgooG_L4Ool00ekgOomoo`08Ool2
G_L3Ool00ekgOomoo`0?Ool00`00Oomoo`0iOol003Uoo`03001oogoo00aoo`03G_Moogoo01Uoo`03
G_Moogoo01Yoo`03G_Moogoo01Uoo`03G_Moogoo01Yoo`04G_MoogooG_L<Ool00ekgOomoo`02Ool0
3EkgOomNmgooG_MooekgOomNmgooG_Mooekg00Aoo`03G_Moogoo00Yoo`04G_MoogooG_LAOol00`00
Oomoo`0iOol003Uoo`03001oogoo00aoo`03G_Moogoo01Uoo`03G_Moogoo01Yoo`03G_Moogoo01Uo
o`03G_Moogoo01Yoo`=Nm`aoo`03G_Moogoo009oo`0<G_MoogooG_MooekgOomNmgooG_Mooekg0Woo
00=NmgooOol00Woo00=NmgooOol02Woo0ekg4Goo00<007ooOol0>Goo000iOol2000=Ool00ekgOomo
o`0JOol00ekgOomoo`0IOol00ekgOomoo`0IOol00ekgOomoo`0JOol00ekgOomoo`0;Ool00ekgOomo
o`03Ool035kgOomooekgOomNmgooG_MooekgOomNm`9oo`03G_Moogoo00=oo`03G_Moogoo00]oo`03
G_Moogoo00ioo`8003]oo`00>Goo00<007ooOol037oo00=NmgooOol06Woo00=NmgooOol06Goo00=N
mgooOol06Goo00=NmgooOol067oo0ekg3Goo00=NmgooOol00Woo00eNmgooOomooekgOomNmgooG_Mo
oekgOomNm`03Ool00ekgOomoo`02Ool00ekgOomoo`0;Ool3G_L?Ool00`00Oomoo`0iOol003Uoo`03
001oogoo00aoo`03G_Moogoo01Yoo`03G_Moogoo01Uoo`03G_Moogoo01Uoo`03G_Moogoo01Moo`04
G_MoogooG_L<Ool00ekgOomoo`03Ool015kgOomooekg0Woo00ENmgooG_Mooekg009oo`04G_Moogoo
G_L5Ool00ekgOomoo`0:Ool015kgOomooekg3Woo00<007ooOol0>Goo000iOol00`00Oomoo`0<Ool0
0ekgOomoo`0JOol00ekgOomoo`0IOol00ekgOomoo`0IOol00ekgOomoo`0EOol2G_L3Ool00ekgOomo
o`09Ool00ekgOomoo`04Ool015kgOomooekg0Woo00ENmgooG_Mooekg009oo`05G_MoogooOomNm`05
Ool00ekgOomoo`09Ool015kgOomoogoo0Ukg37oo00<007ooOol0>Goo000iOol00`00Oomoo`0<Ool0
0ekgOomoo`0JOol00ekgOomoo`0IOol00ekgOomoo`0IOol00ekgOomoo`0DOol00ekgOomoo`04Ool0
0ekgOomoo`08Ool00ekgOomoo`03Ool01EkgOomoogooG_L00Woo00ENmgooG_Mooekg009oo`05G_Mo
ogooOomNm`05Ool00ekgOomoo`08Ool00ekgOomoo`04Ool00ekgOomoo`09Ool00`00Oomoo`0iOol0
03Uoo`03001oogoo00eoo`03G_Moogoo01Uoo`03G_Moogoo01Uoo`03G_Moogoo01Uoo`03G_Moogoo
019oo`9Nm`Moo`03G_Moogoo00Moo`03G_Moogoo00Aoo`05G_MoogooOomNm`02Ool01EkgOomNmgoo
G_L00Woo00ENmgooOomooekg00Ioo`03G_Moogoo00Moo`03G_Moogoo00Eoo`9Nm`Uoo`03001oogoo
03Uoo`00>Goo00<007ooOol03Goo00=NmgooOol06Goo00=NmgooOol06Goo00=NmgooOol06Goo00=N
mgooOol04Goo00=NmgooOol01goo00=NmgooOol01Woo00=NmgooOol017oo00=NmgooOol00Woo00=N
mgooG_L00Woo00ANmgooOomNm`9oo`05G_MoogooOomNm`06Ool00ekgOomoo`06Ool00ekgOomoo`07
Ool00ekgOomoo`06Ool00`00Oomoo`0iOol003Uoo`03001oogoo00eoo`03G_Moogoo01Uoo`03G_Mo
ogoo01Uoo`03G_Moogoo01Uoo`03G_Moogoo00moo`9Nm`Yoo`03G_Moogoo00Ioo`03G_Moogoo00Ao
o`05G_MoogooOomNm`02Ool015kgOomooekg0Woo00ANmgooOomNm`=oo`03G_Moogoo00Eoo`03G_Mo
ogoo00Eoo`03G_Moogoo00Qoo`9Nm`Ioo`03001oogoo03Uoo`00>Goo00<007ooOol03Goo00=Nmgoo
Ool06Goo00=NmgooOol06Goo00=NmgooOol06Goo00=NmgooOol03Woo00=NmgooOol02Woo00=Nmgoo
Ool01Goo00=NmgooOol01Goo00ENmgooOomooekg009oo`04G_MoogooG_L2Ool015kgOomooekg17oo
00=NmgooOol017oo00=NmgooOol01Goo00=NmgooOol02Woo00=NmgooOol00goo00<007ooOol0>Goo
000iOol00`00Oomoo`0=Ool00ekgOomoo`0IOol00ekgOomoo`0IOol00ekgOomoo`0JOol00ekgOomo
o`0;Ool2G_L=Ool00ekgOomoo`04Ool00ekgOomoo`05Ool00ekgOomoo`02Ool015kgOomooekg0Woo
00ANmgooOomNm`9oo`03G_Moogoo009oo`03G_Moogoo00Eoo`03G_Moogoo00Aoo`03G_Moogoo00]o
o`9Nm`=oo`03001oogoo03Uoo`00>Goo00<007ooOol03Goo00=NmgooOol06Goo00=NmgooOol06Goo
00=NmgooOol06Woo00=NmgooOol02Woo00=NmgooOol03Goo00=NmgooOol00goo00=NmgooOol01Woo
00=NmgooOol00Woo00ANmgooOomNm`9oo`04G_MoogooG_L3Ool01EkgOomoogooG_L027oo00=Nmgoo
Ool00goo00=NmgooOol03Goo00ANmgooOol003]oo`00>Goo00<007ooOol03Goo00=NmgooOol06Goo
00=NmgooOol06Goo00=NmgooOol06Woo00=NmgooOol027oo0Ukg47oo00=NmgooOol00goo00=Nmgoo
Ool01Goo00=NmgooOol00Woo00ENmgooOomooekg009oo`04G_MoogooG_L3Ool00ekgOomoo`02Ool0
0ekgOomoo`05Ool00ekgOomoo`03Ool00ekgOomoo`0>Ool2G_L00`00Oomoo`0iOol003Uoo`03001o
ogoo00eoo`03G_Moogoo01Uoo`03G_Moogoo01Uoo`03G_Moogoo01Yoo`03G_Moogoo00Moo`03G_Mo
ogoo011oo`03G_Moogoo009oo`03G_Moogoo00Ioo`06G_MoogooOoml05kg0goo00ANmgooOomNm`9o
o`05G_MoogooOomNm`04Ool00ekgOomoo`06Ool01EkgOomoogooG_L04goo00<007ooOol0>Goo000i
Ool00`00Oomoo`0=Ool00ekgOomoo`0IOol00ekgOomoo`0IOol00ekgOomoo`0JOol00ekgOomoo`05
Ool2G_LDOol015kgOomooekg2Goo00INmgooOomoog`0G0L3Ool015kgOomooekg0Woo00ENmgooOomo
oekg00Eoo`03G_Moogoo00Ioo`04G_MoogooG_LCOol00`00Oomoo`0iOol003Uoo`03001oogoo00eo
o`03G_Moogoo01Uoo`03G_Moogoo01Uoo`03G_Moogoo01Yoo`03G_Moogoo00Aoo`03G_Moogoo01Ao
o`04G_MoogooG_L8Ool00ekgOomoo`03Ool01E`7OomoogooG_L00Woo00ANmgooOomNm`Aoo`03G_Mo
ogoo009oo`03G_Moogoo00Ioo`04G_MoogooG_LCOol00`00Oomoo`0iOol003Uoo`03001oogoo00eo
o`03G_Moogoo01Uoo`03G_Moogoo01Yoo`03G_Moogoo01Uoo`03G_Moogoo009oo`9NmaMoo`03G_Mo
oekg00Uoo`03G_Moogoo009oo`03G_Mooe`9009oo`04G_MoogooG_L2Ool00ekgOomoo`02Ool00ekg
Oomoo`02Ool00ekgOomoo`07Ool00ekgOomNm`0COol00`00Oomoo`0iOol003Uoo`03001oogoo00eo
o`03G_Moogoo01Uoo`03G_Moogoo01Yoo`03G_Moogoo01Uoo`05G_MoogooOomNm`0IOol2G_L9Ool0
0ekgOomoo`03Ool01EkgOomL2GooG_L00goo00ENmgooOomooekg00=oo`03G_Moogoo00=oo`03G_Mo
ogoo00Moo`9Nma=oo`03001oogoo03Uoo`00>Goo0P003Woo00=NmgooOol06Goo00=NmgooOol06Woo
00=NmgooOol06Goo00ANmgooG_MNmaYoo`9Nm`Ioo`04G0]L2G`0G_L5Ool01EkgOomooe`;G_L00goo
00ENmgooOomooekg00=oo`03G_Moogoo00=oo`03G_Moogoo00Qoo`03G_Moogoo011oo`8003]oo`00
>Goo00<007ooOol03Goo00=NmgooOol06Goo00=NmgooOol06Woo00=NmgooOol06Goo0Ukg77oo0Ukg
17oo00IL3WooG0]L2G`0G_L5Ool01EkgOomooe`;G_L00goo00ENmgooOomooekg00=oo`03G_Moogoo
00Aoo`03G_Moogoo00Ioo`9Nma=oo`03001oogoo03Uoo`00>Goo00<007ooOol03Goo00=NmgooOol0
6Goo00=NmgooOol06Woo00=NmgooOol067oo0Ukg77oo00=NmgooG_L00goo00=L45`>Ool00Woo00=N
mgooOol017oo00ENmgooOomooe`>00=oo`05G_MoogooOomNm`04Ool00ekgOomoo`03Ool00ekgOomo
o`06Ool00ekgOomNm`0BOol00`00Oomoo`0iOol003Uoo`03001oogoo00eoo`03G_Moogoo01Uoo`03
G_Moogoo01Yoo`03G_Moogoo01Moo`03G_Mooekg01]oo`04G_MoogooG_L2Ool00e`BG11oo`03Ool0
0ekgOomoo`03Ool00ekgOomoo`02Ool01E`>OomoogooG_L00goo00=NmgooOol00Woo00=NmgooOol0
0goo00=NmgooOol01Woo00ANmgooOomNma5oo`03001oogoo03Uoo`00>Goo00<007ooOol03Goo00=N
mgooOol06Goo00=NmgooOol06Woo00=NmgooOol05Goo0Ukg0Woo00=NmgooOol06Goo00MNmgooOomN
mgooG1EL4P04Ool00ekgOomoo`04Ool00ekgOomoo`02Ool01EkgG11oogooG_L00goo00=NmgooOol0
0Woo00=NmgooOol017oo00=NmgooOol01Goo00ANmgooOomNma5oo`03001oogoo03Uoo`00>Goo00<0
07ooOol03Goo00=NmgooOol06Goo00=NmgooOol06Woo00=NmgooOol057oo00=NmgooOol00goo00=N
mgooOol05goo00=NmgooOol00Woo00=Nme`EOol017oo00=NmgooOol017oo00=NmgooOol00Woo00EN
me`@Oomooekg00=oo`03G_Moogoo009oo`03G_Moogoo00Aoo`03G_Moogoo00Aoo`03G_Moogoo009o
o`03G_Moogoo00ioo`03001oogoo03Uoo`00>Goo00<007ooOol03Goo00=NmgooOol06Goo00=Nmgoo
Ool06Woo00=NmgooOol04Woo0Ukg1Woo00=NmgooOol05Woo00=NmgooOol00Woo00=L5ekgOol01Goo
00=NmgooOol017oo00=NmgooOol00Woo00ENmgooOomL4Ukg00=oo`03G_Moogoo00=oo`03G_Moogoo
00Aoo`03G_Moogoo00=oo`03G_Moogoo00=oo`03G_Moogoo00eoo`03001oogoo03Uoo`00>Goo00<0
07ooOol03Goo00=NmgooOol06Goo00=NmgooOol06Woo00=NmgooOol04Goo00=NmgooOol01Woo00=N
mgooOol05Woo00MNmgooOomooePGG1MNm`05Ool00ekgOomoo`04Ool00ekgOomoo`03Ool01EkgOomo
oe`BG_L00goo00=NmgooOol00goo00=NmgooOol017oo00=NmgooOol00goo00=NmgooOol017oo00=N
mgooOol037oo00<007ooOol0>Goo000iOol00`00Oomoo`0=Ool00ekgOomoo`0IOol00ekgOomoo`0J
Ool00ekgOomoo`0?Ool2G_L9Ool00ekgOomoo`0EOol00ekgOomoo`02Ool015PGOomooekg17oo00=N
mgooOol017oo00=NmgooOol00Woo00=NmgooOol00Woo00=NmgooOol00Woo00=NmgooOol00Woo00=N
mgooOol017oo00=NmgooOol00Woo00=NmgooOol01Goo00=NmgooOol037oo00<007ooOol0>Goo000i
Ool00`00Oomoo`0=Ool00ekgOomoo`0JOol00ekgOomoo`0IOol00ekgOomoo`0>Ool00ekgOomoo`09
Ool00ekgOomoo`0DOol00ekgOomoo`02Ool01D`GOomoogooG_L00goo00=NmgooOol01Goo00=Nmgoo
Ool00Woo00=NmgooOol00Woo00=L5GooOol00Woo00=NmgooOol00Woo00=NmgooOol01Goo00ENmgoo
Oomooekg00Qoo`03G_Moogoo00]oo`03001oogoo03Uoo`00>Goo00<007ooOol03Goo00=NmgooOol0
6Woo00=NmgooOol06Goo00=NmgooOol037oo0Ukg37oo00=NmgooOol057oo00INmgooOomood@GC1L3
Ool01EkgOomoogooG_L01goo00=NmgooOol00Woo00=NmgooOol00Woo00=L5GooOol00Woo00=Nmgoo
Ool00goo00=NmgooOol017oo00ENmgooOomooekg00Uoo`03G_Moogoo00Yoo`03001oogoo03Uoo`00
>Goo00<007ooOol03Goo00=NmgooOol06Woo00=NmgooOol06Goo00=NmgooOol02goo00=NmgooOol0
37oo00=NmgooOol04goo00=NmgooOol00Woo00=45gooOol00Woo00ENmgooOomooekg00Ioo`03G_Mo
ogoo00=oo`03G_Moogoo009oo`03G_ML5goo009oo`03G_Moogoo00=oo`03G_Moogoo00Eoo`04G_Mo
ogooG_L9Ool00ekgOomoo`0:Ool00`00Oomoo`0iOol003Uoo`03001oogoo00eoo`03G_Moogoo01Yo
o`03G_Moogoo01Yoo`03G_Moogoo00Qoo`9Nm`moo`03G_Moogoo019oo`03G_Moogoo009oo`03?1Mo
ogoo00Aoo`03G_Mooekg00Moo`03G_Moogoo00=oo`03G_Moogoo009oo`03G_ML5goo009oo`03G_Mo
ogoo00=oo`03G_Moogoo00Eoo`03G_Mooekg00]oo`03G_Moogoo00Uoo`03001oogoo03Uoo`00>Goo
00<007ooOol03Goo00=NmgooOol06Woo00=NmgooOol06Woo00=NmgooOol01goo00=NmgooOol047oo
00=NmgooOol04Goo00INmgooOomooc0G?1L6Ool00ekgOomNm`07Ool00ekgOomoo`03Ool00ekgOomo
o`02Ool00ekgOomoo`02Ool00ekgOomoo`03Ool00ekgOomoo`05Ool00ekgOomNm`0<Ool00ekgOomo
o`08Ool00`00Oomoo`0iOol003Uoo`03001oogoo00eoo`03G_Moogoo01Yoo`03G_Moogoo01Yoo`03
G_Moogoo00Eoo`9Nma=oo`03G_Moogoo011oo`06G_Moogoo:1Mooc0G1goo0Ukg27oo00=NmgooOol0
0goo00=NmgooOol00Woo00=NmgooF1L00Woo00=NmgooOol00goo00=NmgooOol01Woo00=NmgooOol0
2goo00=NmgooOol027oo00<007ooOol0>Goo000iOol00`00Oomoo`0=Ool00ekgOomoo`0JOol00ekg
Oomoo`0JOol00ekgOomoo`04Ool00ekgOomoo`0COol00ekgOomoo`0?Ool01EkgOomoogoo:1L02Woo
00=NmgooOol01Woo00=NmgooOol00goo00=NmgooOol00Woo00=NmgooF1L00Woo00=NmgooOol017oo
00=NmgooOol01Goo00=NmgooOol037oo00=NmgooOol01goo00<007ooOol0>Goo000iOol00`00Oomo
o`0=Ool00ekgOomoo`0JOol00ekgOomoo`0JOol00ekgOomoo`02Ool2G_LFOol00ekgOomoo`0>Ool0
1EkgOomoogoo81L02goo00=NmgooOol01Goo00=NmgooOol017oo00=NmgooOol00Woo00INmgooOom<
5gooG_L6Ool00ekgOomoo`04Ool00ekgOomNm`0>Ool00ekgOomoo`06Ool00`00Oomoo`0iOol003Uo
o`03001oogoo00ioo`03G_Moogoo01Uoo`03G_Moogoo01Yoo`05G_MoogooOomNm`0HOol00ekgOomo
o`0>Ool01EkgOomooa@G81L02Woo00=NmgooG_L01Woo00=NmgooOol017oo00=NmgooOol00Woo00IN
mgooOom<5gooG_L6Ool00ekgOomoo`04Ool00ekgOomNm`0?Ool00ekgOomoo`05Ool00`00Oomoo`0i
Ool003Uoo`8000moo`03G_Moogoo01Uoo`03G_Moogoo01Yoo`04G_MooekgG_LIOol00ekgOomoo`0=
Ool01EkgOomoogoo51L02goo00=NmgooG_L01Woo00=NmgooOol00goo00=NmgooOol00goo00=Nmgoo
Ool00goo00=NmgooOol00goo00=NmgooOol00goo00ANmgooOomNm`moo`03G_Moogoo00Aoo`8003]o
o`00>Goo00<007ooOol03Woo00=NmgooOol06Goo00=NmgooOol06Woo0Ukg6goo00=NmgooOol037oo
00ENmgooOomoo``G00]oo`05G_MoogooOomNm`05Ool00ekgOomoo`03Ool00ekgOomoo`03Ool00ekg
Oomoo`02Ool00d@GG_Moo`05Ool00ekgOomoo`02Ool01EkgOomoogooG_L03goo00=NmgooOol017oo
00<007ooOol0>Goo000iOol00`00Oomoo`0>Ool00ekgOomoo`0IOol00ekgOomoo`0IOol2G_LMOol0
0ekgOomoo`0;Ool01EkgOomoo`@G31L02goo00=NmgooOol00Woo00ENmgooOomooekg00Ioo`03G_Mo
ogoo00=oo`03G_Moogoo009oo`03A1MNmgoo00Eoo`05G_MoogooOomNm`04Ool00ekgOomoo`0>Ool0
0ekgOomoo`03Ool00`00Oomoo`0iOol003Uoo`03001oogoo00ioo`03G_Moogoo01Uoo`03G_Moogoo
01Qoo`03G_Mooekg01eoo`03G_Moogoo00Yoo`05G_Moogoo03L45`0<Ool00ekgOomoo`02Ool01Ekg
OomoogooG_L01Woo00=NmgooOol00goo00=NmgooOol00goo00=NmgooOol017oo00ENmgooOomooekg
00Eoo`03G_Moogoo00eoo`03G_Moogoo00=oo`03001oogoo03Uoo`00>Goo00<007ooOol03Woo00=N
mgooOol06Goo00=NmgooOol05Woo0Ukg0Woo00=NmgooOol06goo00=NmgooOol02Goo00ENmgooOomo
o`0g00aoo`03G_Moogoo00Aoo`04G_MoogooG_L6Ool00ekgOomoo`03Ool00ekgOomoo`03Ool00c`G
Oomoo`04Ool015kgOomooekg1Woo00=NmgooOol03Woo00=NmgooOol00Woo00<007ooOol0>Goo000i
Ool00`00Oomoo`0>Ool00ekgOomoo`0IOol00ekgOomoo`0EOol00ekgOomoo`03Ool00ekgOomoo`0J
Ool00ekgOomoo`09Ool015kgOomoo`1g3Goo00=NmgooOol017oo00ANmgooOomNm`Ioo`03G_Moogoo
00=oo`03G_Moogoo00=oo`03?1Moogoo00Eoo`03G_Mooekg00Moo`03G_Moogoo00ioo`05G_Moogoo
Ool0000kOol003Uoo`03001oogoo00ioo`03G_Moogoo01Uoo`03G_Moogoo01=oo`9Nm`Ioo`03G_Mo
ogoo01Yoo`03G_Moogoo00Qoo`05G_Moogoo0;L0M`0<Ool00ekgOomoo`06Ool00ekgOomNm`06Ool0
0ekgOomoo`03Ool00ekgOomoo`03Ool00ekg<1Moo`05Ool2G_L8Ool00ekgOomoo`0>Ool01EkgOomo
ogoo0000>goo000iOol00`00Oomoo`0>Ool00ekgOomoo`0IOol00ekgOomoo`0BOol00ekgOomoo`06
Ool00ekgOomoo`0JOol00ekgOomoo`07Ool01EkgOomoo`4G0;L03Goo00=NmgooOol01goo00=Nmgoo
Ool01Goo00=NmgooOol00goo00=NmgooOol00goo00=Nmc0GOol01Goo00=NmgooOol01goo00=Nmgoo
Ool03goo00ANmgooOol003]oo`00>Goo00<007ooOol03Woo00=NmgooOol06Goo00=NmgooOol047oo
0Ukg2Goo00=NmgooOol06goo00=NmgooOol01Goo00ENmgooOol1E`4G00ioo`03G_Moogoo00Moo`03
G_Moogoo00Eoo`03G_Moogoo00=oo`03G_Moogoo00=oo`03G_Moogoo00Eoo`03G_Moogoo00Qoo`03
G_Moogoo00moo`03G_Moo`0003]oo`00>Goo00<007ooOol03Woo00=NmgooOol06Woo00=NmgooOol0
3Woo00=NmgooOol02Goo00=NmgooOol06goo00=NmgooOol01Goo00ANmgoo0IL1E`ioo`03G_Moogoo
00Qoo`9Nm`Eoo`03G_Moogoo00Aoo`03G_Moogoo00Aoo`03G_LX5goo00=oo`03G_Mooekg00Uoo`03
G_Moogoo011oo`03G_L007oo03Yoo`00>Goo00<007ooOol03Woo00=NmgooOol06Woo00=NmgooOol0
37oo0Ukg37oo00=NmgooOol06goo00=NmgooOol017oo00ANmgooOol1U`moo`03G_Moogoo00Qoo`9N
m`Eoo`03G_Moogoo00Aoo`03G_Moogoo00Aoo`03G_LX5goo00=oo`03G_Mooekg00Yoo`03G_Moogoo
00moo`03G_L007oo03Yoo`00>Goo00<007ooOol03Woo00=NmgooOol06Woo00=NmgooOol02goo00=N
mgooOol037oo00=NmgooOol06goo00=NmgooOol00goo00ANmgooOol1m`moo`03G_Moogoo00Qoo`04
G_MoogooG_L4Ool00ekgOomoo`04Ool00ekgOomoo`04Ool00ekgOomoo`02Ool015kgOomooekg2Woo
00=NmgooOol047oo00<007ooOol0>Goo000iOol00`00Oomoo`0>Ool00ekgOomoo`0JOol00ekgOomo
o`09Ool2G_L?Ool00ekgOomoo`0KOol00ekgOomoo`03Ool015kgOol2=`7g3goo00=NmgooOol027oo
00ENmgooOomooekg00=oo`03G_Moogoo00Aoo`03G_Moogoo00Aoo`05G_Moob0GOomNm`03Ool00ekg
Oomoo`08Ool00ekgOomoo`0@Ool00`00Oomoo`0iOol003Uoo`03001oogoo00ioo`03G_Moogoo01Yo
o`03G_Moogoo00Qoo`03G_Moogoo011oo`03G_Moogoo01]oo`08G_MoogooOomNmgoo0WL2=a1oo`03
G_Moogoo00Qoo`03G_Moogoo009oo`04G_MoogooG_L6Ool00ekgOomoo`04Ool015kgOolP5ekg17oo
00=NmgooOol02Goo00=NmgooOol03goo00<007ooOol0>Goo000iOol00`00Oomoo`0?Ool00ekgOomo
o`0IOol00ekgOomoo`06Ool2G_LCOol00ekgOomoo`0KOol01ekgOomooekgOol2e`9g011oo`03G_Mo
ogoo00Uoo`03G_Moogoo00=oo`03G_Mooekg00Ioo`03G_Moogoo00Aoo`04G_Mooekg51L5Ool00ekg
Oomoo`08Ool00ekgOomoo`0?Ool00`00Oomoo`0iOol0039oo`@000=oo`03001oogoo00moo`03G_Mo
ogoo01Uoo`03G_Moogoo00Eoo`03G_Moogoo01=oo`03G_Moogoo01]oo`06G_MoogooG_L2m`;G4Goo
00=NmgooOol027oo00=NmgooOol01Goo0Ukg1Woo00=NmgooOol017oo0Ukg00=ooa@GOol017oo00=N
mgooOol02Goo00=NmgooOol03Woo00<007ooOol0>Goo000bOol00`00Oomoo`04Ool00`00Oomoo`0?
Ool00ekgOomoo`0IOol00ekgOomoo`03Ool2G_LFOol00ekgOomoo`0KOol01EkgOomNm`;e0_L04Goo
00=NmgooOol02Goo00=NmgooOol01Woo15kg0goo00ANmgooOomoo`ANm`Qoo`03G_Moogoo00Uoo`03
G_Moogoo00ioo`03001oogoo03Uoo`00<goo00<007ooOol00goo0`003goo00=NmgooOol06Goo00=N
mgooOol00Woo00=NmgooOol05Woo00=NmgooOol077oo00=Nmgoo0_D04Woo00=NmgooOol02Goo00=N
mgooOol01Woo00ANmgooOomoo`MNm`=oo`05G_MoogooOol<5`04Ool00ekgOomoo`09Ool00ekgOomo
o`0<Ool3000kOol003Aoo`03001oogoo009oo`03001oogoo00moo`03G_Moogoo01Uoo`03G_Moogoo
009NmaUoo`03G_Moogoo01]oo`03G_L2lWoo01=oo`03G_Moogoo00Uoo`03G_Moogoo00Ioo`03G_Mo
ogoo00Aoo`03G_Moogoo00Aoo`05G_MoogooOol<5`05Ool00ekgOomoo`09Ool00ekgOomoo`0=Ool0
0`00Oomoo`0iOol0039oo`04001oogoo0003Ool00`00Oomoo`0?Ool00ekgOomoo`0IOol00ekgOomN
m`0KOol00ekgOomoo`0KOol00`;`0_9oo`0BOol00ekgOomoo`0:Ool00ekgOomoo`05Ool00ekgOomo
o`05Ool00ekgOomoo`05Ool00ekgOomoo`06Ool00ekgOomoo`09Ool00ekgOomoo`0=Ool00`00Oomo
o`0iOol003=oo`8000Aoo`03001oogoo00moo`03G_Moogoo01Uoo`9Nmaaoo`03G_Moogoo01Yoo`03
0^h2l5kg01=oo`03G_Moogoo00Uoo`03G_Moogoo00Ioo`03G_Moogoo00Eoo`03G_Moogoo00Eoo`05
G_MoogooOol45`04Ool00ekgOomoo`0:Ool00ekgOomoo`0<Ool00`00Oomoo`0iOol003Uoo`03001o
ogoo00moo`03G_Moogoo01Qoo`03G_Mooekg01eoo`03G_Moogoo01Qoo`050^/2kWooOomNm`0AOol0
0ekgOomoo`0:Ool00ekgOomoo`06Ool00ekgOomoo`05Ool00ekgOomoo`05Ool01EkgOomoogoo11L0
17oo00=NmgooOol02Woo00=NmgooOol037oo00<007ooOol0>Goo000iOol00`00Oomoo`0?Ool00ekg
Oomoo`0FOol2G_L2Ool00ekgOomoo`0KOol00ekgOomoo`0GOol00`;Y0^]oo`02Ool00ekgOomoo`0?
Ool00ekgOomoo`0:Ool00ekgOomoo`06Ool00ekgOomoo`05Ool00ekgOomoo`05Ool00ekgOomoo`07
Ool00ekgOomoo`09Ool00ekgOomoo`0<Ool00`00Oomoo`0iOol003Uoo`03001oogoo00moo`03G_Mo
ogoo01Eoo`03G_Moogoo009oo`03G_Moogoo01]oo`03G_Moogoo01Moo`030^Uoogoo009oo`03G_Mo
ogoo00moo`03G_Moogoo00Yoo`03G_Moogoo00Ioo`03G_Moogoo00Eoo`03G_Moogoo00Eoo`03G_Mo
ogoo009oo`0303Moogoo009oo`03G_Moogoo00Yoo`03G_Moogoo00]oo`03001oogoo03Uoo`00>Goo
00<007ooOol03goo00=NmgooOol04goo0Ukg1Goo00=NmgooOol06goo00=NmgooOol05Woo00<2igoo
Ool00goo00=NmgooOol03Woo00=NmgooOol02Woo00=NmgooOol01goo00=NmgooOol01Goo00=Nmgoo
Ool01Goo00=NmgooOol00Woo00<0=gooOol00Woo00=NmgooOol02Woo00=NmgooOol02goo00<007oo
Ool0>Goo000iOol00`00Oomoo`0?Ool00ekgOomoo`0BOol00ekgOomoo`05Ool00ekgOomoo`0KOol0
0ekgOomoo`0EOol00`;T0^Moo`05Ool00ekgOomoo`0=Ool00ekgOomoo`0:Ool00ekgOomoo`07Ool0
0ekgOomoo`05Ool00ekgOomoo`05Ool00ekgOomoo`03Ool01@1gOomoogooG_L03Goo00=NmgooOol0
2Woo00<007ooOol0>Goo000iOol00`00Oomoo`0?Ool00ekgOomoo`0@Ool2G_L8Ool00ekgOomoo`0K
Ool00ekgOomoo`0DOol00`;R0^Aoo`06Ool00ekgOomoo`0<Ool00ekgOomoo`0;Ool00ekgOomoo`07
Ool00ekgOomoo`05Ool00ekgOomoo`05Ool00ekgOomoo`03Ool00`1gOomoo`02Ool00ekgOomoo`0:
Ool00ekgOomoo`0:Ool00`00Oomoo`0iOol003Uoo`03001oogoo00moo`03G_Moogoo00moo`03G_Mo
ogoo00Qoo`03G_Moogoo01]oo`03G_Moogoo01Aoo`030^9oogoo00Ioo`03G_Moogoo00aoo`03G_Mo
ogoo00]oo`03G_Moogoo00Moo`03G_Moogoo00Eoo`03G_Moogoo00Eoo`03G_Moogoo00Qoo`03G_Mo
ogoo00Yoo`03G_Moogoo00Yoo`03001oogoo03Uoo`00>Goo00<007ooOol047oo00=NmgooOol037oo
0Ukg37oo00=NmgooOol06goo00=NmgooOol04Woo00=NmgooOol01goo00=NmgooOol02goo00=Nmgoo
Ool02goo00=NmgooOol01goo00=NmgooOol01Woo00=NmgooOol01Goo00=NmgooOol017oo00D0]goo
Oomooekg00eoo`03G_Moogoo00Uoo`03001oogoo03Uoo`00>Goo00<007ooOol047oo00=NmgooOol0
2goo00=NmgooOol037oo00=NmgooOol06goo00=NmgooOol04Woo00=NmgooOol027oo00=NmgooOol0
2Woo00=NmgooOol02goo00=NmgooOol01goo00=NmgooOol01Woo00=NmgooOol01Woo00=NmgooOol0
0goo00D0]gooOomooekg00eoo`03G_Moogoo00Uoo`03001oogoo03Uoo`00>Goo00<007ooOol047oo
00=NmgooOol02Goo0Ukg3goo00=NmgooOol06goo00=NmgooOol04Goo00=NmgooOol02Goo00=Nmgoo
Ool02Woo00=NmgooOol02goo00=NmgooOol01goo00=NmgooOol01Woo00=NmgooOol01Woo00=Nmgoo
Ool01goo00=NmgooOol037oo00=NmgooOol027oo00<007ooOol0>Goo000iOol00`00Oomoo`0@Ool0
0ekgOomoo`08Ool00ekgOomoo`0?Ool00ekgOomoo`0KOol00ekgOomoo`0@Ool00ekgOomoo`0:Ool0
0ekgOomoo`09Ool00ekgOomoo`0<Ool00ekgOomoo`07Ool00ekgOomoo`06Ool00ekgOomoo`06Ool0
0ekgOomoo`04Ool01@4GOomoogooG_L03Goo00=NmgooOol027oo00<007ooOol0>Goo000iOol00`00
Oomoo`0@Ool00ekgOomoo`06Ool2G_LBOol00ekgOomoo`0KOol00ekgOomoo`0@Ool00ekgOomoo`0;
Ool00ekgOomoo`08Ool00ekgOomoo`0<Ool00ekgOomoo`07Ool00ekgOomoo`06Ool00ekgOomoo`06
Ool00ekgOomoo`04Ool01@4GOomoogooG_L03Goo00=NmgooOol027oo00<007ooOol0>Goo000iOol0
0`00Oomoo`0@Ool00ekgOomoo`05Ool00ekgOomoo`0BOol00ekgOomoo`0LOol00ekgOomoo`0>Ool0
0ekgOomoo`0<Ool00ekgOomoo`07Ool00ekgOomoo`0<Ool00ekgOomoo`08Ool00ekgOomoo`06Ool0
0ekgOomoo`06Ool00ekgOomoo`05Ool0105GOomooekg3Woo00=NmgooOol01goo00<007ooOol0>Goo
000iOol00`00Oomoo`0@Ool00ekgOomoo`03Ool2G_LEOol00ekgOomoo`0LOol00ekgOomoo`0=Ool0
0ekgOomoo`0>Ool00ekgOomoo`06Ool00ekgOomoo`0<Ool00ekgOomoo`08Ool00ekgOomoo`06Ool0
0ekgOomoo`06Ool00ekgOomoo`05Ool0105GOomooekg3Woo00=NmgooOol01goo00<007ooOol0>Goo
000iOol2000AOol00ekgOomoo`02Ool00ekgOomoo`0FOol00ekgOomoo`0KOol00ekgOomoo`0=Ool0
0ekgOomoo`0>Ool00ekgOomoo`06Ool00ekgOomoo`0<Ool00ekgOomoo`08Ool00ekgOomoo`06Ool0
0ekgOomoo`06Ool00ekgOomoo`09Ool00ekgOomoo`0<Ool00ekgOomoo`05Ool00ekg001oo`0jOol0
03Uoo`03001oogoo011oo`03G_Moogoo009NmaUoo`03G_Moogoo01]oo`03G_Moogoo00aoo`03G_Mo
ogoo00moo`03G_Moogoo00Eoo`03G_Moogoo00eoo`03G_Moogoo00Qoo`03G_Moogoo00Ioo`03G_Mo
ogoo00Ioo`03G_Moogoo00Ioo`040IMoogooG_L>Ool00ekgOomoo`05Ool00ekg001oo`0jOol003Uo
o`03001oogoo011oo`03G_Mooekg01]oo`03G_Moogoo01]oo`03G_Moogoo00]oo`03G_Moogoo015o
o`03G_Moogoo00Aoo`03G_Moogoo00aoo`03G_Moogoo00Uoo`03G_Moogoo00Ioo`03G_Moogoo00Io
o`03G_Moogoo00Ioo`040IMoogooG_L>Ool00ekgOomoo`04Ool00ekgOol0000kOol003Uoo`03001o
ogoo011oo`9Nmaaoo`03G_Moogoo01aoo`03G_Moogoo00Yoo`03G_Moogoo015oo`03G_Moogoo00=o
o`03G_Moogoo00eoo`03G_Moogoo00Qoo`03G_Moogoo00Moo`03G_Moogoo00Moo`03G_Moogoo00Qo
o`03G_Moogoo00eoo`03G_Moogoo00=oo`03G_Moo`0003]oo`00>Goo00<007ooOol03goo0Ukg7Goo
00=NmgooOol077oo00=NmgooOol02Goo00=NmgooOol04Woo00=NmgooOol00goo00=NmgooOol03Goo
00=NmgooOol027oo00=NmgooOol01goo00=NmgooOol01goo00=NmgooOol01Woo00@1mgooOomNm`io
o`03G_Moogoo00=oo`03G_Moo`0003]oo`00>Goo00<007ooOol03Goo0Ukg0Woo00=NmgooOol06Woo
00=NmgooOol077oo00=NmgooOol027oo00=NmgooOol057oo00=NmgooOol00Woo00=NmgooOol03Goo
00=NmgooOol027oo00=NmgooOol01goo00=NmgooOol01goo00=NmgooOol01Woo00@1mgooOomNm`mo
o`05G_MoogooOomNm`02Ool00`00Oomoo`0iOol003Uoo`03001oogoo00aoo`03G_Moogoo009oo`03
G_Moogoo01]oo`03G_Moogoo01]oo`03G_Moogoo00Moo`03G_Moogoo01Eoo`05G_MoogooOomNm`0@
Ool00ekgOomoo`08Ool00ekgOomoo`07Ool00ekgOomoo`07Ool00ekgOomoo`06Ool0108gOomooekg
3goo00ENmgooOomooekg009oo`03001oogoo03Uoo`00>Goo00<007ooOol02Woo0Ukg1Goo00=Nmgoo
Ool06goo00=NmgooOol077oo00=NmgooOol01Woo00=NmgooOol05Woo00ANmgooOomNm`moo`03G_Mo
ogoo00Uoo`03G_Moogoo00Moo`03G_Moogoo00Moo`03G_Moogoo00Ioo`040SMoogooG_L@Ool00ekg
OomNm`03Ool00`00Oomoo`0iOol003Uoo`03001oogoo00Uoo`03G_Moogoo00Eoo`03G_Moogoo01]o
o`03G_Moogoo01aoo`03G_Moogoo00Eoo`03G_Moogoo01Moo`03G_Mooekg011oo`03G_Moogoo00Uo
o`03G_Moogoo00Moo`03G_Moogoo00Moo`03G_Moogoo00Yoo`03G_Moogoo00eoo`03G_Mooekg00=o
o`03001oogoo03Uoo`00>Goo00<007ooOol01goo0Ukg27oo00=NmgooOol06goo00=NmgooOol077oo
00=NmgooOol017oo00=NmgooOol067oo00=NmgooG_L047oo00=NmgooOol02Goo00=NmgooOol01goo
00=NmgooOol01goo00=NmgooOol01goo00@2MgooOomNm`moo`03G_Mooekg00=oo`03001oogoo03Uo
o`00>Goo00<007ooOol01Woo00=NmgooOol027oo00=NmgooOol06goo00=NmgooOol077oo00=Nmgoo
Ool017oo00=NmgooOol06Goo0Ukg47oo00=NmgooOol02Goo00=NmgooOol01goo00=NmgooOol01goo
00=NmgooOol01goo00@2MgooOomNma1oo`03G_Moogoo009oo`03001oogoo03Uoo`00>Goo00<007oo
Ool017oo0Ukg2goo00=NmgooOol06goo00=NmgooOol077oo00=NmgooOol00goo00=NmgooOol06Woo
00=NmgooOol03Woo00=NmgooOol02Woo00=NmgooOol01goo00=NmgooOol01goo00=NmgooOol02Woo
00=NmgooOol03Woo00=NmgooOol00Woo00<007ooOol0>Goo000iOol00`00Oomoo`03Ool00ekgOomo
o`0;Ool00ekgOomoo`0KOol00ekgOomoo`0MOol01EkgOomoogooG_L07Goo0Ukg3goo00=NmgooOol0
2Woo00=NmgooOol01goo00=NmgooOol01goo00=NmgooOol027oo00<2egooG_L03goo00=NmgooG_L0
0goo00<007ooOol0>Goo000iOol01000Oomoogoo0Ukg3goo00=NmgooOol06goo00=NmgooOol077oo
00ENmgooOomooekg01aoo`03G_Mooekg00moo`03G_Moogoo00Uoo`03G_Moogoo00Qoo`03G_Moogoo
00Qoo`03G_Moogoo00Moo`040]MoogooG_L>Ool00ekgOomNm`03Ool00`00Oomoo`0iOol003Uoo`04
001oogooG_LAOol00ekgOomoo`0KOol00ekgOomoo`0LOol015kgOomooekg7Goo00=NmgooG_L03goo
00=NmgooOol02Goo00=NmgooOol027oo00=NmgooOol027oo00=NmgooOol02Woo00=NmgooOol037oo
00=NmgooG_L00goo00<007ooOol0>Goo000iOol00`00G_MNm`0BOol00ekgOomoo`0KOol00ekgOomo
o`0LOol00ekgOomNm`0NOol015kgOomooekg3Goo00=NmgooOol02Woo00=NmgooOol027oo00=Nmgoo
Ool027oo00=NmgooOol027oo00<2mgooG_L03Goo00ENmgooOomooekg009oo`03001oogoo03Uoo`00
>Goo00=NmgooOol04Woo00=NmgooOol06goo00=NmgooOol077oo0Ukg7Woo00ENmgooOomooekg00eo
o`03G_Moogoo00Yoo`03G_Moogoo00Qoo`03G_Moogoo00Qoo`03G_Moogoo00Qoo`030_Mooekg00eo
o`05G_MoogooOomNm`02Ool00`00Oomoo`0iOol003Uoo`03001oogoo019oo`03G_Moogoo01]oo`03
G_Moogoo01eoo`03G_Moogoo01aoo`05G_MoogooOomNm`0=Ool00ekgOomoo`0:Ool00ekgOomoo`08
Ool00ekgOomoo`08Ool00ekgOomoo`09Ool00`;eOomNm`0<Ool00ekgOomoo`02Ool00ekgOol0000k
Ool003Uoo`8001=oo`03G_Moogoo01]oo`03G_Moogoo01aoo`9Nmaeoo`03G_Moogoo00=oo`03G_Mo
ogoo00Yoo`03G_Moogoo00Yoo`03G_Moogoo00Qoo`03G_Moogoo00Qoo`03G_Moogoo00Uoo`030_Eo
oekg00]oo`03G_Moogoo00=oo`03G_L0000003]oo`00>Goo00<007ooOol04Woo00=NmgooOol077oo
00=NmgooOol06Woo00=NmgooG_L07Goo00=NmgooOol00goo00=NmgooOol02Woo00=NmgooOol02Woo
00=NmgooOol027oo00=NmgooOol027oo00=NmgooOol02goo00=NmgooOol02Goo00=NmgooOol00goo
00=Nmgoo0000>goo000iOol00`00Oomoo`0BOol00ekgOomoo`0LOol00ekgOomoo`0JOol00ekgOomN
m`0MOol00ekgOomoo`04Ool00ekgOomoo`08Ool00ekgOomoo`0;Ool00ekgOomoo`08Ool00ekgOomo
o`08Ool00ekgOomoo`0:Ool00`;bG_Moo`09Ool00ekgOomoo`05Ool00ekg001oo`0jOol003Uoo`03
001oogoo019oo`03G_Moogoo01aoo`03G_Moogoo01Uoo`05G_MoogooOomNm`0KOol00ekgOomoo`05
Ool00ekgOomoo`08Ool00ekgOomoo`0;Ool00ekgOomoo`08Ool00ekgOomoo`08Ool00ekgOomoo`0:
Ool00`;bOomNm`09Ool00ekgOomoo`05Ool00ekg001oo`0jOol003Uoo`03001oogoo01=oo`03G_Mo
ogoo01]oo`03G_Moogoo01Qoo`03G_Moogoo009oo`03G_Moogoo01Uoo`03G_Moogoo00Ioo`03G_Mo
ogoo00Moo`03G_Moogoo00Yoo`03G_Moogoo00Uoo`03G_Moogoo00Uoo`03G_Moogoo00Yoo`030_1N
mgoo00Moo`03G_Moogoo00Moo`03001oogoo03Uoo`00>Goo00<007ooOol04goo00=NmgooOol06goo
00=NmgooOol067oo00=NmgooOol00Woo00=NmgooOol067oo00=NmgooOol01goo00=NmgooOol01goo
00=NmgooOol02Woo00=NmgooOol02Goo00=NmgooOol02Goo00=NmgooOol02Woo00<2l5kgOol01goo
00=NmgooOol01goo00<007ooOol0>Goo000iOol00`00Oomoo`0COol00ekgOomoo`0KOol00ekgOomo
o`0GOol00ekgOomoo`03Ool00ekgOomoo`0HOol00ekgOomoo`08Ool00ekgOomoo`05Ool00ekgOomo
o`0;Ool00ekgOomoo`09Ool00ekgOomoo`09Ool00ekgOomoo`0;Ool00ekgOomoo`05Ool00ekgOomo
o`08Ool00`00Oomoo`0iOol003Uoo`03001oogoo01=oo`03G_Moogoo01aoo`03G_Moogoo01Eoo`03
G_Moogoo00Aoo`03G_Moogoo01Qoo`03G_Moogoo00Qoo`03G_Moogoo00Eoo`03G_Moogoo00]oo`03
G_Moogoo00Uoo`03G_Moogoo00Uoo`03G_Moogoo00]oo`030^iNmgoo00Eoo`03G_Moogoo00Qoo`03
001oogoo03Uoo`00>Goo00<007ooOol04goo00=NmgooOol077oo00=NmgooOol057oo00=NmgooOol0
1Woo00=NmgooOol05Woo00=NmgooOol02Woo00=NmgooOol017oo00=NmgooOol02goo00=NmgooOol0
2Goo00=NmgooOol02Goo00=NmgooOol02goo00<2kUkgOol017oo00=NmgooOol02Goo00<007ooOol0
>Goo000iOol00`00Oomoo`0COol00ekgOomoo`0LOol00ekgOomoo`0DOol00ekgOomoo`06Ool00ekg
Oomoo`0FOol00ekgOomoo`0;Ool00ekgOomoo`03Ool00ekgOomoo`0;Ool00ekgOomoo`09Ool00ekg
Oomoo`09Ool00ekgOomoo`0<Ool00ekgOomoo`02Ool00ekgOomoo`0:Ool00`00Oomoo`0iOol003Uo
o`03001oogoo01=oo`03G_Moogoo01aoo`03G_Moogoo01=oo`03G_Moogoo00Moo`03G_Moogoo01Eo
o`03G_Moogoo00aoo`03G_Moogoo00=oo`03G_Moogoo00]oo`03G_Moogoo00Uoo`03G_Moogoo00Uo
o`03G_Moogoo00]oo`030^]Nmgoo00=oo`03G_Moogoo00Yoo`03001oogoo03Uoo`00>Goo00<007oo
Ool04goo00=NmgooOol077oo00=NmgooOol04Woo00=NmgooOol027oo00=NmgooOol05Goo00=Nmgoo
Ool03Goo00ENmgooOomooekg00ioo`03G_Moogoo00Uoo`03G_Moogoo00Uoo`03G_Moogoo00]oo`03
0^]Nmgoo009oo`03G_Moogoo00]oo`03001oogoo03Uoo`00>Goo00<007ooOol057oo00=NmgooOol0
77oo00=NmgooOol04Goo00=NmgooOol02Goo00=NmgooOol057oo00=NmgooOol03Goo00ENmgooOomo
oekg00ioo`03G_Moogoo00Uoo`03G_Moogoo00Uoo`03G_Moogoo00aoo`050^UNmgooOomNm`0=Ool0
0`00Oomoo`0iOol003Uoo`03001oogoo01Aoo`03G_Moogoo01aoo`03G_Moogoo011oo`03G_Moogoo
00Yoo`03G_Moogoo01=oo`03G_Moogoo00moo`04G_MoogooG_L>Ool00ekgOomoo`09Ool00ekgOomo
o`09Ool00ekgOomoo`0<Ool010;YG_Mooekg3Woo00<007ooOol0>Goo000iOol00`00Oomoo`0DOol0
0ekgOomoo`0LOol00ekgOomoo`0?Ool00ekgOomoo`0;Ool00ekgOomoo`0COol00ekgOomoo`0@Ool0
0ekgOomNm`0=Ool00ekgOomoo`0:Ool00ekgOomoo`0:Ool00ekgOomoo`0<Ool2G_L?Ool00`00Oomo
o`0iOol003Uoo`03001oogoo01Aoo`03G_Moogoo01aoo`03G_Moogoo00moo`03G_Moogoo00]oo`03
G_Moogoo019oo`03G_Moogoo015oo`9Nm`ioo`03G_Moogoo00Yoo`03G_Moogoo00Yoo`03G_Moogoo
00aoo`030^MNmgoo00ioo`03001oogoo03Uoo`00>Goo00<007ooOol057oo00=NmgooOol077oo00=N
mgooOol03Woo00=NmgooOol03Goo00=NmgooOol04Goo00=NmgooOol04Woo00=NmgooOol037oo00=N
mgooOol02Woo00=NmgooOol02Woo00=NmgooOol037oo00<2iekgOol03Woo00<007ooOol0>Goo000i
Ool2000EOol00ekgOomoo`0MOol00ekgOomoo`0<Ool00ekgOomoo`0>Ool00ekgOomoo`0AOol00ekg
Oomoo`0BOol2G_L=Ool00ekgOomoo`0:Ool00ekgOomoo`0:Ool00ekgOomoo`0;Ool00ekgOomNm`0>
Ool2000kOol003Uoo`03001oogoo01Aoo`03G_Moogoo01eoo`03G_Moogoo00aoo`03G_Moogoo00io
o`03G_Moogoo011oo`03G_Moogoo01=oo`9Nm`eoo`03G_Moogoo00Yoo`03G_Moogoo00Yoo`03G_Mo
ogoo00]oo`03G_Moo`;T00moo`03001oogoo03Uoo`00>Goo00<007ooOol057oo00=NmgooOol07Goo
00=NmgooOol02goo00=NmgooOol03goo00=NmgooOol047oo00=NmgooOol04Woo00ANmgooOomNm`ao
o`03G_Moogoo00Yoo`03G_Moogoo00Yoo`03G_Moogoo00Yoo`04G_Moogoo0^@?Ool00`00Oomoo`0i
Ool003Uoo`03001oogoo01Eoo`03G_Moogoo01aoo`03G_Moogoo00Yoo`03G_Moogoo015oo`03G_Mo
ogoo00ioo`03G_Moogoo01=oo`05G_MoogooOomNm`0;Ool00ekgOomoo`0:Ool00ekgOomoo`0:Ool0
0ekgOomoo`09Ool00ekgOomoo`02Ool00`;ROomoo`0<Ool00`00Oomoo`0iOol003Uoo`03001oogoo
01Eoo`03G_Moogoo01aoo`03G_Moogoo00Uoo`03G_Moogoo019oo`03G_Moogoo00ioo`03G_Moogoo
01=oo`05G_MoogooOomNm`0;Ool00ekgOomoo`0:Ool00ekgOomoo`0:Ool00ekgOomoo`09Ool00ekg
Oomoo`02Ool00`;ROomoo`0<Ool00`00Oomoo`0iOol003Uoo`03001oogoo01Eoo`03G_Moogoo01ao
o`03G_Moogoo00Uoo`03G_Moogoo019oo`03G_Moogoo00ioo`03G_Moogoo01=oo`03G_Moogoo009o
o`03G_Moogoo00Qoo`03G_Moogoo00Yoo`03G_Moogoo00Yoo`03G_Moogoo00Qoo`03G_Moogoo00=o
o`03G_Moogoo00aoo`03001oogoo03Uoo`00>Goo00<007ooOol05Goo00=NmgooOol07Goo00=Nmgoo
Ool01goo00=NmgooOol057oo00=NmgooOol037oo00=NmgooOol057oo00=NmgooOol00goo00=Nmgoo
Ool01Woo00=NmgooOol02goo00=NmgooOol02goo00=NmgooOol01Woo00=NmgooOol017oo00=Nmgoo
Ool037oo00<007ooOol0>Goo000iOol00`00Oomoo`0EOol00ekgOomoo`0MOol00ekgOomoo`06Ool0
0ekgOomoo`0EOol00ekgOomoo`0<Ool00ekgOomoo`0COol00ekgOomoo`05Ool00ekgOomoo`05Ool0
0ekgOomoo`0;Ool00ekgOomoo`0;Ool00ekgOomoo`05Ool00ekgOomoo`05Ool00ekgOomoo`0<Ool0
0`00Oomoo`0iOol003Uoo`03001oogoo01Eoo`03G_Moogoo01eoo`03G_Moogoo00Ioo`03G_Moogoo
01Eoo`03G_Moogoo00]oo`03G_Moogoo01Aoo`03G_Moogoo00Ioo`9Nm`Eoo`03G_Moogoo00]oo`03
G_Moogoo00]oo`03G_Moogoo00Aoo`03G_Moogoo00Moo`03G_Moogoo00]oo`03001oogoo03Uoo`00
>Goo00<007ooOol05Goo00=NmgooOol07Goo00=NmgooOol01Goo00=NmgooOol05goo00=NmgooOol0
2Woo00=NmgooOol057oo00=NmgooOol027oo00=NmgooOol00Woo00=NmgooOol02goo00=NmgooOol0
2goo00=NmgooOol00goo00=NmgooOol027oo00=NmgooOol02goo00<007ooOol0>Goo000iOol00`00
Oomoo`0FOol00ekgOomoo`0LOol00ekgOomoo`04Ool00ekgOomoo`0HOol00ekgOomoo`0:Ool00ekg
Oomoo`0DOol00ekgOomoo`09Ool01EkgOomoogooG_L03Goo00=NmgooOol02goo00=NmgooOol00Woo
00=NmgooOol02Goo00=NmgooOol02goo00<007ooOol0>Goo000iOol00`00Oomoo`0FOol00ekgOomo
o`0MOol00ekgOomoo`03Ool00ekgOomoo`0HOol00ekgOomoo`09Ool00ekgOomoo`0DOol00ekgOomo
o`0;Ool015kgOomooekg3Goo00=NmgooOol02goo00ENmgooOomooekg00aoo`03G_Moogoo00]oo`03
001oogoo03Uoo`00>Goo00<007ooOol05Woo00=NmgooOol07Goo00=NmgooOol00Woo00=NmgooOol0
6Woo00=NmgooOol027oo00=NmgooOol057oo00=NmgooOol037oo0ekg3Goo00=NmgooOol02goo00AN
mgooG_MNm`ioo`03G_Moogoo00Yoo`03001oogoo03Uoo`00>Goo00<007ooOol05Woo00=NmgooOol0
7Goo00ENmgooOomooekg01eoo`03G_Moogoo00Moo`03G_Moogoo01Eoo`03G_Moogoo00ioo`03G_Mo
ogoo00]oo`03G_Moogoo00]oo`9Nma1oo`03G_Moogoo00Yoo`03001oogoo03Uoo`00>Goo00<007oo
Ool05goo00=NmgooOol077oo00ANmgooOomNmaioo`03G_Moogoo00Moo`03G_Moogoo01Eoo`03G_Mo
ogoo00ioo`=Nm`]oo`03G_Moogoo00Uoo`=Nma5oo`03G_Moogoo00Yoo`03001oogoo03Uoo`00>Goo
00<007ooOol05goo00=NmgooOol07Goo00=NmgooG_L07goo00=NmgooOol01Woo00=NmgooOol057oo
00=NmgooOol03goo00=NmgooOol00Ukg2Goo00=NmgooOol01goo0Ukg0Woo00=NmgooOol03goo00=N
mgooOol02Woo00<007ooOol0>Goo000dOol30002Ool00`00Oomoo`0GOol00ekgOomoo`0MOol2G_LP
Ool00ekgOomoo`05Ool00ekgOomoo`0EOol00ekgOomoo`0>Ool00ekgOomoo`03Ool2G_L7Ool00ekg
Oomoo`05Ool2G_L5Ool00ekgOomoo`0?Ool00ekgOomoo`09Ool00`00Oomoo`0iOol003Eoo`05001o
ogooOol0000IOol00ekgOomoo`0MOol00ekgOomoo`0OOol00ekgOomoo`05Ool00ekgOomoo`0EOol0
0ekgOomoo`0>Ool00ekgOomoo`05Ool3G_L4Ool00ekgOomoo`03Ool2G_L7Ool00ekgOomoo`0?Ool0
0ekgOomoo`09Ool00`00Oomoo`0iOol0039oo`D0009oo`<001Moo`03G_Moogoo01eoo`03G_Moogoo
021oo`03G_Moogoo00=oo`03G_Moogoo01Ioo`03G_Moogoo00ioo`03G_Moogoo00Qoo`YNm`Uoo`03
G_Moogoo00moo`03G_Moogoo00Moo`<003]oo`00<Woo00@007ooOol000=oo`03001oogoo01Qoo`03
G_Moogoo01]oo`03G_Mooekg025oo`03G_Moogoo00=oo`03G_Moogoo01Ioo`03G_Moogoo00ioo`03
G_Moogoo00aoo`03G_Moogoo00aoo`03G_Moogoo00moo`03G_Moogoo00Uoo`03001oogoo03Uoo`00
<goo00<007oo00000goo00<007ooOol067oo00=NmgooOol06Woo00ANmgooOomNmb5oo`03G_Moogoo
00=oo`03G_Moogoo01Eoo`03G_Moogoo00moo`03G_Moogoo00aoo`03G_Moogoo00aoo`03G_Moogoo
011oo`03G_Moogoo00Qoo`03001oogoo03Uoo`00=7oo0P000goo00<007ooOol067oo00=NmgooOol0
6Woo00ANmgooOomNmb9oo`05G_MoogooOomNm`0HOol00ekgOomoo`0?Ool00ekgOomoo`0<Ool00ekg
Oomoo`0<Ool00ekgOomoo`0@Ool00ekgOomoo`08Ool00`00Oomoo`0iOol003Uoo`03001oogoo01Qo
o`03G_Moogoo01Uoo`05G_MoogooOomNm`0ROol01EkgOomoogooG_L067oo00=NmgooOol03goo00=N
mgooOol037oo00=NmgooOol037oo00=NmgooOol047oo00=NmgooOol027oo00<007ooOol0>Goo000i
Ool00`00Oomoo`0HOol00ekgOomoo`0HOol00ekgOomoo`03Ool00ekgOomoo`0OOol015kgOomooekg
6Goo00=NmgooOol03goo00=NmgooOol037oo00=NmgooOol037oo00=NmgooOol047oo00=NmgooOol0
27oo00<007ooOol0>Goo000iOol00`00Oomoo`0IOol00ekgOomoo`0FOol00ekgOomoo`04Ool00ekg
Oomoo`0POol00ekgOomNm`0HOol00ekgOomoo`0@Ool00ekgOomoo`0<Ool00ekgOomoo`0<Ool00ekg
Oomoo`0@Ool00ekgOomoo`08Ool00`00Oomoo`0iOol003Uoo`03001oogoo01Uoo`03G_Moogoo01Io
o`03G_Moogoo00Aoo`03G_Moogoo021oo`03G_Mooekg01Qoo`03G_Moogoo00moo`03G_Moogoo00eo
o`03G_Moogoo00eoo`03G_Moogoo011oo`03G_Moogoo00Moo`03001oogoo03Uoo`00>Goo00<007oo
Ool06Goo00=NmgooOol05Goo00=NmgooOol01Goo00=NmgooOol08Goo00=NmgooOol05goo00=Nmgoo
Ool03goo00=NmgooOol03Goo00=NmgooOol03Goo00=NmgooOol047oo00=NmgooOol01goo00<007oo
Ool0>Goo000iOol00`00Oomoo`0IOol00ekgOomoo`0DOol00ekgOomoo`07Ool00ekgOomoo`0POol0
0ekgOomoo`0GOol00ekgOomoo`0?Ool00ekgOomoo`0=Ool00ekgOomoo`0=Ool00ekgOomoo`0@Ool0
0ekgOomoo`07Ool00`00Oomoo`0iOol003Uoo`03001oogoo01Yoo`03G_Moogoo01=oo`03G_Moogoo
00Moo`03G_Moogoo01moo`03G_Mooekg01Qoo`03G_Moogoo00moo`03G_Moogoo00eoo`03G_Moogoo
00eoo`03G_Moogoo011oo`03G_Moogoo00Moo`03001oogoo03Uoo`00>Goo00<007ooOol06Woo00=N
mgooOol04Woo00=NmgooOol027oo00=NmgooOol07goo00=NmgooG_L05goo00=NmgooOol047oo00=N
mgooOol03Goo00=NmgooOol03Goo00=NmgooOol04Goo00=NmgooOol01Woo00<007ooOol0>Goo000i
Ool00`00Oomoo`0JOol00ekgOomoo`0AOol00ekgOomoo`0:Ool00ekgOomoo`0NOol015kgOomooekg
5Woo00=NmgooOol047oo00=NmgooOol03Goo00=NmgooOol03Goo00=NmgooOol04Goo00=NmgooOol0
1Woo00<007ooOol0>Goo000iOol00`00Oomoo`0JOol00ekgOomoo`0AOol00ekgOomoo`0:Ool00ekg
Oomoo`0MOol01EkgOomoogooG_L05Woo00=NmgooOol047oo00=NmgooOol03Goo00=NmgooOol03Goo
00=NmgooOol04Goo00=NmgooOol01Woo00<007ooOol0>Goo000iOol00`00Oomoo`0JOol00ekgOomo
o`0@Ool00ekgOomoo`0;Ool00ekgOomoo`0MOol00ekgOomoo`02Ool00ekgOomoo`0COol00ekgOomo
o`0@Ool00ekgOomoo`0=Ool00ekgOomoo`0=Ool00ekgOomoo`0AOol00ekgOomoo`06Ool00`00Oomo
o`0iOol003Uoo`03001oogoo01]oo`03G_Moogoo00ioo`03G_Moogoo00aoo`03G_Moogoo01aoo`03
G_Moogoo00=oo`03G_Moogoo019oo`03G_Moogoo015oo`03G_Moogoo00eoo`03G_Moogoo00eoo`03
G_Moogoo019oo`03G_Moogoo00Eoo`03001oogoo03Uoo`00>Goo00<007ooOol06goo00=NmgooOol0
3Goo00=NmgooOol03Woo00=NmgooOol06goo00=NmgooOol017oo00=NmgooOol04Goo00=NmgooOol0
4Goo00=NmgooOol03Goo00=NmgooOol03Goo00=NmgooOol04Woo00=NmgooOol01Goo00<007ooOol0
>Goo000iOol00`00Oomoo`0KOol00ekgOomoo`0=Ool00ekgOomoo`0>Ool00ekgOomoo`0KOol00ekg
Oomoo`04Ool00ekgOomoo`0AOol00ekgOomoo`0@Ool00ekgOomoo`0>Ool00ekgOomoo`0>Ool00ekg
Oomoo`0AOol00ekgOomoo`05Ool00`00Oomoo`0iOol003Uoo`8001aoo`03G_Moogoo00aoo`03G_Mo
ogoo00moo`03G_Moogoo01Yoo`03G_Moogoo00Ioo`03G_Moogoo011oo`03G_Moogoo011oo`03G_Mo
ogoo00ioo`03G_Moogoo00ioo`03G_Moogoo015oo`03G_Moogoo00Aoo`8003]oo`00>Goo00<007oo
Ool077oo00=NmgooOol02Woo00=NmgooOol047oo00=NmgooOol06Woo00=NmgooOol01Woo00=Nmgoo
Ool03goo00=NmgooOol04Goo00=NmgooOol03Woo00=NmgooOol03Woo00=NmgooOol04Woo00=Nmgoo
Ool017oo00<007ooOol0>Goo000iOol00`00Oomoo`04Ool00`00Oomoo`05Ool00`00Oomoo`04Ool0
0`00Oomoo`04Ool00`00OomNm`04Ool00`00Oomoo`04Ool00`00G_Moo`04Ool00`00Oomoo`04Ool0
0`00Oomoo`04Ool00ekgOomoo`04Ool00`00Oomoo`04Ool00`00Oomoo`04Ool00`00Oomoo`03Ool0
0ekg001oo`05Ool01000Oomooekg17oo00<007ooOol017oo00<007ooOol00Woo00=Nmgoo00001Woo
00<007ooOol017oo00D007ooOomooekg009oo`03001oogoo00Aoo`03001oogoo00Aoo`03G_Moogoo
00Aoo`03001oogoo00Aoo`04001oogooG_L3Ool00`00Oomoo`04Ool00`00Oomoo`04Ool01000Oomo
oekg17oo00<007oo0000>goo000iOolO00000ekg0000000900000ekg0000000B00000ekg0000000H
00000ekg0000000800000ekg0000000>00000ekg0000000A00000ekg0000000>00000ekg0000000>
00000ekg0000000B00000ekg00000005000kOol00?moocmoo`00ogoo?goo003oOoloOol00?moocmo
o`00ogoo?goo003oOoloOol00?moocmoo`00ogoo?goo003oOoloOol00?moocmoo`00ogoo?goo003o
OoloOol00?moocmoo`00ogoo?goo003oOoloOol00?moocmoo`00H7oo00<007ooOol067oo00<007oo
Ool027oo00<007ooOol0;Goo00<007ooOol02Goo00<007ooOol0=Woo00<007ooOol0@7oo001OOol0
0`00Oomoo`0<Ool00`00Oomoo`0;Ool00`00Oomoo`06Ool00`00Oomoo`0AOol00`00Oomoo`0>Ool0
0`00Oomoo`0:Ool00`00Oomoo`07Ool00`00Oomoo`0AOol00`00Oomoo`0FOol00`00Oomoo`0;Ool0
0`00Oomoo`0oOol005ioo`03001oogoo009oo`<000Qoo`03001oogoo00Aoo`8000Ioo`03001oogoo
00Aoo`03001oogoo009oo`<000eoo`03001oogoo00=oo`<000Qoo`03001oogoo00=oo`D000=oo`03
001oogoo00Eoo`03001oogoo009oo`<000eoo`03001oogoo00=oo`@000Eoo`<000Moo`03001oogoo
00Aoo`@000Aoo`03001oogoo03ioo`00GWoo00<007ooOol017oo0P001Goo1@000goo00@007ooOol0
00Eoo`03001oogoo00Aoo`03001oogoo00Aoo`8000Yoo`D000Eoo`8000Eoo`D000Eoo`03001oogoo
00=oo`03001oogoo00Eoo`03001oogoo00Aoo`8000Yoo`D000=oo`03001oogoo00Qoo`8000Aoo`D0
00Aoo`03001oogoo00Eoo`03001oogoo03ioo`00GWoo00<007ooOol00goo00<007ooOol01goo00<0
07ooOol01Woo00<007ooOol00goo00<007ooOol017oo00<007ooOol00goo00<007ooOol037oo00<0
07ooOol017oo00<007ooOol01goo00<007ooOol01Goo00<007ooOol00goo00<007ooOol01Goo00<0
07ooOol00goo00<007ooOol037oo00<007ooOol017oo00<007ooOol01Woo00<007ooOol01Woo00<0
07ooOol01Goo00<007ooOol017oo00<007ooOol0?Woo001NOol00`00Oomoo`03Ool30007Ool00`00
Oomoo`04Ool20006Ool00`00Oomoo`04Ool00`00Oomoo`03Ool30002Ool20008Ool00`00Oomoo`04
Ool30007Ool00`00Oomoo`05Ool00`00Oomoo`03Ool00`00Oomoo`05Ool00`00Oomoo`03Ool30002
Ool20008Ool00`00Oomoo`05Ool00`00Oomoo`05Ool30006Ool00`00Oomoo`06Ool00`00Oomoo`03
Ool00`00Oomoo`0nOol005moo`03001oogoo01=oo`03001oogoo00Aoo`03001oogoo00Ioo`03001o
ogoo00Moo`03001oogoo021oo`03001oogoo009oo`03001oogoo00Moo`03001oogoo00Moo`03001o
ogoo00eoo`04001oogoo000FOol01000Oomoo`000goo00<007ooOol0?goo0011Ool20008Ool2000C
Ool00`00Oomoo`0BOol30003Ool00`00Oomoo`08Ool00`00Oomoo`07Ool00`00Oomoo`0NOol20003
Ool00`00Oomoo`09Ool00`00Oomoo`07Ool00`00Oomoo`0=Ool2000HOol20003Ool00`00Oomoo`10
Ool0045oo`03001oogoo00Qoo`03001oogoo041oo`8003Yoo`80075oo`00>Woo0P001Goo00@007oo
Oomoo`<000Aoo`03001oogoo009oo`@00>Uoo`00>Goo00@007ooOol000Aoo`03001oogoo00Aoo`05
001oogooOol0000>Oom00008Oom00008Ool@0002Ool4000mOol003Uoo`03001oo`00008000=oo`04
001oogooOol30004Ool00`00Oomoo`02Ool4003YOol003Uoo`03001oogoo00Eoo`04001oogooOol4
0003Ool00`00Oomoo`3_Ool003Uoo`03001oogoo00Eoo`03001oogoo00Qoo`03001oogoo03]oo`03
001oogoo01Qoo`03001oogoo00Qoo`03001oogoo01ioo`03001oogoo06Yoo`00>Woo0`0017oo0P00
27oo0P00?7oo00<007ooOol037oo00<007ooOol02goo00<007ooOol01Woo00<007ooOol037oo00<0
07ooOol04Goo00<007ooOol0JGoo0028Ool00`00Oomoo`02Ool30008Ool00`00Oomoo`06Ool30003
Ool00`00Oomoo`04Ool00`00Oomoo`02Ool30008Ool00`00Oomoo`04Ool50002Ool20005Ool00`00
Oomoo`1XOol008Qoo`03001oogoo00Aoo`8000Eoo`D000Moo`03001oogoo009oo`03001oogoo00Ao
o`03001oogoo00Aoo`8000Eoo`D000Ioo`05001oogooOol00002Ool00`00Oomoo`02Ool00`00Oomo
o`1XOol008Qoo`03001oogoo00=oo`03001oogoo00Moo`03001oogoo00Aoo`D000=oo`03001oogoo
00Aoo`03001oogoo00=oo`03001oogoo00Moo`03001oogoo00Ioo`05001oogooOol00002Ool00`00
Oomoo`02Ool00`00Oomoo`1XOol008Qoo`03001oogoo00=oo`<000Moo`03001oogoo00Aoo`04001o
ogoo0004Ool00`00Oomoo`04Ool00`00Oomoo`03Ool30007Ool00`00Oomoo`06Ool01@00Oomoogoo
00000Woo00<007ooOol00Woo00<007ooOol0J7oo0029Ool00`00Oomoo`0DOol00`00Ool00003Ool0
0`00Oomoo`06Ool00`00Oomoo`0EOol01@00Oomoogoo00000Woo00D007ooOomoo`0006]oo`00RWoo
00<007ooOol057oo0P000Woo00<007ooOol027oo00<007ooOol04goo0P0017oo0P000goo00<007oo
Ool0JWoo003oOoloOol00?moocmoo`00ogoo?goo003oOoloOol00?moocmoo`00ogoo?goo003oOolo
Ool00?moocmoo`00ogoo?goo003oOoloOol00?moocmoo`00ogoo?goo003oOoloOol00?moocmoo`00
ogoo?goo003oOoloOol00?moocmoo`00ogoo?goo003oOoloOol00?moocmoo`00ogoo?goo003oOolo
Ool00?moocmoo`00ogoo?goo003oOoloOol00?moocmoo`00ogoo?goo003oOoloOol00?moocmoo`00
ogoo?goo003oOoloOol00001\
\>"],
  ImageRangeCache->{{{0, 317.188}, {447.75, 0}} -> {-0.653492, -1.05092, \
0.00469423, 0.00469423}, {{7.5, 270.813}, {436.875, 10.8125}} -> {-15.0897, \
-6.15831, 0.0706569, 0.0283588}, {{288.313, 309.625}, {330.375, 223.875}} -> \
{-27.6339, -44.1493, 0.0957756, 0.375967}},
  CellTags->{"Root Locus", "i:11", "b:20.3"}],

Cell[BoxData[
    TagBox[\(\[SkeletonIndicator]  Graphics  \[SkeletonIndicator]\),
      False,
      Editable->False]], "Output",
  CellLabel->"Out[136]=",
  CellTags->{"Root Locus", "i:11", "b:20.3"}],

Cell[BoxData[
    \(\(\(\ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \)\(Zeros\ in\ green, \
\ Open\ loop\ poles\ in\ red\)\)\)], "Print",
  GeneratedCell->False,
  CellAutoOverwrite->False,
  CellTags->{"Root Locus", "i:11", "b:20.3"}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: 1.4104 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.438894 0.671621 0.705202 0.671621 [
[ 0 0 0 0 ]
[ 1 1.4104 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
% Start of sub-graphic
p
0.0238095 0.033581 0.853978 1.37682 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.777239 0.0706581 0.809017 0.176047 [
[.07066 -0.0125 -9 -9 ]
[.07066 -0.0125 9 0 ]
[.21197 -0.0125 -6 -9 ]
[.21197 -0.0125 6 0 ]
[.35329 -0.0125 -6 -9 ]
[.35329 -0.0125 6 0 ]
[.49461 -0.0125 -6 -9 ]
[.49461 -0.0125 6 0 ]
[.63592 -0.0125 -6 -9 ]
[.63592 -0.0125 6 0 ]
[.77724 -0.0125 -3 -9 ]
[.77724 -0.0125 3 0 ]
[.91856 -0.0125 -3 -9 ]
[.91856 -0.0125 3 0 ]
[ 0 0 -0.125 0 ]
[.5 -0.0125 -17 -21.875 ]
[.5 -0.0125 17 -9 ]
[-0.0125 .10483 -12 -4.5 ]
[-0.0125 .10483 0 4.5 ]
[-0.0125 .45692 -12 -4.5 ]
[-0.0125 .45692 0 4.5 ]
[-0.0125 .80902 -6 -4.5 ]
[-0.0125 .80902 0 4.5 ]
[-0.0125 1.16111 -6 -4.5 ]
[-0.0125 1.16111 0 4.5 ]
[-0.0125 1.5132 -6 -4.5 ]
[-0.0125 1.5132 0 4.5 ]
[ 0 0 -0.125 0 ]
[-0.01875 .80902 -46.25 -6.4375 ]
[-0.01875 .80902 -12 6.4375 ]
[ 0 1.61803 .125 0 ]
[.5 1.63053 -5 0 ]
[.5 1.63053 5 12.875 ]
[ 1 0 .125 0 ]
[1.0125 .80902 0 -6.4375 ]
[1.0125 .80902 10 6.4375 ]
[.5 1.63053 -101.781 12.875 ]
[.5 1.63053 101.781 35.4375 ]
[ 0 0 0 0 ]
[ 1 1.61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
.07066 0 m
.07066 .00625 L
s
[(-10)] .07066 -0.0125 0 1 Mshowa
.21197 0 m
.21197 .00625 L
s
[(-8)] .21197 -0.0125 0 1 Mshowa
.35329 0 m
.35329 .00625 L
s
[(-6)] .35329 -0.0125 0 1 Mshowa
.49461 0 m
.49461 .00625 L
s
[(-4)] .49461 -0.0125 0 1 Mshowa
.63592 0 m
.63592 .00625 L
s
[(-2)] .63592 -0.0125 0 1 Mshowa
.77724 0 m
.77724 .00625 L
s
[(0)] .77724 -0.0125 0 1 Mshowa
.91856 0 m
.91856 .00625 L
s
[(2)] .91856 -0.0125 0 1 Mshowa
.125 Mabswid
.10599 0 m
.10599 .00375 L
s
.14132 0 m
.14132 .00375 L
s
.17665 0 m
.17665 .00375 L
s
.2473 0 m
.2473 .00375 L
s
.28263 0 m
.28263 .00375 L
s
.31796 0 m
.31796 .00375 L
s
.38862 0 m
.38862 .00375 L
s
.42395 0 m
.42395 .00375 L
s
.45928 0 m
.45928 .00375 L
s
.52994 0 m
.52994 .00375 L
s
.56526 0 m
.56526 .00375 L
s
.60059 0 m
.60059 .00375 L
s
.67125 0 m
.67125 .00375 L
s
.70658 0 m
.70658 .00375 L
s
.74191 0 m
.74191 .00375 L
s
.81257 0 m
.81257 .00375 L
s
.8479 0 m
.8479 .00375 L
s
.88323 0 m
.88323 .00375 L
s
.03533 0 m
.03533 .00375 L
s
.95388 0 m
.95388 .00375 L
s
.98921 0 m
.98921 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
gsave
.5 -0.0125 -78 -25.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20.875 translate 1 -1 scale
gsave
0.000000 0.000000 0.000000 setrgbcolor
1.000000 setlinewidth
gsave
newpath
 61.000000 16.875000 moveto
 460.000000 16.875000 lineto
 460.000000 4.000000 lineto
 61.000000 4.000000 lineto
 61.000000 16.875000 lineto
closepath
clip newpath
63.000000 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
0.000000 0.000000 rmoveto
63.000000 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(Re) show
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
75.000000 13.000000 moveto
(@) show
81.000000 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(s) show
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
87.000000 13.000000 moveto
(D) show
93.000000 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
0.000000 0.000000 rmoveto
1.000000 setlinewidth
grestore
grestore
%%DocumentNeededResources: font Math2Mono
%%+ font Courier
%%DocumentSuppliedResources:
%%DocumentNeededFonts: Math2Mono
%%+ Courier
%%DocumentSuppliedFonts:
%%DocumentFonts: font Math2Mono
%%+ font Courier
grestore
0 .10483 m
.00625 .10483 L
s
[(-4)] -0.0125 .10483 1 0 Mshowa
0 .45692 m
.00625 .45692 L
s
[(-2)] -0.0125 .45692 1 0 Mshowa
0 .80902 m
.00625 .80902 L
s
[(0)] -0.0125 .80902 1 0 Mshowa
0 1.16111 m
.00625 1.16111 L
s
[(2)] -0.0125 1.16111 1 0 Mshowa
0 1.5132 m
.00625 1.5132 L
s
[(4)] -0.0125 1.5132 1 0 Mshowa
.125 Mabswid
0 .19285 m
.00375 .19285 L
s
0 .28088 m
.00375 .28088 L
s
0 .3689 m
.00375 .3689 L
s
0 .54495 m
.00375 .54495 L
s
0 .63297 m
.00375 .63297 L
s
0 .72099 m
.00375 .72099 L
s
0 .89704 m
.00375 .89704 L
s
0 .98506 m
.00375 .98506 L
s
0 1.07309 m
.00375 1.07309 L
s
0 1.24913 m
.00375 1.24913 L
s
0 1.33716 m
.00375 1.33716 L
s
0 1.42518 m
.00375 1.42518 L
s
0 .01681 m
.00375 .01681 L
s
0 1.60123 m
.00375 1.60123 L
s
.25 Mabswid
0 0 m
0 1.61803 L
s
gsave
-0.01875 .80902 -107.25 -10.4375 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20.875 translate 1 -1 scale
gsave
0.000000 0.000000 0.000000 setrgbcolor
1.000000 setlinewidth
gsave
newpath
 61.000000 16.875000 moveto
 460.000000 16.875000 lineto
 460.000000 4.000000 lineto
 61.000000 4.000000 lineto
 61.000000 16.875000 lineto
closepath
clip newpath
63.000000 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
0.000000 0.000000 rmoveto
63.000000 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(Im) show
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
75.250000 13.000000 moveto
(@) show
81.250000 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(s) show
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
87.250000 13.000000 moveto
(D) show
93.250000 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
0.000000 0.000000 rmoveto
1.000000 setlinewidth
grestore
grestore
%%DocumentNeededResources: font Math2Mono
%%+ font Courier
%%DocumentSuppliedResources:
%%DocumentNeededFonts: Math2Mono
%%+ Courier
%%DocumentSuppliedFonts:
%%DocumentFonts: font Math2Mono
%%+ font Courier
grestore
.07066 1.61178 m
.07066 1.61803 L
s
.21197 1.61178 m
.21197 1.61803 L
s
.35329 1.61178 m
.35329 1.61803 L
s
.49461 1.61178 m
.49461 1.61803 L
s
.63592 1.61178 m
.63592 1.61803 L
s
.77724 1.61178 m
.77724 1.61803 L
s
.91856 1.61178 m
.91856 1.61803 L
s
.125 Mabswid
.10599 1.61428 m
.10599 1.61803 L
s
.14132 1.61428 m
.14132 1.61803 L
s
.17665 1.61428 m
.17665 1.61803 L
s
.2473 1.61428 m
.2473 1.61803 L
s
.28263 1.61428 m
.28263 1.61803 L
s
.31796 1.61428 m
.31796 1.61803 L
s
.38862 1.61428 m
.38862 1.61803 L
s
.42395 1.61428 m
.42395 1.61803 L
s
.45928 1.61428 m
.45928 1.61803 L
s
.52994 1.61428 m
.52994 1.61803 L
s
.56526 1.61428 m
.56526 1.61803 L
s
.60059 1.61428 m
.60059 1.61803 L
s
.67125 1.61428 m
.67125 1.61803 L
s
.70658 1.61428 m
.70658 1.61803 L
s
.74191 1.61428 m
.74191 1.61803 L
s
.81257 1.61428 m
.81257 1.61803 L
s
.8479 1.61428 m
.8479 1.61803 L
s
.88323 1.61428 m
.88323 1.61803 L
s
.03533 1.61428 m
.03533 1.61803 L
s
.95388 1.61428 m
.95388 1.61803 L
s
.98921 1.61428 m
.98921 1.61803 L
s
.25 Mabswid
0 1.61803 m
1 1.61803 L
s
gsave
.5 1.63053 -66 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20.875 translate 1 -1 scale
gsave
0.000000 0.000000 0.000000 setrgbcolor
1.000000 setlinewidth
gsave
newpath
 61.000000 16.875000 moveto
 460.000000 16.875000 lineto
 460.000000 4.000000 lineto
 61.000000 4.000000 lineto
 61.000000 16.875000 lineto
closepath
clip newpath
63.000000 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
0.000000 0.000000 rmoveto
69.000000 13.000000 moveto
0.000000 0.000000 rmoveto
1.000000 setlinewidth
grestore
grestore
%%DocumentNeededResources: font Courier
%%DocumentSuppliedResources:
%%DocumentNeededFonts: Courier
%%DocumentSuppliedFonts:
%%DocumentFonts: font Courier
grestore
.99375 .10483 m
1 .10483 L
s
.99375 .45692 m
1 .45692 L
s
.99375 .80902 m
1 .80902 L
s
.99375 1.16111 m
1 1.16111 L
s
.99375 1.5132 m
1 1.5132 L
s
.125 Mabswid
.99625 .19285 m
1 .19285 L
s
.99625 .28088 m
1 .28088 L
s
.99625 .3689 m
1 .3689 L
s
.99625 .54495 m
1 .54495 L
s
.99625 .63297 m
1 .63297 L
s
.99625 .72099 m
1 .72099 L
s
.99625 .89704 m
1 .89704 L
s
.99625 .98506 m
1 .98506 L
s
.99625 1.07309 m
1 1.07309 L
s
.99625 1.24913 m
1 1.24913 L
s
.99625 1.33716 m
1 1.33716 L
s
.99625 1.42518 m
1 1.42518 L
s
.99625 .01681 m
1 .01681 L
s
.99625 1.60123 m
1 1.60123 L
s
.25 Mabswid
1 0 m
1 1.61803 L
s
gsave
1.0125 .80902 -61 -10.4375 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20.875 translate 1 -1 scale
gsave
0.000000 0.000000 0.000000 setrgbcolor
1.000000 setlinewidth
gsave
newpath
 61.000000 16.875000 moveto
 460.000000 16.875000 lineto
 460.000000 4.000000 lineto
 61.000000 4.000000 lineto
 61.000000 16.875000 lineto
closepath
clip newpath
63.000000 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
0.000000 0.000000 rmoveto
69.000000 13.000000 moveto
0.000000 0.000000 rmoveto
1.000000 setlinewidth
grestore
grestore
%%DocumentNeededResources: font Courier
%%DocumentSuppliedResources:
%%DocumentNeededFonts: Courier
%%DocumentSuppliedFonts:
%%DocumentFonts: font Courier
grestore
gsave
.5 1.63053 -162.781 8.875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 30.5625 translate 1 -1 scale
gsave
0.000000 0.000000 0.000000 setrgbcolor
1.000000 setlinewidth
gsave
newpath
 61.000000 26.562500 moveto
 460.000000 26.562500 lineto
 460.000000 4.000000 lineto
 61.000000 4.000000 lineto
 61.000000 26.562500 lineto
closepath
clip newpath
63.000000 17.312500 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
0.000000 0.000000 rmoveto
63.000000 17.312500 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(G) show
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
69.000000 17.312500 moveto
(@) show
75.000000 17.312500 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(s) show
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
81.000000 17.312500 moveto
(D) show
87.000000 17.312500 moveto
%%IncludeResource: font Math1Mono
%%IncludeFont: Math1Mono
/Math1Mono findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(=) show
93.000000 17.312500 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
0.000000 0.000000 rmoveto
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
140.000000 11.250000 moveto
(H) show
146.000000 11.250000 moveto
%%IncludeResource: font Courier-Italic
%%IncludeFont: Courier-Italic
/Courier-Italic findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(s) show
154.375000 11.250000 moveto
%%IncludeResource: font Math1Mono
%%IncludeFont: Math1Mono
/Math1Mono findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(+) show
162.750000 11.250000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(4) show
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
168.750000 11.250000 moveto
(L) show
177.375000 11.250000 moveto
(H) show
183.375000 11.250000 moveto
%%IncludeResource: font Courier-Italic
%%IncludeFont: Courier-Italic
/Courier-Italic findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(s) show
191.750000 11.250000 moveto
%%IncludeResource: font Math1Mono
%%IncludeFont: Math1Mono
/Math1Mono findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(+) show
200.125000 11.250000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(10) show
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
212.125000 11.250000 moveto
(L) show
%%IncludeResource: font Math1Mono
%%IncludeFont: Math1Mono
/Math1Mono findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
97.375000 17.312500 moveto
(\\200) show
99.250000 17.312500 moveto
(\\200) show
101.125000 17.312500 moveto
(\\200) show
103.000000 17.312500 moveto
(\\200) show
104.875000 17.312500 moveto
(\\200) show
106.750000 17.312500 moveto
(\\200) show
108.625000 17.312500 moveto
(\\200) show
110.500000 17.312500 moveto
(\\200) show
112.375000 17.312500 moveto
(\\200) show
114.250000 17.312500 moveto
(\\200) show
116.125000 17.312500 moveto
(\\200) show
118.000000 17.312500 moveto
(\\200) show
119.875000 17.312500 moveto
(\\200) show
121.750000 17.312500 moveto
(\\200) show
123.625000 17.312500 moveto
(\\200) show
125.500000 17.312500 moveto
(\\200) show
127.375000 17.312500 moveto
(\\200) show
129.250000 17.312500 moveto
(\\200) show
131.125000 17.312500 moveto
(\\200) show
133.000000 17.312500 moveto
(\\200) show
134.875000 17.312500 moveto
(\\200) show
136.750000 17.312500 moveto
(\\200) show
138.625000 17.312500 moveto
(\\200) show
140.500000 17.312500 moveto
(\\200) show
142.375000 17.312500 moveto
(\\200) show
144.250000 17.312500 moveto
(\\200) show
146.125000 17.312500 moveto
(\\200) show
148.000000 17.312500 moveto
(\\200) show
149.875000 17.312500 moveto
(\\200) show
151.750000 17.312500 moveto
(\\200) show
153.625000 17.312500 moveto
(\\200) show
155.500000 17.312500 moveto
(\\200) show
157.375000 17.312500 moveto
(\\200) show
159.250000 17.312500 moveto
(\\200) show
161.125000 17.312500 moveto
(\\200) show
163.000000 17.312500 moveto
(\\200) show
164.875000 17.312500 moveto
(\\200) show
166.750000 17.312500 moveto
(\\200) show
168.625000 17.312500 moveto
(\\200) show
170.500000 17.312500 moveto
(\\200) show
172.375000 17.312500 moveto
(\\200) show
174.250000 17.312500 moveto
(\\200) show
176.125000 17.312500 moveto
(\\200) show
178.000000 17.312500 moveto
(\\200) show
179.875000 17.312500 moveto
(\\200) show
181.750000 17.312500 moveto
(\\200) show
183.625000 17.312500 moveto
(\\200) show
185.500000 17.312500 moveto
(\\200) show
187.375000 17.312500 moveto
(\\200) show
189.250000 17.312500 moveto
(\\200) show
191.125000 17.312500 moveto
(\\200) show
193.000000 17.312500 moveto
(\\200) show
194.875000 17.312500 moveto
(\\200) show
196.750000 17.312500 moveto
(\\200) show
198.625000 17.312500 moveto
(\\200) show
200.500000 17.312500 moveto
(\\200) show
202.375000 17.312500 moveto
(\\200) show
204.250000 17.312500 moveto
(\\200) show
206.125000 17.312500 moveto
(\\200) show
208.000000 17.312500 moveto
(\\200) show
209.875000 17.312500 moveto
(\\200) show
211.750000 17.312500 moveto
(\\200) show
213.625000 17.312500 moveto
(\\200) show
215.500000 17.312500 moveto
(\\200) show
217.375000 17.312500 moveto
(\\200) show
219.250000 17.312500 moveto
(\\200) show
221.125000 17.312500 moveto
(\\200) show
223.000000 17.312500 moveto
(\\200) show
224.875000 17.312500 moveto
(\\200) show
226.750000 17.312500 moveto
(\\200) show
228.625000 17.312500 moveto
(\\200) show
230.500000 17.312500 moveto
(\\200) show
232.375000 17.312500 moveto
(\\200) show
234.250000 17.312500 moveto
(\\200) show
236.125000 17.312500 moveto
(\\200) show
238.000000 17.312500 moveto
(\\200) show
239.875000 17.312500 moveto
(\\200) show
241.750000 17.312500 moveto
(\\200) show
243.625000 17.312500 moveto
(\\200) show
245.500000 17.312500 moveto
(\\200) show
247.375000 17.312500 moveto
(\\200) show
249.250000 17.312500 moveto
(\\200) show
251.125000 17.312500 moveto
(\\200) show
253.000000 17.312500 moveto
(\\200) show
254.875000 17.312500 moveto
(\\200) show
256.750000 17.312500 moveto
(\\200) show
258.625000 17.312500 moveto
(\\200) show
258.937500 17.312500 moveto
(\\200) show
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
98.687500 23.625000 moveto
(H) show
104.687500 23.625000 moveto
%%IncludeResource: font Courier-Italic
%%IncludeFont: Courier-Italic
/Courier-Italic findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(s) show
113.062500 23.625000 moveto
%%IncludeResource: font Math1Mono
%%IncludeFont: Math1Mono
/Math1Mono findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(+) show
121.437500 23.625000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(5) show
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
127.437500 23.625000 moveto
(L) show
136.062500 23.625000 moveto
(H) show
142.062500 23.625000 moveto
%%IncludeResource: font Courier-Italic
%%IncludeFont: Courier-Italic
/Courier-Italic findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(s) show
148.062500 21.062500 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 7.125000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(2) show
155.000000 23.625000 moveto
%%IncludeResource: font Math1Mono
%%IncludeFont: Math1Mono
/Math1Mono findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(+) show
163.375000 23.625000 moveto
%%IncludeResource: font Courier-Italic
%%IncludeFont: Courier-Italic
/Courier-Italic findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(s) show
171.750000 23.625000 moveto
%%IncludeResource: font Math1Mono
%%IncludeFont: Math1Mono
/Math1Mono findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(+) show
180.125000 23.625000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(1) show
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
186.125000 23.625000 moveto
(L) show
194.750000 23.625000 moveto
(H) show
200.750000 23.625000 moveto
%%IncludeResource: font Courier-Italic
%%IncludeFont: Courier-Italic
/Courier-Italic findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(s) show
206.750000 21.062500 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 7.125000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(2) show
213.687500 23.625000 moveto
%%IncludeResource: font Math1Mono
%%IncludeFont: Math1Mono
/Math1Mono findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(+) show
222.062500 23.625000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(2) show
230.687500 23.625000 moveto
%%IncludeResource: font Courier-Italic
%%IncludeFont: Courier-Italic
/Courier-Italic findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(s) show
239.062500 23.625000 moveto
%%IncludeResource: font Math1Mono
%%IncludeFont: Math1Mono
/Math1Mono findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(+) show
247.437500 23.625000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(2) show
%%IncludeResource: font Math2Mono
%%IncludeFont: Math2Mono
/Math2Mono findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
253.437500 23.625000 moveto
(L) show
1.000000 setlinewidth
grestore
grestore
%%DocumentNeededResources: font Courier-Italic
%%+ font Math1Mono
%%+ font Math2Mono
%%+ font Courier
%%DocumentSuppliedResources:
%%DocumentNeededFonts: Courier-Italic
%%+ Math1Mono
%%+ Math2Mono
%%+ Courier
%%DocumentSuppliedFonts:
%%DocumentFonts: font Courier-Italic
%%+ font Math1Mono
%%+ font Math2Mono
%%+ font Courier
grestore
0 0 m
1 0 L
1 1.61803 L
0 1.61803 L
closepath
clip
newpath
.75 g
.5 Mabswid
.77724 .80902 m
0 0 rlineto s
.77724 .80902 m
1 .95773 L
s
.77724 .80902 m
0 0 rlineto s
.77724 .80902 m
1 1.12946 L
s
.77724 .80902 m
0 0 rlineto s
.77724 .80902 m
1 1.36403 L
s
.77724 .80902 m
0 0 rlineto s
.77724 .80902 m
.96471 1.61803 L
s
.77724 .80902 m
0 0 rlineto s
.77724 .80902 m
.86424 1.61803 L
s
.77724 .80902 m
0 0 rlineto s
.77724 .80902 m
.77724 1.61803 L
s
.77724 .80902 m
0 0 rlineto s
.77724 .80902 m
.69023 1.61803 L
s
.77724 .80902 m
0 0 rlineto s
.77724 .80902 m
.58977 1.61803 L
s
.77724 .80902 m
0 0 rlineto s
.77724 .80902 m
.45253 1.61803 L
s
.77724 .80902 m
0 0 rlineto s
.77724 .80902 m
.21483 1.61803 L
s
.77724 .80902 m
0 0 rlineto s
.77724 .80902 m
0 1.3279 L
s
.77724 .80902 m
0 0 rlineto s
.77724 .80902 m
0 .80902 L
s
.77724 .80902 m
0 0 rlineto s
.77724 .80902 m
0 .29013 L
s
.77724 .80902 m
0 0 rlineto s
.77724 .80902 m
.21483 0 L
s
.77724 .80902 m
0 0 rlineto s
.77724 .80902 m
.45253 0 L
s
.77724 .80902 m
0 0 rlineto s
.77724 .80902 m
.58977 0 L
s
.77724 .80902 m
0 0 rlineto s
.77724 .80902 m
.69023 0 L
s
.77724 .80902 m
0 0 rlineto s
.77724 .80902 m
.77724 0 L
s
.77724 .80902 m
0 0 rlineto s
.77724 .80902 m
.86424 0 L
s
.77724 .80902 m
0 0 rlineto s
.77724 .80902 m
.96471 0 L
s
.77724 .80902 m
0 0 rlineto s
.77724 .80902 m
1 .254 L
s
.77724 .80902 m
0 0 rlineto s
.77724 .80902 m
1 .48858 L
s
.77724 .80902 m
0 0 rlineto s
.77724 .80902 m
1 .6603 L
s
.77724 .80902 m
0 0 rlineto s
.77724 .80902 m
1 .80902 L
s
.91856 .80902 m
.91744 .85315 L
.91412 .89658 L
.90863 .93863 L
.90108 .97864 L
.89157 1.01597 L
.88025 1.05004 L
.86732 1.08031 L
.85296 1.1063 L
.83741 1.1276 L
.82091 1.14388 L
.80372 1.15487 L
.78611 1.16042 L
.76837 1.16042 L
.75076 1.15487 L
.73357 1.14388 L
.71707 1.1276 L
.70152 1.1063 L
.68716 1.08031 L
.67422 1.05004 L
.66291 1.01597 L
.6534 .97864 L
.64585 .93863 L
.64036 .89658 L
.63704 .85315 L
.63592 .80902 L
.63704 .76489 L
.64036 .72145 L
.64585 .6794 L
.6534 .63939 L
.66291 .60206 L
.67422 .56799 L
.68716 .53772 L
.70152 .51173 L
.71707 .49043 L
.73357 .47416 L
.75076 .46316 L
.76837 .45762 L
.78611 .45762 L
.80372 .46316 L
.82091 .47416 L
.83741 .49043 L
.85296 .51173 L
.86732 .53772 L
.88025 .56799 L
.89157 .60206 L
.90108 .63939 L
.90863 .6794 L
.91412 .72145 L
.91744 .76489 L
Mistroke
.91856 .80902 L
Mfstroke
1 1.24068 m
.98327 1.29107 L
.9574 1.3516 L
.92868 1.40358 L
.89758 1.44618 L
.86458 1.47874 L
.8302 1.50073 L
.79499 1.51181 L
.75949 1.51181 L
.72428 1.50073 L
.6899 1.47874 L
.6569 1.44618 L
.6258 1.40358 L
.59708 1.3516 L
.57121 1.29107 L
.54858 1.22293 L
.52957 1.14826 L
.51445 1.06825 L
.50349 .98414 L
.49684 .89727 L
.49461 .80902 L
.49684 .72076 L
.50349 .63389 L
.51445 .54979 L
.52957 .46977 L
.54858 .39511 L
.57121 .32697 L
.59708 .26643 L
.6258 .21445 L
.6569 .17185 L
.6899 .1393 L
.72428 .1173 L
.75949 .10622 L
.79499 .10622 L
.8302 .1173 L
.86458 .1393 L
.89758 .17185 L
.92868 .21445 L
.9574 .26643 L
.98327 .32697 L
s
.98327 .32697 m
1 .37736 L
s
.50493 1.61803 m
.46819 1.53209 L
.43426 1.42988 L
.40573 1.31788 L
.38306 1.19786 L
.36661 1.0717 L
.35663 .9414 L
.35329 .80902 L
.35663 .67663 L
.36661 .54633 L
.38306 .42017 L
.40573 .30015 L
.43426 .18815 L
.46819 .08594 L
s
.46819 .08594 m
.50493 0 L
s
.31514 1.61803 m
.28189 1.48751 L
.25167 1.32747 L
.22973 1.15927 L
.21643 .98553 L
.21197 .80902 L
.21643 .6325 L
.22973 .45877 L
.25167 .29056 L
.28189 .13053 L
s
.28189 .13053 m
.31514 0 L
s
.15067 1.61803 m
.12028 1.45709 L
.09286 1.24683 L
.07623 1.02966 L
.07066 .80902 L
.07623 .58837 L
.09286 .37121 L
.12028 .16095 L
s
.12028 .16095 m
.15067 0 L
s
.75 0 0 r
.012 w
.42395 .80902 Mdot
.70658 .63297 Mdot
.70658 .98506 Mdot
.74191 .65656 Mdot
.74191 .96148 Mdot
.75 0 .073 r
.42395 .80902 Mdot
.70643 .63304 Mdot
.70643 .98499 Mdot
.74206 .65626 Mdot
.74206 .96177 Mdot
.75 0 .146 r
.42395 .80902 Mdot
.70541 .63343 Mdot
.70541 .9846 Mdot
.74308 .65433 Mdot
.74308 .9637 Mdot
.75 0 .219 r
.42397 .80902 Mdot
.70288 .63392 Mdot
.70288 .98411 Mdot
.7456 .64983 Mdot
.7456 .9682 Mdot
.75 0 .292 r
.42399 .80902 Mdot
.69875 .63358 Mdot
.69875 .98446 Mdot
.74972 .64297 Mdot
.74972 .97507 Mdot
.75 0 .366 r
.42403 .80902 Mdot
.69346 .63165 Mdot
.69346 .98638 Mdot
.75499 .63434 Mdot
.75499 .98369 Mdot
.75 0 .439 r
.42408 .80902 Mdot
.68753 .62808 Mdot
.68753 .98996 Mdot
.7609 .6244 Mdot
.7609 .99363 Mdot
.75 0 .512 r
.42416 .80902 Mdot
.68132 .62316 Mdot
.68132 .99487 Mdot
.76707 .61345 Mdot
.76707 1.00458 Mdot
.75 0 .585 r
.42426 .80902 Mdot
.67505 .61727 Mdot
.67505 1.00076 Mdot
.77329 .60174 Mdot
.77329 1.01629 Mdot
.75 0 .658 r
.4244 .80902 Mdot
.66881 .61073 Mdot
.66881 1.00731 Mdot
.77945 .58947 Mdot
.77945 1.02856 Mdot
.75 0 .731 r
.42457 .80902 Mdot
.66267 .60378 Mdot
.66267 1.01426 Mdot
.78551 .5768 Mdot
.78551 1.04123 Mdot
.696 0 .75 r
.42477 .80902 Mdot
.65664 .59659 Mdot
.65664 1.02145 Mdot
.79144 .56384 Mdot
.79144 1.05419 Mdot
.623 0 .75 r
.42501 .80902 Mdot
.65072 .58928 Mdot
.65072 1.02875 Mdot
.79724 .55069 Mdot
.79724 1.06734 Mdot
.549 0 .75 r
.4253 .80902 Mdot
.6449 .58194 Mdot
.6449 1.03609 Mdot
.80291 .53739 Mdot
.80291 1.08064 Mdot
.476 0 .75 r
.42564 .80902 Mdot
.63918 .57463 Mdot
.63918 1.04341 Mdot
.80847 .52401 Mdot
.80847 1.09403 Mdot
.403 0 .75 r
.42603 .80902 Mdot
.63354 .56738 Mdot
.63354 1.05065 Mdot
.81391 .51055 Mdot
.81391 1.10748 Mdot
.33 0 .75 r
.42648 .80902 Mdot
.62798 .56022 Mdot
.62798 1.05781 Mdot
.81925 .49706 Mdot
.81925 1.12098 Mdot
.257 0 .75 r
.42699 .80902 Mdot
.62248 .55318 Mdot
.62248 1.06486 Mdot
.82449 .48354 Mdot
.82449 1.13449 Mdot
.184 0 .75 r
.42756 .80902 Mdot
.61705 .54625 Mdot
.61705 1.07178 Mdot
.82964 .47001 Mdot
.82964 1.14802 Mdot
.111 0 .75 r
.42819 .80902 Mdot
.61166 .53945 Mdot
.61166 1.07859 Mdot
.83471 .45648 Mdot
.83471 1.16155 Mdot
.038 0 .75 r
.4289 .80902 Mdot
.60631 .53277 Mdot
.60631 1.08526 Mdot
.83971 .44296 Mdot
.83971 1.17508 Mdot
0 .036 .75 r
.42968 .80902 Mdot
.60099 .52622 Mdot
.60099 1.09181 Mdot
.84463 .42944 Mdot
.84463 1.18859 Mdot
0 .109 .75 r
.43054 .80902 Mdot
.5957 .51979 Mdot
.5957 1.09824 Mdot
.84949 .41594 Mdot
.84949 1.2021 Mdot
0 .182 .75 r
.43149 .80902 Mdot
.59043 .51348 Mdot
.59043 1.10455 Mdot
.85429 .40245 Mdot
.85429 1.21558 Mdot
0 .255 .75 r
.43251 .80902 Mdot
.58517 .50728 Mdot
.58517 1.11076 Mdot
.85904 .38898 Mdot
.85904 1.22905 Mdot
0 .328 .75 r
.43362 .80902 Mdot
.57993 .50117 Mdot
.57993 1.11686 Mdot
.86373 .37553 Mdot
.86373 1.24251 Mdot
0 .401 .75 r
.43482 .80902 Mdot
.57469 .49515 Mdot
.57469 1.12288 Mdot
.86837 .3621 Mdot
.86837 1.25594 Mdot
0 .474 .75 r
.43611 .80902 Mdot
.56945 .48921 Mdot
.56945 1.12882 Mdot
.87296 .34868 Mdot
.87296 1.26935 Mdot
0 .548 .75 r
.43749 .80902 Mdot
.56421 .48334 Mdot
.56421 1.1347 Mdot
.87751 .33529 Mdot
.87751 1.28274 Mdot
0 .621 .75 r
.43895 .80902 Mdot
.55898 .47751 Mdot
.55898 1.14053 Mdot
.88201 .32192 Mdot
.88201 1.29612 Mdot
0 .694 .75 r
.4405 .80902 Mdot
.55373 .47172 Mdot
.55373 1.14632 Mdot
.88648 .30857 Mdot
.88648 1.30947 Mdot
0 .75 .733 r
.44214 .80902 Mdot
.54849 .46594 Mdot
.54849 1.15209 Mdot
.89091 .29523 Mdot
.89091 1.3228 Mdot
0 .75 .66 r
.44384 .80902 Mdot
.54324 .46018 Mdot
.54324 1.15786 Mdot
.8953 .28192 Mdot
.8953 1.33612 Mdot
0 .75 .587 r
.44562 .80902 Mdot
.53799 .4544 Mdot
.53799 1.16363 Mdot
.89966 .26862 Mdot
.89966 1.34941 Mdot
0 .75 .514 r
.44746 .80902 Mdot
.53275 .4486 Mdot
.53275 1.16943 Mdot
.90399 .25535 Mdot
.90399 1.36269 Mdot
0 .75 .441 r
.44934 .80902 Mdot
.52751 .44277 Mdot
.52751 1.17527 Mdot
.90828 .24209 Mdot
.90828 1.37595 Mdot
0 .75 .367 r
.45126 .80902 Mdot
.52229 .43688 Mdot
.52229 1.18115 Mdot
.91255 .22885 Mdot
.91255 1.38919 Mdot
0 .75 .294 r
.45319 .80902 Mdot
.51708 .43095 Mdot
.51708 1.18708 Mdot
.91679 .21562 Mdot
.91679 1.40241 Mdot
0 .75 .221 r
.45513 .80902 Mdot
.5119 .42496 Mdot
.5119 1.19307 Mdot
.921 .20242 Mdot
.921 1.41562 Mdot
0 .75 .148 r
.45706 .80902 Mdot
.50675 .41891 Mdot
.50675 1.19912 Mdot
.92518 .18922 Mdot
.92518 1.42881 Mdot
0 .75 .075 r
.45896 .80902 Mdot
.50164 .41281 Mdot
.50164 1.20522 Mdot
.92934 .17605 Mdot
.92934 1.44199 Mdot
0 1 0 r
.0125 w
.07066 .80902 Mdot
.49461 .80902 Mdot
1 0 0 r
.42395 .80902 Mdot
.70658 .63297 Mdot
.70658 .98506 Mdot
.74191 .65656 Mdot
.74191 .96148 Mdot
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.909028 0.369391 0.97619 0.705202 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.00980392 0.490196 0.0024975 0.124875 [
[ 0 0 0 0 ]
[ 1 5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 5 L
0 5 L
closepath
clip
newpath
.75 0 0 r
.0098 .0025 m
.0098 .12737 L
.5 .12737 L
.5 .0025 L
F
0 g
gsave
.52451 .06494 -61 -10.4375 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20.875 translate 1 -1 scale
gsave
0.000000 0.000000 0.000000 setrgbcolor
1.000000 setlinewidth
gsave
newpath
 61.000000 16.875000 moveto
 460.000000 16.875000 lineto
 460.000000 4.000000 lineto
 61.000000 4.000000 lineto
 61.000000 16.875000 lineto
closepath
clip newpath
63.000000 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
0.000000 0.000000 rmoveto
63.000000 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(0) show
69.000000 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
0.000000 0.000000 rmoveto
1.000000 setlinewidth
grestore
grestore
%%DocumentNeededResources: font Courier
%%DocumentSuppliedResources:
%%DocumentNeededFonts: Courier
%%DocumentSuppliedFonts:
%%DocumentFonts: font Courier
grestore
.75 0 .075 r
.0098 .12737 m
.0098 .25225 L
.5 .25225 L
.5 .12737 L
F
.75 0 .15 r
.0098 .25225 m
.0098 .37712 L
.5 .37712 L
.5 .25225 L
F
.75 0 .225 r
.0098 .37712 m
.0098 .502 L
.5 .502 L
.5 .37712 L
F
.75 0 .3 r
.0098 .502 m
.0098 .62687 L
.5 .62687 L
.5 .502 L
F
.75 0 .375 r
.0098 .62687 m
.0098 .75175 L
.5 .75175 L
.5 .62687 L
F
.75 0 .45 r
.0098 .75175 m
.0098 .87662 L
.5 .87662 L
.5 .75175 L
F
.75 0 .525 r
.0098 .87662 m
.0098 1.0015 L
.5 1.0015 L
.5 .87662 L
F
.75 0 .6 r
.0098 1.0015 m
.0098 1.12637 L
.5 1.12637 L
.5 1.0015 L
F
.75 0 .675 r
.0098 1.12637 m
.0098 1.25125 L
.5 1.25125 L
.5 1.12637 L
F
.75 0 .75 r
.0098 1.25125 m
.0098 1.37612 L
.5 1.37612 L
.5 1.25125 L
F
.675 0 .75 r
.0098 1.37612 m
.0098 1.501 L
.5 1.501 L
.5 1.37612 L
F
.6 0 .75 r
.0098 1.501 m
.0098 1.62587 L
.5 1.62587 L
.5 1.501 L
F
.525 0 .75 r
.0098 1.62587 m
.0098 1.75075 L
.5 1.75075 L
.5 1.62587 L
F
.45 0 .75 r
.0098 1.75075 m
.0098 1.87562 L
.5 1.87562 L
.5 1.75075 L
F
.375 0 .75 r
.0098 1.87562 m
.0098 2.0005 L
.5 2.0005 L
.5 1.87562 L
F
.3 0 .75 r
.0098 2.0005 m
.0098 2.12537 L
.5 2.12537 L
.5 2.0005 L
F
.225 0 .75 r
.0098 2.12537 m
.0098 2.25025 L
.5 2.25025 L
.5 2.12537 L
F
.15 0 .75 r
.0098 2.25025 m
.0098 2.37512 L
.5 2.37512 L
.5 2.25025 L
F
.075 0 .75 r
.0098 2.37512 m
.0098 2.5 L
.5 2.5 L
.5 2.37512 L
F
0 0 .75 r
.0098 2.5 m
.0098 2.62488 L
.5 2.62488 L
.5 2.5 L
F
0 .075 .75 r
.0098 2.62488 m
.0098 2.74975 L
.5 2.74975 L
.5 2.62488 L
F
0 .15 .75 r
.0098 2.74975 m
.0098 2.87463 L
.5 2.87463 L
.5 2.74975 L
F
0 .225 .75 r
.0098 2.87463 m
.0098 2.9995 L
.5 2.9995 L
.5 2.87463 L
F
0 .3 .75 r
.0098 2.9995 m
.0098 3.12438 L
.5 3.12438 L
.5 2.9995 L
F
0 .375 .75 r
.0098 3.12438 m
.0098 3.24925 L
.5 3.24925 L
.5 3.12438 L
F
0 .45 .75 r
.0098 3.24925 m
.0098 3.37413 L
.5 3.37413 L
.5 3.24925 L
F
0 .525 .75 r
.0098 3.37413 m
.0098 3.499 L
.5 3.499 L
.5 3.37413 L
F
0 .6 .75 r
.0098 3.499 m
.0098 3.62388 L
.5 3.62388 L
.5 3.499 L
F
0 .675 .75 r
.0098 3.62388 m
.0098 3.74875 L
.5 3.74875 L
.5 3.62388 L
F
0 .75 .75 r
.0098 3.74875 m
.0098 3.87363 L
.5 3.87363 L
.5 3.74875 L
F
0 .75 .675 r
.0098 3.87363 m
.0098 3.9985 L
.5 3.9985 L
.5 3.87363 L
F
0 .75 .6 r
.0098 3.9985 m
.0098 4.12338 L
.5 4.12338 L
.5 3.9985 L
F
0 .75 .525 r
.0098 4.12338 m
.0098 4.24825 L
.5 4.24825 L
.5 4.12338 L
F
0 .75 .45 r
.0098 4.24825 m
.0098 4.37313 L
.5 4.37313 L
.5 4.24825 L
F
0 .75 .375 r
.0098 4.37313 m
.0098 4.498 L
.5 4.498 L
.5 4.37313 L
F
0 .75 .3 r
.0098 4.498 m
.0098 4.62288 L
.5 4.62288 L
.5 4.498 L
F
0 .75 .225 r
.0098 4.62288 m
.0098 4.74775 L
.5 4.74775 L
.5 4.62288 L
F
0 .75 .15 r
.0098 4.74775 m
.0098 4.87263 L
.5 4.87263 L
.5 4.74775 L
F
0 .75 .075 r
.0098 4.87263 m
.0098 4.9975 L
.5 4.9975 L
.5 4.87263 L
F
0 g
gsave
.52451 4.93506 -61 -10.4375 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 20.875 translate 1 -1 scale
gsave
0.000000 0.000000 0.000000 setrgbcolor
1.000000 setlinewidth
gsave
newpath
 61.000000 16.875000 moveto
 460.000000 16.875000 lineto
 460.000000 4.000000 lineto
 61.000000 4.000000 lineto
 61.000000 16.875000 lineto
closepath
clip newpath
63.000000 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
0.000000 0.000000 rmoveto
63.000000 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
(40.) show
81.000000 13.000000 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000000 0.000000 0.000000 setrgbcolor
0.000000 0.000000 rmoveto
1.000000 setlinewidth
grestore
grestore
%%DocumentNeededResources: font Courier
%%DocumentSuppliedResources:
%%DocumentNeededFonts: Courier
%%DocumentSuppliedFonts:
%%DocumentFonts: font Courier
grestore
MathSubEnd
P
% End of sub-graphic
0 0 m
1 0 L
1 1.4104 L
0 1.4104 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  CellLabel->"From In[118]:=",
  ImageSize->{389.188, 548.875},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`400065000291000`40O003h00OogooQWoo003oOon6
Ool00?moohIoo`00ogooQWoo003oOon6Ool00?moohIoo`00ogooQWoo003oOon6Ool00?moohIoo`00
ogooQWoo003oOon6Ool00?moohIoo`00ogooQWoo003oOon6Ool00?moohIoo`00ogooQWoo003oOon6
Ool00?moohIoo`00ogooQWoo003oOon6Ool00?moohIoo`00ogooQWoo003oOon6Ool00?moohIoo`00
ogooQWoo003oOon6Ool00?moohIoo`00ogooQWoo003oOon6Ool00?moohIoo`00ogooQWoo003oOon6
Ool00?moohIoo`00ogooQWoo003oOon6Ool00?moohIoo`00_Goo0P0027oo0P00_7oo002mOol00`00
Oomoo`08Ool00`00Oomoo`2jOol00:ioo`<00004Ool007ooOol20006Ool01000Oomoogoo0P001Goo
00<007ooOol0^Woo002_Ool01P00Oomoo`00Ool000Qoo`03001oogoo00=oo`03001oogoo009oo`03
001oogoo0;Yoo`00[goo0`000Woo0`001Woo00<007ooOol00Woo00<007ooOol00goo00<007ooOol0
^Woo002_Ool01@00Oomoo`00Ool00`001Woo00<007ooOol00Woo0P0017oo00<007ooOol0^Woo002_
Ool01000Oomoo`002Woo00<007ooOol027oo00<007ooOol0^Woo002^Ool4000;Ool20008Ool2002l
Ool00?moohIoo`00ogooQWoo003oOon6Ool004aoo`D0009oo`03001oogoo01ioo`03001oogoo025o
o`8002=oo`<0025oo`<0021oo`03001oogoo021oo`<005]oo`00CWoo00L007ooOomoo`00Ool0000N
Ool00`00Ool0000ROol00`00Ool0000SOol00`00Oomoo`0POol00`00Oomoo`0OOol00`00Ool0000Q
Ool00`00Oomoo`1KOol004Qoo`<000=oo`07001oogooOol007oo00006Goo0`000Woo00<007oo0000
7Goo0`000Woo00<007oo000077oo0`000Woo100077oo0`000goo00<007ooOol07Woo00<007oo0000
8Woo00<007ooOol0FWoo001>Ool01`00Oomoogoo001oo`0001moo`03001oogoo025oo`80029oo`03
001oo`0002=oo`03001oogoo01ioo`03001oo`00029oo`03001oogoo05Yoo`00CWoo00L007ooOomo
o`00Ool0000NOol00`00Ool0000ROol00`00Oomoo`0ROol2000ROol00`00Ool0000OOol00`00Ool0
000QOol00`00Ool0001KOol004eoo`8000Aoo`03001oogoo01ioo`03001oogoo029oo`8002=oo`03
001oogoo025oo`03001oogoo01moo`03001oogoo025oo`03001oogoo05Yoo`00ogooQWoo003oOon6
Ool00?moohIoo`00ogooQWoo003oOon6Ool003aoobL00003G_L0000000d00003G_L0000001L00003
G_L0000002400003G_L0000000X00003G_L0000001<00003G_L0000001L00003G_L0000001<00003
G_L0000001@00003G_L0000001L00003G_L0000000L004Ioo`00?7oo00<007ooOol01Woo00<007oo
Ool01Woo00<007ooOol01Woo00<007ooOol01Woo00@007ooOomNm`Eoo`03001oogoo00Ioo`03001o
oekg00Moo`03001oogoo00Ioo`03001oogoo00Eoo`03G_L007oo00Moo`03001oogoo00Ioo`03001o
ogoo00Ioo`03001oogoo00Eoo`03G_L007oo00Moo`04001oogooG_L6Ool00`00Oomoo`06Ool00`00
Oomoo`03Ool015kgOomoo`0027oo00<007ooOol01Woo00<007ooOol00Woo00ENmgooOomoo`0000Qo
o`03001oogoo00Ioo`03G_Moogoo00Ioo`03001oogoo00Moo`05001oogooOomNm`04Ool00`00Oomo
o`06Ool00`00Oomoo`06Ool01000Oomooekg1Goo00@007ooOol004Ioo`00?7oo00<007ooOol03goo
00<007ooOol04Woo00=NmgooOol037oo00<007ooG_L067oo00=NmgooOol01goo00<007ooOol067oo
00=NmgooOol01Woo00<007ooG_L05Woo00=NmgooOol02Goo00<007ooOol02goo00=NmgooOol04goo
00=NmgooOol057oo00=NmgooOol02goo00<007ooOol02Goo00=NmgooOol01Woo00<007ooOol0A7oo
000lOol00`00Oomoo`0SOol00ekgOomoo`0@Ool00ekgOomoo`0DOol00ekgOomoo`0SOol00ekgOomo
o`08Ool00ekgOomoo`0EOol00ekgOomoo`0FOol00ekgOomoo`0COol00ekgOomoo`0DOol00ekgOomo
o`0FOol00ekgOomoo`07Ool00`00Oomoo`14Ool003aoo`8002Aoo`03G_Moogoo015oo`03G_Moogoo
01=oo`03G_Moogoo02Aoo`03G_Moogoo00Ioo`03G_Moogoo01Ioo`03G_Moogoo01Ioo`03G_Moogoo
01=oo`03G_Moogoo01Aoo`03G_Moogoo01Ioo`03G_Moogoo00Ioo`8004Ioo`00?7oo00<007ooOol0
8goo00=NmgooOol04Goo00=NmgooOol04goo00=NmgooOol097oo00=NmgooOol01Woo00=NmgooOol0
5Woo00=NmgooOol05goo00=NmgooOol04Woo00=NmgooOol04goo00=NmgooOol05goo00=NmgooOol0
1goo00<007ooOol0A7oo000lOol00`00Oomoo`0SOol00ekgOomoo`0BOol00ekgOomoo`0BOol00ekg
Oomoo`0TOol00ekgOomoo`06Ool00ekgOomoo`0FOol00ekgOomoo`0GOol00ekgOomoo`0BOol00ekg
Oomoo`0COol00ekgOomoo`0GOol00ekgOomoo`07Ool00`00Oomoo`14Ool003aoo`03001oogoo02=o
o`03G_Moogoo01=oo`03G_Moogoo011oo`03G_Moogoo02Ioo`03G_Moogoo00Aoo`03G_Moogoo01Qo
o`03G_Moogoo01Ioo`03G_Moogoo019oo`03G_Moogoo01=oo`03G_Moogoo01Ioo`03G_Moogoo00Qo
o`03001oogoo04Aoo`00?7oo00<007ooOol08Woo00=NmgooOol05Goo00=NmgooOol03goo00=Nmgoo
Ool09Woo00=NmgooOol017oo00=NmgooOol067oo00=NmgooOol05Woo00=NmgooOol04Woo00=Nmgoo
Ool04goo00=NmgooOol05Woo00=NmgooOol027oo00<007ooOol0A7oo000lOol00`00Oomoo`0ROol0
0ekgOomoo`0EOol00ekgOomoo`0?Ool00ekgOomoo`0WOol00ekgOomoo`02Ool00ekgOomoo`0IOol0
0ekgOomoo`0FOol00ekgOomoo`0BOol00ekgOomoo`0COol00ekgOomoo`0FOol00ekgOomoo`08Ool0
0`00Oomoo`14Ool003aoo`03001oogoo029oo`03G_Moogoo01Ioo`03G_Moogoo00ioo`03G_Moogoo
02Moo`03G_Moogoo009oo`03G_Moogoo01Uoo`03G_Moogoo01Ioo`03G_Moogoo019oo`03G_Moogoo
01=oo`03G_Moogoo01Ioo`03G_Moogoo00Qoo`03001oogoo04Aoo`00?7oo00<007ooOol08Woo00=N
mgooOol05goo00=NmgooOol037oo00=NmgooOol0:7oo00ENmgooOomooekg01eoo`03G_Moogoo01Eo
o`03G_Moogoo019oo`03G_Moogoo01=oo`03G_Moogoo01Eoo`03G_Moogoo00Uoo`03001oogoo04Ao
o`00?7oo00<007ooOol08Woo00=NmgooOol05goo00=NmgooOol037oo00=NmgooOol0:Goo00ANmgoo
OomNmaeoo`03G_Moogoo01Eoo`03G_Moogoo019oo`03G_Moogoo01=oo`03G_Moogoo01Eoo`03G_Mo
ogoo00Uoo`03001oogoo04Aoo`00?7oo00<007ooOol08Woo00=NmgooOol067oo00=NmgooOol02goo
00=NmgooOol0:Goo00ANmgooOomNmaeoo`03G_Moogoo01Eoo`03G_Moogoo019oo`03G_Moogoo01=o
o`03G_Moogoo01Eoo`03G_Moogoo00Uoo`03001oogoo04Aoo`00?7oo00<007ooOol08Goo00=Nmgoo
Ool06Woo00=NmgooOol02Woo00=NmgooOol0:Woo0Ukg7Woo00=NmgooOol05Goo00=NmgooOol04Woo
00=NmgooOol04Woo00=NmgooOol05Woo00=NmgooOol02Goo00<007ooOol0A7oo000lOol00`00Oomo
o`0QOol00ekgOomoo`0JOol00ekgOomoo`09Ool00ekgOomoo`0[Ool2G_LNOol00ekgOomoo`0FOol0
0ekgOomoo`0AOol00ekgOomoo`0BOol00ekgOomoo`0EOol00ekgOomoo`0:Ool00`00Oomoo`14Ool0
03aoo`03001oogoo025oo`03G_Moogoo01]oo`03G_Moogoo00Qoo`03G_Moogoo02]oo`03G_Moogoo
01ioo`03G_Moogoo01Eoo`03G_Moogoo015oo`03G_Moogoo019oo`03G_Moogoo01Eoo`03G_Moogoo
00Yoo`03001oogoo04Aoo`00?7oo00<007ooOol08Goo00=NmgooOol077oo00=NmgooOol01goo00=N
mgooOol0:goo0Ukg7goo00=NmgooOol05Goo00=NmgooOol04Goo00=NmgooOol04Woo00=NmgooOol0
5Goo00=NmgooOol02Woo00<007ooOol0A7oo000lOol00`00Oomoo`0QOol00ekgOomoo`0LOol00ekg
Oomoo`07Ool00ekgOomoo`0[Ool2G_LOOol00ekgOomoo`0EOol00ekgOomoo`0AOol00ekgOomoo`0B
Ool00ekgOomoo`0EOol00ekgOomoo`0:Ool00`00Oomoo`14Ool003aoo`03001oogoo021oo`03G_Mo
ogoo01ioo`03G_Moogoo00Ioo`03G_Moogoo02Yoo`04G_MoogooG_LNOol00ekgOomoo`0EOol00ekg
Oomoo`0AOol00ekgOomoo`0BOol00ekgOomoo`0EOol00ekgOomoo`0:Ool00`00Oomoo`14Ool003ao
o`03001oogoo021oo`03G_Moogoo01moo`03G_Moogoo00Aoo`03G_Moogoo02]oo`04G_MoogooG_LO
Ool00ekgOomoo`0DOol00ekgOomoo`0AOol00ekgOomoo`0BOol00ekgOomoo`0DOol00ekgOomoo`0;
Ool00`00Oomoo`14Ool003aoo`03001oogoo021oo`03G_Moogoo021oo`03G_Moogoo00=oo`03G_Mo
ogoo02Yoo`05G_MoogooOomNm`0OOol00ekgOomoo`0DOol00ekgOomoo`0AOol00ekgOomoo`0BOol0
0ekgOomoo`0DOol00ekgOomoo`0;Ool00`00Oomoo`14Ool003aoo`03001oogoo021oo`03G_Moogoo
021oo`03G_Moogoo00=oo`03G_Moogoo02Yoo`03G_Moogoo009oo`03G_Moogoo01aoo`03G_Moogoo
01Aoo`03G_Moogoo015oo`03G_Moogoo019oo`03G_Moogoo01Aoo`03G_Moogoo00]oo`03001oogoo
04Aoo`00?7oo00<007ooOol087oo00=NmgooOol08Goo00=NmgooOol00Woo00=NmgooOol0:Woo00=N
mgooOol00Woo00=NmgooOol077oo00=NmgooOol057oo00=NmgooOol04Goo00=NmgooOol04Goo00=N
mgooOol05Goo00=NmgooOol02goo00<007ooOol0A7oo000lOol00`00Oomoo`0OOol00ekgOomoo`0S
Ool015kgOomooekg;7oo00=NmgooOol017oo00=NmgooOol077oo00=NmgooOol057oo00=NmgooOol0
47oo00=NmgooOol04Goo00=NmgooOol057oo00=NmgooOol037oo00<007ooOol0A7oo000fOol30003
Ool00`00Oomoo`0OOol00ekgOomoo`0SOol015kgOomooekg;7oo00=NmgooOol017oo00=NmgooOol0
77oo00=NmgooOol057oo00=NmgooOol047oo00=NmgooOol04Goo00=NmgooOol057oo00=NmgooOol0
37oo00<007ooOol0A7oo000gOol00`00Oomoo`02Ool00`00Oomoo`0OOol00ekgOomoo`0TOol00ekg
OomNm`0/Ool00ekgOomoo`04Ool00ekgOomoo`0LOol00ekgOomoo`0DOol00ekgOomoo`0@Ool00ekg
Oomoo`0AOol00ekgOomoo`0DOol00ekgOomoo`0<Ool00`00Oomoo`14Ool0031oo`<0009oo`@000=o
o`80021oo`03G_Moogoo02Eoo`9Nmb]oo`03G_Moogoo00Ioo`03G_Moogoo01]oo`03G_Moogoo01Ao
o`03G_Moogoo00]oo`aNm`eoo`03G_Moogoo01Aoo`03G_Moogoo00Yoo`<004Ioo`00=Goo00<007oo
000017oo00<007ooOol07goo00=NmgooOol09Goo00=NmgooOol0:Woo00=NmgooOol01Woo00=Nmgoo
Ool06goo00=NmgooOol057oo00=NmgooOol027oo0ekg1Goo00=NmgooOol017oo0ekg2Woo00=Nmgoo
Ool04goo00=NmgooOol03Goo00<007ooOol0A7oo000fOol20004Ool00`00Oomoo`0NOol00ekgOomo
o`0VOol2G_L[Ool00ekgOomoo`07Ool00ekgOomoo`0KOol00ekgOomoo`0COol00ekgOomoo`05Ool3
G_L8Ool00ekgOomoo`07Ool3G_L7Ool00ekgOomoo`0COol00ekgOomoo`0=Ool00`00Oomoo`14Ool0
03Moo`03001oogoo009oo`03001oogoo01ioo`03G_Moogoo02Ioo`03G_Mooekg02Uoo`03G_Moogoo
00Qoo`03G_Moogoo01]oo`03G_Moogoo01=oo`03G_Moogoo00=oo`9Nm`]oo`03G_Moogoo00Yoo`9N
m`Eoo`03G_Moogoo01=oo`03G_Moogoo00eoo`03001oogoo04Aoo`00?7oo00<007ooOol07Woo00=N
mgooOol09Woo00ANmgooOomNmbQoo`03G_Moogoo00Qoo`03G_Moogoo01]oo`03G_Moogoo01=oo`04
G_MoogooOol2G_L=Ool00ekgOomoo`0<Ool2G_L3Ool00ekgOomoo`0COol00ekgOomoo`0=Ool00`00
Oomoo`14Ool003aoo`03001oogoo01ioo`03G_Moogoo02Eoo`05G_MoogooOomNm`0XOol00ekgOomo
o`09Ool00ekgOomoo`0JOol00ekgOomoo`0COol015kgOomooekg3goo00=NmgooOol03Woo00=Nmgoo
G_L05Goo00=NmgooOol03Woo00<007ooOol0A7oo000lOol00`00Oomoo`0NOol00ekgOomoo`0UOol0
0ekgOomoo`02Ool00ekgOomoo`0TOol00ekgOomoo`0:Ool00ekgOomoo`0KOol00ekgOomoo`0BOol3
G_L@Ool00ekgOomoo`0?Ool2G_LEOol00ekgOomoo`0>Ool00`00Oomoo`14Ool003aoo`03001oogoo
01ioo`03G_Moogoo02Eoo`03G_Moogoo00=oo`03G_Moogoo02=oo`03G_Moogoo00]oo`03G_Moogoo
01Yoo`03G_Moogoo019oo`9Nma5oo`03G_Moogoo011oo`9NmaAoo`03G_Moogoo00ioo`03001oogoo
04Aoo`00?7oo00<007ooOol07Goo00=NmgooOol09Woo00=NmgooOol00goo00=NmgooOol08goo00=N
mgooOol02goo00=NmgooOol06Woo00=NmgooOol047oo0Ukg00=ooekgOol047oo00=NmgooOol047oo
00ANmgooG_MNma9oo`03G_Moogoo00ioo`03001oogoo04Aoo`00?7oo00<007ooOol07Goo00=Nmgoo
Ool09Woo00=NmgooOol017oo00=NmgooOol08Goo00=NmgooOol037oo00=NmgooOol06Woo00=Nmgoo
Ool03goo00ENmgooOomooekg015oo`03G_Moogoo011oo`05G_MoogooOomNm`0AOol00ekgOomoo`0>
Ool00`00Oomoo`14Ool003aoo`03001oogoo01eoo`03G_Moogoo02Eoo`03G_Moogoo00Ioo`03G_Mo
ogoo021oo`03G_Moogoo00eoo`03G_Moogoo01Uoo`03G_Moogoo00ioo`03G_Moogoo009oo`03G_Mo
ogoo00moo`03G_Moogoo011oo`03G_Moogoo009oo`03G_Moogoo00eoo`03G_Moogoo00moo`03001o
ogoo04Aoo`00?7oo00<007ooOol07Goo00=NmgooOol09Goo00=NmgooOol01Woo00=NmgooOol087oo
00=NmgooOol03Goo00=NmgooOol06Woo00=NmgooOol037oo00=NmgooOol00goo00=NmgooOol03goo
00=NmgooOol047oo00=NmgooOol00goo00=NmgooOol037oo00=NmgooOol03goo00<007ooOol0A7oo
000lOol00`00Oomoo`0MOol00ekgOomoo`0UOol00ekgOomoo`07Ool00ekgOomoo`0NOol00ekgOomo
o`0>Ool00ekgOomoo`0JOol00ekgOomoo`0;Ool00ekgOomoo`04Ool00ekgOomoo`0?Ool00ekgOomo
o`0@Ool00ekgOomoo`04Ool00ekgOomoo`0;Ool00ekgOomoo`0?Ool00`00Oomoo`14Ool003aoo`03
001oogoo01aoo`03G_Moogoo02Ioo`03G_Moogoo00Qoo`03G_Moogoo01eoo`03G_Moogoo00moo`03
G_Moogoo01Uoo`03G_Moogoo00Uoo`9Nm`Moo`03G_Moogoo00moo`03G_Moogoo011oo`03G_Moogoo
00Eoo`03G_Moogoo00Yoo`03G_Moogoo00moo`03001oogoo04Aoo`00?7oo00<007ooOol077oo00=N
mgooOol09Woo00=NmgooOol027oo00=NmgooOol07Goo00=NmgooOol03goo00=NmgooOol06Goo00=N
mgooOol027oo00=NmgooOol01goo00=NmgooOol03goo00=NmgooOol03goo00=NmgooOol01goo00=N
mgooOol027oo00=NmgooOol047oo00<007ooOol0A7oo000lOol00`00Oomoo`0LOol00ekgOomoo`0U
Ool00ekgOomoo`0:Ool00ekgOomoo`0KOol00ekgOomoo`0AOol00ekgOomoo`0IOol00ekgOomoo`06
Ool00ekgOomoo`08Ool00ekgOomoo`0?Ool00ekgOomoo`0?Ool00ekgOomoo`08Ool00ekgOomoo`07
Ool00ekgOomoo`0@Ool00`00Oomoo`14Ool003aoo`03001oogoo01aoo`03G_Moogoo02Eoo`03G_Mo
ogoo00]oo`03G_Moogoo01Yoo`03G_Moogoo015oo`03G_Moogoo01Uoo`03G_Moogoo00Eoo`03G_Mo
ogoo00Yoo`03G_Moogoo00ioo`03G_Moogoo00moo`03G_Moogoo00Uoo`03G_Moogoo00Ioo`03G_Mo
ogoo011oo`03001oogoo04Aoo`00?7oo00<007ooOol077oo00=NmgooOol09Goo00=NmgooOol037oo
00=NmgooOol06Goo00=NmgooOol04Goo00=NmgooOol06Goo00=NmgooOol017oo00=NmgooOol02goo
00=NmgooOol03Woo00=NmgooOol03goo00=NmgooOol02Woo00=NmgooOol01Goo00=NmgooOol047oo
00<007ooOol0A7oo000lOol00`00Oomoo`0LOol00ekgOomoo`0UOol00ekgOomoo`0<Ool00ekgOomo
o`0HOol00ekgOomoo`0COol00ekgOomoo`0HOol00ekgOomoo`03Ool00ekgOomoo`0<Ool00ekgOomo
o`0>Ool00ekgOomoo`0?Ool00ekgOomoo`0;Ool00ekgOomoo`03Ool00ekgOol2h@0AOol00`00Oomo
o`14Ool003aoo`03001oogoo01]oo`03G_Moogoo02Ioo`03G_Moogoo00eoo`03G_Moogoo01Moo`03
G_Moogoo01=oo`03G_Moogoo01Uoo`03G_Moogoo009oo`03G_Moogoo00aoo`03G_Moogoo00ioo`03
G_Moogoo00moo`03G_Moogoo00]oo`03G_Moogoo00=oo`04G_L2h@;Q0^4@Ool00`00Oomoo`14Ool0
03aoo`03001oogoo01]oo`03G_Moogoo02Eoo`03G_Moogoo00moo`03G_Moogoo01Ioo`03G_Moogoo
01Aoo`03G_Moogoo01Qoo`05G_MoogooOomNm`0?Ool00ekgOomoo`0>Ool00ekgOomoo`0?Ool00ekg
Oomoo`0<Ool00ekgOomoo`02Ool00ekgOol2h@0AOol00`00Oomoo`14Ool003aoo`03001oogoo01]o
o`03G_Moogoo02Eoo`03G_Moogoo00moo`03G_Moogoo01Eoo`03G_Moogoo01Eoo`03G_Moogoo01Qo
o`04G_MoogooG_L@Ool00ekgOomoo`0>Ool00ekgOomoo`0?Ool00ekgOomoo`0=Ool01EkgOomoogoo
0^@04goo00<007ooOol0A7oo000lOol00`00Oomoo`0KOol00ekgOomoo`0UOol00ekgOomoo`0@Ool0
0ekgOomoo`0DOol00ekgOomoo`0EOol00ekgOomoo`0HOol00ekgOomNm`0AOol00ekgOomoo`0>Ool0
0ekgOomoo`0?Ool00ekgOomoo`0>Ool00ekgOol2i0020^@BOol00`00Oomoo`14Ool003aoo`8001ao
o`03G_Moogoo02Eoo`03G_Moogoo015oo`03G_Moogoo01=oo`03G_Moogoo01Ioo`03G_Moogoo01Mo
o`03G_Mooekg015oo`03G_Moogoo00ioo`03G_Moogoo00ioo`03G_Moogoo00moo`04G_Mooekg0^@B
Ool20016Ool003aoo`03001oogoo01]oo`03G_Moogoo02Eoo`03G_Moogoo015oo`03G_Moogoo019o
o`03G_Moogoo01Moo`03G_Moogoo01Qoo`03G_Moogoo011oo`03G_Moogoo00ioo`03G_Moogoo00io
o`03G_Moogoo011oo`03G_L2iWoo01=oo`03001oogoo04Aoo`00?7oo00<007ooOol06goo00=Nmgoo
Ool097oo00=NmgooOol04goo00=NmgooOol04Goo00=NmgooOol067oo00=NmgooOol05Woo0Ukg4Woo
00=NmgooOol03Woo00=NmgooOol03Woo00=NmgooOol047oo0`;V4goo00<007ooOol0A7oo000lOol0
0`00Oomoo`0KOol00ekgOomoo`0TOol00ekgOomoo`0DOol00ekgOomoo`0@Ool00ekgOomoo`0HOol0
0ekgOomoo`0EOol00ekgOomNm`0COol00ekgOomoo`0=Ool00ekgOomoo`0>Ool00ekgOomoo`0AOol0
0`;VG_Moo`0BOol00`00Oomoo`14Ool003aoo`03001oogoo01Yoo`03G_Moogoo02Eoo`03G_Moogoo
01Aoo`03G_Moogoo011oo`03G_Moogoo01Qoo`03G_Moogoo01Eoo`03G_Mooekg01=oo`03G_Moogoo
00eoo`03G_Moogoo00ioo`03G_Moogoo011oo`03G_Mooekg01=oo`03001oogoo04Aoo`00?7oo00<0
07ooOol06Woo00=NmgooOol09Goo00=NmgooOol05Goo00=NmgooOol03Woo00=NmgooOol06Woo00=N
mgooOol04goo00ENmgooOomooekg019oo`03G_Moogoo00eoo`03G_Moogoo00ioo`03G_Moogoo011o
o`040^QoogooG_LBOol00`00Oomoo`14Ool003aoo`03001oogoo01Yoo`03G_Moogoo02Eoo`03G_Mo
ogoo01Ioo`03G_Moogoo00eoo`03G_Moogoo01Yoo`03G_Moogoo019oo`03G_Moogoo009oo`03G_Mo
ogoo011oo`03G_Moogoo00eoo`03G_Moogoo00ioo`03G_Moogoo00moo`<2j09oo`03G_Moogoo00mo
o`03001oogoo04Aoo`00?7oo00<007ooOol06Woo00=NmgooOol09Goo00=NmgooOol05goo00=Nmgoo
Ool037oo00=NmgooOol06goo00=NmgooOol04Goo00=NmgooOol00Woo00=NmgooOol047oo00=Nmgoo
Ool03Goo00=NmgooOol03Woo00=NmgooOol047oo00D2j7ooOomooekg015oo`03001oogoo04Aoo`00
?7oo00<007ooOol06Woo00=NmgooOol097oo00=NmgooOol067oo00=NmgooOol037oo00=NmgooOol0
6goo00=NmgooOol047oo00=NmgooOol00goo00=NmgooOol047oo00=NmgooOol03Goo00=NmgooOol0
3Woo00=NmgooOol03goo00<2jgooOol00goo00=NmgooOol03Woo00<007ooOol0A7oo000lOol00`00
Oomoo`0JOol00ekgOomoo`0TOol00ekgOomoo`0IOol00ekgOomoo`0:Ool00ekgOomoo`0LOol00ekg
Oomoo`0@Ool00ekgOomoo`04Ool00ekgOomoo`0?Ool00ekgOomoo`0=Ool00ekgOomoo`0>Ool00ekg
Oomoo`0>Ool00`;[0^X2j`04Ool00ekgOomoo`0>Ool00`00Oomoo`14Ool003aoo`03001oogoo01Yo
o`03G_Moogoo02Aoo`03G_Moogoo01Yoo`03G_Moogoo00Uoo`03G_Moogoo01eoo`03G_Moogoo00io
o`03G_Moogoo00Eoo`03G_Moogoo00moo`03G_Moogoo00eoo`03G_Moogoo00eoo`03G_Moogoo011o
o`030^]oogoo00Aoo`03G_Moogoo00eoo`03001oogoo04Aoo`00?7oo00<007ooOol06Woo00=Nmgoo
Ool097oo00=NmgooOol06Woo00=NmgooOol02Goo00=NmgooOol07Goo00=NmgooOol03Woo00=Nmgoo
Ool01Goo00=NmgooOol03goo00=NmgooOol03Goo00=NmgooOol03Goo00=NmgooOol047oo00=Nmgoo
Ool017oo00=NmgooOol03Goo00<007ooOol0A7oo000lOol00`00Oomoo`0IOol00ekgOomoo`0UOol0
0ekgOomoo`0KOol00ekgOomoo`07Ool00ekgOomoo`0OOol00ekgOomoo`0<Ool00ekgOomoo`06Ool0
0ekgOomoo`0@Ool00ekgOomoo`0<Ool00ekgOomoo`0=Ool00ekgOomoo`0?Ool00`;]Oomoo`06Ool0
0ekgOomoo`0<Ool00`00Oomoo`14Ool003aoo`03001oogoo01Uoo`03G_Moogoo02Aoo`03G_Moogoo
01eoo`03G_Moogoo00Ioo`03G_Moogoo01moo`03G_Moogoo00aoo`03G_Moogoo00Ioo`03G_Moogoo
011oo`03G_Moogoo00aoo`03G_Moogoo00eoo`03G_Moogoo00ioo`<2k@Qoo`03G_Moogoo00]oo`03
001oogoo04Aoo`00?7oo00<007ooOol06Goo00=NmgooOol097oo00=NmgooOol07Goo00=NmgooOol0
1Woo00=NmgooOol07goo00=NmgooOol02goo00=NmgooOol027oo00=NmgooOol03goo00=NmgooOol0
37oo00=NmgooOol03Goo00=NmgooOol03goo00<2kGooOol01goo00=NmgooOol02goo00<007ooOol0
A7oo000lOol00`00Oomoo`0IOol00ekgOomoo`0TOol00ekgOomoo`0NOol00ekgOomoo`05Ool00ekg
Oomoo`0POol00ekgOomoo`0:Ool00ekgOomoo`08Ool00ekgOomoo`0?Ool00ekgOomoo`0<Ool00ekg
Oomoo`0=Ool00ekgOomoo`0>Ool00`;_G_Moo`09Ool00ekgOomoo`0:Ool00`00Oomoo`14Ool003ao
o`03001oogoo01Uoo`03G_Moogoo02Aoo`03G_Moogoo01moo`03G_Moogoo00=oo`03G_Moogoo025o
o`03G_Moogoo00Uoo`03G_Moogoo00Uoo`03G_Moogoo00moo`03G_Moogoo00aoo`03G_Moogoo00eo
o`03G_Moogoo00eoo`<2k`Yoo`03G_Moogoo00Yoo`03G_Moogoo04Aoo`00?7oo00<007ooOol06Goo
00=NmgooOol097oo00=NmgooOol07goo00=NmgooOol00goo00=NmgooOol08Woo00=NmgooOol027oo
00=NmgooOol02Goo00=NmgooOol03goo00=NmgooOol037oo00=NmgooOol03Goo00=NmgooOol03Woo
00<2kgooOol02Woo00=NmgooOol02Goo00=NmgooOol0A7oo000lOol00`00Oomoo`0IOol00ekgOomo
o`0SOol00ekgOomoo`0QOol00ekgOomoo`02Ool00ekgOomoo`0ROol00ekgOomoo`07Ool00ekgOomo
o`0;Ool00ekgOomoo`0>Ool00ekgOomoo`0<Ool00ekgOomoo`0=Ool00ekgOomoo`0=Ool00`;bG_Mo
o`0;Ool00ekgOomoo`08Ool00ekg001oo`15Ool003aoo`03001oogoo01Qoo`03G_Moogoo02Aoo`03
G_Moogoo029oo`04G_MoogooG_LUOol00ekgOomoo`07Ool00ekgOomoo`0;Ool00ekgOomoo`0>Ool0
0ekgOomoo`0<Ool00ekgOomoo`0<Ool00ekgOomoo`0=Ool30_8=Ool00ekgOomoo`07Ool00ekg001o
o`15Ool003aoo`03001oogoo01Qoo`03G_Moogoo02Aoo`03G_Moogoo02=oo`03G_Mooekg02Ioo`03
G_Moogoo00Ioo`03G_Moogoo00]oo`03G_Moogoo00ioo`03G_Moogoo00aoo`03G_Moogoo00aoo`03
G_Moogoo00ioo`030_9Nmgoo00aoo`03G_Moogoo00Ioo`03G_Moo`0004Ioo`00?7oo00<007ooOol0
67oo00=NmgooOol097oo00=NmgooOol08goo00=NmgooG_L09Woo00=NmgooOol01Goo00=NmgooOol0
37oo00=NmgooOol03Woo00=NmgooOol037oo00=NmgooOol037oo00=NmgooOol03Woo00=NmgooOol0
3Goo00=NmgooOol01Goo00=Nmgoo0000AWoo000lOol00`00Oomoo`0HOol00ekgOomoo`0TOol00ekg
Oomoo`0TOol2G_LWOol00ekgOomoo`04Ool00ekgOomoo`0=Ool00ekgOomoo`0>Ool00ekgOomoo`0;
Ool00ekgOomoo`0<Ool00ekgOomoo`0=Ool00`;dG_Moo`0>Ool00ekgOomoo`05Ool00ekgOol00016
Ool003aoo`8001Uoo`03G_Moogoo02=oo`03G_Moogoo02Eoo`9NmbMoo`03G_Moogoo00=oo`03G_Mo
ogoo00ioo`03G_Moogoo00ioo`03G_Moogoo00]oo`03G_Moogoo00aoo`03G_Moogoo00aoo`<2m11o
o`03G_Moogoo00=oo`04G_Moo`000016Ool003aoo`03001oogoo01Qoo`03G_Moogoo02=oo`03G_Mo
ogoo02Eoo`9NmbMoo`03G_Moogoo00=oo`03G_Moogoo00ioo`03G_Moogoo00ioo`03G_Moogoo00]o
o`03G_Moogoo00aoo`03G_Moogoo00eoo`030_ANmgoo00moo`03G_Moogoo00=oo`04G_Moogoo0016
Ool003aoo`03G_Moogoo01Qoo`03G_Moogoo02=oo`03G_Moogoo02Eoo`03G_Mooekg02Moo`05G_Mo
ogooOomNm`0AOol00ekgOomoo`0>Ool00ekgOomoo`0;Ool00ekgOomoo`0<Ool00ekgOomoo`0<Ool0
0`;fG_Moo`0@Ool00ekgOomoo`02Ool01EkgOomoogoo0000AWoo000lOol00`00G_MNm`0HOol00ekg
Oomoo`0SOol00ekgOomoo`0UOol015kgOomooekg9Woo00ENmgooOomooekg015oo`03G_Moogoo00io
o`03G_Moogoo00]oo`03G_Moogoo00aoo`03G_Moogoo00]oo`<2mQ9oo`05G_MoogooOomNm`03Ool0
0`00Oomoo`14Ool003aoo`04001oogooG_LFOol00ekgOomoo`0TOol00ekgOomoo`0TOol01EkgOomo
ogooG_L09goo00=NmgooG_L04goo00=NmgooOol03Goo00=NmgooOol02goo00=NmgooOol037oo00=N
mgooOol037oo00<2mUkgOol04Goo00ENmgooOomooekg00=oo`03001oogoo04Aoo`00?7oo00@007oo
Oomoo`9NmaAoo`03G_Moogoo02Aoo`03G_Moogoo02Aoo`03G_Moogoo009oo`03G_Moogoo02Aoo`03
G_Mooekg01=oo`03G_Moogoo00eoo`03G_Moogoo00]oo`03G_Moogoo00]oo`03G_Moogoo00ioo`03
G_Moogoo015oo`03G_Mooekg00Aoo`03001oogoo04Aoo`00?7oo00<007ooOol00goo00=NmgooOol0
4Goo00=NmgooOol08goo00=NmgooOol09Goo00=NmgooOol00goo00=NmgooOol08goo0Ukg57oo00=N
mgooOol03Goo00=NmgooOol02goo00=NmgooOol02goo00=NmgooOol02goo00<2]gooG_L057oo00=N
mgooG_L017oo00<007ooOol0A7oo000lOol00`00Oomoo`04Ool2G_LAOol00ekgOomoo`0SOol00ekg
Oomoo`0UOol00ekgOomoo`04Ool00ekgOomoo`0SOol00ekgOomoo`0BOol00ekgOomoo`0=Ool00ekg
Oomoo`0;Ool00ekgOomoo`0;Ool00ekgOomoo`0:Ool30[L00ekgOomoo`0BOol2G_L5Ool00`00Oomo
o`14Ool003aoo`03001oogoo00Ioo`03G_Moogoo00ioo`03G_Moogoo02=oo`03G_Moogoo02Aoo`03
G_Moogoo00Eoo`03G_Moogoo029oo`9NmaEoo`03G_Moogoo00eoo`03G_Moogoo00Yoo`03G_Moogoo
00]oo`03G_Moogoo00]oo`030[Mooekg01Eoo`03G_Moogoo00=oo`03001oogoo04Aoo`00?7oo00<0
07ooOol01goo0Ukg3Woo00=NmgooOol08goo00=NmgooOol097oo00=NmgooOol01Woo00=NmgooOol0
8Goo00=NmgooG_L057oo00=NmgooOol03Goo00=NmgooOol02Woo00=NmgooOol02goo00=NmgooOol0
2Woo00@2MgooOomNmaEoo`03G_Moogoo00=oo`03001oogoo04Aoo`00?7oo00<007ooOol02Goo00=N
mgooOol02goo00=NmgooOol08goo00=NmgooOol097oo00=NmgooOol01goo00=NmgooOol07goo00AN
mgooOomNmaAoo`03G_Moogoo00eoo`03G_Moogoo00Yoo`03G_Moogoo00]oo`03G_Moogoo00Uoo`<2
M`03OomNmgoo01=oo`03G_Mooekg00Aoo`03001oogoo04Aoo`00?7oo00<007ooOol02Woo0Ukg2goo
00=NmgooOol08goo00=NmgooOol097oo00=NmgooOol01goo00=NmgooOol07goo00ANmgooOomNmaAo
o`03G_Moogoo00eoo`03G_Moogoo00Yoo`03G_Moogoo00]oo`03G_Moogoo00Yoo`030WMooekg01Eo
o`03G_Mooekg00Aoo`03001oogoo04Aoo`00?7oo00<007ooOol037oo00=NmgooOol01goo00=Nmgoo
Ool097oo00=NmgooOol097oo00=NmgooOol027oo00=NmgooOol07Woo00ENmgooOomooekg01Aoo`03
G_Moogoo00aoo`03G_Moogoo00Yoo`03G_Moogoo00]oo`03G_Moogoo00aoo`03G_Moogoo019oo`04
G_MoogooG_L4Ool00`00Oomoo`0aOol00`00Oomoo`0@Ool003aoo`03001oogoo00eoo`9Nm`Moo`03
G_Moogoo02=oo`03G_Moogoo02Eoo`03G_Moogoo00Uoo`03G_Moogoo01aoo`03G_Moogoo009oo`03
G_Moogoo019oo`03G_Moogoo00aoo`03G_Moogoo00Yoo`03G_Moogoo00]oo`03G_Moogoo00Uoo`04
0SMoogooG_LDOol01EkgOomoogooG_L00goo00<007ooOol087oo35`017oo00<007oo00004Goo000l
Ool00`00Oomoo`0?Ool00ekgOomoo`04Ool00ekgOomoo`0SOol00ekgOomoo`0TOol00ekgOomoo`0:
Ool00ekgOomoo`0LOol00ekgOomoo`03Ool00ekgOomoo`0AOol00ekgOomoo`0<Ool00ekgOomoo`0:
Ool00ekgOomoo`0:Ool00ekgOomoo`09Ool30SL00gooG_Moo`0BOol00ekgOomoo`02Ool01EkgOomo
ogoo00008Woo00EH05`0G01L05P000=L0004F01L05`0G004Ool00`00Ool0000AOol003aoo`03001o
ogoo011oo`9Nm`Aoo`03G_Moogoo02=oo`03G_Moogoo02Aoo`03G_Moogoo00]oo`03G_Moogoo01]o
o`03G_Moogoo00=oo`03G_Moogoo015oo`03G_Moogoo00aoo`03G_Moogoo00Yoo`03G_Moogoo00Yo
o`03G_Moogoo00Yoo`030SMooekg01Aoo`03G_Moogoo00=oo`04G_Moogoo000ROol<G004Ool00`00
Ool0000AOol003aoo`03001oogoo019oo`05G_MoogooOomNm`0UOol00ekgOomoo`0TOol00ekgOomo
o`0<Ool00ekgOomoo`0IOol00ekgOomoo`04Ool00ekgOomoo`0AOol00ekgOomoo`0<Ool00ekgOomo
o`0:Ool00ekgOomoo`0:Ool00ekgOomoo`09Ool0107GOomooekg57oo00=NmgooOol00goo00ANmgoo
Ool0029oo`9L0005F01L05`0G01H0003G0000eP0G01oo`03Ool00`00Ool0000AOol003aoo`03001o
ogoo01=oo`9Nm`03OomNmgoo02Aoo`03G_Moogoo02Aoo`03G_Moogoo00aoo`03G_Moogoo01Uoo`03
G_Moogoo00Eoo`03G_Moogoo015oo`03G_Moogoo00]oo`03G_Moogoo00Yoo`03G_Moogoo00Yoo`03
G_Moogoo00Qoo`<1e`03OomNmgoo019oo`03G_Moogoo00Aoo`04G_Moogoo000ROol2G0401E`2G05L
0E`1G0800e`100=L0U`1Ool017oo00<007ooOol047oo000lOol00`00Oomoo`0EOol2G_LUOol00ekg
Oomoo`0TOol00ekgOomoo`0=Ool00ekgOomoo`0HOol00ekgOomoo`05Ool00ekgOomoo`0AOol00ekg
Oomoo`0<Ool00ekgOomoo`09Ool00ekgOomoo`0:Ool00ekgOomoo`09Ool0107GOomooekg4goo00=N
mgooOol01Goo00=Nmgoo00008Woo00aH0E`2G05L0UP1G09L0E`2F05L0U`1G08HOol003aoo`03001o
ogoo01Ioo`9NmbAoo`03G_Moogoo02Aoo`03G_Moogoo00ioo`03G_Moogoo01Ioo`03G_Moogoo00Mo
o`03G_Moogoo011oo`03G_Moogoo00aoo`03G_Moogoo00Uoo`03G_Moogoo00Yoo`03G_Moogoo00]o
o`03G_Moogoo015oo`03G_Moogoo00Ioo`03G_Moo`00029oo`05G09L0E`1G05L0P03G04015`2G05L
0E`167oo000lOol00`00Oomoo`0EOol015kgOomooekg8Woo00=NmgooOol097oo00=NmgooOol047oo
00=NmgooOol05Goo00=NmgooOol01goo00=NmgooOol047oo00=NmgooOol037oo00=NmgooOol02Goo
00=NmgooOol02Woo00=NmgooOol027oo00@1UgooOomNma=oo`03G_Moogoo00Ioo`03G_Moo`00029o
o`0<G0=L15P3G0AL0e`4F0=L15`3G0AH0e`467oo000lOol00`00Oomoo`0EOol015kgOomoogoo0Ukg
87oo00=NmgooOol097oo00=NmgooOol047oo00=NmgooOol05Goo00=NmgooOol01goo00=NmgooOol0
4Goo00=NmgooOol02goo00=NmgooOol02Goo00=NmgooOol02Woo00=NmgooOol01goo0`6G00=ooekg
Ool04Woo00=NmgooOol01goo00=Nm`00Ool08Goo35`467oo000lOol2000FOol00ekgOomoo`03Ool0
0ekgOomoo`0MOol00ekgOomoo`0TOol00ekgOomoo`0AOol00ekgOomoo`0COol00ekgOomoo`09Ool0
0ekgOomoo`0@Ool00ekgOomoo`0;Ool00ekgOomoo`09Ool00ekgOomoo`0:Ool00ekgOomoo`08Ool0
106GOomooekg4Woo00=NmgooOol027oo00=Nm`00Ool08Goo00aH0e`4G0=L15P3G0AL0e`4F0=L15`3
G0@HOol003aoo`03001oogoo01Eoo`03G_Moogoo00Aoo`9Nmaeoo`03G_Moogoo02Aoo`03G_Moogoo
019oo`03G_Moogoo019oo`03G_Moogoo00Uoo`03G_Moogoo011oo`03G_Moogoo00]oo`03G_Moogoo
00Uoo`03G_Moogoo00Uoo`03G_Moogoo00Qoo`040EMoogooG_LCOol00ekgOomoo`09Ool00ekgOomo
o`0POol<G0HHOol003aoo`03001oogoo01Eoo`03G_Moogoo00Ioo`03G_Moogoo01Yoo`03G_Moogoo
02Aoo`03G_Moogoo019oo`03G_Moogoo019oo`03G_Moogoo00Yoo`03G_Moogoo00moo`03G_Moogoo
00]oo`03G_Moogoo00Uoo`03G_Moogoo00Uoo`03G_Moogoo00Moo`050EL1=P5GOomNm`0BOol00ekg
Oomoo`0:Ool00ekgOomoo`0POol2G0H01UP6G0ML1U`6F0IL1`9L1P03F0IL1goo01Moo`00?7oo00<0
07ooOol05Goo00=NmgooOol01goo0Ukg6Woo00=NmgooOol097oo00=NmgooOol04goo00=NmgooOol0
47oo00=NmgooOol02goo00=NmgooOol047oo00=NmgooOol02Woo00=NmgooOol02Goo00=NmgooOol0
2Goo00=NmgooOol027oo00@1EgooOomNma9oo`03G_Moogoo00Yoo`03001oogoo021oo`aL1QQoo`00
?7oo00<007ooOol05Goo00=NmgooOol02Goo00=NmgooOol05goo00=NmgooOol08goo00=NmgooOol0
5Goo00=NmgooOol03goo00=NmgooOol02goo00=NmgooOol047oo00=NmgooOol02Woo00=NmgooOol0
2Goo00=NmgooOol02Goo00=NmgooOol01Woo00<0mgooOol00Woo00=NmgooOol047oo00=NmgooOol0
2Woo00<007ooOol087oo00aH25`9G0QL2EP8G0UL25`9F0QL2E`8G0THOol003aoo`03001oogoo01Eo
o`03G_Moogoo00Yoo`9NmaMoo`03G_Moogoo02=oo`03G_Moogoo01Eoo`03G_Moogoo00moo`03G_Mo
ogoo00aoo`03G_Moogoo00moo`03G_Moogoo00]oo`03G_Moogoo00Qoo`03G_Moogoo00Uoo`03G_Mo
ogoo00Eoo`<0m`=oo`03G_Moogoo00moo`03G_Moogoo00]oo`03001oogoo021oo`0<G0UL25`9G0QL
2E`8G0UL25`9G0QL2E`867oo000lOol00`00Oomoo`0EOol00ekgOomoo`0<Ool00ekgOomoo`0COol0
0ekgOomoo`0TOol00ekgOomoo`0FOol00ekgOomoo`0=Ool00ekgOomoo`0=Ool00ekgOomoo`0?Ool0
0ekgOomoo`0;Ool00ekgOomoo`08Ool00ekgOomoo`09Ool00ekgOomoo`06Ool01@3gOomoogooG_L0
4Woo00=NmgooOol02goo00<007ooOol087oo00aL25`9F0QL2E`8G0UH25`9G0QL2EP8G0THOol003ao
o`03001oogoo01Aoo`03G_Moogoo00ioo`9Nma=oo`03G_Moogoo02Aoo`03G_Moogoo01Moo`03G_Mo
ogoo00aoo`03G_Moogoo00ioo`03G_Moogoo00ioo`03G_Moogoo00]oo`03G_Moogoo00Qoo`03G_Mo
ogoo00Uoo`03G_Moogoo00Yoo`03G_Moogoo00moo`03G_Moogoo00aoo`03001oogoo021oo`0<G0UL
25`9G0QL2E`8G0UL25`9G0QL2E`867oo000lOol00`00Oomoo`0DOol00ekgOomoo`0@Ool00ekgOomo
o`0@Ool00ekgOomoo`0TOol00ekgOomoo`0GOol00ekgOomoo`0<Ool00ekgOomoo`0>Ool00ekgOomo
o`0?Ool00ekgOomoo`0:Ool00ekgOomoo`08Ool00ekgOomoo`09Ool00ekgOomoo`05Ool00`2gOomo
o`02Ool00ekgOomoo`0?Ool00ekgOomoo`0<Ool00`00Oomoo`0POol01EP:G0]L2e`;F0X00e`;00AH
2U`;G0]L2aQoo`00?7oo00<007ooOol057oo00=NmgooOol04Goo0Ukg47oo00=NmgooOol097oo00=N
mgooOol067oo00=NmgooOol02Woo00=NmgooOol03goo00=NmgooOol03goo00=NmgooOol02Woo00=N
mgooOol027oo00=NmgooOol02Goo00=NmgooOol017oo0`2g0goo00=NmgooOol03goo00=NmgooOol0
37oo00<007ooOol087oo35`;67oo000lOol00`00Oomoo`0DOol00ekgOomoo`0COol00ekgOomoo`0=
Ool00ekgOomoo`0SOol00ekgOomoo`0JOol00ekgOomoo`09Ool00ekgOomoo`0@Ool00ekgOomoo`0>
Ool00ekgOomoo`0:Ool00ekgOomoo`08Ool00ekgOomoo`08Ool00ekgOomoo`06Ool01@2gOomoogoo
G_L04Goo00=NmgooOol03Goo00<007ooOol087oo0U`;00EH2U`;G0]L2eP:00=L2`03F0YL2goo01Mo
o`00?7oo00<007ooOol057oo00=NmgooOol057oo0Ukg3Goo00=NmgooOol08goo00=NmgooOol06goo
00<2hGooOol027oo00=NmgooOol047oo00=NmgooOol03Woo00=NmgooOol02Woo00=NmgooOol027oo
00=NmgooOol027oo00=NmgooOol01Goo00<0MgooOol00Woo00=NmgooOol03goo00=NmgooOol03Goo
00<007ooOol087oo0U`=00EL3U`=G0eL3E`>00=L3@03G0iL3Goo01Moo`00?7oo00<007ooOol057oo
00=NmgooOol05Woo00=NmgooOol02Woo00=NmgooOol08goo00=NmgooOol06Woo0`;Q00<2i7ooOol0
1Woo00=NmgooOol047oo00=NmgooOol03goo00=NmgooOol02Goo00=NmgooOol027oo00=NmgooOol0
27oo00=NmgooOol017oo00<0M`1G07L00goo00=NmgooOol03Woo00=NmgooOol03Woo00<007ooOol0
87oo00aH3E`>G0eL3UP=G0iL3E`>F0eL3U`=G0hHOol003aoo`03001oogoo01Aoo`03G_Moogoo01Mo
o`03G_Moogoo00Qoo`03G_Moogoo02Aoo`03G_Moogoo01]oo`040^42i0;T0^@6Ool00ekgOomoo`0B
Ool00ekgOomoo`0>Ool00ekgOomoo`09Ool00ekgOomoo`08Ool00ekgOomoo`08Ool00ekgOomoo`05
Ool00`1gOomoo`02Ool00ekgOomoo`0>Ool00ekgOomoo`0>Ool00`00Oomoo`0POol01E`>G0eL3E`=
G0h00e`=00AL3U`=G0eL3AQoo`00?7oo00<007ooOol057oo00=NmgooOol067oo0Ukg27oo00=Nmgoo
Ool097oo00=NmgooOol07Goo00<2i0;VOol01Goo00=NmgooOol04Woo00=NmgooOol03Woo00=Nmgoo
Ool02Goo00=NmgooOol027oo00=NmgooOol027oo00=NmgooOol02Goo00=NmgooOol03goo00=Nmgoo
Ool03Woo00<007ooOol087oo00aL3e`@F0mL45`?G11H3e`@G0mL45P?G10HOol003aoo`03001oogoo
01Aoo`03G_Moogoo01Yoo`03G_Moogoo00Eoo`03G_Moogoo02Aoo`03G_Moogoo01eoo`<2iPEoo`03
G_Moogoo01=oo`03G_Moogoo00eoo`03G_Moogoo00Yoo`03G_Moogoo00Moo`03G_Moogoo00Qoo`03
G_Moogoo00Aoo`0301Moogoo009oo`03G_Moogoo00ioo`03G_Moogoo00moo`03001oogoo021oo`aL
41Qoo`00?7oo00<007ooOol057oo00=NmgooOol06goo0Ukg1Goo00=NmgooOol097oo00=NmgooOol0
7Woo00<2iP;X0^P017oo00=NmgooOol04goo00=NmgooOol03Goo00=NmgooOol02Woo00=NmgooOol0
1goo00=NmgooOol027oo00=NmgooOol00goo00<05`0g01L00goo00=NmgooOol03Woo00=NmgooOol0
3goo00<007ooOol087oo00aH3e`@G0mL45P?G11L3e`@F0mL45`?G10HOol003aoo`03001oogoo01Ao
o`03G_Moogoo01eoo`03G_Moogoo009oo`03G_Moogoo02=oo`03G_Moogoo021oo`030^Qoo`;[009o
o`03G_Moogoo01Aoo`03G_Moogoo00ioo`03G_Moogoo00Uoo`03G_Moogoo00Moo`03G_Moogoo00Qo
o`03G_Moogoo00Aoo`0301Moogoo009oo`03G_Moogoo00eoo`03G_Moogoo011oo`03001oogoo021o
o`aL4QQoo`00?7oo00<007ooOol04goo00=NmgooOol07goo0Ukg0Woo00=NmgooOol08goo00=Nmgoo
Ool087oo00INm`;[0^X2jgooG_LGOol00ekgOomoo`0=Ool00ekgOomoo`09Ool00ekgOomoo`07Ool0
0ekgOomoo`08Ool00ekgOomoo`02Ool00`0GOomoo`04Ool00ekgOomoo`0=Ool00ekgOomoo`0@Ool0
0`00Oomoo`0POol2G1801UPBG1=L4U`BF19L4`9L4P03F19L4goo01Moo`00?7oo00<007ooOol04goo
00=NmgooOol08Goo00=NmgooG_L09Goo00=NmgooOol08Goo00ENm`;[0^d2kEkg01Moo`03G_Moogoo
00eoo`03G_Moogoo00Uoo`03G_Moogoo00Moo`03G_Moogoo00Moo`03G_Moogoo009oo`0301L45`0G
00Aoo`03G_Moogoo00ioo`03G_Moogoo011oo`03001oogoo021oo`aL4QQoo`00?7oo00<007ooOol0
4goo00=NmgooOol08Woo0Ukg9Goo00=NmgooOol08Woo00ANm`;]0^mNmaQoo`03G_Moogoo00aoo`03
G_Moogoo00Uoo`03G_Moogoo00Moo`03G_Moogoo00Moo`03G_Moogoo00=oo`0301Moogoo00=oo`03
G_Moogoo00eoo`03G_Moogoo015oo`03001oogoo021oo`06F19L4e`BG19H4U`C0U`B00AH4U`CG19L
4QQoo`00=Goo0`0017oo00<007ooOol04goo00=NmgooOol08Woo00=NmgooG_L097oo00=NmgooOol0
8Woo00ENm`;_0_02k`;b01Moo`03G_Moogoo00eoo`03G_Moogoo00Qoo`03G_Moogoo00Moo`03G_Mo
ogoo00Moo`03G_Moogoo00Uoo`03G_Moogoo00eoo`03G_Moogoo015oo`03001oogoo021oo`0<G1EL
55`EG1AL5E`DG1EL55`EG1AL5E`D67oo000eOol00`00Oomoo`04Ool00`00Oomoo`0COol00ekgOomo
o`0ROol00ekgOomoo`02G_LROol00ekgOomoo`0SOol01Ekg0^l2lP;a0_805Woo00=NmgooOol03Goo
00=NmgooOol027oo00=NmgooOol01goo00=NmgooOol01goo00=NmgooOol00Woo00<<5gooOol017oo
00=NmgooOol037oo00=NmgooOol04Woo00<007ooOol087oo00aL55`EF1AL5E`DG1EH55`EG1AL5EPD
G1DHOol0031oo`<000=oo`03001oogoo00=oo`8001Aoo`03G_Moogoo029oo`03G_Moogoo009oo`03
G_Moogoo01ioo`03G_Moogoo02Eoo`04G_Moo`;b0_@GOol00ekgOomoo`0<Ool00ekgOomoo`08Ool0
0ekgOomoo`04Ool7G_L6Ool015kgOomoogoo0``G17oo00=NmgooOol03Goo00=NmgooOol047oo0`00
8Woo00aL5E`DG1EL55`EG1AL5E`DG1EL55`EG1@HOol003Ioo`03001oogoo00=oo`03001oogoo01=o
o`03G_Moogoo029oo`03G_Moogoo00=oo`9Nmaioo`03G_Moogoo02Eoo`9Nm`<2m1Ioo`03G_Moogoo
00aoo`03G_Moogoo00Uoo`04G_MoogooOol2G_L3Ool015kgOomoogoo0Ukg17oo00=NmgooOol00Woo
00<<5gooOol00goo00=NmgooOol03Goo00=NmgooOol04Woo00<007ooOol087oo00EH5U`GG1ML5ePF
00=L5`04F1IL5e`GG1LHOol003Eoo`03001oo`0000Aoo`03001oogoo01=oo`03G_Moogoo029oo`03
G_Moogoo00Eoo`03G_Moogoo01]oo`03G_Moogoo02Aoo`07G_MooekgOol2m0;g0_H05Woo00=Nmgoo
Ool037oo00=NmgooOol027oo00ANmgooG_MNm`Eoo`03G_Moogoo00=oo`=Nm`03OomNmgoo009oo`03
51Moogoo00Aoo`03G_Moogoo00aoo`03G_Moogoo01=oo`03001oogoo021oo`aL5aQoo`00=Woo00<0
07ooOol00goo00<007ooOol04goo00=NmgooOol08Woo00=NmgooOol01Woo0Ukg6goo00=NmgooOol0
97oo00QNmgooOomNmgoo0_Ioo`:g5Goo00=NmgooOol037oo00=NmgooOol027oo0Ukg1goo00=Nmgoo
Ool01Woo0Ukg0Woo0a@G1Goo00=NmgooOol037oo00=NmgooOol04goo00<007ooOol087oo0U`G00EH
5U`GG1ML5ePF00=L5`03F1IL5goo01Moo`00?7oo00<007ooOol04goo00=NmgooOol08Woo00=Nmgoo
Ool027oo00=NmgooOol067oo00=NmgooOol097oo00INmgooOomooekgOol30[LDOol00ekgOomoo`0<
Ool00ekgOomoo`06Ool3G_L8Ool00ekgOomoo`07Ool3G_L00goo51Moo`04Ool00ekgOomoo`0<Ool0
0ekgOomoo`0DOol00`00Oomoo`0POol035@GD1MD5e0GE1M@5e@GD1MD5e0GE1M@5aQoo`00?7oo00<0
07ooOol04goo00=NmgooOol08Woo00=NmgooOol02Goo0Ukg67oo00=NmgooOol097oo00ENmgooOomo
oekg009oo`030[L2M`9g01Aoo`03G_Moogoo00]oo`03G_Moogoo00Eoo`04G_MoogooG_L8Ool00ekg
Oomoo`06Ool01EkgOomoogooG_L01Woo00=NmgooOol037oo00=NmgooOol057oo00<007ooOol087oo
00a@5U@GD1MD5e0FE1M@5e@GD1ID5e0GE1LHOol003aoo`03001oogoo019oo`03G_Moogoo02=oo`03
G_Moogoo00]oo`03G_Moogoo01Eoo`03G_Moogoo02Aoo`03G_Moogoo009oo`05G_Moogoo0WL2=`0D
Ool00ekgOomoo`0;Ool00ekgOomoo`04Ool01EkgOomoogooG_L027oo00=NmgooOol01Woo00INmgoo
OolL5gooG_L5Ool00ekgOomoo`0;Ool00ekgOomoo`0EOol00`00Oomoo`0POol035@GD1MD5e0GE1M@
5e@GD1MD5e0GE1M@5aQoo`00?7oo00<007ooOol04Woo00=NmgooOol08goo00=NmgooOol037oo0Ukg
57oo00=NmgooOol097oo00=NmgooOol017oo00=Nmgoo0SL00P8g00<1egooOol04Goo00=NmgooOol0
2goo00=NmgooOol00goo00ENmgooOomooekg00Qoo`03G_Moogoo00Ioo`06G_Mooa`G81LL5ekg1Goo
00=NmgooOol02goo00=NmgooOol05Goo00<007ooOol087oo0TPG00I85T`GB1M85dPFC1L2B1L00dPF
C1Moo`0GOol003aoo`03001oogoo019oo`03G_Moogoo029oo`03G_Moogoo00moo`03G_Moogoo015o
o`03G_Moogoo02Aoo`03G_Moogoo00Aoo`04G_Moogoo0SL30MLBOol00ekgOomoo`0;Ool00ekgOomo
o`02Ool00ekgOomoo`02Ool00ekgOomoo`06Ool00ekgOomoo`06Ool015kgOomooa`G0Woo00ENmgoo
Oomooekg00ioo`03G_Moogoo01Eoo`03G_Moogoo021oo`a85aQoo`00?7oo00<007ooOol04Woo00=N
mgooOol08Woo00=NmgooOol047oo0Ukg4Goo00=NmgooOol097oo00=NmgooOol01Goo00INmgooOomo
o`7G0ILBOol00ekgOomoo`0;Ool01EkgOomoogooG_L01Goo00=NmgooOol01Woo00=NmgooOol01Woo
00=Nmgoo:1L017oo00ANmgooOomNm`eoo`03G_Moogoo01Eoo`03G_L007oo025oo`06B1I<5dPGB1M8
5T`G0TPG00A85T`GB1M85aQoo`00?7oo00<007ooOol04Woo00=NmgooOol08Woo00=NmgooOol04Woo
00=NmgooOol03Woo00=NmgooOol097oo00=NmgooOol01Woo00=NmgooOol00`6G4Woo00=NmgooOol0
2Woo00ANmgooOomNm`Ioo`03G_Moogoo00Ioo`03G_Moogoo00Ioo`04G_LX5bPG:1L4Ool00ekgOomN
m`0=Ool00ekgOomoo`0EOol00ekg001oo`0QOol<B1LHOol003aoo`03001oogoo019oo`03G_Moogoo
029oo`03G_Moogoo01=oo`9Nm`ioo`03G_Moogoo02Aoo`03G_Moogoo00Ioo`07G_MoogooOol1U`4g
0EL04Goo00=NmgooOol02goo0Ukg27oo00=NmgooOol01Goo00=NmgooOol01Woo00=Nmgoo:1L01Woo
0Ukg37oo00=NmgooOol05Goo00=Nmgoo00008Woo00`l5d0G?1I05c`G@1Ll5T0G?1M05c`F@1LHOol0
03aoo`03001oogoo019oo`03G_Moogoo029oo`03G_Moogoo01Eoo`03G_Moogoo00]oo`03G_Moogoo
02Aoo`03G_Moogoo00Moo`07G_MoogooOol1Egoo0?L04Goo00=NmgooOol02Woo0Ukg27oo00=Nmgoo
Ool01Goo00=NmgooOol01Woo00=NmgooOol01Woo0Ukg37oo00=NmgooOol057oo00ANmgooOol0029o
o`a05aQoo`00?7oo00<007ooOol04Woo00=NmgooOol08Woo00=NmgooOol05Woo0Ukg2goo00=Nmgoo
Ool097oo00=NmgooOol027oo00ANmgooOomoo`<0ma1oo`03G_Moogoo00Yoo`03G_Moogoo00Moo`03
G_Moogoo00Eoo`03G_Moogoo00Ioo`03G_L`5goo00Ioo`9Nm`aoo`03G_Moogoo01Aoo`04G_Moogoo
000ROol033`F@1Ll5d0G?1I05c`G@1Ll5T0G?1M05aQoo`00?7oo00<007ooOol04Woo00=NmgooOol0
8Woo00=NmgooOol067oo00=NmgooOol01goo00=NmgooOol097oo00=NmgooOol02Woo00INmgooOomo
o`3g0;L@Ool00ekgOomoo`09Ool2G_L9Ool00ekgOomoo`05Ool00ekgOomoo`05Ool015kg<1L`5c0G
1Woo00=NmgooG_L02Woo00=NmgooOol057oo00ENmgooOomoo`00029oo`05>1Ld5c@G=1Lh5`03=1L0
13PG=1Ld5c@G67oo000lOol00`00Oomoo`0BOol00ekgOomoo`0ROol00ekgOomoo`0IOol2G_L7Ool0
0ekgOomoo`0TOol00ekgOomoo`0:Ool015kgOomoogoo0`2g47oo00=NmgooOol01goo00ANmgooOomN
m`Qoo`03G_Moogoo00Eoo`03G_Moogoo00Eoo`03G_Mooc0G00Moo`04G_MoogooG_L9Ool00ekgOomo
o`0COol00ekgOomoo`02Ool00`00Oomoo`0POol033@G>1Ld5SPG=1Lh5c@F>1Ld5cPG=1Hh5aQoo`00
?7oo00<007ooOol04Woo00=NmgooOol08Woo00=NmgooOol06goo00=NmgooOol017oo00=NmgooOol0
97oo00=NmgooOol02goo00ENmgooOomoo`2g0080M`moo`03G_Moogoo00Moo`04G_MoogooG_L8Ool0
0ekgOomoo`05Ool00ekgOomoo`05Ool00cPGOomoo`07Ool015kgOomooekg27oo00=NmgooOol04goo
00=NmgooOol00goo00<007ooOol087oo0S@G00Dh5c@G=1Ld5cPG00<d5`03>1Ld5goo01Moo`00?7oo
00<007ooOol04Woo00=NmgooOol08Woo00=NmgooOol077oo0Ukg17oo00=NmgooOol097oo00=Nmgoo
Ool037oo00MNmgooOomoo`1gOol05`0?Ool00ekgOomoo`05Ool01EkgOomoogooG_L027oo00=Nmgoo
Ool01Goo00=NmgooOol017oo0cPG1goo00=NmgooOol00Woo00=NmgooOol01Goo00=NmgooOol04goo
00=NmgooOol00goo00<007ooOol087oo00DX5R`G;1L/5bPF00</5`04:1H/5b`G;1LHOol003aoo`03
001oogoo015oo`03G_Moogoo02=oo`03G_Moogoo01ioo`05G_MoogooOomNm`0VOol00ekgOomoo`0<
Ool00ekgOomoo`02Ool301L>Ool00ekgOomoo`05Ool01EkgOomoogooG_L027oo00=NmgooOol01Goo
00=NmgooOol01Goo00<h5gooOol01Woo00=NmgooOol00Woo00=NmgooOol01Goo00=NmgooOol04Woo
00=NmgooOol017oo00<007ooOol087oo32`G67oo000lOol00`00Oomoo`0AOol00ekgOomoo`0SOol0
0ekgOomoo`0OOol2G_L00gooG_Moo`0UOol00ekgOomoo`0=Ool00ekgOomoo`02Ool201L>Ool00ekg
Oomoo`04Ool00ekgOomoo`02Ool00ekgOomoo`06Ool00ekgOomoo`05Ool00ekgOomoo`05Ool00ekg
Oomoo`06Ool00ekgOomoo`03Ool00ekgOomoo`03Ool00ekgOomoo`0BOol00ekgOomoo`05Ool00`00
Oomoo`0POol2;1L01BPF;1L/5b`G:1H00b`G00<X5R`GOol05goo000lOol00`00Oomoo`0AOol00ekg
Oomoo`0SOol00ekgOomoo`0QOol00ekgOomoo`0UOol00ekgOomoo`0>Ool025kgOomoogoo01L45`0G
31L=Ool00ekgOomoo`03Ool00ekgOomoo`03Ool00ekgOomoo`06Ool00ekgOomoo`04Ool00ekgOomo
o`04Ool00d@GG_Moo`07Ool00ekgOomoo`03Ool00ekgOomoo`03Ool00ekgOomoo`0BOol00ekgOomo
o`05Ool00`00Oomoo`0POol032@G81LT5b0G91LP5b@G81LT5b0G91LP5aQoo`00?7oo00<007ooOol0
4Goo00=NmgooOol08goo00=NmgooOol08Goo0ekg97oo00=NmgooOol03goo00=NmgooOol00Woo00@0
5``G31L<5`aoo`03G_Moogoo009oo`03G_Moogoo00Aoo`03G_Moogoo00Ioo`03G_Moogoo00Aoo`03
G_Moogoo00=oo`03A1M05d@G00Moo`03G_Moogoo00Eoo`05G_MoogooOomNm`0DOol00ekgOomoo`06
Ool00`00Oomoo`0POol0320F91LP5b@G81HT5b0G91LP5R@G81LT5aQoo`00?7oo00<007ooOol04Goo
00=NmgooOol08goo00=NmgooOol08Goo00ANmgooOomNmb=oo`03G_Moogoo011oo`03G_Moogoo00=o
o`0331LD5goo00aoo`05G_MoogooOomNm`06Ool00ekgOomoo`06Ool00ekgOomoo`04Ool00ekgOomo
o`04Ool00d@GG_Moo`06Ool00ekgOomoo`05Ool01EkgOomoogooG_L04goo00=NmgooOol01goo00<0
07ooOol087oo00`T5b0G91LP5b@G81LT5b0G91LP5b@G81LHOol003aoo`80019oo`03G_Moogoo029o
o`03G_Moogoo029oo`04G_MoogooOol2G_LQOol00ekgOomoo`0AOol00ekgOomoo`02Ool00a@G41HD
5`0<Ool015kgOomooekg1goo00=NmgooOol01Woo00=NmgooOol017oo00=NmgooOol00Woo00=<5goo
G_L027oo00=NmgooOol01Woo00ANmgooOomNma=oo`03G_Moogoo00Ioo`80029oo`0<81LT5b0F91LP
5b@G81HT5b0G91LP5R@G67oo000lOol00`00Oomoo`0AOol00ekgOomoo`0ROol00ekgOomoo`0ROol0
0ekgOomoo`03Ool00ekgOomoo`0NOol00ekgOomoo`0BOol00ekgOomoo`02Ool00a@G71Moo`0;Ool0
15kgOomooekg27oo00=NmgooOol01Goo00=NmgooOol017oo00ANmgooOomoo`=<5`03G_Moogoo00Io
o`03G_Moogoo00Ioo`03G_Mooekg01=oo`03G_Moogoo00Qoo`03001oogoo021oo``H5aQoo`00?7oo
00<007ooOol04Goo00=NmgooOol08Woo00=NmgooOol08Woo00=NmgooOol017oo0Ukg7Woo00=Nmgoo
Ool04Woo00=NmgooOol00Woo0a`G37oo0Ukg2Goo00=NmgooOol01Goo00=NmgooOol017oo00=Nmgoo
Ool00Woo00=<5gooG_L01goo00=NmgooOol027oo0Ukg4Woo00=NmgooOol02Goo00<007ooOol087oo
00HH5Q`G61LH5aPF71L261L011PF71LH5aPG67oo000lOol00`00Oomoo`0AOol00ekgOomoo`0ROol0
0ekgOomoo`0ROol00ekgOomoo`06Ool00ekgOomoo`0KOol00ekgOomoo`0COol00ekgOomoo`02Ool0
0a`GOolX5`0;Ool2G_L9Ool00ekgOomoo`05Ool00ekgOomoo`04Ool00ekgOomoo`04Ool00ekgOomo
o`05Ool00ekgOomoo`08Ool00ekgOomoo`0@Ool00ekgOomoo`0:Ool00`00Oomoo`0POol<61LHOol0
03aoo`03001oogoo015oo`03G_Moogoo029oo`03G_Moogoo029oo`03G_Moogoo00Moo`9Nma]oo`03
G_Moogoo01Aoo`03G_Moogoo009oo`<X5`]oo`03G_Moogoo00Moo`03G_Moogoo00Eoo`03G_Moogoo
00Aoo`05G_MoogooOomD5`02Ool00ekgOomoo`05Ool00ekgOomoo`08Ool00ekgOomoo`0@Ool00ekg
Oomoo`0:Ool00`00Oomoo`0POol030`G41L<5Q0G31L@5``F41L<5a0G31H@5aQoo`00?7oo00<007oo
Ool04Goo00=NmgooOol08Woo00=NmgooOol08Woo00=NmgooOol02Goo00=NmgooOol05goo00=Nmgoo
Ool05Goo00=NmgooOol00goo00<X5c0G<1L02Goo0Ukg2Woo00=NmgooOol017oo00=NmgooOol017oo
00=NmgooOol00e@G00=ooekgOol01Woo00=NmgooOol027oo0Ukg47oo00=NmgooOol02goo00<007oo
Ool087oo310G67oo000lOol00`00Oomoo`0@Ool00ekgOomoo`0SOol00ekgOomoo`0ROol00ekgOomo
o`0:Ool2G_LGOol00ekgOomoo`0FOol00ekgOomoo`03Ool00c0GOolh5`08Ool2G_L:Ool00ekgOomo
o`04Ool00ekgOomoo`04Ool01EkgOomoogooE1L00Woo00=NmgooOol01Goo00=NmgooOol01goo00=N
mgooG_L03goo00=NmgooOol037oo00<007ooOol087oo00`<5Q0G31L@5``F41L<5a0G31H@5``G41LH
Ool003aoo`03001oogoo011oo`03G_Moogoo02=oo`03G_Moogoo029oo`03G_Moogoo00aoo`03G_Mo
ogoo01Aoo`03G_Moogoo01Moo`03G_Moogoo00=oo`<h5`Moo`03G_Mooekg00Uoo`03G_Moogoo00Eo
o`03G_Moogoo00=oo`03G_Mooe`F00Aoo`03G_Moogoo00Aoo`03G_Moogoo00Qoo`03G_Mooekg00mo
o`03G_Moogoo00aoo`03001oogoo021oo`0521L45`@G11L85`0311L010PG11L45`@G67oo000lOol0
0`00Oomoo`0@Ool00ekgOomoo`0SOol00ekgOomoo`0ROol00ekgOomoo`0=Ool2G_LDOol00ekgOomo
o`0GOol00ekgOomoo`04Ool00cPGA1Moo`05Ool015kgOomooekg2Goo00=NmgooOol01Goo00=Nmgoo
Ool00goo00ANme`FG1ML5P=oo`03G_Moogoo00Aoo`03G_Moogoo00Moo`05G_MoogooOomNm`0=Ool0
0ekgOomoo`0=Ool00`00Oomoo`0POol030@G21L45PPG11L85`@F21L45`PG11H85aQoo`00?7oo00<0
07ooOol047oo00=NmgooOol08goo00=NmgooOol08Goo00=NmgooOol047oo00=NmgooOol04Goo00=N
mgooOol067oo00=NmgooOol00goo00=45d0GA1L01Goo00ENmgooOomooekg00Qoo`03G_Moogoo00Eo
o`03G_Moogoo00=oo`03G_Mooe`F00=oo`03G_Moogoo00Eoo`03G_Moogoo00Moo`05G_MoogooOomN
m`0<Ool00ekgOomoo`0>Ool00`00Oomoo`0POol211L01@PG11L45`@G21L00`@G00<85`@GOol05goo
000lOol00`00Oomoo`0@Ool00ekgOomoo`0SOol00ekgOomoo`0QOol00ekgOomoo`0AOol2G_LAOol0
0ekgOomoo`0IOol00ekgOomoo`03Ool00d@GOom<5`03Ool00ekgOomoo`02Ool00ekgOomoo`07Ool0
0ekgOomoo`04Ool00ekgOomoo`03Ool00ekgG1Aoo`03Ool00ekgOomoo`05Ool00ekgOomoo`07Ool0
0ekgOomoo`02Ool00ekgOomoo`09Ool00ekgOomoo`0>Ool00`00Oomoo`0POol01@0F01L05`0G01H0
0`0G00@05P0G01L05aQoo`00?7oo00<007ooOol047oo00=NmgooOol08goo00=NmgooOol08Goo00=N
mgooOol04goo00=NmgooOol03Woo00=NmgooOol06Goo00=NmgooOol017oo0d`G0Woo00=NmgooOol0
0Woo00=NmgooOol01goo00=NmgooOol017oo00=NmgooOol00goo0e`D0goo00=NmgooOol017oo00=N
mgooOol01goo00=NmgooOol00goo00=NmgooOol027oo00=NmgooOol03goo00<007ooOol087oo300G
67oo000lOol00`00Oomoo`0@Ool00ekgOomoo`0SOol00ekgOomoo`0QOol00ekgOomoo`0DOol2G_L=
Ool00ekgOomoo`0KOol00ekgOomoo`04Ool01D`GE1MoogooG_L01Goo00=NmgooOol01Woo00=Nmgoo
Ool017oo00=NmgooOol00goo00=Nme`DOol00goo00=NmgooOol017oo00=NmgooOol01goo00=Nmgoo
Ool00goo00=NmgooOol01goo00=NmgooOol047oo00<007ooOol087oo0P0G00D05P0G01L05`0F00<0
5`0301H05goo01Moo`00?7oo00<007ooOol047oo00=NmgooOol08goo00=NmgooOol08Goo00=Nmgoo
Ool05Woo00=NmgooOol02Woo00=NmgooOol077oo00=NmgooOol00goo0e@G00=NmgooOol017oo00=N
mgooOol01Woo00=NmgooOol017oo00=NmgooOol00Woo00=L4UkgOol017oo00=NmgooOol017oo00=N
mgooOol01Woo00=NmgooOol01Goo00=NmgooOol01Goo00=NmgooOol04Goo00<007ooOol087oo300G
67oo000lOol00`00Oomoo`0@Ool00ekgOomoo`0SOol00ekgOomoo`0QOol00ekgOomoo`0GOol2G_L:
Ool00ekgOomoo`0MOol00ekgOomoo`03Ool00e@GOomL5P07Ool00ekgOomoo`06Ool00ekgOomoo`03
Ool01ekgOomoogooG19L4E`B00Eoo`03G_Moogoo00Aoo`03G_Moogoo00Ioo`03G_Moogoo00Eoo`03
G_Moogoo00Eoo`03G_Moogoo015oo`03001oogoo021oo`0<03H0E`0g05L0=P1G03L0E`0f05L0=`1G
67oo000lOol00`00Oomoo`0@Ool00ekgOomoo`0ROol00ekgOomoo`0ROol00ekgOomoo`0IOol00ekg
Oomoo`07Ool00ekgOomoo`0MOol00ekgOomoo`04Ool3G1H6Ool00ekgOomoo`06Ool00ekgOomoo`03
Ool00ekgOomoo`02Ool00e`BG_Moo`04Ool00ekgOomoo`03Ool00ekgOomoo`06Ool00ekgOomoo`06
Ool00ekgOomoo`04Ool00ekgOomoo`0BOol00`00Oomoo`0POol<05LHOol003aoo`03001oogoo011o
o`03G_Moogoo029oo`03G_Moogoo029oo`03G_Moogoo01Yoo`9Nm`Moo`03G_Moogoo01ioo`03G_Mo
ogoo00=oo`03G_ML5U`D00Ioo`03G_Moogoo00Ioo`03G_Moogoo00Aoo`06G_MoogooG0mooekg1Goo
00=NmgooOol00goo00=NmgooOol01Woo00=NmgooOol01Woo00=NmgooOol00goo00=NmgooOol04goo
00<007ooOol087oo00`0=`1G03H0E`0g05L0=P1G03L0E`0f05LHOol003aoo`03001oogoo011oo`03
G_Moogoo029oo`03G_Moogoo029oo`03G_Moogoo01aoo`03G_Moogoo00Aoo`03G_Moogoo01moo`03
G_Moogoo009oo`05G_ML55`DG1AL4P05Ool00ekgOomoo`05Ool00ekgOomoo`04Ool00ekgOomL3`02
G0l00ekgOomoo`03Ool00ekgOomoo`03Ool00ekgOomoo`06Ool00ekgOomoo`07Ool00ekgOomoo`02
Ool00ekgOomoo`0COol00`00Oomoo`0POol<09LHOol003aoo`03001oogoo011oo`03G_Moogoo029o
o`03G_Moogoo029oo`03G_Moogoo01eoo`9Nm`Aoo`03G_Moogoo01moo`03G_Moogoo009oo`03G_Mo
oe`D00=L4PAoo`03G_Moogoo00Ioo`03G_Moogoo00=oo`06G_MoogooG0mooekg1Goo00=NmgooOol0
0goo00=NmgooOol01Goo00=NmgooOol027oo00ENmgooOomooekg01Ioo`03001oogoo021oo`0509H0
U`2G09L0UP0309L0102F09L0U`2G67oo000lOol00`00Oomoo`0@Ool00ekgOomoo`0ROol00ekgOomo
o`0ROol00ekgOomoo`0OOol01EkgOomoogooG_L08Woo00ANmgooOomNm`Aoo`03G19ooe`?00Aoo`03
G_Moogoo00Eoo`03G_Moogoo00=oo`03G_ML3Goo009oo`03G_Moogoo009oo`03G_Moogoo00=oo`03
G_Moogoo00Ioo`03G_Moogoo00Qoo`04G_MoogooG_LGOol00`00Oomoo`0POol<09LHOol003aoo`03
001oogoo011oo`03G_Moogoo029oo`03G_Moogoo029oo`03G_Moogoo021oo`=NmbAoo`03G_Mooekg
00Eoo`03G0mL45`?00=oo`03G_Moogoo00Eoo`03G_Moogoo00=oo`=L3@9oo`03G_Moogoo009oo`03
G_Moogoo00=oo`03G_Moogoo00Eoo`03G_Moogoo00Uoo`04G_MoogooG_LGOol00`00Oomoo`0POol0
303G0?L0eP3g0=L0m`3F0?L0e`3g0=H0maQoo`00?7oo00<007ooOol047oo00=NmgooOol08Woo00=N
mgooOol08Woo00=NmgooOol08Woo00=NmgooOol08Woo00=NmgooG_L01Woo00ML3e`=G0eL2gooG_Ml
0006Ool00ekgOomoo`03Ool00ekgG0eoo`02Ool00ekgOomoo`02Ool00ekgOomoo`03Ool00ekgOomo
o`05Ool00ekgOomoo`09Ool00ekgOomNm`0HOol00`00Oomoo`0POol<0=LHOol003aoo`80015oo`03
G_Moogoo029oo`03G_Moogoo029oo`03G_Moogoo029oo`=Nmb=oo`9Nm`Moo`04G0eL2e`:G0/3O005
Ool00ekgOomoo`03Ool00e`;Oomoo`02Ool00ekgOomoo`02Ool00ekgOomoo`03Ool00ekgOomoo`05
Ool00ekgOomoo`0:Ool00ekgOomoo`0FOol2000ROol0303F0?L0e`3g0=H0m`3G0?L0eP3g0=L0maQo
o`00?7oo00<007ooOol047oo00=NmgooOol08Woo00=NmgooOol08Woo00=NmgooOol08Woo00ANmgoo
OomNmb9oo`9Nm`Uoo`05G0]L25`8O01L1006Ool015kgOomoogoo0e`;0goo00=NmgooOol00Woo00=N
mgooOol00goo00=NmgooOol017oo00=NmgooOol02Woo0Ukg6Goo00<007ooOol087oo304g67oo000l
Ool00`00Oomoo`0@Ool00ekgOomoo`0ROol00ekgOomoo`0ROol00ekgOomoo`0ROol015kgOomoogoo
0Ukg87oo0Ukg2Woo00AL25`6G0ANm`Ioo`06G_MoogooG0Qooe`;17oo00=NmgooOol00Woo00=Nmgoo
Ool00Woo00=NmgooOol01Goo00=NmgooOol02Woo0Ukg6Goo00<007ooOol087oo0P4g00D1=P4g0CL1
=`4f00<1=`030CH1=goo01Moo`00?7oo00<007ooOol047oo00=NmgooOol08Woo00=NmgooOol08Woo
00=NmgooOol08Woo00=NmgooOol00goo00=NmgooOol07Goo00=NmgooG_L037oo00=NmgooOol017oo
00=NmgooG0P00U`800=NmgooOol00Woo00=NmgooOol00Woo00=NmgooOol00Woo00=NmgooOol017oo
00=NmgooOol02Woo00=NmgooG_L06Goo00<007ooOol087oo304g67oo000lOol00`00Oomoo`0@Ool0
0ekgOomoo`0ROol00ekgOomoo`0QOol00ekgOomoo`0SOol00ekgOomoo`04Ool2G_LMOol015kgOomo
oekg2goo00=NmgooOol017oo00ANmgooG0IL209oo`05G_MoogooOomNm`04Ool00ekgOomoo`02Ool0
0ekgOomoo`04Ool00ekgOomoo`09Ool015kgOomooekg6Goo00<007ooOol087oo00D1=P4g0CL1=`4f
00<1=`040CH1=`4g0CLHOol003aoo`03001oogoo011oo`03G_Moogoo029oo`03G_Moogoo025oo`03
G_Moogoo02=oo`03G_Moogoo00Ioo`03G_Moogoo01Uoo`03G_Moogoo009oo`03G_Moogoo00Uoo`03
G_Moogoo00Aoo`=L1P9oo`05G_MoogooOomNm`04Ool00ekgOomoo`02Ool00ekgOomoo`04Ool00ekg
Oomoo`09Ool01EkgOomoogooG_L067oo00<007ooOol087oo305g67oo000lOol00`00Oomoo`0@Ool0
0ekgOomoo`0ROol00ekgOomoo`0QOol00ekgOomoo`0SOol00ekgOomoo`07Ool2G_LIOol00ekgOomo
o`02Ool00ekgOomoo`09Ool00ekgOomoo`03Ool00e`4O01L1P03Ool01EkgOomoogooG_L00goo00=N
mgooOol00Woo00=NmgooOol017oo00=NmgooOol02Goo00=NmgooOol00Woo00=NmgooOol05Woo00<0
07ooOol087oo0P5g00D1MP5g0GL1M`5f00<1M`030GH1Mgoo01Moo`00?7oo00<007ooOol047oo00=N
mgooOol08Woo00=NmgooOol08Goo00=NmgooOol08Woo00=NmgooOol02Woo00=NmgooOol05Woo00=N
mgooOol00goo00=NmgooOol02Goo00=NmgooOol00Woo0g`00goo00ENmgooOomooekg00=oo`03G_Mo
ogoo009oo`03G_Moogoo00Aoo`03G_Moogoo00Qoo`03G_Moogoo00=oo`03G_Moogoo01Ioo`03G_Mo
ogoo021oo``1MaQoo`00?7oo00<007ooOol047oo00=NmgooOol08Woo00=NmgooOol08Goo00=Nmgoo
Ool08Woo00=NmgooOol02goo0Ukg5Woo00=NmgooOol017oo00=NmgooOol027oo00=NmgooOol00goo
00=l07ooOol00Woo00ENmgooOomooekg00=oo`03G_Moogoo009oo`03G_Moogoo00=oo`03G_Moogoo
00Uoo`03G_Moogoo00=oo`03G_Moogoo01Aoo`9Nm`03001oogoo021oo`0<0KH1e`6g0ML1]P7G0KL1
e`6f0ML1]`7G67oo000lOol00`00Oomoo`0@Ool00ekgOomoo`0ROol00ekgOomoo`0QOol00ekgOomo
o`0ROol00ekgOomoo`0=Ool00ekgOomoo`0COol00ekgOomoo`04Ool00ekgOomoo`08Ool00ekgOomo
o`04Ool01EkgOomoogooG_L00goo00ENmgooOomooekg00Aoo`03G_Moogoo00=oo`03G_Moogoo00Qo
o`03G_Moogoo00Aoo`03G_Moogoo01=oo`04G_Moogoo000ROol<0MLHOol003aoo`03001oogoo011o
o`03G_Moogoo029oo`03G_Moogoo025oo`03G_Moogoo029oo`03G_Moogoo00ioo`9Nma9oo`03G_Mo
ogoo00Ioo`03G_Moogoo00Qoo`03G_Moogoo00=oo`05G_MoogooOomNm`03Ool01EkgOomoogooG_L0
0goo00=NmgooOol017oo00=NmgooOol01goo00=NmgooOol01Woo00=NmgooOol047oo0Ukg0goo00<0
07ooOol087oo00`1]`7G0KH1e`6g0ML1]P7G0KL1e`6f0MLHOol003aoo`03001oogoo011oo`03G_Mo
ogoo029oo`03G_Moogoo025oo`03G_Moogoo029oo`03G_Moogoo011oo`03G_Moogoo00moo`03G_Mo
ogoo00Moo`03G_Moogoo00Moo`03G_Moogoo00=oo`05G_MoogooOomNm`03Ool01EkgOomoogooG_L0
0goo00=NmgooOol00goo00=NmgooOol01goo00=NmgooOol01goo00=NmgooOol03goo00=NmgooOol0
0goo00<007ooOol087oo308G67oo000lOol00`00Oomoo`0@Ool00ekgOomoo`0QOol00ekgOomoo`0R
Ool00ekgOomoo`0ROol00ekgOomoo`0AOol00ekgOomoo`0>Ool00ekgOomoo`07Ool00ekgOomoo`07
Ool00ekgOomoo`03Ool01EkgOomoogooG_L00goo00ENmgooOomooekg00=oo`03G_Moogoo00=oo`03
G_Moogoo00Moo`03G_Moogoo00Moo`03G_Moogoo00eoo`9Nm`Ioo`03001oogoo021oo`050QH25`8G
0QL25P030QL0108F0QL25`8G67oo000lOol00`00Oomoo`0@Ool00ekgOomoo`0QOol00ekgOomoo`0R
Ool00ekgOomoo`0ROol00ekgOomoo`0BOol2G_L>Ool00ekgOomoo`08Ool00ekgOomoo`07Ool00ekg
Oomoo`02Ool00ekgOomoo`02Ool015kgOomooekg0goo00ENmgooOomooekg00Aoo`03G_Moogoo00Mo
o`03G_Moogoo00Qoo`03G_Moogoo00aoo`03G_Moogoo00Ioo`03001oogoo021oo``25aQoo`00?7oo
00<007ooOol047oo00=NmgooOol08Goo00=NmgooOol08Woo00=NmgooOol08Woo00=NmgooOol057oo
00=NmgooOol02goo00=NmgooOol02Goo00=NmgooOol01Woo00=NmgooOol00goo00ENmgooOomooekg
009oo`05G_MoogooOomNm`03Ool00ekgOomoo`02Ool00ekgOomoo`06Ool00ekgOomoo`09Ool00ekg
Oomoo`0:Ool2G_L9Ool00`00Oomoo`0POol0309G0WL2EP9g0UL2M`9F0WL2E`9g0UH2MaQoo`00?7oo
00<007ooOol047oo00=NmgooOol08Goo00=NmgooOol08Woo00=NmgooOol08Woo00=NmgooOol05Goo
0Ukg2goo00=NmgooOol02Goo00=NmgooOol01goo00=NmgooOol00Woo00ENmgooOomooekg009oo`04
G_MoogooG_L3Ool00ekgOomoo`03Ool00ekgOomoo`06Ool00ekgOomoo`0:Ool00ekgOomoo`08Ool0
0ekgOomoo`09Ool00`00Oomoo`0POol<0ULHOol003aoo`03001oogoo011oo`03G_Moogoo025oo`03
G_Moogoo029oo`03G_Moogoo029oo`03G_Moogoo01Moo`03G_Moogoo00Qoo`03G_Moogoo00Yoo`03
G_Moogoo00Ioo`03G_Moogoo009oo`05G_MoogooOomNm`02Ool015kgOomooekg0goo00=NmgooOol0
0Woo00=NmgooOol01Woo00=NmgooOol02goo00=NmgooOol01Woo0Ukg37oo00<007ooOol087oo00`2
EP9g0UL2M`9F0WL2E`9g0UH2M`9G0WLHOol003aoo`03001oogoo011oo`03G_Moogoo025oo`03G_Mo
ogoo029oo`03G_Moogoo029oo`03G_Moogoo01Qoo`9Nm`Qoo`03G_Moogoo00]oo`03G_Moogoo00Eo
o`03G_Moogoo009oo`05G_MoogooOomNm`02Ool015kgOomooekg0goo00=NmgooOol00Woo00=Nmgoo
Ool01Goo00=NmgooOol037oo00=NmgooOol01Goo00=NmgooOol037oo00<007ooOol087oo309G67oo
000lOol00`00Oomoo`0?Ool00ekgOomoo`0ROol00ekgOomoo`0ROol00ekgOomoo`0QOol00ekgOomo
o`0KOol00ekgOomoo`04Ool00ekgOomoo`0=Ool00ekgOomoo`05Ool00ekgOomoo`02Ool015kgOomo
oekg0Woo00ANmgooOomNm`=oo`05G_MoogooOomNm`08Ool00ekgOomoo`0<Ool00ekgOomoo`03Ool2
G_L?Ool00`00Oomoo`0POol20[L01@:f0[L2]`:g0[H00`:g00<2]P:gOol05goo000lOol00`00Oomo
o`0?Ool00ekgOomoo`0ROol00ekgOomoo`0ROol00ekgOomoo`0QOol00ekgOomoo`0LOol2G_L4Ool0
0ekgOomoo`0=Ool00ekgOomoo`05Ool00ekgOomoo`02Ool015kgOomooekg0Woo00ANmgooOomNm`9o
o`03G_Moogoo009oo`03G_Moogoo00Eoo`03G_Moogoo00eoo`03G_Moogoo009oo`03G_Moogoo00mo
o`03001oogoo021oo``2]aQoo`00?7oo00<007ooOol03goo00=NmgooOol08Woo00=NmgooOol08Woo
00=NmgooOol08Goo00=NmgooOol07Woo00ENmgooOomooekg011oo`03G_Moogoo00Eoo`05G_Moogoo
OomNm`02Ool015kgOomooekg0Woo00ANmgooOomNm`Aoo`03G_Moogoo00Aoo`03G_Moogoo00ioo`03
G_Moogoo009Nma9oo`03001oogoo021oo`050[H2]`:g0[L2]P030[L010:f0[L2]`:g67oo000lOol0
0`00Oomoo`0?Ool00ekgOomoo`0ROol00ekgOomoo`0ROol00ekgOomoo`0QOol00ekgOomoo`0OOol2
G_L00gooG_Moo`0@Ool00ekgOomoo`04Ool01EkgOomoogooG_L00Woo00ANmgooOomNm`9oo`04G_Mo
ogooG_L3Ool00ekgOomoo`04Ool00ekgOomoo`0@Ool2G_LDOol00`00Oomoo`0POol<0_LHOol003ao
o`03001oogoo00moo`03G_Moogoo029oo`03G_Moogoo029oo`03G_Moogoo025oo`03G_Moogoo025o
o`9Nma5oo`03G_Moogoo00Aoo`05G_MoogooOomNm`02Ool015kgOomooekg0Woo00ANmgooOomNm`=o
o`03G_Moogoo00Aoo`03G_Moogoo00moo`9NmaEoo`03001oogoo021oo`82m`050_H2m`;g0_L2mP03
0_L00`;f0_Moo`0GOol003aoo`80011oo`03G_Moogoo029oo`03G_Moogoo029oo`03G_Moogoo025o
o`03G_Moogoo029oo`9Nma5oo`03G_Moogoo00Aoo`05G_MoogooOomNm`02Ool00ekgOomNm`02Ool0
0ekgOomNm`03Ool00ekgOomoo`04Ool00ekgOomoo`0?Ool00ekgOomNm`0DOol2000ROol<0_LHOol0
03aoo`03001oogoo00moo`03G_Moogoo029oo`03G_Moogoo029oo`03G_Moogoo025oo`03G_Moogoo
029oo`03G_Mooekg015oo`03G_Moogoo00=oo`05G_MoogooOomNm`02Ool01EkgOomNmgooG_L00Woo
00ENmgooOomooekg00Eoo`03G_Moogoo00ioo`9Nm`9oo`03G_Moogoo01=oo`03001oogoo021oo`0<
0_@2m@;d0_D2m0;e0_@2m@;d0_D2m0;e67oo000lOol00`00Oomoo`0?Ool00ekgOomoo`0ROol00ekg
Oomoo`0ROol00ekgOomoo`0QOol00ekgOomoo`0ROol00ekgOomoo`02G_L?Ool00ekgOomoo`04Ool0
15kgOomooekg0Woo00ENmgooG_Mooekg009oo`05G_MoogooOomNm`05Ool00ekgOomoo`0=Ool00ekg
Oomoo`02Ool00ekgOomoo`0COol00`00Oomoo`0POol030;e0_@2m@;d0_D2m0;e0_@2m@;d0_D2m1Qo
o`00?7oo00<007ooOol03goo00=NmgooOol08Woo00=NmgooOol08Woo00=NmgooOol08Goo00=Nmgoo
Ool08Woo00=NmgooOol00Woo00=NmgooOol03Goo00=NmgooOol00goo00ANmgooOomNm`9oo`05G_Mo
oekgOomNm`02Ool015kgOomooekg1Goo00=NmgooOol03Goo00=NmgooOol00goo00=NmgooOol04goo
00<007ooOol087oo00`2m0;e0_@2m@;d0_D2m0;e0_@2m@;d0_DHOol003aoo`03001oogoo00moo`03
G_Moogoo029oo`03G_Moogoo029oo`03G_Moogoo025oo`03G_Moogoo029oo`03G_Moogoo00=oo`9N
m`ioo`03G_Moogoo009oo`0=G_MoogooOomNmgooG_MooekgOomNmgooG_L00goo00=NmgooOol00Woo
00=NmgooOol037oo0Ukg1Woo00=NmgooOol04goo00<007ooOol087oo30;b67oo000lOol00`00Oomo
o`0?Ool00ekgOomoo`0ROol00ekgOomoo`0ROol00ekgOomoo`0QOol00ekgOomoo`0ROol00ekgOomo
o`05Ool00ekgOomoo`0<Ool00ekgOomoo`02Ool035kgOomooekgOomNmgooG_MooekgOomNm`9oo`03
G_Moogoo00=oo`03G_Moogoo00]oo`03G_Moogoo00Ioo`03G_Moogoo01=oo`03001oogoo021oo`03
0_82l`;b0082lP050_<2lP;b0_82l`020_8HOol003aoo`03001oogoo00moo`03G_Moogoo029oo`03
G_Moogoo025oo`03G_Moogoo029oo`03G_Moogoo025oo`03G_Moogoo00Moo`9Nm`aoo`03G_Moogoo
009oo`0<G_MoogooG_MooekgOomNmgooG_Mooekg0Woo00=NmgooOol00Woo00=NmgooOol02Woo0Ukg
2Goo00=NmgooOol04goo00<007ooOol087oo30;b67oo000lOol00`00Oomoo`0?Ool00ekgOomoo`0R
Ool00ekgOomoo`0QOol00ekgOomoo`0ROol00ekgOomoo`0QOol00ekgOomoo`09Ool00ekgOomoo`0:
Ool00ekgOomoo`02Ool03EkgOomNmgooG_MooekgOomNmgooG_Mooekg00Aoo`03G_Moogoo00Yoo`03
G_Moogoo00Uoo`03G_Moogoo01=oo`03001oogoo021oo`<2lP050_<2lP;b0_82l`030_800`;cOomo
o`0FOol003aoo`03001oogoo00moo`03G_Moogoo029oo`03G_Moogoo025oo`03G_Moogoo029oo`03
G_Moogoo025oo`03G_Moogoo00Yoo`9Nm`]oo`05G_MoogooOomNm`02Ool2G_L027ooG_MooekgOomN
mgooG_L3Ool00ekgOomoo`09Ool2G_L<Ool00ekgOomoo`0COol00`00Oomoo`0POol<0_0HOol003ao
o`03001oogoo00moo`03G_Moogoo029oo`03G_Moogoo025oo`03G_Moogoo029oo`03G_Moogoo025o
o`03G_Moogoo00aoo`03G_Moogoo00Qoo`05G_MoogooOomNm`02Ool01EkgOomNmekgOol00Ukg0Woo
00ENmgooOomooekg00Yoo`03G_Moogoo00aoo`03G_Moogoo01=oo`03001oogoo021oo`0<0^l2l0;_
0_02k`;`0^l2l0;_0_02k`;`67oo000lOol00`00Oomoo`0?Ool00ekgOomoo`0ROol00ekgOomoo`0Q
Ool00ekgOomoo`0ROol00ekgOomoo`0QOol00ekgOomoo`0=Ool2G_L9Ool025kgOomoogooG_Mooekg
Ool3G_L017ooG_Mooekg0goo00=NmgooOol01goo0Ukg3goo00=NmgooOol04goo00<007ooOol087oo
30;`67oo000lOol00`00Oomoo`0?Ool00ekgOomoo`0ROol00ekgOomoo`0QOol00ekgOomoo`0ROol0
0ekgOomoo`0QOol00ekgOomoo`0?Ool00ekgOomoo`07Ool01ekgOomooekgOomNmgoo00=Nm`04OomN
mgooG_L2Ool00ekgOomoo`07Ool00ekgOomoo`0?Ool00ekgOomoo`0COol00`00Oomoo`0POol030;]
0^h2k@;^0^d2kP;]0^h2k@;^0^d2kQQoo`00?7oo00<007ooOol03goo00=NmgooOol08Goo00=Nmgoo
Ool08Woo00=NmgooOol08Goo00=NmgooOol08Woo00=NmgooOol047oo0Ukg1goo00ANmgooOomoo`9N
m`05OomNmekgG_Moo`02G_L3Ool00ekgOomoo`05Ool2G_LBOol00ekgOomoo`0COol00`00Oomoo`0P
Ool20^d01@;^0^d2k@;]0^h00`;]00<2kP;]Ool05goo000lOol00`00Oomoo`0?Ool00ekgOomoo`0Q
Ool00ekgOomoo`0ROol00ekgOomoo`0QOol00ekgOomoo`0ROol00ekgOomoo`0BOol00ekgOomoo`05
Ool01EkgOomooekgOol01Ekg00EooekgOomooekg00Moo`03G_Moogoo019oo`03G_Moogoo01=oo`03
001oogoo021oo`0<0^d2kP;]0^h2k@;^0^d2kP;]0^h2k@;^67oo000lOol00`00Oomoo`0?Ool00ekg
Oomoo`0QOol00ekgOomoo`0ROol00ekgOomoo`0QOol00ekgOomoo`0ROol00ekgOomoo`0COol2G_L6
Ool015kgOomNmgoo1Ekg00AooekgOomNm`Ioo`9NmaEoo`03G_Moogoo01=oo`03001oogoo021oo``2
jaQoo`00?7oo00<007ooOol03goo00=NmgooOol08Goo00=NmgooOol08Woo00=NmgooOol08Goo00=N
mgooOol08Woo00=NmgooOol05Goo00=NmgooOol00goo00=NmgooOol01ekg0Woo00=NmgooOol00goo
00=NmgooOol05Goo00=NmgooOol04goo00<007ooOol087oo0P;[00D2jP;[0^/2j`;Z00<2j`030^X2
jgoo01Moo`00?7oo00<007ooOol03goo00=NmgooOol08Goo00=NmgooOol08Woo00=NmgooOol08Goo
00=NmgooOol08Woo00=NmgooOol05Woo0Ukg17oo00=NmgooG_L01Ukg00=ooekgOol00goo0Ukg67oo
00=NmgooOol04goo00<007ooOol087oo30;[67oo000lOol00`00Oomoo`0?Ool00ekgOomoo`0QOol0
0ekgOomoo`0ROol00ekgOomoo`0QOol00ekgOomoo`0ROol00ekgOomoo`0HOol00ekgOomoo`02Ool0
0ekgOomNm`04G_L00gooG_Moo`03Ool00ekgOomoo`0IOol00ekgOomoo`0BOol00`00Oomoo`0POol0
30;X0^T2j0;Y0^P2j@;X0^T2j0;Y0^P2jAQoo`00?7oo00<007ooOol03goo00=NmgooOol08Goo00=N
mgooOol08Woo00=NmgooOol08Goo00=NmgooOol08Woo00=NmgooOol06Goo0Ukg0goo1ekg0goo0Ukg
77oo00=NmgooOol04Woo00<007ooOol087oo00`2j@;X0^T2j0;Y0^P2j@;X0^T2j0;Y0^PHOol001Yo
o`8000Qoo`8001Ioo`03001oogoo00moo`03G_Moogoo025oo`03G_Moogoo029oo`03G_Moogoo025o
o`03G_Moogoo029oo`03G_Moogoo01]oo`03G_Moogoo00MNm`9oo`03G_Moogoo01aoo`03G_Moogoo
019oo`03001oogoo021oo`0<0^P2j@;X0^T2j0;Y0^P2j@;X0^T2j0;Y67oo000JOol00`00Oomoo`08
Ool00`00Oomoo`0DOol00`00Oomoo`0?Ool00ekgOomoo`0QOol00ekgOomoo`0ROol00ekgOomoo`0Q
Ool00ekgOomoo`0ROol00ekgOomoo`0LOol2G_L00gooG_MNm`03G_L00gooG_MNm`0OOol00ekgOomo
o`0BOol00`00Oomoo`0POol030;Y0^P2j@;X0^T2j0;Y0^P2j@;X0^T2j1Qoo`0037oo0`0000Ioo`00
Ool007oo0005Ool01000Oomoogoo0P001Goo00<007ooOol03Woo00<007ooOol00goo00<007ooOol0
3goo00=NmgooOol08Goo00=NmgooOol08Woo00=NmgooOol08Goo00=NmgooOol08Woo00=NmgooOol0
7Woo00=NmgooG_L00Ukg00=ooekgOol087oo00=NmgooOol04Woo00<007ooOol087oo00<2iP;W0^H0
0P;V00D2i`;V0^H2iP;W0082iQQoo`003Goo00P007ooOol007oo001oo`001Goo00<007ooOol00goo
00<007ooOol00Woo00<007ooOol03Goo00<007oo000017oo00<007ooOol03goo00<3h7ooOol08Goo
00=NmgooOol08Woo00=NmgooOol03goo00Yl000G0?L1e`:g0_@2k`;[0^H2h@Qoo`030n1oogoo029o
o`03G_Moogoo01moo`ENmb9oo`03G_Moogoo019oo`03001oogoo021oo``2iQQoo`003Goo00P007oo
Ool007oo001oo`001Goo00<007ooOol00Woo00<007ooOol00goo00<007ooOol03Goo00<007oo0000
17oo4Ekg0`?PF5kg0g`000T1e`:g0_@2k`;[0^H2h@;R0^401Ukg0`?PPUkg8Woo0`;V00D2i`;V0^H2
iP;W00<2iP030^Moogoo01Ioo`003Goo00<007ooOol00P0000=oo`00Ool01Goo00<007ooOol00Woo
0P0017oo00<007ooOol03Goo00<007oo000017oo00<007ooOol03goo00<3h7ooOol08Goo00=Nmgoo
Ool08Woo00=NmgooOol03goo00Yl000G0?L1e`:g0_@2k`;[0^H2h@Qoo`030n1oogoo029oo`03G_Mo
ogoo01moo`ENmb9oo`03G_Moogoo019oo`03001oogoo021oo``2i1Qoo`003Goo00<007ooOol02Woo
00<007ooOol027oo00<007ooOol03Goo00<007oo000017oo00<007ooOol03goo00=NmgooOol08Goo
00=NmgooOol08Woo00=NmgooOol08Goo00=NmgooOol08Woo00=NmgooOol07Woo00=NmgooG_L00Ukg
00=ooekgOol087oo00=NmgooOol04Woo00<007ooOol087oo00`2h`;T0^<2i0;S0^@2h`;T0^<2i0;S
0^@HOol000aoo`<000]oo`8000Qoo`80011oo`03001oogoo00=oo`03001oogoo00moo`03G_Moogoo
025oo`03G_Moogoo029oo`03G_Moogoo025oo`03G_Moogoo029oo`03G_Moogoo01aoo`9Nm`03OomN
mekg00=Nm`03OomNmekg01moo`03G_Moogoo019oo`03001oogoo021oo``2i0Eoo`<0009oo`03001o
ogoo009oo`03001oogoo00Ioo`00?7oo00<007ooOol03goo00=NmgooOol08Goo00=NmgooOol08Woo
00=NmgooOol08Goo00=NmgooOol08Woo00=NmgooOol06goo00=NmgooOol01ekg0Woo00=NmgooOol0
77oo00=NmgooOol04Woo00<007ooOol087oo00`2h@;R0^42hP;Q0^82h@;R0^42hP;Q0^86Ool01P00
Oomoo`00Ool000aoo`00?7oo00<007ooOol03goo00=NmgooOol08Goo00=NmgooOol08Woo00=Nmgoo
Ool08Goo00=NmgooOol08Woo00=NmgooOol06Goo0Ukg0goo1Ukg00AooekgOomoo`9Nmaaoo`03G_Mo
ogoo019oo`03001oogoo021oo`82h@050^82h@;Q0^42hP030^400`;R0^5oo`03Ool4000017oo001o
o`0037oo000lOol00`00Oomoo`0?Ool00ekgOomoo`0QOol00ekgOomoo`0ROol00ekgOomoo`0QOol0
0ekgOomoo`0ROol00ekgOomoo`0HOol00ekgOomoo`02Ool00ekgOomNm`04G_L00gooG_Moo`03Ool0
0ekgOomoo`0HOol00ekgOomoo`0COol00`00Oomoo`0POol030;Q0^82h@;R0^42hP;Q0^82h@;R0^42
hPAoo`03001oo`00009oo`03001oo`0000aoo`00?7oo00<007ooOol03goo00=NmgooOol08Goo00=N
mgooOol08Woo00=NmgooOol08Goo00=NmgooOol08Woo00=NmgooOol05Woo0Ukg17oo00=NmgooG_L0
1Ukg00=ooekgOol00goo0Ukg67oo00=NmgooOol04goo00<007ooOol0<Goo0P000Woo00<007oo0000
37oo000lOol00`00Oomoo`0?Ool00ekgOomoo`0QOol00ekgOomoo`0ROol00ekgOomoo`0QOol00ekg
Oomoo`0ROol00ekgOomoo`0EOol00ekgOomoo`03Ool00ekgOomoo`07G_L2Ool00ekgOomoo`03Ool0
0ekgOomoo`0EOol00ekgOomoo`0COol00`00Oomoo`0bOol01@00Oomoogoo00003Goo000lOol00`00
Oomoo`0?Ool00ekgOomoo`0QOol00ekgOomoo`0ROol00ekgOomoo`0QOol00ekgOomoo`0ROol00ekg
Oomoo`0COol2G_L6Ool015kgOomNmgoo1Ekg00AooekgOomNm`Ioo`9NmaEoo`03G_Moogoo01=oo`03
001oogoo04Aoo`00?7oo00<007ooOol03goo00=NmgooOol08Goo00=NmgooOol08Woo00=NmgooOol0
8Goo00=NmgooOol08Woo00=NmgooOol04Woo00=NmgooOol01Goo00ENmgooOomNmgoo00ENm`05OomN
mgooOomNm`07Ool2G_LCOol00ekgOomoo`0COol00`00Oomoo`14Ool003aoo`03001oogoo00moo`03
G_Moogoo025oo`03G_Moogoo029oo`03G_Moogoo025oo`03G_Moogoo029oo`03G_Moogoo011oo`9N
m`Moo`04G_MoogooOol2G_L01GooG_MNmekgOol00Ukg0goo00=NmgooOol01Woo00=NmgooOol047oo
00=NmgooOol04goo00<007ooOol0A7oo000lOol00`00Oomoo`0?Ool00ekgOomoo`0ROol00ekgOomo
o`0QOol00ekgOomoo`0ROol00ekgOomoo`0QOol00ekgOomoo`0?Ool00ekgOomoo`07Ool01ekgOomo
oekgOomNmgoo00=Nm`04OomNmgooG_L2Ool00ekgOomoo`07Ool2G_L@Ool00ekgOomoo`0COol00`00
Oomoo`14Ool003aoo`03001oogoo00moo`03G_Moogoo029oo`03G_Moogoo025oo`03G_Moogoo029o
o`03G_Moogoo025oo`03G_Moogoo00eoo`9Nm`Uoo`08G_MoogooOomNmgooG_Moo`=Nm`04OomNmgoo
G_L3Ool00ekgOomoo`08Ool00ekgOomoo`0=Ool00ekgOomoo`0COol00`00Oomoo`14Ool003aoo`03
001oogoo00moo`03G_Moogoo029oo`03G_Moogoo025oo`03G_Moogoo029oo`03G_Moogoo025oo`03
G_Moogoo00aoo`03G_Moogoo00Qoo`05G_MoogooOomNm`02Ool01EkgOomNmekgOol00Ukg0Woo00EN
mgooOomooekg00Yoo`9Nm`eoo`03G_Moogoo01=oo`03001oogoo04Aoo`00?7oo00<007ooOol03goo
00=NmgooOol08Woo00=NmgooOol08Goo00=NmgooOol08Woo00=NmgooOol08Goo00=NmgooOol02Woo
0Ukg2goo00ENmgooOomooekg009oo`9Nm`08OomNmgooG_MooekgOomNm`Aoo`03G_Moogoo00Uoo`03
G_Moogoo00Yoo`03G_Moogoo01=oo`03001oogoo04Aoo`00?7oo00<007ooOol03goo00=NmgooOol0
8Woo00=NmgooOol08Goo00=NmgooOol08Woo00=NmgooOol08Goo00=NmgooOol02Goo00=NmgooOol0
2Woo00=NmgooOol00Woo00eNmgooG_MooekgOomNmgooG_MooekgOomNm`04Ool00ekgOomoo`0:Ool2
G_L:Ool00ekgOomoo`0COol00`00Oomoo`14Ool003aoo`03001oogoo00moo`03G_Moogoo029oo`03
G_Moogoo029oo`03G_Moogoo025oo`03G_Moogoo029oo`03G_Moogoo00Ioo`9Nm`aoo`03G_Moogoo
009oo`0<G_MoogooG_MooekgOomNmgooG_Mooekg0Woo00=NmgooOol00Woo00=NmgooOol02goo00=N
mgooOol01goo00=NmgooOol04goo00<007ooOol0A7oo000lOol00`00Oomoo`0?Ool00ekgOomoo`0R
Ool00ekgOomoo`0ROol00ekgOomoo`0QOol00ekgOomoo`0ROol00ekgOomoo`05Ool00ekgOomoo`0<
Ool00ekgOomoo`02Ool035kgOomooekgOomNmgooG_MooekgOomNm`9oo`03G_Moogoo00=oo`03G_Mo
ogoo00]oo`9Nm`Moo`03G_Moogoo01=oo`03001oogoo04Aoo`00?7oo00<007ooOol03goo00=Nmgoo
Ool08Woo00=NmgooOol08Woo00=NmgooOol08Goo00=NmgooOol08Woo00=NmgooOol00goo0Ukg3Woo
00=NmgooOol00Woo00eNmgooOomooekgOomNmgooG_MooekgOomNm`03Ool00ekgOomoo`02Ool00ekg
Oomoo`0=Ool00ekgOomoo`04Ool00ekgOomoo`0COol00`00Oomoo`14Ool003aoo`03001oogoo00mo
o`03G_Moogoo029oo`03G_Moogoo029oo`03G_Moogoo025oo`03G_Moogoo029oo`03G_Moogoo009o
o`03G_Moogoo00eoo`03G_Moogoo00=oo`04G_MoogooG_L2Ool01EkgOomNmgooG_L00Woo00ANmgoo
OomNm`Eoo`03G_Moogoo00eoo`9Nm`Aoo`03G_Moogoo01=oo`03001oogoo04Aoo`00?7oo00<007oo
Ool03goo00=NmgooOol08Woo00=NmgooOol08Woo00=NmgooOol08Goo00=NmgooOol08Woo00=Nmgoo
Ool00Ukg3goo00=NmgooOol017oo00ANmgooOomNm`9oo`05G_MooekgOomNm`02Ool01EkgOomoogoo
G_L01Goo00=NmgooOol03Woo00ENmgooOomooekg01Eoo`03001oogoo04Aoo`00?7oo00<007ooOol0
3goo00=NmgooOol08Woo00=NmgooOol08Woo00=NmgooOol08Goo00=NmgooOol08Woo00=NmgooG_L0
4Goo00=NmgooOol00goo00ENmgooOomooekg009oo`05G_MooekgOomNm`02Ool01EkgOomoogooG_L0
1Woo00=NmgooOol03Woo0Ukg00=ooekgOol057oo00<007ooOol0A7oo000lOol2000@Ool00ekgOomo
o`0ROol00ekgOomoo`0ROol00ekgOomoo`0QOol00ekgOomoo`0ROol2G_LAOol00ekgOomoo`04Ool0
1EkgOomoogooG_L00Woo00=NmgooG_L00Woo00=NmgooG_L00goo00=NmgooOol017oo00=NmgooOol0
47oo0Ukg57oo0P00AWoo000lOol00`00Oomoo`0?Ool00ekgOomoo`0ROol00ekgOomoo`0ROol00ekg
Oomoo`0QOol00ekgOomoo`0QOol2G_LAOol00ekgOomoo`04Ool01EkgOomoogooG_L00Woo00ANmgoo
OomNm`9oo`04G_MoogooG_L3Ool00ekgOomoo`04Ool00ekgOomoo`0@Ool2G_LDOol00`00Oomoo`14
Ool003aoo`03001oogoo00moo`03G_Moogoo029oo`03G_Moogoo029oo`03G_Moogoo025oo`03G_Mo
ogoo01moo`9Nm`03OomNmgoo011oo`03G_Moogoo00Aoo`05G_MoogooOomNm`02Ool015kgOomooekg
0Woo00ANmgooOomNm`=oo`03G_Moogoo00Eoo`03G_Moogoo00ioo`04G_MoogooG_LCOol00`00Oomo
o`14Ool003aoo`03001oogoo00moo`03G_Moogoo029oo`03G_Moogoo029oo`03G_Moogoo025oo`03
G_Moogoo01ioo`05G_MoogooOomNm`0@Ool00ekgOomoo`05Ool01EkgOomoogooG_L00Woo00ANmgoo
OomNm`9oo`04G_MoogooG_L4Ool00ekgOomoo`04Ool00ekgOomoo`0>Ool015kgOomoogoo0Ukg4Goo
00<007ooOol0A7oo000lOol00`00Oomoo`0?Ool00ekgOomoo`0ROol00ekgOomoo`0ROol00ekgOomo
o`0QOol00ekgOomoo`0LOol2G_L4Ool00ekgOomoo`0=Ool00ekgOomoo`05Ool00ekgOomoo`02Ool0
15kgOomooekg0Woo00ANmgooOomNm`9oo`03G_Moogoo009oo`03G_Moogoo00Eoo`03G_Moogoo00eo
o`03G_Moogoo00=oo`03G_Moogoo00ioo`03001oogoo04Aoo`00?7oo00<007ooOol03goo00=Nmgoo
Ool08Woo00=NmgooOol08Woo00=NmgooOol08Goo00=NmgooOol06goo00=NmgooOol01Goo00=Nmgoo
Ool037oo00=NmgooOol01Goo00=NmgooOol00Woo00ANmgooOomNm`9oo`04G_MoogooG_L3Ool01Ekg
OomoogooG_L027oo00=NmgooOol037oo00=NmgooOol017oo0Ukg3Woo00<007ooOol0A7oo000lOol0
0`00Oomoo`0@Ool00ekgOomoo`0QOol00ekgOomoo`0ROol00ekgOomoo`0ROol00ekgOomoo`0HOol2
G_L8Ool00ekgOomoo`0;Ool00ekgOomoo`05Ool00ekgOomoo`02Ool01EkgOomoogooG_L00Woo00AN
mgooOomNm`=oo`03G_Moogoo009oo`03G_Moogoo00Ioo`03G_Moogoo00]oo`03G_Moogoo00Ioo`9N
m`aoo`03001oogoo04Aoo`00?7oo00<007ooOol047oo00=NmgooOol08Goo00=NmgooOol08Woo00=N
mgooOol08Woo00=NmgooOol05goo00=NmgooOol027oo00=NmgooOol02Woo00=NmgooOol01Woo00=N
mgooOol00Woo00ENmgooOomooekg009oo`04G_MoogooG_L3Ool00ekgOomoo`02Ool00ekgOomoo`06
Ool00ekgOomoo`0;Ool00ekgOomoo`08Ool00ekgOomoo`09Ool00`00Oomoo`14Ool003aoo`03001o
ogoo011oo`03G_Moogoo025oo`03G_Moogoo029oo`03G_Moogoo029oo`03G_Moogoo01Eoo`9Nm`]o
o`03G_Moogoo00Uoo`03G_Moogoo00Moo`03G_Moogoo009oo`05G_MoogooOomNm`02Ool015kgOomo
oekg0goo00=NmgooOol00goo00=NmgooOol01Woo00=NmgooOol02Goo00=NmgooOol02Woo0Ukg2Goo
00<007ooOol0A7oo000lOol00`00Oomoo`0@Ool00ekgOomoo`0QOol00ekgOomoo`0ROol00ekgOomo
o`0ROol00ekgOomoo`0DOol00ekgOomoo`0;Ool00ekgOomoo`09Ool00ekgOomoo`06Ool00ekgOomo
o`03Ool01EkgOomoogooG_L00Woo00ENmgooOomooekg00=oo`03G_Moogoo009oo`03G_Moogoo00Mo
o`03G_Moogoo00Qoo`03G_Moogoo00aoo`03G_Moogoo00Ioo`03001oogoo04Aoo`00?7oo00<007oo
Ool047oo00=NmgooOol08Goo00=NmgooOol08Woo00=NmgooOol08Woo00=NmgooOol04goo00=Nmgoo
Ool037oo00=NmgooOol027oo00=NmgooOol01goo00=NmgooOol00Woo00=NmgooOol00Woo00ANmgoo
OomNm`=oo`05G_MoogooOomNm`04Ool00ekgOomoo`07Ool00ekgOomoo`08Ool00ekgOomoo`0=Ool2
G_L6Ool00`00Oomoo`14Ool003aoo`03001oogoo011oo`03G_Moogoo029oo`03G_Moogoo025oo`03
G_Moogoo029oo`03G_Moogoo015oo`9Nm`moo`03G_Moogoo00Moo`03G_Moogoo00Moo`03G_Moogoo
00=oo`05G_MoogooOomNm`03Ool01EkgOomoogooG_L00goo00=NmgooOol00goo00=NmgooOol01goo
00=NmgooOol01goo00=NmgooOol03goo00=NmgooOol00goo00<007ooOol0A7oo000lOol00`00Oomo
o`0@Ool00ekgOomoo`0ROol00ekgOomoo`0QOol00ekgOomoo`0ROol00ekgOomoo`0@Ool00ekgOomo
o`0?Ool00ekgOomoo`07Ool00ekgOomoo`07Ool00ekgOomoo`03Ool01EkgOomoogooG_L00goo00EN
mgooOomooekg00=oo`03G_Moogoo00=oo`03G_Moogoo00Qoo`03G_Moogoo00Ioo`03G_Moogoo011o
o`9Nm`=oo`03001oogoo04Aoo`00?7oo00<007ooOol047oo00=NmgooOol08Woo00=NmgooOol08Goo
00=NmgooOol08Woo00=NmgooOol03Woo0Ukg4goo00=NmgooOol01Goo00=NmgooOol027oo00=Nmgoo
Ool00goo00ENmgooOomooekg00=oo`05G_MoogooOomNm`03Ool00ekgOomoo`04Ool00ekgOomoo`07
Ool00ekgOomoo`05Ool00ekgOomoo`0COol015kgOomoo`00AWoo000lOol00`00Oomoo`0@Ool00ekg
Oomoo`0ROol00ekgOomoo`0QOol00ekgOomoo`0ROol00ekgOomoo`0=Ool00ekgOomoo`0COol00ekg
Oomoo`04Ool00ekgOomoo`08Ool00ekgOomoo`04Ool01EkgOomoogooG_L00goo00ENmgooOomooekg
00Aoo`03G_Moogoo00=oo`03G_Moogoo00Qoo`03G_Moogoo00Aoo`03G_Moogoo01Aoo`9Nm`03001o
ogoo04Aoo`00?7oo00<007ooOol047oo00=NmgooOol08Woo00=NmgooOol08Goo00=NmgooOol08Woo
00=NmgooOol02goo0Ukg5Woo00=NmgooOol017oo00=NmgooOol027oo00=NmgooOol00goo00=l07oo
Ool00Woo00ENmgooOomooekg00=oo`03G_Moogoo009oo`03G_Moogoo00=oo`03G_Moogoo00Uoo`03
G_Moogoo00=oo`03G_Moogoo01Ioo`03G_Moogoo04Aoo`00?7oo00<007ooOol047oo00=NmgooOol0
8Woo00=NmgooOol08Goo00=NmgooOol08Woo00=NmgooOol02Woo00=NmgooOol05Woo00=NmgooOol0
0goo00=NmgooOol02Goo00=NmgooOol00Woo0g`00goo00ENmgooOomooekg00=oo`03G_Moogoo009o
o`03G_Moogoo00Aoo`03G_Moogoo00Uoo`03G_Moogoo009oo`03G_Moogoo01Ioo`03001oogoo04Ao
o`00?7oo00<007ooOol047oo00=NmgooOol08Woo00=NmgooOol08Goo00=NmgooOol08goo00=Nmgoo
Ool01goo0Ukg6Goo00=NmgooOol00Woo00=NmgooOol02Goo00=NmgooOol00goo00=L17`0G0H00goo
00ENmgooOomooekg00=oo`03G_Moogoo009oo`03G_Moogoo00Aoo`03G_Moogoo00Uoo`03G_Moogoo
009oo`03G_Moogoo01Ioo`03001oogoo04Aoo`00?7oo00<007ooOol047oo00=NmgooOol08Woo00=N
mgooOol08Goo00=NmgooOol08goo00=NmgooOol01Woo00=NmgooOol06Goo00=NmgooOol00Woo00=N
mgooOol02Goo00=NmgooOol017oo0e`60Woo00ENmgooOomooekg00Aoo`03G_Moogoo009oo`03G_Mo
ogoo00Aoo`03G_Moogoo00Uoo`05G_MoogooOomNm`0HOol00`00Oomoo`14Ool003aoo`03001oogoo
011oo`03G_Moogoo029oo`03G_Moogoo025oo`03G_Moogoo02=oo`03G_Moogoo00Aoo`9Nmaeoo`04
G_MoogooG_L;Ool00ekgOomoo`04Ool015kgOomL1U`80Woo00ENmgooOomooekg00Aoo`03G_Moogoo
009oo`03G_Moogoo00Aoo`03G_Moogoo00Yoo`03G_Mooekg01Uoo`03001oogoo04Aoo`00?7oo00<0
07ooOol047oo00=NmgooOol08Woo00=NmgooOol08Woo00=NmgooOol08Woo00=NmgooOol00goo00=N
mgooOol07Goo00=NmgooG_L037oo00=NmgooOol017oo00=NmgooG0P00U`800=NmgooOol00Woo00=N
mgooOol00Woo00=NmgooOol00Woo00=NmgooOol017oo00=NmgooOol02Woo00=NmgooG_L06Goo00<0
07ooOol0A7oo000lOol00`00Oomoo`0@Ool00ekgOomoo`0ROol00ekgOomoo`0ROol00ekgOomoo`0R
Ool015kgOomoogoo0Ukg87oo0Ukg2Woo00AL25`6O01Nm`Ioo`06G_MoogooG0Qooe`;17oo00=Nmgoo
Ool00Woo00=NmgooOol00Woo00=NmgooOol01Goo00=NmgooOol02Woo0Ukg6Goo00<007ooOol0A7oo
000lOol2000AOol00ekgOomoo`0ROol00ekgOomoo`0ROol00ekgOomoo`0ROol015kgOomooekg8Woo
0Ukg1goo00AL3GooG0]L20=l00Ioo`04G_MoogooOol3G0/3Ool00ekgOomoo`02Ool00ekgOomoo`03
Ool00ekgOomoo`04Ool00ekgOomoo`0;Ool00ekgOomoo`0FOol20016Ool003aoo`03001oogoo011o
o`03G_Moogoo029oo`03G_Moogoo029oo`03G_Moogoo029oo`=Nmb=oo`9Nm`Ioo`07G0eH3E`=G0YL
2e`6O0001Woo00=NmgooOol00goo00=L2e`=Ool00Woo00=NmgooOol00Woo00=NmgooOol00goo00=N
mgooOol01Goo00=NmgooOol02Woo0Ukg67oo00<007ooOol0A7oo000lOol00`00Oomoo`0@Ool00ekg
Oomoo`0ROol00ekgOomoo`0ROol00ekgOomoo`0ROol00ekgOomoo`0ROol00ekgOomNm`06Ool01U`?
G0eooe`;OomNm`Moo`03G_Moogoo00=oo`=L3@9oo`03G_Moogoo009oo`03G_Moogoo00=oo`03G_Mo
ogoo00Eoo`03G_Moogoo00Uoo`03G_Mooekg01Qoo`03001oogoo04Aoo`00?7oo00<007ooOol047oo
00=NmgooOol08Woo00=NmgooOol08Woo00=NmgooOol087oo0ekg97oo00=NmgooG_L017oo00AL4U`?
G11L3`=oo`03G_Moogoo00Eoo`03G_Moogoo00=oo`03G_ML3Goo009oo`03G_Moogoo009oo`03G_Mo
ogoo00=oo`03G_Moogoo00Eoo`03G_Moogoo00Uoo`04G_MoogooG_LGOol00`00Oomoo`14Ool003ao
o`03001oogoo011oo`03G_Moogoo029oo`03G_Moogoo029oo`03G_Moogoo01moo`05G_MoogooOomN
m`0ROol01EkgOomoogooG_L00Woo0e`B00=L3gooOol00Woo00=NmgooOol01Goo00=NmgooOol00goo
00INmgooOomL3gooG_L4Ool00ekgOomoo`03Ool00ekgOomoo`06Ool00ekgOomoo`08Ool01EkgOomo
ogooG_L05Woo00<007ooOol0A7oo000lOol00`00Oomoo`0@Ool00ekgOomoo`0ROol00ekgOomoo`0R
Ool00ekgOomoo`0MOol2G_L4Ool00ekgOomoo`0OOol00ekgOomoo`02Ool01EkgOomL57ooG1801Goo
00=NmgooOol01Woo00=NmgooOol00goo00INmgooG0mL45`?G_L5Ool00ekgOomoo`03Ool00ekgOomo
o`05Ool00ekgOomoo`08Ool01EkgOomoogooG_L05Woo00<007ooOol0A7oo000lOol00`00Oomoo`0@
Ool00ekgOomoo`0ROol00ekgOomoo`0ROol00ekgOomoo`0LOol00ekgOomoo`04Ool00ekgOomoo`0O
Ool00ekgOomoo`02Ool015kgG1AL55`D1Woo00=NmgooOol01Goo00=NmgooOol017oo00INmgooOomL
3gooG_L5Ool00ekgOomoo`03Ool00ekgOomoo`06Ool00ekgOomoo`06Ool00ekgOomoo`03Ool00ekg
Oomoo`0COol00`00Oomoo`14Ool003aoo`03001oogoo011oo`03G_Moogoo029oo`03G_Moogoo029o
o`03G_Moogoo01Yoo`9Nm`Moo`03G_Moogoo01ioo`03G_Moogoo00Aoo`03G1IL57oo00Eoo`03G_Mo
ogoo00Ioo`03G_Moogoo00Aoo`06G_MoogooOomL4Ukg1Goo00=NmgooOol00goo00=NmgooOol01Woo
00=NmgooOol01Woo00=NmgooOol017oo00=NmgooOol04Woo00<007ooOol0A7oo000lOol00`00Oomo
o`0@Ool00ekgOomoo`0SOol00ekgOomoo`0QOol00ekgOomoo`0IOol00ekgOomoo`07Ool00ekgOomo
o`0MOol00ekgOomoo`04Ool00e`FG1ML5P06Ool00ekgOomoo`06Ool00ekgOomoo`03Ool015kgOomo
ogoo0e`B1Goo00=NmgooOol00goo00=NmgooOol01Woo00=NmgooOol01Woo00=NmgooOol017oo00=N
mgooOol04Woo00<007ooOol0A7oo000lOol00`00Oomoo`0@Ool00ekgOomoo`0SOol00ekgOomoo`0Q
Ool00ekgOomoo`0GOol2G_L:Ool00ekgOomoo`0MOol00ekgOomoo`03Ool00e@GOomL5P07Ool00ekg
Oomoo`06Ool00ekgOomoo`03Ool00ekgOomoo`02Ool00e`BG_Moo`04Ool00ekgOomoo`04Ool00ekg
Oomoo`06Ool00ekgOomoo`05Ool00ekgOomoo`05Ool00ekgOomoo`0AOol00`00Oomoo`14Ool003ao
o`03001oogoo011oo`03G_Moogoo02=oo`03G_Moogoo025oo`03G_Moogoo01Ioo`03G_Moogoo00Yo
o`03G_Moogoo01aoo`03G_Moogoo00=oo`=D5`03OomNmgoo00Aoo`03G_Moogoo00Ioo`03G_Moogoo
00Aoo`03G_Moogoo00=oo`03G_ML57oo00=oo`03G_Moogoo00Aoo`03G_Moogoo00Ioo`03G_Moogoo
00Aoo`03G_Moogoo00Moo`03G_Moogoo011oo`03001oogoo04Aoo`00?7oo00<007ooOol047oo00=N
mgooOol08goo00=NmgooOol08Goo00=NmgooOol057oo0Ukg3Woo00=NmgooOol06Woo00=NmgooOol0
17oo00E<5e@GOomooekg00Eoo`03G_Moogoo00Ioo`03G_Moogoo00Aoo`03G_Moogoo00=oo`=L50=o
o`03G_Moogoo00Aoo`03G_Moogoo00Moo`03G_Moogoo00=oo`03G_Moogoo00Qoo`03G_Moogoo00mo
o`03001oogoo04Aoo`00?7oo00<007ooOol047oo00=NmgooOol08goo00=NmgooOol08Goo00=Nmgoo
Ool04goo00=NmgooOol03Woo00=NmgooOol06Goo00=NmgooOol00goo00A45d`GC1M<5`9oo`03G_Mo
ogoo009oo`03G_Moogoo00Moo`03G_Moogoo00Aoo`03G_Moogoo00=oo`03G_ML57oo00=oo`03G_Mo
ogoo00Aoo`03G_Moogoo00Moo`03G_Moogoo00=oo`03G_Moogoo00Qoo`03G_Moogoo00moo`03001o
ogoo04Aoo`00?7oo00<007ooOol047oo00=NmgooOol08goo00=NmgooOol08Goo00=NmgooOol04Goo
0Ukg4Goo00=NmgooOol06Goo00=NmgooOol00Woo0d@G00=<5gooOol00Woo00ENmgooOomooekg00Uo
o`03G_Moogoo00Aoo`03G_Moogoo00=oo`03G_Moogoo00=oo`03G_Moogoo00Eoo`03G_Moogoo00Mo
o`05G_MoogooOomNm`0<Ool00ekgOomoo`0>Ool00`00Oomoo`14Ool003aoo`03001oogoo011oo`03
G_Moogoo02=oo`03G_Moogoo025oo`03G_Moogoo011oo`03G_Moogoo015oo`03G_Moogoo01Qoo`03
G_Moogoo00=oo`03>1M45goo00Eoo`05G_MoogooOomNm`08Ool00ekgOomoo`05Ool00ekgOomoo`03
Ool00ekgOomL5P03Ool00ekgOomoo`05Ool00ekgOomoo`07Ool01EkgOomoogooG_L03Goo00=Nmgoo
Ool03Goo00<007ooOol0A7oo000lOol00`00Oomoo`0@Ool00ekgOomoo`0SOol00ekgOomoo`0ROol0
0ekgOomoo`0=Ool2G_LDOol00ekgOomoo`0GOol00ekgOomoo`03Ool3>1L6Ool015kgOomooekg2Goo
00=NmgooOol01Goo00=NmgooOol00goo00ANme`FG1ML5P=oo`03G_Moogoo00Aoo`03G_Moogoo00Mo
o`05G_MoogooOomNm`0=Ool00ekgOomoo`0=Ool00`00Oomoo`14Ool003aoo`03001oogoo011oo`03
G_Moogoo02=oo`03G_Moogoo029oo`03G_Moogoo00aoo`03G_Moogoo01Aoo`03G_Moogoo01Moo`03
G_Moogoo009oo`03<1MoocPG00Qoo`03G_Mooekg00Uoo`03G_Moogoo00Eoo`03G_Moogoo00=oo`03
G_Mooe`F00Aoo`03G_Moogoo00Aoo`03G_Moogoo00Qoo`03G_Mooekg00moo`03G_Moogoo00aoo`03
001oogoo04Aoo`00?7oo00<007ooOol047oo00=NmgooOol08goo00=NmgooOol08Woo00=NmgooOol0
2Woo0Ukg5goo00=NmgooOol05Woo00=NmgooOol00Woo0c0G2Goo0Ukg2Woo00=NmgooOol017oo00=N
mgooOol017oo00ENmgooOomooe@G009oo`03G_Moogoo00Eoo`03G_Moogoo00Moo`03G_Mooekg011o
o`03G_Moogoo00]oo`03001oogoo04Aoo`00?7oo00<007ooOol04Goo00=NmgooOol08Woo00=Nmgoo
Ool08Woo00=NmgooOol02Goo00=NmgooOol05goo00=NmgooOol05Goo00=NmgooOol00goo00<X5c0G
Ool02Goo0Ukg2Woo00=NmgooOol017oo00=NmgooOol017oo00=NmgooOol00e@G00=ooekgOol01Woo
00=NmgooOol027oo0Ukg4Goo00=NmgooOol02Woo00<007ooOol0A7oo000lOol00`00Oomoo`0AOol0
0ekgOomoo`0ROol00ekgOomoo`0ROol00ekgOomoo`07Ool2G_LKOol00ekgOomoo`0DOol00ekgOomo
o`02Ool3:1L;Ool00ekgOomoo`07Ool00ekgOomoo`05Ool00ekgOomoo`04Ool01EkgOomoogooE1L0
0Woo00=NmgooOol01Goo00=NmgooOol027oo00=NmgooOol047oo00=NmgooOol02Woo00<007ooOol0
A7oo000lOol00`00Oomoo`0AOol00ekgOomoo`0ROol00ekgOomoo`0ROol00ekgOomoo`06Ool00ekg
Oomoo`0KOol00ekgOomoo`0COol00ekgOomoo`02Ool00a`GOolX5`0;Ool2G_L9Ool00ekgOomoo`05
Ool00ekgOomoo`04Ool00ekgOomoo`02Ool00d`GOomNm`07Ool00ekgOomoo`08Ool00ekgOomoo`0A
Ool00ekgOomoo`09Ool00`00Oomoo`14Ool003aoo`03001oogoo015oo`03G_Moogoo029oo`03G_Mo
ogoo029oo`03G_Moogoo00Aoo`9Nmaioo`03G_Moogoo019oo`03G_Moogoo009oo`<L5`aoo`03G_Mo
oekg00Qoo`03G_Moogoo00Eoo`03G_Moogoo00Aoo`08G_MoogooOom<5dPFC1MNm`Moo`03G_Moogoo
00Moo`03G_Mooekg01=oo`03G_Moogoo00Qoo`03001oogoo04Aoo`00?7oo00<007ooOol04Goo00=N
mgooOol08Woo00=NmgooOol08Woo00=NmgooOol00goo00=NmgooOol07Woo00=NmgooOol04Woo00=N
mgooOol00Woo00<D5a`GOol02goo00ANmgooOomNm`Qoo`03G_Moogoo00Eoo`03G_Moogoo00Aoo`03
G_Moogoo009oo`03C1Mooekg00Qoo`03G_Moogoo00Ioo`03G_Mooekg01=oo`03G_Moogoo00Qoo`03
001oogoo04Aoo`00?7oo0P004Woo00=NmgooOol08goo00=NmgooOol08Goo00ANmgooOomoo`9Nmb5o
o`03G_Moogoo015oo`03G_Moogoo009oo`0331L@5Q@G00aoo`04G_MoogooG_L7Ool00ekgOomoo`06
Ool00ekgOomoo`04Ool00ekgOomoo`04Ool00ekgOomoo`06Ool00ekgOomoo`06Ool015kgOomooekg
4goo00=NmgooOol01Woo0P00AWoo000lOol00`00Oomoo`0AOol00ekgOomoo`0SOol00ekgOomoo`0Q
Ool015kgOomooekg8goo00=NmgooOol047oo00=NmgooOol00Woo00<<5`PG31L03Goo00ENmgooOomo
oekg00Ioo`03G_Moogoo00Ioo`03G_Moogoo00Aoo`03G_Moogoo00Aoo`03A1MNmgoo00Ioo`03G_Mo
ogoo00Eoo`05G_MoogooOomNm`0DOol00ekgOomoo`06Ool00`00Oomoo`14Ool003aoo`03001oogoo
015oo`03G_Moogoo02=oo`03G_Moogoo025oo`=NmbAoo`03G_Moogoo00moo`03G_Moogoo009oo`03
01Moo``G00eoo`03G_Moogoo009oo`03G_Moogoo00Aoo`03G_Moogoo00Ioo`03G_Moogoo00Aoo`03
G_Moogoo00=oo`03A1M05d@G00Moo`03G_Moogoo00Eoo`05G_MoogooOomNm`0EOol00ekgOomoo`05
Ool00`00Oomoo`14Ool003aoo`03001oogoo015oo`03G_Moogoo02=oo`03G_Moogoo025oo`03G_Mo
ogoo02Eoo`03G_Moogoo00ioo`07G_MoogooOol05`@G01L03Woo00=NmgooOol00goo00=NmgooOol0
0goo00=NmgooOol01Woo00=NmgooOol017oo00=NmgooOol017oo00=45ekgOol01goo00=NmgooOol0
0goo00=NmgooOol00goo00=NmgooOol04Woo00=NmgooOol01Goo00<007ooOol0A7oo000lOol00`00
Oomoo`0AOol00ekgOomoo`0SOol00ekgOomoo`0OOol2G_L00gooG_Moo`0UOol00ekgOomoo`0=Ool0
0ekgOomoo`02Ool201L>Ool00ekgOomoo`04Ool00ekgOomoo`02Ool00ekgOomoo`06Ool00ekgOomo
o`05Ool00ekgOomoo`05Ool00cPGOomoo`06Ool00ekgOomoo`03Ool00ekgOomoo`03Ool00ekgOomo
o`0COol00ekgOomoo`04Ool00`00Oomoo`14Ool003aoo`03001oogoo015oo`03G_Moogoo02=oo`03
G_Moogoo01ioo`05G_MoogooOomNm`0VOol00ekgOomoo`0<Ool01EkgOomoogoo07L00`0G3Woo00=N
mgooOol01Goo00ENmgooOomooekg00Qoo`03G_Moogoo00Eoo`03G_Moogoo00Aoo`<h5`Moo`03G_Mo
ogoo009oo`03G_Moogoo00Eoo`03G_Moogoo01=oo`03G_Moogoo00=oo`03001oogoo04Aoo`00?7oo
00<007ooOol04Woo00=NmgooOol08Woo00=NmgooOol077oo0Ukg17oo00=NmgooOol097oo00=Nmgoo
Ool037oo00MNmgooOol0M`1F07L05`0?Ool00ekgOomoo`05Ool01EkgOomoogooG_L027oo00=Nmgoo
Ool01Goo00=NmgooOol01Goo00<h5gooOol01Woo00=NmgooOol00Woo00=NmgooOol01Goo00=Nmgoo
Ool04goo00=NmgooOol00goo00<007ooOol0A7oo000lOol00`00Oomoo`0BOol00ekgOomoo`0ROol0
0ekgOomoo`0KOol00ekgOomoo`04Ool00ekgOomoo`0TOol00ekgOomoo`0;Ool01UkgOomoogoo0;L0
Ma1oo`03G_Moogoo00Moo`04G_MoogooG_L8Ool00ekgOomoo`05Ool00ekgOomoo`05Ool00ekgOomo
o`07Ool015kgOomooekg27oo00=NmgooOol057oo00=NmgooOol00Woo00<007ooOol0A7oo000lOol0
0`00Oomoo`0BOol00ekgOomoo`0ROol00ekgOomoo`0IOol2G_L7Ool00ekgOomoo`0TOol00ekgOomo
o`0:Ool015kgOomoogoo0`2g47oo00=NmgooOol01goo00ANmgooOomNm`Qoo`03G_Moogoo00Eoo`03
G_Moogoo00Eoo`03G_Mooc0G00Moo`04G_MoogooG_L9Ool00ekgOomoo`0DOol01EkgOomoogoo0000
AWoo000lOol00`00Oomoo`0BOol00ekgOomoo`0ROol00ekgOomoo`0HOol00ekgOomoo`07Ool00ekg
Oomoo`0UOol00ekgOomoo`09Ool01UkgOomoogoo0?L0]a1oo`03G_Moogoo00Uoo`9Nm`Uoo`03G_Mo
ogoo00Eoo`03G_Moogoo00Eoo`04G_L`5c0G<1L6Ool00ekgOomNm`0:Ool00ekgOomoo`0DOol01Ekg
Oomoogoo0000AWoo000lOol00`00Oomoo`0BOol00ekgOomoo`0ROol00ekgOomoo`0FOol2G_L;Ool0
0ekgOomoo`0TOol00ekgOomoo`08Ool015kgOomoo`5G0`3g47oo00=NmgooOol02Woo00=NmgooOol0
1goo00=NmgooOol01Goo00=NmgooOol01Woo00=Nmc0GOol01Woo0Ukg37oo00=NmgooOol057oo00AN
mgooOol004Ioo`00?7oo00<007ooOol04Woo00=NmgooOol08Woo00=NmgooOol05Goo00=NmgooOol0
2goo00=NmgooOol097oo00=NmgooOol01goo00=NmgooOol00`5G00<0mgooOol03goo00=NmgooOol0
2Woo0Ukg27oo00=NmgooOol01Goo00=NmgooOol01Woo00=Nmgoo:1L01Woo0Ukg37oo00=NmgooOol0
5Goo00=Nmgoo0000AWoo000lOol00`00Oomoo`0BOol00ekgOomoo`0ROol00ekgOomoo`0COol2G_L>
Ool00ekgOomoo`0TOol00ekgOomoo`06Ool01UkgOomoogoo0IL1Ea9oo`03G_Moogoo00]oo`9Nm`Qo
o`03G_Moogoo00Eoo`03G_Moogoo00Ioo`04G_LX5b@F:1L5Ool2G_L<Ool00ekgOomoo`0FOol00ekg
001oo`15Ool003aoo`03001oogoo019oo`03G_Moogoo029oo`03G_Moogoo019oo`03G_Moogoo00io
o`03G_Moogoo02Aoo`03G_Moogoo00Ioo`04G_Moogoo0ML20ILBOol00ekgOomoo`0:Ool015kgOomo
oekg1Woo00=NmgooOol01Woo00=NmgooOol01Woo00=Nmgoo:1L01Goo00=NmgooG_L03Goo00=Nmgoo
Ool05Goo00=Nm`00Ool0AGoo000lOol00`00Oomoo`0BOol00ekgOomoo`0ROol00ekgOomoo`0@Ool2
G_LAOol00ekgOomoo`0TOol00ekgOomoo`05Ool00ekgOomoo`030MLBOol00ekgOomoo`0;Ool01Ekg
OomoogooG_L01Goo00=NmgooOol01Woo00=NmgooOol01Woo00=NmgooOol017oo00ANmgooOomNm`eo
o`03G_Moogoo01Ioo`03G_Moogoo04Aoo`00?7oo00<007ooOol04Woo00=NmgooOol08goo00=Nmgoo
Ool03Woo00=NmgooOol04Goo00=NmgooOol097oo00=NmgooOol017oo00INmgooOol2=goo0MLCOol0
0ekgOomoo`0;Ool00ekgOomoo`02Ool00ekgOomoo`02Ool00ekgOomoo`06Ool00ekgOomoo`06Ool0
15kgOomooa`G0Woo00ENmgooOomooekg00ioo`03G_Moogoo01Eoo`03001oogoo04Aoo`00?7oo00<0
07ooOol04Woo00=NmgooOol08goo00=NmgooOol037oo0Ukg5Goo00=NmgooOol097oo00=NmgooOol0
0goo00=Nmgoo0WL00P8g57oo00=NmgooOol02goo00=NmgooOol00goo00ENmgooOomooekg00Qoo`03
G_Moogoo00Ioo`06G_Mooa`G81LL5ekg1Goo00=NmgooOol02goo00=NmgooOol05Goo00<007ooOol0
A7oo000lOol00`00Oomoo`0COol00ekgOomoo`0ROol00ekgOomoo`0;Ool00ekgOomoo`0EOol00ekg
Oomoo`0TOol00ekgOomoo`02Ool00ekgOol2M`020WLDOol00ekgOomoo`0;Ool00ekgOomoo`05Ool0
15kgOomooekg27oo00=NmgooOol01Woo00ENmgooOolL5ekg00Ioo`03G_Moogoo00]oo`03G_Moogoo
01Eoo`03001oogoo04Aoo`00?7oo00<007ooOol04goo00=NmgooOol08Woo00=NmgooOol02Goo0Ukg
67oo00=NmgooOol097oo00ENmgooOomooekg009oo`030[L2Mgoo01Aoo`03G_Moogoo00]oo`03G_Mo
ogoo00Ioo`03G_Mooekg00Qoo`03G_Moogoo00Ioo`06G_MoogooG_Mooa@G1Goo00=NmgooOol037oo
00=NmgooOol057oo00<007ooOol0A7oo000lOol00`00Oomoo`0COol00ekgOomoo`0ROol00ekgOomo
o`08Ool00ekgOomoo`0HOol00ekgOomoo`0TOol01UkgOomoogooG_L2mP<2]aAoo`03G_Moogoo00ao
o`03G_Moogoo00Moo`9Nm`Qoo`03G_Moogoo00Moo`9Nm`04OolD5a@G51L4Ool00ekgOomoo`0<Ool0
0ekgOomoo`0DOol00`00Oomoo`14Ool003aoo`03001oogoo01=oo`03G_Moogoo029oo`03G_Moogoo
00Ioo`9Nma]oo`03G_Moogoo02Aoo`04G_MoogooG_L30_H00`:gOomoo`0COol00ekgOomoo`0<Ool0
0ekgOomoo`08Ool2G_L7Ool00ekgOomoo`05Ool3G_L3Ool00a@GOomoo`04Ool00ekgOomoo`0<Ool0
0ekgOomoo`0COol00`00Oomoo`14Ool003Eoo`<000Aoo`03001oogoo01=oo`03G_Moogoo029oo`03
G_Moogoo00Eoo`03G_Moogoo01]oo`03G_Moogoo02Eoo`9Nm`03Ool2m0;f01Moo`03G_Moogoo00ao
o`03G_Moogoo00Qoo`03G_Mooekg009Nm`Aoo`03G_Moogoo00=oo`9Nm`9oo`03G_Moogoo00Qoo`03
G_Moogoo00aoo`03G_Moogoo01=oo`03001oogoo04Aoo`00=Goo00<007ooOol017oo00<007ooOol0
4goo00=NmgooOol08Woo00=NmgooOol00goo0Ukg7Woo00=NmgooOol09Goo0Ukg00<2lP;d0_@05Woo
00=NmgooOol037oo00=NmgooOol02Goo00=NmgooOol00Woo2Ukg17oo00=NmgooOol00Woo00<<5goo
Ool00goo00=NmgooOol03Goo00=NmgooOol04Woo00<007ooOol0A7oo000fOol00`00Oomoo`03Ool2
000DOol00ekgOomoo`0ROol00ekgOomoo`02Ool00ekgOomoo`0OOol00ekgOomoo`0TOol015kg0_82
lP;b5goo00=NmgooOol037oo00=NmgooOol027oo00=NmgooOol01goo00=NmgooOol01goo00ANmgoo
Oomoo`<<5`Aoo`03G_Moogoo00eoo`03G_Moogoo011oo`<004Ioo`00=Woo00<007ooOol00goo00<0
07ooOol04goo00=NmgooOol08Woo00=NmgooOol00Ukg8Woo00=NmgooOol08goo00ANm`;_Ool2lQMo
o`03G_Moogoo00eoo`03G_Moogoo00Qoo`03G_Moogoo00Moo`03G_Moogoo00Moo`03G_Moogoo009o
o`0331Moogoo00Aoo`03G_Moogoo00aoo`03G_Moogoo019oo`03001oogoo04Aoo`00=Goo00<007oo
000017oo00<007ooOol04goo00=NmgooOol08Woo00=NmgooG_L097oo00=NmgooOol08Woo00ANm`;]
0^l2kaQoo`03G_Moogoo00eoo`03G_Moogoo00Qoo`03G_Moogoo00Moo`03G_Moogoo00Moo`03G_Mo
ogoo00=oo`0301Moogoo00=oo`03G_Moogoo00eoo`03G_Moogoo015oo`03001oogoo04Aoo`00=Woo
00<007ooOol00goo00<007ooOol04goo00=NmgooOol08Woo0Ukg9Goo00=NmgooOol08Woo0`;]00=N
mgooOol05Woo00=NmgooOol037oo00=NmgooOol02Goo00=NmgooOol01goo00=NmgooOol01goo00=N
mgooOol00Woo00<05`@G01L017oo00=NmgooOol03Goo00=NmgooOol04Goo00<007ooOol0A7oo000l
Ool00`00Oomoo`0COol00ekgOomoo`0QOol00ekgOomNm`0UOol00ekgOomoo`0QOol01Ekg0^/2kGoo
G_L05goo00=NmgooOol03Goo00=NmgooOol02Goo00=NmgooOol01goo00=NmgooOol01goo00=Nmgoo
Ool00goo00<05gooOol00goo00=NmgooOol03Woo00=NmgooOol047oo00<007ooOol0A7oo000lOol0
0`00Oomoo`0COol00ekgOomoo`0OOol2G_L2Ool00ekgOomoo`0SOol00ekgOomoo`0POol01P;X0^/2
jP;[OomNmaMoo`03G_Moogoo00eoo`03G_Moogoo00Uoo`03G_Moogoo00Moo`03G_Moogoo00Qoo`03
G_Moogoo00Uoo`03G_Moogoo00eoo`03G_Moogoo011oo`03001oogoo04Aoo`00?7oo00<007ooOol0
57oo00=NmgooOol07Goo00=NmgooOol00Woo00=NmgooOol097oo00=NmgooOol07Woo0`;X00D2jgoo
Oomooekg01Eoo`03G_Moogoo00ioo`03G_Moogoo00Uoo`03G_Moogoo00Moo`03G_Moogoo00Qoo`03
G_Moogoo00Aoo`0301Moogoo009oo`03G_Moogoo00eoo`03G_Moogoo011oo`03001oogoo04Aoo`00
?7oo00<007ooOol057oo00=NmgooOol06goo0Ukg1Goo00=NmgooOol097oo00=NmgooOol07Woo00<2
iP;XOol017oo00=NmgooOol04goo00=NmgooOol03Goo00=NmgooOol02Woo00=NmgooOol01goo00=N
mgooOol027oo00=NmgooOol00goo00<05`0g01L00goo00=NmgooOol03Woo00=NmgooOol03goo00<0
07ooOol0A7oo000lOol00`00Oomoo`0DOol00ekgOomoo`0JOol00ekgOomoo`05Ool00ekgOomoo`0T
Ool00ekgOomoo`0MOol00`;T0^H2iP05Ool00ekgOomoo`0COol00ekgOomoo`0=Ool00ekgOomoo`0:
Ool00ekgOomoo`07Ool00ekgOomoo`08Ool00ekgOomoo`04Ool00`0GOomoo`02Ool00ekgOomoo`0>
Ool00ekgOomoo`0?Ool00`00Oomoo`14Ool003aoo`03001oogoo01Aoo`03G_Moogoo01Uoo`03G_Mo
ogoo00Ioo`03G_Moogoo02Aoo`03G_Moogoo01aoo`030^@2h`;T00Ioo`03G_Moogoo019oo`03G_Mo
ogoo00ioo`03G_Moogoo00Uoo`03G_Moogoo00Qoo`03G_Moogoo00Qoo`03G_Moogoo00Eoo`0507Mo
ogooOomNm`0AOol00ekgOomoo`0>Ool00`00Oomoo`14Ool003aoo`03001oogoo01Aoo`03G_Moogoo
01Moo`9Nm`Yoo`03G_Moogoo02=oo`03G_Moogoo01]oo`030^5Nm`;T00Qoo`03G_Moogoo015oo`03
G_Moogoo00ioo`03G_Moogoo00Uoo`03G_Moogoo00Qoo`03G_Moogoo00Qoo`03G_Moogoo00Aoo`<0
M`=oo`03G_Moogoo00ioo`03G_Moogoo00ioo`03001oogoo04Aoo`00?7oo00<007ooOol057oo00=N
mgooOol05Woo00=NmgooOol02Woo00=NmgooOol08goo00=NmgooOol06Woo0`;Q2Goo00=NmgooOol0
47oo00=NmgooOol03goo00=NmgooOol02Goo00=NmgooOol027oo00=NmgooOol027oo00=NmgooOol0
1Goo00<0MgooOol00Woo00=NmgooOol03Woo00=NmgooOol03Woo00<007ooOol0A7oo000lOol00`00
Oomoo`0DOol00ekgOomoo`0DOol2G_L=Ool00ekgOomoo`0SOol00ekgOomoo`0KOol00`;QOomoo`08
Ool00ekgOomoo`0@Ool00ekgOomoo`0>Ool00ekgOomoo`0:Ool00ekgOomoo`08Ool00ekgOomoo`08
Ool00ekgOomoo`0:Ool00ekgOomoo`0?Ool00ekgOomoo`0=Ool00`00Oomoo`14Ool003aoo`03001o
ogoo01Aoo`03G_Moogoo01=oo`03G_Moogoo00eoo`03G_Moogoo02Aoo`03G_Moogoo01Uoo`03G_Mo
ogoo00Uoo`03G_Moogoo011oo`03G_Moogoo00ioo`03G_Moogoo00Yoo`03G_Moogoo00Qoo`03G_Mo
ogoo00Qoo`03G_Moogoo00Ioo`050;MoogooOomNm`0AOol00ekgOomoo`0=Ool00`00Oomoo`14Ool0
03aoo`03001oogoo01Aoo`03G_Moogoo015oo`9Nma1oo`03G_Moogoo02Aoo`03G_Moogoo01Qoo`03
G_Moogoo00]oo`03G_Moogoo00ioo`03G_Moogoo00moo`03G_Moogoo00Yoo`03G_Moogoo00Qoo`03
G_Moogoo00Uoo`03G_Moogoo00Aoo`<0]`=oo`03G_Moogoo00moo`03G_Moogoo00aoo`03001oogoo
04Aoo`00?7oo00<007ooOol057oo00=NmgooOol047oo00=NmgooOol047oo00=NmgooOol097oo00=N
mgooOol05goo00=NmgooOol037oo00=NmgooOol03Woo00=NmgooOol03goo00=NmgooOol02Woo00=N
mgooOol027oo00=NmgooOol02Goo00=NmgooOol01Goo00<0]gooOol00Woo00=NmgooOol03goo00=N
mgooOol037oo00<007ooOol0A7oo000lOol00`00Oomoo`0DOol00ekgOomoo`0>Ool2G_LCOol00ekg
Oomoo`0TOol00ekgOomoo`0GOol00ekgOomoo`0<Ool00ekgOomoo`0>Ool00ekgOomoo`0>Ool00ekg
Oomoo`0;Ool00ekgOomoo`08Ool00ekgOomoo`09Ool00ekgOomoo`06Ool01@3gOomoogooG_L04Goo
00=NmgooOol037oo00<007ooOol0A7oo000lOol00`00Oomoo`0EOol00ekgOomoo`0<Ool00ekgOomo
o`0COol00ekgOomoo`0TOol00ekgOomoo`0FOol00ekgOomoo`0=Ool00ekgOomoo`0=Ool00ekgOomo
o`0?Ool00ekgOomoo`0;Ool00ekgOomoo`08Ool00ekgOomoo`09Ool00ekgOomoo`05Ool30?L2Ool0
0ekgOomoo`0@Ool00ekgOomoo`0;Ool00`00Oomoo`14Ool003aoo`03001oogoo01Eoo`03G_Moogoo
00Yoo`9NmaMoo`03G_Moogoo02=oo`03G_Moogoo01Eoo`03G_Moogoo00moo`03G_Moogoo00aoo`03
G_Moogoo00moo`03G_Moogoo00]oo`03G_Moogoo00Qoo`03G_Moogoo00Uoo`03G_Moogoo00Ioo`03
0?Moogoo009oo`03G_Moogoo00moo`03G_Moogoo00]oo`03001oogoo04Aoo`00?7oo00<007ooOol0
5Goo00=NmgooOol02Goo00=NmgooOol05goo00=NmgooOol097oo00=NmgooOol057oo00=NmgooOol0
3goo00=NmgooOol02goo00=NmgooOol047oo00=NmgooOol02Woo00=NmgooOol02Goo00=NmgooOol0
2Goo00=NmgooOol02goo00=NmgooOol047oo00=NmgooOol02Woo00<007ooOol0A7oo000lOol00`00
Oomoo`0EOol00ekgOomoo`07Ool2G_LJOol00ekgOomoo`0TOol00ekgOomoo`0COol00ekgOomoo`0@
Ool00ekgOomoo`0;Ool00ekgOomoo`0@Ool00ekgOomoo`0:Ool00ekgOomoo`09Ool00ekgOomoo`09
Ool00ekgOomoo`08Ool0105GOomooekg4Woo00=NmgooOol02Woo00=NmgooOol0A7oo000lOol00`00
Oomoo`0EOol00ekgOomoo`06Ool00ekgOomoo`0JOol00ekgOomoo`0TOol00ekgOomoo`0BOol00ekg
Oomoo`0BOol00ekgOomoo`0:Ool00ekgOomoo`0?Ool00ekgOomoo`0;Ool00ekgOomoo`09Ool00ekg
Oomoo`09Ool00ekgOomoo`07Ool01@5G0CH1EgooG_L04Woo00=NmgooOol02Woo00=NmgooOol0A7oo
000lOol2000FOol00ekgOomoo`04Ool2G_LMOol00ekgOomoo`0TOol00ekgOomoo`0BOol00ekgOomo
o`0BOol00ekgOomoo`09Ool00ekgOomoo`0@Ool00ekgOomoo`0;Ool00ekgOomoo`09Ool00ekgOomo
o`09Ool00ekgOomoo`08Ool0105GOomooekg4goo00=NmgooOol027oo00=Nm`00Ool0AGoo000lOol0
0`00Oomoo`0EOol00ekgOomoo`03Ool00ekgOomoo`0MOol00ekgOomoo`0TOol00ekgOomoo`0AOol0
0ekgOomoo`0COol00ekgOomoo`09Ool00ekgOomoo`0@Ool00ekgOomoo`0;Ool00ekgOomoo`09Ool0
0ekgOomoo`0:Ool00ekgOomoo`08Ool0106GOomooekg4Woo00=NmgooOol027oo00=Nm`00Ool0AGoo
000lOol00`00Oomoo`0EOol015kgOomoogoo0Ukg87oo00=NmgooOol097oo00=NmgooOol047oo00=N
mgooOol05Goo00=NmgooOol01goo00=NmgooOol04Goo00=NmgooOol02goo00=NmgooOol02Goo00=N
mgooOol02Woo00=NmgooOol01goo0`6G00=ooekgOol04Woo00=NmgooOol01Woo00=Nmgoo0000AWoo
000lOol00`00Oomoo`0EOol015kgOomooekg8goo00=NmgooOol097oo00=NmgooOol03goo00=Nmgoo
Ool05Goo00=NmgooOol01goo00=NmgooOol047oo00=NmgooOol037oo00=NmgooOol02Goo00=Nmgoo
Ool02Woo00=NmgooOol027oo00@1UgooOomNma=oo`03G_Moogoo00Ioo`03G_Moo`0004Ioo`00?7oo
00<007ooOol05Woo0Ukg97oo00=NmgooOol097oo00=NmgooOol03Woo00=NmgooOol05goo00=Nmgoo
Ool01Woo00=NmgooOol047oo00=NmgooOol037oo00=NmgooOol02Goo00=NmgooOol02Woo00=Nmgoo
Ool02goo00=NmgooOol04Goo00=NmgooOol01Woo00=Nmgoo0000AWoo000lOol00`00Oomoo`0EOol2
G_LUOol00ekgOomoo`0TOol00ekgOomoo`0=Ool00ekgOomoo`0HOol00ekgOomoo`05Ool00ekgOomo
o`0AOol00ekgOomoo`0<Ool00ekgOomoo`09Ool00ekgOomoo`0:Ool00ekgOomoo`09Ool0107GOomo
oekg4goo00=NmgooOol017oo00ANmgooOol004Ioo`00?7oo00<007ooOol04goo0Ukg00=ooekgOol0
97oo00=NmgooOol097oo00=NmgooOol037oo00=NmgooOol06Goo00=NmgooOol01Goo00=NmgooOol0
4Goo00=NmgooOol02goo00=NmgooOol02Woo00=NmgooOol02Woo00=NmgooOol027oo0`7G00=ooekg
Ool04Woo00=NmgooOol017oo00ANmgooOol004Ioo`00?7oo00<007ooOol04Woo00ENmgooOomooekg
02Eoo`03G_Moogoo02Aoo`03G_Moogoo00aoo`03G_Moogoo01Yoo`03G_Moogoo00=oo`03G_Moogoo
015oo`03G_Moogoo00aoo`03G_Moogoo00Yoo`03G_Moogoo00Yoo`03G_Moogoo00Uoo`040MMoogoo
G_LDOol00ekgOomoo`03Ool015kgOomoo`00AWoo000lOol00`00Oomoo`0@Ool2G_L4Ool00ekgOomo
o`0SOol00ekgOomoo`0TOol00ekgOomoo`0;Ool00ekgOomoo`0KOol00ekgOomoo`03Ool00ekgOomo
o`0AOol00ekgOomoo`0<Ool00ekgOomoo`0:Ool00ekgOomoo`0:Ool00ekgOomoo`0:Ool00`8gOomN
m`0DOol00ekgOomoo`02Ool01EkgOomoogoo0000AWoo000lOol00`00Oomoo`0?Ool00ekgOomoo`04
Ool00ekgOomoo`0SOol00ekgOomoo`0UOol00ekgOomoo`09Ool00ekgOomoo`0LOol00ekgOomoo`03
Ool00ekgOomoo`0AOol00ekgOomoo`0<Ool00ekgOomoo`0:Ool00ekgOomoo`0:Ool00ekgOomoo`09
Ool30SL00gooG_Moo`0BOol00ekgOomoo`02Ool01EkgOomoogoo0000AWoo000lOol00`00Oomoo`0=
Ool2G_L7Ool00ekgOomoo`0TOol00ekgOomoo`0TOol00ekgOomoo`09Ool00ekgOomoo`0MOol01Ekg
OomoogooG_L057oo00=NmgooOol037oo00=NmgooOol02Woo00=NmgooOol02goo00=NmgooOol02Goo
00@2=gooOomNmaAoo`04G_MoogooG_L4Ool00`00Oomoo`14Ool003aoo`03001oogoo00aoo`03G_Mo
ogoo00Moo`03G_Moogoo02Aoo`03G_Moogoo02Aoo`03G_Moogoo00Qoo`03G_Moogoo01ioo`05G_Mo
ogooOomNm`0DOol00ekgOomoo`0<Ool00ekgOomoo`0:Ool00ekgOomoo`0;Ool00ekgOomoo`0:Ool0
0`9gOomNm`0DOol015kgOomooekg17oo00<007ooOol0A7oo000lOol00`00Oomoo`0:Ool2G_L;Ool0
0ekgOomoo`0SOol00ekgOomoo`0TOol00ekgOomoo`07Ool00ekgOomoo`0OOol015kgOomooekg57oo
00=NmgooOol03Goo00=NmgooOol02Woo00=NmgooOol02goo00=NmgooOol02Goo0`9g00=NmgooOol0
4goo00=NmgooG_L017oo00<007ooOol0A7oo000lOol00`00Oomoo`09Ool00ekgOomoo`0;Ool00ekg
Oomoo`0SOol00ekgOomoo`0TOol00ekgOomoo`07Ool00ekgOomoo`0POol00ekgOomNm`0DOol00ekg
Oomoo`0=Ool00ekgOomoo`0:Ool00ekgOomoo`0;Ool00ekgOomoo`0:Ool0109gOomooekg57oo0Ukg
1Goo00<007ooOol0A7oo000lOol00`00Oomoo`07Ool2G_L>Ool00ekgOomoo`0SOol00ekgOomoo`0T
Ool00ekgOomoo`06Ool00ekgOomoo`0QOol00ekgOomNm`0DOol00ekgOomoo`0=Ool00ekgOomoo`0:
Ool00ekgOomoo`0;Ool00ekgOomoo`0=Ool00ekgOomoo`0COol00ekgOomoo`03Ool00`00Oomoo`14
Ool003aoo`03001oogoo00Ioo`03G_Moogoo00ioo`03G_Moogoo02=oo`03G_Moogoo02Eoo`03G_Mo
ogoo00Aoo`03G_Moogoo02=oo`03G_Moogoo01=oo`03G_Moogoo00eoo`03G_Moogoo00Yoo`03G_Mo
ogoo00]oo`03G_Moogoo00]oo`030[Mooekg01Aoo`9Nm`Eoo`03001oogoo04Aoo`00?7oo00<007oo
Ool017oo0Ukg4Goo00=NmgooOol08goo00=NmgooOol09Goo00=NmgooOol017oo00=NmgooOol08goo
00=NmgooOol04Woo00=NmgooOol03Goo00=NmgooOol02goo00=NmgooOol02goo00=NmgooOol02Woo
0`:g00=NmgooOol04Woo0Ukg1Goo00<007ooOol0A7oo000lOol00`00Oomoo`03Ool00ekgOomoo`0A
Ool00ekgOomoo`0SOol00ekgOomoo`0UOol00ekgOomoo`03Ool00ekgOomoo`0SOol00ekgOomNm`0C
Ool00ekgOomoo`0=Ool00ekgOomoo`0;Ool00ekgOomoo`0;Ool00ekgOomoo`0;Ool00`:gOomNm`0D
Ool00ekgOomNm`04Ool00`00Oomoo`14Ool003aoo`04001oogooOol2G_LDOol00ekgOomoo`0TOol0
0ekgOomoo`0TOol00ekgOomoo`02Ool00ekgOomoo`0TOol00ekgOomNm`0COol00ekgOomoo`0=Ool0
0ekgOomoo`0;Ool00ekgOomoo`0;Ool00ekgOomoo`0=Ool00`;fG_Moo`0AOol015kgOomooekg17oo
00<007ooOol0A7oo000lOol01000Oomooekg5Woo00=NmgooOol097oo00=NmgooOol097oo00ENmgoo
Oomooekg02Moo`04G_MoogooG_LBOol00ekgOomoo`0=Ool00ekgOomoo`0;Ool00ekgOomoo`0<Ool0
0ekgOomoo`0;Ool00`;f0_L2mP0BOol01EkgOomoogooG_L00goo00<007ooOol0A7oo000lOol00`00
G_MNm`0HOol00ekgOomoo`0SOol00ekgOomoo`0UOol015kgOomooekg9Woo00ENmgooOomooekg015o
o`03G_Moogoo00ioo`03G_Moogoo00]oo`03G_Moogoo00aoo`03G_Moogoo00aoo`030_INmgoo015o
o`05G_MoogooOomNm`03Ool00`00Oomoo`14Ool003aoo`03G_Moogoo01Qoo`03G_Moogoo02=oo`03
G_Moogoo02Eoo`03G_Mooekg02Moo`05G_MoogooOomNm`0AOol00ekgOomoo`0>Ool00ekgOomoo`0;
Ool00ekgOomoo`0<Ool00ekgOomoo`0=Ool00ekgOomoo`0?Ool00ekgOomoo`02Ool01EkgOomoogoo
0000AWoo000lOol00`00Oomoo`0HOol00ekgOomoo`0SOol00ekgOomoo`0UOol2G_LWOol00ekgOomo
o`03Ool00ekgOomoo`0>Ool00ekgOomoo`0>Ool00ekgOomoo`0;Ool00ekgOomoo`0<Ool00ekgOomo
o`0=Ool00`;dG_Moo`0?Ool00ekgOomoo`03Ool015kgOomoo`00AWoo000lOol2000IOol00ekgOomo
o`0SOol00ekgOomoo`0UOol2G_LWOol00ekgOomoo`03Ool00ekgOomoo`0>Ool00ekgOomoo`0>Ool0
0ekgOomoo`0;Ool00ekgOomoo`0<Ool00ekgOomoo`0<Ool30_@?Ool00ekgOomoo`04Ool015kgOol0
0000AWoo000lOol00`00Oomoo`0HOol00ekgOomoo`0TOol00ekgOomoo`0TOol2G_LWOol00ekgOomo
o`04Ool00ekgOomoo`0=Ool00ekgOomoo`0>Ool00ekgOomoo`0;Ool00ekgOomoo`0<Ool00ekgOomo
o`0=Ool00`;dG_Moo`0>Ool00ekgOomoo`05Ool00ekgOol00016Ool003aoo`03001oogoo01Qoo`03
G_Moogoo02Aoo`03G_Moogoo02=oo`03G_Mooekg02Ioo`03G_Moogoo00Eoo`03G_Moogoo00aoo`03
G_Moogoo00ioo`03G_Moogoo00aoo`03G_Moogoo00aoo`03G_Moogoo00ioo`030_9oogoo00eoo`03
G_Moogoo00Eoo`03G_Moo`0004Ioo`00?7oo00<007ooOol067oo00=NmgooOol097oo00=NmgooOol0
8goo00=NmgooG_L09Woo00=NmgooOol01Woo00=NmgooOol02goo00=NmgooOol03Woo00=NmgooOol0
37oo00=NmgooOol037oo00=NmgooOol03Goo0`;b3Goo00=NmgooOol01Woo00=Nmgoo0000AWoo000l
Ool00`00Oomoo`0IOol00ekgOomoo`0SOol00ekgOomoo`0ROol015kgOomooekg9Goo00=NmgooOol0
1goo00=NmgooOol02goo00=NmgooOol03Woo00=NmgooOol037oo00=NmgooOol037oo00=NmgooOol0
3Woo00<2lUkgOol037oo00=NmgooOol01goo00=Nm`00Ool0AGoo000lOol00`00Oomoo`0IOol00ekg
Oomoo`0SOol00ekgOomoo`0QOol00ekgOomoo`02Ool00ekgOomoo`0ROol00ekgOomoo`08Ool00ekg
Oomoo`0:Ool00ekgOomoo`0>Ool00ekgOomoo`0<Ool00ekgOomoo`0=Ool00ekgOomoo`0>Ool00ekg
Oomoo`0:Ool00ekgOomoo`08Ool00ekg001oo`15Ool003aoo`03001oogoo01Uoo`03G_Moogoo02Ao
o`03G_Moogoo01moo`03G_Moogoo00=oo`03G_Moogoo029oo`03G_Moogoo00Qoo`03G_Moogoo00Uo
o`03G_Moogoo00moo`03G_Moogoo00aoo`03G_Moogoo00eoo`03G_Moogoo00ioo`030^moogoo00Yo
o`03G_Moogoo00Uoo`03G_Moogoo04Aoo`00?7oo00<007ooOol06Goo00=NmgooOol097oo00=Nmgoo
Ool07goo00=NmgooOol00goo00=NmgooOol08Goo00=NmgooOol02Woo00=NmgooOol027oo00=Nmgoo
Ool03goo00=NmgooOol037oo00=NmgooOol03Goo00=NmgooOol03Goo00<2k`;`0^l02Woo00=Nmgoo
Ool02Woo00=NmgooOol0A7oo000lOol00`00Oomoo`0IOol00ekgOomoo`0TOol00ekgOomoo`0NOol0
0ekgOomoo`05Ool00ekgOomoo`0POol00ekgOomoo`0:Ool00ekgOomoo`08Ool00ekgOomoo`0?Ool0
0ekgOomoo`0<Ool00ekgOomoo`0=Ool00ekgOomoo`0>Ool00`;_G_Moo`09Ool00ekgOomoo`0:Ool0
0`00Oomoo`14Ool003aoo`03001oogoo01Uoo`03G_Moogoo02Aoo`03G_Moogoo01eoo`03G_Moogoo
00Ioo`03G_Moogoo01moo`03G_Moogoo00aoo`03G_Moogoo00Moo`03G_Moogoo00moo`03G_Moogoo
00aoo`03G_Moogoo00eoo`03G_Moogoo00moo`030^eoogoo00Moo`03G_Moogoo00]oo`03001oogoo
04Aoo`00?7oo00<007ooOol06Goo00=NmgooOol097oo00=NmgooOol07Goo00=NmgooOol01Woo00=N
mgooOol07goo00=NmgooOol037oo00=NmgooOol01Woo00=NmgooOol047oo00=NmgooOol037oo00=N
mgooOol03Goo00=NmgooOol03Woo0`;]1goo00=NmgooOol037oo00<007ooOol0A7oo000lOol00`00
Oomoo`0IOol00ekgOomoo`0UOol00ekgOomoo`0KOol00ekgOomoo`07Ool00ekgOomoo`0OOol00ekg
Oomoo`0=Ool00ekgOomoo`05Ool00ekgOomoo`0@Ool00ekgOomoo`0<Ool00ekgOomoo`0=Ool00ekg
Oomoo`0?Ool00`;]Oomoo`06Ool00ekgOomoo`0<Ool00`00Oomoo`14Ool003aoo`03001oogoo01Yo
o`03G_Moogoo02Aoo`03G_Moogoo01Yoo`03G_Moogoo00Uoo`03G_Moogoo01eoo`03G_Moogoo00io
o`03G_Moogoo00Eoo`03G_Moogoo00moo`03G_Moogoo00eoo`03G_Moogoo00eoo`03G_Moogoo011o
o`030^]oogoo00Aoo`03G_Moogoo00eoo`03001oogoo04Aoo`00?7oo00<007ooOol06Woo00=Nmgoo
Ool097oo00=NmgooOol06Woo00=NmgooOol02Goo00=NmgooOol07Goo00=NmgooOol03goo00=Nmgoo
Ool017oo00=NmgooOol03goo00=NmgooOol03Goo00=NmgooOol03Goo00=NmgooOol03goo0`;[17oo
00=NmgooOol03Woo00<007ooOol0A7oo000lOol00`00Oomoo`0JOol00ekgOomoo`0TOol00ekgOomo
o`0IOol00ekgOomoo`0:Ool00ekgOomoo`0LOol00ekgOomoo`0@Ool00ekgOomoo`04Ool00ekgOomo
o`0?Ool00ekgOomoo`0=Ool00ekgOomoo`0>Ool00ekgOomoo`0?Ool00`;[Oomoo`03Ool00ekgOomo
o`0>Ool00`00Oomoo`14Ool003aoo`03001oogoo01Yoo`03G_Moogoo02Aoo`03G_Moogoo01Qoo`03
G_Moogoo00aoo`03G_Moogoo01]oo`03G_Moogoo015oo`03G_Moogoo009oo`03G_Moogoo011oo`03
G_Moogoo00eoo`03G_Moogoo00ioo`03G_Moogoo00moo`03G_Moogoo009oo`03G_Moogoo00moo`03
001oogoo04Aoo`00?7oo00<007ooOol06Woo00=NmgooOol09Goo00=NmgooOol05goo00=NmgooOol0
37oo00=NmgooOol06goo00=NmgooOol04Goo00=NmgooOol00Woo00=NmgooOol047oo00=NmgooOol0
3Goo00=NmgooOol03Woo00=NmgooOol047oo00D2j7ooOomooekg015oo`03001oogoo04Aoo`00?7oo
00<007ooOol06Woo00=NmgooOol09Goo00=NmgooOol05Woo00=NmgooOol03Goo00=NmgooOol06Woo
00=NmgooOol04goo00ENmgooOomooekg019oo`03G_Moogoo00eoo`03G_Moogoo00ioo`03G_Moogoo
00moo`<2j003OomNmgoo015oo`03001oogoo04Aoo`00?7oo00<007ooOol06Woo00=NmgooOol09Goo
00=NmgooOol05Goo00=NmgooOol03Woo00=NmgooOol06Woo00=NmgooOol057oo00ANmgooOomNma9o
o`03G_Moogoo00eoo`03G_Moogoo00ioo`03G_Moogoo011oo`030^Qooekg01=oo`03001oogoo04Ao
o`00?7oo00<007ooOol06Woo00=NmgooOol09Goo00=NmgooOol057oo00=NmgooOol047oo00=Nmgoo
Ool067oo00=NmgooOol05Goo00=NmgooG_L04goo00=NmgooOol03Goo00=NmgooOol03Woo00=Nmgoo
Ool047oo00=Nm`;VG_L04goo00<007ooOol0A7oo000lOol00`00Oomoo`0KOol00ekgOomoo`0TOol0
0ekgOomoo`0DOol00ekgOomoo`0@Ool00ekgOomoo`0HOol00ekgOomoo`0FOol2G_LCOol00ekgOomo
o`0=Ool00ekgOomoo`0>Ool00ekgOomoo`0@Ool30^HCOol00`00Oomoo`14Ool003aoo`03001oogoo
01]oo`03G_Moogoo02Aoo`03G_Moogoo01=oo`03G_Moogoo015oo`03G_Moogoo01Qoo`03G_Moogoo
01Moo`03G_Moogoo011oo`03G_Moogoo00ioo`03G_Moogoo00ioo`03G_Moogoo011oo`03G_L2iWoo
01=oo`03001oogoo04Aoo`00?7oo00<007ooOol06goo00=NmgooOol09Goo00=NmgooOol04Goo00=N
mgooOol04Woo00=NmgooOol05goo00=NmgooOol067oo0Ukg4Goo00=NmgooOol03Woo00=NmgooOol0
3Woo00=NmgooOol03goo00=NmgooG_L057oo00<007ooOol0A7oo000lOol2000LOol00ekgOomoo`0U
Ool00ekgOomoo`0AOol00ekgOomoo`0COol00ekgOomoo`0FOol00ekgOomoo`0GOol00ekgOomNm`0A
Ool00ekgOomoo`0>Ool00ekgOomoo`0>Ool00ekgOomoo`0?Ool015kgOomNm`;T4Woo0P00AWoo000l
Ool00`00Oomoo`0KOol00ekgOomoo`0UOol00ekgOomoo`0@Ool00ekgOomoo`0DOol00ekgOomoo`0E
Ool00ekgOomoo`0HOol015kgOomooekg47oo00=NmgooOol03Woo00=NmgooOol03goo00=NmgooOol0
3Goo00=NmgooOol00`;T4Woo00<007ooOol0A7oo000lOol00`00Oomoo`0KOol00ekgOomoo`0UOol0
0ekgOomoo`0?Ool00ekgOomoo`0EOol00ekgOomoo`0EOol00ekgOomoo`0HOol01EkgOomoogooG_L0
3goo00=NmgooOol03Woo00=NmgooOol03goo00=NmgooOol037oo00=NmgooOol00Woo00<2i7ooOol0
4Goo00<007ooOol0A7oo000lOol00`00Oomoo`0KOol00ekgOomoo`0UOol00ekgOomoo`0?Ool00ekg
Oomoo`0FOol00ekgOomoo`0DOol00ekgOomoo`0HOol00ekgOomoo`02Ool00ekgOomoo`0<Ool00ekg
Oomoo`0>Ool00ekgOomoo`0?Ool00ekgOomoo`0;Ool00ekgOomoo`03Ool00ekgOol2h@0AOol00`00
Oomoo`14Ool003aoo`03001oogoo01]oo`03G_Moogoo02Ioo`03G_Moogoo00eoo`03G_Moogoo01Mo
o`03G_Moogoo01=oo`03G_Moogoo01Uoo`03G_Moogoo009oo`03G_Moogoo00aoo`03G_Moogoo00io
o`03G_Moogoo00moo`03G_Moogoo00]oo`03G_Moogoo00=oo`04G_L2h@;Q0^4@Ool00`00Oomoo`14
Ool003aoo`03001oogoo01aoo`03G_Moogoo02Eoo`03G_Moogoo00aoo`03G_Moogoo01Qoo`03G_Mo
ogoo01=oo`03G_Moogoo01Qoo`03G_Moogoo00Aoo`03G_Moogoo00]oo`03G_Moogoo00ioo`03G_Mo
ogoo00moo`03G_Moogoo00Yoo`03G_Moogoo00Aoo`03G_Moo`;Q015oo`03001oogoo04Aoo`00?7oo
00<007ooOol077oo00=NmgooOol09Goo00=NmgooOol037oo00=NmgooOol06Goo00=NmgooOol04Goo
00=NmgooOol06Goo00=NmgooOol01Goo00=NmgooOol02Woo00=NmgooOol03Woo00=NmgooOol03goo
00=NmgooOol02Goo00=NmgooOol01Woo00=NmgooOol047oo00<007ooOol0A7oo000lOol00`00Oomo
o`0LOol00ekgOomoo`0UOol00ekgOomoo`0;Ool00ekgOomoo`0JOol00ekgOomoo`0AOol00ekgOomo
o`0IOol00ekgOomoo`06Ool00ekgOomoo`09Ool00ekgOomoo`0>Ool00ekgOomoo`0?Ool00ekgOomo
o`08Ool00ekgOomoo`07Ool00ekgOomoo`0@Ool00`00Oomoo`14Ool003aoo`03001oogoo01aoo`03
G_Moogoo02Eoo`03G_Moogoo00Yoo`03G_Moogoo01]oo`03G_Moogoo015oo`03G_Moogoo01Uoo`03
G_Moogoo00Moo`03G_Moogoo00Moo`03G_Moogoo00moo`03G_Moogoo00moo`03G_Moogoo00Moo`03
G_Moogoo00Qoo`03G_Moogoo011oo`03001oogoo04Aoo`00?7oo00<007ooOol077oo00=NmgooOol0
9Woo00=NmgooOol027oo00=NmgooOol07Goo00=NmgooOol03goo00=NmgooOol06Goo00=NmgooOol0
2Goo00=NmgooOol01Woo00=NmgooOol03goo00=NmgooOol03goo00=NmgooOol01Woo00=NmgooOol0
2Goo00=NmgooOol047oo00<007ooOol0A7oo000lOol00`00Oomoo`0LOol00ekgOomoo`0VOol00ekg
Oomoo`08Ool00ekgOomoo`0MOol00ekgOomoo`0?Ool00ekgOomoo`0IOol00ekgOomoo`0:Ool00ekg
Oomoo`05Ool00ekgOomoo`0?Ool00ekgOomoo`0@Ool00ekgOomoo`05Ool00ekgOomoo`0:Ool00ekg
Oomoo`0?Ool00`00Oomoo`14Ool003aoo`03001oogoo01eoo`03G_Moogoo02Eoo`03G_Moogoo00Mo
o`03G_Moogoo01ioo`03G_Moogoo00ioo`03G_Moogoo01Yoo`03G_Moogoo00]oo`03G_Moogoo00Ao
o`03G_Moogoo00moo`03G_Moogoo011oo`03G_Moogoo00Aoo`03G_Moogoo00]oo`03G_Moogoo00mo
o`03001oogoo04Aoo`00?7oo00<007ooOol07Goo00=NmgooOol09Goo00=NmgooOol01Woo00=Nmgoo
Ool087oo00=NmgooOol03Goo00=NmgooOol06Woo00=NmgooOol037oo00=NmgooOol00goo00=Nmgoo
Ool03goo00=NmgooOol047oo00=NmgooOol00goo00=NmgooOol037oo00=NmgooOol03goo00<007oo
Ool0A7oo000lOol00`00Oomoo`0MOol00ekgOomoo`0UOol00ekgOomoo`06Ool00ekgOomoo`0POol0
0ekgOomoo`0=Ool00ekgOomoo`0IOol00ekgOomoo`0>Ool00ekgOomoo`02Ool00ekgOomoo`0?Ool0
0ekgOomoo`0@Ool00ekgOomoo`02Ool00ekgOomoo`0=Ool00ekgOomoo`0?Ool00`00Oomoo`14Ool0
03aoo`03001oogoo01eoo`03G_Moogoo02Ioo`03G_Moogoo00Aoo`03G_Moogoo029oo`03G_Moogoo
00]oo`03G_Moogoo01Yoo`03G_Moogoo00moo`05G_MoogooOomNm`0AOol00ekgOomoo`0@Ool01Ekg
OomoogooG_L04Goo00=NmgooOol03Woo00<007ooOol0A7oo000lOol00`00Oomoo`0MOol00ekgOomo
o`0VOol00ekgOomoo`03Ool00ekgOomoo`0SOol00ekgOomoo`0;Ool00ekgOomoo`0JOol00ekgOomo
o`0@Ool2G_L00gooG_Moo`0@Ool00ekgOomoo`0@Ool015kgOomNmekg4Woo00=NmgooOol03Woo00<0
07ooOol0A7oo000lOol00`00Oomoo`0NOol00ekgOomoo`0UOol00ekgOomoo`03Ool00ekgOomoo`0S
Ool00ekgOomoo`0;Ool00ekgOomoo`0JOol00ekgOomoo`0BOol2G_LAOol00ekgOomoo`0@Ool2G_LD
Ool00ekgOomoo`0>Ool00`00Oomoo`14Ool003aoo`03001oogoo01ioo`03G_Moogoo02Eoo`03G_Mo
ogoo009oo`03G_Moogoo02Eoo`03G_Moogoo00Uoo`03G_Moogoo01]oo`03G_Moogoo019oo`04G_Mo
oekgG_L?Ool00ekgOomoo`0>Ool3G_LEOol00ekgOomoo`0>Ool00`00Oomoo`14Ool003aoo`03001o
ogoo01ioo`03G_Moogoo02Eoo`05G_MoogooOomNm`0XOol00ekgOomoo`09Ool00ekgOomoo`0JOol0
0ekgOomoo`0COol015kgOomoogoo0Ukg3Goo00=NmgooOol037oo0Ukg0Woo00=NmgooOol04goo00=N
mgooOol03Woo00<007ooOol0A7oo000lOol00`00Oomoo`0NOol00ekgOomoo`0VOol015kgOomooekg
:7oo00=NmgooOol027oo00=NmgooOol06goo00=NmgooOol04goo00=NmgooOol00goo0Ukg2goo00=N
mgooOol02Woo0Ukg1Goo00=NmgooOol04goo00=NmgooOol03Goo00<007ooOol0A7oo000fOol30003
Ool00`00Oomoo`0NOol00ekgOomoo`0VOol00ekgOomNm`0ZOol00ekgOomoo`07Ool00ekgOomoo`0K
Ool00ekgOomoo`0COol00ekgOomoo`05Ool3G_L8Ool00ekgOomoo`07Ool3G_L7Ool00ekgOomoo`0C
Ool00ekgOomoo`0=Ool00`00Oomoo`14Ool003Moo`03001oogoo009oo`03001oogoo01ioo`03G_Mo
ogoo02Ioo`9Nmb]oo`03G_Moogoo00Moo`03G_Moogoo01]oo`03G_Moogoo01=oo`03G_Moogoo00Qo
o`=Nm`Eoo`03G_Moogoo00Aoo`=Nm`Yoo`03G_Moogoo01=oo`03G_Moogoo00eoo`03001oogoo04Ao
o`00=Goo10000goo0P0087oo00=NmgooOol09Goo00=NmgooOol0:Woo00=NmgooOol01Woo00=Nmgoo
Ool06goo00=NmgooOol057oo00=NmgooOol02goo35kg3Goo00=NmgooOol04goo00=NmgooOol02goo
0`00AWoo000eOol00`00Ool00004Ool00`00Oomoo`0OOol00ekgOomoo`0UOol2G_L/Ool00ekgOomo
o`05Ool00ekgOomoo`0KOol00ekgOomoo`0DOol00ekgOomoo`0@Ool00ekgOomoo`0AOol00ekgOomo
o`0DOol00ekgOomoo`0<Ool00`00Oomoo`14Ool003Ioo`8000Aoo`03001oogoo01moo`03G_Moogoo
02Aoo`03G_Mooekg02aoo`03G_Moogoo00Aoo`03G_Moogoo01aoo`03G_Moogoo01Aoo`03G_Moogoo
011oo`03G_Moogoo015oo`03G_Moogoo01Aoo`03G_Moogoo00aoo`03001oogoo04Aoo`00=goo00<0
07ooOol00Woo00<007ooOol07goo00=NmgooOol08goo00ANmgooOomNmbaoo`03G_Moogoo00Aoo`03
G_Moogoo01aoo`03G_Moogoo01Aoo`03G_Moogoo011oo`03G_Moogoo015oo`03G_Moogoo01Aoo`03
G_Moogoo00aoo`03001oogoo04Aoo`00?7oo00<007ooOol07goo00=NmgooOol08goo00ANmgooOomN
mbeoo`03G_Moogoo00=oo`03G_Moogoo01aoo`03G_Moogoo01Aoo`03G_Moogoo011oo`03G_Moogoo
015oo`03G_Moogoo01Aoo`03G_Moogoo00aoo`03001oogoo04Aoo`00?7oo00<007ooOol087oo00=N
mgooOol08Goo00=NmgooOol00Woo00=NmgooOol0:Woo00=NmgooOol00Woo00=NmgooOol077oo00=N
mgooOol057oo00=NmgooOol04Goo00=NmgooOol04Goo00=NmgooOol05Goo00=NmgooOol02goo00<0
07ooOol0A7oo000lOol00`00Oomoo`0POol00ekgOomoo`0POol00ekgOomoo`03Ool00ekgOomoo`0Z
Ool00ekgOomoo`02Ool00ekgOomoo`0LOol00ekgOomoo`0DOol00ekgOomoo`0AOol00ekgOomoo`0B
Ool00ekgOomoo`0DOol00ekgOomoo`0;Ool00`00Oomoo`14Ool003aoo`03001oogoo021oo`03G_Mo
ogoo021oo`03G_Moogoo00=oo`03G_Moogoo02]oo`04G_MoogooG_LOOol00ekgOomoo`0DOol00ekg
Oomoo`0AOol00ekgOomoo`0BOol00ekgOomoo`0DOol00ekgOomoo`0;Ool00`00Oomoo`14Ool003ao
o`03001oogoo021oo`03G_Moogoo01moo`03G_Moogoo00Aoo`03G_Moogoo02]oo`04G_MoogooG_LO
Ool00ekgOomoo`0DOol00ekgOomoo`0AOol00ekgOomoo`0BOol00ekgOomoo`0DOol00ekgOomoo`0;
Ool00`00Oomoo`14Ool003aoo`03001oogoo021oo`03G_Moogoo01ioo`03G_Moogoo00Ioo`03G_Mo
ogoo02]oo`03G_Mooekg01ioo`03G_Moogoo01Eoo`03G_Moogoo015oo`03G_Moogoo019oo`03G_Mo
ogoo01Eoo`03G_Moogoo00Yoo`03001oogoo04Aoo`00?7oo00<007ooOol08Goo00=NmgooOol077oo
00=NmgooOol01goo00=NmgooOol0:goo0Ukg7goo00=NmgooOol05Goo00=NmgooOol04Goo00=Nmgoo
Ool04Woo00=NmgooOol05Goo00=NmgooOol02Woo00<007ooOol0A7oo000lOol00`00Oomoo`0QOol0
0ekgOomoo`0LOol00ekgOomoo`07Ool00ekgOomoo`0[Ool2G_LOOol00ekgOomoo`0EOol00ekgOomo
o`0AOol00ekgOomoo`0BOol00ekgOomoo`0EOol00ekgOomoo`0:Ool00`00Oomoo`14Ool003aoo`03
001oogoo025oo`03G_Moogoo01]oo`03G_Moogoo00Qoo`03G_Moogoo02]oo`9Nmamoo`03G_Moogoo
01Eoo`03G_Moogoo015oo`03G_Moogoo019oo`03G_Moogoo01Eoo`03G_Moogoo00Yoo`03001oogoo
04Aoo`00?7oo00<007ooOol08Goo00=NmgooOol06Woo00=NmgooOol02Goo00=NmgooOol0:goo0Ukg
7Woo00=NmgooOol05Woo00=NmgooOol04Goo00=NmgooOol04Woo00=NmgooOol05Goo00=NmgooOol0
2Woo00<007ooOol0A7oo000lOol00`00Oomoo`0QOol00ekgOomoo`0JOol00ekgOomoo`0:Ool00ekg
Oomoo`0ZOol00ekgOomNm`0MOol00ekgOomoo`0EOol00ekgOomoo`0BOol00ekgOomoo`0BOol00ekg
Oomoo`0FOol00ekgOomoo`09Ool00`00Oomoo`14Ool003aoo`03001oogoo029oo`03G_Moogoo01Qo
o`03G_Moogoo00]oo`03G_Moogoo02Uoo`04G_MoogooG_LMOol00ekgOomoo`0EOol00ekgOomoo`0B
Ool00ekgOomoo`0COol00ekgOomoo`0EOol00ekgOomoo`09Ool00`00Oomoo`14Ool003aoo`03001o
ogoo029oo`03G_Moogoo01Moo`03G_Moogoo00aoo`03G_Moogoo02Uoo`04G_MoogooG_LMOol00ekg
Oomoo`0EOol00ekgOomoo`0BOol00ekgOomoo`0COol00ekgOomoo`0EOol00ekgOomoo`09Ool00`00
Oomoo`14Ool003aoo`03001oogoo029oo`03G_Moogoo01Moo`03G_Moogoo00aoo`03G_Moogoo02Qo
o`03G_Moogoo009oo`03G_Moogoo01Yoo`03G_Moogoo01Eoo`03G_Moogoo019oo`03G_Moogoo01=o
o`03G_Moogoo01Eoo`03G_Moogoo00Uoo`03001oogoo04Aoo`00?7oo00<007ooOol08Woo00=Nmgoo
Ool05Woo00=NmgooOol03Woo00=NmgooOol09goo00=NmgooOol00Woo00=NmgooOol06Goo00=Nmgoo
Ool05Woo00=NmgooOol04Woo00=NmgooOol04goo00=NmgooOol05Woo00=NmgooOol027oo00<007oo
Ool0A7oo000lOol00`00Oomoo`0ROol00ekgOomoo`0EOol00ekgOomoo`0?Ool00ekgOomoo`0WOol0
0ekgOomoo`02Ool00ekgOomoo`0IOol00ekgOomoo`0FOol00ekgOomoo`0BOol00ekgOomoo`0COol0
0ekgOomoo`0FOol00ekgOomoo`08Ool00`00Oomoo`14Ool003aoo`03001oogoo029oo`03G_Moogoo
01Eoo`03G_Moogoo00moo`03G_Moogoo02Ioo`03G_Moogoo00Aoo`03G_Moogoo01Qoo`03G_Moogoo
01Ioo`03G_Moogoo019oo`03G_Moogoo01=oo`03G_Moogoo01Ioo`03G_Moogoo00Qoo`03001oogoo
04Aoo`00?7oo00<007ooOol08goo00=NmgooOol04goo00=NmgooOol047oo00=NmgooOol09Woo00=N
mgooOol017oo00=NmgooOol067oo00=NmgooOol05Woo00=NmgooOol04Woo00=NmgooOol04goo00=N
mgooOol05Woo00=NmgooOol027oo00<007ooOol0A7oo000lOol00`00Oomoo`0SOol00ekgOomoo`0B
Ool00ekgOomoo`0BOol00ekgOomoo`0TOol00ekgOomoo`06Ool00ekgOomoo`0FOol00ekgOomoo`0G
Ool00ekgOomoo`0BOol00ekgOomoo`0COol00ekgOomoo`0GOol00ekgOomoo`07Ool00`00Oomoo`14
Ool003aoo`8002Aoo`03G_Moogoo015oo`03G_Moogoo01=oo`03G_Moogoo02Aoo`03G_Moogoo00Io
o`03G_Moogoo01Ioo`03G_Moogoo01Moo`03G_Moogoo019oo`03G_Moogoo01=oo`03G_Moogoo01Mo
o`03G_Moogoo00Ioo`8004Ioo`00?7oo00<007ooOol08goo00=NmgooOol04Goo00=NmgooOol04goo
00=NmgooOol097oo00=NmgooOol01Woo00=NmgooOol05Woo00=NmgooOol05Woo00=NmgooOol04goo
00=NmgooOol057oo00=NmgooOol05Woo00=NmgooOol01goo00<007ooOol0A7oo000lOol00`00Oomo
o`0SOol00ekgOomoo`0@Ool00ekgOomoo`0DOol00ekgOomoo`0SOol00ekgOomoo`08Ool00ekgOomo
o`0EOol00ekgOomoo`0FOol00ekgOomoo`0COol00ekgOomoo`0DOol00ekgOomoo`0FOol00ekgOomo
o`07Ool00`00Oomoo`14Ool003aoo`03001oogoo00moo`03001oogoo019oo`03G_Moogoo00aoo`03
001ooekg01Qoo`03G_Moogoo00Moo`03001oogoo01Qoo`03G_Moogoo00Ioo`03001ooekg01Ioo`03
G_Moogoo00Uoo`03001oogoo00]oo`03G_Moogoo01=oo`03G_Moogoo01Aoo`03G_Moogoo00]oo`03
001oogoo00Uoo`03G_Moogoo00Ioo`03001oogoo04Aoo`00?7oo00<007ooOol01Woo00<007ooOol0
1Woo00<007ooOol01Woo00<007ooOol01Woo00@007ooOomNm`Eoo`03001oogoo00Ioo`03001ooekg
00Moo`03001oogoo00Ioo`03001oogoo00Eoo`03G_L007oo00Moo`03001oogoo00Ioo`03001oogoo
00Ioo`03001oogoo00Eoo`03G_L007oo00Moo`04001oogooG_L6Ool00`00Oomoo`06Ool00`00Oomo
o`03Ool015kgOomoo`0027oo00<007ooOol01Woo00<007ooOol00Woo00ENmgooOomoo`0000Qoo`03
001oogoo00Ioo`03G_Moogoo00Ioo`03001oogoo00Moo`05001oogooOomNm`04Ool00`00Oomoo`06
Ool00`00Oomoo`06Ool01000Oomooekg1Goo00@007ooOol004Ioo`00?7oo9`0000=Nm`0000003@00
00=Nm`0000005`0000=Nm`0000008@0000=Nm`0000002P0000=Nm`0000004`0000=Nm`0000005`00
00=Nm`0000004`0000=Nm`000000500000=Nm`0000005`0000=Nm`0000001`00AWoo003oOon6Ool0
0?moohIoo`00ogooQWoo003oOon6Ool00?moohIoo`00ogooQWoo003oOon6Ool00?moohIoo`00ogoo
QWoo003oOon6Ool00?moohIoo`00ogooQWoo003oOon6Ool00?moohIoo`00ogooQWoo003oOon6Ool0
0?moohIoo`00PGoo00<007ooOol05Woo00<007ooOol02Goo00<007ooOol0;7oo00<007ooOol02Goo
00<007ooOol0=7oo00<007ooOol0JWoo0020Ool00`00Oomoo`0;Ool00`00Oomoo`0:Ool00`00Oomo
o`07Ool00`00Oomoo`0@Ool00`00Oomoo`0>Ool00`00Oomoo`0:Ool00`00Oomoo`07Ool00`00Oomo
o`0@Ool00`00Oomoo`0FOol00`00Oomoo`0:Ool00`00Oomoo`1YOol007moo`03001oogoo009oo`<0
00Moo`03001oogoo00Aoo`03001oogoo00Aoo`03001oogoo00Eoo`03001oogoo009oo`<000aoo`03
001oogoo00=oo`<000Qoo`03001oogoo009oo`D000Aoo`03001oogoo00Eoo`03001oogoo009oo`<0
00aoo`03001oogoo00=oo`<000Ioo`<000Moo`03001oogoo00=oo`<000Eoo`03001oogoo06Qoo`00
Ogoo00<007ooOol017oo0P0017oo1@000goo00<007oo00001Goo00<007ooOol01Goo00<007ooOol0
17oo0P002Goo1@001Goo0P001Goo1@0017oo00<007ooOol017oo00<007ooOol01Goo00<007ooOol0
17oo0P002Goo1@000goo00<007ooOol027oo0P0017oo1@000goo00<007ooOol01Goo00<007ooOol0
J7oo001oOol00`00Oomoo`03Ool00`00Oomoo`06Ool00`00Oomoo`05Ool00`00Oomoo`03Ool00`00
Oomoo`05Ool00`00Oomoo`03Ool00`00Oomoo`02Ool30006Ool00`00Oomoo`04Ool00`00Oomoo`07
Ool00`00Oomoo`04Ool00`00Oomoo`04Ool00`00Oomoo`05Ool00`00Oomoo`03Ool00`00Oomoo`02
Ool30006Ool00`00Oomoo`04Ool00`00Oomoo`06Ool00`00Oomoo`06Ool00`00Oomoo`04Ool00`00
Oomoo`04Ool00`00Oomoo`1XOol007moo`03001oogoo00=oo`<000Ioo`03001oogoo00=oo`8000Io
o`03001oogoo00Eoo`03001oogoo00=oo`<0009oo`8000Moo`03001oogoo00Aoo`<000Moo`03001o
ogoo00Aoo`03001oogoo00Aoo`03001oogoo00Eoo`03001oogoo00=oo`<0009oo`8000Moo`03001o
ogoo00Aoo`03001oogoo00Ioo`<000Ioo`03001oogoo00Aoo`03001oogoo00Aoo`03001oogoo06Qo
o`00HWoo0P0027oo0P004Woo00<007ooOol04Goo00<007ooOol017oo00<007ooOol01goo00<007oo
Ool02Goo00<007ooOol077oo00<007ooOol00goo00<007ooOol01goo00<007ooOol02Goo00<007oo
Ool02Woo00<007oo00005Woo00<007oo000017oo00<007ooOol0JGoo001ROol00`00Oomoo`08Ool0
0`00Oomoo`0AOol00`00Oomoo`0@Ool30003Ool00`00Oomoo`09Ool00`00Oomoo`08Ool00`00Oomo
o`0KOol20004Ool00`00Oomoo`09Ool00`00Oomoo`08Ool00`00Oomoo`0;Ool00`00Oomoo`0FOol0
0`00Oomoo`02Ool00`00Oomoo`1ZOol005]oo`8000Eoo`04001oogooOol20005Ool00`00Oomoo`02
Ool4000iOol3000hOol3002HOol005Yoo`03001oo`0000Eoo`03001oogoo00=oo`03001oogoo009o
o`03001oogoo00]ooj@006Ioo`00FWoo00@007oo000000Aoo`03001oogoo009oo`03001oogoo00=o
o`03001oogoo009oo`@00?mooa1oo`00FWoo00<007ooOol01Goo00<007ooOol00Woo0P0017oo00<0
07ooOol0ogoo5Woo001JOol00`00Oomoo`05Ool00`00Oomoo`08Ool00`00Oomoo`0jOol00`00Oomo
o`0GOol00`00Oomoo`08Ool00`00Oomoo`0MOol00`00Oomoo`2COol005Yoo`<000Eoo`8000Qoo`80
03]oo`03001oogoo00]oo`03001oogoo00]oo`03001oogoo00Ioo`03001oogoo00aoo`03001oogoo
011oo`03001oogoo099oo`00Z7oo00<007ooOol00Woo0`001goo00<007ooOol01Goo0`0017oo00<0
07ooOol017oo00<007ooOol00Woo0`0027oo00<007ooOol00Woo1@000Woo00<007ooOol01Goo00<0
07ooOol0TGoo002XOol00`00Oomoo`04Ool20004Ool50006Ool00`00Oomoo`03Ool00`00Oomoo`04
Ool00`00Oomoo`04Ool20005Ool50004Ool01`00Oomoogoo001oo`0000Ioo`03001oogoo095oo`00
Z7oo00<007ooOol00goo00<007ooOol01Woo00<007ooOol017oo100017oo00<007ooOol017oo00<0
07ooOol00goo00<007ooOol01goo00<007ooOol017oo00L007ooOomoo`00Ool00006Ool00`00Oomo
o`2AOol00:Qoo`03001oogoo00=oo`<000Ioo`03001oogoo00Aoo`03001oo`0000Eoo`03001oogoo
00Aoo`03001oogoo00=oo`<000Moo`03001oogoo00Aoo`07001oogooOol007oo00001Woo00<007oo
Ool0TGoo002YOol00`00Oomoo`0COol20004Ool00`00Oomoo`06Ool00`00Oomoo`0COol01`00Oomo
ogoo001oo`0000Eoo`03001oogoo099oo`00ZWoo00<007ooOol04goo00D007ooOomoo`0000Yoo`03
001oogoo015oo`8000Aoo`03001oogoo00=oo`03001oogoo09=oo`00ogooQWoo003oOon6Ool00?mo
ohIoo`00ogooQWoo003oOon6Ool00?moohIoo`00ogooQWoo003oOon6Ool00?moohIoo`00ogooQWoo
003oOon6Ool00?moohIoo`00ogooQWoo003oOon6Ool00?moohIoo`00ogooQWoo003oOon6Ool00?mo
ohIoo`00ogooQWoo003oOon6Ool00?moohIoo`00ogooQWoo003oOon6Ool00?moohIoo`00ogooQWoo
003oOon6Ool00?moohIoo`00ogooQWoo003oOon6Ool00?moohIoo`00ogooQWoo003oOon6Ool00?mo
ohIoo`00ogooQWoo0000\
\>"],
  ImageRangeCache->{{{0, 388.188}, {547.875, 0}} -> {-0.653492, -1.05073, \
0.00383565, 0.00383565}, {{9.1875, 331.5}, {534.625, 13.1875}} -> {-14.3065, \
-5.88265, 0.0548558, 0.0220169}, {{352.813, 378.938}, {404.25, 273.938}} -> \
{-27.6386, -44.1511, 0.0782742, 0.307265}},
  CellTags->{"Root Locus", "i:11", "b:20.3"}],

Cell[BoxData[
    TagBox[\(\[SkeletonIndicator]  Graphics  \[SkeletonIndicator]\),
      False,
      Editable->False]], "Output",
  CellLabel->"Out[118]=",
  CellTags->{"Root Locus", "i:11", "b:20.3"}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
    \(G[s_] := \(\((s + 10)\)\ \((s + 4)\)\)\/\(s\ \((s + 5)\)\ \((s + 2)\)\ \
\((s\^2 +  .2\ s + 2)\)\ \((s\^2 + 1\ s + 1)\)\)\), "\n", 
    \(RootLocus[G, s, k, 0, \(+40. \), 1. ]\)}], "Input",
  CellLabel->"In[137]:=",
  CellTags->{"Root Locus", "i:11", "b:20.3"}],

Cell[BoxData[
    \("\n                Zeros in green, Open loop poles in red\n"\)], "Print",\

  CellLabel->"From In[137]:=",
  CellTags->{"Root Locus", "i:11", "b:20.3"}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: 1.4104 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.438894 0.671621 0.705202 0.671621 [
[ 0 0 0 0 ]
[ 1 1.4104 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
% Start of sub-graphic
p
0.0238095 0.033581 0.853978 1.37682 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.803899 0.0730817 0.809017 0.218073 [
[.07308 -0.0125 -9 -9 ]
[.07308 -0.0125 9 0 ]
[.21925 -0.0125 -6 -9 ]
[.21925 -0.0125 6 0 ]
[.36541 -0.0125 -6 -9 ]
[.36541 -0.0125 6 0 ]
[.51157 -0.0125 -6 -9 ]
[.51157 -0.0125 6 0 ]
[.65774 -0.0125 -6 -9 ]
[.65774 -0.0125 6 0 ]
[.8039 -0.0125 -3 -9 ]
[.8039 -0.0125 3 0 ]
[.95006 -0.0125 -3 -9 ]
[.95006 -0.0125 3 0 ]
[ 0 0 -0.125 0 ]
[.5 -0.0125 -17.3125 -22.1875 ]
[.5 -0.0125 17.3125 -9 ]
[-0.0125 .1548 -12 -4.5 ]
[-0.0125 .1548 0 4.5 ]
[-0.0125 .37287 -12 -4.5 ]
[-0.0125 .37287 0 4.5 ]
[-0.0125 .59094 -12 -4.5 ]
[-0.0125 .59094 0 4.5 ]
[-0.0125 .80902 -6 -4.5 ]
[-0.0125 .80902 0 4.5 ]
[-0.0125 1.02709 -6 -4.5 ]
[-0.0125 1.02709 0 4.5 ]
[-0.0125 1.24516 -6 -4.5 ]
[-0.0125 1.24516 0 4.5 ]
[-0.0125 1.46324 -6 -4.5 ]
[-0.0125 1.46324 0 4.5 ]
[ 0 0 -0.125 0 ]
[-0.01875 .80902 -46.625 -6.59375 ]
[-0.01875 .80902 -12 6.59375 ]
[ 0 1.61803 .125 0 ]
[.5 1.63053 -5.0625 0 ]
[.5 1.63053 5.0625 13.1875 ]
[ 1 0 .125 0 ]
[1.0125 .80902 0 -6.59375 ]
[1.0125 .80902 10.125 6.59375 ]
[.5 1.63053 -133.188 13.1875 ]
[.5 1.63053 133.188 35.6875 ]
[ 0 0 0 0 ]
[ 1 1.61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.07308 0 m
.07308 .00625 L
s
[(-10)] .07308 -0.0125 0 1 Mshowa
.21925 0 m
.21925 .00625 L
s
[(-8)] .21925 -0.0125 0 1 Mshowa
.36541 0 m
.36541 .00625 L
s
[(-6)] .36541 -0.0125 0 1 Mshowa
.51157 0 m
.51157 .00625 L
s
[(-4)] .51157 -0.0125 0 1 Mshowa
.65774 0 m
.65774 .00625 L
s
[(-2)] .65774 -0.0125 0 1 Mshowa
.8039 0 m
.8039 .00625 L
s
[(0)] .8039 -0.0125 0 1 Mshowa
.95006 0 m
.95006 .00625 L
s
[(2)] .95006 -0.0125 0 1 Mshowa
.125 Mabswid
.10962 0 m
.10962 .00375 L
s
.14616 0 m
.14616 .00375 L
s
.1827 0 m
.1827 .00375 L
s
.25579 0 m
.25579 .00375 L
s
.29233 0 m
.29233 .00375 L
s
.32887 0 m
.32887 .00375 L
s
.40195 0 m
.40195 .00375 L
s
.43849 0 m
.43849 .00375 L
s
.47503 0 m
.47503 .00375 L
s
.54811 0 m
.54811 .00375 L
s
.58465 0 m
.58465 .00375 L
s
.62119 0 m
.62119 .00375 L
s
.69428 0 m
.69428 .00375 L
s
.73082 0 m
.73082 .00375 L
s
.76736 0 m
.76736 .00375 L
s
.84044 0 m
.84044 .00375 L
s
.87698 0 m
.87698 .00375 L
s
.91352 0 m
.91352 .00375 L
s
.03654 0 m
.03654 .00375 L
s
.9866 0 m
.9866 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
gsave
.5 -0.0125 -78.3125 -26.1875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 21.1875 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(Re) show
%%IncludeResource: font Mathematica2Mono
%%IncludeFont: Mathematica2Mono
/Mathematica2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
75.250 13.313 moveto
(@) show
81.375 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(s) show
%%IncludeResource: font Mathematica2Mono
%%IncludeFont: Mathematica2Mono
/Mathematica2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
87.500 13.313 moveto
(D) show
93.625 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 .1548 m
.00625 .1548 L
s
[(-3)] -0.0125 .1548 1 0 Mshowa
0 .37287 m
.00625 .37287 L
s
[(-2)] -0.0125 .37287 1 0 Mshowa
0 .59094 m
.00625 .59094 L
s
[(-1)] -0.0125 .59094 1 0 Mshowa
0 .80902 m
.00625 .80902 L
s
[(0)] -0.0125 .80902 1 0 Mshowa
0 1.02709 m
.00625 1.02709 L
s
[(1)] -0.0125 1.02709 1 0 Mshowa
0 1.24516 m
.00625 1.24516 L
s
[(2)] -0.0125 1.24516 1 0 Mshowa
0 1.46324 m
.00625 1.46324 L
s
[(3)] -0.0125 1.46324 1 0 Mshowa
.125 Mabswid
0 .19841 m
.00375 .19841 L
s
0 .24203 m
.00375 .24203 L
s
0 .28564 m
.00375 .28564 L
s
0 .32926 m
.00375 .32926 L
s
0 .41649 m
.00375 .41649 L
s
0 .4601 m
.00375 .4601 L
s
0 .50371 m
.00375 .50371 L
s
0 .54733 m
.00375 .54733 L
s
0 .63456 m
.00375 .63456 L
s
0 .67817 m
.00375 .67817 L
s
0 .72179 m
.00375 .72179 L
s
0 .7654 m
.00375 .7654 L
s
0 .85263 m
.00375 .85263 L
s
0 .89625 m
.00375 .89625 L
s
0 .93986 m
.00375 .93986 L
s
0 .98348 m
.00375 .98348 L
s
0 1.0707 m
.00375 1.0707 L
s
0 1.11432 m
.00375 1.11432 L
s
0 1.15793 m
.00375 1.15793 L
s
0 1.20155 m
.00375 1.20155 L
s
0 1.28878 m
.00375 1.28878 L
s
0 1.33239 m
.00375 1.33239 L
s
0 1.37601 m
.00375 1.37601 L
s
0 1.41962 m
.00375 1.41962 L
s
0 .11118 m
.00375 .11118 L
s
0 .06757 m
.00375 .06757 L
s
0 .02395 m
.00375 .02395 L
s
0 1.50685 m
.00375 1.50685 L
s
0 1.55047 m
.00375 1.55047 L
s
0 1.59408 m
.00375 1.59408 L
s
.25 Mabswid
0 0 m
0 1.61803 L
s
gsave
-0.01875 .80902 -107.625 -10.5938 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 21.1875 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(Im) show
%%IncludeResource: font Mathematica2Mono
%%IncludeFont: Mathematica2Mono
/Mathematica2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
75.250 13.313 moveto
(@) show
81.375 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(s) show
%%IncludeResource: font Mathematica2Mono
%%IncludeFont: Mathematica2Mono
/Mathematica2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
87.500 13.313 moveto
(D) show
93.625 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.07308 1.61178 m
.07308 1.61803 L
s
.21925 1.61178 m
.21925 1.61803 L
s
.36541 1.61178 m
.36541 1.61803 L
s
.51157 1.61178 m
.51157 1.61803 L
s
.65774 1.61178 m
.65774 1.61803 L
s
.8039 1.61178 m
.8039 1.61803 L
s
.95006 1.61178 m
.95006 1.61803 L
s
.125 Mabswid
.10962 1.61428 m
.10962 1.61803 L
s
.14616 1.61428 m
.14616 1.61803 L
s
.1827 1.61428 m
.1827 1.61803 L
s
.25579 1.61428 m
.25579 1.61803 L
s
.29233 1.61428 m
.29233 1.61803 L
s
.32887 1.61428 m
.32887 1.61803 L
s
.40195 1.61428 m
.40195 1.61803 L
s
.43849 1.61428 m
.43849 1.61803 L
s
.47503 1.61428 m
.47503 1.61803 L
s
.54811 1.61428 m
.54811 1.61803 L
s
.58465 1.61428 m
.58465 1.61803 L
s
.62119 1.61428 m
.62119 1.61803 L
s
.69428 1.61428 m
.69428 1.61803 L
s
.73082 1.61428 m
.73082 1.61803 L
s
.76736 1.61428 m
.76736 1.61803 L
s
.84044 1.61428 m
.84044 1.61803 L
s
.87698 1.61428 m
.87698 1.61803 L
s
.91352 1.61428 m
.91352 1.61803 L
s
.03654 1.61428 m
.03654 1.61803 L
s
.9866 1.61428 m
.9866 1.61803 L
s
.25 Mabswid
0 1.61803 m
1 1.61803 L
s
gsave
.5 1.63053 -66.0625 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 21.1875 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.125 13.313 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.99375 .1548 m
1 .1548 L
s
.99375 .37287 m
1 .37287 L
s
.99375 .59094 m
1 .59094 L
s
.99375 .80902 m
1 .80902 L
s
.99375 1.02709 m
1 1.02709 L
s
.99375 1.24516 m
1 1.24516 L
s
.99375 1.46324 m
1 1.46324 L
s
.125 Mabswid
.99625 .19841 m
1 .19841 L
s
.99625 .24203 m
1 .24203 L
s
.99625 .28564 m
1 .28564 L
s
.99625 .32926 m
1 .32926 L
s
.99625 .41649 m
1 .41649 L
s
.99625 .4601 m
1 .4601 L
s
.99625 .50371 m
1 .50371 L
s
.99625 .54733 m
1 .54733 L
s
.99625 .63456 m
1 .63456 L
s
.99625 .67817 m
1 .67817 L
s
.99625 .72179 m
1 .72179 L
s
.99625 .7654 m
1 .7654 L
s
.99625 .85263 m
1 .85263 L
s
.99625 .89625 m
1 .89625 L
s
.99625 .93986 m
1 .93986 L
s
.99625 .98348 m
1 .98348 L
s
.99625 1.0707 m
1 1.0707 L
s
.99625 1.11432 m
1 1.11432 L
s
.99625 1.15793 m
1 1.15793 L
s
.99625 1.20155 m
1 1.20155 L
s
.99625 1.28878 m
1 1.28878 L
s
.99625 1.33239 m
1 1.33239 L
s
.99625 1.37601 m
1 1.37601 L
s
.99625 1.41962 m
1 1.41962 L
s
.99625 .11118 m
1 .11118 L
s
.99625 .06757 m
1 .06757 L
s
.99625 .02395 m
1 .02395 L
s
.99625 1.50685 m
1 1.50685 L
s
.99625 1.55047 m
1 1.55047 L
s
.99625 1.59408 m
1 1.59408 L
s
.25 Mabswid
1 0 m
1 1.61803 L
s
gsave
1.0125 .80902 -61 -10.5938 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 21.1875 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.125 13.313 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.5 1.63053 -194.188 9.1875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 30.5 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding WindowsANSIEncoding def
        currentdict
    end

    newfontname exch definefont pop
} def

63.000 17.438 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
%%BeginResource: font Courier-MISO
%%BeginFont: Courier-MISO
/Courier /Courier-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-MISO
%%IncludeFont: Courier-MISO
/Courier-MISO findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 17.438 moveto
%%IncludeResource: font Courier-MISO
%%IncludeFont: Courier-MISO
/Courier-MISO findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(G) show
%%IncludeResource: font Mathematica2Mono
%%IncludeFont: Mathematica2Mono
/Mathematica2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
69.125 17.438 moveto
(@) show
75.250 17.438 moveto
%%IncludeResource: font Courier-MISO
%%IncludeFont: Courier-MISO
/Courier-MISO findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(s) show
%%IncludeResource: font Mathematica2Mono
%%IncludeFont: Mathematica2Mono
/Mathematica2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
81.375 17.438 moveto
(D) show
87.500 17.438 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(=) show
93.625 17.438 moveto
%%IncludeResource: font Courier-MISO
%%IncludeFont: Courier-MISO
/Courier-MISO findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
%%IncludeResource: font Mathematica2Mono
%%IncludeFont: Mathematica2Mono
/Mathematica2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
170.938 11.500 moveto
(H) show
177.063 11.500 moveto
%%IncludeResource: font Courier-Italic
%%IncludeFont: Courier-Italic
%%BeginResource: font Courier-Italic-MISO
%%BeginFont: Courier-Italic-MISO
/Courier-Italic /Courier-Italic-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Italic-MISO
%%IncludeFont: Courier-Italic-MISO
/Courier-Italic-MISO findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(s) show
185.625 11.500 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(+) show
194.188 11.500 moveto
%%IncludeResource: font Courier-MISO
%%IncludeFont: Courier-MISO
/Courier-MISO findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
%%IncludeResource: font Mathematica2Mono
%%IncludeFont: Mathematica2Mono
/Mathematica2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
200.313 11.500 moveto
(L) show
208.938 11.500 moveto
(H) show
215.063 11.500 moveto
%%IncludeResource: font Courier-Italic-MISO
%%IncludeFont: Courier-Italic-MISO
/Courier-Italic-MISO findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(s) show
223.625 11.500 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(+) show
232.188 11.500 moveto
%%IncludeResource: font Courier-MISO
%%IncludeFont: Courier-MISO
/Courier-MISO findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(10) show
%%IncludeResource: font Mathematica2Mono
%%IncludeFont: Mathematica2Mono
/Mathematica2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
244.438 11.500 moveto
(L) show
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
97.938 17.438 moveto
(\\200\\200\\200\\200\\200\\200\\200\\200\\200\\200\\200\\200\\200\\200\\200\\\
200\\200\\200\\200\\200\\200\\200\\200\\200\\200\\200\\200\\200\\200\\200\\\
200\\200) show
169.938 17.438 moveto
(\\200\\200\\200\\200\\200\\200\\200\\200\\200\\200\\200\\200\\200\\200\\200\\\
200\\200\\200\\200\\200\\200\\200\\200\\200\\200\\200\\200\\200\\200\\200\\\
200\\200) show
241.938 17.438 moveto
(\\200\\200\\200\\200\\200\\200\\200\\200\\200\\200\\200\\200\\200\\200\\200\\\
200) show
277.938 17.438 moveto
(\\200\\200\\200\\200\\200\\200\\200\\200\\200\\200\\200\\200\\200\\200\\200\\\
200) show
313.938 17.438 moveto
(\\200\\200) show
318.438 17.438 moveto
(\\200) show
320.688 17.438 moveto
(\\200) show
321.063 17.438 moveto
(\\200) show
99.313 23.688 moveto
%%IncludeResource: font Courier-Italic-MISO
%%IncludeFont: Courier-Italic-MISO
/Courier-Italic-MISO findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(s) show
%%IncludeResource: font Mathematica2Mono
%%IncludeFont: Mathematica2Mono
/Mathematica2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
107.938 23.688 moveto
(H) show
114.063 23.688 moveto
%%IncludeResource: font Courier-Italic-MISO
%%IncludeFont: Courier-Italic-MISO
/Courier-Italic-MISO findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(s) show
122.625 23.688 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(+) show
131.188 23.688 moveto
%%IncludeResource: font Courier-MISO
%%IncludeFont: Courier-MISO
/Courier-MISO findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
%%IncludeResource: font Mathematica2Mono
%%IncludeFont: Mathematica2Mono
/Mathematica2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
137.313 23.688 moveto
(L) show
145.938 23.688 moveto
(H) show
152.063 23.688 moveto
%%IncludeResource: font Courier-Italic-MISO
%%IncludeFont: Courier-Italic-MISO
/Courier-Italic-MISO findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(s) show
160.625 23.688 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(+) show
169.188 23.688 moveto
%%IncludeResource: font Courier-MISO
%%IncludeFont: Courier-MISO
/Courier-MISO findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
%%IncludeResource: font Mathematica2Mono
%%IncludeFont: Mathematica2Mono
/Mathematica2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
175.313 23.688 moveto
(L) show
183.938 23.688 moveto
(H) show
190.063 23.688 moveto
%%IncludeResource: font Courier-Italic-MISO
%%IncludeFont: Courier-Italic-MISO
/Courier-Italic-MISO findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(s) show
196.188 21.125 moveto
%%IncludeResource: font Courier-MISO
%%IncludeFont: Courier-MISO
/Courier-MISO findfont 7.125 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
203.438 23.688 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(+) show
212.000 23.688 moveto
%%IncludeResource: font Courier-MISO
%%IncludeFont: Courier-MISO
/Courier-MISO findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(0.2) show
232.875 23.688 moveto
%%IncludeResource: font Courier-Italic-MISO
%%IncludeFont: Courier-Italic-MISO
/Courier-Italic-MISO findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(s) show
241.438 23.688 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(+) show
250.000 23.688 moveto
%%IncludeResource: font Courier-MISO
%%IncludeFont: Courier-MISO
/Courier-MISO findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
%%IncludeResource: font Mathematica2Mono
%%IncludeFont: Mathematica2Mono
/Mathematica2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
256.125 23.688 moveto
(L) show
264.750 23.688 moveto
(H) show
270.875 23.688 moveto
%%IncludeResource: font Courier-Italic-MISO
%%IncludeFont: Courier-Italic-MISO
/Courier-Italic-MISO findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(s) show
277.000 21.125 moveto
%%IncludeResource: font Courier-MISO
%%IncludeFont: Courier-MISO
/Courier-MISO findfont 7.125 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
284.250 23.688 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(+) show
292.813 23.688 moveto
%%IncludeResource: font Courier-Italic-MISO
%%IncludeFont: Courier-Italic-MISO
/Courier-Italic-MISO findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(s) show
301.375 23.688 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(+) show
309.938 23.688 moveto
%%IncludeResource: font Courier-MISO
%%IncludeFont: Courier-MISO
/Courier-MISO findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(1) show
%%IncludeResource: font Mathematica2Mono
%%IncludeFont: Mathematica2Mono
/Mathematica2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
316.063 23.688 moveto
(L) show
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 1.61803 L
0 1.61803 L
closepath
clip
newpath
.75 g
.5 Mabswid
.8039 .80902 m
0 0 rlineto s
.8039 .80902 m
1 .96581 L
s
.8039 .80902 m
0 0 rlineto s
.8039 .80902 m
1 1.14686 L
s
.8039 .80902 m
0 0 rlineto s
.8039 .80902 m
1 1.39417 L
s
.8039 .80902 m
0 0 rlineto s
.8039 .80902 m
.96043 1.61803 L
s
.8039 .80902 m
0 0 rlineto s
.8039 .80902 m
.87655 1.61803 L
s
.8039 .80902 m
0 0 rlineto s
.8039 .80902 m
.8039 1.61803 L
s
.8039 .80902 m
0 0 rlineto s
.8039 .80902 m
.73125 1.61803 L
s
.8039 .80902 m
0 0 rlineto s
.8039 .80902 m
.64737 1.61803 L
s
.8039 .80902 m
0 0 rlineto s
.8039 .80902 m
.53278 1.61803 L
s
.8039 .80902 m
0 0 rlineto s
.8039 .80902 m
.3343 1.61803 L
s
.8039 .80902 m
0 0 rlineto s
.8039 .80902 m
0 1.45178 L
s
.8039 .80902 m
0 0 rlineto s
.8039 .80902 m
0 .80902 L
s
.8039 .80902 m
0 0 rlineto s
.8039 .80902 m
0 .16626 L
s
.8039 .80902 m
0 0 rlineto s
.8039 .80902 m
.3343 0 L
s
.8039 .80902 m
0 0 rlineto s
.8039 .80902 m
.53278 0 L
s
.8039 .80902 m
0 0 rlineto s
.8039 .80902 m
.64737 0 L
s
.8039 .80902 m
0 0 rlineto s
.8039 .80902 m
.73125 0 L
s
.8039 .80902 m
0 0 rlineto s
.8039 .80902 m
.8039 0 L
s
.8039 .80902 m
0 0 rlineto s
.8039 .80902 m
.87655 0 L
s
.8039 .80902 m
0 0 rlineto s
.8039 .80902 m
.96043 0 L
s
.8039 .80902 m
0 0 rlineto s
.8039 .80902 m
1 .22386 L
s
.8039 .80902 m
0 0 rlineto s
.8039 .80902 m
1 .47118 L
s
.8039 .80902 m
0 0 rlineto s
.8039 .80902 m
1 .65222 L
s
.8039 .80902 m
0 0 rlineto s
.8039 .80902 m
1 .80902 L
s
.95006 .80902 m
.94891 .86368 L
.94547 .91748 L
.9398 .96957 L
.93198 1.01913 L
.92215 1.06538 L
.91045 1.10758 L
.89707 1.14507 L
.88222 1.17727 L
.86613 1.20365 L
.84907 1.22382 L
.83129 1.23744 L
.81308 1.2443 L
.79472 1.2443 L
.77651 1.23744 L
.75873 1.22382 L
.74167 1.20365 L
.72558 1.17727 L
.71073 1.14507 L
.69735 1.10758 L
.68565 1.06538 L
.67582 1.01913 L
.668 .96957 L
.66233 .91748 L
.65889 .86368 L
.65774 .80902 L
.65889 .75435 L
.66233 .70055 L
.668 .64846 L
.67582 .5989 L
.68565 .55266 L
.69735 .51045 L
.71073 .47296 L
.72558 .44077 L
.74167 .41438 L
.75873 .39422 L
.77651 .3806 L
.79472 .37373 L
.81308 .37373 L
.83129 .3806 L
.84907 .39422 L
.86613 .41438 L
.88222 .44077 L
.89707 .47296 L
.91045 .51045 L
.92215 .55266 L
.93198 .5989 L
.9398 .64846 L
.94547 .70055 L
.94891 .75435 L
Mistroke
.95006 .80902 L
Mfstroke
1 1.45377 m
.99024 1.48113 L
.96054 1.54552 L
.92837 1.59829 L
s
.92837 1.59829 m
.91166 1.61803 L
s
.69614 1.61803 m
.67943 1.59829 L
.64726 1.54552 L
.61756 1.48113 L
.5908 1.40614 L
.5674 1.32174 L
.54773 1.22925 L
.5321 1.13013 L
.52076 1.02595 L
.51388 .91834 L
.51157 .80902 L
.51388 .69969 L
.52076 .59209 L
.5321 .4879 L
.54773 .38879 L
.5674 .2963 L
.5908 .21189 L
.61756 .1369 L
.64726 .07252 L
.67943 .01974 L
s
.67943 .01974 m
.69614 0 L
s
.91166 0 m
.92837 .01974 L
.96054 .07252 L
.99024 .1369 L
s
.99024 .1369 m
1 .16427 L
s
.46022 1.61803 m
.44915 1.5781 L
.41965 1.43936 L
.3962 1.29069 L
.37918 1.13441 L
.36887 .97301 L
.36541 .80902 L
.36887 .64503 L
.37918 .48362 L
.3962 .32735 L
.41965 .17867 L
.44915 .03994 L
s
.44915 .03994 m
.46022 0 L
s
.2866 1.61803 m
.2603 1.45124 L
.23761 1.24288 L
.22386 1.02767 L
.21925 .80902 L
.22386 .59036 L
.23761 .37516 L
.2603 .16679 L
s
.2603 .16679 m
.2866 0 L
s
.12539 1.61803 m
.1244 1.6118 L
.09604 1.35134 L
.07884 1.08234 L
.07308 .80902 L
.07884 .5357 L
.09604 .26669 L
.1244 .00624 L
s
.1244 .00624 m
.12539 0 L
s
.75 0 0 r
.012 w
.43849 .80902 Mdot
.65774 .80902 Mdot
.76736 .62016 Mdot
.76736 .99787 Mdot
.79659 .50139 Mdot
.79659 1.11665 Mdot
.8039 .80902 Mdot
.75 0 .073 r
.43849 .80902 Mdot
.65774 .80902 Mdot
.76742 .62025 Mdot
.76742 .99778 Mdot
.79657 .50141 Mdot
.79657 1.11662 Mdot
.80381 .80902 Mdot
.75 0 .146 r
.43849 .80902 Mdot
.65779 .80902 Mdot
.76789 .62091 Mdot
.76789 .99712 Mdot
.7964 .50156 Mdot
.7964 1.11647 Mdot
.80316 .80902 Mdot
.75 0 .219 r
.43849 .80902 Mdot
.65793 .80902 Mdot
.76921 .62272 Mdot
.76921 .99531 Mdot
.79593 .50196 Mdot
.79593 1.11607 Mdot
.80132 .80902 Mdot
.75 0 .292 r
.43849 .80902 Mdot
.65821 .80902 Mdot
.77204 .62632 Mdot
.77204 .99172 Mdot
.79497 .50261 Mdot
.79497 1.11542 Mdot
.79731 .80902 Mdot
.75 0 .366 r
.43849 .80902 Mdot
.65867 .80902 Mdot
.77751 .63195 Mdot
.77751 .98608 Mdot
.78931 .80902 Mdot
.79327 .5032 Mdot
.79327 1.11483 Mdot
.75 0 .439 r
.4385 .80902 Mdot
.65939 .80902 Mdot
.77471 .80902 Mdot
.78712 .6365 Mdot
.78712 .98154 Mdot
.7906 .50259 Mdot
.7906 1.11544 Mdot
.75 0 .512 r
.4385 .80902 Mdot
.66045 .80902 Mdot
.75681 .80902 Mdot
.78722 .49878 Mdot
.78722 1.11926 Mdot
.79891 .63372 Mdot
.79891 .98431 Mdot
.75 0 .585 r
.4385 .80902 Mdot
.66201 .80902 Mdot
.74112 .80902 Mdot
.78396 .49142 Mdot
.78396 1.12662 Mdot
.80923 .6277 Mdot
.80923 .99033 Mdot
.75 0 .658 r
.43851 .80902 Mdot
.66433 .80902 Mdot
.7272 .80902 Mdot
.78127 .48211 Mdot
.78127 1.13592 Mdot
.81773 .62174 Mdot
.81773 .9963 Mdot
.75 0 .731 r
.43852 .80902 Mdot
.66802 .80902 Mdot
.7135 .80902 Mdot
.77907 .47208 Mdot
.77907 1.14595 Mdot
.82493 .61608 Mdot
.82493 1.00195 Mdot
.696 0 .75 r
.43853 .80902 Mdot
.67564 .80902 Mdot
.69691 .80902 Mdot
.77724 .46185 Mdot
.77724 1.15618 Mdot
.83123 .61062 Mdot
.83123 1.00741 Mdot
.623 0 .75 r
.43854 .80902 Mdot
.68216 .76229 Mdot
.68216 .85574 Mdot
.77568 .45162 Mdot
.77568 1.16641 Mdot
.8369 .6053 Mdot
.8369 1.01274 Mdot
.549 0 .75 r
.43855 .80902 Mdot
.67833 .73778 Mdot
.67833 .88025 Mdot
.77431 .44149 Mdot
.77431 1.17654 Mdot
.84209 .60007 Mdot
.84209 1.01796 Mdot
.476 0 .75 r
.43857 .80902 Mdot
.67472 .72106 Mdot
.67472 .89698 Mdot
.77309 .4315 Mdot
.77309 1.18653 Mdot
.84691 .59493 Mdot
.84691 1.02311 Mdot
.403 0 .75 r
.43858 .80902 Mdot
.67129 .70794 Mdot
.67129 .9101 Mdot
.772 .42166 Mdot
.772 1.19637 Mdot
.85144 .58986 Mdot
.85144 1.02818 Mdot
.33 0 .75 r
.4386 .80902 Mdot
.66801 .697 Mdot
.66801 .92104 Mdot
.77099 .41198 Mdot
.77099 1.20605 Mdot
.85571 .58485 Mdot
.85571 1.03318 Mdot
.257 0 .75 r
.43863 .80902 Mdot
.66485 .68755 Mdot
.66485 .93048 Mdot
.77007 .40247 Mdot
.77007 1.21557 Mdot
.85978 .57991 Mdot
.85978 1.03812 Mdot
.184 0 .75 r
.43865 .80902 Mdot
.66181 .6792 Mdot
.66181 .93883 Mdot
.76921 .39311 Mdot
.76921 1.22493 Mdot
.86366 .57504 Mdot
.86366 1.043 Mdot
.111 0 .75 r
.43868 .80902 Mdot
.65887 .67169 Mdot
.65887 .94634 Mdot
.76841 .3839 Mdot
.76841 1.23414 Mdot
.8674 .57022 Mdot
.8674 1.04781 Mdot
.038 0 .75 r
.43871 .80902 Mdot
.65601 .66485 Mdot
.65601 .95318 Mdot
.76765 .37484 Mdot
.76765 1.24319 Mdot
.87099 .56546 Mdot
.87099 1.05257 Mdot
0 .036 .75 r
.43875 .80902 Mdot
.65324 .65857 Mdot
.65324 .95947 Mdot
.76693 .36593 Mdot
.76693 1.25211 Mdot
.87446 .56076 Mdot
.87446 1.05728 Mdot
0 .109 .75 r
.43879 .80902 Mdot
.65054 .65274 Mdot
.65054 .96529 Mdot
.76625 .35715 Mdot
.76625 1.26088 Mdot
.87783 .55611 Mdot
.87783 1.06192 Mdot
0 .182 .75 r
.43883 .80902 Mdot
.6479 .64731 Mdot
.6479 .97072 Mdot
.7656 .34852 Mdot
.7656 1.26952 Mdot
.88109 .55152 Mdot
.88109 1.06651 Mdot
0 .255 .75 r
.43888 .80902 Mdot
.64533 .64222 Mdot
.64533 .97582 Mdot
.76498 .34001 Mdot
.76498 1.27803 Mdot
.88427 .54698 Mdot
.88427 1.07106 Mdot
0 .328 .75 r
.43893 .80902 Mdot
.64281 .63742 Mdot
.64281 .98062 Mdot
.76438 .33162 Mdot
.76438 1.28641 Mdot
.88736 .54249 Mdot
.88736 1.07554 Mdot
0 .401 .75 r
.43898 .80902 Mdot
.64034 .63288 Mdot
.64034 .98515 Mdot
.76381 .32336 Mdot
.76381 1.29468 Mdot
.89037 .53805 Mdot
.89037 1.07999 Mdot
0 .474 .75 r
.43904 .80902 Mdot
.63793 .62858 Mdot
.63793 .98946 Mdot
.76325 .31521 Mdot
.76325 1.30283 Mdot
.89332 .53366 Mdot
.89332 1.08438 Mdot
0 .548 .75 r
.4391 .80902 Mdot
.63555 .62448 Mdot
.63555 .99355 Mdot
.76271 .30717 Mdot
.76271 1.31087 Mdot
.8962 .52931 Mdot
.8962 1.08872 Mdot
0 .621 .75 r
.43917 .80902 Mdot
.63322 .62058 Mdot
.63322 .99746 Mdot
.76219 .29924 Mdot
.76219 1.3188 Mdot
.89902 .52501 Mdot
.89902 1.09302 Mdot
0 .694 .75 r
.43924 .80902 Mdot
.63093 .61684 Mdot
.63093 1.00119 Mdot
.76168 .29141 Mdot
.76168 1.32662 Mdot
.90178 .52076 Mdot
.90178 1.09728 Mdot
0 .75 .733 r
.43932 .80902 Mdot
.62868 .61327 Mdot
.62868 1.00477 Mdot
.76118 .28368 Mdot
.76118 1.33435 Mdot
.90449 .51654 Mdot
.90449 1.10149 Mdot
0 .75 .66 r
.43941 .80902 Mdot
.62646 .60984 Mdot
.62646 1.0082 Mdot
.7607 .27605 Mdot
.7607 1.34199 Mdot
.90715 .51237 Mdot
.90715 1.10566 Mdot
0 .75 .587 r
.4395 .80902 Mdot
.62428 .60654 Mdot
.62428 1.01149 Mdot
.76023 .26851 Mdot
.76023 1.34953 Mdot
.90976 .50824 Mdot
.90976 1.10979 Mdot
0 .75 .514 r
.43959 .80902 Mdot
.62212 .60337 Mdot
.62212 1.01467 Mdot
.75977 .26106 Mdot
.75977 1.35698 Mdot
.91233 .50415 Mdot
.91233 1.11388 Mdot
0 .75 .441 r
.43969 .80902 Mdot
.62 .60031 Mdot
.62 1.01772 Mdot
.75931 .25369 Mdot
.75931 1.36434 Mdot
.91485 .5001 Mdot
.91485 1.11794 Mdot
0 .75 .367 r
.4398 .80902 Mdot
.6179 .59736 Mdot
.6179 1.02067 Mdot
.75887 .24641 Mdot
.75887 1.37162 Mdot
.91734 .49608 Mdot
.91734 1.12195 Mdot
0 .75 .294 r
.43991 .80902 Mdot
.61583 .59452 Mdot
.61583 1.02352 Mdot
.75844 .23921 Mdot
.75844 1.37882 Mdot
.91979 .4921 Mdot
.91979 1.12593 Mdot
0 .75 .221 r
.44003 .80902 Mdot
.61379 .59176 Mdot
.61379 1.02627 Mdot
.75801 .23209 Mdot
.75801 1.38594 Mdot
.9222 .48816 Mdot
.9222 1.12987 Mdot
0 .75 .148 r
.44016 .80902 Mdot
.61177 .5891 Mdot
.61177 1.02893 Mdot
.75759 .22505 Mdot
.75759 1.39299 Mdot
.92457 .48425 Mdot
.92457 1.13378 Mdot
0 .75 .075 r
.44029 .80902 Mdot
.60977 .58653 Mdot
.60977 1.03151 Mdot
.75718 .21807 Mdot
.75718 1.39996 Mdot
.92692 .48038 Mdot
.92692 1.13766 Mdot
0 1 0 r
.0125 w
.07308 .80902 Mdot
.51157 .80902 Mdot
1 0 0 r
.43849 .80902 Mdot
.65774 .80902 Mdot
.76736 .62016 Mdot
.76736 .99787 Mdot
.79659 .50139 Mdot
.79659 1.11665 Mdot
.8039 .80902 Mdot
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.909028 0.369391 0.97619 0.705202 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.00980392 0.490196 0.0024975 0.124875 [
[ 0 0 0 0 ]
[ 1 5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 5 L
0 5 L
closepath
clip
newpath
.75 0 0 r
.0098 .0025 m
.0098 .12737 L
.5 .12737 L
.5 .0025 L
F
0 g
gsave
.52451 .06494 -61 -10.5938 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 21.1875 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(0) show
69.125 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.75 0 .075 r
.0098 .12737 m
.0098 .25225 L
.5 .25225 L
.5 .12737 L
F
.75 0 .15 r
.0098 .25225 m
.0098 .37712 L
.5 .37712 L
.5 .25225 L
F
.75 0 .225 r
.0098 .37712 m
.0098 .502 L
.5 .502 L
.5 .37712 L
F
.75 0 .3 r
.0098 .502 m
.0098 .62687 L
.5 .62687 L
.5 .502 L
F
.75 0 .375 r
.0098 .62687 m
.0098 .75175 L
.5 .75175 L
.5 .62687 L
F
.75 0 .45 r
.0098 .75175 m
.0098 .87662 L
.5 .87662 L
.5 .75175 L
F
.75 0 .525 r
.0098 .87662 m
.0098 1.0015 L
.5 1.0015 L
.5 .87662 L
F
.75 0 .6 r
.0098 1.0015 m
.0098 1.12637 L
.5 1.12637 L
.5 1.0015 L
F
.75 0 .675 r
.0098 1.12637 m
.0098 1.25125 L
.5 1.25125 L
.5 1.12637 L
F
.75 0 .75 r
.0098 1.25125 m
.0098 1.37612 L
.5 1.37612 L
.5 1.25125 L
F
.675 0 .75 r
.0098 1.37612 m
.0098 1.501 L
.5 1.501 L
.5 1.37612 L
F
.6 0 .75 r
.0098 1.501 m
.0098 1.62587 L
.5 1.62587 L
.5 1.501 L
F
.525 0 .75 r
.0098 1.62587 m
.0098 1.75075 L
.5 1.75075 L
.5 1.62587 L
F
.45 0 .75 r
.0098 1.75075 m
.0098 1.87562 L
.5 1.87562 L
.5 1.75075 L
F
.375 0 .75 r
.0098 1.87562 m
.0098 2.0005 L
.5 2.0005 L
.5 1.87562 L
F
.3 0 .75 r
.0098 2.0005 m
.0098 2.12537 L
.5 2.12537 L
.5 2.0005 L
F
.225 0 .75 r
.0098 2.12537 m
.0098 2.25025 L
.5 2.25025 L
.5 2.12537 L
F
.15 0 .75 r
.0098 2.25025 m
.0098 2.37512 L
.5 2.37512 L
.5 2.25025 L
F
.075 0 .75 r
.0098 2.37512 m
.0098 2.5 L
.5 2.5 L
.5 2.37512 L
F
0 0 .75 r
.0098 2.5 m
.0098 2.62488 L
.5 2.62488 L
.5 2.5 L
F
0 .075 .75 r
.0098 2.62488 m
.0098 2.74975 L
.5 2.74975 L
.5 2.62488 L
F
0 .15 .75 r
.0098 2.74975 m
.0098 2.87463 L
.5 2.87463 L
.5 2.74975 L
F
0 .225 .75 r
.0098 2.87463 m
.0098 2.9995 L
.5 2.9995 L
.5 2.87463 L
F
0 .3 .75 r
.0098 2.9995 m
.0098 3.12438 L
.5 3.12438 L
.5 2.9995 L
F
0 .375 .75 r
.0098 3.12438 m
.0098 3.24925 L
.5 3.24925 L
.5 3.12438 L
F
0 .45 .75 r
.0098 3.24925 m
.0098 3.37413 L
.5 3.37413 L
.5 3.24925 L
F
0 .525 .75 r
.0098 3.37413 m
.0098 3.499 L
.5 3.499 L
.5 3.37413 L
F
0 .6 .75 r
.0098 3.499 m
.0098 3.62388 L
.5 3.62388 L
.5 3.499 L
F
0 .675 .75 r
.0098 3.62388 m
.0098 3.74875 L
.5 3.74875 L
.5 3.62388 L
F
0 .75 .75 r
.0098 3.74875 m
.0098 3.87363 L
.5 3.87363 L
.5 3.74875 L
F
0 .75 .675 r
.0098 3.87363 m
.0098 3.9985 L
.5 3.9985 L
.5 3.87363 L
F
0 .75 .6 r
.0098 3.9985 m
.0098 4.12338 L
.5 4.12338 L
.5 3.9985 L
F
0 .75 .525 r
.0098 4.12338 m
.0098 4.24825 L
.5 4.24825 L
.5 4.12338 L
F
0 .75 .45 r
.0098 4.24825 m
.0098 4.37313 L
.5 4.37313 L
.5 4.24825 L
F
0 .75 .375 r
.0098 4.37313 m
.0098 4.498 L
.5 4.498 L
.5 4.37313 L
F
0 .75 .3 r
.0098 4.498 m
.0098 4.62288 L
.5 4.62288 L
.5 4.498 L
F
0 .75 .225 r
.0098 4.62288 m
.0098 4.74775 L
.5 4.74775 L
.5 4.62288 L
F
0 .75 .15 r
.0098 4.74775 m
.0098 4.87263 L
.5 4.87263 L
.5 4.74775 L
F
0 .75 .075 r
.0098 4.87263 m
.0098 4.9975 L
.5 4.9975 L
.5 4.87263 L
F
0 g
gsave
.52451 4.93506 -61 -10.5938 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 21.1875 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(40.) show
81.375 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
MathSubEnd
P
% End of sub-graphic
0 0 m
1 0 L
1 1.4104 L
0 1.4104 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  CellLabel->"From In[137]:=",
  ImageSize->{367.188, 517.875},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40005_00021A000`40O003h00OogooL7oo003oOom`
Ool00?moog1oo`00ogooL7oo003oOom`Ool00?moog1oo`00ogooL7oo003oOom`Ool00?moog1oo`00
ogooL7oo003oOom`Ool00?moog1oo`00ogooL7oo003oOom`Ool00?moog1oo`00ogooL7oo003oOom`
Ool00?moog1oo`00ogooL7oo003oOom`Ool00?moog1oo`00ogooL7oo003oOom`Ool00?moog1oo`00
ogooL7oo003oOom`Ool00?moog1oo`00ogooL7oo003oOom`Ool00?moog1oo`00ogooL7oo003oOom`
Ool00?moog1oo`00ogooL7oo003oOom`Ool00;=oo`8000Qoo`800;1oo`00/goo00<007ooOol027oo
00<007ooOol0[Woo002TOol30002Ool00`00Oomoo`030004Ool01000Oomoogoo0`0017oo00<007oo
Ool0[Woo002UOol01000Oomoo`000Woo00<007ooOol01Goo00<007ooOol017oo00D007ooOomoo`00
0;1oo`00YGoo0`000goo100017oo00@007ooOomoo`<000Aoo`03001oogoo0:ioo`00YGoo00@007oo
Ool000=oo`8000Eoo`04001oogooOol40003Ool00`00Oomoo`2^Ool00:Eoo`04001oogoo000:Ool0
0`00Oomoo`08Ool00`00Oomoo`2^Ool00:Aoo`@000]oo`8000Qoo`800;1oo`00ogooL7oo003oOom`
Ool00?moog1oo`00ogooL7oo001;Ool50002Ool2000NOol2000POol3000ROol3000NOol4000MOol2
000POol4001>Ool004eoo`05001oogooOol00002Ool00`00Oomoo`0JOol01000Oomoo`007goo00@0
07ooOol0029oo`03001oogoo01eoo`03001oogoo01eoo`04001oogoo000OOol00`00Oomoo`1?Ool0
04eoo`05001oogooOol00002Ool00`00Oomoo`0JOol01000Oomoo`007goo00@007ooOol001moo`D0
01moo`03001oogoo01aoo`04001oogoo000POol00`00Oomoo`1>Ool004Eoo`@000Aoo`05001oogoo
Ool00002Ool00`00Oomoo`0DOol40003Ool2000JOol40002Ool3000JOol40002Ool01000Oomoo`00
6Goo100017oo00<007ooOol06goo00@007ooOol0025oo`03001oogoo04eoo`00CGoo00D007ooOomo
o`00009oo`03001oogoo01Yoo`04001oogoo000POol00`00Oomoo`0POol00`00Ool0000OOol01000
Oomoo`0077oo00@007ooOol001moo`04001oogoo001>Ool004aoo`8000Aoo`8001ioo`80025oo`<0
025oo`80021oo`8001ioo`80025oo`8004moo`00ogooL7oo003oOom`Ool00?moog1oo`00ogooL7oo
003oOom`Ool003]ooo4004=oo`00>goo00<007ooOol01Woo00<007ooOol01Woo00<007ooOol01Woo
00@007ooOomNm`Aoo`03001oogoo00Ioo`03001oogoo00Ioo`03001oogoo00Ioo`03001oogoo00Ao
o`03G_L007oo00Moo`03001ooekg00Ioo`03001oogoo00Ioo`03001oogoo00Eoo`03001oogoo009o
o`05G_MoogooOol00008Ool00`00Oomoo`02Ool01EkgOomoogoo00001goo00<007ooOol01Woo00<0
07ooOol00goo00ANmgooOol000Moo`03G_L007oo00Ioo`03G_Moogoo00Ioo`03001oogoo00Ioo`03
G_Moogoo00Ioo`03001oogoo00Eoo`03G_Moogoo00Ioo`03001Nmgoo00Ioo`03001ooekg00Eoo`05
001oogooOol00013Ool003]oo`03001oogoo01]oo`03G_Moogoo02Aoo`03G_Moogoo00Uoo`03G_Mo
ogoo01Yoo`03G_Moogoo011oo`03G_Moogoo01Moo`03G_Moogoo00Moo`03G_Moogoo00Moo`03G_Mo
ogoo00moo`03G_Moogoo00ioo`03G_Moogoo00Qoo`03G_Moogoo00Ioo`03G_Moogoo00Moo`03001o
ogoo045oo`00>goo00<007ooOol06goo00=NmgooOol097oo00=NmgooOol02Woo00=NmgooOol067oo
00=NmgooOol04Goo00=NmgooOol067oo00=NmgooOol01Goo00=NmgooOol027oo00=NmgooOol03goo
00=NmgooOol03Woo00=NmgooOol02Goo00=NmgooOol017oo00=NmgooOol027oo00<007ooOol0@Goo
000kOol00`00Oomoo`0KOol00ekgOomoo`0SOol00ekgOomoo`0;Ool00ekgOomoo`0HOol00ekgOomo
o`0AOol00ekgOomoo`0HOol00ekgOomoo`04Ool00ekgOomoo`09Ool00ekgOomoo`0?Ool00ekgOomo
o`0>Ool00ekgOomoo`0:Ool00ekgOomoo`03Ool00ekgOomoo`08Ool00`00Oomoo`11Ool003]oo`80
01aoo`03G_Moogoo02=oo`03G_Moogoo00aoo`03G_Moogoo01Moo`03G_Moogoo019oo`03G_Moogoo
01Moo`03G_Moogoo00=oo`03G_Moogoo00Yoo`03G_Moogoo00moo`03G_Moogoo00ioo`03G_Moogoo
00]oo`03G_Moogoo009oo`03G_Moogoo00Moo`8004=oo`00>goo00<007ooOol06Woo00=NmgooOol0
97oo00=NmgooOol03Goo00=NmgooOol05Woo00=NmgooOol04Woo00=NmgooOol05goo00=NmgooOol0
0goo00=NmgooOol02goo00=NmgooOol03Woo00=NmgooOol03Goo00=NmgooOol037oo00=NmgooOol0
0Woo00=NmgooOol027oo00<007ooOol0@Goo000kOol00`00Oomoo`0JOol00ekgOomoo`0TOol00ekg
Oomoo`0=Ool00ekgOomoo`0EOol00ekgOomoo`0COol00ekgOomoo`0GOol00ekgOomoo`02Ool00ekg
Oomoo`0<Ool00ekgOomoo`0>Ool00ekgOomoo`0=Ool00ekgOomoo`0=Ool01EkgOomoogooG_L02Woo
00<007ooOol0@Goo000kOol00`00Oomoo`0JOol00ekgOomoo`0TOol00ekgOomoo`0>Ool00ekgOomo
o`0DOol00ekgOomoo`0DOol00ekgOomoo`0GOol01EkgOomoogooG_L03Woo00=NmgooOol03Woo00=N
mgooOol03Goo00=NmgooOol03Goo00ANmgooOomNm`]oo`03001oogoo045oo`00>goo00<007ooOol0
6Woo00=NmgooOol097oo00=NmgooOol03Woo00=NmgooOol057oo00=NmgooOol057oo00=NmgooOol0
5goo00ANmgooOomNm`moo`03G_Moogoo00ioo`03G_Moogoo00eoo`03G_Moogoo00ioo`03G_Mooekg
00]oo`03001oogoo045oo`00>goo00<007ooOol06Woo00=NmgooOol08goo00=NmgooOol047oo00=N
mgooOol04goo00=NmgooOol057oo00=NmgooOol05goo00=NmgooG_L047oo00=NmgooOol03Woo00=N
mgooOol03Goo00=NmgooOol03Woo00=NmgooG_L02goo00<007ooOol0@Goo000kOol00`00Oomoo`0J
Ool00ekgOomoo`0SOol00ekgOomoo`0@Ool00ekgOomoo`0COol00ekgOomoo`0EOol00ekgOomoo`0F
Ool00ekgOomNm`0@Ool00ekgOomoo`0>Ool00ekgOomoo`0=Ool00ekgOomoo`0?Ool2G_L;Ool00`00
Oomoo`11Ool003]oo`03001oogoo01Yoo`03G_Moogoo02=oo`03G_Moogoo015oo`03G_Moogoo015o
o`03G_Moogoo01Ioo`03G_Moogoo01Ioo`9Nma5oo`03G_Moogoo00ioo`03G_Moogoo00eoo`03G_Mo
ogoo00moo`9Nm`]oo`03001oogoo045oo`00>goo00<007ooOol06Woo00=NmgooOol08goo00=Nmgoo
Ool04Woo00=NmgooOol047oo00=NmgooOol05Woo00=NmgooOol05Woo0Ukg4Goo00=NmgooOol03Woo
00=NmgooOol03Goo00=NmgooOol047oo00=NmgooOol02Goo00<007ooOol0@Goo000kOol00`00Oomo
o`0JOol00ekgOomoo`0SOol00ekgOomoo`0BOol00ekgOomoo`0@Ool00ekgOomoo`0GOol00ekgOomo
o`0EOol2G_LAOol00ekgOomoo`0>Ool00ekgOomoo`0=Ool00ekgOomoo`0?Ool2G_L;Ool00`00Oomo
o`11Ool003]oo`03001oogoo01Uoo`03G_Moogoo02Aoo`03G_Moogoo01=oo`03G_Moogoo00moo`03
G_Moogoo01Moo`03G_Moogoo01Aoo`03G_Mooekg015oo`03G_Moogoo00ioo`03G_Moogoo00eoo`03
G_Moogoo00moo`03G_Mooekg00Yoo`03001oogoo045oo`00>goo0P006Woo00=NmgooOol097oo00=N
mgooOol04goo00=NmgooOol03goo00=NmgooOol05goo00=NmgooOol057oo00=NmgooG_L04Goo00=N
mgooOol03Woo00=NmgooOol03Goo00=NmgooOol03goo00=NmgooG_L02Goo0P00@goo000kOol00`00
Oomoo`0IOol00ekgOomoo`0SOol00ekgOomoo`0EOol00ekgOomoo`0=Ool00ekgOomoo`0IOol00ekg
Oomoo`0BOol015kgOomooekg4Woo00=NmgooOol03Goo00=NmgooOol03Goo00=NmgooOol03goo00AN
mgooOomNm`Uoo`03001oogoo045oo`00>goo00<007ooOol06Goo00=NmgooOol08goo00=NmgooOol0
5Woo00=NmgooOol037oo00=NmgooOol06Goo00=NmgooOol04Woo00ENmgooOomooekg015oo`03G_Mo
ogoo00eoo`03G_Moogoo00aoo`03G_Moogoo011oo`04G_MoogooG_L9Ool00`00Oomoo`11Ool003]o
o`03001oogoo01Uoo`03G_Moogoo02=oo`03G_Moogoo01Ioo`03G_Moogoo00aoo`03G_Moogoo01Uo
o`03G_Moogoo015oo`03G_Moogoo009oo`03G_Moogoo00moo`03G_Moogoo00eoo`03G_Moogoo00ao
o`03G_Moogoo00moo`03G_Moogoo009oo`03G_Moogoo00Ioo`03001oogoo045oo`00>goo00<007oo
Ool06Goo00=NmgooOol08goo00=NmgooOol05goo00=NmgooOol02goo00=NmgooOol06Woo00=Nmgoo
Ool047oo00=NmgooOol00Woo00=NmgooOol03goo00=NmgooOol03Goo00=NmgooOol037oo00=Nmgoo
Ool03goo00=NmgooOol00Woo00=NmgooOol01Woo00<007ooOol0@Goo000kOol00`00Oomoo`0IOol0
0ekgOomoo`0SOol00ekgOomoo`0GOol00ekgOomoo`0:Ool00ekgOomoo`0KOol00ekgOomoo`0?Ool0
0ekgOomoo`03Ool00ekgOomoo`0?Ool00ekgOomoo`0=Ool00ekgOomoo`0<Ool00ekgOomoo`0?Ool0
0ekgOomoo`03Ool00ekgOomoo`05Ool00`00Oomoo`11Ool003]oo`03001oogoo01Uoo`03G_Moogoo
02=oo`03G_Moogoo01Qoo`03G_Moogoo00Uoo`03G_Moogoo01]oo`03G_Moogoo00moo`03G_Moogoo
00=oo`03G_Moogoo00moo`03G_Moogoo00eoo`03G_Moogoo00aoo`03G_Moogoo00moo`03G_Moogoo
00=oo`03G_Moogoo00Eoo`03001oogoo045oo`00>goo00<007ooOol06Goo00=NmgooOol08goo00=N
mgooOol067oo00=NmgooOol02Goo00=NmgooOol077oo00=NmgooOol03Goo00=NmgooOol01Goo00=N
mgooOol03Woo00=NmgooOol03Goo00=NmgooOol037oo00=NmgooOol03goo00=NmgooOol017oo00=N
mgooOol017oo00<007ooOol0@Goo000kOol00`00Oomoo`0HOol00ekgOomoo`0SOol00ekgOomoo`0J
Ool00ekgOomoo`08Ool00ekgOomoo`0LOol00ekgOomoo`0=Ool00ekgOomoo`05Ool00ekgOomoo`0>
Ool00ekgOomoo`0=Ool00ekgOomoo`0<Ool00ekgOomoo`0>Ool00ekgOomoo`05Ool00ekgOomoo`04
Ool00`00Oomoo`11Ool003]oo`03001oogoo01Qoo`03G_Moogoo02=oo`03G_Moogoo01]oo`03G_Mo
ogoo00Moo`03G_Moogoo01aoo`03G_Moogoo00aoo`03G_Moogoo00Ioo`03G_Moogoo00ioo`03G_Mo
ogoo00eoo`03G_Moogoo00aoo`03G_Moogoo00ioo`03G_Moogoo00Ioo`03G_Moogoo00=oo`03001o
ogoo045oo`00>goo0P006Goo00=NmgooOol08goo00=NmgooOol06goo00=NmgooOol01Woo00=Nmgoo
Ool07Woo00=NmgooOol02goo00=NmgooOol01Woo00=NmgooOol03Woo00=NmgooOol03Goo00=Nmgoo
Ool037oo00=NmgooOol03Woo00=NmgooOol01Woo00=NmgooOol00Woo0P00@goo000kOol00`00Oomo
o`0HOol00ekgOomoo`0SOol00ekgOomoo`0LOol00ekgOomoo`05Ool00ekgOomoo`0NOol00ekgOomo
o`0:Ool00ekgOomoo`07Ool00ekgOomoo`0?Ool00ekgOomoo`0<Ool00ekgOomoo`0<Ool00ekgOomo
o`0>Ool00ekgOomoo`07Ool00ekgOomoo`02Ool00`00Oomoo`11Ool003]oo`03001oogoo01Qoo`03
G_Moogoo02=oo`03G_Moogoo01aoo`03G_Moogoo00Eoo`03G_Moogoo01ioo`03G_Moogoo00Yoo`03
G_Moogoo00Qoo`03G_Moogoo00ioo`03G_Moogoo00aoo`03G_Moogoo00aoo`03G_Moogoo00ioo`03
G_Moogoo00Moo`03G_Moogoo009oo`03001oogoo045oo`00>goo00<007ooOol067oo00=NmgooOol0
8goo00=NmgooOol07Goo00=NmgooOol017oo00=NmgooOol07goo00=NmgooOol027oo00=NmgooOol0
2Goo00=NmgooOol03Woo00=NmgooOol037oo00=NmgooOol02goo00=NmgooOol03Woo00=NmgooOol0
2Goo00ENmgooOomoo`0004=oo`00>goo00<007ooOol067oo00=NmgooOol08Woo00=NmgooOol07goo
00=NmgooOol00goo00=NmgooOol07goo00=NmgooOol027oo00=NmgooOol02Goo00=NmgooOol03Woo
00=NmgooOol037oo00=NmgooOol02goo00=NmgooOol03Woo00=NmgooOol02Goo00ENmgooOomoo`00
04=oo`00>goo00<007ooOol067oo00=NmgooOol08Woo00=NmgooOol07goo00=NmgooOol00Woo00=N
mgooOol087oo00=NmgooOol01goo00=NmgooOol02Woo00=NmgooOol03Woo00=NmgooOol037oo00=N
mgooOol02goo00=NmgooOol03Woo00=NmgooOol02Woo00ANmgooOol004=oo`00>goo00<007ooOol0
5goo00=NmgooOol08goo00=NmgooOol087oo00ENmgooOomooekg02=oo`03G_Moogoo00Ioo`03G_Mo
ogoo00Yoo`03G_Moogoo00ioo`03G_Moogoo00aoo`03G_Moogoo00]oo`03G_Moogoo00ioo`03G_Mo
ogoo00Yoo`04G_Moogoo0013Ool003]oo`03001oogoo01Moo`03G_Moogoo02=oo`03G_Moogoo021o
o`05G_MoogooOomNm`0SOol00ekgOomoo`06Ool00ekgOomoo`0:Ool00ekgOomoo`0>Ool00ekgOomo
o`0<Ool00ekgOomoo`0;Ool00ekgOomoo`0>Ool00ekgOomoo`0:Ool015kgOomoo`00@goo000kOol0
0`00Oomoo`0GOol00ekgOomoo`0SOol00ekgOomoo`0QOol015kgOomooekg8goo00=NmgooOol01Goo
00=NmgooOol037oo00=NmgooOol03Goo00=NmgooOol037oo00=NmgooOol02goo00=NmgooOol03Goo
00=NmgooOol037oo00=Nmgoo0000@goo000dOol20005Ool00`00Oomoo`0GOol00ekgOomoo`0SOol0
0ekgOomoo`0QOol00ekgOomNm`0UOol00ekgOomoo`04Ool00ekgOomoo`0<Ool00ekgOomoo`0=Ool0
0ekgOomoo`0<Ool00ekgOomoo`0;Ool00ekgOomoo`0=Ool00ekgOomoo`0<Ool00ekgOol00013Ool0
03=oo`04001oogoo0004Ool00`00Oomoo`0GOol00ekgOomoo`0SOol00ekgOomoo`0ROol2G_LUOol0
0ekgOomoo`04Ool00ekgOomoo`0<Ool00ekgOomoo`0=Ool00ekgOomoo`0<Ool00ekgOomoo`0;Ool0
0ekgOomoo`0=Ool00ekgOomoo`0=Ool00ekg001oo`12Ool003Eoo`03001oogoo00=oo`<001Moo`03
G_Moogoo029oo`03G_Moogoo02Aoo`03G_Moogoo02=oo`03G_Moogoo00=oo`03G_Moogoo00eoo`03
G_Moogoo00eoo`03G_Moogoo00aoo`03G_Moogoo00]oo`03G_Moogoo00eoo`03G_Moogoo00aoo`03
001Nm`0004=oo`00;Goo10001Goo00<007ooOol00Woo00<007ooOol05goo00=NmgooOol08Woo00=N
mgooOol097oo00=NmgooOol097oo00=NmgooOol00Woo00=NmgooOol03Goo00=NmgooOol03Woo00=N
mgooOol02goo00=NmgooOol02goo00=NmgooOol03Goo00=NmgooOol03Woo00<007ooOol0@Goo000c
Ool01000Oomoo`0017oo00=NmgooOol05goo00=NmgooOol08Woo00=NmgooOol097oo0Ukg9Goo00=N
mgooOol00Woo00=NmgooOol03Woo00=NmgooOol03Goo00=NmgooOol02goo00=NmgooOol02goo00=N
mgooOol03Goo00=NmgooOol03Woo00<007ooOol0@Goo000dOol20005Ool00`00G_Moo`0GOol00ekg
Oomoo`0ROol00ekgOomoo`0SOol00ekgOomNm`0UOol01EkgOomoogooG_L04Goo00=NmgooOol03Goo
00=NmgooOol02goo00=NmgooOol02Woo00=NmgooOol03Goo00=NmgooOol03goo00<007ooOol0@Goo
000kOol01000OomNmekg5Goo00=NmgooOol08goo00=NmgooOol08goo00ANmgooOomNmbEoo`04G_Mo
ogooG_LAOol00ekgOomoo`0=Ool00ekgOomoo`0;Ool00ekgOomoo`0:Ool00ekgOomoo`0=Ool00ekg
Oomoo`0?Ool00`00Oomoo`11Ool003]oo`05001oogooOomNm`0DOol00ekgOomoo`0SOol00ekgOomo
o`0SOol01EkgOomoogooG_L097oo00ANmgooOomNma5oo`03G_Moogoo00eoo`03G_Moogoo00]oo`03
G_Moogoo00Yoo`03G_Moogoo00eoo`03G_Moogoo00moo`03001oogoo045oo`00>goo00<007ooOol0
0Woo00=NmgooOol04Goo00=NmgooOol08goo00=NmgooOol08goo00ENmgooOomooekg02Aoo`03G_Mo
oekg019oo`03G_Moogoo00eoo`03G_Moogoo00]oo`03G_Moogoo00Yoo`03G_Moogoo00eoo`03G_Mo
ogoo00moo`03001oogoo045oo`00>goo00<007ooOol00goo00=NmgooOol047oo00=NmgooOol08goo
00=NmgooOol08goo00=NmgooOol00Woo00=NmgooOol08Woo0Ukg4goo00=NmgooOol037oo00=Nmgoo
Ool02goo00=NmgooOol02Woo00=NmgooOol03Goo00=NmgooOol03goo00<007ooOol0@Goo000kOol0
0`00Oomoo`04Ool2G_L@Ool00ekgOomoo`0ROol00ekgOomoo`0SOol00ekgOomoo`03Ool00ekgOomo
o`0ROol2G_LCOol00ekgOomoo`0<Ool00ekgOomoo`0;Ool00ekgOomoo`0:Ool00ekgOomoo`0<Ool0
0ekgOomoo`0@Ool00`00Oomoo`11Ool003]oo`03001oogoo00Ioo`03G_Moogoo00eoo`03G_Moogoo
029oo`03G_Moogoo02=oo`03G_Moogoo00Aoo`03G_Moogoo025oo`03G_Moogoo019oo`03G_Moogoo
00aoo`03G_Moogoo00]oo`03G_Moogoo00Yoo`03G_Moogoo00aoo`03G_Moogoo011oo`03001oogoo
045oo`00>goo0P0027oo00=NmgooOol037oo00=NmgooOol08Woo00=NmgooOol08goo00=NmgooOol0
1Goo00=NmgooOol087oo0Ukg4goo00=NmgooOol037oo00=NmgooOol02goo00=NmgooOol02Woo00=N
mgooOol037oo00=NmgooOol03goo0P00@goo000kOol00`00Oomoo`08Ool00ekgOomoo`0;Ool00ekg
Oomoo`0ROol00ekgOomoo`0SOol00ekgOomoo`05Ool00ekgOomoo`0POol2G_LCOol00ekgOomoo`0<
Ool00ekgOomoo`0;Ool00ekgOomoo`0:Ool00ekgOomoo`0<Ool00ekgOomoo`0@Ool00`00Oomoo`11
Ool003]oo`03001oogoo00Uoo`9Nm`]oo`03G_Moogoo029oo`03G_Moogoo02=oo`03G_Moogoo00Io
o`03G_Moogoo01ioo`04G_MoogooG_LCOol00ekgOomoo`0<Ool00ekgOomoo`0:Ool00ekgOomoo`0:
Ool00ekgOomoo`0<Ool00ekgOomoo`0@Ool00`00Oomoo`11Ool003]oo`03001oogoo00]oo`03G_Mo
ogoo00Moo`03G_Moogoo02=oo`03G_Moogoo02=oo`03G_Moogoo00Ioo`03G_Moogoo01ioo`04G_Mo
ogooG_LCOol00ekgOomoo`0<Ool00ekgOomoo`0:Ool00ekgOomoo`0:Ool00ekgOomoo`0;Ool00ekg
Oomoo`0AOol00`00Oomoo`11Ool003]oo`03001oogoo00aoo`03G_Moogoo00Ioo`03G_Moogoo02=o
o`03G_Moogoo029oo`03G_Moogoo00Qoo`03G_Moogoo01eoo`04G_MoogooG_LCOol00ekgOomoo`0<
Ool00ekgOomoo`0:Ool00ekgOomoo`0:Ool00ekgOomoo`0;Ool00ekgOomoo`0AOol00`00Oomoo`11
Ool003]oo`03001oogoo00eoo`03G_Moogoo00Eoo`03G_Moogoo02=oo`03G_Moogoo029oo`03G_Mo
ogoo00Qoo`03G_Moogoo01aoo`03G_Moogoo009oo`03G_Moogoo011oo`03G_Moogoo00aoo`03G_L2
hWoo00Yoo`03G_Moogoo00Uoo`03G_Moogoo00aoo`03G_Moogoo015oo`03001oogoo045oo`00>goo
00<007ooOol03Woo0Ukg1Goo00=NmgooOol08Woo00=NmgooOol08goo00=NmgooOol02Goo00=Nmgoo
Ool06goo00=NmgooOol00Woo00=NmgooOol047oo00=NmgooOol037oo00=Nm`;ROol02Woo00=Nmgoo
Ool02Goo00=NmgooOol037oo00=NmgooOol04Goo00<007ooOol0@Goo000kOol00`00Oomoo`0@Ool0
0ekgOomoo`02Ool00ekgOomoo`0ROol00ekgOomoo`0SOol00ekgOomoo`0:Ool00ekgOomoo`0JOol0
0ekgOomoo`02Ool00ekgOomoo`0AOol00ekgOomoo`0;Ool00ekg0^Aoo`0:Ool00ekgOomoo`09Ool0
0ekgOomoo`0<Ool00ekgOomoo`0AOol00`00Oomoo`11Ool003]oo`03001oogoo015oo`05G_Moogoo
OomNm`0TOol00ekgOomoo`0SOol00ekgOomoo`0:Ool00ekgOomoo`0JOol00ekgOomoo`03Ool00ekg
Oomoo`0@Ool00ekgOomoo`0;Ool00ekg0^Moo`0:Ool00ekgOomoo`09Ool00ekgOomoo`0;Ool00ekg
Oomoo`0AOol00ekg001oo`12Ool003]oo`03001oogoo019oo`04G_MoogooG_LTOol00ekgOomoo`0S
Ool00ekgOomoo`0;Ool00ekgOomoo`0HOol00ekgOomoo`04Ool00ekgOomoo`0@Ool00ekgOomoo`0;
Ool00ekg0^Moo`0:Ool00ekgOomoo`09Ool00ekgOomoo`0;Ool00ekgOomoo`0AOol00ekg001oo`12
Ool003]oo`03001oogoo01=oo`=NmbAoo`03G_Moogoo029oo`03G_Moogoo00aoo`03G_Moogoo01Qo
o`03G_Moogoo00Aoo`03G_Moogoo011oo`03G_Moogoo00]oo`03G_L2jGoo00Yoo`03G_Moogoo00Uo
o`03G_Moogoo00]oo`03G_Moogoo015oo`03G_L007oo049oo`00>goo0P005Woo00=NmgooOol08Woo
00=NmgooOol08Woo00=NmgooOol03Goo00=NmgooOol05goo00=NmgooOol01Goo00=NmgooOol03goo
00=NmgooOol02goo00=Nm`;YOol02Woo00=NmgooOol02Goo00=NmgooOol02goo00=NmgooOol047oo
00=Nm`000000@goo000kOol00`00Oomoo`0DOol00ekgOomNm`0SOol00ekgOomoo`0ROol00ekgOomo
o`0>Ool00ekgOomoo`0EOol00ekgOomoo`06Ool00ekgOomoo`0@Ool00ekgOomoo`0;Ool00`;[Oomo
o`09Ool00ekgOomoo`09Ool00ekgOomoo`0;Ool00ekgOomoo`0@Ool00ekgOol00013Ool003]oo`03
001oogoo01Aoo`04G_MoogooG_LROol00ekgOomoo`0ROol00ekgOomoo`0>Ool00ekgOomoo`0EOol0
0ekgOomoo`06Ool00ekgOomoo`0@Ool00ekgOomoo`0;Ool00`;[Oomoo`09Ool00ekgOomoo`09Ool0
0ekgOomoo`0:Ool00ekgOomoo`0AOol00ekgOol00013Ool003]oo`03001oogoo01Aoo`04G_Moogoo
Ool2G_LOOol00ekgOomoo`0SOol00ekgOomoo`0?Ool00ekgOomoo`0DOol00ekgOomoo`07Ool00ekg
Oomoo`0?Ool00ekgOomoo`0;Ool00`;^Oomoo`09Ool00ekgOomoo`09Ool00ekgOomoo`0:Ool00ekg
Oomoo`0@Ool015kgOomoo`00@goo000kOol00`00Oomoo`0DOol00ekgOomoo`03Ool00ekgOomoo`0L
Ool00ekgOomoo`0SOol00ekgOomoo`0?Ool00ekgOomoo`0DOol00ekgOomoo`07Ool00ekgOomoo`0?
Ool00ekgOomoo`0;Ool00`;`Oomoo`09Ool00ekgOomoo`09Ool00ekgOomoo`0:Ool00ekgOomoo`0@
Ool015kgOomoo`00@goo000kOol00`00Oomoo`0DOol00ekgOomoo`04Ool00ekgOomoo`0KOol00ekg
Oomoo`0ROol00ekgOomoo`0AOol00ekgOomoo`0BOol00ekgOomoo`08Ool00ekgOomoo`0?Ool00ekg
Oomoo`0;Ool00`;`Oomoo`09Ool00ekgOomoo`08Ool00ekgOomoo`0;Ool00ekgOomoo`0@Ool015kg
Oomoo`00@goo000kOol00`00Oomoo`0DOol00ekgOomoo`05Ool00ekgOomoo`0JOol00ekgOomoo`0R
Ool00ekgOomoo`0AOol00ekgOomoo`0BOol00ekgOomoo`09Ool00ekgOomoo`0?Ool00ekgOomoo`0:
Ool00`;bOomoo`09Ool00ekgOomoo`08Ool00ekgOomoo`0;Ool00ekgOomoo`0?Ool01EkgOomoogoo
0000@goo000kOol00`00Oomoo`0DOol00ekgOomoo`06Ool2G_LJOol00ekgOomoo`0ROol00ekgOomo
o`0BOol00ekgOomoo`0AOol00ekgOomoo`09Ool00ekgOomoo`0?Ool00ekgOomoo`0:Ool00`;bOomo
o`09Ool00ekgOomoo`08Ool00ekgOomoo`0;Ool00ekgOomoo`0?Ool01EkgOomoogoo0000@goo000k
Ool00`00Oomoo`0DOol00ekgOomoo`08Ool00ekgOomoo`0GOol00ekgOomoo`0ROol00ekgOomoo`0C
Ool00ekgOomoo`0?Ool00ekgOomoo`0:Ool00ekgOomoo`0?Ool00ekgOomoo`0:Ool00ekg0_Eoo`09
Ool00ekgOomoo`08Ool00ekgOomoo`0:Ool00ekgOomoo`0@Ool01EkgOomoogoo0000@goo000kOol0
0`00Oomoo`0DOol00ekgOomoo`09Ool00ekgOomoo`0FOol00ekgOomoo`0ROol00ekgOomoo`0COol0
0ekgOomoo`0?Ool00ekgOomoo`0;Ool00ekgOomoo`0>Ool00ekgOomoo`0:Ool00ekg0_Eoo`09Ool0
0ekgOomoo`08Ool00ekgOomoo`0:Ool00ekgOomoo`0?Ool00ekgOomoo`02Ool00`00Oomoo`11Ool0
03]oo`8001Eoo`03G_Moogoo00Yoo`03G_Moogoo01Eoo`03G_Moogoo029oo`03G_Moogoo01Aoo`03
G_Moogoo00ioo`03G_Moogoo00]oo`03G_Moogoo00ioo`03G_Moogoo00Yoo`03G_L2mgoo00Uoo`03
G_Moogoo00Qoo`03G_Moogoo00Yoo`03G_Moogoo00moo`04G_MoogooOol20013Ool003]oo`03001o
ogoo01Aoo`03G_Moogoo00]oo`9NmaAoo`03G_Moogoo029oo`03G_Moogoo01Eoo`03G_Moogoo00io
o`03G_Moogoo00]oo`03G_Moogoo00moo`03G_Moogoo00Uoo`03G_L2egoo00Uoo`03G_Moogoo00Qo
o`03G_Moogoo00Yoo`03G_Moogoo00moo`03G_Moogoo009oo`03001oogoo045oo`00>goo00<007oo
Ool057oo00=NmgooOol03Goo00=NmgooOol04Goo00=NmgooOol08Woo00=NmgooOol05Woo00=Nmgoo
Ool037oo00=NmgooOol03Goo00=NmgooOol03Woo00=NmgooOol02Woo00<2egooOol027oo00=Nmgoo
Ool027oo00=NmgooOol02Woo00=NmgooOol03Woo00=NmgooOol00goo00<007ooOol0@Goo000kOol0
0`00Oomoo`0DOol00ekgOomoo`0>Ool00ekgOomoo`0@Ool00ekgOomoo`0ROol00ekgOomoo`0GOol0
0ekgOomoo`0;Ool00ekgOomoo`0=Ool00ekgOomoo`0>Ool00ekgOomoo`0:Ool00`9gOomoo`08Ool0
0ekgOomoo`08Ool00ekgOomoo`09Ool00ekgOomoo`0?Ool00ekgOomoo`03Ool00`00Oomoo`11Ool0
03]oo`03001oogoo01=oo`03G_Moogoo011oo`03G_Moogoo00moo`03G_Moogoo029oo`03G_Moogoo
01Moo`03G_Moogoo00]oo`03G_Moogoo00eoo`03G_Moogoo00ioo`03G_Moogoo00Yoo`030WMoogoo
00Qoo`03G_Moogoo00Qoo`03G_Moogoo00Uoo`03G_Moogoo00moo`03G_Moogoo00=oo`03001oogoo
045oo`00>goo00<007ooOol04goo00=NmgooOol04Goo0Ukg3goo00=NmgooOol08Woo00=NmgooOol0
67oo00=NmgooOol02Woo00=NmgooOol03Woo00=NmgooOol03Goo00=NmgooOol02Woo00<2=gooOol0
27oo00=NmgooOol027oo00=NmgooOol02Goo00=NmgooOol03Woo00=NmgooOol017oo00<007ooOol0
@Goo000kOol00`00Oomoo`0COol00ekgOomoo`0COol00ekgOomoo`0<Ool00ekgOomoo`0ROol00ekg
Oomoo`0HOol00ekgOomoo`09Ool00ekgOomoo`0?Ool00ekgOomoo`0>Ool00ekgOomoo`09Ool00`8g
Oomoo`08Ool00ekgOomoo`07Ool00ekgOomoo`0:Ool00ekgOomoo`0>Ool00ekgOomoo`04Ool00`00
Oomoo`11Ool003]oo`03001oogoo01=oo`03G_Moogoo01Aoo`03G_Moogoo00]oo`03G_Moogoo025o
o`03G_Moogoo01Yoo`03G_Moogoo00Qoo`03G_Moogoo00moo`03G_Moogoo00ioo`03G_Moogoo00Uo
o`030OMoogoo00Qoo`03G_Moogoo00Moo`03G_Moogoo00Yoo`03G_Moogoo00ioo`03G_Moogoo00Ao
o`03001oogoo045oo`00>goo00<007ooOol04goo00=NmgooOol05Goo00=NmgooOol02Woo00=Nmgoo
Ool08Goo00=NmgooOol06Woo00=NmgooOol027oo00=NmgooOol047oo00=NmgooOol03Goo00=Nmgoo
Ool02Goo00<1mgooOol027oo00=NmgooOol01goo00=NmgooOol02Goo00=NmgooOol03Woo00=Nmgoo
Ool01Goo00<007ooOol0@Goo000kOol00`00Oomoo`0COol00ekgOomoo`0FOol2G_L9Ool00ekgOomo
o`0ROol00ekgOomoo`0KOol00ekgOomoo`07Ool00ekgOomoo`0@Ool00ekgOomoo`0=Ool00ekgOomo
o`09Ool00`6GOomoo`08Ool00ekgOomoo`07Ool00ekgOomoo`09Ool00ekgOomoo`0>Ool00ekgOomo
o`05Ool00`00Oomoo`11Ool003]oo`8001Aoo`03G_Moogoo01Qoo`03G_Moogoo00Ioo`03G_Moogoo
029oo`03G_Moogoo01aoo`03G_Moogoo00Eoo`03G_Moogoo015oo`03G_Moogoo00eoo`03G_Moogoo
00Uoo`030IMoogoo00Qoo`03G_Moogoo00Moo`03G_Moogoo00Uoo`03G_Moogoo00ioo`03G_Moogoo
00Aoo`80025oo`aL00=oo`04001oogoo000?Ool003]oo`03001oogoo01=oo`03G_Moogoo01Uoo`03
G_Moogoo00Eoo`03G_Moogoo029oo`03G_Moogoo01aoo`03G_Moogoo00Eoo`03G_Moogoo019oo`03
G_Moogoo00eoo`03G_Moogoo00Qoo`030EMoogoo00Qoo`03G_Moogoo00Moo`03G_Moogoo00Uoo`03
G_Moogoo00eoo`03G_Moogoo00Ioo`03001oogoo01moo`aL00=oo`04001oogoo000?Ool003]oo`03
001oogoo01=oo`03G_Moogoo01Yoo`9Nm`Eoo`03G_Moogoo029oo`03G_Moogoo01eoo`03G_Moogoo
00Aoo`03G_Moogoo019oo`03G_Moogoo00eoo`03G_Moogoo00Qoo`030EMoogoo00Qoo`03G_Moogoo
00Moo`03G_Moogoo00Uoo`03G_Moogoo00eoo`03G_Moogoo00Ioo`03001oogoo01moo`aL00=oo`04
001oogoo000?Ool003]oo`03001oogoo01=oo`03G_Moogoo01aoo`03G_Moogoo009oo`03G_Moogoo
029oo`03G_Moogoo01eoo`03G_Moogoo00Aoo`03G_Moogoo019oo`03G_Moogoo00eoo`03G_Moogoo
00Uoo`030AMoogoo00Moo`03G_Moogoo00Moo`03G_Moogoo00Qoo`03G_Moogoo00ioo`03G_Moogoo
00Ioo`03001oogoo01moo`aL0P=oo`04001oogoo000?Ool003]oo`03001oogoo01=oo`03G_Moogoo
01eoo`05G_MoogooOomNm`0TOol00ekgOomoo`0NOol00ekgOomoo`02Ool00ekgOomoo`0DOol00ekg
Oomoo`0<Ool00ekgOomoo`09Ool00`4GOomoo`07Ool00ekgOomoo`07Ool00ekgOomoo`08Ool00ekg
Oomoo`0=Ool00ekgOomoo`07Ool00`00Oomoo`0OOol<G084Ool2000@Ool003]oo`03001oogoo01=o
o`03G_Moogoo01ioo`04G_MoogooG_LSOol00ekgOomoo`0POol01EkgOomoogooG_L05Woo00=Nmgoo
Ool037oo00=NmgooOol02Goo00<0]gooOol01goo00=NmgooOol01goo00=NmgooOol027oo00=Nmgoo
Ool03Goo00=NmgooOol01goo00<007ooOol07goo35`25Woo000kOol00`00Oomoo`0COol00ekgOomo
o`0OOol3G_LSOol00ekgOomoo`0POol01EkgOomoogooG_L05Woo00=NmgooOol03Goo00=NmgooOol0
27oo00<0]gooOol01goo00=NmgooOol01goo00=NmgooOol027oo00=NmgooOol03Goo00=NmgooOol0
1goo00<007ooOol07goo35`45Woo000kOol00`00Oomoo`0COol00ekgOomoo`0POol2G_LSOol00ekg
Oomoo`0QOol015kgOomooekg5goo00=NmgooOol037oo00=NmgooOol027oo00<0MgooOol01goo00=N
mgooOol01goo00=NmgooOol027oo00=NmgooOol037oo00=NmgooOol027oo00<007ooOol07goo35`4
5Woo000kOol00`00Oomoo`0COol00ekgOomoo`0POol00ekgOomNm`0ROol00ekgOomoo`0QOol015kg
Oomooekg5goo00=NmgooOol037oo00=NmgooOol027oo00<0MgooOol01goo00=NmgooOol01Woo00=N
mgooOol02Goo00=NmgooOol037oo00=NmgooOol027oo00<007ooOol07goo35`45Woo000cOol40004
Ool00`00Oomoo`0COol00ekgOomoo`0POol015kgOomooekg8Goo00=NmgooOol08Woo0Ukg67oo00=N
mgooOol037oo00=NmgooOol027oo00<0=gooOol01goo00=NmgooOol01Woo00=NmgooOol027oo00=N
mgooOol03Goo00=NmgooOol027oo00<007ooOol07goo35`75Woo000cOol00`00Oomoo`05Ool00`00
Oomoo`0BOol00ekgOomoo`0QOol015kgOomoogoo0Ukg7goo00=NmgooOol08goo00=NmgooOol05goo
00=NmgooOol02goo00=NmgooOol027oo00<0=gooOol01goo00=NmgooOol01Woo00=NmgooOol027oo
00=NmgooOol037oo00=NmgooOol02Goo00<007ooOol07goo35`75Woo000dOol00`00Oomoo`04Ool3
000BOol00ekgOomoo`0QOol00ekgOomoo`03Ool00ekgOomoo`0LOol00ekgOomoo`0SOol00ekgOomo
o`0GOol00ekgOomoo`0<Ool00ekgOomoo`07Ool00`@GOomoo`04Ool6G_L6Ool00ekgOomoo`08Ool0
0ekgOomoo`0<Ool00ekgOomoo`07Ool3000QOol<G0LFOol002eoo`@000Aoo`03001oogoo00=oo`03
001oogoo019oo`03G_Moogoo025oo`03G_Moogoo00Aoo`03G_Moogoo01]oo`03G_Moogoo02=oo`9N
maQoo`03G_Moogoo00aoo`03G_Moogoo00Moo`0311Moogoo009oo`9Nm`=oo`03G_Moogoo009Nm`Ao
o`03G_Moogoo00Qoo`03G_Moogoo00aoo`03G_Moogoo00Uoo`03001oogoo01moo`aL1aIoo`00<goo
00@007ooOol000Aoo`03001oogoo019oo`03G_Moogoo025oo`03G_Moogoo00Eoo`03G_Moogoo01Yo
o`03G_Moogoo029oo`03G_Mooekg01Uoo`03G_Moogoo00]oo`03G_Moogoo00Moo`0331Moogoo009N
m`Eoo`03G_Moogoo009oo`9Nm`9oo`03G_Moogoo00Qoo`03G_Moogoo00]oo`03G_Moogoo00Yoo`03
001oogoo01moo`aL2AIoo`00=7oo0P001Goo00<007ooOol04Woo00=NmgooOol08Goo00=NmgooOol0
1Woo0Ukg6Goo00=NmgooOol08goo00ANmgooOomNmaQoo`03G_Moogoo00]oo`03G_Moogoo00Moo`03
31MNmekg00Moo`03G_Moogoo00Aoo`=Nm`Uoo`03G_Moogoo00aoo`03G_Moogoo00Yoo`03001oogoo
01moo`aL2AIoo`00>goo00<007ooOol04Woo00=NmgooOol08Goo00=NmgooOol027oo00=NmgooOol0
5Woo00=NmgooOol08goo00ANmgooOomNmaQoo`03G_Moogoo00]oo`03G_Moogoo00Moo`9Nm`Qoo`03
G_Moogoo00Ioo`9Nm`Qoo`03G_Moogoo00aoo`03G_Moogoo00Yoo`03001oogoo01moo`aL2AIoo`00
>goo00<007ooOol04Woo00=NmgooOol08Goo00=NmgooOol02Goo00=NmgooOol05Goo00=NmgooOol0
8goo00ENmgooOomooekg01Qoo`03G_Moogoo00]oo`03G_Moogoo00Eoo`03G_Mooa@G00Qoo`03G_Mo
ogoo00Ioo`03G_Mooekg00Moo`03G_Moogoo00]oo`03G_Moogoo00]oo`03001oogoo01moo`aL2aIo
o`00>goo00<007ooOol04Woo00=NmgooOol08Goo00=NmgooOol02Woo00=NmgooOol057oo00=Nmgoo
Ool08goo00=NmgooOol00Woo00=NmgooOol05Goo00=NmgooOol02goo00=NmgooOol017oo00ANmgoo
OolD5`Qoo`03G_Moogoo00Ioo`04G_MoogooG_L6Ool00ekgOomoo`0;Ool00ekgOomoo`0;Ool00`00
Oomoo`0OOol<G0/FOol003]oo`03001oogoo019oo`03G_Moogoo025oo`03G_Moogoo00]oo`9NmaAo
o`03G_Moogoo02=oo`03G_Moogoo009oo`03G_Moogoo01Eoo`03G_Moogoo00]oo`03G_Moogoo00=o
o`05G_MoogooOolP5`08Ool00ekgOomoo`06Ool01EkgOomoogooG_L01Goo00=NmgooOol02goo00=N
mgooOol02goo00<007ooOol07goo35`;5Woo000kOol00`00Oomoo`0BOol00ekgOomoo`0QOol00ekg
Oomoo`0=Ool00ekgOomoo`0AOol00ekgOomoo`0ROol00ekgOomoo`04Ool00ekgOomoo`0EOol00ekg
Oomoo`0:Ool00ekgOomoo`03Ool01EkgOomoogoo81L027oo00=NmgooOol01Goo00=NmgooOol00Woo
00=NmgooOol00Woo00=NmgooOol02goo00=NmgooOol037oo00<007ooOol07goo35`>5Woo000kOol0
0`00Oomoo`0BOol00ekgOomoo`0POol00ekgOomoo`0?Ool00ekgOomoo`0@Ool00ekgOomoo`0ROol0
0ekgOomoo`04Ool00ekgOomoo`0EOol00ekgOomoo`0:Ool00ekgOomoo`02Ool00ekgOomoo`02Ool0
0bPGOomoo`06Ool00ekgOomoo`05Ool00ekgOomoo`03Ool01EkgOomoogooG_L03Goo00=NmgooOol0
37oo00<007ooOol07goo35`>5Woo000kOol2000COol00ekgOomoo`0POol00ekgOomoo`0@Ool00ekg
Oomoo`0?Ool00ekgOomoo`0ROol00ekgOomoo`05Ool00ekgOomoo`0DOol00ekgOomoo`0:Ool01Ekg
OomoogooG_L01Goo00<X5gooOol01Woo00=NmgooOol01Goo00=NmgooOol017oo00ANmgooOomNm`eo
o`03G_Moogoo00]oo`80025oo`aL3QIoo`00>goo00<007ooOol04Woo00=NmgooOol087oo00=Nmgoo
Ool04Goo0Ukg3goo00=NmgooOol08Woo00=NmgooOol01Woo00=NmgooOol057oo00=NmgooOol02Woo
00=NmgooG_L01Woo00<`5gooOol01Woo00=NmgooOol01Goo00=NmgooOol01Goo00=NmgooG_L037oo
00=NmgooOol03Goo00<007ooOol07goo35`@5Woo000kOol00`00Oomoo`0BOol00ekgOomoo`0POol0
0ekgOomoo`0COol00ekgOomoo`0<Ool00ekgOomoo`0ROol00ekgOomoo`06Ool00ekgOomoo`0DOol0
0ekgOomoo`0:Ool00ekgOomNm`06Ool00c0GOomoo`06Ool00ekgOomoo`05Ool00ekgOomoo`05Ool0
0ekgOomNm`0<Ool00ekgOomoo`0=Ool00`00Oomoo`0OOol<G10FOol003]oo`03001oogoo019oo`03
G_Moogoo021oo`03G_Moogoo01Aoo`03G_Moogoo00Yoo`03G_Moogoo02=oo`03G_Moogoo00Moo`03
G_Moogoo01=oo`03G_Moogoo00Yoo`9Nm`Qoo`03G_Moogoo00Eoo`03G_Moogoo00Eoo`03G_Moogoo
00Ioo`03G_Moogoo00]oo`03G_Moogoo00eoo`03001oogoo01moo`aL41Ioo`00>goo00<007ooOol0
4Woo00=NmgooOol087oo00=NmgooOol05Goo00=NmgooOol02Goo00=NmgooOol08goo00=NmgooOol0
1goo00=NmgooOol057oo00=NmgooOol02Goo00=NmgooOol01goo00<l5gooOol01Goo00=NmgooOol0
1Goo00=NmgooOol01Woo0Ukg2goo00=NmgooOol03Woo00<007ooOol07goo35`C5Woo000kOol00`00
Oomoo`0AOol00ekgOomoo`0QOol00ekgOomoo`0FOol2G_L9Ool00ekgOomoo`0SOol00ekgOomoo`08
Ool00ekgOomoo`0COol00ekgOomoo`09Ool00ekgOomoo`07Ool00c`GOomoo`05Ool00ekgOomoo`05
Ool00ekgOomoo`06Ool2G_L;Ool00ekgOomoo`0>Ool00`00Oomoo`0OOol<G1<FOol003]oo`03001o
ogoo015oo`03G_Moogoo025oo`03G_Moogoo01Qoo`03G_Moogoo00Ioo`03G_Moogoo029oo`03G_Mo
ogoo00Uoo`03G_Moogoo01=oo`03G_Moogoo00Qoo`03G_Mooekg00Qoo`03A1Moogoo00Eoo`03G_Mo
ogoo00Eoo`03G_Moogoo00Ioo`03G_Mooekg00Yoo`03G_Moogoo00ioo`03001oogoo01moo`aL4aIo
o`00>goo00<007ooOol04Goo00=NmgooOol08Goo00=NmgooOol06Goo00=NmgooOol01Goo00=Nmgoo
Ool08Woo00=NmgooOol02Woo00=NmgooOol04goo00=NmgooOol01Woo00ANmgooOomNm`Qoo`03A1Mo
ogoo00Eoo`03G_Moogoo00Eoo`03G_Moogoo00Ioo`03G_Mooekg00Uoo`03G_Moogoo00moo`03001o
ogoo01moo`aL5AIoo`00>goo00<007ooOol04Goo00=NmgooOol08Goo00=NmgooOol06Woo00=Nmgoo
Ool017oo00=NmgooOol08Woo00=NmgooOol02goo00=NmgooOol04Woo00=NmgooOol01Woo00ANmgoo
OomNm`Qoo`03G_Moogoo00Eoo`03G_Moogoo00Eoo`03G_Moogoo00Eoo`05G_MoogooOomNm`08Ool0
0ekgOomoo`0?Ool00`00Oomoo`0OOol<G1DFOol003]oo`03001oogoo015oo`03G_Moogoo025oo`03
G_Moogoo01]oo`9Nm`Aoo`03G_Moogoo029oo`03G_Moogoo00]oo`03G_Moogoo019oo`03G_Moogoo
00Eoo`05G_MoogooOomNm`08Ool00d`GOomoo`05Ool00ekgOomoo`04Ool00ekgOomoo`06Ool01Ekg
OomoogooG_L027oo00=NmgooOol03goo00<007ooOol07goo35`E5Woo000kOol00`00Oomoo`0AOol0
0ekgOomoo`0QOol00ekgOomoo`0MOol01EkgOomoogooG_L097oo00=NmgooOol037oo00=NmgooOol0
4Woo00=NmgooOol017oo00ENmgooOomooekg00Qoo`03C1Moogoo00Eoo`03G_Moogoo00Aoo`03G_Mo
ogoo00Ioo`05G_MoogooOomNm`07Ool00ekgOomoo`0@Ool00`00Oomoo`0OOol<G1LFOol003]oo`80
019oo`03G_Moogoo025oo`03G_Moogoo01ioo`04G_MoogooG_LTOol00ekgOomoo`0<Ool00ekgOomo
o`0BOol00ekgOomoo`03Ool00ekgOomoo`03Ool00ekgOomoo`05Ool00ePGOomoo`05Ool00ekgOomo
o`04Ool00ekgOomoo`06Ool00ekgOomoo`02Ool00ekgOomoo`04Ool00ekgOomoo`0?Ool2000QOol<
G1LFOol003]oo`03001oogoo015oo`03G_Moogoo025oo`03G_Moogoo01moo`9NmbEoo`03G_Moogoo
00eoo`03G_Moogoo015oo`03G_Moogoo00=oo`03G_Moogoo00=oo`03G_Moogoo00Eoo`03F1Moogoo
00Eoo`03G_Moogoo00Aoo`03G_Moogoo00Ioo`03G_Moogoo009oo`03G_Moogoo00Aoo`03G_Moogoo
011oo`03001oogoo01moo`aL5aIoo`00>goo00<007ooOol04Goo00=NmgooOol08Goo00=NmgooOol0
87oo0Ukg97oo00=NmgooOol03Woo00=NmgooOol04Goo00ENmgooOomooekg00Ioo`03G_Moogoo00Eo
o`03G_Moogoo00Eoo`03G_Moogoo00Aoo`03G_Moogoo00Ioo`03G_Moogoo00=oo`03G_Moogoo009o
o`03G_Moogoo015oo`03001oogoo01moo`aD5aIoo`00>goo00<007ooOol04Goo00=NmgooOol08Goo
00=NmgooOol087oo00=NmgooG_L08Woo00=NmgooOol03goo00=NmgooOol04Goo00ENmgooOomooekg
00Ioo`03G_Moogoo00Ioo`03G1Moogoo00Aoo`03G_Moogoo00Aoo`03G_Moogoo00Eoo`03G_Moogoo
00Aoo`03G_Moogoo009oo`03G_Moogoo011oo`03G_L007oo021oo`aD5aIoo`00>goo00<007ooOol0
4Goo00=NmgooOol08Goo00=NmgooOol087oo00ANmgooOomNmb5oo`03G_Moogoo011oo`03G_Moogoo
011oo`05G_MoogooOomNm`06Ool00ekgOomoo`06Ool00e`GOomoo`04Ool00ekgOomoo`04Ool00ekg
Oomoo`05Ool00ekgOomoo`04Ool00ekgOomoo`02Ool00ekgOomoo`0@Ool00ekg001oo`0POol<E1LF
Ool003]oo`03001oogoo015oo`03G_Moogoo021oo`03G_Moogoo025oo`05G_MoogooOomNm`0POol0
0ekgOomoo`0@Ool00ekgOomoo`0AOol00ekgOomNm`08Ool00ekgOomoo`05Ool00e`EOomoo`04Ool0
0ekgOomoo`04Ool00ekgOomoo`05Ool00ekgOomoo`05Ool01UkgOomooekgOol2hQ1oo`03G_Moo`00
025oo`a<5aIoo`00>goo00<007ooOol04Goo00=NmgooOol087oo00=NmgooOol08Goo00=NmgooOol0
0Woo0Ukg7Woo00=NmgooOol04Goo00=NmgooOol047oo00=NmgooG_L027oo00=NmgooOol01Goo00=L
5GooOol017oo00=NmgooOol017oo00=NmgooOol01Goo00=NmgooOol01Goo00INmgooOomNm`;W0^8@
Ool00ekgOol0000QOol<C1LFOol003]oo`03001oogoo015oo`03G_Moogoo021oo`03G_Moogoo025o
o`03G_Moogoo00Aoo`03G_Moogoo01]oo`03G_Moogoo019oo`03G_Moogoo00moo`03G_Mooekg00Qo
o`03G_Moogoo00Eoo`03G_ML4Woo00Aoo`03G_Moogoo00Aoo`03G_Moogoo00Eoo`03G_Moogoo00Eo
o`05G_MoogooG_L2i`0@Ool015kgOomoo`008Goo34`G5Woo000kOol00`00Oomoo`0AOol00ekgOomo
o`0POol00ekgOomoo`0QOol00ekgOomoo`05Ool00ekgOomoo`0JOol00ekgOomoo`0BOol00ekgOomo
o`0@Ool00ekgOomoo`07Ool00ekgOomoo`05Ool00ekgG19oo`04Ool00ekgOomoo`04Ool00ekgOomo
o`04Ool00ekgOomoo`07Ool2G_L00`;[0^Uoo`0?Ool015kgOomoo`008Goo340G5Woo000kOol00`00
Oomoo`0AOol00ekgOomoo`0POol00ekgOomoo`0QOol00ekgOomoo`06Ool00ekgOomoo`0IOol00ekg
Oomoo`0COol00ekgOomoo`0?Ool00ekgOomoo`07Ool00ekgOomoo`05Ool00ekgOomL4004Ool00ekg
Oomoo`04Ool00ekgOomoo`04Ool00ekgOomoo`07Ool00ekg0^h2j`0@Ool01EkgOomoogoo00008Goo
340G5Woo000kOol2000AOol00ekgOomoo`0QOol00ekgOomoo`0QOol00ekgOomoo`07Ool2G_LIOol0
0ekgOomoo`0COol00ekgOomoo`0?Ool00ekgOomoo`08Ool00ekgOomoo`04Ool01EkgOomL45`>O000
0Woo00=NmgooOol00goo00=NmgooOol01Goo00=NmgooOol01goo00=Nm`;^Ool03goo00ANmgooOomo
o`80025oo`a05aIoo`00>goo00<007ooOol047oo00=NmgooOol08Goo00=NmgooOol08Goo00=Nmgoo
Ool02Goo00=NmgooOol05Goo00=NmgooOol05Goo00=NmgooOol03Goo00=NmgooG_L02Goo00=Nmgoo
Ool017oo00ENmgooOomL3W`0009oo`03G_Moogoo00=oo`03G_Moogoo00Eoo`03G_Moogoo00Moo`03
0_82l7oo00moo`03G_Moogoo009oo`03001oogoo01moo``h5aIoo`00>goo00<007ooOol047oo00=N
mgooOol08Goo00=NmgooOol08Goo00=NmgooOol02Woo00=NmgooOol057oo00=NmgooOol05Goo00=N
mgooOol03Goo00=NmgooG_L02Goo00=NmgooOol017oo00=NmgooOol017oo00=NmgooOol00goo00=N
mgooOol01Goo00=NmgooOol01goo00<2lUkgOol03Woo00=NmgooOol00goo00<007ooOol07goo33PG
5Woo000kOol00`00Oomoo`0@Ool00ekgOomoo`0QOol00ekgOomoo`0QOol00ekgOomoo`0;Ool00ekg
Oomoo`0COol00ekgOomoo`0FOol00ekgOomoo`0<Ool00ekgOomNm`09Ool00ekgOomoo`04Ool00ekg
Oomoo`04Ool00ekgOomoo`03Ool00ekgOomoo`04Ool00ekgOomoo`07Ool00`;g0_ENm`0?Ool00ekg
Oomoo`03Ool00`00Oomoo`0OOol<>1LFOol003]oo`03001oogoo011oo`03G_Moogoo025oo`03G_Mo
ogoo025oo`03G_Moogoo00aoo`9Nma=oo`03G_Moogoo01Moo`03G_Moogoo00Yoo`05G_MoogooOomN
m`08Ool00ekgOomoo`05Ool00ekgOomoo`03Ool00ekgOomoo`03Ool00ekgOomoo`04Ool00ekgOomo
o`06Ool01@;G0_MoogooG_L03Goo00=NmgooOol017oo00<007ooOol07goo32`G5Woo000kOol00`00
Oomoo`0@Ool00ekgOomoo`0QOol00ekgOomoo`0POol00ekgOomoo`0?Ool00ekgOomoo`0@Ool00ekg
Oomoo`0GOol00ekgOomoo`0:Ool01EkgOomoogooG_L02Goo00=NmgooOol017oo00=NmgooOol00goo
00=NmgooOol00goo00=NmgooOol017oo00=NmgooOol01Woo00D2eekgOomooekg00aoo`03G_Moogoo
00Eoo`03001oogoo01moo``/5aIoo`00>goo00<007ooOol047oo00=NmgooOol08Goo00=NmgooOol0
87oo00=NmgooOol047oo00=NmgooOol03goo00=NmgooOol067oo00=NmgooOol02Goo00ENmgooOomo
oekg00Uoo`03G_Moogoo00Aoo`03G_Moogoo00=oo`03G_Moogoo00=oo`03G_Moogoo00Aoo`03G_Mo
ogoo00Eoo`030SL2Mgoo009oo`03G_Moogoo00Yoo`03G_Moogoo00Eoo`03001oogoo01moo``/5aIo
o`00>goo00<007ooOol047oo00=NmgooOol08Goo00=NmgooOol087oo00=NmgooOol04Goo00=Nmgoo
Ool03Woo00=NmgooOol067oo00=NmgooOol027oo00=NmgooOol00goo00=NmgooOol01Woo00=Nmgoo
Ool017oo00=NmgooOol00goo00=NmgooOol00goo00=NmgooOol017oo00=NmgooOol017oo00<1m`8g
G_L00goo00=NmgooOol02Goo00=NmgooOol01Woo00<007ooOol07goo32@G5Woo000kOol00`00Oomo
o`0@Ool00ekgOomoo`0QOol00ekgOomoo`0POol00ekgOomoo`0BOol2G_L>Ool00ekgOomoo`0IOol0
0ekgOomoo`07Ool00ekgOomoo`03Ool00ekgOomoo`06Ool00ekgOomoo`04Ool00ekgOomoo`03Ool0
0ekgOomoo`03Ool00ekgOomoo`03Ool00ekgOomoo`05Ool00`7gOomNm`04Ool00ekgOomoo`08Ool0
0ekgOomoo`06Ool00`00Oomoo`0OOol<91LFOol003]oo`03001oogoo011oo`03G_Moogoo025oo`03
G_Moogoo021oo`03G_Moogoo01Aoo`03G_Moogoo00Yoo`03G_Moogoo01]oo`03G_Moogoo00Ioo`03
G_Moogoo00=oo`03G_Moogoo00Ioo`03G_Moogoo00Aoo`03G_Moogoo00=oo`03G_Moogoo00=oo`03
G_Moogoo00=oo`03G_Moogoo00Aoo`030EL1Uekg00Eoo`03G_Moogoo00Moo`03G_Moogoo00Moo`03
001oogoo01moo``T5aIoo`00>goo00<007ooOol047oo00=NmgooOol08Goo00=NmgooOol087oo00=N
mgooOol05Goo00=NmgooOol02Goo00=NmgooOol06goo00=NmgooOol01Woo00=NmgooOol017oo00=N
mgooOol01Woo00=NmgooOol00goo00=NmgooOol00goo00=NmgooOol00goo00=NmgooOol00goo00=N
mgooOol00goo00@15`5GOomNm`Eoo`03G_Moogoo00Moo`03G_Moogoo00Moo`03001oogoo01moo``L
5aIoo`00>goo0P004Goo00=NmgooOol08Goo00=NmgooOol087oo00=NmgooOol05Woo00=NmgooOol0
27oo00=NmgooOol077oo00=NmgooOol017oo00=NmgooOol01Goo00=NmgooOol01Woo00=NmgooOol0
0goo00=NmgooOol00goo00=NmgooOol00Woo00=NmgooOol017oo00=NmgooOol00goo00@15gooOomN
m`Ioo`03G_Moogoo00Eoo`03G_Moogoo00Moo`80025oo``L5aIoo`00>goo00<007ooOol047oo00=N
mgooOol08Goo00=NmgooOol087oo00=NmgooOol05goo0Ukg27oo00=NmgooOol077oo00=NmgooOol0
17oo00=NmgooOol01Goo00=NmgooOol01Woo00=NmgooOol00goo00=NmgooOol00goo00=NmgooOol0
0Woo00=NmgooOol017oo00=NmgooOol00Woo00@0]gooOomNm`Moo`03G_Moogoo00Aoo`03G_Moogoo
00Uoo`03001oogoo01moo``L5aIoo`00>goo00<007ooOol047oo00=NmgooOol087oo00=NmgooOol0
8Goo00=NmgooOol06Goo00=NmgooOol01Goo00=NmgooOol07Goo00=NmgooOol00goo00=NmgooOol0
1Woo00=NmgooOol01Goo00=NmgooOol00goo00=NmgooOol00goo00=NmgooOol00Woo00=NmgooOol0
17oo00=NmgooOol00Woo00@0]gooOomNm`Moo`03G_Moogoo00Aoo`03G_Moogoo00Uoo`03001oogoo
01moo``@5aIoo`00>goo00<007ooOol047oo00=NmgooOol087oo00=NmgooOol08Goo00=NmgooOol0
6Woo00=NmgooOol017oo00=NmgooOol07Goo00=NmgooOol00goo00=NmgooOol01Woo00=NmgooOol0
1Goo00=NmgooOol00goo00=NmgooOol00goo00=NmgooOol00Woo00=NmgooOol00goo00=NmgooOol0
0Woo00D0=`1gOomooekg00Moo`03G_Moogoo00=oo`03G_Moogoo00Yoo`03001oogoo01moo``@5aIo
o`00>goo00<007ooOol047oo00=NmgooOol087oo00=NmgooOol08Goo00=NmgooOol06goo00=Nmgoo
Ool00goo00=NmgooOol07Woo00ENmgooOomooekg00Uoo`03G_Moogoo00Ioo`03G_Moogoo00=oo`03
G_Moogoo009oo`03G_Moogoo009oo`03G_Moogoo00=oo`06G_MoogooOol45`0g0Woo00=NmgooOol0
1goo00=NmgooOol00Woo00=NmgooOol02Woo00<007ooOol07goo310G5Woo000kOol00`00Oomoo`0@
Ool00ekgOomoo`0POol00ekgOomoo`0QOol00ekgOomoo`0LOol2G_L3Ool00ekgOomoo`0OOol015kg
Oomooekg2Woo00=NmgooOol01Goo00=NmgooOol00goo00=NmgooOol00Woo00=NmgooOol00Woo00=N
mgooOol00goo00ENmgooOol<5`@G00=oo`03G_Moogoo00Moo`05G_MoogooOomNm`0=Ool00`00Oomo
o`0OOol<41LFOol003]oo`03001oogoo011oo`03G_Moogoo021oo`03G_Moogoo025oo`03G_Moogoo
01ioo`03G_Mooekg029oo`04G_MoogooG_L:Ool00ekgOomoo`05Ool00ekgOomoo`03Ool00ekgOomo
o`02Ool00ekgOomoo`02Ool00ekgOomoo`03Ool015kgOolD5``G17oo00=NmgooOol01goo00ANmgoo
OomNm`ioo`03001oogoo01moo``85aIoo`00>goo00<007ooOol047oo00=NmgooOol087oo00=Nmgoo
Ool08Goo00=NmgooOol07goo0Ukg8goo00=NmgooG_L02Woo00=NmgooOol01Goo00=NmgooOol00goo
00=NmgooOol00Woo00=NmgooOol00Woo00=NmgooOol00goo00=Nmb0G51L017oo00=NmgooOol027oo
00ANmgooOomNm`ioo`03001oogoo01moo``85aIoo`00<goo1@000goo00<007ooOol047oo00=Nmgoo
Ool087oo00=NmgooOol08Goo00=NmgooOol087oo00=NmgooOol08Goo00=NmgooG_L02goo00=Nmgoo
Ool017oo00=NmgooOol00goo00=NmgooOol00Woo00=NmgooOol00Woo00=NmgooOol00Woo00=Nmgoo
81L01Goo00=NmgooOol027oo00=NmgooG_L03goo00<007ooOol07goo30PG5Woo000eOol00`00Oomo
o`03Ool00`00Oomoo`0@Ool00ekgOomoo`0POol00ekgOomoo`0QOol00ekgOomoo`0POol3G_LAOol0
0`;ROomoo`0>Ool2G_L;Ool00ekgOomoo`05Ool00ekgOomoo`02Ool00ekgOomoo`02Ool00ekgOomo
o`02Ool00ekgOomoo`02Ool00ekg:1Moo`05Ool00ekgOomoo`08Ool00ekgOomNm`0?Ool00`00Oomo
o`0OOol<01LFOol003Eoo`03001oogoo00=oo`<0011oo`03G_Moogoo021oo`03G_Moogoo025oo`03
G_Moogoo021oo`04G_MoogooG_L@Ool00`;R0^Aoo`0>Ool2G_L;Ool00ekgOomoo`05Ool00ekgOomo
o`02Ool00ekgOomoo`02Ool00ekgOomoo`02Ool00ekgOomoo`02Ool00c0G:1Moo`04Ool00ekgOomo
o`0:Ool00ekgOomoo`0<Ool3000QOol<01LFOol002eoo`@000Aoo`03001oogoo00=oo`03001oogoo
011oo`03G_Moogoo021oo`03G_Moogoo025oo`03G_Moogoo021oo`05G_MoogooOomNm`0@Ool00`;T
0^Uoo`0=Ool2G_L<Ool00ekgOomoo`04Ool00ekgOomoo`02Ool00ekgOomoo`02Ool01EkgOomoogoo
G_L017oo00<l5c0GOol01Goo00=NmgooOol02Woo00=NmgooOol03Woo00<007ooOol07goo300G5Woo
000eOol00`00Oomoo`03Ool00`00Oomoo`0@Ool00ekgOomoo`0POol00ekgOomoo`0QOol00ekgOomo
o`0POol00ekgOomoo`02Ool00ekgOomoo`0>Ool00`;Y0^ioo`0<Ool00ekgOomNm`0;Ool00ekgOomo
o`04Ool00ekgOomoo`02Ool00ekgOomoo`02Ool01EkgOomoogooG_L00goo00=45c`GG_L01Woo00=N
mgooOol02Goo0Ukg47oo00<007ooOol07goo301G5Woo000dOol20005Ool00`00Oomoo`0@Ool00ekg
Oomoo`0POol00ekgOomoo`0QOol00ekgOomoo`0POol00ekgOomoo`03Ool2G_L>Ool00`;[0^ioo`0<
Ool00ekgOomNm`0;Ool00ekgOomoo`04Ool00ekgOomoo`02Ool00ekgOomoo`02Ool01EkgOomoogoo
G_L00Woo00=<5d@GG_L01Woo00=NmgooOol02Goo00=NmgooG_L047oo00<007ooOol07goo301G5Woo
000kOol00`00Oomoo`0@Ool00ekgOomoo`0POol00ekgOomoo`0POol00ekgOomoo`0QOol00ekgOomo
o`05Ool00ekgOomoo`0<Ool00`;`0_9oo`0;Ool015kgOomooekg2goo00=NmgooOol017oo00=Nmgoo
Ool00Woo00ENmgooOomooekg00=oo`06G_MoogooC1Mooekg1Woo00=NmgooOol02Goo00=NmgooG_L0
47oo00<007ooOol07goo301G5Woo000kOol00`00Oomoo`0@Ool00ekgOomoo`0POol00ekgOomoo`0P
Ool00ekgOomoo`0QOol00ekgOomoo`06Ool00ekgOomoo`0<Ool00`;b0_Moo`09Ool01EkgOomoogoo
G_L02goo00=NmgooOol017oo00=NmgooOol00Woo00ENmgooOomooekg00=oo`03G_MH5goo009oo`03
G_Moogoo00Aoo`03G_Moogoo00Qoo`04G_MoogooG_L@Ool00`00Oomoo`0OOol<09LFOol003]oo`03
001oogoo011oo`03G_Moogoo021oo`03G_Moogoo021oo`03G_Moogoo025oo`03G_Moogoo00Moo`03
G_Moogoo00]oo`030_D2mgoo00Uoo`03G_Moogoo009oo`03G_Moogoo00Uoo`03G_Moogoo00=oo`03
G_Moogoo009oo`05G_MoogooOomNm`03Ool00e`GF1Moo`02Ool00ekgOomoo`03Ool00ekgOomoo`09
Ool01EkgOomoogooG_L03goo00<007ooOol07goo302G5Woo000kOol00`00Oomoo`0@Ool00ekgOomo
o`0POol00ekgOomoo`0POol00ekgOomoo`0POol00ekgOomoo`09Ool2G_L<Ool00`;G0WMoo`08Ool0
0ekgOomoo`03Ool00ekgOomoo`08Ool00ekgOomoo`02Ool00g`0G_Moo`03Ool02EkgOomoogooG_Mo
oe`EOomL5`04Ool00ekgOomoo`03Ool00ekgOomoo`08Ool00ekgOomoo`02Ool00ekgOomoo`0=Ool0
0`00Oomoo`0OOol<09LFOol003]oo`03001oogoo011oo`03G_Moogoo021oo`03G_Moogoo021oo`03
G_Moogoo021oo`03G_Moogoo00]oo`03G_Moogoo00Yoo`030WL2=goo00Moo`03G_Moogoo00=oo`03
G_Moogoo00Qoo`03G_Moogoo009oo`03O01L2Goo00=oo`09G_MoogooOomNmgooG1Eooekg00=oo`03
G_Moogoo00Aoo`03G_Moogoo00Qoo`03G_Moogoo009oo`03G_Moogoo00eoo`03001oogoo01moo``0
maIoo`00>goo00<007ooOol047oo00=NmgooOol087oo00=NmgooOol087oo00=NmgooOol087oo00=N
mgooOol037oo00=NmgooOol02Woo00<2=gooOol01Woo00=NmgooOol017oo00=NmgooOol027oo00=N
mgooOol00Woo00=L2EkgOol00Woo00ENmgooOomooe`B00=oo`05G_MoogooOomNm`05Ool00ekgOomo
o`08Ool00ekgOomoo`03Ool00ekgOomoo`0=Ool00`00Oomoo`0OOol<0?LFOol003]oo`03001oogoo
011oo`03G_Moogoo021oo`03G_Moogoo021oo`03G_Moogoo021oo`03G_Moogoo00eoo`03G_Moogoo
00Uoo`030OL1Ugoo00Ioo`03G_Moogoo00Aoo`03G_Moogoo00Qoo`03G_Moogoo00=oo`09G_ML2goo
OomNmgooG11ooe`B00=oo`05G_MoogooOomNm`05Ool00ekgOomoo`07Ool00ekgOomoo`04Ool00ekg
Oomoo`0=Ool00`00Oomoo`0OOol<0?LFOol003]oo`80015oo`03G_Moogoo021oo`03G_Moogoo021o
o`03G_Moogoo021oo`03G_Moogoo00ioo`9Nm`Yoo`030IMoogoo00Aoo`03G_Moogoo00Ioo`03G_Mo
ogoo00Moo`03G_Moogoo00=oo`09G_ML2gooG0iNmgooG11ooekg00=oo`05G_MoogooOomNm`05Ool0
0ekgOomoo`07Ool00ekgOomoo`04Ool00ekgOomoo`0<Ool2000QOol<0CLFOol003]oo`03001oogoo
011oo`03G_Moogoo021oo`03G_Moogoo021oo`03G_Moogoo021oo`03G_Moogoo011oo`03G_Moogoo
00Moo`030EL15goo00Aoo`03G_Moogoo00Moo`03G_Moogoo00Moo`03G_Moogoo009oo`05G_Moogoo
G0iNm`03Ool01EkgOomoogooG_L00goo00=NmgooOol00Woo00=NmgooOol01goo00=NmgooOol01Woo
00=NmgooOol037oo00<007ooOol07goo304g5Woo000kOol00`00Oomoo`0@Ool00ekgOomoo`0POol0
0ekgOomoo`0POol00ekgOomoo`0POol00ekgOomoo`0AOol00ekgOomoo`07Ool00`4G0;Moo`03Ool0
0ekgOomoo`07Ool00ekgOomoo`07Ool00ekgOomoo`02Ool01EkgOomoogooG_L00goo00ANmgooOomN
m`=oo`03G_Moogoo00=oo`03G_Moogoo00Moo`03G_Moogoo00Ioo`03G_Moogoo00aoo`03001oogoo
01moo``1=aIoo`00>goo00<007ooOol047oo00=NmgooOol087oo00=NmgooOol087oo00=NmgooOol0
87oo00=NmgooOol04Woo0Ukg27oo00<0]gooOol00Woo00=NmgooOol027oo00=NmgooOol01Woo00=N
mgooOol00goo00ANmgooOomNm`=oo`04G_MoogooG_L3Ool00ekgOomoo`03Ool00ekgOomoo`06Ool0
0ekgOomoo`07Ool00ekgOomoo`0<Ool00`00Oomoo`0OOol<0GLFOol003]oo`03001oogoo011oo`03
G_Moogoo021oo`03G_Moogoo021oo`03G_Moogoo021oo`03G_Moogoo01Aoo`03G_Moogoo00Eoo`03
07Moogoo009oo`03G_Moogoo00Qoo`03G_Moogoo00Moo`03G_Moogoo009oo`05G_MoogooOomNm`02
Ool015kgOomooekg0goo00=NmgooOol00Woo00=NmgooOol01Woo00=NmgooOol027oo00=NmgooOol0
37oo00<007ooOol07goo305g5Woo000kOol00`00Oomoo`0@Ool00ekgOomoo`0POol00ekgOomoo`0P
Ool00ekgOomoo`0POol00ekgOomoo`0EOol00ekgOomoo`04Ool00`1g03Moo`02Ool00ekgOomoo`09
Ool00ekgOomoo`06Ool00ekgOomoo`02Ool01EkgOomoogooG_L00Woo00ANmgooOomNm`=oo`03G_Mo
ogoo009oo`03G_Moogoo00Ioo`03G_Moogoo00Qoo`03G_Moogoo00]oo`03G_L007oo021oo``1MaIo
o`00>goo00<007ooOol047oo00=NmgooOol087oo00=NmgooOol087oo00=NmgooOol087oo00=Nmgoo
Ool05Woo00=NmgooOol017oo00D0=gooOomooekg00aoo`03G_Moogoo00Eoo`03G_Moogoo009oo`05
G_MoogooOomNm`02Ool015kgOomooekg0goo00=NmgooOol00Woo00=NmgooOol01Goo00=NmgooOol0
2Goo00=NmgooOol02Goo0Ukg00=oo`00Ool087oo307G5Woo000kOol00`00Oomoo`0@Ool00ekgOomo
o`0POol00ekgOomoo`0POol00ekgOomoo`0POol00ekgOomoo`0GOol2G_L4Ool01@@GOomoogooG_L0
37oo00=NmgooOol01Woo00ENmgooOomooekg00=oo`04G_MoogooG_L2Ool01EkgOomoogooG_L00goo
00=NmgooOol01Woo00=NmgooOol02Woo00=NmgooOol01goo00ENmgooOomoo`00025oo``1eaIoo`00
>goo00<007ooOol047oo00=NmgooOol087oo00=NmgooOol087oo00=NmgooOol087oo00=NmgooOol0
6Goo00INmgooOomoo`@G31L2Ool00ekgOomoo`0;Ool00ekgOomoo`05Ool00ekgOomoo`02Ool015kg
Oomooekg0Woo00ANmgooOomNm`9oo`03G_Moogoo009oo`03G_Moogoo00Eoo`03G_Moogoo00]oo`03
G_Moogoo00Ioo`03G_Moogoo009oo`03001oogoo01moo``1eaIoo`00>goo00<007ooOol03goo00=N
mgooOol08Goo00=NmgooOol087oo00=NmgooOol07goo00=NmgooOol06goo00MNmgooOomoo``GOomN
m`0>Ool00ekgOomoo`05Ool00ekgOomoo`02Ool015kgOomooekg0Woo00ANmgooOomNm`9oo`03G_Mo
ogoo009oo`03G_Moogoo00Eoo`03G_Moogoo00]oo`03G_Moogoo00Eoo`03G_Moogoo00=oo`03001o
ogoo01moo``25aIoo`00>goo0P0047oo00=NmgooOol08Goo00=NmgooOol087oo00=NmgooOol07goo
00=NmgooOol077oo00INmgooOomooa@GG_L?Ool00ekgOomoo`05Ool01EkgOomoogooG_L00Woo00AN
mgooOomNm`9oo`04G_MoogooG_L3Ool00ekgOomoo`05Ool00ekgOomoo`0<Ool00ekgOomoo`03Ool2
G_L5Ool2000QOol<0QLFOol003]oo`03001oogoo00moo`03G_Moogoo025oo`03G_Moogoo021oo`03
G_Moogoo01moo`03G_Moogoo01eoo`9Nm`03OolD5ekg00moo`03G_Moogoo00Eoo`05G_MoogooOomN
m`02Ool015kgOomooekg0Woo00ANmgooOomNm`=oo`03G_Moogoo00Aoo`03G_Moogoo00eoo`03G_Mo
ogoo009oo`03G_Moogoo00Ioo`03001oogoo01moo``25aIoo`00>goo00<007ooOol03goo00=Nmgoo
Ool08Goo00=NmgooOol087oo00=NmgooOol07goo00=NmgooOol07goo00=Nmgoo81L047oo00=Nmgoo
Ool017oo00ENmgooOomooekg009oo`04G_MoogooG_L2Ool015kgOomooekg0goo00=NmgooOol017oo
00=NmgooOol03Goo00ENmgooOomooekg00Uoo`03001oogoo01moo``2MaIoo`00>goo00<007ooOol0
3goo00=NmgooOol08Goo00=NmgooOol087oo00=NmgooOol07goo00=NmgooOol087oo00=Nmb0GOol0
47oo00=NmgooOol017oo00ANmgooOomNm`9oo`06G_MoogooG_Mooekg0Woo00ENmgooOomooekg00Io
o`03G_Moogoo00moo`=Nm`Yoo`03001oogoo01moo``2MaIoo`00>goo00<007ooOol03goo00=Nmgoo
Ool08Goo00=NmgooOol087oo00=NmgooOol07goo00=NmgooOol08Goo00<X5gooOol03goo00=Nmgoo
Ool017oo00MNmgooOomooekgOomNm`02Ool00ekgOomNm`02Ool01EkgOomoogooG_L01Woo00=Nmgoo
Ool03goo00=NmgooOol02Woo00<007ooOol07goo309g5Woo000kOol00`00Oomoo`0?Ool00ekgOomo
o`0POol00ekgOomoo`0QOol00ekgOomoo`0OOol00ekgOomoo`0QOol00bPGG_MNm`0@Ool00ekgOomo
o`03Ool01EkgOomoogooG_L00Woo00ENmgooG_Mooekg009oo`05G_MoogooOomNm`05Ool00ekgOomo
o`0?Ool2G_L<Ool00`00Oomoo`0OOol<0[LFOol003]oo`03001oogoo00moo`03G_Moogoo021oo`03
G_Moogoo025oo`03G_Moogoo01moo`03G_Moogoo025oo`04G_MoogooG_L?Ool00ekgOomoo`04Ool0
15kgOomooekg0Woo00ENmgooG_Mooekg009oo`04G_MoogooG_L6Ool00ekgOomoo`0>Ool00ekgOomN
m`0<Ool00`00Oomoo`0OOol<0[LFOol003]oo`03001oogoo00moo`03G_Moogoo021oo`03G_Moogoo
025oo`03G_Moogoo01moo`03G_Moogoo025oo`05G_L`5gooOomNm`0?Ool00ekgOomoo`03Ool015kg
Oomooekg0Woo00ENmgooG_Mooekg009oo`04G_MoogooG_L5Ool00ekgOomoo`0=Ool2G_L2Ool00ekg
Oomoo`0:Ool00`00Oomoo`0OOol<0[LFOol003]oo`03001oogoo00moo`03G_Moogoo021oo`03G_Mo
ogoo025oo`03G_Moogoo01moo`03G_Moogoo025oo`03G_L`5goo009oo`03G_Moogoo00eoo`03G_Mo
ogoo009oo`04G_MoogooG_L2Ool01ekgOomNmgooG_Mooekg00=oo`03G_Moogoo009oo`03G_Moogoo
00eoo`03G_Moogoo009oo`03G_Moogoo00Yoo`03001oogoo01moo``2maIoo`00>goo00<007ooOol0
3goo00=NmgooOol087oo00=NmgooOol08Goo00=NmgooOol07goo00=NmgooOol08Goo00=NmgooOol0
0goo0Ukg3Goo00=NmgooOol00goo00aNmgooOomNmgooG_MooekgOomNmgooG_L2Ool00ekgOomoo`03
Ool00ekgOomoo`0<Ool00ekgOomoo`03Ool00ekgOomoo`0:Ool00`00Oomoo`0OOol<0_LFOol003]o
o`80011oo`03G_Moogoo021oo`03G_Moogoo025oo`03G_Moogoo01moo`03G_Moogoo025oo`03G_Mo
oc`G00Eoo`03G_Moogoo00]oo`03G_Moogoo009oo`0<G_MoogooG_MooekgOomNmgooG_Mooekg0Woo
00=NmgooOol00Woo00=NmgooOol037oo00=NmgooOol017oo00=NmgooOol02Goo0P008Goo30;g5Woo
000kOol00`00Oomoo`0?Ool00ekgOomoo`0POol00ekgOomoo`0QOol00ekgOomoo`0OOol00ekgOomo
o`0QOol00ekgOoll5`06Ool00ekgOomoo`0:Ool00ekgOomoo`02Ool035kgOomooekgOomNmgooG_Mo
oekgOomNm`9oo`03G_Moogoo009oo`03G_Moogoo00Yoo`9Nm`Moo`03G_Moogoo00Yoo`03001oogoo
01moo``2mAIoo`00>goo00<007ooOol03goo00=NmgooOol087oo00=NmgooOol087oo00=NmgooOol0
87oo00=NmgooOol087oo00=NmgooOol027oo00=NmgooOol02Woo00=NmgooOol00Woo00eNmgooG_Mo
oekgOomNmgooG_MooekgOomNm`04Ool00ekgOomoo`0:Ool00ekgOomoo`07Ool00ekgOomoo`0:Ool0
0`00Oomoo`0OOol<0_DFOol003]oo`03001oogoo00moo`03G_Moogoo021oo`03G_Moogoo021oo`03
G_Moogoo021oo`03G_Moogoo021oo`03G_Moogoo00Uoo`9Nm`Yoo`03G_Moogoo009oo`08G_Mooekg
OomNmgooG_Moo`9Nm`9oo`05G_MoogooOomNm`0<Ool00ekgOomoo`08Ool00ekgOomoo`0:Ool00`00
Oomoo`0OOol<0_DFOol003]oo`03001oogoo00moo`03G_Moogoo021oo`03G_Moogoo021oo`03G_Mo
ogoo021oo`03G_Moogoo021oo`05G_MoogooOom45`09Ool00ekgOomoo`08Ool01EkgOomoogooG_L0
0Woo0Ukg00EooekgG_Mooekg009oo`05G_MoogooOomNm`0:Ool2G_L;Ool00ekgOomoo`0:Ool00`00
Oomoo`0OOol<0_<FOol003]oo`03001oogoo00moo`03G_Moogoo021oo`03G_Moogoo021oo`03G_Mo
ogoo021oo`03G_Moogoo021oo`05G_MoogooOom45`0:Ool00ekgOomoo`08Ool025kgOomoogooG_Mo
oekgOol3G_L017ooG_Mooekg0goo00=NmgooOol027oo00=NmgooOol02goo00=NmgooOol02Woo00<0
07ooOol07goo30;c5Woo000kOol00`00Oomoo`0?Ool00ekgOomoo`0POol00ekgOomoo`0POol00ekg
Oomoo`0POol00ekgOomoo`0POol00ekgOomoo`0=Ool00ekgOomoo`07Ool025kgOomoogooG_Mooekg
Ool3G_L017ooG_Mooekg0goo00=NmgooOol01goo00=NmgooOol037oo00=NmgooOol02Woo00<007oo
Ool07goo30;c5Woo000kOol00`00Oomoo`0?Ool00ekgOomoo`0POol00ekgOomoo`0POol00ekgOomo
o`0POol00ekgOomoo`0POol00ekgOomoo`0>Ool2G_L8Ool01ekgOomooekgOomNmgoo00=Nm`04OomN
mgooG_L2Ool00ekgOomoo`07Ool00ekgOomoo`0=Ool00ekgOomoo`0:Ool00`00Oomoo`0OOol<0_0F
Ool003]oo`03001oogoo00moo`03G_Moogoo021oo`03G_Moogoo021oo`03G_Moogoo021oo`03G_Mo
ogoo021oo`03G_Moogoo011oo`03G_Moogoo00Eoo`04G_MoogooOol2G_L00gooG_MNm`02G_L00goo
G_Moo`02Ool00ekgOomoo`05Ool2G_L@Ool00ekgOomoo`0:Ool00`00Oomoo`0OOol<0_0FOol003]o
o`03001oogoo00moo`03G_Moogoo021oo`03G_Moogoo021oo`03G_Moogoo021oo`03G_Moogoo021o
o`03G_Moogoo015oo`03G_Moogoo00Eoo`05G_MoogooG_Moo`05G_L01GooG_MoogooG_L01goo00=N
mgooOol047oo00=NmgooOol02Woo00<007ooOol07goo30;`5Woo000kOol00`00Oomoo`0?Ool00ekg
Oomoo`0POol00ekgOomoo`0POol00ekgOomoo`0POol00ekgOomoo`0POol00ekgOomoo`02Ool00d`G
Oomoo`0=Ool00ekgOomoo`05Ool015kgOomNmgoo1Ekg00AooekgOomNm`Moo`03G_Moogoo015oo`03
G_Moogoo00Yoo`03001oogoo01moo``2l1Ioo`00>goo0P0047oo00=NmgooOol087oo00=NmgooOol0
87oo00=NmgooOol087oo00=NmgooOol087oo00=NmgooOol00Woo00=<5gooOol03Woo0Ukg1Goo00=N
mgooOol01ekg0Woo00=NmgooOol017oo00=NmgooOol04Woo00=NmgooOol02Goo0P008Goo30;^5Woo
000kOol00`00Oomoo`0?Ool00ekgOomoo`0POol00ekgOomoo`0POol00ekgOomoo`0POol00ekgOomo
o`0POol00ekgOomoo`0EOol00ekgOomoo`03Ool00ekgOomNm`06G_L00gooG_Moo`04Ool2G_LEOol0
0ekgOomoo`0:Ool00`00Oomoo`0OOol<0^hFOol003]oo`03001oogoo00moo`03G_Moogoo021oo`03
G_Moogoo021oo`03G_Moogoo021oo`03G_Moogoo021oo`03G_Moogoo01Ioo`03G_Moogoo009oo`03
G_Mooekg00INm`03OomNmgoo00=oo`03G_Moogoo01Eoo`03G_Moogoo00Yoo`03001oogoo01moo``2
kQIoo`00>goo00<007ooOol03goo00=NmgooOol087oo00=NmgooOol087oo00=NmgooOol087oo00=N
mgooOol087oo00=NmgooOol05goo00=NmgooOol00Woo00=NmgooG_L015kg00=ooekgOol00goo00=N
mgooOol05Woo00=NmgooOol02Woo00<007ooOol07goo30;[5Woo000kOol00`00Oomoo`0?Ool00ekg
Oomoo`0POol00ekgOomoo`0POol00ekgOomoo`0POol00ekgOomoo`0POol00ekgOomoo`0HOol2G_L2
Ool00ekgOomNm`05G_L3Ool2G_LJOol00ekgOomoo`09Ool00`00Oomoo`0OOol<0^/FOol003]oo`03
001oogoo00moo`03G_Moogoo021oo`03G_Moogoo021oo`03G_Moogoo021oo`03G_Moogoo021oo`03
G_Moogoo01Yoo`03G_Moogoo00MNm`9oo`03G_Moogoo01Yoo`03G_Moogoo00Uoo`03001oogoo01mo
o``2jaIoo`00>goo00<007ooOol03goo00=NmgooOol087oo00=NmgooOol087oo00=NmgooOol087oo
00=NmgooOol087oo00=NmgooOol06goo00=NmgooOol01Ekg0Woo00=NmgooOol06goo00=NmgooOol0
2Goo00<007ooOol07goo30;Y5Woo000IOol20009Ool2000EOol00`00Oomoo`0?Ool00ekgOomoo`0P
Ool00ekgOomoo`0POol00ekgOomoo`0POol00ekgOomoo`0POol00ekgOomoo`0LOol00ekgOomNm`04
G_L00gooG_Moo`0MOol00ekgOomoo`09Ool00`00Oomoo`0OOol<0^TFOol001Uoo`03001oogoo00Uo
o`03001oogoo00aoo`8000Eoo`03001oogoo00moo`03G_Moogoo021oo`03G_Moogoo021oo`03G_Mo
ogoo021oo`03G_Moogoo021oo`03G_Moogoo01eoo`MNmamoo`03G_Moogoo00Uoo`03001oogoo01mo
o``2jAIoo`0037oo0`0000Moo`00001oo`00Ool00003Ool00`00Oomoo`02Ool30004Ool00`00Oomo
o`0;Ool01000Oomoo`0017oo00<007ooOol03goo00=NmgooOol087oo00=NmgooOol087oo00=Nmgoo
Ool087oo00=NmgooOol087oo00=NmgooOol07goo0ekg8Goo00=NmgooOol02Goo00<007ooOol07goo
30;W5Woo000=Ool02@00Oomoogoo001oo`00Ool00003Ool00`00Oomoo`05Ool01@00Oomoogoo0000
3Goo00@007ooOol000Aooa5Nm`030n1Nmekg05ANm`03O002hUkg00mNm`030n1Nmekg021Nm`05O01L
5E`GG_MH5`04G_L01EPGG_MNmekgG1L00ekg00AL5EkgG_ML4P=Nm`05G11NmekgG_ML3P02G_L01E`;
G_ML2E`7O000;ekg00<007ooOol07goo30;W5Woo000=Ool02@00Oomoogoo001oo`00Ool00003Ool0
0`00Oomoo`02Ool30004Ool00`00Oomoo`0;Ool01000Oomoo`0017oo00<007ooOol03Woo00<3h5kg
Ool08Goo00=NmgooOol087oo00=NmgooOol03Goo00=l00;ROol03goo00<3h5kgOol087oo00El05`E
G1MooePG00Aoo`05F1MoogooOomL5`03Ool015`EOomooe`B0goo00EL47ooOomooe`>009oo`05G0]o
oe`9G0Ml0002G_LQOol00ekgOomoo`09Ool00`00Oomoo`0OOol<0^LFOol000eoo`03001oogoo00<0
0003Ool007oo00=oo`03001oogoo009oo`@000=oo`03001oogoo00]oo`04001oogoo0004Ool00`00
Oomoo`0?Ool00ekgOomoo`0POol00ekgOomoo`0POol00ekgOomoo`0POol00ekgOomoo`0POol00ekg
Oomoo`0MOol7G_LOOol00ekgOomoo`09Ool00`00Oomoo`0OOol<0^@FOol000eoo`03001oogoo00Uo
o`03001oogoo00Uoo`03001oogoo00aoo`8000Eoo`03001oogoo00moo`03G_Moogoo021oo`03G_Mo
ogoo021oo`03G_Moogoo021oo`03G_Moogoo021oo`03G_Moogoo01aoo`03G_Mooekg00ANm`03OomN
mgoo01eoo`03G_Moogoo00Uoo`03001oogoo01moo``2i1Ioo`0037oo0`002Woo0P002Goo0P005Goo
00<007ooOol03goo00=NmgooOol087oo00=NmgooOol087oo00=NmgooOol087oo00=NmgooOol087oo
00=NmgooOol06goo00=NmgooOol01Ekg0Woo00=NmgooOol06goo00=NmgooOol02Goo00<007ooOol0
7goo30;T1Goo0`000Woo0P002Woo000kOol00`00Oomoo`0?Ool00ekgOomoo`0POol00ekgOomoo`0P
Ool00ekgOomoo`0POol00ekgOomoo`0POol00ekgOomoo`0JOol00ekgOomoo`07G_L2Ool00ekgOomo
o`0JOol00ekgOomoo`09Ool00`00Oomoo`0OOol<0^86Ool01000Oomoo`0037oo000kOol00`00Oomo
o`0?Ool00ekgOomoo`0POol00ekgOomoo`0POol00ekgOomoo`0POol00ekgOomoo`0POol00ekgOomo
o`0HOol2G_L3Ool7G_L3Ool2G_LJOol00ekgOomoo`09Ool00`00Oomoo`0OOol<0^83Ool500000goo
001oo`0;Ool003]oo`03001oogoo00moo`03G_Moogoo021oo`03G_Moogoo021oo`03G_Moogoo021o
o`03G_Moogoo021oo`03G_Moogoo01Moo`03G_Moogoo009oo`03G_Mooekg00ANm`03OomNmgoo00=o
o`03G_Moogoo01Ioo`03G_Moogoo00Yoo`03001oogoo01moo``2hP=oo`04001oogoo0002Ool00`00
Oomoo`0:Ool003]oo`03001oogoo00moo`03G_Moogoo021oo`03G_Moogoo021oo`03G_Moogoo021o
o`03G_Moogoo021oo`03G_Moogoo01Ioo`03G_Moogoo009oo`03G_Mooekg00INm`03OomNmgoo00=o
o`03G_Moogoo01Eoo`03G_Moogoo00Yoo`03001oogoo045oo`00>goo00<007ooOol03goo00=Nmgoo
Ool087oo00=NmgooOol087oo00=NmgooOol087oo00=NmgooOol087oo00=NmgooOol05Goo00=Nmgoo
Ool00goo00=NmgooG_L01Ukg00=ooekgOol017oo00=NmgooOol057oo00=NmgooOol02Woo00<007oo
Ool0@Goo000kOol00`00Oomoo`0?Ool00ekgOomoo`0POol00ekgOomoo`0POol00ekgOomoo`0POol0
0ekgOomoo`0POol00ekgOomoo`0COol2G_L5Ool00ekgOomoo`07G_L2Ool00ekgOomoo`03Ool00ekg
Oomoo`0COol00ekgOomoo`0:Ool00`00Oomoo`11Ool003]oo`80011oo`03G_Moogoo021oo`03G_Mo
ogoo021oo`03G_Moogoo021oo`03G_Moogoo021oo`03G_Moogoo009oo`03C1Moogoo00eoo`03G_Mo
ogoo00Eoo`04G_MooekgOol5G_L017ooG_Mooekg1Woo0Ukg4goo00=NmgooOol02Goo0P00@goo000k
Ool00`00Oomoo`0?Ool00ekgOomoo`0POol00ekgOomoo`0POol00ekgOomoo`0POol00ekgOomoo`0P
Ool00ekgOomoo`02Ool00d`GOomoo`0<Ool00ekgOomoo`05Ool01EkgOomooekgOol01Ekg00Eooekg
Oomooekg00Moo`03G_Moogoo011oo`03G_Moogoo00Yoo`03001oogoo045oo`00>goo00<007ooOol0
3goo00=NmgooOol087oo00=NmgooOol087oo00=NmgooOol087oo00=NmgooOol087oo00=NmgooOol0
47oo00=NmgooOol01Goo00ANmgooOomoo`9Nm`03OomNmekg009Nm`03OomNmgoo009oo`03G_Moogoo
00Eoo`03G_Moogoo00moo`03G_Moogoo00Yoo`03001oogoo045oo`00>goo00<007ooOol03goo00=N
mgooOol087oo00=NmgooOol087oo00=NmgooOol087oo00=NmgooOol087oo00=NmgooOol03Woo0Ukg
27oo00MNmgooOomNmgooG_Moo`03G_L017ooG_Mooekg0Woo00=NmgooOol01Woo00=NmgooOol03Woo
00=NmgooOol02Woo00<007ooOol0@Goo000kOol00`00Oomoo`0?Ool00ekgOomoo`0POol00ekgOomo
o`0POol00ekgOomoo`0POol00ekgOomoo`0POol00ekgOomoo`0=Ool00ekgOomoo`07Ool025kgOomo
ogooG_MooekgOol3G_L017ooG_Mooekg0goo00=NmgooOol01Woo0Ukg3Woo00=NmgooOol02Woo00<0
07ooOol0@Goo000kOol00`00Oomoo`0?Ool00ekgOomoo`0POol00ekgOomoo`0POol00ekgOomoo`0P
Ool00ekgOomoo`0POol00ekgOomoo`0<Ool00ekgOomoo`08Ool025kgOomoogooG_MooekgOol3G_L0
17ooG_Mooekg0goo00=NmgooOol027oo00=NmgooOol02goo00=NmgooOol02Woo00<007ooOol0@Goo
000kOol00`00Oomoo`0?Ool00ekgOomoo`0POol00ekgOomoo`0POol00ekgOomoo`0POol00ekgOomo
o`0POol01EkgOomoogooA1L02Goo00=NmgooOol027oo00ENmgooOomooekg009oo`9Nm`05OomNmekg
OomNm`02Ool01EkgOomoogooG_L02Woo00=NmgooOol02Woo00=NmgooOol02Woo00<007ooOol0@Goo
000kOol00`00Oomoo`0?Ool00ekgOomoo`0POol00ekgOomoo`0POol00ekgOomoo`0POol00ekgOomo
o`0POol01EkgOomoogooA1L01goo0Ukg2goo00aNmgooOomooekgOomNmgooG_MooekgOol2G_L2Ool0
1EkgOomoogooG_L02goo00=NmgooOol02Goo00=NmgooOol02Woo00<007ooOol0@Goo000kOol00`00
Oomoo`0?Ool00ekgOomoo`0POol00ekgOomoo`0POol00ekgOomoo`0POol00ekgOomoo`0POol00ekg
Oomoo`08Ool00ekgOomoo`0:Ool00ekgOomoo`02Ool03EkgOomNmgooG_MooekgOomNmgooG_Mooekg
00Aoo`03G_Moogoo00Uoo`9Nm`Uoo`03G_Moogoo00Yoo`03001oogoo045oo`00>goo00<007ooOol0
3goo00=NmgooOol087oo00=NmgooOol087oo00=NmgooOol087oo00=NmgooOol08Goo00=NmgooOol0
1Woo00=NmgooOol02Woo00=NmgooOol00Woo00aNmgooOomNmgooG_MooekgOomNmgooG_L2Ool00ekg
Oomoo`02Ool00ekgOomoo`0:Ool00ekgOomoo`06Ool00ekgOomoo`0:Ool00`00Oomoo`11Ool003]o
o`80011oo`03G_Moogoo021oo`03G_Moogoo025oo`03G_Moogoo01moo`03G_Moogoo025oo`03G_Mo
oc`G00Eoo`03G_Moogoo00]oo`03G_Moogoo009oo`0<G_MoogooG_MooekgOomNmgooG_Mooekg0Woo
00=NmgooOol00Woo00=NmgooOol02goo00=NmgooOol01Goo00=NmgooOol02Goo0P00@goo000kOol0
0`00Oomoo`0?Ool00ekgOomoo`0POol00ekgOomoo`0QOol00ekgOomoo`0OOol00ekgOomoo`0QOol0
0ekgOoll5`03Ool2G_L=Ool00ekgOomoo`03Ool035kgOomooekgOomNmgooG_MooekgOomNm`9oo`03
G_Moogoo00=oo`03G_Moogoo00]oo`03G_Moogoo00Aoo`03G_Moogoo00Yoo`03001oogoo045oo`00
>goo00<007ooOol03goo00=NmgooOol087oo00=NmgooOol08Goo00=NmgooOol07goo00=NmgooOol0
8Goo00=NmgooOol00Woo00=NmgooOol03Goo00=NmgooOol00Woo00ANmgooOomNm`9oo`07G_Mooekg
OomNmgooG_L00goo00=NmgooOol00Woo00=NmgooOol037oo0Ukg17oo00=NmgooOol02Woo00<007oo
Ool0@Goo000kOol00`00Oomoo`0?Ool00ekgOomoo`0POol00ekgOomoo`0QOol00ekgOomoo`0OOol0
0ekgOomoo`0QOol01Ekg<1MoogooG_L03goo00=NmgooOol00goo00ANmgooOomNm`9oo`05G_Mooekg
OomNm`02Ool015kgOomooekg1Goo00=NmgooOol03Goo00ENmgooOomooekg00aoo`03001oogoo045o
o`00>goo00<007ooOol03goo00=NmgooOol087oo00=NmgooOol08Goo00=NmgooOol07goo00=Nmgoo
Ool08Goo00ANmc0GOomNm`moo`03G_Moogoo00Aoo`04G_MoogooG_L2Ool01EkgOomNmgooG_L00Woo
00ANmgooOomNm`Ioo`03G_Moogoo00eoo`04G_MoogooG_L<Ool00`00Oomoo`11Ool003]oo`03001o
ogoo00moo`03G_Moogoo021oo`03G_Moogoo025oo`03G_Moogoo01moo`03G_Moogoo025oo`=Nma1o
o`03G_Moogoo00=oo`05G_MoogooOomNm`02Ool01EkgOomNmgooG_L00Woo00ENmgooOomooekg00Eo
o`03G_Moogoo00ioo`03G_Mooekg00aoo`03001oogoo045oo`00>goo00<007ooOol03goo00=Nmgoo
Ool08Goo00=NmgooOol087oo00=NmgooOol07goo00=NmgooOol08Goo00<X5gooOol03goo00=Nmgoo
Ool017oo00MNmgooOomooekgOomNm`02Ool00ekgOomNm`02Ool01EkgOomoogooG_L01Woo00=Nmgoo
Ool03Woo0Ukg37oo00<007ooOol0@Goo000kOol00`00Oomoo`0?Ool00ekgOomoo`0QOol00ekgOomo
o`0POol00ekgOomoo`0OOol00ekgOomoo`0POol00ekg:1Moo`0@Ool00ekgOomoo`04Ool01ekgOomo
ogooG_Mooekg009oo`03G_Mooekg009oo`05G_MoogooOomNm`06Ool00ekgOomoo`0?Ool2G_L;Ool0
0`00Oomoo`11Ool003]oo`03001oogoo00moo`03G_Moogoo025oo`03G_Moogoo021oo`03G_Moogoo
01moo`03G_Moogoo01moo`03G_Moob0G011oo`03G_Moogoo00Aoo`05G_MoogooOomNm`02Ool015kg
Oomooekg0Woo00ANmgooOomNm`=oo`03G_Moogoo00Aoo`03G_Moogoo00ioo`03G_Mooekg00Yoo`03
001oogoo045oo`00>goo00<007ooOol03goo00=NmgooOol08Goo00=NmgooOol087oo00=NmgooOol0
7goo00=NmgooOol07Goo0Ukg0Woo00<P5gooOol03Woo00=NmgooOol017oo00ENmgooOomooekg009o
o`04G_MoogooG_L2Ool015kgOomooekg0goo00=NmgooOol017oo00=NmgooOol03Goo00ENmgooOomo
oekg00Uoo`03001oogoo045oo`00>goo00<007ooOol03goo00=NmgooOol08Goo00=NmgooOol087oo
00=NmgooOol07goo00=NmgooOol077oo00INmgooOomooa@GG_L?Ool00ekgOomoo`05Ool01EkgOomo
ogooG_L00Woo00ANmgooOomNm`9oo`04G_MoogooG_L3Ool00ekgOomoo`05Ool00ekgOomoo`0<Ool0
0ekgOomoo`02Ool00ekgOomoo`06Ool00`00Oomoo`11Ool003]oo`80011oo`03G_Moogoo025oo`03
G_Moogoo021oo`03G_Moogoo01moo`03G_Moogoo01]oo`03G_Moogoo009oo`0351MNmgoo00eoo`03
G_Moogoo00Eoo`03G_Moogoo009oo`04G_MoogooG_L2Ool015kgOomooekg0Woo00=NmgooOol00Woo
00=NmgooOol01Goo00=NmgooOol02goo00=NmgooOol00goo0Ukg1Goo0P00@goo000kOol00`00Oomo
o`0?Ool00ekgOomoo`0QOol00ekgOomoo`0POol00ekgOomoo`0POol00ekgOomoo`0IOol00ekgOomo
o`02Ool010`GOomooekg3Goo00=NmgooOol01Goo00=NmgooOol00Woo00ANmgooOomNm`9oo`04G_Mo
ogooG_L2Ool00ekgOomoo`02Ool00ekgOomoo`05Ool00ekgOomoo`0;Ool00ekgOomoo`05Ool00ekg
Oomoo`03Ool00`00Oomoo`11Ool003]oo`03001oogoo011oo`03G_Moogoo021oo`03G_Moogoo021o
o`03G_Moogoo021oo`03G_Moogoo01Moo`9Nm`Eoo`0431MoogooG_L<Ool00ekgOomoo`06Ool01Ekg
OomoogooG_L00goo00ANmgooOomNm`9oo`04G_MoogooG_L4Ool00ekgOomoo`06Ool00ekgOomoo`0:
Ool00ekgOomoo`06Ool00ekgOomoo`02Ool00`00Oomoo`11Ool003]oo`03001oogoo011oo`03G_Mo
ogoo021oo`03G_Moogoo021oo`03G_Moogoo021oo`03G_Moogoo01Ioo`03G_Moogoo00Aoo`0511Mo
ogooOomNm`0<Ool00ekgOomoo`05Ool00ekgOomoo`02Ool01EkgOomoogooG_L00Woo00ANmgooOomN
m`=oo`03G_Moogoo009oo`03G_Moogoo00Eoo`03G_Moogoo00Yoo`03G_Moogoo00Moo`05G_Moogoo
Ool00013Ool003]oo`03001oogoo011oo`03G_Moogoo021oo`03G_Moogoo021oo`03G_Moogoo021o
o`03G_Moogoo01Eoo`03G_Moogoo00Eoo`0503MoogooOomNm`0;Ool00ekgOomoo`06Ool00ekgOomo
o`02Ool01EkgOomoogooG_L00Woo00ANmgooOomNm`=oo`03G_Moogoo009oo`03G_Moogoo00Ioo`03
G_Moogoo00Qoo`03G_Moogoo00Uoo`9Nm`03Ool007oo049oo`00>goo00<007ooOol047oo00=Nmgoo
Ool087oo00=NmgooOol087oo00=NmgooOol087oo00=NmgooOol057oo00=NmgooOol01Woo00D0=goo
Oomooekg00Yoo`03G_Moogoo00Moo`03G_Moogoo009oo`05G_MoogooOomNm`02Ool015kgOomooekg
0goo00=NmgooOol00Woo00=NmgooOol01Woo00=NmgooOol027oo00=NmgooOol02goo00=Nm`00Ool0
@Woo000kOol00`00Oomoo`0@Ool00ekgOomoo`0POol00ekgOomoo`0POol00ekgOomoo`0POol00ekg
Oomoo`0BOol2G_L8Ool00`1gOomoo`02Ool00ekgOomoo`08Ool00ekgOomoo`06Ool00ekgOomoo`03
Ool015kgOomooekg0goo00ANmgooOomNm`=oo`03G_Moogoo00=oo`03G_Moogoo00Ioo`03G_Moogoo
00Moo`03G_Moogoo00aoo`03001oogoo045oo`00>goo00<007ooOol047oo00=NmgooOol087oo00=N
mgooOol087oo00=NmgooOol087oo00=NmgooOol04Goo00=NmgooOol027oo00<0]gooOol00Woo00=N
mgooOol01goo00=NmgooOol01goo00=NmgooOol00Woo00ENmgooOomooekg00=oo`04G_MoogooG_L3
Ool00ekgOomoo`03Ool00ekgOomoo`07Ool00ekgOomoo`06Ool00ekgOomoo`0<Ool00`00Oomoo`11
Ool003]oo`03001oogoo011oo`03G_Moogoo021oo`03G_Moogoo021oo`03G_Moogoo021oo`03G_Mo
ogoo011oo`03G_Moogoo00Qoo`030AL0]goo00=oo`03G_Moogoo00Moo`03G_Moogoo00Moo`03G_Mo
ogoo009oo`05G_MoogooOomNm`03Ool01EkgOomoogooG_L00goo00=NmgooOol00Woo00=NmgooOol0
1goo00=NmgooOol01Woo00=NmgooOol037oo00<007ooOol0@Goo000kOol00`00Oomoo`0@Ool00ekg
Oomoo`0POol00ekgOomoo`0POol00ekgOomoo`0POol00ekgOomoo`0>Ool2G_L:Ool00`5G0AMoo`04
Ool00ekgOomoo`06Ool00ekgOomoo`07Ool00ekgOomoo`03Ool01EkgOomooe`>G_L00goo00ENmgoo
Oomooekg00=oo`03G_Moogoo00=oo`03G_Moogoo00Moo`03G_Moogoo00Eoo`03G_Moogoo00aoo`03
001oogoo045oo`00>goo0P004Goo00=NmgooOol087oo00=NmgooOol087oo00=NmgooOol087oo00=N
mgooOol03Goo00=NmgooOol02Woo00<1UgooOol017oo00=NmgooOol01Woo00=NmgooOol01goo00=N
mgooOol00goo00UNmgooOomL3UkgOomL47ooG_L00goo00ENmgooOomooekg00Eoo`03G_Moogoo00Mo
o`03G_Moogoo00Aoo`03G_Moogoo00aoo`8004=oo`00>goo00<007ooOol047oo00=NmgooOol087oo
00=NmgooOol087oo00=NmgooOol087oo00=NmgooOol037oo00=NmgooOol02Woo00<1m`6GOol01Woo
00=NmgooOol017oo00=NmgooOol027oo00=NmgooOol00goo00UNme`;OomooekgOomL47ooG_L00goo
00ENmgooOomooekg00Eoo`03G_Moogoo00Qoo`03G_Moogoo00=oo`03G_Moogoo00eoo`03001oogoo
045oo`00>goo00<007ooOol047oo00=NmgooOol087oo00=NmgooOol087oo00=NmgooOol087oo00=N
mgooOol02goo00=NmgooOol02goo00<2=gooOol01Woo00=NmgooOol00goo00=NmgooOol027oo00=N
mgooOol00goo00=L2GooG0/00Woo00ENmgooOomooe`B00=oo`05G_MoogooOomNm`06Ool00ekgOomo
o`08Ool00ekgOomoo`02Ool00ekgOomoo`0=Ool00`00Oomoo`11Ool003]oo`03001oogoo011oo`03
G_Moogoo021oo`03G_Moogoo021oo`03G_Moogoo021oo`03G_Moogoo00Uoo`9Nm`eoo`030WL2=goo
00Moo`03G_Moogoo00=oo`03G_Moogoo00Qoo`03G_Moogoo009oo`03O01L2Goo00=oo`09G_Moogoo
OomL4WooG1Eooekg00Aoo`03G_Moogoo00=oo`03G_Moogoo00Qoo`03G_Moogoo009oo`03G_Moogoo
00eoo`03001oogoo045oo`00>goo00<007ooOol047oo00=NmgooOol087oo00=NmgooOol087oo00=N
mgooOol08Goo00=NmgooOol01goo00=NmgooOol037oo00<2e`9gOol027oo00=NmgooOol00Woo00=N
mgooOol02Goo00=NmgooOol00Woo00=l05`7Ool00goo00UNmgooOomooekgOomL5GooG1L017oo00=N
mgooOol00goo00=NmgooOol02Goo00ENmgooOomooekg00moo`03001oogoo045oo`00>goo00<007oo
Ool047oo00=NmgooOol087oo00=NmgooOol087oo00=NmgooOol08Goo00=NmgooOol01Woo00=Nmgoo
Ool03Goo00<2mgooOol027oo00=NmgooOol00Woo00=NmgooOol027oo00=NmgooOol017oo00=Nmgoo
Ool00Woo00ENmgooOomooekg00=oo`03G1Moogoo009oo`03G_Moogoo00Aoo`03G_Moogoo00Qoo`05
G_MoogooOomNm`0?Ool00`00Oomoo`11Ool003]oo`03001oogoo011oo`03G_Moogoo021oo`03G_Mo
ogoo021oo`03G_Moogoo025oo`03G_Moogoo00Eoo`03G_Moogoo00eoo`030_D2mgoo00Uoo`05G_Mo
ogooOomNm`0;Ool00ekgOomoo`04Ool00ekgOomoo`02Ool01EkgOomoogooG_L00goo00=NmePGOol0
0Woo00=NmgooOol017oo00=NmgooOol02Goo00=NmgooG_L047oo00<007ooOol0@Goo000kOol00`00
Oomoo`0@Ool00ekgOomoo`0POol00ekgOomoo`0POol00ekgOomoo`0QOol00ekgOomoo`03Ool2G_L?
Ool00`;`0_9oo`0;Ool00ekgOomNm`0<Ool00ekgOomoo`03Ool00ekgOomoo`02Ool00ekgOomoo`02
Ool02UkgOomoogooG_MH5gooC1Mooekg1Woo00=NmgooOol02Goo00=NmgooG_L047oo00<007ooOol0
@Goo000kOol00`00Oomoo`0@Ool00ekgOomoo`0POol00ekgOomoo`0QOol00ekgOomoo`0POol00ekg
Oomoo`02Ool00ekgOomoo`0?Ool00`;^0_9oo`0;Ool00ekgOomNm`0;Ool00ekgOomoo`04Ool00ekg
Oomoo`02Ool00ekgOomoo`02Ool01EkgOomoogooG_L00Woo00A<5d@GOomNm`Ioo`03G_Moogoo00Uo
o`9Nma1oo`03001oogoo045oo`00<goo1@000goo00<007ooOol047oo00=NmgooOol087oo00=Nmgoo
Ool08Goo00=NmgooOol087oo00ENmgooOomooekg015oo`030^/2kWoo00aoo`9Nm`aoo`03G_Moogoo
00Aoo`03G_Moogoo009oo`03G_Moogoo009oo`05G_MoogooOomNm`03Ool00d@G?1MNm`06Ool00ekg
Oomoo`0:Ool00ekgOomoo`0>Ool00`00Oomoo`11Ool003Eoo`03001oogoo00=oo`03001oogoo011o
o`03G_Moogoo021oo`03G_Moogoo025oo`03G_Moogoo021oo`04G_MoogooG_LAOol00`;W0^Uoo`0=
Ool2G_L<Ool00ekgOomoo`04Ool00ekgOomoo`02Ool00ekgOomoo`02Ool00ekgOomoo`02Ool01Ukg
Oomoogoo?1MNm`Ioo`03G_Moogoo00Yoo`03G_Moogoo00ioo`03001oogoo045oo`00=Goo00<007oo
Ool00goo0`0047oo00=NmgooOol087oo00=NmgooOol08Goo00=NmgooOol087oo0ekg4Goo00<2hP;T
0^T03Woo00=NmgooOol02Woo00=NmgooOol01Goo00=NmgooOol00Woo00=NmgooOol00Woo00=Nmgoo
Ool00Woo00=NmgooOol00Woo00<`5gooOol01Goo00=NmgooOol02Goo0Ukg3Goo0`00@goo000eOol0
0`00Oomoo`03Ool00`00Oomoo`0@Ool00ekgOomoo`0POol00ekgOomoo`0QOol00ekgOomoo`0POol0
0ekgOomoo`0AOol00`;R0^Aoo`0>Ool2G_L;Ool00ekgOomoo`04Ool00ekgOomoo`03Ool00ekgOomo
o`02Ool00ekgOomoo`02Ool00ekgOomoo`02Ool00c0G:1Moo`05Ool00ekgOomoo`08Ool00ekgOomN
m`0?Ool00`00Oomoo`11Ool003Eoo`03001oogoo00=oo`03001oogoo011oo`03G_Moogoo021oo`03
G_Moogoo025oo`03G_Moogoo01moo`9Nmb=oo`03G_Mooekg00]oo`03G_Moogoo00Aoo`03G_Moogoo
00=oo`03G_Moogoo009oo`03G_Moogoo009oo`03G_Moogoo009oo`03G_LX5b0G00Eoo`03G_Moogoo
00Qoo`04G_MoogooG_L>Ool00`00Oomoo`11Ool003Aoo`8000Eoo`03001oogoo011oo`03G_Moogoo
021oo`03G_Moogoo025oo`03G_Moogoo01ioo`03G_Mooekg029oo`04G_MoogooG_L:Ool00ekgOomo
o`05Ool00ekgOomoo`03Ool00ekgOomoo`02Ool00ekgOomoo`02Ool00ekgOomoo`03Ool00ekg81LD
5`05Ool00ekgOomoo`07Ool015kgOomooekg3Woo00<007ooOol0@Goo000kOol00`00Oomoo`0@Ool0
0ekgOomoo`0POol00ekgOomoo`0QOol00ekgOomoo`0LOol2G_L3Ool00ekgOomoo`0OOol015kgOomo
oekg2Woo00=NmgooOol01Goo00=NmgooOol00goo00=NmgooOol00Woo00=NmgooOol00Woo00=Nmgoo
Ool00goo00ANmgoo51L<5`Aoo`03G_Moogoo00Moo`05G_MoogooOomNm`0=Ool00`00Oomoo`11Ool0
03]oo`03001oogoo011oo`03G_Moogoo021oo`03G_Moogoo025oo`03G_Moogoo01]oo`03G_Moogoo
00=oo`03G_Moogoo01ioo`05G_MoogooOomNm`0:Ool00ekgOomoo`05Ool00ekgOomoo`03Ool00ekg
Oomoo`02Ool00ekgOomoo`02Ool00ekgOomoo`03Ool01EkgOomoo``G11L00goo00=NmgooOol01goo
00=NmgooOol00Woo00=NmgooOol02Woo00<007ooOol0@Goo000kOol00`00Oomoo`0@Ool00ekgOomo
o`0POol00ekgOomoo`0QOol00ekgOomoo`0JOol00ekgOomoo`04Ool00ekgOomoo`0NOol01EkgOomo
ogooG_L02Goo00=NmgooOol01Goo00=NmgooOol017oo00=NmgooOol00Woo00=NmgooOol00Woo00=N
mgooOol00goo00ENmgooOomoo`@G00Aoo`03G_Moogoo00Ioo`03G_Moogoo009oo`03G_Moogoo00Yo
o`03001oogoo045oo`00>goo00<007ooOol047oo00=NmgooOol087oo00=NmgooOol08Goo00=Nmgoo
Ool06Goo00=NmgooOol01Goo00=NmgooOol07Goo00=NmgooOol00goo00=NmgooOol01Woo00=Nmgoo
Ool01Goo00=NmgooOol00goo00=NmgooOol00goo00=NmgooOol00Woo00=NmgooOol00goo00=Nmgoo
Ool00Woo00D0=gooOomooekg00Moo`03G_Moogoo00Aoo`03G_Moogoo00Uoo`03001oogoo045oo`00
>goo00<007ooOol047oo00=NmgooOol087oo00=NmgooOol08Goo00=NmgooOol05goo0Ukg27oo00=N
mgooOol077oo00=NmgooOol017oo00=NmgooOol01Woo00=NmgooOol01Goo00=NmgooOol00goo00=N
mgooOol00goo00=NmgooOol00Woo00=NmgooOol017oo00INmgooOomoo`0g07L2Ool00ekgOomoo`05
Ool00ekgOomoo`04Ool00ekgOomoo`09Ool00`00Oomoo`11Ool003]oo`03001oogoo011oo`03G_Mo
ogoo025oo`03G_Moogoo021oo`03G_Moogoo01Ioo`03G_Moogoo00Qoo`03G_Moogoo01aoo`03G_Mo
ogoo00Aoo`03G_Moogoo00Eoo`03G_Moogoo00Ioo`03G_Moogoo00=oo`03G_Moogoo00=oo`03G_Mo
ogoo009oo`03G_Moogoo00Aoo`03G_Moogoo009oo`050;MoogooOomNm`06Ool00ekgOomoo`05Ool0
0ekgOomoo`08Ool00`00Oomoo`11Ool003]oo`80015oo`03G_Moogoo025oo`03G_Moogoo021oo`03
G_Moogoo01Eoo`03G_Moogoo00Uoo`03G_Moogoo01]oo`03G_Moogoo00Eoo`03G_Moogoo00Eoo`03
G_Moogoo00Ioo`03G_Moogoo00=oo`03G_Moogoo00=oo`03G_Moogoo00=oo`03G_Moogoo00=oo`03
G_Moogoo009oo`050;L15gooOomNm`06Ool00ekgOomoo`06Ool00ekgOomoo`06Ool20013Ool003]o
o`03001oogoo011oo`03G_Moogoo025oo`03G_Moogoo021oo`03G_Moogoo01Aoo`03G_Moogoo00Yo
o`03G_Moogoo01]oo`03G_Moogoo00Ioo`03G_Moogoo00Aoo`03G_Moogoo00Eoo`03G_Moogoo00Ao
o`03G_Moogoo00=oo`03G_Moogoo00=oo`03G_Moogoo00=oo`03G_Moogoo00=oo`040AL1EgooG_L5
Ool00ekgOomoo`07Ool00ekgOomoo`07Ool00`00Oomoo`11Ool003]oo`03001oogoo011oo`03G_Mo
ogoo025oo`03G_Moogoo021oo`03G_Moogoo019oo`9Nm`ioo`03G_Moogoo01Uoo`03G_Moogoo00Mo
o`03G_Moogoo00=oo`03G_Moogoo00Ioo`03G_Moogoo00Aoo`03G_Moogoo00=oo`03G_Moogoo00=o
o`03G_Moogoo00=oo`03G_Moogoo00Aoo`040EL1UgooG_L4Ool00ekgOomoo`08Ool00ekgOomoo`06
Ool00`00Oomoo`11Ool003]oo`03001oogoo011oo`03G_Moogoo025oo`03G_Moogoo021oo`03G_Mo
ogoo015oo`03G_Moogoo00ioo`03G_Moogoo01Uoo`03G_Moogoo00Moo`03G_Moogoo00=oo`03G_Mo
ogoo00Ioo`03G_Moogoo00Aoo`03G_Moogoo00=oo`03G_Moogoo00=oo`03G_Moogoo00Aoo`03G_Mo
ogoo00Aoo`030OMooekg00Aoo`03G_Moogoo00Qoo`03G_Moogoo00Ioo`03001oogoo045oo`00>goo
00<007ooOol047oo00=NmgooOol08Goo00=NmgooOol087oo00=NmgooOol047oo00=NmgooOol03goo
00=NmgooOol067oo00=NmgooOol027oo00=NmgooOol00goo00=NmgooOol01Woo00=NmgooOol017oo
00=NmgooOol00goo00=NmgooOol00goo00=NmgooOol017oo00=NmgooOol017oo00<1m`8gG_L00goo
00=NmgooOol02Woo00=NmgooOol01Goo00<007ooOol0@Goo000kOol00`00Oomoo`0@Ool00ekgOomo
o`0QOol00ekgOomoo`0POol00ekgOomoo`0?Ool00ekgOomoo`0@Ool00ekgOomoo`0GOol00ekgOomo
o`0:Ool01EkgOomoogooG_L02Goo00=NmgooOol017oo00=NmgooOol00goo00=NmgooOol00goo00=N
mgooOol017oo00=NmgooOol01Goo00<2=`9gG_L00Woo00=NmgooOol02Woo00=NmgooOol01Goo00<0
07ooOol0@Goo000kOol00`00Oomoo`0@Ool00ekgOomoo`0QOol00ekgOomoo`0QOol00ekgOomoo`0<
Ool2G_LCOol00ekgOomoo`0GOol00ekgOomoo`0:Ool01EkgOomoogooG_L027oo00=NmgooOol01Goo
00=NmgooOol00goo00=NmgooOol00goo00=NmgooOol017oo00=NmgooOol01Woo00D2eekgOomooekg
00eoo`03G_Moogoo00Aoo`03001oogoo045oo`00>goo00<007ooOol047oo00=NmgooOol08Goo00=N
mgooOol08Goo00=NmgooOol02goo00=NmgooOol04goo00=NmgooOol05Woo00=NmgooOol02goo00EN
mgooOomooekg00Qoo`03G_Moogoo00Eoo`03G_Moogoo00=oo`03G_Moogoo00=oo`03G_Moogoo00Ao
o`03G_Moogoo00Ioo`050]L2mgooOomNm`0>Ool00ekgOomoo`03Ool00`00Oomoo`11Ool003]oo`03
001oogoo011oo`03G_Moogoo025oo`03G_Moogoo025oo`03G_Moogoo00Yoo`03G_Moogoo01Aoo`03
G_Moogoo01Ioo`03G_Moogoo00aoo`03G_Mooekg00Uoo`03G_Moogoo00Aoo`03G_Moogoo00Aoo`03
G_Moogoo00=oo`03G_Moogoo00Eoo`03G_Moogoo00Ioo`030_L2mEkg00moo`03G_Moogoo00=oo`03
001oogoo045oo`00>goo00<007ooOol047oo00=NmgooOol08Goo00=NmgooOol08Goo00=NmgooOol0
2Goo00=NmgooOol05Goo00=NmgooOol05Goo00=NmgooOol03Goo00=NmgooG_L02Goo00=NmgooOol0
17oo00=NmgooOol017oo00=NmgooOol00goo00=NmgooOol01Goo00=NmgooOol01goo00<2lUkgOol0
3goo00=NmgooOol00Woo00<007ooOol0@Goo000kOol2000AOol00ekgOomoo`0QOol00ekgOomoo`0Q
Ool00ekgOomoo`07Ool2G_LIOol00ekgOomoo`0COol00ekgOomoo`0>Ool00ekgOomNm`09Ool00ekg
Oomoo`04Ool015kgOomooe`;0goo00=NmgooOol00goo00=NmgooOol01Goo00=NmgooOol01goo00<2
lP;`Ool03goo00ANmgooOomoo`8004=oo`00>goo00<007ooOol047oo00=NmgooOol08Goo00=Nmgoo
Ool08Goo00=NmgooOol01Woo00=NmgooOol06Goo00=NmgooOol04goo00=NmgooOol03goo00=Nmgoo
Ool027oo00=NmgooOol017oo00ENmgooG11L3W`0009oo`03G_Moogoo00=oo`03G_Moogoo00Eoo`03
G_Moogoo00Moo`03G_L2kWoo011oo`05G_MoogooOol00013Ool003]oo`03001oogoo015oo`03G_Mo
ogoo021oo`03G_Moogoo025oo`03G_Moogoo00Eoo`03G_Moogoo01Yoo`03G_Moogoo019oo`03G_Mo
ogoo011oo`03G_Moogoo00Moo`03G_Moogoo00Eoo`05G_Mooe`@G0il0002Ool00ekgOomoo`04Ool0
0ekgOomoo`04Ool00ekgOomoo`07Ool00ekg0^h2j`0AOol015kgOomoo`00@goo000kOol00`00Oomo
o`0AOol00ekgOomoo`0POol00ekgOomoo`0QOol00ekgOomoo`04Ool00ekgOomoo`0KOol00ekgOomo
o`0BOol00ekgOomoo`0@Ool00ekgOomoo`07Ool00ekgOomoo`05Ool00ekgG19oo`04Ool00ekgOomo
o`04Ool00ekgOomoo`04Ool00ekgOomoo`07Ool015kgOol2j`;Y47oo00ANmgooOol004=oo`00>goo
00<007ooOol04Goo00=NmgooOol087oo00=NmgooOol08Goo00=NmgooOol00Woo0Ukg7Woo00=Nmgoo
Ool04Goo00=NmgooOol047oo00=NmgooG_L027oo00=NmgooOol01Goo00=Nme`BOol017oo00=Nmgoo
Ool017oo00=NmgooOol01Goo00=NmgooOol01Goo00ENmgooOomNm`;W015oo`03G_Moo`0004=oo`00
>goo00<007ooOol04Goo00=NmgooOol087oo00=NmgooOol08Goo00ENmgooOomooekg021oo`03G_Mo
ogoo015oo`03G_Moogoo011oo`03G_Mooekg00Qoo`03G_Moogoo00Eoo`03G1Eoogoo00Aoo`03G_Mo
ogoo00Aoo`03G_Moogoo00Eoo`03G_Moogoo00Eoo`06G_MoogooG_L2i`;T47oo00=Nmgoo0000@goo
000kOol00`00Oomoo`0AOol00ekgOomoo`0QOol00ekgOomoo`0POol015kgOomooekg8Goo00=Nmgoo
Ool047oo00=NmgooOol04Goo00=NmgooG_L027oo00=NmgooOol01Goo00=L5GooOol017oo00=Nmgoo
Ool017oo00=NmgooOol01Goo00=NmgooOol01Goo00INmgooOomooekg0^8AOol00ekg001oo`12Ool0
03]oo`03001oogoo015oo`03G_Moogoo025oo`03G_Moogoo021oo`03G_Mooekg029oo`03G_Moogoo
00moo`03G_Moogoo015oo`05G_MoogooOomNm`06Ool00ekgOomoo`06Ool00ekgOomoo`04Ool00ekg
Oomoo`04Ool00ekgOomoo`05Ool00ekgOomoo`04Ool00ekgOomoo`02Ool00ekg0^9oo`0@Ool00ekg
001oo`12Ool003]oo`03001oogoo015oo`03G_Moogoo025oo`03G_Moogoo021oo`9Nmb=oo`03G_Mo
ogoo00moo`03G_Moogoo015oo`05G_MoogooOomNm`06Ool00ekgOomoo`05Ool00ekgG1Moo`05Ool0
0ekgOomoo`04Ool00ekgOomoo`05Ool00ekgOomoo`04Ool00ekgOomoo`02Ool00ekgOomoo`0AOol0
0`00Oomoo`11Ool003]oo`03001oogoo015oo`03G_Moogoo025oo`03G_Moogoo01moo`9NmbEoo`03
G_Moogoo00eoo`03G_Moogoo019oo`03G_Moogoo009oo`03G_Moogoo00=oo`03G_Moogoo00Eoo`03
G_ML5goo00Eoo`03G_Moogoo00Aoo`03G_Moogoo00Ioo`03G_Moogoo00=oo`03G_Moogoo00=oo`03
G_Moogoo011oo`03001oogoo045oo`00>goo00<007ooOol04Goo00=NmgooOol08Goo00=NmgooOol0
7Woo00ANmgooOomNmbAoo`03G_Moogoo00eoo`03G_Moogoo015oo`03G_Moogoo00=oo`03G_Moogoo
00=oo`03G_Moogoo00Eoo`03F1Moogoo00Eoo`03G_Moogoo00Aoo`03G_Moogoo00Ioo`03G_Moogoo
009oo`03G_Moogoo00Aoo`03G_Moogoo011oo`03001oogoo045oo`00>goo0P004Woo00=NmgooOol0
8Goo00=NmgooOol07Goo00ENmgooOomooekg02Aoo`03G_Moogoo00aoo`03G_Moogoo019oo`03G_Mo
ogoo00Aoo`03G_Moogoo009oo`03G_Moogoo00Eoo`03F1Moogoo00Eoo`03G_Moogoo00Aoo`03G_Mo
ogoo00Ioo`03G_Moogoo009oo`03G_Moogoo00Aoo`03G_Moogoo00moo`8004=oo`00>goo00<007oo
Ool04Goo00=NmgooOol08Goo00=NmgooOol06goo0Ukg17oo00=NmgooOol08Woo00=NmgooOol02goo
00=NmgooOol04goo00=NmgooOol017oo00ENmgooOomooekg00Qoo`03G_Moogoo00Eoo`03G_Moogoo
00Aoo`03G_Moogoo00Ioo`05G_MoogooOomNm`08Ool00ekgOomoo`0?Ool00`00Oomoo`11Ool003]o
o`03001oogoo015oo`03G_Moogoo025oo`03G_Moogoo01Yoo`03G_Moogoo00Aoo`03G_Moogoo029o
o`03G_Moogoo00]oo`03G_Moogoo019oo`03G_Moogoo00Ioo`04G_MoogooG_L8Ool00d`GOomoo`05
Ool00ekgOomoo`05Ool00ekgOomoo`05Ool01EkgOomoogooG_L027oo00=NmgooOol03goo00<007oo
Ool0@Goo000kOol00`00Oomoo`0AOol00ekgOomoo`0QOol00ekgOomoo`0IOol00ekgOomoo`05Ool0
0ekgOomoo`0ROol00ekgOomoo`0:Ool00ekgOomoo`0COol00ekgOomoo`06Ool015kgOomooekg27oo
00=<5gooOol01Goo00=NmgooOol01Goo00=NmgooOol01Woo00=NmgooG_L02Goo00=NmgooOol03goo
00<007ooOol0@Goo000kOol00`00Oomoo`0AOol00ekgOomoo`0QOol00ekgOomoo`0HOol00ekgOomo
o`06Ool00ekgOomoo`0ROol00ekgOomoo`0:Ool00ekgOomoo`0COol00ekgOomoo`07Ool00ekgOomN
m`08Ool00d@GOomoo`05Ool00ekgOomoo`05Ool00ekgOomoo`06Ool00ekgOomNm`0:Ool00ekgOomo
o`0>Ool00`00Oomoo`11Ool003]oo`03001oogoo015oo`03G_Moogoo025oo`03G_Moogoo01Ioo`9N
m`Uoo`03G_Moogoo029oo`03G_Moogoo00Uoo`03G_Moogoo01=oo`03G_Moogoo00Uoo`9Nm`Qoo`03
A1Moogoo00Eoo`03G_Moogoo00Eoo`03G_Moogoo00Ioo`9Nm`]oo`03G_Moogoo00ioo`03001oogoo
045oo`00>goo00<007ooOol04Goo00=NmgooOol08Goo00=NmgooOol05Goo00=NmgooOol02Goo00=N
mgooOol08goo00=NmgooOol027oo00=NmgooOol04goo00=NmgooOol02Goo00=NmgooOol01goo00=N
mgooOol01Goo00=NmgooOol01Goo00=NmgooOol01Woo0Ukg2goo00=NmgooOol03Woo00<007ooOol0
@Goo000kOol00`00Oomoo`0BOol00ekgOomoo`0POol00ekgOomoo`0DOol00ekgOomoo`0:Ool00ekg
Oomoo`0SOol00ekgOomoo`07Ool00ekgOomoo`0DOol00ekgOomoo`09Ool2G_L8Ool00c`GOomoo`05
Ool00ekgOomoo`05Ool00ekgOomoo`06Ool00ekgOomoo`0;Ool00ekgOomoo`0=Ool00`00Oomoo`11
Ool003]oo`03001oogoo019oo`03G_Moogoo021oo`03G_Moogoo01=oo`03G_Moogoo00]oo`03G_Mo
ogoo02=oo`03G_Moogoo00Ioo`03G_Moogoo01Aoo`03G_Moogoo00Yoo`9Nm`Moo`03G_Ll5goo00Io
o`03G_Moogoo00Eoo`03G_Moogoo00Ioo`9Nm`aoo`03G_Moogoo00eoo`03001oogoo045oo`00>goo
00<007ooOol04Woo00=NmgooOol087oo00=NmgooOol04Goo0Ukg3goo00=NmgooOol08Woo00=Nmgoo
Ool01Woo00=NmgooOol057oo00=NmgooOol02Woo00=NmgooG_L01Woo00<`5gooOol01Woo00=Nmgoo
Ool01Goo00=NmgooOol01Goo00=NmgooG_L037oo00=NmgooOol03Goo00<007ooOol0@Goo000kOol2
000COol00ekgOomoo`0POol00ekgOomoo`0@Ool00ekgOomoo`0?Ool00ekgOomoo`0ROol00ekgOomo
o`05Ool00ekgOomoo`0EOol00ekgOomoo`0:Ool00ekgOomNm`06Ool00c0GOomoo`06Ool00ekgOomo
o`05Ool00ekgOomoo`05Ool00ekgOomNm`0=Ool00ekgOomoo`0;Ool20013Ool003]oo`03001oogoo
019oo`03G_Moogoo021oo`03G_Moogoo00moo`03G_Moogoo011oo`03G_Moogoo029oo`03G_Moogoo
00Eoo`03G_Moogoo01Aoo`03G_Moogoo00Yoo`05G_MoogooOomNm`05Ool00bPGOomoo`06Ool00ekg
Oomoo`05Ool00ekgOomoo`04Ool015kgOomooekg3Goo00=NmgooOol037oo00<007ooOol0@Goo000k
Ool00`00Oomoo`0BOol00ekgOomoo`0QOol00ekgOomoo`0=Ool00ekgOomoo`0AOol00ekgOomoo`0R
Ool00ekgOomoo`04Ool00ekgOomoo`0EOol00ekgOomoo`0:Ool00ekgOomoo`02Ool00ekgOomoo`02
Ool00bPGOomoo`06Ool00ekgOomoo`05Ool00ekgOomoo`03Ool01EkgOomoogooG_L03Goo00=Nmgoo
Ool037oo00<007ooOol0@Goo000kOol00`00Oomoo`0BOol00ekgOomoo`0QOol00ekgOomoo`0;Ool2
G_LDOol00ekgOomoo`0ROol00ekgOomoo`03Ool00ekgOomoo`0EOol00ekgOomoo`0;Ool00ekgOomo
o`03Ool01EkgOomoogooG_L027oo00=NmgooOol01Goo00=NmgooOol00Woo00=NmgooOol00Woo00=N
mgooOol037oo00=NmgooOol02goo00<007ooOol0@Goo000kOol00`00Oomoo`0BOol00ekgOomoo`0Q
Ool00ekgOomoo`0:Ool00ekgOomoo`0DOol00ekgOomoo`0SOol00ekgOomoo`02Ool00ekgOomoo`0E
Ool00ekgOomoo`0;Ool00ekgOomoo`03Ool01EkgOomoogoo81L027oo00=NmgooOol01Woo00ENmgoo
Oomooekg00Eoo`03G_Moogoo00]oo`03G_Moogoo00]oo`03001oogoo045oo`00>goo00<007ooOol0
4Woo00=NmgooOol08Goo00=NmgooOol02Goo00=NmgooOol05Goo00=NmgooOol08goo00ENmgooOomo
oekg01Qoo`03G_Moogoo00]oo`03G_Moogoo00Aoo`04G_Moogoo81L8Ool00ekgOomoo`06Ool015kg
Oomooekg1Woo00=NmgooOol02goo00=NmgooOol02goo00<007ooOol0@Goo000kOol00`00Oomoo`0B
Ool00ekgOomoo`0QOol00ekgOomoo`08Ool00ekgOomoo`0FOol00ekgOomoo`0SOol01EkgOomoogoo
G_L05goo00=NmgooOol02goo00=NmgooOol01Woo00=Nmgoo51L027oo00=NmgooOol01Woo00=Nmgoo
G_L01goo00=NmgooOol037oo00=NmgooOol02Woo00<007ooOol0@Goo000kOol00`00Oomoo`0BOol0
0ekgOomoo`0QOol00ekgOomoo`06Ool2G_LIOol00ekgOomoo`0SOol015kgOomooekg67oo00=Nmgoo
Ool02goo00=NmgooOol01goo00=Nma@GOol01goo00=NmgooOol01Woo0Ukg27oo00=NmgooOol037oo
00=NmgooOol02Woo00<007ooOol0@Goo000kOol00`00Oomoo`0BOol00ekgOomoo`0QOol00ekgOomo
o`05Ool00ekgOomoo`0JOol00ekgOomoo`0ROol015kgOomooekg67oo00=NmgooOol02goo00=Nmgoo
Ool01goo00<<5ekgG_L01goo00=NmgooOol017oo0ekg2Goo00=NmgooOol037oo00=NmgooOol02Woo
00<007ooOol0@Goo000cOol40004Ool00`00Oomoo`0BOol00ekgOomoo`0QOol00ekgOomoo`04Ool0
0ekgOomoo`0KOol00ekgOomoo`0ROol00ekgOomNm`0HOol00ekgOomoo`0<Ool00ekgOomoo`07Ool0
0``GOomoo`02G_L5Ool00ekgOomoo`03Ool015kgOomooekg2Woo00=NmgooOol037oo00=NmgooOol0
2Goo00<007ooOol0@Goo000cOol00`00Oomoo`05Ool00`00Oomoo`0BOol00ekgOomoo`0QOol00ekg
Oomoo`03Ool00ekgOomoo`0LOol00ekgOomoo`0SOol00ekgOomoo`0GOol00ekgOomoo`0<Ool00ekg
Oomoo`07Ool00`@GOomoo`02Ool2G_L3Ool015kgOomoogoo0Ukg0goo00=NmgooOol027oo00=Nmgoo
Ool037oo00=NmgooOol02Goo00<007ooOol0@Goo000dOol00`00Oomoo`04Ool3000BOol00ekgOomo
o`0QOol015kgOomoogoo0Ukg7goo00=NmgooOol08goo00=NmgooOol05goo00=NmgooOol02goo00=N
mgooOol027oo00<45gooOol017oo1ekg1Goo00=NmgooOol027oo00=NmgooOol037oo00=NmgooOol0
1goo0`00@goo000eOol00`00Oomoo`03Ool00`00Oomoo`0BOol00ekgOomoo`0QOol015kgOomooekg
8Goo00=NmgooOol08Woo0Ukg67oo00=NmgooOol037oo00=NmgooOol027oo00<0=gooOol01goo00=N
mgooOol01Woo00=NmgooOol027oo00=NmgooOol03Goo00=NmgooOol027oo00<007ooOol0@Goo000c
Ool01000Oomoo`0017oo00<007ooOol04goo00=NmgooOol087oo00=NmgooG_L08Woo00=NmgooOol0
8Woo0Ukg67oo00=NmgooOol037oo00=NmgooOol027oo00<0=gooOol01goo00=NmgooOol01Woo00=N
mgooOol027oo00=NmgooOol03Goo00=NmgooOol027oo00<007ooOol0@Goo000dOol20005Ool00`00
Oomoo`0COol00ekgOomoo`0POol2G_LSOol00ekgOomoo`0QOol015kgOomooekg5goo00=NmgooOol0
37oo00=NmgooOol027oo00<0MgooOol01goo00=NmgooOol01Woo00=NmgooOol02Goo00=NmgooOol0
37oo00=NmgooOol027oo00<007ooOol0@Goo000kOol00`00Oomoo`0COol00ekgOomoo`0OOol3G_LS
Ool00ekgOomoo`0QOol015kgOomooekg5Woo00=NmgooOol03Goo00=NmgooOol027oo00<0MgooOol0
1goo00=NmgooOol01goo00=NmgooOol027oo00=NmgooOol03Goo00=NmgooOol01goo00<007ooOol0
@Goo000kOol00`00Oomoo`0COol00ekgOomoo`0NOol015kgOomooekg8goo00=NmgooOol087oo00EN
mgooOomooekg01Ioo`03G_Moogoo00aoo`03G_Moogoo00Uoo`030;Moogoo00Moo`03G_Moogoo00Mo
o`03G_Moogoo00Qoo`03G_Moogoo00eoo`03G_Moogoo00Moo`03001oogoo045oo`00>goo00<007oo
Ool04goo00=NmgooOol07Goo00ENmgooOomooekg02=oo`03G_Moogoo01moo`03G_Moogoo009oo`03
G_Moogoo01Aoo`03G_Moogoo00aoo`03G_Moogoo00Uoo`030;Moogoo00Moo`03G_Moogoo00Moo`03
G_Moogoo00Qoo`03G_Moogoo00eoo`03G_Moogoo00Moo`03001oogoo045oo`00>goo00<007ooOol0
4goo00=NmgooOol077oo00=NmgooOol00Woo00=NmgooOol08Woo00=NmgooOol07Woo00=NmgooOol0
0Woo00=NmgooOol04goo00=NmgooOol03Goo00=NmgooOol02Goo00<15gooOol01goo00=NmgooOol0
1goo00=NmgooOol027oo00=NmgooOol03Woo00=NmgooOol01Woo00<007ooOol0@Goo000kOol00`00
Oomoo`0COol00ekgOomoo`0JOol2G_L5Ool00ekgOomoo`0ROol00ekgOomoo`0MOol00ekgOomoo`04
Ool00ekgOomoo`0BOol00ekgOomoo`0=Ool00ekgOomoo`09Ool00`4GOomoo`07Ool00ekgOomoo`07
Ool00ekgOomoo`09Ool00ekgOomoo`0=Ool00ekgOomoo`06Ool00`00Oomoo`11Ool003]oo`03001o
ogoo01=oo`03G_Moogoo01Uoo`03G_Moogoo00Eoo`03G_Moogoo029oo`03G_Moogoo01eoo`03G_Mo
ogoo00Aoo`03G_Moogoo019oo`03G_Moogoo00eoo`03G_Moogoo00Qoo`030EMoogoo00Qoo`03G_Mo
ogoo00Moo`03G_Moogoo00Uoo`03G_Moogoo00eoo`03G_Moogoo00Ioo`03001oogoo045oo`00>goo
0P0057oo00=NmgooOol067oo00=NmgooOol01Woo00=NmgooOol08Woo00=NmgooOol077oo00=Nmgoo
Ool01Goo00=NmgooOol04Goo00=NmgooOol03Goo00=NmgooOol02Goo00<1EgooOol027oo00=Nmgoo
Ool01goo00=NmgooOol02Goo00=NmgooOol03Woo00=NmgooOol017oo0P00@goo000kOol00`00Oomo
o`0COol00ekgOomoo`0FOol2G_L9Ool00ekgOomoo`0ROol00ekgOomoo`0KOol00ekgOomoo`06Ool0
0ekgOomoo`0AOol00ekgOomoo`0=Ool00ekgOomoo`09Ool00`6GOomoo`08Ool00ekgOomoo`07Ool0
0ekgOomoo`09Ool00ekgOomoo`0>Ool00ekgOomoo`05Ool00`00Oomoo`11Ool003]oo`03001oogoo
01=oo`03G_Moogoo01Eoo`03G_Moogoo00Yoo`03G_Moogoo025oo`03G_Moogoo01]oo`03G_Moogoo
00Moo`03G_Moogoo011oo`03G_Moogoo00eoo`03G_Moogoo00Uoo`030IMoogoo00Qoo`03G_Moogoo
00Moo`03G_Moogoo00Uoo`03G_Moogoo00ioo`03G_Moogoo00Eoo`03001oogoo045oo`00>goo00<0
07ooOol04goo00=NmgooOol057oo00=NmgooOol02goo00=NmgooOol08Goo00=NmgooOol06Woo00=N
mgooOol027oo00=NmgooOol03goo00=NmgooOol03Woo00=NmgooOol02Goo00<1mgooOol027oo00=N
mgooOol01goo00=NmgooOol02Woo00=NmgooOol03Woo00=NmgooOol017oo00<007ooOol0@Goo000k
Ool00`00Oomoo`0COol00ekgOomoo`0COol00ekgOomoo`0<Ool00ekgOomoo`0ROol00ekgOomoo`0I
Ool00ekgOomoo`08Ool00ekgOomoo`0?Ool00ekgOomoo`0>Ool00ekgOomoo`09Ool00`7gOomoo`08
Ool00ekgOomoo`07Ool00ekgOomoo`0:Ool00ekgOomoo`0>Ool00ekgOomoo`04Ool00`00Oomoo`11
Ool003]oo`03001oogoo01=oo`03G_Moogoo015oo`9Nm`moo`03G_Moogoo029oo`03G_Moogoo01Qo
o`03G_Moogoo00Uoo`03G_Moogoo00moo`03G_Moogoo00eoo`03G_Moogoo00Yoo`030SMoogoo00Qo
o`03G_Moogoo00Qoo`03G_Moogoo00Uoo`03G_Moogoo00ioo`03G_Moogoo00Aoo`03001oogoo045o
o`00>goo00<007ooOol04goo00=NmgooOol047oo00=NmgooOol03goo00=NmgooOol08Woo00=Nmgoo
Ool067oo00=NmgooOol02Woo00=NmgooOol03Goo00=NmgooOol03Woo00=NmgooOol02Woo00<2=goo
Ool027oo00=NmgooOol027oo00=NmgooOol02Goo00=NmgooOol03goo00=NmgooOol00goo00<007oo
Ool0@Goo000kOol00`00Oomoo`0COol00ekgOomoo`0?Ool00ekgOomoo`0@Ool00ekgOomoo`0ROol0
0ekgOomoo`0GOol00ekgOomoo`0;Ool00ekgOomoo`0=Ool00ekgOomoo`0>Ool00ekgOomoo`0:Ool0
0`9gOomoo`08Ool00ekgOomoo`08Ool00ekgOomoo`09Ool00ekgOomoo`0?Ool00ekgOomoo`03Ool0
0`00Oomoo`11Ool003]oo`03001oogoo01Aoo`03G_Moogoo00eoo`03G_Moogoo015oo`03G_Moogoo
029oo`03G_Moogoo01Ioo`03G_Moogoo00aoo`03G_Moogoo00eoo`03G_Moogoo00ioo`03G_Moogoo
00Yoo`030WMoogoo00Qoo`03G_Moogoo00Qoo`03G_Moogoo00Uoo`03G_Moogoo00moo`03G_Moogoo
00=oo`03001oogoo045oo`00>goo00<007ooOol057oo00=NmgooOol02goo0Ukg57oo00=NmgooOol0
8Woo00=NmgooOol05Woo00=NmgooOol037oo00=NmgooOol037oo00=NmgooOol03goo00=NmgooOol0
2Goo00=Nm`;GOol02Goo00=NmgooOol027oo00=NmgooOol02Woo00=NmgooOol03goo00=NmgooOol0
0Woo00<007ooOol0@Goo000kOol00`00Oomoo`0DOol00ekgOomoo`0:Ool00ekgOomoo`0EOol00ekg
Oomoo`0ROol00ekgOomoo`0DOol00ekgOomoo`0>Ool00ekgOomoo`0;Ool00ekgOomoo`0?Ool00ekg
Oomoo`09Ool00ekg0]Moo`09Ool00ekgOomoo`08Ool00ekgOomoo`0:Ool00ekgOomoo`0?Ool00ekg
Oomoo`02Ool00`00Oomoo`11Ool003]oo`8001Eoo`03G_Moogoo00Uoo`03G_Moogoo01Ioo`03G_Mo
ogoo029oo`03G_Moogoo01Aoo`03G_Moogoo00ioo`03G_Moogoo00]oo`03G_Moogoo00ioo`03G_Mo
ogoo00Yoo`03G_L2mgoo00Uoo`03G_Moogoo00Qoo`03G_Moogoo00Yoo`03G_Moogoo00moo`04G_Mo
ogooOol20013Ool003]oo`03001oogoo01Aoo`03G_Moogoo00Qoo`03G_Moogoo01Moo`03G_Moogoo
029oo`03G_Moogoo01=oo`03G_Moogoo00moo`03G_Moogoo00Yoo`03G_Moogoo00moo`03G_Moogoo
00Yoo`03G_L2mgoo00Uoo`03G_Moogoo00Qoo`03G_Moogoo00Yoo`03G_Moogoo011oo`05G_Moogoo
Ool00013Ool003]oo`03001oogoo01Aoo`03G_Moogoo00Ioo`9NmaYoo`03G_Moogoo029oo`03G_Mo
ogoo019oo`03G_Moogoo011oo`03G_Moogoo00Yoo`03G_Moogoo00moo`03G_Moogoo00Yoo`03G_L2
mGoo00Uoo`03G_Moogoo00Qoo`03G_Moogoo00Yoo`03G_Moogoo011oo`05G_MoogooOol00013Ool0
03]oo`03001oogoo01Aoo`03G_Moogoo00Eoo`03G_Moogoo01Yoo`03G_Moogoo029oo`03G_Moogoo
019oo`03G_Moogoo015oo`03G_Moogoo00Uoo`03G_Moogoo00moo`03G_Moogoo00Yoo`03G_L2mGoo
00Uoo`03G_Moogoo00Qoo`03G_Moogoo00]oo`03G_Moogoo00moo`05G_MoogooOol00013Ool003]o
o`03001oogoo01Aoo`03G_Moogoo00Aoo`03G_Moogoo01]oo`03G_Moogoo029oo`03G_Moogoo015o
o`03G_Moogoo019oo`03G_Moogoo00Qoo`03G_Moogoo011oo`03G_Moogoo00Yoo`030_9oogoo00Uo
o`03G_Moogoo00Qoo`03G_Moogoo00]oo`03G_Moogoo011oo`04G_Moogoo0013Ool003]oo`03001o
ogoo01Aoo`03G_Moogoo00=oo`03G_Moogoo01aoo`03G_Moogoo02=oo`03G_Moogoo011oo`03G_Mo
ogoo019oo`03G_Moogoo00Qoo`03G_Moogoo00moo`03G_Moogoo00]oo`030_1oogoo00Uoo`03G_Mo
ogoo00Qoo`03G_Moogoo00]oo`03G_Moogoo011oo`04G_Moogoo0013Ool003]oo`03001oogoo01Ao
o`04G_MoogooOol2G_LOOol00ekgOomoo`0SOol00ekgOomoo`0?Ool00ekgOomoo`0DOol00ekgOomo
o`07Ool00ekgOomoo`0?Ool00ekgOomoo`0;Ool00`;`Oomoo`09Ool00ekgOomoo`09Ool00ekgOomo
o`0:Ool00ekgOomoo`0@Ool015kgOomoo`00@goo000kOol00`00Oomoo`0DOol015kgOomooekg8Goo
00=NmgooOol08goo00=NmgooOol03goo00=NmgooOol057oo00=NmgooOol01Woo00=NmgooOol047oo
00=NmgooOol02goo00<2kWooOol02Goo00=NmgooOol02Goo00=NmgooOol02Woo00=NmgooOol04Goo
00=Nmgoo0000@goo000kOol00`00Oomoo`0DOol00ekgOomNm`0SOol00ekgOomoo`0ROol00ekgOomo
o`0>Ool00ekgOomoo`0EOol00ekgOomoo`06Ool00ekgOomoo`0@Ool00ekgOomoo`0;Ool00`;^Oomo
o`09Ool00ekgOomoo`09Ool00ekgOomoo`0;Ool00ekgOomoo`0@Ool00ekgOol00013Ool003]oo`03
001oogoo01Eoo`03G_Moogoo029oo`03G_Moogoo029oo`03G_Moogoo00eoo`03G_Moogoo01Moo`03
G_Moogoo00Eoo`03G_Moogoo011oo`03G_Moogoo00Yoo`03G_L2jgoo00Yoo`03G_Moogoo00Uoo`03
G_Moogoo00]oo`03G_Moogoo011oo`03G_Moo`0004=oo`00>goo0P0057oo0ekg97oo00=NmgooOol0
8Woo00=NmgooOol03Goo00=NmgooOol05goo00=NmgooOol017oo00=NmgooOol047oo00=NmgooOol0
2goo00=Nm`;[Ool02Woo00=NmgooOol02Goo00=NmgooOol02goo00=NmgooOol04Goo00=Nm`00Ool0
@Woo000kOol00`00Oomoo`0BOol015kgOomooekg97oo00=NmgooOol08goo00=NmgooOol02goo00=N
mgooOol067oo00=NmgooOol017oo00=NmgooOol047oo00=NmgooOol02goo00=Nm`;YOol02Woo00=N
mgooOol02Goo00=NmgooOol02goo00=NmgooOol04Goo00=Nm`00Ool0@Woo000kOol00`00Oomoo`0A
Ool01EkgOomoogooG_L097oo00=NmgooOol08goo00=NmgooOol02goo00=NmgooOol067oo00=Nmgoo
Ool017oo00=NmgooOol047oo00=NmgooOol02goo00=Nm`;WOol02Woo00=NmgooOol02Goo00=Nmgoo
Ool02goo00=NmgooOol04Goo00=Nm`00Ool0@Woo000kOol00`00Oomoo`0@Ool00ekgOomoo`02Ool0
0ekgOomoo`0ROol00ekgOomoo`0SOol00ekgOomoo`0:Ool00ekgOomoo`0JOol00ekgOomoo`02Ool0
0ekgOomoo`0AOol00ekgOomoo`0;Ool00ekg0^Moo`0:Ool00ekgOomoo`09Ool00ekgOomoo`0<Ool0
0ekgOomoo`0AOol00`00Oomoo`11Ool003]oo`03001oogoo00ioo`9Nm`Eoo`03G_Moogoo029oo`03
G_Moogoo02=oo`03G_Moogoo00Uoo`03G_Moogoo01]oo`03G_Moogoo009oo`03G_Moogoo015oo`03
G_Moogoo00]oo`03G_L2i7oo00Yoo`03G_Moogoo00Uoo`03G_Moogoo00aoo`03G_Moogoo015oo`03
001oogoo045oo`00>goo00<007ooOol03Goo00=NmgooOol01Goo00=NmgooOol08Woo00=NmgooOol0
8goo00=NmgooOol02Goo00=NmgooOol06goo00=NmgooOol00Woo00=NmgooOol047oo00=NmgooOol0
37oo00=Nm`;TOol02Woo00=NmgooOol02Goo00=NmgooOol037oo00=NmgooOol04Goo00<007ooOol0
@Goo000kOol00`00Oomoo`0<Ool00ekgOomoo`06Ool00ekgOomoo`0SOol00ekgOomoo`0ROol00ekg
Oomoo`08Ool00ekgOomoo`0MOol015kgOomooekg4goo00=NmgooOol037oo00=Nm`;ROol02Woo00=N
mgooOol02Goo00=NmgooOol037oo00=NmgooOol04Goo00<007ooOol0@Goo000kOol00`00Oomoo`0;
Ool00ekgOomoo`07Ool00ekgOomoo`0SOol00ekgOomoo`0SOol00ekgOomoo`07Ool00ekgOomoo`0M
Ool015kgOomooekg4goo00=NmgooOol037oo00=Nm`;ROol02Woo00=NmgooOol02Woo00=NmgooOol0
2goo00=NmgooOol04Goo00<007ooOol0@Goo000kOol00`00Oomoo`09Ool2G_L;Ool00ekgOomoo`0R
Ool00ekgOomoo`0SOol00ekgOomoo`06Ool00ekgOomoo`0NOol015kgOomooekg4goo00=NmgooOol0
37oo00=NmgooOol02Woo00=NmgooOol02Woo00=NmgooOol02goo00=NmgooOol04Goo00<007ooOol0
@Goo000kOol00`00Oomoo`08Ool00ekgOomoo`0;Ool00ekgOomoo`0ROol00ekgOomoo`0SOol00ekg
Oomoo`06Ool00ekgOomoo`0OOol2G_LDOol00ekgOomoo`0<Ool00ekgOomoo`0:Ool00ekgOomoo`0:
Ool00ekgOomoo`0<Ool00ekgOomoo`0@Ool00`00Oomoo`11Ool003]oo`8000Qoo`03G_Moogoo00ao
o`03G_Moogoo029oo`03G_Moogoo02=oo`03G_Moogoo00Eoo`03G_Moogoo021oo`9Nma=oo`03G_Mo
ogoo00aoo`03G_Moogoo00]oo`03G_Moogoo00Yoo`03G_Moogoo00aoo`03G_Moogoo00moo`8004=o
o`00>goo00<007ooOol01Woo00=NmgooOol03Goo00=NmgooOol08Woo00=NmgooOol08goo00=Nmgoo
Ool017oo00=NmgooOol08Goo0Ukg4goo00=NmgooOol037oo00=NmgooOol02goo00=NmgooOol02Woo
00=NmgooOol037oo00=NmgooOol047oo00<007ooOol0@Goo000kOol00`00Oomoo`04Ool2G_L@Ool0
0ekgOomoo`0ROol00ekgOomoo`0SOol00ekgOomoo`04Ool00ekgOomoo`0QOol2G_LCOol00ekgOomo
o`0<Ool00ekgOomoo`0;Ool00ekgOomoo`0:Ool00ekgOomoo`0<Ool00ekgOomoo`0@Ool00`00Oomo
o`11Ool003]oo`03001oogoo00=oo`03G_Moogoo011oo`03G_Moogoo029oo`03G_Moogoo02Aoo`03
G_Moogoo009oo`03G_Moogoo029oo`9Nma=oo`03G_Moogoo00aoo`03G_Moogoo00]oo`03G_Moogoo
00Yoo`03G_Moogoo00aoo`03G_Moogoo011oo`03001oogoo045oo`00>goo00<007ooOol00Woo00=N
mgooOol04Goo00=NmgooOol08goo00=NmgooOol08goo00=NmgooOol00Woo00=NmgooOol08Woo0Ukg
4goo00=NmgooOol037oo00=NmgooOol02goo00=NmgooOol02Woo00=NmgooOol03Goo00=NmgooOol0
3goo00<007ooOol0@Goo000kOol01@00OomoogooG_L057oo00=NmgooOol08goo00=NmgooOol08goo
00ENmgooOomooekg02Aoo`04G_MoogooG_LAOol00ekgOomoo`0=Ool00ekgOomoo`0;Ool00ekgOomo
o`0:Ool00ekgOomoo`0=Ool00ekgOomoo`0?Ool00`00Oomoo`11Ool003]oo`04001ooekgG_LEOol0
0ekgOomoo`0SOol00ekgOomoo`0SOol015kgOomooekg9Goo00ANmgooOomNma5oo`03G_Moogoo00eo
o`03G_Moogoo00]oo`03G_Moogoo00Yoo`03G_Moogoo00eoo`03G_Moogoo00moo`03001oogoo045o
o`00>goo00<005kgOol05goo00=NmgooOol08Woo00=NmgooOol08goo00ANmgooOomNmbEoo`04G_Mo
ogooG_LAOol00ekgOomoo`0=Ool00ekgOomoo`0;Ool00ekgOomoo`0:Ool00ekgOomoo`0=Ool00ekg
Oomoo`0?Ool00`00Oomoo`11Ool003]oo`03G_Moogoo01Moo`03G_Moogoo029oo`03G_Moogoo02Ao
o`9NmbEoo`03G_Moogoo009oo`03G_Moogoo00ioo`03G_Moogoo00eoo`03G_Moogoo00]oo`03G_Mo
ogoo00Yoo`03G_Moogoo00eoo`03G_Moogoo00moo`03001oogoo045oo`00=7oo0P001Goo00<007oo
Ool05goo00=NmgooOol08Woo00=NmgooOol097oo0Ukg9Goo00=NmgooOol00Woo00=NmgooOol03Woo
00=NmgooOol03Goo00=NmgooOol02goo00=NmgooOol02goo00=NmgooOol03Goo00=NmgooOol03Woo
00<007ooOol0@Goo000cOol01000Oomoo`0017oo00<007ooOol05goo00=NmgooOol08Woo00=Nmgoo
Ool097oo00=NmgooOol097oo00=NmgooOol00Woo00=NmgooOol03Goo00=NmgooOol03Woo00=Nmgoo
Ool02goo00=NmgooOol02goo00=NmgooOol03Goo00=NmgooOol03Goo00=Nm`00Ool0@Woo000eOol0
0`00Oomoo`03Ool3000GOol00ekgOomoo`0ROol00ekgOomoo`0TOol00ekgOomoo`0SOol00ekgOomo
o`04Ool00ekgOomoo`0<Ool00ekgOomoo`0=Ool00ekgOomoo`0<Ool00ekgOomoo`0;Ool00ekgOomo
o`0=Ool00ekgOomoo`0<Ool00`00G_L00013Ool003Ioo`03001oogoo009oo`03001oogoo01Moo`03
G_Moogoo02=oo`03G_Moogoo029oo`9NmbEoo`03G_Moogoo00Aoo`03G_Moogoo00aoo`03G_Moogoo
00eoo`03G_Moogoo00aoo`03G_Moogoo00]oo`03G_Moogoo00eoo`03G_Moogoo00aoo`03G_Moo`00
04=oo`00<goo00@007ooOol000Aoo`03001oogoo01Moo`03G_Moogoo02=oo`03G_Moogoo025oo`04
G_MoogooG_LTOol00ekgOomoo`04Ool00ekgOomoo`0<Ool00ekgOomoo`0=Ool00ekgOomoo`0<Ool0
0ekgOomoo`0;Ool00ekgOomoo`0=Ool00ekgOomoo`0<Ool00ekgOol00013Ool003Aoo`8000Eoo`03
001oogoo01Moo`03G_Moogoo02=oo`03G_Moogoo025oo`04G_MoogooG_LSOol00ekgOomoo`06Ool0
0ekgOomoo`0;Ool00ekgOomoo`0=Ool00ekgOomoo`0<Ool00ekgOomoo`0;Ool00ekgOomoo`0>Ool0
0ekgOomoo`0:Ool015kgOomoo`00@goo000kOol00`00Oomoo`0GOol00ekgOomoo`0SOol00ekgOomo
o`0POol01EkgOomoogooG_L08goo00=NmgooOol01Woo00=NmgooOol02Woo00=NmgooOol03Woo00=N
mgooOol037oo00=NmgooOol02goo00=NmgooOol03Woo00=NmgooOol02Woo00ANmgooOol004=oo`00
>goo00<007ooOol067oo00=NmgooOol08Woo00=NmgooOol087oo00ENmgooOomooekg02=oo`03G_Mo
ogoo00Ioo`03G_Moogoo00Yoo`03G_Moogoo00ioo`03G_Moogoo00aoo`03G_Moogoo00]oo`03G_Mo
ogoo00ioo`03G_Moogoo00Yoo`04G_Moogoo0013Ool003]oo`03001oogoo01Qoo`03G_Moogoo029o
o`03G_Moogoo01moo`03G_Moogoo00=oo`03G_Moogoo01moo`03G_Moogoo00Qoo`03G_Moogoo00Uo
o`03G_Moogoo00ioo`03G_Moogoo00aoo`03G_Moogoo00]oo`03G_Moogoo00ioo`03G_Moogoo00Uo
o`05G_MoogooOol00013Ool003]oo`03001oogoo01Qoo`03G_Moogoo029oo`03G_Moogoo01ioo`03
G_Moogoo00Aoo`03G_Moogoo01moo`03G_Moogoo00Qoo`03G_Moogoo00Uoo`03G_Moogoo00ioo`03
G_Moogoo00aoo`03G_Moogoo00]oo`03G_Moogoo00ioo`03G_Moogoo00Uoo`05G_MoogooOol00013
Ool003]oo`03001oogoo01Qoo`03G_Moogoo02=oo`03G_Moogoo01eoo`03G_Moogoo00Aoo`03G_Mo
ogoo01moo`03G_Moogoo00Uoo`03G_Moogoo00Qoo`03G_Moogoo00ioo`03G_Moogoo00aoo`03G_Mo
ogoo00]oo`03G_Moogoo00ioo`03G_Moogoo00Qoo`03G_Moogoo009oo`03001oogoo045oo`00>goo
00<007ooOol067oo00=NmgooOol08goo00=NmgooOol077oo00=NmgooOol01Goo00=NmgooOol07Woo
00=NmgooOol02Woo00=NmgooOol01goo00=NmgooOol03goo00=NmgooOol037oo00=NmgooOol037oo
00=NmgooOol03Woo00=NmgooOol01goo00=NmgooOol00Woo00<007ooOol0@Goo000kOol2000IOol0
0ekgOomoo`0SOol00ekgOomoo`0LOol00ekgOomoo`05Ool00ekgOomoo`0NOol00ekgOomoo`0;Ool0
0ekgOomoo`06Ool00ekgOomoo`0?Ool00ekgOomoo`0<Ool00ekgOomoo`0<Ool00ekgOomoo`0>Ool0
0ekgOomoo`06Ool00ekgOomoo`02Ool20013Ool003]oo`03001oogoo01Qoo`03G_Moogoo02=oo`03
G_Moogoo01]oo`03G_Moogoo00Moo`03G_Moogoo01eoo`03G_Moogoo00]oo`03G_Moogoo00Ioo`03
G_Moogoo00ioo`03G_Moogoo00eoo`03G_Moogoo00aoo`03G_Moogoo00ioo`03G_Moogoo00Ioo`03
G_Moogoo00=oo`03001oogoo045oo`00>goo00<007ooOol067oo00=NmgooOol08goo00=NmgooOol0
6goo00=NmgooOol01goo00=NmgooOol077oo00=NmgooOol037oo00=NmgooOol01Woo00=NmgooOol0
3Woo00=NmgooOol03Goo00=NmgooOol037oo00=NmgooOol03Woo00=NmgooOol01Goo00=NmgooOol0
17oo00<007ooOol0@Goo000kOol00`00Oomoo`0IOol00ekgOomoo`0ROol00ekgOomoo`0JOol00ekg
Oomoo`08Ool00ekgOomoo`0LOol00ekgOomoo`0=Ool00ekgOomoo`05Ool00ekgOomoo`0>Ool00ekg
Oomoo`0=Ool00ekgOomoo`0<Ool00ekgOomoo`0>Ool00ekgOomoo`05Ool00ekgOomoo`04Ool00`00
Oomoo`11Ool003]oo`03001oogoo01Uoo`03G_Moogoo02=oo`03G_Moogoo01Qoo`03G_Moogoo00Uo
o`03G_Moogoo01aoo`03G_Moogoo00eoo`03G_Moogoo00Eoo`03G_Moogoo00ioo`03G_Moogoo00eo
o`03G_Moogoo00aoo`03G_Moogoo00moo`03G_Moogoo00Aoo`03G_Moogoo00Aoo`03001oogoo045o
o`00>goo00<007ooOol06Goo00=NmgooOol08goo00=NmgooOol067oo00=NmgooOol02Goo00=Nmgoo
Ool06goo00=NmgooOol03goo00=NmgooOol00goo00=NmgooOol03goo00=NmgooOol03Goo00=Nmgoo
Ool037oo00=NmgooOol03goo00=NmgooOol00goo00=NmgooOol01Goo00<007ooOol0@Goo000kOol0
0`00Oomoo`0IOol00ekgOomoo`0SOol00ekgOomoo`0GOol00ekgOomoo`0;Ool00ekgOomoo`0JOol0
0ekgOomoo`0?Ool00ekgOomoo`03Ool00ekgOomoo`0?Ool00ekgOomoo`0=Ool00ekgOomoo`0<Ool0
0ekgOomoo`0?Ool00ekgOomoo`03Ool00ekgOomoo`05Ool00`00Oomoo`11Ool003]oo`03001oogoo
01Uoo`03G_Moogoo02=oo`03G_Moogoo01Moo`03G_Moogoo00]oo`03G_Moogoo01Yoo`03G_Moogoo
011oo`03G_Moogoo009oo`03G_Moogoo00moo`03G_Moogoo00eoo`03G_Moogoo00aoo`03G_Moogoo
00moo`03G_Moogoo009oo`03G_Moogoo00Ioo`03001oogoo045oo`00>goo00<007ooOol06Goo00=N
mgooOol08goo00=NmgooOol05Woo00=NmgooOol037oo00=NmgooOol06Goo00=NmgooOol04Goo00=N
mgooOol00Woo00=NmgooOol03goo00=NmgooOol03Goo00=NmgooOol037oo00=NmgooOol03goo00=N
mgooOol00Woo00=NmgooOol01Woo00<007ooOol0@Goo000kOol00`00Oomoo`0IOol00ekgOomoo`0S
Ool00ekgOomoo`0EOol00ekgOomoo`0=Ool00ekgOomoo`0IOol00ekgOomoo`0BOol01EkgOomoogoo
G_L04Goo00=NmgooOol03Goo00=NmgooOol037oo00=NmgooOol047oo00ANmgooOomNm`Uoo`03001o
ogoo045oo`00>goo00<007ooOol06Goo00=NmgooOol08goo00=NmgooOol05Goo00=NmgooOol03Woo
00=NmgooOol067oo00=NmgooOol04Woo00ANmgooOomNma9oo`03G_Moogoo00eoo`03G_Moogoo00eo
o`03G_Moogoo00moo`04G_MoogooG_L9Ool00`00Oomoo`11Ool003]oo`8001Yoo`03G_Moogoo02Ao
o`03G_Moogoo01=oo`03G_Moogoo00moo`03G_Moogoo01Moo`03G_Moogoo01Aoo`03G_Mooekg015o
o`03G_Moogoo00ioo`03G_Moogoo00eoo`03G_Moogoo00moo`03G_Mooekg00Uoo`8004=oo`00>goo
00<007ooOol06Woo00=NmgooOol08goo00=NmgooOol04goo00=NmgooOol03goo00=NmgooOol05goo
00=NmgooOol057oo00=NmgooG_L04Goo00=NmgooOol03Woo00=NmgooOol03Goo00=NmgooOol03goo
00=NmgooG_L02Woo00<007ooOol0@Goo000kOol00`00Oomoo`0JOol00ekgOomoo`0SOol00ekgOomo
o`0BOol00ekgOomoo`0@Ool00ekgOomoo`0GOol00ekgOomoo`0EOol2G_LAOol00ekgOomoo`0>Ool0
0ekgOomoo`0=Ool00ekgOomoo`0?Ool2G_L;Ool00`00Oomoo`11Ool003]oo`03001oogoo01Yoo`03
G_Moogoo02=oo`03G_Moogoo019oo`03G_Moogoo011oo`03G_Moogoo01Ioo`03G_Moogoo01Moo`03
G_Moogoo00moo`03G_Moogoo00ioo`03G_Moogoo00eoo`03G_Moogoo011oo`03G_Moogoo00Uoo`03
001oogoo045oo`00>goo00<007ooOol06Woo00=NmgooOol08goo00=NmgooOol04Goo00=NmgooOol0
4Woo00=NmgooOol05Goo00=NmgooOol05Woo0Ukg4Goo00=NmgooOol03Woo00=NmgooOol03Goo00=N
mgooOol03goo0Ukg2goo00<007ooOol0@Goo000kOol00`00Oomoo`0JOol00ekgOomoo`0SOol00ekg
Oomoo`0@Ool00ekgOomoo`0COol00ekgOomoo`0EOol00ekgOomoo`0FOol00ekgOomNm`0@Ool00ekg
Oomoo`0>Ool00ekgOomoo`0=Ool00ekgOomoo`0>Ool00ekgOomNm`0;Ool00`00Oomoo`11Ool003]o
o`03001oogoo01Yoo`03G_Moogoo02=oo`03G_Moogoo011oo`03G_Moogoo01=oo`03G_Moogoo01Ao
o`03G_Moogoo01Moo`04G_MoogooG_L?Ool00ekgOomoo`0>Ool00ekgOomoo`0=Ool00ekgOomoo`0>
Ool00ekgOomNm`0;Ool00`00Oomoo`11Ool003]oo`03001oogoo01Yoo`03G_Moogoo02Aoo`03G_Mo
ogoo00ioo`03G_Moogoo01Aoo`03G_Moogoo01Aoo`03G_Moogoo01Moo`04G_MoogooG_L?Ool00ekg
Oomoo`0>Ool00ekgOomoo`0=Ool00ekgOomoo`0=Ool015kgOomooekg2goo00<007ooOol0@Goo000k
Ool00`00Oomoo`0JOol00ekgOomoo`0TOol00ekgOomoo`0>Ool00ekgOomoo`0DOol00ekgOomoo`0D
Ool00ekgOomoo`0GOol01EkgOomoogooG_L03Woo00=NmgooOol03Woo00=NmgooOol03Goo00=Nmgoo
Ool03Goo00ANmgooOomNm`]oo`03001oogoo045oo`00>goo00<007ooOol06Woo00=NmgooOol097oo
00=NmgooOol03Goo00=NmgooOol05Woo00=NmgooOol04Woo00=NmgooOol05goo00=NmgooOol00goo
00=NmgooOol02goo00=NmgooOol03Woo00=NmgooOol03Goo00=NmgooOol037oo00=NmgooOol00Woo
00=NmgooOol027oo00<007ooOol0@Goo000kOol2000LOol00ekgOomoo`0SOol00ekgOomoo`0<Ool0
0ekgOomoo`0GOol00ekgOomoo`0BOol00ekgOomoo`0GOol00ekgOomoo`03Ool00ekgOomoo`0;Ool0
0ekgOomoo`0>Ool00ekgOomoo`0=Ool00ekgOomoo`0<Ool00ekgOomoo`02Ool00ekgOomoo`07Ool2
0013Ool003]oo`03001oogoo01]oo`03G_Moogoo02=oo`03G_Moogoo00aoo`03G_Moogoo01Moo`03
G_Moogoo019oo`03G_Moogoo01Moo`03G_Moogoo00Aoo`03G_Moogoo00Uoo`03G_Moogoo00moo`03
G_Moogoo00ioo`03G_Moogoo00Yoo`03G_Moogoo00=oo`03G_Moogoo00Qoo`03001oogoo045oo`00
>goo00<007ooOol06goo00=NmgooOol08goo00=NmgooOol02goo00=NmgooOol067oo00=NmgooOol0
4Goo00=NmgooOol067oo00=NmgooOol01Goo00=NmgooOol027oo00=NmgooOol03goo00=NmgooOol0
3Woo00=NmgooOol02Goo00=NmgooOol017oo00=NmgooOol027oo00<007ooOol0@Goo000kOol00`00
Oomoo`0KOol00ekgOomoo`0TOol00ekgOomoo`0:Ool00ekgOomoo`0HOol00ekgOomoo`0AOol00ekg
Oomoo`0HOol00ekgOomoo`06Ool00ekgOomoo`07Ool00ekgOomoo`0?Ool00ekgOomoo`0>Ool00ekg
Oomoo`08Ool00ekgOomoo`05Ool00ekgOomoo`08Ool00`00Oomoo`11Ool003]oo`03001oogoo00mo
o`03001oogoo00Uoo`03G_Moogoo01Aoo`03001oogoo00eoo`03G_Moogoo00Uoo`03G_Moogoo00Ao
o`03001oogoo01=oo`03G_Moogoo00Yoo`03001oogoo00=oo`03G_Moogoo01Moo`04G_Moogoo0006
Ool00ekgOomoo`07Ool00ekgOomoo`0?Ool00ekgOomoo`0>Ool00ekgOomoo`08Ool00ekgOomoo`04
Ool00`00OomNm`09Ool00`00Oomoo`11Ool003]oo`03001oogoo00Ioo`03001oogoo00Ioo`03001o
ogoo00Ioo`04001oogooG_L4Ool00`00Oomoo`06Ool00`00Oomoo`06Ool00`00Oomoo`06Ool00`00
Oomoo`04Ool00ekg001oo`07Ool00`00OomNm`06Ool00`00Oomoo`06Ool00`00Oomoo`05Ool00`00
Oomoo`02Ool01EkgOomoogoo000027oo00<007ooOol00Woo00ENmgooOomoo`0000Moo`03001oogoo
00Ioo`03001oogoo00=oo`04G_Moogoo0007Ool00ekg001oo`06Ool00ekgOomoo`06Ool00`00Oomo
o`06Ool00ekgOomoo`06Ool00`00Oomoo`05Ool00ekgOomoo`06Ool00`00G_Moo`06Ool00`00OomN
m`05Ool01@00Oomoogoo0000@goo000kOolN00000ekg0000000T00000ekg0000000800000ekg0000
000K00000ekg0000000?00000ekg0000000H00000ekg0000000900000ekg0000000500000ekg0000
000?00000ekg0000000>00000ekg0000000600000ekg0000000800000ekg000000080013Ool00?mo
og1oo`00ogooL7oo003oOom`Ool00?moog1oo`00ogooL7oo003oOom`Ool00?moog1oo`00ogooL7oo
003oOom`Ool00?moog1oo`00ogooL7oo003oOom`Ool00?moog1oo`00ogooL7oo003oOom`Ool00?mo
og1oo`00ogooL7oo001QOol00`00Oomoo`0GOol00`00Oomoo`09Ool00`00Oomoo`0GOol00`00Oomo
o`09Ool00`00Oomoo`12Ool00`00Oomoo`09Ool00`00Oomoo`0]Ool00`00Oomoo`0nOol0061oo`03
001oogoo00]oo`03001oogoo00]oo`03001oogoo00Moo`03001oogoo00]oo`03001oogoo00]oo`03
001oogoo00Moo`03001oogoo011oo`03001oogoo02=oo`03001oogoo00]oo`03001oogoo00Moo`03
001oogoo011oo`03001oogoo00ioo`03001oogoo00]oo`03001oogoo03eoo`00EGoo0`001goo00<0
07ooOol00Woo0`001goo00<007ooOol017oo100017oo00<007ooOol01Goo00<007ooOol00Woo0`00
1goo00<007ooOol01Goo0P001Goo00<007ooOol01Goo00<007ooOol00Woo0`0037oo00<007ooOol0
1Goo0P0017oo0P000goo10001Goo0`001goo00<007ooOol017oo100017oo00<007ooOol01Goo00<0
07ooOol00Woo0`0037oo00<007ooOol017oo0`001goo00<007ooOol017oo1@000goo00<007ooOol0
?7oo001GOol20006Ool00`00Oomoo`04Ool20004Ool50004Ool00`00Oomoo`05Ool00`00Oomoo`05
Ool00`00Oomoo`04Ool20004Ool50004Ool01000Oomoo`0017oo00<007ooOol01Goo00<007ooOol0
17oo0P002Goo1@0017oo00@007ooOol000Qoo`03001oogoo00Qoo`8000Aoo`D000Aoo`03001oogoo
00Eoo`03001oogoo00Eoo`03001oogoo00Aoo`8000Uoo`D000Ioo`8000Aoo`D000Ioo`03001oogoo
00=oo`03001oogoo03aoo`00EWoo00<007ooOol01Woo00<007ooOol00goo00<007ooOol01Woo00<0
07ooOol01Goo00<007ooOol017oo00<007ooOol01Goo00<007ooOol00goo00<007ooOol01Woo00<0
07ooOol01goo00<007ooOol00Woo00<007ooOol01Goo00<007ooOol00goo00<007ooOol02goo00<0
07ooOol017oo00@007ooOol000Uoo`03001oogoo00Ioo`03001oogoo00Ioo`03001oogoo00Eoo`03
001oogoo00Aoo`03001oogoo00Eoo`03001oogoo00=oo`03001oogoo00]oo`03001oogoo00Eoo`03
001oogoo00Ioo`03001oogoo00Ioo`03001oogoo00=oo`03001oogoo03aoo`00EWoo0`001Woo00<0
07ooOol00goo0`001Woo00<007ooOol01Woo00<007ooOol00goo00<007ooOol01Goo00<007ooOol0
0goo0`001Woo00<007ooOol01Goo0P001Goo00<007ooOol01Goo00<007ooOol00goo0`000Woo0P00
1goo00<007ooOol017oo00@007ooOol000Yoo`03001oogoo00Eoo`<000Ioo`03001oogoo00Ioo`03
001oogoo00=oo`03001oogoo00Eoo`03001oogoo00=oo`<0009oo`8000Moo`03001oogoo00Eoo`<0
00Ioo`03001oogoo00Ioo`03001oogoo00=oo`03001oogoo03aoo`00>Goo0P0027oo0P006goo00<0
07ooOol04Woo00@007ooOol000=oo`03001oogoo00Moo`03001oogoo01=oo`03001oogoo00=oo`03
001oogoo00Moo`03001oogoo00Moo`03001oogoo00eoo`04001oogoo0008Ool01000Oomoo`005Woo
00@007ooOol000=oo`03001oogoo00Moo`03001oogoo00Moo`03001oogoo021oo`03001oogoo009o
o`03001oogoo03eoo`00>Goo00<007ooOol027oo00<007ooOol06Woo00<007ooOol04Woo0P000goo
00<007ooOol02Goo00<007ooOol04Woo0`000Woo00<007ooOol02Goo00<007ooOol01goo00<007oo
Ool03Goo0P002Woo0P0067oo0P000goo00<007ooOol02Goo00<007ooOol01goo00<007ooOol07Woo
0P000goo00<007ooOol0?Woo000bOol20005Ool01000Oomoogoo0`0017oo00<007ooOol00Woo1000
JGoo0P00Cgoo0P00IWoo000aOol01000Oomoo`0017oo00<007ooOol017oo00D007ooOomoo`0000io
od0000Qood0000Qoob0000Aoob0000Aoo`H00003Ool0000003]oo`00<Goo00<007oo00000P000goo
00@007ooOomoo`<000Aoo`03001oogoo009oo`@00?moob=oo`00<Goo00<007ooOol01Goo00@007oo
Oomoo`@000=oo`03001oogoo0?moobUoo`00<Goo00<007ooOol01Goo00<007ooOol027oo00<007oo
Ool0FGoo00<007ooOol05goo00<007ooOol02Goo00<007ooOol07Goo00<007ooOol0QWoo000bOol3
0004Ool20008Ool2001JOol00`00Oomoo`0;Ool00`00Oomoo`0;Ool00`00Oomoo`07Ool00`00Oomo
o`0;Ool00`00Oomoo`0AOol00`00Oomoo`25Ool009ioo`03001oogoo009oo`<000Moo`03001oogoo
00Ioo`<000=oo`03001oogoo00Eoo`03001oogoo009oo`<000Moo`03001oogoo00Aoo`D0009oo`80
00Eoo`03001oogoo08Aoo`00WWoo00<007ooOol017oo0P0017oo1@001goo00<007ooOol00Woo00<0
07ooOol01Goo00<007ooOol017oo0P0017oo1@001Woo00D007ooOomoo`00009oo`03001oogoo009o
o`03001oogoo08Aoo`00WWoo00<007ooOol00goo00<007ooOol01Woo00<007ooOol017oo1@000goo
00<007ooOol01Goo00<007ooOol00goo00<007ooOol01Woo00<007ooOol01Woo00D007ooOomoo`00
009oo`03001oogoo009oo`03001oogoo08Aoo`00WWoo00<007ooOol00goo0`001Woo00<007ooOol0
17oo00@007ooOol000Aoo`03001oogoo00Eoo`03001oogoo00=oo`<000Ioo`03001oogoo00Ioo`05
001oogooOol00002Ool00`00Oomoo`02Ool00`00Oomoo`24Ool009moo`03001oogoo01=oo`03001o
o`0000=oo`03001oogoo00Moo`03001oogoo01Aoo`05001oogooOol00002Ool01@00Oomoogoo0000
Qgoo002POol00`00Oomoo`0COol20002Ool00`00Oomoo`09Ool00`00Oomoo`0BOol20004Ool20003
Ool00`00Oomoo`26Ool00?moog1oo`00ogooL7oo003oOom`Ool00?moog1oo`00ogooL7oo003oOom`
Ool00?moog1oo`00ogooL7oo003oOom`Ool00?moog1oo`00ogooL7oo003oOom`Ool00?moog1oo`00
ogooL7oo003oOom`Ool00?moog1oo`00ogooL7oo003oOom`Ool00?moog1oo`00ogooL7oo003oOom`
Ool00?moog1oo`00ogooL7oo003oOom`Ool00?moog1oo`00ogooL7oo003oOom`Ool00?moog1oo`00
ogooL7oo003oOom`Ool00?moog1oo`00ogooL7oo003oOom`Ool00?moog1oo`00\
\>"],
  ImageRangeCache->{{{0, 366.188}, {516.875, 0}} -> {-0.653492, -1.05083, \
0.00406609, 0.00406609}, {{8.6875, 312.688}, {504.375, 12.5}} -> {-14.4182, \
-4.82111, 0.0571581, 0.0191551}, {{332.875, 357.438}, {381.375, 258.438}} -> \
{-27.6667, -44.2175, 0.0830543, 0.326029}},
  CellTags->{"Root Locus", "i:11", "b:20.3"}],

Cell[BoxData[
    TagBox[\(\[SkeletonIndicator]  Graphics  \[SkeletonIndicator]\),
      False,
      Editable->False]], "Output",
  CellLabel->"Out[138]=",
  CellTags->{"Root Locus", "i:11", "b:20.3"}]
}, Open  ]],

Cell["\<\
The root locus can also be constructed for a range of gains that includes \
negative values:\
\>", "Text",
  Evaluatable->False,
  AspectRatioFixed->True,
  CellTags->{"Root Locus", "i:11", "b:20.3"}],

Cell[CellGroupData[{

Cell[BoxData[
    \(RootLocus[G, s, k, \(-10\), \(+20. \), 1. ]\)], "Input",
  CellLabel->"In[139]:=",
  PageWidth->Infinity,
  AspectRatioFixed->True,
  CellTags->{"Root Locus", "i:11", "b:20.3"}],

Cell[BoxData[
    \("\n                Zeros in green, Open loop poles in red\n"\)], "Print",\

  CellLabel->"From In[139]:=",
  CellTags->{"Root Locus", "i:11", "b:20.3"}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: 1.4104 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.438894 0.671621 0.705202 0.671621 [
[ 0 0 0 0 ]
[ 1 1.4104 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
% Start of sub-graphic
p
0.0238095 0.033581 0.853978 1.37682 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.818737 0.0744307 0.809017 0.23549 [
[.07443 -0.0125 -9 -9 ]
[.07443 -0.0125 9 0 ]
[.22329 -0.0125 -6 -9 ]
[.22329 -0.0125 6 0 ]
[.37215 -0.0125 -6 -9 ]
[.37215 -0.0125 6 0 ]
[.52101 -0.0125 -6 -9 ]
[.52101 -0.0125 6 0 ]
[.66988 -0.0125 -6 -9 ]
[.66988 -0.0125 6 0 ]
[.81874 -0.0125 -3 -9 ]
[.81874 -0.0125 3 0 ]
[.9676 -0.0125 -3 -9 ]
[.9676 -0.0125 3 0 ]
[ 0 0 -0.125 0 ]
[.5 -0.0125 -17.3125 -22.1875 ]
[.5 -0.0125 17.3125 -9 ]
[-0.0125 .10255 -12 -4.5 ]
[-0.0125 .10255 0 4.5 ]
[-0.0125 .33804 -12 -4.5 ]
[-0.0125 .33804 0 4.5 ]
[-0.0125 .57353 -12 -4.5 ]
[-0.0125 .57353 0 4.5 ]
[-0.0125 .80902 -6 -4.5 ]
[-0.0125 .80902 0 4.5 ]
[-0.0125 1.04451 -6 -4.5 ]
[-0.0125 1.04451 0 4.5 ]
[-0.0125 1.28 -6 -4.5 ]
[-0.0125 1.28 0 4.5 ]
[-0.0125 1.51549 -6 -4.5 ]
[-0.0125 1.51549 0 4.5 ]
[ 0 0 -0.125 0 ]
[-0.01875 .80902 -46.625 -6.59375 ]
[-0.01875 .80902 -12 6.59375 ]
[ 0 1.61803 .125 0 ]
[.5 1.63053 -5.0625 0 ]
[.5 1.63053 5.0625 13.1875 ]
[ 1 0 .125 0 ]
[1.0125 .80902 0 -6.59375 ]
[1.0125 .80902 10.125 6.59375 ]
[.5 1.63053 -133.188 13.1875 ]
[.5 1.63053 133.188 35.6875 ]
[ 0 0 0 0 ]
[ 1 1.61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.07443 0 m
.07443 .00625 L
s
[(-10)] .07443 -0.0125 0 1 Mshowa
.22329 0 m
.22329 .00625 L
s
[(-8)] .22329 -0.0125 0 1 Mshowa
.37215 0 m
.37215 .00625 L
s
[(-6)] .37215 -0.0125 0 1 Mshowa
.52101 0 m
.52101 .00625 L
s
[(-4)] .52101 -0.0125 0 1 Mshowa
.66988 0 m
.66988 .00625 L
s
[(-2)] .66988 -0.0125 0 1 Mshowa
.81874 0 m
.81874 .00625 L
s
[(0)] .81874 -0.0125 0 1 Mshowa
.9676 0 m
.9676 .00625 L
s
[(2)] .9676 -0.0125 0 1 Mshowa
.125 Mabswid
.11165 0 m
.11165 .00375 L
s
.14886 0 m
.14886 .00375 L
s
.18608 0 m
.18608 .00375 L
s
.26051 0 m
.26051 .00375 L
s
.29772 0 m
.29772 .00375 L
s
.33494 0 m
.33494 .00375 L
s
.40937 0 m
.40937 .00375 L
s
.44658 0 m
.44658 .00375 L
s
.4838 0 m
.4838 .00375 L
s
.55823 0 m
.55823 .00375 L
s
.59545 0 m
.59545 .00375 L
s
.63266 0 m
.63266 .00375 L
s
.70709 0 m
.70709 .00375 L
s
.74431 0 m
.74431 .00375 L
s
.78152 0 m
.78152 .00375 L
s
.85595 0 m
.85595 .00375 L
s
.89317 0 m
.89317 .00375 L
s
.93038 0 m
.93038 .00375 L
s
.03722 0 m
.03722 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
gsave
.5 -0.0125 -78.3125 -26.1875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 21.1875 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(Re) show
%%IncludeResource: font Mathematica2Mono
%%IncludeFont: Mathematica2Mono
/Mathematica2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
75.250 13.313 moveto
(@) show
81.375 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(s) show
%%IncludeResource: font Mathematica2Mono
%%IncludeFont: Mathematica2Mono
/Mathematica2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
87.500 13.313 moveto
(D) show
93.625 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 .10255 m
.00625 .10255 L
s
[(-3)] -0.0125 .10255 1 0 Mshowa
0 .33804 m
.00625 .33804 L
s
[(-2)] -0.0125 .33804 1 0 Mshowa
0 .57353 m
.00625 .57353 L
s
[(-1)] -0.0125 .57353 1 0 Mshowa
0 .80902 m
.00625 .80902 L
s
[(0)] -0.0125 .80902 1 0 Mshowa
0 1.04451 m
.00625 1.04451 L
s
[(1)] -0.0125 1.04451 1 0 Mshowa
0 1.28 m
.00625 1.28 L
s
[(2)] -0.0125 1.28 1 0 Mshowa
0 1.51549 m
.00625 1.51549 L
s
[(3)] -0.0125 1.51549 1 0 Mshowa
.125 Mabswid
0 .14965 m
.00375 .14965 L
s
0 .19674 m
.00375 .19674 L
s
0 .24384 m
.00375 .24384 L
s
0 .29094 m
.00375 .29094 L
s
0 .38514 m
.00375 .38514 L
s
0 .43223 m
.00375 .43223 L
s
0 .47933 m
.00375 .47933 L
s
0 .52643 m
.00375 .52643 L
s
0 .62063 m
.00375 .62063 L
s
0 .66772 m
.00375 .66772 L
s
0 .71482 m
.00375 .71482 L
s
0 .76192 m
.00375 .76192 L
s
0 .85611 m
.00375 .85611 L
s
0 .90321 m
.00375 .90321 L
s
0 .95031 m
.00375 .95031 L
s
0 .99741 m
.00375 .99741 L
s
0 1.0916 m
.00375 1.0916 L
s
0 1.1387 m
.00375 1.1387 L
s
0 1.1858 m
.00375 1.1858 L
s
0 1.2329 m
.00375 1.2329 L
s
0 1.32709 m
.00375 1.32709 L
s
0 1.37419 m
.00375 1.37419 L
s
0 1.42129 m
.00375 1.42129 L
s
0 1.46839 m
.00375 1.46839 L
s
0 .05545 m
.00375 .05545 L
s
0 .00835 m
.00375 .00835 L
s
0 1.56258 m
.00375 1.56258 L
s
0 1.60968 m
.00375 1.60968 L
s
.25 Mabswid
0 0 m
0 1.61803 L
s
gsave
-0.01875 .80902 -107.625 -10.5938 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 21.1875 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(Im) show
%%IncludeResource: font Mathematica2Mono
%%IncludeFont: Mathematica2Mono
/Mathematica2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
75.250 13.313 moveto
(@) show
81.375 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(s) show
%%IncludeResource: font Mathematica2Mono
%%IncludeFont: Mathematica2Mono
/Mathematica2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
87.500 13.313 moveto
(D) show
93.625 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.07443 1.61178 m
.07443 1.61803 L
s
.22329 1.61178 m
.22329 1.61803 L
s
.37215 1.61178 m
.37215 1.61803 L
s
.52101 1.61178 m
.52101 1.61803 L
s
.66988 1.61178 m
.66988 1.61803 L
s
.81874 1.61178 m
.81874 1.61803 L
s
.9676 1.61178 m
.9676 1.61803 L
s
.125 Mabswid
.11165 1.61428 m
.11165 1.61803 L
s
.14886 1.61428 m
.14886 1.61803 L
s
.18608 1.61428 m
.18608 1.61803 L
s
.26051 1.61428 m
.26051 1.61803 L
s
.29772 1.61428 m
.29772 1.61803 L
s
.33494 1.61428 m
.33494 1.61803 L
s
.40937 1.61428 m
.40937 1.61803 L
s
.44658 1.61428 m
.44658 1.61803 L
s
.4838 1.61428 m
.4838 1.61803 L
s
.55823 1.61428 m
.55823 1.61803 L
s
.59545 1.61428 m
.59545 1.61803 L
s
.63266 1.61428 m
.63266 1.61803 L
s
.70709 1.61428 m
.70709 1.61803 L
s
.74431 1.61428 m
.74431 1.61803 L
s
.78152 1.61428 m
.78152 1.61803 L
s
.85595 1.61428 m
.85595 1.61803 L
s
.89317 1.61428 m
.89317 1.61803 L
s
.93038 1.61428 m
.93038 1.61803 L
s
.03722 1.61428 m
.03722 1.61803 L
s
.25 Mabswid
0 1.61803 m
1 1.61803 L
s
gsave
.5 1.63053 -66.0625 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 21.1875 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.125 13.313 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.99375 .10255 m
1 .10255 L
s
.99375 .33804 m
1 .33804 L
s
.99375 .57353 m
1 .57353 L
s
.99375 .80902 m
1 .80902 L
s
.99375 1.04451 m
1 1.04451 L
s
.99375 1.28 m
1 1.28 L
s
.99375 1.51549 m
1 1.51549 L
s
.125 Mabswid
.99625 .14965 m
1 .14965 L
s
.99625 .19674 m
1 .19674 L
s
.99625 .24384 m
1 .24384 L
s
.99625 .29094 m
1 .29094 L
s
.99625 .38514 m
1 .38514 L
s
.99625 .43223 m
1 .43223 L
s
.99625 .47933 m
1 .47933 L
s
.99625 .52643 m
1 .52643 L
s
.99625 .62063 m
1 .62063 L
s
.99625 .66772 m
1 .66772 L
s
.99625 .71482 m
1 .71482 L
s
.99625 .76192 m
1 .76192 L
s
.99625 .85611 m
1 .85611 L
s
.99625 .90321 m
1 .90321 L
s
.99625 .95031 m
1 .95031 L
s
.99625 .99741 m
1 .99741 L
s
.99625 1.0916 m
1 1.0916 L
s
.99625 1.1387 m
1 1.1387 L
s
.99625 1.1858 m
1 1.1858 L
s
.99625 1.2329 m
1 1.2329 L
s
.99625 1.32709 m
1 1.32709 L
s
.99625 1.37419 m
1 1.37419 L
s
.99625 1.42129 m
1 1.42129 L
s
.99625 1.46839 m
1 1.46839 L
s
.99625 .05545 m
1 .05545 L
s
.99625 .00835 m
1 .00835 L
s
.99625 1.56258 m
1 1.56258 L
s
.99625 1.60968 m
1 1.60968 L
s
.25 Mabswid
1 0 m
1 1.61803 L
s
gsave
1.0125 .80902 -61 -10.5938 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 21.1875 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
69.125 13.313 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.5 1.63053 -194.188 9.1875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 30.5 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding WindowsANSIEncoding def
        currentdict
    end

    newfontname exch definefont pop
} def

63.000 17.438 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
%%BeginResource: font Courier-MISO
%%BeginFont: Courier-MISO
/Courier /Courier-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-MISO
%%IncludeFont: Courier-MISO
/Courier-MISO findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 17.438 moveto
%%IncludeResource: font Courier-MISO
%%IncludeFont: Courier-MISO
/Courier-MISO findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(G) show
%%IncludeResource: font Mathematica2Mono
%%IncludeFont: Mathematica2Mono
/Mathematica2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
69.125 17.438 moveto
(@) show
75.250 17.438 moveto
%%IncludeResource: font Courier-MISO
%%IncludeFont: Courier-MISO
/Courier-MISO findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(s) show
%%IncludeResource: font Mathematica2Mono
%%IncludeFont: Mathematica2Mono
/Mathematica2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
81.375 17.438 moveto
(D) show
87.500 17.438 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(=) show
93.625 17.438 moveto
%%IncludeResource: font Courier-MISO
%%IncludeFont: Courier-MISO
/Courier-MISO findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
%%IncludeResource: font Mathematica2Mono
%%IncludeFont: Mathematica2Mono
/Mathematica2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
170.938 11.500 moveto
(H) show
177.063 11.500 moveto
%%IncludeResource: font Courier-Italic
%%IncludeFont: Courier-Italic
%%BeginResource: font Courier-Italic-MISO
%%BeginFont: Courier-Italic-MISO
/Courier-Italic /Courier-Italic-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Italic-MISO
%%IncludeFont: Courier-Italic-MISO
/Courier-Italic-MISO findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(s) show
185.625 11.500 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(+) show
194.188 11.500 moveto
%%IncludeResource: font Courier-MISO
%%IncludeFont: Courier-MISO
/Courier-MISO findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
%%IncludeResource: font Mathematica2Mono
%%IncludeFont: Mathematica2Mono
/Mathematica2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
200.313 11.500 moveto
(L) show
208.938 11.500 moveto
(H) show
215.063 11.500 moveto
%%IncludeResource: font Courier-Italic-MISO
%%IncludeFont: Courier-Italic-MISO
/Courier-Italic-MISO findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(s) show
223.625 11.500 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(+) show
232.188 11.500 moveto
%%IncludeResource: font Courier-MISO
%%IncludeFont: Courier-MISO
/Courier-MISO findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(10) show
%%IncludeResource: font Mathematica2Mono
%%IncludeFont: Mathematica2Mono
/Mathematica2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
244.438 11.500 moveto
(L) show
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
97.938 17.438 moveto
(\\200\\200\\200\\200\\200\\200\\200\\200\\200\\200\\200\\200\\200\\200\\200\\\
200\\200\\200\\200\\200\\200\\200\\200\\200\\200\\200\\200\\200\\200\\200\\\
200\\200) show
169.938 17.438 moveto
(\\200\\200\\200\\200\\200\\200\\200\\200\\200\\200\\200\\200\\200\\200\\200\\\
200\\200\\200\\200\\200\\200\\200\\200\\200\\200\\200\\200\\200\\200\\200\\\
200\\200) show
241.938 17.438 moveto
(\\200\\200\\200\\200\\200\\200\\200\\200\\200\\200\\200\\200\\200\\200\\200\\\
200) show
277.938 17.438 moveto
(\\200\\200\\200\\200\\200\\200\\200\\200\\200\\200\\200\\200\\200\\200\\200\\\
200) show
313.938 17.438 moveto
(\\200\\200) show
318.438 17.438 moveto
(\\200) show
320.688 17.438 moveto
(\\200) show
321.063 17.438 moveto
(\\200) show
99.313 23.688 moveto
%%IncludeResource: font Courier-Italic-MISO
%%IncludeFont: Courier-Italic-MISO
/Courier-Italic-MISO findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(s) show
%%IncludeResource: font Mathematica2Mono
%%IncludeFont: Mathematica2Mono
/Mathematica2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
107.938 23.688 moveto
(H) show
114.063 23.688 moveto
%%IncludeResource: font Courier-Italic-MISO
%%IncludeFont: Courier-Italic-MISO
/Courier-Italic-MISO findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(s) show
122.625 23.688 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(+) show
131.188 23.688 moveto
%%IncludeResource: font Courier-MISO
%%IncludeFont: Courier-MISO
/Courier-MISO findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
%%IncludeResource: font Mathematica2Mono
%%IncludeFont: Mathematica2Mono
/Mathematica2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
137.313 23.688 moveto
(L) show
145.938 23.688 moveto
(H) show
152.063 23.688 moveto
%%IncludeResource: font Courier-Italic-MISO
%%IncludeFont: Courier-Italic-MISO
/Courier-Italic-MISO findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(s) show
160.625 23.688 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(+) show
169.188 23.688 moveto
%%IncludeResource: font Courier-MISO
%%IncludeFont: Courier-MISO
/Courier-MISO findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
%%IncludeResource: font Mathematica2Mono
%%IncludeFont: Mathematica2Mono
/Mathematica2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
175.313 23.688 moveto
(L) show
183.938 23.688 moveto
(H) show
190.063 23.688 moveto
%%IncludeResource: font Courier-Italic-MISO
%%IncludeFont: Courier-Italic-MISO
/Courier-Italic-MISO findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(s) show
196.188 21.125 moveto
%%IncludeResource: font Courier-MISO
%%IncludeFont: Courier-MISO
/Courier-MISO findfont 7.125 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
203.438 23.688 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(+) show
212.000 23.688 moveto
%%IncludeResource: font Courier-MISO
%%IncludeFont: Courier-MISO
/Courier-MISO findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(0.2) show
232.875 23.688 moveto
%%IncludeResource: font Courier-Italic-MISO
%%IncludeFont: Courier-Italic-MISO
/Courier-Italic-MISO findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(s) show
241.438 23.688 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(+) show
250.000 23.688 moveto
%%IncludeResource: font Courier-MISO
%%IncludeFont: Courier-MISO
/Courier-MISO findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
%%IncludeResource: font Mathematica2Mono
%%IncludeFont: Mathematica2Mono
/Mathematica2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
256.125 23.688 moveto
(L) show
264.750 23.688 moveto
(H) show
270.875 23.688 moveto
%%IncludeResource: font Courier-Italic-MISO
%%IncludeFont: Courier-Italic-MISO
/Courier-Italic-MISO findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(s) show
277.000 21.125 moveto
%%IncludeResource: font Courier-MISO
%%IncludeFont: Courier-MISO
/Courier-MISO findfont 7.125 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
284.250 23.688 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(+) show
292.813 23.688 moveto
%%IncludeResource: font Courier-Italic-MISO
%%IncludeFont: Courier-Italic-MISO
/Courier-Italic-MISO findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(s) show
301.375 23.688 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(+) show
309.938 23.688 moveto
%%IncludeResource: font Courier-MISO
%%IncludeFont: Courier-MISO
/Courier-MISO findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(1) show
%%IncludeResource: font Mathematica2Mono
%%IncludeFont: Mathematica2Mono
/Mathematica2Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
316.063 23.688 moveto
(L) show
1.000 setlinewidth
grestore
0 0 m
1 0 L
1 1.61803 L
0 1.61803 L
closepath
clip
newpath
.75 g
.5 Mabswid
.81874 .80902 m
0 0 rlineto s
.81874 .80902 m
1 .96268 L
s
.81874 .80902 m
0 0 rlineto s
.81874 .80902 m
1 1.14012 L
s
.81874 .80902 m
0 0 rlineto s
.81874 .80902 m
1 1.38251 L
s
.81874 .80902 m
0 0 rlineto s
.81874 .80902 m
.96637 1.61803 L
s
.81874 .80902 m
0 0 rlineto s
.81874 .80902 m
.88725 1.61803 L
s
.81874 .80902 m
0 0 rlineto s
.81874 .80902 m
.81874 1.61803 L
s
.81874 .80902 m
0 0 rlineto s
.81874 .80902 m
.75022 1.61803 L
s
.81874 .80902 m
0 0 rlineto s
.81874 .80902 m
.67111 1.61803 L
s
.81874 .80902 m
0 0 rlineto s
.81874 .80902 m
.56303 1.61803 L
s
.81874 .80902 m
0 0 rlineto s
.81874 .80902 m
.37584 1.61803 L
s
.81874 .80902 m
0 0 rlineto s
.81874 .80902 m
0 1.50311 L
s
.81874 .80902 m
0 0 rlineto s
.81874 .80902 m
0 .80902 L
s
.81874 .80902 m
0 0 rlineto s
.81874 .80902 m
0 .11493 L
s
.81874 .80902 m
0 0 rlineto s
.81874 .80902 m
.37584 0 L
s
.81874 .80902 m
0 0 rlineto s
.81874 .80902 m
.56303 0 L
s
.81874 .80902 m
0 0 rlineto s
.81874 .80902 m
.67111 0 L
s
.81874 .80902 m
0 0 rlineto s
.81874 .80902 m
.75022 0 L
s
.81874 .80902 m
0 0 rlineto s
.81874 .80902 m
.81874 0 L
s
.81874 .80902 m
0 0 rlineto s
.81874 .80902 m
.88725 0 L
s
.81874 .80902 m
0 0 rlineto s
.81874 .80902 m
.96637 0 L
s
.81874 .80902 m
0 0 rlineto s
.81874 .80902 m
1 .23552 L
s
.81874 .80902 m
0 0 rlineto s
.81874 .80902 m
1 .47791 L
s
.81874 .80902 m
0 0 rlineto s
.81874 .80902 m
1 .65535 L
s
.81874 .80902 m
0 0 rlineto s
.81874 .80902 m
1 .80902 L
s
.9676 .80902 m
.96642 .86805 L
.96292 .92614 L
.95715 .9824 L
.94919 1.03591 L
.93917 1.08585 L
.92725 1.13142 L
.91363 1.17191 L
.8985 1.20668 L
.88212 1.23517 L
.86474 1.25694 L
.84663 1.27165 L
.82808 1.27907 L
.80939 1.27907 L
.79084 1.27165 L
.77274 1.25694 L
.75536 1.23517 L
.73897 1.20668 L
.72385 1.17191 L
.71022 1.13142 L
.69831 1.08585 L
.68829 1.03591 L
.68033 .9824 L
.67455 .92614 L
.67105 .86805 L
.66988 .80902 L
.67105 .74999 L
.67455 .69189 L
.68033 .63564 L
.68829 .58212 L
.69831 .53218 L
.71022 .48661 L
.72385 .44612 L
.73897 .41136 L
.75536 .38286 L
.77274 .36109 L
.79084 .34638 L
.80939 .33897 L
.82808 .33897 L
.84663 .34638 L
.86474 .36109 L
.88212 .38286 L
.8985 .41136 L
.91363 .44612 L
.92725 .48661 L
.93917 .53218 L
.94919 .58212 L
.95715 .63564 L
.96292 .69189 L
.96642 .74999 L
Mistroke
.9676 .80902 L
Mfstroke
1 1.55438 m
.97827 1.60434 L
s
.97827 1.60434 m
.97039 1.61803 L
s
.66708 1.61803 m
.65921 1.60434 L
.62896 1.53481 L
.60171 1.45383 L
.57787 1.36269 L
.55784 1.26281 L
.54192 1.15577 L
.53037 1.04327 L
.52336 .92708 L
.52101 .80902 L
.52336 .69096 L
.53037 .57476 L
.54192 .46226 L
.55784 .35523 L
.57787 .25535 L
.60171 .1642 L
.62896 .08323 L
.65921 .0137 L
s
.65921 .0137 m
.66708 0 L
s
.97039 0 m
.97827 .0137 L
s
.97827 .0137 m
1 .06366 L
s
.45313 1.61803 m
.42739 1.4897 L
.40351 1.32915 L
.38618 1.1604 L
.37567 .98611 L
.37215 .80902 L
.37567 .63193 L
.38618 .45763 L
.40351 .28888 L
.42739 .12833 L
s
.42739 .12833 m
.45313 0 L
s
.28228 1.61803 m
.26511 1.50253 L
.242 1.27753 L
.22799 1.04513 L
.22329 .80902 L
.22799 .5729 L
.242 .34051 L
.26511 .1155 L
s
.26511 .1155 m
.28228 0 L
s
.12075 1.61803 m
.09781 1.39466 L
.0803 1.10416 L
.07443 .80902 L
.0803 .51387 L
.09781 .22338 L
s
.09781 .22338 m
.12075 0 L
s
.75 0 0 r
.012 w
.44613 .80902 Mdot
.63309 .80902 Mdot
.70771 .41212 Mdot
.70771 1.20591 Mdot
.85031 .32551 Mdot
.85031 1.29253 Mdot
.92557 .80902 Mdot
.75 0 .098 r
.44623 .80902 Mdot
.63705 .80902 Mdot
.71196 .42688 Mdot
.71196 1.19116 Mdot
.84755 .34061 Mdot
.84755 1.27743 Mdot
.91852 .80902 Mdot
.75 0 .195 r
.44631 .80902 Mdot
.64108 .80902 Mdot
.71647 .44226 Mdot
.71647 1.17578 Mdot
.84467 .35595 Mdot
.84467 1.26208 Mdot
.91115 .80902 Mdot
.75 0 .292 r
.44637 .80902 Mdot
.64515 .80902 Mdot
.72129 .45832 Mdot
.72129 1.15972 Mdot
.84165 .37151 Mdot
.84165 1.24652 Mdot
.90341 .80902 Mdot
.75 0 .39 r
.44643 .80902 Mdot
.64922 .80902 Mdot
.72649 .47511 Mdot
.72649 1.14293 Mdot
.83848 .38724 Mdot
.83848 1.23079 Mdot
.89523 .80902 Mdot
.75 0 .488 r
.44647 .80902 Mdot
.65323 .80902 Mdot
.73214 .49266 Mdot
.73214 1.12537 Mdot
.83514 .40303 Mdot
.83514 1.215 Mdot
.88656 .80902 Mdot
.75 0 .585 r
.44651 .80902 Mdot
.65709 .80902 Mdot
.73837 .51096 Mdot
.73837 1.10707 Mdot
.83159 .41871 Mdot
.83159 1.19932 Mdot
.87732 .80902 Mdot
.75 0 .683 r
.44654 .80902 Mdot
.66067 .80902 Mdot
.74527 .5299 Mdot
.74527 1.08814 Mdot
.82784 .43395 Mdot
.82784 1.18408 Mdot
.86741 .80902 Mdot
.72 0 .75 r
.44656 .80902 Mdot
.66381 .80902 Mdot
.75293 .54914 Mdot
.75293 1.0689 Mdot
.82389 .4482 Mdot
.82389 1.16984 Mdot
.85682 .80902 Mdot
.623 0 .75 r
.44657 .80902 Mdot
.66637 .80902 Mdot
.76127 .56796 Mdot
.76127 1.05008 Mdot
.81984 .4605 Mdot
.81984 1.15753 Mdot
.84567 .80902 Mdot
.525 0 .75 r
.44658 .80902 Mdot
.6682 .80902 Mdot
.7697 .58487 Mdot
.7697 1.03317 Mdot
.81603 .46957 Mdot
.81603 1.14846 Mdot
.83458 .80902 Mdot
.427 0 .75 r
.44658 .80902 Mdot
.66929 .80902 Mdot
.77671 .59739 Mdot
.77671 1.02064 Mdot
.81312 .4746 Mdot
.81312 1.14343 Mdot
.82529 .80902 Mdot
.33 0 .75 r
.44658 .80902 Mdot
.66977 .80902 Mdot
.78059 .60365 Mdot
.78059 1.01438 Mdot
.81164 .47646 Mdot
.81164 1.14157 Mdot
.82002 .80902 Mdot
.232 0 .75 r
.44658 .80902 Mdot
.66987 .80902 Mdot
.78151 .60506 Mdot
.78151 1.01297 Mdot
.8113 .47681 Mdot
.8113 1.14122 Mdot
.81875 .80902 Mdot
.135 0 .75 r
.44658 .80902 Mdot
.6699 .80902 Mdot
.7817 .60534 Mdot
.7817 1.01269 Mdot
.81123 .47688 Mdot
.81123 1.14115 Mdot
.8185 .80902 Mdot
.038 0 .75 r
.44658 .80902 Mdot
.67014 .80902 Mdot
.78401 .60868 Mdot
.78401 1.00935 Mdot
.81041 .47761 Mdot
.81041 1.14043 Mdot
.81527 .80902 Mdot
0 .06 .75 r
.44659 .80902 Mdot
.67093 .80902 Mdot
.79321 .61895 Mdot
.79321 .99908 Mdot
.80185 .80902 Mdot
.80752 .47881 Mdot
.80752 1.13922 Mdot
0 .158 .75 r
.44659 .80902 Mdot
.67274 .80902 Mdot
.76957 .80902 Mdot
.8015 .47355 Mdot
.8015 1.14448 Mdot
.81447 .6193 Mdot
.81447 .99873 Mdot
0 .255 .75 r
.4466 .80902 Mdot
.6765 .80902 Mdot
.74104 .80902 Mdot
.79576 .45633 Mdot
.79576 1.1617 Mdot
.83258 .60697 Mdot
.83258 1.01106 Mdot
0 .352 .75 r
.44662 .80902 Mdot
.6865 .80902 Mdot
.71254 .80902 Mdot
.79181 .43558 Mdot
.79181 1.18245 Mdot
.84577 .59555 Mdot
.84577 1.02249 Mdot
0 .45 .75 r
.44664 .80902 Mdot
.69174 .7372 Mdot
.69174 .88084 Mdot
.78891 .41468 Mdot
.78891 1.20335 Mdot
.85644 .58469 Mdot
.85644 1.03334 Mdot
0 .548 .75 r
.44667 .80902 Mdot
.68483 .70429 Mdot
.68483 .91375 Mdot
.78661 .39426 Mdot
.78661 1.22377 Mdot
.86564 .57418 Mdot
.86564 1.04386 Mdot
0 .645 .75 r
.44671 .80902 Mdot
.67851 .68213 Mdot
.67851 .93591 Mdot
.78468 .37445 Mdot
.78468 1.24358 Mdot
.87387 .56393 Mdot
.87387 1.0541 Mdot
0 .742 .75 r
.44676 .80902 Mdot
.67263 .66497 Mdot
.67263 .95306 Mdot
.78302 .35526 Mdot
.78302 1.26277 Mdot
.88139 .55393 Mdot
.88139 1.0641 Mdot
0 .75 .66 r
.44682 .80902 Mdot
.66709 .65082 Mdot
.66709 .96722 Mdot
.78155 .33666 Mdot
.78155 1.28137 Mdot
.88836 .54416 Mdot
.88836 1.07387 Mdot
0 .75 .563 r
.4469 .80902 Mdot
.66184 .63869 Mdot
.66184 .97934 Mdot
.78022 .31862 Mdot
.78022 1.29942 Mdot
.89491 .53461 Mdot
.89491 1.08342 Mdot
0 .75 .465 r
.44698 .80902 Mdot
.65683 .62804 Mdot
.65683 .98999 Mdot
.779 .30109 Mdot
.779 1.31694 Mdot
.9011 .52527 Mdot
.9011 1.09276 Mdot
0 .75 .367 r
.44709 .80902 Mdot
.65202 .61853 Mdot
.65202 .9995 Mdot
.77787 .28405 Mdot
.77787 1.33399 Mdot
.90699 .51613 Mdot
.90699 1.10191 Mdot
0 .75 .27 r
.44721 .80902 Mdot
.64739 .60993 Mdot
.64739 1.00811 Mdot
.77681 .26745 Mdot
.77681 1.35058 Mdot
.91262 .50717 Mdot
.91262 1.11086 Mdot
0 .75 .172 r
.44734 .80902 Mdot
.64291 .60206 Mdot
.64291 1.01597 Mdot
.77581 .25128 Mdot
.77581 1.36676 Mdot
.91802 .49839 Mdot
.91802 1.11964 Mdot
0 .75 .075 r
.4475 .80902 Mdot
.63857 .59482 Mdot
.63857 1.02321 Mdot
.77486 .23549 Mdot
.77486 1.38254 Mdot
.92323 .48978 Mdot
.92323 1.12826 Mdot
0 1 0 r
.0125 w
.07443 .80902 Mdot
.52101 .80902 Mdot
1 0 0 r
.44658 .80902 Mdot
.66988 .80902 Mdot
.78152 .60508 Mdot
.78152 1.01296 Mdot
.81129 .47682 Mdot
.81129 1.14122 Mdot
.81874 .80902 Mdot
MathSubEnd
P
% End of sub-graphic
% Start of sub-graphic
p
0.909028 0.369391 0.97619 0.705202 MathSubStart
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.00980392 0.490196 0.00332889 0.166445 [
[ 0 0 0 0 ]
[ 1 5 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 5 L
0 5 L
closepath
clip
newpath
.75 0 0 r
.0098 .00333 m
.0098 .16977 L
.5 .16977 L
.5 .00333 L
F
0 g
gsave
.52451 .08655 -61 -10.5938 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 21.1875 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.313 moveto
%%IncludeResource: font Mathematica1Mono
%%IncludeFont: Mathematica1Mono
/Mathematica1Mono findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(-) show
69.125 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(10) show
81.375 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.75 0 .101 r
.0098 .16977 m
.0098 .33622 L
.5 .33622 L
.5 .16977 L
F
.75 0 .202 r
.0098 .33622 m
.0098 .50266 L
.5 .50266 L
.5 .33622 L
F
.75 0 .303 r
.0098 .50266 m
.0098 .66911 L
.5 .66911 L
.5 .50266 L
F
.75 0 .403 r
.0098 .66911 m
.0098 .83555 L
.5 .83555 L
.5 .66911 L
F
.75 0 .504 r
.0098 .83555 m
.0098 1.002 L
.5 1.002 L
.5 .83555 L
F
.75 0 .605 r
.0098 1.002 m
.0098 1.16844 L
.5 1.16844 L
.5 1.002 L
F
.75 0 .706 r
.0098 1.16844 m
.0098 1.33489 L
.5 1.33489 L
.5 1.16844 L
F
.693 0 .75 r
.0098 1.33489 m
.0098 1.50133 L
.5 1.50133 L
.5 1.33489 L
F
.592 0 .75 r
.0098 1.50133 m
.0098 1.66778 L
.5 1.66778 L
.5 1.50133 L
F
.491 0 .75 r
.0098 1.66778 m
.0098 1.83422 L
.5 1.83422 L
.5 1.66778 L
F
.391 0 .75 r
.0098 1.83422 m
.0098 2.00067 L
.5 2.00067 L
.5 1.83422 L
F
.29 0 .75 r
.0098 2.00067 m
.0098 2.16711 L
.5 2.16711 L
.5 2.00067 L
F
.189 0 .75 r
.0098 2.16711 m
.0098 2.33356 L
.5 2.33356 L
.5 2.16711 L
F
.088 0 .75 r
.0098 2.33356 m
.0098 2.5 L
.5 2.5 L
.5 2.33356 L
F
0 .013 .75 r
.0098 2.5 m
.0098 2.66644 L
.5 2.66644 L
.5 2.5 L
F
0 .114 .75 r
.0098 2.66644 m
.0098 2.83289 L
.5 2.83289 L
.5 2.66644 L
F
0 .215 .75 r
.0098 2.83289 m
.0098 2.99933 L
.5 2.99933 L
.5 2.83289 L
F
0 .316 .75 r
.0098 2.99933 m
.0098 3.16578 L
.5 3.16578 L
.5 2.99933 L
F
0 .416 .75 r
.0098 3.16578 m
.0098 3.33222 L
.5 3.33222 L
.5 3.16578 L
F
0 .517 .75 r
.0098 3.33222 m
.0098 3.49867 L
.5 3.49867 L
.5 3.33222 L
F
0 .618 .75 r
.0098 3.49867 m
.0098 3.66511 L
.5 3.66511 L
.5 3.49867 L
F
0 .719 .75 r
.0098 3.66511 m
.0098 3.83156 L
.5 3.83156 L
.5 3.66511 L
F
0 .75 .68 r
.0098 3.83156 m
.0098 3.998 L
.5 3.998 L
.5 3.83156 L
F
0 .75 .579 r
.0098 3.998 m
.0098 4.16445 L
.5 4.16445 L
.5 3.998 L
F
0 .75 .478 r
.0098 4.16445 m
.0098 4.33089 L
.5 4.33089 L
.5 4.16445 L
F
0 .75 .378 r
.0098 4.33089 m
.0098 4.49734 L
.5 4.49734 L
.5 4.33089 L
F
0 .75 .277 r
.0098 4.49734 m
.0098 4.66378 L
.5 4.66378 L
.5 4.49734 L
F
0 .75 .176 r
.0098 4.66378 m
.0098 4.83023 L
.5 4.83023 L
.5 4.66378 L
F
0 .75 .075 r
.0098 4.83023 m
.0098 4.99667 L
.5 4.99667 L
.5 4.83023 L
F
0 g
gsave
.52451 4.91345 -61 -10.5938 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 21.1875 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(20.) show
81.375 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
MathSubEnd
P
% End of sub-graphic
0 0 m
1 0 L
1 1.4104 L
0 1.4104 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  CellLabel->"From In[139]:=",
  ImageSize->{344.188, 485.438},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40005H0001iA000`40O003h00OogooFGoo003oOomI
Ool00?mooeUoo`00ogooFGoo003oOomIOol00?mooeUoo`00ogooFGoo003oOomIOol00?mooeUoo`00
ogooFGoo003oOomIOol00?mooeUoo`00ogooFGoo003oOomIOol00?mooeUoo`00ogooFGoo003oOomI
Ool00?mooeUoo`00ogooFGoo003oOomIOol00?mooeUoo`00ogooFGoo003oOomIOol00?mooeUoo`00
ogooFGoo003oOomIOol00?mooeUoo`00ogooFGoo003oOomIOol00?mooeUoo`00ogooFGoo003oOomI
Ool00?mooeUoo`00ogooFGoo003oOomIOol00?mooeUoo`00ogooFGoo003oOomIOol00?mooeUoo`00
ogooFGoo003oOomIOol00?mooeUoo`00ogooFGoo003oOomIOol00?mooeUoo`00ogooFGoo003oOomI
Ool00?mooeUoo`00ogooFGoo003oOomIOol009moo`8000Uoo`800:aoo`00Wgoo00<007ooOol02Goo
00<007ooOol0ZWoo002@Ool30002Ool00`00Oomoo`030004Ool01000Oomoogoo0`001Goo00<007oo
Ool0ZWoo002AOol01000Oomoo`000Woo00<007ooOol01Goo00<007ooOol017oo00<007ooOol00Woo
00<007ooOol0ZWoo002AOol30003Ool40004Ool01000Oomoogoo0`001Goo00<007ooOol0ZWoo002A
Ool01000Oomoo`000goo0P001Goo00@007ooOomoo`@000Aoo`03001oogoo0:Yoo`00TGoo00@007oo
Ool000Yoo`03001oogoo00Uoo`03001oogoo0:Yoo`00T7oo10002goo0P002Goo0P00[7oo003oOomI
Ool00?mooeUoo`00ogooFGoo0017Ool50002Ool2000IOol2000KOol3000NOol3000IOol4000HOol2
000KOol4001HOol004Uoo`05001oogooOol00002Ool00`00Oomoo`0EOol01000Oomoo`006Woo00@0
07ooOol001ioo`03001oogoo01Qoo`03001oogoo01Qoo`04001oogoo000JOol00`00Oomoo`1IOol0
04Uoo`05001oogooOol00002Ool00`00Oomoo`0EOol01000Oomoo`006Woo00@007ooOol001]oo`D0
01Yoo`03001oogoo01Moo`04001oogoo000KOol00`00Oomoo`1HOol0045oo`@000Aoo`05001oogoo
Ool00002Ool00`00Oomoo`0?Ool40003Ool2000EOol40002Ool3000FOol40002Ool01000Oomoo`00
57oo100017oo00<007ooOol05Woo00@007ooOol001aoo`03001oogoo05Moo`00BGoo00D007ooOomo
o`00009oo`03001oogoo01Eoo`04001oogoo000KOol00`00Oomoo`0LOol00`00Ool0000JOol01000
Oomoo`005goo00@007ooOol001Yoo`04001oogoo001HOol004Qoo`8000Aoo`8001Uoo`8001aoo`<0
01eoo`8001]oo`8001Uoo`8001aoo`8005Uoo`00ogooFGoo003oOomIOol00?mooeUoo`00ogooFGoo
003oOomIOol003Yool`0059oo`00>Woo0P003Goo00<007ooOol01goo00=NmgooOol04Goo00<007oo
Ool02Goo00=NmgooOol03goo00<007ooG_L03Woo00=NmgooOol02goo00<007ooOol01Goo00=Nmgoo
Ool04Goo00=NmgooG_L03goo00=NmgooOol02goo00=NmgooOol02goo00=NmgooOol03Goo0Ukg17oo
0P00DWoo000jOol00`00Oomoo`0FOol00ekgOomoo`0MOol00ekgOomoo`0AOol00ekgOomoo`0<Ool0
0ekgOomoo`0DOol00ekgOomoo`0@Ool00ekgOomNm`0?Ool00ekgOomoo`0;Ool00ekgOomoo`0;Ool0
0ekgOomoo`0=Ool00ekgOomNm`04Ool00`00Oomoo`1@Ool003Yoo`03001oogoo01Ioo`03G_Moogoo
01eoo`03G_Moogoo019oo`03G_Moogoo00Yoo`03G_Moogoo01Eoo`03G_Moogoo011oo`04G_Moogoo
G_L>Ool00ekgOomoo`0;Ool00ekgOomoo`0;Ool00ekgOomoo`0<Ool015kgOomooekg17oo00<007oo
Ool0D7oo000jOol00`00Oomoo`0FOol00ekgOomoo`0LOol00ekgOomoo`0COol00ekgOomoo`0:Ool0
0ekgOomoo`0EOol00ekgOomoo`0?Ool01EkgOomoogooG_L03Woo00=NmgooOol02goo00=NmgooOol0
2goo00=NmgooOol037oo00ENmgooOomooekg00=oo`03001oogoo051oo`00>Woo00<007ooOol05Goo
00=NmgooOol07Goo00=NmgooOol057oo00=NmgooOol02Goo00=NmgooOol05Woo00=NmgooOol03Woo
00ENmgooOomooekg00ioo`03G_Moogoo00]oo`03G_Moogoo00]oo`03G_Moogoo00aoo`05G_Moogoo
OomNm`03Ool00`00Oomoo`1@Ool003Yoo`03001oogoo01Eoo`03G_Moogoo01eoo`03G_Moogoo01Ao
o`03G_Moogoo00Uoo`03G_Moogoo01Ioo`03G_Moogoo00eoo`03G_Moogoo009oo`03G_Moogoo00eo
o`03G_Moogoo00Yoo`03G_Moogoo00Yoo`03G_Moogoo00eoo`03G_Moogoo009oo`04G_Moogoo001B
Ool003Yoo`03001oogoo01Eoo`03G_Moogoo01eoo`03G_Moogoo01Eoo`03G_Moogoo00Qoo`03G_Mo
ogoo01Ioo`03G_Moogoo00eoo`03G_Moogoo009oo`03G_Moogoo00eoo`03G_Moogoo00Yoo`03G_Mo
ogoo00Yoo`03G_Moogoo00eoo`03G_Moogoo009oo`04G_Moogoo001BOol003Yoo`03001oogoo01Eo
o`03G_Moogoo01eoo`03G_Moogoo01Eoo`03G_Moogoo00Moo`03G_Moogoo01Qoo`03G_Moogoo00]o
o`03G_Moogoo00=oo`03G_Moogoo00eoo`03G_Moogoo00Yoo`03G_Moogoo00Yoo`03G_Moogoo00eo
o`03G_Moogoo00=oo`03G_Moo`00059oo`00>Woo00<007ooOol05Goo00=NmgooOol07Goo00=Nmgoo
Ool05Woo00=NmgooOol01Woo00=NmgooOol067oo00=NmgooOol02goo00=NmgooOol017oo00=Nmgoo
Ool037oo00=NmgooOol02Woo00=NmgooOol02Woo00=NmgooOol037oo00=NmgooOol017oo00=Nmgoo
0000DWoo000jOol00`00Oomoo`0EOol00ekgOomoo`0MOol00ekgOomoo`0FOol00ekgOomoo`06Ool0
0ekgOomoo`0HOol00ekgOomoo`0;Ool00ekgOomoo`04Ool00ekgOomoo`0<Ool00ekgOomoo`0:Ool0
0ekgOomoo`0:Ool00ekgOomoo`0<Ool00ekgOomoo`05Ool00ekg001oo`1AOol003Yoo`8001Ioo`03
G_Moogoo01eoo`03G_Moogoo01Moo`03G_Moogoo00Eoo`03G_Moogoo01Qoo`03G_Moogoo00Yoo`03
G_Moogoo00Eoo`03G_Moogoo00aoo`03G_Moogoo00Yoo`03G_Moogoo00Yoo`03G_Moogoo00aoo`03
G_Moogoo00Eoo`03G_L007oo055oo`00>Woo00<007ooOol05Goo00=NmgooOol077oo00=NmgooOol0
6Goo00=NmgooOol017oo00=NmgooOol06Goo00=NmgooOol02Goo00=NmgooOol01Goo00=NmgooOol0
37oo00=NmgooOol02Woo00=NmgooOol02Woo00=NmgooOol037oo00=NmgooOol01Woo00<007ooOol0
D7oo000jOol00`00Oomoo`0EOol00ekgOomoo`0LOol00ekgOomoo`0IOol00ekgOomoo`03Ool00ekg
Oomoo`0JOol00ekgOomoo`08Ool00ekgOomoo`06Ool00ekgOomoo`0<Ool00ekgOomoo`0:Ool00ekg
Oomoo`0:Ool00ekgOomoo`0<Ool00ekgOomoo`06Ool00`00Oomoo`1@Ool003Yoo`03001oogoo01Ao
o`03G_Moogoo01eoo`03G_Moogoo01Yoo`03G_Moogoo009oo`03G_Moogoo01Yoo`03G_Moogoo00Qo
o`03G_Moogoo00Moo`03G_Moogoo00]oo`03G_Moogoo00Yoo`03G_Moogoo00Yoo`03G_Moogoo00]o
o`03G_Moogoo00Moo`03001oogoo051oo`00>Woo00<007ooOol057oo00=NmgooOol07Goo00=Nmgoo
Ool06Woo00=NmgooOol00Woo00=NmgooOol06goo00=NmgooOol01Woo00=NmgooOol027oo00=Nmgoo
Ool02goo00=NmgooOol02Woo00=NmgooOol02Woo00=NmgooOol02goo00=NmgooOol01goo00<007oo
Ool0D7oo000jOol00`00Oomoo`0DOol00ekgOomoo`0MOol00ekgOomoo`0KOol01EkgOomoogooG_L0
7Goo00=NmgooOol01Woo00=NmgooOol027oo00=NmgooOol02goo00=NmgooOol02Woo00=NmgooOol0
2Woo00=NmgooOol02goo00=NmgooOol01goo00<007ooOol0D7oo000jOol00`00Oomoo`0DOol00ekg
Oomoo`0MOol00ekgOomoo`0KOol01EkgOomoogooG_L07Goo00=NmgooOol01Woo00=NmgooOol027oo
00=NmgooOol02goo00=NmgooOol02Woo00=NmgooOol02Woo00=NmgooOol02goo00=NmgooOol01goo
00<007ooOol0D7oo000dOol20004Ool00`00Oomoo`0DOol00ekgOomoo`0MOol00ekgOomoo`0LOol0
15kgOomooekg7Woo00=NmgooOol017oo00=NmgooOol02Goo00=NmgooOol037oo00=NmgooOol02Goo
00=NmgooOol02Goo00=NmgooOol037oo00=NmgooOol01goo00<007ooOol0D7oo000cOol01000Oomo
o`000goo00<007ooOol057oo00=NmgooOol07Goo00=NmgooOol077oo00=NmgooG_L07goo00=Nmgoo
Ool017oo00=NmgooOol02Goo00=NmgooOol037oo00=NmgooOol02Goo00=NmgooOol02Goo00=Nmgoo
Ool037oo00=NmgooOol01goo00<007ooOol0D7oo000eOol00`00Oomoo`02Ool2000EOol00ekgOomo
o`0LOol00ekgOomoo`0NOol2G_LOOol00ekgOomoo`04Ool00ekgOomoo`0:Ool00ekgOomoo`0;Ool0
0ekgOomoo`09Ool00ekgOomoo`09Ool00ekgOomoo`0;Ool00ekgOomoo`06Ool3001BOol002eoo`@0
00Eoo`05001oogooOol0000FOol00ekgOomoo`0LOol00ekgOomoo`0OOol00ekgOomoo`0NOol00ekg
Oomoo`02Ool00ekgOomoo`0;Ool00ekgOomoo`0;Ool00ekgOomoo`09Ool00ekgOomoo`09Ool00ekg
Oomoo`0;Ool00ekgOomoo`08Ool00`00Oomoo`1@Ool003=oo`04001oogoo0003Ool00`00Oomoo`0D
Ool00ekgOomoo`0LOol00ekgOomoo`0OOol00ekgOomoo`0NOol00ekgOomoo`02Ool00ekgOomoo`0;
Ool00ekgOomoo`0;Ool00ekgOomoo`09Ool00ekgOomoo`09Ool00ekgOomoo`0;Ool00ekgOomoo`08
Ool00`00Oomoo`1@Ool003Aoo`8000Aoo`03G_Moogoo01=oo`03G_Moogoo01eoo`03G_Moogoo01mo
o`9Nmamoo`03G_Moogoo009oo`03G_Moogoo00]oo`03G_Moogoo00]oo`03G_Moogoo00Uoo`03G_Mo
ogoo00Uoo`03G_Moogoo00]oo`03G_Moogoo00Qoo`03001oogoo051oo`00>Woo00<005kgOol04goo
00=NmgooOol07Goo00=NmgooOol07Woo00=NmgooG_L087oo00ANmgooOomNm`ioo`03G_Moogoo00]o
o`03G_Moogoo00Uoo`03G_Moogoo00Uoo`03G_Moogoo00]oo`03G_Moogoo00Qoo`03001oogoo051o
o`00>Woo00<007ooG_L04goo00=NmgooOol07Goo00=NmgooOol07Woo00ANmgooOomNmamoo`04G_Mo
ogooG_L?Ool00ekgOomoo`0:Ool00ekgOomoo`09Ool00ekgOomoo`09Ool00ekgOomoo`0:Ool00ekg
Oomoo`09Ool00`00Oomoo`1@Ool003Yoo`03001oogoo009Nma5oo`03G_Moogoo01eoo`03G_Moogoo
01ioo`04G_MoogooG_LOOol00ekgOomNm`0@Ool00ekgOomoo`0:Ool00ekgOomoo`09Ool00ekgOomo
o`09Ool00ekgOomoo`0:Ool00ekgOomoo`09Ool00`00Oomoo`1@Ool003Yoo`03001oogoo009oo`03
G_Moogoo00ioo`03G_Moogoo01eoo`03G_Moogoo01ioo`05G_MoogooOomNm`0OOol2G_L@Ool00ekg
Oomoo`0:Ool00ekgOomoo`09Ool00ekgOomoo`09Ool00ekgOomoo`0:Ool00ekgOomoo`09Ool00`00
Oomoo`1@Ool003Yoo`03001oogoo00=oo`03G_Moogoo00eoo`03G_Moogoo01aoo`03G_Moogoo01mo
o`05G_MoogooOomNm`0OOol2G_L@Ool00ekgOomoo`0:Ool00ekgOomoo`09Ool00ekgOomoo`09Ool0
0ekgOomoo`0:Ool00ekgOomoo`09Ool00`00Oomoo`1@Ool003Yoo`03001oogoo00Aoo`03G_Moogoo
00aoo`03G_Moogoo01aoo`03G_Moogoo01moo`03G_Moogoo009oo`03G_Moogoo01aoo`03G_Moogoo
00moo`03G_Moogoo00Yoo`03G_Moogoo00Uoo`03G_Moogoo00Uoo`03G_Moogoo00Yoo`03G_Moogoo
00Uoo`03001oogoo051oo`00>Woo0P001Woo00=NmgooOol02goo00=NmgooOol077oo00=NmgooOol0
7Woo00=NmgooOol00goo00=NmgooOol077oo0Ukg47oo00=NmgooOol02goo00=NmgooOol027oo00=N
mgooOol027oo00=NmgooOol02goo00=NmgooOol027oo0P00DWoo000jOol00`00Oomoo`06Ool2G_L;
Ool00ekgOomoo`0LOol00ekgOomoo`0NOol00ekgOomoo`04Ool00ekgOomoo`0KOol2G_LAOol00ekg
Oomoo`0:Ool00ekgOomoo`08Ool00ekgOomoo`08Ool00ekgOomoo`0:Ool00ekgOomoo`0:Ool00`00
Oomoo`1@Ool003Yoo`03001oogoo00Qoo`03G_Moogoo00Moo`03G_Moogoo01eoo`03G_Moogoo01io
o`03G_Moogoo00Eoo`03G_Moogoo01Uoo`03G_Mooekg015oo`03G_Moogoo00Yoo`03G_Moogoo00Qo
o`03G_Moogoo00Qoo`03G_Moogoo00Yoo`03G_Moogoo00Yoo`03001oogoo051oo`00>Woo00<007oo
Ool02Goo00=NmgooOol01Woo00=NmgooOol07Goo00=NmgooOol07Woo00=NmgooOol01Goo00=Nmgoo
Ool06Goo00=NmgooG_L04Goo00=NmgooOol02Woo00=NmgooOol027oo00=NmgooOol027oo00=Nmgoo
Ool02Woo00=NmgooOol02Woo00<007ooOol0D7oo000jOol00`00Oomoo`0:Ool00ekgOomoo`05Ool0
0ekgOomoo`0MOol00ekgOomoo`0NOol00ekgOomoo`06Ool00ekgOomoo`0HOol015kgOomooekg47oo
00=NmgooOol02Woo00=NmgooOol027oo00=NmgooOol027oo00=NmgooOol02Woo00=NmgooOol02Woo
00<007ooOol0D7oo000jOol00`00Oomoo`0;Ool00ekgOomoo`04Ool00ekgOomoo`0MOol00ekgOomo
o`0NOol00ekgOomoo`06Ool00ekgOomoo`0GOol01EkgOomoogooG_L047oo00=NmgooOol02Woo00=N
mgooOol027oo00=NmgooOol027oo00=NmgooOol02Woo00=NmgooOol02Woo00<007ooOol0D7oo000j
Ool00`00Oomoo`0<Ool00ekgOomoo`03Ool00ekgOomoo`0MOol00ekgOomoo`0MOol00ekgOomoo`08
Ool00ekgOomoo`0FOol01EkgOomoogooG_L04Goo00=NmgooOol02Goo00=NmgooOol027oo00=Nmgoo
Ool027oo00=NmgooOol02Goo00=NmgooOol02goo00<007ooOol0D7oo000jOol00`00Oomoo`0=Ool2
G_L3Ool00ekgOomoo`0LOol00ekgOomoo`0NOol00ekgOomoo`08Ool00ekgOomoo`0FOol00ekgOomo
o`02Ool00ekgOomoo`0>Ool00ekgOomoo`09Ool00ekgOomoo`08Ool00ekgOomoo`08Ool00ekgOomo
o`09Ool00ekgOomoo`0;Ool00`00Oomoo`1@Ool003Yoo`03001oogoo00moo`04G_MoogooG_LNOol0
0ekgOomoo`0NOol00ekgOomoo`09Ool00ekgOomoo`0EOol00ekgOomoo`02Ool00ekgOomoo`0>Ool0
0ekgOomoo`09Ool00ekgOomoo`08Ool00ekgOomoo`08Ool00ekgOomoo`09Ool00ekgOomoo`0;Ool0
0`00Oomoo`1@Ool003Yoo`80015oo`03G_Mooekg01ioo`03G_Moogoo01ioo`03G_Moogoo00Uoo`03
G_Moogoo01Aoo`03G_Moogoo00=oo`03G_Moogoo00ioo`03G_Moogoo00Uoo`03G_Moogoo00Qoo`03
G_Moogoo00Qoo`03G_Moogoo00Uoo`03G_Moogoo00Yoo`80059oo`00>Woo00<007ooOol04Goo0Ukg
7Woo00=NmgooOol07Woo00=NmgooOol02Woo00=NmgooOol04goo00=NmgooOol017oo00=NmgooOol0
3Goo00=NmgooOol02Goo00=NmgooOol027oo00=NmgooOol027oo00=NmgooOol02Goo00=NmgooOol0
2goo00<007ooOol0D7oo000jOol00`00Oomoo`0AOol2G_LNOol00ekgOomoo`0NOol00ekgOomoo`0:
Ool00ekgOomoo`0COol00ekgOomoo`04Ool00ekgOomoo`0=Ool00ekgOomoo`09Ool00ekgOomoo`08
Ool00ekgOomoo`07Ool00ekgOomoo`09Ool00ekgOomoo`0<Ool00`00Oomoo`1@Ool003Yoo`03001o
ogoo015oo`03G_Mooekg01eoo`03G_Moogoo01eoo`03G_Moogoo00aoo`03G_Moogoo015oo`03G_Mo
ogoo00Eoo`03G_Moogoo00ioo`03G_Moogoo00Uoo`03G_Moogoo00Moo`03G_Moogoo00Moo`03G_Mo
ogoo00Uoo`03G_Moogoo00aoo`03001oogoo051oo`00>Woo00<007ooOol04Goo00=NmgooOol00Ukg
6goo00=NmgooOol07Goo00=NmgooOol03Goo00=NmgooOol047oo00=NmgooOol01Woo00=NmgooOol0
3Goo00=NmgooOol02Goo00=NmgooOol01goo00=NmgooOol01goo00=NmgooOol02Goo00=NmgooOol0
37oo00<007ooOol0D7oo000jOol00`00Oomoo`0AOol00ekgOomoo`02Ool00ekgOomoo`0HOol00ekg
Oomoo`0MOol00ekgOomoo`0=Ool00ekgOomoo`0@Ool00ekgOomoo`06Ool00ekgOomoo`0=Ool00ekg
Oomoo`09Ool00ekgOomoo`07Ool00ekgOomoo`07Ool00ekgOomoo`09Ool00ekgOomoo`0<Ool00`00
Oomoo`1@Ool003Yoo`03001oogoo015oo`03G_Moogoo00=oo`03G_Moogoo01Moo`03G_Moogoo01eo
o`03G_Moogoo00ioo`03G_Moogoo00moo`03G_Moogoo00Ioo`03G_Moogoo00eoo`03G_Moogoo00Uo
o`03G_Moogoo00Moo`03G_Moogoo00Moo`03G_Moogoo00Uoo`03G_Moogoo00aoo`03001oogoo051o
o`00>Woo00<007ooOol04Goo00=NmgooOol017oo00=NmgooOol05Goo00=NmgooOol07Woo00=Nmgoo
Ool03Woo00=NmgooOol03Woo00=NmgooOol027oo00=NmgooOol037oo00=NmgooOol02Goo00=Nmgoo
Ool01goo00=NmgooOol01goo00=NmgooOol02Goo00=NmgooOol037oo00<007ooOol0D7oo000jOol0
0`00Oomoo`0AOol00ekgOomoo`05Ool00ekgOomoo`0DOol00ekgOomoo`0NOol00ekgOomoo`0?Ool0
0ekgOomoo`0=Ool00ekgOomoo`08Ool00ekgOomoo`0=Ool00ekgOomoo`08Ool00`;ROomoo`07Ool0
0ekgOomoo`07Ool00ekgOomoo`08Ool00ekgOomoo`0=Ool00`00Oomoo`1@Ool003Yoo`03001oogoo
015oo`03G_Moogoo00Ioo`9NmaAoo`03G_Moogoo01ioo`03G_Moogoo00moo`03G_Moogoo00eoo`03
G_Moogoo00Qoo`03G_Moogoo00eoo`03G_Moogoo00Qoo`030^9oogoo00Moo`03G_Moogoo00Moo`03
G_Moogoo00Qoo`03G_Moogoo00eoo`03001oogoo051oo`00>Woo0P004Woo00=NmgooOol027oo00=N
mgooOol04Goo00=NmgooOol07Goo00=NmgooOol04Goo00=NmgooOol037oo00=NmgooOol02Goo00=N
mgooOol037oo00=NmgooOol027oo00=NmgooOol01goo00=NmgooOol01goo00=NmgooOol027oo00=N
mgooOol037oo00=Nm`00Ool0DGoo000jOol00`00Oomoo`0AOol00ekgOomoo`09Ool00ekgOomoo`0@
Ool00ekgOomoo`0MOol00ekgOomoo`0AOol00ekgOomoo`0;Ool00ekgOomoo`0:Ool00ekgOomoo`0<
Ool00ekgOomoo`08Ool00ekg0^Eoo`07Ool00ekgOomoo`07Ool00ekgOomoo`08Ool00ekgOomoo`0<
Ool00ekg001oo`1AOol003Yoo`03001oogoo015oo`03G_Moogoo00Yoo`03G_Moogoo00moo`03G_Mo
ogoo01eoo`03G_Moogoo019oo`03G_Moogoo00Yoo`03G_Moogoo00Yoo`03G_Moogoo00aoo`03G_Mo
ogoo00Qoo`03G_L2iGoo00Moo`03G_Moogoo00Moo`03G_Moogoo00Qoo`03G_Moogoo00aoo`03G_L0
07oo055oo`00>Woo00<007ooOol04Goo00=NmgooOol02goo00=NmgooOol03Woo00=NmgooOol07Goo
00=NmgooOol04goo00=NmgooOol02Goo00=NmgooOol02Woo00=NmgooOol03Goo00=NmgooOol01goo
00=NmgooOol01goo00=NmgooOol01goo00=NmgooOol01goo00=NmgooOol037oo00=Nmgoo0000DWoo
000jOol00`00Oomoo`0@Ool00ekgOomoo`0=Ool00ekgOomoo`0=Ool00ekgOomoo`0MOol00ekgOomo
o`0COol00ekgOomoo`09Ool00ekgOomoo`0;Ool00ekgOomoo`0<Ool00ekgOomoo`08Ool00ekgOomo
o`06Ool00ekgOomoo`06Ool00ekgOomoo`08Ool00ekgOomoo`0<Ool00ekgOol0001BOol003Yoo`03
001oogoo011oo`03G_Moogoo00ioo`9Nm`eoo`03G_Moogoo01eoo`03G_Moogoo01Aoo`03G_Moogoo
00Moo`03G_Moogoo00aoo`03G_Moogoo00aoo`03G_Moogoo00Qoo`030^Qoogoo00Ioo`03G_Moogoo
00Ioo`03G_Moogoo00Qoo`03G_Moogoo00aoo`03G_Moo`00059oo`00>Woo00<007ooOol047oo00=N
mgooOol047oo00=NmgooOol02Woo00=NmgooOol077oo00=NmgooOol05Goo00=NmgooOol01goo00=N
mgooOol037oo00=NmgooOol037oo00=NmgooOol027oo00<2j7ooOol01Woo00=NmgooOol01Woo00=N
mgooOol027oo00=NmgooOol02goo00ANmgooOol0059oo`00>Woo00<007ooOol047oo00=NmgooOol0
4Goo00=NmgooOol027oo00=NmgooOol07Goo00=NmgooOol05Woo00=NmgooOol01Woo00=NmgooOol0
3Goo00=NmgooOol02goo00=NmgooOol027oo00=NmgooOol01Woo00=NmgooOol01Woo00=NmgooOol0
27oo00=NmgooOol02goo00ANmgooOol0039oo`]L00Aoo`@000eoo`00>Woo00<007ooOol047oo00=N
mgooOol04Woo00=NmgooOol01goo00=NmgooOol07Goo00=NmgooOol05Woo00=NmgooOol01Woo00=N
mgooOol03Goo00=NmgooOol02goo00=NmgooOol027oo00<2jgooOol01Woo00=NmgooOol01Woo00=N
mgooOol027oo00=NmgooOol02goo00ANmgooOol0039oo`]L01Eoo`00>Woo00<007ooOol047oo00=N
mgooOol04goo00=NmgooOol01Woo00=NmgooOol07Goo00=NmgooOol05goo00=NmgooOol01Goo00=N
mgooOol03Goo00=NmgooOol037oo00=NmgooOol01goo00<2jgooOol01Woo00=NmgooOol01Woo00=N
mgooOol01goo00=NmgooOol037oo00ANmgooOol0039oo`]L01Eoo`00>Woo0P004Goo00=NmgooOol0
57oo00=NmgooOol01Goo00=NmgooOol07Goo00=NmgooOol05goo00=NmgooOol017oo00=NmgooOol0
3goo00=NmgooOol02goo00=NmgooOol01goo00=NmgooOol01Woo00=NmgooOol01Woo00=NmgooOol0
1goo00=NmgooOol02goo00=NmgooOol00P00<Woo2e`05Goo000jOol00`00Oomoo`0@Ool00ekgOomo
o`0EOol2G_L5Ool00ekgOomoo`0MOol00ekgOomoo`0HOol00ekgOomoo`03Ool00ekgOomoo`0?Ool0
0ekgOomoo`0;Ool00ekgOomoo`07Ool00`;^Oomoo`06Ool00ekgOomoo`06Ool00ekgOomoo`07Ool0
0ekgOomoo`0;Ool01EkgOomoogoo0000<Woo2e`35Goo000jOol00`00Oomoo`0@Ool00ekgOomoo`0G
Ool00ekgOomoo`02Ool00ekgOomoo`0MOol00ekgOomoo`0HOol00ekgOomoo`03Ool00ekgOomoo`0?
Ool00ekgOomoo`0;Ool00ekgOomoo`07Ool00`;^Oomoo`06Ool00ekgOomoo`06Ool00ekgOomoo`07
Ool00ekgOomoo`0;Ool01EkgOomoogoo0000<Woo2e`35Goo000jOol00`00Oomoo`0@Ool00ekgOomo
o`0HOol01EkgOomoogooG_L07goo00=NmgooOol06Goo00=NmgooOol00Woo00=NmgooOol047oo00=N
mgooOol02Woo00=NmgooOol01goo00=NmgooOol01Woo00=NmgooOol01Woo00=NmgooOol01goo00=N
mgooOol02Woo00=NmgooOol00Woo00<007ooOol0<7oo2e`35Goo000jOol00`00Oomoo`0@Ool00ekg
Oomoo`0IOol015kgOomooekg7Woo00=NmgooOol06goo00ENmgooOomooekg019oo`03G_Moogoo00]o
o`03G_Moogoo00Ioo`03G_Moogoo00Ioo`03G_Moogoo00Ioo`03G_Moogoo00Ioo`03G_Moogoo00]o
o`03G_Moogoo009oo`03001oogoo031oo`]L0aEoo`00>Woo00<007ooOol047oo00=NmgooOol06Woo
00=NmgooG_L07Woo00=NmgooOol06goo00ENmgooOomooekg019oo`03G_Moogoo00]oo`03G_Moogoo
00Ioo`030_9oogoo00Ioo`03G_Moogoo00Ioo`03G_Moogoo00Ioo`03G_Moogoo00]oo`03G_Moogoo
009oo`03001oogoo031oo`]L1QEoo`00>Woo00<007ooOol047oo00=NmgooOol06goo0Ukg7Woo00=N
mgooOol077oo00=NmgooG_L057oo00=NmgooOol02Woo00=NmgooOol01Woo00<2lUkgOol01Woo00=N
mgooOol00goo00=L07ooG_L02Goo00=NmgooOol02Woo00=NmgooOol00goo00<007ooOol0<7oo2e`6
5Goo000cOol40003Ool00`00Oomoo`0@Ool00ekgOomoo`0KOol00ekgOomNm`0MOol00ekgOomoo`0L
Ool00ekgOomNm`0DOol00ekgOomoo`0:Ool00ekgOomoo`07Ool00ekgOomoo`05Ool00ekgOomoo`03
Ool00e`0OomNm`09Ool00ekgOomoo`0:Ool00ekgOomoo`03Ool00`00Oomoo`0`Ool;G0HEOol003=o
o`03001oogoo00Aoo`03001oogoo011oo`03G_Moogoo01]oo`04G_MoogooG_LLOol00ekgOomoo`0M
Ool2G_LDOol00ekgOomoo`0:Ool00ekgOomoo`07Ool00ekgOomoo`05Ool00ekgOomoo`05Ool00ekg
Oomoo`07Ool00ekgOomoo`0:Ool00ekgOomoo`03Ool00`00Oomoo`0`Ool;G0HEOol003Aoo`03001o
ogoo00=oo`80011oo`03G_Moogoo01aoo`05G_MoogooOomNm`0KOol00ekgOomoo`0MOol2G_LEOol0
0ekgOomoo`09Ool00ekgOomoo`07Ool00`;eOomoo`03Ool5G_L2Ool015`3Oomooekg2Goo00=Nmgoo
Ool02Goo00=NmgooOol00Woo0`00<Woo2e`95Goo000]Ool40004Ool00`00Oomoo`02Ool00`00Oomo
o`0?Ool00ekgOomoo`0LOol00ekgOomoo`02Ool00ekgOomoo`0HOol00ekgOomoo`0NOol00ekgOomo
o`0COol00ekgOomoo`0:Ool00ekgOomoo`06Ool010;eOomoogoo0Ukg0Woo00=NmgooOol00Ukg00AL
0gooOomNm`Qoo`03G_Moogoo00Yoo`03G_Moogoo00Aoo`03001oogoo031oo`]L2AEoo`00<goo00@0
07ooOol000=oo`03001oogoo00moo`03G_Moogoo01aoo`03G_Moogoo00=oo`03G_Moogoo01Moo`03
G_Moogoo01eoo`9NmaEoo`03G_Moogoo00Yoo`03G_Moogoo00Ioo`04G_MooekgG_L4Ool00ekgOomo
o`02Ool2G_L00gooG_Moo`07Ool00ekgOomoo`0:Ool00ekgOomoo`04Ool00`00Oomoo`0`Ool;G0TE
Ool003Aoo`8000Aoo`03001oogoo00moo`03G_Moogoo01aoo`03G_Moogoo00Aoo`9NmaIoo`03G_Mo
ogoo01ioo`03G_Mooekg01Eoo`03G_Moogoo00Uoo`03G_Moogoo00Ioo`030_MNmgoo00Eoo`03G_Mo
ogoo009oo`04G0IooekgG_L8Ool00ekgOomoo`09Ool00ekgOomoo`05Ool00`00Oomoo`0`Ool;G0`E
Ool003Yoo`03001oogoo00moo`03G_Moogoo01aoo`03G_Moogoo00Ioo`03G_Moogoo01=oo`03G_Mo
ogoo01ioo`04G_MoogooG_LDOol00ekgOomoo`09Ool00ekgOomoo`06Ool00`;gOomoo`05Ool00ekg
Oomoo`02Ool015`6Oomooekg27oo00=NmgooOol02Goo00=NmgooOol01Goo00<007ooOol0<7oo2e`<
5Goo000jOol00`00Oomoo`0?Ool00ekgOomoo`0LOol00ekgOomoo`07Ool00ekgOomoo`0BOol00ekg
Oomoo`0NOol015kgOomooekg57oo00=NmgooOol02Goo00=NmgooOol01Goo0Ukg1goo00=NmgooOol0
1Goo0Ukg1goo00=NmgooOol02Goo00=NmgooOol01Goo00<007ooOol0<7oo2e`<5Goo000jOol00`00
Oomoo`0?Ool00ekgOomoo`0LOol00ekgOomoo`08Ool00ekgOomoo`0AOol00ekgOomoo`0NOol01Ekg
OomoogooG_L04goo00=NmgooOol02Woo00=NmgooOol00goo00=NmgooG_L01goo00=NmgooOol01Goo
00=NmgooG_L01Goo00=NmgooOol02Goo00=NmgooOol01Woo00<007ooOol0<7oo2e`<5Goo000jOol0
0`00Oomoo`0?Ool00ekgOomoo`0LOol00ekgOomoo`09Ool00ekgOomoo`0@Ool00ekgOomoo`0NOol0
1EkgOomoogooG_L057oo00=NmgooOol02Goo00=NmgooOol00Woo00ANmgooOol2U`Moo`05G_Moogoo
OomL2@03Ool015kgOomooekg17oo00=NmgooOol02Goo00=NmgooOol01Woo00<007ooOol0<7oo2e`@
5Goo000jOol00`00Oomoo`0?Ool00ekgOomoo`0LOol00ekgOomoo`0:Ool00ekgOomoo`0?Ool00ekg
Oomoo`0MOol00ekgOomoo`03Ool00ekgOomoo`0AOol00ekgOomoo`09Ool01EkgOomoogooG_L00goo
00<2UgooOol01Goo00ENmgooOomooe`900=oo`05G_MoogooOomNm`03Ool00ekgOomoo`09Ool00ekg
Oomoo`06Ool00`00Oomoo`0`Ool;G10EOol003Yoo`03001oogoo00moo`03G_Moogoo01]oo`03G_Mo
ogoo00aoo`9Nm`moo`03G_Moogoo01eoo`03G_Moogoo00=oo`03G_Moogoo015oo`03G_Moogoo00Uo
o`04G_MoogooG_L5Ool00ekgOomoo`04Ool00ekgOomoo`04Ool00ekgOomoo`03Ool015kgOomooekg
2goo00=NmgooOol01Woo00<007ooOol0<7oo2e`@5Goo000jOol2000@Ool00ekgOomoo`0KOol00ekg
Oomoo`0>Ool00ekgOomoo`0<Ool00ekgOomoo`0MOol00ekgOomoo`04Ool00ekgOomoo`0AOol00ekg
Oomoo`08Ool00ekgOomNm`06Ool00ekgOomoo`04Ool015kgOomooe`<0goo00=NmgooOol00goo00AN
mgooOomNm`Yoo`03G_Moogoo00Ioo`80039oo`]L41Eoo`00>Woo00<007ooOol03goo00=NmgooOol0
6goo00=NmgooOol03goo00=NmgooOol02goo00=NmgooOol07Goo00=NmgooOol017oo00=NmgooOol0
4Goo00=NmgooOol027oo00=NmgooG_L01Woo00<2=gooOol017oo00ANmgooOomL30=oo`03G_Moogoo
00Aoo`03G_Mooekg00Yoo`03G_Moogoo00Moo`03001oogoo031oo`]L4aEoo`00>Woo00<007ooOol0
3goo00=NmgooOol06goo00=NmgooOol047oo00=NmgooOol02Goo00=NmgooOol07Woo00=NmgooOol0
1Goo00=NmgooOol047oo00=NmgooOol02Goo00=NmgooOol01Goo00<2=gooOol017oo00=NmgooOol0
17oo00=NmgooOol017oo0Ukg2goo00=NmgooOol01goo00<007ooOol0<7oo2e`C5Goo000jOol00`00
Oomoo`0?Ool00ekgOomoo`0KOol00ekgOomoo`0AOol00ekgOomoo`08Ool00ekgOomoo`0NOol00ekg
Oomoo`05Ool00ekgOomoo`0AOol00ekgOomoo`08Ool00ekgOomoo`05Ool00ekgOomoo`04Ool015kg
Oomooe`?0goo00=NmgooOol01Goo00=NmgooOol027oo00=NmgooOol027oo00<007ooOol0<7oo2e`C
5Goo000jOol00`00Oomoo`0>Ool00ekgOomoo`0LOol00ekgOomoo`0BOol2G_L8Ool00ekgOomoo`0N
Ool00ekgOomoo`06Ool00ekgOomoo`0@Ool00ekgOomoo`07Ool2G_L7Ool00ekgOomoo`04Ool015kg
Oomooe`?0goo00=NmgooOol01Goo00=NmgooOol027oo00=NmgooOol027oo00<007ooOol0<7oo2e`C
5Goo000jOol00`00Oomoo`0>Ool00ekgOomoo`0LOol00ekgOomoo`0DOol00ekgOomoo`05Ool00ekg
Oomoo`0MOol00ekgOomoo`08Ool00ekgOomoo`0?Ool015kgOomooe`01Woo0Ukg1goo00<1egooOol0
17oo00=NmgooOol017oo00=NmgooOol01Goo0Ukg2Goo00=NmgooOol027oo00<007ooOol0<7oo2e`F
5Goo000jOol00`00Oomoo`0>Ool00ekgOomoo`0LOol00ekgOomoo`0EOol00ekgOomoo`04Ool00ekg
Oomoo`0MOol00ekgOomoo`08Ool00ekgOomoo`0@Ool00ekgOomL0006Ool2G_L7Ool00`7GOomoo`04
Ool00ekgOomL4P04Ool00ekgOomoo`05Ool2G_L8Ool00ekgOomoo`09Ool00`00Oomoo`0`Ool;G1HE
Ool003Yoo`03001oogoo00ioo`03G_Moogoo01aoo`03G_Moogoo01Ioo`03G_Moogoo00=oo`03G_Mo
ogoo01eoo`03G_Moogoo00Uoo`03G_Moogoo00moo`03G_Moogoo00Eoo`04G_MoogooG_L6Ool00ekg
Oomoo`04Ool00ekgOomL4P04Ool00ekgOomoo`04Ool015kgOomooekg1goo00=NmgooOol02Goo00<0
07ooOol0<7oo2e`F5Goo000jOol00`00Oomoo`0>Ool00ekgOomoo`0LOol00ekgOomoo`0GOol00ekg
Oomoo`02Ool00ekgOomoo`0MOol00ekgOomoo`09Ool00ekgOomoo`0?Ool015kgOomooe`317oo00AN
mgooOomNm`Ioo`03G_Moogoo00Aoo`03G_Moogoo00Aoo`03G_Moogoo00Aoo`04G_MoogooG_L7Ool0
0ekgOomoo`09Ool00`00Oomoo`0`Ool;G1HEOol003Yoo`8000moo`03G_Moogoo01aoo`03G_Moogoo
01Qoo`05G_MoogooOomNm`0OOol00ekgOomoo`0:Ool00ekgOomoo`0?Ool00ekgOomL0`03Ool01Ekg
OomoogooG_L01Woo00=NmgooOol017oo00=Nme`EOol017oo00=NmgooOol017oo00ENmgooOomooekg
00Eoo`03G_Moogoo00Uoo`80039oo`]H5aEoo`00>Woo00<007ooOol03Woo00=NmgooOol077oo00=N
mgooOol06Goo0ekg87oo00=NmgooOol02Woo00=NmgooOol03goo00=NmgooOol00goo00ENmgooOomo
oekg00Moo`030GMoogoo00=oo`03G_ML5Goo00=oo`03G_Moogoo00Eoo`05G_MoogooOomNm`05Ool0
0ekgOomoo`0:Ool00`00Oomoo`0`Ool;F1LEOol003Yoo`03001oogoo00ioo`03G_Moogoo01aoo`03
G_Moogoo01]oo`03G_Moogoo01ioo`03G_Moogoo00]oo`03G_Moogoo00ioo`06G_MoogooG0Iooekg
17oo00=NmgooOol01Goo00<1MgooOol00goo00=NmgooOol00goo00=NmgooOol01Goo00=NmgooOol0
0Woo00=NmgooOol00Woo00=NmgooOol02Woo00<007ooOol0<7oo2ePG5Goo000jOol00`00Oomoo`0>
Ool00ekgOomoo`0LOol00ekgOomoo`0KOol2G_LNOol00ekgOomoo`0<Ool00ekgOomoo`0?Ool01Ekg
OomL1WooG_L017oo00=NmgooOol01Goo00=NmgooOol00goo00=L5gooOol00goo00=NmgooOol01Goo
00=NmgooOol00Woo00ENmgooOomooekg00eoo`03001oogoo031oo`]H5aEoo`00>Woo00<007ooOol0
3Woo00=NmgooOol077oo00=NmgooOol06goo00=NmgooG_L07Goo00=NmgooOol03Goo00=NmgooOol0
3Woo00ENmgooOomooekg00Eoo`03G_Moogoo00Aoo`03G_Moogoo00=oo`03G1Moogoo00=oo`03G_Mo
ogoo00Aoo`03G_Moogoo00=oo`05G_MoogooOomNm`0=Ool00`00Oomoo`0`Ool;B1LEOol003Yoo`03
001oogoo00ioo`03G_Moogoo01aoo`03G_Moogoo01]oo`04G_MoogooG_LLOol00ekgOomoo`0=Ool0
0ekgOomoo`0>Ool015kgOomooe`91Woo00=NmgooOol017oo00=Nm`4GOol00goo00=NmgooOol00goo
00=NmgooOol017oo00=NmgooOol017oo00ANmgooOomNm`eoo`03001oogoo031oo`]85aEoo`00>Woo
00<007ooOol03Woo00=NmgooOol06goo00=NmgooOol077oo00ENmgooOomooekg01]oo`03G_Moogoo
00ioo`03G_Moogoo00eoo`04G_MoogooG0T6Ool00ekgOomoo`04Ool00ekg0AMoo`03Ool00d`GOomo
o`03Ool00ekgOomoo`04Ool00ekgOomoo`04Ool00ekgOomNm`0>Ool00`00Oomoo`0`Ool;B1LEOol0
03Yoo`03001oogoo00ioo`03G_Moogoo01]oo`03G_Moogoo01aoo`03G_Moogoo009oo`9NmaUoo`03
G_Moogoo00moo`03G_Moogoo00eoo`9Nm`Moo`03G_Moogoo00Aoo`03G_Moogoo009oo`03@1M<5goo
00Aoo`03G_Moogoo00Aoo`03G_Moogoo00Aoo`03G_Mooekg00ioo`03001oogoo031oo`]85aEoo`00
>Woo00<007ooOol03Woo00=NmgooOol06goo00=NmgooOol077oo00=NmgooOol017oo00=NmgooOol0
5Woo00=NmgooOol03goo00=NmgooOol03Goo0Ukg1goo00=NmgooOol017oo00MNmgoo0;Mooc@G@1MN
m`05Ool00ekgOomoo`04Ool00ekgOomoo`05Ool2G_L>Ool00`00Oomoo`0`Ool;?1LEOol003Yoo`03
001oogoo00ioo`03G_Moogoo01]oo`03G_Moogoo01aoo`03G_Moogoo00Eoo`03G_Moogoo01Eoo`03
G_Moogoo011oo`03G_Moogoo00aoo`9Nm`03OomL37oo00Eoo`03G_Moogoo00=oo`07G_Moo`2g03Ml
07ooG_L01Goo00=NmgooOol00goo00=NmgooOol01Woo0Ukg3Woo00<007ooOol0<7oo2c`G5Goo000j
Ool2000>Ool00ekgOomoo`0LOol00ekgOomoo`0LOol00ekgOomoo`06Ool00ekgOomoo`0DOol00ekg
Oomoo`0@Ool00ekgOomoo`0<Ool2G_L00gooG0aoo`05Ool00ekgOomoo`03Ool01ekgOomoo`0gO01o
oekg00Eoo`03G_Moogoo00=oo`03G_Moogoo00Ioo`9Nm`eoo`03G_L007oo035oo`/l5aEoo`00>Woo
00<007ooOol03Goo00=NmgooOol077oo00=NmgooOol077oo00=NmgooOol01goo00=NmgooOol04goo
00=NmgooOol04Goo00=NmgooOol02goo0Ukg27oo00=NmgooOol00goo00=NmgooOol00goo00=Nmgoo
Ool00goo00=NmgooOol00goo00=NmgooOol01Woo0Ukg3Goo00=Nm`00Ool0<Goo2c0G5Goo000jOol0
0`00Oomoo`0=Ool00ekgOomoo`0LOol00ekgOomoo`0LOol00ekgOomoo`08Ool2G_LBOol00ekgOomo
o`0BOol00ekgOomoo`0;Ool2G_L2Ool00e`?Oomoo`03Ool00ekgOomoo`03Ool00ekgOomoo`03Ool0
0ekgOomoo`03Ool00ekgOomoo`03Ool00ekgOomoo`05Ool00`;RG_MNm`0<Ool00ekgOol0000bOol;
<1LEOol003Yoo`03001oogoo00eoo`03G_Moogoo01aoo`03G_Moogoo01aoo`03G_Moogoo00Yoo`03
G_Moogoo00moo`03G_Moogoo01=oo`03G_Moogoo00Yoo`05G_MooekgOomL3`05Ool00ekgOomoo`04
Ool00ekgOomoo`02Ool00ekgOomoo`02Ool00ekgOomoo`04Ool00ekgOomoo`04Ool010;U0^9ooekg
37oo00=Nmgoo0000<Woo2c0G5Goo000jOol00`00Oomoo`0=Ool00ekgOomoo`0LOol00ekgOomoo`0K
Ool00ekgOomoo`0<Ool00ekgOomoo`0>Ool00ekgOomoo`0COol00ekgOomoo`09Ool015kgOomooekg
1goo00=NmgooOol017oo00=NmgooOol00Woo00=NmgooOol00Woo00=NmgooOol017oo00=NmgooOol0
17oo00D2iEkgOomooekg00Yoo`04G_Moogoo000bOol;<1LEOol003Yoo`03001oogoo00eoo`03G_Mo
ogoo01aoo`03G_Moogoo01]oo`03G_Moogoo00eoo`03G_Moogoo00eoo`03G_Moogoo01Aoo`03G_Mo
ogoo00Qoo`04G_MoogooG_L8Ool00ekgOomoo`03Ool00ekgOomoo`02Ool00ekgOomoo`02Ool00ekg
Oomoo`03Ool00ekgOomoo`04Ool00`;XOomNm`02Ool00ekgOomoo`08Ool015kgOomoo`00<Woo2b@G
5Goo000jOol00`00Oomoo`0=Ool00ekgOomoo`0LOol00ekgOomoo`0KOol00ekgOomoo`0>Ool00ekg
Oomoo`0<Ool00ekgOomoo`0EOol00ekgOomoo`07Ool01ekgOomoogooG_Mooe`B00Eoo`03G_Moogoo
00=oo`03G_Moogoo009oo`03G_Moogoo009oo`03G_Moogoo00=oo`03G_Moogoo00Aoo`030^QNmgoo
009oo`03G_Moogoo00Moo`05G_MoogooOol0000bOol;91LEOol003Yoo`03001oogoo00eoo`03G_Mo
ogoo01aoo`03G_Moogoo01]oo`03G_Moogoo00moo`03G_Moogoo00]oo`03G_Moogoo01Eoo`03G_Mo
ogoo00Moo`07G_MoogooOomNmgooG1801Goo00=NmgooOol00goo00=NmgooOol00Woo00=NmgooOol0
0Woo00=NmgooOol00goo00=NmgooOol00goo00<2jgooG_L00goo00=NmgooOol01goo00ENmgooOomo
o`00039oo`/T5aEoo`00>Woo00<007ooOol03Goo00=NmgooOol077oo00=NmgooOol06goo00=Nmgoo
Ool047oo0Ukg2goo00=NmgooOol05Woo00=NmgooOol01Goo00=NmgooOol00Woo00=NmgooOol01Goo
00=NmgooOol00goo00=NmgooOol00Woo00=NmgooOol00Woo00=NmgooOol00goo00=NmgooOol00goo
00<2jgooG_L017oo00=NmgooOol01Goo00=NmgooOol00Woo00<007ooOol0<7oo2b@G5Goo000jOol2
000>Ool00ekgOomoo`0LOol00ekgOomoo`0KOol00ekgOomoo`0BOol00ekgOomoo`08Ool00ekgOomo
o`0FOol00ekgOomoo`05Ool00ekgOomoo`03Ool00ekgOomoo`04Ool00ekgOomoo`03Ool00ekgOomo
o`02Ool00ekgOomoo`02Ool00ekgOomoo`03Ool00ekgOomoo`02Ool00`;^OomNm`05Ool00ekgOomo
o`05Ool015kgOomoogoo0P00<Woo2aPG5Goo000jOol00`00Oomoo`0=Ool00ekgOomoo`0LOol00ekg
Oomoo`0KOol00ekgOomoo`0COol00ekgOomoo`07Ool00ekgOomoo`0GOol00ekgOomoo`04Ool00ekg
Oomoo`03Ool00ekgOomL5@05Ool00ekgOomoo`02Ool00ekgOomoo`02Ool00ekgOomoo`02Ool00ekg
Oomoo`02Ool00ekgOomoo`03Ool00`;^OomNm`05Ool00ekgOomoo`04Ool00ekgOomoo`03Ool00`00
Oomoo`0`Ool;61LEOol003Yoo`03001oogoo00eoo`03G_Moogoo01aoo`03G_Moogoo01]oo`03G_Mo
ogoo01Aoo`03G_Moogoo00Ioo`03G_Moogoo01Moo`03G_Moogoo00Aoo`03G_Moogoo00=oo`03G_Mo
oe`E00Eoo`03G_Moogoo009oo`03G_Moogoo009oo`03G_Moogoo009oo`03G_Moogoo009oo`03G_Mo
ogoo009oo`040_9oogooG_L5Ool00ekgOomoo`03Ool00ekgOomoo`04Ool00`00Oomoo`0`Ool;61LE
Ool003Yoo`03001oogoo00eoo`03G_Moogoo01]oo`03G_Moogoo01aoo`03G_Moogoo01Eoo`03G_Mo
ogoo00Eoo`03G_Moogoo01Qoo`03G_Moogoo00=oo`03G_Moogoo00Aoo`03G_Moogoo00Aoo`03G_Mo
ogoo009oo`03G_Moogoo009oo`03G_Moogoo009oo`03G_Moogoo009oo`03G_Moogoo009oo`030_9o
oekg00Ioo`03G_Moogoo00=oo`03G_Moogoo00Aoo`03001oogoo031oo`/H5aEoo`00>Woo00<007oo
Ool03Goo00=NmgooOol06goo00=NmgooOol077oo00=NmgooOol05Woo0Ukg1Goo00=NmgooOol067oo
00=NmgooOol00Woo00=NmgooOol01Goo00=NmgooOol017oo00=NmgooOol00Woo00=NmgooOol00Woo
00=NmgooOol00Woo00=NmgooOol00Woo00ANmgooOol2m@=oo`03G_Moogoo00Eoo`05G_MoogooOomN
m`07Ool00`00Oomoo`0`Ool;21LEOol003Yoo`03001oogoo00eoo`03G_Moogoo01]oo`03G_Moogoo
01aoo`03G_Moogoo01Qoo`05G_MoogooOomNm`0LOol01EkgOomoogooG_L01goo00ANmgooOomL5`=o
o`03G_Moogoo009oo`03G_Moogoo009oo`03G_Moogoo009oo`03G_Moogoo009oo`04G_Moogoo0_D3
Ool00ekgOomoo`05Ool01EkgOomoogooG_L01goo00<007ooOol0<7oo2`PG5Goo000jOol00`00Oomo
o`0=Ool00ekgOomoo`0KOol00ekgOomoo`0LOol00ekgOomoo`0IOol015kgOomooekg77oo00ENmgoo
Oomooekg00Qoo`03G_Mooe`G00=oo`03G_Moogoo00=oo`05G_MoogooOomNm`03Ool00ekgOomoo`03
Ool00ekgOol2m`03Ool00ekgOomoo`06Ool015kgOomooekg27oo00<007ooOol0<7oo2`PG5Goo000j
Ool00`00Oomoo`0=Ool00ekgOomoo`0KOol00ekgOomoo`0LOol00ekgOomoo`0JOol00ekgOomNm`0M
Ool015kgOomooekg27oo00=NmgooOol017oo00=NmgooOol00Woo00ENmgooOomooekg00=oo`03G_Mo
ogoo009oo`04G_Moogoo0_L3Ool00ekgOomoo`06Ool015kgOomooekg27oo00<007ooOol0<7oo2`PG
5Goo000cOol50002Ool00`00Oomoo`0=Ool00ekgOomoo`0KOol00ekgOomoo`0LOol00ekgOomoo`0K
Ool2G_LNOol00ekgOomNm`08Ool01EkgOomoogooC1L00Woo00=NmgooOol00Woo00ENmgooOomooekg
00=oo`03G_Moogoo009oo`03G_L2Ugoo00Aoo`03G_Moogoo00Ioo`03G_Mooekg00Uoo`03001oogoo
031oo`/05aEoo`00=Goo00<007ooOol00Woo00<007ooOol03Goo00=NmgooOol06goo00=NmgooOol0
77oo00=NmgooOol077oo00=NmgooOol077oo00=NmgooG_L027oo00ENmgooOomood`G009oo`03G_Mo
ogoo009oo`05G_MoogooOomNm`03Ool00ekgOomoo`02Ool00ekg0YMoo`03Ool00ekgOomoo`07Ool0
0ekgOomNm`09Ool00`00Oomoo`0`Ool;01LEOol003Eoo`03001oogoo009oo`8000ioo`03G_Moogoo
01]oo`03G_Moogoo01aoo`03G_Moogoo01aoo`=Nmaeoo`03G_Moogoo00Qoo`03G_Moogoo00=oo`03
G_Moogoo009oo`05G_MoogooOomNm`03Ool00ekgOomoo`02Ool00`8gOomoo`03Ool00ekgOomoo`08
Ool00ekgOomoo`06Ool3000bOol;01LEOol002eoo`@000Aoo`03001oogoo009oo`03001oogoo00eo
o`03G_Moogoo01]oo`03G_Moogoo01aoo`03G_Moogoo01aoo`04G_MoogooG_LLOol00ekgOomoo`08
Ool00ekgOomoo`03Ool00ekgOomoo`02Ool01EkgOomoogooG_L00goo00=NmgooOol00Woo00<2=goo
Ool00goo00=NmgooOol027oo00=NmgooOol027oo00<007ooOol0<7oo2`0G5Goo000eOol00`00Oomo
o`02Ool00`00Oomoo`0=Ool00ekgOomoo`0KOol00ekgOomoo`0LOol00ekgOomoo`0LOol01EkgOomo
ogooG_L06goo0Ukg2Goo00ENmgooOomood0G009oo`05G_MoogooOomNm`03Ool01EkgOomoogooG_L0
0Woo00<1eekgOol01Goo00=NmgooOol01goo0Ukg2Woo00<007ooOol0<7oo2`1g5Goo000dOol20004
Ool00`00Oomoo`0=Ool00ekgOomoo`0KOol00ekgOomoo`0KOol00ekgOomoo`0MOol00ekgOomoo`02
Ool00ekgOomoo`0HOol2G_L:Ool015kgOomood0G0Woo00ENmgooOomooekg00=oo`05G_MoogooOomN
m`02Ool00`7GG_Moo`04Ool00ekgOomoo`07Ool00ekgOomNm`0:Ool00`00Oomoo`0`Ool;07LEOol0
03Yoo`03001oogoo00eoo`03G_Moogoo01]oo`03G_Moogoo01]oo`03G_Moogoo01eoo`03G_Moogoo
00=oo`03G_Moogoo00aoo`030^9oogoo00Qoo`03G_Mooekg00Uoo`03G_Moogoo009oo`03=1MNmgoo
009oo`05G_MoogooOomNm`03Ool01Ekg0GMoogooG_L01Goo00=NmgooOol01goo00=NmgooG_L02Woo
00<007ooOol0<7oo2`1g5Goo000jOol00`00Oomoo`0=Ool00ekgOomoo`0KOol00ekgOomoo`0KOol0
0ekgOomoo`0MOol00ekgOomoo`04Ool00ekgOomoo`0;Ool00`;R0^Eoo`07Ool015kgOomooekg2Goo
00=NmgooOol00Woo00<d5ekgOol00Woo00ENmgooOomooekg00=oo`05G_L1MgooOomNm`05Ool00ekg
Oomoo`06Ool01EkgOomoogooG_L02Goo00<007ooOol0<7oo2`3G5Goo000jOol00`00Oomoo`0=Ool0
0ekgOomoo`0KOol00ekgOomoo`0KOol00ekgOomoo`0LOol00ekgOomoo`06Ool2G_L<Ool00`;UOomo
o`06Ool01EkgOomoogooG_L02Goo00=NmgooOol00Woo00El07ooOomooekg00=oo`05G_Moo`4GOomN
m`03Ool00ekgOomoo`02Ool00ekgOomoo`07Ool01EkgOomoogooG_L02Goo00<007ooOol0<7oo2`3G
5Goo000jOol00`00Oomoo`0=Ool00ekgOomoo`0KOol00ekgOomoo`0KOol00ekgOomoo`0LOol00ekg
Oomoo`08Ool00ekgOomoo`0:Ool00`;XOomoo`05Ool01EkgOomoogooG_L02Goo00=NmgooOol00Woo
00El07ooOomooekg00=oo`04G_Moo`4GG_L3Ool00ekgOomoo`03Ool00ekgOomoo`06Ool00ekgOomo
o`02Ool00ekgOomoo`07Ool00`00Oomoo`0`Ool;0=LEOol003Yoo`03001oogoo00eoo`03G_Moogoo
01]oo`03G_Moogoo01]oo`03G_Moogoo01aoo`03G_Moogoo00Uoo`03G_Moogoo00Uoo`030^Qoogoo
00Eoo`03G_Moogoo009oo`03G_Moogoo00Ioo`03G_Moogoo009oo`0311MNmgoo009oo`04G_Moogoo
G_L2Ool01EkgOomoogooG_L01Goo00=NmgooOol01Woo00=NmgooOol00Woo00=NmgooOol01goo00<0
07ooOol0<7oo2`3G5Goo000jOol2000>Ool00ekgOomoo`0KOol00ekgOomoo`0KOol00ekgOomoo`0L
Ool00ekgOomoo`0:Ool00ekgOomoo`08Ool00`;[Oomoo`05Ool00ekgOomoo`03Ool00ekgOomoo`06
Ool00ekgOomoo`02Ool025kg03MoogooG_L0]gooG_L2Ool01EkgOomoogooG_L017oo00=NmgooOol0
1Woo00=NmgooOol00goo00=NmgooOol01Woo0P00<Woo2`5G5Goo000jOol00`00Oomoo`0=Ool00ekg
Oomoo`0KOol00ekgOomoo`0KOol00ekgOomoo`0LOol00ekgOomoo`0;Ool00ekgOomoo`07Ool00`;[
Oomoo`04Ool00ekgOomoo`04Ool00ekgOomoo`06Ool00ekgOomoo`02Ool025kg03MoogooG_L0]goo
G_L2Ool01EkgOomoogooG_L017oo00=NmgooOol01Woo00=NmgooOol017oo00=NmgooOol01Woo00<0
07ooOol0<7oo2`5G5Goo000jOol00`00Oomoo`0=Ool00ekgOomoo`0KOol00ekgOomoo`0KOol00ekg
Oomoo`0LOol00ekgOomoo`0<Ool2G_L8Ool00`;^Oomoo`03Ool00ekgOomoo`05Ool00ekgOomoo`05
Ool00ekgOomoo`02Ool01EkgOomoogooG_L00Woo00ANmgooOomNm`=oo`03G_Moogoo009oo`03G_Mo
ogoo00Eoo`03G_Moogoo00Eoo`03G_Moogoo00Ioo`03001oogoo031oo`/1EaEoo`00>Woo00<007oo
Ool03Goo00=NmgooOol06goo00=NmgooOol06goo00=NmgooOol077oo00=NmgooOol03Woo00=Nmgoo
Ool01Goo00<2kWooOol00goo00=NmgooOol01Goo00=NmgooOol01Woo00ENmgooOomooekg00=oo`04
G_MoogooG_L2Ool01EkgOomoogooG_L00goo00=NmgooOol01Woo00=NmgooOol01Goo00=NmgooOol0
1Woo00<007ooOol0<7oo2`5G5Goo000jOol00`00Oomoo`0=Ool00ekgOomoo`0KOol00ekgOomoo`0K
Ool00ekgOomoo`0LOol00ekgOomoo`0?Ool00ekgOomoo`05Ool00`;bOomoo`02Ool00ekgOomoo`06
Ool00ekgOomoo`05Ool00ekgOomoo`02Ool015kgOomooekg0Woo00ANmgooOomNm`9oo`03G_Moogoo
009oo`03G_Moogoo00Eoo`03G_Moogoo00Ioo`03G_Moogoo00Ioo`03001oogoo031oo`/1]aEoo`00
>Woo00<007ooOol03Goo00=NmgooOol06goo00=NmgooOol06goo00=NmgooOol077oo00=NmgooOol0
47oo00=NmgooOol017oo00<2lWooOol00Woo00=NmgooOol01Woo00=NmgooOol01Goo00=NmgooOol0
0Woo00ANmgooOomNm`9oo`04G_MoogooG_L2Ool00ekgOomoo`02Ool00ekgOomoo`04Ool00ekgOomo
o`07Ool00ekgOomoo`06Ool00`00Oomoo`0`Ool;0KLEOol003Yoo`03001oogoo00eoo`03G_Moogoo
01]oo`03G_Moogoo01]oo`03G_Moogoo01aoo`03G_Moogoo015oo`03G_Moogoo00Eoo`040_Eoogoo
G_L9Ool00ekgOomoo`05Ool01EkgOomoogooG_L00Woo00ANmgooOomNm`9oo`04G_MoogooG_L3Ool0
0ekgOomoo`05Ool00ekgOomoo`07Ool00ekgOomoo`06Ool00`00Oomoo`0`Ool;0KLEOol003Yoo`03
001oogoo00eoo`03G_Moogoo01]oo`03G_Moogoo01]oo`03G_Moogoo01aoo`03G_Moogoo019oo`03
G_Moogoo00Aoo`040_EoogooG_L9Ool00ekgOomoo`05Ool01EkgOomoogooG_L00Woo00ANmgooOomN
m`9oo`04G_MoogooG_L3Ool00ekgOomoo`04Ool00ekgOomoo`08Ool00ekgOomoo`06Ool00`00Oomo
o`0`Ool;0KLEOol003Yoo`03001oogoo00eoo`03G_Moogoo01]oo`03G_Moogoo01]oo`03G_Moogoo
01aoo`03G_Moogoo01=oo`9Nm`Moo`03G_Moogoo00Qoo`03G_Moogoo00Aoo`05G_MoogooOomNm`02
Ool015kgOomooekg0Woo00ANmgooOomNm`=oo`03G_Moogoo00Aoo`03G_Moogoo00Qoo`03G_Moogoo
00Eoo`03G_L007oo035oo`/25aEoo`00>Woo00<007ooOol037oo00=NmgooOol077oo00=NmgooOol0
6goo00=NmgooOol06goo00=NmgooOol05Woo00=NmgooOol00Woo00<2mekgOol02goo00=NmgooOol0
0goo00=NmgooOol00Woo00=NmgooG_L00Woo00INmgooOomNmgooG_L3Ool00ekgOomoo`04Ool00ekg
Oomoo`09Ool00ekgOomoo`04Ool00ekgOol0000bOol;0QLEOol003Yoo`8000eoo`03G_Moogoo01ao
o`03G_Moogoo01]oo`03G_Moogoo01]oo`03G_Moogoo01Moo`06G_MoogooOol2mekg37oo00=Nmgoo
Ool017oo00ENmgooOomooekg009oo`05G_MooekgOomNm`02Ool01EkgOomoogooG_L01Woo00=Nmgoo
Ool02Woo00ANmgooOomoo`9Nm`03Ool00000039oo`/25aEoo`00>Woo00<007ooOol037oo00=Nmgoo
Ool077oo00=NmgooOol06goo00=NmgooOol06goo00=NmgooOol067oo00ENmgooOomooekg00eoo`03
G_Moogoo00=oo`05G_MoogooOomNm`02Ool01EkgOomNmgooG_L00Woo00ENmgooOomooekg00Eoo`03
G_Moogoo00]oo`04G_MoogooG_L4Ool00`00Oomoo`0`Ool;0QLEOol003Yoo`03001oogoo00aoo`03
G_Moogoo01aoo`03G_Moogoo01]oo`03G_Moogoo01]oo`03G_Moogoo01Uoo`04G_MoogooG_L=Ool0
0ekgOomoo`03Ool01EkgOomoogooG_L00Woo00ENmgooG_Mooekg009oo`05G_MoogooOomNm`05Ool0
0ekgOomoo`0;Ool00ekgOomNm`05Ool00`00Oomoo`0`Ool;0WLEOol003Yoo`03001oogoo00aoo`03
G_Moogoo01aoo`03G_Moogoo01]oo`03G_Moogoo01]oo`03G_Moogoo01Yoo`03G_Moo`:G00ioo`03
G_Moogoo00=oo`04G_MoogooG_L2Ool01EkgOomNmgooG_L00Woo00ANmgooOomNm`Eoo`03G_Moogoo
00aoo`9Nm`Ioo`03001oogoo031oo`/2MaEoo`00>Woo00<007ooOol037oo00=NmgooOol077oo00=N
mgooOol06goo00=NmgooOol06goo00=NmgooOol06goo00=Nm`:GOol03Goo00=NmgooOol00goo00AN
mgooOomNm`9oo`05G_MooekgOomNm`02Ool015kgOomooekg1Goo00=NmgooOol037oo00=NmgooOol0
1Goo00<007ooOol0<7oo2`9g5Goo000jOol00`00Oomoo`0<Ool00ekgOomoo`0KOol00ekgOomoo`0L
Ool00ekgOomoo`0KOol00ekgOomoo`0LOol2G_L>Ool00ekgOomoo`02Ool03EkgOomoogooG_Mooekg
OomNmgooG_Mooekg00=oo`03G_Moogoo009oo`03G_Moogoo00aoo`9Nm`Moo`03001oogoo031oo`/2
MaEoo`00>Woo00<007ooOol037oo00=NmgooOol06goo00=NmgooOol077oo00=NmgooOol06goo00=N
mgooOol077oo00=NmgooG_L03Goo00=NmgooOol00goo00aNmgooOomNmgooG_MooekgOomNmgooG_L2
Ool00ekgOomoo`03Ool00ekgOomoo`0;Ool00ekgOomNm`07Ool00`00Oomoo`0`Ool;0_LEOol003Yo
o`03001oogoo00aoo`03G_Moogoo01]oo`03G_Moogoo01aoo`03G_Moogoo01]oo`03G_Moogoo01ao
o`04G_L2=gooG_L=Ool00ekgOomoo`02Ool035kgOomooekgOomNmgooG_MooekgOomNm`9oo`03G_Mo
ogoo009oo`03G_Moogoo00Yoo`9Nm`9oo`03G_Moogoo00Eoo`03001oogoo031oo`/2maEoo`00>Woo
00<007ooOol037oo00=NmgooOol06goo00=NmgooOol077oo00=NmgooOol06goo00=NmgooOol077oo
00ENm`8gOomooekg00aoo`03G_Moogoo009oo`0<G_MoogooG_MooekgOomNmgooG_Mooekg0Woo00EN
mgooOomooekg00aoo`03G_Moogoo009oo`03G_Moogoo00Eoo`03001oogoo031oo`/2maEoo`00>Woo
0P003Goo00=NmgooOol06goo00=NmgooOol077oo00=NmgooOol06goo00=NmgooOol077oo00=Nmgoo
Ool00Woo0Ukg2goo00=NmgooOol00Woo00eNmgooG_MooekgOomNmgooG_MooekgOomNm`04Ool00ekg
Oomoo`09Ool00ekgOomoo`03Ool00ekgOomoo`04Ool2000bOol;0_DEOol003Yoo`03001oogoo00ao
o`03G_Moogoo01]oo`03G_Moogoo01aoo`03G_Moogoo01]oo`03G_Moogoo01aoo`03G_Moogoo00Ao
o`03G_Moogoo00Uoo`05G_MoogooOomNm`02Ool2G_L00gooG_Moo`02G_L2Ool01EkgOomoogooG_L0
2goo00=NmgooOol017oo00=NmgooOol01Goo00<007ooOol0<7oo2`;e5Goo000jOol00`00Oomoo`0<
Ool00ekgOomoo`0KOol00ekgOomoo`0KOol00ekgOomoo`0LOol00ekgOomoo`0KOol00ekgOomoo`06
Ool00ekgOomoo`08Ool01EkgOomoogooG_L00Woo0Ukg00=ooekgOol00Ukg0Woo00ENmgooOomooekg
00Yoo`03G_Moogoo00Eoo`03G_Moogoo00Eoo`03001oogoo031oo`/2mAEoo`00>Woo00<007ooOol0
37oo00=NmgooOol06goo00=NmgooOol06goo00=NmgooOol077oo00=NmgooOol06goo00=NmgooOol0
1goo00=NmgooOol027oo00QNmgooOomooekgOomNmgoo0ekg00AooekgOomNm`=oo`03G_Moogoo00Qo
o`03G_Moogoo00Moo`03G_Moogoo00Aoo`03001oogoo031oo`/2mAEoo`00>Woo00<007ooOol037oo
00=NmgooOol06goo00=NmgooOol06goo00=NmgooOol077oo00=NmgooOol06goo00=NmgooOol027oo
00=NmgooOol01goo00QNmgooOomooekgOomNmgoo0ekg00AooekgOomNm`=oo`03G_Moogoo00Ioo`9N
m`Yoo`03G_Moogoo00Aoo`03001oogoo031oo`/2lQEoo`00>Woo00<007ooOol037oo00=NmgooOol0
6goo00=NmgooOol06goo00=NmgooOol077oo00=NmgooOol06goo00ENmgooOomoo`7G00Moo`03G_Mo
ogoo00Moo`07G_MoogooG_MooekgOol00ekg00AooekgOomNm`9oo`03G_Moogoo00Ioo`03G_Moogoo
00Yoo`03G_Moogoo00Aoo`03001oogoo031oo`/2lQEoo`00>Woo00<007ooOol037oo00=NmgooOol0
6goo00=NmgooOol06goo00=NmgooOol077oo00=NmgooOol06goo00ENmgooOomoo`7G00Qoo`9Nm`Mo
o`04G_MoogooOol2G_L01GooG_MNmekgOol00Ukg0goo00=NmgooOol01Goo00=NmgooOol02goo00=N
mgooOol017oo00<007ooOol0<7oo2`;b5Goo000jOol00`00Oomoo`0<Ool00ekgOomoo`0KOol00ekg
Oomoo`0KOol00ekgOomoo`0LOol00ekgOomoo`0KOol00ekgOomoo`0<Ool00ekgOomoo`05Ool01Ekg
OomooekgOol01Ekg00EooekgOomooekg00Moo`03G_Moogoo00aoo`03G_Moogoo00Aoo`03001oogoo
031oo`/2lQEoo`00>Woo00<007ooOol037oo00=NmgooOol06goo00=NmgooOol06goo00=NmgooOol0
77oo00=NmgooOol06goo00=NmgooOol03Goo00=NmgooOol017oo00ENmgooOomNmgoo00ENm`05OomN
mgooOomNm`06Ool00ekgOomoo`0=Ool00ekgOomoo`04Ool00`00Oomoo`0`Ool;0^lEOol003Yoo`03
001oogoo00aoo`03G_Moogoo01]oo`03G_Moogoo01]oo`03G_Moogoo01aoo`03G_Moogoo01]oo`03
G_Moogoo00ioo`03G_Moogoo00Aoo`03G_Moogoo00MNm`9oo`03G_Moogoo00Aoo`03G_Moogoo00io
o`03G_Moogoo00Aoo`03001oogoo031oo`/2kaEoo`00>Woo0P003Goo00=NmgooOol06goo00=Nmgoo
Ool06goo00=NmgooOol077oo00=NmgooOol06goo00=NmgooOol03goo00=NmgooOol017oo00=Nmgoo
G_L01Ukg00=ooekgOol017oo0Ukg4Goo00=NmgooOol00goo0P00<Woo2`;_5Goo000jOol00`00Oomo
o`0<Ool00ekgOomoo`0KOol00ekgOomoo`0KOol00ekgOomoo`0LOol00ekgOomoo`0KOol00ekgOomo
o`0@Ool00ekgOomoo`03Ool00ekgOomNm`06G_L00gooG_Moo`03Ool00ekgOomoo`0AOol00ekgOomo
o`04Ool00`00Oomoo`0`Ool;0^lEOol003Yoo`03001oogoo00aoo`03G_Moogoo01]oo`03G_Moogoo
01]oo`03G_Moogoo01aoo`03G_Moogoo01]oo`03G_Moogoo015oo`9Nm`Aoo`9Nm`05OomNmekgG_Mo
o`02G_L4Ool00ekgOomoo`0BOol00ekgOomoo`04Ool00`00Oomoo`0`Ool;0^`EOol003Yoo`03001o
ogoo00aoo`03G_Moogoo01]oo`03G_Moogoo01]oo`03G_Moogoo01aoo`03G_Moogoo01]oo`03G_Mo
ogoo01=oo`06G_MoogooOomNmgoo1Ekg00=ooekgOol00Woo00=NmgooOol04goo00=NmgooOol017oo
00<007ooOol0<7oo2`;/5Goo000jOol00`00Oomoo`0<Ool00ekgOomoo`0KOol00ekgOomoo`0KOol0
0ekgOomoo`0LOol00ekgOomoo`0KOol00ekgOomoo`0DOol015kgOomoogoo1ekg0goo00=NmgooOol0
57oo00=NmgooOol017oo00<007ooOol0<7oo2`;/5Goo000jOol00`00Oomoo`0<Ool00ekgOomoo`0K
Ool00ekgOomoo`0KOol00ekgOomoo`0LOol00ekgOomoo`0KOol00ekgOomoo`0EOol00ekgOomoo`07
G_L2Ool00ekgOomoo`0EOol00ekgOomoo`04Ool00`00Oomoo`0`Ool;0^`EOol001Uoo`8000Qoo`80
01Eoo`03001oogoo00aoo`03G_Moogoo01]oo`03G_Moogoo01]oo`03G_Moogoo01aoo`03G_Moogoo
01]oo`03G_Moogoo01Ioo`03G_Moogoo00ENm`9oo`03G_Moogoo01Ioo`03G_Moogoo00Aoo`03001o
ogoo031oo`/2j1Eoo`006Goo00<007ooOol027oo00<007ooOol04goo00<007ooOol037oo00=Nmgoo
Ool06goo00=NmgooOol06goo00=NmgooOol077oo00=NmgooOol06goo00=NmgooOol05goo2Ekg6Goo
00=NmgooOol017oo00<007ooOol0<7oo2`;X5Goo000<Ool300001goo000007oo001oo`0000=oo`04
001oogooOol30004Ool00`00Oomoo`0=Ool20004Ool00`00Oomoo`0<Ool00ekgOomoo`0KOol00ekg
Oomoo`0KOol00ekgOomoo`0LOol00ekgOomoo`0KOol00ekgOomoo`0IOol5G_LKOol00ekgOomoo`04
Ool00`00Oomoo`0`Ool;0^PEOol000eoo`09001oogooOol007oo001oo`0000=oo`03001oogoo00Ao
o`05001oogooOol0000>Ool01000Oomoo`000goo00<007ooOol02goo00<3h5kgOol077oo00=Nmgoo
Ool06goo00=NmgooOol037oo00=l07ooOol037oo00<3h5kgOol057oo00]L0e`6G0UL35`?G1E<5g`0
0AMoo`5g00Eoo`030GMoogoo00=oo`030AMoogoo009oo`030;Moogoo00Aoo`0703MoogooO00X5c@G
@1L00Woo015<5gooG1Mooe`EOomL4WooG0mooe`<G0Uooe`6OomL0e`000Qoo`03G_Moogoo00Aoo`03
001oogoo031oo`/2j1Eoo`003Goo00T007ooOomoo`00Ool007oo00000goo00@007ooOomoo`<000Ao
o`03001oogoo00aoo`04001oogoo0003Ool>G_L00`?PG_MNm`19G_L00g`0G_MNm`0<G_L00`?PG_MN
m`0DG_L02e`3G0IL2E`<G0mL5D`GO0015ekg0GL01Ekg00<1MekgG_L00ekg00<15ekgG_L00Ukg00<0
]ekgG_L015kg00L0=ekgG_Ml02PG=1M05`02G_L04D`GG_ML5ekgG1ENme`BG_ML3ekgG0aL2EkgG0IN
me`3G0003ekg00<007ooOol0<7oo2`;U5Goo000=Ool00`00Oomoo`0300000goo001oo`03Ool01000
Oomoogoo10000goo00<007ooOol037oo00@007ooOol000=oo`03001oogoo00aoo`03G_Moogoo01]o
o`03G_Moogoo01]oo`03G_Moogoo01aoo`03G_Moogoo01]oo`03G_Moogoo01Yoo`=Nmaaoo`03G_Mo
ogoo00Aoo`03001oogoo031oo`/2iAEoo`003Goo00<007ooOol02Goo00<007ooOol027oo00<007oo
Ool037oo00@007ooOol000=oo`03001oogoo00aoo`03G_Moogoo01]oo`03G_Moogoo01]oo`03G_Mo
ogoo01aoo`03G_Moogoo01]oo`03G_Moogoo01Uoo`ENma]oo`03G_Moogoo00Aoo`03001oogoo031o
o`/2iAEoo`0037oo0`002Woo0P0027oo0P003goo0P0017oo00<007ooOol037oo00=NmgooOol06goo
00=NmgooOol06goo00=NmgooOol077oo00=NmgooOol06goo00=NmgooOol05goo2Ekg6Goo00=Nmgoo
Ool017oo00<007ooOol0<7oo2`;R17oo10003Goo000jOol00`00Oomoo`0<Ool00ekgOomoo`0KOol0
0ekgOomoo`0KOol00ekgOomoo`0LOol00ekgOomoo`0KOol00ekgOomoo`0FOol00ekgOomoo`05G_L2
Ool00ekgOomoo`0FOol00ekgOomoo`04Ool00`00Oomoo`0`Ool;0^84Ool00`00Oomoo`03Ool00`00
Oomoo`08Ool003Yoo`03001oogoo00aoo`03G_Moogoo01]oo`03G_Moogoo01]oo`03G_Moogoo01ao
o`03G_Moogoo01]oo`03G_Moogoo01Eoo`03G_Moogoo00MNm`9oo`03G_Moogoo01Eoo`03G_Moogoo
00Aoo`03001oogoo031oo`/2hPEoo`03001oogoo009oo`03001oogoo00Qoo`00>Woo00<007ooOol0
37oo00=NmgooOol06goo00=NmgooOol06goo00=NmgooOol077oo00=NmgooOol06goo00=NmgooOol0
57oo00ANmgooOomoo`MNm`=oo`03G_Moogoo01Aoo`03G_Moogoo00Aoo`03001oogoo031oo`/2hPIo
o`05001oogooOol0000:Ool003Yoo`03001oogoo00aoo`03G_Moogoo01]oo`03G_Moogoo01]oo`03
G_Moogoo01aoo`03G_Moogoo01]oo`03G_Moogoo01=oo`06G_MoogooOomNmgoo1Ekg00=ooekgOol0
0Woo00=NmgooOol04goo00=NmgooOol017oo00<007ooOol0D7oo000jOol00`00Oomoo`0<Ool00ekg
Oomoo`0KOol00ekgOomoo`0KOol00ekgOomoo`0LOol00ekgOomoo`0KOol00ekgOomoo`0AOol2G_L4
Ool2G_L01GooG_MNmekgOol00Ukg17oo0Ukg4goo00=NmgooOol017oo00<007ooOol0D7oo000jOol2
000=Ool00ekgOomoo`0KOol00ekgOomoo`0KOol00ekgOomoo`0LOol00ekgOomoo`0KOol00ekgOomo
o`0@Ool00ekgOomoo`03Ool00ekgOomNm`06G_L00gooG_Moo`04Ool00ekgOomoo`0@Ool00ekgOomo
o`03Ool2001BOol003Yoo`03001oogoo00aoo`03G_Moogoo01]oo`03G_Moogoo01]oo`03G_Moogoo
01aoo`03G_Moogoo01]oo`03G_Moogoo00moo`03G_Moogoo00Aoo`03G_Mooekg00INm`9oo`03G_Mo
ogoo00=oo`03G_Moogoo00moo`03G_Moogoo00Aoo`03001oogoo051oo`00>Woo00<007ooOol037oo
00=NmgooOol06goo00=NmgooOol06goo00=NmgooOol077oo00=NmgooOol06goo00=NmgooOol03Woo
00=NmgooOol017oo00=NmgooOol01Ukg00AooekgOomNm`Ioo`03G_Moogoo00ioo`03G_Moogoo00Ao
o`03001oogoo051oo`00>Woo00<007ooOol037oo00=NmgooOol06goo00=NmgooOol06goo00=Nmgoo
Ool077oo00=NmgooOol06goo00=NmgooOol03Goo00=NmgooOol017oo00ENmgooOomNmgoo00ENm`05
OomNmgooOomNm`06Ool00ekgOomoo`0=Ool00ekgOomoo`04Ool00`00Oomoo`1@Ool003Yoo`03001o
ogoo00aoo`03G_Moogoo01]oo`03G_Moogoo01]oo`03G_Moogoo01aoo`03G_Moogoo01]oo`03G_Mo
ogoo00]oo`9Nm`Moo`05G_MoogooG_Moo`05G_L01GooG_MoogooG_L01goo0Ukg3Goo00=NmgooOol0
17oo00<007ooOol0D7oo000jOol00`00Oomoo`0<Ool00ekgOomoo`0KOol00ekgOomoo`0KOol00ekg
Oomoo`0LOol00ekgOomoo`0KOol01EkgOomoogoo0ML027oo00=NmgooOol01Woo00ANmgooOomoo`9N
m`05OomNmekgG_Moo`02G_L3Ool00ekgOomoo`06Ool00ekgOomoo`0:Ool00ekgOomoo`04Ool00`00
Oomoo`1@Ool003Yoo`03001oogoo00aoo`03G_Moogoo01]oo`03G_Moogoo01]oo`03G_Moogoo01ao
o`03G_Moogoo01]oo`05G_MoogooOol1e`07Ool00ekgOomoo`07Ool01ekgOomooekgOomNmgoo00=N
m`04OomNmgooG_L2Ool00ekgOomoo`07Ool00ekgOomoo`09Ool00ekgOomoo`04Ool00`00Oomoo`1@
Ool003Yoo`03001oogoo00aoo`03G_Moogoo01]oo`03G_Moogoo01]oo`03G_Moogoo01aoo`03G_Mo
ogoo01]oo`03G_Moogoo00Qoo`03G_Moogoo00Moo`08G_MoogooOomNmgooG_Moo`=Nm`04OomNmgoo
G_L3Ool00ekgOomoo`07Ool00ekgOomoo`08Ool00ekgOomoo`04Ool00`00Oomoo`1@Ool003Yoo`03
001oogoo00aoo`03G_Moogoo01]oo`03G_Moogoo01]oo`03G_Moogoo01aoo`03G_Moogoo01]oo`03
G_Moogoo00Moo`03G_Moogoo00Qoo`08G_MoogooOomNmgooG_Moo`=Nm`04OomNmgooG_L3Ool00ekg
Oomoo`08Ool00ekgOomoo`07Ool00ekgOomoo`04Ool00`00Oomoo`1@Ool003Yoo`03001oogoo00ao
o`03G_Moogoo01]oo`03G_Moogoo01aoo`03G_Moogoo01]oo`03G_Moogoo01aoo`03G_Moogoo00Eo
o`03G_Moogoo00Qoo`05G_MoogooOomNm`02Ool2G_L00gooG_Moo`02G_L2Ool01EkgOomoogooG_L0
2Woo0Ukg1Woo00=NmgooOol01Goo00<007ooOol0D7oo000jOol2000=Ool00ekgOomoo`0KOol00ekg
Oomoo`0LOol00ekgOomoo`0KOol00ekgOomoo`0LOol00ekgOomoo`03Ool2G_L;Ool01EkgOomoogoo
G_L00Woo0Ukg00=ooekgOol00Ukg0Woo00ENmgooOomooekg00aoo`03G_Moogoo00=oo`03G_Moogoo
00Aoo`80059oo`00>Woo00<007ooOol037oo00=NmgooOol06goo00=NmgooOol077oo00=NmgooOol0
6goo00=NmgooOol077oo00=Nm`8gOol00Woo00=NmgooOol02Woo00=NmgooOol00Woo00eNmgooG_Mo
oekgOomNmgooG_MooekgOomNm`04Ool00ekgOomoo`0:Ool00ekgOomoo`02Ool00ekgOomoo`05Ool0
0`00Oomoo`1@Ool003Yoo`03001oogoo00aoo`03G_Moogoo01]oo`03G_Moogoo01aoo`03G_Moogoo
01]oo`03G_Moogoo01aoo`05G_L2=gooOomNm`0<Ool00ekgOomoo`02Ool035kgOomooekgOomNmgoo
G_MooekgOomNm`9oo`03G_Moogoo009oo`03G_Moogoo00Yoo`05G_MoogooOomNm`07Ool00`00Oomo
o`1@Ool003Yoo`03001oogoo00aoo`03G_Moogoo01]oo`03G_Moogoo01aoo`03G_Moogoo01]oo`03
G_Moogoo01aoo`04G_MoogooG_L=Ool00ekgOomoo`02Ool035kgOomooekgOomNmgooG_MooekgOomN
m`9oo`03G_Moogoo009oo`03G_Moogoo00]oo`04G_MoogooG_L7Ool00`00Oomoo`1@Ool003Yoo`03
001oogoo00aoo`03G_Moogoo01]oo`03G_Moogoo01aoo`03G_Moogoo01]oo`03G_Moogoo01aoo`03
G_Mooekg00eoo`03G_Moogoo00=oo`0<G_MoogooG_MooekgOomNmgooG_Mooekg0Woo00=NmgooOol0
0goo00=NmgooOol02goo0ekg1goo00<007ooOol0D7oo000jOol00`00Oomoo`0<Ool00ekgOomoo`0L
Ool00ekgOomoo`0KOol00ekgOomoo`0KOol00ekgOomoo`0LOol2G_L>Ool00ekgOomoo`02Ool03Ekg
OomoogooG_MooekgOomNmgooG_Mooekg00=oo`03G_Moogoo009oo`03G_Moogoo00eoo`03G_Moogoo
00Eoo`03001oogoo051oo`00>Woo00<007ooOol037oo00=NmgooOol077oo00=NmgooOol06goo00=N
mgooOol06goo00=NmgooOol06goo00=Nm`:GOol03Goo00=NmgooOol00goo00ANmgooOomNm`9oo`05
G_MooekgOomNm`02Ool015kgOomooekg1Goo00=NmgooOol037oo0Ukg1Woo00<007ooOol0D7oo000j
Ool00`00Oomoo`0<Ool00ekgOomoo`0LOol00ekgOomoo`0KOol00ekgOomoo`0KOol00ekgOomoo`0J
Ool00ekgOol2U`0>Ool00ekgOomoo`03Ool015kgOomooekg0Woo00ENmgooG_Mooekg009oo`04G_Mo
ogooG_L5Ool00ekgOomoo`0<Ool00ekgOomNm`05Ool00`00Oomoo`1@Ool003Yoo`03001oogoo00ao
o`03G_Moogoo01aoo`03G_Moogoo01]oo`03G_Moogoo01]oo`03G_Moogoo01Uoo`04G_MoogooG_L=
Ool00ekgOomoo`03Ool01EkgOomoogooG_L00Woo00ENmgooG_Mooekg009oo`05G_MoogooOomNm`05
Ool00ekgOomoo`0;Ool015kgOomooekg17oo00<007ooOol0D7oo000jOol2000=Ool00ekgOomoo`0L
Ool00ekgOomoo`0KOol00ekgOomoo`0KOol00ekgOomoo`0HOol01EkgOomoo`;gG_L03Goo00=Nmgoo
Ool00goo00ENmgooOomooekg009oo`05G_MooekgOomNm`02Ool01EkgOomoogooG_L01Goo00=Nmgoo
Ool02goo00ANmgooOomoo`9Nm`03Ool00000059oo`00>Woo00<007ooOol037oo00=NmgooOol077oo
00=NmgooOol06goo00=NmgooOol06goo00=NmgooOol05goo00INmgooOomoo`;gG_L<Ool00ekgOomo
o`04Ool01EkgOomoogooG_L00Woo00ENmgooG_Mooekg009oo`05G_MoogooOomNm`06Ool00ekgOomo
o`09Ool00ekgOomoo`04Ool00ekgOol0001BOol003Yoo`03001oogoo00eoo`03G_Moogoo01]oo`03
G_Moogoo01]oo`03G_Moogoo01aoo`03G_Moogoo01Aoo`9Nm`Ioo`03G_Moogoo00Uoo`03G_Moogoo
00=oo`03G_Moogoo009oo`03G_Mooekg009oo`06G_MoogooG_Mooekg17oo00=NmgooOol017oo00=N
mgooOol027oo00=NmgooOol01Goo00=Nm`00Ool0DGoo000jOol00`00Oomoo`0=Ool00ekgOomoo`0K
Ool00ekgOomoo`0KOol00ekgOomoo`0LOol00ekgOomoo`0COol00ekgOomoo`03Ool010;eOomooekg
2Woo00=NmgooOol017oo00ENmgooOomooekg009oo`04G_MoogooG_L2Ool015kgOomooekg0goo00=N
mgooOol017oo00=NmgooOol027oo00=NmgooOol01Woo00<007ooOol0D7oo000jOol00`00Oomoo`0=
Ool00ekgOomoo`0KOol00ekgOomoo`0KOol00ekgOomoo`0LOol00ekgOomoo`0BOol00ekgOomoo`04
Ool010;eOomooekg2Goo00=NmgooOol01Goo00ENmgooOomooekg009oo`04G_MoogooG_L2Ool015kg
Oomooekg0goo00=NmgooOol01Goo00=NmgooOol01goo00=NmgooOol01Woo00<007ooOol0D7oo000j
Ool00`00Oomoo`0=Ool00ekgOomoo`0KOol00ekgOomoo`0KOol00ekgOomoo`0LOol00ekgOomoo`0A
Ool00ekgOomoo`08Ool00ekgOomoo`07Ool00ekgOomoo`05Ool01EkgOomoogooG_L00Woo00ANmgoo
OomNm`9oo`04G_MoogooG_L4Ool00ekgOomoo`04Ool00ekgOomoo`07Ool00ekgOomoo`06Ool00`00
Oomoo`1@Ool003Yoo`03001oogoo00eoo`03G_Moogoo01]oo`03G_Moogoo01]oo`03G_Moogoo01ao
o`03G_Moogoo011oo`03G_Moogoo00Aoo`030_9oogoo009oo`03G_Moogoo00Ioo`03G_Moogoo00Eo
o`03G_Moogoo009oo`04G_MoogooG_L2Ool015kgOomooekg0Woo00=NmgooOol00Woo00=NmgooOol0
1Goo00=NmgooOol01Woo00=NmgooOol01Woo00<007ooOol0D7oo000jOol00`00Oomoo`0=Ool00ekg
Oomoo`0KOol00ekgOomoo`0KOol00ekgOomoo`0LOol00ekgOomoo`0>Ool2G_L7Ool00`;bOomoo`02
Ool00ekgOomoo`06Ool00ekgOomoo`05Ool00ekgOomoo`02Ool015kgOomooekg0Woo00ANmgooOomN
m`9oo`03G_Moogoo009oo`03G_Moogoo00Eoo`03G_Moogoo00Ioo`03G_Moogoo00Ioo`03001oogoo
051oo`00>Woo00<007ooOol03Goo00=NmgooOol06goo00=NmgooOol06goo00=NmgooOol077oo00=N
mgooOol03Goo00=NmgooOol01Woo00<2kWooOol00goo00=NmgooOol01Goo00=NmgooOol01Woo00EN
mgooOomooekg00=oo`04G_MoogooG_L2Ool01EkgOomoogooG_L00goo00=NmgooOol01Woo00=Nmgoo
Ool01Goo00=NmgooOol01Woo00<007ooOol0D7oo000jOol00`00Oomoo`0=Ool00ekgOomoo`0KOol0
0ekgOomoo`0KOol00ekgOomoo`0LOol00ekgOomoo`0<Ool00ekgOomoo`07Ool00`;^Oomoo`03Ool0
0ekgOomoo`05Ool00ekgOomoo`05Ool00ekgOomoo`02Ool01EkgOomoogooG_L00Woo00ANmgooOomN
m`=oo`03G_Moogoo009oo`03G_Moogoo00Eoo`03G_Moogoo00Eoo`03G_Moogoo00Ioo`03001oogoo
051oo`00>Woo0P003Woo00=NmgooOol06goo00=NmgooOol06goo00=NmgooOol077oo00=NmgooOol0
2goo00=NmgooOol01goo00<2jgooOol01Goo00=NmgooOol00goo00=NmgooOol01Woo00=NmgooOol0
0Woo00QNm`0gOomooekg0;Mooekg0Woo00ENmgooOomooekg00Aoo`03G_Moogoo00Ioo`03G_Moogoo
00=oo`03G_Moogoo00Ioo`80059oo`00>Woo00<007ooOol03Goo00=NmgooOol06goo00=NmgooOol0
6goo00=NmgooOol077oo00=NmgooOol02Woo00=NmgooOol027oo00<2jgooOol01Goo00=NmgooOol0
0goo00=NmgooOol01Woo00=NmgooOol00Woo00QNm`0gOomooekg0;Mooekg0Woo00ENmgooOomooekg
00Aoo`03G_Moogoo00Moo`03G_Moogoo009oo`03G_Moogoo00Moo`03001oogoo051oo`00>Woo00<0
07ooOol03Goo00=NmgooOol06goo00=NmgooOol06goo00=NmgooOol077oo00=NmgooOol027oo0Ukg
2goo00<2j7ooOol01Goo00=NmgooOol00Woo00=NmgooOol01Woo00=NmgooOol00Woo00<45ekgOol0
0Woo00MNmgooOomNmgoo0AMNm`03Ool00ekgOomoo`03Ool00ekgOomoo`06Ool00ekgOomoo`02Ool0
0ekgOomoo`07Ool00`00Oomoo`1@Ool003Yoo`03001oogoo00eoo`03G_Moogoo01]oo`03G_Moogoo
01]oo`03G_Moogoo01aoo`03G_Moogoo00Moo`03G_Moogoo00Yoo`030^D2j7oo00Ioo`05G_Moogoo
OomNm`09Ool00ekgOomoo`02Ool01G`0OomoogooG_L00goo00ANmgoo0AMNm`=oo`03G_Moogoo00=o
o`03G_Moogoo00Moo`05G_MoogooOomNm`09Ool00`00Oomoo`1@Ool003Yoo`03001oogoo00eoo`03
G_Moogoo01]oo`03G_Moogoo01]oo`03G_Moogoo01eoo`03G_Moogoo00Eoo`03G_Moogoo00]oo`03
0^Eoogoo00Ioo`05G_MoogooOomNm`09Ool01UkgOomoogoo=1Ml00=oo`05G_MoogooOomNm`03Ool0
1EkgOomoogooG_L017oo00=NmgooOol01goo00ENmgooOomooekg00Uoo`03001oogoo051oo`00>Woo
00<007ooOol03Goo00=NmgooOol06goo00=NmgooOol06goo00=NmgooOol07Goo00=NmgooOol017oo
00=NmgooOol02goo00<2hWooOol01goo00ANmgooOomNm`Uoo`03G_Moogoo009oo`03=1MNmgoo009o
o`05G_MoogooOomNm`03Ool01Ekg0GMoogooG_L01Goo00=NmgooOol01goo00ANmgooOomNm`Uoo`03
001oogoo051oo`00>Woo00<007ooOol03Goo00=NmgooOol06goo00=NmgooOol06goo00=NmgooOol0
7Goo00=NmgooOol00goo00=NmgooOol037oo00<2hWooOol027oo00=NmgooG_L02Goo00=NmgooOol0
0goo00ENmgooOomooekg00=oo`06G_MoogooOomNm`5g0Woo00=NmgooOol00goo00=NmgooOol01goo
00=NmgooG_L02Woo00<007ooOol0D7oo000cOol50002Ool00`00Oomoo`0=Ool00ekgOomoo`0KOol0
0ekgOomoo`0LOol00ekgOomoo`0LOol00ekgOomoo`02Ool00ekgOomoo`0HOol2G_L:Ool015kgOomo
od0G0Woo00ENmgooOomooekg00=oo`05G_MoogooOomNm`02Ool00`7GG_Moo`04Ool00ekgOomoo`08
Ool2G_L:Ool00`00Oomoo`1@Ool003Eoo`03001oogoo009oo`03001oogoo00eoo`03G_Moogoo01]o
o`03G_Moogoo01aoo`03G_Moogoo01aoo`03G_Moogoo009Nma]oo`9Nm`Uoo`05G_MoogooOom05`02
Ool01EkgOomoogooG_L00goo00ENmgooOomooekg009oo`030MMNmgoo00Eoo`03G_Moogoo00Moo`9N
m`Yoo`03001oogoo051oo`00=Goo00<007ooOol00Woo0P003Woo00=NmgooOol06goo00=NmgooOol0
77oo00=NmgooOol077oo00=NmgooG_L07Goo00=NmgooOol027oo00=NmgooOol00goo00=NmgooOol0
0Woo00ENmgooOomooekg00=oo`03G_Moogoo009oo`030SMoogoo00=oo`03G_Moogoo00Qoo`03G_Mo
ogoo00Ioo`<0059oo`00=Goo00<007ooOol00Woo00<007ooOol03Goo00=NmgooOol06goo00=Nmgoo
Ool077oo00=NmgooOol077oo0Ukg7Woo00=NmgooOol027oo00ANmgooOom<5`9oo`03G_Moogoo009o
o`05G_MoogooOomNm`03Ool00ekgOomoo`02Ool00`8gOomoo`03Ool00ekgOomoo`08Ool2G_L9Ool0
0`00Oomoo`1@Ool003Eoo`03001oogoo009oo`03001oogoo00eoo`03G_Moogoo01]oo`03G_Moogoo
01aoo`03G_Moogoo01aoo`03G_Moogoo01aoo`03G_Mooekg00Qoo`05G_MoogooOom<5`02Ool00ekg
Oomoo`02Ool01EkgOomoogooG_L00goo00=NmgooOol00Woo00=Nm`:GOol017oo00=NmgooOol01Woo
00=NmgooG_L02Goo00<007ooOol0D7oo000dOol20004Ool00`00Oomoo`0=Ool00ekgOomoo`0KOol0
0ekgOomoo`0LOol00ekgOomoo`0KOol2G_LNOol00ekgOomNm`08Ool00ekgOomoo`04Ool00ekgOomo
o`02Ool01EkgOomoogooG_L00goo00=NmgooOol00Woo00=Nm`:GOol017oo00=NmgooOol01Woo00AN
mgooOomNm`Qoo`03001oogoo051oo`00>Woo00<007ooOol03Goo00=NmgooOol06goo00=NmgooOol0
77oo00=NmgooOol06Goo0Ukg00=ooekgOol077oo00ANmgooOomNm`Qoo`03G_Moogoo00Aoo`03G_Mo
ogoo009oo`05G_MoogooOomNm`03Ool00ekgOomoo`02Ool015kgOomoo`;g0goo00=NmgooOol01Woo
00ANmgooOomNm`Qoo`03001oogoo051oo`00>Woo00<007ooOol03Goo00=NmgooOol06goo00=Nmgoo
Ool077oo00=NmgooOol067oo00ENmgooOomooekg01aoo`05G_MoogooOomNm`08Ool00ekgOomL5`03
Ool00ekgOomoo`03Ool01EkgOomoogooG_L00goo00=NmgooOol00goo00=Nmgoo0_L017oo00=Nmgoo
Ool01Goo00ENmgooOomooekg00Moo`03001oogoo051oo`00>Woo00<007ooOol03Goo00=NmgooOol0
6goo00=NmgooOol077oo00=NmgooOol05goo00=NmgooOol00goo00=NmgooOol06Goo00ENmgooOomo
oekg00Moo`04G_MoogooG1L3Ool00ekgOomoo`02Ool00ekgOomoo`02Ool00ekgOomoo`02Ool00ekg
Oomoo`02Ool015kgOomoo`;e0goo00=NmgooOol01Goo00ENmgooOomooekg00Moo`03001oogoo051o
o`00>Woo00<007ooOol03Goo00=NmgooOol06goo00=NmgooOol077oo00=NmgooOol05Woo00=Nmgoo
Ool017oo00=NmgooOol067oo00=NmgooOol00goo00=NmgooOol017oo00=NmgooOol017oo00=Nmgoo
Ool00Woo00=NmgooOol00Woo00=NmgooOol00Woo00=NmgooOol00Woo00ANmgooOol2m@=oo`03G_Mo
ogoo00Aoo`03G_Moogoo00=oo`03G_Moogoo00Aoo`03001oogoo051oo`00>Woo00<007ooOol03Goo
00=NmgooOol06goo00=NmgooOol077oo00=NmgooOol05Goo00=NmgooOol01Goo00=NmgooOol067oo
00=NmgooOol00goo00=NmgooOol017oo00=NmgooOol017oo00=NmgooOol00Woo00=NmgooOol00Woo
00=NmgooOol00Woo00=NmgooOol00Woo00=NmgooOol00Woo00@2lWooOomNm`Eoo`03G_Moogoo00=o
o`03G_Moogoo00Aoo`03001oogoo051oo`00>Woo00<007ooOol03Goo00=NmgooOol077oo00=Nmgoo
Ool06goo00=NmgooOol057oo00=NmgooOol01Woo00=NmgooOol05goo00=NmgooOol017oo00=Nmgoo
Ool00goo00=NmgooG1D01Goo00=NmgooOol00Woo00=NmgooOol00Woo00=NmgooOol00Woo00=Nmgoo
Ool00Woo00=NmgooOol00Woo00@2lWooOomNm`Eoo`03G_Moogoo00Aoo`03G_Moogoo00=oo`03001o
ogoo051oo`00>Woo0P003Woo00=NmgooOol077oo00=NmgooOol06goo00=NmgooOol04Woo0Ukg2Goo
00=NmgooOol05goo00=NmgooOol017oo00=NmgooOol00goo00=NmgooG1D01Goo00=NmgooOol00Woo
00=NmgooOol00Woo00=NmgooOol00Woo00=NmgooOol00Woo00=NmgooOol00goo00<2kWooG_L01Goo
00=NmgooOol017oo00=NmgooOol00Woo0P00DWoo000jOol00`00Oomoo`0=Ool00ekgOomoo`0LOol0
0ekgOomoo`0KOol00ekgOomoo`0AOol00ekgOomoo`09Ool00ekgOomoo`0FOol00ekgOomoo`05Ool0
0ekgOomoo`03Ool00ekgOomoo`04Ool00ekgOomoo`03Ool00ekgOomoo`02Ool00ekgOomoo`02Ool0
0ekgOomoo`03Ool00ekgOomoo`02Ool00`;^OomNm`05Ool00ekgOomoo`05Ool00ekgOomoo`02Ool0
0`00Oomoo`1@Ool003Yoo`03001oogoo00eoo`03G_Moogoo01aoo`03G_Moogoo01]oo`03G_Moogoo
011oo`03G_Moogoo00Yoo`03G_Moogoo01Ioo`03G_Moogoo00Ioo`05G_MoogooOomNm`07Ool00ekg
Oomoo`03Ool00ekgOomoo`02Ool00ekgOomoo`02Ool00ekgOomoo`03Ool00ekgOomoo`03Ool00`;[
OomNm`03Ool00ekgOomoo`07Ool01EkgOomoogoo0000DWoo000jOol00`00Oomoo`0=Ool00ekgOomo
o`0LOol00ekgOomoo`0KOol00ekgOomoo`0?Ool00ekgOomoo`0;Ool00ekgOomoo`0EOol00ekgOomo
o`07Ool01ekgOomoogooG_Mooe`B00Eoo`03G_Moogoo00=oo`03G_Moogoo009oo`03G_Moogoo009o
o`03G_Moogoo00=oo`03G_Moogoo00=oo`030^/2j5kg00=oo`03G_Moogoo00Moo`05G_MoogooOol0
001BOol003Yoo`03001oogoo00eoo`03G_Moogoo01aoo`03G_Moogoo01]oo`03G_Moogoo00ioo`03
G_Moogoo00aoo`03G_Moogoo01Eoo`03G_Moogoo00Moo`07G_MoogooOomNmgooG1801Goo00=Nmgoo
Ool00goo00=NmgooOol00Woo00=NmgooOol00Woo00=NmgooOol00goo00=NmgooOol017oo00<2j5kg
Ool00Woo00=NmgooOol027oo00ANmgooOol0059oo`00>Woo00<007ooOol03Goo00=NmgooOol077oo
00=NmgooOol06goo00=NmgooOol037oo0Ukg3goo00=NmgooOol057oo00=NmgooOol027oo00ANmgoo
OomNm`Qoo`03G_Moogoo00=oo`03G_Moogoo009oo`03G_Moogoo009oo`03G_Moogoo00=oo`03G_Mo
ogoo00Eoo`050^ENmgooOomNm`0:Ool015kgOomoo`00DWoo000jOol00`00Oomoo`0=Ool00ekgOomo
o`0LOol00ekgOomoo`0LOol00ekgOomoo`0:Ool00ekgOomoo`0?Ool00ekgOomoo`0COol00ekgOomo
o`0:Ool01EkgOomNmgooG0l01Goo00=NmgooOol017oo00=NmgooOol00Woo00=NmgooOol00Woo00=N
mgooOol017oo00=NmgooOol017oo00@2iEkgOomNm`aoo`03G_Moo`00059oo`00>Woo00<007ooOol0
3Goo00=NmgooOol077oo00=NmgooOol077oo00=NmgooOol02Goo00=NmgooOol047oo00=NmgooOol0
4goo00=NmgooOol02Woo00ENmgooG_Mooe`?00Eoo`03G_Moogoo00Aoo`03G_Moogoo009oo`03G_Mo
ogoo009oo`03G_Moogoo00Aoo`03G_Moogoo00Eoo`030^9ooekg00aoo`03G_Moo`00059oo`00>Woo
00<007ooOol03Goo00=NmgooOol077oo00=NmgooOol077oo00=NmgooOol027oo00=NmgooOol04Woo
00=NmgooOol04Goo00=NmgooOol02goo0Ukg27oo00=NmgooOol00goo00=NmgooOol00goo00=Nmgoo
Ool00goo00=NmgooOol00goo00=NmgooOol01Goo00<2hUkgG_L03Goo00=Nm`00Ool0DGoo000jOol2
000>Ool00ekgOomoo`0LOol00ekgOomoo`0LOol00ekgOomoo`07Ool00ekgOomoo`0COol00ekgOomo
o`0AOol00ekgOomoo`0;Ool2G_L8Ool00ekgOomoo`03Ool01ekgOomoo`0g11Mooekg00Eoo`03G_Mo
ogoo00=oo`03G_Moogoo00Ioo`9Nm`eoo`03G_L007oo055oo`00>Woo00<007ooOol03Woo00=Nmgoo
Ool06goo00=NmgooOol077oo00=NmgooOol01Goo0Ukg5Woo00=NmgooOol047oo00=NmgooOol03Goo
00=NmgooG0`01Woo00=NmgooOol00goo00MNmgoo0;L0=g`0OomNm`05Ool00ekgOomoo`03Ool00ekg
Oomoo`06Ool00ekgOomoo`0=Ool00`00Oomoo`1@Ool003Yoo`03001oogoo00ioo`03G_Moogoo01]o
o`03G_Moogoo01aoo`03G_Moogoo00Aoo`03G_Moogoo01Ioo`03G_Moogoo011oo`03G_Moogoo00ao
o`9Nm`03OomL37oo00Eoo`03G_Moogoo00=oo`07G_Moo`2gOoml040GG_L01Goo00=NmgooOol00goo
00=NmgooOol01Woo0Ukg3Woo00<007ooOol0D7oo000jOol00`00Oomoo`0>Ool00ekgOomoo`0KOol0
0ekgOomoo`0LOol00ekgOomoo`03Ool00ekgOomoo`0GOol00ekgOomoo`0?Ool00ekgOomoo`0=Ool2
G_L7Ool00ekgOomoo`04Ool00ekgOomoo`02Ool00d0GG_Moo`04Ool00ekgOomoo`04Ool00ekgOomo
o`04Ool00ekgOomNm`0>Ool00`00Oomoo`1@Ool003Yoo`03001oogoo00ioo`03G_Moogoo01]oo`03
G_Moogoo01aoo`03G_Moogoo009oo`03G_Moogoo01Qoo`03G_Moogoo00moo`03G_Moogoo00eoo`03
G_Mooe`900Ioo`03G_Moogoo00Aoo`03G_Moogoo00=oo`03C1Moogoo00=oo`03G_Moogoo00Aoo`03
G_Moogoo00Aoo`03G_Mooekg00ioo`03001oogoo051oo`00>Woo00<007ooOol03Woo00=NmgooOol0
6goo00=NmgooOol077oo00ENmgooOomooekg01]oo`03G_Moogoo00ioo`03G_Moogoo00eoo`04G_Mo
ogooG0T6Ool00ekgOomoo`04Ool00ekg0AMoo`03Ool00d`GOomoo`03Ool00ekgOomoo`04Ool00ekg
Oomoo`04Ool015kgOomooekg3Goo00<007ooOol0D7oo000jOol00`00Oomoo`0>Ool00ekgOomoo`0L
Ool00ekgOomoo`0KOol015kgOomooekg77oo00=NmgooOol03Goo00=NmgooOol03Woo00ENmgooOomo
oekg00Eoo`03G_Moogoo00Aoo`03G_L15goo00=oo`03G1Moogoo00=oo`03G_Moogoo00Aoo`03G_Mo
ogoo00=oo`05G_MoogooOomNm`0=Ool00`00Oomoo`1@Ool003Yoo`03001oogoo00ioo`03G_Moogoo
01aoo`03G_Moogoo01]oo`=Nmaeoo`03G_Moogoo00eoo`03G_Moogoo00ioo`05G_MoogooOomNm`05
Ool00ekgOomoo`04Ool00ekgOomoo`03Ool00e`GOomoo`03Ool00ekgOomoo`04Ool00ekgOomoo`03
Ool01EkgOomoogooG_L03Goo00<007ooOol0D7oo000jOol00`00Oomoo`0>Ool00ekgOomoo`0LOol0
0ekgOomoo`0KOol00ekgOomoo`0NOol00ekgOomoo`0;Ool00ekgOomoo`0?Ool01EkgOomL1WooG_L0
17oo00=NmgooOol01Goo00=NmgooOol00goo00=NmgooOol00goo00=NmgooOol01Goo00=NmgooOol0
0Woo00=NmgooOol00Woo00=NmgooOol02Woo00<007ooOol0D7oo000jOol00`00Oomoo`0>Ool00ekg
Oomoo`0LOol00ekgOomoo`0JOol2G_LPOol00ekgOomoo`0;Ool00ekgOomoo`0>Ool015kgOomooe`6
0Woo00ENmgooOomooekg00Moo`030GMoogoo00=oo`03G_ML5Goo00=oo`03G_Moogoo00Eoo`05G_Mo
ogooOomNm`05Ool00ekgOomoo`0:Ool00`00Oomoo`1@Ool003Yoo`8000moo`03G_Moogoo01aoo`03
G_Moogoo01Uoo`04G_MoogooG_LOOol00ekgOomoo`0:Ool00ekgOomoo`0?Ool00ekgOomoo`03Ool0
1EkgOomoogooG_L01goo00<1MgooOol00goo00=Nme`EOol00goo00=NmgooOol01Goo00ENmgooOomo
oekg00Eoo`03G_Moogoo00Uoo`80059oo`00>Woo00<007ooOol03Woo00=NmgooOol077oo00=Nmgoo
Ool067oo00ENmgooOomooekg01moo`03G_Moogoo00Yoo`03G_Moogoo00moo`03G_Mooe`300Aoo`04
G_MoogooG_L6Ool00ekgOomoo`04Ool00ekgOomoo`04Ool00ekgOomoo`04Ool015kgOomooekg1goo
00=NmgooOol02Goo00<007ooOol0D7oo000jOol00`00Oomoo`0>Ool00ekgOomoo`0LOol00ekgOomo
o`0FOol2G_L4Ool00ekgOomoo`0MOol00ekgOomoo`09Ool00ekgOomoo`0?Ool015kgOomooe`317oo
00ANmgooOomNm`Ioo`03G_Moogoo00Aoo`03G_Mooe`B00Aoo`03G_Moogoo00Aoo`04G_MoogooG_L7
Ool00ekgOomoo`09Ool00`00Oomoo`1@Ool003Yoo`03001oogoo00ioo`03G_Moogoo01aoo`03G_Mo
ogoo01Eoo`03G_Moogoo00Aoo`03G_Moogoo01eoo`03G_Moogoo00Uoo`03G_Moogoo00moo`03G_Mo
ogoo00Ioo`03G_Mooekg00Ioo`030MMoogoo00Aoo`03G_Mooe`B00Aoo`03G_Moogoo00Aoo`03G_Mo
oekg00Qoo`03G_Moogoo00Uoo`03001oogoo051oo`00>Woo00<007ooOol03Woo00=NmgooOol077oo
00=NmgooOol057oo00=NmgooOol01Goo00=NmgooOol07Goo00=NmgooOol027oo00=NmgooOol047oo
00=NmgooG0001Woo0Ukg1goo00<1egooOol017oo00=NmgooOol017oo00=NmgooOol01Goo0Ukg2Goo
00=NmgooOol027oo00<007ooOol0D7oo000jOol00`00Oomoo`0>Ool00ekgOomoo`0LOol00ekgOomo
o`0COol00ekgOomoo`06Ool00ekgOomoo`0MOol00ekgOomoo`08Ool00ekgOomoo`0?Ool015kgOomo
oe`01Woo0Ukg1goo00=NmgooOol017oo00=NmgooOol017oo00=NmgooOol01Goo00=NmgooOol027oo
00=NmgooOol027oo00<007ooOol0D7oo000jOol00`00Oomoo`0?Ool00ekgOomoo`0KOol00ekgOomo
o`0BOol00ekgOomoo`07Ool00ekgOomoo`0NOol00ekgOomoo`06Ool00ekgOomoo`0@Ool00ekgOomo
o`08Ool00ekgOomoo`05Ool00ekgOomoo`04Ool015kgOomooe`?0goo00=NmgooOol01Goo00=Nmgoo
Ool027oo00=NmgooOol027oo00<007ooOol0D7oo000jOol00`00Oomoo`0?Ool00ekgOomoo`0KOol0
0ekgOomoo`0@Ool2G_L:Ool00ekgOomoo`0NOol00ekgOomoo`05Ool00ekgOomoo`0AOol00ekgOomo
o`08Ool00ekgOomoo`05Ool00`8gOomoo`04Ool015kgOomooe`?0goo00=NmgooOol017oo0Ukg2Woo
00=NmgooOol027oo00<007ooOol0D7oo000jOol00`00Oomoo`0?Ool00ekgOomoo`0KOol00ekgOomo
o`0?Ool00ekgOomoo`0;Ool00ekgOomoo`0MOol00ekgOomoo`05Ool00ekgOomoo`0@Ool00ekgOomo
o`09Ool2G_L6Ool00`8gOomoo`04Ool00ekgOomoo`04Ool00ekgOomoo`04Ool2G_L;Ool00ekgOomo
o`07Ool00`00Oomoo`1@Ool003Yoo`80011oo`03G_Moogoo01]oo`03G_Moogoo00ioo`03G_Moogoo
00aoo`03G_Moogoo01eoo`03G_Moogoo00Aoo`03G_Moogoo015oo`03G_Moogoo00Qoo`03G_Mooekg
00Ioo`03G_Moogoo00Aoo`04G_MoogooG0`3Ool00ekgOomoo`03Ool015kgOomooekg2Woo00=Nmgoo
Ool01Woo0P00DWoo000jOol00`00Oomoo`0?Ool00ekgOomoo`0KOol00ekgOomoo`0=Ool00ekgOomo
o`0=Ool00ekgOomoo`0MOol00ekgOomoo`04Ool00ekgOomoo`0AOol00ekgOomoo`08Ool015kgOomo
oekg1Goo00=NmgooOol017oo00ANmgooOomL30=oo`03G_Moogoo00=oo`04G_MoogooG_L:Ool00ekg
Oomoo`07Ool00`00Oomoo`1@Ool003Yoo`03001oogoo00moo`03G_Moogoo01]oo`03G_Moogoo00ao
o`03G_Moogoo00ioo`03G_Moogoo01eoo`03G_Moogoo00=oo`03G_Moogoo015oo`03G_Moogoo00Uo
o`05G_MoogooOomNm`03Ool00`:GG_Moo`05Ool00ekgOomoo`04Ool00ekgOomoo`02Ool01EkgOomo
ogooG_L02goo00=NmgooOol01Woo00<007ooOol0D7oo000jOol00`00Oomoo`0?Ool00ekgOomoo`0L
Ool00ekgOomoo`0:Ool00ekgOomoo`0?Ool00ekgOomoo`0MOol00ekgOomoo`03Ool00ekgOomoo`0A
Ool00ekgOomoo`09Ool00ekgOomoo`02Ool015kgOomoo`:G1goo00ENmgooOomooe`900=oo`04G_Mo
ogooG_L4Ool00ekgOomoo`09Ool00ekgOomoo`06Ool00`00Oomoo`1@Ool003Yoo`03001oogoo00mo
o`03G_Moogoo01aoo`03G_Moogoo00Qoo`9Nma9oo`03G_Moogoo01ioo`05G_MoogooOomNm`0DOol0
0ekgOomoo`09Ool00ekgOomoo`03Ool00ekgOomNm`07Ool01EkgOomoogooG0T00goo00=NmgooG_L0
1Goo00=NmgooOol02Goo00=NmgooOol01Woo00<007ooOol0D7oo000jOol00`00Oomoo`0?Ool00ekg
Oomoo`0LOol00ekgOomoo`07Ool00ekgOomoo`0BOol00ekgOomoo`0NOol01EkgOomoogooG_L04goo
00=NmgooOol02Woo00=NmgooOol017oo0Ukg1goo00=NmgooOol01Goo0Ukg1Woo00=NmgooOol02Woo
00=NmgooOol01Goo00<007ooOol0D7oo000jOol00`00Oomoo`0?Ool00ekgOomoo`0LOol00ekgOomo
o`06Ool00ekgOomoo`0COol00ekgOomoo`0NOol015kgOomooekg57oo00=NmgooOol02Goo00=Nmgoo
Ool01Woo00<2mgooOol01Goo00=NmgooOol00Woo00AL1WooOomNm`Qoo`03G_Moogoo00Uoo`03G_Mo
ogoo00Eoo`03001oogoo051oo`00>Woo00<007ooOol03goo00=NmgooOol077oo00=NmgooOol01Goo
00=NmgooOol057oo00=NmgooOol07Woo00ANmgooOomNmaAoo`03G_Moogoo00Uoo`03G_Moogoo00Io
o`030_MNmgoo00Eoo`03G_Moogoo009oo`04G0IooekgG_L8Ool00ekgOomoo`09Ool00ekgOomoo`05
Ool00`00Oomoo`1@Ool003=oo`@000=oo`03001oogoo00moo`03G_Moogoo01aoo`03G_Moogoo00Ao
o`03G_Moogoo01Ioo`03G_Moogoo01eoo`03G_Mooekg01Eoo`03G_Moogoo00Uoo`03G_Moogoo00Io
o`03G_Mooekg00Eoo`03G_Moogoo00=oo`03G_Mooekg00Qoo`03G_Moogoo00Yoo`03G_Moogoo00Ao
o`03001oogoo051oo`00<goo00<007ooOol017oo00<007ooOol03goo00=NmgooOol077oo00=Nmgoo
Ool00Woo0Ukg6Goo00=NmgooOol07Goo0Ukg5Goo00=NmgooOol02Woo00=NmgooOol01Woo00=Nmgoo
Ool00Ukg0goo00INmgooOomooekgG0<2Ool00ekgOomoo`06Ool00ekgOomoo`0:Ool00ekgOomoo`04
Ool00`00Oomoo`1@Ool003Aoo`03001oogoo00=oo`80011oo`03G_Moogoo01aoo`05G_MoogooOomN
m`0KOol00ekgOomoo`0NOol00ekgOomoo`0COol00ekgOomoo`0:Ool00ekgOomoo`06Ool00`;eOomo
o`02Ool7G_L01GooG0=oogooG_L027oo00=NmgooOol02Woo00=NmgooOol00Woo0`00DWoo000eOol0
0`00Oomoo`02Ool00`00Oomoo`0@Ool00ekgOomoo`0KOol015kgOomooekg77oo00=NmgooOol07Goo
0Ukg5Goo00=NmgooOol02Goo00=NmgooOol01goo00<2mGooOol01Goo00=NmgooOol01Goo00=Nmgoo
Ool01goo00=NmgooOol02Woo00=NmgooOol00goo00<007ooOol0D7oo000cOol01000Oomoo`000goo
00<007ooOol047oo00=NmgooOol06goo00=NmgooG_L07Goo00=NmgooOol07Goo0Ukg57oo00=Nmgoo
Ool02Woo00=NmgooOol01goo00=NmgooOol01Goo00=NmgooOol00goo00=L07ooG_L02Goo00=Nmgoo
Ool02Woo00=NmgooOol00goo00<007ooOol0D7oo000dOol20004Ool00`00Oomoo`0@Ool00ekgOomo
o`0KOol2G_LNOol00ekgOomoo`0LOol00ekgOomNm`0DOol00ekgOomoo`0:Ool00ekgOomoo`07Ool0
0ekgOomoo`05Ool00ekgOomoo`03Ool00e`0OomNm`09Ool00ekgOomoo`0:Ool00ekgOomoo`03Ool0
0`00Oomoo`1@Ool003Yoo`03001oogoo011oo`03G_Moogoo01]oo`03G_Moogoo01eoo`03G_Moogoo
01aoo`03G_Mooekg01Aoo`03G_Moogoo00Yoo`03G_Moogoo00Ioo`030_9Nmgoo00Ioo`03G_Moogoo
00Eoo`03G_Moogoo00Moo`03G_Moogoo00]oo`03G_Moogoo009oo`03001oogoo051oo`00>Woo00<0
07ooOol047oo00=NmgooOol06Goo0Ukg00=ooekgOol07Goo00=NmgooOol06goo00ENmgooOomooekg
019oo`03G_Moogoo00]oo`03G_Moogoo00Ioo`030_9oogoo00Ioo`03G_Moogoo00Ioo`03G_Moogoo
00Ioo`03G_Moogoo00]oo`03G_Moogoo009oo`03001oogoo051oo`00>Woo00<007ooOol047oo00=N
mgooOol067oo00ENmgooOomooekg01moo`03G_Moogoo01Yoo`05G_MoogooOomNm`0BOol00ekgOomo
o`0;Ool00ekgOomoo`06Ool00ekgOomoo`06Ool00ekgOomoo`06Ool00ekgOomoo`06Ool00ekgOomo
o`0;Ool00ekgOomoo`02Ool00`00Oomoo`1@Ool003Yoo`03001oogoo011oo`03G_Moogoo01Moo`03
G_Moogoo009oo`03G_Moogoo01eoo`03G_Moogoo01Uoo`03G_Moogoo009oo`03G_Moogoo011oo`03
G_Moogoo00Yoo`03G_Moogoo00Moo`030^ioogoo00Ioo`03G_Moogoo00Ioo`03G_Moogoo00Moo`03
G_Moogoo00]oo`05G_MoogooOol0001BOol003Yoo`03001oogoo011oo`03G_Moogoo01Ioo`03G_Mo
ogoo00=oo`03G_Moogoo01eoo`03G_Moogoo01Qoo`03G_Moogoo00=oo`03G_Moogoo00moo`03G_Mo
ogoo00]oo`03G_Moogoo00Moo`030^ioogoo00Ioo`03G_Moogoo00Ioo`03G_Moogoo00Moo`03G_Mo
ogoo00]oo`05G_MoogooOol0001BOol003Yoo`03001oogoo011oo`03G_Moogoo01Eoo`03G_Moogoo
00Aoo`03G_Moogoo01eoo`03G_Moogoo01Qoo`03G_Moogoo00=oo`03G_Moogoo00moo`03G_Moogoo
00]oo`03G_Moogoo00Moo`03G_Moogoo00Ioo`03G_Moogoo00Ioo`03G_Moogoo00Moo`03G_Moogoo
00]oo`05G_MoogooOol0001BOol003Yoo`80015oo`03G_Moogoo01=oo`9Nm`Moo`03G_Moogoo01eo
o`03G_Moogoo01Moo`03G_Moogoo00Eoo`03G_Moogoo00ioo`03G_Moogoo00]oo`03G_Moogoo00Mo
o`03G_Moogoo00Ioo`03G_Moogoo00Ioo`03G_Moogoo00Moo`03G_Moogoo00]oo`03G_Moogoo0080
059oo`00>Woo00<007ooOol047oo00=NmgooOol04Woo00=NmgooOol01goo00=NmgooOol07Goo00=N
mgooOol05goo00=NmgooOol01Goo00=NmgooOol03Goo00=NmgooOol037oo00=NmgooOol01goo00<2
jgooOol01Woo00=NmgooOol01Woo00=NmgooOol01goo00=NmgooOol037oo00ANmgooOol0059oo`00
>Woo00<007ooOol047oo00=NmgooOol04Goo00=NmgooOol027oo00=NmgooOol07Goo00=NmgooOol0
5Woo00=NmgooOol01Woo00=NmgooOol03Goo00=NmgooOol02goo00=NmgooOol027oo00<2jgooOol0
1Woo00=NmgooOol01Woo00=NmgooOol027oo00=NmgooOol02goo00ANmgooOol0059oo`00>Woo00<0
07ooOol047oo00=NmgooOol047oo00=NmgooOol02Goo00=NmgooOol07Goo00=NmgooOol05Woo00=N
mgooOol01Woo00=NmgooOol03Goo00=NmgooOol02goo00=NmgooOol027oo00=NmgooOol01Woo00=N
mgooOol01Woo00=NmgooOol027oo00=NmgooOol02goo00ANmgooOol0059oo`00>Woo00<007ooOol0
47oo00=NmgooOol03goo00=NmgooOol02goo00=NmgooOol07Goo00=NmgooOol057oo00=NmgooOol0
1goo00=NmgooOol037oo00=NmgooOol037oo00=NmgooOol027oo00<2j7ooOol01Woo00=NmgooOol0
1Woo00=NmgooOol027oo00=NmgooOol037oo00=Nmgoo0000DWoo000jOol00`00Oomoo`0@Ool00ekg
Oomoo`0=Ool2G_L>Ool00ekgOomoo`0MOol00ekgOomoo`0DOol00ekgOomoo`08Ool00ekgOomoo`0;
Ool00ekgOomoo`0<Ool00ekgOomoo`08Ool00`;XOomoo`06Ool00ekgOomoo`06Ool00ekgOomoo`08
Ool00ekgOomoo`0<Ool00ekgOol0001BOol003Yoo`03001oogoo015oo`03G_Moogoo00]oo`03G_Mo
ogoo00ioo`03G_Moogoo01eoo`03G_Moogoo01=oo`03G_Moogoo00Uoo`03G_Moogoo00]oo`03G_Mo
ogoo00aoo`03G_Moogoo00Qoo`03G_Moogoo00Ioo`03G_Moogoo00Ioo`03G_Moogoo00Qoo`03G_Mo
ogoo00aoo`03G_Moo`00059oo`00>Woo00<007ooOol04Goo00=NmgooOol02Woo00=NmgooOol03goo
00=NmgooOol07Goo00=NmgooOol04goo00=NmgooOol02Goo00=NmgooOol02Woo00=NmgooOol03Goo
00=NmgooOol01goo00=Nm`;UOol01goo00=NmgooOol01goo00=NmgooOol01goo00=NmgooOol03Goo
00=Nm`00Ool0DGoo000jOol00`00Oomoo`0AOol00ekgOomoo`09Ool00ekgOomoo`0@Ool00ekgOomo
o`0MOol00ekgOomoo`0BOol00ekgOomoo`0:Ool00ekgOomoo`0:Ool00ekgOomoo`0<Ool00ekgOomo
o`08Ool00ekg0^Eoo`07Ool00ekgOomoo`07Ool00ekgOomoo`08Ool00ekgOomoo`0<Ool00ekg001o
o`1AOol003Yoo`80019oo`03G_Moogoo00Qoo`03G_Moogoo015oo`03G_Moogoo01eoo`03G_Moogoo
015oo`03G_Moogoo00aoo`03G_Moogoo00Uoo`03G_Moogoo00aoo`03G_Moogoo00Qoo`03G_Moogoo
00Moo`03G_Moogoo00Moo`03G_Moogoo00Qoo`03G_Moogoo00aoo`03G_L007oo055oo`00>Woo00<0
07ooOol04Goo00=NmgooOol01goo00=NmgooOol04Woo00=NmgooOol07Woo00=NmgooOol047oo00=N
mgooOol037oo00=NmgooOol02Goo00=NmgooOol037oo00=NmgooOol027oo00<2hWooOol01goo00=N
mgooOol01goo00=NmgooOol027oo00=NmgooOol03Goo00<007ooOol0D7oo000jOol00`00Oomoo`0A
Ool00ekgOomoo`05Ool2G_LEOol00ekgOomoo`0NOol00ekgOomoo`0?Ool00ekgOomoo`0=Ool00ekg
Oomoo`08Ool00ekgOomoo`0=Ool00ekgOomoo`08Ool00`;ROomoo`07Ool00ekgOomoo`07Ool00ekg
Oomoo`08Ool00ekgOomoo`0=Ool00`00Oomoo`1@Ool003Yoo`03001oogoo015oo`03G_Moogoo00Ao
o`03G_Moogoo01Eoo`03G_Moogoo01ioo`03G_Moogoo00moo`03G_Moogoo00eoo`03G_Moogoo00Qo
o`03G_Moogoo00eoo`03G_Moogoo00Qoo`03G_Moogoo00Moo`03G_Moogoo00Moo`03G_Moogoo00Qo
o`03G_Moogoo00eoo`03001oogoo051oo`00>Woo00<007ooOol04Goo00=NmgooOol00goo00=Nmgoo
Ool05goo00=NmgooOol07Goo00=NmgooOol03Woo00=NmgooOol03goo00=NmgooOol01goo00=Nmgoo
Ool037oo00=NmgooOol02Goo00=NmgooOol01goo00=NmgooOol01goo00=NmgooOol02Goo00=Nmgoo
Ool037oo00<007ooOol0D7oo000jOol00`00Oomoo`0AOol00ekgOomoo`02Ool00ekgOomoo`0HOol0
0ekgOomoo`0MOol00ekgOomoo`0>Ool00ekgOomoo`0?Ool00ekgOomoo`06Ool00ekgOomoo`0=Ool0
0ekgOomoo`09Ool00ekgOomoo`07Ool00ekgOomoo`07Ool00ekgOomoo`09Ool00ekgOomoo`0<Ool0
0`00Oomoo`1@Ool003Yoo`03001oogoo015oo`05G_MoogooOomNm`0KOol00ekgOomoo`0MOol00ekg
Oomoo`0=Ool00ekgOomoo`0@Ool00ekgOomoo`06Ool00ekgOomoo`0=Ool00ekgOomoo`09Ool00ekg
Oomoo`07Ool00ekgOomoo`07Ool00ekgOomoo`09Ool00ekgOomoo`0<Ool00`00Oomoo`1@Ool003Yo
o`03001oogoo015oo`04G_MooekgG_LLOol00ekgOomoo`0MOol00ekgOomoo`0=Ool00ekgOomoo`0@
Ool00ekgOomoo`06Ool00ekgOomoo`0=Ool00ekgOomoo`09Ool00ekgOomoo`07Ool00ekgOomoo`07
Ool00ekgOomoo`09Ool00ekgOomoo`0<Ool00`00Oomoo`1@Ool003Yoo`03001oogoo015oo`9Nmaio
o`03G_Moogoo01ioo`03G_Moogoo00]oo`03G_Moogoo019oo`03G_Moogoo00Aoo`03G_Moogoo00io
o`03G_Moogoo00Uoo`03G_Moogoo00Moo`03G_Moogoo00Moo`03G_Moogoo00Uoo`03G_Moogoo00ao
o`03001oogoo051oo`00>Woo00<007ooOol04Goo0Ukg7Woo00=NmgooOol07Woo00=NmgooOol02Woo
00=NmgooOol04goo00=NmgooOol017oo00=NmgooOol03Goo00=NmgooOol02Goo00=NmgooOol027oo
00=NmgooOol01goo00=NmgooOol02Goo00=NmgooOol037oo00<007ooOol0D7oo000jOol2000AOol0
0ekgOomNm`0NOol00ekgOomoo`0NOol00ekgOomoo`0:Ool00ekgOomoo`0COol00ekgOomoo`04Ool0
0ekgOomoo`0=Ool00ekgOomoo`09Ool00ekgOomoo`08Ool00ekgOomoo`08Ool00ekgOomoo`09Ool0
0ekgOomoo`0:Ool2001BOol003Yoo`03001oogoo00moo`04G_MoogooG_LNOol00ekgOomoo`0NOol0
0ekgOomoo`09Ool00ekgOomoo`0EOol00ekgOomoo`02Ool00ekgOomoo`0>Ool00ekgOomoo`09Ool0
0ekgOomoo`08Ool00ekgOomoo`08Ool00ekgOomoo`09Ool00ekgOomoo`0;Ool00`00Oomoo`1@Ool0
03Yoo`03001oogoo00ioo`05G_MoogooOomNm`0NOol00ekgOomoo`0NOol00ekgOomoo`09Ool00ekg
Oomoo`0EOol00ekgOomoo`02Ool00ekgOomoo`0>Ool00ekgOomoo`09Ool00ekgOomoo`08Ool00ekg
Oomoo`08Ool00ekgOomoo`09Ool00ekgOomoo`0;Ool00`00Oomoo`1@Ool003Yoo`03001oogoo00ao
o`9Nm`Aoo`03G_Moogoo01eoo`03G_Moogoo01eoo`03G_Moogoo00Qoo`03G_Moogoo01Ioo`03G_Mo
ogoo009oo`03G_Moogoo00ioo`03G_Moogoo00Uoo`03G_Moogoo00Qoo`03G_Moogoo00Qoo`03G_Mo
ogoo00Uoo`03G_Moogoo00]oo`03001oogoo051oo`00>Woo00<007ooOol02goo00=NmgooOol017oo
00=NmgooOol07Goo00=NmgooOol07Woo00=NmgooOol01goo00=NmgooOol05Woo00ENmgooOomooekg
015oo`03G_Moogoo00Uoo`03G_Moogoo00Qoo`03G_Moogoo00Qoo`03G_Moogoo00Uoo`03G_Moogoo
00]oo`03001oogoo051oo`00>Woo00<007ooOol02Woo00=NmgooOol01Goo00=NmgooOol07Goo00=N
mgooOol07Woo00=NmgooOol01Woo00=NmgooOol067oo00ANmgooOomNma1oo`03G_Moogoo00Yoo`03
G_Moogoo00Qoo`03G_Moogoo00Qoo`03G_Moogoo00Yoo`03G_Moogoo00Yoo`03001oogoo051oo`00
>Woo00<007ooOol02Goo00=NmgooOol01Woo00=NmgooOol07Goo00=NmgooOol07Woo00=NmgooOol0
1Woo00=NmgooOol067oo00ANmgooOomNma1oo`03G_Moogoo00Yoo`03G_Moogoo00Qoo`03G_Moogoo
00Qoo`03G_Moogoo00Yoo`03G_Moogoo00Yoo`03001oogoo051oo`00>Woo00<007ooOol027oo00=N
mgooOol01goo00=NmgooOol07Goo00=NmgooOol07Woo00=NmgooOol01Goo00=NmgooOol06Goo00=N
mgooG_L04Goo00=NmgooOol02Woo00=NmgooOol027oo00=NmgooOol027oo00=NmgooOol02Woo00=N
mgooOol02Woo00<007ooOol0D7oo000jOol00`00Oomoo`06Ool2G_L;Ool00ekgOomoo`0LOol00ekg
Oomoo`0NOol00ekgOomoo`05Ool00ekgOomoo`0JOol2G_LAOol00ekgOomoo`0:Ool00ekgOomoo`08
Ool00ekgOomoo`08Ool00ekgOomoo`0:Ool00ekgOomoo`0:Ool00`00Oomoo`1@Ool003Yoo`8000Io
o`03G_Moogoo00]oo`03G_Moogoo01aoo`03G_Moogoo01ioo`03G_Moogoo00Aoo`03G_Moogoo01]o
o`9Nma5oo`03G_Moogoo00Yoo`03G_Moogoo00Qoo`03G_Moogoo00Qoo`03G_Moogoo00Yoo`03G_Mo
ogoo00Uoo`80059oo`00>Woo00<007ooOol017oo00=NmgooOol037oo00=NmgooOol077oo00=Nmgoo
Ool07goo00=NmgooOol00Woo00=NmgooOol077oo0Ukg47oo00=NmgooOol02goo00=NmgooOol027oo
00=NmgooOol027oo00=NmgooOol02goo00=NmgooOol02Goo00<007ooOol0D7oo000jOol00`00Oomo
o`03Ool00ekgOomoo`0=Ool00ekgOomoo`0LOol00ekgOomoo`0OOol00ekgOomoo`02Ool00ekgOomo
o`0LOol2G_L@Ool00ekgOomoo`0:Ool00ekgOomoo`09Ool00ekgOomoo`09Ool00ekgOomoo`0:Ool0
0ekgOomoo`09Ool00`00Oomoo`1@Ool003Yoo`03001oogoo009oo`03G_Moogoo00ioo`03G_Moogoo
01eoo`03G_Moogoo01ioo`05G_MoogooOomNm`0OOol2G_L@Ool00ekgOomoo`0:Ool00ekgOomoo`09
Ool00ekgOomoo`09Ool00ekgOomoo`0:Ool00ekgOomoo`09Ool00`00Oomoo`1@Ool003Yoo`03001o
ogoo009Nma5oo`03G_Moogoo01eoo`03G_Moogoo01ioo`05G_MoogooOomNm`0OOol2G_L@Ool00ekg
Oomoo`0:Ool00ekgOomoo`09Ool00ekgOomoo`09Ool00ekgOomoo`0:Ool00ekgOomoo`09Ool00`00
Oomoo`1@Ool003Yoo`03001ooekg01=oo`03G_Moogoo01eoo`03G_Moogoo01ioo`04G_MoogooG_LO
Ool015kgOomooekg3goo00=NmgooOol02Woo00=NmgooOol02Goo00=NmgooOol02Goo00=NmgooOol0
2Woo00=NmgooOol02Goo00<007ooOol0D7oo000jOol00`00G_Moo`0COol00ekgOomoo`0MOol00ekg
Oomoo`0NOol015kgOomooekg7goo00ANmgooOomNm`moo`03G_Moogoo00Yoo`03G_Moogoo00Uoo`03
G_Moogoo00Uoo`03G_Moogoo00Yoo`03G_Moogoo00Uoo`03001oogoo051oo`00>Woo00=NmgooOol0
4goo00=NmgooOol07Goo00=NmgooOol07goo0Ukg87oo00ENmgooOomooekg00eoo`03G_Moogoo00]o
o`03G_Moogoo00Uoo`03G_Moogoo00Uoo`03G_Moogoo00]oo`03G_Moogoo00Qoo`03001oogoo051o
o`00=7oo0P0017oo00<007ooOol04goo00=NmgooOol07Goo00=NmgooOol07goo0Ukg7goo00=Nmgoo
Ool00Woo00=NmgooOol02goo00=NmgooOol02goo00=NmgooOol02Goo00=NmgooOol02Goo00=Nmgoo
Ool02goo00=NmgooOol027oo00<007ooOol0D7oo000cOol01000Oomoo`000goo00<007ooOol057oo
00=NmgooOol077oo00=NmgooOol07goo00=NmgooOol07Woo00=NmgooOol00Woo00=NmgooOol02goo
00=NmgooOol02goo00=NmgooOol02Goo00=NmgooOol02Goo00=NmgooOol02goo00=NmgooOol027oo
00<007ooOol0D7oo000eOol00`00Oomoo`02Ool2000EOol00ekgOomoo`0LOol00ekgOomoo`0OOol0
0ekgOomoo`0NOol00ekgOomoo`03Ool00ekgOomoo`0:Ool00ekgOomoo`0;Ool00ekgOomoo`09Ool0
0ekgOomoo`09Ool00ekgOomoo`0;Ool00ekgOomoo`06Ool3001BOol003Ioo`05001oogooOol0000F
Ool00ekgOomoo`0LOol00ekgOomoo`0NOol2G_LOOol00ekgOomoo`04Ool00ekgOomoo`0:Ool00ekg
Oomoo`0;Ool00ekgOomoo`09Ool00ekgOomoo`09Ool00ekgOomoo`0;Ool00ekgOomoo`08Ool00`00
Oomoo`1@Ool003=oo`04001oogoo0003Ool00`00Oomoo`0DOol00ekgOomoo`0MOol00ekgOomoo`0L
Ool00ekgOomNm`0OOol00ekgOomoo`04Ool00ekgOomoo`09Ool00ekgOomoo`0<Ool00ekgOomoo`09
Ool00ekgOomoo`09Ool00ekgOomoo`0<Ool00ekgOomoo`07Ool00`00Oomoo`1@Ool003Aoo`8000Ao
o`03001oogoo01Aoo`03G_Moogoo01eoo`03G_Moogoo01aoo`04G_MoogooG_LNOol00ekgOomoo`05
Ool00ekgOomoo`08Ool00ekgOomoo`0<Ool00ekgOomoo`09Ool00ekgOomoo`09Ool00ekgOomoo`0<
Ool00ekgOomoo`07Ool00`00Oomoo`1@Ool003Yoo`03001oogoo01Aoo`03G_Moogoo01eoo`03G_Mo
ogoo01]oo`05G_MoogooOomNm`0MOol00ekgOomoo`06Ool00ekgOomoo`08Ool00ekgOomoo`0;Ool0
0ekgOomoo`0:Ool00ekgOomoo`0:Ool00ekgOomoo`0;Ool00ekgOomoo`07Ool00`00Oomoo`1@Ool0
03Yoo`03001oogoo01Aoo`03G_Moogoo01eoo`03G_Moogoo01]oo`05G_MoogooOomNm`0MOol00ekg
Oomoo`06Ool00ekgOomoo`08Ool00ekgOomoo`0;Ool00ekgOomoo`0:Ool00ekgOomoo`0:Ool00ekg
Oomoo`0;Ool00ekgOomoo`07Ool00`00Oomoo`1@Ool003Yoo`03001oogoo01Aoo`03G_Moogoo01eo
o`03G_Moogoo01Yoo`03G_Moogoo009oo`03G_Moogoo01]oo`03G_Moogoo00Moo`03G_Moogoo00Mo
o`03G_Moogoo00]oo`03G_Moogoo00Yoo`03G_Moogoo00Yoo`03G_Moogoo00]oo`03G_Moogoo00Mo
o`03001oogoo051oo`00>Woo00<007ooOol057oo00=NmgooOol07Goo00=NmgooOol06Woo00=Nmgoo
Ool00Woo00=NmgooOol06Woo00=NmgooOol027oo00=NmgooOol01goo00=NmgooOol02goo00=Nmgoo
Ool02Woo00=NmgooOol02Woo00=NmgooOol02goo00=NmgooOol01goo00<007ooOol0D7oo000jOol0
0`00Oomoo`0EOol00ekgOomoo`0LOol00ekgOomoo`0IOol00ekgOomoo`04Ool00ekgOomoo`0IOol0
0ekgOomoo`09Ool00ekgOomoo`05Ool00ekgOomoo`0<Ool00ekgOomoo`0:Ool00ekgOomoo`0:Ool0
0ekgOomoo`0<Ool00ekgOomoo`06Ool00`00Oomoo`1@Ool003Yoo`8001Ioo`03G_Moogoo01aoo`03
G_Moogoo01Uoo`03G_Moogoo00Aoo`03G_Moogoo01Uoo`03G_Moogoo00Uoo`03G_Moogoo00Eoo`03
G_Moogoo00aoo`03G_Moogoo00Yoo`03G_Moogoo00Yoo`03G_Moogoo00aoo`03G_Moogoo00Eoo`03
G_L007oo055oo`00>Woo00<007ooOol05Goo00=NmgooOol07Goo00=NmgooOol05goo00=NmgooOol0
1Goo00=NmgooOol067oo00=NmgooOol02goo00=NmgooOol017oo00=NmgooOol037oo00=NmgooOol0
2Woo00=NmgooOol02Woo00=NmgooOol037oo00=NmgooOol01Goo00=Nm`00Ool0DGoo000jOol00`00
Oomoo`0EOol00ekgOomoo`0MOol00ekgOomoo`0FOol00ekgOomoo`06Ool00ekgOomoo`0HOol00ekg
Oomoo`0;Ool00ekgOomoo`04Ool00ekgOomoo`0<Ool00ekgOomoo`0:Ool00ekgOomoo`0:Ool00ekg
Oomoo`0<Ool00ekgOomoo`04Ool00ekgOol0001BOol003Yoo`03001oogoo01Eoo`03G_Moogoo01eo
o`03G_Moogoo01Ioo`03G_Moogoo00Ioo`03G_Moogoo01Qoo`03G_Moogoo00]oo`03G_Moogoo00Ao
o`03G_Moogoo00aoo`03G_Moogoo00Yoo`03G_Moogoo00Yoo`03G_Moogoo00aoo`03G_Moogoo00Ao
o`03G_Moo`00059oo`00>Woo00<007ooOol05Goo00=NmgooOol07Goo00=NmgooOol05Goo00=Nmgoo
Ool027oo00=NmgooOol05goo00=NmgooOol037oo00=NmgooOol00Woo00=NmgooOol03Goo00=Nmgoo
Ool02Woo00=NmgooOol02Woo00=NmgooOol03Goo00=NmgooOol00Woo00ANmgooOol0059oo`00>Woo
00<007ooOol05Goo00=NmgooOol07Goo00=NmgooOol05Goo00=NmgooOol027oo00=NmgooOol05Woo
00=NmgooOol03Goo00=NmgooOol00Woo00=NmgooOol03Goo00=NmgooOol02Woo00=NmgooOol02Woo
00=NmgooOol03Goo00=NmgooOol00Woo00ANmgooOol0059oo`00>Woo00<007ooOol05Goo00=Nmgoo
Ool07Goo00=NmgooOol057oo00=NmgooOol02Goo00=NmgooOol05Woo00=NmgooOol03Woo00ENmgoo
Oomooekg00moo`03G_Moogoo00Yoo`03G_Moogoo00Yoo`03G_Moogoo00eoo`05G_MoogooOomNm`03
Ool00`00Oomoo`1@Ool003Yoo`03001oogoo01Eoo`03G_Moogoo01eoo`03G_Moogoo01Aoo`03G_Mo
ogoo00Uoo`03G_Moogoo01Ioo`03G_Moogoo00ioo`05G_MoogooOomNm`0>Ool00ekgOomoo`0;Ool0
0ekgOomoo`0;Ool00ekgOomoo`0<Ool01EkgOomoogooG_L00goo00<007ooOol0D7oo000jOol00`00
Oomoo`0FOol00ekgOomoo`0LOol00ekgOomoo`0COol00ekgOomoo`0:Ool00ekgOomoo`0EOol00ekg
Oomoo`0@Ool015kgOomooekg3Woo00=NmgooOol02goo00=NmgooOol02goo00=NmgooOol037oo00AN
mgooOomNm`Aoo`03001oogoo051oo`00>Woo00<007ooOol05Woo00=NmgooOol07Goo00=NmgooOol0
4Woo00=NmgooOol02Woo00=NmgooOol05Goo00=NmgooOol047oo00ANmgooOomNm`ioo`03G_Moogoo
00]oo`03G_Moogoo00]oo`03G_Moogoo00aoo`04G_MoogooG_L4Ool00`00Oomoo`1@Ool003Yoo`80
00eoo`03001oogoo00Moo`03G_Moogoo015oo`03001oogoo00Uoo`03G_Moogoo00moo`03001ooekg
00ioo`03G_Moogoo00]oo`03001oogoo00Ioo`03G_Moogoo011oo`03G_Mooekg00moo`03G_Moogoo
00]oo`03G_Moogoo00]oo`03G_Moogoo00eoo`03G_Mooekg00=oo`80059oo`00>Woo00<007ooOol0
1Goo00<007ooOol017oo00<007ooOol01Goo00<007ooG_L017oo00<007ooOol01Goo00<007ooOol0
17oo00<007ooOol01Goo00D007ooOomooekg009oo`03001oogoo00Eoo`03001oogoo00Aoo`03001o
oekg00Eoo`03001oogoo00Eoo`03001Nmgoo00Aoo`03001oogoo00Eoo`03001oogoo00Aoo`03001N
mgoo00Eoo`03001oogoo00Aoo`03001oogoo00Aoo`9Nm`Ioo`03001oogoo00Eoo`03001Nmgoo00Ao
o`03001oogoo00Eoo`03G_Moogoo00Eoo`03001oogoo00=oo`03G_L007oo00Ioo`03001oogoo00Ao
o`9Nm`Eoo`03001oogoo051oo`00>Woo6@0000=Nm`0000007@0000=Nm`000000400000=Nm`000000
3@0000=Nm`0000004`0000=Nm`0000004P000Ukg3`0000=Nm`0000002`0000=Nm`0000002`0000=N
m`0000003@000Ukg1P00DWoo003oOomIOol00?mooeUoo`00ogooFGoo003oOomIOol00?mooeUoo`00
ogooFGoo003oOomIOol00?mooeUoo`00ogooFGoo003oOomIOol00?mooeUoo`00ogooFGoo003oOomI
Ool00?mooeUoo`00ogooFGoo003oOomIOol004eoo`03001oogoo01Qoo`03001oogoo00Qoo`03001o
ogoo01Qoo`03001oogoo00Qoo`03001oogoo049oo`03001oogoo00Uoo`03001oogoo02eoo`03001o
ogoo03]oo`00C7oo00<007ooOol037oo00<007ooOol02goo00<007ooOol01Woo00<007ooOol037oo
00<007ooOol02goo00<007ooOol01Woo00<007ooOol04Goo00<007ooOol08goo00<007ooOol02Woo
00<007ooOol01goo00<007ooOol047oo00<007ooOol03goo00<007ooOol02Woo00<007ooOol0>Woo
0012Ool30006Ool00`00Oomoo`02Ool30008Ool00`00Oomoo`03Ool40005Ool00`00Oomoo`04Ool0
0`00Oomoo`02Ool30008Ool00`00Oomoo`04Ool20006Ool00`00Oomoo`04Ool00`00Oomoo`02Ool3
000=Ool00`00Oomoo`04Ool20004Ool20003Ool40005Ool30008Ool00`00Oomoo`03Ool40004Ool0
0`00Oomoo`05Ool00`00Oomoo`02Ool3000<Ool00`00Oomoo`04Ool30008Ool00`00Oomoo`03Ool5
0003Ool00`00Oomoo`0iOol004Aoo`8000Eoo`03001oogoo00Aoo`8000Eoo`D000=oo`03001oogoo
00Ioo`03001oogoo00Aoo`03001oogoo00Aoo`8000Eoo`D000=oo`04001oogoo0005Ool00`00Oomo
o`04Ool00`00Oomoo`04Ool2000:Ool50003Ool01000Oomoo`0027oo00<007ooOol027oo0P001Goo
1@000goo00<007ooOol01Goo00<007ooOol01Goo00<007ooOol017oo0P002Goo1@001Woo0P001Goo
1@001Goo00<007ooOol00goo00<007ooOol0>Goo0013Ool00`00Oomoo`05Ool00`00Oomoo`03Ool0
0`00Oomoo`07Ool00`00Oomoo`04Ool00`00Oomoo`05Ool00`00Oomoo`04Ool00`00Oomoo`03Ool0
0`00Oomoo`07Ool00`00Oomoo`06Ool00`00Oomoo`03Ool00`00Oomoo`04Ool00`00Oomoo`03Ool0
0`00Oomoo`0<Ool00`00Oomoo`03Ool01000Oomoo`002Goo00<007ooOol01Woo00<007ooOol01goo
00<007ooOol017oo00<007ooOol017oo00<007ooOol01Goo00<007ooOol00goo00<007ooOol02goo
00<007ooOol01Goo00<007ooOol01goo00<007ooOol01Goo00<007ooOol00goo00<007ooOol0>Goo
0013Ool30005Ool00`00Oomoo`03Ool30007Ool00`00Oomoo`05Ool00`00Oomoo`04Ool00`00Oomo
o`04Ool00`00Oomoo`03Ool30007Ool00`00Oomoo`04Ool20006Ool00`00Oomoo`04Ool00`00Oomo
o`03Ool30002Ool20008Ool00`00Oomoo`03Ool01000Oomoo`002Woo00<007ooOol01Goo0`001goo
00<007ooOol01Goo00<007ooOol00goo00<007ooOol01Goo00<007ooOol00goo0`000Woo0P001goo
00<007ooOol01Goo0`001goo00<007ooOol01Goo00<007ooOol00goo00<007ooOol0>Goo000UOol2
0009Ool2000JOol00`00Oomoo`0BOol01000Oomoo`0017oo00<007ooOol01Woo00<007ooOol04goo
00<007ooOol017oo00<007ooOol01Woo00<007ooOol01goo00<007ooOol03Goo00@007ooOol000Qo
o`04001oogoo000FOol01000Oomoo`000goo00<007ooOol01goo00<007ooOol01goo00<007ooOol0
87oo00<007ooOol00Woo00<007ooOol0>Woo000UOol00`00Oomoo`09Ool00`00Oomoo`0IOol00`00
Oomoo`0BOol20004Ool00`00Oomoo`08Ool00`00Oomoo`0BOol30003Ool00`00Oomoo`08Ool00`00
Oomoo`07Ool00`00Oomoo`0=Ool2000:Ool2000HOol20003Ool00`00Oomoo`09Ool00`00Oomoo`07
Ool00`00Oomoo`0NOol20003Ool00`00Oomoo`0kOol001ioo`8000Eoo`04001oogooOol30005Ool0
0`00Oomoo`02Ool4001XOol2001?Ool2001SOol001eoo`04001oogoo0004Ool00`00Oomoo`04Ool0
0`00Oomoo`02Ool00`00Oomoo`0;Oom00008Oom00008OolP0004OolP0004Ool400000goo00000002
000hOol001eoo`03001oo`00008000=oo`04001oogooOol30005Ool00`00Oomoo`02Ool4003oOolO
Ool001eoo`03001oogoo00Eoo`04001oogooOol40004Ool00`00Oomoo`3oOolUOol001eoo`03001o
ogoo00Eoo`03001oogoo00Uoo`03001oogoo05Qoo`03001oogoo01Qoo`03001oogoo00Qoo`03001o
ogoo01ioo`03001oogoo089oo`007Woo0`0017oo0P002Goo0P00FGoo00<007ooOol037oo00<007oo
Ool02goo00<007ooOol01Woo00<007ooOol037oo00<007ooOol04Goo00<007ooOol0PGoo002:Ool0
0`00Oomoo`02Ool30008Ool00`00Oomoo`05Ool30004Ool00`00Oomoo`04Ool00`00Oomoo`02Ool3
0008Ool00`00Oomoo`03Ool50002Ool20006Ool00`00Oomoo`20Ool008Yoo`03001oogoo00Aoo`80
00Eoo`D000Ioo`03001oogoo00=oo`03001oogoo00Aoo`03001oogoo00Aoo`8000Eoo`D000Eoo`05
001oogooOol00002Ool00`00Oomoo`03Ool00`00Oomoo`20Ool008Yoo`03001oogoo00=oo`03001o
ogoo00Moo`03001oogoo00=oo`D000Aoo`03001oogoo00Aoo`03001oogoo00=oo`03001oogoo00Mo
o`03001oogoo00Eoo`05001oogooOol00002Ool00`00Oomoo`03Ool00`00Oomoo`20Ool008Yoo`03
001oogoo00=oo`<000Moo`03001oogoo00=oo`04001oogoo0005Ool00`00Oomoo`04Ool00`00Oomo
o`03Ool30007Ool00`00Oomoo`05Ool01@00Oomoogoo00000Woo00<007ooOol00goo00<007ooOol0
P7oo002;Ool00`00Oomoo`0COol00`00Ool00004Ool00`00Oomoo`06Ool00`00Oomoo`0DOol01@00
Oomoogoo00000Woo00<007ooOol00Woo00<007ooOol0PGoo002<Ool00`00Oomoo`0COol20003Ool0
0`00Oomoo`08Ool00`00Oomoo`0BOol20004Ool20004Ool00`00Oomoo`22Ool00?mooeUoo`00ogoo
FGoo003oOomIOol00?mooeUoo`00ogooFGoo003oOomIOol00?mooeUoo`00ogooFGoo003oOomIOol0
0?mooeUoo`00ogooFGoo003oOomIOol00?mooeUoo`00ogooFGoo003oOomIOol00?mooeUoo`00ogoo
FGoo003oOomIOol00?mooeUoo`00ogooFGoo003oOomIOol00?mooeUoo`00ogooFGoo003oOomIOol0
0?mooeUoo`00ogooFGoo003oOomIOol00?mooeUoo`00ogooFGoo003oOomIOol00?mooeUoo`00ogoo
FGoo003oOomIOol00?mooeUoo`00ogooFGoo003oOomIOol00?mooeUoo`00ogooFGoo003oOomIOol0
0?mooeUoo`00ogooFGoo003oOomIOol00?mooeUoo`00ogooFGoo003oOomIOol00?mooeUoo`00ogoo
FGoo003oOomIOol00001\
\>"],
  ImageRangeCache->{{{0, 343.188}, {484.438, 0}} -> {-0.653492, -1.05089, \
0.00433859, 0.00433859}, {{8.125, 293.063}, {472.688, 11.6875}} -> {-14.8818, \
-4.93489, 0.0662989, 0.0209549}, {{311.938, 335}, {357.438, 242.188}} -> \
{-27.6283, -33.1231, 0.0885042, 0.260653}},
  CellTags->{"Root Locus", "i:11", "b:20.3"}],

Cell[BoxData[
    TagBox[\(\[SkeletonIndicator]  Graphics  \[SkeletonIndicator]\),
      False,
      Editable->False]], "Output",
  CellLabel->"Out[139]=",
  CellTags->{"Root Locus", "i:11", "b:20.3"}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Pole-Zero Plot", "Subsection",
  Evaluatable->False,
  AspectRatioFixed->True,
  CellTags->{"Pole-Zero Plot", "i:12", "b:20.4"}],

Cell["\<\
A view of the singlarities of a transfer function is obtained from the \
pole-zero plot. Try the transfer function\
\>", "Text",
  Evaluatable->False,
  AspectRatioFixed->True,
  CellTags->{"Pole-Zero Plot", "i:12", "b:20.4"}],

Cell[BoxData[
    \(G[s_] := 
      10\/\(\((s + 5)\)\ \((s\^2 + 5\ s + 2)\)\ \((s\^2 + 1\ s + 3)\)\)\)], \
"Input",
  CellLabel->"In[140]:=",
  PageWidth->Infinity,
  AspectRatioFixed->True,
  CellTags->{"Pole-Zero Plot", "i:12", "b:20.4"}],

Cell["Now, the plot", "Text",
  Evaluatable->False,
  AspectRatioFixed->True,
  CellTags->{"Pole-Zero Plot", "i:12", "b:20.4"}],

Cell[CellGroupData[{

Cell[BoxData[
    \(PoleZeroPlot[G, s]\)], "Input",
  CellLabel->"In[141]:=",
  PageWidth->Infinity,
  AspectRatioFixed->True,
  CellTags->{"Pole-Zero Plot", "i:12", "b:20.4"}],

Cell[BoxData[
    InterpretationBox[\("There are "\[InvisibleSpace]5\[InvisibleSpace]" \
poles located at:\n"\),
      SequenceForm[ "There are ", 5, " poles located at:\n"],
      Editable->False]], "Print",
  CellLabel->"From In[141]:=",
  CellTags->{"Pole-Zero Plot", "i:12", "b:20.4"}],

Cell[BoxData[
    \({{\(-5.`\), 0}, {\(-4.561552812808831`\), 
        0}, {\(-0.5`\), \(-1.6583123951777`\)}, {\(-0.5`\), 
        1.6583123951777`}, {\(-0.4384471871911697`\), 0}}\)], "Print",
  CellLabel->"From In[141]:=",
  CellTags->{"Pole-Zero Plot", "i:12", "b:20.4"}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .81114 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% SurfaceGraphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-1.55041e-017 1.04977 -0.0679587 1.04977 [
[.08489 .22362 -12 -8.86949 ]
[.08489 .22362 0 .13051 ]
[.20669 .17569 -11.6763 -9 ]
[.20669 .17569 .3237 0 ]
[.3345 .12542 -5.5867 -9 ]
[.3345 .12542 .4133 0 ]
[.46877 .07262 -5.33525 -9 ]
[.46877 .07262 .66475 0 ]
[.61001 .01712 -5.0838 -9 ]
[.61001 .01712 .9162 0 ]
[.29165 .07573 -26.5368 -13.1875 ]
[.29165 .07573 1.96317 0 ]
[.76936 .09995 0 -6.15903 ]
[.76936 .09995 12 2.84097 ]
[.85112 .22515 0 -6.03904 ]
[.85112 .22515 12 2.96096 ]
[.92375 .33638 0 -5.93524 ]
[.92375 .33638 12 3.06476 ]
[.91861 .21225 0 -8.83749 ]
[.91861 .21225 28.5 4.35001 ]
[.02414 .26497 -6 -2.7422 ]
[.02414 .26497 0 6.2578 ]
[.01073 .34897 -6 -2.81329 ]
[.01073 .34897 0 6.18671 ]
[-0.00342 .43769 -6 -2.88879 ]
[-0.00342 .43769 0 6.11121 ]
[-0.05457 .39542 -22.375 -4.15171 ]
[-0.05457 .39542 0 9.03579 ]
[ 0 0 0 0 ]
[ 1 .81114 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.03716 .25514 m
.68874 0 L
s
.0943 .23276 m
.09901 .23733 L
s
[(-2)] .08489 .22362 1 .971 Mshowa
.21571 .18522 m
.22021 .18999 L
s
[(-1)] .20669 .17569 .94605 1 Mshowa
.34306 .13535 m
.34735 .14032 L
s
[(0)] .3345 .12542 .86223 1 Mshowa
.47683 .08298 m
.48086 .08815 L
s
[(1)] .46877 .07262 .77842 1 Mshowa
.6175 .02789 m
.62124 .03328 L
s
[(2)] .61001 .01712 .6946 1 Mshowa
.125 Mabswid
.11813 .22343 m
.12093 .2262 L
s
.14218 .21402 m
.14496 .2168 L
s
.16645 .20451 m
.16921 .20732 L
s
.19096 .19491 m
.19369 .19775 L
s
.24069 .17544 m
.24337 .17833 L
s
.26591 .16557 m
.26856 .16847 L
s
.29138 .15559 m
.294 .15853 L
s
.3171 .14552 m
.31969 .14848 L
s
.36929 .12509 m
.37183 .12809 L
s
.39578 .11471 m
.39829 .11775 L
s
.42252 .10424 m
.42501 .1073 L
s
.44954 .09366 m
.45199 .09674 L
s
.5044 .07218 m
.50678 .07531 L
s
.53224 .06128 m
.53459 .06444 L
s
.56037 .05026 m
.56269 .05345 L
s
.58879 .03914 m
.59107 .04234 L
s
.0707 .242 m
.07355 .24472 L
s
.04732 .25116 m
.05019 .25386 L
s
.64651 .01654 m
.64872 .01979 L
s
.67582 .00506 m
.67799 .00834 L
s
gsave
.29165 .07573 -87.5368 -17.1875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 21.1875 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(Imag) show
87.500 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.25 Mabswid
.68874 0 m
.96935 .42924 L
s
.75705 .10449 m
.75089 .10676 L
s
[(-6)] .76936 .09995 -1 .36867 Mshowa
.8387 .2294 m
.8325 .23152 L
s
[(-4)] .85112 .22515 -1 .34201 Mshowa
.91125 .34037 m
.905 .34236 L
s
[(-2)] .92375 .33638 -1 .31894 Mshowa
.125 Mabswid
.77841 .13717 m
.77471 .1385 L
s
.79912 .16885 m
.79541 .17016 L
s
.81921 .19958 m
.81549 .20087 L
s
.85763 .25835 m
.8539 .25961 L
s
.87602 .28647 m
.87228 .28771 L
s
.89388 .3138 m
.89014 .31502 L
s
.735 .07077 m
.73132 .07216 L
s
.71224 .03596 m
.70857 .03737 L
s
.92814 .3662 m
.92438 .36738 L
s
.94457 .39133 m
.9408 .39249 L
s
.96055 .41579 m
.95679 .41693 L
s
gsave
.91861 .21225 -61 -12.8375 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 21.1875 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(Real) show
87.500 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.25 Mabswid
.03716 .25514 m
0 .48963 L
s
.03636 .26019 m
.04247 .25781 L
s
[(0)] .02414 .26497 1 -0.39062 Mshowa
.02302 .34436 m
.02916 .34206 L
s
[(1)] .01073 .34897 1 -0.37482 Mshowa
.00893 .43326 m
.01511 .43105 L
s
[(2)] -0.00342 .43769 1 -0.35805 Mshowa
.125 Mabswid
.03375 .27667 m
.03742 .27525 L
s
.03111 .29332 m
.03478 .29191 L
s
.02844 .31015 m
.03212 .30875 L
s
.02575 .32716 m
.02943 .32577 L
s
.02026 .36175 m
.02395 .36038 L
s
.01748 .37933 m
.02117 .37797 L
s
.01466 .39711 m
.01836 .39576 L
s
.01181 .41509 m
.01552 .41375 L
s
.00602 .45164 m
.00973 .45033 L
s
.00307 .47023 m
.00679 .46893 L
s
9e-005 .48904 m
.00381 .48774 L
s
gsave
-0.05457 .39542 -83.375 -8.15171 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 21.1875 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(Mag) show
81.375 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.25 Mabswid
.03716 .25514 m
0 .48963 L
s
0 .48963 m
.39787 .81114 L
s
.39787 .81114 m
.40529 .59895 L
s
.40529 .59895 m
.03716 .25514 L
s
.68874 0 m
.96935 .42924 L
s
.96935 .42924 m
1 .6535 L
s
1 .6535 m
.70298 .24544 L
s
.70298 .24544 m
.68874 0 L
s
.03716 .25514 m
0 .48963 L
s
0 .48963 m
.70298 .24544 L
s
.70298 .24544 m
.68874 0 L
s
.68874 0 m
.03716 .25514 L
s
.40529 .59895 m
.96935 .42924 L
s
.96935 .42924 m
1 .6535 L
s
1 .6535 m
.39787 .81114 L
s
.39787 .81114 m
.40529 .59895 L
s
0 0 m
1 0 L
1 .81114 L
0 .81114 L
closepath
clip
newpath
.5 Mabswid
0 1 .182 r
.39444 .59732 .40502 .60665 .42268 .60262 .41216 .5936 Metetra
0 1 .067 r
.41216 .5936 .42268 .60262 .44046 .59938 .42998 .59122 Metetra
.088 1 0 r
.42998 .59122 .44046 .59938 .45834 .59763 .44787 .59251 Metetra
.327 1 0 r
.44787 .59251 .45834 .59763 .47635 .59809 .46566 .61074 Metetra
1 .842 0 r
.46566 .61074 .47635 .59809 .49455 .59794 .48254 .73685 Metetra
1 0 .157 r
.48254 .73685 .49455 .59794 .51294 .59217 .50266 .60151 Metetra
1 0 .603 r
.50266 .60151 .51294 .59217 .53146 .58464 .52138 .58233 Metetra
1 0 .819 r
.52138 .58233 .53146 .58464 .55008 .57809 .54012 .57287 Metetra
1 0 .978 r
.54012 .57287 .55008 .57809 .56883 .57273 .55898 .56667 Metetra
.885 0 1 r
.55898 .56667 .56883 .57273 .58774 .56861 .578 .56263 Metetra
.754 0 1 r
.578 .56263 .58774 .56861 .60684 .56614 .59722 .56116 Metetra
.615 0 1 r
.59722 .56116 .60684 .56614 .62618 .56638 .61675 .56451 Metetra
.452 0 1 r
.61675 .56451 .62618 .56638 .64591 .57166 .63698 .58162 Metetra
.252 0 1 r
.63698 .58162 .64591 .57166 .66613 .58268 .66114 .68965 Metetra
.5 1 0 r
.66114 .68965 .66613 .58268 .6859 .57695 .68171 .68407 Metetra
.252 1 0 r
.68171 .68407 .6859 .57695 .70492 .55438 .69664 .56423 Metetra
.452 1 0 r
.69664 .56423 .70492 .55438 .72421 .53748 .7155 .53531 Metetra
.615 1 0 r
.7155 .53531 .72421 .53748 .74383 .5256 .7351 .52017 Metetra
.754 1 0 r
.7351 .52017 .74383 .5256 .76372 .51644 .75506 .50985 Metetra
.885 1 0 r
.75506 .50985 .76372 .51644 .78385 .50893 .77531 .50212 Metetra
1 .978 0 r
.77531 .50212 .78385 .50893 .80421 .50267 .79586 .49659 Metetra
1 .819 0 r
.79586 .49659 .80421 .50267 .82483 .49764 .81687 .4944 Metetra
1 .603 0 r
.81687 .4944 .82483 .49764 .8457 .49361 .83903 .50226 Metetra
1 .157 0 r
.83903 .50226 .8457 .49361 .86657 .48777 .87371 .6307 Metetra
1 0 .842 r
.87371 .6307 .86657 .48777 .88696 .47609 .88115 .48802 Metetra
.327 0 1 r
.88115 .48802 .88696 .47609 .90735 .46374 .89971 .4571 Metetra
.088 0 1 r
.89971 .4571 .90735 .46374 .9281 .45366 .92022 .4437 Metetra
0 .067 1 r
.92022 .4437 .9281 .45366 .94916 .44509 .94129 .43408 Metetra
0 .182 1 r
.94129 .43408 .94916 .44509 .97045 .43733 .96265 .42584 Metetra
0 1 .702 r
.38374 .58756 .39444 .59732 .41216 .5936 .40154 .58377 Metetra
0 1 .682 r
.40154 .58377 .41216 .5936 .42998 .59122 .41943 .58111 Metetra
0 1 .684 r
.41943 .58111 .42998 .59122 .44787 .59251 .43741 .58084 Metetra
0 1 .729 r
.43741 .58084 .44787 .59251 .46566 .61074 .45547 .58521 Metetra
0 1 .396 r
.45547 .58521 .46566 .61074 .48254 .73685 .47377 .58939 Metetra
.985 0 1 r
.47377 .58939 .48254 .73685 .50266 .60151 .49242 .5806 Metetra
.972 0 1 r
.49242 .5806 .50266 .60151 .52138 .58233 .51117 .57028 Metetra
1 0 .998 r
.51117 .57028 .52138 .58233 .54012 .57287 .53 .56252 Metetra
.999 0 1 r
.53 .56252 .54012 .57287 .55898 .56667 .54895 .55672 Metetra
.983 0 1 r
.54895 .55672 .55898 .56667 .578 .56263 .56805 .55258 Metetra
.969 0 1 r
.56805 .55258 .578 .56263 .59722 .56116 .58734 .55035 Metetra
.972 0 1 r
.58734 .55035 .59722 .56116 .61675 .56451 .60687 .55091 Metetra
1 0 .982 r
.60687 .55091 .61675 .56451 .63698 .58162 .62673 .55558 Metetra
1 0 .815 r
.62673 .55558 .63698 .58162 .66114 .68965 .64694 .5623 Metetra
1 0 0 r
.64694 .5623 .66114 .68965 .68171 .68407 .6669 .55642 Metetra
1 .815 0 r
.6669 .55642 .68171 .68407 .69664 .56423 .6864 .53787 Metetra
1 .982 0 r
.6864 .53787 .69664 .56423 .7155 .53531 .706 .52131 Metetra
.972 1 0 r
.706 .52131 .7155 .53531 .7351 .52017 .72587 .50883 Metetra
.969 1 0 r
.72587 .50883 .7351 .52017 .75506 .50985 .74598 .49912 Metetra
.983 1 0 r
.74598 .49912 .75506 .50985 .77531 .50212 .76634 .49135 Metetra
.999 1 0 r
.76634 .49135 .77531 .50212 .79586 .49659 .78697 .48526 Metetra
1 .998 0 r
.78697 .48526 .79586 .49659 .81687 .4944 .80792 .48117 Metetra
.972 1 0 r
.80792 .48117 .81687 .4944 .83903 .50226 .82929 .47973 Metetra
.985 1 0 r
.82929 .47973 .83903 .50226 .87371 .6307 .85073 .47673 Metetra
0 .396 1 r
.85073 .47673 .87371 .6307 .88115 .48802 .87096 .4603 Metetra
0 .729 1 r
.87096 .4603 .88115 .48802 .89971 .4571 .89119 .4436 Metetra
0 .684 1 r
.89119 .4436 .89971 .4571 .92022 .4437 .912 .43167 Metetra
0 .682 1 r
.912 .43167 .92022 .4437 .94129 .43408 .93321 .42219 Metetra
0 .702 1 r
.93321 .42219 .94129 .43408 .96265 .42584 .9547 .41387 Metetra
0 .797 1 r
.37293 .57737 .38374 .58756 .40154 .58377 .3908 .57322 Metetra
0 .743 1 r
.3908 .57322 .40154 .58377 .41943 .58111 .40878 .56967 Metetra
0 .634 1 r
.40878 .56967 .41943 .58111 .43741 .58084 .42689 .56692 Metetra
0 .423 1 r
.42689 .56692 .43741 .58084 .45547 .58521 .44513 .56487 Metetra
0 .054 1 r
.44513 .56487 .45547 .58521 .47377 .58939 .46354 .5625 Metetra
.382 0 1 r
.46354 .5625 .47377 .58939 .49242 .5806 .48212 .55864 Metetra
.704 0 1 r
.48212 .55864 .49242 .5806 .51117 .57028 .50087 .55359 Metetra
.887 0 1 r
.50087 .55359 .51117 .57028 .53 .56252 .51975 .54831 Metetra
.997 0 1 r
.51975 .54831 .53 .56252 .54895 .55672 .53877 .54339 Metetra
1 0 .924 r
.53877 .54339 .54895 .55672 .56805 .55258 .55794 .53909 Metetra
1 0 .847 r
.55794 .53909 .56805 .55258 .58734 .55035 .57727 .53555 Metetra
1 0 .748 r
.57727 .53555 .58734 .55035 .60687 .55091 .59678 .53278 Metetra
1 0 .596 r
.59678 .53278 .60687 .55091 .62673 .55558 .61647 .53035 Metetra
1 0 .348 r
.61647 .53035 .62673 .55558 .64694 .5623 .63631 .52698 Metetra
1 0 0 r
.63631 .52698 .64694 .5623 .6669 .55642 .65623 .52098 Metetra
1 .348 0 r
.65623 .52098 .6669 .55642 .6864 .53787 .67617 .51234 Metetra
1 .596 0 r
.67617 .51234 .6864 .53787 .706 .52131 .69617 .50272 Metetra
1 .748 0 r
.69617 .50272 .706 .52131 .72587 .50883 .71629 .49343 Metetra
1 .847 0 r
.71629 .49343 .72587 .50883 .74598 .49912 .73657 .48489 Metetra
1 .924 0 r
.73657 .48489 .74598 .49912 .76634 .49135 .75702 .47711 Metetra
.997 1 0 r
.75702 .47711 .76634 .49135 .78697 .48526 .77766 .46996 Metetra
.887 1 0 r
.77766 .46996 .78697 .48526 .80792 .48117 .79847 .46315 Metetra
.704 1 0 r
.79847 .46315 .80792 .48117 .82929 .47973 .8194 .4561 Metetra
.382 1 0 r
.8194 .4561 .82929 .47973 .85073 .47673 .84036 .44781 Metetra
0 1 .054 r
.84036 .44781 .85073 .47673 .87096 .4603 .8613 .43796 Metetra
0 1 .423 r
.8613 .43796 .87096 .4603 .89119 .4436 .88231 .42774 Metetra
0 1 .634 r
.88231 .42774 .89119 .4436 .912 .43167 .90352 .41822 Metetra
0 1 .743 r
.90352 .41822 .912 .43167 .93321 .42219 .92495 .40951 Metetra
0 1 .797 r
.92495 .40951 .93321 .42219 .9547 .41387 .9466 .40141 Metetra
0 .356 1 r
.36198 .56691 .37293 .57737 .3908 .57322 .37994 .56238 Metetra
0 .272 1 r
.37994 .56238 .3908 .57322 .40878 .56967 .39801 .55813 Metetra
0 .146 1 r
.39801 .55813 .40878 .56967 .42689 .56692 .41621 .5542 Metetra
.032 0 1 r
.41621 .5542 .42689 .56692 .44513 .56487 .43455 .55049 Metetra
.259 0 1 r
.43455 .55049 .44513 .56487 .46354 .5625 .45303 .54674 Metetra
.505 0 1 r
.45303 .54674 .46354 .5625 .48212 .55864 .47167 .5427 Metetra
.728 0 1 r
.47167 .5427 .48212 .55864 .50087 .55359 .49046 .53831 Metetra
.909 0 1 r
.49046 .53831 .50087 .55359 .51975 .54831 .5094 .53371 Metetra
1 0 .948 r
.5094 .53371 .51975 .54831 .53877 .54339 .52848 .52907 Metetra
1 0 .825 r
.52848 .52907 .53877 .54339 .55794 .53909 .5477 .52453 Metetra
1 0 .706 r
.5477 .52453 .55794 .53909 .57727 .53555 .56709 .52013 Metetra
1 0 .574 r
.56709 .52013 .57727 .53555 .59678 .53278 .58662 .51578 Metetra
1 0 .415 r
.58662 .51578 .59678 .53278 .61647 .53035 .60631 .51122 Metetra
1 0 .221 r
.60631 .51122 .61647 .53035 .63631 .52698 .62614 .50606 Metetra
1 0 0 r
.62614 .50606 .63631 .52698 .65623 .52098 .64609 .49996 Metetra
1 .221 0 r
.64609 .49996 .65623 .52098 .67617 .51234 .66615 .49292 Metetra
1 .415 0 r
.66615 .49292 .67617 .51234 .69617 .50272 .68631 .48527 Metetra
1 .574 0 r
.68631 .48527 .69617 .50272 .71629 .49343 .70658 .4774 Metetra
1 .706 0 r
.70658 .4774 .71629 .49343 .73657 .48489 .72699 .46956 Metetra
1 .825 0 r
.72699 .46956 .73657 .48489 .75702 .47711 .74754 .46185 Metetra
1 .948 0 r
.74754 .46185 .75702 .47711 .77766 .46996 .76823 .45423 Metetra
.909 1 0 r
.76823 .45423 .77766 .46996 .79847 .46315 .78906 .44656 Metetra
.728 1 0 r
.78906 .44656 .79847 .46315 .8194 .4561 .81 .43865 Metetra
.505 1 0 r
.81 .43865 .8194 .4561 .84036 .44781 .83105 .43037 Metetra
.259 1 0 r
.83105 .43037 .84036 .44781 .8613 .43796 .85221 .42176 Metetra
.032 1 0 r
.85221 .42176 .8613 .43796 .88231 .42774 .87349 .41311 Metetra
0 1 .146 r
.87349 .41311 .88231 .42774 .90352 .41822 .89493 .40465 Metetra
0 1 .272 r
.89493 .40465 .90352 .41822 .92495 .40951 .91656 .39649 Metetra
0 1 .356 r
.91656 .39649 .92495 .40951 .9466 .40141 .93836 .38862 Metetra
.022 0 1 r
.35091 .55628 .36198 .56691 .37994 .56238 .36894 .55145 Metetra
.109 0 1 r
.36894 .55145 .37994 .56238 .39801 .55813 .3871 .54677 Metetra
.222 0 1 r
.3871 .54677 .39801 .55813 .41621 .5542 .40539 .54225 Metetra
.362 0 1 r
.40539 .54225 .41621 .5542 .43455 .55049 .42381 .53783 Metetra
.524 0 1 r
.42381 .53783 .43455 .55049 .45303 .54674 .44237 .53345 Metetra
.695 0 1 r
.44237 .53345 .45303 .54674 .47167 .5427 .46107 .52902 Metetra
.861 0 1 r
.46107 .52902 .47167 .5427 .49046 .53831 .47993 .52447 Metetra
1 0 .986 r
.47993 .52447 .49046 .53831 .5094 .53371 .49892 .51981 Metetra
1 0 .847 r
.49892 .51981 .5094 .53371 .52848 .52907 .51807 .51507 Metetra
1 0 .719 r
.51807 .51507 .52848 .52907 .5477 .52453 .53736 .51027 Metetra
1 0 .593 r
.53736 .51027 .5477 .52453 .56709 .52013 .55681 .50538 Metetra
1 0 .461 r
.55681 .50538 .56709 .52013 .58662 .51578 .5764 .50035 Metetra
1 0 .319 r
.5764 .50035 .58662 .51578 .60631 .51122 .59614 .49506 Metetra
1 0 .164 r
.59614 .49506 .60631 .51122 .62614 .50606 .61602 .48937 Metetra
1 0 0 r
.61602 .48937 .62614 .50606 .64609 .49996 .63603 .48319 Metetra
1 .164 0 r
.63603 .48319 .64609 .49996 .66615 .49292 .65617 .4765 Metetra
1 .319 0 r
.65617 .4765 .66615 .49292 .68631 .48527 .67643 .46941 Metetra
1 .461 0 r
.67643 .46941 .68631 .48527 .70658 .4774 .69682 .46204 Metetra
1 .593 0 r
.69682 .46204 .70658 .4774 .72699 .46956 .71733 .45452 Metetra
1 .719 0 r
.71733 .45452 .72699 .46956 .74754 .46185 .73798 .44691 Metetra
1 .847 0 r
.73798 .44691 .74754 .46185 .76823 .45423 .75876 .43922 Metetra
1 .986 0 r
.75876 .43922 .76823 .45423 .78906 .44656 .77967 .43143 Metetra
.861 1 0 r
.77967 .43143 .78906 .44656 .81 .43865 .80072 .4235 Metetra
.695 1 0 r
.80072 .4235 .81 .43865 .83105 .43037 .82189 .41546 Metetra
.524 1 0 r
.82189 .41546 .83105 .43037 .85221 .42176 .8432 .40733 Metetra
.362 1 0 r
.8432 .40733 .85221 .42176 .87349 .41311 .86466 .39923 Metetra
.222 1 0 r
.86466 .39923 .87349 .41311 .89493 .40465 .88627 .39122 Metetra
.109 1 0 r
.88627 .39122 .89493 .40465 .91656 .39649 .90806 .38335 Metetra
.022 1 0 r
.90806 .38335 .91656 .39649 .93836 .38862 .93001 .37563 Metetra
.351 0 1 r
.33969 .54555 .35091 .55628 .36894 .55145 .35781 .54049 Metetra
.433 0 1 r
.35781 .54049 .36894 .55145 .3871 .54677 .37605 .53552 Metetra
.53 0 1 r
.37605 .53552 .3871 .54677 .40539 .54225 .39441 .53064 Metetra
.642 0 1 r
.39441 .53064 .40539 .54225 .42381 .53783 .41292 .52583 Metetra
.767 0 1 r
.41292 .52583 .42381 .53783 .44237 .53345 .43155 .52107 Metetra
.897 0 1 r
.43155 .52107 .44237 .53345 .46107 .52902 .45033 .5163 Metetra
1 0 .973 r
.45033 .5163 .46107 .52902 .47993 .52447 .46926 .5115 Metetra
1 0 .846 r
.46926 .5115 .47993 .52447 .49892 .51981 .48833 .50663 Metetra
1 0 .725 r
.48833 .50663 .49892 .51981 .51807 .51507 .50755 .50168 Metetra
1 0 .608 r
.50755 .50168 .51807 .51507 .53736 .51027 .52691 .49663 Metetra
1 0 .492 r
.52691 .49663 .53736 .51027 .55681 .50538 .54643 .49145 Metetra
1 0 .375 r
.54643 .49145 .55681 .50538 .5764 .50035 .56609 .48608 Metetra
1 0 .254 r
.56609 .48608 .5764 .50035 .59614 .49506 .5859 .48046 Metetra
1 0 .128 r
.5859 .48046 .59614 .49506 .61602 .48937 .60585 .47454 Metetra
1 0 0 r
.60585 .47454 .61602 .48937 .63603 .48319 .62593 .46826 Metetra
1 .128 0 r
.62593 .46826 .63603 .48319 .65617 .4765 .64616 .46164 Metetra
1 .254 0 r
.64616 .46164 .65617 .4765 .67643 .46941 .66651 .4547 Metetra
1 .375 0 r
.66651 .4547 .67643 .46941 .69682 .46204 .68699 .4475 Metetra
1 .492 0 r
.68699 .4475 .69682 .46204 .71733 .45452 .70761 .44011 Metetra
1 .608 0 r
.70761 .44011 .71733 .45452 .73798 .44691 .72836 .43257 Metetra
1 .725 0 r
.72836 .43257 .73798 .44691 .75876 .43922 .74924 .42491 Metetra
1 .846 0 r
.74924 .42491 .75876 .43922 .77967 .43143 .77026 .41716 Metetra
1 .973 0 r
.77026 .41716 .77967 .43143 .80072 .4235 .79142 .40933 Metetra
.897 1 0 r
.79142 .40933 .80072 .4235 .82189 .41546 .81272 .40145 Metetra
.767 1 0 r
.81272 .40145 .82189 .41546 .8432 .40733 .83417 .39355 Metetra
.642 1 0 r
.83417 .39355 .8432 .40733 .86466 .39923 .85577 .38568 Metetra
.53 1 0 r
.85577 .38568 .86466 .39923 .88627 .39122 .87753 .37787 Metetra
.433 1 0 r
.87753 .37787 .88627 .39122 .90806 .38335 .89945 .37013 Metetra
.351 1 0 r
.89945 .37013 .90806 .38335 .93001 .37563 .92155 .36248 Metetra
.647 0 1 r
.32834 .53472 .33969 .54555 .35781 .54049 .34653 .52948 Metetra
.721 0 1 r
.34653 .52948 .35781 .54049 .37605 .53552 .36485 .5243 Metetra
.804 0 1 r
.36485 .5243 .37605 .53552 .39441 .53064 .38329 .51918 Metetra
.897 0 1 r
.38329 .51918 .39441 .53064 .41292 .52583 .40188 .51411 Metetra
.996 0 1 r
.40188 .51411 .41292 .52583 .43155 .52107 .42059 .50907 Metetra
1 0 .901 r
.42059 .50907 .43155 .52107 .45033 .5163 .43945 .50405 Metetra
1 0 .796 r
.43945 .50405 .45033 .5163 .46926 .5115 .45845 .49902 Metetra
1 0 .693 r
.45845 .49902 .46926 .5115 .48833 .50663 .4776 .49394 Metetra
1 0 .592 r
.4776 .49394 .48833 .50663 .50755 .50168 .49689 .48879 Metetra
1 0 .493 r
.49689 .48879 .50755 .50168 .52691 .49663 .51633 .48354 Metetra
1 0 .395 r
.51633 .48354 .52691 .49663 .54643 .49145 .53593 .47815 Metetra
1 0 .298 r
.53593 .47815 .54643 .49145 .56609 .48608 .55566 .47258 Metetra
1 0 .2 r
.55566 .47258 .56609 .48608 .5859 .48046 .57555 .46677 Metetra
1 0 .1 r
.57555 .46677 .5859 .48046 .60585 .47454 .59558 .4607 Metetra
1 0 0 r
.59558 .4607 .60585 .47454 .62593 .46826 .61575 .45434 Metetra
1 .1 0 r
.61575 .45434 .62593 .46826 .64616 .46164 .63606 .44768 Metetra
1 .2 0 r
.63606 .44768 .64616 .46164 .66651 .4547 .65651 .44076 Metetra
1 .298 0 r
.65651 .44076 .66651 .4547 .68699 .4475 .67709 .43359 Metetra
1 .395 0 r
.67709 .43359 .68699 .4475 .70761 .44011 .69781 .42623 Metetra
1 .493 0 r
.69781 .42623 .70761 .44011 .72836 .43257 .71866 .41872 Metetra
1 .592 0 r
.71866 .41872 .72836 .43257 .74924 .42491 .73965 .41109 Metetra
1 .693 0 r
.73965 .41109 .74924 .42491 .77026 .41716 .76078 .40338 Metetra
1 .796 0 r
.76078 .40338 .77026 .41716 .79142 .40933 .78206 .39562 Metetra
1 .901 0 r
.78206 .39562 .79142 .40933 .81272 .40145 .80348 .38782 Metetra
.996 1 0 r
.80348 .38782 .81272 .40145 .83417 .39355 .82506 .38003 Metetra
.897 1 0 r
.82506 .38003 .83417 .39355 .85577 .38568 .84679 .37226 Metetra
.804 1 0 r
.84679 .37226 .85577 .38568 .87753 .37787 .86868 .36452 Metetra
.721 1 0 r
.86868 .36452 .87753 .37787 .89945 .37013 .89074 .35683 Metetra
.647 1 0 r
.89074 .35683 .89945 .37013 .92155 .36248 .91298 .34919 Metetra
.921 0 1 r
.31683 .5238 .32834 .53472 .34653 .52948 .3351 .51841 Metetra
.987 0 1 r
.3351 .51841 .34653 .52948 .36485 .5243 .3535 .51306 Metetra
1 0 .941 r
.3535 .51306 .36485 .5243 .38329 .51918 .37203 .50776 Metetra
1 0 .864 r
.37203 .50776 .38329 .51918 .40188 .51411 .39069 .50249 Metetra
1 0 .784 r
.39069 .50249 .40188 .51411 .42059 .50907 .40949 .49726 Metetra
1 0 .701 r
.40949 .49726 .42059 .50907 .43945 .50405 .42842 .49204 Metetra
1 0 .617 r
.42842 .49204 .43945 .50405 .45845 .49902 .4475 .48682 Metetra
1 0 .535 r
.4475 .48682 .45845 .49902 .4776 .49394 .46673 .48157 Metetra
1 0 .454 r
.46673 .48157 .4776 .49394 .49689 .48879 .4861 .47626 Metetra
1 0 .375 r
.4861 .47626 .49689 .48879 .51633 .48354 .50563 .47086 Metetra
1 0 .298 r
.50563 .47086 .51633 .48354 .53593 .47815 .5253 .46532 Metetra
1 0 .223 r
.5253 .46532 .53593 .47815 .55566 .47258 .54512 .4596 Metetra
1 0 .148 r
.54512 .4596 .55566 .47258 .57555 .46677 .56509 .45367 Metetra
1 0 .074 r
.56509 .45367 .57555 .46677 .59558 .4607 .58521 .44748 Metetra
1 0 0 r
.58521 .44748 .59558 .4607 .61575 .45434 .60547 .44103 Metetra
1 .074 0 r
.60547 .44103 .61575 .45434 .63606 .44768 .62587 .43431 Metetra
1 .148 0 r
.62587 .43431 .63606 .44768 .65651 .44076 .64641 .42734 Metetra
1 .223 0 r
.64641 .42734 .65651 .44076 .67709 .43359 .66709 .42014 Metetra
1 .298 0 r
.66709 .42014 .67709 .43359 .69781 .42623 .68791 .41275 Metetra
1 .375 0 r
.68791 .41275 .69781 .42623 .71866 .41872 .70887 .40522 Metetra
1 .454 0 r
.70887 .40522 .71866 .41872 .73965 .41109 .72997 .39758 Metetra
1 .535 0 r
.72997 .39758 .73965 .41109 .76078 .40338 .75121 .38987 Metetra
1 .617 0 r
.75121 .38987 .76078 .40338 .78206 .39562 .7726 .38212 Metetra
1 .701 0 r
.7726 .38212 .78206 .39562 .80348 .38782 .79415 .37435 Metetra
1 .784 0 r
.79415 .37435 .80348 .38782 .82506 .38003 .81585 .36658 Metetra
1 .864 0 r
.81585 .36658 .82506 .38003 .84679 .37226 .83771 .35884 Metetra
1 .941 0 r
.83771 .35884 .84679 .37226 .86868 .36452 .85973 .35111 Metetra
.987 1 0 r
.85973 .35111 .86868 .36452 .89074 .35683 .88192 .34342 Metetra
.921 1 0 r
.88192 .34342 .89074 .35683 .91298 .34919 .90429 .33575 Metetra
1 0 .819 r
.30518 .51277 .31683 .5238 .3351 .51841 .32353 .50726 Metetra
1 0 .761 r
.32353 .50726 .3351 .51841 .3535 .51306 .34201 .50177 Metetra
1 0 .699 r
.34201 .50177 .3535 .51306 .37203 .50776 .36061 .49632 Metetra
1 0 .634 r
.36061 .49632 .37203 .50776 .39069 .50249 .37935 .4909 Metetra
1 0 .568 r
.37935 .4909 .39069 .50249 .40949 .49726 .39823 .48551 Metetra
1 0 .501 r
.39823 .48551 .40949 .49726 .42842 .49204 .41725 .48014 Metetra
1 0 .436 r
.41725 .48014 .42842 .49204 .4475 .48682 .43641 .47477 Metetra
1 0 .372 r
.43641 .47477 .4475 .48682 .46673 .48157 .45572 .46939 Metetra
1 0 .311 r
.45572 .46939 .46673 .48157 .4861 .47626 .47517 .46396 Metetra
1 0 .253 r
.47517 .46396 .4861 .47626 .50563 .47086 .49478 .45845 Metetra
1 0 .198 r
.49478 .45845 .50563 .47086 .5253 .46532 .51454 .45281 Metetra
1 0 .146 r
.51454 .45281 .5253 .46532 .54512 .4596 .53445 .44699 Metetra
1 0 .096 r
.53445 .44699 .54512 .4596 .56509 .45367 .5545 .44097 Metetra
1 0 .048 r
.5545 .44097 .56509 .45367 .58521 .44748 .57471 .4347 Metetra
1 0 0 r
.57471 .4347 .58521 .44748 .60547 .44103 .59507 .42816 Metetra
1 .048 0 r
.59507 .42816 .60547 .44103 .62587 .43431 .61557 .42135 Metetra
1 .096 0 r
.61557 .42135 .62587 .43431 .64641 .42734 .63621 .41429 Metetra
1 .146 0 r
.63621 .41429 .64641 .42734 .66709 .42014 .65699 .40701 Metetra
1 .198 0 r
.65699 .40701 .66709 .42014 .68791 .41275 .67791 .39955 Metetra
1 .253 0 r
.67791 .39955 .68791 .41275 .70887 .40522 .69897 .39195 Metetra
1 .311 0 r
.69897 .39195 .70887 .40522 .72997 .39758 .72018 .38425 Metetra
1 .372 0 r
.72018 .38425 .72997 .39758 .75121 .38987 .74153 .3765 Metetra
1 .436 0 r
.74153 .3765 .75121 .38987 .7726 .38212 .76304 .36871 Metetra
1 .501 0 r
.76304 .36871 .7726 .38212 .79415 .37435 .7847 .36092 Metetra
1 .568 0 r
.7847 .36092 .79415 .37435 .81585 .36658 .80653 .35313 Metetra
1 .634 0 r
.80653 .35313 .81585 .36658 .83771 .35884 .82851 .34536 Metetra
1 .699 0 r
.82851 .34536 .83771 .35884 .85973 .35111 .85066 .33761 Metetra
1 .761 0 r
.85066 .33761 .85973 .35111 .88192 .34342 .87298 .32988 Metetra
1 .819 0 r
.87298 .32988 .88192 .34342 .90429 .33575 .89548 .32216 Metetra
1 0 .569 r
.29338 .50163 .30518 .51277 .32353 .50726 .31181 .496 Metetra
1 0 .516 r
.31181 .496 .32353 .50726 .34201 .50177 .33036 .49039 Metetra
1 0 .461 r
.33036 .49039 .34201 .50177 .36061 .49632 .34905 .48481 Metetra
1 0 .407 r
.34905 .48481 .36061 .49632 .37935 .4909 .36787 .47927 Metetra
1 0 .352 r
.36787 .47927 .37935 .4909 .39823 .48551 .38683 .47375 Metetra
1 0 .3 r
.38683 .47375 .39823 .48551 .41725 .48014 .40593 .46827 Metetra
1 0 .25 r
.40593 .46827 .41725 .48014 .43641 .47477 .42517 .4628 Metetra
1 0 .203 r
.42517 .4628 .43641 .47477 .45572 .46939 .44456 .45732 Metetra
1 0 .161 r
.44456 .45732 .45572 .46939 .47517 .46396 .4641 .45181 Metetra
1 0 .124 r
.4641 .45181 .47517 .46396 .49478 .45845 .48379 .44624 Metetra
1 0 .092 r
.48379 .44624 .49478 .45845 .51454 .45281 .50363 .44054 Metetra
1 0 .065 r
.50363 .44054 .51454 .45281 .53445 .44699 .52363 .43468 Metetra
1 0 .041 r
.52363 .43468 .53445 .44699 .5545 .44097 .54378 .4286 Metetra
1 0 .02 r
.54378 .4286 .5545 .44097 .57471 .4347 .56409 .42225 Metetra
1 0 0 r
.56409 .42225 .57471 .4347 .59507 .42816 .58454 .41562 Metetra
1 .02 0 r
.58454 .41562 .59507 .42816 .61557 .42135 .60514 .40871 Metetra
1 .041 0 r
.60514 .40871 .61557 .42135 .63621 .41429 .62588 .40153 Metetra
1 .065 0 r
.62588 .40153 .63621 .41429 .65699 .40701 .64676 .39412 Metetra
1 .092 0 r
.64676 .39412 .65699 .40701 .67791 .39955 .66779 .38653 Metetra
1 .124 0 r
.66779 .38653 .67791 .39955 .69897 .39195 .68896 .37881 Metetra
1 .161 0 r
.68896 .37881 .69897 .39195 .72018 .38425 .71027 .37101 Metetra
1 .203 0 r
.71027 .37101 .72018 .38425 .74153 .3765 .73174 .36317 Metetra
1 .25 0 r
.73174 .36317 .74153 .3765 .76304 .36871 .75336 .35531 Metetra
1 .3 0 r
.75336 .35531 .76304 .36871 .7847 .36092 .77514 .34745 Metetra
1 .352 0 r
.77514 .34745 .7847 .36092 .80653 .35313 .79709 .33961 Metetra
1 .407 0 r
.79709 .33961 .80653 .35313 .82851 .34536 .81919 .33178 Metetra
1 .461 0 r
.81919 .33178 .82851 .34536 .85066 .33761 .84147 .32398 Metetra
1 .516 0 r
.84147 .32398 .85066 .33761 .87298 .32988 .86392 .31619 Metetra
1 .569 0 r
.86392 .31619 .87298 .32988 .89548 .32216 .88655 .30841 Metetra
1 0 .323 r
.28143 .49036 .29338 .50163 .31181 .496 .29993 .48462 Metetra
1 0 .274 r
.29993 .48462 .31181 .496 .33036 .49039 .31856 .47891 Metetra
1 0 .225 r
.31856 .47891 .33036 .49039 .34905 .48481 .33733 .47322 Metetra
1 0 .178 r
.33733 .47322 .34905 .48481 .36787 .47927 .35623 .46757 Metetra
1 0 .133 r
.35623 .46757 .36787 .47927 .38683 .47375 .37527 .46195 Metetra
1 0 .092 r
.37527 .46195 .38683 .47375 .40593 .46827 .39445 .45638 Metetra
1 0 .056 r
.39445 .45638 .40593 .46827 .42517 .4628 .41377 .45083 Metetra
1 0 .025 r
.41377 .45083 .42517 .4628 .44456 .45732 .43325 .44531 Metetra
1 0 .001 r
.43325 .44531 .44456 .45732 .4641 .45181 .45287 .43978 Metetra
1 .015 0 r
.45287 .43978 .4641 .45181 .48379 .44624 .47265 .43419 Metetra
1 .024 0 r
.47265 .43419 .48379 .44624 .50363 .44054 .49258 .42851 Metetra
1 .025 0 r
.49258 .42851 .50363 .44054 .52363 .43468 .51267 .42265 Metetra
1 .021 0 r
.51267 .42265 .52363 .43468 .54378 .4286 .53292 .41656 Metetra
1 .012 0 r
.53292 .41656 .54378 .4286 .56409 .42225 .55332 .41017 Metetra
1 0 0 r
.55332 .41017 .56409 .42225 .58454 .41562 .57388 .40345 Metetra
1 0 .012 r
.57388 .40345 .58454 .41562 .60514 .40871 .59458 .3964 Metetra
1 0 .021 r
.59458 .3964 .60514 .40871 .62588 .40153 .61542 .38904 Metetra
1 0 .025 r
.61542 .38904 .62588 .40153 .64676 .39412 .63641 .38144 Metetra
1 0 .024 r
.63641 .38144 .64676 .39412 .66779 .38653 .65754 .37366 Metetra
1 0 .015 r
.65754 .37366 .66779 .38653 .68896 .37881 .67882 .36576 Metetra
1 .001 0 r
.67882 .36576 .68896 .37881 .71027 .37101 .70025 .35781 Metetra
1 .025 0 r
.70025 .35781 .71027 .37101 .73174 .36317 .72182 .34983 Metetra
1 .056 0 r
.72182 .34983 .73174 .36317 .75336 .35531 .74356 .34186 Metetra
1 .092 0 r
.74356 .34186 .75336 .35531 .77514 .34745 .76546 .3339 Metetra
1 .133 0 r
.76546 .3339 .77514 .34745 .79709 .33961 .78752 .32598 Metetra
1 .178 0 r
.78752 .32598 .79709 .33961 .81919 .33178 .80975 .31808 Metetra
1 .225 0 r
.80975 .31808 .81919 .33178 .84147 .32398 .83216 .3102 Metetra
1 .274 0 r
.83216 .3102 .84147 .32398 .86392 .31619 .85474 .30234 Metetra
1 .323 0 r
.85474 .30234 .86392 .31619 .88655 .30841 .87749 .29448 Metetra
1 0 .078 r
.26932 .47896 .28143 .49036 .29993 .48462 .2879 .47312 Metetra
1 0 .031 r
.2879 .47312 .29993 .48462 .31856 .47891 .30661 .4673 Metetra
1 .014 0 r
.30661 .4673 .31856 .47891 .33733 .47322 .32546 .46151 Metetra
1 .056 0 r
.32546 .46151 .33733 .47322 .35623 .46757 .34444 .45577 Metetra
1 .093 0 r
.34444 .45577 .35623 .46757 .37527 .46195 .36356 .45007 Metetra
1 .126 0 r
.36356 .45007 .37527 .46195 .39445 .45638 .38282 .44443 Metetra
1 .151 0 r
.38282 .44443 .39445 .45638 .41377 .45083 .40222 .43885 Metetra
1 .168 0 r
.40222 .43885 .41377 .45083 .43325 .44531 .42178 .43332 Metetra
1 .175 0 r
.42178 .43332 .43325 .44531 .45287 .43978 .44149 .42782 Metetra
1 .171 0 r
.44149 .42782 .45287 .43978 .47265 .43419 .46135 .42231 Metetra
1 .155 0 r
.46135 .42231 .47265 .43419 .49258 .42851 .48137 .41673 Metetra
1 .129 0 r
.48137 .41673 .49258 .42851 .51267 .42265 .50156 .41098 Metetra
1 .092 0 r
.50156 .41098 .51267 .42265 .53292 .41656 .52191 .40496 Metetra
1 .048 0 r
.52191 .40496 .53292 .41656 .55332 .41017 .54241 .39857 Metetra
1 0 0 r
.54241 .39857 .55332 .41017 .57388 .40345 .56307 .39176 Metetra
1 0 .048 r
.56307 .39176 .57388 .40345 .59458 .3964 .58388 .38452 Metetra
1 0 .092 r
.58388 .38452 .59458 .3964 .61542 .38904 .60483 .3769 Metetra
1 0 .129 r
.60483 .3769 .61542 .38904 .63641 .38144 .62593 .36901 Metetra
1 0 .155 r
.62593 .36901 .63641 .38144 .65754 .37366 .64717 .36094 Metetra
1 0 .171 r
.64717 .36094 .65754 .37366 .67882 .36576 .66855 .35278 Metetra
1 0 .175 r
.66855 .35278 .67882 .36576 .70025 .35781 .69009 .3446 Metetra
1 0 .168 r
.69009 .3446 .70025 .35781 .72182 .34983 .71178 .33644 Metetra
1 0 .151 r
.71178 .33644 .72182 .34983 .74356 .34186 .73363 .32832 Metetra
1 0 .126 r
.73363 .32832 .74356 .34186 .76546 .3339 .75564 .32024 Metetra
1 0 .093 r
.75564 .32024 .76546 .3339 .78752 .32598 .77783 .31221 Metetra
1 0 .056 r
.77783 .31221 .78752 .32598 .80975 .31808 .80018 .30422 Metetra
1 0 .014 r
.80018 .30422 .80975 .31808 .83216 .3102 .82271 .29625 Metetra
1 .031 0 r
.82271 .29625 .83216 .3102 .85474 .30234 .84542 .2883 Metetra
1 .078 0 r
.84542 .2883 .85474 .30234 .87749 .29448 .86831 .28036 Metetra
1 .169 0 r
.25705 .46741 .26932 .47896 .2879 .47312 .27571 .46148 Metetra
1 .215 0 r
.27571 .46148 .2879 .47312 .30661 .4673 .2945 .45556 Metetra
1 .259 0 r
.2945 .45556 .30661 .4673 .32546 .46151 .31342 .44968 Metetra
1 .298 0 r
.31342 .44968 .32546 .46151 .34444 .45577 .33249 .44384 Metetra
1 .332 0 r
.33249 .44384 .34444 .45577 .36356 .45007 .35169 .43807 Metetra
1 .359 0 r
.35169 .43807 .36356 .45007 .38282 .44443 .37103 .43239 Metetra
1 .376 0 r
.37103 .43239 .38282 .44443 .40222 .43885 .39052 .42679 Metetra
1 .382 0 r
.39052 .42679 .40222 .43885 .42178 .43332 .41015 .42131 Metetra
1 .375 0 r
.41015 .42131 .42178 .43332 .44149 .42782 .42994 .41593 Metetra
1 .352 0 r
.42994 .41593 .44149 .42782 .46135 .42231 .44989 .41061 Metetra
1 .312 0 r
.44989 .41061 .46135 .42231 .48137 .41673 .47 .4053 Metetra
1 .254 0 r
.47 .4053 .48137 .41673 .50156 .41098 .49028 .39984 Metetra
1 .18 0 r
.49028 .39984 .50156 .41098 .52191 .40496 .51073 .39408 Metetra
1 .094 0 r
.51073 .39408 .52191 .40496 .54241 .39857 .53135 .3878 Metetra
1 0 0 r
.53135 .3878 .54241 .39857 .56307 .39176 .55212 .3809 Metetra
1 0 .094 r
.55212 .3809 .56307 .39176 .58388 .38452 .57304 .37336 Metetra
1 0 .18 r
.57304 .37336 .58388 .38452 .60483 .3769 .59411 .36531 Metetra
1 0 .254 r
.59411 .36531 .60483 .3769 .62593 .36901 .61531 .35693 Metetra
1 0 .312 r
.61531 .35693 .62593 .36901 .64717 .36094 .63666 .3484 Metetra
1 0 .352 r
.63666 .3484 .64717 .36094 .66855 .35278 .65815 .33985 Metetra
1 0 .375 r
.65815 .33985 .66855 .35278 .69009 .3446 .67979 .33136 Metetra
1 0 .382 r
.67979 .33136 .69009 .3446 .71178 .33644 .70159 .32296 Metetra
1 0 .376 r
.70159 .32296 .71178 .33644 .73363 .32832 .72356 .31466 Metetra
1 0 .359 r
.72356 .31466 .73363 .32832 .75564 .32024 .74569 .30643 Metetra
1 0 .332 r
.74569 .30643 .75564 .32024 .77783 .31221 .768 .29828 Metetra
1 0 .298 r
.768 .29828 .77783 .31221 .80018 .30422 .79048 .29019 Metetra
1 0 .259 r
.79048 .29019 .80018 .30422 .82271 .29625 .81313 .28212 Metetra
1 0 .215 r
.81313 .28212 .82271 .29625 .84542 .2883 .83597 .27408 Metetra
1 0 .169 r
.83597 .27408 .84542 .2883 .86831 .28036 .85899 .26604 Metetra
1 .419 0 r
.24462 .45572 .25705 .46741 .27571 .46148 .26336 .44969 Metetra
1 .467 0 r
.26336 .44969 .27571 .46148 .2945 .45556 .28223 .44367 Metetra
1 .512 0 r
.28223 .44367 .2945 .45556 .31342 .44968 .30123 .43769 Metetra
1 .552 0 r
.30123 .43769 .31342 .44968 .33249 .44384 .32038 .43177 Metetra
1 .586 0 r
.32038 .43177 .33249 .44384 .35169 .43807 .33966 .42593 Metetra
1 .611 0 r
.33966 .42593 .35169 .43807 .37103 .43239 .35908 .42021 Metetra
1 .625 0 r
.35908 .42021 .37103 .43239 .39052 .42679 .37865 .41463 Metetra
1 .625 0 r
.37865 .41463 .39052 .42679 .41015 .42131 .39836 .40925 Metetra
1 .608 0 r
.39836 .40925 .41015 .42131 .42994 .41593 .41823 .40409 Metetra
1 .569 0 r
.41823 .40409 .42994 .41593 .44989 .41061 .43825 .39916 Metetra
1 .506 0 r
.43825 .39916 .44989 .41061 .47 .4053 .45845 .39441 Metetra
1 .415 0 r
.45845 .39441 .47 .4053 .49028 .39984 .47882 .38967 Metetra
1 .297 0 r
.47882 .38967 .49028 .39984 .51073 .39408 .49938 .3846 Metetra
1 .155 0 r
.49938 .3846 .51073 .39408 .53135 .3878 .52011 .37875 Metetra
1 0 0 r
.52011 .37875 .53135 .3878 .55212 .3809 .54101 .37176 Metetra
1 0 .155 r
.54101 .37176 .55212 .3809 .57304 .37336 .56206 .36361 Metetra
1 0 .297 r
.56206 .36361 .57304 .37336 .59411 .36531 .58324 .35466 Metetra
1 0 .415 r
.58324 .35466 .59411 .36531 .61531 .35693 .60456 .34538 Metetra
1 0 .506 r
.60456 .34538 .61531 .35693 .63666 .3484 .626 .33608 Metetra
1 0 .569 r
.626 .33608 .63666 .3484 .65815 .33985 .6476 .32695 Metetra
1 0 .608 r
.6476 .32695 .65815 .33985 .67979 .33136 .66935 .31804 Metetra
1 0 .625 r
.66935 .31804 .67979 .33136 .70159 .32296 .69127 .30934 Metetra
1 0 .625 r
.69127 .30934 .70159 .32296 .72356 .31466 .71335 .30082 Metetra
1 0 .611 r
.71335 .30082 .72356 .31466 .74569 .30643 .7356 .29244 Metetra
1 0 .586 r
.7356 .29244 .74569 .30643 .768 .29828 .75803 .28416 Metetra
1 0 .552 r
.75803 .28416 .768 .29828 .79048 .29019 .78063 .27596 Metetra
1 0 .512 r
.78063 .27596 .79048 .29019 .81313 .28212 .80342 .26779 Metetra
1 0 .467 r
.80342 .26779 .81313 .28212 .83597 .27408 .82638 .25965 Metetra
1 0 .419 r
.82638 .25965 .83597 .27408 .85899 .26604 .84954 .25152 Metetra
1 .673 0 r
.23203 .44388 .24462 .45572 .26336 .44969 .25084 .43774 Metetra
1 .726 0 r
.25084 .43774 .26336 .44969 .28223 .44367 .26979 .43162 Metetra
1 .775 0 r
.26979 .43162 .28223 .44367 .30123 .43769 .28888 .42554 Metetra
1 .82 0 r
.28888 .42554 .30123 .43769 .32038 .43177 .3081 .41952 Metetra
1 .858 0 r
.3081 .41952 .32038 .43177 .33966 .42593 .32747 .41361 Metetra
1 .887 0 r
.32747 .41361 .33966 .42593 .35908 .42021 .34697 .40785 Metetra
1 .905 0 r
.34697 .40785 .35908 .42021 .37865 .41463 .36661 .40229 Metetra
1 .906 0 r
.36661 .40229 .37865 .41463 .39836 .40925 .3864 .39704 Metetra
1 .887 0 r
.3864 .39704 .39836 .40925 .41823 .40409 .40634 .39221 Metetra
1 .841 0 r
.40634 .39221 .41823 .40409 .43825 .39916 .42644 .38793 Metetra
1 .761 0 r
.42644 .38793 .43825 .39916 .45845 .39441 .4467 .38431 Metetra
1 .638 0 r
.4467 .38431 .45845 .39441 .47882 .38967 .46715 .38129 Metetra
1 .467 0 r
.46715 .38129 .47882 .38967 .49938 .3846 .4878 .37832 Metetra
1 .249 0 r
.4878 .37832 .49938 .3846 .52011 .37875 .50867 .37406 Metetra
1 0 0 r
.50867 .37406 .52011 .37875 .54101 .37176 .52973 .36697 Metetra
1 0 .249 r
.52973 .36697 .54101 .37176 .56206 .36361 .55093 .35706 Metetra
1 0 .467 r
.55093 .35706 .56206 .36361 .58324 .35466 .57224 .34583 Metetra
1 0 .638 r
.57224 .34583 .58324 .35466 .60456 .34538 .59366 .33462 Metetra
1 0 .761 r
.59366 .33462 .60456 .34538 .626 .33608 .61521 .32398 Metetra
1 0 .841 r
.61521 .32398 .626 .33608 .6476 .32695 .63691 .314 Metetra
1 0 .887 r
.63691 .314 .6476 .32695 .66935 .31804 .65876 .30455 Metetra
1 0 .906 r
.65876 .30455 .66935 .31804 .69127 .30934 .68079 .29552 Metetra
1 0 .905 r
.68079 .29552 .69127 .30934 .71335 .30082 .70298 .28677 Metetra
1 0 .887 r
.70298 .28677 .71335 .30082 .7356 .29244 .72536 .27823 Metetra
1 0 .858 r
.72536 .27823 .7356 .29244 .75803 .28416 .74791 .26983 Metetra
1 0 .82 r
.74791 .26983 .75803 .28416 .78063 .27596 .77064 .26151 Metetra
1 0 .775 r
.77064 .26151 .78063 .27596 .80342 .26779 .79356 .25325 Metetra
1 0 .726 r
.79356 .25325 .80342 .26779 .82638 .25965 .81666 .24501 Metetra
1 0 .673 r
.81666 .24501 .82638 .25965 .84954 .25152 .83994 .23678 Metetra
1 .931 0 r
.21926 .43187 .23203 .44388 .25084 .43774 .23816 .42562 Metetra
1 .991 0 r
.23816 .42562 .25084 .43774 .26979 .43162 .25719 .41939 Metetra
.952 1 0 r
.25719 .41939 .26979 .43162 .28888 .42554 .27636 .4132 Metetra
.899 1 0 r
.27636 .4132 .28888 .42554 .3081 .41952 .29567 .40708 Metetra
.851 1 0 r
.29567 .40708 .3081 .41952 .32747 .41361 .31511 .40107 Metetra
.811 1 0 r
.31511 .40107 .32747 .41361 .34697 .40785 .3347 .39524 Metetra
.783 1 0 r
.3347 .39524 .34697 .40785 .36661 .40229 .35442 .38968 Metetra
.77 1 0 r
.35442 .38968 .36661 .40229 .3864 .39704 .37429 .38455 Metetra
.778 1 0 r
.37429 .38455 .3864 .39704 .40634 .39221 .39429 .38009 Metetra
.815 1 0 r
.39429 .38009 .40634 .39221 .42644 .38793 .41444 .3767 Metetra
.894 1 0 r
.41444 .3767 .42644 .38793 .4467 .38431 .43474 .37503 Metetra
1 .968 0 r
.43474 .37503 .4467 .38431 .46715 .38129 .45521 .37603 Metetra
1 .748 0 r
.45521 .37603 .46715 .38129 .4878 .37832 .47588 .38043 Metetra
1 .421 0 r
.47588 .38043 .4878 .37832 .50867 .37406 .49686 .38494 Metetra
1 0 0 r
.49686 .38494 .50867 .37406 .52973 .36697 .51819 .3778 Metetra
1 0 .421 r
.51819 .3778 .52973 .36697 .55093 .35706 .53963 .35894 Metetra
1 0 .748 r
.53963 .35894 .55093 .35706 .57224 .34583 .56108 .34013 Metetra
1 0 .968 r
.56108 .34013 .57224 .34583 .59366 .33462 .5826 .32467 Metetra
.894 0 1 r
.5826 .32467 .59366 .33462 .61521 .32398 .60425 .31186 Metetra
.815 0 1 r
.60425 .31186 .61521 .32398 .63691 .314 .62605 .30077 Metetra
.778 0 1 r
.62605 .30077 .63691 .314 .65876 .30455 .64801 .29074 Metetra
.77 0 1 r
.64801 .29074 .65876 .30455 .68079 .29552 .67015 .28138 Metetra
.783 0 1 r
.67015 .28138 .68079 .29552 .70298 .28677 .69247 .27244 Metetra
.811 0 1 r
.69247 .27244 .70298 .28677 .72536 .27823 .71496 .26376 Metetra
.851 0 1 r
.71496 .26376 .72536 .27823 .74791 .26983 .73764 .25525 Metetra
.899 0 1 r
.73764 .25525 .74791 .26983 .77064 .26151 .7605 .24684 Metetra
.952 0 1 r
.7605 .24684 .77064 .26151 .79356 .25325 .78355 .23848 Metetra
1 0 .991 r
.78355 .23848 .79356 .25325 .81666 .24501 .80678 .23015 Metetra
1 0 .931 r
.80678 .23015 .81666 .24501 .83994 .23678 .83021 .22182 Metetra
.807 1 0 r
.20633 .4197 .21926 .43187 .23816 .42562 .22531 .41334 Metetra
.739 1 0 r
.22531 .41334 .23816 .42562 .25719 .41939 .24442 .40699 Metetra
.671 1 0 r
.24442 .40699 .25719 .41939 .27636 .4132 .26367 .40068 Metetra
.606 1 0 r
.26367 .40068 .27636 .4132 .29567 .40708 .28307 .39443 Metetra
.544 1 0 r
.28307 .39443 .29567 .40708 .31511 .40107 .3026 .3883 Metetra
.487 1 0 r
.3026 .3883 .31511 .40107 .3347 .39524 .32227 .38234 Metetra
.438 1 0 r
.32227 .38234 .3347 .39524 .35442 .38968 .34207 .3767 Metetra
.401 1 0 r
.34207 .3767 .35442 .38968 .37429 .38455 .36202 .37156 Metetra
.381 1 0 r
.36202 .37156 .37429 .38455 .39429 .38009 .38209 .36731 Metetra
.386 1 0 r
.38209 .36731 .39429 .38009 .41444 .3767 .40229 .36468 Metetra
.428 1 0 r
.40229 .36468 .41444 .3767 .43474 .37503 .4226 .36522 Metetra
.529 1 0 r
.4226 .36522 .43474 .37503 .45521 .37603 .44298 .37281 Metetra
.728 1 0 r
.44298 .37281 .45521 .37603 .47588 .38043 .46335 .39981 Metetra
1 .875 0 r
.46335 .39981 .47588 .38043 .49686 .38494 .48323 .51441 Metetra
1 0 0 r
.48323 .51441 .49686 .38494 .51819 .3778 .50562 .50742 Metetra
1 0 .875 r
.50562 .50742 .51819 .3778 .53963 .35894 .52807 .37817 Metetra
.728 0 1 r
.52807 .37817 .53963 .35894 .56108 .34013 .54972 .33646 Metetra
.529 0 1 r
.54972 .33646 .56108 .34013 .5826 .32467 .57135 .31417 Metetra
.428 0 1 r
.57135 .31417 .5826 .32467 .60425 .31186 .5931 .29892 Metetra
.386 0 1 r
.5931 .29892 .60425 .31186 .62605 .30077 .61501 .28686 Metetra
.381 0 1 r
.61501 .28686 .62605 .30077 .64801 .29074 .63709 .27641 Metetra
.401 0 1 r
.63709 .27641 .64801 .29074 .67015 .28138 .65935 .26684 Metetra
.438 0 1 r
.65935 .26684 .67015 .28138 .69247 .27244 .68179 .25778 Metetra
.487 0 1 r
.68179 .25778 .69247 .27244 .71496 .26376 .70441 .24901 Metetra
.544 0 1 r
.70441 .24901 .71496 .26376 .73764 .25525 .72722 .24041 Metetra
.606 0 1 r
.72722 .24041 .73764 .25525 .7605 .24684 .75021 .23192 Metetra
.671 0 1 r
.75021 .23192 .7605 .24684 .78355 .23848 .77339 .22348 Metetra
.739 0 1 r
.77339 .22348 .78355 .23848 .80678 .23015 .79676 .21506 Metetra
.807 0 1 r
.79676 .21506 .80678 .23015 .83021 .22182 .82032 .20663 Metetra
.546 1 0 r
.19322 .40736 .20633 .4197 .22531 .41334 .21228 .40088 Metetra
.466 1 0 r
.21228 .40088 .22531 .41334 .24442 .40699 .23148 .39441 Metetra
.386 1 0 r
.23148 .39441 .24442 .40699 .26367 .40068 .25082 .38796 Metetra
.305 1 0 r
.25082 .38796 .26367 .40068 .28307 .39443 .2703 .38157 Metetra
.225 1 0 r
.2703 .38157 .28307 .39443 .3026 .3883 .28991 .37527 Metetra
.146 1 0 r
.28991 .37527 .3026 .3883 .32227 .38234 .30967 .36914 Metetra
.07 1 0 r
.30967 .36914 .32227 .38234 .34207 .3767 .32957 .36329 Metetra
0 1 .002 r
.32957 .36329 .34207 .3767 .36202 .37156 .3496 .35795 Metetra
0 1 .067 r
.3496 .35795 .36202 .37156 .38209 .36731 .36976 .3535 Metetra
0 1 .121 r
.36976 .3535 .38209 .36731 .40229 .36468 .39003 .3508 Metetra
0 1 .156 r
.39003 .3508 .40229 .36468 .4226 .36522 .41039 .3518 Metetra
0 1 .163 r
.41039 .3518 .4226 .36522 .44298 .37281 .43074 .36177 Metetra
0 1 .121 r
.43074 .36177 .44298 .37281 .46335 .39981 .4509 .39657 Metetra
.023 1 0 r
.4509 .39657 .46335 .39981 .48323 .51441 .47091 .48599 Metetra
.5 0 1 r
.47091 .48599 .48323 .51441 .50562 .50742 .49331 .47887 Metetra
.023 0 1 r
.49331 .47887 .50562 .50742 .52807 .37817 .51616 .37467 Metetra
0 .121 1 r
.51616 .37467 .52807 .37817 .54972 .33646 .53808 .32491 Metetra
0 .163 1 r
.53808 .32491 .54972 .33646 .57135 .31417 .55987 .3 Metetra
0 .156 1 r
.55987 .3 .57135 .31417 .5931 .29892 .58176 .28408 Metetra
0 .121 1 r
.58176 .28408 .5931 .29892 .61501 .28686 .60379 .27187 Metetra
0 .067 1 r
.60379 .27187 .61501 .28686 .63709 .27641 .626 .2614 Metetra
0 .002 1 r
.626 .2614 .63709 .27641 .65935 .26684 .64839 .25184 Metetra
.07 0 1 r
.64839 .25184 .65935 .26684 .68179 .25778 .67095 .24276 Metetra
.146 0 1 r
.67095 .24276 .68179 .25778 .70441 .24901 .6937 .23396 Metetra
.225 0 1 r
.6937 .23396 .70441 .24901 .72722 .24041 .71664 .22532 Metetra
.305 0 1 r
.71664 .22532 .72722 .24041 .75021 .23192 .73977 .21676 Metetra
.386 0 1 r
.73977 .21676 .75021 .23192 .77339 .22348 .76308 .20824 Metetra
.466 0 1 r
.76308 .20824 .77339 .22348 .79676 .21506 .78659 .19973 Metetra
.546 0 1 r
.78659 .19973 .79676 .21506 .82032 .20663 .81029 .19121 Metetra
.286 1 0 r
.17994 .39486 .19322 .40736 .21228 .40088 .19908 .38826 Metetra
.195 1 0 r
.19908 .38826 .21228 .40088 .23148 .39441 .21836 .38165 Metetra
.101 1 0 r
.21836 .38165 .23148 .39441 .25082 .38796 .23779 .37506 Metetra
.004 1 0 r
.23779 .37506 .25082 .38796 .2703 .38157 .25735 .3685 Metetra
0 1 .096 r
.25735 .3685 .2703 .38157 .28991 .37527 .27706 .36201 Metetra
0 1 .2 r
.27706 .36201 .28991 .37527 .30967 .36914 .29691 .35565 Metetra
0 1 .308 r
.29691 .35565 .30967 .36914 .32957 .36329 .31691 .3495 Metetra
0 1 .42 r
.31691 .3495 .32957 .36329 .3496 .35795 .33704 .34375 Metetra
0 1 .537 r
.33704 .34375 .3496 .35795 .36976 .3535 .35731 .33868 Metetra
0 1 .663 r
.35731 .33868 .36976 .3535 .39003 .3508 .37769 .33492 Metetra
0 1 .799 r
.37769 .33492 .39003 .3508 .41039 .3518 .39817 .33386 Metetra
0 1 .951 r
.39817 .33386 .41039 .3518 .43074 .36177 .41868 .33912 Metetra
0 .871 1 r
.41868 .33912 .43074 .36177 .4509 .39657 .439 .36337 Metetra
0 .646 1 r
.439 .36337 .4509 .39657 .47091 .48599 .45732 .51599 Metetra
0 1 1 r
.45732 .51599 .47091 .48599 .49331 .47887 .48014 .50884 Metetra
0 1 .646 r
.48014 .50884 .49331 .47887 .51616 .37467 .50419 .34105 Metetra
0 1 .871 r
.50419 .34105 .51616 .37467 .53808 .32491 .52626 .30165 Metetra
0 .951 1 r
.52626 .30165 .53808 .32491 .55987 .3 .5482 .28126 Metetra
0 .799 1 r
.5482 .28126 .55987 .3 .58176 .28408 .57022 .2672 Metetra
0 .663 1 r
.57022 .2672 .58176 .28408 .60379 .27187 .59239 .25583 Metetra
0 .537 1 r
.59239 .25583 .60379 .27187 .626 .2614 .61474 .24578 Metetra
0 .42 1 r
.61474 .24578 .626 .2614 .64839 .25184 .63725 .23641 Metetra
0 .308 1 r
.63725 .23641 .64839 .25184 .67095 .24276 .65995 .22742 Metetra
0 .2 1 r
.65995 .22742 .67095 .24276 .6937 .23396 .68283 .21864 Metetra
0 .096 1 r
.68283 .21864 .6937 .23396 .71664 .22532 .7059 .20997 Metetra
.004 0 1 r
.7059 .20997 .71664 .22532 .73977 .21676 .72916 .20136 Metetra
.101 0 1 r
.72916 .20136 .73977 .21676 .76308 .20824 .75262 .19277 Metetra
.195 0 1 r
.75262 .19277 .76308 .20824 .78659 .19973 .77626 .18417 Metetra
.286 0 1 r
.77626 .18417 .78659 .19973 .81029 .19121 .80011 .17555 Metetra
.033 1 0 r
.16647 .38219 .17994 .39486 .19908 .38826 .1857 .37546 Metetra
0 1 .069 r
.1857 .37546 .19908 .38826 .21836 .38165 .20506 .36872 Metetra
0 1 .177 r
.20506 .36872 .21836 .38165 .23779 .37506 .22458 .36198 Metetra
0 1 .29 r
.22458 .36198 .23779 .37506 .25735 .3685 .24423 .35525 Metetra
0 1 .41 r
.24423 .35525 .25735 .3685 .27706 .36201 .26403 .34855 Metetra
0 1 .538 r
.26403 .34855 .27706 .36201 .29691 .35565 .28398 .34194 Metetra
0 1 .676 r
.28398 .34194 .29691 .35565 .31691 .3495 .30408 .33545 Metetra
0 1 .826 r
.30408 .33545 .31691 .3495 .33704 .34375 .32432 .3292 Metetra
0 1 .993 r
.32432 .3292 .33704 .34375 .35731 .33868 .3447 .32334 Metetra
0 .817 1 r
.3447 .32334 .35731 .33868 .37769 .33492 .36523 .31816 Metetra
0 .591 1 r
.36523 .31816 .37769 .33492 .39817 .33386 .38588 .31419 Metetra
0 .313 1 r
.38588 .31419 .39817 .33386 .41868 .33912 .40666 .31239 Metetra
.052 0 1 r
.40666 .31239 .41868 .33912 .439 .36337 .42756 .31437 Metetra
.542 0 1 r
.42756 .31437 .439 .36337 .45732 .51599 .44869 .31937 Metetra
.5 1 0 r
.44869 .31937 .45732 .51599 .48014 .50884 .47037 .31178 Metetra
.542 1 0 r
.47037 .31178 .48014 .50884 .50419 .34105 .49236 .29154 Metetra
.052 1 0 r
.49236 .29154 .50419 .34105 .52626 .30165 .51434 .27427 Metetra
0 1 .313 r
.51434 .27427 .52626 .30165 .5482 .28126 .53637 .26075 Metetra
0 1 .591 r
.53637 .26075 .5482 .28126 .57022 .2672 .55853 .2494 Metetra
0 1 .817 r
.55853 .2494 .57022 .2672 .59239 .25583 .58083 .23925 Metetra
0 .993 1 r
.58083 .23925 .59239 .25583 .61474 .24578 .60331 .22977 Metetra
0 .826 1 r
.60331 .22977 .61474 .24578 .63725 .23641 .62595 .22068 Metetra
0 .676 1 r
.62595 .22068 .63725 .23641 .65995 .22742 .64878 .21182 Metetra
0 .538 1 r
.64878 .21182 .65995 .22742 .68283 .21864 .6718 .20307 Metetra
0 .41 1 r
.6718 .20307 .68283 .21864 .7059 .20997 .69501 .19439 Metetra
0 .29 1 r
.69501 .19439 .7059 .20997 .72916 .20136 .7184 .18573 Metetra
0 .177 1 r
.7184 .18573 .72916 .20136 .75262 .19277 .74199 .17707 Metetra
0 .069 1 r
.74199 .17707 .75262 .19277 .77626 .18417 .76578 .16838 Metetra
.033 0 1 r
.76578 .16838 .77626 .18417 .80011 .17555 .78976 .15966 Metetra
0 1 .21 r
.15282 .36935 .16647 .38219 .1857 .37546 .17213 .3625 Metetra
0 1 .324 r
.17213 .3625 .1857 .37546 .20506 .36872 .19158 .35563 Metetra
0 1 .443 r
.19158 .35563 .20506 .36872 .22458 .36198 .21118 .34873 Metetra
0 1 .571 r
.21118 .34873 .22458 .36198 .24423 .35525 .23093 .34183 Metetra
0 1 .708 r
.23093 .34183 .24423 .35525 .26403 .34855 .25082 .33494 Metetra
0 1 .856 r
.25082 .33494 .26403 .34855 .28398 .34194 .27087 .32807 Metetra
0 .983 1 r
.27087 .32807 .28398 .34194 .30408 .33545 .29107 .32127 Metetra
0 .803 1 r
.29107 .32127 .30408 .33545 .32432 .3292 .31142 .31456 Metetra
0 .601 1 r
.31142 .31456 .32432 .3292 .3447 .32334 .33192 .30802 Metetra
0 .367 1 r
.33192 .30802 .3447 .32334 .36523 .31816 .35258 .30172 Metetra
0 .088 1 r
.35258 .30172 .36523 .31816 .38588 .31419 .37339 .29576 Metetra
.253 0 1 r
.37339 .29576 .38588 .31419 .40666 .31239 .39438 .29018 Metetra
.689 0 1 r
.39438 .29018 .40666 .31239 .42756 .31437 .41554 .28478 Metetra
1 0 .73 r
.41554 .28478 .42756 .31437 .44869 .31937 .43693 .27877 Metetra
1 0 0 r
.43693 .27877 .44869 .31937 .47037 .31178 .45854 .27103 Metetra
1 .73 0 r
.45854 .27103 .47037 .31178 .49236 .29154 .48035 .26154 Metetra
.689 1 0 r
.48035 .26154 .49236 .29154 .51434 .27427 .50231 .25143 Metetra
.253 1 0 r
.50231 .25143 .51434 .27427 .53637 .26075 .52442 .24149 Metetra
0 1 .088 r
.52442 .24149 .53637 .26075 .55853 .2494 .54669 .23191 Metetra
0 1 .367 r
.54669 .23191 .55853 .2494 .58083 .23925 .56912 .22266 Metetra
0 1 .601 r
.56912 .22266 .58083 .23925 .60331 .22977 .59172 .21365 Metetra
0 1 .803 r
.59172 .21365 .60331 .22977 .62595 .22068 .61449 .20479 Metetra
0 1 .983 r
.61449 .20479 .62595 .22068 .64878 .21182 .63746 .19602 Metetra
0 .856 1 r
.63746 .19602 .64878 .21182 .6718 .20307 .6606 .1873 Metetra
0 .708 1 r
.6606 .1873 .6718 .20307 .69501 .19439 .68394 .17859 Metetra
0 .571 1 r
.68394 .17859 .69501 .19439 .7184 .18573 .70748 .16988 Metetra
0 .443 1 r
.70748 .16988 .7184 .18573 .74199 .17707 .73121 .16114 Metetra
0 .324 1 r
.73121 .16114 .74199 .17707 .76578 .16838 .75513 .15236 Metetra
0 .21 1 r
.75513 .15236 .76578 .16838 .78976 .15966 .77926 .14354 Metetra
0 1 .442 r
.13897 .35635 .15282 .36935 .17213 .3625 .15836 .34937 Metetra
0 1 .564 r
.15836 .34937 .17213 .3625 .19158 .35563 .17791 .34237 Metetra
0 1 .693 r
.17791 .34237 .19158 .35563 .21118 .34873 .19759 .33533 Metetra
0 1 .832 r
.19759 .33533 .21118 .34873 .23093 .34183 .21743 .32827 Metetra
0 1 .982 r
.21743 .32827 .23093 .34183 .25082 .33494 .23742 .32119 Metetra
0 .856 1 r
.23742 .32119 .25082 .33494 .27087 .32807 .25757 .3141 Metetra
0 .678 1 r
.25757 .3141 .27087 .32807 .29107 .32127 .27787 .30702 Metetra
0 .481 1 r
.27787 .30702 .29107 .32127 .31142 .31456 .29832 .29996 Metetra
0 .259 1 r
.29832 .29996 .31142 .31456 .33192 .30802 .31894 .29293 Metetra
0 .007 1 r
.31894 .29293 .33192 .30802 .35258 .30172 .33972 .28595 Metetra
.285 0 1 r
.33972 .28595 .35258 .30172 .37339 .29576 .36066 .27901 Metetra
.627 0 1 r
.36066 .27901 .37339 .29576 .39438 .29018 .38178 .27205 Metetra
1 0 .972 r
.38178 .27205 .39438 .29018 .41554 .28478 .40307 .26497 Metetra
1 0 .508 r
.40307 .26497 .41554 .28478 .43693 .27877 .42456 .25757 Metetra
1 0 0 r
.42456 .25757 .43693 .27877 .45854 .27103 .44624 .2497 Metetra
1 .508 0 r
.44624 .2497 .45854 .27103 .48035 .26154 .46809 .24136 Metetra
1 .972 0 r
.46809 .24136 .48035 .26154 .50231 .25143 .49012 .2327 Metetra
.627 1 0 r
.49012 .2327 .50231 .25143 .52442 .24149 .51232 .2239 Metetra
.285 1 0 r
.51232 .2239 .52442 .24149 .54669 .23191 .5347 .21508 Metetra
0 1 .007 r
.5347 .21508 .54669 .23191 .56912 .22266 .55724 .20629 Metetra
0 1 .259 r
.55724 .20629 .56912 .22266 .59172 .21365 .57996 .19753 Metetra
0 1 .481 r
.57996 .19753 .59172 .21365 .61449 .20479 .60287 .1888 Metetra
0 1 .678 r
.60287 .1888 .61449 .20479 .63746 .19602 .62596 .18008 Metetra
0 1 .856 r
.62596 .18008 .63746 .19602 .6606 .1873 .64924 .17135 Metetra
0 .982 1 r
.64924 .17135 .6606 .1873 .68394 .17859 .67272 .1626 Metetra
0 .832 1 r
.67272 .1626 .68394 .17859 .70748 .16988 .69639 .15381 Metetra
0 .693 1 r
.69639 .15381 .70748 .16988 .73121 .16114 .72026 .14498 Metetra
0 .564 1 r
.72026 .14498 .73121 .16114 .75513 .15236 .74433 .1361 Metetra
0 .442 1 r
.74433 .1361 .75513 .15236 .77926 .14354 .7686 .12717 Metetra
0 1 .658 r
.12493 .34317 .13897 .35635 .15836 .34937 .14441 .33608 Metetra
0 1 .787 r
.14441 .33608 .15836 .34937 .17791 .34237 .16404 .32894 Metetra
0 1 .924 r
.16404 .32894 .17791 .34237 .19759 .33533 .18381 .32177 Metetra
0 .929 1 r
.18381 .32177 .19759 .33533 .21743 .32827 .20374 .31456 Metetra
0 .771 1 r
.20374 .31456 .21743 .32827 .23742 .32119 .22383 .30731 Metetra
0 .6 1 r
.22383 .30731 .23742 .32119 .25757 .3141 .24407 .30003 Metetra
0 .414 1 r
.24407 .30003 .25757 .3141 .27787 .30702 .26447 .29273 Metetra
0 .209 1 r
.26447 .29273 .27787 .30702 .29832 .29996 .28503 .2854 Metetra
.017 0 1 r
.28503 .2854 .29832 .29996 .31894 .29293 .30575 .27805 Metetra
.27 0 1 r
.30575 .27805 .31894 .29293 .33972 .28595 .32664 .27067 Metetra
.553 0 1 r
.32664 .27067 .33972 .28595 .36066 .27901 .34769 .26324 Metetra
.869 0 1 r
.34769 .26324 .36066 .27901 .38178 .27205 .36892 .25574 Metetra
1 0 .78 r
.36892 .25574 .38178 .27205 .40307 .26497 .39033 .24812 Metetra
1 0 .399 r
.39033 .24812 .40307 .26497 .42456 .25757 .41191 .24033 Metetra
1 0 0 r
.41191 .24033 .42456 .25757 .44624 .2497 .43368 .23234 Metetra
1 .399 0 r
.43368 .23234 .44624 .2497 .46809 .24136 .45563 .22415 Metetra
1 .78 0 r
.45563 .22415 .46809 .24136 .49012 .2327 .47775 .21578 Metetra
.869 1 0 r
.47775 .21578 .49012 .2327 .51232 .2239 .50005 .20729 Metetra
.553 1 0 r
.50005 .20729 .51232 .2239 .5347 .21508 .52253 .19872 Metetra
.27 1 0 r
.52253 .19872 .5347 .21508 .55724 .20629 .5452 .1901 Metetra
.017 1 0 r
.5452 .1901 .55724 .20629 .57996 .19753 .56804 .18143 Metetra
0 1 .209 r
.56804 .18143 .57996 .19753 .60287 .1888 .59107 .17273 Metetra
0 1 .414 r
.59107 .17273 .60287 .1888 .62596 .18008 .6143 .164 Metetra
0 1 .6 r
.6143 .164 .62596 .18008 .64924 .17135 .63771 .15522 Metetra
0 1 .771 r
.63771 .15522 .64924 .17135 .67272 .1626 .66132 .1464 Metetra
0 1 .929 r
.66132 .1464 .67272 .1626 .69639 .15381 .68513 .13753 Metetra
0 .924 1 r
.68513 .13753 .69639 .15381 .72026 .14498 .70914 .1286 Metetra
0 .787 1 r
.70914 .1286 .72026 .14498 .74433 .1361 .73335 .11961 Metetra
0 .658 1 r
.73335 .11961 .74433 .1361 .7686 .12717 .75777 .11056 Metetra
0 1 .86 r
.11069 .32983 .12493 .34317 .14441 .33608 .13025 .32261 Metetra
0 1 .993 r
.13025 .32261 .14441 .33608 .16404 .32894 .14997 .31535 Metetra
0 .865 1 r
.14997 .31535 .16404 .32894 .18381 .32177 .16983 .30805 Metetra
0 .714 1 r
.16983 .30805 .18381 .32177 .20374 .31456 .18986 .30069 Metetra
0 .552 1 r
.18986 .30069 .20374 .31456 .22383 .30731 .21003 .2933 Metetra
0 .377 1 r
.21003 .2933 .22383 .30731 .24407 .30003 .23037 .28585 Metetra
0 .189 1 r
.23037 .28585 .24407 .30003 .26447 .29273 .25087 .27837 Metetra
.016 0 1 r
.25087 .27837 .26447 .29273 .28503 .2854 .27153 .27083 Metetra
.239 0 1 r
.27153 .27083 .28503 .2854 .30575 .27805 .29235 .26325 Metetra
.482 0 1 r
.29235 .26325 .30575 .27805 .32664 .27067 .31334 .25562 Metetra
.747 0 1 r
.31334 .25562 .32664 .27067 .34769 .26324 .33451 .24792 Metetra
1 0 .966 r
.33451 .24792 .34769 .26324 .36892 .25574 .35584 .24014 Metetra
1 0 .658 r
.35584 .24014 .36892 .25574 .39033 .24812 .37735 .23226 Metetra
1 0 .334 r
.37735 .23226 .39033 .24812 .41191 .24033 .39904 .22427 Metetra
1 0 0 r
.39904 .22427 .41191 .24033 .43368 .23234 .42091 .21616 Metetra
1 .334 0 r
.42091 .21616 .43368 .23234 .45563 .22415 .44296 .20792 Metetra
1 .658 0 r
.44296 .20792 .45563 .22415 .47775 .21578 .46519 .19957 Metetra
1 .966 0 r
.46519 .19957 .47775 .21578 .50005 .20729 .4876 .19112 Metetra
.747 1 0 r
.4876 .19112 .50005 .20729 .52253 .19872 .5102 .18258 Metetra
.482 1 0 r
.5102 .18258 .52253 .19872 .5452 .1901 .53298 .17397 Metetra
.239 1 0 r
.53298 .17397 .5452 .1901 .56804 .18143 .55594 .16529 Metetra
.016 1 0 r
.55594 .16529 .56804 .18143 .59107 .17273 .5791 .15656 Metetra
0 1 .189 r
.5791 .15656 .59107 .17273 .6143 .164 .60245 .14776 Metetra
0 1 .377 r
.60245 .14776 .6143 .164 .63771 .15522 .626 .13891 Metetra
0 1 .552 r
.626 .13891 .63771 .15522 .66132 .1464 .64975 .13 Metetra
0 1 .714 r
.64975 .13 .66132 .1464 .68513 .13753 .67369 .12102 Metetra
0 1 .865 r
.67369 .12102 .68513 .13753 .70914 .1286 .69784 .11198 Metetra
0 .993 1 r
.69784 .11198 .70914 .1286 .73335 .11961 .7222 .10287 Metetra
0 .86 1 r
.7222 .10287 .73335 .11961 .75777 .11056 .74677 .0937 Metetra
0 .955 1 r
.09624 .3163 .11069 .32983 .13025 .32261 .11589 .30897 Metetra
0 .819 1 r
.11589 .30897 .13025 .32261 .14997 .31535 .13569 .30159 Metetra
0 .675 1 r
.13569 .30159 .14997 .31535 .16983 .30805 .15565 .29416 Metetra
0 .522 1 r
.15565 .29416 .16983 .30805 .18986 .30069 .17576 .28667 Metetra
0 .359 1 r
.17576 .28667 .18986 .30069 .21003 .2933 .19603 .27914 Metetra
0 .185 1 r
.19603 .27914 .21003 .2933 .23037 .28585 .21647 .27154 Metetra
.002 0 1 r
.21647 .27154 .23037 .28585 .25087 .27837 .23706 .2639 Metetra
.202 0 1 r
.23706 .2639 .25087 .27837 .27153 .27083 .25782 .2562 Metetra
.416 0 1 r
.25782 .2562 .27153 .27083 .29235 .26325 .27874 .24844 Metetra
.646 0 1 r
.27874 .24844 .29235 .26325 .31334 .25562 .29984 .24062 Metetra
.892 0 1 r
.29984 .24062 .31334 .25562 .33451 .24792 .32111 .23272 Metetra
1 0 .847 r
.32111 .23272 .33451 .24792 .35584 .24014 .34255 .22476 Metetra
1 0 .573 r
.34255 .22476 .35584 .24014 .37735 .23226 .36416 .21671 Metetra
1 0 .289 r
.36416 .21671 .37735 .23226 .39904 .22427 .38596 .20856 Metetra
1 0 0 r
.38596 .20856 .39904 .22427 .42091 .21616 .40793 .20033 Metetra
1 .289 0 r
.40793 .20033 .42091 .21616 .44296 .20792 .43009 .192 Metetra
1 .573 0 r
.43009 .192 .44296 .20792 .46519 .19957 .45243 .18357 Metetra
1 .847 0 r
.45243 .18357 .46519 .19957 .4876 .19112 .47496 .17506 Metetra
.892 1 0 r
.47496 .17506 .4876 .19112 .5102 .18258 .49767 .16646 Metetra
.646 1 0 r
.49767 .16646 .5102 .18258 .53298 .17397 .52057 .15779 Metetra
.416 1 0 r
.52057 .15779 .53298 .17397 .55594 .16529 .54366 .14905 Metetra
.202 1 0 r
.54366 .14905 .55594 .16529 .5791 .15656 .56695 .14023 Metetra
.002 1 0 r
.56695 .14023 .5791 .15656 .60245 .14776 .59043 .13135 Metetra
0 1 .185 r
.59043 .13135 .60245 .14776 .626 .13891 .61411 .1224 Metetra
0 1 .359 r
.61411 .1224 .626 .13891 .64975 .13 .63799 .11338 Metetra
0 1 .522 r
.63799 .11338 .64975 .13 .67369 .12102 .66208 .10429 Metetra
0 1 .675 r
.66208 .10429 .67369 .12102 .69784 .11198 .68637 .09513 Metetra
0 1 .819 r
.68637 .09513 .69784 .11198 .7222 .10287 .71088 .08589 Metetra
0 1 .955 r
.71088 .08589 .7222 .10287 .74677 .0937 .73559 .07658 Metetra
0 .785 1 r
.08159 .3026 .09624 .3163 .11589 .30897 .10133 .29515 Metetra
0 .649 1 r
.10133 .29515 .11589 .30897 .13569 .30159 .12121 .28765 Metetra
0 .504 1 r
.12121 .28765 .13569 .30159 .15565 .29416 .14126 .28009 Metetra
0 .352 1 r
.14126 .28009 .15565 .29416 .17576 .28667 .16146 .27248 Metetra
0 .19 1 r
.16146 .27248 .17576 .28667 .19603 .27914 .18183 .26481 Metetra
0 .019 1 r
.18183 .26481 .19603 .27914 .21647 .27154 .20235 .25708 Metetra
.163 0 1 r
.20235 .25708 .21647 .27154 .23706 .2639 .22304 .24929 Metetra
.356 0 1 r
.22304 .24929 .23706 .2639 .25782 .2562 .2439 .24145 Metetra
.561 0 1 r
.2439 .24145 .25782 .2562 .27874 .24844 .26493 .23353 Metetra
.777 0 1 r
.26493 .23353 .27874 .24844 .29984 .24062 .28613 .22556 Metetra
1 0 .995 r
.28613 .22556 .29984 .24062 .32111 .23272 .3075 .21751 Metetra
1 0 .757 r
.3075 .21751 .32111 .23272 .34255 .22476 .32904 .20939 Metetra
1 0 .51 r
.32904 .20939 .34255 .22476 .36416 .21671 .35077 .20119 Metetra
1 0 .257 r
.35077 .20119 .36416 .21671 .38596 .20856 .37267 .19291 Metetra
1 0 0 r
.37267 .19291 .38596 .20856 .40793 .20033 .39475 .18455 Metetra
1 .257 0 r
.39475 .18455 .40793 .20033 .43009 .192 .41702 .1761 Metetra
1 .51 0 r
.41702 .1761 .43009 .192 .45243 .18357 .43948 .16757 Metetra
1 .757 0 r
.43948 .16757 .45243 .18357 .47496 .17506 .46212 .15896 Metetra
1 .995 0 r
.46212 .15896 .47496 .17506 .49767 .16646 .48495 .15027 Metetra
.777 1 0 r
.48495 .15027 .49767 .16646 .52057 .15779 .50798 .1415 Metetra
.561 1 0 r
.50798 .1415 .52057 .15779 .54366 .14905 .53119 .13265 Metetra
.356 1 0 r
.53119 .13265 .54366 .14905 .56695 .14023 .55461 .12373 Metetra
.163 1 0 r
.55461 .12373 .56695 .14023 .59043 .13135 .57822 .11474 Metetra
0 1 .019 r
.57822 .11474 .59043 .13135 .61411 .1224 .60204 .10567 Metetra
0 1 .19 r
.60204 .10567 .61411 .1224 .63799 .11338 .62606 .09653 Metetra
0 1 .352 r
.62606 .09653 .63799 .11338 .66208 .10429 .65029 .08731 Metetra
0 1 .504 r
.65029 .08731 .66208 .10429 .68637 .09513 .67472 .07802 Metetra
0 1 .649 r
.67472 .07802 .68637 .09513 .71088 .08589 .69937 .06865 Metetra
0 1 .785 r
.69937 .06865 .71088 .08589 .73559 .07658 .72424 .0592 Metetra
0 .631 1 r
.06673 .28871 .08159 .3026 .10133 .29515 .08654 .28114 Metetra
0 .494 1 r
.08654 .28114 .10133 .29515 .12121 .28765 .10652 .27352 Metetra
0 .351 1 r
.10652 .27352 .12121 .28765 .14126 .28009 .12666 .26584 Metetra
0 .2 1 r
.12666 .26584 .14126 .28009 .16146 .27248 .14695 .25811 Metetra
0 .042 1 r
.14695 .25811 .16146 .27248 .18183 .26481 .16741 .25031 Metetra
.125 0 1 r
.16741 .25031 .18183 .26481 .20235 .25708 .18803 .24245 Metetra
.301 0 1 r
.18803 .24245 .20235 .25708 .22304 .24929 .20882 .23453 Metetra
.486 0 1 r
.20882 .23453 .22304 .24929 .2439 .24145 .22977 .22654 Metetra
.68 0 1 r
.22977 .22654 .2439 .24145 .26493 .23353 .2509 .21849 Metetra
.883 0 1 r
.2509 .21849 .26493 .23353 .28613 .22556 .2722 .21037 Metetra
1 0 .906 r
.2722 .21037 .28613 .22556 .3075 .21751 .29367 .20218 Metetra
1 0 .687 r
.29367 .20218 .3075 .21751 .32904 .20939 .31533 .19392 Metetra
1 0 .462 r
.31533 .19392 .32904 .20939 .35077 .20119 .33716 .18558 Metetra
1 0 .232 r
.33716 .18558 .35077 .20119 .37267 .19291 .35917 .17717 Metetra
1 0 0 r
.35917 .17717 .37267 .19291 .39475 .18455 .38137 .16868 Metetra
1 .232 0 r
.38137 .16868 .39475 .18455 .41702 .1761 .40375 .16011 Metetra
1 .462 0 r
.40375 .16011 .41702 .1761 .43948 .16757 .42632 .15146 Metetra
1 .687 0 r
.42632 .15146 .43948 .16757 .46212 .15896 .44908 .14273 Metetra
1 .906 0 r
.44908 .14273 .46212 .15896 .48495 .15027 .47204 .13392 Metetra
.883 1 0 r
.47204 .13392 .48495 .15027 .50798 .1415 .49518 .12503 Metetra
.68 1 0 r
.49518 .12503 .50798 .1415 .53119 .13265 .51853 .11607 Metetra
.486 1 0 r
.51853 .11607 .53119 .13265 .55461 .12373 .54207 .10703 Metetra
.301 1 0 r
.54207 .10703 .55461 .12373 .57822 .11474 .56582 .09791 Metetra
.125 1 0 r
.56582 .09791 .57822 .11474 .60204 .10567 .58977 .08871 Metetra
0 1 .042 r
.58977 .08871 .60204 .10567 .62606 .09653 .61393 .07944 Metetra
0 1 .2 r
.61393 .07944 .62606 .09653 .65029 .08731 .6383 .07009 Metetra
0 1 .351 r
.6383 .07009 .65029 .08731 .67472 .07802 .66288 .06065 Metetra
0 1 .494 r
.66288 .06065 .67472 .07802 .69937 .06865 .68768 .05114 Metetra
0 1 .631 r
.68768 .05114 .69937 .06865 .72424 .0592 .7127 .04155 Metetra
0 .49 1 r
.05164 .27462 .06673 .28871 .08654 .28114 .07155 .26694 Metetra
0 .355 1 r
.07155 .26694 .08654 .28114 .10652 .27352 .09161 .2592 Metetra
0 .214 1 r
.09161 .2592 .10652 .27352 .12666 .26584 .11183 .2514 Metetra
0 .066 1 r
.11183 .2514 .12666 .26584 .14695 .25811 .13222 .24354 Metetra
.089 0 1 r
.13222 .24354 .14695 .25811 .16741 .25031 .15277 .23562 Metetra
.25 0 1 r
.15277 .23562 .16741 .25031 .18803 .24245 .17349 .22763 Metetra
.419 0 1 r
.17349 .22763 .18803 .24245 .20882 .23453 .19437 .21958 Metetra
.596 0 1 r
.19437 .21958 .20882 .23453 .22977 .22654 .21543 .21146 Metetra
.78 0 1 r
.21543 .21146 .22977 .22654 .2509 .21849 .23666 .20327 Metetra
.97 0 1 r
.23666 .20327 .2509 .21849 .2722 .21037 .25806 .19502 Metetra
1 0 .833 r
.25806 .19502 .2722 .21037 .29367 .20218 .27964 .18669 Metetra
1 0 .63 r
.27964 .18669 .29367 .20218 .31533 .19392 .3014 .1783 Metetra
1 0 .423 r
.3014 .1783 .31533 .19392 .33716 .18558 .32334 .16982 Metetra
1 0 .212 r
.32334 .16982 .33716 .18558 .35917 .17717 .34546 .16128 Metetra
1 0 0 r
.34546 .16128 .35917 .17717 .38137 .16868 .36777 .15265 Metetra
1 .212 0 r
.36777 .15265 .38137 .16868 .40375 .16011 .39027 .14395 Metetra
1 .423 0 r
.39027 .14395 .40375 .16011 .42632 .15146 .41296 .13517 Metetra
1 .63 0 r
.41296 .13517 .42632 .15146 .44908 .14273 .43584 .12632 Metetra
1 .833 0 r
.43584 .12632 .44908 .14273 .47204 .13392 .45892 .11738 Metetra
.97 1 0 r
.45892 .11738 .47204 .13392 .49518 .12503 .48219 .10837 Metetra
.78 1 0 r
.48219 .10837 .49518 .12503 .51853 .11607 .50567 .09927 Metetra
.596 1 0 r
.50567 .09927 .51853 .11607 .54207 .10703 .52934 .0901 Metetra
.419 1 0 r
.52934 .0901 .54207 .10703 .56582 .09791 .55322 .08084 Metetra
.25 1 0 r
.55322 .08084 .56582 .09791 .58977 .08871 .57731 .07151 Metetra
.089 1 0 r
.57731 .07151 .58977 .08871 .61393 .07944 .60161 .0621 Metetra
0 1 .066 r
.60161 .0621 .61393 .07944 .6383 .07009 .62612 .0526 Metetra
0 1 .214 r
.62612 .0526 .6383 .07009 .66288 .06065 .65085 .04302 Metetra
0 1 .355 r
.65085 .04302 .66288 .06065 .68768 .05114 .6758 .03336 Metetra
0 1 .49 r
.6758 .03336 .68768 .05114 .7127 .04155 .70097 .02361 Metetra
0 .362 1 r
.03634 .26033 .05164 .27462 .07155 .26694 .05633 .25254 Metetra
0 .229 1 r
.05633 .25254 .07155 .26694 .09161 .2592 .07648 .24468 Metetra
0 .091 1 r
.07648 .24468 .09161 .2592 .11183 .2514 .09679 .23676 Metetra
.054 0 1 r
.09679 .23676 .11183 .2514 .13222 .24354 .11727 .22877 Metetra
.204 0 1 r
.11727 .22877 .13222 .24354 .15277 .23562 .13791 .22072 Metetra
.36 0 1 r
.13791 .22072 .15277 .23562 .17349 .22763 .15873 .21261 Metetra
.522 0 1 r
.15873 .21261 .17349 .22763 .19437 .21958 .17971 .20443 Metetra
.69 0 1 r
.17971 .20443 .19437 .21958 .21543 .21146 .20086 .19618 Metetra
.864 0 1 r
.20086 .19618 .21543 .21146 .23666 .20327 .22219 .18786 Metetra
1 0 .956 r
.22219 .18786 .23666 .20327 .25806 .19502 .2437 .17947 Metetra
1 0 .772 r
.2437 .17947 .25806 .19502 .27964 .18669 .26539 .17101 Metetra
1 0 .583 r
.26539 .17101 .27964 .18669 .3014 .1783 .28725 .16248 Metetra
1 0 .39 r
.28725 .16248 .3014 .1783 .32334 .16982 .3093 .15387 Metetra
1 0 .196 r
.3093 .15387 .32334 .16982 .34546 .16128 .33154 .14519 Metetra
1 0 0 r
.33154 .14519 .34546 .16128 .36777 .15265 .35396 .13643 Metetra
1 .196 0 r
.35396 .13643 .36777 .15265 .39027 .14395 .37658 .1276 Metetra
1 .39 0 r
.37658 .1276 .39027 .14395 .41296 .13517 .39939 .11868 Metetra
1 .583 0 r
.39939 .11868 .41296 .13517 .43584 .12632 .42239 .10969 Metetra
1 .772 0 r
.42239 .10969 .43584 .12632 .45892 .11738 .44559 .10062 Metetra
1 .956 0 r
.44559 .10062 .45892 .11738 .48219 .10837 .46899 .09147 Metetra
.864 1 0 r
.46899 .09147 .48219 .10837 .50567 .09927 .4926 .08223 Metetra
.69 1 0 r
.4926 .08223 .50567 .09927 .52934 .0901 .5164 .07292 Metetra
.522 1 0 r
.5164 .07292 .52934 .0901 .55322 .08084 .54042 .06353 Metetra
.36 1 0 r
.54042 .06353 .55322 .08084 .57731 .07151 .56465 .05405 Metetra
.204 1 0 r
.56465 .05405 .57731 .07151 .60161 .0621 .58909 .04449 Metetra
.054 1 0 r
.58909 .04449 .60161 .0621 .62612 .0526 .61375 .03484 Metetra
0 1 .091 r
.61375 .03484 .62612 .0526 .65085 .04302 .63863 .02511 Metetra
0 1 .229 r
.63863 .02511 .65085 .04302 .6758 .03336 .66372 .01529 Metetra
0 1 .362 r
.66372 .01529 .6758 .03336 .70097 .02361 .68905 .00539 Metetra
0 g
.25 Mabswid
.68874 0 m
.96935 .42924 L
s
.96935 .42924 m
1 .6535 L
s
1 .6535 m
.70298 .24544 L
s
.70298 .24544 m
.68874 0 L
s
.03716 .25514 m
0 .48963 L
s
0 .48963 m
.70298 .24544 L
s
.70298 .24544 m
.68874 0 L
s
.68874 0 m
.03716 .25514 L
s
.03716 .25514 m
.68874 0 L
s
.0943 .23276 m
.09901 .23733 L
s
[(-2)] .08489 .22362 1 .971 Mshowa
.21571 .18522 m
.22021 .18999 L
s
[(-1)] .20669 .17569 .94605 1 Mshowa
.34306 .13535 m
.34735 .14032 L
s
[(0)] .3345 .12542 .86223 1 Mshowa
.47683 .08298 m
.48086 .08815 L
s
[(1)] .46877 .07262 .77842 1 Mshowa
.6175 .02789 m
.62124 .03328 L
s
[(2)] .61001 .01712 .6946 1 Mshowa
.125 Mabswid
.11813 .22343 m
.12093 .2262 L
s
.14218 .21402 m
.14496 .2168 L
s
.16645 .20451 m
.16921 .20732 L
s
.19096 .19491 m
.19369 .19775 L
s
.24069 .17544 m
.24337 .17833 L
s
.26591 .16557 m
.26856 .16847 L
s
.29138 .15559 m
.294 .15853 L
s
.3171 .14552 m
.31969 .14848 L
s
.36929 .12509 m
.37183 .12809 L
s
.39578 .11471 m
.39829 .11775 L
s
.42252 .10424 m
.42501 .1073 L
s
.44954 .09366 m
.45199 .09674 L
s
.5044 .07218 m
.50678 .07531 L
s
.53224 .06128 m
.53459 .06444 L
s
.56037 .05026 m
.56269 .05345 L
s
.58879 .03914 m
.59107 .04234 L
s
.0707 .242 m
.07355 .24472 L
s
.04732 .25116 m
.05019 .25386 L
s
.64651 .01654 m
.64872 .01979 L
s
.67582 .00506 m
.67799 .00834 L
s
gsave
.29165 .07573 -87.5368 -17.1875 Mabsadd m
1 1 Mabs scale
currentpoint translate
0 21.1875 translate 1 -1 scale
/g { setgray} bind def
/k { setcmykcolor} bind def
/p { gsave} bind def
/r { setrgbcolor} bind def
/w { setlinewidth} bind def
/C { curveto} bind def
/F { fill} bind def
/L { lineto} bind def
/rL { rlineto} bind def
/P { grestore} bind def
/s { stroke} bind def
/S { show} bind def
/N {currentpoint 3 -1 roll show moveto} bind def
/Msf { findfont exch scalefont [1 0 0 -1 0 0 ] makefont setfont} bind def
/m { moveto} bind def
/Mr { rmoveto} bind def
/Mx {currentpoint exch pop moveto} bind def
/My {currentpoint pop exch moveto} bind def
/X {0 rmoveto} bind def
/Y {0 exch rmoveto} bind def
63.000 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(Imag) show
87.500 13.313 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  CellLabel->"From In[141]:=",
  ImageSize->{288, 233.563},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004P0000jA000`40O003h00Oogoo8Goo003oOolQ
Ool00?moob5oo`00ogoo8Goo003oOolQOol00?moob5oo`00ogoo8Goo003oOolQOol00?moob5oo`00
ogoo8Goo003oOolQOol00?moob5oo`00ogoo8Goo003oOolQOol00?moob5oo`00ogoo8Goo002cOol4
001YOol00;=oo`03001oogoo06Yoo`00]7oo00<007ooOol0JGoo002eOol00`00Oomoo`1XOol00;=o
o`04001oogoo000BOol2001EOol00;Aoo`80015oo`800003Ool0000005Aoo`00a7oo0`0000=oo`00
00000P00E7oo0032Ool20002Ool3000010?[00000000Dgoo002oOol3000017oo0000000010?[0P00
00=oo`00Ool0DGoo002lOol3000017oo000000000P?W00<000?[0n/00P?[00@000?[0000059oo`00
^Woo0P000Woo0P001@?W00<000?[0n/00P?[00<000?[00000P00DGoo002gOol30002Ool200000`?R
0003i`050nL00`000n/3j`0300020nl2001@Ool006Aoo`<004ioo`8000=oo`8000<3hP030003i`?W
00D3i`800083k`030003k`?_0080051oo`00Igoo00<007ooOol0B7oo0`000Woo0`001P?R00<000?W
0nL00P?W0P0000D3j`000nl3k`0000<3k`8004moo`00Dgoo0`0000Qoo`00001oo`00Ool007oo1@00
0Woo0`00:7oo1@006goo0`0000Aoo`0000000087h0030003hP?R00@3hP030003i`?W008000<3j`04
0003k`?_00040nl2001>Ool005Aoo`0:001oogooOol007oo001oo`00Ool40002Ool01000Oomoo`00
:Woo00<007ooOol067oo0`0000Aoo`00000000D7h0030003hP?R00@3hP<000H3j`030003k`000083
k`8000030o@007oo04eoo`00E7oo00T007ooOomoo`00Ool007oo000017oo00@007ooOol0009oo`03
001oogoo02Qoo`03001oogoo01Ioo`800004Ool0000000026n000`001n07h0041n000`000n83hP03
00020nH00`000n/3j`040n/00`000nl0000200030o@2001=Ool005Aoo`03001oogoo00<00003Ool0
07oo009oo`<000=oo`@002Uoo`03001oogoo01=oo`<00003Ool0000000DKh0030007h0OP00@7h0<0
00D3iP030003j`?[00@3j`<000H3m003001oogoo04]oo`00E7oo00<007ooOol0>goo00<007ooOol0
4Goo0P000Woo0P0000<_h0006n001A_P00<000OP1n000`000P?R00<000?V0nH010?V00<000?[0n/0
0`000P?_00<000?d0o@010?d0P00C7oo001COol3000kOol2000@Ool30002Ool20003;n000`006n0K
h0056n0200050n800`000nH3iP040nH300050nl00`000o@3m0040o@3001;Ool00:1oo`<0009oo`<0
00H_h003000Kh1_P008Kh08000032n0000?R00D3hP030003iP?V00<00083j`030003k`?_00<3k`80
0083m0<00083n@03001oogoo04Uoo`00WWoo0P000Woo0`000T?P00<002oP;n0012oP00<001_P6n00
0P000`_P00<000?R0n801@?R0P001@?[00<000?_0nl00`?_10001@?i0P00BWoo002KOol70005@n00
0`00;n0_h004;n0300062n000`000n83hP020n8200000`?V0003j`050n/00`000nl3k`0300020o@0
0`000oT3n@040oT20019Ool009Uoo`80009oo`80009Kh0030013h4?P00A3h003000_h2oP00<0008O
h003000;h0_P00@;h0030003hP?R008000<3iP030003j`?[00@3j`<00083m0040003m0?d00060oT2
0019Ool009Ioo`<00004Ool000000005Fn000`00@n13h003@n0300057n000`002n0;h0042n030006
0nH00`000n/3j`0300020o0010000o@3m0000`?d00<000?i0oT00`0000<3oP0000003Goo0`00>7oo
002DOol2000017oo000000000VoP00<005_PFn0015_P00<004?P@n000P000SOP00<001oP7n0011oP
00<000_P2n000`000P?Q00<000?V0nH01@?V0P001@?`00@000?d0o@000<3m0<000D3oP8000aoo`04
001oogoo000gOol0095oo`<00005Ool00000Kn000003Kn000`00Fn1Kh004Fn030004=n000`007n0O
h0047n0300050n400`000nH3iP030nH200000`?[0003l0050o000`000o@0000300000`?j0003oP05
0oh2000<Ool01000Oomoo`00=goo001aOol2000LOol20002Ool200000go0001_h005Kn000`00Fn1K
h0030002Cn000`00=n0gh003=n000`007n0Oh00300023n000`000n43h@040n400`000nH3iP020003
0n/00`000o03l0050o0300040oX00`000oh3oP030oh30005Ool40002Ool3000hOol0071oo`04001o
ogoo000HOol30002Ool20003Ol000`00Kn1_h005Kn020005Cn000`00=n0gh003=n0300053n000`00
0n43h@040n4300060n/00`000o03l0020o0300000`?j0003nP030oX00`000oh3oP0300020gl2000;
Ool00`00Oomoo`0gOol0071oo`04001oogoo000FOol20002Ool30006Ol000`00Kn1_h002Kn020000
0f?P001?h005Cn000`00=n0gh00200029n000`003n0?h0043n000`000n43h@0300020nH00`000n/3
j`040n/00`000o03l00200030oD200040oX300050gl2000;Ool3000gOol0071oo`04001oogoo000C
Ool400000goo00000002O`000`00Ol1o`004Ol000`00Kn1_h0020003Hn000`00Cn1?h004Cn030004
9n000`003n0?h0043n0300050nH00`000n/3j`040n/300050oD2000010?j000000000P?o00<000=o
0gl010=o0P00A7oo001`Ool01000Oomoo`0047oo0`000Woo0`0017l000<007o0Ol0017o00`001V?P
00<004oPCn000`000SoP00<002OP9n000bOP00<000oP3n000`000P?P00<000?V0nH010?V00<000?[
0n/00`000P?`00<000?e0oD010?e0P001@?o00<000=o0gl010=o0`00@goo001aOol2000?Ool20002
Ool30002OT000`00O`1o0003O`000`00Ol1o`0030002On000`00Hn1Sh005Hn020005?n000`009n0W
h0039n0300050n000`000nH3iP040nH300050o000`000oD3m@020oD400060ol00`000gl3O`030002
0[l00`00Oomoo`11Ool007moo`<00004Ool000000005OT000`00O`1o0003O`030005On000`00Hn1S
h003Hn0200000eOP000oh005?n000`009n0Wh00200025n000`000n03h0040n000`000nH3iP030002
0n/00`000o03l0040o0010000oD000000P?k0P001P?o0`001@:o0P00@Woo001mOol2000017oo0000
00000Wf000<007i0OT0017i000<007l0O`000P000Wm000<007oPOn0017oP00<006?PHn000P000eOP
00<003oP?n0013oP0`0011OP00<000?P0n0010?P0`001@?[00<000?`0o0010?`0P0010?k00<000?k
00000P?o0`000P<o00<000:o0[l010:o0P00@Goo001jOol60005OH000`00OT1n@004OT030005Od00
0`00On1oh003On030006En000`00?n0oh0030002;n000`005n0Gh0035n000`000n03h00300020nD0
0`000n/3j`040n/00`000o03l00300000`?f0003n`030o/00`000o/3n`0200050cl00`000[l2_`04
0[l20011Ool007Qoo`800003Ool00000009l`003001mP7f000AmP003001n@7i000<0009nP003001o
@7m000Ao@003001oh7oP0080009ch003001Gh5OP00EGh08000D_h003000Gh1OP00<Gh0<000D3i@03
0003j`?[00@3j`<000D3mP040003n`?k0o/300000`>o0003?`050cl00`000[l2_`0300000`7O0000
0010Ool007Eoo`H000El`003001mP7f000=mP0<000EnP003001o@7m000Ao@0<000Ach003001Gh5OP
00=Gh0800003An0002oP00D_h003000Gh1OP00800083h0030003i@?U00@3i@030003j`?[00<00083
l@030003mP?f00<3mP030003n`?k008000<3_`030003?`<o00@3?`<000D1g`8003moo`00Lgoo0P00
00=oo`0000000W`000<007c0O<0017c000<007f0OH000P000WfP00<007j0OX0017j000<007m0Od00
0`000Wn000<007?PLn000g?P00<005OPEn000P000dOP00<002oP;n0012oP0`0010?P00<000?U0nD0
10?U0`001@?a00<000?f0oH00`?f0`0000<3_`000kl00`>o00<000<o0cl00`0000<2G`000Ml01@7O
0P00?goo001AOol5000JOol300000goo00000004O0000`00O<1l`004O<030005OJ000`00OX1nP003
OX030005Oh000`00Ln1ch003Ln030006An000`00;n0_h00300026n000`000n03h0030n000`000nD3
i@0300020n`00`000o43l@040o400`000oH3mP0200020od00`000kl000050kl200050Ul00`000Ml1
g`030Ml3000nOol005=oo`03001oogoo01Moo`L00003O0H007`000Al0003001l`7c000<0009l`003
001mX7fP00AmX003001nP7j00080009nX003001oP7n000AoP003001ch7?P0080009Sh0030017h4OP
00E7h08000DKh0030003h0?P00<3h0<000D3k0030003l@?a00@3l@<000@3o@030003_`0000<3_`80
00030]l0009O00@2G`030001g`7O00<00080g`8003eoo`00Dgoo00<007ooOol05Goo0P000goo0P00
0g`600<007`0O0000g`00`001Gc000<007fPOJ0017fP0`0017jP00<007n0Oh0017n00`0016?P00<0
04OPAn000dOP0P0000<gh0006n001A_P00<000?P0n000P000P?V00<000?/0n`010?/00<000?a0o40
0`0000<3n0000od01@?m0P0000<3_`0000000`;O00<0009O0Ul00`9O0`001@3O0P00?Goo001;Ool4
0004Ool00`00Oomoo`0BOol30002Ool30006O0H00`00O01l00020002O0000`00O<1l`004O<000`00
OJ1mX0030002OL000`00OZ1nX003OZ000`00Oh1oP0030002On000`00Hn1Sh003Hn000`00An17h002
0003=n000`006n0Kh0046n0300040nH00`000n`3k0040n`300050oP00`000od3o@030od300060]l0
0`000Ul2G`0200020El00`000=l0g`040=l2000lOol005=oo`03001oogoo011oo`80009oo`<0009l
3003001l1W`600Al1P<000El0003001l`7c000=l`0<000Em`003001nX7jP00=nX0<000Eoh003001S
h6?P00=Sh0<000Hgh003000Kh1_P00<00083h0030003iP?V00<3iP030003k0?/00<00083l`030003
n0?h00<3n0030003o@?m00<00083G`030002g`;O00@2g`<000@1G`030000g`3O00@0g`8003aoo`00
DWoo0P003goo0`000Woo0`001G`<0P000W`60P000W`600<007`0O00017`000<007c0O<000P000WcP
00<007g0OL0017g000<007jPOZ000P000Wl000<007oPOn0017oP00<006?PHn000P000U?P00<003OP
=n0013OP0`001@?P00<000?V0nH00`?V0`001@?c00<000?h0oP00`?h0`001@=O0P000P;O0`0000<1
g`000El01@5O00<0003O0=l00`0000<47`000000>goo001QOol200000goo001oo`020002O1800`00
O0al3004O0`30004O0H00`00O01l0004O0030004O>000`00OL1m`004OL030004O`000`00On1oh004
On030005Dn000`00=n0gh00300027n000`000n03h0040n000`000nH3iP0200020nd00`000o<3l`04
0o<00`000oP3n00200020ol00`000el3G`030el010000el000001@7O00<0005O0El00`5O0`001@@O
0P00>Woo001NOol30002Ool30005O1800`00O0al30030002O0d00`00O0Il1P03O0H00`00O01l0003
0002O0000`00O>1lh003O>000`00OL1m`0030002OP000`00O`1o0003O`000`00On1oh0030002Ln00
0`00Dn1Ch004Dn0200057n000`000n03h0040n0300040nd00`000o<3l`040o<300040ol00`000el3
G`030el300060Ml00`000El1G`0300000`1O00047`0511l2000jOol005aoo`<00004Ool000000002
O1P00`00O19l4P04O1820005O0d00`00O0Il1P03O0H30005O0000`00O>1lh003O>030005OP000`00
O`1o0003O`030005Ln000`00Dn1Ch002Dn0200000coP000Oh0057n000`000n03h00300000`?V0003
k@050nd00`000o<3l`0300000`?k0003o`050ol00`000el3G`0300020Ul00`000Ml1g`030Ml30005
05l00`0011l47`0311l3000iOol005Uoo`<00004Ool000000005O1P00`00O19l4P02O18200000g`D
001l3@05O0d00`00O0Il1P020002O0L00`00O01l0004O0000`00O>1lh0020002O@000`00OP1n0004
OP000`00O`1o00020002Of000`00Ln1ch004Ln001000Dn0000000coP00<001oP7n0011oP0`001@?V
00<000?]0nd00`?]0`001@?k00<000?o0ol00`?o0`000P9O00@0009O0Ul00081g`<00080_`030000
G`1O00<0G`0300047`@O00<0008T7`8003Qoo`00Egoo0P000Woo0P000W`N00<007`HO1P017`H00@0
07`B000000Al5003001l3G`=00=l3@<000El1`03001l07`000=l00<000Am0003001n07h000An00<0
00AoH003001ch7?P00Ach08000Hoh003000Oh1oP00<00083h0030003iP?V00<3iP030003k@?]00<0
0083m@030003n`?k00<3n`030003o`?o00<00082g`040002G`9O00020Ul300050;l00`0005l0G`03
05l3000591l2000hOol005Aoo`<00004Ool000000005O1h00`00O1Ql6003O1P20007O1@00`00O0el
3@020002O0h00`00O0Ml1`04O0L00`00O01l00020002O0000`00O@1m0003O@000`00OP1n00030002
OT000`00Of1oH003Of000`00Ln1ch0030002Gn000`00?n0oh003?n0300050n000`000nH3iP030nH3
00050oD00`000o/3n`030o/300060]l00`000Ul0000200020Cl00`000;l0_`040;l00`0005l0G`02
000261l00`0091lT7`0491l2000gOol003=oo`@001Yoo`<0009oo`80009/7`03001l7W`N00Al7P03
001l67`H0080009l6P03001l57`D00Al50<000Al3P03001l1g`700Al1`<000Al0003001m07d000=m
00<000En@003001oH7mP00=oH0<000IOh003000oh3oP0080008Sh0030003h0?P00@3h0030003iP?V
00800083k`030003m@?e00@3m@030003n`?k00800083O`030002g`;O00D2g`8000@1?`030000_`2o
00@0_`<000@H7`03000T7b@O00@T7`<003Ioo`00<goo00<007ooOol06Goo1`001F`O00<007`NO1h0
0g`N0`001G`J00<007`DO1@00`000W`E00<007`>O0h00g`>00<007`7O0L00`000W`800<007`0O000
0g`000<007d0O@000P000WdP00<007i0OT0017i000<007mPOf000P000Wo000<005oPGn001EoP0P00
12?P00<000?P0n0010?P0`0010?_00<000?e0oD010?e0`0010=o00<000;O0]l00`;O10001@4o00<0
002o0;l00`0000<<7`0061l01APO00<002@O91l00`000T@O00<007ooOol067oo0`000Woo00<007oo
Ool00`000Woo1@0000Aoo`00000000Ioo`00=7oo00<007ooOol05Goo0`000Woo0P000UPO00<006`O
K1l016`O00<007`NO1h00P000W`O00<007`JO1X00g`J0`001G`E00<007`>O0h00g`>0`001G`800<0
07`0O0000g`00`001GdP00<007i0OT000gi00`0017o000<005oPGn000eoP0P0000=7h0008n0012?P
00<000?P0n000`000P?X00<000?_0nl00`?_00<000?e0oD00`000P?o00<000=o0gl00`=o00<000;O
0]l00P000`6o00<0004o0Cl00`4o0`001@`O00<001PO61l00aPO0`001D@O0P006Woo00@007ooOol0
009oo`03001oogoo00=oo`@000=oo`03001oogoo00Eoo`00;Goo100017oo00<007ooOol04Woo0`00
00Aoo`00000000AH7`03001/7f`O00A/7`<000El7`03001l6W`J0080009l7003001l5G`E00Al5@03
001l3W`>0080009l4003001l27`800Al2003001l07`00080009l0003001m87dP00Am8003001n@7i0
0080009nX003001o`7o000=o`003001Oh5oP008000=7h003000Sh2?P00<Sh0<000D3j0030003k`?_
00<3k`<000D3o`030003O`=o00<3O`<000D1_`030001?`4o00<000807`03000<7``O00<<7`03000H
7aPO00<0008h7`0300147d@O00=47`<001Uoo`<000=oo`@000Eoo`05001oogooOol00007Ool003=o
o`04001oogoo000@Ool30002Ool20002@1l00`00F1mH7`03F1l00`00K1m/7`030002H1l00`00O1ml
7`03O1l30005O1`00`00O1El5@03O1D30004O1000`00O0Ql2004O0P30004O0000`00OB1m8004OB03
0004OZ000`00Ol1o`003Ol030006An000`008n0Sh00200020n000`000nP3j0040nP00`000nl3k`02
00020oT00`000ol3o`040ol00`000gl3O`0200020Sl00`000Kl1_`030Kl3000501l00`0031l<7`03
31l30005>1l00`00A1m47`030002I1l00`00Oomoo`0=Ool30007Ool01000Oomoo`000goo0P0017oo
0`000goo00<007ooOol01Goo000dOol2000?Ool20002Ool30004@1l00`00F1mH7`03F1l30006H1l0
0`00O1ml7`020002L1l00`00O1al7004O1`00`00O1El5@020002O1P00`00O11l4003O1000`00O0Ql
20030002O0T00`00O01l0003O0000`00OB1m80030002OD000`00OZ1nX003OZ000`00Ol1o`0020002
Kn000`00An17h005An0200040n000`000nP3j0040nP300040oT00`000ol3o`040ol300050Sl00`00
0Kl1_`0300000`1o00007`0501l00`0031l<7`020002<1l00`00>1lh7`03>1l30005I1l2000?Ool0
0`00Oomoo`06Ool01000Oomoo`003goo00<007ooOol01Goo0012Ool3000017oo000000000R`O00<0
040O@1l00d0O00<005POF1l00P000T`O00<0060OH1l0160O0`001G0O00<007`LO1`00g`L0`0017`H
00<007`@O1000g`@0`001G`900<007`0O0000g`00`001Ge000<007jPOZ000gjP0`0016oP00<004OP
An000dOP0P0000<Wh0000n0010?P00<000?X0nP00`0000<3l`000oT01@?i00<000?o0ol00`000P:o
00<0008o0Sl00`8o0`000`1o0P001P0O0`001C0O00<003PO>1l00P000U`O00<006@OI1l016@O0P00
2goo1@001Woo10003goo0P001goo0010Ool20002Ool30005;1l01000@1m07d0O10001D`O0P000V0O
0P000U@O00<0070OL1l0170O00<007`LO1`00P000W`O00<007`HO1P00g`H00<007`@O1000P000W`B
00<007`9O0T017`900<007`0O0000P000W`000<007e0OD0017e000<007jPOZ000P000Wl000<006oP
Kn000foP00<004OPAn000P000bOP00<000?P0n0010?P0P001@?c00<000?i0oT00`?i0`001@:o00<0
008o0Sl00`0000<0g`0007l00`1o00<0001o00000P0O0`0000<T7`00<1l01S0O0P0015`O00<006@O
I1l016@O0P001Goo10000Woo00@007ooOol002=oo`00?Goo100000=oo`0000000QPO00<002`O;1l0
0b`O10000c@O00<004`OC1l014`O0`0015@O00<0070OL1l0170O0`0017`O00<007`HO1P00g`H0`00
1G`B00<007`9O0T00g`90`0017`000<007e0OD0017e00`0017l000<006oPKn000foP0`001ROP00@0
00?P0n03h08000030n/000?c00@3l`030003n@?i00<00083G`030002_`:o00@2_`8000D0g`060000
O`1o07l0001o0`001B@O00<0030O<1l00S0O0`001U`O00<006@OI1l00`0000=l7@0000002goo00<0
07oo00008goo000kOol20002Ool3000561l00`00;1l/7`02000271l00`00=1ld7`03=1l20002C1l2
0002?1l00`00E1mD7`03E1l00`00L1m`7`030002H1l00`00O1ml7`03O1l00`00O1Ql60020002O1/0
0`00O19l4P04O1800`00O0Ul2@020002O0X00`00O01l0003O0000`00OD1m@0030002OH000`00O`1o
0003O`000`00Kn1_h0020002Dn000`009n0Wh0049n0010000n0000000`?[00<000?c0o<00`?c0`00
1@=O00<000:o0[l00P:o0P0000<1?`000=l0103O00<0001o07l00`000Q`O00<002@O91l00b@O00<0
030O<1l00P000e@O00<005`OG1l00e`O0`001G`M0P002goo0P008goo000hOol30002Ool2000211l0
0`0061lH7`0361l3000571l00`00=1ld7`03=1l30004?1l00`00E1mD7`03E1l30005H1l00`00O1ml
7`03O1l30004O1/00`00O19l4P04O1830004O0X00`00O01l0003O0030005OH000`00O`1o0003O`03
0004Dn000`009n0Wh0049n0200060n/00`000o<3l`0200020ol00`000el3G`040el010000[l00000
0`4o00<0003O0=l00`3O0`0000<L7`0071l00Q`O00<002@O91l00b@O0`001E@O00<005`OG1l00`00
00=l7`00O1d01G`M0P00<7oo000eOol30002Ool3000511l00`0061lH7`02000221l00`0071lL7`04
71l00`00=1ld7`02000291l00`00?1ll7`03?1l00`00E1mD7`020002A1l00`00H1mP7`04H1l00`00
O1ml7`020002L1l00`00O1]l6`03O1/00`00O19l4P030002O1D00`00O0Yl2P03O0X00`00O01l0002
0002O0000`00OH1mP004OH000`00O`1o00020002On000`00Dn1Ch003Dn000`009n0Wh00300020n80
0`000n/3j`040n/200040ol00`000el3G`040el200060Cl00`000=l0g`02000241l00`0071l00004
71l00`0091lT7`020002C1l00`00E1mD7`03E1l30005O1l00`00O1el7@03O1d3000_Ool003=oo`80
00=oo`800080G`0300047`@O00<47`<000D87`03000L7a`O00<L7`<000@T7`03000l7c`O00<l7`<0
00E47`03001P7f0O00=P7`<000E`7`04001l6g`KO1/40006O1D01000O0Yl2W`:100017`000<007f0
OH0017f00`0017oP00<005?PDn000e?P0`001@?R00<000?[0n/00P?[0P0000<3nP000ol010?o00<0
00=O0el00`000P6o00<0004o0Cl00`4o0`00110O00<001`O000011`O0`001D`O00<005@OE1l00P00
0WPO00<007`OO1l00g`O00<007`MO1d00`000W`E0P00;Woo000`Ool30002Ool3000505l00`0011l4
7`02000205l00`0021l87`0421l00`0071lL7`02000231l00`0091lT7`0391l00`00?1ll7`020002
;1l00`00A1m47`04A1l00`00H1mP7`020002D1l00`00L1m`7`03L1l40003O1h00`00O1El5@04O1D4
0003O0`00`00O01l0003O0000`00OH1mP0030002OP000`00On1oh003On000`00Dn1Ch00200028n00
0`000n83hP040n8010000n/000000`?j00<000?o0ol00`?o0`001@6o00<0004o0Cl00`000PPO00<0
010O41l00a0O0P0000@L7`00000000947`03001<7d`O00=<7`<000Ah7`03001l7g`O00=l7`<000El
5@8002ioo`00;Woo0P000goo0P000P3o00<0001O05l00`1O0`001@1O00<000PO21l00`PO0`0010`O
00<002@O91l00b@O0`001B`O0P000d@O10001E0O00<0070OL1l00P000U`O00<007`NO1h00g`N0P00
0W`E0P000W`H00<007`<O0`00W`<00<007`0O0000g`00`001Gh000<007oPOn0017oP0P0012?P00<0
00?R0n801@?R00<000?j0oX010?j00<000?o0ol00P000P8o00<0006o0Kl0106o0P001@PO00<0010O
41l01P001D@O00<004`OC1l00`0000=`7`00N1l01GPO00<007`OO1l00P000W`G00<007`EO1D00g`E
0`00;Goo000/Ool200000goo0000000200050?l00`0005l0G`0200020=l00`0005l0G`0405l00`00
21l87`02000203l00`0031l<7`0331l00`0091lT7`02000251l00`00;1l/7`04;1l40003=1l00`00
D1m@7`03D1l30004G1l00`00O1il7P04O1h30004O1P00`00O0al3003O0`00`00O01l00020002O000
0`00OP1n0004OP001000On1oh7oP0`001R?P00<000?R0n800P?R0`001`?j0P00108o00<0006o0Kl0
0P6o0P0000<07`0021l010PO0`0000<@7`0000000S`O00<004@OA1l00d@O0`001G0O00<007PON1l0
0gPO0`001G`G00<007`EO1D00P000W`=0P00;7oo000/Ool300030Gl00`000?l0o`030?l300050=l0
0`0005l0G`0305l3000503l0100031l<7``O10001A@O0P000R`O0P000QPO00<003@O=1l00c@O00<0
050OD1l00P000S`O00<005`OG1l00e`O00<007`NO1h00`000V`O00<007`HO1P00g`H00<007`<O0`0
0W`<0`0017`000<007h0OP0017h000@007oP000000=Kh003000Sh2?P00<Sh0030003hP?R008000<3
lP030003nP?j0083nP8000030[l0008o00@2?`040001_`00000301l00`0021l87`03000010PO0000
00001C`O00<004@OA1l00P000V`O00<0070OL1l00g0O00<007PON1l00`000W`H00<007`GO1L00g`G
0`0017`=0P00;7oo000/Ool200050Gl00`000?l0o`0200020Gl00`000=l0g`040=l00`0005l0G`02
00020=l00`0003l0?`0303l4000301l00`0051lD7`0451l3000461l00`00=1ld7`03=1l30004?1l0
0`00G1mL7`03G1l30005K1l00`00O1Ql6003O1P00`00O0al30020002O1000`00O01l0003O0000`00
OP1n0003OP020005Fn000`008n0Sh0048n0200050o800`000oX3nP0200030[l00`000Sl2?`030Sl2
000501l3000010PO000000000SPO00<003`O?1l00c`O0`0016`O00<0070OL1l00g0O0`001G`H00<0
07`GO1L00`0000=l3P00O0d01G`=0P00:goo000UOol20005Ool00`00Ool000050Gl200050Gl00`00
0=l0g`030=l300050=l00`0003l0?`0200020=l00`0001l07`0301l2000251l2000201l00`0061lH
7`0361l00`00=1ld7`02000271l00`00?1ll7`03?1l00`00G1mL7`020002A1l00`00K1m/7`04K1l0
1000O1Ql67`H100017`@00<007`0O0000g`000<007h0OP000`0000=nh000Fn001E_P00@002?P8n0S
h08000030nX000?b00D3lP8000H2_`030002?`8o00800080G`0300007`0O0080000401l000000005
>1l00`00?1ll7`0300000f@O00000005K1l00`00L1m`7`020002O1X00`00O1Ql6003O1P30005O0h0
0`00O0el3@03O0d2000[Ool002Aoo`04001oogoo0003Ool01@00Oomoogoo00000P5o0P0000<1o`00
0Gl01@5o00<0003O0=l00P000P5o00<0003O0=l00`3O0`001@3O00<0000O01l00`0O0`00100O00<0
01PO61l00aPO0`0011`O00<003`O?1l00c`O0`001D@O00<006`OK1l00f`O10000g`O00<007`@O100
0g`@00<007`0O0000W`00`001GkP00<005_PFn000e_P00@002?P000000<3jP030003lP?b0083lP80
00030cl000:o00H2_`8000@0G`<0000301l00000008`7`03000h7cPO00@h7`8000ET7`03001/7f`O
00=/7`<000El6P03001l67`H00800003O10007`>00El3P03001l3G`=00<0009l1@03001oogoo02Qo
o`0097oo00@007ooOol000=oo`8000=oo`8000@1o`8000<1O`@000D1O`030000g`3O00800081O`03
0000g`3O00@0g`0300007`0O00800080_`0300007`0O00<07`03000H7aPO008000807`03000L7a`O
00<L7`03000l7c`O0080008P7`0300147d@O00A47`03001/7f`O0080009@7`03001l7g`O009l7`03
001l47`@00=l4003001l07`000800003O00007kP00Enh003001Kh5_P00AKh0030003jP?Z00@3jP04
0003lP0000030cl00`000[l2_`030[l3000205l3000205l20004<1l00`00>1lh7`02>1l200000f@O
001T7`04I1l2000016`O000000000W`K00<007`JO1X00g`J0`0017`@00<007`>O0h00g`>0`001G`5
0P00:Goo000TOol01000Oomoo`000goo00<007ooOol00goo00<0007o0Ol00`7o10000`7o00<0005o
0Gl0105o0P001@5o00<0003O0=l00`3O0`00102o00<0000O01l00`0O0`001@0O00@001`O71lL7`@0
00DP7`0300147d@O00=47`<000A@7`03001l7g`O00=l7`04001l47`@O1040004O0000`00O^1nh004
O^000`00Fn1Kh002Fn0200070nX00`000cl3?`040cl00`000[l2_`02000207l3000305l30006<1l0
1000>1l000000f@O00<006@OI1l00f@O0`001G`K00<007`JO1X00`0000=l4@00O10017`@00<007`>
O0h00`000W`600<007`5O0D00g`50P00:Goo000TOol01000Oomoo`000goo00<007ooOol017oo00<0
007o0Ol00P000P:O00<0007o0Ol00`7o0P000P5o0P0000<27`000Gl01@5o00<0003O0=l00P000P5o
00<0002o0;l00`2o00<0000O01l00P000P3O00<0000O01l00`0O10000`0O00<0020O81l0120O00<0
04@OA1l00P000R@O00<0050OD1l00e0O00<007`OO1l00W`O10000W`G00<007`0O0000g`000<007kP
O^0017kP00<005_PFn000P000POP00<000?Z0nX00`?Z00<000?O00001P<o0P0000H0O`000000001o
000205l20003<1l00`00<1l`7`03<1l20006I1l00`00I1mT7`020002O1`20004O1/30005O1400`00
O11l4002O1030005O0H00`00O0El1@0300000ga00000000XOol002Eoo`8000Aoo`03001oogoo00Eo
o`8000D2W`030001o`7o00<1o`<000@27`030001O`5o00<1O`<000D1O`040000_`2o0;l400050=l0
0`0001l07`0200020=l00`0001l07`0301l2000381l4000491l00`00D1m@7`03D1l00`00O1ml7`02
00000ePO001l5`04O1L00`00O01l0002O0000`00O^1nh005O^0200041n000`000nX3jP020nX01000
0ml3g`001@<o10001@1o0P001C0O00<0030O<1l00`000V0O00<006@OI1l00f@O0`001G`L00<007`K
O1/00P0000=l4P00O1401G`A00<007`@O1000P000W`800<007`6O0H00g`60`001Ga00P009goo000[
Ool20007Ool00`000Yl2W`040Yl00`000Ol1o`0200020Yl00`000Ql27`030Ql00`000Gl1O`020002
0Ql00`000Gl1O`030Gl400030Il00`000=l0g`030=l300040=l00`0001l07`0401l4000301l00`00
91lT7`0391l01000D1m@7e0O100015PO00<007`GO1L00W`G00<007`0O0000W`000<007kPO^001GkP
00<000OP1n0010OP00@000?Z0nX000@3g`030003?`<o00<0000309l0001o00<0O`800003<1l0030O
00@`7`<000EP7`03001T7f@O00<0009l7003001l77`L00=l70<000Al4P03001l4G`A00=l4@<000El
2003001l1W`60080009l0003001l@7a000=l@08002Moo`00:Woo00<007ooOol027oo00<000:O0Yl0
0`:O0`001@:O00@0008O0Ql27`@000D27`030001O`5o00800082?`030001W`6O00<1W`030000g`3O
00800081_`030000g`3O00<0g`0300007`0O00<000817`0300007`0O00<07`04000T7b@O91l50003
81l00`00F1mH7`02F1l00`00O1Ml5`02O1L00`00O01l0003O0000`00O^1nh003O^0200061n000`00
0nX000050ml3000509l0100007l00000130O00<0030O<1l00P000V0O00<0060OH1l00f0O0`001G`L
00<007`LO1`00`0000=l4`00000017`B00<007`AO1400`000W`900<007`8O0P00g`80`0017`000<0
07a0O4000ga00`009Woo000ZOol00`00Oomoo`09Ool00`000Yl2W`0200020cl00`000Yl2W`030Yl4
00030[l00`000Ql27`030Ql300040Sl00`000Il1W`030Il300050Kl00`000=l0g`030=l200050Al0
0`0001l07`0301l4000305l00`0081lP7`0281l00`00F1mH7`02F1l00`00O1Ml5`02O1L00`00O01l
0003O0000`00O^1nh002O^000`00An0000071n0010000ml3g`?O0`0000<3g`0009l01P2O00<0030O
<1l01C0O0P001F0O00<0060OH1l00P000W`L00<007`LO1`00g`L0`001G`C00<007`BO1800W`B0`00
1G`900<007`8O0P00`0000=l0000O0001G`000<007a0O4000P000We00P009Goo000ZOol00`00Oomo
o`0:Ool200050cl00`000Yl2W`0200020el00`000[l2_`030[l00`000Ql27`0200020]l00`000Sl2
?`030Sl00`000Il1W`0200020Wl00`000Kl1_`040Kl00`000=l0g`0200000`7o00017`050Al00`00
01l07`0200020Gl00`0005l0G`0205l00`0081lP7`0381l00`00F1mH7`02F1l00`00O1Ml5`02O1L0
0`00O01l0002O0000`00O^1nh0020002An000`001n07h0041n0500030ml00`000;l0000409l20000
0c@O000`7`03<1l200000fPO001P7`04H1l30005O1`00`00O1al70020002O1<00`00O1=l4`03O1<2
00000g`B00000002O0X00`00O0Ul2@03O0T30005O0000`00O01l0003O0030004OD02000UOol002Yo
o`8000aoo`030003?`<o00<3?`<000D3G`030002_`:o00<2_`8000D2g`030002?`8o00<2?`8000D2
O`8000<1_`@000@1o`0300017`4O00<17`<000@1O`030000G`1O00<0G`03000P7b0O008P7`03001H
7ePO009H7`03001l5g`G009l5`03001l07`000=l008000E7h0030007h0OP00<7h0<000@3g`060000
_`2o0;l0002O0P0013@O00@0030O000000AX7`03001P7f0O0080009l7003001l77`L00=l70<000Al
4`03001l4g`C00=l4`<000El2P03001l2G`90080009l0@03001l07`000=l0003001l07`000<0009m
0003001m@7e0009m@0<002Aoo`00:Woo00<007ooOol037oo00<000<o0cl00P000P?O00<000=O0el0
10=O00<000:o0[l00P0000<3O`000]l01@;O00<0008o0Sl00P0000<37`000Wl01@9o10000`:o00<0
007o0Ol00`7o00<0004O0Al00P000P9o00<0005o0Gl00`5o00@0001O05l0G`X0009H7`05001l5g`G
O1L00004O0020006An000`001n07h00300020o/01@000ml3g`?O00001@2o00<003@O=1l01C@O00<0
06POJ1l01FPO0P001G`L00<007`LO1`00P0000=l4`00O1<01G`C00<007`CO1<00P000W`;0P0017`:
0`001G`100@007`0O01l00@000Em0003001m@7e00080009n@08002=oo`00:Woo00<007ooOol03Goo
0P001@?O00<000=O0el00`=O0`0010=o0P000`;O100010<O0P000P9o0P000P=o00<000:o0[l00`:o
00@0007o0Ol1o`@000@2O`030001O`5o00<1O`@000<2G`050001G`5O0El0000211l50002O1L01P00
O0000000?n0000I7h0<00087h0050003n`?k0o/000020ml00`000;l0_`020;l00`00@1l00004=1l2
00000g0O001X7`03J1l30007O1`20004O1<00`00O1=l4`03O1<30004O0/2000017`:000000000W`2
00<007`1O0400g`110000gcP00<007d0O@000gd00`0017i00P008goo000YOol00`00Oomoo`0?Ool0
0`000ml3g`040ml00`000el3G`0200020ol00`000gl3O`030gl400030kl00`000al37`030al30004
0gl00`000[l2_`030[l400030cl00`000Wl2O`030Wl00`000Gl1O`0200020el00`000Ul2G`020Ul0
0`000El1G`020El01@0011l47`@O00000T@O10000coP00@004OPAn17h0@000<7h0030003n`?k0083
n`030003g`0000@0_`0400107d0O0002=1l20003L1l00`00J1mX7`020003O1X00`00O1al7002O1`3
0005O1<00`00O1=l4`030002O0`00`00O0]l2`02O0/30005O0800`00O05l0@0300000gbP001lh004
O>000`00O@1m00030002OP000`00OT1n@002OT03000<Ool4000BOol002Uoo`80015oo`8000<3g`@0
00D3o`030003O`=o00800083o@030003_`>o00<3_`0300037`<O00800083o`030003O`=o00<3O`03
0002_`:o00800083o`030003?`<o00<3?`040002O`9o0Wl400040el00`000Ul2G`030Ul01@000El1
G`5O000010@O00D004@OA1m47`0000@oh0@000=7h0040007h0OP00060o/00`000;l0_`020;l00`00
@1m07`02@1l20005L1l30005O1X00`00O1al70020003O1<00`00O1=l4`02O1<30005O0`00`00O0]l
2`020002O0@20004O0830005O:000`00O>1lh002O>030005OP000`00OT1n@0020002Od02000;Ool0
0`00Oomoo`0COol002Uoo`03001oogoo019oo`<000<3n`030003o`?o00<3o`<000@3o@030003_`>o
00<3_`<000@3o`030003O`=o00<3O`<000@3o`030003?`<o00<3?`@000<3o`030003G`=O00<3G`03
0002G`9O0082G`030001G`5O0081G`0500047`@O11l00003A1l00`00?n0oh0030006An0010001n07
h0001@?k00<0001o00000P2o00<0040O@1l00T0O00@007`N0000009`7`80009l6003001l6W`J00=l
6P<000El4`03001l4g`C0080009l3003001l37`<00=l30<000El10800003O0800000009lP003001l
X7bP00=lX003001lh7cP0080009m`003001n07h000=n00<000Ao@08000aoo`03001oogoo019oo`00
:Goo00<007ooOol04goo00<000?k0o/00`?k00<000?o0ol00P000P?i00<000?m0od00`?m00<000>o
0kl00P000P?j00<000?o0ol00`?o00<000=o0gl00P000P?k00<000?o0ol00`?o00<000<o0cl00P00
0P?j00<000?o0ol00`?o00@000=O0el3G`T00081G`0500047`@O11l00003A1l30002?n000`00An17
h005An0200060o/01@0007l0002o00000d0O0P0017`N0P001G`H00<007`JO1X00P000W`B00<007`C
O1<00g`C0`001G`<00<007`<O0`00P000W`400<007`4O0@00g`40`0017b000<007bPO:000gbP0`00
1Gg000<007h0OP000P0000=o0000Od001Gm00P0017oo100017oo00<007ooOol04Goo000YOol00`00
Oomoo`0DOol010000o/3n`?k10001@?i00@000?m0od3o@@000D3nP040003o`?o0ol400050o/01000
0ol3o`?o100010?j00<000?o0ol00`?o10000`?e00<000?i0oT00P?i0`0000@1G`0011l47`D000@o
h0030017h4OP00E7h08000D3n`040000O`1o07l20002@1l00`00O1il7P02O1h200000g`D001l6004
O1P30005O1800`00O1=l4`020002O0/00`00O0al3003O0`30005O0@00`00O0Al100200000ga00000
0005O8000`00O:1lX0020002OJ000`00OL1m`003OL030004O`000`00Od1o@003Od030009Ool01000
Oomoo`004Woo000YOol2000FOol300030oD00`000oT3n@040oT300030oH00`000oX3nP030oX40003
0oH00`000o/3n`030o/400030oD00`000oX3nP030oX00`000ol3o`0200020o400`000oD3m@020oD0
0`000oT3n@020oT00`000oh3oP060002A1l00`00?n0oh002?n000`00An17h005An000`000o/3n`04
0o/0100007l0O`000U`O0`000W`N0P0017`D00<007`HO1P00P000W`@00<007`BO1800g`B0`001G`;
00<007`<O0`00P000W`500<007`4O0@00g`40`0017a00P0017b00`0017fP00<007g0OL000`000Wk0
00<007l0O`000Wl000<007m0Od000`000WOP00<007ooOol027oo0P004goo000YOol00`00Oomoo`0F
Ool00`000oD3m@030oD200020oT200000`?b0003mP040oH00`000oX3nP0200020o800`000oH3mP03
0oH00`000o/3n`0200020o400`000oD3m@030oD010000oX3nP?j100010?a00<000?e0oD00`?e00<0
00?i0oT00P?i1@000P@O00@004@OA1l000@oh0030017h4OP00E7h0030003n`?k00<3n`050000O`1o
07l00002G1l00`00O1Ml5`020006O1@30005O1000`00O19l4P020002O0/00`00O0]l2`03O0/30004
O0D00`00O0Al10030002O2000`00O41l@002O402000017b0000000000WeP00<007fPOJ000WfP0`00
1Gk000@007l0O`1o00@000Egh08001ioo`008Goo1@000Woo00<007ooOol067oo00<000?e0oD00`?e
0`0010?b00<000?f0oH00`?f0P001@?b00@000?f0oH3mP@000@3l@030003m@?e00<3m@@000<3k@03
0003l@?a00<3l@040003m@?e0oD700030oh200001@@O00147d@O00001CoP00<004OPAn0014OP0P00
10?k00D0001o07l005`O0080009l5`800003O0h00000009l5080009l3@03001l47`@00=l40<000Al
2`03001l2g`;00<0009l1@03001l1G`5009l1@<000El8004001l@7a0O4040005OF000`00OJ1mX002
0002OX000`00O/1n`003O/040003On000`00Mn1gh003Mn03000MOol002=oo`03001oogoo009oo`03
001oogoo01Uoo`030003m@?e00800083kP030003lP?b00<3lP030003mP?f008000030nh000?b00D3
lP<000<3k@030003l@?a00<3l@030003m@?e00800083j@030003k@?]00<3k@040003l@?a0o450002
0n<700020oh30002A1l00`00?n0oh003?n000`00An17h004An0200030o/0100007l0O`1o0P000W`G
0P0017`>0`0017`=00<007`@O1000`000W`900<007`;O0/00W`;0`001G`500<007`5O0D00P000W`0
00<007`PO2000g`P10000gdP0P0017eP0`0017j000<007k0O/000`0000=o`000On0017oP00<007OP
Mn000`000U?P00<007ooOol06goo000SOol00`00Oomoo`02Ool00`00Oomoo`0JOol200050nh01000
0o83lP?b100010?^0P000P?b0P0000<3j@000nd010?]00@000?a0o43l@@000D3j@040003k@?]0nd5
00030n8400000`?S0003i0030n@400001@=o000004@O00001CoP00<004OPAn0014OP0P000`?k00<0
001o07l01@000g`>0`000W`900<007`=O0d00W`=0`001G`900<007`;O0/00P000W`500<007`5O0D0
0g`50`001G`000<007`PO2000P0000=lh000OB001GdP0P0000=mH00000000Wi000<007j0OX000Wj0
0`001Go000<007oPOn000WoP0`001E?P0P0077oo000SOol00`00Oomoo`02Ool2000LOol00`000nh3
kP030nh400030nX00`000nh3kP030nh300040nT00`000nd3k@030nd300030nH00`000nT3j@030nT4
00030n000`000n83hP0400040n<00`000n@3i0020n@020000nD000000gl004@O0005?n000`00An17
h003An001P000o@3m0000o/000<0O`<0009l1`<000El2@03001l3G`=0080009l2003001l2G`900=l
2@<000El1@03001l1G`50080009l0003001l07`000=l00<000Alh003001m87dP00=m80<000An@003
001nP7j00080009oH003001o`7o000=o`003001oh7oP0080009Oh003001Ch5?P00=Ch0<001]oo`00
8goo00<007ooOol00Woo00<007ooOol077oo00<000?^0nh00P000P?V00<000?Z0nX00`?Z00<000?^
0nh00P000P?U00<000?Y0nT00`?Y00<000?]0nd00P0000<3h`000nH010?V00<000?Y0nT00P000P_P
00<000?P0n000P?P0`000P?R3P0000D3i@0000147`0000Doh0030017h4OP00=7h0060003m0?d0003
n`000P1o0P000W`70P000W`400<007`9O0T00g`90`001G`800<007`9O0T00P000W`400<007`5O0D0
0g`50`0017`000<007`0O0000`0000=l`000O>0017cP00<007dPOB000`000Wh000<007i0OT000Wi0
0`0017mP00<007o0Ol000go00`0015oP00<005?PDn000`000RoP00<007ooOol06Goo000ROol20004
Ool00`00Oomoo`0MOol200050nH010000nX3jP?Z10001@?U00@000?Y0nT3j@@000@3h`040003iP?V
0nH400042n000`000n00000200000`?P000000020003<n000`00<n0ch002<n000`00=n0gh002=n04
0002A1l00`00?n0oh002?n000`00An17h003An001@000o@3m0?d00000`1o10001G`400<007`9O0T0
0P000W`500<007`8O0P00g`80`001G`400<007`5O0D00P000W`000<007`0O0000W`00`001Gc000<0
07cPO>000WcP0`001Gh00P0000=n@00000000WlP00<007mPOf000gmP00<007o0Ol000P000VOP00<0
05oPGn000UoP0`001BoP0P006Woo000WOol00`00Oomoo`0OOol00`000nH3iP040nH300030n800`00
0nD3i@030nD400030n000`000n<3h`030n<300034n0010002n0;h0_P0`000P?P0P000S?P00<003?P
<n000c?P00<003?P<n000S?P00@003OP=n0gh0@000947`03000oh3oP008oh0030017h4OP00=7h004
0003m0?d0o@200000`1o00000002O0000`00O0Al1003O0@30005O0D00`00O0Ql20020002O0@00`00
O0Al1003O0@30004O0000`00O01l00020002O:000`00O<1l`003O<000`00O>1lh0020002OJ000`00
OP1n0003OP030004Ob000`00Of1oH002Of040004In000`00Gn1Oh0020002=n000`00;n0_h003;n02
000JOol002Moo`80025oo`800083iP8000031n0000?R00@3hP030003i@?U0080008?h0030003h0?P
00<3h0030003h`?S008000037n0001?P00@Ch0<000032n000000008000@ch003000ch3?P00<ch0T0
00=ch00400147d@O0004?n000`00An17h003An001P000o@3m0?d00007`8000Al0003001l17`40080
009l0`03001l1G`500=l1@<000El1003001l17`40080009l0003001l07`0009l00<000ElX004001l
`7c0O<040005OJ000`00OP1n00020002O/000`00Ob1o8002Ob050003Ln000`00In1Wh002In030004
=n000`00;n0_h00300000`?P0000000IOol002Moo`03001oogoo029oo`8000@7h0040003hP?R0n84
00053n0010000n03h0?P100011oP2@000c_P00<003?P<n000c?P00<003?P<n000P000V?P00<006_P
Jn000V_P0P000g?P0P0000=47`00?n000coP00<004OPAn000dOP00D000?d0o@3m00000807`04001l
07`0O0040005O0<00`00O0El1@020002O0800`00O0Al1003O0@30004O0000`00O01l00020002O600
0`00O:1lX003O:040003OF000`00OJ1mX003OJ030004O/0200000glP00000002On000`00Ln1ch003
Ln000`00In1Wh0020002@n000`00=n0gh002=n0300050n02000HOol002Moo`03001oogoo02=oo`03
0007h0OP00<7h0<000<Kh003000?h0oP00<?h0@000<Wh003000Oh1oP008Oh0D0008oh003000kh3_P
00<kh004000ch3?P<n040005Hn001000Jn1[h6_P1@0000Ao0000A1l000@oh0030017h4OP00=7h004
0003m0?d000301l40003O0020003O0<40004O0800`00O0Al10030002O0000`00O01l0002O0030005
O6000`00O:1lX00200000gdP001mH004OF000`00OJ1mX0030002OV000`00O/1n`002O/030004On00
0`00Ln1ch003Ln030004@n000`00=n0gh00200023n000`000n03h0030n02000HOol000moo`<001Eo
o`03001oogoo02Aoo`030007h0OP008000039n0001_P00@Kh003000?h0oP0080008ch003000Wh2OP
00<Wh0D00097h003000oh3oP008oh004000kh3_P>n050003Hn000`00Hn1Sh003Hn040003Od001P00
O`1o0000A1l000@oh0030017h4OP00=7h0040003m0?d000301l00`00O6000005O0040003O0401000
O09l0W`210001G`000<007`0O0000P000Wa000<007aPO6000gaP0`0017dP00<007ePOF000WeP0`00
1GiP00<007k0O/000P0000=oP00000001GoP00<007?PLn000P000U?P00<004?P@n000T?P0`001@oP
00@000?P0n03h0@001Moo`004Woo00<007ooOol04Woo0P009Woo0P0012OP00<001_P6n000a_P0P00
1C?P00<002OP9n001@0014OP00<003oP?n000coP0`000fOP00<006?PHn000f?P00<006?PHn000P00
0Wn000<007m0Od000Wm000H007l0O`0004@O0004?n000`00An17h002An001@000o@3m0?d00000P0O
00D007aPO61lH000009l0080009l0003001l0G`1009l0@@000=l0003001l07`000=l00<000El@003
001lH7aP00800003O@0007dP00Am8003001mH7eP0080009n8003001nH7iP00=nH0<000AoP08000Ao
h0<000ACh0030013h4?P0080008Oh003000?h0oP00<?h0@000<3j`8001Ioo`000Woo0P0000Eoo`00
000007oo00D0009oo`<001=oo`8002Qoo`03000Wh2OP00<Wh003000Kh1_P00800003>n0003?P00@c
h0@000=?h0030017h4OP00=7h003000oh3oP00800003In0006OP00AWh004001Sh6?PHn040005Oh00
1000Od1o@7m0100000=47`00?n000coP00<004OPAn000TOP00D000?d0o@3m00000807`03001lH7aP
00@000Al0003001l0G`10080009l0003001l07`000=l0003001l07`00080009l@003001l@7a000=l
@0<000Am0003001m87dP009m80<000En8003001nH7iP00800003Ob0007n000AoP003001oh00000<0
009Sh003001Ch5?P009Ch0<000@Oh003000?h0oP00<000030nP000?[00@3j`8001Ioo`000Woo00D0
07ooOomoo`00009oo`@0009oo`04001oogoo000COol00`00Oomoo`0XOol010009n0Wh2OP100013_P
00<003?P00000P000UOP00<004oPCn000doP00@004OPAn17h0@000AWh004001Wh6OPIn050003Oh00
0`00Oh1oP003Oh040002OT0200000d@O000oh003?n000`00An17h002An001@000o@3m0?d00000P0O
0`000g`P00<007`0O0000W`00`001G`000@007`0O01l00@000El@003001l@7a00080009l`003001m
07d0009m0003001m87dP0080009m`003001n87hP00=n80<000Ao8003001oP7n0009oP0@000ASh003
001Ch5?P0080008_h003000Oh1oP008Oh0<000D3j0030003j`?[0083j`<001Eoo`000Woo00D007oo
001oo`0000Eoo`04001oogoo0002Ool00`00Oomoo`0AOol00`00Oomoo`0YOol30003An001000>n0k
h3_P10001EOP00@004oPCn1?h0D000=_h003001Wh6OP00=Wh0<000=oP003001oP7n000=oP003001o
P7n00080009nH003001n@7i0009n@00300147`0000@oh0030017h4OP0097h0040003m0?d000301l2
0004O2000`00O01l00020002O0000`00O01l0003O0040003O2000`00O41l@003O4030004O<001000
O@1m07d010001Gg000<007hPOR000P000Wk000<007lPOb000WlP00<007n0Oh000P000W?P0P0016?P
0`0012oP00<001oP7n000P0000<3i0000nP01@?X00<000?[0n/00P000P?i0P0057oo0002Ool20000
0goo00000003Ool30003Ool4000BOol00`00Oomoo`0ZOol00`00An17h003An0500000eoP001Gh005
En030003Ln000`00Kn1_h003Kn000`00In1Wh00200000gn0001oP004Oh001000Oh1oP7n0100017iP
00@007i0OT1n@0800003A1l003oP00<oh0030017h4OP0097h0040003m0?d000301l20003O2040005
O0000`00O01l00020002O0000`00O21l8002O2000`00O41l@0030002O8000`00O<1l`002O<040003
OF000`00OL1m`003OL030004O/001000Ob1o87lP10001G?P0P0000ESh0000013h00000H_h08000@3
i0030003j0?X00<3j0<000@3n@8001Aoo`000Woo0P0000=oo`0000007goo0P00;7oo00<004OP0000
1@0015oP0P000UOP0P0000=kh000Ln0017?P00@006oPKn1_h0@000AoP004001oP7n0Oh050003OV02
0003OV04000017eP00147`001CoP00D004OPAn17h0000083m00600007`0O01l007a00`000g`000<0
07`0O0000g`00`0017`000@007`PO21l80@000ElP003001l`7c000800003OB0007eP00AmH003001m
`7g000<0009n@003001n`7k0009n`0@000=oh003001ch7?P00=ch0<000A3h004000_h2oP;n030005
0n@00`000nP3j00300020oL00`000oT3n@020oT3000COol0009oo`800004Ool00000000NOol00`00
Oomoo`0ZOol50003In000`00Gn1Oh003Gn030004Nn001000Ln1ch7?P1@000gmP00<007n0Oh000gn0
0`000giP00<007iPOV000giP10000WeP00@007ePOF1mH08000Doh0050017h4OPAn0000020o@00`00
01l07`0300000g`0001l0004O0000`00O01l00020002O0000`00O01l0003O0030003O6000`00O81l
P003O8030004OB000`00OF1mH002OF030005OT000`00O/1n`00200000gmP001oh004On000`00Ln1c
h003000015_P0013h0000d?P00@002oP000000<7h0030003i0?T0083i0<000D3m`030003n@?i0080
0082g`80019oo`009Woo00<007ooOol09goo0`000goo00<006OPIn000fOP00<005oPGn000P000WoP
00<007_PNn000g_P0`000gm000<007mPOf000gmP00<007n0Oh000P0000=nH000OV0017iP00<007iP
OV000P000Wf000<007ePOF000WeP00<007ePOF000P001CoP00D004OPAn17h0000083m00400007`0O
0004O0001000O01l07`010001G`000<007`0O0000P0000=l8000O60017aP00<007b0O8000P000WcP
00<007dPOB000WdP00<007ePOF000P000WgP00<007i0OT000gi00`0017mP00<007oPOn000WoP0`00
1E_P0P000d?P0P001@OP00<000?T0n@00P000P?d00<000?g0oL00`?g0`0010;O0P004Woo000UOol0
0`00Oomoo`0VOol20007Ool01000In1Wh6OP10001GoP00<007_PNn000P0000=o0000Od0017m000@0
07mPOf1oH0@000AnH004001nH7iPOV040004OH001000OF1mH7eP1P001CoP00@004OPAn000083m005
00007`0O01l00004O0040003O0000`00O01l0003O0030003O2000`00O61lH003O6030004O>001000
OB1m87dP10001GgP00<007i0OT000P0000=nh000Of0017mP00<007oPOn000P000VoP00<005_PFn00
0e_P00<004?P00000P000R?P00<000OP1n000POP0`0010?d00<000?g0oL00`000P:o00<000;O0]l0
0P;O0`004Goo000UOol3000SOol3000:Ool30003Oj020003On040004O`001000Od1o@7m01@000gi0
00<007iPOV000WiP10000gf000<007f0OH000gf00`000gbP0`001CoP00@004OPAn000083m0050000
7`0O01l00002O0020002O0400`00O01l0003O0000`00O01l00020002O0000`00O21l8002O2000`00
O61lH0020002O8000`00O>1lh002O>040003OH000`00ON1mh003ON030004O^000`00Of1oH002Of03
0004Kn000`00Fn1Kh003Fn0400038n000`001n07h00200000`?]0003m0050o@200050[l00`000]l2
g`0200020;l00`00Oomoo`0?Ool002Eoo`03001oogoo021oo`<000ioo`03001oX7nP00=oX0@000=n
h003001o07l000=o00<000=n8003001n@7i0009n@003001nH7iP0080009mH003001mP7f000=mP003
001mP7f000800003O:0007bP00AlX08000Doh0040017h4OP00020o@0100001l07`0O0`001G`100@0
07`0O01l00@000Al0004001l87`PO2040004O8000`00O>1lh0020002OB000`00OH1mP003OH000`00
ON1mh00200000giP001nh004O^000`00Of1oH0020002On000`00Kn1_h003Kn000`00Fn1Kh0020000
14?P000Sh00012?P0P0010?]00@000?d0o@3m08000030[l000:o00@2_`<000@0_`80011oo`007Goo
100017oo00<007ooOol07Goo0`004Woo00<007nPOj000P000WjP00<007kPO^000gkP00<007l0O`00
0P0000=n0000OR0017hP00@007i0OT1n@0<000EmH004001mP7f0OH040004O:001000O:1lX7bP0`00
1CoP00@004OPAn000083m00700007`0O01l007`200001G`110000g`100<007`0O0000W`010000ga0
00<007b0O8000Wb00`0017dP00<007f0OH000gf00`0017iP00<007kPO^000WkP0`0017oP00<006oP
Kn000foP0`0014?P00@002?P000Sh0<000D3k@040003m00000030[l00`000[l2_`030000101O0000
_`2o10004Goo000MOol00`00Oomoo`05Ool00`00Oomoo`0JOol3000FOol20005OZ001000O^1nh7kP
100017h000@007hPOR1n80D0009m@08000=mH0D000=lP003001lX7bP00=lX0<00003O000000000Do
h0040017h4OP00020o@0100001l07`000g`200<007`1O0400P000W`300<007`1O0400W`100<007`0
O0000P000W`000<007a0O4000Wa000<007b0O8000P000Wc000<007dPOB000gdP00<007f0OH000P00
00=mh000OV0017iP00<007kPO^000P000WmP00<007oPOn000goP00<006oPKn000P0000=Oh000@n00
14?P00@002?P000000<3h@030003k@?]00<3k@030002_`:o00@2_`8000@0G`<000Aoo`03001oogoo
00ioo`007Woo00<007ooOol017oo00<007ooOol05goo0`006Woo00<007jPOZ000gjP10000gg000<0
07h0OP000gh00`000gdP00<007e0OD000ge00`000gb000<007b0O8000gb000<007bPO:000P0000Al
0000O01l008000Doh0060017h4OP0003m0000`0O00<007`2O080100017`300@007`1O05l0@@000El
0004001l@7a0O4030004O<000`00OB1m8003OB030004ON000`00OV1nH002OV030005Of001000On1o
h7oP100015oP00<004?P@n000T?P0P000P?Q00@000?Q0n4000@3k@030002o`0000<2_`80000421l0
001O05l20007Ool00`00Oomoo`0>Ool001moo`03001oogoo009oo`8001Ioo`<001ioo`03001nX7jP
0080009mX003001m`7g000=m`003001n07h000800003O@0007dP00Am8003001m@7e000800003O400
07b000AlP004001lP7b0O8040004O0001000O00000001CoP00H004OPAn0000?d000301l30003O0@0
0`00O0=l0`02O0<40003O0800`00O01l0003O0040002O6000`00O<1l`003O<000`00OB1m80020002
OF000`00ON1mh002ON000`00OV1nH0020002O^000`00Of1oH003Of040002Mn000`00Gn1Oh003Gn00
0`00@n13h00200001C?P0003h@?Q00000P?Q00<000?]0nd00P000P;o00@000:o000000@87`8000Uo
o`03001oogoo00ioo`007Goo00@007ooOol000=oo`03001oogoo019oo`<0029oo`8000EmX004001m
`7g0OL040004O@001000OB1m87dP100017a000@007b0O81lP0D000=l0@03001l07`0009l00@000Do
h0060017h4OP0003m0000`0O0P0017`400<007`3O0<00P000W`400<007`2O0800g`200<007`0O000
0P0000=l0000O60017aP00@007c0O<1l`0@000AmH004001mh7gPON040004O^000`00Of1oH0030000
0go0001gh004Mn000`00Gn1Oh002Gn030004<n0010000n43h@000P?Q0P001@;o00<000PO21l00PPO
0P002goo00<007ooOol03Woo000NOol20004Ool00`00Oomoo`0?Ool3000VOol00`00OJ1mX003OJ04
0003O<000`00O@1m0003O@030003O2000`00O41l@003O4030003O0800`00O05l0@02O0400`00O01l
00020002O0H20005?n000`00An0000020o@01`0001l07`0O001l1P0000=l10<000El1004001l0W`2
O0840004O0000`00O61lH002O6040003O@000`00OF1mH002OF040003OT000`00O^1nh003O^020005
Ol000`00Mn1gh002Mn000`00Gn1Oh00200000e_P000ch004<n001`000n43h@?Q0003h@0000D2o`04
000X7`0021l2000=Ool00`00Oomoo`0>Ool002Aoo`03001oogoo00aoo`<002Yoo`03001mX7fP0080
009lX003001l`7c000=l`003001m07d000800003O00007`P00Al8003001l@7a000800003O0@007`2
00Al0P04001l0G`1O0430005O0H00`00?n0oh003?n000`00An0000020o@0100001l07`0O1P000W`7
00<007`4O0@00g`410000g`300<007`0O0000W`000<007aPO6000P0000=lP000O@0017d000<007eP
OF000P000Wg000<007i0OT000gi000<007kPO^000P0000=o@000Ol0017o000@007OPMn1gh0@000AK
h003000ch3?P00<ch0040003h@?Q0n4200050_l01000:1lX7`003goo00<007ooOol03Woo000TOol2
000;Ool2000^Ool20005O:001000O<1l`7c0100017`000@007`PO21l80@000Al1004001l0W`2O085
0002O0L20003O0H30004?n001@00An0000?d00000`0O0P000g`900<007`7O0L00W`700<007`4O0@0
0P0000=l1P00O0<017`300@007`0O01l00@000AlP003001m07d0009m00<000Am`003001n@7i000=n
@0<000=o@003001o`7o000=o`0@0009ch003001Kh5_P00=Kh003000ch3?P00<ch0030003h@?Q0080
00030Il000;o0082o`04000X7`00000@Ool00`00Oomoo`0>Ool002Aoo`03001oogoo00Moo`<0035o
o`8000=lX0D000=l0004001l07`0O0050003O0D00`00O0Al1002O0@40003O0T00`00O0Ml1`02O0L4
00000g`;00000004?n001@00An0000?d00000`0O00<007`9O0T00W`900@007`7O0Ml1`@000Al1P03
001l0g`3009l0`@000=l0003001lP7b0009lP003001m07d00080009m@003001m`7g000=m`003001n
@7i000800003O/0007m000Ao@003001o`7o000800003On0007?P00Ach003001Kh5_P009Kh003000c
h3?P00@ch0800081W`8000<2o`8001=oo`03001oogoo00eoo`008goo00<007ooOol01Goo0`00=Woo
0`000g`200<007`0O0000g`00`000g`700<007`5O0D00W`500<007`4O0@00P000W`;00<007`9O0T0
0W`900<007`7O0L00P000W`=00<007`;O0/00P0013oP00D004OP0003m00000<07`03001l2G`9009l
2@@000=l2@03001l1W`6009l1P03001l0g`30080009l1003001l07`0009l0004001lP7b0O8040004
OD000`00OL1m`003OL030004O/000`00Od1o@002Od030004On000`00Ln1ch002Ln000`00Fn1Kh003
Fn001000<n0ch3?P0`00106O0P0000<2o`00Ool057oo00<007ooOol03Goo000SOol00`00Oomoo`02
Ool3000jOol00`00O09l0P03O0800`00O01l000200000g`8001l1`04O0L01000O0El1G`50`001G`;
00@007`9O0Ul2@<000El3@04001l2`000005?n0200000`?d00007`0201l00`00O0Ul2@020002O0`0
0`00O0Ul2@02O0T01000O0Il1W`6100017`400<007`0O0000g`00`000gbP00<007e0OD000ge000<0
07g0OL000P0000=n@000O/0017k000<007m0Od000P000WnP00<007oPOn000WoP00@007?PLn1ch0/0
009oh0030001W`6O0081W`8000030_l007oo01Aoo`03001oogoo00eoo`008goo00<007oo00000P00
?Woo00@007`2O09l0P@000Al2004001l1g`7O0L50002O0d20003O0/50002O1000`00O0el3@03O0d4
0005?n03000013`O00007`0O0`001G`<00@007`9O0Ul2@@000=l2003001l17`400=l1003001l07`0
00800003O00007bP00=lX003001m@7e000=m@0<000An@003001n`7k0009n`0<000AoX004001oh7oP
On050003On000`00On1oh002On000`00On1oh002On000`000Il1W`030Il2000FOol00`00Oomoo`0=
Ool002=oo`80049oo`<000=l2P03001l27`800=l20<000=l3P03001l3G`=00=l3@<000=l4P03001l
47`@009l4003001l3G`=0080009l4`8000Doh0<00007?1l0000O01l007`?00001G`<10000W`;00<0
07`8O0P00g`800@007`4O0Al10@000=l0003001lX7bP00=lX003001m@7e000800003OJ0007i000An
@003001n`7k00080009oH003001oX7nP009oX0@000=oh003001oh7oP009oh003001oh7oP009oh003
001oh7oP009oh0030001W`6O00@1W`03001oogoo01Aoo`03001oogoo00eoo`0097oo00<007ooOol0
@Goo00<007`:O0X00g`:00<007`8O0P00P0000=l4000O0h017`>00<007`=O0d00P0000=l5000O180
0g`B00@007`@O11l40@000Al4`8000Doh08000<l7`8000=l3`03001l37`<00800003O0l007`;00=l
2`03001l27`800=l20@0009l1@03001l07`000=l0003001lX7bP009lX0<000AmX003001n@7i0009n
@0<000AoH003001oX7nP0080009oh003001oh7oP009oh004001oh7oPOn040003On000`00On1oh002
On000`000Il1W`030Il2000EOol00`00Oomoo`0=Ool002Eoo`80049oo`04001l2W`:O0X40004O100
1000O0il3W`>100017`D00@007`BO19l4P@000=l5P03001l4g`C00=l4`03000oh3oP00<oh08000<l
7`80009l3`@000Al3`03001l2g`;009l2`03001l27`800800003O0X007`500Al1@03001l07`0009l
0003001lX7bP00800003O>0007fP00AmX003001n@7i000800003O^0007mP00EoH08000Aoh004001o
h7oPOn050002Od060004On000`000Il1W`030Il2000EOol00`00Oomoo`0=Ool002Moo`03001oogoo
041oo`<000=l4P8000=l40@000=l5P04001l57`DO1@50002O1T00`00O1Il5P03O1H00`00O1=l4`03
0005?n020004?1l30003O1<00`00O0ml3`02O0l01000O0]l2g`;100017`:00<007`5O0D00W`500@0
07`0O01l00@000Alh003001mX7fP00=mX08000Anh004001oH7mPOf0200000goP001oh003On040003
On040005Ool20003On000`000Il1W`030Il00`00Ool0000EOol00`00Oomoo`0<Ool002Qoo`03001o
ogoo041oo`03001l4W`B00=l4P@0009l6003001l5W`F00=l5P<000=l6`03001l6G`I009l6@04001l
5W`FO1H40002O1T00`00?n0oh003?n000`00?1ll7`02?1l30004O1<01000O0ml3g`?1@000g`>00<0
07`:O0X00W`:00@007`5O0El1@D0009l0003001lh7cP00=lh004001mX7fPOJ030005O^001000Of00
00000goP00<007oPOn000P000W?P00<007oPOn000P002Woo00D007oPOn1oh00000D1W`04001oogoo
000DOol00`00Oomoo`0<Ool002Uoo`03001oogoo041oo`03001l4W`B0080009l6P03001l67`H009l
6003001l5W`F00800003O1h007`K00Al6`04001l6G`IO1T40003O1`01000O1Ul6@000coP0`0000@l
7`00000000=l5`04001l4g`CO1<40003O1800`00O0il3P02O0h01000O0Yl2W`:1@000g`700<007`0
O0000W`000<007cPO>000gcP0`000giP00<007kPO^000gkP00<007oPOn000goP0`0017?P0`003Goo
00@007oPOn0000D1W`05001oogooOol0000COol00`00Oomoo`0<Ool002Yoo`80045oo`8000Al6P04
001l67`HO1P40004O1h01000O1]l6g`K1@000W`O00<007`LO1`00W`L00<007`IO1T01@0000El6`00
001l6`0000=l5`D0009l5`03001l4W`B00=l4P04001l3W`>O0h40003O0d00`00O0Ml1`02O0L00`00
O01l0002O0000`00O>1lh002O>020005OV001000O^1nh7kP0P0000Aoh000On1oh080009Sh003001c
h7?P0080011oo`04001oh7oP00050Il01@00Oomoogoo00004goo00<007ooOol037oo000/Ool00`00
Oomoo`0oOol20003O1X40003O1l20003O1h40003L1l00`00O1ml7`02O1l01000O1al77`L0`001G`O
00@007`KO1]l6`@0009l6`03001l5g`G009l5`03001l4W`B00=l4P@0009l4P03001l3G`=009l3@03
001l1g`700=l1`03001l07`0009l0006001lh000001mH0001WiP0`0017oP0P001F?P0P004Woo00@0
07oPOn0000D1W`03001oogoo009oo`03001oogoo011oo`03001oogoo00aoo`00;Goo00<007ooOol0
@7oo0`000W@O00<007`OO1l00g`O10000V@O00<0070OL1l00W0O00@007`OO1ml7`D0009`7`03001l
7g`O00=l7`@0009l7`03001l6g`K009l6`03001l5g`G009l5`03001l4W`B00800003O1H007`B00=l
4P03001l3G`=00=l3@03001l1g`7009l1`04001l07`0O0030004OF000`00OV1nH003OV000`00On1o
h003On001000Cn0000000V?P0P0057oo00@007oPOn0000D1W`03001oogoo00=oo`03001oogoo00mo
o`03001oogoo00aoo`00;Woo00<007ooOol0@7oo00<007@OM1l00W@O00<007`OO1l00P000U`O00<0
06@OI1l00V@O00@0070OL1m`7`@000=P7`03001`7g0O009`7`03001l7g`O00800003K1l007`O00=l
7`03001l6g`K009l6`04001l5g`GO1L40004O1H00`00O19l4P02O1800`00O0el3@02O0d01000O0Ml
1g`71@0000=l0000OF0017eP00<007iPOV000WiP00<007oP00000goP00<004oPCn000ToP0P005goo
00@007oPOn0000<1W`03001oogoo00Aoo`03001oogoo00moo`03001oogoo00aoo`00;goo0P00@Goo
00@007@OM1md7`<000AL7`04001T7f@OI1l50002D1l00`00H1mP7`02H1l01000L1m`7g0O100016`O
00<007`OO1l00W`O00@007`KO1]l6`@000=l6P03001l5W`F009l5P03001l4W`B009l4P04001l3G`=
O0d50002O0/00`00O01l0002O0000`00OF1mH003OF001000OV1nH0000goP00<007oP00000doP0P00
6Goo00@007oPOn0000<1W`03001oogoo00Eoo`03001oogoo00moo`03001oogoo00]oo`00<Goo00<0
07ooOol0?goo0`000U0O0P000e`O10000d0O00<0050OD1l00U0O00@0060OH1mP7`@000=H7`03001/
7f`O009/7`04001l7g`OO1l50002O1h00`00O1Yl6P02O1X01000O1Il5W`F2P000W`C00<007`;O0/0
0W`;00<007`0O0000W`000<007ePOF000geP00<007iP00001GoP00<004oPCn000P006goo00@007oP
On0000<1W`03001oogoo00Ioo`03001oogoo00ioo`03001oogoo00]oo`00<Woo00<007ooOol0?goo
00<0050OD1l00e0O0`000S@O00<0040O@1l00T0O00@0050OD1m@7`D000907`03001H7ePO00=H7`04
001/7f`OK1l40003M1l00`00O1il7P02O1h01000O1Yl6W`J10000g`K00D007`GO1Ml5`0000El4`03
001l2g`;009l2`05001l07`0O0000006OF000`00On1oh003On001000>n0000007Goo00@007oPOn00
00<1W`03001oogoo00Moo`03001oogoo00eoo`03001oogoo00]oo`00<goo00<007ooOol0?goo00<0
050OD1l00P0000</7`00=1l00c@O00@0040O@1m07`@000</7`0300107d0O00907`04001H7ePOF1l5
0002G1l00`00M1md7`02M1l01000O1il7W`N1@000W`M00<007`KO1/00W`K00<007`GO1L00W`G00<0
07`CO1<00W`C00<007`;O0/00W`;00<007`0O0000W`000<007ePOF000WeP0P001GoP00<003_P0000
7goo00<007oP00000`6O00<007ooOol01goo00<007ooOol03Goo00<007ooOol02goo000dOol20010
Ool20004;1l01000=1ld7c@O10000Q`O00<002`O;1l00b`O00@0040O@1m07`@000907`03001L7e`O
009L7`03001d7g@O00=d7`<000=l7`03001l7G`M009l7@03001l6g`K009l6`05001l5g`GO1L00004
O1<00`00O0]l2`02O0/00`00O01l0002O0000`00OF1mH0020002Od001000On1oh7oP0`0087oo00<0
07oP00000`6O00<007ooOol027oo00<007ooOol037oo00<007ooOol02goo000fOol00`00Oomoo`0n
Ool01000;1l/7b`O1@000P`O00<001`O71l00Q`O00@002`O;1l/7`D0008P7`0300107d0O00907`03
001L7e`O009L7`03001d7g@O00800003L1l007`O00=l7`04001l7G`MO1d>0002O1<01@00O0]l2g`;
00001G`00P0017m000<007oPOn000P008Woo00<007oP00000`6O00<007ooOol02Goo00<007ooOol0
2goo00<007ooOol02goo000gOol00`00Oomoo`0nOol3000301l00`0031l<7`0231l0100071lL7a`O
10000`@O00D0020O81lP7`0000A07`04001L7e`OG1l40003L1l00`00O1ml7`03O1l30003O1l00`00
O1ml7`02O1l01P00O1ml7g`O001l7`@000=l2`04001l07`0O0020005Od001000On0000008goo00@0
07oPOn000081W`03001oogoo00Yoo`03001oogoo00]oo`03001oogoo00Yoo`00>7oo00<007ooOol0
?Woo00<0000O01l00P0O00@000`O31l<7`D00080W`0300047`@O00847`03000P7b0O008P7`040010
7d0O@1l40002F1l00`00L1m`7`03L1l00`00O1ml7`0200000g`O001l7`03O1l01000O1ml7g`O1@00
00Il7`00O1ml7`00O1X200000g`;001l000200000g`0001o@005Od02000UOol00`00On0000020Il0
0`00Oomoo`0:Ool00`00Oomoo`0;Ool00`00Oomoo`0:Ool003Uoo`8003moo`0400007`0O01l40003
0Al00`0009l0W`0209l0100011l47`@O2@000S0O00<005POF1l00UPO00<0070OL1l00W0O0`0017`O
00@007`OO1ml7`@000=P7`03001<7`000080009l7`03001l6W`J00<000=l0003001o@7m000Ao@003
001oogoo02Aoo`03001oh0000081W`03001oogoo00]oo`03001oogoo00Yoo`03001oogoo00Yoo`00
>goo00<007ooOol0?Goo0`000P5o0P000`4O2@000P6o00D0000o03l0?`0000@`7`03001H7ePO009H
7`03001`7g0O0080009l7`04001l7g`OO1l50002L1l;00000g`O001l6P02O1X00`00O01l0002O000
0`00Od1o@004Od000`00Oomoo`0TOol00`00On0000020Il00`00Oomoo`0<Ool00`00Oomoo`09Ool0
0`00Oomoo`0:Ool003aoo`03001oogoo03eoo`8000<1O`@00082o`030002W`:O0082W`050001_`6o
0Kl0000403l00`00<1l`7`02<1l00`00F1mH7`02F1l20005O1l30003O1l4000;Ool30002O1X00`00
O01l0003O0000`00Od1o@003Od000`00Oomoo`0TOol00`00On0000020Il00`00Oomoo`0<Ool00`00
Oomoo`09Ool00`00Oomoo`0:Ool003eoo`03001oogoo03ioo`<00083?`030002o`;o0082o`050002
W`:O0Yl000040Kl01@0003l0?`0o0000130O00<005POF1l00P0000=l7`00O1l00g`O00<007`JO1X0
10004Goo00@007`JO1X000El0003001o@7m000=o@003001oogoo02Eoo`800081W`03001oogoo00eo
o`03001oogoo00Qoo`03001oogoo00Yoo`00?Woo00<007ooOol0?Woo00<000<o0cl00P<o00@000;o
0_l2o`P000030Kl0000o0080?`03000`7c0O008`7`<000Al7`05001l7`00001l6P02000FOol01000
O1Yl6P0017`000<007m0Od000gm000<007ooOol09Goo0P000P6O00<007ooOol03Woo00<007ooOol0
1goo00<007ooOol02Woo000oOol2000nOol010000cl3?`<o1@000P?e00H000?e0oD3m@000oL40002
03l01P00<1l00000O1l000Il7`@001Qoo`04001l6W`J0004O0000`00Od1o@002Od000`00Oomoo`0V
Ool01@00On00006O00004Goo00<007ooOol01goo00<007ooOol02Goo0011Ool00`00Oomoo`0lOol3
00030oH01@000oD3m@?e000010?e00D000?g0oL000?/00@000Al7`03001l7g`O009l7`<001Yoo`04
001l6W`J0004O0000`00Od1o@002Od000`00Oomoo`0VOol01@00On00006O00004Goo00<007ooOol0
1goo00<007ooOol02Goo0012Ool00`00Oomoo`0lOol200030oH;00020oL010000n`3k0001G`O00<0
07`OO1l00`007Goo00<007`J000017`000<007m0Od000Wm000<007ooOol09goo0P0000<1W`00Ool0
4Goo00<007ooOol01Woo00<007ooOol02Goo0013Ool00`00Oomoo`0mOol300020nD200020n820003
2n000`000oL000020n`00`00O1ml7`04O1l3000OOol00`00O1X00004O0000`00Od1o@002Od000`00
Oomoo`0WOol3000DOol00`00Oomoo`05Ool00`00Oomoo`09Ool004Aoo`8003ioo`040003i@?U0nD9
00000goo000000020n`00`00O1ml7`04O1l00`00Oomoo`0OOol00`00O1X00004O0000`00Od1o@002
Od000`00Oomoo`0WOol3000EOol00`00Oomoo`04Ool00`00Oomoo`09Ool004Ioo`03001oogoo03ao
o`<000]oo`8000030n`007`O00El7`03001oogoo01moo`03001l6P0000El0005001o@7m0Od00000Y
Ool3000EOol00`00Oomoo`04Ool00`00Oomoo`09Ool004Moo`03001oogoo03]oo`03001oogoo00ao
o`030003k00000Il7`03001oogoo021oo`8000El0005001o@7m0Od00000ZOol2000FOol00`00Oomo
o`03Ool00`00Oomoo`09Ool004Qoo`03001oogoo03Yoo`03001oogoo00aoo`030003k00000Il7`03
001oogoo021oo`03001l6P0000Al0005001o@7m0Od00000ZOol2000GOol00`00Oomoo`03Ool00`00
Oomoo`08Ool004Uoo`8003Yoo`03001oogoo00aoo`030003k00000El7`03001oogoo025oo`03001l
6P0000Al0005001o@7m0Od00000ZOol2000GOol00`00Oomoo`03Ool00`00Oomoo`08Ool004]oo`03
001oogoo03Moo`03001oogoo00aoo`030003k00000El7`03001oogoo025oo`03001l6P0000Al0005
001o@7m0Od00000ZOol2000HOol00`00Oomoo`02Ool00`00Oomoo`08Ool004aoo`03001oogoo03Io
o`03001oogoo00eoo`8000El7`03001oogoo025oo`03001l6P0000Al0004001o@7m0000/Ool00`00
Oomoo`0GOol01@00Oomoogoo00002Woo001=Ool00`00Oomoo`0eOol00`00Oomoo`0=Ool00`000n`0
0004O1l00`00Oomoo`0ROol20004O0001000Od1o@000;7oo00<007ooOol067oo00@007ooOol000Yo
o`00CWoo0P00=Goo00<007ooOol03Goo00<000?/000017`O00<007ooOol08Woo0P0017`000@007m0
Od0004Moo`04001oogoo000:Ool0051oo`03001oogoo039oo`03001oogoo00eoo`030003k00000Al
7`03001oogoo029oo`8000El0003001o@00004Qoo`03001oo`0000Yoo`00DGoo00<007ooOol0<Goo
00<007ooOol03Goo00<000?/00000g`O00<007ooOol08goo0P001G`000<007m00000BGoo00<007oo
00002Goo001BOol00`00Oomoo`0`Ool00`00Oomoo`0=Ool00`000n`00003O1l00`00Oomoo`0TOol2
0004O0000`00Od00001:Ool20009Ool005=oo`80031oo`03001oogoo00eoo`030003k00000=l7`03
001oogoo02Aoo`8000Al0003001o@00004Yoo`8000Uoo`00EGoo00<007ooOol0;Goo00<007ooOol0
3Goo00<000?/00000g`O00<007ooOol097oo0P0017`000<007m00000BWoo0P002Goo001FOol00`00
Oomoo`0/Ool00`00Oomoo`0>Ool20003O1l00`00Oomoo`0TOol20004O0000`00Od000016Ool4000;
Ool005Moo`03001oogoo02]oo`03001oogoo00ioo`8000=l7`03001oogoo02Aoo`8000Al0003001o
@000049oo`@000moo`00F7oo0P00:goo00<007ooOol03Woo0P000g`O00<007ooOol09Goo00<007`0
O0000W`00P00?goo10004goo001JOol00`00Oomoo`0XOol00`00Oomoo`0>Ool20002O1l00`00Oomo
o`0VOol00`00O01l0003O0000`00Oomoo`0iOol4000GOol005]oo`03001oogoo02Moo`03001oogoo
00ioo`80009l7`03001oogoo02Ioo`03001l07`000=l0003001oogoo03Eoo`@001]oo`00G7oo00<0
07ooOol09Woo00<007ooOol03Woo0P000W`O00<007ooOol09Woo0P0017`000<007ooOol0<Woo0`00
7goo001MOol2000VOol00`00Oomoo`0>Ool20002O1l00`00Oomoo`0WOol01000O01l07`00P00<7oo
10008Woo001OOol00`00Oomoo`0SOol00`00Oomoo`0>Ool20002O1l00`00Oomoo`0WOol01000O000
0000;Woo10009Woo001POol00`00Oomoo`0ROol00`00Oomoo`0?Ool01000O1ml7`00:Goo0P00;7oo
1000:Woo001QOol00`00Oomoo`0QOol00`00Oomoo`0?Ool01000O1ml7`00Dgoo1000;Woo001ROol2
000QOol00`00Oomoo`0?Ool00`00O1l0001@Ool4000bOol006Aoo`03001oogoo01ioo`03001oogoo
00moo`<004aoo`@003Ioo`00IGoo00<007ooOol077oo00<007ooOol047oo0`00BGoo0`00>Woo001V
Ool00`00Oomoo`0KOol00`00Oomoo`0@Ool30015Ool4000mOol006Moo`8001]oo`03001oogoo011o
o`<0045oo`@0045oo`00JGoo00<007ooOol067oo00<007ooOol047oo0`00?Goo1000AGoo001ZOol0
0`00Oomoo`0GOol00`00Oomoo`0AOol00`00Oomoo`0hOol40019Ool006]oo`03001oogoo01Ioo`03
001oogoo015oo`03001oogoo03Aoo`@004eoo`00K7oo00<007ooOol05Goo00<007ooOol04Goo00<0
07ooOol0<Goo0`00DGoo001]Ool2000EOol00`00Oomoo`0AOol00`00Oomoo`0]Ool4001DOol006mo
o`03001oogoo019oo`03001oogoo03eoo`@005Qoo`00L7oo00<007ooOol04Goo00<007ooOol0>Goo
1000G7oo001aOol00`00Oomoo`0@Ool00`00Oomoo`0eOol4001POol0079oo`80011oo`03001oogoo
035oo`@006Aoo`00M7oo00<007ooOol03Goo00<007ooOol0;Woo0`00J7oo001eOol00`00Oomoo`0<
Ool00`00Oomoo`0ZOol4001[Ool007Ioo`03001oogoo00]oo`03001oogoo02Ioo`@006moo`00Mgoo
0P002goo00<007ooOol08Woo1000Lgoo001iOol00`00Oomoo`08Ool00`00Oomoo`0NOol4001gOol0
07Yoo`03001oogoo00Moo`03001oogoo01Yoo`@007]oo`00Ngoo00<007ooOol01Woo00<007ooOol0
5Woo1000Ogoo001lOol20006Ool00`00Oomoo`0COol30023Ool007ioo`03001oogoo00=oo`03001o
ogoo00moo`@008Ioo`00Ogoo00<007ooOol00Woo00<007ooOol02goo1000RWoo0020Ool01@00Oomo
ogoo00002Goo1000SWoo0021Ool200000goo001oo`04Ool4002BOol008=oo`800003Ool000000080
09Ioo`00Q7oo0P00VWoo003oOolQOol00?moob5oo`00ogoo8Goo003oOolQOol00?moob5oo`00ogoo
8Goo003oOolQOol00?moob5oo`00ogoo8Goo003oOolQOol00?moob5oo`00ogoo8Goo003oOolQOol0
0?moob5oo`00ogoo8Goo0000\
\>"],
  ImageRangeCache->{{{0, 287}, {232.563, 0}} -> {-0.139834, -0.0149666, \
0.0039261, 0.0039261}},
  CellTags->{"Pole-Zero Plot", "i:12", "b:20.4"}],

Cell[BoxData[
    TagBox[\(\[SkeletonIndicator]  SurfaceGraphics  \[SkeletonIndicator]\),
      False,
      Editable->False]], "Output",
  CellLabel->"Out[141]=",
  CellTags->{"Pole-Zero Plot", "i:12", "b:20.4"}]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["The Linear Quadratic Regulator Problem", "Section",
  Evaluatable->False,
  AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["Introduction", "Subsection",
  Evaluatable->False,
  AspectRatioFixed->True,
  CellTags->{"Introduction the linear", "b:21.0"}],

Cell["\<\
We will illustrate three functions used for solving the linear quadratic \
regulator design problem. The main tool is a function which solves the \
algebraic Riccati equation which is then used to obtain the optimal state \
feedback controller and the optimal stochastic state estimator. \
\>", "Text",
  Evaluatable->False,
  AspectRatioFixed->True,
  CellTags->{"Introduction the linear", "b:21.0"}]
}, Open  ]],

Cell[CellGroupData[{

Cell["The Lyapunov Equation", "Subsection",
  CellTags->{"i:24", "LyapunovEquation", "b:21.1"}],

Cell[CellGroupData[{

Cell[BoxData[
    \(\(?LyapunovEquation\)\)], "Input",
  CellLabel->"In[142]:=",
  CellTags->{"i:24", "LyapunovEquation", "b:21.1"}],

Cell[BoxData[
    \("LyapunovEquation[A,Q] Returns the solution P of the Matrix\n Lyapunov \
equation\n       PA + A^TP = -Q\n Ordinarily, Q is a symmetric, positive \
semidefiite matrix. "\)], "Print",
  CellTags->{"Info3266692353-2707657", "b:21.1"}]
}, Open  ]],

Cell[BoxData[
    \(A = {{0, 1}, {\(-1\), \(-2\)}}; Q = IdentityMatrix[2];\)], "Input",
  CellLabel->"In[143]:=",
  CellTags->{"i:24", "LyapunovEquation", "b:21.1"}],

Cell[CellGroupData[{

Cell[BoxData[
    \(Eigenvalues[A]\)], "Input",
  CellLabel->"In[144]:=",
  CellTags->{"i:24", "LyapunovEquation", "b:21.1"}],

Cell[BoxData[
    \({\(-1\), \(-1\)}\)], "Output",
  CellLabel->"Out[144]=",
  CellTags->{"i:24", "LyapunovEquation", "b:21.1"}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(P = LyapunovEquation[A, Q]\)], "Input",
  CellLabel->"In[145]:=",
  CellTags->{"i:24", "LyapunovEquation", "b:21.1"}],

Cell[BoxData[
    \({{3\/2, 1\/2}, {1\/2, 1\/2}}\)], "Output",
  CellLabel->"Out[145]=",
  CellTags->{"i:24", "LyapunovEquation", "b:21.1"}]
}, Open  ]],

Cell["\<\
Since A has eignenvalues with negative real parts and Q is positive definite, \
we expact the solution P to be positive definite.\
\>", "Text",
  CellTags->{"i:24", "LyapunovEquation", "b:21.1"}],

Cell[CellGroupData[{

Cell[BoxData[
    \(Eigenvalues[P]\)], "Input",
  CellLabel->"In[146]:=",
  CellTags->{"i:24", "LyapunovEquation", "b:21.1"}],

Cell[BoxData[
    \({1\/2\ \((2 + \@2)\), 1\/2\ \((2 - \@2)\)}\)], "Output",
  CellLabel->"Out[146]=",
  CellTags->{"i:24", "LyapunovEquation", "b:21.1"}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(LyapunovEquation[A, IdentityMatrix[3]]\)], "Input",
  CellLabel->"In[147]:=",
  CellTags->{"i:24", "LyapunovEquation", "b:21.1"}],

Cell[BoxData[
    \("Arguments have incorrect dimensions."\)], "Print",
  CellLabel->"From In[147]:=",
  CellTags->{"i:24", "LyapunovEquation", "b:21.1"}],

Cell[BoxData[
    \({}\)], "Output",
  CellLabel->"Out[147]=",
  CellTags->{"i:24", "LyapunovEquation", "b:21.1"}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["The Algebraic Riccati Equation", "Subsection",
  Evaluatable->False,
  AspectRatioFixed->True,
  CellTags->{"The Algebraic Riccati Equation", "i:13", "b:21.2"}],

Cell["\<\
It is not our intent to duplicate the many efficient numerical solvers for \
the algebraic Riccati equation. The method of solution provided here gives \
infinite precision results when the data is provided in infinite precision \
(assuming the solution exists). Results of this type are interesting only for \
rather simple systems. And they are time consuming to obtain. Numerical \
results are produced - and much more quickly - when numerical data is \
provided. Consider the solution of the equation
\tPA + A'P - PUP + Q = 0
with the following data\
\>", "Text",
  Evaluatable->False,
  AspectRatioFixed->True,
  CellTags->{"The Algebraic Riccati Equation", "i:13", "b:21.2"}],

Cell[BoxData[
    \(A = {{0, 0}, {1, \(-\@2\)}}; U = {{1, 0}, {0, 0}}; 
    Q = {{0, 0}, {0, 1}};\)], "Input",
  CellLabel->"In[148]:=",
  PageWidth->Infinity,
  AspectRatioFixed->True,
  CellTags->{"The Algebraic Riccati Equation", "i:13", "b:21.2"}],

Cell["The result is obtained with", "Text",
  Evaluatable->False,
  AspectRatioFixed->True,
  CellTags->{"The Algebraic Riccati Equation", "i:13", "b:21.2"}],

Cell[CellGroupData[{

Cell[BoxData[
    \({P, Eigs} = AlgebraicRiccatiEquation[A, Q, U]\)], "Input",
  CellLabel->"In[149]:=",
  PageWidth->Infinity,
  AspectRatioFixed->True,
  CellTags->{"The Algebraic Riccati Equation", "i:13", "b:21.2"}],

Cell[BoxData[
    \("Hamiltonian has nonsimple divisors."\)], "Print",
  CellLabel->"From In[149]:=",
  CellTags->{"The Algebraic Riccati Equation", "i:13", "b:21.2"}],

Cell[BoxData[
    \("This could take a while."\)], "Print",
  CellLabel->"From In[149]:=",
  CellTags->{"The Algebraic Riccati Equation", "i:13", "b:21.2"}],

Cell[BoxData[
    \({{{\(2 + \@2\)\/\(3 + 2\ \@2\), 1\/\(3 + 2\ \@2\)}, {1\/\(3 + 2\ \@2\), 
          2\/\(3 + 2\ \@2\)}}, {\(-1\), \(-1\)}}\)], "Output",
  CellLabel->"Out[149]=",
  CellTags->{"The Algebraic Riccati Equation", "i:13", "b:21.2"}]
}, Open  ]],

Cell["\<\
The matrix P is the solution of the Riccati equations and the list Eigs \
contains the eigenvalues of the associated Hamiltonian matrix that have \
negative real parts (the \"closed loop\" eigenvalues. Notice that the results \
are indeed given in infinite precision. Also, a message is received \
indicating that the Hamiltonian matrix has an incomplete set of eigenvectors \
so that a more time consuming method must be used. Consider another set of \
data\
\>", "Text",
  Evaluatable->False,
  AspectRatioFixed->True,
  CellTags->{"The Algebraic Riccati Equation", "i:13", "b:21.2"}],

Cell[BoxData[{
    \(\(A2 = {{0, 1, 0}, {0, 0, 1}, {0, 0, 0}};\)\), "\n", 
    \(\(Q2 = {{1, 0, 0}, {0, 0, 0}, {0, 0, 0}};\)\), "\n", 
    \(\(U2 = {{0, 0, 0}, {0, 0, 0}, {0, 0, 1}};\)\)}], "Input",
  CellLabel->"In[150]:=",
  PageWidth->Infinity,
  AspectRatioFixed->True,
  CellTags->{"The Algebraic Riccati Equation", "i:13", "b:21.2"}],

Cell[CellGroupData[{

Cell[BoxData[
    \({P, Eigs} = AlgebraicRiccatiEquation[A2, Q2, U2]\)], "Input",
  CellLabel->"In[153]:=",
  PageWidth->Infinity,
  AspectRatioFixed->True,
  CellTags->{"The Algebraic Riccati Equation", "i:13", "b:21.2"}],

Cell[BoxData[
    \({{{2, 2, 1}, {2, 3, 2}, {1, 2, 2}}, {\(-1\), 
        1\/2\ \((\(-1\) + \[ImaginaryI]\ \@3)\), 
        1\/2\ \((\(-1\) - \[ImaginaryI]\ \@3)\)}}\)], "Output",
  CellLabel->"Out[153]=",
  CellTags->{"The Algebraic Riccati Equation", "i:13", "b:21.2"}]
}, Open  ]],

Cell["\<\
In this case, a complete set of eigenvectors does exist so the preferred \
method is used and no messages appear. Even in this simple case the increase \
in speed obtained when using finite precision is quite evident. Try this:\
\>", "Text",
  Evaluatable->False,
  AspectRatioFixed->True,
  CellTags->{"The Algebraic Riccati Equation", "i:13", "b:21.2"}],

Cell[CellGroupData[{

Cell[BoxData[
    \({P, Eigs} = AlgebraicRiccatiEquation[N[A2], Q2, U2]\)], "Input",
  CellLabel->"In[154]:=",
  PageWidth->Infinity,
  AspectRatioFixed->True,
  CellTags->{"The Algebraic Riccati Equation", "i:13", "b:21.2"}],

Cell[BoxData[
    \({{{1.9999999999999978`, 1.999999999999997`, 
          0.9999999999999981`}, {1.9999999999999973`, 2.9999999999999964`, 
          1.9999999999999976`}, {0.9999999999999978`, 1.9999999999999971`, 
          1.9999999999999978`}}, {\(-0.9999999999999994`\), \
\(-0.5000000000000001`\) + 
          0.8660254037844386`\ \[ImaginaryI], \(-0.5000000000000001`\) - 
          0.8660254037844386`\ \[ImaginaryI]}}\)], "Output",
  CellLabel->"Out[154]=",
  CellTags->{"The Algebraic Riccati Equation", "i:13", "b:21.2"}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Optimal State Feedback", "Subsection",
  Evaluatable->False,
  AspectRatioFixed->True,
  CellTags->{"Optimal State Feedback", "i:14", "b:21.3"}],

Cell["\<\
Consider the linear control system with (A,B) parameter matrices\
\>", "Text",
  Evaluatable->False,
  AspectRatioFixed->True,
  CellTags->{"Optimal State Feedback", "i:14", "b:21.3"}],

Cell[BoxData[
    \(A = {{0, 0}, {1, \(-\@2\)}}; B = {{1}, {0}};\)], "Input",
  CellLabel->"In[155]:=",
  PageWidth->Infinity,
  AspectRatioFixed->True,
  CellTags->{"Optimal State Feedback", "i:14", "b:21.3"}],

Cell["\<\
We wish to design a state feedback controller that minimizes a quadratic \
performance index with control weighting matrix R and state weighting matrix \
Q:\
\>", "Text",
  Evaluatable->False,
  AspectRatioFixed->True,
  CellTags->{"Optimal State Feedback", "i:14", "b:21.3"}],

Cell[BoxData[
    \(R = {{1}}; Q = {{0, 0}, {0, 1}};\)], "Input",
  CellLabel->"In[156]:=",
  PageWidth->Infinity,
  AspectRatioFixed->True,
  CellTags->{"Optimal State Feedback", "i:14", "b:21.3"}],

Cell["This is accomplished with the LQR function:", "Text",
  Evaluatable->False,
  AspectRatioFixed->True,
  CellTags->{"Optimal State Feedback", "i:14", "b:21.3"}],

Cell[CellGroupData[{

Cell[BoxData[
    \({K, P, Eigs} = LQR[A, B, Q, R]\)], "Input",
  CellLabel->"In[157]:=",
  PageWidth->Infinity,
  AspectRatioFixed->True,
  CellTags->{"Optimal State Feedback", "i:14", "b:21.3"}],

Cell[BoxData[
    \("Hamiltonian has nonsimple divisors."\)], "Print",
  CellLabel->"From In[157]:=",
  CellTags->{"Optimal State Feedback", "i:14", "b:21.3"}],

Cell[BoxData[
    \("This could take a while."\)], "Print",
  CellLabel->"From In[157]:=",
  CellTags->{"Optimal State Feedback", "i:14", "b:21.3"}],

Cell[BoxData[
    \({{{\(-\(\(2 + \@2\)\/\(3 + 2\ \@2\)\)\), \(-\(1\/\(3 + 
                  2\ \@2\)\)\)}}, {{\(2 + \@2\)\/\(3 + 2\ \@2\), 
          1\/\(3 + 2\ \@2\)}, {1\/\(3 + 2\ \@2\), 
          2\/\(3 + 2\ \@2\)}}, {\(-1\), \(-1\)}}\)], "Output",
  CellLabel->"Out[157]=",
  CellTags->{"Optimal State Feedback", "i:14", "b:21.3"}]
}, Open  ]],

Cell["\<\
LQR returns the state feedback gain F, the Riccati solution P and the closed \
loop eigenvalues, i.e., the eigenvalues of the matrix (A+BK).\
\>", "Text",
  Evaluatable->False,
  AspectRatioFixed->True,
  CellTags->{"Optimal State Feedback", "i:14", "b:21.3"}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Optimal Stochastic State Estimator", "Subsection",
  Evaluatable->False,
  AspectRatioFixed->True,
  CellTags->{"Optimal Stochastic State Estimator", "i:15", "b:21.4"}],

Cell["\<\
When the states are not directly measured, it is necessary to use a state \
estimator. The function LQE computes the optimal least squares estimator \
parameters for a system with (white) driving noise and measurement noise. As \
an example consider a system with state equations

\t             x_dot = Ax + Bu + Gw
\t
\toutput equations
\t
\t\t y = Cx + Du + v
\t\t\t\t\t\t\t\t\t\t\t\t
\twhere v,w are white Gaussian noise vectors with zero mean and covariance \
matrices Q, R, respectively. Then the estimator is of the form:
\t
\t\txest_dot = Axest +Bu + L(Cxest + Du - y)
\t\t\t\t\t\t\t\t\t\t\t
\tand the matrix parameter L is obtained from the function LQE. For example, \
consider the system used above with additional parameters:\
\>", "Text",
  Evaluatable->False,
  AspectRatioFixed->True,
  CellTags->{"Optimal Stochastic State Estimator", "i:15", "b:21.4"}],

Cell[BoxData[
    \(CC = {{0, 1}}; G = {{1}, {1}}; Q = {{1}}; R = {{1}};\)], "Input",
  CellLabel->"In[158]:=",
  PageWidth->Infinity,
  AspectRatioFixed->True,
  CellTags->{"Optimal Stochastic State Estimator", "i:15", "b:21.4"}],

Cell["LQE is used to compute L:", "Text",
  Evaluatable->False,
  AspectRatioFixed->True,
  CellTags->{"Optimal Stochastic State Estimator", "i:15", "b:21.4"}],

Cell[CellGroupData[{

Cell[BoxData[
    \({L, S, Eigs} = LQE[A, G, CC, Q, R]\)], "Input",
  CellLabel->"In[159]:=",
  PageWidth->Infinity,
  AspectRatioFixed->True,
  CellTags->{"Optimal Stochastic State Estimator", "i:15", "b:21.4"}],

Cell[BoxData[
    \({{{\(-1\)}, {\(-\(5\/\(2 + \@5\)\)\) + \(2\ \@2\)\/\(2 + \@5\) - \(2\ \
\@5\)\/\(2 + \@5\) + \@10\/\(2 + \@5\)}}, {{3\/\(2 + \@5\) + \@5\/\(2 + \
\@5\), 1}, {1, 
          5\/\(2 + \@5\) - \(2\ \@2\)\/\(2 + \@5\) + \(2\ \@5\)\/\(2 + \@5\) \
- \@10\/\(2 + \@5\)}}, {1\/2\ \((\(-1\) - \@5)\), 
        1\/2\ \((1 - \@5)\)}}\)], "Output",
  CellLabel->"Out[159]=",
  CellTags->{"Optimal Stochastic State Estimator", "i:15", "b:21.4"}]
}, Open  ]],

Cell["We can get a better look at the results", "Text",
  Evaluatable->False,
  AspectRatioFixed->True,
  CellTags->{"Optimal Stochastic State Estimator", "i:15", "b:21.4"}],

Cell[CellGroupData[{

Cell[BoxData[
    \(N[%]\)], "Input",
  CellLabel->"In[160]:=",
  PageWidth->Infinity,
  AspectRatioFixed->True,
  CellTags->{"Optimal Stochastic State Estimator", "i:15", "b:21.4"}],

Cell[BoxData[
    \({{{\(-1.`\)}, {\(-0.8218544151266948`\)}}, {{1.2360679774997898`, 
          1.`}, {1.`, 
          0.8218544151266948`}}, {\(-1.618033988749895`\), \
\(-0.6180339887498949`\)}}\)], "Output",
  CellLabel->"Out[160]=",
  CellTags->{"Optimal Stochastic State Estimator", "i:15", "b:21.4"}]
}, Open  ]],

Cell["\<\
As does LQR, LQE returns three objects, the observer parameter matrix L, the \
associated Riccati solution S, which is the error covariance matrix, and the \
estimator eigenvalues Eigs, the eigenvalues of (A+LC).

Here again, finite precision computation is observed to be substantially \
faster.\
\>", "Text",
  Evaluatable->False,
  AspectRatioFixed->True,
  CellTags->{"Optimal Stochastic State Estimator", "i:15", "b:21.4"}],

Cell[CellGroupData[{

Cell[BoxData[
    \({L, S, Eigs} = LQE[N[A], G, CC, Q, R]\)], "Input",
  CellLabel->"In[161]:=",
  PageWidth->Infinity,
  AspectRatioFixed->True,
  CellTags->{"Optimal Stochastic State Estimator", "i:15", "b:21.4"}],

Cell[BoxData[
    \({{{\(-1.0000000000000004`\)}, {\(-0.8218544151266947`\)}}, \
{{1.2360679774997898`, 1.0000000000000004`}, {1.`, 
          0.8218544151266947`}}, {\(-1.6180339887498958`\), \
\(-0.6180339887498945`\)}}\)], "Output",
  CellLabel->"Out[161]=",
  CellTags->{"Optimal Stochastic State Estimator", "i:15", "b:21.4"}]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Bibliography", "Section",
  CellTags->{"Bibliography", "b:22"}],

Cell["\<\
Effective use of the tools provided in this package require a basic \
understanding of modern control system analysis and design concepts. Books on \
linear control abound. Here are just a few titles, including some classics: 
Nise, N., Control Systems Engineering, Benjamin/Cummings, Redwood City, 1995.
Friedland, B. Control System Design, McGraw-Hill, New York, 1986.
Kailath, T., Linear Systems, Prentice-Hall, Englewood Cliffs, 1980.
Wonham, W. M., Linear Multivariable Control: a Geometric Approach, \
Springer-Verlag, New York, 1979.
Anderson, B. and J. Moore, Linear Optimal Control, Prentice-Hall, Englewood \
Cliffs, 1971.
Brockett, R. W., Finite Dimensional Linear Systems, John Wiley, New York, \
1970.

\
\>", "Text",
  CellTags->{"Bibliography", "b:22"}]
}, Open  ]]
},
FrontEndVersion->"5.0 for Microsoft Windows",
ScreenRectangle->{{0, 1024}, {0, 695}},
ShowPageBreaks->False,
WindowToolbars->{},
WindowSize->{770, 605},
WindowMargins->{{11, Automatic}, {Automatic, 10}},
Visible->True,
PrintingStartingPageNumber->96,
PrivateNotebookOptions->{"ColorPalette"->{RGBColor, -1}},
IndexCreationOptions->{"Format"->"Hyperlinks"},
TaggingRules:>{"NextIndexingNumber" -> 25, "IndexEntries" -> {{"i:1", \
"TaylorLinearize"}, {"i:10", "ColorNyquist"}, {"i:10", "Nyquist"}, {"i:11", \
"RootLocus"}, {"i:12", "PoleZeroPlot"}, {"i:13", "AlgebraicRiccatiEquation"}, \
{"i:14", "LQR"}, {"i:15", "LQE"}, {"i:2", "Poles"}, {"i:2", "Zeros"}, \
{"i:24", "LyapunovEquation"}, {"i:3", "ControllableRealization"}, {"i:3", \
"ObservablePair"}, {"i:3", "StateSpaceToTransferFunction"}, {"i:4", \
"MinimalRealization"}, {"i:5", "ControllablePair"}, {"i:5", \
"ObservablePair"}, {"i:5", "PolePlace"}, {"i:6", "IrreducibleRealization"}, \
{"i:6", "KalmanDecomposition"}, {"i:6", "MinimalRealization"}, {"i:9", \
"Bode"}}, "PaginationCache" -> {{2003, 8, 1, 21, 15, \
45.9169664`9.41454805418952}, {96, 96, 96, 96, 96, 96, 96, 97, 97, 97, 97, \
97, 97, 98, 98, 98, 98, 98, 98, 98, 98, 98, 98, 98, 98, 98, 99, 99, 99, 99, \
99, 99, 99, 99, 99, 99, 99, 99, 99, 99, 100, 100, 100, 100, 100, 100, 100, \
100, 100, 100, 100, 100, 100, 101, 101, 101, 101, 101, 101, 101, 101, 101, \
101, 101, 101, 101, 101, 101, 102, 102, 102, 102, 102, 102, 102, 102, 103, \
103, 103, 103, 103, 103, 103, 103, 103, 104, 104, 104, 104, 104, 104, 104, \
104, 104, 104, 105, 105, 105, 105, 105, 105, 105, 105, 105, 105, 105, 106, \
106, 106, 106, 106, 106, 106, 106, 106, 106, 106, 106, 107, 107, 107, 107, \
107, 107, 107, 107, 108, 108, 108, 108, 108, 108, 108, 108, 108, 108, 108, \
108, 108, 108, 109, 109, 109, 109, 109, 109, 109, 109, 109, 109, 110, 110, \
110, 110, 110, 110, 110, 110, 110, 111, 111, 111, 111, 111, 111, 111, 111, \
111, 111, 112, 112, 112, 112, 112, 112, 112, 112, 112, 112, 112, 112, 112, \
113, 113, 113, 113, 113, 113, 113, 113, 113, 113, 113, 113, 113, 113, 114, \
114, 114, 114, 114, 114, 114, 114, 114, 114, 114, 115, 115, 115, 115, 115, \
115, 115, 115, 115, 115, 115, 115, 116, 116, 116, 116, 116, 116, 116, 116, \
116, 117, 117, 117, 117, 117, 118, 118, 118, 118, 118, 119, 119, 119, 119, \
119, 119, 119, 119, 120, 120, 120, 120, 121, 121, 121, 122, 122, 122, 122, \
123, 123, 123, 124, 124, 125, 125, 126, 126, 126, 127, 127, 127, 127, 128, \
128, 128, 128, 128, 128, 128, 128, 128, 129, 129, 129, 129, 129, 129, 129, \
129, 129, 129, 129, 129, 130, 130, 130, 130, 130, 130, 130, 130, 130, 130, \
130, 130, 130, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, 131, \
131, 132, 132, 132, 132, 132, 132, 132, 132, 133, 133, 133, 133, 133, 133, \
133, 133, 133, 134, 134}}},
ShowCellLabel->True,
ShowCellTags->True,
RenderingOptions->{"ObjectDithering"->True,
"RasterDithering"->False},
StyleDefinitions -> "HelpBrowser.nb"
]

(*******************************************************************
Cached data follows.  If you edit this Notebook file directly, not
using Mathematica, you must remove the line containing CacheID at
the top of  the file.  The cache data will then be recreated when
you save this file from within Mathematica.
*******************************************************************)

(*CellTagsOutline
CellTagsIndex->{
  "Getting Started"->{
    Cell[1776, 53, 123, 3, 70, "Section",
      Evaluatable->False,
      CellTags->{"Getting Started", "b:18"}],
    Cell[2050, 64, 804, 16, 107, "Text",
      Evaluatable->False,
      CellTags->{"Getting Started", "b:18"}],
    Cell[2857, 82, 266, 9, 39, "Text",
      Evaluatable->False,
      CellTags->{"Getting Started", "b:18"}],
    Cell[3148, 95, 140, 4, 45, "Input",
      CellTags->{"Getting Started", "b:18"}],
    Cell[3291, 101, 730, 11, 417, "Print",
      CellTags->{"Getting Started", "b:18"}],
    Cell[4036, 115, 172, 6, 35, "Text",
      CellTags->{"Getting Started", "b:18"}]},
  "b:18"->{
    Cell[1776, 53, 123, 3, 70, "Section",
      Evaluatable->False,
      CellTags->{"Getting Started", "b:18"}],
    Cell[1902, 58, 145, 4, 63, "Input",
      CellTags->"b:18"],
    Cell[2050, 64, 804, 16, 107, "Text",
      Evaluatable->False,
      CellTags->{"Getting Started", "b:18"}],
    Cell[2857, 82, 266, 9, 39, "Text",
      Evaluatable->False,
      CellTags->{"Getting Started", "b:18"}],
    Cell[3148, 95, 140, 4, 45, "Input",
      CellTags->{"Getting Started", "b:18"}],
    Cell[3291, 101, 730, 11, 417, "Print",
      CellTags->{"Getting Started", "b:18"}],
    Cell[4036, 115, 172, 6, 35, "Text",
      CellTags->{"Getting Started", "b:18"}]},
  "What's in the Package"->{
    Cell[4365, 132, 140, 3, 54, "Subsection",
      Evaluatable->False,
      CellTags->{"What's in the Package", "b:19.0"}],
    Cell[4508, 137, 231, 7, 56, "Text",
      Evaluatable->False,
      CellTags->{"What's in the Package", "b:19.0"}],
    Cell[4764, 148, 165, 5, 33, "Input",
      CellTags->{"What's in the Package", "b:19.0"}],
    Cell[4932, 155, 738, 11, 292, "Print",
      CellTags->{"What's in the Package", "b:19.0"}],
    Cell[5685, 169, 192, 5, 35, "Text",
      Evaluatable->False,
      CellTags->{"What's in the Package", "b:19.0"}],
    Cell[5902, 178, 128, 3, 33, "Input",
      CellTags->{"b:19.0", "What's in the Package"}],
    Cell[6033, 183, 22551, 520, 218, "Print",
      CellTags->{"b:19.0", "What's in the Package"}]},
  "b:19.0"->{
    Cell[4365, 132, 140, 3, 54, "Subsection",
      Evaluatable->False,
      CellTags->{"What's in the Package", "b:19.0"}],
    Cell[4508, 137, 231, 7, 56, "Text",
      Evaluatable->False,
      CellTags->{"What's in the Package", "b:19.0"}],
    Cell[4764, 148, 165, 5, 33, "Input",
      CellTags->{"What's in the Package", "b:19.0"}],
    Cell[4932, 155, 738, 11, 292, "Print",
      CellTags->{"What's in the Package", "b:19.0"}],
    Cell[5685, 169, 192, 5, 35, "Text",
      Evaluatable->False,
      CellTags->{"What's in the Package", "b:19.0"}],
    Cell[5902, 178, 128, 3, 33, "Input",
      CellTags->{"b:19.0", "What's in the Package"}],
    Cell[6033, 183, 22551, 520, 218, "Print",
      CellTags->{"b:19.0", "What's in the Package"}]},
  "Linearization"->{
    Cell[28633, 709, 131, 3, 54, "Subsection",
      Evaluatable->False,
      CellTags->{"Linearization", "i:1", "b:19.1"}],
    Cell[28767, 714, 138, 3, 35, "Text",
      Evaluatable->False,
      CellTags->{"Linearization", "i:1", "b:19.1"}],
    Cell[28930, 721, 229, 6, 33, "Input",
      CellTags->{"Linearization", "i:1", "b:19.1"}],
    Cell[29162, 729, 161, 3, 33, "Output",
      CellTags->{"Linearization", "i:1", "b:19.1"}],
    Cell[29360, 737, 179, 5, 33, "Input",
      CellTags->{"Linearization", "i:1", "b:19.1"}],
    Cell[29542, 744, 127, 3, 33, "Output",
      CellTags->{"Linearization", "i:1", "b:19.1"}],
    Cell[29706, 752, 166, 5, 33, "Input",
      CellTags->{"Linearization", "i:1", "b:19.1"}],
    Cell[29875, 759, 114, 3, 33, "Output",
      CellTags->{"Linearization", "i:1", "b:19.1"}],
    Cell[30026, 767, 166, 5, 33, "Input",
      CellTags->{"Linearization", "i:1", "b:19.1"}],
    Cell[30195, 774, 114, 3, 33, "Output",
      CellTags->{"Linearization", "i:1", "b:19.1"}],
    Cell[30324, 780, 182, 5, 35, "Text",
      Evaluatable->False,
      CellTags->{"Linearization", "i:1", "b:19.1"}],
    Cell[30531, 789, 224, 6, 33, "Input",
      CellTags->{"Linearization", "i:1", "b:19.1"}],
    Cell[30758, 797, 156, 3, 29, "Print",
      CellTags->{"Linearization", "i:1", "b:19.1"}],
    Cell[30917, 802, 200, 4, 33, "Output",
      CellTags->{"Linearization", "i:1", "b:19.1"}]},
  "i:1"->{
    Cell[28633, 709, 131, 3, 54, "Subsection",
      Evaluatable->False,
      CellTags->{"Linearization", "i:1", "b:19.1"}],
    Cell[28767, 714, 138, 3, 35, "Text",
      Evaluatable->False,
      CellTags->{"Linearization", "i:1", "b:19.1"}],
    Cell[28930, 721, 229, 6, 33, "Input",
      CellTags->{"Linearization", "i:1", "b:19.1"}],
    Cell[29162, 729, 161, 3, 33, "Output",
      CellTags->{"Linearization", "i:1", "b:19.1"}],
    Cell[29360, 737, 179, 5, 33, "Input",
      CellTags->{"Linearization", "i:1", "b:19.1"}],
    Cell[29542, 744, 127, 3, 33, "Output",
      CellTags->{"Linearization", "i:1", "b:19.1"}],
    Cell[29706, 752, 166, 5, 33, "Input",
      CellTags->{"Linearization", "i:1", "b:19.1"}],
    Cell[29875, 759, 114, 3, 33, "Output",
      CellTags->{"Linearization", "i:1", "b:19.1"}],
    Cell[30026, 767, 166, 5, 33, "Input",
      CellTags->{"Linearization", "i:1", "b:19.1"}],
    Cell[30195, 774, 114, 3, 33, "Output",
      CellTags->{"Linearization", "i:1", "b:19.1"}],
    Cell[30324, 780, 182, 5, 35, "Text",
      Evaluatable->False,
      CellTags->{"Linearization", "i:1", "b:19.1"}],
    Cell[30531, 789, 224, 6, 33, "Input",
      CellTags->{"Linearization", "i:1", "b:19.1"}],
    Cell[30758, 797, 156, 3, 29, "Print",
      CellTags->{"Linearization", "i:1", "b:19.1"}],
    Cell[30917, 802, 200, 4, 33, "Output",
      CellTags->{"Linearization", "i:1", "b:19.1"}]},
  "b:19.1"->{
    Cell[28633, 709, 131, 3, 54, "Subsection",
      Evaluatable->False,
      CellTags->{"Linearization", "i:1", "b:19.1"}],
    Cell[28767, 714, 138, 3, 35, "Text",
      Evaluatable->False,
      CellTags->{"Linearization", "i:1", "b:19.1"}],
    Cell[28930, 721, 229, 6, 33, "Input",
      CellTags->{"Linearization", "i:1", "b:19.1"}],
    Cell[29162, 729, 161, 3, 33, "Output",
      CellTags->{"Linearization", "i:1", "b:19.1"}],
    Cell[29360, 737, 179, 5, 33, "Input",
      CellTags->{"Linearization", "i:1", "b:19.1"}],
    Cell[29542, 744, 127, 3, 33, "Output",
      CellTags->{"Linearization", "i:1", "b:19.1"}],
    Cell[29706, 752, 166, 5, 33, "Input",
      CellTags->{"Linearization", "i:1", "b:19.1"}],
    Cell[29875, 759, 114, 3, 33, "Output",
      CellTags->{"Linearization", "i:1", "b:19.1"}],
    Cell[30026, 767, 166, 5, 33, "Input",
      CellTags->{"Linearization", "i:1", "b:19.1"}],
    Cell[30195, 774, 114, 3, 33, "Output",
      CellTags->{"Linearization", "i:1", "b:19.1"}],
    Cell[30324, 780, 182, 5, 35, "Text",
      Evaluatable->False,
      CellTags->{"Linearization", "i:1", "b:19.1"}],
    Cell[30531, 789, 224, 6, 33, "Input",
      CellTags->{"Linearization", "i:1", "b:19.1"}],
    Cell[30758, 797, 156, 3, 29, "Print",
      CellTags->{"Linearization", "i:1", "b:19.1"}],
    Cell[30917, 802, 200, 4, 33, "Output",
      CellTags->{"Linearization", "i:1", "b:19.1"}]},
  "Poles and Zeros"->{
    Cell[31166, 812, 85, 1, 54, "Subsection",
      CellTags->{"Poles and Zeros", "i:2", "b:19.2"}],
    Cell[31254, 815, 668, 19, 75, "Text",
      CellTags->{"Poles and Zeros", "i:2", "b:19.2"}],
    Cell[31925, 836, 440, 8, 72, "Input",
      CellTags->{"Poles and Zeros", "i:2", "b:19.2"}],
    Cell[32390, 848, 126, 3, 33, "Input",
      CellTags->{"Poles and Zeros", "i:2", "b:19.2"}],
    Cell[32519, 853, 515, 12, 61, "Output",
      CellTags->{"Poles and Zeros", "i:2", "b:19.2"}],
    Cell[33071, 870, 126, 3, 33, "Input",
      CellTags->{"Poles and Zeros", "i:2", "b:19.2"}],
    Cell[33200, 875, 626, 13, 61, "Output",
      CellTags->{"Poles and Zeros", "i:2", "b:19.2"}],
    Cell[33863, 893, 119, 3, 33, "Input",
      CellTags->{"Poles and Zeros", "i:2", "b:19.2"}],
    Cell[33985, 898, 143, 3, 33, "Output",
      CellTags->{"Poles and Zeros", "i:2", "b:19.2"}],
    Cell[34165, 906, 119, 3, 33, "Input",
      CellTags->{"Poles and Zeros", "i:2", "b:19.2"}],
    Cell[34287, 911, 135, 3, 33, "Output",
      CellTags->{"Poles and Zeros", "i:2", "b:19.2"}],
    Cell[34437, 917, 512, 9, 86, "Input",
      CellTags->{"Poles and Zeros", "i:2", "b:19.2"}],
    Cell[34974, 930, 126, 3, 33, "Input",
      CellTags->{"Poles and Zeros", "i:2", "b:19.2"}],
    Cell[35103, 935, 515, 12, 61, "Output",
      CellTags->{"Poles and Zeros", "i:2", "b:19.2"}],
    Cell[35655, 952, 126, 3, 33, "Input",
      CellTags->{"Poles and Zeros", "i:2", "b:19.2"}],
    Cell[35784, 957, 626, 13, 61, "Output",
      CellTags->{"Poles and Zeros", "i:2", "b:19.2"}],
    Cell[36447, 975, 126, 3, 33, "Input",
      CellTags->{"Poles and Zeros", "i:2", "b:19.2"}],
    Cell[36576, 980, 404, 9, 59, "Output",
      CellTags->{"Poles and Zeros", "i:2", "b:19.2"}],
    Cell[37017, 994, 119, 3, 33, "Input",
      CellTags->{"Poles and Zeros", "i:2", "b:19.2"}],
    Cell[37139, 999, 117, 3, 33, "Output",
      CellTags->{"Poles and Zeros", "i:2", "b:19.2"}],
    Cell[37293, 1007, 119, 3, 33, "Input",
      CellTags->{"Poles and Zeros", "i:2", "b:19.2"}],
    Cell[37415, 1012, 111, 3, 33, "Output",
      CellTags->{"Poles and Zeros", "i:2", "b:19.2"}],
    Cell[37563, 1020, 119, 3, 33, "Input",
      CellTags->{"Poles and Zeros", "i:2", "b:19.2"}],
    Cell[37685, 1025, 117, 3, 33, "Output",
      CellTags->{"Poles and Zeros", "i:2", "b:19.2"}]},
  "i:2"->{
    Cell[31166, 812, 85, 1, 54, "Subsection",
      CellTags->{"Poles and Zeros", "i:2", "b:19.2"}],
    Cell[31254, 815, 668, 19, 75, "Text",
      CellTags->{"Poles and Zeros", "i:2", "b:19.2"}],
    Cell[31925, 836, 440, 8, 72, "Input",
      CellTags->{"Poles and Zeros", "i:2", "b:19.2"}],
    Cell[32390, 848, 126, 3, 33, "Input",
      CellTags->{"Poles and Zeros", "i:2", "b:19.2"}],
    Cell[32519, 853, 515, 12, 61, "Output",
      CellTags->{"Poles and Zeros", "i:2", "b:19.2"}],
    Cell[33071, 870, 126, 3, 33, "Input",
      CellTags->{"Poles and Zeros", "i:2", "b:19.2"}],
    Cell[33200, 875, 626, 13, 61, "Output",
      CellTags->{"Poles and Zeros", "i:2", "b:19.2"}],
    Cell[33863, 893, 119, 3, 33, "Input",
      CellTags->{"Poles and Zeros", "i:2", "b:19.2"}],
    Cell[33985, 898, 143, 3, 33, "Output",
      CellTags->{"Poles and Zeros", "i:2", "b:19.2"}],
    Cell[34165, 906, 119, 3, 33, "Input",
      CellTags->{"Poles and Zeros", "i:2", "b:19.2"}],
    Cell[34287, 911, 135, 3, 33, "Output",
      CellTags->{"Poles and Zeros", "i:2", "b:19.2"}],
    Cell[34437, 917, 512, 9, 86, "Input",
      CellTags->{"Poles and Zeros", "i:2", "b:19.2"}],
    Cell[34974, 930, 126, 3, 33, "Input",
      CellTags->{"Poles and Zeros", "i:2", "b:19.2"}],
    Cell[35103, 935, 515, 12, 61, "Output",
      CellTags->{"Poles and Zeros", "i:2", "b:19.2"}],
    Cell[35655, 952, 126, 3, 33, "Input",
      CellTags->{"Poles and Zeros", "i:2", "b:19.2"}],
    Cell[35784, 957, 626, 13, 61, "Output",
      CellTags->{"Poles and Zeros", "i:2", "b:19.2"}],
    Cell[36447, 975, 126, 3, 33, "Input",
      CellTags->{"Poles and Zeros", "i:2", "b:19.2"}],
    Cell[36576, 980, 404, 9, 59, "Output",
      CellTags->{"Poles and Zeros", "i:2", "b:19.2"}],
    Cell[37017, 994, 119, 3, 33, "Input",
      CellTags->{"Poles and Zeros", "i:2", "b:19.2"}],
    Cell[37139, 999, 117, 3, 33, "Output",
      CellTags->{"Poles and Zeros", "i:2", "b:19.2"}],
    Cell[37293, 1007, 119, 3, 33, "Input",
      CellTags->{"Poles and Zeros", "i:2", "b:19.2"}],
    Cell[37415, 1012, 111, 3, 33, "Output",
      CellTags->{"Poles and Zeros", "i:2", "b:19.2"}],
    Cell[37563, 1020, 119, 3, 33, "Input",
      CellTags->{"Poles and Zeros", "i:2", "b:19.2"}],
    Cell[37685, 1025, 117, 3, 33, "Output",
      CellTags->{"Poles and Zeros", "i:2", "b:19.2"}]},
  "b:19.2"->{
    Cell[31166, 812, 85, 1, 54, "Subsection",
      CellTags->{"Poles and Zeros", "i:2", "b:19.2"}],
    Cell[31254, 815, 668, 19, 75, "Text",
      CellTags->{"Poles and Zeros", "i:2", "b:19.2"}],
    Cell[31925, 836, 440, 8, 72, "Input",
      CellTags->{"Poles and Zeros", "i:2", "b:19.2"}],
    Cell[32390, 848, 126, 3, 33, "Input",
      CellTags->{"Poles and Zeros", "i:2", "b:19.2"}],
    Cell[32519, 853, 515, 12, 61, "Output",
      CellTags->{"Poles and Zeros", "i:2", "b:19.2"}],
    Cell[33071, 870, 126, 3, 33, "Input",
      CellTags->{"Poles and Zeros", "i:2", "b:19.2"}],
    Cell[33200, 875, 626, 13, 61, "Output",
      CellTags->{"Poles and Zeros", "i:2", "b:19.2"}],
    Cell[33863, 893, 119, 3, 33, "Input",
      CellTags->{"Poles and Zeros", "i:2", "b:19.2"}],
    Cell[33985, 898, 143, 3, 33, "Output",
      CellTags->{"Poles and Zeros", "i:2", "b:19.2"}],
    Cell[34165, 906, 119, 3, 33, "Input",
      CellTags->{"Poles and Zeros", "i:2", "b:19.2"}],
    Cell[34287, 911, 135, 3, 33, "Output",
      CellTags->{"Poles and Zeros", "i:2", "b:19.2"}],
    Cell[34437, 917, 512, 9, 86, "Input",
      CellTags->{"Poles and Zeros", "i:2", "b:19.2"}],
    Cell[34974, 930, 126, 3, 33, "Input",
      CellTags->{"Poles and Zeros", "i:2", "b:19.2"}],
    Cell[35103, 935, 515, 12, 61, "Output",
      CellTags->{"Poles and Zeros", "i:2", "b:19.2"}],
    Cell[35655, 952, 126, 3, 33, "Input",
      CellTags->{"Poles and Zeros", "i:2", "b:19.2"}],
    Cell[35784, 957, 626, 13, 61, "Output",
      CellTags->{"Poles and Zeros", "i:2", "b:19.2"}],
    Cell[36447, 975, 126, 3, 33, "Input",
      CellTags->{"Poles and Zeros", "i:2", "b:19.2"}],
    Cell[36576, 980, 404, 9, 59, "Output",
      CellTags->{"Poles and Zeros", "i:2", "b:19.2"}],
    Cell[37017, 994, 119, 3, 33, "Input",
      CellTags->{"Poles and Zeros", "i:2", "b:19.2"}],
    Cell[37139, 999, 117, 3, 33, "Output",
      CellTags->{"Poles and Zeros", "i:2", "b:19.2"}],
    Cell[37293, 1007, 119, 3, 33, "Input",
      CellTags->{"Poles and Zeros", "i:2", "b:19.2"}],
    Cell[37415, 1012, 111, 3, 33, "Output",
      CellTags->{"Poles and Zeros", "i:2", "b:19.2"}],
    Cell[37563, 1020, 119, 3, 33, "Input",
      CellTags->{"Poles and Zeros", "i:2", "b:19.2"}],
    Cell[37685, 1025, 117, 3, 33, "Output",
      CellTags->{"Poles and Zeros", "i:2", "b:19.2"}]},
  "State Space to Transfer Function and Back"->{
    Cell[37851, 1034, 187, 3, 54, "Subsection",
      Evaluatable->False,
      CellTags->{
      "State Space to Transfer Function and Back", "i:3", "b:19.3"}],
    Cell[38041, 1039, 199, 3, 35, "Text",
      Evaluatable->False,
      CellTags->{
      "State Space to Transfer Function and Back", "i:3", "b:19.3"}],
    Cell[38265, 1046, 264, 6, 46, "Input",
      CellTags->{
      "State Space to Transfer Function and Back", "i:3", "b:19.3"}],
    Cell[38532, 1054, 250, 4, 41, "Output",
      CellTags->{
      "State Space to Transfer Function and Back", "i:3", "b:19.3"}],
    Cell[38797, 1061, 219, 5, 35, "Text",
      Evaluatable->False,
      CellTags->{
      "State Space to Transfer Function and Back", "i:3", "b:19.3"}],
    Cell[39041, 1070, 228, 5, 33, "Input",
      CellTags->{
      "State Space to Transfer Function and Back", "i:3", "b:19.3"}],
    Cell[39272, 1077, 299, 5, 46, "Output",
      CellTags->{
      "State Space to Transfer Function and Back", "i:3", "b:19.3"}],
    Cell[39586, 1085, 183, 3, 35, "Text",
      Evaluatable->False,
      CellTags->{
      "State Space to Transfer Function and Back", "i:3", "b:19.3"}],
    Cell[39794, 1092, 205, 5, 33, "Input",
      CellTags->{
      "State Space to Transfer Function and Back", "i:3", "b:19.3"}],
    Cell[40002, 1099, 140, 3, 33, "Output",
      CellTags->{
      "State Space to Transfer Function and Back", "i:3", "b:19.3"}],
    Cell[40157, 1105, 196, 3, 35, "Text",
      Evaluatable->False,
      CellTags->{
      "State Space to Transfer Function and Back", "i:3", "b:19.3"}],
    Cell[40378, 1112, 260, 6, 46, "Input",
      CellTags->{
      "State Space to Transfer Function and Back", "i:3", "b:19.3"}],
    Cell[40641, 1120, 250, 4, 41, "Output",
      CellTags->{
      "State Space to Transfer Function and Back", "i:3", "b:19.3"}]},
  "i:3"->{
    Cell[37851, 1034, 187, 3, 54, "Subsection",
      Evaluatable->False,
      CellTags->{
      "State Space to Transfer Function and Back", "i:3", "b:19.3"}],
    Cell[38041, 1039, 199, 3, 35, "Text",
      Evaluatable->False,
      CellTags->{
      "State Space to Transfer Function and Back", "i:3", "b:19.3"}],
    Cell[38265, 1046, 264, 6, 46, "Input",
      CellTags->{
      "State Space to Transfer Function and Back", "i:3", "b:19.3"}],
    Cell[38532, 1054, 250, 4, 41, "Output",
      CellTags->{
      "State Space to Transfer Function and Back", "i:3", "b:19.3"}],
    Cell[38797, 1061, 219, 5, 35, "Text",
      Evaluatable->False,
      CellTags->{
      "State Space to Transfer Function and Back", "i:3", "b:19.3"}],
    Cell[39041, 1070, 228, 5, 33, "Input",
      CellTags->{
      "State Space to Transfer Function and Back", "i:3", "b:19.3"}],
    Cell[39272, 1077, 299, 5, 46, "Output",
      CellTags->{
      "State Space to Transfer Function and Back", "i:3", "b:19.3"}],
    Cell[39586, 1085, 183, 3, 35, "Text",
      Evaluatable->False,
      CellTags->{
      "State Space to Transfer Function and Back", "i:3", "b:19.3"}],
    Cell[39794, 1092, 205, 5, 33, "Input",
      CellTags->{
      "State Space to Transfer Function and Back", "i:3", "b:19.3"}],
    Cell[40002, 1099, 140, 3, 33, "Output",
      CellTags->{
      "State Space to Transfer Function and Back", "i:3", "b:19.3"}],
    Cell[40157, 1105, 196, 3, 35, "Text",
      Evaluatable->False,
      CellTags->{
      "State Space to Transfer Function and Back", "i:3", "b:19.3"}],
    Cell[40378, 1112, 260, 6, 46, "Input",
      CellTags->{
      "State Space to Transfer Function and Back", "i:3", "b:19.3"}],
    Cell[40641, 1120, 250, 4, 41, "Output",
      CellTags->{
      "State Space to Transfer Function and Back", "i:3", "b:19.3"}]},
  "b:19.3"->{
    Cell[37851, 1034, 187, 3, 54, "Subsection",
      Evaluatable->False,
      CellTags->{
      "State Space to Transfer Function and Back", "i:3", "b:19.3"}],
    Cell[38041, 1039, 199, 3, 35, "Text",
      Evaluatable->False,
      CellTags->{
      "State Space to Transfer Function and Back", "i:3", "b:19.3"}],
    Cell[38265, 1046, 264, 6, 46, "Input",
      CellTags->{
      "State Space to Transfer Function and Back", "i:3", "b:19.3"}],
    Cell[38532, 1054, 250, 4, 41, "Output",
      CellTags->{
      "State Space to Transfer Function and Back", "i:3", "b:19.3"}],
    Cell[38797, 1061, 219, 5, 35, "Text",
      Evaluatable->False,
      CellTags->{
      "State Space to Transfer Function and Back", "i:3", "b:19.3"}],
    Cell[39041, 1070, 228, 5, 33, "Input",
      CellTags->{
      "State Space to Transfer Function and Back", "i:3", "b:19.3"}],
    Cell[39272, 1077, 299, 5, 46, "Output",
      CellTags->{
      "State Space to Transfer Function and Back", "i:3", "b:19.3"}],
    Cell[39586, 1085, 183, 3, 35, "Text",
      Evaluatable->False,
      CellTags->{
      "State Space to Transfer Function and Back", "i:3", "b:19.3"}],
    Cell[39794, 1092, 205, 5, 33, "Input",
      CellTags->{
      "State Space to Transfer Function and Back", "i:3", "b:19.3"}],
    Cell[40002, 1099, 140, 3, 33, "Output",
      CellTags->{
      "State Space to Transfer Function and Back", "i:3", "b:19.3"}],
    Cell[40157, 1105, 196, 3, 35, "Text",
      Evaluatable->False,
      CellTags->{
      "State Space to Transfer Function and Back", "i:3", "b:19.3"}],
    Cell[40378, 1112, 260, 6, 46, "Input",
      CellTags->{
      "State Space to Transfer Function and Back", "i:3", "b:19.3"}],
    Cell[40641, 1120, 250, 4, 41, "Output",
      CellTags->{
      "State Space to Transfer Function and Back", "i:3", "b:19.3"}]},
  "Minimal Realization"->{
    Cell[40940, 1130, 95, 1, 54, "Subsection",
      CellTags->{"Minimal Realization", "i:4", "b:19.4"}],
    Cell[41038, 1133, 234, 5, 48, "Text",
      CellTags->{"Minimal Realization", "i:4", "b:19.4"}],
    Cell[41275, 1140, 487, 10, 72, "Input",
      CellTags->{"Minimal Realization", "i:4", "b:19.4"}],
    Cell[41787, 1154, 329, 8, 99, "Input",
      CellTags->{"Minimal Realization", "i:4", "b:19.4"}],
    Cell[42119, 1164, 801, 16, 83, "Output",
      CellTags->{"Minimal Realization", "i:4", "b:19.4"}],
    Cell[42923, 1182, 152, 3, 29, "Print",
      CellTags->{"Minimal Realization", "i:4", "b:19.4"}],
    Cell[43078, 1187, 552, 13, 101, "Output",
      CellTags->{"Minimal Realization", "i:4", "b:19.4"}],
    Cell[43633, 1202, 447, 13, 101, "Output",
      CellTags->{"Minimal Realization", "i:4", "b:19.4"}],
    Cell[44083, 1217, 420, 10, 65, "Output",
      CellTags->{"Minimal Realization", "i:4", "b:19.4"}],
    Cell[44506, 1229, 357, 10, 65, "Output",
      CellTags->{"Minimal Realization", "i:4", "b:19.4"}],
    Cell[44878, 1242, 502, 10, 72, "Input",
      CellTags->{"Minimal Realization", "i:4", "b:19.4"}],
    Cell[45405, 1256, 329, 8, 99, "Input",
      CellTags->{"Minimal Realization", "i:4", "b:19.4"}],
    Cell[45737, 1266, 1003, 19, 83, "Output",
      CellTags->{"Minimal Realization", "i:4", "b:19.4"}],
    Cell[46743, 1287, 152, 3, 29, "Print",
      CellTags->{"Minimal Realization", "i:4", "b:19.4"}],
    Cell[46898, 1292, 552, 13, 101, "Output",
      CellTags->{"Minimal Realization", "i:4", "b:19.4"}],
    Cell[47453, 1307, 447, 13, 101, "Output",
      CellTags->{"Minimal Realization", "i:4", "b:19.4"}],
    Cell[47903, 1322, 420, 10, 65, "Output",
      CellTags->{"Minimal Realization", "i:4", "b:19.4"}],
    Cell[48326, 1334, 357, 10, 65, "Output",
      CellTags->{"Minimal Realization", "i:4", "b:19.4"}],
    Cell[48698, 1347, 205, 4, 33, "Input",
      CellTags->{"Minimal Realization", "i:4", "b:19.4"}],
    Cell[48928, 1355, 130, 3, 33, "Input",
      CellTags->{"Minimal Realization", "i:4", "b:19.4"}],
    Cell[49061, 1360, 379, 9, 60, "Output",
      CellTags->{"Minimal Realization", "i:4", "b:19.4"}],
    Cell[49477, 1374, 294, 7, 86, "Input",
      CellTags->{"Minimal Realization", "i:4", "b:19.4"}],
    Cell[49774, 1383, 418, 11, 77, "Output",
      CellTags->{"Minimal Realization", "i:4", "b:19.4"}],
    Cell[50195, 1396, 370, 11, 77, "Output",
      CellTags->{"Minimal Realization", "i:4", "b:19.4"}],
    Cell[50568, 1409, 372, 9, 56, "Output",
      CellTags->{"Minimal Realization", "i:4", "b:19.4"}],
    Cell[50943, 1420, 318, 9, 53, "Output",
      CellTags->{"Minimal Realization", "i:4", "b:19.4"}],
    Cell[51276, 1432, 227, 5, 33, "Input",
      CellTags->{"Minimal Realization", "i:4", "b:19.4"}],
    Cell[51528, 1441, 130, 3, 33, "Input",
      CellTags->{"Minimal Realization", "i:4", "b:19.4"}],
    Cell[51661, 1446, 463, 11, 62, "Output",
      CellTags->{"Minimal Realization", "i:4", "b:19.4"}],
    Cell[52161, 1462, 294, 7, 86, "Input",
      CellTags->{"Minimal Realization", "i:4", "b:19.4"}],
    Cell[52458, 1471, 418, 11, 77, "Output",
      CellTags->{"Minimal Realization", "i:4", "b:19.4"}],
    Cell[52879, 1484, 370, 11, 77, "Output",
      CellTags->{"Minimal Realization", "i:4", "b:19.4"}],
    Cell[53252, 1497, 372, 9, 56, "Output",
      CellTags->{"Minimal Realization", "i:4", "b:19.4"}],
    Cell[53627, 1508, 318, 9, 53, "Output",
      CellTags->{"Minimal Realization", "i:4", "b:19.4"}],
    Cell[53960, 1520, 157, 4, 35, "Text",
      CellTags->{"Minimal Realization", "i:4", "b:19.4"}],
    Cell[54142, 1528, 187, 4, 33, "Input",
      CellTags->{"Minimal Realization", "i:4", "b:19.4"}],
    Cell[54332, 1534, 142, 3, 29, "Print",
      CellTags->{"Minimal Realization", "i:4", "b:19.4"}],
    Cell[54477, 1539, 168, 3, 29, "Print",
      CellTags->{"Minimal Realization", "i:4", "b:19.4"}],
    Cell[54648, 1544, 181, 4, 29, "Print",
      CellTags->{"Minimal Realization", "i:4", "b:19.4"}],
    Cell[54832, 1550, 140, 3, 29, "Print",
      CellTags->{"Minimal Realization", "i:4", "b:19.4"}],
    Cell[55009, 1558, 237, 6, 72, "Input",
      CellTags->{"Minimal Realization", "i:4", "b:19.4"}],
    Cell[55249, 1566, 418, 11, 77, "Output",
      CellTags->{"Minimal Realization", "i:4", "b:19.4"}],
    Cell[55670, 1579, 370, 11, 77, "Output",
      CellTags->{"Minimal Realization", "i:4", "b:19.4"}],
    Cell[56043, 1592, 372, 9, 56, "Output",
      CellTags->{"Minimal Realization", "i:4", "b:19.4"}],
    Cell[56418, 1603, 318, 9, 53, "Output",
      CellTags->{"Minimal Realization", "i:4", "b:19.4"}]},
  "i:4"->{
    Cell[40940, 1130, 95, 1, 54, "Subsection",
      CellTags->{"Minimal Realization", "i:4", "b:19.4"}],
    Cell[41038, 1133, 234, 5, 48, "Text",
      CellTags->{"Minimal Realization", "i:4", "b:19.4"}],
    Cell[41275, 1140, 487, 10, 72, "Input",
      CellTags->{"Minimal Realization", "i:4", "b:19.4"}],
    Cell[41787, 1154, 329, 8, 99, "Input",
      CellTags->{"Minimal Realization", "i:4", "b:19.4"}],
    Cell[42119, 1164, 801, 16, 83, "Output",
      CellTags->{"Minimal Realization", "i:4", "b:19.4"}],
    Cell[42923, 1182, 152, 3, 29, "Print",
      CellTags->{"Minimal Realization", "i:4", "b:19.4"}],
    Cell[43078, 1187, 552, 13, 101, "Output",
      CellTags->{"Minimal Realization", "i:4", "b:19.4"}],
    Cell[43633, 1202, 447, 13, 101, "Output",
      CellTags->{"Minimal Realization", "i:4", "b:19.4"}],
    Cell[44083, 1217, 420, 10, 65, "Output",
      CellTags->{"Minimal Realization", "i:4", "b:19.4"}],
    Cell[44506, 1229, 357, 10, 65, "Output",
      CellTags->{"Minimal Realization", "i:4", "b:19.4"}],
    Cell[44878, 1242, 502, 10, 72, "Input",
      CellTags->{"Minimal Realization", "i:4", "b:19.4"}],
    Cell[45405, 1256, 329, 8, 99, "Input",
      CellTags->{"Minimal Realization", "i:4", "b:19.4"}],
    Cell[45737, 1266, 1003, 19, 83, "Output",
      CellTags->{"Minimal Realization", "i:4", "b:19.4"}],
    Cell[46743, 1287, 152, 3, 29, "Print",
      CellTags->{"Minimal Realization", "i:4", "b:19.4"}],
    Cell[46898, 1292, 552, 13, 101, "Output",
      CellTags->{"Minimal Realization", "i:4", "b:19.4"}],
    Cell[47453, 1307, 447, 13, 101, "Output",
      CellTags->{"Minimal Realization", "i:4", "b:19.4"}],
    Cell[47903, 1322, 420, 10, 65, "Output",
      CellTags->{"Minimal Realization", "i:4", "b:19.4"}],
    Cell[48326, 1334, 357, 10, 65, "Output",
      CellTags->{"Minimal Realization", "i:4", "b:19.4"}],
    Cell[48698, 1347, 205, 4, 33, "Input",
      CellTags->{"Minimal Realization", "i:4", "b:19.4"}],
    Cell[48928, 1355, 130, 3, 33, "Input",
      CellTags->{"Minimal Realization", "i:4", "b:19.4"}],
    Cell[49061, 1360, 379, 9, 60, "Output",
      CellTags->{"Minimal Realization", "i:4", "b:19.4"}],
    Cell[49477, 1374, 294, 7, 86, "Input",
      CellTags->{"Minimal Realization", "i:4", "b:19.4"}],
    Cell[49774, 1383, 418, 11, 77, "Output",
      CellTags->{"Minimal Realization", "i:4", "b:19.4"}],
    Cell[50195, 1396, 370, 11, 77, "Output",
      CellTags->{"Minimal Realization", "i:4", "b:19.4"}],
    Cell[50568, 1409, 372, 9, 56, "Output",
      CellTags->{"Minimal Realization", "i:4", "b:19.4"}],
    Cell[50943, 1420, 318, 9, 53, "Output",
      CellTags->{"Minimal Realization", "i:4", "b:19.4"}],
    Cell[51276, 1432, 227, 5, 33, "Input",
      CellTags->{"Minimal Realization", "i:4", "b:19.4"}],
    Cell[51528, 1441, 130, 3, 33, "Input",
      CellTags->{"Minimal Realization", "i:4", "b:19.4"}],
    Cell[51661, 1446, 463, 11, 62, "Output",
      CellTags->{"Minimal Realization", "i:4", "b:19.4"}],
    Cell[52161, 1462, 294, 7, 86, "Input",
      CellTags->{"Minimal Realization", "i:4", "b:19.4"}],
    Cell[52458, 1471, 418, 11, 77, "Output",
      CellTags->{"Minimal Realization", "i:4", "b:19.4"}],
    Cell[52879, 1484, 370, 11, 77, "Output",
      CellTags->{"Minimal Realization", "i:4", "b:19.4"}],
    Cell[53252, 1497, 372, 9, 56, "Output",
      CellTags->{"Minimal Realization", "i:4", "b:19.4"}],
    Cell[53627, 1508, 318, 9, 53, "Output",
      CellTags->{"Minimal Realization", "i:4", "b:19.4"}],
    Cell[53960, 1520, 157, 4, 35, "Text",
      CellTags->{"Minimal Realization", "i:4", "b:19.4"}],
    Cell[54142, 1528, 187, 4, 33, "Input",
      CellTags->{"Minimal Realization", "i:4", "b:19.4"}],
    Cell[54332, 1534, 142, 3, 29, "Print",
      CellTags->{"Minimal Realization", "i:4", "b:19.4"}],
    Cell[54477, 1539, 168, 3, 29, "Print",
      CellTags->{"Minimal Realization", "i:4", "b:19.4"}],
    Cell[54648, 1544, 181, 4, 29, "Print",
      CellTags->{"Minimal Realization", "i:4", "b:19.4"}],
    Cell[54832, 1550, 140, 3, 29, "Print",
      CellTags->{"Minimal Realization", "i:4", "b:19.4"}],
    Cell[55009, 1558, 237, 6, 72, "Input",
      CellTags->{"Minimal Realization", "i:4", "b:19.4"}],
    Cell[55249, 1566, 418, 11, 77, "Output",
      CellTags->{"Minimal Realization", "i:4", "b:19.4"}],
    Cell[55670, 1579, 370, 11, 77, "Output",
      CellTags->{"Minimal Realization", "i:4", "b:19.4"}],
    Cell[56043, 1592, 372, 9, 56, "Output",
      CellTags->{"Minimal Realization", "i:4", "b:19.4"}],
    Cell[56418, 1603, 318, 9, 53, "Output",
      CellTags->{"Minimal Realization", "i:4", "b:19.4"}]},
  "b:19.4"->{
    Cell[40940, 1130, 95, 1, 54, "Subsection",
      CellTags->{"Minimal Realization", "i:4", "b:19.4"}],
    Cell[41038, 1133, 234, 5, 48, "Text",
      CellTags->{"Minimal Realization", "i:4", "b:19.4"}],
    Cell[41275, 1140, 487, 10, 72, "Input",
      CellTags->{"Minimal Realization", "i:4", "b:19.4"}],
    Cell[41787, 1154, 329, 8, 99, "Input",
      CellTags->{"Minimal Realization", "i:4", "b:19.4"}],
    Cell[42119, 1164, 801, 16, 83, "Output",
      CellTags->{"Minimal Realization", "i:4", "b:19.4"}],
    Cell[42923, 1182, 152, 3, 29, "Print",
      CellTags->{"Minimal Realization", "i:4", "b:19.4"}],
    Cell[43078, 1187, 552, 13, 101, "Output",
      CellTags->{"Minimal Realization", "i:4", "b:19.4"}],
    Cell[43633, 1202, 447, 13, 101, "Output",
      CellTags->{"Minimal Realization", "i:4", "b:19.4"}],
    Cell[44083, 1217, 420, 10, 65, "Output",
      CellTags->{"Minimal Realization", "i:4", "b:19.4"}],
    Cell[44506, 1229, 357, 10, 65, "Output",
      CellTags->{"Minimal Realization", "i:4", "b:19.4"}],
    Cell[44878, 1242, 502, 10, 72, "Input",
      CellTags->{"Minimal Realization", "i:4", "b:19.4"}],
    Cell[45405, 1256, 329, 8, 99, "Input",
      CellTags->{"Minimal Realization", "i:4", "b:19.4"}],
    Cell[45737, 1266, 1003, 19, 83, "Output",
      CellTags->{"Minimal Realization", "i:4", "b:19.4"}],
    Cell[46743, 1287, 152, 3, 29, "Print",
      CellTags->{"Minimal Realization", "i:4", "b:19.4"}],
    Cell[46898, 1292, 552, 13, 101, "Output",
      CellTags->{"Minimal Realization", "i:4", "b:19.4"}],
    Cell[47453, 1307, 447, 13, 101, "Output",
      CellTags->{"Minimal Realization", "i:4", "b:19.4"}],
    Cell[47903, 1322, 420, 10, 65, "Output",
      CellTags->{"Minimal Realization", "i:4", "b:19.4"}],
    Cell[48326, 1334, 357, 10, 65, "Output",
      CellTags->{"Minimal Realization", "i:4", "b:19.4"}],
    Cell[48698, 1347, 205, 4, 33, "Input",
      CellTags->{"Minimal Realization", "i:4", "b:19.4"}],
    Cell[48928, 1355, 130, 3, 33, "Input",
      CellTags->{"Minimal Realization", "i:4", "b:19.4"}],
    Cell[49061, 1360, 379, 9, 60, "Output",
      CellTags->{"Minimal Realization", "i:4", "b:19.4"}],
    Cell[49477, 1374, 294, 7, 86, "Input",
      CellTags->{"Minimal Realization", "i:4", "b:19.4"}],
    Cell[49774, 1383, 418, 11, 77, "Output",
      CellTags->{"Minimal Realization", "i:4", "b:19.4"}],
    Cell[50195, 1396, 370, 11, 77, "Output",
      CellTags->{"Minimal Realization", "i:4", "b:19.4"}],
    Cell[50568, 1409, 372, 9, 56, "Output",
      CellTags->{"Minimal Realization", "i:4", "b:19.4"}],
    Cell[50943, 1420, 318, 9, 53, "Output",
      CellTags->{"Minimal Realization", "i:4", "b:19.4"}],
    Cell[51276, 1432, 227, 5, 33, "Input",
      CellTags->{"Minimal Realization", "i:4", "b:19.4"}],
    Cell[51528, 1441, 130, 3, 33, "Input",
      CellTags->{"Minimal Realization", "i:4", "b:19.4"}],
    Cell[51661, 1446, 463, 11, 62, "Output",
      CellTags->{"Minimal Realization", "i:4", "b:19.4"}],
    Cell[52161, 1462, 294, 7, 86, "Input",
      CellTags->{"Minimal Realization", "i:4", "b:19.4"}],
    Cell[52458, 1471, 418, 11, 77, "Output",
      CellTags->{"Minimal Realization", "i:4", "b:19.4"}],
    Cell[52879, 1484, 370, 11, 77, "Output",
      CellTags->{"Minimal Realization", "i:4", "b:19.4"}],
    Cell[53252, 1497, 372, 9, 56, "Output",
      CellTags->{"Minimal Realization", "i:4", "b:19.4"}],
    Cell[53627, 1508, 318, 9, 53, "Output",
      CellTags->{"Minimal Realization", "i:4", "b:19.4"}],
    Cell[53960, 1520, 157, 4, 35, "Text",
      CellTags->{"Minimal Realization", "i:4", "b:19.4"}],
    Cell[54142, 1528, 187, 4, 33, "Input",
      CellTags->{"Minimal Realization", "i:4", "b:19.4"}],
    Cell[54332, 1534, 142, 3, 29, "Print",
      CellTags->{"Minimal Realization", "i:4", "b:19.4"}],
    Cell[54477, 1539, 168, 3, 29, "Print",
      CellTags->{"Minimal Realization", "i:4", "b:19.4"}],
    Cell[54648, 1544, 181, 4, 29, "Print",
      CellTags->{"Minimal Realization", "i:4", "b:19.4"}],
    Cell[54832, 1550, 140, 3, 29, "Print",
      CellTags->{"Minimal Realization", "i:4", "b:19.4"}],
    Cell[55009, 1558, 237, 6, 72, "Input",
      CellTags->{"Minimal Realization", "i:4", "b:19.4"}],
    Cell[55249, 1566, 418, 11, 77, "Output",
      CellTags->{"Minimal Realization", "i:4", "b:19.4"}],
    Cell[55670, 1579, 370, 11, 77, "Output",
      CellTags->{"Minimal Realization", "i:4", "b:19.4"}],
    Cell[56043, 1592, 372, 9, 56, "Output",
      CellTags->{"Minimal Realization", "i:4", "b:19.4"}],
    Cell[56418, 1603, 318, 9, 53, "Output",
      CellTags->{"Minimal Realization", "i:4", "b:19.4"}]},
  "Controllability"->{
    Cell[56785, 1618, 169, 3, 54, "Subsection",
      Evaluatable->False,
      CellTags->{"Controllability", "i:5", "b:19.5"}],
    Cell[56957, 1623, 201, 6, 35, "Text",
      Evaluatable->False,
      CellTags->{"Controllability", "i:5", "b:19.5"}],
    Cell[57183, 1633, 181, 5, 33, "Input",
      CellTags->{"Controllability", "i:5", "b:19.5"}],
    Cell[57367, 1640, 113, 3, 33, "Output",
      CellTags->{"Controllability", "i:5", "b:19.5"}],
    Cell[57517, 1648, 179, 5, 33, "Input",
      CellTags->{"Controllability", "i:5", "b:19.5"}],
    Cell[57699, 1655, 113, 3, 33, "Output",
      CellTags->{"Controllability", "i:5", "b:19.5"}],
    Cell[57827, 1661, 257, 6, 48, "Text",
      Evaluatable->False,
      CellTags->{"Controllability", "i:5", "b:19.5"}],
    Cell[58109, 1671, 192, 5, 33, "Input",
      CellTags->{"Controllability", "i:5", "b:19.5"}],
    Cell[58304, 1678, 130, 3, 33, "Output",
      CellTags->{"Controllability", "i:5", "b:19.5"}],
    Cell[58449, 1684, 164, 3, 35, "Text",
      Evaluatable->False,
      CellTags->{"Controllability", "i:5", "b:19.5"}],
    Cell[58638, 1691, 195, 5, 33, "Input",
      CellTags->{"Controllability", "i:5", "b:19.5"}],
    Cell[58836, 1698, 137, 3, 39, "Output",
      CellTags->{"Controllability", "i:5", "b:19.5"}]},
  "i:5"->{
    Cell[56785, 1618, 169, 3, 54, "Subsection",
      Evaluatable->False,
      CellTags->{"Controllability", "i:5", "b:19.5"}],
    Cell[56957, 1623, 201, 6, 35, "Text",
      Evaluatable->False,
      CellTags->{"Controllability", "i:5", "b:19.5"}],
    Cell[57183, 1633, 181, 5, 33, "Input",
      CellTags->{"Controllability", "i:5", "b:19.5"}],
    Cell[57367, 1640, 113, 3, 33, "Output",
      CellTags->{"Controllability", "i:5", "b:19.5"}],
    Cell[57517, 1648, 179, 5, 33, "Input",
      CellTags->{"Controllability", "i:5", "b:19.5"}],
    Cell[57699, 1655, 113, 3, 33, "Output",
      CellTags->{"Controllability", "i:5", "b:19.5"}],
    Cell[57827, 1661, 257, 6, 48, "Text",
      Evaluatable->False,
      CellTags->{"Controllability", "i:5", "b:19.5"}],
    Cell[58109, 1671, 192, 5, 33, "Input",
      CellTags->{"Controllability", "i:5", "b:19.5"}],
    Cell[58304, 1678, 130, 3, 33, "Output",
      CellTags->{"Controllability", "i:5", "b:19.5"}],
    Cell[58449, 1684, 164, 3, 35, "Text",
      Evaluatable->False,
      CellTags->{"Controllability", "i:5", "b:19.5"}],
    Cell[58638, 1691, 195, 5, 33, "Input",
      CellTags->{"Controllability", "i:5", "b:19.5"}],
    Cell[58836, 1698, 137, 3, 39, "Output",
      CellTags->{"Controllability", "i:5", "b:19.5"}]},
  "b:19.5"->{
    Cell[56785, 1618, 169, 3, 54, "Subsection",
      Evaluatable->False,
      CellTags->{"Controllability", "i:5", "b:19.5"}],
    Cell[56957, 1623, 201, 6, 35, "Text",
      Evaluatable->False,
      CellTags->{"Controllability", "i:5", "b:19.5"}],
    Cell[57183, 1633, 181, 5, 33, "Input",
      CellTags->{"Controllability", "i:5", "b:19.5"}],
    Cell[57367, 1640, 113, 3, 33, "Output",
      CellTags->{"Controllability", "i:5", "b:19.5"}],
    Cell[57517, 1648, 179, 5, 33, "Input",
      CellTags->{"Controllability", "i:5", "b:19.5"}],
    Cell[57699, 1655, 113, 3, 33, "Output",
      CellTags->{"Controllability", "i:5", "b:19.5"}],
    Cell[57827, 1661, 257, 6, 48, "Text",
      Evaluatable->False,
      CellTags->{"Controllability", "i:5", "b:19.5"}],
    Cell[58109, 1671, 192, 5, 33, "Input",
      CellTags->{"Controllability", "i:5", "b:19.5"}],
    Cell[58304, 1678, 130, 3, 33, "Output",
      CellTags->{"Controllability", "i:5", "b:19.5"}],
    Cell[58449, 1684, 164, 3, 35, "Text",
      Evaluatable->False,
      CellTags->{"Controllability", "i:5", "b:19.5"}],
    Cell[58638, 1691, 195, 5, 33, "Input",
      CellTags->{"Controllability", "i:5", "b:19.5"}],
    Cell[58836, 1698, 137, 3, 39, "Output",
      CellTags->{"Controllability", "i:5", "b:19.5"}]},
  "Kalman Form"->{
    Cell[59022, 1707, 121, 1, 54, "Subsection",
      CellTags->{"Kalman Form", "i:6", "b:19.6"}],
    Cell[59146, 1710, 442, 7, 61, "Text",
      CellTags->{"Kalman Form", "i:6", "b:19.6"}],
    Cell[59591, 1719, 249, 5, 59, "Input",
      CellTags->{"Kalman Form", "i:6", "b:19.6"}],
    Cell[59865, 1728, 322, 8, 86, "Input",
      CellTags->{"Kalman Form", "i:6", "b:19.6"}],
    Cell[60190, 1738, 160, 3, 29, "Print",
      CellTags->{"Kalman Form", "i:6", "b:19.6"}],
    Cell[60353, 1743, 173, 4, 29, "Print",
      CellTags->{"Kalman Form", "i:6", "b:19.6"}],
    Cell[60529, 1749, 132, 3, 29, "Print",
      CellTags->{"Kalman Form", "i:6", "b:19.6"}],
    Cell[60664, 1754, 175, 4, 29, "Print",
      CellTags->{"Kalman Form", "i:6", "b:19.6"}],
    Cell[60842, 1760, 349, 10, 65, "Output",
      CellTags->{"Kalman Form", "i:6", "b:19.6"}],
    Cell[61194, 1772, 334, 10, 65, "Output",
      CellTags->{"Kalman Form", "i:6", "b:19.6"}],
    Cell[61531, 1784, 291, 8, 43, "Output",
      CellTags->{"Kalman Form", "i:6", "b:19.6"}],
    Cell[61825, 1794, 286, 8, 43, "Output",
      CellTags->{"Kalman Form", "i:6", "b:19.6"}],
    Cell[62148, 1807, 173, 6, 72, "Input",
      CellTags->{"Kalman Form", "i:6", "b:19.6"}],
    Cell[62324, 1815, 138, 3, 33, "Output",
      CellTags->{"Kalman Form", "i:6", "b:19.6"}],
    Cell[62465, 1820, 129, 3, 33, "Output",
      CellTags->{"Kalman Form", "i:6", "b:19.6"}],
    Cell[62597, 1825, 116, 3, 33, "Output",
      CellTags->{"Kalman Form", "i:6", "b:19.6"}],
    Cell[62716, 1830, 113, 3, 33, "Output",
      CellTags->{"Kalman Form", "i:6", "b:19.6"}],
    Cell[62866, 1838, 365, 9, 99, "Input",
      CellTags->{"Kalman Form", "i:6", "b:19.6"}],
    Cell[63234, 1849, 160, 3, 29, "Print",
      CellTags->{"Kalman Form", "i:6", "b:19.6"}],
    Cell[63397, 1854, 173, 4, 29, "Print",
      CellTags->{"Kalman Form", "i:6", "b:19.6"}],
    Cell[63573, 1860, 132, 3, 29, "Print",
      CellTags->{"Kalman Form", "i:6", "b:19.6"}],
    Cell[63708, 1865, 175, 4, 29, "Print",
      CellTags->{"Kalman Form", "i:6", "b:19.6"}],
    Cell[63886, 1871, 349, 10, 65, "Output",
      CellTags->{"Kalman Form", "i:6", "b:19.6"}],
    Cell[64238, 1883, 334, 10, 65, "Output",
      CellTags->{"Kalman Form", "i:6", "b:19.6"}],
    Cell[64575, 1895, 291, 8, 43, "Output",
      CellTags->{"Kalman Form", "i:6", "b:19.6"}],
    Cell[64869, 1905, 286, 8, 43, "Output",
      CellTags->{"Kalman Form", "i:6", "b:19.6"}],
    Cell[65170, 1916, 264, 5, 59, "Input",
      CellTags->{"Kalman Form", "i:6", "b:19.6"}],
    Cell[65459, 1925, 322, 8, 86, "Input",
      CellTags->{"Kalman Form", "i:6", "b:19.6"}],
    Cell[65784, 1935, 160, 3, 29, "Print",
      CellTags->{"Kalman Form", "i:6", "b:19.6"}],
    Cell[65947, 1940, 173, 4, 29, "Print",
      CellTags->{"Kalman Form", "i:6", "b:19.6"}],
    Cell[66123, 1946, 175, 4, 29, "Print",
      CellTags->{"Kalman Form", "i:6", "b:19.6"}],
    Cell[66301, 1952, 132, 3, 29, "Print",
      CellTags->{"Kalman Form", "i:6", "b:19.6"}],
    Cell[66436, 1957, 355, 10, 65, "Output",
      CellTags->{"Kalman Form", "i:6", "b:19.6"}],
    Cell[66794, 1969, 334, 10, 65, "Output",
      CellTags->{"Kalman Form", "i:6", "b:19.6"}],
    Cell[67131, 1981, 294, 8, 43, "Output",
      CellTags->{"Kalman Form", "i:6", "b:19.6"}],
    Cell[67428, 1991, 286, 8, 43, "Output",
      CellTags->{"Kalman Form", "i:6", "b:19.6"}],
    Cell[67751, 2004, 365, 9, 99, "Input",
      CellTags->{"Kalman Form", "i:6", "b:19.6"}],
    Cell[68119, 2015, 160, 3, 29, "Print",
      CellTags->{"Kalman Form", "i:6", "b:19.6"}],
    Cell[68282, 2020, 173, 4, 29, "Print",
      CellTags->{"Kalman Form", "i:6", "b:19.6"}],
    Cell[68458, 2026, 175, 4, 29, "Print",
      CellTags->{"Kalman Form", "i:6", "b:19.6"}],
    Cell[68636, 2032, 132, 3, 29, "Print",
      CellTags->{"Kalman Form", "i:6", "b:19.6"}],
    Cell[68771, 2037, 355, 10, 65, "Output",
      CellTags->{"Kalman Form", "i:6", "b:19.6"}],
    Cell[69129, 2049, 334, 10, 65, "Output",
      CellTags->{"Kalman Form", "i:6", "b:19.6"}],
    Cell[69466, 2061, 294, 8, 43, "Output",
      CellTags->{"Kalman Form", "i:6", "b:19.6"}],
    Cell[69763, 2071, 286, 8, 43, "Output",
      CellTags->{"Kalman Form", "i:6", "b:19.6"}],
    Cell[70064, 2082, 264, 5, 59, "Input",
      CellTags->{"Kalman Form", "i:6", "b:19.6"}],
    Cell[70353, 2091, 322, 8, 96, "Input",
      CellTags->{"Kalman Form", "i:6", "b:19.6"}],
    Cell[70678, 2101, 161, 3, 29, "Print",
      CellTags->{"Kalman Form", "i:6", "b:19.6"}],
    Cell[70842, 2106, 174, 4, 29, "Print",
      CellTags->{"Kalman Form", "i:6", "b:19.6"}],
    Cell[71019, 2112, 285, 8, 43, "Output",
      CellTags->{"Kalman Form", "i:6", "b:19.6"}],
    Cell[71307, 2122, 287, 8, 43, "Output",
      CellTags->{"Kalman Form", "i:6", "b:19.6"}],
    Cell[71597, 2132, 282, 8, 43, "Output",
      CellTags->{"Kalman Form", "i:6", "b:19.6"}],
    Cell[71882, 2142, 287, 8, 43, "Output",
      CellTags->{"Kalman Form", "i:6", "b:19.6"}]},
  "i:6"->{
    Cell[59022, 1707, 121, 1, 54, "Subsection",
      CellTags->{"Kalman Form", "i:6", "b:19.6"}],
    Cell[59146, 1710, 442, 7, 61, "Text",
      CellTags->{"Kalman Form", "i:6", "b:19.6"}],
    Cell[59591, 1719, 249, 5, 59, "Input",
      CellTags->{"Kalman Form", "i:6", "b:19.6"}],
    Cell[59865, 1728, 322, 8, 86, "Input",
      CellTags->{"Kalman Form", "i:6", "b:19.6"}],
    Cell[60190, 1738, 160, 3, 29, "Print",
      CellTags->{"Kalman Form", "i:6", "b:19.6"}],
    Cell[60353, 1743, 173, 4, 29, "Print",
      CellTags->{"Kalman Form", "i:6", "b:19.6"}],
    Cell[60529, 1749, 132, 3, 29, "Print",
      CellTags->{"Kalman Form", "i:6", "b:19.6"}],
    Cell[60664, 1754, 175, 4, 29, "Print",
      CellTags->{"Kalman Form", "i:6", "b:19.6"}],
    Cell[60842, 1760, 349, 10, 65, "Output",
      CellTags->{"Kalman Form", "i:6", "b:19.6"}],
    Cell[61194, 1772, 334, 10, 65, "Output",
      CellTags->{"Kalman Form", "i:6", "b:19.6"}],
    Cell[61531, 1784, 291, 8, 43, "Output",
      CellTags->{"Kalman Form", "i:6", "b:19.6"}],
    Cell[61825, 1794, 286, 8, 43, "Output",
      CellTags->{"Kalman Form", "i:6", "b:19.6"}],
    Cell[62148, 1807, 173, 6, 72, "Input",
      CellTags->{"Kalman Form", "i:6", "b:19.6"}],
    Cell[62324, 1815, 138, 3, 33, "Output",
      CellTags->{"Kalman Form", "i:6", "b:19.6"}],
    Cell[62465, 1820, 129, 3, 33, "Output",
      CellTags->{"Kalman Form", "i:6", "b:19.6"}],
    Cell[62597, 1825, 116, 3, 33, "Output",
      CellTags->{"Kalman Form", "i:6", "b:19.6"}],
    Cell[62716, 1830, 113, 3, 33, "Output",
      CellTags->{"Kalman Form", "i:6", "b:19.6"}],
    Cell[62866, 1838, 365, 9, 99, "Input",
      CellTags->{"Kalman Form", "i:6", "b:19.6"}],
    Cell[63234, 1849, 160, 3, 29, "Print",
      CellTags->{"Kalman Form", "i:6", "b:19.6"}],
    Cell[63397, 1854, 173, 4, 29, "Print",
      CellTags->{"Kalman Form", "i:6", "b:19.6"}],
    Cell[63573, 1860, 132, 3, 29, "Print",
      CellTags->{"Kalman Form", "i:6", "b:19.6"}],
    Cell[63708, 1865, 175, 4, 29, "Print",
      CellTags->{"Kalman Form", "i:6", "b:19.6"}],
    Cell[63886, 1871, 349, 10, 65, "Output",
      CellTags->{"Kalman Form", "i:6", "b:19.6"}],
    Cell[64238, 1883, 334, 10, 65, "Output",
      CellTags->{"Kalman Form", "i:6", "b:19.6"}],
    Cell[64575, 1895, 291, 8, 43, "Output",
      CellTags->{"Kalman Form", "i:6", "b:19.6"}],
    Cell[64869, 1905, 286, 8, 43, "Output",
      CellTags->{"Kalman Form", "i:6", "b:19.6"}],
    Cell[65170, 1916, 264, 5, 59, "Input",
      CellTags->{"Kalman Form", "i:6", "b:19.6"}],
    Cell[65459, 1925, 322, 8, 86, "Input",
      CellTags->{"Kalman Form", "i:6", "b:19.6"}],
    Cell[65784, 1935, 160, 3, 29, "Print",
      CellTags->{"Kalman Form", "i:6", "b:19.6"}],
    Cell[65947, 1940, 173, 4, 29, "Print",
      CellTags->{"Kalman Form", "i:6", "b:19.6"}],
    Cell[66123, 1946, 175, 4, 29, "Print",
      CellTags->{"Kalman Form", "i:6", "b:19.6"}],
    Cell[66301, 1952, 132, 3, 29, "Print",
      CellTags->{"Kalman Form", "i:6", "b:19.6"}],
    Cell[66436, 1957, 355, 10, 65, "Output",
      CellTags->{"Kalman Form", "i:6", "b:19.6"}],
    Cell[66794, 1969, 334, 10, 65, "Output",
      CellTags->{"Kalman Form", "i:6", "b:19.6"}],
    Cell[67131, 1981, 294, 8, 43, "Output",
      CellTags->{"Kalman Form", "i:6", "b:19.6"}],
    Cell[67428, 1991, 286, 8, 43, "Output",
      CellTags->{"Kalman Form", "i:6", "b:19.6"}],
    Cell[67751, 2004, 365, 9, 99, "Input",
      CellTags->{"Kalman Form", "i:6", "b:19.6"}],
    Cell[68119, 2015, 160, 3, 29, "Print",
      CellTags->{"Kalman Form", "i:6", "b:19.6"}],
    Cell[68282, 2020, 173, 4, 29, "Print",
      CellTags->{"Kalman Form", "i:6", "b:19.6"}],
    Cell[68458, 2026, 175, 4, 29, "Print",
      CellTags->{"Kalman Form", "i:6", "b:19.6"}],
    Cell[68636, 2032, 132, 3, 29, "Print",
      CellTags->{"Kalman Form", "i:6", "b:19.6"}],
    Cell[68771, 2037, 355, 10, 65, "Output",
      CellTags->{"Kalman Form", "i:6", "b:19.6"}],
    Cell[69129, 2049, 334, 10, 65, "Output",
      CellTags->{"Kalman Form", "i:6", "b:19.6"}],
    Cell[69466, 2061, 294, 8, 43, "Output",
      CellTags->{"Kalman Form", "i:6", "b:19.6"}],
    Cell[69763, 2071, 286, 8, 43, "Output",
      CellTags->{"Kalman Form", "i:6", "b:19.6"}],
    Cell[70064, 2082, 264, 5, 59, "Input",
      CellTags->{"Kalman Form", "i:6", "b:19.6"}],
    Cell[70353, 2091, 322, 8, 96, "Input",
      CellTags->{"Kalman Form", "i:6", "b:19.6"}],
    Cell[70678, 2101, 161, 3, 29, "Print",
      CellTags->{"Kalman Form", "i:6", "b:19.6"}],
    Cell[70842, 2106, 174, 4, 29, "Print",
      CellTags->{"Kalman Form", "i:6", "b:19.6"}],
    Cell[71019, 2112, 285, 8, 43, "Output",
      CellTags->{"Kalman Form", "i:6", "b:19.6"}],
    Cell[71307, 2122, 287, 8, 43, "Output",
      CellTags->{"Kalman Form", "i:6", "b:19.6"}],
    Cell[71597, 2132, 282, 8, 43, "Output",
      CellTags->{"Kalman Form", "i:6", "b:19.6"}],
    Cell[71882, 2142, 287, 8, 43, "Output",
      CellTags->{"Kalman Form", "i:6", "b:19.6"}]},
  "b:19.6"->{
    Cell[59022, 1707, 121, 1, 54, "Subsection",
      CellTags->{"Kalman Form", "i:6", "b:19.6"}],
    Cell[59146, 1710, 442, 7, 61, "Text",
      CellTags->{"Kalman Form", "i:6", "b:19.6"}],
    Cell[59591, 1719, 249, 5, 59, "Input",
      CellTags->{"Kalman Form", "i:6", "b:19.6"}],
    Cell[59865, 1728, 322, 8, 86, "Input",
      CellTags->{"Kalman Form", "i:6", "b:19.6"}],
    Cell[60190, 1738, 160, 3, 29, "Print",
      CellTags->{"Kalman Form", "i:6", "b:19.6"}],
    Cell[60353, 1743, 173, 4, 29, "Print",
      CellTags->{"Kalman Form", "i:6", "b:19.6"}],
    Cell[60529, 1749, 132, 3, 29, "Print",
      CellTags->{"Kalman Form", "i:6", "b:19.6"}],
    Cell[60664, 1754, 175, 4, 29, "Print",
      CellTags->{"Kalman Form", "i:6", "b:19.6"}],
    Cell[60842, 1760, 349, 10, 65, "Output",
      CellTags->{"Kalman Form", "i:6", "b:19.6"}],
    Cell[61194, 1772, 334, 10, 65, "Output",
      CellTags->{"Kalman Form", "i:6", "b:19.6"}],
    Cell[61531, 1784, 291, 8, 43, "Output",
      CellTags->{"Kalman Form", "i:6", "b:19.6"}],
    Cell[61825, 1794, 286, 8, 43, "Output",
      CellTags->{"Kalman Form", "i:6", "b:19.6"}],
    Cell[62148, 1807, 173, 6, 72, "Input",
      CellTags->{"Kalman Form", "i:6", "b:19.6"}],
    Cell[62324, 1815, 138, 3, 33, "Output",
      CellTags->{"Kalman Form", "i:6", "b:19.6"}],
    Cell[62465, 1820, 129, 3, 33, "Output",
      CellTags->{"Kalman Form", "i:6", "b:19.6"}],
    Cell[62597, 1825, 116, 3, 33, "Output",
      CellTags->{"Kalman Form", "i:6", "b:19.6"}],
    Cell[62716, 1830, 113, 3, 33, "Output",
      CellTags->{"Kalman Form", "i:6", "b:19.6"}],
    Cell[62866, 1838, 365, 9, 99, "Input",
      CellTags->{"Kalman Form", "i:6", "b:19.6"}],
    Cell[63234, 1849, 160, 3, 29, "Print",
      CellTags->{"Kalman Form", "i:6", "b:19.6"}],
    Cell[63397, 1854, 173, 4, 29, "Print",
      CellTags->{"Kalman Form", "i:6", "b:19.6"}],
    Cell[63573, 1860, 132, 3, 29, "Print",
      CellTags->{"Kalman Form", "i:6", "b:19.6"}],
    Cell[63708, 1865, 175, 4, 29, "Print",
      CellTags->{"Kalman Form", "i:6", "b:19.6"}],
    Cell[63886, 1871, 349, 10, 65, "Output",
      CellTags->{"Kalman Form", "i:6", "b:19.6"}],
    Cell[64238, 1883, 334, 10, 65, "Output",
      CellTags->{"Kalman Form", "i:6", "b:19.6"}],
    Cell[64575, 1895, 291, 8, 43, "Output",
      CellTags->{"Kalman Form", "i:6", "b:19.6"}],
    Cell[64869, 1905, 286, 8, 43, "Output",
      CellTags->{"Kalman Form", "i:6", "b:19.6"}],
    Cell[65170, 1916, 264, 5, 59, "Input",
      CellTags->{"Kalman Form", "i:6", "b:19.6"}],
    Cell[65459, 1925, 322, 8, 86, "Input",
      CellTags->{"Kalman Form", "i:6", "b:19.6"}],
    Cell[65784, 1935, 160, 3, 29, "Print",
      CellTags->{"Kalman Form", "i:6", "b:19.6"}],
    Cell[65947, 1940, 173, 4, 29, "Print",
      CellTags->{"Kalman Form", "i:6", "b:19.6"}],
    Cell[66123, 1946, 175, 4, 29, "Print",
      CellTags->{"Kalman Form", "i:6", "b:19.6"}],
    Cell[66301, 1952, 132, 3, 29, "Print",
      CellTags->{"Kalman Form", "i:6", "b:19.6"}],
    Cell[66436, 1957, 355, 10, 65, "Output",
      CellTags->{"Kalman Form", "i:6", "b:19.6"}],
    Cell[66794, 1969, 334, 10, 65, "Output",
      CellTags->{"Kalman Form", "i:6", "b:19.6"}],
    Cell[67131, 1981, 294, 8, 43, "Output",
      CellTags->{"Kalman Form", "i:6", "b:19.6"}],
    Cell[67428, 1991, 286, 8, 43, "Output",
      CellTags->{"Kalman Form", "i:6", "b:19.6"}],
    Cell[67751, 2004, 365, 9, 99, "Input",
      CellTags->{"Kalman Form", "i:6", "b:19.6"}],
    Cell[68119, 2015, 160, 3, 29, "Print",
      CellTags->{"Kalman Form", "i:6", "b:19.6"}],
    Cell[68282, 2020, 173, 4, 29, "Print",
      CellTags->{"Kalman Form", "i:6", "b:19.6"}],
    Cell[68458, 2026, 175, 4, 29, "Print",
      CellTags->{"Kalman Form", "i:6", "b:19.6"}],
    Cell[68636, 2032, 132, 3, 29, "Print",
      CellTags->{"Kalman Form", "i:6", "b:19.6"}],
    Cell[68771, 2037, 355, 10, 65, "Output",
      CellTags->{"Kalman Form", "i:6", "b:19.6"}],
    Cell[69129, 2049, 334, 10, 65, "Output",
      CellTags->{"Kalman Form", "i:6", "b:19.6"}],
    Cell[69466, 2061, 294, 8, 43, "Output",
      CellTags->{"Kalman Form", "i:6", "b:19.6"}],
    Cell[69763, 2071, 286, 8, 43, "Output",
      CellTags->{"Kalman Form", "i:6", "b:19.6"}],
    Cell[70064, 2082, 264, 5, 59, "Input",
      CellTags->{"Kalman Form", "i:6", "b:19.6"}],
    Cell[70353, 2091, 322, 8, 96, "Input",
      CellTags->{"Kalman Form", "i:6", "b:19.6"}],
    Cell[70678, 2101, 161, 3, 29, "Print",
      CellTags->{"Kalman Form", "i:6", "b:19.6"}],
    Cell[70842, 2106, 174, 4, 29, "Print",
      CellTags->{"Kalman Form", "i:6", "b:19.6"}],
    Cell[71019, 2112, 285, 8, 43, "Output",
      CellTags->{"Kalman Form", "i:6", "b:19.6"}],
    Cell[71307, 2122, 287, 8, 43, "Output",
      CellTags->{"Kalman Form", "i:6", "b:19.6"}],
    Cell[71597, 2132, 282, 8, 43, "Output",
      CellTags->{"Kalman Form", "i:6", "b:19.6"}],
    Cell[71882, 2142, 287, 8, 43, "Output",
      CellTags->{"Kalman Form", "i:6", "b:19.6"}]},
  "Another Example"->{
    Cell[72218, 2156, 155, 3, 54, "Subsection",
      Evaluatable->False,
      CellTags->{"Another Example", "b:19.7"}],
    Cell[72376, 2161, 204, 6, 35, "Text",
      Evaluatable->False,
      CellTags->{"Another Example", "b:19.7"}],
    Cell[72605, 2171, 254, 6, 43, "Input",
      CellTags->{"Another Example", "b:19.7"}],
    Cell[72862, 2179, 201, 4, 43, "Output",
      CellTags->{"Another Example", "b:19.7"}],
    Cell[73100, 2188, 199, 5, 43, "Input",
      CellTags->{"Another Example", "b:19.7"}],
    Cell[73302, 2195, 148, 3, 43, "Output",
      CellTags->{"Another Example", "b:19.7"}],
    Cell[73487, 2203, 184, 5, 43, "Input",
      CellTags->{"Another Example", "b:19.7"}],
    Cell[73674, 2210, 131, 3, 43, "Output",
      CellTags->{"Another Example", "b:19.7"}],
    Cell[73820, 2216, 151, 3, 35, "Text",
      Evaluatable->False,
      CellTags->{"Another Example", "b:19.7"}],
    Cell[73996, 2223, 175, 5, 43, "Input",
      CellTags->{"Another Example", "b:19.7"}],
    Cell[74174, 2230, 107, 3, 43, "Output",
      CellTags->{"Another Example", "b:19.7"}],
    Cell[74318, 2238, 173, 5, 43, "Input",
      CellTags->{"Another Example", "b:19.7"}],
    Cell[74494, 2245, 107, 3, 43, "Output",
      CellTags->{"Another Example", "b:19.7"}],
    Cell[74616, 2251, 148, 3, 35, "Text",
      Evaluatable->False,
      CellTags->{"Another Example", "b:19.7"}],
    Cell[74767, 2256, 203, 5, 43, "Input",
      CellTags->{"Another Example", "b:19.7"}],
    Cell[74995, 2265, 155, 5, 43, "Input",
      CellTags->{"Another Example", "b:19.7"}],
    Cell[75153, 2272, 487, 8, 74, "Output",
      CellTags->{"Another Example", "b:19.7"}],
    Cell[75655, 2283, 179, 5, 35, "Text",
      Evaluatable->False,
      CellTags->{"Another Example", "b:19.7"}],
    Cell[75859, 2292, 171, 5, 43, "Input",
      CellTags->{"Another Example", "b:19.7"}],
    Cell[76033, 2299, 104, 3, 43, "Output",
      CellTags->{"Another Example", "b:19.7"}],
    Cell[76174, 2307, 173, 5, 43, "Input",
      CellTags->{"Another Example", "b:19.7"}],
    Cell[76350, 2314, 1639, 42, 75, "Output",
      CellTags->{"Another Example", "b:19.7"}],
    Cell[78004, 2359, 202, 6, 35, "Text",
      Evaluatable->False,
      CellTags->{"Another Example", "b:19.7"}],
    Cell[78231, 2369, 180, 5, 43, "Input",
      CellTags->{"Another Example", "b:19.7"}],
    Cell[78414, 2376, 678, 11, 96, "Output",
      CellTags->{"Another Example", "b:19.7"}],
    Cell[79129, 2392, 178, 5, 43, "Input",
      CellTags->{"Another Example", "b:19.7"}],
    Cell[79310, 2399, 676, 11, 96, "Output",
      CellTags->{"Another Example", "b:19.7"}],
    Cell[80001, 2413, 215, 6, 35, "Text",
      Evaluatable->False,
      CellTags->{"Another Example", "b:19.7"}],
    Cell[80219, 2421, 354, 9, 43, "Input",
      CellTags->{"Another Example", "b:19.7"}],
    Cell[80598, 2434, 156, 5, 43, "Input",
      CellTags->{"Another Example", "b:19.7"}],
    Cell[80757, 2441, 239, 4, 51, "Output",
      CellTags->{"Another Example", "b:19.7"}],
    Cell[81033, 2450, 172, 5, 43, "Input",
      CellTags->{"Another Example", "b:19.7"}],
    Cell[81208, 2457, 104, 3, 43, "Output",
      CellTags->{"Another Example", "b:19.7"}],
    Cell[81349, 2465, 179, 5, 43, "Input",
      CellTags->{"Another Example", "b:19.7"}],
    Cell[81531, 2472, 270, 5, 56, "Output",
      CellTags->{"Another Example", "b:19.7"}],
    Cell[81838, 2482, 251, 7, 43, "Input",
      CellTags->{"Another Example", "b:19.7"}],
    Cell[82092, 2491, 108, 3, 43, "Output",
      CellTags->{"Another Example", "b:19.7"}],
    Cell[82237, 2499, 207, 5, 43, "Input",
      CellTags->{"Another Example", "b:19.7"}],
    Cell[82447, 2506, 223, 4, 43, "Output",
      CellTags->{"Another Example", "b:19.7"}],
    Cell[82707, 2515, 249, 7, 43, "Input",
      CellTags->{"Another Example", "b:19.7"}],
    Cell[82959, 2524, 107, 3, 43, "Output",
      CellTags->{"Another Example", "b:19.7"}],
    Cell[83103, 2532, 205, 5, 43, "Input",
      CellTags->{"Another Example", "b:19.7"}],
    Cell[83311, 2539, 209, 4, 43, "Output",
      CellTags->{"Another Example", "b:19.7"}]},
  "b:19.7"->{
    Cell[72218, 2156, 155, 3, 54, "Subsection",
      Evaluatable->False,
      CellTags->{"Another Example", "b:19.7"}],
    Cell[72376, 2161, 204, 6, 35, "Text",
      Evaluatable->False,
      CellTags->{"Another Example", "b:19.7"}],
    Cell[72605, 2171, 254, 6, 43, "Input",
      CellTags->{"Another Example", "b:19.7"}],
    Cell[72862, 2179, 201, 4, 43, "Output",
      CellTags->{"Another Example", "b:19.7"}],
    Cell[73100, 2188, 199, 5, 43, "Input",
      CellTags->{"Another Example", "b:19.7"}],
    Cell[73302, 2195, 148, 3, 43, "Output",
      CellTags->{"Another Example", "b:19.7"}],
    Cell[73487, 2203, 184, 5, 43, "Input",
      CellTags->{"Another Example", "b:19.7"}],
    Cell[73674, 2210, 131, 3, 43, "Output",
      CellTags->{"Another Example", "b:19.7"}],
    Cell[73820, 2216, 151, 3, 35, "Text",
      Evaluatable->False,
      CellTags->{"Another Example", "b:19.7"}],
    Cell[73996, 2223, 175, 5, 43, "Input",
      CellTags->{"Another Example", "b:19.7"}],
    Cell[74174, 2230, 107, 3, 43, "Output",
      CellTags->{"Another Example", "b:19.7"}],
    Cell[74318, 2238, 173, 5, 43, "Input",
      CellTags->{"Another Example", "b:19.7"}],
    Cell[74494, 2245, 107, 3, 43, "Output",
      CellTags->{"Another Example", "b:19.7"}],
    Cell[74616, 2251, 148, 3, 35, "Text",
      Evaluatable->False,
      CellTags->{"Another Example", "b:19.7"}],
    Cell[74767, 2256, 203, 5, 43, "Input",
      CellTags->{"Another Example", "b:19.7"}],
    Cell[74995, 2265, 155, 5, 43, "Input",
      CellTags->{"Another Example", "b:19.7"}],
    Cell[75153, 2272, 487, 8, 74, "Output",
      CellTags->{"Another Example", "b:19.7"}],
    Cell[75655, 2283, 179, 5, 35, "Text",
      Evaluatable->False,
      CellTags->{"Another Example", "b:19.7"}],
    Cell[75859, 2292, 171, 5, 43, "Input",
      CellTags->{"Another Example", "b:19.7"}],
    Cell[76033, 2299, 104, 3, 43, "Output",
      CellTags->{"Another Example", "b:19.7"}],
    Cell[76174, 2307, 173, 5, 43, "Input",
      CellTags->{"Another Example", "b:19.7"}],
    Cell[76350, 2314, 1639, 42, 75, "Output",
      CellTags->{"Another Example", "b:19.7"}],
    Cell[78004, 2359, 202, 6, 35, "Text",
      Evaluatable->False,
      CellTags->{"Another Example", "b:19.7"}],
    Cell[78231, 2369, 180, 5, 43, "Input",
      CellTags->{"Another Example", "b:19.7"}],
    Cell[78414, 2376, 678, 11, 96, "Output",
      CellTags->{"Another Example", "b:19.7"}],
    Cell[79129, 2392, 178, 5, 43, "Input",
      CellTags->{"Another Example", "b:19.7"}],
    Cell[79310, 2399, 676, 11, 96, "Output",
      CellTags->{"Another Example", "b:19.7"}],
    Cell[80001, 2413, 215, 6, 35, "Text",
      Evaluatable->False,
      CellTags->{"Another Example", "b:19.7"}],
    Cell[80219, 2421, 354, 9, 43, "Input",
      CellTags->{"Another Example", "b:19.7"}],
    Cell[80598, 2434, 156, 5, 43, "Input",
      CellTags->{"Another Example", "b:19.7"}],
    Cell[80757, 2441, 239, 4, 51, "Output",
      CellTags->{"Another Example", "b:19.7"}],
    Cell[81033, 2450, 172, 5, 43, "Input",
      CellTags->{"Another Example", "b:19.7"}],
    Cell[81208, 2457, 104, 3, 43, "Output",
      CellTags->{"Another Example", "b:19.7"}],
    Cell[81349, 2465, 179, 5, 43, "Input",
      CellTags->{"Another Example", "b:19.7"}],
    Cell[81531, 2472, 270, 5, 56, "Output",
      CellTags->{"Another Example", "b:19.7"}],
    Cell[81838, 2482, 251, 7, 43, "Input",
      CellTags->{"Another Example", "b:19.7"}],
    Cell[82092, 2491, 108, 3, 43, "Output",
      CellTags->{"Another Example", "b:19.7"}],
    Cell[82237, 2499, 207, 5, 43, "Input",
      CellTags->{"Another Example", "b:19.7"}],
    Cell[82447, 2506, 223, 4, 43, "Output",
      CellTags->{"Another Example", "b:19.7"}],
    Cell[82707, 2515, 249, 7, 43, "Input",
      CellTags->{"Another Example", "b:19.7"}],
    Cell[82959, 2524, 107, 3, 43, "Output",
      CellTags->{"Another Example", "b:19.7"}],
    Cell[83103, 2532, 205, 5, 43, "Input",
      CellTags->{"Another Example", "b:19.7"}],
    Cell[83311, 2539, 209, 4, 43, "Output",
      CellTags->{"Another Example", "b:19.7"}]},
  "Introduction"->{
    Cell[83691, 2556, 122, 3, 54, "Subsection",
      Evaluatable->False,
      CellTags->{"Introduction", "b:20.0"}],
    Cell[83816, 2561, 326, 7, 48, "Text",
      Evaluatable->False,
      CellTags->{"Introduction", "b:20.0"}]},
  "b:20.0"->{
    Cell[83691, 2556, 122, 3, 54, "Subsection",
      Evaluatable->False,
      CellTags->{"Introduction", "b:20.0"}],
    Cell[83816, 2561, 326, 7, 48, "Text",
      Evaluatable->False,
      CellTags->{"Introduction", "b:20.0"}]},
  "Bode plot"->{
    Cell[84179, 2573, 123, 3, 54, "Subsection",
      Evaluatable->False,
      CellTags->{"Bode plot", "i:9", "b:20.1"}],
    Cell[84305, 2578, 139, 3, 35, "Text",
      Evaluatable->False,
      CellTags->{"Bode plot", "i:9", "b:20.1"}],
    Cell[84447, 2583, 255, 6, 54, "Input",
      CellTags->{"Bode plot", "i:9", "b:20.1"}],
    Cell[84705, 2591, 227, 6, 35, "Text",
      Evaluatable->False,
      CellTags->{"Bode plot", "i:9", "b:20.1"}],
    Cell[84957, 2601, 172, 5, 43, "Input",
      CellTags->{"Bode plot", "i:9", "b:20.1"}],
    Cell[85154, 2610, 55774, 1794, 192, 31470, 1488, "GraphicsData", 
    "PostScript", "Graphics",
      CellTags->{"Bode plot", "i:9", "b:20.1"}],
    Cell[140931, 4406, 56161, 1796, 192, 31696, 1488, "GraphicsData", 
    "PostScript", "Graphics",
      CellTags->{"Bode plot", "i:9", "b:20.1"}],
    Cell[197107, 6205, 378, 10, 43, "Output",
      CellTags->{"Bode plot", "i:9", "b:20.1"}],
    Cell[197500, 6218, 153, 4, 35, "Text",
      CellTags->{"Bode plot", "i:9", "b:20.1"}],
    Cell[197678, 6226, 274, 6, 68, "Input",
      CellTags->{"Bode plot", "i:9", "b:20.1"}],
    Cell[197977, 6236, 54493, 1812, 189, 31704, 1525, "GraphicsData", 
    "PostScript", "Graphics",
      CellTags->{"Bode plot", "i:9", "b:20.1"}],
    Cell[252473, 8050, 66076, 2555, 189, 42935, 2264, "GraphicsData", 
    "PostScript", "Graphics",
      CellTags->{"Bode plot", "i:9", "b:20.1"}],
    Cell[318564, 10608, 378, 10, 43, "Output",
      CellTags->{"Bode plot", "i:9", "b:20.1"}]},
  "i:9"->{
    Cell[84179, 2573, 123, 3, 54, "Subsection",
      Evaluatable->False,
      CellTags->{"Bode plot", "i:9", "b:20.1"}],
    Cell[84305, 2578, 139, 3, 35, "Text",
      Evaluatable->False,
      CellTags->{"Bode plot", "i:9", "b:20.1"}],
    Cell[84447, 2583, 255, 6, 54, "Input",
      CellTags->{"Bode plot", "i:9", "b:20.1"}],
    Cell[84705, 2591, 227, 6, 35, "Text",
      Evaluatable->False,
      CellTags->{"Bode plot", "i:9", "b:20.1"}],
    Cell[84957, 2601, 172, 5, 43, "Input",
      CellTags->{"Bode plot", "i:9", "b:20.1"}],
    Cell[85154, 2610, 55774, 1794, 192, 31470, 1488, "GraphicsData", 
    "PostScript", "Graphics",
      CellTags->{"Bode plot", "i:9", "b:20.1"}],
    Cell[140931, 4406, 56161, 1796, 192, 31696, 1488, "GraphicsData", 
    "PostScript", "Graphics",
      CellTags->{"Bode plot", "i:9", "b:20.1"}],
    Cell[197107, 6205, 378, 10, 43, "Output",
      CellTags->{"Bode plot", "i:9", "b:20.1"}],
    Cell[197500, 6218, 153, 4, 35, "Text",
      CellTags->{"Bode plot", "i:9", "b:20.1"}],
    Cell[197678, 6226, 274, 6, 68, "Input",
      CellTags->{"Bode plot", "i:9", "b:20.1"}],
    Cell[197977, 6236, 54493, 1812, 189, 31704, 1525, "GraphicsData", 
    "PostScript", "Graphics",
      CellTags->{"Bode plot", "i:9", "b:20.1"}],
    Cell[252473, 8050, 66076, 2555, 189, 42935, 2264, "GraphicsData", 
    "PostScript", "Graphics",
      CellTags->{"Bode plot", "i:9", "b:20.1"}],
    Cell[318564, 10608, 378, 10, 43, "Output",
      CellTags->{"Bode plot", "i:9", "b:20.1"}]},
  "b:20.1"->{
    Cell[84179, 2573, 123, 3, 54, "Subsection",
      Evaluatable->False,
      CellTags->{"Bode plot", "i:9", "b:20.1"}],
    Cell[84305, 2578, 139, 3, 35, "Text",
      Evaluatable->False,
      CellTags->{"Bode plot", "i:9", "b:20.1"}],
    Cell[84447, 2583, 255, 6, 54, "Input",
      CellTags->{"Bode plot", "i:9", "b:20.1"}],
    Cell[84705, 2591, 227, 6, 35, "Text",
      Evaluatable->False,
      CellTags->{"Bode plot", "i:9", "b:20.1"}],
    Cell[84957, 2601, 172, 5, 43, "Input",
      CellTags->{"Bode plot", "i:9", "b:20.1"}],
    Cell[85154, 2610, 55774, 1794, 192, 31470, 1488, "GraphicsData", 
    "PostScript", "Graphics",
      CellTags->{"Bode plot", "i:9", "b:20.1"}],
    Cell[140931, 4406, 56161, 1796, 192, 31696, 1488, "GraphicsData", 
    "PostScript", "Graphics",
      CellTags->{"Bode plot", "i:9", "b:20.1"}],
    Cell[197107, 6205, 378, 10, 43, "Output",
      CellTags->{"Bode plot", "i:9", "b:20.1"}],
    Cell[197500, 6218, 153, 4, 35, "Text",
      CellTags->{"Bode plot", "i:9", "b:20.1"}],
    Cell[197678, 6226, 274, 6, 68, "Input",
      CellTags->{"Bode plot", "i:9", "b:20.1"}],
    Cell[197977, 6236, 54493, 1812, 189, 31704, 1525, "GraphicsData", 
    "PostScript", "Graphics",
      CellTags->{"Bode plot", "i:9", "b:20.1"}],
    Cell[252473, 8050, 66076, 2555, 189, 42935, 2264, "GraphicsData", 
    "PostScript", "Graphics",
      CellTags->{"Bode plot", "i:9", "b:20.1"}],
    Cell[318564, 10608, 378, 10, 43, "Output",
      CellTags->{"Bode plot", "i:9", "b:20.1"}]},
  "Nyquist Plot"->{
    Cell[318991, 10624, 130, 3, 54, "Subsection",
      Evaluatable->False,
      CellTags->{"Nyquist Plot", "i:10", "b:20.2"}],
    Cell[319124, 10629, 216, 6, 35, "Text",
      Evaluatable->False,
      CellTags->{"Nyquist Plot", "i:10", "b:20.2"}],
    Cell[319343, 10637, 259, 6, 54, "Input",
      CellTags->{"Nyquist Plot", "i:10", "b:20.2"}],
    Cell[319627, 10647, 187, 5, 43, "Input",
      CellTags->{"Nyquist Plot", "i:10", "b:20.2"}],
    Cell[319817, 10654, 53660, 2128, 194, 29467, 1824, "GraphicsData", 
    "PostScript", "Graphics",
      CellTags->{"Nyquist Plot", "i:10", "b:20.2"}],
    Cell[373480, 12784, 204, 5, 43, "Output",
      CellTags->{"Nyquist Plot", "i:10", "b:20.2"}],
    Cell[373699, 12792, 164, 3, 35, "Text",
      Evaluatable->False,
      CellTags->{"Nyquist Plot", "i:10", "b:20.2"}],
    Cell[373888, 12799, 194, 5, 43, "Input",
      CellTags->{"Nyquist Plot", "i:10", "b:20.2"}],
    Cell[374085, 12806, 26628, 1030, 194, 14823, 879, "GraphicsData", 
    "PostScript", "Graphics",
      CellTags->{"Nyquist Plot", "i:10", "b:20.2"}],
    Cell[400716, 13838, 204, 5, 43, "Output",
      CellTags->{"Nyquist Plot", "i:10", "b:20.2"}],
    Cell[400935, 13846, 288, 7, 48, "Text",
      Evaluatable->False,
      CellTags->{"Nyquist Plot", "i:10", "b:20.2"}],
    Cell[401248, 13857, 205, 5, 43, "Input",
      CellTags->{"Nyquist Plot", "i:10", "b:20.2"}],
    Cell[401456, 13864, 189295, 10547, 402, 130862, 9820, "GraphicsData", 
    "PostScript", "Graphics",
      CellTags->{"Nyquist Plot", "i:10", "b:20.2"}],
    Cell[590754, 24413, 204, 5, 43, "Output",
      CellTags->{"Nyquist Plot", "i:10", "b:20.2"}],
    Cell[590973, 24421, 344, 6, 61, "Text",
      CellTags->{"Nyquist Plot", "i:10", "b:20.2"}],
    Cell[591342, 24431, 453, 9, 69, "Input",
      CellTags->{"Nyquist Plot", "i:10", "b:20.2"}],
    Cell[591798, 24442, 125195, 5345, 431, 67547, 4628, "GraphicsData", 
    "PostScript", "Graphics",
      CellTags->{"Nyquist Plot", "i:10", "b:20.2"}],
    Cell[716996, 29789, 204, 5, 43, "Output",
      CellTags->{"Nyquist Plot", "i:10", "b:20.2"}]},
  "i:10"->{
    Cell[318991, 10624, 130, 3, 54, "Subsection",
      Evaluatable->False,
      CellTags->{"Nyquist Plot", "i:10", "b:20.2"}],
    Cell[319124, 10629, 216, 6, 35, "Text",
      Evaluatable->False,
      CellTags->{"Nyquist Plot", "i:10", "b:20.2"}],
    Cell[319343, 10637, 259, 6, 54, "Input",
      CellTags->{"Nyquist Plot", "i:10", "b:20.2"}],
    Cell[319627, 10647, 187, 5, 43, "Input",
      CellTags->{"Nyquist Plot", "i:10", "b:20.2"}],
    Cell[319817, 10654, 53660, 2128, 194, 29467, 1824, "GraphicsData", 
    "PostScript", "Graphics",
      CellTags->{"Nyquist Plot", "i:10", "b:20.2"}],
    Cell[373480, 12784, 204, 5, 43, "Output",
      CellTags->{"Nyquist Plot", "i:10", "b:20.2"}],
    Cell[373699, 12792, 164, 3, 35, "Text",
      Evaluatable->False,
      CellTags->{"Nyquist Plot", "i:10", "b:20.2"}],
    Cell[373888, 12799, 194, 5, 43, "Input",
      CellTags->{"Nyquist Plot", "i:10", "b:20.2"}],
    Cell[374085, 12806, 26628, 1030, 194, 14823, 879, "GraphicsData", 
    "PostScript", "Graphics",
      CellTags->{"Nyquist Plot", "i:10", "b:20.2"}],
    Cell[400716, 13838, 204, 5, 43, "Output",
      CellTags->{"Nyquist Plot", "i:10", "b:20.2"}],
    Cell[400935, 13846, 288, 7, 48, "Text",
      Evaluatable->False,
      CellTags->{"Nyquist Plot", "i:10", "b:20.2"}],
    Cell[401248, 13857, 205, 5, 43, "Input",
      CellTags->{"Nyquist Plot", "i:10", "b:20.2"}],
    Cell[401456, 13864, 189295, 10547, 402, 130862, 9820, "GraphicsData", 
    "PostScript", "Graphics",
      CellTags->{"Nyquist Plot", "i:10", "b:20.2"}],
    Cell[590754, 24413, 204, 5, 43, "Output",
      CellTags->{"Nyquist Plot", "i:10", "b:20.2"}],
    Cell[590973, 24421, 344, 6, 61, "Text",
      CellTags->{"Nyquist Plot", "i:10", "b:20.2"}],
    Cell[591342, 24431, 453, 9, 69, "Input",
      CellTags->{"Nyquist Plot", "i:10", "b:20.2"}],
    Cell[591798, 24442, 125195, 5345, 431, 67547, 4628, "GraphicsData", 
    "PostScript", "Graphics",
      CellTags->{"Nyquist Plot", "i:10", "b:20.2"}],
    Cell[716996, 29789, 204, 5, 43, "Output",
      CellTags->{"Nyquist Plot", "i:10", "b:20.2"}]},
  "b:20.2"->{
    Cell[318991, 10624, 130, 3, 54, "Subsection",
      Evaluatable->False,
      CellTags->{"Nyquist Plot", "i:10", "b:20.2"}],
    Cell[319124, 10629, 216, 6, 35, "Text",
      Evaluatable->False,
      CellTags->{"Nyquist Plot", "i:10", "b:20.2"}],
    Cell[319343, 10637, 259, 6, 54, "Input",
      CellTags->{"Nyquist Plot", "i:10", "b:20.2"}],
    Cell[319627, 10647, 187, 5, 43, "Input",
      CellTags->{"Nyquist Plot", "i:10", "b:20.2"}],
    Cell[319817, 10654, 53660, 2128, 194, 29467, 1824, "GraphicsData", 
    "PostScript", "Graphics",
      CellTags->{"Nyquist Plot", "i:10", "b:20.2"}],
    Cell[373480, 12784, 204, 5, 43, "Output",
      CellTags->{"Nyquist Plot", "i:10", "b:20.2"}],
    Cell[373699, 12792, 164, 3, 35, "Text",
      Evaluatable->False,
      CellTags->{"Nyquist Plot", "i:10", "b:20.2"}],
    Cell[373888, 12799, 194, 5, 43, "Input",
      CellTags->{"Nyquist Plot", "i:10", "b:20.2"}],
    Cell[374085, 12806, 26628, 1030, 194, 14823, 879, "GraphicsData", 
    "PostScript", "Graphics",
      CellTags->{"Nyquist Plot", "i:10", "b:20.2"}],
    Cell[400716, 13838, 204, 5, 43, "Output",
      CellTags->{"Nyquist Plot", "i:10", "b:20.2"}],
    Cell[400935, 13846, 288, 7, 48, "Text",
      Evaluatable->False,
      CellTags->{"Nyquist Plot", "i:10", "b:20.2"}],
    Cell[401248, 13857, 205, 5, 43, "Input",
      CellTags->{"Nyquist Plot", "i:10", "b:20.2"}],
    Cell[401456, 13864, 189295, 10547, 402, 130862, 9820, "GraphicsData", 
    "PostScript", "Graphics",
      CellTags->{"Nyquist Plot", "i:10", "b:20.2"}],
    Cell[590754, 24413, 204, 5, 43, "Output",
      CellTags->{"Nyquist Plot", "i:10", "b:20.2"}],
    Cell[590973, 24421, 344, 6, 61, "Text",
      CellTags->{"Nyquist Plot", "i:10", "b:20.2"}],
    Cell[591342, 24431, 453, 9, 69, "Input",
      CellTags->{"Nyquist Plot", "i:10", "b:20.2"}],
    Cell[591798, 24442, 125195, 5345, 431, 67547, 4628, "GraphicsData", 
    "PostScript", "Graphics",
      CellTags->{"Nyquist Plot", "i:10", "b:20.2"}],
    Cell[716996, 29789, 204, 5, 43, "Output",
      CellTags->{"Nyquist Plot", "i:10", "b:20.2"}]},
  "Root Locus"->{
    Cell[717249, 29800, 126, 3, 54, "Subsection",
      Evaluatable->False,
      CellTags->{"Root Locus", "i:11", "b:20.3"}],
    Cell[717378, 29805, 412, 8, 61, "Text",
      Evaluatable->False,
      CellTags->{"Root Locus", "i:11", "b:20.3"}],
    Cell[717815, 29817, 191, 5, 43, "Input",
      CellTags->{"Root Locus", "i:11", "b:20.3"}],
    Cell[718009, 29824, 172, 4, 55, "Print",
      CellTags->{"Root Locus", "i:11", "b:20.3"}],
    Cell[718184, 29830, 116395, 2854, 465, 35031, 1844, "GraphicsData", 
    "PostScript", "Graphics",
      CellTags->{"Root Locus", "i:11", "b:20.3"}],
    Cell[834582, 32686, 202, 5, 43, "Output",
      CellTags->{"Root Locus", "i:11", "b:20.3"}],
    Cell[834787, 32693, 237, 5, 29, "Print",
      CellTags->{"Root Locus", "i:11", "b:20.3"}],
    Cell[835027, 32700, 146636, 3345, 565, 36843, 1984, "GraphicsData", 
    "PostScript", "Graphics",
      CellTags->{"Root Locus", "i:11", "b:20.3"}],
    Cell[981666, 36047, 202, 5, 43, "Output",
      CellTags->{"Root Locus", "i:11", "b:20.3"}],
    Cell[981905, 36057, 282, 5, 68, "Input",
      CellTags->{"Root Locus", "i:11", "b:20.3"}],
    Cell[982190, 36064, 172, 4, 55, "Print",
      CellTags->{"Root Locus", "i:11", "b:20.3"}],
    Cell[982365, 36070, 139858, 3325, 534, 38850, 2073, "GraphicsData", 
    "PostScript", "Graphics",
      CellTags->{"Root Locus", "i:11", "b:20.3"}],
    Cell[1122226, 39397, 202, 5, 43, "Output",
      CellTags->{"Root Locus", "i:11", "b:20.3"}],
    Cell[1122443, 39405, 210, 6, 35, "Text",
      Evaluatable->False,
      CellTags->{"Root Locus", "i:11", "b:20.3"}],
    Cell[1122678, 39415, 197, 5, 43, "Input",
      CellTags->{"Root Locus", "i:11", "b:20.3"}],
    Cell[1122878, 39422, 172, 4, 55, "Print",
      CellTags->{"Root Locus", "i:11", "b:20.3"}],
    Cell[1123053, 39428, 121244, 2962, 502, 36644, 1912, "GraphicsData", 
    "PostScript", "Graphics",
      CellTags->{"Root Locus", "i:11", "b:20.3"}],
    Cell[1244300, 42392, 202, 5, 43, "Output",
      CellTags->{"Root Locus", "i:11", "b:20.3"}]},
  "i:11"->{
    Cell[717249, 29800, 126, 3, 54, "Subsection",
      Evaluatable->False,
      CellTags->{"Root Locus", "i:11", "b:20.3"}],
    Cell[717378, 29805, 412, 8, 61, "Text",
      Evaluatable->False,
      CellTags->{"Root Locus", "i:11", "b:20.3"}],
    Cell[717815, 29817, 191, 5, 43, "Input",
      CellTags->{"Root Locus", "i:11", "b:20.3"}],
    Cell[718009, 29824, 172, 4, 55, "Print",
      CellTags->{"Root Locus", "i:11", "b:20.3"}],
    Cell[718184, 29830, 116395, 2854, 465, 35031, 1844, "GraphicsData", 
    "PostScript", "Graphics",
      CellTags->{"Root Locus", "i:11", "b:20.3"}],
    Cell[834582, 32686, 202, 5, 43, "Output",
      CellTags->{"Root Locus", "i:11", "b:20.3"}],
    Cell[834787, 32693, 237, 5, 29, "Print",
      CellTags->{"Root Locus", "i:11", "b:20.3"}],
    Cell[835027, 32700, 146636, 3345, 565, 36843, 1984, "GraphicsData", 
    "PostScript", "Graphics",
      CellTags->{"Root Locus", "i:11", "b:20.3"}],
    Cell[981666, 36047, 202, 5, 43, "Output",
      CellTags->{"Root Locus", "i:11", "b:20.3"}],
    Cell[981905, 36057, 282, 5, 68, "Input",
      CellTags->{"Root Locus", "i:11", "b:20.3"}],
    Cell[982190, 36064, 172, 4, 55, "Print",
      CellTags->{"Root Locus", "i:11", "b:20.3"}],
    Cell[982365, 36070, 139858, 3325, 534, 38850, 2073, "GraphicsData", 
    "PostScript", "Graphics",
      CellTags->{"Root Locus", "i:11", "b:20.3"}],
    Cell[1122226, 39397, 202, 5, 43, "Output",
      CellTags->{"Root Locus", "i:11", "b:20.3"}],
    Cell[1122443, 39405, 210, 6, 35, "Text",
      Evaluatable->False,
      CellTags->{"Root Locus", "i:11", "b:20.3"}],
    Cell[1122678, 39415, 197, 5, 43, "Input",
      CellTags->{"Root Locus", "i:11", "b:20.3"}],
    Cell[1122878, 39422, 172, 4, 55, "Print",
      CellTags->{"Root Locus", "i:11", "b:20.3"}],
    Cell[1123053, 39428, 121244, 2962, 502, 36644, 1912, "GraphicsData", 
    "PostScript", "Graphics",
      CellTags->{"Root Locus", "i:11", "b:20.3"}],
    Cell[1244300, 42392, 202, 5, 43, "Output",
      CellTags->{"Root Locus", "i:11", "b:20.3"}]},
  "b:20.3"->{
    Cell[717249, 29800, 126, 3, 54, "Subsection",
      Evaluatable->False,
      CellTags->{"Root Locus", "i:11", "b:20.3"}],
    Cell[717378, 29805, 412, 8, 61, "Text",
      Evaluatable->False,
      CellTags->{"Root Locus", "i:11", "b:20.3"}],
    Cell[717815, 29817, 191, 5, 43, "Input",
      CellTags->{"Root Locus", "i:11", "b:20.3"}],
    Cell[718009, 29824, 172, 4, 55, "Print",
      CellTags->{"Root Locus", "i:11", "b:20.3"}],
    Cell[718184, 29830, 116395, 2854, 465, 35031, 1844, "GraphicsData", 
    "PostScript", "Graphics",
      CellTags->{"Root Locus", "i:11", "b:20.3"}],
    Cell[834582, 32686, 202, 5, 43, "Output",
      CellTags->{"Root Locus", "i:11", "b:20.3"}],
    Cell[834787, 32693, 237, 5, 29, "Print",
      CellTags->{"Root Locus", "i:11", "b:20.3"}],
    Cell[835027, 32700, 146636, 3345, 565, 36843, 1984, "GraphicsData", 
    "PostScript", "Graphics",
      CellTags->{"Root Locus", "i:11", "b:20.3"}],
    Cell[981666, 36047, 202, 5, 43, "Output",
      CellTags->{"Root Locus", "i:11", "b:20.3"}],
    Cell[981905, 36057, 282, 5, 68, "Input",
      CellTags->{"Root Locus", "i:11", "b:20.3"}],
    Cell[982190, 36064, 172, 4, 55, "Print",
      CellTags->{"Root Locus", "i:11", "b:20.3"}],
    Cell[982365, 36070, 139858, 3325, 534, 38850, 2073, "GraphicsData", 
    "PostScript", "Graphics",
      CellTags->{"Root Locus", "i:11", "b:20.3"}],
    Cell[1122226, 39397, 202, 5, 43, "Output",
      CellTags->{"Root Locus", "i:11", "b:20.3"}],
    Cell[1122443, 39405, 210, 6, 35, "Text",
      Evaluatable->False,
      CellTags->{"Root Locus", "i:11", "b:20.3"}],
    Cell[1122678, 39415, 197, 5, 43, "Input",
      CellTags->{"Root Locus", "i:11", "b:20.3"}],
    Cell[1122878, 39422, 172, 4, 55, "Print",
      CellTags->{"Root Locus", "i:11", "b:20.3"}],
    Cell[1123053, 39428, 121244, 2962, 502, 36644, 1912, "GraphicsData", 
    "PostScript", "Graphics",
      CellTags->{"Root Locus", "i:11", "b:20.3"}],
    Cell[1244300, 42392, 202, 5, 43, "Output",
      CellTags->{"Root Locus", "i:11", "b:20.3"}]},
  "Pole-Zero Plot"->{
    Cell[1244551, 42403, 134, 3, 54, "Subsection",
      Evaluatable->False,
      CellTags->{"Pole-Zero Plot", "i:12", "b:20.4"}],
    Cell[1244688, 42408, 236, 6, 35, "Text",
      Evaluatable->False,
      CellTags->{"Pole-Zero Plot", "i:12", "b:20.4"}],
    Cell[1244927, 42416, 241, 7, 54, "Input",
      CellTags->{"Pole-Zero Plot", "i:12", "b:20.4"}],
    Cell[1245171, 42425, 127, 3, 35, "Text",
      Evaluatable->False,
      CellTags->{"Pole-Zero Plot", "i:12", "b:20.4"}],
    Cell[1245323, 42432, 176, 5, 43, "Input",
      CellTags->{"Pole-Zero Plot", "i:12", "b:20.4"}],
    Cell[1245502, 42439, 289, 6, 42, "Print",
      CellTags->{"Pole-Zero Plot", "i:12", "b:20.4"}],
    Cell[1245794, 42447, 275, 5, 29, "Print",
      CellTags->{"Pole-Zero Plot", "i:12", "b:20.4"}],
    Cell[1246072, 42454, 125883, 2944, 250, 72965, 2285, "GraphicsData", 
    "PostScript", "Graphics",
      CellTags->{"Pole-Zero Plot", "i:12", "b:20.4"}],
    Cell[1371958, 45400, 213, 5, 43, "Output",
      CellTags->{"Pole-Zero Plot", "i:12", "b:20.4"}]},
  "i:12"->{
    Cell[1244551, 42403, 134, 3, 54, "Subsection",
      Evaluatable->False,
      CellTags->{"Pole-Zero Plot", "i:12", "b:20.4"}],
    Cell[1244688, 42408, 236, 6, 35, "Text",
      Evaluatable->False,
      CellTags->{"Pole-Zero Plot", "i:12", "b:20.4"}],
    Cell[1244927, 42416, 241, 7, 54, "Input",
      CellTags->{"Pole-Zero Plot", "i:12", "b:20.4"}],
    Cell[1245171, 42425, 127, 3, 35, "Text",
      Evaluatable->False,
      CellTags->{"Pole-Zero Plot", "i:12", "b:20.4"}],
    Cell[1245323, 42432, 176, 5, 43, "Input",
      CellTags->{"Pole-Zero Plot", "i:12", "b:20.4"}],
    Cell[1245502, 42439, 289, 6, 42, "Print",
      CellTags->{"Pole-Zero Plot", "i:12", "b:20.4"}],
    Cell[1245794, 42447, 275, 5, 29, "Print",
      CellTags->{"Pole-Zero Plot", "i:12", "b:20.4"}],
    Cell[1246072, 42454, 125883, 2944, 250, 72965, 2285, "GraphicsData", 
    "PostScript", "Graphics",
      CellTags->{"Pole-Zero Plot", "i:12", "b:20.4"}],
    Cell[1371958, 45400, 213, 5, 43, "Output",
      CellTags->{"Pole-Zero Plot", "i:12", "b:20.4"}]},
  "b:20.4"->{
    Cell[1244551, 42403, 134, 3, 54, "Subsection",
      Evaluatable->False,
      CellTags->{"Pole-Zero Plot", "i:12", "b:20.4"}],
    Cell[1244688, 42408, 236, 6, 35, "Text",
      Evaluatable->False,
      CellTags->{"Pole-Zero Plot", "i:12", "b:20.4"}],
    Cell[1244927, 42416, 241, 7, 54, "Input",
      CellTags->{"Pole-Zero Plot", "i:12", "b:20.4"}],
    Cell[1245171, 42425, 127, 3, 35, "Text",
      Evaluatable->False,
      CellTags->{"Pole-Zero Plot", "i:12", "b:20.4"}],
    Cell[1245323, 42432, 176, 5, 43, "Input",
      CellTags->{"Pole-Zero Plot", "i:12", "b:20.4"}],
    Cell[1245502, 42439, 289, 6, 42, "Print",
      CellTags->{"Pole-Zero Plot", "i:12", "b:20.4"}],
    Cell[1245794, 42447, 275, 5, 29, "Print",
      CellTags->{"Pole-Zero Plot", "i:12", "b:20.4"}],
    Cell[1246072, 42454, 125883, 2944, 250, 72965, 2285, "GraphicsData", 
    "PostScript", "Graphics",
      CellTags->{"Pole-Zero Plot", "i:12", "b:20.4"}],
    Cell[1371958, 45400, 213, 5, 43, "Output",
      CellTags->{"Pole-Zero Plot", "i:12", "b:20.4"}]},
  "Introduction the linear"->{
    Cell[1372362, 45418, 133, 3, 54, "Subsection",
      Evaluatable->False,
      CellTags->{"Introduction the linear", "b:21.0"}],
    Cell[1372498, 45423, 411, 8, 61, "Text",
      Evaluatable->False,
      CellTags->{"Introduction the linear", "b:21.0"}]},
  "b:21.0"->{
    Cell[1372362, 45418, 133, 3, 54, "Subsection",
      Evaluatable->False,
      CellTags->{"Introduction the linear", "b:21.0"}],
    Cell[1372498, 45423, 411, 8, 61, "Text",
      Evaluatable->False,
      CellTags->{"Introduction the linear", "b:21.0"}]},
  "i:24"->{
    Cell[1372946, 45436, 95, 1, 54, "Subsection",
      CellTags->{"i:24", "LyapunovEquation", "b:21.1"}],
    Cell[1373066, 45441, 132, 3, 43, "Input",
      CellTags->{"i:24", "LyapunovEquation", "b:21.1"}],
    Cell[1373468, 45453, 165, 3, 43, "Input",
      CellTags->{"i:24", "LyapunovEquation", "b:21.1"}],
    Cell[1373658, 45460, 125, 3, 43, "Input",
      CellTags->{"i:24", "LyapunovEquation", "b:21.1"}],
    Cell[1373786, 45465, 128, 3, 43, "Output",
      CellTags->{"i:24", "LyapunovEquation", "b:21.1"}],
    Cell[1373951, 45473, 137, 3, 43, "Input",
      CellTags->{"i:24", "LyapunovEquation", "b:21.1"}],
    Cell[1374091, 45478, 140, 3, 49, "Output",
      CellTags->{"i:24", "LyapunovEquation", "b:21.1"}],
    Cell[1374246, 45484, 205, 4, 35, "Text",
      CellTags->{"i:24", "LyapunovEquation", "b:21.1"}],
    Cell[1374476, 45492, 125, 3, 43, "Input",
      CellTags->{"i:24", "LyapunovEquation", "b:21.1"}],
    Cell[1374604, 45497, 154, 3, 49, "Output",
      CellTags->{"i:24", "LyapunovEquation", "b:21.1"}],
    Cell[1374795, 45505, 149, 3, 43, "Input",
      CellTags->{"i:24", "LyapunovEquation", "b:21.1"}],
    Cell[1374947, 45510, 154, 3, 29, "Print",
      CellTags->{"i:24", "LyapunovEquation", "b:21.1"}],
    Cell[1375104, 45515, 114, 3, 43, "Output",
      CellTags->{"i:24", "LyapunovEquation", "b:21.1"}]},
  "LyapunovEquation"->{
    Cell[1372946, 45436, 95, 1, 54, "Subsection",
      CellTags->{"i:24", "LyapunovEquation", "b:21.1"}],
    Cell[1373066, 45441, 132, 3, 43, "Input",
      CellTags->{"i:24", "LyapunovEquation", "b:21.1"}],
    Cell[1373468, 45453, 165, 3, 43, "Input",
      CellTags->{"i:24", "LyapunovEquation", "b:21.1"}],
    Cell[1373658, 45460, 125, 3, 43, "Input",
      CellTags->{"i:24", "LyapunovEquation", "b:21.1"}],
    Cell[1373786, 45465, 128, 3, 43, "Output",
      CellTags->{"i:24", "LyapunovEquation", "b:21.1"}],
    Cell[1373951, 45473, 137, 3, 43, "Input",
      CellTags->{"i:24", "LyapunovEquation", "b:21.1"}],
    Cell[1374091, 45478, 140, 3, 49, "Output",
      CellTags->{"i:24", "LyapunovEquation", "b:21.1"}],
    Cell[1374246, 45484, 205, 4, 35, "Text",
      CellTags->{"i:24", "LyapunovEquation", "b:21.1"}],
    Cell[1374476, 45492, 125, 3, 43, "Input",
      CellTags->{"i:24", "LyapunovEquation", "b:21.1"}],
    Cell[1374604, 45497, 154, 3, 49, "Output",
      CellTags->{"i:24", "LyapunovEquation", "b:21.1"}],
    Cell[1374795, 45505, 149, 3, 43, "Input",
      CellTags->{"i:24", "LyapunovEquation", "b:21.1"}],
    Cell[1374947, 45510, 154, 3, 29, "Print",
      CellTags->{"i:24", "LyapunovEquation", "b:21.1"}],
    Cell[1375104, 45515, 114, 3, 43, "Output",
      CellTags->{"i:24", "LyapunovEquation", "b:21.1"}]},
  "b:21.1"->{
    Cell[1372946, 45436, 95, 1, 54, "Subsection",
      CellTags->{"i:24", "LyapunovEquation", "b:21.1"}],
    Cell[1373066, 45441, 132, 3, 43, "Input",
      CellTags->{"i:24", "LyapunovEquation", "b:21.1"}],
    Cell[1373201, 45446, 252, 4, 68, "Print",
      CellTags->{"Info3266692353-2707657", "b:21.1"}],
    Cell[1373468, 45453, 165, 3, 43, "Input",
      CellTags->{"i:24", "LyapunovEquation", "b:21.1"}],
    Cell[1373658, 45460, 125, 3, 43, "Input",
      CellTags->{"i:24", "LyapunovEquation", "b:21.1"}],
    Cell[1373786, 45465, 128, 3, 43, "Output",
      CellTags->{"i:24", "LyapunovEquation", "b:21.1"}],
    Cell[1373951, 45473, 137, 3, 43, "Input",
      CellTags->{"i:24", "LyapunovEquation", "b:21.1"}],
    Cell[1374091, 45478, 140, 3, 49, "Output",
      CellTags->{"i:24", "LyapunovEquation", "b:21.1"}],
    Cell[1374246, 45484, 205, 4, 35, "Text",
      CellTags->{"i:24", "LyapunovEquation", "b:21.1"}],
    Cell[1374476, 45492, 125, 3, 43, "Input",
      CellTags->{"i:24", "LyapunovEquation", "b:21.1"}],
    Cell[1374604, 45497, 154, 3, 49, "Output",
      CellTags->{"i:24", "LyapunovEquation", "b:21.1"}],
    Cell[1374795, 45505, 149, 3, 43, "Input",
      CellTags->{"i:24", "LyapunovEquation", "b:21.1"}],
    Cell[1374947, 45510, 154, 3, 29, "Print",
      CellTags->{"i:24", "LyapunovEquation", "b:21.1"}],
    Cell[1375104, 45515, 114, 3, 43, "Output",
      CellTags->{"i:24", "LyapunovEquation", "b:21.1"}]},
  "Info3266692353-2707657"->{
    Cell[1373201, 45446, 252, 4, 68, "Print",
      CellTags->{"Info3266692353-2707657", "b:21.1"}]},
  "The Algebraic Riccati Equation"->{
    Cell[1375267, 45524, 166, 3, 54, "Subsection",
      Evaluatable->False,
      CellTags->{"The Algebraic Riccati Equation", "i:13", "b:21.2"}],
    Cell[1375436, 45529, 691, 13, 116, "Text",
      Evaluatable->False,
      CellTags->{"The Algebraic Riccati Equation", "i:13", "b:21.2"}],
    Cell[1376130, 45544, 251, 6, 46, "Input",
      CellTags->{"The Algebraic Riccati Equation", "i:13", "b:21.2"}],
    Cell[1376384, 45552, 157, 3, 35, "Text",
      Evaluatable->False,
      CellTags->{"The Algebraic Riccati Equation", "i:13", "b:21.2"}],
    Cell[1376566, 45559, 219, 5, 43, "Input",
      CellTags->{"The Algebraic Riccati Equation", "i:13", "b:21.2"}],
    Cell[1376788, 45566, 167, 3, 29, "Print",
      CellTags->{"The Algebraic Riccati Equation", "i:13", "b:21.2"}],
    Cell[1376958, 45571, 156, 3, 29, "Print",
      CellTags->{"The Algebraic Riccati Equation", "i:13", "b:21.2"}],
    Cell[1377117, 45576, 247, 4, 55, "Output",
      CellTags->{"The Algebraic Riccati Equation", "i:13", "b:21.2"}],
    Cell[1377379, 45583, 596, 11, 74, "Text",
      Evaluatable->False,
      CellTags->{"The Algebraic Riccati Equation", "i:13", "b:21.2"}],
    Cell[1377978, 45596, 339, 7, 69, "Input",
      CellTags->{"The Algebraic Riccati Equation", "i:13", "b:21.2"}],
    Cell[1378342, 45607, 222, 5, 43, "Input",
      CellTags->{"The Algebraic Riccati Equation", "i:13", "b:21.2"}],
    Cell[1378567, 45614, 271, 5, 49, "Output",
      CellTags->{"The Algebraic Riccati Equation", "i:13", "b:21.2"}],
    Cell[1378853, 45622, 365, 7, 48, "Text",
      Evaluatable->False,
      CellTags->{"The Algebraic Riccati Equation", "i:13", "b:21.2"}],
    Cell[1379243, 45633, 225, 5, 43, "Input",
      CellTags->{"The Algebraic Riccati Equation", "i:13", "b:21.2"}],
    Cell[1379471, 45640, 533, 9, 43, "Output",
      CellTags->{"The Algebraic Riccati Equation", "i:13", "b:21.2"}]},
  "i:13"->{
    Cell[1375267, 45524, 166, 3, 54, "Subsection",
      Evaluatable->False,
      CellTags->{"The Algebraic Riccati Equation", "i:13", "b:21.2"}],
    Cell[1375436, 45529, 691, 13, 116, "Text",
      Evaluatable->False,
      CellTags->{"The Algebraic Riccati Equation", "i:13", "b:21.2"}],
    Cell[1376130, 45544, 251, 6, 46, "Input",
      CellTags->{"The Algebraic Riccati Equation", "i:13", "b:21.2"}],
    Cell[1376384, 45552, 157, 3, 35, "Text",
      Evaluatable->False,
      CellTags->{"The Algebraic Riccati Equation", "i:13", "b:21.2"}],
    Cell[1376566, 45559, 219, 5, 43, "Input",
      CellTags->{"The Algebraic Riccati Equation", "i:13", "b:21.2"}],
    Cell[1376788, 45566, 167, 3, 29, "Print",
      CellTags->{"The Algebraic Riccati Equation", "i:13", "b:21.2"}],
    Cell[1376958, 45571, 156, 3, 29, "Print",
      CellTags->{"The Algebraic Riccati Equation", "i:13", "b:21.2"}],
    Cell[1377117, 45576, 247, 4, 55, "Output",
      CellTags->{"The Algebraic Riccati Equation", "i:13", "b:21.2"}],
    Cell[1377379, 45583, 596, 11, 74, "Text",
      Evaluatable->False,
      CellTags->{"The Algebraic Riccati Equation", "i:13", "b:21.2"}],
    Cell[1377978, 45596, 339, 7, 69, "Input",
      CellTags->{"The Algebraic Riccati Equation", "i:13", "b:21.2"}],
    Cell[1378342, 45607, 222, 5, 43, "Input",
      CellTags->{"The Algebraic Riccati Equation", "i:13", "b:21.2"}],
    Cell[1378567, 45614, 271, 5, 49, "Output",
      CellTags->{"The Algebraic Riccati Equation", "i:13", "b:21.2"}],
    Cell[1378853, 45622, 365, 7, 48, "Text",
      Evaluatable->False,
      CellTags->{"The Algebraic Riccati Equation", "i:13", "b:21.2"}],
    Cell[1379243, 45633, 225, 5, 43, "Input",
      CellTags->{"The Algebraic Riccati Equation", "i:13", "b:21.2"}],
    Cell[1379471, 45640, 533, 9, 43, "Output",
      CellTags->{"The Algebraic Riccati Equation", "i:13", "b:21.2"}]},
  "b:21.2"->{
    Cell[1375267, 45524, 166, 3, 54, "Subsection",
      Evaluatable->False,
      CellTags->{"The Algebraic Riccati Equation", "i:13", "b:21.2"}],
    Cell[1375436, 45529, 691, 13, 116, "Text",
      Evaluatable->False,
      CellTags->{"The Algebraic Riccati Equation", "i:13", "b:21.2"}],
    Cell[1376130, 45544, 251, 6, 46, "Input",
      CellTags->{"The Algebraic Riccati Equation", "i:13", "b:21.2"}],
    Cell[1376384, 45552, 157, 3, 35, "Text",
      Evaluatable->False,
      CellTags->{"The Algebraic Riccati Equation", "i:13", "b:21.2"}],
    Cell[1376566, 45559, 219, 5, 43, "Input",
      CellTags->{"The Algebraic Riccati Equation", "i:13", "b:21.2"}],
    Cell[1376788, 45566, 167, 3, 29, "Print",
      CellTags->{"The Algebraic Riccati Equation", "i:13", "b:21.2"}],
    Cell[1376958, 45571, 156, 3, 29, "Print",
      CellTags->{"The Algebraic Riccati Equation", "i:13", "b:21.2"}],
    Cell[1377117, 45576, 247, 4, 55, "Output",
      CellTags->{"The Algebraic Riccati Equation", "i:13", "b:21.2"}],
    Cell[1377379, 45583, 596, 11, 74, "Text",
      Evaluatable->False,
      CellTags->{"The Algebraic Riccati Equation", "i:13", "b:21.2"}],
    Cell[1377978, 45596, 339, 7, 69, "Input",
      CellTags->{"The Algebraic Riccati Equation", "i:13", "b:21.2"}],
    Cell[1378342, 45607, 222, 5, 43, "Input",
      CellTags->{"The Algebraic Riccati Equation", "i:13", "b:21.2"}],
    Cell[1378567, 45614, 271, 5, 49, "Output",
      CellTags->{"The Algebraic Riccati Equation", "i:13", "b:21.2"}],
    Cell[1378853, 45622, 365, 7, 48, "Text",
      Evaluatable->False,
      CellTags->{"The Algebraic Riccati Equation", "i:13", "b:21.2"}],
    Cell[1379243, 45633, 225, 5, 43, "Input",
      CellTags->{"The Algebraic Riccati Equation", "i:13", "b:21.2"}],
    Cell[1379471, 45640, 533, 9, 43, "Output",
      CellTags->{"The Algebraic Riccati Equation", "i:13", "b:21.2"}]},
  "Optimal State Feedback"->{
    Cell[1380053, 45655, 150, 3, 54, "Subsection",
      Evaluatable->False,
      CellTags->{"Optimal State Feedback", "i:14", "b:21.3"}],
    Cell[1380206, 45660, 194, 5, 35, "Text",
      Evaluatable->False,
      CellTags->{"Optimal State Feedback", "i:14", "b:21.3"}],
    Cell[1380403, 45667, 210, 5, 46, "Input",
      CellTags->{"Optimal State Feedback", "i:14", "b:21.3"}],
    Cell[1380616, 45674, 286, 7, 48, "Text",
      Evaluatable->False,
      CellTags->{"Optimal State Feedback", "i:14", "b:21.3"}],
    Cell[1380905, 45683, 198, 5, 43, "Input",
      CellTags->{"Optimal State Feedback", "i:14", "b:21.3"}],
    Cell[1381106, 45690, 165, 3, 35, "Text",
      Evaluatable->False,
      CellTags->{"Optimal State Feedback", "i:14", "b:21.3"}],
    Cell[1381296, 45697, 196, 5, 43, "Input",
      CellTags->{"Optimal State Feedback", "i:14", "b:21.3"}],
    Cell[1381495, 45704, 159, 3, 29, "Print",
      CellTags->{"Optimal State Feedback", "i:14", "b:21.3"}],
    Cell[1381657, 45709, 148, 3, 29, "Print",
      CellTags->{"Optimal State Feedback", "i:14", "b:21.3"}],
    Cell[1381808, 45714, 339, 6, 55, "Output",
      CellTags->{"Optimal State Feedback", "i:14", "b:21.3"}],
    Cell[1382162, 45723, 270, 6, 48, "Text",
      Evaluatable->False,
      CellTags->{"Optimal State Feedback", "i:14", "b:21.3"}]},
  "i:14"->{
    Cell[1380053, 45655, 150, 3, 54, "Subsection",
      Evaluatable->False,
      CellTags->{"Optimal State Feedback", "i:14", "b:21.3"}],
    Cell[1380206, 45660, 194, 5, 35, "Text",
      Evaluatable->False,
      CellTags->{"Optimal State Feedback", "i:14", "b:21.3"}],
    Cell[1380403, 45667, 210, 5, 46, "Input",
      CellTags->{"Optimal State Feedback", "i:14", "b:21.3"}],
    Cell[1380616, 45674, 286, 7, 48, "Text",
      Evaluatable->False,
      CellTags->{"Optimal State Feedback", "i:14", "b:21.3"}],
    Cell[1380905, 45683, 198, 5, 43, "Input",
      CellTags->{"Optimal State Feedback", "i:14", "b:21.3"}],
    Cell[1381106, 45690, 165, 3, 35, "Text",
      Evaluatable->False,
      CellTags->{"Optimal State Feedback", "i:14", "b:21.3"}],
    Cell[1381296, 45697, 196, 5, 43, "Input",
      CellTags->{"Optimal State Feedback", "i:14", "b:21.3"}],
    Cell[1381495, 45704, 159, 3, 29, "Print",
      CellTags->{"Optimal State Feedback", "i:14", "b:21.3"}],
    Cell[1381657, 45709, 148, 3, 29, "Print",
      CellTags->{"Optimal State Feedback", "i:14", "b:21.3"}],
    Cell[1381808, 45714, 339, 6, 55, "Output",
      CellTags->{"Optimal State Feedback", "i:14", "b:21.3"}],
    Cell[1382162, 45723, 270, 6, 48, "Text",
      Evaluatable->False,
      CellTags->{"Optimal State Feedback", "i:14", "b:21.3"}]},
  "b:21.3"->{
    Cell[1380053, 45655, 150, 3, 54, "Subsection",
      Evaluatable->False,
      CellTags->{"Optimal State Feedback", "i:14", "b:21.3"}],
    Cell[1380206, 45660, 194, 5, 35, "Text",
      Evaluatable->False,
      CellTags->{"Optimal State Feedback", "i:14", "b:21.3"}],
    Cell[1380403, 45667, 210, 5, 46, "Input",
      CellTags->{"Optimal State Feedback", "i:14", "b:21.3"}],
    Cell[1380616, 45674, 286, 7, 48, "Text",
      Evaluatable->False,
      CellTags->{"Optimal State Feedback", "i:14", "b:21.3"}],
    Cell[1380905, 45683, 198, 5, 43, "Input",
      CellTags->{"Optimal State Feedback", "i:14", "b:21.3"}],
    Cell[1381106, 45690, 165, 3, 35, "Text",
      Evaluatable->False,
      CellTags->{"Optimal State Feedback", "i:14", "b:21.3"}],
    Cell[1381296, 45697, 196, 5, 43, "Input",
      CellTags->{"Optimal State Feedback", "i:14", "b:21.3"}],
    Cell[1381495, 45704, 159, 3, 29, "Print",
      CellTags->{"Optimal State Feedback", "i:14", "b:21.3"}],
    Cell[1381657, 45709, 148, 3, 29, "Print",
      CellTags->{"Optimal State Feedback", "i:14", "b:21.3"}],
    Cell[1381808, 45714, 339, 6, 55, "Output",
      CellTags->{"Optimal State Feedback", "i:14", "b:21.3"}],
    Cell[1382162, 45723, 270, 6, 48, "Text",
      Evaluatable->False,
      CellTags->{"Optimal State Feedback", "i:14", "b:21.3"}]},
  "Optimal Stochastic State Estimator"->{
    Cell[1382469, 45734, 174, 3, 54, "Subsection",
      Evaluatable->False,
      CellTags->{"Optimal Stochastic State Estimator", "i:15", "b:21.4"}],
    Cell[1382646, 45739, 879, 22, 338, "Text",
      Evaluatable->False,
      CellTags->{"Optimal Stochastic State Estimator", "i:15", "b:21.4"}],
    Cell[1383528, 45763, 230, 5, 43, "Input",
      CellTags->{"Optimal Stochastic State Estimator", "i:15", "b:21.4"}],
    Cell[1383761, 45770, 159, 3, 35, "Text",
      Evaluatable->False,
      CellTags->{"Optimal Stochastic State Estimator", "i:15", "b:21.4"}],
    Cell[1383945, 45777, 212, 5, 43, "Input",
      CellTags->{"Optimal Stochastic State Estimator", "i:15", "b:21.4"}],
    Cell[1384160, 45784, 451, 8, 106, "Output",
      CellTags->{"Optimal Stochastic State Estimator", "i:15", "b:21.4"}],
    Cell[1384626, 45795, 173, 3, 35, "Text",
      Evaluatable->False,
      CellTags->{"Optimal Stochastic State Estimator", "i:15", "b:21.4"}],
    Cell[1384824, 45802, 182, 5, 43, "Input",
      CellTags->{"Optimal Stochastic State Estimator", "i:15", "b:21.4"}],
    Cell[1385009, 45809, 307, 6, 43, "Output",
      CellTags->{"Optimal Stochastic State Estimator", "i:15", "b:21.4"}],
    Cell[1385331, 45818, 438, 10, 90, "Text",
      Evaluatable->False,
      CellTags->{"Optimal Stochastic State Estimator", "i:15", "b:21.4"}],
    Cell[1385794, 45832, 215, 5, 43, "Input",
      CellTags->{"Optimal Stochastic State Estimator", "i:15", "b:21.4"}],
    Cell[1386012, 45839, 331, 6, 43, "Output",
      CellTags->{"Optimal Stochastic State Estimator", "i:15", "b:21.4"}]},
  "i:15"->{
    Cell[1382469, 45734, 174, 3, 54, "Subsection",
      Evaluatable->False,
      CellTags->{"Optimal Stochastic State Estimator", "i:15", "b:21.4"}],
    Cell[1382646, 45739, 879, 22, 338, "Text",
      Evaluatable->False,
      CellTags->{"Optimal Stochastic State Estimator", "i:15", "b:21.4"}],
    Cell[1383528, 45763, 230, 5, 43, "Input",
      CellTags->{"Optimal Stochastic State Estimator", "i:15", "b:21.4"}],
    Cell[1383761, 45770, 159, 3, 35, "Text",
      Evaluatable->False,
      CellTags->{"Optimal Stochastic State Estimator", "i:15", "b:21.4"}],
    Cell[1383945, 45777, 212, 5, 43, "Input",
      CellTags->{"Optimal Stochastic State Estimator", "i:15", "b:21.4"}],
    Cell[1384160, 45784, 451, 8, 106, "Output",
      CellTags->{"Optimal Stochastic State Estimator", "i:15", "b:21.4"}],
    Cell[1384626, 45795, 173, 3, 35, "Text",
      Evaluatable->False,
      CellTags->{"Optimal Stochastic State Estimator", "i:15", "b:21.4"}],
    Cell[1384824, 45802, 182, 5, 43, "Input",
      CellTags->{"Optimal Stochastic State Estimator", "i:15", "b:21.4"}],
    Cell[1385009, 45809, 307, 6, 43, "Output",
      CellTags->{"Optimal Stochastic State Estimator", "i:15", "b:21.4"}],
    Cell[1385331, 45818, 438, 10, 90, "Text",
      Evaluatable->False,
      CellTags->{"Optimal Stochastic State Estimator", "i:15", "b:21.4"}],
    Cell[1385794, 45832, 215, 5, 43, "Input",
      CellTags->{"Optimal Stochastic State Estimator", "i:15", "b:21.4"}],
    Cell[1386012, 45839, 331, 6, 43, "Output",
      CellTags->{"Optimal Stochastic State Estimator", "i:15", "b:21.4"}]},
  "b:21.4"->{
    Cell[1382469, 45734, 174, 3, 54, "Subsection",
      Evaluatable->False,
      CellTags->{"Optimal Stochastic State Estimator", "i:15", "b:21.4"}],
    Cell[1382646, 45739, 879, 22, 338, "Text",
      Evaluatable->False,
      CellTags->{"Optimal Stochastic State Estimator", "i:15", "b:21.4"}],
    Cell[1383528, 45763, 230, 5, 43, "Input",
      CellTags->{"Optimal Stochastic State Estimator", "i:15", "b:21.4"}],
    Cell[1383761, 45770, 159, 3, 35, "Text",
      Evaluatable->False,
      CellTags->{"Optimal Stochastic State Estimator", "i:15", "b:21.4"}],
    Cell[1383945, 45777, 212, 5, 43, "Input",
      CellTags->{"Optimal Stochastic State Estimator", "i:15", "b:21.4"}],
    Cell[1384160, 45784, 451, 8, 106, "Output",
      CellTags->{"Optimal Stochastic State Estimator", "i:15", "b:21.4"}],
    Cell[1384626, 45795, 173, 3, 35, "Text",
      Evaluatable->False,
      CellTags->{"Optimal Stochastic State Estimator", "i:15", "b:21.4"}],
    Cell[1384824, 45802, 182, 5, 43, "Input",
      CellTags->{"Optimal Stochastic State Estimator", "i:15", "b:21.4"}],
    Cell[1385009, 45809, 307, 6, 43, "Output",
      CellTags->{"Optimal Stochastic State Estimator", "i:15", "b:21.4"}],
    Cell[1385331, 45818, 438, 10, 90, "Text",
      Evaluatable->False,
      CellTags->{"Optimal Stochastic State Estimator", "i:15", "b:21.4"}],
    Cell[1385794, 45832, 215, 5, 43, "Input",
      CellTags->{"Optimal Stochastic State Estimator", "i:15", "b:21.4"}],
    Cell[1386012, 45839, 331, 6, 43, "Output",
      CellTags->{"Optimal Stochastic State Estimator", "i:15", "b:21.4"}]},
  "Bibliography"->{
    Cell[1386404, 45852, 69, 1, 51, "Section",
      CellTags->{"Bibliography", "b:22"}],
    Cell[1386476, 45855, 778, 16, 216, "Text",
      CellTags->{"Bibliography", "b:22"}]},
  "b:22"->{
    Cell[1386404, 45852, 69, 1, 51, "Section",
      CellTags->{"Bibliography", "b:22"}],
    Cell[1386476, 45855, 778, 16, 216, "Text",
      CellTags->{"Bibliography", "b:22"}]}
  }
*)

(*CellTagsIndex
CellTagsIndex->{
  {"Getting Started", 1390656, 45933},
  {"b:18", 1391268, 45949},
  {"What's in the Package", 1391962, 45967},
  {"b:19.0", 1392730, 45985},
  {"Linearization", 1393505, 46003},
  {"i:1", 1394933, 46035},
  {"b:19.1", 1396364, 46067},
  {"Poles and Zeros", 1397804, 46099},
  {"i:2", 1400166, 46148},
  {"b:19.2", 1402531, 46197},
  {"State Space to Transfer Function and Back", 1404931, 46246},
  {"i:3", 1406781, 46291},
  {"b:19.3", 1408634, 46336},
  {"Minimal Realization", 1410500, 46381},
  {"i:4", 1415152, 46472},
  {"b:19.4", 1419807, 46563},
  {"Controllability", 1424471, 46654},
  {"i:5", 1425769, 46683},
  {"b:19.5", 1427070, 46712},
  {"Kalman Form", 1428376, 46741},
  {"i:6", 1433406, 46848},
  {"b:19.6", 1438439, 46955},
  {"Another Example", 1443481, 47062},
  {"b:19.7", 1447611, 47156},
  {"Introduction", 1451747, 47250},
  {"b:20.0", 1451994, 47257},
  {"Bode plot", 1452244, 47264},
  {"i:9", 1453772, 47298},
  {"b:20.1", 1455303, 47332},
  {"Nyquist Plot", 1456840, 47366},
  {"i:10", 1458957, 47411},
  {"b:20.2", 1461076, 47456},
  {"Root Locus", 1463199, 47501},
  {"i:11", 1465263, 47545},
  {"b:20.3", 1467329, 47589},
  {"Pole-Zero Plot", 1469403, 47633},
  {"i:12", 1470465, 47656},
  {"b:20.4", 1471529, 47679},
  {"Introduction the linear", 1472610, 47702},
  {"b:21.0", 1472885, 47709},
  {"i:24", 1473158, 47716},
  {"LyapunovEquation", 1474529, 47743},
  {"b:21.1", 1475890, 47770},
  {"Info3266692353-2707657", 1477368, 47799},
  {"The Algebraic Riccati Equation", 1477508, 47802},
  {"i:13", 1479413, 47838},
  {"b:21.2", 1481320, 47874},
  {"Optimal State Feedback", 1483243, 47910},
  {"i:14", 1484587, 47938},
  {"b:21.3", 1485933, 47966},
  {"Optimal Stochastic State Estimator", 1487307, 47994},
  {"i:15", 1488910, 48024},
  {"b:21.4", 1490515, 48054},
  {"Bibliography", 1492126, 48084},
  {"b:22", 1492319, 48089}
  }
*)

(*NotebookFileOutline
Notebook[{

Cell[CellGroupData[{
Cell[1776, 53, 123, 3, 70, "Section",
  Evaluatable->False,
  CellTags->{"Getting Started", "b:18"}],
Cell[1902, 58, 145, 4, 63, "Input",
  CellTags->"b:18"],
Cell[2050, 64, 804, 16, 107, "Text",
  Evaluatable->False,
  CellTags->{"Getting Started", "b:18"}],
Cell[2857, 82, 266, 9, 39, "Text",
  Evaluatable->False,
  CellTags->{"Getting Started", "b:18"}],

Cell[CellGroupData[{
Cell[3148, 95, 140, 4, 45, "Input",
  CellTags->{"Getting Started", "b:18"}],
Cell[3291, 101, 730, 11, 417, "Print",
  CellTags->{"Getting Started", "b:18"}]
}, Open  ]],
Cell[4036, 115, 172, 6, 35, "Text",
  CellTags->{"Getting Started", "b:18"}]
}, Open  ]],

Cell[CellGroupData[{
Cell[4245, 126, 95, 2, 40, "Section",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[4365, 132, 140, 3, 54, "Subsection",
  Evaluatable->False,
  CellTags->{"What's in the Package", "b:19.0"}],
Cell[4508, 137, 231, 7, 56, "Text",
  Evaluatable->False,
  CellTags->{"What's in the Package", "b:19.0"}],

Cell[CellGroupData[{
Cell[4764, 148, 165, 5, 33, "Input",
  CellTags->{"What's in the Package", "b:19.0"}],
Cell[4932, 155, 738, 11, 292, "Print",
  CellTags->{"What's in the Package", "b:19.0"}]
}, Open  ]],
Cell[5685, 169, 192, 5, 35, "Text",
  Evaluatable->False,
  CellTags->{"What's in the Package", "b:19.0"}],

Cell[CellGroupData[{
Cell[5902, 178, 128, 3, 33, "Input",
  CellTags->{"b:19.0", "What's in the Package"}],
Cell[6033, 183, 22551, 520, 218, "Print",
  CellTags->{"b:19.0", "What's in the Package"}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[28633, 709, 131, 3, 54, "Subsection",
  Evaluatable->False,
  CellTags->{"Linearization", "i:1", "b:19.1"}],
Cell[28767, 714, 138, 3, 35, "Text",
  Evaluatable->False,
  CellTags->{"Linearization", "i:1", "b:19.1"}],

Cell[CellGroupData[{
Cell[28930, 721, 229, 6, 33, "Input",
  CellTags->{"Linearization", "i:1", "b:19.1"}],
Cell[29162, 729, 161, 3, 33, "Output",
  CellTags->{"Linearization", "i:1", "b:19.1"}]
}, Open  ]],

Cell[CellGroupData[{
Cell[29360, 737, 179, 5, 33, "Input",
  CellTags->{"Linearization", "i:1", "b:19.1"}],
Cell[29542, 744, 127, 3, 33, "Output",
  CellTags->{"Linearization", "i:1", "b:19.1"}]
}, Open  ]],

Cell[CellGroupData[{
Cell[29706, 752, 166, 5, 33, "Input",
  CellTags->{"Linearization", "i:1", "b:19.1"}],
Cell[29875, 759, 114, 3, 33, "Output",
  CellTags->{"Linearization", "i:1", "b:19.1"}]
}, Open  ]],

Cell[CellGroupData[{
Cell[30026, 767, 166, 5, 33, "Input",
  CellTags->{"Linearization", "i:1", "b:19.1"}],
Cell[30195, 774, 114, 3, 33, "Output",
  CellTags->{"Linearization", "i:1", "b:19.1"}]
}, Open  ]],
Cell[30324, 780, 182, 5, 35, "Text",
  Evaluatable->False,
  CellTags->{"Linearization", "i:1", "b:19.1"}],

Cell[CellGroupData[{
Cell[30531, 789, 224, 6, 33, "Input",
  CellTags->{"Linearization", "i:1", "b:19.1"}],
Cell[30758, 797, 156, 3, 29, "Print",
  CellTags->{"Linearization", "i:1", "b:19.1"}],
Cell[30917, 802, 200, 4, 33, "Output",
  CellTags->{"Linearization", "i:1", "b:19.1"}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[31166, 812, 85, 1, 54, "Subsection",
  CellTags->{"Poles and Zeros", "i:2", "b:19.2"}],
Cell[31254, 815, 668, 19, 75, "Text",
  CellTags->{"Poles and Zeros", "i:2", "b:19.2"}],
Cell[31925, 836, 440, 8, 72, "Input",
  CellTags->{"Poles and Zeros", "i:2", "b:19.2"}],

Cell[CellGroupData[{
Cell[32390, 848, 126, 3, 33, "Input",
  CellTags->{"Poles and Zeros", "i:2", "b:19.2"}],
Cell[32519, 853, 515, 12, 61, "Output",
  CellTags->{"Poles and Zeros", "i:2", "b:19.2"}]
}, Open  ]],

Cell[CellGroupData[{
Cell[33071, 870, 126, 3, 33, "Input",
  CellTags->{"Poles and Zeros", "i:2", "b:19.2"}],
Cell[33200, 875, 626, 13, 61, "Output",
  CellTags->{"Poles and Zeros", "i:2", "b:19.2"}]
}, Open  ]],

Cell[CellGroupData[{
Cell[33863, 893, 119, 3, 33, "Input",
  CellTags->{"Poles and Zeros", "i:2", "b:19.2"}],
Cell[33985, 898, 143, 3, 33, "Output",
  CellTags->{"Poles and Zeros", "i:2", "b:19.2"}]
}, Open  ]],

Cell[CellGroupData[{
Cell[34165, 906, 119, 3, 33, "Input",
  CellTags->{"Poles and Zeros", "i:2", "b:19.2"}],
Cell[34287, 911, 135, 3, 33, "Output",
  CellTags->{"Poles and Zeros", "i:2", "b:19.2"}]
}, Open  ]],
Cell[34437, 917, 512, 9, 86, "Input",
  CellTags->{"Poles and Zeros", "i:2", "b:19.2"}],

Cell[CellGroupData[{
Cell[34974, 930, 126, 3, 33, "Input",
  CellTags->{"Poles and Zeros", "i:2", "b:19.2"}],
Cell[35103, 935, 515, 12, 61, "Output",
  CellTags->{"Poles and Zeros", "i:2", "b:19.2"}]
}, Open  ]],

Cell[CellGroupData[{
Cell[35655, 952, 126, 3, 33, "Input",
  CellTags->{"Poles and Zeros", "i:2", "b:19.2"}],
Cell[35784, 957, 626, 13, 61, "Output",
  CellTags->{"Poles and Zeros", "i:2", "b:19.2"}]
}, Open  ]],

Cell[CellGroupData[{
Cell[36447, 975, 126, 3, 33, "Input",
  CellTags->{"Poles and Zeros", "i:2", "b:19.2"}],
Cell[36576, 980, 404, 9, 59, "Output",
  CellTags->{"Poles and Zeros", "i:2", "b:19.2"}]
}, Open  ]],

Cell[CellGroupData[{
Cell[37017, 994, 119, 3, 33, "Input",
  CellTags->{"Poles and Zeros", "i:2", "b:19.2"}],
Cell[37139, 999, 117, 3, 33, "Output",
  CellTags->{"Poles and Zeros", "i:2", "b:19.2"}]
}, Open  ]],

Cell[CellGroupData[{
Cell[37293, 1007, 119, 3, 33, "Input",
  CellTags->{"Poles and Zeros", "i:2", "b:19.2"}],
Cell[37415, 1012, 111, 3, 33, "Output",
  CellTags->{"Poles and Zeros", "i:2", "b:19.2"}]
}, Open  ]],

Cell[CellGroupData[{
Cell[37563, 1020, 119, 3, 33, "Input",
  CellTags->{"Poles and Zeros", "i:2", "b:19.2"}],
Cell[37685, 1025, 117, 3, 33, "Output",
  CellTags->{"Poles and Zeros", "i:2", "b:19.2"}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[37851, 1034, 187, 3, 54, "Subsection",
  Evaluatable->False,
  CellTags->{"State Space to Transfer Function and Back", "i:3", "b:19.3"}],
Cell[38041, 1039, 199, 3, 35, "Text",
  Evaluatable->False,
  CellTags->{"State Space to Transfer Function and Back", "i:3", "b:19.3"}],

Cell[CellGroupData[{
Cell[38265, 1046, 264, 6, 46, "Input",
  CellTags->{"State Space to Transfer Function and Back", "i:3", "b:19.3"}],
Cell[38532, 1054, 250, 4, 41, "Output",
  CellTags->{"State Space to Transfer Function and Back", "i:3", "b:19.3"}]
}, Open  ]],
Cell[38797, 1061, 219, 5, 35, "Text",
  Evaluatable->False,
  CellTags->{"State Space to Transfer Function and Back", "i:3", "b:19.3"}],

Cell[CellGroupData[{
Cell[39041, 1070, 228, 5, 33, "Input",
  CellTags->{"State Space to Transfer Function and Back", "i:3", "b:19.3"}],
Cell[39272, 1077, 299, 5, 46, "Output",
  CellTags->{"State Space to Transfer Function and Back", "i:3", "b:19.3"}]
}, Open  ]],
Cell[39586, 1085, 183, 3, 35, "Text",
  Evaluatable->False,
  CellTags->{"State Space to Transfer Function and Back", "i:3", "b:19.3"}],

Cell[CellGroupData[{
Cell[39794, 1092, 205, 5, 33, "Input",
  CellTags->{"State Space to Transfer Function and Back", "i:3", "b:19.3"}],
Cell[40002, 1099, 140, 3, 33, "Output",
  CellTags->{"State Space to Transfer Function and Back", "i:3", "b:19.3"}]
}, Open  ]],
Cell[40157, 1105, 196, 3, 35, "Text",
  Evaluatable->False,
  CellTags->{"State Space to Transfer Function and Back", "i:3", "b:19.3"}],

Cell[CellGroupData[{
Cell[40378, 1112, 260, 6, 46, "Input",
  CellTags->{"State Space to Transfer Function and Back", "i:3", "b:19.3"}],
Cell[40641, 1120, 250, 4, 41, "Output",
  CellTags->{"State Space to Transfer Function and Back", "i:3", "b:19.3"}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[40940, 1130, 95, 1, 54, "Subsection",
  CellTags->{"Minimal Realization", "i:4", "b:19.4"}],
Cell[41038, 1133, 234, 5, 48, "Text",
  CellTags->{"Minimal Realization", "i:4", "b:19.4"}],
Cell[41275, 1140, 487, 10, 72, "Input",
  CellTags->{"Minimal Realization", "i:4", "b:19.4"}],

Cell[CellGroupData[{
Cell[41787, 1154, 329, 8, 99, "Input",
  CellTags->{"Minimal Realization", "i:4", "b:19.4"}],
Cell[42119, 1164, 801, 16, 83, "Output",
  CellTags->{"Minimal Realization", "i:4", "b:19.4"}],
Cell[42923, 1182, 152, 3, 29, "Print",
  CellTags->{"Minimal Realization", "i:4", "b:19.4"}],
Cell[43078, 1187, 552, 13, 101, "Output",
  CellTags->{"Minimal Realization", "i:4", "b:19.4"}],
Cell[43633, 1202, 447, 13, 101, "Output",
  CellTags->{"Minimal Realization", "i:4", "b:19.4"}],
Cell[44083, 1217, 420, 10, 65, "Output",
  CellTags->{"Minimal Realization", "i:4", "b:19.4"}],
Cell[44506, 1229, 357, 10, 65, "Output",
  CellTags->{"Minimal Realization", "i:4", "b:19.4"}]
}, Open  ]],
Cell[44878, 1242, 502, 10, 72, "Input",
  CellTags->{"Minimal Realization", "i:4", "b:19.4"}],

Cell[CellGroupData[{
Cell[45405, 1256, 329, 8, 99, "Input",
  CellTags->{"Minimal Realization", "i:4", "b:19.4"}],
Cell[45737, 1266, 1003, 19, 83, "Output",
  CellTags->{"Minimal Realization", "i:4", "b:19.4"}],
Cell[46743, 1287, 152, 3, 29, "Print",
  CellTags->{"Minimal Realization", "i:4", "b:19.4"}],
Cell[46898, 1292, 552, 13, 101, "Output",
  CellTags->{"Minimal Realization", "i:4", "b:19.4"}],
Cell[47453, 1307, 447, 13, 101, "Output",
  CellTags->{"Minimal Realization", "i:4", "b:19.4"}],
Cell[47903, 1322, 420, 10, 65, "Output",
  CellTags->{"Minimal Realization", "i:4", "b:19.4"}],
Cell[48326, 1334, 357, 10, 65, "Output",
  CellTags->{"Minimal Realization", "i:4", "b:19.4"}]
}, Open  ]],
Cell[48698, 1347, 205, 4, 33, "Input",
  CellTags->{"Minimal Realization", "i:4", "b:19.4"}],

Cell[CellGroupData[{
Cell[48928, 1355, 130, 3, 33, "Input",
  CellTags->{"Minimal Realization", "i:4", "b:19.4"}],
Cell[49061, 1360, 379, 9, 60, "Output",
  CellTags->{"Minimal Realization", "i:4", "b:19.4"}]
}, Open  ]],

Cell[CellGroupData[{
Cell[49477, 1374, 294, 7, 86, "Input",
  CellTags->{"Minimal Realization", "i:4", "b:19.4"}],
Cell[49774, 1383, 418, 11, 77, "Output",
  CellTags->{"Minimal Realization", "i:4", "b:19.4"}],
Cell[50195, 1396, 370, 11, 77, "Output",
  CellTags->{"Minimal Realization", "i:4", "b:19.4"}],
Cell[50568, 1409, 372, 9, 56, "Output",
  CellTags->{"Minimal Realization", "i:4", "b:19.4"}],
Cell[50943, 1420, 318, 9, 53, "Output",
  CellTags->{"Minimal Realization", "i:4", "b:19.4"}]
}, Open  ]],
Cell[51276, 1432, 227, 5, 33, "Input",
  CellTags->{"Minimal Realization", "i:4", "b:19.4"}],

Cell[CellGroupData[{
Cell[51528, 1441, 130, 3, 33, "Input",
  CellTags->{"Minimal Realization", "i:4", "b:19.4"}],
Cell[51661, 1446, 463, 11, 62, "Output",
  CellTags->{"Minimal Realization", "i:4", "b:19.4"}]
}, Open  ]],

Cell[CellGroupData[{
Cell[52161, 1462, 294, 7, 86, "Input",
  CellTags->{"Minimal Realization", "i:4", "b:19.4"}],
Cell[52458, 1471, 418, 11, 77, "Output",
  CellTags->{"Minimal Realization", "i:4", "b:19.4"}],
Cell[52879, 1484, 370, 11, 77, "Output",
  CellTags->{"Minimal Realization", "i:4", "b:19.4"}],
Cell[53252, 1497, 372, 9, 56, "Output",
  CellTags->{"Minimal Realization", "i:4", "b:19.4"}],
Cell[53627, 1508, 318, 9, 53, "Output",
  CellTags->{"Minimal Realization", "i:4", "b:19.4"}]
}, Open  ]],
Cell[53960, 1520, 157, 4, 35, "Text",
  CellTags->{"Minimal Realization", "i:4", "b:19.4"}],

Cell[CellGroupData[{
Cell[54142, 1528, 187, 4, 33, "Input",
  CellTags->{"Minimal Realization", "i:4", "b:19.4"}],
Cell[54332, 1534, 142, 3, 29, "Print",
  CellTags->{"Minimal Realization", "i:4", "b:19.4"}],
Cell[54477, 1539, 168, 3, 29, "Print",
  CellTags->{"Minimal Realization", "i:4", "b:19.4"}],
Cell[54648, 1544, 181, 4, 29, "Print",
  CellTags->{"Minimal Realization", "i:4", "b:19.4"}],
Cell[54832, 1550, 140, 3, 29, "Print",
  CellTags->{"Minimal Realization", "i:4", "b:19.4"}]
}, Open  ]],

Cell[CellGroupData[{
Cell[55009, 1558, 237, 6, 72, "Input",
  CellTags->{"Minimal Realization", "i:4", "b:19.4"}],
Cell[55249, 1566, 418, 11, 77, "Output",
  CellTags->{"Minimal Realization", "i:4", "b:19.4"}],
Cell[55670, 1579, 370, 11, 77, "Output",
  CellTags->{"Minimal Realization", "i:4", "b:19.4"}],
Cell[56043, 1592, 372, 9, 56, "Output",
  CellTags->{"Minimal Realization", "i:4", "b:19.4"}],
Cell[56418, 1603, 318, 9, 53, "Output",
  CellTags->{"Minimal Realization", "i:4", "b:19.4"}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[56785, 1618, 169, 3, 54, "Subsection",
  Evaluatable->False,
  CellTags->{"Controllability", "i:5", "b:19.5"}],
Cell[56957, 1623, 201, 6, 35, "Text",
  Evaluatable->False,
  CellTags->{"Controllability", "i:5", "b:19.5"}],

Cell[CellGroupData[{
Cell[57183, 1633, 181, 5, 33, "Input",
  CellTags->{"Controllability", "i:5", "b:19.5"}],
Cell[57367, 1640, 113, 3, 33, "Output",
  CellTags->{"Controllability", "i:5", "b:19.5"}]
}, Open  ]],

Cell[CellGroupData[{
Cell[57517, 1648, 179, 5, 33, "Input",
  CellTags->{"Controllability", "i:5", "b:19.5"}],
Cell[57699, 1655, 113, 3, 33, "Output",
  CellTags->{"Controllability", "i:5", "b:19.5"}]
}, Open  ]],
Cell[57827, 1661, 257, 6, 48, "Text",
  Evaluatable->False,
  CellTags->{"Controllability", "i:5", "b:19.5"}],

Cell[CellGroupData[{
Cell[58109, 1671, 192, 5, 33, "Input",
  CellTags->{"Controllability", "i:5", "b:19.5"}],
Cell[58304, 1678, 130, 3, 33, "Output",
  CellTags->{"Controllability", "i:5", "b:19.5"}]
}, Open  ]],
Cell[58449, 1684, 164, 3, 35, "Text",
  Evaluatable->False,
  CellTags->{"Controllability", "i:5", "b:19.5"}],

Cell[CellGroupData[{
Cell[58638, 1691, 195, 5, 33, "Input",
  CellTags->{"Controllability", "i:5", "b:19.5"}],
Cell[58836, 1698, 137, 3, 39, "Output",
  CellTags->{"Controllability", "i:5", "b:19.5"}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[59022, 1707, 121, 1, 54, "Subsection",
  CellTags->{"Kalman Form", "i:6", "b:19.6"}],
Cell[59146, 1710, 442, 7, 61, "Text",
  CellTags->{"Kalman Form", "i:6", "b:19.6"}],
Cell[59591, 1719, 249, 5, 59, "Input",
  CellTags->{"Kalman Form", "i:6", "b:19.6"}],

Cell[CellGroupData[{
Cell[59865, 1728, 322, 8, 86, "Input",
  CellTags->{"Kalman Form", "i:6", "b:19.6"}],
Cell[60190, 1738, 160, 3, 29, "Print",
  CellTags->{"Kalman Form", "i:6", "b:19.6"}],
Cell[60353, 1743, 173, 4, 29, "Print",
  CellTags->{"Kalman Form", "i:6", "b:19.6"}],
Cell[60529, 1749, 132, 3, 29, "Print",
  CellTags->{"Kalman Form", "i:6", "b:19.6"}],
Cell[60664, 1754, 175, 4, 29, "Print",
  CellTags->{"Kalman Form", "i:6", "b:19.6"}],
Cell[60842, 1760, 349, 10, 65, "Output",
  CellTags->{"Kalman Form", "i:6", "b:19.6"}],
Cell[61194, 1772, 334, 10, 65, "Output",
  CellTags->{"Kalman Form", "i:6", "b:19.6"}],
Cell[61531, 1784, 291, 8, 43, "Output",
  CellTags->{"Kalman Form", "i:6", "b:19.6"}],
Cell[61825, 1794, 286, 8, 43, "Output",
  CellTags->{"Kalman Form", "i:6", "b:19.6"}]
}, Open  ]],

Cell[CellGroupData[{
Cell[62148, 1807, 173, 6, 72, "Input",
  CellTags->{"Kalman Form", "i:6", "b:19.6"}],
Cell[62324, 1815, 138, 3, 33, "Output",
  CellTags->{"Kalman Form", "i:6", "b:19.6"}],
Cell[62465, 1820, 129, 3, 33, "Output",
  CellTags->{"Kalman Form", "i:6", "b:19.6"}],
Cell[62597, 1825, 116, 3, 33, "Output",
  CellTags->{"Kalman Form", "i:6", "b:19.6"}],
Cell[62716, 1830, 113, 3, 33, "Output",
  CellTags->{"Kalman Form", "i:6", "b:19.6"}]
}, Open  ]],

Cell[CellGroupData[{
Cell[62866, 1838, 365, 9, 99, "Input",
  CellTags->{"Kalman Form", "i:6", "b:19.6"}],
Cell[63234, 1849, 160, 3, 29, "Print",
  CellTags->{"Kalman Form", "i:6", "b:19.6"}],
Cell[63397, 1854, 173, 4, 29, "Print",
  CellTags->{"Kalman Form", "i:6", "b:19.6"}],
Cell[63573, 1860, 132, 3, 29, "Print",
  CellTags->{"Kalman Form", "i:6", "b:19.6"}],
Cell[63708, 1865, 175, 4, 29, "Print",
  CellTags->{"Kalman Form", "i:6", "b:19.6"}],
Cell[63886, 1871, 349, 10, 65, "Output",
  CellTags->{"Kalman Form", "i:6", "b:19.6"}],
Cell[64238, 1883, 334, 10, 65, "Output",
  CellTags->{"Kalman Form", "i:6", "b:19.6"}],
Cell[64575, 1895, 291, 8, 43, "Output",
  CellTags->{"Kalman Form", "i:6", "b:19.6"}],
Cell[64869, 1905, 286, 8, 43, "Output",
  CellTags->{"Kalman Form", "i:6", "b:19.6"}]
}, Open  ]],
Cell[65170, 1916, 264, 5, 59, "Input",
  CellTags->{"Kalman Form", "i:6", "b:19.6"}],

Cell[CellGroupData[{
Cell[65459, 1925, 322, 8, 86, "Input",
  CellTags->{"Kalman Form", "i:6", "b:19.6"}],
Cell[65784, 1935, 160, 3, 29, "Print",
  CellTags->{"Kalman Form", "i:6", "b:19.6"}],
Cell[65947, 1940, 173, 4, 29, "Print",
  CellTags->{"Kalman Form", "i:6", "b:19.6"}],
Cell[66123, 1946, 175, 4, 29, "Print",
  CellTags->{"Kalman Form", "i:6", "b:19.6"}],
Cell[66301, 1952, 132, 3, 29, "Print",
  CellTags->{"Kalman Form", "i:6", "b:19.6"}],
Cell[66436, 1957, 355, 10, 65, "Output",
  CellTags->{"Kalman Form", "i:6", "b:19.6"}],
Cell[66794, 1969, 334, 10, 65, "Output",
  CellTags->{"Kalman Form", "i:6", "b:19.6"}],
Cell[67131, 1981, 294, 8, 43, "Output",
  CellTags->{"Kalman Form", "i:6", "b:19.6"}],
Cell[67428, 1991, 286, 8, 43, "Output",
  CellTags->{"Kalman Form", "i:6", "b:19.6"}]
}, Open  ]],

Cell[CellGroupData[{
Cell[67751, 2004, 365, 9, 99, "Input",
  CellTags->{"Kalman Form", "i:6", "b:19.6"}],
Cell[68119, 2015, 160, 3, 29, "Print",
  CellTags->{"Kalman Form", "i:6", "b:19.6"}],
Cell[68282, 2020, 173, 4, 29, "Print",
  CellTags->{"Kalman Form", "i:6", "b:19.6"}],
Cell[68458, 2026, 175, 4, 29, "Print",
  CellTags->{"Kalman Form", "i:6", "b:19.6"}],
Cell[68636, 2032, 132, 3, 29, "Print",
  CellTags->{"Kalman Form", "i:6", "b:19.6"}],
Cell[68771, 2037, 355, 10, 65, "Output",
  CellTags->{"Kalman Form", "i:6", "b:19.6"}],
Cell[69129, 2049, 334, 10, 65, "Output",
  CellTags->{"Kalman Form", "i:6", "b:19.6"}],
Cell[69466, 2061, 294, 8, 43, "Output",
  CellTags->{"Kalman Form", "i:6", "b:19.6"}],
Cell[69763, 2071, 286, 8, 43, "Output",
  CellTags->{"Kalman Form", "i:6", "b:19.6"}]
}, Open  ]],
Cell[70064, 2082, 264, 5, 59, "Input",
  CellTags->{"Kalman Form", "i:6", "b:19.6"}],

Cell[CellGroupData[{
Cell[70353, 2091, 322, 8, 96, "Input",
  CellTags->{"Kalman Form", "i:6", "b:19.6"}],
Cell[70678, 2101, 161, 3, 29, "Print",
  CellTags->{"Kalman Form", "i:6", "b:19.6"}],
Cell[70842, 2106, 174, 4, 29, "Print",
  CellTags->{"Kalman Form", "i:6", "b:19.6"}],
Cell[71019, 2112, 285, 8, 43, "Output",
  CellTags->{"Kalman Form", "i:6", "b:19.6"}],
Cell[71307, 2122, 287, 8, 43, "Output",
  CellTags->{"Kalman Form", "i:6", "b:19.6"}],
Cell[71597, 2132, 282, 8, 43, "Output",
  CellTags->{"Kalman Form", "i:6", "b:19.6"}],
Cell[71882, 2142, 287, 8, 43, "Output",
  CellTags->{"Kalman Form", "i:6", "b:19.6"}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[72218, 2156, 155, 3, 54, "Subsection",
  Evaluatable->False,
  CellTags->{"Another Example", "b:19.7"}],
Cell[72376, 2161, 204, 6, 35, "Text",
  Evaluatable->False,
  CellTags->{"Another Example", "b:19.7"}],

Cell[CellGroupData[{
Cell[72605, 2171, 254, 6, 43, "Input",
  CellTags->{"Another Example", "b:19.7"}],
Cell[72862, 2179, 201, 4, 43, "Output",
  CellTags->{"Another Example", "b:19.7"}]
}, Open  ]],

Cell[CellGroupData[{
Cell[73100, 2188, 199, 5, 43, "Input",
  CellTags->{"Another Example", "b:19.7"}],
Cell[73302, 2195, 148, 3, 43, "Output",
  CellTags->{"Another Example", "b:19.7"}]
}, Open  ]],

Cell[CellGroupData[{
Cell[73487, 2203, 184, 5, 43, "Input",
  CellTags->{"Another Example", "b:19.7"}],
Cell[73674, 2210, 131, 3, 43, "Output",
  CellTags->{"Another Example", "b:19.7"}]
}, Open  ]],
Cell[73820, 2216, 151, 3, 35, "Text",
  Evaluatable->False,
  CellTags->{"Another Example", "b:19.7"}],

Cell[CellGroupData[{
Cell[73996, 2223, 175, 5, 43, "Input",
  CellTags->{"Another Example", "b:19.7"}],
Cell[74174, 2230, 107, 3, 43, "Output",
  CellTags->{"Another Example", "b:19.7"}]
}, Open  ]],

Cell[CellGroupData[{
Cell[74318, 2238, 173, 5, 43, "Input",
  CellTags->{"Another Example", "b:19.7"}],
Cell[74494, 2245, 107, 3, 43, "Output",
  CellTags->{"Another Example", "b:19.7"}]
}, Open  ]],
Cell[74616, 2251, 148, 3, 35, "Text",
  Evaluatable->False,
  CellTags->{"Another Example", "b:19.7"}],
Cell[74767, 2256, 203, 5, 43, "Input",
  CellTags->{"Another Example", "b:19.7"}],

Cell[CellGroupData[{
Cell[74995, 2265, 155, 5, 43, "Input",
  CellTags->{"Another Example", "b:19.7"}],
Cell[75153, 2272, 487, 8, 74, "Output",
  CellTags->{"Another Example", "b:19.7"}]
}, Open  ]],
Cell[75655, 2283, 179, 5, 35, "Text",
  Evaluatable->False,
  CellTags->{"Another Example", "b:19.7"}],

Cell[CellGroupData[{
Cell[75859, 2292, 171, 5, 43, "Input",
  CellTags->{"Another Example", "b:19.7"}],
Cell[76033, 2299, 104, 3, 43, "Output",
  CellTags->{"Another Example", "b:19.7"}]
}, Open  ]],

Cell[CellGroupData[{
Cell[76174, 2307, 173, 5, 43, "Input",
  CellTags->{"Another Example", "b:19.7"}],
Cell[76350, 2314, 1639, 42, 75, "Output",
  CellTags->{"Another Example", "b:19.7"}]
}, Open  ]],
Cell[78004, 2359, 202, 6, 35, "Text",
  Evaluatable->False,
  CellTags->{"Another Example", "b:19.7"}],

Cell[CellGroupData[{
Cell[78231, 2369, 180, 5, 43, "Input",
  CellTags->{"Another Example", "b:19.7"}],
Cell[78414, 2376, 678, 11, 96, "Output",
  CellTags->{"Another Example", "b:19.7"}]
}, Open  ]],

Cell[CellGroupData[{
Cell[79129, 2392, 178, 5, 43, "Input",
  CellTags->{"Another Example", "b:19.7"}],
Cell[79310, 2399, 676, 11, 96, "Output",
  CellTags->{"Another Example", "b:19.7"}]
}, Open  ]],
Cell[80001, 2413, 215, 6, 35, "Text",
  Evaluatable->False,
  CellTags->{"Another Example", "b:19.7"}],
Cell[80219, 2421, 354, 9, 43, "Input",
  CellTags->{"Another Example", "b:19.7"}],

Cell[CellGroupData[{
Cell[80598, 2434, 156, 5, 43, "Input",
  CellTags->{"Another Example", "b:19.7"}],
Cell[80757, 2441, 239, 4, 51, "Output",
  CellTags->{"Another Example", "b:19.7"}]
}, Open  ]],

Cell[CellGroupData[{
Cell[81033, 2450, 172, 5, 43, "Input",
  CellTags->{"Another Example", "b:19.7"}],
Cell[81208, 2457, 104, 3, 43, "Output",
  CellTags->{"Another Example", "b:19.7"}]
}, Open  ]],

Cell[CellGroupData[{
Cell[81349, 2465, 179, 5, 43, "Input",
  CellTags->{"Another Example", "b:19.7"}],
Cell[81531, 2472, 270, 5, 56, "Output",
  CellTags->{"Another Example", "b:19.7"}]
}, Open  ]],

Cell[CellGroupData[{
Cell[81838, 2482, 251, 7, 43, "Input",
  CellTags->{"Another Example", "b:19.7"}],
Cell[82092, 2491, 108, 3, 43, "Output",
  CellTags->{"Another Example", "b:19.7"}]
}, Open  ]],

Cell[CellGroupData[{
Cell[82237, 2499, 207, 5, 43, "Input",
  CellTags->{"Another Example", "b:19.7"}],
Cell[82447, 2506, 223, 4, 43, "Output",
  CellTags->{"Another Example", "b:19.7"}]
}, Open  ]],

Cell[CellGroupData[{
Cell[82707, 2515, 249, 7, 43, "Input",
  CellTags->{"Another Example", "b:19.7"}],
Cell[82959, 2524, 107, 3, 43, "Output",
  CellTags->{"Another Example", "b:19.7"}]
}, Open  ]],

Cell[CellGroupData[{
Cell[83103, 2532, 205, 5, 43, "Input",
  CellTags->{"Another Example", "b:19.7"}],
Cell[83311, 2539, 209, 4, 43, "Output",
  CellTags->{"Another Example", "b:19.7"}]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[83581, 2550, 85, 2, 40, "Section",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[83691, 2556, 122, 3, 54, "Subsection",
  Evaluatable->False,
  CellTags->{"Introduction", "b:20.0"}],
Cell[83816, 2561, 326, 7, 48, "Text",
  Evaluatable->False,
  CellTags->{"Introduction", "b:20.0"}]
}, Open  ]],

Cell[CellGroupData[{
Cell[84179, 2573, 123, 3, 54, "Subsection",
  Evaluatable->False,
  CellTags->{"Bode plot", "i:9", "b:20.1"}],
Cell[84305, 2578, 139, 3, 35, "Text",
  Evaluatable->False,
  CellTags->{"Bode plot", "i:9", "b:20.1"}],
Cell[84447, 2583, 255, 6, 54, "Input",
  CellTags->{"Bode plot", "i:9", "b:20.1"}],
Cell[84705, 2591, 227, 6, 35, "Text",
  Evaluatable->False,
  CellTags->{"Bode plot", "i:9", "b:20.1"}],

Cell[CellGroupData[{
Cell[84957, 2601, 172, 5, 43, "Input",
  CellTags->{"Bode plot", "i:9", "b:20.1"}],

Cell[CellGroupData[{
Cell[85154, 2610, 55774, 1794, 192, 31470, 1488, "GraphicsData", \
"PostScript", "Graphics",
  CellTags->{"Bode plot", "i:9", "b:20.1"}],
Cell[140931, 4406, 56161, 1796, 192, 31696, 1488, "GraphicsData", \
"PostScript", "Graphics",
  CellTags->{"Bode plot", "i:9", "b:20.1"}]
}, Open  ]],
Cell[197107, 6205, 378, 10, 43, "Output",
  CellTags->{"Bode plot", "i:9", "b:20.1"}]
}, Open  ]],
Cell[197500, 6218, 153, 4, 35, "Text",
  CellTags->{"Bode plot", "i:9", "b:20.1"}],

Cell[CellGroupData[{
Cell[197678, 6226, 274, 6, 68, "Input",
  CellTags->{"Bode plot", "i:9", "b:20.1"}],

Cell[CellGroupData[{
Cell[197977, 6236, 54493, 1812, 189, 31704, 1525, "GraphicsData", \
"PostScript", "Graphics",
  CellTags->{"Bode plot", "i:9", "b:20.1"}],
Cell[252473, 8050, 66076, 2555, 189, 42935, 2264, "GraphicsData", \
"PostScript", "Graphics",
  CellTags->{"Bode plot", "i:9", "b:20.1"}]
}, Open  ]],
Cell[318564, 10608, 378, 10, 43, "Output",
  CellTags->{"Bode plot", "i:9", "b:20.1"}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[318991, 10624, 130, 3, 54, "Subsection",
  Evaluatable->False,
  CellTags->{"Nyquist Plot", "i:10", "b:20.2"}],
Cell[319124, 10629, 216, 6, 35, "Text",
  Evaluatable->False,
  CellTags->{"Nyquist Plot", "i:10", "b:20.2"}],
Cell[319343, 10637, 259, 6, 54, "Input",
  CellTags->{"Nyquist Plot", "i:10", "b:20.2"}],

Cell[CellGroupData[{
Cell[319627, 10647, 187, 5, 43, "Input",
  CellTags->{"Nyquist Plot", "i:10", "b:20.2"}],
Cell[319817, 10654, 53660, 2128, 194, 29467, 1824, "GraphicsData", \
"PostScript", "Graphics",
  CellTags->{"Nyquist Plot", "i:10", "b:20.2"}],
Cell[373480, 12784, 204, 5, 43, "Output",
  CellTags->{"Nyquist Plot", "i:10", "b:20.2"}]
}, Open  ]],
Cell[373699, 12792, 164, 3, 35, "Text",
  Evaluatable->False,
  CellTags->{"Nyquist Plot", "i:10", "b:20.2"}],

Cell[CellGroupData[{
Cell[373888, 12799, 194, 5, 43, "Input",
  CellTags->{"Nyquist Plot", "i:10", "b:20.2"}],
Cell[374085, 12806, 26628, 1030, 194, 14823, 879, "GraphicsData", \
"PostScript", "Graphics",
  CellTags->{"Nyquist Plot", "i:10", "b:20.2"}],
Cell[400716, 13838, 204, 5, 43, "Output",
  CellTags->{"Nyquist Plot", "i:10", "b:20.2"}]
}, Open  ]],
Cell[400935, 13846, 288, 7, 48, "Text",
  Evaluatable->False,
  CellTags->{"Nyquist Plot", "i:10", "b:20.2"}],

Cell[CellGroupData[{
Cell[401248, 13857, 205, 5, 43, "Input",
  CellTags->{"Nyquist Plot", "i:10", "b:20.2"}],
Cell[401456, 13864, 189295, 10547, 402, 130862, 9820, "GraphicsData", \
"PostScript", "Graphics",
  CellTags->{"Nyquist Plot", "i:10", "b:20.2"}],
Cell[590754, 24413, 204, 5, 43, "Output",
  CellTags->{"Nyquist Plot", "i:10", "b:20.2"}]
}, Open  ]],
Cell[590973, 24421, 344, 6, 61, "Text",
  CellTags->{"Nyquist Plot", "i:10", "b:20.2"}],

Cell[CellGroupData[{
Cell[591342, 24431, 453, 9, 69, "Input",
  CellTags->{"Nyquist Plot", "i:10", "b:20.2"}],
Cell[591798, 24442, 125195, 5345, 431, 67547, 4628, "GraphicsData", \
"PostScript", "Graphics",
  CellTags->{"Nyquist Plot", "i:10", "b:20.2"}],
Cell[716996, 29789, 204, 5, 43, "Output",
  CellTags->{"Nyquist Plot", "i:10", "b:20.2"}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[717249, 29800, 126, 3, 54, "Subsection",
  Evaluatable->False,
  CellTags->{"Root Locus", "i:11", "b:20.3"}],
Cell[717378, 29805, 412, 8, 61, "Text",
  Evaluatable->False,
  CellTags->{"Root Locus", "i:11", "b:20.3"}],

Cell[CellGroupData[{
Cell[717815, 29817, 191, 5, 43, "Input",
  CellTags->{"Root Locus", "i:11", "b:20.3"}],
Cell[718009, 29824, 172, 4, 55, "Print",
  CellTags->{"Root Locus", "i:11", "b:20.3"}],
Cell[718184, 29830, 116395, 2854, 465, 35031, 1844, "GraphicsData", \
"PostScript", "Graphics",
  CellTags->{"Root Locus", "i:11", "b:20.3"}],
Cell[834582, 32686, 202, 5, 43, "Output",
  CellTags->{"Root Locus", "i:11", "b:20.3"}],
Cell[834787, 32693, 237, 5, 29, "Print",
  CellTags->{"Root Locus", "i:11", "b:20.3"}],
Cell[835027, 32700, 146636, 3345, 565, 36843, 1984, "GraphicsData", \
"PostScript", "Graphics",
  CellTags->{"Root Locus", "i:11", "b:20.3"}],
Cell[981666, 36047, 202, 5, 43, "Output",
  CellTags->{"Root Locus", "i:11", "b:20.3"}]
}, Open  ]],

Cell[CellGroupData[{
Cell[981905, 36057, 282, 5, 68, "Input",
  CellTags->{"Root Locus", "i:11", "b:20.3"}],
Cell[982190, 36064, 172, 4, 55, "Print",
  CellTags->{"Root Locus", "i:11", "b:20.3"}],
Cell[982365, 36070, 139858, 3325, 534, 38850, 2073, "GraphicsData", \
"PostScript", "Graphics",
  CellTags->{"Root Locus", "i:11", "b:20.3"}],
Cell[1122226, 39397, 202, 5, 43, "Output",
  CellTags->{"Root Locus", "i:11", "b:20.3"}]
}, Open  ]],
Cell[1122443, 39405, 210, 6, 35, "Text",
  Evaluatable->False,
  CellTags->{"Root Locus", "i:11", "b:20.3"}],

Cell[CellGroupData[{
Cell[1122678, 39415, 197, 5, 43, "Input",
  CellTags->{"Root Locus", "i:11", "b:20.3"}],
Cell[1122878, 39422, 172, 4, 55, "Print",
  CellTags->{"Root Locus", "i:11", "b:20.3"}],
Cell[1123053, 39428, 121244, 2962, 502, 36644, 1912, "GraphicsData", \
"PostScript", "Graphics",
  CellTags->{"Root Locus", "i:11", "b:20.3"}],
Cell[1244300, 42392, 202, 5, 43, "Output",
  CellTags->{"Root Locus", "i:11", "b:20.3"}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[1244551, 42403, 134, 3, 54, "Subsection",
  Evaluatable->False,
  CellTags->{"Pole-Zero Plot", "i:12", "b:20.4"}],
Cell[1244688, 42408, 236, 6, 35, "Text",
  Evaluatable->False,
  CellTags->{"Pole-Zero Plot", "i:12", "b:20.4"}],
Cell[1244927, 42416, 241, 7, 54, "Input",
  CellTags->{"Pole-Zero Plot", "i:12", "b:20.4"}],
Cell[1245171, 42425, 127, 3, 35, "Text",
  Evaluatable->False,
  CellTags->{"Pole-Zero Plot", "i:12", "b:20.4"}],

Cell[CellGroupData[{
Cell[1245323, 42432, 176, 5, 43, "Input",
  CellTags->{"Pole-Zero Plot", "i:12", "b:20.4"}],
Cell[1245502, 42439, 289, 6, 42, "Print",
  CellTags->{"Pole-Zero Plot", "i:12", "b:20.4"}],
Cell[1245794, 42447, 275, 5, 29, "Print",
  CellTags->{"Pole-Zero Plot", "i:12", "b:20.4"}],
Cell[1246072, 42454, 125883, 2944, 250, 72965, 2285, "GraphicsData", \
"PostScript", "Graphics",
  CellTags->{"Pole-Zero Plot", "i:12", "b:20.4"}],
Cell[1371958, 45400, 213, 5, 43, "Output",
  CellTags->{"Pole-Zero Plot", "i:12", "b:20.4"}]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[1372232, 45412, 105, 2, 40, "Section",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[1372362, 45418, 133, 3, 54, "Subsection",
  Evaluatable->False,
  CellTags->{"Introduction the linear", "b:21.0"}],
Cell[1372498, 45423, 411, 8, 61, "Text",
  Evaluatable->False,
  CellTags->{"Introduction the linear", "b:21.0"}]
}, Open  ]],

Cell[CellGroupData[{
Cell[1372946, 45436, 95, 1, 54, "Subsection",
  CellTags->{"i:24", "LyapunovEquation", "b:21.1"}],

Cell[CellGroupData[{
Cell[1373066, 45441, 132, 3, 43, "Input",
  CellTags->{"i:24", "LyapunovEquation", "b:21.1"}],
Cell[1373201, 45446, 252, 4, 68, "Print",
  CellTags->{"Info3266692353-2707657", "b:21.1"}]
}, Open  ]],
Cell[1373468, 45453, 165, 3, 43, "Input",
  CellTags->{"i:24", "LyapunovEquation", "b:21.1"}],

Cell[CellGroupData[{
Cell[1373658, 45460, 125, 3, 43, "Input",
  CellTags->{"i:24", "LyapunovEquation", "b:21.1"}],
Cell[1373786, 45465, 128, 3, 43, "Output",
  CellTags->{"i:24", "LyapunovEquation", "b:21.1"}]
}, Open  ]],

Cell[CellGroupData[{
Cell[1373951, 45473, 137, 3, 43, "Input",
  CellTags->{"i:24", "LyapunovEquation", "b:21.1"}],
Cell[1374091, 45478, 140, 3, 49, "Output",
  CellTags->{"i:24", "LyapunovEquation", "b:21.1"}]
}, Open  ]],
Cell[1374246, 45484, 205, 4, 35, "Text",
  CellTags->{"i:24", "LyapunovEquation", "b:21.1"}],

Cell[CellGroupData[{
Cell[1374476, 45492, 125, 3, 43, "Input",
  CellTags->{"i:24", "LyapunovEquation", "b:21.1"}],
Cell[1374604, 45497, 154, 3, 49, "Output",
  CellTags->{"i:24", "LyapunovEquation", "b:21.1"}]
}, Open  ]],

Cell[CellGroupData[{
Cell[1374795, 45505, 149, 3, 43, "Input",
  CellTags->{"i:24", "LyapunovEquation", "b:21.1"}],
Cell[1374947, 45510, 154, 3, 29, "Print",
  CellTags->{"i:24", "LyapunovEquation", "b:21.1"}],
Cell[1375104, 45515, 114, 3, 43, "Output",
  CellTags->{"i:24", "LyapunovEquation", "b:21.1"}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[1375267, 45524, 166, 3, 54, "Subsection",
  Evaluatable->False,
  CellTags->{"The Algebraic Riccati Equation", "i:13", "b:21.2"}],
Cell[1375436, 45529, 691, 13, 116, "Text",
  Evaluatable->False,
  CellTags->{"The Algebraic Riccati Equation", "i:13", "b:21.2"}],
Cell[1376130, 45544, 251, 6, 46, "Input",
  CellTags->{"The Algebraic Riccati Equation", "i:13", "b:21.2"}],
Cell[1376384, 45552, 157, 3, 35, "Text",
  Evaluatable->False,
  CellTags->{"The Algebraic Riccati Equation", "i:13", "b:21.2"}],

Cell[CellGroupData[{
Cell[1376566, 45559, 219, 5, 43, "Input",
  CellTags->{"The Algebraic Riccati Equation", "i:13", "b:21.2"}],
Cell[1376788, 45566, 167, 3, 29, "Print",
  CellTags->{"The Algebraic Riccati Equation", "i:13", "b:21.2"}],
Cell[1376958, 45571, 156, 3, 29, "Print",
  CellTags->{"The Algebraic Riccati Equation", "i:13", "b:21.2"}],
Cell[1377117, 45576, 247, 4, 55, "Output",
  CellTags->{"The Algebraic Riccati Equation", "i:13", "b:21.2"}]
}, Open  ]],
Cell[1377379, 45583, 596, 11, 74, "Text",
  Evaluatable->False,
  CellTags->{"The Algebraic Riccati Equation", "i:13", "b:21.2"}],
Cell[1377978, 45596, 339, 7, 69, "Input",
  CellTags->{"The Algebraic Riccati Equation", "i:13", "b:21.2"}],

Cell[CellGroupData[{
Cell[1378342, 45607, 222, 5, 43, "Input",
  CellTags->{"The Algebraic Riccati Equation", "i:13", "b:21.2"}],
Cell[1378567, 45614, 271, 5, 49, "Output",
  CellTags->{"The Algebraic Riccati Equation", "i:13", "b:21.2"}]
}, Open  ]],
Cell[1378853, 45622, 365, 7, 48, "Text",
  Evaluatable->False,
  CellTags->{"The Algebraic Riccati Equation", "i:13", "b:21.2"}],

Cell[CellGroupData[{
Cell[1379243, 45633, 225, 5, 43, "Input",
  CellTags->{"The Algebraic Riccati Equation", "i:13", "b:21.2"}],
Cell[1379471, 45640, 533, 9, 43, "Output",
  CellTags->{"The Algebraic Riccati Equation", "i:13", "b:21.2"}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[1380053, 45655, 150, 3, 54, "Subsection",
  Evaluatable->False,
  CellTags->{"Optimal State Feedback", "i:14", "b:21.3"}],
Cell[1380206, 45660, 194, 5, 35, "Text",
  Evaluatable->False,
  CellTags->{"Optimal State Feedback", "i:14", "b:21.3"}],
Cell[1380403, 45667, 210, 5, 46, "Input",
  CellTags->{"Optimal State Feedback", "i:14", "b:21.3"}],
Cell[1380616, 45674, 286, 7, 48, "Text",
  Evaluatable->False,
  CellTags->{"Optimal State Feedback", "i:14", "b:21.3"}],
Cell[1380905, 45683, 198, 5, 43, "Input",
  CellTags->{"Optimal State Feedback", "i:14", "b:21.3"}],
Cell[1381106, 45690, 165, 3, 35, "Text",
  Evaluatable->False,
  CellTags->{"Optimal State Feedback", "i:14", "b:21.3"}],

Cell[CellGroupData[{
Cell[1381296, 45697, 196, 5, 43, "Input",
  CellTags->{"Optimal State Feedback", "i:14", "b:21.3"}],
Cell[1381495, 45704, 159, 3, 29, "Print",
  CellTags->{"Optimal State Feedback", "i:14", "b:21.3"}],
Cell[1381657, 45709, 148, 3, 29, "Print",
  CellTags->{"Optimal State Feedback", "i:14", "b:21.3"}],
Cell[1381808, 45714, 339, 6, 55, "Output",
  CellTags->{"Optimal State Feedback", "i:14", "b:21.3"}]
}, Open  ]],
Cell[1382162, 45723, 270, 6, 48, "Text",
  Evaluatable->False,
  CellTags->{"Optimal State Feedback", "i:14", "b:21.3"}]
}, Open  ]],

Cell[CellGroupData[{
Cell[1382469, 45734, 174, 3, 54, "Subsection",
  Evaluatable->False,
  CellTags->{"Optimal Stochastic State Estimator", "i:15", "b:21.4"}],
Cell[1382646, 45739, 879, 22, 338, "Text",
  Evaluatable->False,
  CellTags->{"Optimal Stochastic State Estimator", "i:15", "b:21.4"}],
Cell[1383528, 45763, 230, 5, 43, "Input",
  CellTags->{"Optimal Stochastic State Estimator", "i:15", "b:21.4"}],
Cell[1383761, 45770, 159, 3, 35, "Text",
  Evaluatable->False,
  CellTags->{"Optimal Stochastic State Estimator", "i:15", "b:21.4"}],

Cell[CellGroupData[{
Cell[1383945, 45777, 212, 5, 43, "Input",
  CellTags->{"Optimal Stochastic State Estimator", "i:15", "b:21.4"}],
Cell[1384160, 45784, 451, 8, 106, "Output",
  CellTags->{"Optimal Stochastic State Estimator", "i:15", "b:21.4"}]
}, Open  ]],
Cell[1384626, 45795, 173, 3, 35, "Text",
  Evaluatable->False,
  CellTags->{"Optimal Stochastic State Estimator", "i:15", "b:21.4"}],

Cell[CellGroupData[{
Cell[1384824, 45802, 182, 5, 43, "Input",
  CellTags->{"Optimal Stochastic State Estimator", "i:15", "b:21.4"}],
Cell[1385009, 45809, 307, 6, 43, "Output",
  CellTags->{"Optimal Stochastic State Estimator", "i:15", "b:21.4"}]
}, Open  ]],
Cell[1385331, 45818, 438, 10, 90, "Text",
  Evaluatable->False,
  CellTags->{"Optimal Stochastic State Estimator", "i:15", "b:21.4"}],

Cell[CellGroupData[{
Cell[1385794, 45832, 215, 5, 43, "Input",
  CellTags->{"Optimal Stochastic State Estimator", "i:15", "b:21.4"}],
Cell[1386012, 45839, 331, 6, 43, "Output",
  CellTags->{"Optimal Stochastic State Estimator", "i:15", "b:21.4"}]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[1386404, 45852, 69, 1, 51, "Section",
  CellTags->{"Bibliography", "b:22"}],
Cell[1386476, 45855, 778, 16, 216, "Text",
  CellTags->{"Bibliography", "b:22"}]
}, Open  ]]
}
]
*)



(*******************************************************************
End of Mathematica Notebook file.
*******************************************************************)

