(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 7.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[     43491,       1654]
NotebookOptionsPosition[     23437,       1036]
NotebookOutlinePosition[     36736,       1455]
CellTagsIndexPosition[     33262,       1351]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell["ProPac", "IndexSection",
 CellTags->"MasterIndexHeading"],

Cell[TextData[{
 "Ad",
 ", ",
 ButtonBox["LieBracket & Ad",
  BaseStyle->"AddOnsLink",
  ButtonData:>{"LieBracket & Ad", "i:3"}]
}], "Index",
 CellTags->"Ad"],

Cell[TextData[{
 "AdaptiveBackstepRegulator",
 ", ",
 ButtonBox["Adaptive Control",
  BaseStyle->"AddOnsLink",
  ButtonData:>{"Adaptive Control", "i:4"}]
}], "Index",
 CellTags->"AdaptiveBackstepRegulator"],

Cell[TextData[{
 "AdaptiveRegulator",
 ", ",
 ButtonBox["Adaptive Control",
  BaseStyle->"AddOnsLink",
  ButtonData:>{"Adaptive Control", "i:22"}]
}], "Index",
 CellTags->"AdaptiveRegulator"],

Cell[TextData[{
 "AdaptiveTracking",
 ", ",
 ButtonBox["Adaptive Control",
  BaseStyle->"AddOnsLink",
  ButtonData:>{"Adaptive Control", "i:22"}]
}], "Index",
 CellTags->"AdaptiveTracking"],

Cell[TextData[{
 "AlgebraicConstraints",
 ", ",
 ButtonBox["Closed Chains",
  BaseStyle->"AddOnsLink",
  ButtonData:>{"Closed Chains", "i:7"}]
}], "Index",
 CellTags->"AlgebraicConstraints"],

Cell[TextData[{
 "AlgebraicRiccatiEquation",
 ", ",
 ButtonBox["The Algebraic Riccati Equation",
  BaseStyle->"AddOnsLink",
  ButtonData:>{"The Algebraic Riccati Equation", "i:13"}]
}], "Index",
 CellTags->"AlgebraicRiccatiEquation"],

Cell[TextData[{
 "BacklashPotential",
 ", ",
 ButtonBox["Backlash",
  BaseStyle->"AddOnsLink",
  ButtonData:>{"Backlash", "i:3"}],
 ", ",
 ButtonBox["Friction",
  BaseStyle->"AddOnsLink",
  ButtonData:>{"Friction", "i:5"}],
 ", ",
 ButtonBox["Introduction",
  BaseStyle->"AddOnsLink",
  ButtonData:>{"Introduction", "i:1"}]
}], "Index",
 CellTags->"BacklashPotential"],

Cell[TextData[{
 "Bode",
 ", ",
 ButtonBox["Bode Plot",
  BaseStyle->"AddOnsLink",
  ButtonData:>{"Bode Plot", "i:9"}]
}], "Index",
 CellTags->"Bode"],

Cell[TextData[{
 "ColorNyquist",
 ", ",
 ButtonBox["Nyquist Plot",
  BaseStyle->"AddOnsLink",
  ButtonData:>{"Nyquist Plot", "i:10"}]
}], "Index",
 CellTags->"ColorNyquist"],

Cell[TextData[{
 "Contraction",
 ", ",
 ButtonBox["Contraction",
  BaseStyle->"AddOnsLink",
  ButtonData:>{"Contraction", "i:7"}]
}], "Index",
 CellTags->"Contraction"],

Cell[TextData[{
 "ControlDistribution",
 ", ",
 ButtonBox["Controllability & Observability",
  BaseStyle->"AddOnsLink",
  ButtonData:>{"Controllability & Observability", "i:17"}]
}], "Index",
 CellTags->"ControlDistribution"],

Cell[TextData[{
 "Controllability",
 ", ",
 ButtonBox["Controllability & Observability",
  BaseStyle->"AddOnsLink",
  ButtonData:>{"Controllability & Observability", "i:17"}]
}], "Index",
 CellTags->"Controllability"],

Cell[TextData[{
 "ControllablePair",
 ", ",
 ButtonBox["Controllability, Observability and Pole Placement",
  BaseStyle->"AddOnsLink",
  ButtonData:>{"Controllability, Observability and Pole Placement", "i:5"}]
}], "Index",
 CellTags->"ControllablePair"],

Cell[TextData[{
 "ControllableRealization",
 ", ",
 ButtonBox["State Space to Transfer Function and Back",
  BaseStyle->"AddOnsLink",
  ButtonData:>{"State Space to Transfer Function and Back", "i:3"}]
}], "Index",
 CellTags->"ControllableRealization"],

Cell[TextData[{
 "CreateControllerMEX",
 ", ",
 ButtonBox["Creating SIMULINK S-Functions",
  BaseStyle->"AddOnsLink",
  ButtonData:>{"Creating SIMULINK S-Functions", "i:23"}]
}], "Index",
 CellTags->"CreateControllerMEX"],

Cell[TextData[{
 "CreateModel",
 ", ",
 ButtonBox["Backlash",
  BaseStyle->"AddOnsLink",
  ButtonData:>{"Backlash", "i:3"}],
 ", ",
 ButtonBox["Building Equations",
  BaseStyle->"AddOnsLink",
  ButtonData:>{"Building Equations", "i:1"}],
 ", ",
 ButtonBox["Flexible Manipulator",
  BaseStyle->"AddOnsLink",
  ButtonData:>{"Flexible Manipulator", "i:5"}],
 ", ",
 ButtonBox["Suspension System",
  BaseStyle->"AddOnsLink",
  ButtonData:>{"Suspension System", "i:4"}],
 ", ",
 ButtonBox["Tractor-Trailer",
  BaseStyle->"AddOnsLink",
  ButtonData:>{"Tractor-Trailer", "i:6"}]
}], "Index",
 CellTags->"CreateModel"],

Cell[TextData[{
 "CreateModelMEX",
 ", ",
 ButtonBox["Creating MEX-Files",
  BaseStyle->"AddOnsLink",
  ButtonData:>{"Creating MEX-Files", "i:3"}],
 ", ",
 ButtonBox["Tractor-Trailer",
  BaseStyle->"AddOnsLink",
  ButtonData:>{"Tractor-Trailer", "i:6"}]
}], "Index",
 CellTags->"CreateModelMEX"],

Cell[TextData[{
 "d[ ]",
 ", ",
 ButtonBox["Exterior Derivative",
  BaseStyle->"AddOnsLink",
  ButtonData:>{"Exterior Derivative", "i:1"}]
}], "Index",
 CellTags->"d[ ]"],

Cell[TextData[{
 "DecouplingMatrix",
 ", ",
 ButtonBox["Input-Output Linearization, Relative Degree & Decoupling",
  BaseStyle->"AddOnsLink",
  ButtonData:>{
   "Input-Output Linearization, Relative Degree & Decoupling", "i:19"}]
}], "Index",
 CellTags->"DecouplingMatrix"],

Cell[TextData[{
 "DifferentialConstraints",
 ", ",
 ButtonBox["The Rolling Disk",
  BaseStyle->"AddOnsLink",
  ButtonData:>{"The Rolling Disk", "i:9"}]
}], "Index",
 CellTags->"DifferentialConstraints"],

Cell[TextData[{
 "DynamicExtension",
 ", ",
 ButtonBox["Dynamic extension",
  BaseStyle->"AddOnsLink",
  ButtonData:>{"Dynamic extension", "i:20"}]
}], "Index",
 CellTags->"DynamicExtension"],

Cell[TextData[{
 "EndEffector",
 ", ",
 ButtonBox["Closed Chains",
  BaseStyle->"AddOnsLink",
  ButtonData:>{"Closed Chains", "i:7"}],
 ", ",
 ButtonBox["Flexible Manipulator",
  BaseStyle->"AddOnsLink",
  ButtonData:>{"Flexible Manipulator", "i:5"}]
}], "Index",
 CellTags->"EndEffector"],

Cell[TextData[{
 "EquilibriumSurface",
 ", ",
 ButtonBox["Equilibrium Surface",
  BaseStyle->"AddOnsLink",
  ButtonData:>{"Equilibrium Surface", "i:2"}]
}], "Index",
 CellTags->"EquilibriumSurface"],

Cell[TextData[{
 "ExpMap",
 ", ",
 ButtonBox["Composition",
  BaseStyle->"AddOnsLink",
  ButtonData:>{"Composition", "i:4"}],
 ", ",
 ButtonBox["Exponential Map",
  BaseStyle->"AddOnsLink",
  ButtonData:>{"Exponential Map", "i:3"}]
}], "Index",
 CellTags->"ExpMap"],

Cell[TextData[{
 "ExponentialObserver",
 ", ",
 ButtonBox["Nonlinear Observers",
  BaseStyle->"AddOnsLink",
  ButtonData:>{"Nonlinear Observers", "i:1"}]
}], "Index",
 CellTags->"ExponentialObserver"],

Cell[TextData[{
 "FeedbackLinearizable",
 ", ",
 ButtonBox["Exact Feedback Linearization",
  BaseStyle->"AddOnsLink",
  ButtonData:>{"Exact Feedback Linearization", "i:2"}]
}], "Index",
 CellTags->"FeedbackLinearizable"],

Cell[TextData[{
 "FlowComposition",
 ", ",
 ButtonBox["Composition",
  BaseStyle->"AddOnsLink",
  ButtonData:>{"Composition", "i:4"}]
}], "Index",
 CellTags->"FlowComposition"],

Cell[TextData[{
 "FormBasis",
 ", ",
 ButtonBox["Form Basis",
  BaseStyle->"AddOnsLink",
  ButtonData:>{"Form Basis", "i:4"}]
}], "Index",
 CellTags->"FormBasis"],

Cell[TextData[{
 "FormDegree",
 ", ",
 ButtonBox["Forms",
  BaseStyle->"AddOnsLink",
  ButtonData:>{"Forms", "i:2"}]
}], "Index",
 CellTags->"FormDegree"],

Cell[TextData[{
 "FormQ",
 ", ",
 ButtonBox["Forms",
  BaseStyle->"AddOnsLink",
  ButtonData:>{"Forms", "i:2"}]
}], "Index",
 CellTags->"FormQ"],

Cell[TextData[{
 "GeneralizedForce",
 ", ",
 ButtonBox["Tractor-Trailer",
  BaseStyle->"AddOnsLink",
  ButtonData:>{"Tractor-Trailer", "i:6"}]
}], "Index",
 CellTags->"GeneralizedForce"],

Cell[TextData[{
 "Grad",
 ", ",
 ButtonBox["Grad",
  BaseStyle->"AddOnsLink",
  ButtonData:>{"Grad", "i:1"}]
}], "Index",
 CellTags->"Grad"],

Cell[TextData[{
 "InverseTransformation",
 ", ",
 ButtonBox["Autonomous Systems",
  BaseStyle->"AddOnsLink",
  ButtonData:>{"Autonomous Systems", "i:2"}],
 ", ",
 ButtonBox["Exact Feedback Linearization",
  BaseStyle->"AddOnsLink",
  ButtonData:>{"Exact Feedback Linearization", "i:2"}],
 ", ",
 ButtonBox["Input-Output Linearization, Relative Degree & Decoupling",
  BaseStyle->"AddOnsLink",
  ButtonData:>{
   "Input-Output Linearization, Relative Degree & Decoupling", "i:19"}]
}], "Index",
 CellTags->"InverseTransformation"],

Cell[TextData[{
 "Involutive",
 ", ",
 ButtonBox["Exact Feedback Linearization",
  BaseStyle->"AddOnsLink",
  ButtonData:>{"Exact Feedback Linearization", "i:2"}]
}], "Index",
 CellTags->"Involutive"],

Cell[TextData[{
 "IOLinearization",
 ", ",
 ButtonBox["Dynamic Inverse",
  BaseStyle->"AddOnsLink",
  ButtonData:>{"Dynamic Inverse", "i:21"}]
}], "Index",
 CellTags->"IOLinearization"],

Cell[TextData[{
 "IOLinearize",
 ", ",
 ButtonBox["Input-Output Linearization, Relative Degree & Decoupling",
  BaseStyle->"AddOnsLink",
  ButtonData:>{
   "Input-Output Linearization, Relative Degree & Decoupling", "i:19"}],
 ", ",
 ButtonBox["The Sliding Surface",
  BaseStyle->"AddOnsLink",
  ButtonData:>{"The Sliding Surface", "i:1"}]
}], "Index",
 CellTags->"IOLinearize"],

Cell[TextData[{
 "IrreducibleRealization",
 ", ",
 ButtonBox["Kalman Canonical Form",
  BaseStyle->"AddOnsLink",
  ButtonData:>{"Kalman Canonical Form", "i:6"}]
}], "Index",
 CellTags->"IrreducibleRealization"],

Cell[TextData[{
 "Jacob",
 ", ",
 ButtonBox["Jacob",
  BaseStyle->"AddOnsLink",
  ButtonData:>{"Jacob", "i:2"}]
}], "Index",
 CellTags->"Jacob"],

Cell[TextData[{
 "JointFrictionPotential",
 ", ",
 ButtonBox["Friction",
  BaseStyle->"AddOnsLink",
  ButtonData:>{"Friction", "i:5"}],
 ", ",
 ButtonBox["Introduction",
  BaseStyle->"AddOnsLink",
  ButtonData:>{"Introduction", "i:1"}]
}], "Index",
 CellTags->"JointFrictionPotential"],

Cell[TextData[{
 "Joints",
 ", ",
 ButtonBox["Backlash",
  BaseStyle->"AddOnsLink",
  ButtonData:>{"Backlash", "i:3"}],
 ", ",
 ButtonBox["Suspension System",
  BaseStyle->"AddOnsLink",
  ButtonData:>{"Suspension System", "i:4"}],
 ", ",
 ButtonBox["Tractor-Trailer",
  BaseStyle->"AddOnsLink",
  ButtonData:>{"Tractor-Trailer", "i:6"}]
}], "Index",
 CellTags->"Joints"],

Cell[TextData[{
 "KalmanDecomposition",
 ", ",
 ButtonBox["Kalman Canonical Form",
  BaseStyle->"AddOnsLink",
  ButtonData:>{"Kalman Canonical Form", "i:6"}]
}], "Index",
 CellTags->"KalmanDecomposition"],

Cell[TextData[{
 "KinematicReplacements",
 ", ",
 ButtonBox["Tractor-Trailer",
  BaseStyle->"AddOnsLink",
  ButtonData:>{"Tractor-Trailer", "i:6"}]
}], "Index",
 CellTags->"KinematicReplacements"],

Cell[TextData[{
 "LargestInvariantDistribution",
 ", ",
 ButtonBox["Invariant Distributions",
  BaseStyle->"AddOnsLink",
  ButtonData:>{"Invariant Distributions", "i:8"}]
}], "Index",
 CellTags->"LargestInvariantDistribution"],

Cell[TextData[{
 "LeafPotential",
 ", ",
 ButtonBox["Suspension System",
  BaseStyle->"AddOnsLink",
  ButtonData:>{"Suspension System", "i:4"}]
}], "Index",
 CellTags->"LeafPotential"],

Cell[TextData[{
 "LieBracket",
 ", ",
 ButtonBox["LieBracket & Ad",
  BaseStyle->"AddOnsLink",
  ButtonData:>{"LieBracket & Ad", "i:3"}]
}], "Index",
 CellTags->"LieBracket"],

Cell[TextData[{
 "LieDerivative",
 ", ",
 ButtonBox["Lie Derivative",
  BaseStyle->"AddOnsLink",
  ButtonData:>{"Lie Derivative", "i:5"}],
 ", ",
 ButtonBox["LieDerivative",
  BaseStyle->"AddOnsLink",
  ButtonData:>{"LieDerivative", "i:4"}]
}], "Index",
 CellTags->"LieDerivative"],

Cell[TextData[{
 "LinearizeToOutputInjection",
 ", ",
 ButtonBox["Autonomous Systems",
  BaseStyle->"AddOnsLink",
  ButtonData:>{"Autonomous Systems", "i:2"}],
 ", ",
 ButtonBox["Introduction",
  BaseStyle->"AddOnsLink",
  ButtonData:>{"Introduction", "i:1"}]
}], "Index",
 CellTags->"LinearizeToOutputInjection"],

Cell[TextData[{
 "LocalDecomposition",
 ", ",
 ButtonBox["Controllability & Observability",
  BaseStyle->"AddOnsLink",
  ButtonData:>{"Controllability & Observability", "i:17"}]
}], "Index",
 CellTags->"LocalDecomposition"],

Cell[TextData[{
 "LocalZeroDynamics",
 ", ",
 ButtonBox["Input-Output Linearization, Relative Degree & Decoupling",
  BaseStyle->"AddOnsLink",
  ButtonData:>{
   "Input-Output Linearization, Relative Degree & Decoupling", "i:19"}]
}], "Index",
 CellTags->"LocalZeroDynamics"],

Cell[TextData[{
 "LQE",
 ", ",
 ButtonBox["Optimal Stochastic State Estimator",
  BaseStyle->"AddOnsLink",
  ButtonData:>{"Optimal Stochastic State Estimator", "i:15"}]
}], "Index",
 CellTags->"LQE"],

Cell[TextData[{
 "LQR",
 ", ",
 ButtonBox["Optimal State Feedback",
  BaseStyle->"AddOnsLink",
  ButtonData:>{"Optimal State Feedback", "i:14"}]
}], "Index",
 CellTags->"LQR"],

Cell[TextData[{
 "LyapunovEquation",
 ", ",
 ButtonBox["The Lyapunov Equation",
  BaseStyle->"AddOnsLink",
  ButtonData:>{"The Lyapunov Equation", "i:24"}]
}], "Index",
 CellTags->"LyapunovEquation"],

Cell[TextData[{
 "MakeODEs",
 ", ",
 ButtonBox["Backlash",
  BaseStyle->"AddOnsLink",
  ButtonData:>{"Backlash", "i:3"}],
 ", ",
 ButtonBox["Simulation: Numerical Solution",
  BaseStyle->"AddOnsLink",
  ButtonData:>{"Simulation: Numerical Solution", "i:2"}]
}], "Index",
 CellTags->"MakeODEs"],

Cell[TextData[{
 "MatlabForm",
 ", ",
 ButtonBox["Matlab Output",
  BaseStyle->"AddOnsLink",
  ButtonData:>{"Matlab Output", "i:17"}]
}], "Index",
 CellTags->"MatlabForm"],

Cell[TextData[{
 "MatlabFormPolynomials",
 ", ",
 ButtonBox["Matlab Output",
  BaseStyle->"AddOnsLink",
  ButtonData:>{"Matlab Output", "i:17"}]
}], "Index",
 CellTags->"MatlabFormPolynomials"],

Cell[TextData[{
 "MinimalRealization",
 ", ",
 ButtonBox["Kalman Canonical Form",
  BaseStyle->"AddOnsLink",
  ButtonData:>{"Kalman Canonical Form", "i:6"}],
 ", ",
 ButtonBox["Minimal Realization",
  BaseStyle->"AddOnsLink",
  ButtonData:>{"Minimal Realization", "i:4"}]
}], "Index",
 CellTags->"MinimalRealization"],

Cell[TextData[{
 "ModeratingFunctions",
 ", ",
 ButtonBox["Moderating",
  BaseStyle->"AddOnsLink",
  ButtonData:>{"Moderating", "i:4"}]
}], "Index",
 CellTags->"ModeratingFunctions"],

Cell[TextData[{
 "NodeVelocity",
 ", ",
 ButtonBox["The Rolling Disk",
  BaseStyle->"AddOnsLink",
  ButtonData:>{"The Rolling Disk", "i:9"}]
}], "Index",
 CellTags->"NodeVelocity"],

Cell[TextData[{
 "NormalCoordinates",
 ", ",
 ButtonBox["Input-Output Linearization, Relative Degree & Decoupling",
  BaseStyle->"AddOnsLink",
  ButtonData:>{
   "Input-Output Linearization, Relative Degree & Decoupling", "i:19"}],
 ", ",
 ButtonBox["The Sliding Surface",
  BaseStyle->"AddOnsLink",
  ButtonData:>{"The Sliding Surface", "i:1"}]
}], "Index",
 CellTags->"NormalCoordinates"],

Cell[TextData[{
 "Nyquist",
 ", ",
 ButtonBox["Nyquist Plot",
  BaseStyle->"AddOnsLink",
  ButtonData:>{"Nyquist Plot", "i:10"}]
}], "Index",
 CellTags->"Nyquist"],

Cell[TextData[{
 "Observability",
 ", ",
 ButtonBox["Controllability & Observability",
  BaseStyle->"AddOnsLink",
  ButtonData:>{"Controllability & Observability", "i:1"}]
}], "Index",
 CellTags->"Observability"],

Cell[TextData[{
 "ObservabilityCodistribution",
 ", ",
 ButtonBox["Controllability & Observability",
  BaseStyle->"AddOnsLink",
  ButtonData:>{"Controllability & Observability", "i:1"}]
}], "Index",
 CellTags->"ObservabilityCodistribution"],

Cell[TextData[{
 "ObservabilityIndices",
 ", ",
 ButtonBox["Autonomous Systems",
  BaseStyle->"AddOnsLink",
  ButtonData:>{"Autonomous Systems", "i:2"}],
 ", ",
 ButtonBox["Introduction",
  BaseStyle->"AddOnsLink",
  ButtonData:>{"Introduction", "i:1"}]
}], "Index",
 CellTags->"ObservabilityIndices"],

Cell[TextData[{
 "ObservableForm",
 ", ",
 ButtonBox["Autonomous Systems",
  BaseStyle->"AddOnsLink",
  ButtonData:>{"Autonomous Systems", "i:2"}],
 ", ",
 ButtonBox["Introduction",
  BaseStyle->"AddOnsLink",
  ButtonData:>{"Introduction", "i:1"}]
}], "Index",
 CellTags->"ObservableForm"],

Cell[TextData[{
 "ObservablePair",
 ", ",
 ButtonBox["Controllability, Observability and Pole Placement",
  BaseStyle->"AddOnsLink",
  ButtonData:>{"Controllability, Observability and Pole Placement", "i:5"}],
 ", ",
 ButtonBox["State Space to Transfer Function and Back",
  BaseStyle->"AddOnsLink",
  ButtonData:>{"State Space to Transfer Function and Back", "i:3"}]
}], "Index",
 CellTags->"ObservablePair"],

Cell[TextData[{
 "ParametricManifold",
 ", ",
 ButtonBox["Implicit & Parametric Descriptions",
  BaseStyle->"AddOnsLink",
  ButtonData:>{"Implicit & Parametric Descriptions", "i:1"}]
}], "Index",
 CellTags->"ParametricManifold"],

Cell[TextData[{
 "PDESolve",
 ", ",
 ButtonBox["Autonomous Systems",
  BaseStyle->"AddOnsLink",
  ButtonData:>{"Autonomous Systems", "i:2"}],
 ", ",
 ButtonBox["Introduction",
  BaseStyle->"AddOnsLink",
  ButtonData:>{"Introduction", "i:1"}]
}], "Index",
 CellTags->"PDESolve"],

Cell[TextData[{
 "PolePlace",
 ", ",
 ButtonBox["Controllability, Observability and Pole Placement",
  BaseStyle->"AddOnsLink",
  ButtonData:>{"Controllability, Observability and Pole Placement", "i:5"}]
}], "Index",
 CellTags->"PolePlace"],

Cell[TextData[{
 "Poles",
 ", ",
 ButtonBox["Poles and Zeros",
  BaseStyle->"AddOnsLink",
  ButtonData:>{"Poles and Zeros", "i:2"}]
}], "Index",
 CellTags->"Poles"],

Cell[TextData[{
 "PoleZeroPlot",
 ", ",
 ButtonBox["Pole-Zero Plot",
  BaseStyle->"AddOnsLink",
  ButtonData:>{"Pole-Zero Plot", "i:12"}]
}], "Index",
 CellTags->"PoleZeroPlot"],

Cell[TextData[{
 "PSFFCond",
 ", ",
 ButtonBox["Adaptive Control",
  BaseStyle->"AddOnsLink",
  ButtonData:>{"Adaptive Control", "i:4"}]
}], "Index",
 CellTags->"PSFFCond"],

Cell[TextData[{
 "PSFFSolve",
 ", ",
 ButtonBox["Adaptive Control",
  BaseStyle->"AddOnsLink",
  ButtonData:>{"Adaptive Control", "i:4"}]
}], "Index",
 CellTags->"PSFFSolve"],

Cell[TextData[ButtonBox["",
 BaseStyle->"AddOnsLink",
 ButtonData:>"Note on Browser Index",
 ButtonNote->"i:3"]], "Index",
 CellTags->"PSSFSolve"],

Cell[TextData[{
 "Rank",
 ", ",
 ButtonBox["Rank",
  BaseStyle->"AddOnsLink",
  ButtonData:>{"Rank", "i:5"}]
}], "Index",
 CellTags->"Rank"],

Cell[TextData[{
 "RankCodistribution",
 ", ",
 ButtonBox["Codistribution Rank",
  BaseStyle->"AddOnsLink",
  ButtonData:>{"Codistribution Rank", "i:6"}]
}], "Index",
 CellTags->"RankCodistribution"],

Cell[TextData[{
 "RelativeOrder",
 ", ",
 ButtonBox["Input-Output Linearization, Relative Degree & Decoupling",
  BaseStyle->"AddOnsLink",
  ButtonData:>{
   "Input-Output Linearization, Relative Degree & Decoupling", "i:19"}]
}], "Index",
 CellTags->"RelativeOrder"],

Cell[TextData[{
 "RootLocus",
 ", ",
 ButtonBox["Root Locus",
  BaseStyle->"AddOnsLink",
  ButtonData:>{"Root Locus", "i:11"}]
}], "Index",
 CellTags->"RootLocus"],

Cell[TextData[{
 "SeriesExpansion",
 ", ",
 ButtonBox["Drive Train",
  BaseStyle->"AddOnsLink",
  ButtonData:>{"Drive Train", "i:10"}]
}], "Index",
 CellTags->"SeriesExpansion"],

Cell[TextData[{
 "Truncate",
 ", ",
 ButtonBox["Series Expansion",
  BaseStyle->"AddOnsLink",
  ButtonData:>{"Series Expansion", "i:16"}]
}], "IndexSubentry",
 CellTags->"SeriesExpansion"],

Cell[TextData[{
 "SIExactFBL",
 ", ",
 ButtonBox["Exact Feedback Linearization",
  BaseStyle->"AddOnsLink",
  ButtonData:>{"Exact Feedback Linearization", "i:2"}]
}], "Index",
 CellTags->"SIExactFBL"],

Cell[TextData[{
 "SimplifyArray",
 ", ",
 ButtonBox["Complex Arrays",
  BaseStyle->"AddOnsLink",
  ButtonData:>{"Complex Arrays", "i:10"}]
}], "Index",
 CellTags->"SimplifyArray"],

Cell[TextData[{
 "SISONormalFormTrans",
 ", ",
 ButtonBox["Input-Output Linearization, Relative Degree & Decoupling",
  BaseStyle->"AddOnsLink",
  ButtonData:>{
   "Input-Output Linearization, Relative Degree & Decoupling", "i:19"}]
}], "Index",
 CellTags->"SISONormalFormTrans"],

Cell[TextData[{
 "SlidingSurface",
 ", ",
 ButtonBox["The Sliding Surface",
  BaseStyle->"AddOnsLink",
  ButtonData:>{"The Sliding Surface", "i:1"}]
}], "Index",
 CellTags->"SlidingSurface"],

Cell[TextData[{
 "SmallestInvariantDistribution",
 ", ",
 ButtonBox["Invariant Distributions",
  BaseStyle->"AddOnsLink",
  ButtonData:>{"Invariant Distributions", "i:8"}]
}], "Index",
 CellTags->"SmallestInvariantDistribution"],

Cell[TextData[{
 "SmoothingFunctions",
 ", ",
 ButtonBox["Smoothing",
  BaseStyle->"AddOnsLink",
  ButtonData:>{"Smoothing", "i:3"}]
}], "Index",
 CellTags->"SmoothingFunctions"],

Cell[TextData[{
 "Span",
 ", ",
 ButtonBox["Span",
  BaseStyle->"AddOnsLink",
  ButtonData:>{"Span", "i:6"}]
}], "Index",
 CellTags->"Span"],

Cell[TextData[{
 "SpecialInverse",
 ", ",
 ButtonBox["Complex Arrays",
  BaseStyle->"AddOnsLink",
  ButtonData:>{"Complex Arrays", "i:9"}]
}], "Index",
 CellTags->"SpecialInverse"],

Cell[TextData[{
 "SpecialNullSpace",
 ", ",
 ButtonBox["Composition",
  BaseStyle->"AddOnsLink",
  ButtonData:>{"Composition", "i:4"}],
 ", ",
 ButtonBox["SpecialNullSpace",
  BaseStyle->"AddOnsLink",
  ButtonData:>{"SpecialNullSpace", "i:12"}]
}], "Index",
 CellTags->"SpecialNullSpace"],

Cell[TextData[{
 "SpringPotential",
 ", ",
 ButtonBox["Suspension System",
  BaseStyle->"AddOnsLink",
  ButtonData:>{"Suspension System", "i:4"}]
}], "Index",
 CellTags->"SpringPotential"],

Cell[TextData[{
 "StateSpaceToTransferFunction",
 ", ",
 ButtonBox["State Space to Transfer Function and Back",
  BaseStyle->"AddOnsLink",
  ButtonData:>{"State Space to Transfer Function and Back", "i:3"}]
}], "Index",
 CellTags->"StateSpaceToTransferFunction"],

Cell[TextData[{
 "StructureAlgorithm",
 ", ",
 ButtonBox["Dynamic Inverse",
  BaseStyle->"AddOnsLink",
  ButtonData:>{"Dynamic Inverse", "i:21"}]
}], "Index",
 CellTags->"StructureAlgorithm"],

Cell[TextData[{
 "SwitchingControl",
 ", ",
 ButtonBox["Reaching",
  BaseStyle->"AddOnsLink",
  ButtonData:>{"Reaching", "i:2"}],
 ", ",
 ButtonBox["The Sliding Surface",
  BaseStyle->"AddOnsLink",
  ButtonData:>{"The Sliding Surface", "i:1"}]
}], "Index",
 CellTags->"SwitchingControl"],

Cell[TextData[{
 "TaylorLinearize",
 ", ",
 ButtonBox["Linearization",
  BaseStyle->"AddOnsLink",
  ButtonData:>{"Linearization", "i:1"}]
}], "Index",
 CellTags->"TaylorLinearize"],

Cell[TextData[{
 "TransformSystem",
 ", ",
 ButtonBox["Autonomous Systems",
  BaseStyle->"AddOnsLink",
  ButtonData:>{"Autonomous Systems", "i:2"}],
 ", ",
 ButtonBox["Exact Feedback Linearization",
  BaseStyle->"AddOnsLink",
  ButtonData:>{"Exact Feedback Linearization", "i:2"}]
}], "Index",
 CellTags->"TransformSystem"],

Cell[TextData[{
 "TriangularDecomposition",
 ", ",
 ButtonBox["Triangular Decomposition",
  BaseStyle->"AddOnsLink",
  ButtonData:>{"Triangular Decomposition", "i:13"}]
}], "Index",
 CellTags->"TriangularDecomposition"],

Cell[TextData[{
 "UnitStep2Sign",
 ", ",
 ButtonBox["Friction",
  BaseStyle->"AddOnsLink",
  ButtonData:>{"Friction", "i:5"}]
}], "Index",
 CellTags->"UnitStep2Sign"],

Cell[TextData[{
 "VectorRelativeOrder",
 ", ",
 ButtonBox["Input-Output Linearization, Relative Degree & Decoupling",
  BaseStyle->"AddOnsLink",
  ButtonData:>{
   "Input-Output Linearization, Relative Degree & Decoupling", "i:19"}]
}], "Index",
 CellTags->"VectorRelativeOrder"],

Cell[TextData[{
 "Wedge",
 ", ",
 ButtonBox["Wedge Product",
  BaseStyle->"AddOnsLink",
  ButtonData:>{"Wedge Product", "i:3"}]
}], "Index",
 CellTags->"Wedge"],

Cell[TextData[{
 "WriteArray",
 ", ",
 ButtonBox["Complex Arrays",
  BaseStyle->"AddOnsLink",
  ButtonData:>{"Complex Arrays", "i:11"}]
}], "Index",
 CellTags->"WriteArray"],

Cell[TextData[{
 "Zeros",
 ", ",
 ButtonBox["Poles and Zeros",
  BaseStyle->"AddOnsLink",
  ButtonData:>{"Poles and Zeros", "i:2"}]
}], "Index",
 CellTags->"Zeros"]
},
WindowSize->{616, 505},
WindowMargins->{{200, Automatic}, {Automatic, 11}},
FrontEndVersion->"7.0 for Microsoft Windows (32-bit) (November 10, 2008)",
StyleDefinitions->"HelpBrowser.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "MasterIndexHeading"->{
  Cell[545, 20, 63, 1, 40, "IndexSection",
   CellTags->"MasterIndexHeading"]},
 "Ad"->{
  Cell[611, 23, 158, 7, 15, "Index",
   CellTags->"Ad"]},
 "AdaptiveBackstepRegulator"->{
  Cell[772, 32, 206, 7, 15, "Index",
   CellTags->"AdaptiveBackstepRegulator"]},
 "AdaptiveRegulator"->{
  Cell[981, 41, 191, 7, 15, "Index",
   CellTags->"AdaptiveRegulator"]},
 "AdaptiveTracking"->{
  Cell[1175, 50, 189, 7, 15, "Index",
   CellTags->"AdaptiveTracking"]},
 "AlgebraicConstraints"->{
  Cell[1367, 59, 190, 7, 15, "Index",
   CellTags->"AlgebraicConstraints"]},
 "AlgebraicRiccatiEquation"->{
  Cell[1560, 68, 233, 7, 15, "Index",
   CellTags->"AlgebraicRiccatiEquation"]},
 "BacklashPotential"->{
  Cell[1796, 77, 368, 15, 15, "Index",
   CellTags->"BacklashPotential"]},
 "Bode"->{
  Cell[2167, 94, 150, 7, 15, "Index",
   CellTags->"Bode"]},
 "ColorNyquist"->{
  Cell[2320, 103, 173, 7, 15, "Index",
   CellTags->"ColorNyquist"]},
 "Contraction"->{
  Cell[2496, 112, 168, 7, 15, "Index",
   CellTags->"Contraction"]},
 "ControlDistribution"->{
  Cell[2667, 121, 225, 7, 15, "Index",
   CellTags->"ControlDistribution"]},
 "Controllability"->{
  Cell[2895, 130, 217, 7, 15, "Index",
   CellTags->"Controllability"]},
 "ControllablePair"->{
  Cell[3115, 139, 254, 7, 15, "Index",
   CellTags->"ControllablePair"]},
 "ControllableRealization"->{
  Cell[3372, 148, 252, 7, 15, "Index",
   CellTags->"ControllableRealization"]},
 "CreateControllerMEX"->{
  Cell[3627, 157, 221, 7, 15, "Index",
   CellTags->"CreateControllerMEX"]},
 "CreateModel"->{
  Cell[3851, 166, 610, 23, 31, "Index",
   CellTags->"CreateModel"]},
 "CreateModelMEX"->{
  Cell[4464, 191, 295, 11, 15, "Index",
   CellTags->"CreateModelMEX"]},
 "d[ ]"->{
  Cell[4762, 204, 170, 7, 15, "Index",
   CellTags->"d[ ]"]},
 "DecouplingMatrix"->{
  Cell[4935, 213, 273, 8, 15, "Index",
   CellTags->"DecouplingMatrix"]},
 "DifferentialConstraints"->{
  Cell[5211, 223, 202, 7, 15, "Index",
   CellTags->"DifferentialConstraints"]},
 "DynamicExtension"->{
  Cell[5416, 232, 191, 7, 15, "Index",
   CellTags->"DynamicExtension"]},
 "EndEffector"->{
  Cell[5610, 241, 289, 11, 15, "Index",
   CellTags->"EndEffector"]},
 "EquilibriumSurface"->{
  Cell[5902, 254, 198, 7, 15, "Index",
   CellTags->"EquilibriumSurface"]},
 "ExpMap"->{
  Cell[6103, 263, 265, 11, 15, "Index",
   CellTags->"ExpMap"]},
 "ExponentialObserver"->{
  Cell[6371, 276, 200, 7, 15, "Index",
   CellTags->"ExponentialObserver"]},
 "FeedbackLinearizable"->{
  Cell[6574, 285, 220, 7, 15, "Index",
   CellTags->"FeedbackLinearizable"]},
 "FlowComposition"->{
  Cell[6797, 294, 176, 7, 15, "Index",
   CellTags->"FlowComposition"]},
 "FormBasis"->{
  Cell[6976, 303, 162, 7, 15, "Index",
   CellTags->"FormBasis"]},
 "FormDegree"->{
  Cell[7141, 312, 154, 7, 15, "Index",
   CellTags->"FormDegree"]},
 "FormQ"->{
  Cell[7298, 321, 144, 7, 15, "Index",
   CellTags->"FormQ"]},
 "GeneralizedForce"->{
  Cell[7445, 330, 186, 7, 15, "Index",
   CellTags->"GeneralizedForce"]},
 "Grad"->{
  Cell[7634, 339, 140, 7, 15, "Index",
   CellTags->"Grad"]},
 "InverseTransformation"->{
  Cell[7777, 348, 529, 16, 31, "Index",
   CellTags->"InverseTransformation"]},
 "Involutive"->{
  Cell[8309, 366, 200, 7, 15, "Index",
   CellTags->"Involutive"]},
 "IOLinearization"->{
  Cell[8512, 375, 185, 7, 15, "Index",
   CellTags->"IOLinearization"]},
 "IOLinearize"->{
  Cell[8700, 384, 378, 12, 31, "Index",
   CellTags->"IOLinearize"]},
 "IrreducibleRealization"->{
  Cell[9081, 398, 210, 7, 15, "Index",
   CellTags->"IrreducibleRealization"]},
 "Jacob"->{
  Cell[9294, 407, 144, 7, 15, "Index",
   CellTags->"Jacob"]},
 "JointFrictionPotential"->{
  Cell[9441, 416, 285, 11, 15, "Index",
   CellTags->"JointFrictionPotential"]},
 "Joints"->{
  Cell[9729, 429, 370, 15, 15, "Index",
   CellTags->"Joints"]},
 "KalmanDecomposition"->{
  Cell[10102, 446, 204, 7, 15, "Index",
   CellTags->"KalmanDecomposition"]},
 "KinematicReplacements"->{
  Cell[10309, 455, 196, 7, 15, "Index",
   CellTags->"KinematicReplacements"]},
 "LargestInvariantDistribution"->{
  Cell[10508, 464, 226, 7, 15, "Index",
   CellTags->"LargestInvariantDistribution"]},
 "LeafPotential"->{
  Cell[10737, 473, 184, 7, 15, "Index",
   CellTags->"LeafPotential"]},
 "LieBracket"->{
  Cell[10924, 482, 174, 7, 15, "Index",
   CellTags->"LieBracket"]},
 "LieDerivative"->{
  Cell[11101, 491, 281, 11, 15, "Index",
   CellTags->"LieDerivative"]},
 "LinearizeToOutputInjection"->{
  Cell[11385, 504, 313, 11, 15, "Index",
   CellTags->"LinearizeToOutputInjection"]},
 "LocalDecomposition"->{
  Cell[11701, 517, 223, 7, 15, "Index",
   CellTags->"LocalDecomposition"]},
 "LocalZeroDynamics"->{
  Cell[11927, 526, 275, 8, 15, "Index",
   CellTags->"LocalZeroDynamics"]},
 "LQE"->{
  Cell[12205, 536, 199, 7, 15, "Index",
   CellTags->"LQE"]},
 "LQR"->{
  Cell[12407, 545, 175, 7, 15, "Index",
   CellTags->"LQR"]},
 "LyapunovEquation"->{
  Cell[12585, 554, 199, 7, 15, "Index",
   CellTags->"LyapunovEquation"]},
 "MakeODEs"->{
  Cell[12787, 563, 293, 11, 15, "Index",
   CellTags->"MakeODEs"]},
 "MatlabForm"->{
  Cell[13083, 576, 171, 7, 15, "Index",
   CellTags->"MatlabForm"]},
 "MatlabFormPolynomials"->{
  Cell[13257, 585, 193, 7, 15, "Index",
   CellTags->"MatlabFormPolynomials"]},
 "MinimalRealization"->{
  Cell[13453, 594, 317, 11, 15, "Index",
   CellTags->"MinimalRealization"]},
 "ModeratingFunctions"->{
  Cell[13773, 607, 182, 7, 15, "Index",
   CellTags->"ModeratingFunctions"]},
 "NodeVelocity"->{
  Cell[13958, 616, 180, 7, 15, "Index",
   CellTags->"NodeVelocity"]},
 "NormalCoordinates"->{
  Cell[14141, 625, 390, 12, 31, "Index",
   CellTags->"NormalCoordinates"]},
 "Nyquist"->{
  Cell[14534, 639, 163, 7, 15, "Index",
   CellTags->"Nyquist"]},
 "Observability"->{
  Cell[14700, 648, 212, 7, 15, "Index",
   CellTags->"Observability"]},
 "ObservabilityCodistribution"->{
  Cell[14915, 657, 240, 7, 15, "Index",
   CellTags->"ObservabilityCodistribution"]},
 "ObservabilityIndices"->{
  Cell[15158, 666, 301, 11, 15, "Index",
   CellTags->"ObservabilityIndices"]},
 "ObservableForm"->{
  Cell[15462, 679, 289, 11, 15, "Index",
   CellTags->"ObservableForm"]},
 "ObservablePair"->{
  Cell[15754, 692, 409, 11, 31, "Index",
   CellTags->"ObservablePair"]},
 "ParametricManifold"->{
  Cell[16166, 705, 228, 7, 15, "Index",
   CellTags->"ParametricManifold"]},
 "PDESolve"->{
  Cell[16397, 714, 277, 11, 15, "Index",
   CellTags->"PDESolve"]},
 "PolePlace"->{
  Cell[16677, 727, 240, 7, 15, "Index",
   CellTags->"PolePlace"]},
 "Poles"->{
  Cell[16920, 736, 164, 7, 15, "Index",
   CellTags->"Poles"]},
 "PoleZeroPlot"->{
  Cell[17087, 745, 177, 7, 15, "Index",
   CellTags->"PoleZeroPlot"]},
 "PSFFCond"->{
  Cell[17267, 754, 172, 7, 15, "Index",
   CellTags->"PSFFCond"]},
 "PSFFSolve"->{
  Cell[17442, 763, 174, 7, 15, "Index",
   CellTags->"PSFFSolve"]},
 "PSSFSolve"->{
  Cell[17619, 772, 146, 4, 15, "Index",
   CellTags->"PSSFSolve"]},
 "Rank"->{
  Cell[17768, 778, 140, 7, 15, "Index",
   CellTags->"Rank"]},
 "RankCodistribution"->{
  Cell[17911, 787, 198, 7, 15, "Index",
   CellTags->"RankCodistribution"]},
 "RelativeOrder"->{
  Cell[18112, 796, 267, 8, 15, "Index",
   CellTags->"RelativeOrder"]},
 "RootLocus"->{
  Cell[18382, 806, 163, 7, 15, "Index",
   CellTags->"RootLocus"]},
 "SeriesExpansion"->{
  Cell[18548, 815, 177, 7, 15, "Index",
   CellTags->"SeriesExpansion"],
  Cell[18728, 824, 188, 7, 15, "IndexSubentry",
   CellTags->"SeriesExpansion"]},
 "SIExactFBL"->{
  Cell[18919, 833, 200, 7, 15, "Index",
   CellTags->"SIExactFBL"]},
 "SimplifyArray"->{
  Cell[19122, 842, 179, 7, 15, "Index",
   CellTags->"SimplifyArray"]},
 "SISONormalFormTrans"->{
  Cell[19304, 851, 279, 8, 15, "Index",
   CellTags->"SISONormalFormTrans"]},
 "SlidingSurface"->{
  Cell[19586, 861, 190, 7, 15, "Index",
   CellTags->"SlidingSurface"]},
 "SmallestInvariantDistribution"->{
  Cell[19779, 870, 228, 7, 15, "Index",
   CellTags->"SmallestInvariantDistribution"]},
 "SmoothingFunctions"->{
  Cell[20010, 879, 178, 7, 15, "Index",
   CellTags->"SmoothingFunctions"]},
 "Span"->{
  Cell[20191, 888, 140, 7, 15, "Index",
   CellTags->"Span"]},
 "SpecialInverse"->{
  Cell[20334, 897, 180, 7, 15, "Index",
   CellTags->"SpecialInverse"]},
 "SpecialNullSpace"->{
  Cell[20517, 906, 288, 11, 15, "Index",
   CellTags->"SpecialNullSpace"]},
 "SpringPotential"->{
  Cell[20808, 919, 188, 7, 15, "Index",
   CellTags->"SpringPotential"]},
 "StateSpaceToTransferFunction"->{
  Cell[20999, 928, 262, 7, 15, "Index",
   CellTags->"StateSpaceToTransferFunction"]},
 "StructureAlgorithm"->{
  Cell[21264, 937, 191, 7, 15, "Index",
   CellTags->"StructureAlgorithm"]},
 "SwitchingControl"->{
  Cell[21458, 946, 287, 11, 15, "Index",
   CellTags->"SwitchingControl"]},
 "TaylorLinearize"->{
  Cell[21748, 959, 180, 7, 15, "Index",
   CellTags->"TaylorLinearize"]},
 "TransformSystem"->{
  Cell[21931, 968, 323, 11, 15, "Index",
   CellTags->"TransformSystem"]},
 "TriangularDecomposition"->{
  Cell[22257, 981, 219, 7, 15, "Index",
   CellTags->"TriangularDecomposition"]},
 "UnitStep2Sign"->{
  Cell[22479, 990, 166, 7, 15, "Index",
   CellTags->"UnitStep2Sign"]},
 "VectorRelativeOrder"->{
  Cell[22648, 999, 279, 8, 15, "Index",
   CellTags->"VectorRelativeOrder"]},
 "Wedge"->{
  Cell[22930, 1009, 160, 7, 15, "Index",
   CellTags->"Wedge"]},
 "WriteArray"->{
  Cell[23093, 1018, 173, 7, 15, "Index",
   CellTags->"WriteArray"]},
 "Zeros"->{
  Cell[23269, 1027, 164, 7, 15, "Index",
   CellTags->"Zeros"]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"MasterIndexHeading", 23747, 1046},
 {"Ad", 23836, 1049},
 {"AdaptiveBackstepRegulator", 23926, 1052},
 {"AdaptiveRegulator", 24031, 1055},
 {"AdaptiveTracking", 24127, 1058},
 {"AlgebraicConstraints", 24227, 1061},
 {"AlgebraicRiccatiEquation", 24335, 1064},
 {"BacklashPotential", 24440, 1067},
 {"Bode", 24526, 1070},
 {"ColorNyquist", 24606, 1073},
 {"Contraction", 24694, 1076},
 {"ControlDistribution", 24789, 1079},
 {"Controllability", 24888, 1082},
 {"ControllablePair", 24984, 1085},
 {"ControllableRealization", 25088, 1088},
 {"CreateControllerMEX", 25195, 1091},
 {"CreateModel", 25290, 1094},
 {"CreateModelMEX", 25381, 1097},
 {"d[ ]", 25465, 1100},
 {"DecouplingMatrix", 25550, 1103},
 {"DifferentialConstraints", 25654, 1106},
 {"DynamicExtension", 25758, 1109},
 {"EndEffector", 25850, 1112},
 {"EquilibriumSurface", 25945, 1115},
 {"ExpMap", 26034, 1118},
 {"ExponentialObserver", 26125, 1121},
 {"FeedbackLinearizable", 26229, 1124},
 {"FlowComposition", 26329, 1127},
 {"FormBasis", 26418, 1130},
 {"FormDegree", 26502, 1133},
 {"FormQ", 26582, 1136},
 {"GeneralizedForce", 26668, 1139},
 {"Grad", 26753, 1142},
 {"InverseTransformation", 26843, 1145},
 {"Involutive", 26940, 1148},
 {"IOLinearization", 27030, 1151},
 {"IOLinearize", 27121, 1154},
 {"IrreducibleRealization", 27220, 1157},
 {"Jacob", 27312, 1160},
 {"JointFrictionPotential", 27404, 1163},
 {"Joints", 27498, 1166},
 {"KalmanDecomposition", 27589, 1169},
 {"KinematicReplacements", 27695, 1172},
 {"LargestInvariantDistribution", 27810, 1175},
 {"LeafPotential", 27917, 1178},
 {"LieBracket", 28006, 1181},
 {"LieDerivative", 28095, 1184},
 {"LinearizeToOutputInjection", 28201, 1187},
 {"LocalDecomposition", 28312, 1190},
 {"LocalZeroDynamics", 28413, 1193},
 {"LQE", 28499, 1196},
 {"LQR", 28571, 1199},
 {"LyapunovEquation", 28656, 1202},
 {"MakeODEs", 28746, 1205},
 {"MatlabForm", 28831, 1208},
 {"MatlabFormPolynomials", 28928, 1211},
 {"MinimalRealization", 29033, 1214},
 {"ModeratingFunctions", 29137, 1217},
 {"NodeVelocity", 29234, 1220},
 {"NormalCoordinates", 29329, 1223},
 {"Nyquist", 29420, 1226},
 {"Observability", 29506, 1229},
 {"ObservabilityCodistribution", 29612, 1232},
 {"ObservabilityIndices", 29725, 1235},
 {"ObservableForm", 29826, 1238},
 {"ObservablePair", 29921, 1241},
 {"ParametricManifold", 30020, 1244},
 {"PDESolve", 30112, 1247},
 {"PolePlace", 30196, 1250},
 {"Poles", 30276, 1253},
 {"PoleZeroPlot", 30359, 1256},
 {"PSFFCond", 30445, 1259},
 {"PSFFSolve", 30528, 1262},
 {"PSSFSolve", 30612, 1265},
 {"Rank", 30691, 1268},
 {"RankCodistribution", 30779, 1271},
 {"RelativeOrder", 30876, 1274},
 {"RootLocus", 30964, 1277},
 {"SeriesExpansion", 31054, 1280},
 {"SIExactFBL", 31226, 1285},
 {"SimplifyArray", 31315, 1288},
 {"SISONormalFormTrans", 31413, 1291},
 {"SlidingSurface", 31512, 1294},
 {"SmallestInvariantDistribution", 31621, 1297},
 {"SmoothingFunctions", 31734, 1300},
 {"Span", 31822, 1303},
 {"SpecialInverse", 31906, 1306},
 {"SpecialNullSpace", 32002, 1309},
 {"SpringPotential", 32100, 1312},
 {"StateSpaceToTransferFunction", 32209, 1315},
 {"StructureAlgorithm", 32321, 1318},
 {"SwitchingControl", 32421, 1321},
 {"TaylorLinearize", 32519, 1324},
 {"TransformSystem", 32615, 1327},
 {"TriangularDecomposition", 32720, 1330},
 {"UnitStep2Sign", 32822, 1333},
 {"VectorRelativeOrder", 32920, 1336},
 {"Wedge", 33010, 1339},
 {"WriteArray", 33092, 1342},
 {"Zeros", 33174, 1345}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[545, 20, 63, 1, 40, "IndexSection",
 CellTags->"MasterIndexHeading"],
Cell[611, 23, 158, 7, 15, "Index",
 CellTags->"Ad"],
Cell[772, 32, 206, 7, 15, "Index",
 CellTags->"AdaptiveBackstepRegulator"],
Cell[981, 41, 191, 7, 15, "Index",
 CellTags->"AdaptiveRegulator"],
Cell[1175, 50, 189, 7, 15, "Index",
 CellTags->"AdaptiveTracking"],
Cell[1367, 59, 190, 7, 15, "Index",
 CellTags->"AlgebraicConstraints"],
Cell[1560, 68, 233, 7, 15, "Index",
 CellTags->"AlgebraicRiccatiEquation"],
Cell[1796, 77, 368, 15, 15, "Index",
 CellTags->"BacklashPotential"],
Cell[2167, 94, 150, 7, 15, "Index",
 CellTags->"Bode"],
Cell[2320, 103, 173, 7, 15, "Index",
 CellTags->"ColorNyquist"],
Cell[2496, 112, 168, 7, 15, "Index",
 CellTags->"Contraction"],
Cell[2667, 121, 225, 7, 15, "Index",
 CellTags->"ControlDistribution"],
Cell[2895, 130, 217, 7, 15, "Index",
 CellTags->"Controllability"],
Cell[3115, 139, 254, 7, 15, "Index",
 CellTags->"ControllablePair"],
Cell[3372, 148, 252, 7, 15, "Index",
 CellTags->"ControllableRealization"],
Cell[3627, 157, 221, 7, 15, "Index",
 CellTags->"CreateControllerMEX"],
Cell[3851, 166, 610, 23, 31, "Index",
 CellTags->"CreateModel"],
Cell[4464, 191, 295, 11, 15, "Index",
 CellTags->"CreateModelMEX"],
Cell[4762, 204, 170, 7, 15, "Index",
 CellTags->"d[ ]"],
Cell[4935, 213, 273, 8, 15, "Index",
 CellTags->"DecouplingMatrix"],
Cell[5211, 223, 202, 7, 15, "Index",
 CellTags->"DifferentialConstraints"],
Cell[5416, 232, 191, 7, 15, "Index",
 CellTags->"DynamicExtension"],
Cell[5610, 241, 289, 11, 15, "Index",
 CellTags->"EndEffector"],
Cell[5902, 254, 198, 7, 15, "Index",
 CellTags->"EquilibriumSurface"],
Cell[6103, 263, 265, 11, 15, "Index",
 CellTags->"ExpMap"],
Cell[6371, 276, 200, 7, 15, "Index",
 CellTags->"ExponentialObserver"],
Cell[6574, 285, 220, 7, 15, "Index",
 CellTags->"FeedbackLinearizable"],
Cell[6797, 294, 176, 7, 15, "Index",
 CellTags->"FlowComposition"],
Cell[6976, 303, 162, 7, 15, "Index",
 CellTags->"FormBasis"],
Cell[7141, 312, 154, 7, 15, "Index",
 CellTags->"FormDegree"],
Cell[7298, 321, 144, 7, 15, "Index",
 CellTags->"FormQ"],
Cell[7445, 330, 186, 7, 15, "Index",
 CellTags->"GeneralizedForce"],
Cell[7634, 339, 140, 7, 15, "Index",
 CellTags->"Grad"],
Cell[7777, 348, 529, 16, 31, "Index",
 CellTags->"InverseTransformation"],
Cell[8309, 366, 200, 7, 15, "Index",
 CellTags->"Involutive"],
Cell[8512, 375, 185, 7, 15, "Index",
 CellTags->"IOLinearization"],
Cell[8700, 384, 378, 12, 31, "Index",
 CellTags->"IOLinearize"],
Cell[9081, 398, 210, 7, 15, "Index",
 CellTags->"IrreducibleRealization"],
Cell[9294, 407, 144, 7, 15, "Index",
 CellTags->"Jacob"],
Cell[9441, 416, 285, 11, 15, "Index",
 CellTags->"JointFrictionPotential"],
Cell[9729, 429, 370, 15, 15, "Index",
 CellTags->"Joints"],
Cell[10102, 446, 204, 7, 15, "Index",
 CellTags->"KalmanDecomposition"],
Cell[10309, 455, 196, 7, 15, "Index",
 CellTags->"KinematicReplacements"],
Cell[10508, 464, 226, 7, 15, "Index",
 CellTags->"LargestInvariantDistribution"],
Cell[10737, 473, 184, 7, 15, "Index",
 CellTags->"LeafPotential"],
Cell[10924, 482, 174, 7, 15, "Index",
 CellTags->"LieBracket"],
Cell[11101, 491, 281, 11, 15, "Index",
 CellTags->"LieDerivative"],
Cell[11385, 504, 313, 11, 15, "Index",
 CellTags->"LinearizeToOutputInjection"],
Cell[11701, 517, 223, 7, 15, "Index",
 CellTags->"LocalDecomposition"],
Cell[11927, 526, 275, 8, 15, "Index",
 CellTags->"LocalZeroDynamics"],
Cell[12205, 536, 199, 7, 15, "Index",
 CellTags->"LQE"],
Cell[12407, 545, 175, 7, 15, "Index",
 CellTags->"LQR"],
Cell[12585, 554, 199, 7, 15, "Index",
 CellTags->"LyapunovEquation"],
Cell[12787, 563, 293, 11, 15, "Index",
 CellTags->"MakeODEs"],
Cell[13083, 576, 171, 7, 15, "Index",
 CellTags->"MatlabForm"],
Cell[13257, 585, 193, 7, 15, "Index",
 CellTags->"MatlabFormPolynomials"],
Cell[13453, 594, 317, 11, 15, "Index",
 CellTags->"MinimalRealization"],
Cell[13773, 607, 182, 7, 15, "Index",
 CellTags->"ModeratingFunctions"],
Cell[13958, 616, 180, 7, 15, "Index",
 CellTags->"NodeVelocity"],
Cell[14141, 625, 390, 12, 31, "Index",
 CellTags->"NormalCoordinates"],
Cell[14534, 639, 163, 7, 15, "Index",
 CellTags->"Nyquist"],
Cell[14700, 648, 212, 7, 15, "Index",
 CellTags->"Observability"],
Cell[14915, 657, 240, 7, 15, "Index",
 CellTags->"ObservabilityCodistribution"],
Cell[15158, 666, 301, 11, 15, "Index",
 CellTags->"ObservabilityIndices"],
Cell[15462, 679, 289, 11, 15, "Index",
 CellTags->"ObservableForm"],
Cell[15754, 692, 409, 11, 31, "Index",
 CellTags->"ObservablePair"],
Cell[16166, 705, 228, 7, 15, "Index",
 CellTags->"ParametricManifold"],
Cell[16397, 714, 277, 11, 15, "Index",
 CellTags->"PDESolve"],
Cell[16677, 727, 240, 7, 15, "Index",
 CellTags->"PolePlace"],
Cell[16920, 736, 164, 7, 15, "Index",
 CellTags->"Poles"],
Cell[17087, 745, 177, 7, 15, "Index",
 CellTags->"PoleZeroPlot"],
Cell[17267, 754, 172, 7, 15, "Index",
 CellTags->"PSFFCond"],
Cell[17442, 763, 174, 7, 15, "Index",
 CellTags->"PSFFSolve"],
Cell[17619, 772, 146, 4, 15, "Index",
 CellTags->"PSSFSolve"],
Cell[17768, 778, 140, 7, 15, "Index",
 CellTags->"Rank"],
Cell[17911, 787, 198, 7, 15, "Index",
 CellTags->"RankCodistribution"],
Cell[18112, 796, 267, 8, 15, "Index",
 CellTags->"RelativeOrder"],
Cell[18382, 806, 163, 7, 15, "Index",
 CellTags->"RootLocus"],
Cell[18548, 815, 177, 7, 15, "Index",
 CellTags->"SeriesExpansion"],
Cell[18728, 824, 188, 7, 15, "IndexSubentry",
 CellTags->"SeriesExpansion"],
Cell[18919, 833, 200, 7, 15, "Index",
 CellTags->"SIExactFBL"],
Cell[19122, 842, 179, 7, 15, "Index",
 CellTags->"SimplifyArray"],
Cell[19304, 851, 279, 8, 15, "Index",
 CellTags->"SISONormalFormTrans"],
Cell[19586, 861, 190, 7, 15, "Index",
 CellTags->"SlidingSurface"],
Cell[19779, 870, 228, 7, 15, "Index",
 CellTags->"SmallestInvariantDistribution"],
Cell[20010, 879, 178, 7, 15, "Index",
 CellTags->"SmoothingFunctions"],
Cell[20191, 888, 140, 7, 15, "Index",
 CellTags->"Span"],
Cell[20334, 897, 180, 7, 15, "Index",
 CellTags->"SpecialInverse"],
Cell[20517, 906, 288, 11, 15, "Index",
 CellTags->"SpecialNullSpace"],
Cell[20808, 919, 188, 7, 15, "Index",
 CellTags->"SpringPotential"],
Cell[20999, 928, 262, 7, 15, "Index",
 CellTags->"StateSpaceToTransferFunction"],
Cell[21264, 937, 191, 7, 15, "Index",
 CellTags->"StructureAlgorithm"],
Cell[21458, 946, 287, 11, 15, "Index",
 CellTags->"SwitchingControl"],
Cell[21748, 959, 180, 7, 15, "Index",
 CellTags->"TaylorLinearize"],
Cell[21931, 968, 323, 11, 15, "Index",
 CellTags->"TransformSystem"],
Cell[22257, 981, 219, 7, 15, "Index",
 CellTags->"TriangularDecomposition"],
Cell[22479, 990, 166, 7, 15, "Index",
 CellTags->"UnitStep2Sign"],
Cell[22648, 999, 279, 8, 15, "Index",
 CellTags->"VectorRelativeOrder"],
Cell[22930, 1009, 160, 7, 15, "Index",
 CellTags->"Wedge"],
Cell[23093, 1018, 173, 7, 15, "Index",
 CellTags->"WriteArray"],
Cell[23269, 1027, 164, 7, 15, "Index",
 CellTags->"Zeros"]
}
]
*)

(* End of internal cache information *)

