(************** Content-type: application/mathematica **************
                     CreatedBy='Mathematica 5.0'

                    Mathematica-Compatible Notebook

This notebook can be used with any Mathematica-compatible
application, such as Mathematica, MathReader or Publicon. The data
for the notebook starts with the line containing stars above.

To get the notebook into a Mathematica-compatible application, do
one of the following:

* Save the data starting with the line of stars above into a file
  with a name ending in .nb, then open the file inside the
  application;

* Copy the data starting with the line of stars above to the
  clipboard, then use the Paste menu command inside the application.

Data for notebooks contains only printable 7-bit ASCII and can be
sent directly in email or through ftp in text mode.  Newlines can be
CR, LF or CRLF (Unix, Macintosh or MS-DOS style).

NOTE: If you modify the data for this notebook not in a Mathematica-
compatible application, you must delete the line below containing
the word CacheID, otherwise Mathematica-compatible applications may
try to use invalid cache data.

For more information on notebooks and Mathematica-compatible 
applications, contact Wolfram Research:
  web: http://www.wolfram.com
  email: info@wolfram.com
  phone: +1-217-398-0700 (U.S.)

Notebook reader applications are available free of charge from 
Wolfram Research.
*******************************************************************)

(*CacheID: 232*)


(*NotebookFileLineBreakTest
NotebookFileLineBreakTest*)
(*NotebookOptionsPosition[    125137,       3396]*)
(*NotebookOutlinePosition[    222848,       5332]*)
(*  CellTagsIndexPosition[    221420,       5285]*)
(*WindowFrame->Normal*)



Notebook[{

Cell[CellGroupData[{
Cell["Getting Started", "Section",
  Evaluatable->False,
  AspectRatioFixed->True,
  CellTags->{"Getting Started Nonlinear", "b:29"}],

Cell[BoxData[{
    \(\(Off[General::spell];\)\), "\n", 
    \(\(Off[General::spell1];\)\)}], "Input",
  CellLabel->"In[1]:=",
  CellTags->{"Getting Started Nonlinear", "b:29"}],

Cell[TextData[{
  "This notebook illustrates the tools provided in the nonlinear control \
package (ControlN) including a few new functions contained in Version 3.0. \
ControlN is contained in the directory ProPac. ProPac can be placed anywhwere \
you like, but a search path must be defined for it. It is most convenient to \
place ProPac in the AddOns\\Applications directiory, i.e, C:\\Program \
Files\\Wolfram Research\\",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  "\\5.0\\AddOns\\Applications. Once ProPac is loaded all of the functions in \
Dynamics as well as other packages included in TSi ProPac will be available \
for use and loaded as when needed."
}], "Text",
  Evaluatable->False,
  CellHorizontalScrolling->False,
  AspectRatioFixed->True,
  CellTags->{"Getting Started Nonlinear", "b:29"}],

Cell[TextData[{
  "In ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  " 3 and above ProPac can be loaded with the command"
}], "Text",
  Evaluatable->False,
  CellHorizontalScrolling->False,
  AspectRatioFixed->True,
  CellTags->{"Getting Started Nonlinear", "b:29"}],

Cell[CellGroupData[{

Cell["<<ProPac`", "Input",
  CellLabel->"In[3]:=",
  PageWidth->Infinity,
  AspectRatioFixed->True,
  CellTags->{"Getting Started Nonlinear", "b:29"}],

Cell[BoxData[
    \("\n    This is ProPac - Development Version 3.xx\n \n ProPac has been \
successfully loaded. It contains several packages\n for multibody dynamics, \
linear control and nonlinear control.\n The package names are:\n    GeoTools\n\
    Dynamics\n    ControlL\n    ControlN\n    DifferentialForms\n    \
ObserverTools\n    NDTools\n    VSCTools\n    MatlabInterface\n    MEXTools\n \
Appropriate packages will be loaded automatically as required.\n To obtain a \
list of functions in a package and links to function\n declarations, enter:\n \
   ?ProPac`PackageName`*\n Help is also available in the Help Browser under \
Add-ons."\)], "Print",
  CellLabel->"From In[3]:=",
  CellTags->{"Getting Started Nonlinear", "b:29"}]
}, Open  ]],

Cell[TextData[{
  "With ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  " 2.2 use the command ProPac`Master`."
}], "Text",
  CellTags->{"Getting Started Nonlinear", "b:29"}]
}, Open  ]],

Cell[CellGroupData[{

Cell["The Nonlinear Control Package", "Section",
  Evaluatable->False,
  AspectRatioFixed->True,
  CellTags->"b:30"],

Cell["\<\
We will demonstrate some of the functionality of TSiConN. First load the \
package and the examples file. The functions available in the nonlinear \
package are\
\>", "Text",
  Evaluatable->False,
  AspectRatioFixed->True,
  CellTags->{"Package", "b:30"}],

Cell[CellGroupData[{

Cell[BoxData[
    \(\(?ProPac`ControlN`*\)\)], "Input",
  CellLabel->"In[4]:=",
  CellTags->{"b:30", "Package"}],

Cell[BoxData[GridBox[{
        {
          StyleBox["ProPac`ControlN`",
            FontFamily->"Helvetica",
            FontSize->12,
            FontWeight->"Bold"]},
        {GridBox[{
              {
                ButtonBox[
                  StyleBox["AdaptiveBackstepRegulator",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3266691079-2207279", 
                    "ProPac`ControlN`AdaptiveBackstepRegulator"},
                  ButtonFrame->"None",
                  ButtonNote->"ProPac`ControlN`"], 
                ButtonBox[
                  StyleBox["FeedbackLinearizable",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3266691079-2207279", 
                    "ProPac`ControlN`FeedbackLinearizable"},
                  ButtonFrame->"None",
                  ButtonNote->"ProPac`ControlN`"], 
                ButtonBox[
                  StyleBox["ObservabilityCodistribution",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3266691079-2207279", 
                    "ProPac`ControlN`ObservabilityCodistribution"},
                  ButtonFrame->"None",
                  ButtonNote->"ProPac`ControlN`"]},
              {
                ButtonBox[
                  StyleBox["AdaptiveRegulator",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3266691079-2207279", 
                    "ProPac`ControlN`AdaptiveRegulator"},
                  ButtonFrame->"None",
                  ButtonNote->"ProPac`ControlN`"], 
                ButtonBox[
                  StyleBox["HToH1AndH2",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3266691079-2207279", 
                    "ProPac`ControlN`HToH1AndH2"},
                  ButtonFrame->"None",
                  ButtonNote->"ProPac`ControlN`"], 
                ButtonBox[
                  StyleBox["PartialTransformSystem",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3266691079-2207279", 
                    "ProPac`ControlN`PartialTransformSystem"},
                  ButtonFrame->"None",
                  ButtonNote->"ProPac`ControlN`"]},
              {
                ButtonBox[
                  StyleBox["AdaptiveTracking",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3266691079-2207279", 
                    "ProPac`ControlN`AdaptiveTracking"},
                  ButtonFrame->"None",
                  ButtonNote->"ProPac`ControlN`"], 
                ButtonBox[
                  StyleBox["HToNAndM",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3266691079-2207279", 
                    "ProPac`ControlN`HToNAndM"},
                  ButtonFrame->"None",
                  ButtonNote->"ProPac`ControlN`"], 
                ButtonBox[
                  StyleBox["PSFFCond",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3266691079-2207279", 
                    "ProPac`ControlN`PSFFCond"},
                  ButtonFrame->"None",
                  ButtonNote->"ProPac`ControlN`"]},
              {
                ButtonBox[
                  StyleBox["CoefParameter",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3266691079-2207279", 
                    "ProPac`ControlN`CoefParameter"},
                  ButtonFrame->"None",
                  ButtonNote->"ProPac`ControlN`"], 
                ButtonBox[
                  StyleBox["InverseTransformation",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3266691079-2207279", 
                    "ProPac`ControlN`InverseTransformation"},
                  ButtonFrame->"None",
                  ButtonNote->"ProPac`ControlN`"], 
                ButtonBox[
                  StyleBox["PSFFSolve",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3266691079-2207279", 
                    "ProPac`ControlN`PSFFSolve"},
                  ButtonFrame->"None",
                  ButtonNote->"ProPac`ControlN`"]},
              {
                ButtonBox[
                  StyleBox["ControlDistribution",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3266691079-2207279", 
                    "ProPac`ControlN`ControlDistribution"},
                  ButtonFrame->"None",
                  ButtonNote->"ProPac`ControlN`"], 
                ButtonBox[
                  StyleBox["IOLinearize",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3266691079-2207279", 
                    "ProPac`ControlN`IOLinearize"},
                  ButtonFrame->"None",
                  ButtonNote->"ProPac`ControlN`"], 
                ButtonBox[
                  StyleBox["RelativeOrder",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3266691079-2207279", 
                    "ProPac`ControlN`RelativeOrder"},
                  ButtonFrame->"None",
                  ButtonNote->"ProPac`ControlN`"]},
              {
                ButtonBox[
                  StyleBox["Controllability",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3266691079-2207279", 
                    "ProPac`ControlN`Controllability"},
                  ButtonFrame->"None",
                  ButtonNote->"ProPac`ControlN`"], 
                ButtonBox[
                  StyleBox["LocalDecomposition",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3266691079-2207279", 
                    "ProPac`ControlN`LocalDecomposition"},
                  ButtonFrame->"None",
                  ButtonNote->"ProPac`ControlN`"], 
                ButtonBox[
                  StyleBox["SIExactFBL",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3266691079-2207279", 
                    "ProPac`ControlN`SIExactFBL"},
                  ButtonFrame->"None",
                  ButtonNote->"ProPac`ControlN`"]},
              {
                ButtonBox[
                  StyleBox["DecouplingMatrix",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3266691079-2207279", 
                    "ProPac`ControlN`DecouplingMatrix"},
                  ButtonFrame->"None",
                  ButtonNote->"ProPac`ControlN`"], 
                ButtonBox[
                  StyleBox["LocalInverseTransformation",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3266691079-2207279", 
                    "ProPac`ControlN`LocalInverseTransformation"},
                  ButtonFrame->"None",
                  ButtonNote->"ProPac`ControlN`"], 
                ButtonBox[
                  StyleBox["SISONormalFormTrans",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3266691079-2207279", 
                    "ProPac`ControlN`SISONormalFormTrans"},
                  ButtonFrame->"None",
                  ButtonNote->"ProPac`ControlN`"]},
              {
                ButtonBox[
                  StyleBox["Dist",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  ButtonData:>{"Info3266691079-2207279", 
                    "ProPac`ControlN`Dist"},
                  ButtonFrame->"None",
                  ButtonNote->"ProPac`ControlN`"], 
                ButtonBox[
                  StyleBox["LocalZeroDynamics",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3266691079-2207279", 
                    "ProPac`ControlN`LocalZeroDynamics"},
                  ButtonFrame->"None",
                  ButtonNote->"ProPac`ControlN`"], 
                ButtonBox[
                  StyleBox["StructureAlgorithm",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3266691079-2207279", 
                    "ProPac`ControlN`StructureAlgorithm"},
                  ButtonFrame->"None",
                  ButtonNote->"ProPac`ControlN`"]},
              {
                ButtonBox[
                  StyleBox["DynamicExtension",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3266691079-2207279", 
                    "ProPac`ControlN`DynamicExtension"},
                  ButtonFrame->"None",
                  ButtonNote->"ProPac`ControlN`"], 
                ButtonBox[
                  StyleBox["NonlinearControl",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3266691079-2207279", 
                    "ProPac`ControlN`NonlinearControl"},
                  ButtonFrame->"None",
                  ButtonNote->"ProPac`ControlN`"], 
                ButtonBox[
                  StyleBox["TransformSystem",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3266691079-2207279", 
                    "ProPac`ControlN`TransformSystem"},
                  ButtonFrame->"None",
                  ButtonNote->"ProPac`ControlN`"]},
              {
                ButtonBox[
                  StyleBox["ExponentialObserver",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3266691079-2207279", 
                    "ProPac`ControlN`ExponentialObserver"},
                  ButtonFrame->"None",
                  ButtonNote->"ProPac`ControlN`"], 
                ButtonBox[
                  StyleBox["NormalCoordinates",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3266691079-2207279", 
                    "ProPac`ControlN`NormalCoordinates"},
                  ButtonFrame->"None",
                  ButtonNote->"ProPac`ControlN`"], 
                ButtonBox[
                  StyleBox["VectorRelativeOrder",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3266691079-2207279", 
                    "ProPac`ControlN`VectorRelativeOrder"},
                  ButtonFrame->"None",
                  ButtonNote->"ProPac`ControlN`"]},
              {
                ButtonBox[
                  StyleBox["FBLCond",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3266691079-2207279", 
                    "ProPac`ControlN`FBLCond"},
                  ButtonFrame->"None",
                  ButtonNote->"ProPac`ControlN`"], 
                ButtonBox[
                  StyleBox["Observability",
                    FontColor->RGBColor[0, 0, 1],
                    FontVariations->{"Underline"->True}],
                  
                  ButtonFunction:>(
                    Internal`PutInformation[ #, LongForm -> False]&),
                  ButtonEvaluator->Automatic,
                  
                  ButtonData:>{"Info3266691079-2207279", 
                    "ProPac`ControlN`Observability"},
                  ButtonFrame->"None",
                  ButtonNote->"ProPac`ControlN`"], ""}
              },
            RowMinHeight->{1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1.05}]}
        },
      RowSpacings->{2, 3},
      ColumnAlignments->{Left},
      ColumnsEqual->True]], "Print",
  CellMargins->{{20, Inherited}, {Inherited, Inherited}},
  ShowCellLabel->False,
  CellFrameMargins->{{Inherited, Inherited}, {14, 14}},
  Background->RGBColor[0.964706, 0.929412, 0.839216],
  ButtonBoxOptions->{Active->True},
  CellTags->{"b:30", "Package"}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Controllability & Observability", "Section",
  CellTags->{"Controllability & Observability", "i:17"}],

Cell[CellGroupData[{

Cell["Controllability", "Subsection",
  CellTags->{"Controllability & Observability", "i:17", "b:31.0"}],

Cell[CellGroupData[{

Cell[BoxData[
    \(\(?ControlDistribution\)\)], "Input",
  CellLabel->"In[5]:=",
  CellTags->{"Controllability & Observability", "i:17", "b:31.0"}],

Cell[BoxData[
    \("  *** LinearControl successfully loaded ***"\)], "Print",
  CellLabel->"From In[5]:=",
  CellTags->{"Controllability & Observability", "i:17", "b:31.0"}],

Cell[BoxData[
    \("  *** NonlinearControl successfully loaded ***"\)], "Print",
  CellLabel->"From In[5]:=",
  CellTags->{"Controllability & Observability", "i:17", "b:31.0"}],

Cell[BoxData[
    \("ControlDistribution[f,g,x] computes the controllability distribution\n \
of a nonlinear system. That is, it produces a basis set of vector fields for\n\
 the smallest f,g[1],..g[m]-invariant distribution that contains \
f,g[1],..g[m].\n ControlDistribution has two options:\n \n \
ControlDrift->False produces the smallest f,g[1],..g[m]-invariant \n \
distribution that contains g[1],..g[m].\n \n IntermediateResults->True prints \
intermediate distributions as they are\n computed.\n \n \
ControlDistribution[f,g,x,x0] returns the control distribution evaluated\n at \
the point x0. "\)], "Print",
  CellTags->{"Info3266691080-3602776", "b:31.0"}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
    \(\(A = {{0, 0, \(-14\)}, {0, 0, 0}, {0, 0, \(-1\)}};\)\), "\n", 
    \(\(B = {{1, 2, 4}, {0, 2, 0}, {0, 0, 3}};\)\), "\n", 
    \(\(x = {x1, x2, x3};\)\), "\n", 
    \(\(f = A . x;\)\), "\n", 
    \(\(g = B . x;\)\), "\n", 
    \(ControlDistribution[f, g, x] // MatrixForm\)}], "Input",
  CellLabel->"In[6]:=",
  CellTags->{"Controllability & Observability", "i:17", "b:31.0"}],

Cell[BoxData[
    TagBox[
      RowBox[{"(", "\[NoBreak]", GridBox[{
            {"1", "0", "0"},
            {"0", "1", "0"},
            {"0", "0", "1"}
            }], "\[NoBreak]", ")"}],
      Function[ BoxForm`e$, 
        MatrixForm[ BoxForm`e$]]]], "Output",
  CellLabel->"Out[11]//MatrixForm=",
  CellTags->{"Controllability & Observability", "i:17", "b:31.0"}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(ControlDistribution[f, g, x, IncludeDrift -> False] // 
      MatrixForm\)], "Input",
  CellLabel->"In[12]:=",
  CellTags->{"Controllability & Observability", "i:16", "i:17", "b:31.0"}],

Cell[BoxData[
    TagBox[
      RowBox[{"(", "\[NoBreak]", GridBox[{
            {"1", "0", "0"},
            {"0", \(2\ x2\), \(3\ x3\)}
            }], "\[NoBreak]", ")"}],
      Function[ BoxForm`e$, 
        MatrixForm[ BoxForm`e$]]]], "Output",
  CellLabel->"Out[12]//MatrixForm=",
  CellTags->{"Controllability & Observability", "i:16", "i:17", "b:31.0"}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(\(?Controllability\)\)], "Input",
  CellLabel->"In[13]:=",
  CellTags->{"Controllability & Observability", "i:17", "b:31.0"}],

Cell[BoxData[
    \("Controllability[f,g,x] tests the pair (f,g) to determine if the system \
is\n  weakly locally controllable. If the controllability distribution has \
rank=dim[x]\n  it returns True. If it does not, it returns False. The option\n\
 LocalControllability->True tests for local controllability"\)], "Print",
  CellTags->{"Info3266691083-3296927", "b:31.0"}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Controllability[f, g, x]\)], "Input",
  CellLabel->"In[14]:=",
  CellTags->{"Controllability & Observability", "i:17", "b:31.0"}],

Cell[BoxData[
    \(True\)], "Output",
  CellLabel->"Out[14]=",
  CellTags->{"Controllability & Observability", "i:17", "b:31.0"}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Controllability[f, g, x, LocalControllability \[Rule] True]\)], "Input",\

  CellLabel->"In[15]:=",
  CellTags->{"Controllability & Observability", "i:17", "b:31.0"}],

Cell[BoxData[
    \(False\)], "Output",
  CellLabel->"Out[15]=",
  CellTags->{"Controllability & Observability", "i:17", "b:31.0"}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Observability", "Subsection",
  CellTags->{"Controllability & Observability", "i:1", "b:31.1"}],

Cell["\<\
Example 65 (Section 7.3) from Vidyasagar (shows how control can be used to \
establish observability) \
\>", "Text",
  CellTags->{"Controllability & Observability", "i:1", "b:31.1"}],

Cell[CellGroupData[{

Cell[BoxData[
    \(\(?Observability\)\)], "Input",
  CellLabel->"In[16]:=",
  CellTags->{"Controllability & Observability", "i:1", "b:31.1"}],

Cell[BoxData[
    \("Observability[f,G,h,var] tests local observability\n and returns \
either True or False. "\)], "Print",
  CellTags->{"Info3266691083-3416360", "i:1", "b:31.1"}]
}, Open  ]],

Cell[BoxData[{
    \(\(f = {x2, x3, 0};\)\), "\n", 
    \(\(g = {0, x1, 0};\)\), "\n", 
    \(\(h1 = x1;\)\), "\n", 
    \(\(h2 = x2;\)\), "\n", 
    \(\(var = {x1, x2, x3};\)\)}], "Input",
  CellLabel->"In[17]:=",
  CellTags->{"Controllability & Observability", "i:1", "b:31.1"}],

Cell[CellGroupData[{

Cell[BoxData[
    \(Observability[f, g, h2, var]\)], "Input",
  CellLabel->"In[22]:=",
  CellTags->{"Controllability & Observability", "i:1", "b:31.1"}],

Cell[BoxData[
    \(True\)], "Output",
  CellLabel->"Out[22]=",
  CellTags->{"Controllability & Observability", "i:1", "b:31.1"}]
}, Open  ]],

Cell["Try it without any input:", "Text",
  CellTags->{"Controllability & Observability", "i:1", "b:31.1"}],

Cell[CellGroupData[{

Cell[BoxData[
    \(Observability[f, {{}}, {h2}, var]\)], "Input",
  CellLabel->"In[23]:=",
  CellTags->{"Controllability & Observability", "i:1", "b:31.1"}],

Cell[BoxData[
    \(False\)], "Output",
  CellLabel->"Out[23]=",
  CellTags->{"Controllability & Observability", "i:1", "b:31.1"}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(ObservabilityCodistribution[f, Transpose[{g}], {h2}, var]\)], "Input",
  CellLabel->"In[24]:=",
  CellTags->{"Controllability & Observability", "i:1", "b:31.1"}],

Cell[BoxData[
    \({{1, 0, 0}, {0, 1, 0}, {0, 0, 1}}\)], "Output",
  CellLabel->"Out[24]=",
  CellTags->{"Controllability & Observability", "i:1", "b:31.1"}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(ObservabilityCodistribution[f, {{}}, {h2}, var]\)], "Input",
  CellLabel->"In[25]:=",
  CellTags->{"Controllability & Observability", "i:1", "b:31.1"}],

Cell[BoxData[
    \({{0, 0, 1}, {0, 1, 0}}\)], "Output",
  CellLabel->"Out[25]=",
  CellTags->{"Controllability & Observability", "i:1", "b:31.1"}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Local Decomposition", "Subsection",
  CellTags->{"Controllability & Observability", "i:17", "b:31.2"}],

Cell[CellGroupData[{

Cell[BoxData[
    \(\(?LocalDecomposition\)\)], "Input",
  CellLabel->"In[26]:=",
  CellTags->{"Controllability & Observability", "i:17", "b:31.2"}],

Cell[BoxData[
    \("LocalDecomposition[f,G,h,var,u,m] returns \
{Psi,PsiInverse,fnew,Gnew,hnew}\n where Psi is a transformation var=Psi(z) \
that puts the system into a \n partitioned form with four parts:\n \n \
controllable & not observable\n controllable & observable\n not controllable \
& not observable\n not controllable & observable\n \n computations are \
carried out locally up to order m, if m is an integer.\n Computations are \
exact, if this is possible, when m=Infinity.\n  "\)], "Print",
  CellTags->{"Info3266691083-1465963", "b:31.2"}]
}, Open  ]],

Cell[BoxData[{
    \(\(f = {x1\ x3 + x2\ Exp[x2], x3, x4 - x2\ x3, 
          x3^2 + x2\ x4 - x2^2\ x3};\)\), "\n", 
    \(G = Transpose[{{x1, 1, 0, x3}}]; u = {u1};\), "\n", 
    \(\(h = {x3};\)\), "\n", 
    \(\(var = {x1, x2, x3, x4};\)\)}], "Input",
  CellLabel->"In[27]:=",
  CellTags->{"Controllability & Observability", "i:17", "b:31.2"}],

Cell[CellGroupData[{

Cell[BoxData[
    \(LocalDecomposition[f, G, h, var, u, Infinity]\)], "Input",
  CellLabel->"In[31]:=",
  CellTags->{"Controllability & Observability", "i:17", "b:31.2"}],

Cell[BoxData[
    \({{z1, z2, z3, z2\ z3 + z4}, {x1, x2, 
        x3, \(-x2\)\ x3 + x4}, {\[ExponentialE]\^z2\ z2 + z1\ z3, z3, z4, 
        0}, {{z1}, {1}, {0}, {0}}, {z3}}\)], "Output",
  CellLabel->"Out[31]=",
  CellTags->{"Controllability & Observability", "i:17", "b:31.2"}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
    \(\(f = {x2, x3, 0};\)\), "\n", 
    \(g = {0, x1, 0}; u = {u1}\), "\n", 
    \(\(h = x2;\)\), "\n", 
    \(\(var = {x1, x2, x3};\)\)}], "Input",
  CellLabel->"In[32]:=",
  CellTags->{"Controllability & Observability", "i:17", "b:31.2"}],

Cell[BoxData[
    \({u1}\)], "Output",
  CellLabel->"Out[33]=",
  CellTags->{"Controllability & Observability", "i:17", "b:31.2"}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(LocalDecomposition[f, Transpose[{g}], {h}, var, u, Infinity]\)], "Input",\

  CellLabel->"In[36]:=",
  CellTags->{"Controllability & Observability", "i:17", "b:31.2"}],

Cell[BoxData[
    \("System is locally observable"\)], "Print",
  CellLabel->"From In[36]:=",
  CellTags->{"Controllability & Observability", "i:17", "b:31.2"}],

Cell[BoxData[
    \({{z1, z2, z3}, {x1, x2, x3}, {z2, z3, 
        0}, {{0}, {z1}, {0}}, {z2}}\)], "Output",
  CellLabel->"Out[36]=",
  CellTags->{"Controllability & Observability", "i:17", "b:31.2"}]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Exact Feedback Linearization", "Section",
  CellTags->{"i:2", "b:32.0", "Exact Feedback Linearization"}],

Cell["\<\
Some nonlinear systems can be exactly linearized by a combination of a state \
transformation and nonlinear feedback. TSi Controls implements some of the \
basic constructions of the 'feedback linearization' method. To determine if a \
system is feedback linearizable, We can use the test function \
FeedbackLinearizable\
\>", "Text",
  Evaluatable->False,
  CellTags->{"Exact Feedback Linearization", "i:18", "i:2", "b:32.0"}],

Cell["As an example, consider the following:", "Text",
  Evaluatable->False,
  CellTags->{"Exact Feedback Linearization", "i:18", "i:2", "b:32.0"}],

Cell[CellGroupData[{

Cell[BoxData[{
    \(\(f30 = {theta\ x1\^3 + x2, x3, 0};\)\), "\n", 
    \(\(g30 = {0, 0, 1};\)\), "\n", 
    \(\(var30 = {x1, x2, x3};\)\), "\n", 
    \(FeedbackLinearizable[f30, g30, var30]\)}], "Input",
  CellLabel->"In[37]:=",
  PageWidth->Infinity,
  AspectRatioFixed->True,
  FontFamily->"Courier New",
  FontSize->12,
  FontWeight->"Bold",
  FontColor->GrayLevel[0],
  Background->GrayLevel[1],
  CellTags->{"Exact Feedback Linearization", "i:18", "i:2", "b:32.0"}],

Cell[BoxData[
    \(True\)], "Output",
  CellLabel->"Out[40]=",
  CellTags->{"Exact Feedback Linearization", "i:18", "i:2", "b:32.0"}]
}, Open  ]],

Cell["\<\
Since this system is linearizable, we can proceed to obtain the exact \
feedback linearizing state transformation with the function SIExactFBL\
\>", "Text",
  Evaluatable->False,
  CellTags->{"Exact Feedback Linearization", "i:18", "i:2", "b:32.0"}],

Cell[CellGroupData[{

Cell[BoxData[
    \(Trans = SIExactFBL[f30, g30, var30, True]\)], "Input",
  CellLabel->"In[41]:=",
  PageWidth->Infinity,
  FontFamily->"Courier New",
  FontSize->12,
  FontWeight->"Bold",
  FontColor->GrayLevel[0],
  Background->GrayLevel[1],
  CellTags->{"Exact Feedback Linearization", "i:18", "i:2", "b:32.0"}],

Cell[BoxData[
    InterpretationBox[\("Linearizing Output Solutions: "\[InvisibleSpace]{x1}\
\),
      SequenceForm[ "Linearizing Output Solutions: ", {x1}],
      Editable->False]], "Print",
  CellLabel->"From In[41]:=",
  CellTags->{"Exact Feedback Linearization", "i:18", "i:2", "b:32.0"}],

Cell[BoxData[
    InterpretationBox[\("Exact Feedback Linearizing Transformation z=T("\
\[InvisibleSpace]{x1, x2, x3}\[InvisibleSpace]"):"\),
      SequenceForm[ 
      "Exact Feedback Linearizing Transformation z=T(", {x1, x2, x3}, "):"],
      Editable->False]], "Print",
  CellLabel->"From In[41]:=",
  CellTags->{"Exact Feedback Linearization", "i:18", "i:2", "b:32.0"}],

Cell[BoxData[
    InterpretationBox[\("         "\[InvisibleSpace]z1\[InvisibleSpace]" =  "\
\[InvisibleSpace]x1\),
      SequenceForm[ "         ", z1, " =  ", x1],
      Editable->False]], "Print",
  CellLabel->"From In[41]:=",
  CellTags->{"Exact Feedback Linearization", "i:18", "i:2", "b:32.0"}],

Cell[BoxData[
    InterpretationBox[\("         "\[InvisibleSpace]z2\[InvisibleSpace]" =  "\
\[InvisibleSpace]\(theta\ x1\^3 + x2\)\),
      SequenceForm[ "         ", z2, " =  ", 
        Plus[ 
          Times[ theta, 
            Power[ x1, 3]], x2]],
      Editable->False]], "Print",
  CellLabel->"From In[41]:=",
  CellTags->{"Exact Feedback Linearization", "i:18", "i:2", "b:32.0"}],

Cell[BoxData[
    InterpretationBox[\("         "\[InvisibleSpace]z3\[InvisibleSpace]" =  "\
\[InvisibleSpace]\(3\ theta\ x1\^2\ \((theta\ x1\^3 + x2)\) + x3\)\),
      SequenceForm[ "         ", z3, " =  ", 
        Plus[ 
          Times[ 3, theta, 
            Power[ x1, 2], 
            Plus[ 
              Times[ theta, 
                Power[ x1, 3]], x2]], x3]],
      Editable->False]], "Print",
  CellLabel->"From In[41]:=",
  CellTags->{"Exact Feedback Linearization", "i:18", "i:2", "b:32.0"}],

Cell[BoxData[
    \({x1, theta\ x1\^3 + x2, 
      3\ theta\ x1\^2\ \((theta\ x1\^3 + x2)\) + x3}\)], "Output",
  CellLabel->"Out[41]=",
  CellTags->{"Exact Feedback Linearization", "i:18", "i:2", "b:32.0"}]
}, Open  ]],

Cell["\<\
To obtain the linearizeable system in normal form coordinates, we need to \
first invert the transformation using InverseTrans and then use TransSystem \
to obtain the system representation in the new coordinates.\
\>", "Text",
  Evaluatable->False,
  CellTags->{"Exact Feedback Linearization", "i:18", "i:2", "b:32.0"}],

Cell[CellGroupData[{

Cell[BoxData[
    \(InvTrans = InverseTransformation[var30, {z1, z2, z3}, Trans]\)], "Input",\

  CellLabel->"In[42]:=",
  PageWidth->Infinity,
  CellTags->{"Exact Feedback Linearization", "i:18", "i:2", "b:32.0"}],

Cell[BoxData[
    InterpretationBox[\("Inverse Transformation: "\[InvisibleSpace]{x1, x2, 
          x3}\[InvisibleSpace]" =  "\[InvisibleSpace]{z1, \(-theta\)\ z1\^3 + 
            z2, \(-3\)\ theta\ z1\^2\ z2 + z3}\),
      SequenceForm[ "Inverse Transformation: ", {x1, x2, x3}, " =  ", {z1, 
        Plus[ 
          Times[ -1, theta, 
            Power[ z1, 3]], z2], 
        Plus[ 
          Times[ -3, theta, 
            Power[ z1, 2], z2], z3]}],
      Editable->False]], "Print",
  CellLabel->"From In[42]:=",
  CellTags->{"Exact Feedback Linearization", "i:18", "i:2", "b:32.0"}],

Cell[BoxData[
    \({z1, \(-theta\)\ z1\^3 + z2, \(-3\)\ theta\ z1\^2\ z2 + z3}\)], "Output",\

  CellLabel->"Out[42]=",
  CellTags->{"Exact Feedback Linearization", "i:18", "i:2", "b:32.0"}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(TransformSystem[f30, g30, var30, {z1, z2, z3}, Trans, 
      InvTrans]\)], "Input",
  CellLabel->"In[43]:=",
  PageWidth->Infinity,
  CellTags->{"Exact Feedback Linearization", "i:18", "i:2", "b:32.0"}],

Cell[BoxData[
    \({{z2, z3, 3\ theta\ z1\ \((2\ z2\^2 + z1\ z3)\)}, {0, 0, 
        1}}\)], "Output",
  CellLabel->"Out[43]=",
  CellTags->{"Exact Feedback Linearization", "i:18", "i:2", "b:32.0"}]
}, Open  ]],

Cell["\<\
In these coordinates the feedback linearizing controller is obvious.

Another illustration is:\
\>", "Text",
  Evaluatable->False,
  CellTags->{"Exact Feedback Linearization", "i:18", "i:2", "b:32.0"}],

Cell[BoxData[{
    \(\(f33 = {1 + x1 + x3, 1 + x2, \(-x3\)};\)\), "\n", 
    \(\(g33 = {{1 + x1 + x3, 0}, {1 + x2, 0}, {0, 
            Exp[x3] + x1\ x2}};\)\), "\n", 
    \(\(var33 = {x1, x2, x3};\)\)}], "Input",
  CellLabel->"In[44]:=",
  PageWidth->Infinity,
  CellTags->{"Exact Feedback Linearization", "i:18", "i:2", "b:32.0"}],

Cell[CellGroupData[{

Cell[BoxData[
    \(FeedbackLinearizable[f33, g33, var33]\)], "Input",
  CellLabel->"In[47]:=",
  PageWidth->Infinity,
  CellTags->{"Exact Feedback Linearization", "i:18", "i:2", "b:32.0"}],

Cell[BoxData[
    \(False\)], "Output",
  CellLabel->"Out[47]=",
  CellTags->{"Exact Feedback Linearization", "i:18", "i:2", "b:32.0"}]
}, Open  ]],

Cell["\<\
The fact that the system is not exactly linearizable is not remarkable, but \
the way in which linearizability fails is interesting. First, let's test \
controllability:\
\>", "Text",
  Evaluatable->False,
  CellTags->{"Exact Feedback Linearization", "i:18", "i:2", "b:32.0"}],

Cell[CellGroupData[{

Cell[BoxData[
    \(Controllability[f33, g33, var33]\)], "Input",
  CellLabel->"In[48]:=",
  PageWidth->Infinity,
  CellTags->{"Exact Feedback Linearization", "i:18", "i:2", "b:32.0"}],

Cell[BoxData[
    \(True\)], "Output",
  CellLabel->"Out[48]=",
  CellTags->{"Exact Feedback Linearization", "i:18", "i:2", "b:32.0"}]
}, Open  ]],

Cell["\<\
Now, we test for involutivity of the requisite distributions. There are only \
two. Let g1,g2 denote the columns of g33:\
\>", "Text",
  Evaluatable->False,
  CellTags->{"Exact Feedback Linearization", "i:18", "i:2", "b:32.0"}],

Cell[CellGroupData[{

Cell[BoxData[{
    \(\({g1, g2} = Transpose[g33];\)\), "\n", 
    \(Involutive[{g1, g2}, var33]\)}], "Input",
  CellLabel->"In[49]:=",
  PageWidth->Infinity,
  CellTags->{"Exact Feedback Linearization", "i:18", "i:2", "b:32.0"}],

Cell[BoxData[
    \(False\)], "Output",
  CellLabel->"Out[50]=",
  CellTags->{"Exact Feedback Linearization", "i:18", "i:2", "b:32.0"}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Involutive[{g1, g2, Ad[f33, g1, var33], Ad[f33, g2, var33]}, 
      var33]\)], "Input",
  CellLabel->"In[51]:=",
  PageWidth->Infinity,
  CellTags->{"Exact Feedback Linearization", "i:18", "i:2", "b:32.0"}],

Cell[BoxData[
    \(True\)], "Output",
  CellLabel->"Out[51]=",
  CellTags->{"Exact Feedback Linearization", "i:18", "i:2", "b:32.0"}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Input-Output Linearization, Relative Degree & Decoupling ", "Section",
  Evaluatable->False,
  AspectRatioFixed->True,
  CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],

Cell[CellGroupData[{

Cell["I-O Linearization & Zero Dynamics for SISO Systems", "Subsection",
  Evaluatable->False,
  CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],

Cell["\<\
If a system is not exactly feedback linearizable, it may still be \
linearizable in an input-output sense. In this event, we can find a state \
transformation and a nonlinear state feedback control such that the \
input-output behavior is described by a linear dynamical system. When a \
system is not exactly feedback linearizable, but is linearizable in the \
input-output sense, it is possible to use a state transformation to reduce \
the system to a normal form similar to that illustrated above. However, in \
the this case there remain residual nonlinear dynamics, called the internal \
dynamics, which are decoupled from the output. Hence the input-output \
behavior is linear even though the entire state dynamics are not. In the SISO \
case, the coordinate transformation can always be chosen such that the \
internal dynamics are independent of the control. \
\>", "Text",
  Evaluatable->False,
  AspectRatioFixed->True,
  FontFamily->"Times New Roman",
  FontSize->12,
  FontWeight->"Plain",
  FontSlant->"Plain",
  FontTracking->"Plain",
  FontColor->GrayLevel[0],
  Background->GrayLevel[1],
  FontVariations->{"Underline"->False,
  "Outline"->False,
  "Shadow"->False},
  CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],

Cell["\<\
As an example, consider the following (example 4.1.5 in Isidori):\
\>", "Text",
  Evaluatable->False,
  FontFamily->"Times New Roman",
  FontSize->12,
  FontWeight->"Plain",
  FontSlant->"Plain",
  FontTracking->"Plain",
  FontColor->GrayLevel[0],
  Background->GrayLevel[1],
  FontVariations->{"Underline"->False,
  "Outline"->False,
  "Shadow"->False},
  CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],

Cell[CellGroupData[{

Cell[BoxData[{
    \(\(f29 = {x1\ x2 - x1\^3, x1, \(-x3\), x1\^2 + x2};\)\), "\n", 
    \(g29 = {0, 2 + 2\ x3, 1, 0}; h29 = {x4};\), "\n", 
    \(var29 = {x1, x2, x3, x4}; newvar29 = {z1, z2, z3, z4};\), "\n", 
    \({T1, T2} = SISONormalFormTrans[f29, g29, h29, var29]\)}], "Input",
  CellLabel->"In[52]:=",
  PageWidth->Infinity,
  FontFamily->"Courier New",
  FontSize->12,
  FontWeight->"Bold",
  FontColor->GrayLevel[0],
  Background->GrayLevel[1],
  CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],

Cell[BoxData[
    \({{x4, x1\^2 + x2}, {x1, 
        1\/2\ \((\(-x2\) + 2\ x3 + x3\^2)\)}}\)], "Output",
  CellLabel->"Out[55]=",
  CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
    \(\(Trans = Join[T1, T2];\)\), "\n", 
    \(InvTrans = InverseTransformation[var29, newvar29, Trans]\)}], "Input",
  CellLabel->"In[56]:=",
  PageWidth->Infinity,
  FontFamily->"Courier New",
  FontSize->12,
  FontWeight->"Bold",
  FontColor->GrayLevel[0],
  Background->GrayLevel[1],
  CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],

Cell[BoxData[
    InterpretationBox[\("Inverse Transformation: "\[InvisibleSpace]{x1, x2, 
          x3, x4}\[InvisibleSpace]" =  "\[InvisibleSpace]{z3, 
          z2 - z3\^2, \(-1\) - \@\(1 + z2 - z3\^2 + 2\ z4\), z1}\),
      SequenceForm[ 
      "Inverse Transformation: ", {x1, x2, x3, x4}, " =  ", {z3, 
        Plus[ z2, 
          Times[ -1, 
            Power[ z3, 2]]], 
        Plus[ -1, 
          Times[ -1, 
            Power[ 
              Plus[ 1, z2, 
                Times[ -1, 
                  Power[ z3, 2]], 
                Times[ 2, z4]], 
              Rational[ 1, 2]]]], z1}],
      Editable->False]], "Print",
  CellLabel->"From In[56]:=",
  CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],

Cell[BoxData[
    \({z3, z2 - z3\^2, \(-1\) - \@\(1 + z2 - z3\^2 + 2\ z4\), z1}\)], "Output",\

  CellLabel->"Out[57]=",
  CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}]
}, Open  ]],

Cell[BoxData[
    \(\({Newf, Newg} = 
        TransformSystem[f29, g29, var29, newvar29, Trans, 
          InvTrans];\)\)], "Input",
  CellLabel->"In[58]:=",
  PageWidth->Infinity,
  FontFamily->"Courier New",
  FontSize->12,
  FontWeight->"Bold",
  FontColor->GrayLevel[0],
  Background->GrayLevel[1],
  CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],

Cell["\<\
Now, the output y=x4=z1 is identically equal to zero if and only if z1=0 and \
z2=0. When this obtains, the internal dynamics reduce to the zero (output) \
dynamics:\
\>", "Text",
  Evaluatable->False,
  CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],

Cell[CellGroupData[{

Cell[BoxData[
    \(ZeroDyn = {\[PartialD]\_t{z3[t], 
              z4[t]} == \((Newf\[LeftDoubleBracket]{3, 
                  4}\[RightDoubleBracket] /. {z1 \[Rule] 0, z2 \[Rule] 0, 
                z3 \[Rule] z3[t], z4 \[Rule] z4[t]})\)}\)], "Input",
  CellLabel->"In[59]:=",
  PageWidth->Infinity,
  CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{
        RowBox[{"{", 
          RowBox[{
            RowBox[{
              SuperscriptBox["z3", "\[Prime]",
                MultilineFunction->None], "[", "t", "]"}], ",", 
            RowBox[{
              SuperscriptBox["z4", "\[Prime]",
                MultilineFunction->None], "[", "t", "]"}]}], "}"}], 
        "\[Equal]", \({\(-2\)\ z3[t]\^3, \(-1\) - z3[t]\/2 + z3[t]\^2 - 
            2\ z4[t] - \@\(1 - z3[t]\^2 + 2\ z4[t]\)}\)}], "}"}]], "Output",
  CellLabel->"Out[59]=",
  CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}]
}, Open  ]],

Cell["As another example, consider ( Example 4.1.4 from Isidori)", "Text",
  Evaluatable->False,
  CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],

Cell[BoxData[{
    \(f28 = {\(-x1\), x1\ x2, x2}; g28 = {Exp[x2], 1, 0}; 
    h28 = {x3};\), "\n", 
    \(var28 = {x1, x2, x3}; newvar28 = {z1, z2, z3};\)}], "Input",
  CellLabel->"In[60]:=",
  PageWidth->Infinity,
  FontFamily->"Courier New",
  FontSize->12,
  FontWeight->"Bold",
  FontColor->GrayLevel[0],
  Background->GrayLevel[1],
  CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],

Cell[CellGroupData[{

Cell[BoxData[
    \({T1, T2} = SISONormalFormTrans[f28, g28, h28, var28]\)], "Input",
  CellLabel->"In[62]:=",
  PageWidth->Infinity,
  FontFamily->"Courier New",
  FontSize->12,
  FontWeight->"Bold",
  FontColor->GrayLevel[0],
  Background->GrayLevel[1],
  CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],

Cell[BoxData[
    RowBox[{\(Solve::"ifun"\), \(\(:\)\(\ \)\), "\<\"Inverse functions are \
being used by \\!\\(Solve\\), so some solutions may not be found; use Reduce \
for complete solution information. \
\\!\\(\\*ButtonBox[\\\"More\[Ellipsis]\\\", ButtonStyle->\\\"RefGuideLinkText\
\\\", ButtonFrame->None, ButtonData:>\\\"Solve::ifun\\\"]\\)\"\>"}]], \
"Message",
  CellLabel->"From In[62]:=",
  CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],

Cell[BoxData[
    \({{x3, x2}, {\(-1\) + \[ExponentialE]\^x2 - x1}}\)], "Output",
  CellLabel->"Out[62]=",
  CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Trans = Join[T1, T2]\)], "Input",
  CellLabel->"In[63]:=",
  PageWidth->Infinity,
  FontFamily->"Courier New",
  FontSize->12,
  FontWeight->"Bold",
  FontColor->GrayLevel[0],
  Background->GrayLevel[1],
  CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],

Cell[BoxData[
    \({x3, x2, \(-1\) + \[ExponentialE]\^x2 - x1}\)], "Output",
  CellLabel->"Out[63]=",
  CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(InvTrans = InverseTransformation[var28, newvar28, Trans]\)], "Input",
  CellLabel->"In[64]:=",
  PageWidth->Infinity,
  FontFamily->"Courier New",
  FontSize->12,
  FontWeight->"Bold",
  FontColor->GrayLevel[0],
  Background->GrayLevel[1],
  CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],

Cell[BoxData[
    RowBox[{\(Solve::"incnst"\), \(\(:\)\(\ \)\), "\<\"Inconsistent or \
redundant transcendental equation. After reduction, the bad equation is \
\\!\\(\\(\\(-z2\\)\\) + \\(\\(Log[\\(\\(\[ExponentialE]\\^x2\\)\\)]\\)\\)\\) \
== 0. \\!\\(\\*ButtonBox[\\\"More\[Ellipsis]\\\", \
ButtonStyle->\\\"RefGuideLinkText\\\", ButtonFrame->None, \
ButtonData:>\\\"Solve::incnst\\\"]\\)\"\>"}]], "Message",
  CellLabel->"From In[64]:=",
  CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],

Cell[BoxData[
    RowBox[{\(Solve::"ifun"\), \(\(:\)\(\ \)\), "\<\"Inverse functions are \
being used by \\!\\(Solve\\), so some solutions may not be found; use Reduce \
for complete solution information. \
\\!\\(\\*ButtonBox[\\\"More\[Ellipsis]\\\", ButtonStyle->\\\"RefGuideLinkText\
\\\", ButtonFrame->None, ButtonData:>\\\"Solve::ifun\\\"]\\)\"\>"}]], \
"Message",
  CellLabel->"From In[64]:=",
  CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],

Cell[BoxData[
    InterpretationBox[\("Inverse Transformation: "\[InvisibleSpace]{x1, x2, 
          x3}\[InvisibleSpace]" =  "\[InvisibleSpace]{\(-1\) + \
\[ExponentialE]\^z2 - z3, z2, z1}\),
      SequenceForm[ "Inverse Transformation: ", {x1, x2, x3}, " =  ", {
        Plus[ -1, 
          Power[ E, z2], 
          Times[ -1, z3]], z2, z1}],
      Editable->False]], "Print",
  CellLabel->"From In[64]:=",
  CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],

Cell[BoxData[
    \({\(-1\) + \[ExponentialE]\^z2 - z3, z2, z1}\)], "Output",
  CellLabel->"Out[64]=",
  CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}]
}, Open  ]],

Cell["\<\
This illustrates a difficulty in using Mathematica's Solve function. \
Mathematica finds the 'bad equation' to be inconstant with the equation \
z2=x2. However, the bad equation is indeed equivalent. In fact, the inverse \
transformation is obvious:\
\>", "Text",
  Evaluatable->False,
  CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],

Cell[CellGroupData[{

Cell[BoxData[
    \(InvTrans = {1 - Exp[z2] + z3, z2, z1}\)], "Input",
  CellLabel->"In[65]:=",
  PageWidth->Infinity,
  FontFamily->"Courier New",
  FontSize->12,
  FontWeight->"Bold",
  FontColor->GrayLevel[0],
  Background->GrayLevel[1],
  CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],

Cell[BoxData[
    \({1 - \[ExponentialE]\^z2 + z3, z2, z1}\)], "Output",
  CellLabel->"Out[65]=",
  CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}]
}, Open  ]],

Cell["Now, we can proceed to obtain the transformed system.", "Text",
  Evaluatable->False,
  CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],

Cell[CellGroupData[{

Cell[BoxData[
    \({Newf, Newg} = 
      TransformSystem[f28, g28, var28, newvar28, Trans, InvTrans]\)], "Input",\

  CellLabel->"In[66]:=",
  PageWidth->Infinity,
  FontFamily->"Courier New",
  FontSize->12,
  FontWeight->"Bold",
  FontColor->GrayLevel[0],
  Background->GrayLevel[1],
  CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],

Cell[BoxData[
    \({{z2, 
        z2\ \((1 - \[ExponentialE]\^z2 + 
              z3)\), \(-\((1 + \[ExponentialE]\^z2\ z2)\)\)\ \((\(-1\) + \
\[ExponentialE]\^z2 - z3)\)}, {0, 1, 0}}\)], "Output",
  CellLabel->"Out[66]=",
  CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(ZeroDyn = {\[PartialD]\_t z3[
              t] == \((Newf\[LeftDoubleBracket]3\[RightDoubleBracket] /. {z1 \
\[Rule] 0, z2 \[Rule] 0, z3 \[Rule] z3[t]})\)}\)], "Input",
  CellLabel->"In[67]:=",
  PageWidth->Infinity,
  FontFamily->"Courier New",
  FontSize->12,
  FontWeight->"Bold",
  FontColor->GrayLevel[0],
  Background->GrayLevel[1],
  CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{
        RowBox[{
          SuperscriptBox["z3", "\[Prime]",
            MultilineFunction->None], "[", "t", "]"}], 
        "\[Equal]", \(z3[t]\)}], "}"}]], "Output",
  CellLabel->"Out[67]=",
  CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Relative Degree, Decoupling & Zero Dynamics for MIMO Systems", \
"Subsection",
  Evaluatable->False,
  CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],

Cell["\<\
For some SISO systems and most MIMO systems it is difficult or impossible to \
find complete global transformations to the linearizable normal form. \
Fortunately, it is not necessary to do so. For SISO systems the difference \
between the order of the system and the order of the zero dynamics is called \
the relative degree or relative order. In the above examples\
\>", "Text",
  Evaluatable->False,
  CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],

Cell[CellGroupData[{

Cell[BoxData[
    \(RelativeOrder[f29, g29, h29, var29]\)], "Input",
  CellLabel->"In[68]:=",
  PageWidth->Infinity,
  CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],

Cell[BoxData[
    \(2\)], "Output",
  CellLabel->"Out[68]=",
  CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(RelativeOrder[f28, g28, h28, var28]\)], "Input",
  CellLabel->"In[69]:=",
  PageWidth->Infinity,
  FontFamily->"Courier New",
  FontSize->12,
  FontWeight->"Bold",
  FontColor->GrayLevel[0],
  Background->GrayLevel[1],
  CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],

Cell[BoxData[
    \(2\)], "Output",
  CellLabel->"Out[69]=",
  CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}]
}, Open  ]],

Cell["\<\
For MIMO systems relative order is a vector (or list) of integers, in a sense \
characterizing the relative degree associated with each output. The function \
relative VectorRelativeOrder returns a vector, even for the SISO case.\
\>", "Text",
  Evaluatable->False,
  CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],

Cell[CellGroupData[{

Cell[BoxData[
    \(VectorRelativeOrder[f28, g28, h28, var28]\)], "Input",
  CellLabel->"In[70]:=",
  PageWidth->Infinity,
  FontFamily->"Courier New",
  FontSize->12,
  FontWeight->"Bold",
  FontColor->GrayLevel[0],
  Background->GrayLevel[1],
  CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],

Cell[BoxData[
    \({2}\)], "Output",
  CellLabel->"Out[70]=",
  CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}]
}, Open  ]],

Cell["\<\
Recall that the existance of an I-O feedback linearizing controller depends \
on the nonsingularity of the 'decoupling matrix' which can be systematically \
computed by differentiation. Consider the following example (adapted from \
Isidori). \
\>", "Text",
  Evaluatable->False,
  AspectRatioFixed->True,
  FontFamily->"Times New Roman",
  FontSize->12,
  FontWeight->"Plain",
  FontSlant->"Plain",
  FontTracking->"Plain",
  FontColor->GrayLevel[0],
  Background->GrayLevel[1],
  FontVariations->{"Underline"->False,
  "Outline"->False,
  "Shadow"->False},
  CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],

Cell[BoxData[{
    \(var2 := {x1, x2, x3}\), "\n", 
    \(f2 := {0, \ x1\  + \ x2^2, \ x1\  - \ x2}\), "\n", 
    \(g2 := {Exp[x2], Exp[x2], 0}\), "\n", 
    \(h2 := {x3}\), "\n", 
    \(p2 := {Sin[x1], 0, Exp[x2]}\)}], "Input",
  CellLabel->"In[71]:=",
  CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],

Cell["\<\
We can use the functions VectorRelativeDegree and then DecouplingMatrix to \
obtain: \
\>", "Text",
  Evaluatable->False,
  AspectRatioFixed->True,
  FontFamily->"Times New Roman",
  FontSize->12,
  FontWeight->"Plain",
  FontSlant->"Plain",
  FontTracking->"Plain",
  FontColor->GrayLevel[0],
  Background->GrayLevel[1],
  FontVariations->{"Underline"->False,
  "Outline"->False,
  "Shadow"->False},
  CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],

Cell[CellGroupData[{

Cell[BoxData[
    \(ro = VectorRelativeOrder[f2, g2, h2, var2]\)], "Input",
  CellLabel->"In[76]:=",
  PageWidth->Infinity,
  AspectRatioFixed->True,
  CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],

Cell[BoxData[
    \({3}\)], "Output",
  CellLabel->"Out[76]=",
  CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(DecouplingMatrix[f2, g2, h2, var2, ro]\)], "Input",
  CellLabel->"In[77]:=",
  PageWidth->Infinity,
  AspectRatioFixed->True,
  CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],

Cell[BoxData[
    \({{\(-\[ExponentialE]\^x2\) - 2\ \[ExponentialE]\^x2\ x2}}\)], "Output",
  CellLabel->"Out[77]=",
  CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}]
}, Open  ]],

Cell["\<\
Since the decoupling matrix is nonsingular, we can proceed to compute \
linearizing controller. The function IOLinearize does this.\
\>", "Text",
  Evaluatable->False,
  CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],

Cell[CellGroupData[{

Cell[BoxData[
    \({rho, alpha, ro, control} = IOLinearize[f2, g2, h2, var2]\)], "Input",
  CellLabel->"In[78]:=",
  PageWidth->Infinity,
  AspectRatioFixed->True,
  CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],

Cell[BoxData[
    \("Computing Decoupling Matrix"\)], "Print",
  CellLabel->"From In[78]:=",
  CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],

Cell[BoxData[
    \("Computing linearizing/decoupling control"\)], "Print",
  CellLabel->"From In[78]:=",
  CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],

Cell[BoxData[
    \({{{\(-\[ExponentialE]\^x2\) - 
            2\ \[ExponentialE]\^x2\ x2}}, {\(-2\)\ x2\ \((x1 + 
              x2\^2)\)}, {3}, {\(v1 + 2\ x2\ \((x1 + x2\^2)\)\)\/\(\(-\
\[ExponentialE]\^x2\) - 2\ \[ExponentialE]\^x2\ x2\)}}\)], "Output",
  CellLabel->"Out[78]=",
  CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}]
}, Open  ]],

Cell["\<\
It is also possible to compute the partial normal form transformation:\
\>", "Text",
  Evaluatable->False,
  CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],

Cell[CellGroupData[{

Cell[BoxData[
    \(z = NormalCoordinates[f2, g2, h2, var2, ro]\)], "Input",
  CellLabel->"In[79]:=",
  PageWidth->Infinity,
  AspectRatioFixed->True,
  CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],

Cell[BoxData[
    \({x3, x1 - x2, \(-x1\) - x2\^2}\)], "Output",
  CellLabel->"Out[79]=",
  CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}]
}, Open  ]],

Cell["\<\
And it is always possible to obtain a local representation of the zero \
dynamics.\
\>", "Text",
  Evaluatable->False,
  CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],

Cell[CellGroupData[{

Cell[BoxData[
    \(u0 = control /. {v1 \[Rule] 0}\)], "Input",
  CellLabel->"In[80]:=",
  PageWidth->Infinity,
  AspectRatioFixed->True,
  CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],

Cell[BoxData[
    \({\(2\ x2\ \((x1 + x2\^2)\)\)\/\(\(-\[ExponentialE]\^x2\) - 2\ \
\[ExponentialE]\^x2\ x2\)}\)], "Output",
  CellLabel->"Out[80]=",
  CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(LocalZeroDynamics[f2, g2, h2, var2, u0, z]\)], "Input",
  CellLabel->"In[81]:=",
  PageWidth->Infinity,
  AspectRatioFixed->True,
  CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],

Cell[BoxData[
    \("The system is completely linearizable."\)], "Print",
  CellLabel->"From In[81]:=",
  CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],

Cell[BoxData[
    \("There are no zero dynamics."\)], "Print",
  CellLabel->"From In[81]:=",
  CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],

Cell[BoxData[
    \({}\)], "Output",
  CellLabel->"Out[81]=",
  CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Dynamic extension", "Section",
  Evaluatable->False,
  AspectRatioFixed->True,
  CellTags->{"Dynamic extension", "i:20", "b:32.2"}],

Cell["\<\
The following example (Slotine, p.269) does not have well defined relative \
degree. Thus, direct computation leads to a singular decoupling matrix. \
however, dynamic extension does produce a decouplable system.\
\>", "Text",
  Evaluatable->False,
  AspectRatioFixed->True,
  CellTags->{"Dynamic extension", "i:20", "b:32.2"}],

Cell[BoxData[
    \(\(\(\(f12 := {0, 0, 0};\)\n
    \(g12 := Transpose[{{Cos[x3], Sin[x3], 0}, {0, 0, 1}}];\)\n
    \(h12 := {x1, x2};\)\n
    \(var12 := {x1, x2, x3};\)\n
    \(yyd12 := {E^t, t};\)\)\(\ \)\)\)], "Input",
  CellLabel->"In[82]:=",
  CellTags->{"Dynamic extension", "i:20", "b:32.2"}],

Cell[CellGroupData[{

Cell[BoxData[
    \(DynamicExtension[f12, g12, h12, var12]\)], "Input",
  CellLabel->"In[87]:=",
  PageWidth->Infinity,
  AspectRatioFixed->True,
  CellTags->{"Dynamic extension", "i:20", "b:32.2"}],

Cell[BoxData[
    \("Dynamic extension completed"\)], "Print",
  CellLabel->"From In[87]:=",
  CellTags->{"Dynamic extension", "i:20", "b:32.2"}],

Cell[BoxData[
    \({{z1\ Cos[x3], z1\ Sin[x3], 0, 
        0}, {{0, 0}, {0, 0}, {0, 1}, {1, 0}}, {x1, x2}, {x1, x2, x3, 
        z1}}\)], "Output",
  CellLabel->"Out[87]=",
  CellTags->{"Dynamic extension", "i:20", "b:32.2"}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Dynamic Inverse", "Section",
  CellTags->{"Dynamic Inverse", "i:21", "b:32.3"}],

Cell["\<\
When a system has a singular decoupling matrix, an (equivalent) alternative \
to dynamic extension is to construct a dynamic inverse. Dynamic inverses are \
interesting in their own right and have useful application such as in the \
design of tracking controllers. ProPac implements the Hirschorn-Singh \
constructions in the function StructureAlgorithm. The following example is \
from Neijmeijer and Van der Schaft.\
\>", "Text",
  CellTags->{"Dynamic Inverse", "i:21", "b:32.3"}],

Cell[BoxData[{
    \(\(x = {x1, x2, x3, x4};\)\), "\n", 
    \(f = {0, x3, x4, 0}; G = {{1, 0}, {x4, 0}, {0, 0}, {0, 1}};\), "\n", 
    \(\(h = {x1, x2};\)\)}], "Input",
  CellLabel->"In[88]:=",
  CellTags->{"Dynamic Inverse", "i:21", "b:32.3"}],

Cell[CellGroupData[{

Cell[BoxData[
    \({DD, CC, HH, ZZ} = StructureAlgorithm[f, G, h, x, t]\)], "Input",
  CellLabel->"In[91]:=",
  CellTags->{"Dynamic Inverse", "i:21", "b:32.3"}],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{
        RowBox[{"{", 
          RowBox[{\({1, 0}\), ",", 
            RowBox[{"{", 
              RowBox[{"0", ",", 
                RowBox[{
                  SuperscriptBox["y1", "\[Prime]",
                    MultilineFunction->None], "[", "t", "]"}]}], "}"}]}], 
          "}"}], ",", \({0, x4}\), 
        ",", \({{1, 0, 0, 0}, {0, 0, \(-x4\), 1}}\), ",", 
        RowBox[{"{", 
          RowBox[{
            RowBox[{
              SuperscriptBox["y1", "\[Prime]",
                MultilineFunction->None], "[", "t", "]"}], ",", 
            RowBox[{
              RowBox[{\(-x4\), " ", 
                RowBox[{
                  SuperscriptBox["y1", "\[Prime]\[Prime]",
                    MultilineFunction->None], "[", "t", "]"}]}], "+", 
              RowBox[{
                SuperscriptBox["y2", "\[Prime]\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}]}]}], "}"}]}], 
      "}"}]], "Output",
  CellLabel->"Out[91]=",
  CellTags->{"Dynamic Inverse", "i:21", "b:32.3"}]
}, Open  ]],

Cell["The dynamic inverse is defined by f+Gu where:", "Text",
  CellTags->{"Dynamic Inverse", "i:21", "b:32.3"}],

Cell[CellGroupData[{

Cell[BoxData[
    \(u = RightInverse[DD] . \((\(-CC\) + ZZ)\)\)], "Input",
  CellLabel->"In[92]:=",
  CellTags->{"Dynamic Inverse", "i:21", "b:32.3"}],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{
        RowBox[{
          SuperscriptBox["y1", "\[Prime]",
            MultilineFunction->None], "[", "t", "]"}], ",", 
        FractionBox[
          RowBox[{\(-x4\), "-", 
            RowBox[{"x4", " ", 
              RowBox[{
                SuperscriptBox["y1", "\[Prime]\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}]}], "+", 
            RowBox[{
              SuperscriptBox["y2", "\[Prime]\[Prime]",
                MultilineFunction->None], "[", "t", "]"}]}], 
          RowBox[{
            SuperscriptBox["y1", "\[Prime]",
              MultilineFunction->None], "[", "t", "]"}]]}], "}"}]], "Output",
  CellLabel->"Out[92]=",
  CellTags->{"Dynamic Inverse", "i:21", "b:32.3"}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(f + G . u\)], "Input",
  CellLabel->"In[93]:=",
  CellTags->{"Dynamic Inverse", "i:21", "b:32.3"}],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{
        RowBox[{
          SuperscriptBox["y1", "\[Prime]",
            MultilineFunction->None], "[", "t", "]"}], ",", 
        RowBox[{"x3", "+", 
          RowBox[{"x4", " ", 
            RowBox[{
              SuperscriptBox["y1", "\[Prime]",
                MultilineFunction->None], "[", "t", "]"}]}]}], ",", "x4", ",",
         
        FractionBox[
          RowBox[{\(-x4\), "-", 
            RowBox[{"x4", " ", 
              RowBox[{
                SuperscriptBox["y1", "\[Prime]\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}]}], "+", 
            RowBox[{
              SuperscriptBox["y2", "\[Prime]\[Prime]",
                MultilineFunction->None], "[", "t", "]"}]}], 
          RowBox[{
            SuperscriptBox["y1", "\[Prime]",
              MultilineFunction->None], "[", "t", "]"}]]}], "}"}]], "Output",
  CellLabel->"Out[93]=",
  CellTags->{"Dynamic Inverse", "i:21", "b:32.3"}]
}, Open  ]],

Cell["Dynamic extension can also be used to construct the inverse.", "Text",
  CellTags->{"Dynamic Inverse", "i:21", "b:32.3"}],

Cell[CellGroupData[{

Cell[BoxData[
    \(IOLinearize[f, G, h, x]\)], "Input",
  CellLabel->"In[94]:=",
  CellTags->{"Dynamic Inverse", "i:21", "b:32.3"}],

Cell[BoxData[
    \("Computing Decoupling Matrix"\)], "Print",
  CellLabel->"From In[94]:=",
  CellTags->{"Dynamic Inverse", "i:21", "b:32.3"}],

Cell[BoxData[
    \("Decoupling matrix is singular!"\)], "Print",
  CellLabel->"From In[94]:=",
  CellTags->{"Dynamic Inverse", "i:21", "b:32.3"}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \({fnew, Gnew, hnew, xnew} = DynamicExtension[f, G, h, x]\)], "Input",
  CellLabel->"In[95]:=",
  CellTags->{"Dynamic Inverse", "i:21", "b:32.3"}],

Cell[BoxData[
    \("Dynamic extension completed"\)], "Print",
  CellLabel->"From In[95]:=",
  CellTags->{"Dynamic Inverse", "i:21", "b:32.3"}],

Cell[BoxData[
    \({{z1, x3 + x4\ z1, x4, 0, 
        0}, {{0, 0}, {0, 0}, {0, 0}, {0, 1}, {1, 0}}, {x1, x2}, {x1, x2, x3, 
        x4, z1}}\)], "Output",
  CellLabel->"Out[95]=",
  CellTags->{"Dynamic Inverse", "i:21", "b:32.3"}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \({rho, alpha, r0, u} = IOLinearize[fnew, Gnew, hnew, xnew]\)], "Input",
  CellLabel->"In[96]:=",
  CellTags->{"Dynamic Inverse", "i:21", "b:32.3"}],

Cell[BoxData[
    \("Computing Decoupling Matrix"\)], "Print",
  CellLabel->"From In[96]:=",
  CellTags->{"Dynamic Inverse", "i:21", "b:32.3"}],

Cell[BoxData[
    \("Computing linearizing/decoupling control"\)], "Print",
  CellLabel->"From In[96]:=",
  CellTags->{"Dynamic Inverse", "i:21", "b:32.3"}],

Cell[BoxData[
    \({{{1, 0}, {x4, z1}}, {0, x4}, {2, 
        2}, {v1, \(v2 - x4\)\/z1 - \(v1\ x4\)\/z1}}\)], "Output",
  CellLabel->"Out[96]=",
  CellTags->{"Dynamic Inverse", "i:21", "b:32.3"}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
    \(\(u = \((u /. {v1 -> D[y1[t], {t, r0[\([1]\)]}], 
              v2 -> D[y2[t], {t, r0[\([2]\)]}]})\);\)\), "\n", 
    \(\((fnew + Gnew . u)\) // MatrixForm\)}], "Input",
  CellLabel->"In[97]:=",
  CellTags->{"Dynamic Inverse", "i:21", "b:32.3"}],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"(", "\[NoBreak]", GridBox[{
            {"z1"},
            {\(x3 + x4\ z1\)},
            {"x4"},
            {
              RowBox[{
                RowBox[{"-", 
                  FractionBox[
                    RowBox[{"x4", " ", 
                      RowBox[{
                        SuperscriptBox["y1", "\[Prime]\[Prime]",
                          MultilineFunction->None], "[", "t", "]"}]}], 
                    "z1"]}], "+", 
                FractionBox[
                  RowBox[{\(-x4\), "+", 
                    RowBox[{
                      SuperscriptBox["y2", "\[Prime]\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}], 
                  "z1"]}]},
            {
              RowBox[{
                SuperscriptBox["y1", "\[Prime]\[Prime]",
                  MultilineFunction->None], "[", "t", "]"}]}
            }], "\[NoBreak]", ")"}],
      MatrixForm[ {z1, 
        Plus[ x3, 
          Times[ x4, z1]], x4, 
        Plus[ 
          Times[ -1, x4, 
            Power[ z1, -1], 
            Derivative[ 2][ y1][ t]], 
          Times[ 
            Power[ z1, -1], 
            Plus[ 
              Times[ -1, x4], 
              Derivative[ 2][ y2][ t]]]], 
        Derivative[ 2][ y1][ t]}]]], "Output",
  CellLabel->"Out[98]//MatrixForm=",
  CellTags->{"Dynamic Inverse", "i:21", "b:32.3"}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Adaptive Control", "Section",
  Evaluatable->False,
  AspectRatioFixed->True,
  CellTags->{"Adaptive Control", "i:22"}],

Cell[CellGroupData[{

Cell["Adaptive Regulation", "Subsection",
  Evaluatable->False,
  CellTags->{"Adaptive Control", "i:22", "b:33.0"}],

Cell["\<\
We will illustrate adaptive regulation using the following example (adapted \
from Isidori). \
\>", "Text",
  Evaluatable->False,
  CellTags->{"Adaptive Control", "i:22", "b:33.0"}],

Cell[BoxData[{
    \(\(var32 := {x1, x2, x3};\)\), "\n", 
    \(\(f32 := {0, \ x1\  + \ x2^2, \ theta*x1\  - \ x2};\)\), "\n", 
    \(\(g32 := {Exp[x2], Exp[x2], 0};\)\), "\n", 
    \(\(h32 := {x3};\)\), "\n", 
    \(\(p32 := {Sin[x1], 0, Exp[x2]};\)\)}], "Input",
  CellLabel->"In[99]:=",
  CellTags->{"Adaptive Control", "i:22", "b:33.0"}],

Cell["\<\
First, we need to specify the desired closed loop pole locations. It is \
necessary to do this in groups according to the vector relative degree:\
\>", "Text",
  Evaluatable->False,
  CellTags->{"Adaptive Control", "i:22", "b:33.0"}],

Cell[CellGroupData[{

Cell[BoxData[
    \(ro = VectorRelativeOrder[f32, g32, h32, var32]\)], "Input",
  CellLabel->"In[104]:=",
  PageWidth->Infinity,
  AspectRatioFixed->True,
  FontFamily->"Courier New",
  FontSize->12,
  FontWeight->"Bold",
  FontColor->GrayLevel[0],
  Background->GrayLevel[1],
  CellTags->{"Adaptive Control", "i:22", "b:33.0"}],

Cell[BoxData[
    \({2}\)], "Output",
  CellLabel->"Out[104]=",
  CellTags->{"Adaptive Control", "i:22", "b:33.0"}]
}, Open  ]],

Cell[BoxData[
    \(\(Poles = {{\(-2\), \(-2\)}};\)\)], "Input",
  CellLabel->"In[105]:=",
  PageWidth->Infinity,
  AspectRatioFixed->True,
  FontFamily->"Courier New",
  FontSize->12,
  FontWeight->"Bold",
  FontColor->GrayLevel[0],
  Background->GrayLevel[1],
  CellTags->{"Adaptive Control", "i:22", "b:33.0"}],

Cell["Now, compute the adaptive control", "Text",
  Evaluatable->False,
  CellTags->{"Adaptive Control", "i:22", "b:33.0"}],

Cell[CellGroupData[{

Cell[BoxData[
    \(AdaptiveRegulator[f32, g32, h32, var32, t, {theta}, {}, 
      Poles]\)], "Input",
  CellLabel->"In[106]:=",
  PageWidth->Infinity,
  AspectRatioFixed->True,
  FontFamily->"Courier New",
  FontSize->12,
  FontWeight->"Bold",
  FontColor->GrayLevel[0],
  Background->GrayLevel[1],
  CellTags->{"Adaptive Control", "i:22", "b:33.0"}],

Cell[BoxData[
    \("Computing Decoupling Matrix"\)], "Print",
  CellLabel->"From In[106]:=",
  CellTags->{"Adaptive Control", "i:22", "b:33.0"}],

Cell[BoxData[
    \("Computing linearizing/decoupling control"\)], "Print",
  CellLabel->"From In[106]:=",
  CellTags->{"Adaptive Control", "i:22", "b:33.0"}],

Cell[BoxData[
    \("Finished Linearizing Control"\)], "Print",
  CellLabel->"From In[106]:=",
  CellTags->{"Adaptive Control", "i:22", "b:33.0"}],

Cell[BoxData[
    InterpretationBox[\("New Parameters =  "\[InvisibleSpace]{theta}\),
      SequenceForm[ "New Parameters =  ", {theta}],
      Editable->False]], "Print",
  CellLabel->"From In[106]:=",
  CellTags->{"Adaptive Control", "i:22", "b:33.0"}],

Cell[BoxData[
    \("Finished Stabilizing Control"\)], "Print",
  CellLabel->"From In[106]:=",
  CellTags->{"Adaptive Control", "i:22", "b:33.0"}],

Cell[BoxData[
    \("Finished regressor computation"\)], "Print",
  CellLabel->"From In[106]:=",
  CellTags->{"Adaptive Control", "i:22", "b:33.0"}],

Cell[BoxData[
    \("Finished Liapunov Equation"\)], "Print",
  CellLabel->"From In[106]:=",
  CellTags->{"Adaptive Control", "i:22", "b:33.0"}],

Cell[BoxData[
    \("Finished parameter update law"\)], "Print",
  CellLabel->"From In[106]:=",
  CellTags->{"Adaptive Control", "i:22", "b:33.0"}],

Cell[BoxData[
    \({{theta}, {thetahat1}, {\(125.`\ "AdaptGain1"\ \[ExponentialE]\^x2\ z1\ \
\((x1 + x2\^2 - 4\ z1 - 4\ z2)\)\)\/\(\(-\[ExponentialE]\^x2\) + \
\[ExponentialE]\^x2\ thetahat1\) + \(156.25`\ "AdaptGain1"\ \
\[ExponentialE]\^x2\ \((x1 + x2\^2 - 4\ z1 - 4\ z2)\)\ z2\)\/\(\(-\
\[ExponentialE]\^x2\) + \[ExponentialE]\^x2\ thetahat1\)}, {\(x1 + x2\^2 - 4\ \
z1 - 4\ z2\)\/\(\(-\[ExponentialE]\^x2\) + \[ExponentialE]\^x2\ thetahat1\)}}\
\)], "Output",
  CellLabel->"Out[106]=",
  CellTags->{"Adaptive Control", "i:22", "b:33.0"}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["AdaptiveRegulation via Backstepping", "Subsection",
  CellTags->{"Adaptive Control", "i:4", "b:33.1"}],

Cell["\<\
TSi Controls implements tool for designing adaptive controllers for SISO \
systems via backstepping. Backstepping can be applied to systems that are in \
parametric-strict-feedback-form (PSFF) or parametric-pure-feedback-form \
(PPFF). Methods exist to test a given system to determine if it can be \
transformed to PSFF and to determine the required transformation if it can \
be. The functions PSFFCond and PSFFSolve provide an implementation of these \
constructions. The function AdaptBackstepReg computes the adaptive regulator \
for a system in PSFF.

Once again, consider example 30 from above. The function PSFFSolve tests to \
see if the system can be placed in PSFF and if, so generates the transformed \
system.\
\>", "Text",
  Evaluatable->False,
  FontFamily->"Times New Roman",
  FontSize->12,
  FontWeight->"Plain",
  FontSlant->"Plain",
  FontTracking->"Plain",
  FontColor->GrayLevel[0],
  Background->GrayLevel[1],
  FontVariations->{"Underline"->False,
  "Outline"->False,
  "Shadow"->False},
  CellTags->{"Adaptive Control", "i:4", "b:33.1"}],

Cell[BoxData[{
    \(\(f30 = {theta\ x1\^3 + x2, x3, 0};\)\), "\n", 
    \(\(g30 = {0, 0, 1};\)\)}], "Input",
  CellLabel->"In[107]:=",
  PageWidth->Infinity,
  AspectRatioFixed->True,
  FontFamily->"Courier New",
  FontSize->12,
  FontWeight->"Bold",
  FontColor->GrayLevel[0],
  Background->GrayLevel[1],
  CellTags->{"Adaptive Control", "i:4", "b:33.1"}],

Cell[CellGroupData[{

Cell[BoxData[
    \(Information["\<PSFFSolve\>", LongForm \[Rule] False]\)], "Input",
  CellLabel->"In[109]:=",
  PageWidth->Infinity,
  FontFamily->"Courier New",
  FontSize->12,
  FontWeight->"Bold",
  FontColor->GrayLevel[0],
  Background->GrayLevel[1],
  CellTags->{"Adaptive Control", "i:4", "b:33.1"}],

Cell[BoxData[
    \("PSFFSolve[f,g,var,para] computes the diffeomorphism\n required to \
transform a single-input nonlinear system {f,g} with\n parameter {para} to a \
Parametric Strict Feedback Form. It first \n checks whether such coordinate \
change exists by checking the necessary\n and sufficient geometric \
conditions. It returns the transformation, and\n the new vector fields \
{fnew,gnew} describing the original system in the\n PSFF form.\n"\)], "Print",\

  CellTags->{
  "Info3266691090-8486293", "i:3", "i:4", "b:33.1", "Adaptive Control"}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(PSFFSolve[f30, g30, {x1, x2, x3}, {theta}]\)], "Input",
  CellLabel->"In[110]:=",
  PageWidth->Infinity,
  AspectRatioFixed->True,
  FontFamily->"Courier New",
  FontSize->12,
  FontWeight->"Bold",
  FontColor->GrayLevel[0],
  Background->GrayLevel[1],
  CellTags->{"Adaptive Control", "i:4", "b:33.1"}],

Cell[BoxData[
    InterpretationBox[\("Feedback Linearization Condition = \
"\[InvisibleSpace]True\),
      SequenceForm[ "Feedback Linearization Condition = ", True],
      Editable->False]], "Print",
  CellLabel->"From In[110]:=",
  CellTags->{"Adaptive Control", "i:4", "b:33.1"}],

Cell[BoxData[
    InterpretationBox[\("1st Parametric Strict Feedback Condition = "\
\[InvisibleSpace]True\),
      SequenceForm[ "1st Parametric Strict Feedback Condition = ", True],
      Editable->False]], "Print",
  CellLabel->"From In[110]:=",
  CellTags->{"Adaptive Control", "i:4", "b:33.1"}],

Cell[BoxData[
    InterpretationBox[\("2nd Parametric Strict Feedback Condition = "\
\[InvisibleSpace]True\),
      SequenceForm[ "2nd Parametric Strict Feedback Condition = ", True],
      Editable->False]], "Print",
  CellLabel->"From In[110]:=",
  CellTags->{"Adaptive Control", "i:4", "b:33.1"}],

Cell[BoxData[
    \("Computing Parametric-Strict-Feedback Form\n"\)], "Print",
  CellLabel->"From In[110]:=",
  CellTags->{"Adaptive Control", "i:4", "b:33.1"}],

Cell[BoxData[
    InterpretationBox[\("Linearizing Output Solutions: "\[InvisibleSpace]{x1}\
\),
      SequenceForm[ "Linearizing Output Solutions: ", {x1}],
      Editable->False]], "Print",
  CellLabel->"From In[110]:=",
  CellTags->{"Adaptive Control", "i:4", "b:33.1"}],

Cell[BoxData[
    InterpretationBox[\("PSFF Transformation z=T("\[InvisibleSpace]{x1, x2, 
          x3}\[InvisibleSpace]"):\n"\),
      SequenceForm[ "PSFF Transformation z=T(", {x1, x2, x3}, "):\n"],
      Editable->False]], "Print",
  CellLabel->"From In[110]:=",
  CellTags->{"Adaptive Control", "i:4", "b:33.1"}],

Cell[BoxData[
    InterpretationBox[\("         "\[InvisibleSpace]z1\[InvisibleSpace]" =  "\
\[InvisibleSpace]x1\),
      SequenceForm[ "         ", z1, " =  ", x1],
      Editable->False]], "Print",
  CellLabel->"From In[110]:=",
  CellTags->{"Adaptive Control", "i:4", "b:33.1"}],

Cell[BoxData[
    InterpretationBox[\("         "\[InvisibleSpace]z2\[InvisibleSpace]" =  "\
\[InvisibleSpace]x2\),
      SequenceForm[ "         ", z2, " =  ", x2],
      Editable->False]], "Print",
  CellLabel->"From In[110]:=",
  CellTags->{"Adaptive Control", "i:4", "b:33.1"}],

Cell[BoxData[
    InterpretationBox[\("         "\[InvisibleSpace]z3\[InvisibleSpace]" =  "\
\[InvisibleSpace]x3\),
      SequenceForm[ "         ", z3, " =  ", x3],
      Editable->False]], "Print",
  CellLabel->"From In[110]:=",
  CellTags->{"Adaptive Control", "i:4", "b:33.1"}],

Cell[BoxData[
    \({{x1, x2, x3}, {theta\ z1\^3 + z2, z3, 0}, {0, 0, 1}}\)], "Output",
  CellLabel->"Out[110]=",
  CellTags->{"Adaptive Control", "i:4", "b:33.1"}]
}, Open  ]],

Cell["\<\
In fact, we see that the transformation is an identity and that the system \
was in PSFF to begin with. Now, we design an adaptive regulator:\
\>", "Text",
  Evaluatable->False,
  FontFamily->"Times New Roman",
  FontSize->12,
  FontWeight->"Plain",
  FontSlant->"Plain",
  FontTracking->"Plain",
  FontColor->GrayLevel[0],
  Background->GrayLevel[1],
  FontVariations->{"Underline"->False,
  "Outline"->False,
  "Shadow"->False},
  CellTags->{"Adaptive Control", "i:4", "b:33.1"}],

Cell[CellGroupData[{

Cell[BoxData[
    \(Information["\<AdaptiveBackstepRegulator\>", 
      LongForm \[Rule] False]\)], "Input",
  CellLabel->"In[111]:=",
  PageWidth->Infinity,
  AspectRatioFixed->True,
  FontFamily->"Courier New",
  FontSize->12,
  FontWeight->"Bold",
  FontColor->GrayLevel[0],
  Background->GrayLevel[1],
  CellTags->{"Adaptive Control", "i:4", "b:33.1"}],

Cell[BoxData[
    \("AdaptiveBackstepRegulator[f,g,x,Theta,AdGain,Cs] gives adaptive  \
control law and parameter update laws based on adaptive  backstepping \
regulator design method.  Calling Syntax: \
{r1,r2,r3}=AdaptiveBackstepRegulator[f,g,x,Theta,AdGain,Cs];\n r1=control law \
u(x,Thetahat)\n r2=p-vector of rhs of parameter update law\n r3=n-vector of Z \
coordinates defined as a function of (x,Thetahat).\n "\)], "Print",
  CellTags->{"Info3266691090-6166343", "i:4", "b:33.1", "Adaptive Control"}]
}, Open  ]],

Cell[BoxData[
    \(\({r1, r2, r3} = 
        AdaptiveBackstepRegulator[f30, g30, 
          var30, {theta}, {{AdGain}}, {c1, c2, c3}];\)\)], "Input",
  CellLabel->"In[112]:=",
  PageWidth->Infinity,
  AspectRatioFixed->True,
  FontFamily->"Courier New",
  FontSize->12,
  FontWeight->"Bold",
  FontColor->GrayLevel[0],
  Background->GrayLevel[1],
  CellTags->{"Adaptive Control", "i:4", "b:33.1"}],

Cell[CellGroupData[{

Cell[BoxData[
    \(r1\)], "Input",
  CellLabel->"In[113]:=",
  PageWidth->Infinity,
  CellTags->{"Adaptive Control", "i:4", "b:33.1"}],

Cell[BoxData[
    \(\(-c1\)\ x1 - thetahat1\ x1\^3 - x2 - 
      x2\ \((1 + 3\ c2\ thetahat1\ x1\^2 + 15\ thetahat1\^2\ x1\^4 + 
            7\ AdGain\ x1\^6 + 7\ AdGain\ c1\^2\ x1\^6 + 
            33\ AdGain\ thetahat1\^2\ x1\^10 + 6\ thetahat1\ x1\ x2 + 
            24\ AdGain\ thetahat1\ x1\^7\ x2 + 
            c1\ \((c2 + 3\ thetahat1\ x1\^2 + 36\ AdGain\ thetahat1\ x1\^8 + 
                  6\ AdGain\ x1\^5\ x2)\))\) - 
      x1\^3\ \((thetahat1 + AdGain\ thetahat1\ x1\^6 + 
            AdGain\ x1\^3\ \((c1\ x1 + x2)\))\)\ \((1 + 
            3\ c2\ thetahat1\ x1\^2 + 15\ thetahat1\^2\ x1\^4 + 
            7\ AdGain\ x1\^6 + 7\ AdGain\ c1\^2\ x1\^6 + 
            33\ AdGain\ thetahat1\^2\ x1\^10 + 6\ thetahat1\ x1\ x2 + 
            24\ AdGain\ thetahat1\ x1\^7\ x2 + 
            c1\ \((c2 + 3\ thetahat1\ x1\^2 + 36\ AdGain\ thetahat1\ x1\^8 + 
                  6\ AdGain\ x1\^5\ x2)\))\) - \((c1 + c2 + 
            AdGain\ c1\ x1\^6 + 
            3\ thetahat1\ x1\^2\ \((1 + AdGain\ x1\^6)\))\)\ x3 - 
      c3\ \((x1 + c1\ c2\ x1 + \((c1 + c2)\)\ thetahat1\ x1\^3 + 
            3\ thetahat1\^2\ x1\^5 + AdGain\ \((1 + c1\^2)\)\ x1\^7 + 
            4\ AdGain\ c1\ thetahat1\ x1\^9 + 
            3\ AdGain\ thetahat1\^2\ x1\^11 + c1\ x2 + c2\ x2 + 
            3\ thetahat1\ x1\^2\ x2 + AdGain\ c1\ x1\^6\ x2 + 
            3\ AdGain\ thetahat1\ x1\^8\ x2 + x3)\) - 
      AdGain\ x1\^5\ \((c2\ x1 + c1\ \((x1 + 4\ AdGain\ x1\^7)\) + 
            3\ \((1 + AdGain\ x1\^6)\)\ \((2\ thetahat1\ x1\^3 + 
                  x2)\))\)\ \((x1 + \((c1 + 
                  3\ thetahat1\ x1\^2)\)\ \((c1\ x1 + thetahat1\ x1\^3 + 
                  x2)\) + \((1 + 3\ c2\ thetahat1\ x1\^2 + 
                  15\ thetahat1\^2\ x1\^4 + 7\ AdGain\ x1\^6 + 
                  7\ AdGain\ c1\^2\ x1\^6 + 
                  33\ AdGain\ thetahat1\^2\ x1\^10 + 6\ thetahat1\ x1\ x2 + 
                  24\ AdGain\ thetahat1\ x1\^7\ x2 + 
                  c1\ \((c2 + 3\ thetahat1\ x1\^2 + 
                        36\ AdGain\ thetahat1\ x1\^8 + 
                        6\ AdGain\ x1\^5\ x2)\))\)\ \((x1 + 
                  c1\ c2\ x1 + \((c1 + c2)\)\ thetahat1\ x1\^3 + 
                  3\ thetahat1\^2\ x1\^5 + AdGain\ \((1 + c1\^2)\)\ x1\^7 + 
                  4\ AdGain\ c1\ thetahat1\ x1\^9 + 
                  3\ AdGain\ thetahat1\^2\ x1\^11 + c1\ x2 + c2\ x2 + 
                  3\ thetahat1\ x1\^2\ x2 + AdGain\ c1\ x1\^6\ x2 + 
                  3\ AdGain\ thetahat1\ x1\^8\ x2 + x3)\))\)\)], "Output",
  CellLabel->"Out[113]=",
  CellTags->{"Adaptive Control", "i:4", "b:33.1"}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(r2\)], "Input",
  CellLabel->"In[114]:=",
  PageWidth->Infinity,
  CellTags->{"Adaptive Control", "i:4", "b:33.1"}],

Cell[BoxData[
    \({AdGain\ x1\^3\ \((x1 + \((c1 + 3\ thetahat1\ x1\^2)\)\ \((c1\ x1 + 
                  thetahat1\ x1\^3 + x2)\) + \((1 + 3\ c2\ thetahat1\ x1\^2 + 
                  15\ thetahat1\^2\ x1\^4 + 7\ AdGain\ x1\^6 + 
                  7\ AdGain\ c1\^2\ x1\^6 + 
                  33\ AdGain\ thetahat1\^2\ x1\^10 + 6\ thetahat1\ x1\ x2 + 
                  24\ AdGain\ thetahat1\ x1\^7\ x2 + 
                  c1\ \((c2 + 3\ thetahat1\ x1\^2 + 
                        36\ AdGain\ thetahat1\ x1\^8 + 
                        6\ AdGain\ x1\^5\ x2)\))\)\ \((x1 + 
                  c1\ c2\ x1 + \((c1 + c2)\)\ thetahat1\ x1\^3 + 
                  3\ thetahat1\^2\ x1\^5 + AdGain\ \((1 + c1\^2)\)\ x1\^7 + 
                  4\ AdGain\ c1\ thetahat1\ x1\^9 + 
                  3\ AdGain\ thetahat1\^2\ x1\^11 + c1\ x2 + c2\ x2 + 
                  3\ thetahat1\ x1\^2\ x2 + AdGain\ c1\ x1\^6\ x2 + 
                  3\ AdGain\ thetahat1\ x1\^8\ x2 + x3)\))\)}\)], "Output",
  CellLabel->"Out[114]=",
  CellTags->{"Adaptive Control", "i:4", "b:33.1"}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(r3\)], "Input",
  CellLabel->"In[115]:=",
  PageWidth->Infinity,
  CellTags->{"Adaptive Control", "i:4", "b:33.1"}],

Cell[BoxData[
    \({x1, c1\ x1 + thetahat1\ x1\^3 + x2, 
      x1 - thetahat1\ x1\^3\ \((\(-c1\) - 
              3\ thetahat1\ x1\^2)\) - \((\(-c1\) - 
              3\ thetahat1\ x1\^2)\)\ x2 + 
        c2\ \((c1\ x1 + thetahat1\ x1\^3 + x2)\) + 
        x1\^3\ \((AdGain\ x1\^4 - 
              AdGain\ x1\^3\ \((\(-c1\) - 3\ thetahat1\ x1\^2)\)\ \((c1\ x1 + 
                    thetahat1\ x1\^3 + x2)\))\) + x3}\)], "Output",
  CellLabel->"Out[115]=",
  CellTags->{"Adaptive Control", "i:4", "b:33.1"}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Adaptive Tracking", "Subsection",
  Evaluatable->False,
  CellTags->{"Adaptive Control", "i:22", "b:33.2"}],

Cell["\<\
Adaptive tracking control can also be illustrated using the following example \
(from Ghanadan and Blankenship).\
\>", "Text",
  Evaluatable->False,
  AspectRatioFixed->True,
  CellTags->{"Adaptive Control", "i:22", "b:33.2"}],

Cell[BoxData[{
    \(\(\(f14 := {x2, \n\ \ \ \ \ \ \ \ 0, \n\ \ \ \ \ \ \ \ 0, \n\ \ \ \ \ \ \
\ \ \((\(-theta\))\)*Sin[x1]^2 + 
            x3*Cos[x1], \n\ \ \ \ \ \ \ \ \((theta/2)\)\ Sin[2\ x1] + \ 
            x3\ Sin[x1]};\)\(\n\)
    \)\), "\n", 
    \(\(g14 := Transpose[{{0, 0, 1, 0, 0}, {0, 1, 0, 0, 0}}];\)\), "\n", 
    \(\(h14 := {x4, x5};\)\), "\n", 
    \(\(\(var14 := {x1, x2, x3, x4, x5};\)\(\n\)
    \)\)}], "Input",
  CellLabel->"In[116]:=",
  CellTags->{"Adaptive Control", "i:22", "b:33.2"}],

Cell["First define a reference signal:", "Text",
  Evaluatable->False,
  AspectRatioFixed->True,
  CellTags->{"Adaptive Control", "i:22", "b:33.2"}],

Cell[CellGroupData[{

Cell[BoxData[
    \(RefSig = 
      Table[ToExpression["\<yd\>" <> ToString[i1] <> "\<[t]\>"], {i1, 1, 
          Length[h14]}]\)], "Input",
  CellLabel->"In[120]:=",
  PageWidth->Infinity,
  AspectRatioFixed->True,
  CellTags->{"Adaptive Control", "i:22", "b:33.2"}],

Cell[BoxData[
    \({yd1[t], yd2[t]}\)], "Output",
  CellLabel->"Out[120]=",
  CellTags->{"Adaptive Control", "i:22", "b:33.2"}]
}, Open  ]],

Cell["Specify the desired closed loop pole locations:", "Text",
  Evaluatable->False,
  AspectRatioFixed->True,
  CellTags->{"Adaptive Control", "i:22", "b:33.2"}],

Cell[BoxData[
    \(\(Poles = {{\(-1\), \(-2\)}, {\(-1\), \(-2\), \(-2\)}};\)\)], "Input",
  CellLabel->"In[121]:=",
  PageWidth->Infinity,
  AspectRatioFixed->True,
  CellTags->{"Adaptive Control", "i:22", "b:33.2"}],

Cell["Now, compute the adaptive controller.", "Text",
  Evaluatable->False,
  AspectRatioFixed->True,
  CellTags->{"Adaptive Control", "i:22", "b:33.2"}],

Cell[CellGroupData[{

Cell[BoxData[
    \(AdaptiveTracking[f14, g14, h14, var14, t, {theta}, RefSig, {}, 
      Poles]\)], "Input",
  CellLabel->"In[122]:=",
  PageWidth->Infinity,
  AspectRatioFixed->True,
  CellTags->{"Adaptive Control", "i:22", "b:33.2"}],

Cell[BoxData[
    \("Finished StructureAlgorithm"\)], "Print",
  CellLabel->"From In[122]:=",
  CellTags->{"Adaptive Control", "i:22", "b:33.2"}],

Cell[BoxData[
    InterpretationBox[\("Thetabar2 =  "\[InvisibleSpace]{theta}\),
      SequenceForm[ "Thetabar2 =  ", {theta}],
      Editable->False]], "Print",
  CellLabel->"From In[122]:=",
  CellTags->{"Adaptive Control", "i:22", "b:33.2"}],

Cell[BoxData[
    \("Computing control"\)], "Print",
  CellLabel->"From In[122]:=",
  CellTags->{"Adaptive Control", "i:22", "b:33.2"}],

Cell[BoxData[
    \("Computing parameter update law"\)], "Print",
  CellLabel->"From In[122]:=",
  CellTags->{"Adaptive Control", "i:22", "b:33.2"}],

Cell[BoxData[
    \("Substituting reference output into control"\)], "Print",
  CellLabel->"From In[122]:=",
  CellTags->{"Adaptive Control", "i:22", "b:33.2"}],

Cell[BoxData[
    \("Substituting reference output into parameter update law"\)], "Print",
  CellLabel->"From In[122]:=",
  CellTags->{"Adaptive Control", "i:22", "b:33.2"}],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{\({theta}\), ",", \({thetahat1}\), ",", 
        RowBox[{"{", 
          
          RowBox[{\(500.`\ "AdaptGain1"\ x2\ Cos[x1]\ Sin[
                x1]\ \((\(-x4\) + yd1[t])\)\), "+", 
            RowBox[{
            "500.`", " ", "\<\"AdaptGain1\"\>", " ", "x2", " ", \(Cos[x1]\), 
              " ", \(Sin[x1]\), " ", 
              RowBox[{"(", 
                RowBox[{
                  RowBox[{"-", 
                    RowBox[{
                      SuperscriptBox["y1", "\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}], "+", 
                  RowBox[{
                    SuperscriptBox["yd1", "\[Prime]",
                      MultilineFunction->None], "[", "t", "]"}]}], ")"}]}], 
            "-", 
            RowBox[{
            "125.`", " ", "\<\"AdaptGain1\"\>", " ", \((\(-x5\) + yd2[t])\), 
              " ", 
              RowBox[{"(", 
                RowBox[{\(\(-2\)\ x2\^2\ Tan[x1]\), "-", 
                  RowBox[{
                    RowBox[{"(", 
                      RowBox[{"x2", " ", \((thetahat1 + x3\ Sec[x1])\), " ", 
                        RowBox[{"(", 
                          
                          RowBox[{\(x2\ x3\ Sin[x1]\), 
                            "+", \(2\ thetahat1\ x2\ Cos[x1]\ Sin[x1]\), 
                            "+", \(2\ \((\(-x4\) + yd1[t])\)\), "+", 
                            RowBox[{"3", " ", 
                              RowBox[{"(", 
                                RowBox[{
                                  RowBox[{"-", 
                                    RowBox[{
                                      SuperscriptBox["y1", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                      "]"}]}], "+", 
                                  RowBox[{
                                    SuperscriptBox["yd1", "\[Prime]",
                                      MultilineFunction->None], "[", "t", 
                                    "]"}]}], ")"}]}], "+", 
                            RowBox[{
                              SuperscriptBox["yd1", "\[Prime]\[Prime]",
                                MultilineFunction->None], "[", "t", "]"}]}], 
                          ")"}]}], ")"}], 
                    "/", \((\(-x2\^2\) + 
                        Cos[x1]\^2\ \((x2\^2\ Sec[x1]\^2 + \((thetahat1 + x3\ \
Sec[x1])\)\^2)\))\)}], "+", 
                  RowBox[{
                    RowBox[{"(", 
                      
                      RowBox[{\(Cos[x1]\^2\), 
                        " ", \((thetahat1 + x3\ Sec[x1])\), " ", 
                        RowBox[{"(", 
                          
                          RowBox[{\(\(-x2\^2\)\ x3\ Sec[x1]\ Tan[x1]\), 
                            "+", \(4\ \((\(-x5\) + yd2[t])\)\), "+", 
                            RowBox[{"8", " ", 
                              RowBox[{"(", 
                                RowBox[{
                                  RowBox[{"-", 
                                    RowBox[{
                                      SuperscriptBox["y2", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                      "]"}]}], "+", 
                                  RowBox[{
                                    SuperscriptBox["yd2", "\[Prime]",
                                      MultilineFunction->None], "[", "t", 
                                    "]"}]}], ")"}]}], "-", 
                            RowBox[{"x2", " ", \(Sec[x1]\^2\), " ", 
                              RowBox[{"(", 
                                RowBox[{\(2\ \((\(-x4\) + yd1[t])\)\), "+", 
                                  RowBox[{"3", " ", 
                                    RowBox[{"(", 
                                      RowBox[{
                                        RowBox[{"-", 
                                        RowBox[{
                                        SuperscriptBox["y1", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}]}], "+", 
                                        RowBox[{
                                        SuperscriptBox["yd1", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}]}], ")"}]}], "+", 
                                  RowBox[{
                                    SuperscriptBox["yd1", "\[Prime]\[Prime]",
                                      MultilineFunction->None], "[", "t", 
                                    "]"}]}], ")"}]}], "+", 
                            RowBox[{"5", " ", 
                              RowBox[{"(", 
                                RowBox[{
                                  RowBox[{"-", 
                                    RowBox[{
                                      
                                      SuperscriptBox["y2", "\[Prime]\[Prime]",
                                        
                                        MultilineFunction->None], "[", "t", 
                                      "]"}]}], "+", 
                                  RowBox[{
                                    SuperscriptBox["yd2", "\[Prime]\[Prime]",
                                      MultilineFunction->None], "[", "t", 
                                    "]"}]}], ")"}]}], "-", 
                            RowBox[{\(Tan[x1]\), " ", 
                              RowBox[{
                                SuperscriptBox["y1", 
                                  TagBox[\((3)\),
                                    Derivative],
                                  MultilineFunction->None], "[", "t", "]"}]}],
                             "+", 
                            RowBox[{
                              SuperscriptBox["yd2", 
                                TagBox[\((3)\),
                                  Derivative],
                                MultilineFunction->None], "[", "t", "]"}]}], 
                          ")"}]}], ")"}], 
                    "/", \((\(-x2\^2\) + 
                        Cos[x1]\^2\ \((x2\^2\ Sec[x1]\^2 + \((thetahat1 + x3\ \
Sec[x1])\)\^2)\))\)}]}], ")"}]}], "-", 
            RowBox[{"211.80555555555554`", " ", "\<\"AdaptGain1\"\>", " ", 
              RowBox[{"(", 
                RowBox[{
                  RowBox[{"-", 
                    RowBox[{
                      SuperscriptBox["y2", "\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}], "+", 
                  RowBox[{
                    SuperscriptBox["yd2", "\[Prime]",
                      MultilineFunction->None], "[", "t", "]"}]}], ")"}], " ",
               
              RowBox[{"(", 
                RowBox[{\(\(-2\)\ x2\^2\ Tan[x1]\), "-", 
                  RowBox[{
                    RowBox[{"(", 
                      RowBox[{"x2", " ", \((thetahat1 + x3\ Sec[x1])\), " ", 
                        RowBox[{"(", 
                          
                          RowBox[{\(x2\ x3\ Sin[x1]\), 
                            "+", \(2\ thetahat1\ x2\ Cos[x1]\ Sin[x1]\), 
                            "+", \(2\ \((\(-x4\) + yd1[t])\)\), "+", 
                            RowBox[{"3", " ", 
                              RowBox[{"(", 
                                RowBox[{
                                  RowBox[{"-", 
                                    RowBox[{
                                      SuperscriptBox["y1", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                      "]"}]}], "+", 
                                  RowBox[{
                                    SuperscriptBox["yd1", "\[Prime]",
                                      MultilineFunction->None], "[", "t", 
                                    "]"}]}], ")"}]}], "+", 
                            RowBox[{
                              SuperscriptBox["yd1", "\[Prime]\[Prime]",
                                MultilineFunction->None], "[", "t", "]"}]}], 
                          ")"}]}], ")"}], 
                    "/", \((\(-x2\^2\) + 
                        Cos[x1]\^2\ \((x2\^2\ Sec[x1]\^2 + \((thetahat1 + x3\ \
Sec[x1])\)\^2)\))\)}], "+", 
                  RowBox[{
                    RowBox[{"(", 
                      
                      RowBox[{\(Cos[x1]\^2\), 
                        " ", \((thetahat1 + x3\ Sec[x1])\), " ", 
                        RowBox[{"(", 
                          RowBox[{\(\(-x2\^2\)\ x3\ Sec[x1]\ Tan[x1]\), 
                            "+", \(4\ \((\(-x5\) + yd2[t])\)\), "+", 
                            RowBox[{"8", " ", 
                              RowBox[{"(", 
                                RowBox[{
                                  RowBox[{"-", 
                                    RowBox[{
                                      SuperscriptBox["y2", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                      "]"}]}], "+", 
                                  RowBox[{
                                    SuperscriptBox["yd2", "\[Prime]",
                                      MultilineFunction->None], "[", "t", 
                                    "]"}]}], ")"}]}], "-", 
                            RowBox[{"x2", " ", \(Sec[x1]\^2\), " ", 
                              RowBox[{"(", 
                                RowBox[{\(2\ \((\(-x4\) + yd1[t])\)\), "+", 
                                  RowBox[{"3", " ", 
                                    RowBox[{"(", 
                                      RowBox[{
                                        RowBox[{"-", 
                                        RowBox[{
                                        SuperscriptBox["y1", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}]}], "+", 
                                        RowBox[{
                                        SuperscriptBox["yd1", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}]}], ")"}]}], "+", 
                                  RowBox[{
                                    SuperscriptBox["yd1", "\[Prime]\[Prime]",
                                      MultilineFunction->None], "[", "t", 
                                    "]"}]}], ")"}]}], "+", 
                            RowBox[{"5", " ", 
                              RowBox[{"(", 
                                RowBox[{
                                  RowBox[{"-", 
                                    RowBox[{
                                      
                                      SuperscriptBox["y2", "\[Prime]\[Prime]",
                                        
                                        MultilineFunction->None], "[", "t", 
                                      "]"}]}], "+", 
                                  RowBox[{
                                    SuperscriptBox["yd2", "\[Prime]\[Prime]",
                                      MultilineFunction->None], "[", "t", 
                                    "]"}]}], ")"}]}], "-", 
                            RowBox[{\(Tan[x1]\), " ", 
                              RowBox[{
                                SuperscriptBox["y1", 
                                  TagBox[\((3)\),
                                    Derivative],
                                  MultilineFunction->None], "[", "t", "]"}]}],
                             "+", 
                            RowBox[{
                              SuperscriptBox["yd2", 
                                TagBox[\((3)\),
                                  Derivative],
                                MultilineFunction->None], "[", "t", "]"}]}], 
                          ")"}]}], ")"}], 
                    "/", \((\(-x2\^2\) + 
                        Cos[x1]\^2\ \((x2\^2\ Sec[x1]\^2 + \((thetahat1 + x3\ \
Sec[x1])\)\^2)\))\)}]}], ")"}]}], "-", 
            RowBox[{"142.36111111111111`", " ", "\<\"AdaptGain1\"\>", " ", 
              RowBox[{"(", 
                RowBox[{
                  RowBox[{"-", 
                    RowBox[{
                      SuperscriptBox["y2", "\[Prime]\[Prime]",
                        MultilineFunction->None], "[", "t", "]"}]}], "+", 
                  RowBox[{
                    SuperscriptBox["yd2", "\[Prime]\[Prime]",
                      MultilineFunction->None], "[", "t", "]"}]}], ")"}], " ",
               
              RowBox[{"(", 
                RowBox[{\(\(-2\)\ x2\^2\ Tan[x1]\), "-", 
                  RowBox[{
                    RowBox[{"(", 
                      RowBox[{"x2", " ", \((thetahat1 + x3\ Sec[x1])\), " ", 
                        RowBox[{"(", 
                          
                          RowBox[{\(x2\ x3\ Sin[x1]\), 
                            "+", \(2\ thetahat1\ x2\ Cos[x1]\ Sin[x1]\), 
                            "+", \(2\ \((\(-x4\) + yd1[t])\)\), "+", 
                            RowBox[{"3", " ", 
                              RowBox[{"(", 
                                RowBox[{
                                  RowBox[{"-", 
                                    RowBox[{
                                      SuperscriptBox["y1", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                      "]"}]}], "+", 
                                  RowBox[{
                                    SuperscriptBox["yd1", "\[Prime]",
                                      MultilineFunction->None], "[", "t", 
                                    "]"}]}], ")"}]}], "+", 
                            RowBox[{
                              SuperscriptBox["yd1", "\[Prime]\[Prime]",
                                MultilineFunction->None], "[", "t", "]"}]}], 
                          ")"}]}], ")"}], 
                    "/", \((\(-x2\^2\) + 
                        Cos[x1]\^2\ \((x2\^2\ Sec[x1]\^2 + \((thetahat1 + x3\ \
Sec[x1])\)\^2)\))\)}], "+", 
                  RowBox[{
                    RowBox[{"(", 
                      
                      RowBox[{\(Cos[x1]\^2\), 
                        " ", \((thetahat1 + x3\ Sec[x1])\), " ", 
                        RowBox[{"(", 
                          
                          RowBox[{\(\(-x2\^2\)\ x3\ Sec[x1]\ Tan[x1]\), 
                            "+", \(4\ \((\(-x5\) + yd2[t])\)\), "+", 
                            RowBox[{"8", " ", 
                              RowBox[{"(", 
                                RowBox[{
                                  RowBox[{"-", 
                                    RowBox[{
                                      SuperscriptBox["y2", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                      "]"}]}], "+", 
                                  RowBox[{
                                    SuperscriptBox["yd2", "\[Prime]",
                                      MultilineFunction->None], "[", "t", 
                                    "]"}]}], ")"}]}], "-", 
                            RowBox[{"x2", " ", \(Sec[x1]\^2\), " ", 
                              RowBox[{"(", 
                                RowBox[{\(2\ \((\(-x4\) + yd1[t])\)\), "+", 
                                  RowBox[{"3", " ", 
                                    RowBox[{"(", 
                                      RowBox[{
                                        RowBox[{"-", 
                                        RowBox[{
                                        SuperscriptBox["y1", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}]}], "+", 
                                        RowBox[{
                                        SuperscriptBox["yd1", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}]}], ")"}]}], "+", 
                                  RowBox[{
                                    SuperscriptBox["yd1", "\[Prime]\[Prime]",
                                      MultilineFunction->None], "[", "t", 
                                    "]"}]}], ")"}]}], "+", 
                            RowBox[{"5", " ", 
                              RowBox[{"(", 
                                RowBox[{
                                  RowBox[{"-", 
                                    RowBox[{
                                      
                                      SuperscriptBox["y2", "\[Prime]\[Prime]",
                                        
                                        MultilineFunction->None], "[", "t", 
                                      "]"}]}], "+", 
                                  RowBox[{
                                    SuperscriptBox["yd2", "\[Prime]\[Prime]",
                                      MultilineFunction->None], "[", "t", 
                                    "]"}]}], ")"}]}], "-", 
                            RowBox[{\(Tan[x1]\), " ", 
                              RowBox[{
                                SuperscriptBox["y1", 
                                  TagBox[\((3)\),
                                    Derivative],
                                  MultilineFunction->None], "[", "t", "]"}]}],
                             "+", 
                            RowBox[{
                              SuperscriptBox["yd2", 
                                TagBox[\((3)\),
                                  Derivative],
                                MultilineFunction->None], "[", "t", "]"}]}], 
                          ")"}]}], ")"}], 
                    "/", \((\(-x2\^2\) + 
                        Cos[x1]\^2\ \((x2\^2\ Sec[x1]\^2 + \((thetahat1 + x3\ \
Sec[x1])\)\^2)\))\)}]}], ")"}]}]}], "}"}], ",", 
        RowBox[{"{", 
          RowBox[{
            
            RowBox[{\((\(-\(\(x2\^2\ Sec[x1]\)\/\(\(-x2\^2\) + 
                          Cos[x1]\^2\ \((x2\^2\ Sec[x1]\^2 + \((thetahat1 + \
x3\ Sec[x1])\)\^2)\)\)\)\) + \(Cos[x1]\ \((x2\^2\ Sec[x1]\^2 + \((thetahat1 + \
x3\ Sec[x1])\)\^2)\)\)\/\(\(-x2\^2\) + Cos[x1]\^2\ \((x2\^2\ Sec[x1]\^2 + \
\((thetahat1 + x3\ Sec[x1])\)\^2)\)\))\), " ", 
              RowBox[{"(", 
                
                RowBox[{\(x2\ x3\ Sin[x1]\), 
                  "+", \(2\ thetahat1\ x2\ Cos[x1]\ Sin[x1]\), 
                  "+", \(2\ \((\(-x4\) + yd1[t])\)\), "+", 
                  RowBox[{"3", " ", 
                    RowBox[{"(", 
                      RowBox[{
                        RowBox[{"-", 
                          RowBox[{
                            SuperscriptBox["y1", "\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}]}], 
                        "+", 
                        RowBox[{
                          SuperscriptBox["yd1", "\[Prime]",
                            MultilineFunction->None], "[", "t", "]"}]}], 
                      ")"}]}], "+", 
                  RowBox[{
                    SuperscriptBox["yd1", "\[Prime]\[Prime]",
                      MultilineFunction->None], "[", "t", "]"}]}], ")"}]}], 
            ",", 
            RowBox[{
              RowBox[{"-", 
                RowBox[{
                  RowBox[{"(", 
                    RowBox[{"x2", " ", \((thetahat1 + x3\ Sec[x1])\), " ", 
                      RowBox[{"(", 
                        
                        RowBox[{\(x2\ x3\ Sin[x1]\), 
                          "+", \(2\ thetahat1\ x2\ Cos[x1]\ Sin[x1]\), 
                          "+", \(2\ \((\(-x4\) + yd1[t])\)\), "+", 
                          RowBox[{"3", " ", 
                            RowBox[{"(", 
                              RowBox[{
                                RowBox[{"-", 
                                  RowBox[{
                                    SuperscriptBox["y1", "\[Prime]",
                                      MultilineFunction->None], "[", "t", 
                                    "]"}]}], "+", 
                                RowBox[{
                                  SuperscriptBox["yd1", "\[Prime]",
                                    MultilineFunction->None], "[", "t", 
                                  "]"}]}], ")"}]}], "+", 
                          RowBox[{
                            SuperscriptBox["yd1", "\[Prime]\[Prime]",
                              MultilineFunction->None], "[", "t", "]"}]}], 
                        ")"}]}], ")"}], 
                  "/", \((\(-x2\^2\) + 
                      Cos[x1]\^2\ \((x2\^2\ Sec[x1]\^2 + \((thetahat1 + x3\ \
Sec[x1])\)\^2)\))\)}]}], "+", 
              RowBox[{
                RowBox[{"(", 
                  
                  RowBox[{\(Cos[x1]\^2\), " ", \((thetahat1 + x3\ Sec[x1])\), 
                    " ", 
                    RowBox[{"(", 
                      
                      RowBox[{\(\(-x2\^2\)\ x3\ Sec[x1]\ Tan[x1]\), 
                        "+", \(4\ \((\(-x5\) + yd2[t])\)\), "+", 
                        RowBox[{"8", " ", 
                          RowBox[{"(", 
                            RowBox[{
                              RowBox[{"-", 
                                RowBox[{
                                  SuperscriptBox["y2", "\[Prime]",
                                    MultilineFunction->None], "[", "t", 
                                  "]"}]}], "+", 
                              RowBox[{
                                SuperscriptBox["yd2", "\[Prime]",
                                  MultilineFunction->None], "[", "t", "]"}]}],
                             ")"}]}], "-", 
                        RowBox[{"x2", " ", \(Sec[x1]\^2\), " ", 
                          RowBox[{"(", 
                            RowBox[{\(2\ \((\(-x4\) + yd1[t])\)\), "+", 
                              RowBox[{"3", " ", 
                                RowBox[{"(", 
                                  RowBox[{
                                    RowBox[{"-", 
                                      RowBox[{
                                        SuperscriptBox["y1", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                        "]"}]}], "+", 
                                    RowBox[{
                                      SuperscriptBox["yd1", "\[Prime]",
                                        MultilineFunction->None], "[", "t", 
                                      "]"}]}], ")"}]}], "+", 
                              RowBox[{
                                SuperscriptBox["yd1", "\[Prime]\[Prime]",
                                  MultilineFunction->None], "[", "t", "]"}]}],
                             ")"}]}], "+", 
                        RowBox[{"5", " ", 
                          RowBox[{"(", 
                            RowBox[{
                              RowBox[{"-", 
                                RowBox[{
                                  SuperscriptBox["y2", "\[Prime]\[Prime]",
                                    MultilineFunction->None], "[", "t", 
                                  "]"}]}], "+", 
                              RowBox[{
                                SuperscriptBox["yd2", "\[Prime]\[Prime]",
                                  MultilineFunction->None], "[", "t", "]"}]}],
                             ")"}]}], "-", 
                        RowBox[{\(Tan[x1]\), " ", 
                          RowBox[{
                            SuperscriptBox["y1", 
                              TagBox[\((3)\),
                                Derivative],
                              MultilineFunction->None], "[", "t", "]"}]}], 
                        "+", 
                        RowBox[{
                          SuperscriptBox["yd2", 
                            TagBox[\((3)\),
                              Derivative],
                            MultilineFunction->None], "[", "t", "]"}]}], 
                      ")"}]}], ")"}], 
                "/", \((\(-x2\^2\) + 
                    Cos[x1]\^2\ \((x2\^2\ Sec[x1]\^2 + \((thetahat1 + x3\ \
Sec[x1])\)\^2)\))\)}]}]}], "}"}], 
        ",", \({{Cos[x1], 0}, {x2\ Sec[x1], thetahat1 + x3\ Sec[x1]}}\), 
        ",", \({2, 3}\)}], "}"}]], "Output",
  CellLabel->"Out[122]=",
  CellTags->{"Adaptive Control", "i:22", "b:33.2"}]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Creating SIMULINK S-Functions", "Section",
  Evaluatable->False,
  CellTags->{"Creating SIMULINK S-Functions", "i:23", "b:34"}],

Cell[CellGroupData[{

Cell[BoxData[{
    \(<< ProPac`\), "\[IndentingNewLine]", 
    \(\(SetDirectory["\<C:\Projects\ProPac\ProPac_3x\Test\>"];\)\)}], "Input",\

  CellLabel->"In[123]:=",
  CellTags->"b:34"],

Cell[BoxData[
    \("\n    This is ProPac - Development Version 3.xx\n \n ProPac has been \
successfully loaded. It contains several packages\n for multibody dynamics, \
linear control and nonlinear control.\n The package names are:\n    GeoTools\n\
    Dynamics\n    ControlL\n    ControlN\n    DifferentialForms\n    \
ObserverTools\n    NDTools\n    VSCTools\n    MatlabInterface\n    MEXTools\n \
Appropriate packages will be loaded automatically as required.\n To obtain a \
list of functions in a package and links to function\n declarations, enter:\n \
   ?ProPac`PackageName`*\n Help is also available in the Help Browser under \
Add-ons."\)], "Print",
  CellLabel->"From In[123]:=",
  CellTags->"b:34"]
}, Open  ]],

Cell["\<\
TSi provides a convenient interconnection to MATLAB/SIMULINK that enables a \
user to incorporate systems or controllers developed in Mathematica as \
subsystems in SIMULINK. This in turn allows controllers developed using TSi \
Controls to be easily implemented using MATLAB's Real Time Workshop. The main \
tool provided in TSi Controls is the function CreateControllerMEX that can be \
used to generate S-functions for SIMULINK 1.3 (the function CreateMEXFile can \
be used with the earlier version, SIMULINK 1.2).
\tCreateControllerMEX generates C source code that compiles as a 'mex' \
function in the structure of a SIMULINK S-function. Hence, it is a standard \
SIMULINK block with inputs and outputs that can be interconnected with any \
other SIMULINK block using SIMULINK's block diagramming facility. As an \
illustration consider example 13, which is a 4 state system with 2 inputs and \
2 outputs:   \
\>", "Text",
  Evaluatable->False,
  CellTags->{"Creating SIMULINK S-Functions", "i:23", "b:34"}],

Cell[BoxData[{
    \(\(f13 := {x2, x1\ x4\^2 - x4\^2\/2, 
          x4, \(4\ x2\ x4 - 8\ x1\ x2\ x4\)\/\(4\ x1\^2 - 4\ x1 + 5\)};\)\), \
"\n", 
    \(\(h13 := {x1, x3};\)\), "\n", 
    \(\(g13 := 
        Transpose[{{0, 1, 0, 0}, {0, 0, 0, 
              4\/\(4\ x1\^2 - 4\ x1 + 5\)}}];\)\), "\n", 
    \(\(var13 := {x1, x2, x3, x4};\)\), "\n", 
    \(\(u13 = {u1, u2};\)\)}], "Input",
  CellLabel->"In[125]:=",
  PageWidth->Infinity,
  FontFamily->"Courier New",
  FontSize->12,
  FontWeight->"Bold",
  FontColor->GrayLevel[0],
  Background->GrayLevel[1],
  CellTags->{"Creating SIMULINK S-Functions", "i:23", "b:34"}],

Cell[CellGroupData[{

Cell[BoxData[
    \(StateEqns = f13 + g13 . u13\)], "Input",
  CellLabel->"In[130]:=",
  PageWidth->Infinity,
  FontFamily->"Courier New",
  FontSize->12,
  FontWeight->"Bold",
  FontColor->GrayLevel[0],
  Background->GrayLevel[1],
  CellTags->{"Creating SIMULINK S-Functions", "i:23", "b:34"}],

Cell[BoxData[
    \({x2, u1 - x4\^2\/2 + x1\ x4\^2, 
      x4, \(4\ u2\)\/\(5 - 4\ x1 + 4\ x1\^2\) + \(4\ x2\ x4 - 8\ x1\ x2\ x4\)\
\/\(5 - 4\ x1 + 4\ x1\^2\)}\)], "Output",
  CellLabel->"Out[130]=",
  CellTags->{"Creating SIMULINK S-Functions", "i:23", "b:34"}]
}, Open  ]],

Cell["\<\
The S-function source code, with filename MXTst.c is obtained using \
CreateControllerMEX:\
\>", "Text",
  Evaluatable->False,
  CellTags->{"Creating SIMULINK S-Functions", "i:23", "b:34"}],

Cell[CellGroupData[{

Cell[BoxData[
    \(CreateControllerMEX[var13, u13, h13, 
      StateEqns, {"\<X0\>"}, {{4, 1}}, "\<MXTst.c\>"]\)], "Input",
  CellLabel->"In[131]:=",
  PageWidth->Infinity,
  FontFamily->"Courier New",
  FontSize->12,
  FontWeight->"Bold",
  FontColor->GrayLevel[0],
  Background->GrayLevel[1],
  CellTags->{"Creating SIMULINK S-Functions", "i:23", "b:34"}],

Cell[BoxData[
    \("  *** MEXTools successfully loaded ***"\)], "Print",
  CellLabel->"From In[131]:=",
  CellTags->{"Creating SIMULINK S-Functions", "i:23", "b:34"}],

Cell[BoxData[
    \("...Generating Header Code"\)], "Print",
  CellLabel->"From In[131]:=",
  CellTags->{"Creating SIMULINK S-Functions", "i:23", "b:34"}],

Cell[BoxData[
    \("...Generating Initial Condition Function Code"\)], "Print",
  CellLabel->"From In[131]:=",
  CellTags->{"Creating SIMULINK S-Functions", "i:23", "b:34"}],

Cell[BoxData[
    \("...Generating State Derivative Function Code"\)], "Print",
  CellLabel->"From In[131]:=",
  CellTags->{"Creating SIMULINK S-Functions", "i:23", "b:34"}],

Cell[BoxData[
    \("...Removing Function terms"\)], "Print",
  CellLabel->"From In[131]:=",
  CellTags->{"Creating SIMULINK S-Functions", "i:23", "b:34"}],

Cell[BoxData[
    \("...Generating temp variable declarations"\)], "Print",
  CellLabel->"From In[131]:=",
  CellTags->{"Creating SIMULINK S-Functions", "i:23", "b:34"}],

Cell[BoxData[
    \("...Converting Expressions to C form"\)], "Print",
  CellLabel->"From In[131]:=",
  CellTags->{"Creating SIMULINK S-Functions", "i:23", "b:34"}],

Cell[BoxData[
    \("...Generating Output Function Code"\)], "Print",
  CellLabel->"From In[131]:=",
  CellTags->{"Creating SIMULINK S-Functions", "i:23", "b:34"}],

Cell[BoxData[
    \("MEX File created with name: MXTst.c"\)], "Print",
  CellLabel->"From In[131]:=",
  CellTags->{"Creating SIMULINK S-Functions", "i:23", "b:34"}]
}, Open  ]],

Cell["\<\
The system for which the S-function representation is to be created can \
consist of differential equations and an output map as is the case above. The \
output map can have direct feedthrough of the inputs. In fact, it is not \
necessary to have any differential equations - the system can be a \
memoryless. Here is a 2 input - 2 output map that merely interchanges the \
order of the inputs:\
\>", "Text",
  Evaluatable->False,
  CellTags->{"Creating SIMULINK S-Functions", "i:23", "b:34"}],

Cell[CellGroupData[{

Cell[BoxData[
    \(CreateControllerMEX[{}, {u1, u2}, {u2, 
        u1}, {}, {"\<X0\>"}, {{0, 0}}, "\<MXTst2.c\>"]\)], "Input",
  CellLabel->"In[132]:=",
  PageWidth->Infinity,
  FontFamily->"Courier New",
  FontSize->12,
  FontWeight->"Bold",
  FontColor->GrayLevel[0],
  Background->GrayLevel[1],
  CellTags->{"Creating SIMULINK S-Functions", "i:23", "b:34"}],

Cell[BoxData[
    \("...Generating Header Code"\)], "Print",
  CellLabel->"From In[132]:=",
  CellTags->{"Creating SIMULINK S-Functions", "i:23", "b:34"}],

Cell[BoxData[
    \("...Generating Initial Condition Function Code"\)], "Print",
  CellLabel->"From In[132]:=",
  CellTags->{"Creating SIMULINK S-Functions", "i:23", "b:34"}],

Cell[BoxData[
    \("...Generating State Derivative Function Code"\)], "Print",
  CellLabel->"From In[132]:=",
  CellTags->{"Creating SIMULINK S-Functions", "i:23", "b:34"}],

Cell[BoxData[
    \("...Removing Function terms"\)], "Print",
  CellLabel->"From In[132]:=",
  CellTags->{"Creating SIMULINK S-Functions", "i:23", "b:34"}],

Cell[BoxData[
    \("...Generating temp variable declarations"\)], "Print",
  CellLabel->"From In[132]:=",
  CellTags->{"Creating SIMULINK S-Functions", "i:23", "b:34"}],

Cell[BoxData[
    \("...Converting Expressions to C form"\)], "Print",
  CellLabel->"From In[132]:=",
  CellTags->{"Creating SIMULINK S-Functions", "i:23", "b:34"}],

Cell[BoxData[
    \("...Generating Output Function Code"\)], "Print",
  CellLabel->"From In[132]:=",
  CellTags->{"Creating SIMULINK S-Functions", "i:23", "b:34"}],

Cell[BoxData[
    \("MEX File created with name: MXTst2.c"\)], "Print",
  CellLabel->"From In[132]:=",
  CellTags->{"Creating SIMULINK S-Functions", "i:23", "b:34"}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Bibliography", "Section",
  CellTags->{"Bibliography", "b:35"}],

Cell["\<\
Effective use of the tools provided in this package require a basic \
understanding of modern control system analysis and design concepts. Some \
general references for the methods underlying this package are given below.

Books on linear control abound. Here are just a few titles, including some \
classics: 
Nise, N., Control Systems Engineering, Benjamin/Cummings, Redwood City, 1995.
Friedland, B. Control System Design, McGraw-Hill, New York, 1986.
Kailath, T., Linear Systems, Prentice-Hall, Englewood Cliffs, 1980.
Wonham, W. M., Linear Multivariable Control: a Geometric Approach, \
Springer-Verlag, New York, 1979.
Anderson, B. and J. Moore, Linear Optimal Control, Prentice-Hall, Englewood \
Cliffs, 1971.
Brockett, R. W., Finite Dimensional Linear Systems, John Wiley, New York, \
1970.\
\>", "Text",
  CellTags->"Bibliography"],

Cell["\<\

Nonlinear and adaptive control theory has made import strides in the past \
decade. Usefull references for the methods implemented here are:
H. G. Kwatny and G. L. Blankenship, Nonlinear Contril and Analystical \
Mechanics: a computational approach, Birkhauser, Boston, 2000.
Isidori, A., Nonlinear Control Systems, Springer-Verlag, New York, 1995.
Niejmeijer, H. and A. J. van der Schaft, Nonlinear Dynamical Control Systems, \
Springer-Verlag, Berlin, 1990.
Slotine, J-J. E. and W. Li, Applied Nonlinear Control, Prentice-Hall, \
Englewood Cliffs, 1991.
Friedland, B., Advanced Control System Design, Prentice Hall, Englewood \
Cliffs, 1996.
Astrom, K. and B. Wittenmark, Adaptive Control, Addison-Wesley, Reading, \
1995.
Tao, G. and P. Kokotovic, Adaptive Control of Systems with Actuator and \
Sensor Nonlinearities, John Wiley, New York, 1996.
Young, K-K. D., Variable Structure Control for Robotics and Aerospace \
Applications, Elsevier, Amsterdam, 1993.\
\>", "Text",
  CellTags->{"Bibliography", "b:35"}]
}, Open  ]]
},
FrontEndVersion->"5.0 for Microsoft Windows",
ScreenRectangle->{{0, 1024}, {0, 695}},
ShowPageBreaks->False,
WindowSize->{779, 537},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
PrintingStartingPageNumber->143,
TaggingRules:>{"NextIndexingNumber" -> 5, "IndexEntries" -> {{"i:1", \
"Observability"}, {"i:1", "ObservabilityCodistribution"}, {"i:17", \
"ControlDistribution"}, {"i:17", "Controllability"}, {"i:17", \
"LocalDecomposition"}, {"i:19", "DecouplingMatrix"}, {"i:19", \
"InverseTransformation"}, {"i:19", "IOLinearize"}, {"i:19", \
"LocalZeroDynamics"}, {"i:19", "NormalCoordinates"}, {"i:19", \
"RelativeOrder"}, {"i:19", "SISONormalFormTrans"}, {"i:19", \
"VectorRelativeOrder"}, {"i:2", "FeedbackLinearizable"}, {"i:2", \
"InverseTransformation"}, {"i:2", "Involutive"}, {"i:2", "SIExactFBL"}, \
{"i:2", "TransformSystem"}, {"i:20", "DynamicExtension"}, {"i:21", \
"IOLinearization"}, {"i:21", "StructureAlgorithm"}, {"i:22", \
"AdaptiveRegulator"}, {"i:22", "AdaptiveTracking"}, {"i:23", \
"CreateControllerMEX"}, {"i:3", "PSSFSolve"}, {"i:4", \
"AdaptiveBackstepRegulator"}, {"i:4", "PSFFCond"}, {"i:4", "PSFFSolve"}}, \
"PaginationCache" -> {{2003, 8, 1, 21, 15, 47.2889392`9.42733443286363}, \
{143, 143, 143, 143, 143, 143, 143, 144, 144, 144, 144, 145, 145, 145, 145, \
145, 145, 145, 145, 145, 145, 146, 146, 146, 146, 146, 146, 146, 146, 146, \
146, 146, 146, 146, 146, 147, 147, 147, 147, 147, 147, 147, 147, 147, 147, \
147, 147, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 148, 149, 149, \
149, 149, 149, 149, 149, 149, 149, 149, 149, 149, 149, 149, 149, 149, 149, \
150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 150, 151, 151, 151, \
151, 151, 151, 151, 151, 151, 151, 151, 151, 151, 151, 152, 152, 152, 152, \
152, 152, 152, 152, 152, 152, 152, 152, 152, 152, 152, 153, 153, 153, 153, \
153, 153, 153, 153, 153, 153, 153, 153, 153, 153, 154, 154, 154, 154, 154, \
154, 154, 154, 154, 154, 154, 154, 154, 154, 154, 154, 154, 155, 155, 155, \
155, 155, 155, 155, 155, 155, 155, 155, 155, 156, 156, 156, 156, 156, 156, \
156, 156, 156, 156, 156, 156, 156, 156, 156, 157, 157, 157, 157, 157, 157, \
157, 157, 157, 157, 157, 158, 158, 158, 158, 158, 158, 158, 158, 158, 158, \
158, 158, 158, 159, 159, 159, 159, 159, 159, 159, 159, 159, 159, 159, 159, \
159, 159, 160, 160, 160, 160, 160, 161, 161, 161, 161, 161, 161, 161, 161, \
161, 161, 162, 162, 162, 162, 162, 162, 162, 162, 162, 162, 163, 164, 164, \
164, 164, 165, 165, 165, 165, 165, 165, 165, 165, 165, 165, 165, 165, 165, \
165, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 166, 167}}},
ShowCellTags->True,
StyleDefinitions -> "HelpBrowser.nb"
]

(*******************************************************************
Cached data follows.  If you edit this Notebook file directly, not
using Mathematica, you must remove the line containing CacheID at
the top of  the file.  The cache data will then be recreated when
you save this file from within Mathematica.
*******************************************************************)

(*CellTagsOutline
CellTagsIndex->{
  "Getting Started Nonlinear"->{
    Cell[1776, 53, 133, 3, 70, "Section",
      Evaluatable->False,
      CellTags->{"Getting Started Nonlinear", "b:29"}],
    Cell[1912, 58, 176, 4, 63, "Input",
      CellTags->{"Getting Started Nonlinear", "b:29"}],
    Cell[2091, 64, 817, 16, 107, "Text",
      Evaluatable->False,
      CellTags->{"Getting Started Nonlinear", "b:29"}],
    Cell[2911, 82, 276, 9, 39, "Text",
      Evaluatable->False,
      CellTags->{"Getting Started Nonlinear", "b:29"}],
    Cell[3212, 95, 150, 4, 45, "Input",
      CellTags->{"Getting Started Nonlinear", "b:29"}],
    Cell[3365, 101, 740, 11, 417, "Print",
      CellTags->{"Getting Started Nonlinear", "b:29"}],
    Cell[4120, 115, 182, 6, 39, "Text",
      CellTags->{"Getting Started Nonlinear", "b:29"}]},
  "b:29"->{
    Cell[1776, 53, 133, 3, 70, "Section",
      Evaluatable->False,
      CellTags->{"Getting Started Nonlinear", "b:29"}],
    Cell[1912, 58, 176, 4, 63, "Input",
      CellTags->{"Getting Started Nonlinear", "b:29"}],
    Cell[2091, 64, 817, 16, 107, "Text",
      Evaluatable->False,
      CellTags->{"Getting Started Nonlinear", "b:29"}],
    Cell[2911, 82, 276, 9, 39, "Text",
      Evaluatable->False,
      CellTags->{"Getting Started Nonlinear", "b:29"}],
    Cell[3212, 95, 150, 4, 45, "Input",
      CellTags->{"Getting Started Nonlinear", "b:29"}],
    Cell[3365, 101, 740, 11, 417, "Print",
      CellTags->{"Getting Started Nonlinear", "b:29"}],
    Cell[4120, 115, 182, 6, 39, "Text",
      CellTags->{"Getting Started Nonlinear", "b:29"}]},
  "b:30"->{
    Cell[4339, 126, 116, 3, 70, "Section",
      Evaluatable->False,
      CellTags->"b:30"],
    Cell[4458, 131, 265, 7, 56, "Text",
      Evaluatable->False,
      CellTags->{"Package", "b:30"}],
    Cell[4748, 142, 112, 3, 43, "Input",
      CellTags->{"b:30", "Package"}],
    Cell[4863, 147, 19277, 444, 245, "Print",
      CellTags->{"b:30", "Package"}]},
  "Package"->{
    Cell[4458, 131, 265, 7, 56, "Text",
      Evaluatable->False,
      CellTags->{"Package", "b:30"}],
    Cell[4748, 142, 112, 3, 43, "Input",
      CellTags->{"b:30", "Package"}],
    Cell[4863, 147, 19277, 444, 245, "Print",
      CellTags->{"b:30", "Package"}]},
  "Controllability & Observability"->{
    Cell[24189, 597, 107, 1, 70, "Section",
      CellTags->{"Controllability & Observability", "i:17"}],
    Cell[24321, 602, 104, 1, 53, "Subsection",
      CellTags->{"Controllability & Observability", "i:17", "b:31.0"}],
    Cell[24450, 607, 148, 3, 43, "Input",
      CellTags->{"Controllability & Observability", "i:17", "b:31.0"}],
    Cell[24601, 612, 174, 3, 37, "Print",
      CellTags->{"Controllability & Observability", "i:17", "b:31.0"}],
    Cell[24778, 617, 177, 3, 37, "Print",
      CellTags->{"Controllability & Observability", "i:17", "b:31.0"}],
    Cell[25664, 637, 397, 8, 143, "Input",
      CellTags->{"Controllability & Observability", "i:17", "b:31.0"}],
    Cell[26064, 647, 370, 10, 82, "Output",
      CellTags->{"Controllability & Observability", "i:17", "b:31.0"}],
    Cell[26471, 662, 205, 4, 43, "Input",
      CellTags->{
      "Controllability & Observability", "i:16", "i:17", "b:31.0"}],
    Cell[26679, 668, 361, 9, 66, "Output",
      CellTags->{
      "Controllability & Observability", "i:16", "i:17", "b:31.0"}],
    Cell[27077, 682, 145, 3, 43, "Input",
      CellTags->{"Controllability & Observability", "i:17", "b:31.0"}],
    Cell[27636, 697, 149, 3, 43, "Input",
      CellTags->{"Controllability & Observability", "i:17", "b:31.0"}],
    Cell[27788, 702, 130, 3, 41, "Output",
      CellTags->{"Controllability & Observability", "i:17", "b:31.0"}],
    Cell[27955, 710, 186, 4, 43, "Input",
      CellTags->{"Controllability & Observability", "i:17", "b:31.0"}],
    Cell[28144, 716, 131, 3, 41, "Output",
      CellTags->{"Controllability & Observability", "i:17", "b:31.0"}],
    Cell[28324, 725, 101, 1, 53, "Subsection",
      CellTags->{"Controllability & Observability", "i:1", "b:31.1"}],
    Cell[28428, 728, 192, 4, 39, "Text",
      CellTags->{"Controllability & Observability", "i:1", "b:31.1"}],
    Cell[28645, 736, 142, 3, 43, "Input",
      CellTags->{"Controllability & Observability", "i:1", "b:31.1"}],
    Cell[28986, 747, 280, 7, 123, "Input",
      CellTags->{"Controllability & Observability", "i:1", "b:31.1"}],
    Cell[29291, 758, 152, 3, 43, "Input",
      CellTags->{"Controllability & Observability", "i:1", "b:31.1"}],
    Cell[29446, 763, 129, 3, 41, "Output",
      CellTags->{"Controllability & Observability", "i:1", "b:31.1"}],
    Cell[29590, 769, 107, 1, 39, "Text",
      CellTags->{"Controllability & Observability", "i:1", "b:31.1"}],
    Cell[29722, 774, 157, 3, 43, "Input",
      CellTags->{"Controllability & Observability", "i:1", "b:31.1"}],
    Cell[29882, 779, 130, 3, 41, "Output",
      CellTags->{"Controllability & Observability", "i:1", "b:31.1"}],
    Cell[30049, 787, 181, 3, 43, "Input",
      CellTags->{"Controllability & Observability", "i:1", "b:31.1"}],
    Cell[30233, 792, 158, 3, 41, "Output",
      CellTags->{"Controllability & Observability", "i:1", "b:31.1"}],
    Cell[30428, 800, 171, 3, 43, "Input",
      CellTags->{"Controllability & Observability", "i:1", "b:31.1"}],
    Cell[30602, 805, 147, 3, 41, "Output",
      CellTags->{"Controllability & Observability", "i:1", "b:31.1"}],
    Cell[30798, 814, 108, 1, 53, "Subsection",
      CellTags->{"Controllability & Observability", "i:17", "b:31.2"}],
    Cell[30931, 819, 148, 3, 43, "Input",
      CellTags->{"Controllability & Observability", "i:17", "b:31.2"}],
    Cell[31651, 835, 345, 7, 103, "Input",
      CellTags->{"Controllability & Observability", "i:17", "b:31.2"}],
    Cell[32021, 846, 170, 3, 43, "Input",
      CellTags->{"Controllability & Observability", "i:17", "b:31.2"}],
    Cell[32194, 851, 279, 5, 60, "Output",
      CellTags->{"Controllability & Observability", "i:17", "b:31.2"}],
    Cell[32510, 861, 256, 6, 103, "Input",
      CellTags->{"Controllability & Observability", "i:17", "b:31.2"}],
    Cell[32769, 869, 130, 3, 41, "Output",
      CellTags->{"Controllability & Observability", "i:17", "b:31.2"}],
    Cell[32936, 877, 187, 4, 43, "Input",
      CellTags->{"Controllability & Observability", "i:17", "b:31.2"}],
    Cell[33126, 883, 160, 3, 37, "Print",
      CellTags->{"Controllability & Observability", "i:17", "b:31.2"}],
    Cell[33289, 888, 200, 4, 41, "Output",
      CellTags->{"Controllability & Observability", "i:17", "b:31.2"}]},
  "i:17"->{
    Cell[24189, 597, 107, 1, 70, "Section",
      CellTags->{"Controllability & Observability", "i:17"}],
    Cell[24321, 602, 104, 1, 53, "Subsection",
      CellTags->{"Controllability & Observability", "i:17", "b:31.0"}],
    Cell[24450, 607, 148, 3, 43, "Input",
      CellTags->{"Controllability & Observability", "i:17", "b:31.0"}],
    Cell[24601, 612, 174, 3, 37, "Print",
      CellTags->{"Controllability & Observability", "i:17", "b:31.0"}],
    Cell[24778, 617, 177, 3, 37, "Print",
      CellTags->{"Controllability & Observability", "i:17", "b:31.0"}],
    Cell[25664, 637, 397, 8, 143, "Input",
      CellTags->{"Controllability & Observability", "i:17", "b:31.0"}],
    Cell[26064, 647, 370, 10, 82, "Output",
      CellTags->{"Controllability & Observability", "i:17", "b:31.0"}],
    Cell[26471, 662, 205, 4, 43, "Input",
      CellTags->{
      "Controllability & Observability", "i:16", "i:17", "b:31.0"}],
    Cell[26679, 668, 361, 9, 66, "Output",
      CellTags->{
      "Controllability & Observability", "i:16", "i:17", "b:31.0"}],
    Cell[27077, 682, 145, 3, 43, "Input",
      CellTags->{"Controllability & Observability", "i:17", "b:31.0"}],
    Cell[27636, 697, 149, 3, 43, "Input",
      CellTags->{"Controllability & Observability", "i:17", "b:31.0"}],
    Cell[27788, 702, 130, 3, 41, "Output",
      CellTags->{"Controllability & Observability", "i:17", "b:31.0"}],
    Cell[27955, 710, 186, 4, 43, "Input",
      CellTags->{"Controllability & Observability", "i:17", "b:31.0"}],
    Cell[28144, 716, 131, 3, 41, "Output",
      CellTags->{"Controllability & Observability", "i:17", "b:31.0"}],
    Cell[30798, 814, 108, 1, 53, "Subsection",
      CellTags->{"Controllability & Observability", "i:17", "b:31.2"}],
    Cell[30931, 819, 148, 3, 43, "Input",
      CellTags->{"Controllability & Observability", "i:17", "b:31.2"}],
    Cell[31651, 835, 345, 7, 103, "Input",
      CellTags->{"Controllability & Observability", "i:17", "b:31.2"}],
    Cell[32021, 846, 170, 3, 43, "Input",
      CellTags->{"Controllability & Observability", "i:17", "b:31.2"}],
    Cell[32194, 851, 279, 5, 60, "Output",
      CellTags->{"Controllability & Observability", "i:17", "b:31.2"}],
    Cell[32510, 861, 256, 6, 103, "Input",
      CellTags->{"Controllability & Observability", "i:17", "b:31.2"}],
    Cell[32769, 869, 130, 3, 41, "Output",
      CellTags->{"Controllability & Observability", "i:17", "b:31.2"}],
    Cell[32936, 877, 187, 4, 43, "Input",
      CellTags->{"Controllability & Observability", "i:17", "b:31.2"}],
    Cell[33126, 883, 160, 3, 37, "Print",
      CellTags->{"Controllability & Observability", "i:17", "b:31.2"}],
    Cell[33289, 888, 200, 4, 41, "Output",
      CellTags->{"Controllability & Observability", "i:17", "b:31.2"}]},
  "b:31.0"->{
    Cell[24321, 602, 104, 1, 53, "Subsection",
      CellTags->{"Controllability & Observability", "i:17", "b:31.0"}],
    Cell[24450, 607, 148, 3, 43, "Input",
      CellTags->{"Controllability & Observability", "i:17", "b:31.0"}],
    Cell[24601, 612, 174, 3, 37, "Print",
      CellTags->{"Controllability & Observability", "i:17", "b:31.0"}],
    Cell[24778, 617, 177, 3, 37, "Print",
      CellTags->{"Controllability & Observability", "i:17", "b:31.0"}],
    Cell[24958, 622, 669, 10, 265, "Print",
      CellTags->{"Info3266691080-3602776", "b:31.0"}],
    Cell[25664, 637, 397, 8, 143, "Input",
      CellTags->{"Controllability & Observability", "i:17", "b:31.0"}],
    Cell[26064, 647, 370, 10, 82, "Output",
      CellTags->{"Controllability & Observability", "i:17", "b:31.0"}],
    Cell[26471, 662, 205, 4, 43, "Input",
      CellTags->{
      "Controllability & Observability", "i:16", "i:17", "b:31.0"}],
    Cell[26679, 668, 361, 9, 66, "Output",
      CellTags->{
      "Controllability & Observability", "i:16", "i:17", "b:31.0"}],
    Cell[27077, 682, 145, 3, 43, "Input",
      CellTags->{"Controllability & Observability", "i:17", "b:31.0"}],
    Cell[27225, 687, 374, 5, 94, "Print",
      CellTags->{"Info3266691083-3296927", "b:31.0"}],
    Cell[27636, 697, 149, 3, 43, "Input",
      CellTags->{"Controllability & Observability", "i:17", "b:31.0"}],
    Cell[27788, 702, 130, 3, 41, "Output",
      CellTags->{"Controllability & Observability", "i:17", "b:31.0"}],
    Cell[27955, 710, 186, 4, 43, "Input",
      CellTags->{"Controllability & Observability", "i:17", "b:31.0"}],
    Cell[28144, 716, 131, 3, 41, "Output",
      CellTags->{"Controllability & Observability", "i:17", "b:31.0"}]},
  "Info3266691080-3602776"->{
    Cell[24958, 622, 669, 10, 265, "Print",
      CellTags->{"Info3266691080-3602776", "b:31.0"}]},
  "i:16"->{
    Cell[26471, 662, 205, 4, 43, "Input",
      CellTags->{
      "Controllability & Observability", "i:16", "i:17", "b:31.0"}],
    Cell[26679, 668, 361, 9, 66, "Output",
      CellTags->{
      "Controllability & Observability", "i:16", "i:17", "b:31.0"}]},
  "Info3266691083-3296927"->{
    Cell[27225, 687, 374, 5, 94, "Print",
      CellTags->{"Info3266691083-3296927", "b:31.0"}]},
  "i:1"->{
    Cell[28324, 725, 101, 1, 53, "Subsection",
      CellTags->{"Controllability & Observability", "i:1", "b:31.1"}],
    Cell[28428, 728, 192, 4, 39, "Text",
      CellTags->{"Controllability & Observability", "i:1", "b:31.1"}],
    Cell[28645, 736, 142, 3, 43, "Input",
      CellTags->{"Controllability & Observability", "i:1", "b:31.1"}],
    Cell[28790, 741, 181, 3, 56, "Print",
      CellTags->{"Info3266691083-3416360", "i:1", "b:31.1"}],
    Cell[28986, 747, 280, 7, 123, "Input",
      CellTags->{"Controllability & Observability", "i:1", "b:31.1"}],
    Cell[29291, 758, 152, 3, 43, "Input",
      CellTags->{"Controllability & Observability", "i:1", "b:31.1"}],
    Cell[29446, 763, 129, 3, 41, "Output",
      CellTags->{"Controllability & Observability", "i:1", "b:31.1"}],
    Cell[29590, 769, 107, 1, 39, "Text",
      CellTags->{"Controllability & Observability", "i:1", "b:31.1"}],
    Cell[29722, 774, 157, 3, 43, "Input",
      CellTags->{"Controllability & Observability", "i:1", "b:31.1"}],
    Cell[29882, 779, 130, 3, 41, "Output",
      CellTags->{"Controllability & Observability", "i:1", "b:31.1"}],
    Cell[30049, 787, 181, 3, 43, "Input",
      CellTags->{"Controllability & Observability", "i:1", "b:31.1"}],
    Cell[30233, 792, 158, 3, 41, "Output",
      CellTags->{"Controllability & Observability", "i:1", "b:31.1"}],
    Cell[30428, 800, 171, 3, 43, "Input",
      CellTags->{"Controllability & Observability", "i:1", "b:31.1"}],
    Cell[30602, 805, 147, 3, 41, "Output",
      CellTags->{"Controllability & Observability", "i:1", "b:31.1"}]},
  "b:31.1"->{
    Cell[28324, 725, 101, 1, 53, "Subsection",
      CellTags->{"Controllability & Observability", "i:1", "b:31.1"}],
    Cell[28428, 728, 192, 4, 39, "Text",
      CellTags->{"Controllability & Observability", "i:1", "b:31.1"}],
    Cell[28645, 736, 142, 3, 43, "Input",
      CellTags->{"Controllability & Observability", "i:1", "b:31.1"}],
    Cell[28790, 741, 181, 3, 56, "Print",
      CellTags->{"Info3266691083-3416360", "i:1", "b:31.1"}],
    Cell[28986, 747, 280, 7, 123, "Input",
      CellTags->{"Controllability & Observability", "i:1", "b:31.1"}],
    Cell[29291, 758, 152, 3, 43, "Input",
      CellTags->{"Controllability & Observability", "i:1", "b:31.1"}],
    Cell[29446, 763, 129, 3, 41, "Output",
      CellTags->{"Controllability & Observability", "i:1", "b:31.1"}],
    Cell[29590, 769, 107, 1, 39, "Text",
      CellTags->{"Controllability & Observability", "i:1", "b:31.1"}],
    Cell[29722, 774, 157, 3, 43, "Input",
      CellTags->{"Controllability & Observability", "i:1", "b:31.1"}],
    Cell[29882, 779, 130, 3, 41, "Output",
      CellTags->{"Controllability & Observability", "i:1", "b:31.1"}],
    Cell[30049, 787, 181, 3, 43, "Input",
      CellTags->{"Controllability & Observability", "i:1", "b:31.1"}],
    Cell[30233, 792, 158, 3, 41, "Output",
      CellTags->{"Controllability & Observability", "i:1", "b:31.1"}],
    Cell[30428, 800, 171, 3, 43, "Input",
      CellTags->{"Controllability & Observability", "i:1", "b:31.1"}],
    Cell[30602, 805, 147, 3, 41, "Output",
      CellTags->{"Controllability & Observability", "i:1", "b:31.1"}]},
  "Info3266691083-3416360"->{
    Cell[28790, 741, 181, 3, 56, "Print",
      CellTags->{"Info3266691083-3416360", "i:1", "b:31.1"}]},
  "b:31.2"->{
    Cell[30798, 814, 108, 1, 53, "Subsection",
      CellTags->{"Controllability & Observability", "i:17", "b:31.2"}],
    Cell[30931, 819, 148, 3, 43, "Input",
      CellTags->{"Controllability & Observability", "i:17", "b:31.2"}],
    Cell[31082, 824, 554, 8, 246, "Print",
      CellTags->{"Info3266691083-1465963", "b:31.2"}],
    Cell[31651, 835, 345, 7, 103, "Input",
      CellTags->{"Controllability & Observability", "i:17", "b:31.2"}],
    Cell[32021, 846, 170, 3, 43, "Input",
      CellTags->{"Controllability & Observability", "i:17", "b:31.2"}],
    Cell[32194, 851, 279, 5, 60, "Output",
      CellTags->{"Controllability & Observability", "i:17", "b:31.2"}],
    Cell[32510, 861, 256, 6, 103, "Input",
      CellTags->{"Controllability & Observability", "i:17", "b:31.2"}],
    Cell[32769, 869, 130, 3, 41, "Output",
      CellTags->{"Controllability & Observability", "i:17", "b:31.2"}],
    Cell[32936, 877, 187, 4, 43, "Input",
      CellTags->{"Controllability & Observability", "i:17", "b:31.2"}],
    Cell[33126, 883, 160, 3, 37, "Print",
      CellTags->{"Controllability & Observability", "i:17", "b:31.2"}],
    Cell[33289, 888, 200, 4, 41, "Output",
      CellTags->{"Controllability & Observability", "i:17", "b:31.2"}]},
  "Info3266691083-1465963"->{
    Cell[31082, 824, 554, 8, 246, "Print",
      CellTags->{"Info3266691083-1465963", "b:31.2"}]},
  "i:2"->{
    Cell[33550, 899, 110, 1, 70, "Section",
      CellTags->{"i:2", "b:32.0", "Exact Feedback Linearization"}],
    Cell[33663, 902, 437, 8, 73, "Text",
      Evaluatable->False,
      CellTags->{"Exact Feedback Linearization", "i:18", "i:2", "b:32.0"}],
    Cell[34103, 912, 147, 2, 39, "Text",
      Evaluatable->False,
      CellTags->{"Exact Feedback Linearization", "i:18", "i:2", "b:32.0"}],
    Cell[34275, 918, 472, 13, 104, "Input",
      CellTags->{"Exact Feedback Linearization", "i:18", "i:2", "b:32.0"}],
    Cell[34750, 933, 134, 3, 41, "Output",
      CellTags->{"Exact Feedback Linearization", "i:18", "i:2", "b:32.0"}],
    Cell[34899, 939, 259, 5, 39, "Text",
      Evaluatable->False,
      CellTags->{"Exact Feedback Linearization", "i:18", "i:2", "b:32.0"}],
    Cell[35183, 948, 315, 9, 43, "Input",
      CellTags->{"Exact Feedback Linearization", "i:18", "i:2", "b:32.0"}],
    Cell[35501, 959, 292, 6, 37, "Print",
      CellTags->{"Exact Feedback Linearization", "i:18", "i:2", "b:32.0"}],
    Cell[35796, 967, 374, 7, 37, "Print",
      CellTags->{"Exact Feedback Linearization", "i:18", "i:2", "b:32.0"}],
    Cell[36173, 976, 300, 6, 37, "Print",
      CellTags->{"Exact Feedback Linearization", "i:18", "i:2", "b:32.0"}],
    Cell[36476, 984, 389, 9, 37, "Print",
      CellTags->{"Exact Feedback Linearization", "i:18", "i:2", "b:32.0"}],
    Cell[36868, 995, 506, 12, 37, "Print",
      CellTags->{"Exact Feedback Linearization", "i:18", "i:2", "b:32.0"}],
    Cell[37377, 1009, 207, 4, 41, "Output",
      CellTags->{"Exact Feedback Linearization", "i:18", "i:2", "b:32.0"}],
    Cell[37599, 1016, 330, 6, 56, "Text",
      Evaluatable->False,
      CellTags->{"Exact Feedback Linearization", "i:18", "i:2", "b:32.0"}],
    Cell[37954, 1026, 214, 5, 43, "Input",
      CellTags->{"Exact Feedback Linearization", "i:18", "i:2", "b:32.0"}],
    Cell[38171, 1033, 591, 13, 37, "Print",
      CellTags->{"Exact Feedback Linearization", "i:18", "i:2", "b:32.0"}],
    Cell[38765, 1048, 191, 4, 41, "Output",
      CellTags->{"Exact Feedback Linearization", "i:18", "i:2", "b:32.0"}],
    Cell[38993, 1057, 222, 5, 43, "Input",
      CellTags->{"Exact Feedback Linearization", "i:18", "i:2", "b:32.0"}],
    Cell[39218, 1064, 199, 4, 41, "Output",
      CellTags->{"Exact Feedback Linearization", "i:18", "i:2", "b:32.0"}],
    Cell[39432, 1071, 211, 6, 89, "Text",
      Evaluatable->False,
      CellTags->{"Exact Feedback Linearization", "i:18", "i:2", "b:32.0"}],
    Cell[39646, 1079, 332, 7, 83, "Input",
      CellTags->{"Exact Feedback Linearization", "i:18", "i:2", "b:32.0"}],
    Cell[40003, 1090, 189, 4, 43, "Input",
      CellTags->{"Exact Feedback Linearization", "i:18", "i:2", "b:32.0"}],
    Cell[40195, 1096, 135, 3, 41, "Output",
      CellTags->{"Exact Feedback Linearization", "i:18", "i:2", "b:32.0"}],
    Cell[40345, 1102, 286, 6, 56, "Text",
      Evaluatable->False,
      CellTags->{"Exact Feedback Linearization", "i:18", "i:2", "b:32.0"}],
    Cell[40656, 1112, 184, 4, 43, "Input",
      CellTags->{"Exact Feedback Linearization", "i:18", "i:2", "b:32.0"}],
    Cell[40843, 1118, 134, 3, 41, "Output",
      CellTags->{"Exact Feedback Linearization", "i:18", "i:2", "b:32.0"}],
    Cell[40992, 1124, 237, 5, 39, "Text",
      Evaluatable->False,
      CellTags->{"Exact Feedback Linearization", "i:18", "i:2", "b:32.0"}],
    Cell[41254, 1133, 228, 5, 63, "Input",
      CellTags->{"Exact Feedback Linearization", "i:18", "i:2", "b:32.0"}],
    Cell[41485, 1140, 135, 3, 41, "Output",
      CellTags->{"Exact Feedback Linearization", "i:18", "i:2", "b:32.0"}],
    Cell[41657, 1148, 226, 5, 43, "Input",
      CellTags->{"Exact Feedback Linearization", "i:18", "i:2", "b:32.0"}],
    Cell[41886, 1155, 134, 3, 41, "Output",
      CellTags->{"Exact Feedback Linearization", "i:18", "i:2", "b:32.0"}]},
  "b:32.0"->{
    Cell[33550, 899, 110, 1, 70, "Section",
      CellTags->{"i:2", "b:32.0", "Exact Feedback Linearization"}],
    Cell[33663, 902, 437, 8, 73, "Text",
      Evaluatable->False,
      CellTags->{"Exact Feedback Linearization", "i:18", "i:2", "b:32.0"}],
    Cell[34103, 912, 147, 2, 39, "Text",
      Evaluatable->False,
      CellTags->{"Exact Feedback Linearization", "i:18", "i:2", "b:32.0"}],
    Cell[34275, 918, 472, 13, 104, "Input",
      CellTags->{"Exact Feedback Linearization", "i:18", "i:2", "b:32.0"}],
    Cell[34750, 933, 134, 3, 41, "Output",
      CellTags->{"Exact Feedback Linearization", "i:18", "i:2", "b:32.0"}],
    Cell[34899, 939, 259, 5, 39, "Text",
      Evaluatable->False,
      CellTags->{"Exact Feedback Linearization", "i:18", "i:2", "b:32.0"}],
    Cell[35183, 948, 315, 9, 43, "Input",
      CellTags->{"Exact Feedback Linearization", "i:18", "i:2", "b:32.0"}],
    Cell[35501, 959, 292, 6, 37, "Print",
      CellTags->{"Exact Feedback Linearization", "i:18", "i:2", "b:32.0"}],
    Cell[35796, 967, 374, 7, 37, "Print",
      CellTags->{"Exact Feedback Linearization", "i:18", "i:2", "b:32.0"}],
    Cell[36173, 976, 300, 6, 37, "Print",
      CellTags->{"Exact Feedback Linearization", "i:18", "i:2", "b:32.0"}],
    Cell[36476, 984, 389, 9, 37, "Print",
      CellTags->{"Exact Feedback Linearization", "i:18", "i:2", "b:32.0"}],
    Cell[36868, 995, 506, 12, 37, "Print",
      CellTags->{"Exact Feedback Linearization", "i:18", "i:2", "b:32.0"}],
    Cell[37377, 1009, 207, 4, 41, "Output",
      CellTags->{"Exact Feedback Linearization", "i:18", "i:2", "b:32.0"}],
    Cell[37599, 1016, 330, 6, 56, "Text",
      Evaluatable->False,
      CellTags->{"Exact Feedback Linearization", "i:18", "i:2", "b:32.0"}],
    Cell[37954, 1026, 214, 5, 43, "Input",
      CellTags->{"Exact Feedback Linearization", "i:18", "i:2", "b:32.0"}],
    Cell[38171, 1033, 591, 13, 37, "Print",
      CellTags->{"Exact Feedback Linearization", "i:18", "i:2", "b:32.0"}],
    Cell[38765, 1048, 191, 4, 41, "Output",
      CellTags->{"Exact Feedback Linearization", "i:18", "i:2", "b:32.0"}],
    Cell[38993, 1057, 222, 5, 43, "Input",
      CellTags->{"Exact Feedback Linearization", "i:18", "i:2", "b:32.0"}],
    Cell[39218, 1064, 199, 4, 41, "Output",
      CellTags->{"Exact Feedback Linearization", "i:18", "i:2", "b:32.0"}],
    Cell[39432, 1071, 211, 6, 89, "Text",
      Evaluatable->False,
      CellTags->{"Exact Feedback Linearization", "i:18", "i:2", "b:32.0"}],
    Cell[39646, 1079, 332, 7, 83, "Input",
      CellTags->{"Exact Feedback Linearization", "i:18", "i:2", "b:32.0"}],
    Cell[40003, 1090, 189, 4, 43, "Input",
      CellTags->{"Exact Feedback Linearization", "i:18", "i:2", "b:32.0"}],
    Cell[40195, 1096, 135, 3, 41, "Output",
      CellTags->{"Exact Feedback Linearization", "i:18", "i:2", "b:32.0"}],
    Cell[40345, 1102, 286, 6, 56, "Text",
      Evaluatable->False,
      CellTags->{"Exact Feedback Linearization", "i:18", "i:2", "b:32.0"}],
    Cell[40656, 1112, 184, 4, 43, "Input",
      CellTags->{"Exact Feedback Linearization", "i:18", "i:2", "b:32.0"}],
    Cell[40843, 1118, 134, 3, 41, "Output",
      CellTags->{"Exact Feedback Linearization", "i:18", "i:2", "b:32.0"}],
    Cell[40992, 1124, 237, 5, 39, "Text",
      Evaluatable->False,
      CellTags->{"Exact Feedback Linearization", "i:18", "i:2", "b:32.0"}],
    Cell[41254, 1133, 228, 5, 63, "Input",
      CellTags->{"Exact Feedback Linearization", "i:18", "i:2", "b:32.0"}],
    Cell[41485, 1140, 135, 3, 41, "Output",
      CellTags->{"Exact Feedback Linearization", "i:18", "i:2", "b:32.0"}],
    Cell[41657, 1148, 226, 5, 43, "Input",
      CellTags->{"Exact Feedback Linearization", "i:18", "i:2", "b:32.0"}],
    Cell[41886, 1155, 134, 3, 41, "Output",
      CellTags->{"Exact Feedback Linearization", "i:18", "i:2", "b:32.0"}]},
  "Exact Feedback Linearization"->{
    Cell[33550, 899, 110, 1, 70, "Section",
      CellTags->{"i:2", "b:32.0", "Exact Feedback Linearization"}],
    Cell[33663, 902, 437, 8, 73, "Text",
      Evaluatable->False,
      CellTags->{"Exact Feedback Linearization", "i:18", "i:2", "b:32.0"}],
    Cell[34103, 912, 147, 2, 39, "Text",
      Evaluatable->False,
      CellTags->{"Exact Feedback Linearization", "i:18", "i:2", "b:32.0"}],
    Cell[34275, 918, 472, 13, 104, "Input",
      CellTags->{"Exact Feedback Linearization", "i:18", "i:2", "b:32.0"}],
    Cell[34750, 933, 134, 3, 41, "Output",
      CellTags->{"Exact Feedback Linearization", "i:18", "i:2", "b:32.0"}],
    Cell[34899, 939, 259, 5, 39, "Text",
      Evaluatable->False,
      CellTags->{"Exact Feedback Linearization", "i:18", "i:2", "b:32.0"}],
    Cell[35183, 948, 315, 9, 43, "Input",
      CellTags->{"Exact Feedback Linearization", "i:18", "i:2", "b:32.0"}],
    Cell[35501, 959, 292, 6, 37, "Print",
      CellTags->{"Exact Feedback Linearization", "i:18", "i:2", "b:32.0"}],
    Cell[35796, 967, 374, 7, 37, "Print",
      CellTags->{"Exact Feedback Linearization", "i:18", "i:2", "b:32.0"}],
    Cell[36173, 976, 300, 6, 37, "Print",
      CellTags->{"Exact Feedback Linearization", "i:18", "i:2", "b:32.0"}],
    Cell[36476, 984, 389, 9, 37, "Print",
      CellTags->{"Exact Feedback Linearization", "i:18", "i:2", "b:32.0"}],
    Cell[36868, 995, 506, 12, 37, "Print",
      CellTags->{"Exact Feedback Linearization", "i:18", "i:2", "b:32.0"}],
    Cell[37377, 1009, 207, 4, 41, "Output",
      CellTags->{"Exact Feedback Linearization", "i:18", "i:2", "b:32.0"}],
    Cell[37599, 1016, 330, 6, 56, "Text",
      Evaluatable->False,
      CellTags->{"Exact Feedback Linearization", "i:18", "i:2", "b:32.0"}],
    Cell[37954, 1026, 214, 5, 43, "Input",
      CellTags->{"Exact Feedback Linearization", "i:18", "i:2", "b:32.0"}],
    Cell[38171, 1033, 591, 13, 37, "Print",
      CellTags->{"Exact Feedback Linearization", "i:18", "i:2", "b:32.0"}],
    Cell[38765, 1048, 191, 4, 41, "Output",
      CellTags->{"Exact Feedback Linearization", "i:18", "i:2", "b:32.0"}],
    Cell[38993, 1057, 222, 5, 43, "Input",
      CellTags->{"Exact Feedback Linearization", "i:18", "i:2", "b:32.0"}],
    Cell[39218, 1064, 199, 4, 41, "Output",
      CellTags->{"Exact Feedback Linearization", "i:18", "i:2", "b:32.0"}],
    Cell[39432, 1071, 211, 6, 89, "Text",
      Evaluatable->False,
      CellTags->{"Exact Feedback Linearization", "i:18", "i:2", "b:32.0"}],
    Cell[39646, 1079, 332, 7, 83, "Input",
      CellTags->{"Exact Feedback Linearization", "i:18", "i:2", "b:32.0"}],
    Cell[40003, 1090, 189, 4, 43, "Input",
      CellTags->{"Exact Feedback Linearization", "i:18", "i:2", "b:32.0"}],
    Cell[40195, 1096, 135, 3, 41, "Output",
      CellTags->{"Exact Feedback Linearization", "i:18", "i:2", "b:32.0"}],
    Cell[40345, 1102, 286, 6, 56, "Text",
      Evaluatable->False,
      CellTags->{"Exact Feedback Linearization", "i:18", "i:2", "b:32.0"}],
    Cell[40656, 1112, 184, 4, 43, "Input",
      CellTags->{"Exact Feedback Linearization", "i:18", "i:2", "b:32.0"}],
    Cell[40843, 1118, 134, 3, 41, "Output",
      CellTags->{"Exact Feedback Linearization", "i:18", "i:2", "b:32.0"}],
    Cell[40992, 1124, 237, 5, 39, "Text",
      Evaluatable->False,
      CellTags->{"Exact Feedback Linearization", "i:18", "i:2", "b:32.0"}],
    Cell[41254, 1133, 228, 5, 63, "Input",
      CellTags->{"Exact Feedback Linearization", "i:18", "i:2", "b:32.0"}],
    Cell[41485, 1140, 135, 3, 41, "Output",
      CellTags->{"Exact Feedback Linearization", "i:18", "i:2", "b:32.0"}],
    Cell[41657, 1148, 226, 5, 43, "Input",
      CellTags->{"Exact Feedback Linearization", "i:18", "i:2", "b:32.0"}],
    Cell[41886, 1155, 134, 3, 41, "Output",
      CellTags->{"Exact Feedback Linearization", "i:18", "i:2", "b:32.0"}]},
  "i:18"->{
    Cell[33663, 902, 437, 8, 73, "Text",
      Evaluatable->False,
      CellTags->{"Exact Feedback Linearization", "i:18", "i:2", "b:32.0"}],
    Cell[34103, 912, 147, 2, 39, "Text",
      Evaluatable->False,
      CellTags->{"Exact Feedback Linearization", "i:18", "i:2", "b:32.0"}],
    Cell[34275, 918, 472, 13, 104, "Input",
      CellTags->{"Exact Feedback Linearization", "i:18", "i:2", "b:32.0"}],
    Cell[34750, 933, 134, 3, 41, "Output",
      CellTags->{"Exact Feedback Linearization", "i:18", "i:2", "b:32.0"}],
    Cell[34899, 939, 259, 5, 39, "Text",
      Evaluatable->False,
      CellTags->{"Exact Feedback Linearization", "i:18", "i:2", "b:32.0"}],
    Cell[35183, 948, 315, 9, 43, "Input",
      CellTags->{"Exact Feedback Linearization", "i:18", "i:2", "b:32.0"}],
    Cell[35501, 959, 292, 6, 37, "Print",
      CellTags->{"Exact Feedback Linearization", "i:18", "i:2", "b:32.0"}],
    Cell[35796, 967, 374, 7, 37, "Print",
      CellTags->{"Exact Feedback Linearization", "i:18", "i:2", "b:32.0"}],
    Cell[36173, 976, 300, 6, 37, "Print",
      CellTags->{"Exact Feedback Linearization", "i:18", "i:2", "b:32.0"}],
    Cell[36476, 984, 389, 9, 37, "Print",
      CellTags->{"Exact Feedback Linearization", "i:18", "i:2", "b:32.0"}],
    Cell[36868, 995, 506, 12, 37, "Print",
      CellTags->{"Exact Feedback Linearization", "i:18", "i:2", "b:32.0"}],
    Cell[37377, 1009, 207, 4, 41, "Output",
      CellTags->{"Exact Feedback Linearization", "i:18", "i:2", "b:32.0"}],
    Cell[37599, 1016, 330, 6, 56, "Text",
      Evaluatable->False,
      CellTags->{"Exact Feedback Linearization", "i:18", "i:2", "b:32.0"}],
    Cell[37954, 1026, 214, 5, 43, "Input",
      CellTags->{"Exact Feedback Linearization", "i:18", "i:2", "b:32.0"}],
    Cell[38171, 1033, 591, 13, 37, "Print",
      CellTags->{"Exact Feedback Linearization", "i:18", "i:2", "b:32.0"}],
    Cell[38765, 1048, 191, 4, 41, "Output",
      CellTags->{"Exact Feedback Linearization", "i:18", "i:2", "b:32.0"}],
    Cell[38993, 1057, 222, 5, 43, "Input",
      CellTags->{"Exact Feedback Linearization", "i:18", "i:2", "b:32.0"}],
    Cell[39218, 1064, 199, 4, 41, "Output",
      CellTags->{"Exact Feedback Linearization", "i:18", "i:2", "b:32.0"}],
    Cell[39432, 1071, 211, 6, 89, "Text",
      Evaluatable->False,
      CellTags->{"Exact Feedback Linearization", "i:18", "i:2", "b:32.0"}],
    Cell[39646, 1079, 332, 7, 83, "Input",
      CellTags->{"Exact Feedback Linearization", "i:18", "i:2", "b:32.0"}],
    Cell[40003, 1090, 189, 4, 43, "Input",
      CellTags->{"Exact Feedback Linearization", "i:18", "i:2", "b:32.0"}],
    Cell[40195, 1096, 135, 3, 41, "Output",
      CellTags->{"Exact Feedback Linearization", "i:18", "i:2", "b:32.0"}],
    Cell[40345, 1102, 286, 6, 56, "Text",
      Evaluatable->False,
      CellTags->{"Exact Feedback Linearization", "i:18", "i:2", "b:32.0"}],
    Cell[40656, 1112, 184, 4, 43, "Input",
      CellTags->{"Exact Feedback Linearization", "i:18", "i:2", "b:32.0"}],
    Cell[40843, 1118, 134, 3, 41, "Output",
      CellTags->{"Exact Feedback Linearization", "i:18", "i:2", "b:32.0"}],
    Cell[40992, 1124, 237, 5, 39, "Text",
      Evaluatable->False,
      CellTags->{"Exact Feedback Linearization", "i:18", "i:2", "b:32.0"}],
    Cell[41254, 1133, 228, 5, 63, "Input",
      CellTags->{"Exact Feedback Linearization", "i:18", "i:2", "b:32.0"}],
    Cell[41485, 1140, 135, 3, 41, "Output",
      CellTags->{"Exact Feedback Linearization", "i:18", "i:2", "b:32.0"}],
    Cell[41657, 1148, 226, 5, 43, "Input",
      CellTags->{"Exact Feedback Linearization", "i:18", "i:2", "b:32.0"}],
    Cell[41886, 1155, 134, 3, 41, "Output",
      CellTags->{"Exact Feedback Linearization", "i:18", "i:2", "b:32.0"}]},
  "Input-Output Linearization"->{
    Cell[42069, 1164, 186, 3, 70, "Section",
      Evaluatable->False,
      CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
    Cell[42280, 1171, 156, 2, 53, "Subsection",
      Evaluatable->False,
      CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
    Cell[42439, 1175, 1256, 26, 124, "Text",
      Evaluatable->False,
      CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
    Cell[43698, 1203, 426, 14, 39, "Text",
      Evaluatable->False,
      CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
    Cell[44149, 1221, 515, 12, 104, "Input",
      CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
    Cell[44667, 1235, 191, 4, 54, "Output",
      CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
    Cell[44895, 1244, 365, 10, 63, "Input",
      CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
    Cell[45263, 1256, 730, 19, 46, "Print",
      CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
    Cell[45996, 1277, 182, 4, 50, "Output",
      CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
    Cell[46193, 1284, 364, 11, 43, "Input",
      CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
    Cell[46560, 1297, 273, 6, 56, "Text",
      Evaluatable->False,
      CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
    Cell[46858, 1307, 363, 7, 43, "Input",
      CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
    Cell[47224, 1316, 594, 14, 54, "Output",
      CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
    Cell[47833, 1333, 158, 2, 39, "Text",
      Evaluatable->False,
      CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
    Cell[47994, 1337, 398, 11, 63, "Input",
      CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
    Cell[48417, 1352, 317, 9, 43, "Input",
      CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
    Cell[48737, 1363, 460, 8, 49, "Message",
      CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
    Cell[49200, 1373, 168, 3, 41, "Output",
      CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
    Cell[49405, 1381, 285, 9, 43, "Input",
      CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
    Cell[49693, 1392, 164, 3, 41, "Output",
      CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
    Cell[49894, 1400, 321, 9, 43, "Input",
      CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
    Cell[50218, 1411, 501, 8, 51, "Message",
      CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
    Cell[50722, 1421, 460, 8, 49, "Message",
      CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
    Cell[51185, 1431, 472, 10, 37, "Print",
      CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
    Cell[51660, 1443, 164, 3, 41, "Output",
      CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
    Cell[51839, 1449, 357, 7, 56, "Text",
      Evaluatable->False,
      CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
    Cell[52221, 1460, 302, 9, 43, "Input",
      CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
    Cell[52526, 1471, 159, 3, 41, "Output",
      CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
    Cell[52700, 1477, 153, 2, 39, "Text",
      Evaluatable->False,
      CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
    Cell[52878, 1483, 348, 11, 43, "Input",
      CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
    Cell[53229, 1496, 285, 6, 41, "Output",
      CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
    Cell[53551, 1507, 420, 11, 43, "Input",
      CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
    Cell[53974, 1520, 300, 8, 41, "Output",
      CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
    Cell[54323, 1534, 168, 3, 53, "Subsection",
      Evaluatable->False,
      CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
    Cell[54494, 1539, 475, 8, 73, "Text",
      Evaluatable->False,
      CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
    Cell[54994, 1551, 178, 4, 43, "Input",
      CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
    Cell[55175, 1557, 122, 3, 41, "Output",
      CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
    Cell[55334, 1565, 300, 9, 43, "Input",
      CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
    Cell[55637, 1576, 122, 3, 41, "Output",
      CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
    Cell[55774, 1582, 337, 6, 56, "Text",
      Evaluatable->False,
      CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
    Cell[56136, 1592, 306, 9, 43, "Input",
      CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
    Cell[56445, 1603, 124, 3, 41, "Output",
      CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
    Cell[56584, 1609, 630, 18, 56, "Text",
      Evaluatable->False,
      CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
    Cell[57217, 1629, 315, 7, 123, "Input",
      CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
    Cell[57535, 1638, 472, 16, 39, "Text",
      Evaluatable->False,
      CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
    Cell[58032, 1658, 211, 5, 43, "Input",
      CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
    Cell[58246, 1665, 124, 3, 41, "Output",
      CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
    Cell[58407, 1673, 207, 5, 43, "Input",
      CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
    Cell[58617, 1680, 178, 3, 41, "Output",
      CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
    Cell[58810, 1686, 239, 5, 39, "Text",
      Evaluatable->False,
      CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
    Cell[59074, 1695, 226, 5, 43, "Input",
      CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
    Cell[59303, 1702, 154, 3, 37, "Print",
      CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
    Cell[59460, 1707, 167, 3, 37, "Print",
      CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
    Cell[59630, 1712, 342, 6, 58, "Output",
      CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
    Cell[59987, 1721, 178, 4, 39, "Text",
      Evaluatable->False,
      CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
    Cell[60190, 1729, 212, 5, 43, "Input",
      CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
    Cell[60405, 1736, 151, 3, 41, "Output",
      CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
    Cell[60571, 1742, 190, 5, 39, "Text",
      Evaluatable->False,
      CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
    Cell[60786, 1751, 199, 5, 43, "Input",
      CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
    Cell[60988, 1758, 211, 4, 58, "Output",
      CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
    Cell[61236, 1767, 211, 5, 43, "Input",
      CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
    Cell[61450, 1774, 165, 3, 37, "Print",
      CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
    Cell[61618, 1779, 154, 3, 37, "Print",
      CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
    Cell[61775, 1784, 123, 3, 41, "Output",
      CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}]},
  "i:19"->{
    Cell[42069, 1164, 186, 3, 70, "Section",
      Evaluatable->False,
      CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
    Cell[42280, 1171, 156, 2, 53, "Subsection",
      Evaluatable->False,
      CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
    Cell[42439, 1175, 1256, 26, 124, "Text",
      Evaluatable->False,
      CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
    Cell[43698, 1203, 426, 14, 39, "Text",
      Evaluatable->False,
      CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
    Cell[44149, 1221, 515, 12, 104, "Input",
      CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
    Cell[44667, 1235, 191, 4, 54, "Output",
      CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
    Cell[44895, 1244, 365, 10, 63, "Input",
      CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
    Cell[45263, 1256, 730, 19, 46, "Print",
      CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
    Cell[45996, 1277, 182, 4, 50, "Output",
      CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
    Cell[46193, 1284, 364, 11, 43, "Input",
      CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
    Cell[46560, 1297, 273, 6, 56, "Text",
      Evaluatable->False,
      CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
    Cell[46858, 1307, 363, 7, 43, "Input",
      CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
    Cell[47224, 1316, 594, 14, 54, "Output",
      CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
    Cell[47833, 1333, 158, 2, 39, "Text",
      Evaluatable->False,
      CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
    Cell[47994, 1337, 398, 11, 63, "Input",
      CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
    Cell[48417, 1352, 317, 9, 43, "Input",
      CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
    Cell[48737, 1363, 460, 8, 49, "Message",
      CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
    Cell[49200, 1373, 168, 3, 41, "Output",
      CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
    Cell[49405, 1381, 285, 9, 43, "Input",
      CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
    Cell[49693, 1392, 164, 3, 41, "Output",
      CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
    Cell[49894, 1400, 321, 9, 43, "Input",
      CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
    Cell[50218, 1411, 501, 8, 51, "Message",
      CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
    Cell[50722, 1421, 460, 8, 49, "Message",
      CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
    Cell[51185, 1431, 472, 10, 37, "Print",
      CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
    Cell[51660, 1443, 164, 3, 41, "Output",
      CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
    Cell[51839, 1449, 357, 7, 56, "Text",
      Evaluatable->False,
      CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
    Cell[52221, 1460, 302, 9, 43, "Input",
      CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
    Cell[52526, 1471, 159, 3, 41, "Output",
      CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
    Cell[52700, 1477, 153, 2, 39, "Text",
      Evaluatable->False,
      CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
    Cell[52878, 1483, 348, 11, 43, "Input",
      CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
    Cell[53229, 1496, 285, 6, 41, "Output",
      CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
    Cell[53551, 1507, 420, 11, 43, "Input",
      CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
    Cell[53974, 1520, 300, 8, 41, "Output",
      CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
    Cell[54323, 1534, 168, 3, 53, "Subsection",
      Evaluatable->False,
      CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
    Cell[54494, 1539, 475, 8, 73, "Text",
      Evaluatable->False,
      CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
    Cell[54994, 1551, 178, 4, 43, "Input",
      CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
    Cell[55175, 1557, 122, 3, 41, "Output",
      CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
    Cell[55334, 1565, 300, 9, 43, "Input",
      CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
    Cell[55637, 1576, 122, 3, 41, "Output",
      CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
    Cell[55774, 1582, 337, 6, 56, "Text",
      Evaluatable->False,
      CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
    Cell[56136, 1592, 306, 9, 43, "Input",
      CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
    Cell[56445, 1603, 124, 3, 41, "Output",
      CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
    Cell[56584, 1609, 630, 18, 56, "Text",
      Evaluatable->False,
      CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
    Cell[57217, 1629, 315, 7, 123, "Input",
      CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
    Cell[57535, 1638, 472, 16, 39, "Text",
      Evaluatable->False,
      CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
    Cell[58032, 1658, 211, 5, 43, "Input",
      CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
    Cell[58246, 1665, 124, 3, 41, "Output",
      CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
    Cell[58407, 1673, 207, 5, 43, "Input",
      CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
    Cell[58617, 1680, 178, 3, 41, "Output",
      CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
    Cell[58810, 1686, 239, 5, 39, "Text",
      Evaluatable->False,
      CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
    Cell[59074, 1695, 226, 5, 43, "Input",
      CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
    Cell[59303, 1702, 154, 3, 37, "Print",
      CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
    Cell[59460, 1707, 167, 3, 37, "Print",
      CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
    Cell[59630, 1712, 342, 6, 58, "Output",
      CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
    Cell[59987, 1721, 178, 4, 39, "Text",
      Evaluatable->False,
      CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
    Cell[60190, 1729, 212, 5, 43, "Input",
      CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
    Cell[60405, 1736, 151, 3, 41, "Output",
      CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
    Cell[60571, 1742, 190, 5, 39, "Text",
      Evaluatable->False,
      CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
    Cell[60786, 1751, 199, 5, 43, "Input",
      CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
    Cell[60988, 1758, 211, 4, 58, "Output",
      CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
    Cell[61236, 1767, 211, 5, 43, "Input",
      CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
    Cell[61450, 1774, 165, 3, 37, "Print",
      CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
    Cell[61618, 1779, 154, 3, 37, "Print",
      CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
    Cell[61775, 1784, 123, 3, 41, "Output",
      CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}]},
  "b:32.1"->{
    Cell[42069, 1164, 186, 3, 70, "Section",
      Evaluatable->False,
      CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
    Cell[42280, 1171, 156, 2, 53, "Subsection",
      Evaluatable->False,
      CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
    Cell[42439, 1175, 1256, 26, 124, "Text",
      Evaluatable->False,
      CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
    Cell[43698, 1203, 426, 14, 39, "Text",
      Evaluatable->False,
      CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
    Cell[44149, 1221, 515, 12, 104, "Input",
      CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
    Cell[44667, 1235, 191, 4, 54, "Output",
      CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
    Cell[44895, 1244, 365, 10, 63, "Input",
      CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
    Cell[45263, 1256, 730, 19, 46, "Print",
      CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
    Cell[45996, 1277, 182, 4, 50, "Output",
      CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
    Cell[46193, 1284, 364, 11, 43, "Input",
      CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
    Cell[46560, 1297, 273, 6, 56, "Text",
      Evaluatable->False,
      CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
    Cell[46858, 1307, 363, 7, 43, "Input",
      CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
    Cell[47224, 1316, 594, 14, 54, "Output",
      CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
    Cell[47833, 1333, 158, 2, 39, "Text",
      Evaluatable->False,
      CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
    Cell[47994, 1337, 398, 11, 63, "Input",
      CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
    Cell[48417, 1352, 317, 9, 43, "Input",
      CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
    Cell[48737, 1363, 460, 8, 49, "Message",
      CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
    Cell[49200, 1373, 168, 3, 41, "Output",
      CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
    Cell[49405, 1381, 285, 9, 43, "Input",
      CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
    Cell[49693, 1392, 164, 3, 41, "Output",
      CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
    Cell[49894, 1400, 321, 9, 43, "Input",
      CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
    Cell[50218, 1411, 501, 8, 51, "Message",
      CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
    Cell[50722, 1421, 460, 8, 49, "Message",
      CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
    Cell[51185, 1431, 472, 10, 37, "Print",
      CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
    Cell[51660, 1443, 164, 3, 41, "Output",
      CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
    Cell[51839, 1449, 357, 7, 56, "Text",
      Evaluatable->False,
      CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
    Cell[52221, 1460, 302, 9, 43, "Input",
      CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
    Cell[52526, 1471, 159, 3, 41, "Output",
      CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
    Cell[52700, 1477, 153, 2, 39, "Text",
      Evaluatable->False,
      CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
    Cell[52878, 1483, 348, 11, 43, "Input",
      CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
    Cell[53229, 1496, 285, 6, 41, "Output",
      CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
    Cell[53551, 1507, 420, 11, 43, "Input",
      CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
    Cell[53974, 1520, 300, 8, 41, "Output",
      CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
    Cell[54323, 1534, 168, 3, 53, "Subsection",
      Evaluatable->False,
      CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
    Cell[54494, 1539, 475, 8, 73, "Text",
      Evaluatable->False,
      CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
    Cell[54994, 1551, 178, 4, 43, "Input",
      CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
    Cell[55175, 1557, 122, 3, 41, "Output",
      CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
    Cell[55334, 1565, 300, 9, 43, "Input",
      CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
    Cell[55637, 1576, 122, 3, 41, "Output",
      CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
    Cell[55774, 1582, 337, 6, 56, "Text",
      Evaluatable->False,
      CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
    Cell[56136, 1592, 306, 9, 43, "Input",
      CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
    Cell[56445, 1603, 124, 3, 41, "Output",
      CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
    Cell[56584, 1609, 630, 18, 56, "Text",
      Evaluatable->False,
      CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
    Cell[57217, 1629, 315, 7, 123, "Input",
      CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
    Cell[57535, 1638, 472, 16, 39, "Text",
      Evaluatable->False,
      CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
    Cell[58032, 1658, 211, 5, 43, "Input",
      CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
    Cell[58246, 1665, 124, 3, 41, "Output",
      CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
    Cell[58407, 1673, 207, 5, 43, "Input",
      CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
    Cell[58617, 1680, 178, 3, 41, "Output",
      CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
    Cell[58810, 1686, 239, 5, 39, "Text",
      Evaluatable->False,
      CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
    Cell[59074, 1695, 226, 5, 43, "Input",
      CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
    Cell[59303, 1702, 154, 3, 37, "Print",
      CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
    Cell[59460, 1707, 167, 3, 37, "Print",
      CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
    Cell[59630, 1712, 342, 6, 58, "Output",
      CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
    Cell[59987, 1721, 178, 4, 39, "Text",
      Evaluatable->False,
      CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
    Cell[60190, 1729, 212, 5, 43, "Input",
      CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
    Cell[60405, 1736, 151, 3, 41, "Output",
      CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
    Cell[60571, 1742, 190, 5, 39, "Text",
      Evaluatable->False,
      CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
    Cell[60786, 1751, 199, 5, 43, "Input",
      CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
    Cell[60988, 1758, 211, 4, 58, "Output",
      CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
    Cell[61236, 1767, 211, 5, 43, "Input",
      CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
    Cell[61450, 1774, 165, 3, 37, "Print",
      CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
    Cell[61618, 1779, 154, 3, 37, "Print",
      CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
    Cell[61775, 1784, 123, 3, 41, "Output",
      CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}]},
  "Dynamic extension"->{
    Cell[61959, 1794, 137, 3, 70, "Section",
      Evaluatable->False,
      CellTags->{"Dynamic extension", "i:20", "b:32.2"}],
    Cell[62099, 1799, 337, 7, 56, "Text",
      Evaluatable->False,
      CellTags->{"Dynamic extension", "i:20", "b:32.2"}],
    Cell[62439, 1808, 299, 7, 123, "Input",
      CellTags->{"Dynamic extension", "i:20", "b:32.2"}],
    Cell[62763, 1819, 198, 5, 43, "Input",
      CellTags->{"Dynamic extension", "i:20", "b:32.2"}],
    Cell[62964, 1826, 145, 3, 37, "Print",
      CellTags->{"Dynamic extension", "i:20", "b:32.2"}],
    Cell[63112, 1831, 226, 5, 41, "Output",
      CellTags->{"Dynamic extension", "i:20", "b:32.2"}]},
  "i:20"->{
    Cell[61959, 1794, 137, 3, 70, "Section",
      Evaluatable->False,
      CellTags->{"Dynamic extension", "i:20", "b:32.2"}],
    Cell[62099, 1799, 337, 7, 56, "Text",
      Evaluatable->False,
      CellTags->{"Dynamic extension", "i:20", "b:32.2"}],
    Cell[62439, 1808, 299, 7, 123, "Input",
      CellTags->{"Dynamic extension", "i:20", "b:32.2"}],
    Cell[62763, 1819, 198, 5, 43, "Input",
      CellTags->{"Dynamic extension", "i:20", "b:32.2"}],
    Cell[62964, 1826, 145, 3, 37, "Print",
      CellTags->{"Dynamic extension", "i:20", "b:32.2"}],
    Cell[63112, 1831, 226, 5, 41, "Output",
      CellTags->{"Dynamic extension", "i:20", "b:32.2"}]},
  "b:32.2"->{
    Cell[61959, 1794, 137, 3, 70, "Section",
      Evaluatable->False,
      CellTags->{"Dynamic extension", "i:20", "b:32.2"}],
    Cell[62099, 1799, 337, 7, 56, "Text",
      Evaluatable->False,
      CellTags->{"Dynamic extension", "i:20", "b:32.2"}],
    Cell[62439, 1808, 299, 7, 123, "Input",
      CellTags->{"Dynamic extension", "i:20", "b:32.2"}],
    Cell[62763, 1819, 198, 5, 43, "Input",
      CellTags->{"Dynamic extension", "i:20", "b:32.2"}],
    Cell[62964, 1826, 145, 3, 37, "Print",
      CellTags->{"Dynamic extension", "i:20", "b:32.2"}],
    Cell[63112, 1831, 226, 5, 41, "Output",
      CellTags->{"Dynamic extension", "i:20", "b:32.2"}]},
  "Dynamic Inverse"->{
    Cell[63387, 1842, 85, 1, 70, "Section",
      CellTags->{"Dynamic Inverse", "i:21", "b:32.3"}],
    Cell[63475, 1845, 492, 8, 73, "Text",
      CellTags->{"Dynamic Inverse", "i:21", "b:32.3"}],
    Cell[63970, 1855, 245, 5, 83, "Input",
      CellTags->{"Dynamic Inverse", "i:21", "b:32.3"}],
    Cell[64240, 1864, 161, 3, 43, "Input",
      CellTags->{"Dynamic Inverse", "i:21", "b:32.3"}],
    Cell[64404, 1869, 1051, 27, 41, "Output",
      CellTags->{"Dynamic Inverse", "i:21", "b:32.3"}],
    Cell[65470, 1899, 112, 1, 39, "Text",
      CellTags->{"Dynamic Inverse", "i:21", "b:32.3"}],
    Cell[65607, 1904, 150, 3, 43, "Input",
      CellTags->{"Dynamic Inverse", "i:21", "b:32.3"}],
    Cell[65760, 1909, 758, 19, 56, "Output",
      CellTags->{"Dynamic Inverse", "i:21", "b:32.3"}],
    Cell[66555, 1933, 118, 3, 43, "Input",
      CellTags->{"Dynamic Inverse", "i:21", "b:32.3"}],
    Cell[66676, 1938, 973, 25, 56, "Output",
      CellTags->{"Dynamic Inverse", "i:21", "b:32.3"}],
    Cell[67664, 1966, 127, 1, 39, "Text",
      CellTags->{"Dynamic Inverse", "i:21", "b:32.3"}],
    Cell[67816, 1971, 132, 3, 43, "Input",
      CellTags->{"Dynamic Inverse", "i:21", "b:32.3"}],
    Cell[67951, 1976, 143, 3, 37, "Print",
      CellTags->{"Dynamic Inverse", "i:21", "b:32.3"}],
    Cell[68097, 1981, 146, 3, 37, "Print",
      CellTags->{"Dynamic Inverse", "i:21", "b:32.3"}],
    Cell[68280, 1989, 164, 3, 43, "Input",
      CellTags->{"Dynamic Inverse", "i:21", "b:32.3"}],
    Cell[68447, 1994, 143, 3, 37, "Print",
      CellTags->{"Dynamic Inverse", "i:21", "b:32.3"}],
    Cell[68593, 1999, 231, 5, 41, "Output",
      CellTags->{"Dynamic Inverse", "i:21", "b:32.3"}],
    Cell[68861, 2009, 166, 3, 43, "Input",
      CellTags->{"Dynamic Inverse", "i:21", "b:32.3"}],
    Cell[69030, 2014, 143, 3, 37, "Print",
      CellTags->{"Dynamic Inverse", "i:21", "b:32.3"}],
    Cell[69176, 2019, 156, 3, 37, "Print",
      CellTags->{"Dynamic Inverse", "i:21", "b:32.3"}],
    Cell[69335, 2024, 196, 4, 54, "Output",
      CellTags->{"Dynamic Inverse", "i:21", "b:32.3"}],
    Cell[69568, 2033, 266, 5, 63, "Input",
      CellTags->{"Dynamic Inverse", "i:21", "b:32.3"}],
    Cell[69837, 2040, 1402, 40, 124, "Output",
      CellTags->{"Dynamic Inverse", "i:21", "b:32.3"}]},
  "i:21"->{
    Cell[63387, 1842, 85, 1, 70, "Section",
      CellTags->{"Dynamic Inverse", "i:21", "b:32.3"}],
    Cell[63475, 1845, 492, 8, 73, "Text",
      CellTags->{"Dynamic Inverse", "i:21", "b:32.3"}],
    Cell[63970, 1855, 245, 5, 83, "Input",
      CellTags->{"Dynamic Inverse", "i:21", "b:32.3"}],
    Cell[64240, 1864, 161, 3, 43, "Input",
      CellTags->{"Dynamic Inverse", "i:21", "b:32.3"}],
    Cell[64404, 1869, 1051, 27, 41, "Output",
      CellTags->{"Dynamic Inverse", "i:21", "b:32.3"}],
    Cell[65470, 1899, 112, 1, 39, "Text",
      CellTags->{"Dynamic Inverse", "i:21", "b:32.3"}],
    Cell[65607, 1904, 150, 3, 43, "Input",
      CellTags->{"Dynamic Inverse", "i:21", "b:32.3"}],
    Cell[65760, 1909, 758, 19, 56, "Output",
      CellTags->{"Dynamic Inverse", "i:21", "b:32.3"}],
    Cell[66555, 1933, 118, 3, 43, "Input",
      CellTags->{"Dynamic Inverse", "i:21", "b:32.3"}],
    Cell[66676, 1938, 973, 25, 56, "Output",
      CellTags->{"Dynamic Inverse", "i:21", "b:32.3"}],
    Cell[67664, 1966, 127, 1, 39, "Text",
      CellTags->{"Dynamic Inverse", "i:21", "b:32.3"}],
    Cell[67816, 1971, 132, 3, 43, "Input",
      CellTags->{"Dynamic Inverse", "i:21", "b:32.3"}],
    Cell[67951, 1976, 143, 3, 37, "Print",
      CellTags->{"Dynamic Inverse", "i:21", "b:32.3"}],
    Cell[68097, 1981, 146, 3, 37, "Print",
      CellTags->{"Dynamic Inverse", "i:21", "b:32.3"}],
    Cell[68280, 1989, 164, 3, 43, "Input",
      CellTags->{"Dynamic Inverse", "i:21", "b:32.3"}],
    Cell[68447, 1994, 143, 3, 37, "Print",
      CellTags->{"Dynamic Inverse", "i:21", "b:32.3"}],
    Cell[68593, 1999, 231, 5, 41, "Output",
      CellTags->{"Dynamic Inverse", "i:21", "b:32.3"}],
    Cell[68861, 2009, 166, 3, 43, "Input",
      CellTags->{"Dynamic Inverse", "i:21", "b:32.3"}],
    Cell[69030, 2014, 143, 3, 37, "Print",
      CellTags->{"Dynamic Inverse", "i:21", "b:32.3"}],
    Cell[69176, 2019, 156, 3, 37, "Print",
      CellTags->{"Dynamic Inverse", "i:21", "b:32.3"}],
    Cell[69335, 2024, 196, 4, 54, "Output",
      CellTags->{"Dynamic Inverse", "i:21", "b:32.3"}],
    Cell[69568, 2033, 266, 5, 63, "Input",
      CellTags->{"Dynamic Inverse", "i:21", "b:32.3"}],
    Cell[69837, 2040, 1402, 40, 124, "Output",
      CellTags->{"Dynamic Inverse", "i:21", "b:32.3"}]},
  "b:32.3"->{
    Cell[63387, 1842, 85, 1, 70, "Section",
      CellTags->{"Dynamic Inverse", "i:21", "b:32.3"}],
    Cell[63475, 1845, 492, 8, 73, "Text",
      CellTags->{"Dynamic Inverse", "i:21", "b:32.3"}],
    Cell[63970, 1855, 245, 5, 83, "Input",
      CellTags->{"Dynamic Inverse", "i:21", "b:32.3"}],
    Cell[64240, 1864, 161, 3, 43, "Input",
      CellTags->{"Dynamic Inverse", "i:21", "b:32.3"}],
    Cell[64404, 1869, 1051, 27, 41, "Output",
      CellTags->{"Dynamic Inverse", "i:21", "b:32.3"}],
    Cell[65470, 1899, 112, 1, 39, "Text",
      CellTags->{"Dynamic Inverse", "i:21", "b:32.3"}],
    Cell[65607, 1904, 150, 3, 43, "Input",
      CellTags->{"Dynamic Inverse", "i:21", "b:32.3"}],
    Cell[65760, 1909, 758, 19, 56, "Output",
      CellTags->{"Dynamic Inverse", "i:21", "b:32.3"}],
    Cell[66555, 1933, 118, 3, 43, "Input",
      CellTags->{"Dynamic Inverse", "i:21", "b:32.3"}],
    Cell[66676, 1938, 973, 25, 56, "Output",
      CellTags->{"Dynamic Inverse", "i:21", "b:32.3"}],
    Cell[67664, 1966, 127, 1, 39, "Text",
      CellTags->{"Dynamic Inverse", "i:21", "b:32.3"}],
    Cell[67816, 1971, 132, 3, 43, "Input",
      CellTags->{"Dynamic Inverse", "i:21", "b:32.3"}],
    Cell[67951, 1976, 143, 3, 37, "Print",
      CellTags->{"Dynamic Inverse", "i:21", "b:32.3"}],
    Cell[68097, 1981, 146, 3, 37, "Print",
      CellTags->{"Dynamic Inverse", "i:21", "b:32.3"}],
    Cell[68280, 1989, 164, 3, 43, "Input",
      CellTags->{"Dynamic Inverse", "i:21", "b:32.3"}],
    Cell[68447, 1994, 143, 3, 37, "Print",
      CellTags->{"Dynamic Inverse", "i:21", "b:32.3"}],
    Cell[68593, 1999, 231, 5, 41, "Output",
      CellTags->{"Dynamic Inverse", "i:21", "b:32.3"}],
    Cell[68861, 2009, 166, 3, 43, "Input",
      CellTags->{"Dynamic Inverse", "i:21", "b:32.3"}],
    Cell[69030, 2014, 143, 3, 37, "Print",
      CellTags->{"Dynamic Inverse", "i:21", "b:32.3"}],
    Cell[69176, 2019, 156, 3, 37, "Print",
      CellTags->{"Dynamic Inverse", "i:21", "b:32.3"}],
    Cell[69335, 2024, 196, 4, 54, "Output",
      CellTags->{"Dynamic Inverse", "i:21", "b:32.3"}],
    Cell[69568, 2033, 266, 5, 63, "Input",
      CellTags->{"Dynamic Inverse", "i:21", "b:32.3"}],
    Cell[69837, 2040, 1402, 40, 124, "Output",
      CellTags->{"Dynamic Inverse", "i:21", "b:32.3"}]},
  "Adaptive Control"->{
    Cell[71288, 2086, 125, 3, 70, "Section",
      Evaluatable->False,
      CellTags->{"Adaptive Control", "i:22"}],
    Cell[71438, 2093, 115, 2, 53, "Subsection",
      Evaluatable->False,
      CellTags->{"Adaptive Control", "i:22", "b:33.0"}],
    Cell[71556, 2097, 191, 5, 39, "Text",
      Evaluatable->False,
      CellTags->{"Adaptive Control", "i:22", "b:33.0"}],
    Cell[71750, 2104, 341, 7, 123, "Input",
      CellTags->{"Adaptive Control", "i:22", "b:33.0"}],
    Cell[72094, 2113, 243, 5, 39, "Text",
      Evaluatable->False,
      CellTags->{"Adaptive Control", "i:22", "b:33.0"}],
    Cell[72362, 2122, 328, 10, 43, "Input",
      CellTags->{"Adaptive Control", "i:22", "b:33.0"}],
    Cell[72693, 2134, 115, 3, 41, "Output",
      CellTags->{"Adaptive Control", "i:22", "b:33.0"}],
    Cell[72823, 2140, 313, 10, 43, "Input",
      CellTags->{"Adaptive Control", "i:22", "b:33.0"}],
    Cell[73139, 2152, 123, 2, 39, "Text",
      Evaluatable->False,
      CellTags->{"Adaptive Control", "i:22", "b:33.0"}],
    Cell[73287, 2158, 351, 11, 43, "Input",
      CellTags->{"Adaptive Control", "i:22", "b:33.0"}],
    Cell[73641, 2171, 145, 3, 37, "Print",
      CellTags->{"Adaptive Control", "i:22", "b:33.0"}],
    Cell[73789, 2176, 158, 3, 37, "Print",
      CellTags->{"Adaptive Control", "i:22", "b:33.0"}],
    Cell[73950, 2181, 146, 3, 37, "Print",
      CellTags->{"Adaptive Control", "i:22", "b:33.0"}],
    Cell[74099, 2186, 254, 5, 37, "Print",
      CellTags->{"Adaptive Control", "i:22", "b:33.0"}],
    Cell[74356, 2193, 146, 3, 37, "Print",
      CellTags->{"Adaptive Control", "i:22", "b:33.0"}],
    Cell[74505, 2198, 148, 3, 37, "Print",
      CellTags->{"Adaptive Control", "i:22", "b:33.0"}],
    Cell[74656, 2203, 144, 3, 37, "Print",
      CellTags->{"Adaptive Control", "i:22", "b:33.0"}],
    Cell[74803, 2208, 147, 3, 37, "Print",
      CellTags->{"Adaptive Control", "i:22", "b:33.0"}],
    Cell[74953, 2213, 542, 9, 123, "Output",
      CellTags->{"Adaptive Control", "i:22", "b:33.0"}],
    Cell[75544, 2228, 108, 1, 53, "Subsection",
      CellTags->{"Adaptive Control", "i:4", "b:33.1"}],
    Cell[75655, 2231, 1072, 25, 157, "Text",
      Evaluatable->False,
      CellTags->{"Adaptive Control", "i:4", "b:33.1"}],
    Cell[76730, 2258, 357, 11, 64, "Input",
      CellTags->{"Adaptive Control", "i:4", "b:33.1"}],
    Cell[77112, 2273, 307, 9, 43, "Input",
      CellTags->{"Adaptive Control", "i:4", "b:33.1"}],
    Cell[77422, 2284, 555, 9, 170, "Print",
      CellTags->{
      "Info3266691090-8486293", "i:3", "i:4", "b:33.1", "Adaptive Control"}],
    Cell[78014, 2298, 323, 10, 43, "Input",
      CellTags->{"Adaptive Control", "i:4", "b:33.1"}],
    Cell[78340, 2310, 283, 6, 37, "Print",
      CellTags->{"Adaptive Control", "i:4", "b:33.1"}],
    Cell[78626, 2318, 299, 6, 37, "Print",
      CellTags->{"Adaptive Control", "i:4", "b:33.1"}],
    Cell[78928, 2326, 299, 6, 37, "Print",
      CellTags->{"Adaptive Control", "i:4", "b:33.1"}],
    Cell[79230, 2334, 160, 3, 56, "Print",
      CellTags->{"Adaptive Control", "i:4", "b:33.1"}],
    Cell[79393, 2339, 273, 6, 37, "Print",
      CellTags->{"Adaptive Control", "i:4", "b:33.1"}],
    Cell[79669, 2347, 317, 6, 56, "Print",
      CellTags->{"Adaptive Control", "i:4", "b:33.1"}],
    Cell[79989, 2355, 281, 6, 37, "Print",
      CellTags->{"Adaptive Control", "i:4", "b:33.1"}],
    Cell[80273, 2363, 281, 6, 37, "Print",
      CellTags->{"Adaptive Control", "i:4", "b:33.1"}],
    Cell[80557, 2371, 281, 6, 37, "Print",
      CellTags->{"Adaptive Control", "i:4", "b:33.1"}],
    Cell[80841, 2379, 164, 3, 41, "Output",
      CellTags->{"Adaptive Control", "i:4", "b:33.1"}],
    Cell[81020, 2385, 491, 15, 39, "Text",
      Evaluatable->False,
      CellTags->{"Adaptive Control", "i:4", "b:33.1"}],
    Cell[81536, 2404, 356, 11, 43, "Input",
      CellTags->{"Adaptive Control", "i:4", "b:33.1"}],
    Cell[81895, 2417, 508, 7, 151, "Print",
      CellTags->{
      "Info3266691090-6166343", "i:4", "b:33.1", "Adaptive Control"}],
    Cell[82418, 2427, 398, 12, 43, "Input",
      CellTags->{"Adaptive Control", "i:4", "b:33.1"}],
    Cell[82841, 2443, 135, 4, 43, "Input",
      CellTags->{"Adaptive Control", "i:4", "b:33.1"}],
    Cell[82979, 2449, 2603, 43, 383, "Output",
      CellTags->{"Adaptive Control", "i:4", "b:33.1"}],
    Cell[85619, 2497, 135, 4, 43, "Input",
      CellTags->{"Adaptive Control", "i:4", "b:33.1"}],
    Cell[85757, 2503, 1066, 17, 155, "Output",
      CellTags->{"Adaptive Control", "i:4", "b:33.1"}],
    Cell[86860, 2525, 135, 4, 43, "Input",
      CellTags->{"Adaptive Control", "i:4", "b:33.1"}],
    Cell[86998, 2531, 508, 10, 79, "Output",
      CellTags->{"Adaptive Control", "i:4", "b:33.1"}],
    Cell[87555, 2547, 113, 2, 53, "Subsection",
      Evaluatable->False,
      CellTags->{"Adaptive Control", "i:22", "b:33.2"}],
    Cell[87671, 2551, 236, 6, 39, "Text",
      Evaluatable->False,
      CellTags->{"Adaptive Control", "i:22", "b:33.2"}],
    Cell[87910, 2559, 511, 11, 223, "Input",
      CellTags->{"Adaptive Control", "i:22", "b:33.2"}],
    Cell[88424, 2572, 148, 3, 39, "Text",
      Evaluatable->False,
      CellTags->{"Adaptive Control", "i:22", "b:33.2"}],
    Cell[88597, 2579, 267, 7, 43, "Input",
      CellTags->{"Adaptive Control", "i:22", "b:33.2"}],
    Cell[88867, 2588, 128, 3, 41, "Output",
      CellTags->{"Adaptive Control", "i:22", "b:33.2"}],
    Cell[89010, 2594, 163, 3, 39, "Text",
      Evaluatable->False,
      CellTags->{"Adaptive Control", "i:22", "b:33.2"}],
    Cell[89176, 2599, 217, 5, 43, "Input",
      CellTags->{"Adaptive Control", "i:22", "b:33.2"}],
    Cell[89396, 2606, 153, 3, 39, "Text",
      Evaluatable->False,
      CellTags->{"Adaptive Control", "i:22", "b:33.2"}],
    Cell[89574, 2613, 236, 6, 43, "Input",
      CellTags->{"Adaptive Control", "i:22", "b:33.2"}],
    Cell[89813, 2621, 145, 3, 37, "Print",
      CellTags->{"Adaptive Control", "i:22", "b:33.2"}],
    Cell[89961, 2626, 244, 5, 37, "Print",
      CellTags->{"Adaptive Control", "i:22", "b:33.2"}],
    Cell[90208, 2633, 135, 3, 37, "Print",
      CellTags->{"Adaptive Control", "i:22", "b:33.2"}],
    Cell[90346, 2638, 148, 3, 37, "Print",
      CellTags->{"Adaptive Control", "i:22", "b:33.2"}],
    Cell[90497, 2643, 160, 3, 37, "Print",
      CellTags->{"Adaptive Control", "i:22", "b:33.2"}],
    Cell[90660, 2648, 173, 3, 37, "Print",
      CellTags->{"Adaptive Control", "i:22", "b:33.2"}],
    Cell[90836, 2653, 24573, 470, 790, "Output",
      CellTags->{"Adaptive Control", "i:22", "b:33.2"}]},
  "i:22"->{
    Cell[71288, 2086, 125, 3, 70, "Section",
      Evaluatable->False,
      CellTags->{"Adaptive Control", "i:22"}],
    Cell[71438, 2093, 115, 2, 53, "Subsection",
      Evaluatable->False,
      CellTags->{"Adaptive Control", "i:22", "b:33.0"}],
    Cell[71556, 2097, 191, 5, 39, "Text",
      Evaluatable->False,
      CellTags->{"Adaptive Control", "i:22", "b:33.0"}],
    Cell[71750, 2104, 341, 7, 123, "Input",
      CellTags->{"Adaptive Control", "i:22", "b:33.0"}],
    Cell[72094, 2113, 243, 5, 39, "Text",
      Evaluatable->False,
      CellTags->{"Adaptive Control", "i:22", "b:33.0"}],
    Cell[72362, 2122, 328, 10, 43, "Input",
      CellTags->{"Adaptive Control", "i:22", "b:33.0"}],
    Cell[72693, 2134, 115, 3, 41, "Output",
      CellTags->{"Adaptive Control", "i:22", "b:33.0"}],
    Cell[72823, 2140, 313, 10, 43, "Input",
      CellTags->{"Adaptive Control", "i:22", "b:33.0"}],
    Cell[73139, 2152, 123, 2, 39, "Text",
      Evaluatable->False,
      CellTags->{"Adaptive Control", "i:22", "b:33.0"}],
    Cell[73287, 2158, 351, 11, 43, "Input",
      CellTags->{"Adaptive Control", "i:22", "b:33.0"}],
    Cell[73641, 2171, 145, 3, 37, "Print",
      CellTags->{"Adaptive Control", "i:22", "b:33.0"}],
    Cell[73789, 2176, 158, 3, 37, "Print",
      CellTags->{"Adaptive Control", "i:22", "b:33.0"}],
    Cell[73950, 2181, 146, 3, 37, "Print",
      CellTags->{"Adaptive Control", "i:22", "b:33.0"}],
    Cell[74099, 2186, 254, 5, 37, "Print",
      CellTags->{"Adaptive Control", "i:22", "b:33.0"}],
    Cell[74356, 2193, 146, 3, 37, "Print",
      CellTags->{"Adaptive Control", "i:22", "b:33.0"}],
    Cell[74505, 2198, 148, 3, 37, "Print",
      CellTags->{"Adaptive Control", "i:22", "b:33.0"}],
    Cell[74656, 2203, 144, 3, 37, "Print",
      CellTags->{"Adaptive Control", "i:22", "b:33.0"}],
    Cell[74803, 2208, 147, 3, 37, "Print",
      CellTags->{"Adaptive Control", "i:22", "b:33.0"}],
    Cell[74953, 2213, 542, 9, 123, "Output",
      CellTags->{"Adaptive Control", "i:22", "b:33.0"}],
    Cell[87555, 2547, 113, 2, 53, "Subsection",
      Evaluatable->False,
      CellTags->{"Adaptive Control", "i:22", "b:33.2"}],
    Cell[87671, 2551, 236, 6, 39, "Text",
      Evaluatable->False,
      CellTags->{"Adaptive Control", "i:22", "b:33.2"}],
    Cell[87910, 2559, 511, 11, 223, "Input",
      CellTags->{"Adaptive Control", "i:22", "b:33.2"}],
    Cell[88424, 2572, 148, 3, 39, "Text",
      Evaluatable->False,
      CellTags->{"Adaptive Control", "i:22", "b:33.2"}],
    Cell[88597, 2579, 267, 7, 43, "Input",
      CellTags->{"Adaptive Control", "i:22", "b:33.2"}],
    Cell[88867, 2588, 128, 3, 41, "Output",
      CellTags->{"Adaptive Control", "i:22", "b:33.2"}],
    Cell[89010, 2594, 163, 3, 39, "Text",
      Evaluatable->False,
      CellTags->{"Adaptive Control", "i:22", "b:33.2"}],
    Cell[89176, 2599, 217, 5, 43, "Input",
      CellTags->{"Adaptive Control", "i:22", "b:33.2"}],
    Cell[89396, 2606, 153, 3, 39, "Text",
      Evaluatable->False,
      CellTags->{"Adaptive Control", "i:22", "b:33.2"}],
    Cell[89574, 2613, 236, 6, 43, "Input",
      CellTags->{"Adaptive Control", "i:22", "b:33.2"}],
    Cell[89813, 2621, 145, 3, 37, "Print",
      CellTags->{"Adaptive Control", "i:22", "b:33.2"}],
    Cell[89961, 2626, 244, 5, 37, "Print",
      CellTags->{"Adaptive Control", "i:22", "b:33.2"}],
    Cell[90208, 2633, 135, 3, 37, "Print",
      CellTags->{"Adaptive Control", "i:22", "b:33.2"}],
    Cell[90346, 2638, 148, 3, 37, "Print",
      CellTags->{"Adaptive Control", "i:22", "b:33.2"}],
    Cell[90497, 2643, 160, 3, 37, "Print",
      CellTags->{"Adaptive Control", "i:22", "b:33.2"}],
    Cell[90660, 2648, 173, 3, 37, "Print",
      CellTags->{"Adaptive Control", "i:22", "b:33.2"}],
    Cell[90836, 2653, 24573, 470, 790, "Output",
      CellTags->{"Adaptive Control", "i:22", "b:33.2"}]},
  "b:33.0"->{
    Cell[71438, 2093, 115, 2, 53, "Subsection",
      Evaluatable->False,
      CellTags->{"Adaptive Control", "i:22", "b:33.0"}],
    Cell[71556, 2097, 191, 5, 39, "Text",
      Evaluatable->False,
      CellTags->{"Adaptive Control", "i:22", "b:33.0"}],
    Cell[71750, 2104, 341, 7, 123, "Input",
      CellTags->{"Adaptive Control", "i:22", "b:33.0"}],
    Cell[72094, 2113, 243, 5, 39, "Text",
      Evaluatable->False,
      CellTags->{"Adaptive Control", "i:22", "b:33.0"}],
    Cell[72362, 2122, 328, 10, 43, "Input",
      CellTags->{"Adaptive Control", "i:22", "b:33.0"}],
    Cell[72693, 2134, 115, 3, 41, "Output",
      CellTags->{"Adaptive Control", "i:22", "b:33.0"}],
    Cell[72823, 2140, 313, 10, 43, "Input",
      CellTags->{"Adaptive Control", "i:22", "b:33.0"}],
    Cell[73139, 2152, 123, 2, 39, "Text",
      Evaluatable->False,
      CellTags->{"Adaptive Control", "i:22", "b:33.0"}],
    Cell[73287, 2158, 351, 11, 43, "Input",
      CellTags->{"Adaptive Control", "i:22", "b:33.0"}],
    Cell[73641, 2171, 145, 3, 37, "Print",
      CellTags->{"Adaptive Control", "i:22", "b:33.0"}],
    Cell[73789, 2176, 158, 3, 37, "Print",
      CellTags->{"Adaptive Control", "i:22", "b:33.0"}],
    Cell[73950, 2181, 146, 3, 37, "Print",
      CellTags->{"Adaptive Control", "i:22", "b:33.0"}],
    Cell[74099, 2186, 254, 5, 37, "Print",
      CellTags->{"Adaptive Control", "i:22", "b:33.0"}],
    Cell[74356, 2193, 146, 3, 37, "Print",
      CellTags->{"Adaptive Control", "i:22", "b:33.0"}],
    Cell[74505, 2198, 148, 3, 37, "Print",
      CellTags->{"Adaptive Control", "i:22", "b:33.0"}],
    Cell[74656, 2203, 144, 3, 37, "Print",
      CellTags->{"Adaptive Control", "i:22", "b:33.0"}],
    Cell[74803, 2208, 147, 3, 37, "Print",
      CellTags->{"Adaptive Control", "i:22", "b:33.0"}],
    Cell[74953, 2213, 542, 9, 123, "Output",
      CellTags->{"Adaptive Control", "i:22", "b:33.0"}]},
  "i:4"->{
    Cell[75544, 2228, 108, 1, 53, "Subsection",
      CellTags->{"Adaptive Control", "i:4", "b:33.1"}],
    Cell[75655, 2231, 1072, 25, 157, "Text",
      Evaluatable->False,
      CellTags->{"Adaptive Control", "i:4", "b:33.1"}],
    Cell[76730, 2258, 357, 11, 64, "Input",
      CellTags->{"Adaptive Control", "i:4", "b:33.1"}],
    Cell[77112, 2273, 307, 9, 43, "Input",
      CellTags->{"Adaptive Control", "i:4", "b:33.1"}],
    Cell[77422, 2284, 555, 9, 170, "Print",
      CellTags->{
      "Info3266691090-8486293", "i:3", "i:4", "b:33.1", "Adaptive Control"}],
    Cell[78014, 2298, 323, 10, 43, "Input",
      CellTags->{"Adaptive Control", "i:4", "b:33.1"}],
    Cell[78340, 2310, 283, 6, 37, "Print",
      CellTags->{"Adaptive Control", "i:4", "b:33.1"}],
    Cell[78626, 2318, 299, 6, 37, "Print",
      CellTags->{"Adaptive Control", "i:4", "b:33.1"}],
    Cell[78928, 2326, 299, 6, 37, "Print",
      CellTags->{"Adaptive Control", "i:4", "b:33.1"}],
    Cell[79230, 2334, 160, 3, 56, "Print",
      CellTags->{"Adaptive Control", "i:4", "b:33.1"}],
    Cell[79393, 2339, 273, 6, 37, "Print",
      CellTags->{"Adaptive Control", "i:4", "b:33.1"}],
    Cell[79669, 2347, 317, 6, 56, "Print",
      CellTags->{"Adaptive Control", "i:4", "b:33.1"}],
    Cell[79989, 2355, 281, 6, 37, "Print",
      CellTags->{"Adaptive Control", "i:4", "b:33.1"}],
    Cell[80273, 2363, 281, 6, 37, "Print",
      CellTags->{"Adaptive Control", "i:4", "b:33.1"}],
    Cell[80557, 2371, 281, 6, 37, "Print",
      CellTags->{"Adaptive Control", "i:4", "b:33.1"}],
    Cell[80841, 2379, 164, 3, 41, "Output",
      CellTags->{"Adaptive Control", "i:4", "b:33.1"}],
    Cell[81020, 2385, 491, 15, 39, "Text",
      Evaluatable->False,
      CellTags->{"Adaptive Control", "i:4", "b:33.1"}],
    Cell[81536, 2404, 356, 11, 43, "Input",
      CellTags->{"Adaptive Control", "i:4", "b:33.1"}],
    Cell[81895, 2417, 508, 7, 151, "Print",
      CellTags->{
      "Info3266691090-6166343", "i:4", "b:33.1", "Adaptive Control"}],
    Cell[82418, 2427, 398, 12, 43, "Input",
      CellTags->{"Adaptive Control", "i:4", "b:33.1"}],
    Cell[82841, 2443, 135, 4, 43, "Input",
      CellTags->{"Adaptive Control", "i:4", "b:33.1"}],
    Cell[82979, 2449, 2603, 43, 383, "Output",
      CellTags->{"Adaptive Control", "i:4", "b:33.1"}],
    Cell[85619, 2497, 135, 4, 43, "Input",
      CellTags->{"Adaptive Control", "i:4", "b:33.1"}],
    Cell[85757, 2503, 1066, 17, 155, "Output",
      CellTags->{"Adaptive Control", "i:4", "b:33.1"}],
    Cell[86860, 2525, 135, 4, 43, "Input",
      CellTags->{"Adaptive Control", "i:4", "b:33.1"}],
    Cell[86998, 2531, 508, 10, 79, "Output",
      CellTags->{"Adaptive Control", "i:4", "b:33.1"}]},
  "b:33.1"->{
    Cell[75544, 2228, 108, 1, 53, "Subsection",
      CellTags->{"Adaptive Control", "i:4", "b:33.1"}],
    Cell[75655, 2231, 1072, 25, 157, "Text",
      Evaluatable->False,
      CellTags->{"Adaptive Control", "i:4", "b:33.1"}],
    Cell[76730, 2258, 357, 11, 64, "Input",
      CellTags->{"Adaptive Control", "i:4", "b:33.1"}],
    Cell[77112, 2273, 307, 9, 43, "Input",
      CellTags->{"Adaptive Control", "i:4", "b:33.1"}],
    Cell[77422, 2284, 555, 9, 170, "Print",
      CellTags->{
      "Info3266691090-8486293", "i:3", "i:4", "b:33.1", "Adaptive Control"}],
    Cell[78014, 2298, 323, 10, 43, "Input",
      CellTags->{"Adaptive Control", "i:4", "b:33.1"}],
    Cell[78340, 2310, 283, 6, 37, "Print",
      CellTags->{"Adaptive Control", "i:4", "b:33.1"}],
    Cell[78626, 2318, 299, 6, 37, "Print",
      CellTags->{"Adaptive Control", "i:4", "b:33.1"}],
    Cell[78928, 2326, 299, 6, 37, "Print",
      CellTags->{"Adaptive Control", "i:4", "b:33.1"}],
    Cell[79230, 2334, 160, 3, 56, "Print",
      CellTags->{"Adaptive Control", "i:4", "b:33.1"}],
    Cell[79393, 2339, 273, 6, 37, "Print",
      CellTags->{"Adaptive Control", "i:4", "b:33.1"}],
    Cell[79669, 2347, 317, 6, 56, "Print",
      CellTags->{"Adaptive Control", "i:4", "b:33.1"}],
    Cell[79989, 2355, 281, 6, 37, "Print",
      CellTags->{"Adaptive Control", "i:4", "b:33.1"}],
    Cell[80273, 2363, 281, 6, 37, "Print",
      CellTags->{"Adaptive Control", "i:4", "b:33.1"}],
    Cell[80557, 2371, 281, 6, 37, "Print",
      CellTags->{"Adaptive Control", "i:4", "b:33.1"}],
    Cell[80841, 2379, 164, 3, 41, "Output",
      CellTags->{"Adaptive Control", "i:4", "b:33.1"}],
    Cell[81020, 2385, 491, 15, 39, "Text",
      Evaluatable->False,
      CellTags->{"Adaptive Control", "i:4", "b:33.1"}],
    Cell[81536, 2404, 356, 11, 43, "Input",
      CellTags->{"Adaptive Control", "i:4", "b:33.1"}],
    Cell[81895, 2417, 508, 7, 151, "Print",
      CellTags->{
      "Info3266691090-6166343", "i:4", "b:33.1", "Adaptive Control"}],
    Cell[82418, 2427, 398, 12, 43, "Input",
      CellTags->{"Adaptive Control", "i:4", "b:33.1"}],
    Cell[82841, 2443, 135, 4, 43, "Input",
      CellTags->{"Adaptive Control", "i:4", "b:33.1"}],
    Cell[82979, 2449, 2603, 43, 383, "Output",
      CellTags->{"Adaptive Control", "i:4", "b:33.1"}],
    Cell[85619, 2497, 135, 4, 43, "Input",
      CellTags->{"Adaptive Control", "i:4", "b:33.1"}],
    Cell[85757, 2503, 1066, 17, 155, "Output",
      CellTags->{"Adaptive Control", "i:4", "b:33.1"}],
    Cell[86860, 2525, 135, 4, 43, "Input",
      CellTags->{"Adaptive Control", "i:4", "b:33.1"}],
    Cell[86998, 2531, 508, 10, 79, "Output",
      CellTags->{"Adaptive Control", "i:4", "b:33.1"}]},
  "Info3266691090-8486293"->{
    Cell[77422, 2284, 555, 9, 170, "Print",
      CellTags->{
      "Info3266691090-8486293", "i:3", "i:4", "b:33.1", 
        "Adaptive Control"}]},
  "i:3"->{
    Cell[77422, 2284, 555, 9, 170, "Print",
      CellTags->{
      "Info3266691090-8486293", "i:3", "i:4", "b:33.1", 
        "Adaptive Control"}]},
  "Info3266691090-6166343"->{
    Cell[81895, 2417, 508, 7, 151, "Print",
      CellTags->{
      "Info3266691090-6166343", "i:4", "b:33.1", "Adaptive Control"}]},
  "b:33.2"->{
    Cell[87555, 2547, 113, 2, 53, "Subsection",
      Evaluatable->False,
      CellTags->{"Adaptive Control", "i:22", "b:33.2"}],
    Cell[87671, 2551, 236, 6, 39, "Text",
      Evaluatable->False,
      CellTags->{"Adaptive Control", "i:22", "b:33.2"}],
    Cell[87910, 2559, 511, 11, 223, "Input",
      CellTags->{"Adaptive Control", "i:22", "b:33.2"}],
    Cell[88424, 2572, 148, 3, 39, "Text",
      Evaluatable->False,
      CellTags->{"Adaptive Control", "i:22", "b:33.2"}],
    Cell[88597, 2579, 267, 7, 43, "Input",
      CellTags->{"Adaptive Control", "i:22", "b:33.2"}],
    Cell[88867, 2588, 128, 3, 41, "Output",
      CellTags->{"Adaptive Control", "i:22", "b:33.2"}],
    Cell[89010, 2594, 163, 3, 39, "Text",
      Evaluatable->False,
      CellTags->{"Adaptive Control", "i:22", "b:33.2"}],
    Cell[89176, 2599, 217, 5, 43, "Input",
      CellTags->{"Adaptive Control", "i:22", "b:33.2"}],
    Cell[89396, 2606, 153, 3, 39, "Text",
      Evaluatable->False,
      CellTags->{"Adaptive Control", "i:22", "b:33.2"}],
    Cell[89574, 2613, 236, 6, 43, "Input",
      CellTags->{"Adaptive Control", "i:22", "b:33.2"}],
    Cell[89813, 2621, 145, 3, 37, "Print",
      CellTags->{"Adaptive Control", "i:22", "b:33.2"}],
    Cell[89961, 2626, 244, 5, 37, "Print",
      CellTags->{"Adaptive Control", "i:22", "b:33.2"}],
    Cell[90208, 2633, 135, 3, 37, "Print",
      CellTags->{"Adaptive Control", "i:22", "b:33.2"}],
    Cell[90346, 2638, 148, 3, 37, "Print",
      CellTags->{"Adaptive Control", "i:22", "b:33.2"}],
    Cell[90497, 2643, 160, 3, 37, "Print",
      CellTags->{"Adaptive Control", "i:22", "b:33.2"}],
    Cell[90660, 2648, 173, 3, 37, "Print",
      CellTags->{"Adaptive Control", "i:22", "b:33.2"}],
    Cell[90836, 2653, 24573, 470, 790, "Output",
      CellTags->{"Adaptive Control", "i:22", "b:33.2"}]},
  "Creating SIMULINK S-Functions"->{
    Cell[115470, 3130, 133, 2, 70, "Section",
      Evaluatable->False,
      CellTags->{"Creating SIMULINK S-Functions", "i:23", "b:34"}],
    Cell[116542, 3157, 1022, 16, 149, "Text",
      Evaluatable->False,
      CellTags->{"Creating SIMULINK S-Functions", "i:23", "b:34"}],
    Cell[117567, 3175, 619, 17, 155, "Input",
      CellTags->{"Creating SIMULINK S-Functions", "i:23", "b:34"}],
    Cell[118211, 3196, 294, 9, 43, "Input",
      CellTags->{"Creating SIMULINK S-Functions", "i:23", "b:34"}],
    Cell[118508, 3207, 262, 5, 58, "Output",
      CellTags->{"Creating SIMULINK S-Functions", "i:23", "b:34"}],
    Cell[118785, 3215, 199, 5, 39, "Text",
      Evaluatable->False,
      CellTags->{"Creating SIMULINK S-Functions", "i:23", "b:34"}],
    Cell[119009, 3224, 358, 10, 43, "Input",
      CellTags->{"Creating SIMULINK S-Functions", "i:23", "b:34"}],
    Cell[119370, 3236, 167, 3, 37, "Print",
      CellTags->{"Creating SIMULINK S-Functions", "i:23", "b:34"}],
    Cell[119540, 3241, 154, 3, 37, "Print",
      CellTags->{"Creating SIMULINK S-Functions", "i:23", "b:34"}],
    Cell[119697, 3246, 174, 3, 37, "Print",
      CellTags->{"Creating SIMULINK S-Functions", "i:23", "b:34"}],
    Cell[119874, 3251, 173, 3, 37, "Print",
      CellTags->{"Creating SIMULINK S-Functions", "i:23", "b:34"}],
    Cell[120050, 3256, 155, 3, 37, "Print",
      CellTags->{"Creating SIMULINK S-Functions", "i:23", "b:34"}],
    Cell[120208, 3261, 169, 3, 37, "Print",
      CellTags->{"Creating SIMULINK S-Functions", "i:23", "b:34"}],
    Cell[120380, 3266, 164, 3, 37, "Print",
      CellTags->{"Creating SIMULINK S-Functions", "i:23", "b:34"}],
    Cell[120547, 3271, 163, 3, 37, "Print",
      CellTags->{"Creating SIMULINK S-Functions", "i:23", "b:34"}],
    Cell[120713, 3276, 164, 3, 37, "Print",
      CellTags->{"Creating SIMULINK S-Functions", "i:23", "b:34"}],
    Cell[120892, 3282, 503, 9, 73, "Text",
      Evaluatable->False,
      CellTags->{"Creating SIMULINK S-Functions", "i:23", "b:34"}],
    Cell[121420, 3295, 361, 10, 43, "Input",
      CellTags->{"Creating SIMULINK S-Functions", "i:23", "b:34"}],
    Cell[121784, 3307, 154, 3, 37, "Print",
      CellTags->{"Creating SIMULINK S-Functions", "i:23", "b:34"}],
    Cell[121941, 3312, 174, 3, 37, "Print",
      CellTags->{"Creating SIMULINK S-Functions", "i:23", "b:34"}],
    Cell[122118, 3317, 173, 3, 37, "Print",
      CellTags->{"Creating SIMULINK S-Functions", "i:23", "b:34"}],
    Cell[122294, 3322, 155, 3, 37, "Print",
      CellTags->{"Creating SIMULINK S-Functions", "i:23", "b:34"}],
    Cell[122452, 3327, 169, 3, 37, "Print",
      CellTags->{"Creating SIMULINK S-Functions", "i:23", "b:34"}],
    Cell[122624, 3332, 164, 3, 37, "Print",
      CellTags->{"Creating SIMULINK S-Functions", "i:23", "b:34"}],
    Cell[122791, 3337, 163, 3, 37, "Print",
      CellTags->{"Creating SIMULINK S-Functions", "i:23", "b:34"}],
    Cell[122957, 3342, 165, 3, 37, "Print",
      CellTags->{"Creating SIMULINK S-Functions", "i:23", "b:34"}]},
  "i:23"->{
    Cell[115470, 3130, 133, 2, 70, "Section",
      Evaluatable->False,
      CellTags->{"Creating SIMULINK S-Functions", "i:23", "b:34"}],
    Cell[116542, 3157, 1022, 16, 149, "Text",
      Evaluatable->False,
      CellTags->{"Creating SIMULINK S-Functions", "i:23", "b:34"}],
    Cell[117567, 3175, 619, 17, 155, "Input",
      CellTags->{"Creating SIMULINK S-Functions", "i:23", "b:34"}],
    Cell[118211, 3196, 294, 9, 43, "Input",
      CellTags->{"Creating SIMULINK S-Functions", "i:23", "b:34"}],
    Cell[118508, 3207, 262, 5, 58, "Output",
      CellTags->{"Creating SIMULINK S-Functions", "i:23", "b:34"}],
    Cell[118785, 3215, 199, 5, 39, "Text",
      Evaluatable->False,
      CellTags->{"Creating SIMULINK S-Functions", "i:23", "b:34"}],
    Cell[119009, 3224, 358, 10, 43, "Input",
      CellTags->{"Creating SIMULINK S-Functions", "i:23", "b:34"}],
    Cell[119370, 3236, 167, 3, 37, "Print",
      CellTags->{"Creating SIMULINK S-Functions", "i:23", "b:34"}],
    Cell[119540, 3241, 154, 3, 37, "Print",
      CellTags->{"Creating SIMULINK S-Functions", "i:23", "b:34"}],
    Cell[119697, 3246, 174, 3, 37, "Print",
      CellTags->{"Creating SIMULINK S-Functions", "i:23", "b:34"}],
    Cell[119874, 3251, 173, 3, 37, "Print",
      CellTags->{"Creating SIMULINK S-Functions", "i:23", "b:34"}],
    Cell[120050, 3256, 155, 3, 37, "Print",
      CellTags->{"Creating SIMULINK S-Functions", "i:23", "b:34"}],
    Cell[120208, 3261, 169, 3, 37, "Print",
      CellTags->{"Creating SIMULINK S-Functions", "i:23", "b:34"}],
    Cell[120380, 3266, 164, 3, 37, "Print",
      CellTags->{"Creating SIMULINK S-Functions", "i:23", "b:34"}],
    Cell[120547, 3271, 163, 3, 37, "Print",
      CellTags->{"Creating SIMULINK S-Functions", "i:23", "b:34"}],
    Cell[120713, 3276, 164, 3, 37, "Print",
      CellTags->{"Creating SIMULINK S-Functions", "i:23", "b:34"}],
    Cell[120892, 3282, 503, 9, 73, "Text",
      Evaluatable->False,
      CellTags->{"Creating SIMULINK S-Functions", "i:23", "b:34"}],
    Cell[121420, 3295, 361, 10, 43, "Input",
      CellTags->{"Creating SIMULINK S-Functions", "i:23", "b:34"}],
    Cell[121784, 3307, 154, 3, 37, "Print",
      CellTags->{"Creating SIMULINK S-Functions", "i:23", "b:34"}],
    Cell[121941, 3312, 174, 3, 37, "Print",
      CellTags->{"Creating SIMULINK S-Functions", "i:23", "b:34"}],
    Cell[122118, 3317, 173, 3, 37, "Print",
      CellTags->{"Creating SIMULINK S-Functions", "i:23", "b:34"}],
    Cell[122294, 3322, 155, 3, 37, "Print",
      CellTags->{"Creating SIMULINK S-Functions", "i:23", "b:34"}],
    Cell[122452, 3327, 169, 3, 37, "Print",
      CellTags->{"Creating SIMULINK S-Functions", "i:23", "b:34"}],
    Cell[122624, 3332, 164, 3, 37, "Print",
      CellTags->{"Creating SIMULINK S-Functions", "i:23", "b:34"}],
    Cell[122791, 3337, 163, 3, 37, "Print",
      CellTags->{"Creating SIMULINK S-Functions", "i:23", "b:34"}],
    Cell[122957, 3342, 165, 3, 37, "Print",
      CellTags->{"Creating SIMULINK S-Functions", "i:23", "b:34"}]},
  "b:34"->{
    Cell[115470, 3130, 133, 2, 70, "Section",
      Evaluatable->False,
      CellTags->{"Creating SIMULINK S-Functions", "i:23", "b:34"}],
    Cell[115628, 3136, 185, 5, 63, "Input",
      CellTags->"b:34"],
    Cell[115816, 3143, 711, 11, 417, "Print",
      CellTags->"b:34"],
    Cell[116542, 3157, 1022, 16, 149, "Text",
      Evaluatable->False,
      CellTags->{"Creating SIMULINK S-Functions", "i:23", "b:34"}],
    Cell[117567, 3175, 619, 17, 155, "Input",
      CellTags->{"Creating SIMULINK S-Functions", "i:23", "b:34"}],
    Cell[118211, 3196, 294, 9, 43, "Input",
      CellTags->{"Creating SIMULINK S-Functions", "i:23", "b:34"}],
    Cell[118508, 3207, 262, 5, 58, "Output",
      CellTags->{"Creating SIMULINK S-Functions", "i:23", "b:34"}],
    Cell[118785, 3215, 199, 5, 39, "Text",
      Evaluatable->False,
      CellTags->{"Creating SIMULINK S-Functions", "i:23", "b:34"}],
    Cell[119009, 3224, 358, 10, 43, "Input",
      CellTags->{"Creating SIMULINK S-Functions", "i:23", "b:34"}],
    Cell[119370, 3236, 167, 3, 37, "Print",
      CellTags->{"Creating SIMULINK S-Functions", "i:23", "b:34"}],
    Cell[119540, 3241, 154, 3, 37, "Print",
      CellTags->{"Creating SIMULINK S-Functions", "i:23", "b:34"}],
    Cell[119697, 3246, 174, 3, 37, "Print",
      CellTags->{"Creating SIMULINK S-Functions", "i:23", "b:34"}],
    Cell[119874, 3251, 173, 3, 37, "Print",
      CellTags->{"Creating SIMULINK S-Functions", "i:23", "b:34"}],
    Cell[120050, 3256, 155, 3, 37, "Print",
      CellTags->{"Creating SIMULINK S-Functions", "i:23", "b:34"}],
    Cell[120208, 3261, 169, 3, 37, "Print",
      CellTags->{"Creating SIMULINK S-Functions", "i:23", "b:34"}],
    Cell[120380, 3266, 164, 3, 37, "Print",
      CellTags->{"Creating SIMULINK S-Functions", "i:23", "b:34"}],
    Cell[120547, 3271, 163, 3, 37, "Print",
      CellTags->{"Creating SIMULINK S-Functions", "i:23", "b:34"}],
    Cell[120713, 3276, 164, 3, 37, "Print",
      CellTags->{"Creating SIMULINK S-Functions", "i:23", "b:34"}],
    Cell[120892, 3282, 503, 9, 73, "Text",
      Evaluatable->False,
      CellTags->{"Creating SIMULINK S-Functions", "i:23", "b:34"}],
    Cell[121420, 3295, 361, 10, 43, "Input",
      CellTags->{"Creating SIMULINK S-Functions", "i:23", "b:34"}],
    Cell[121784, 3307, 154, 3, 37, "Print",
      CellTags->{"Creating SIMULINK S-Functions", "i:23", "b:34"}],
    Cell[121941, 3312, 174, 3, 37, "Print",
      CellTags->{"Creating SIMULINK S-Functions", "i:23", "b:34"}],
    Cell[122118, 3317, 173, 3, 37, "Print",
      CellTags->{"Creating SIMULINK S-Functions", "i:23", "b:34"}],
    Cell[122294, 3322, 155, 3, 37, "Print",
      CellTags->{"Creating SIMULINK S-Functions", "i:23", "b:34"}],
    Cell[122452, 3327, 169, 3, 37, "Print",
      CellTags->{"Creating SIMULINK S-Functions", "i:23", "b:34"}],
    Cell[122624, 3332, 164, 3, 37, "Print",
      CellTags->{"Creating SIMULINK S-Functions", "i:23", "b:34"}],
    Cell[122791, 3337, 163, 3, 37, "Print",
      CellTags->{"Creating SIMULINK S-Functions", "i:23", "b:34"}],
    Cell[122957, 3342, 165, 3, 37, "Print",
      CellTags->{"Creating SIMULINK S-Functions", "i:23", "b:34"}]},
  "Bibliography"->{
    Cell[123171, 3351, 69, 1, 70, "Section",
      CellTags->{"Bibliography", "b:35"}],
    Cell[123243, 3354, 850, 17, 256, "Text",
      CellTags->"Bibliography"],
    Cell[124096, 3373, 1025, 20, 264, "Text",
      CellTags->{"Bibliography", "b:35"}]},
  "b:35"->{
    Cell[123171, 3351, 69, 1, 70, "Section",
      CellTags->{"Bibliography", "b:35"}],
    Cell[124096, 3373, 1025, 20, 264, "Text",
      CellTags->{"Bibliography", "b:35"}]}
  }
*)

(*CellTagsIndex
CellTagsIndex->{
  {"Getting Started Nonlinear", 128242, 3448},
  {"b:29", 129010, 3466},
  {"b:30", 129778, 3484},
  {"Package", 130155, 3495},
  {"Controllability & Observability", 130462, 3503},
  {"i:17", 134731, 3580},
  {"b:31.0", 137525, 3631},
  {"Info3266691080-3602776", 139275, 3664},
  {"i:16", 139387, 3667},
  {"Info3266691083-3296927", 139677, 3674},
  {"i:1", 139786, 3677},
  {"b:31.1", 141382, 3706},
  {"Info3266691083-3416360", 142994, 3735},
  {"b:31.2", 143113, 3738},
  {"Info3266691083-1465963", 144392, 3761},
  {"i:2", 144502, 3764},
  {"b:32.0", 148375, 3834},
  {"Exact Feedback Linearization", 152270, 3904},
  {"i:18", 156141, 3974},
  {"Input-Output Linearization", 159922, 4042},
  {"i:19", 167431, 4187},
  {"b:32.1", 174942, 4332},
  {"Dynamic extension", 182464, 4477},
  {"i:20", 183138, 4492},
  {"b:32.2", 183814, 4507},
  {"Dynamic Inverse", 184499, 4522},
  {"i:21", 186800, 4569},
  {"b:32.3", 189103, 4616},
  {"Adaptive Control", 191416, 4663},
  {"i:22", 198023, 4802},
  {"b:33.0", 201909, 4885},
  {"i:4", 203834, 4926},
  {"b:33.1", 206572, 4983},
  {"Info3266691090-8486293", 209326, 5040},
  {"i:3", 209487, 5045},
  {"Info3266691090-6166343", 209667, 5050},
  {"b:33.2", 209815, 5054},
  {"Creating SIMULINK S-Functions", 211693, 5094},
  {"i:23", 214729, 5151},
  {"b:34", 217765, 5208},
  {"Bibliography", 220949, 5269},
  {"b:35", 221217, 5276}
  }
*)

(*NotebookFileOutline
Notebook[{

Cell[CellGroupData[{
Cell[1776, 53, 133, 3, 70, "Section",
  Evaluatable->False,
  CellTags->{"Getting Started Nonlinear", "b:29"}],
Cell[1912, 58, 176, 4, 63, "Input",
  CellTags->{"Getting Started Nonlinear", "b:29"}],
Cell[2091, 64, 817, 16, 107, "Text",
  Evaluatable->False,
  CellTags->{"Getting Started Nonlinear", "b:29"}],
Cell[2911, 82, 276, 9, 39, "Text",
  Evaluatable->False,
  CellTags->{"Getting Started Nonlinear", "b:29"}],

Cell[CellGroupData[{
Cell[3212, 95, 150, 4, 45, "Input",
  CellTags->{"Getting Started Nonlinear", "b:29"}],
Cell[3365, 101, 740, 11, 417, "Print",
  CellTags->{"Getting Started Nonlinear", "b:29"}]
}, Open  ]],
Cell[4120, 115, 182, 6, 39, "Text",
  CellTags->{"Getting Started Nonlinear", "b:29"}]
}, Open  ]],

Cell[CellGroupData[{
Cell[4339, 126, 116, 3, 70, "Section",
  Evaluatable->False,
  CellTags->"b:30"],
Cell[4458, 131, 265, 7, 56, "Text",
  Evaluatable->False,
  CellTags->{"Package", "b:30"}],

Cell[CellGroupData[{
Cell[4748, 142, 112, 3, 43, "Input",
  CellTags->{"b:30", "Package"}],
Cell[4863, 147, 19277, 444, 245, "Print",
  CellTags->{"b:30", "Package"}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[24189, 597, 107, 1, 70, "Section",
  CellTags->{"Controllability & Observability", "i:17"}],

Cell[CellGroupData[{
Cell[24321, 602, 104, 1, 53, "Subsection",
  CellTags->{"Controllability & Observability", "i:17", "b:31.0"}],

Cell[CellGroupData[{
Cell[24450, 607, 148, 3, 43, "Input",
  CellTags->{"Controllability & Observability", "i:17", "b:31.0"}],
Cell[24601, 612, 174, 3, 37, "Print",
  CellTags->{"Controllability & Observability", "i:17", "b:31.0"}],
Cell[24778, 617, 177, 3, 37, "Print",
  CellTags->{"Controllability & Observability", "i:17", "b:31.0"}],
Cell[24958, 622, 669, 10, 265, "Print",
  CellTags->{"Info3266691080-3602776", "b:31.0"}]
}, Open  ]],

Cell[CellGroupData[{
Cell[25664, 637, 397, 8, 143, "Input",
  CellTags->{"Controllability & Observability", "i:17", "b:31.0"}],
Cell[26064, 647, 370, 10, 82, "Output",
  CellTags->{"Controllability & Observability", "i:17", "b:31.0"}]
}, Open  ]],

Cell[CellGroupData[{
Cell[26471, 662, 205, 4, 43, "Input",
  CellTags->{"Controllability & Observability", "i:16", "i:17", "b:31.0"}],
Cell[26679, 668, 361, 9, 66, "Output",
  CellTags->{"Controllability & Observability", "i:16", "i:17", "b:31.0"}]
}, Open  ]],

Cell[CellGroupData[{
Cell[27077, 682, 145, 3, 43, "Input",
  CellTags->{"Controllability & Observability", "i:17", "b:31.0"}],
Cell[27225, 687, 374, 5, 94, "Print",
  CellTags->{"Info3266691083-3296927", "b:31.0"}]
}, Open  ]],

Cell[CellGroupData[{
Cell[27636, 697, 149, 3, 43, "Input",
  CellTags->{"Controllability & Observability", "i:17", "b:31.0"}],
Cell[27788, 702, 130, 3, 41, "Output",
  CellTags->{"Controllability & Observability", "i:17", "b:31.0"}]
}, Open  ]],

Cell[CellGroupData[{
Cell[27955, 710, 186, 4, 43, "Input",
  CellTags->{"Controllability & Observability", "i:17", "b:31.0"}],
Cell[28144, 716, 131, 3, 41, "Output",
  CellTags->{"Controllability & Observability", "i:17", "b:31.0"}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[28324, 725, 101, 1, 53, "Subsection",
  CellTags->{"Controllability & Observability", "i:1", "b:31.1"}],
Cell[28428, 728, 192, 4, 39, "Text",
  CellTags->{"Controllability & Observability", "i:1", "b:31.1"}],

Cell[CellGroupData[{
Cell[28645, 736, 142, 3, 43, "Input",
  CellTags->{"Controllability & Observability", "i:1", "b:31.1"}],
Cell[28790, 741, 181, 3, 56, "Print",
  CellTags->{"Info3266691083-3416360", "i:1", "b:31.1"}]
}, Open  ]],
Cell[28986, 747, 280, 7, 123, "Input",
  CellTags->{"Controllability & Observability", "i:1", "b:31.1"}],

Cell[CellGroupData[{
Cell[29291, 758, 152, 3, 43, "Input",
  CellTags->{"Controllability & Observability", "i:1", "b:31.1"}],
Cell[29446, 763, 129, 3, 41, "Output",
  CellTags->{"Controllability & Observability", "i:1", "b:31.1"}]
}, Open  ]],
Cell[29590, 769, 107, 1, 39, "Text",
  CellTags->{"Controllability & Observability", "i:1", "b:31.1"}],

Cell[CellGroupData[{
Cell[29722, 774, 157, 3, 43, "Input",
  CellTags->{"Controllability & Observability", "i:1", "b:31.1"}],
Cell[29882, 779, 130, 3, 41, "Output",
  CellTags->{"Controllability & Observability", "i:1", "b:31.1"}]
}, Open  ]],

Cell[CellGroupData[{
Cell[30049, 787, 181, 3, 43, "Input",
  CellTags->{"Controllability & Observability", "i:1", "b:31.1"}],
Cell[30233, 792, 158, 3, 41, "Output",
  CellTags->{"Controllability & Observability", "i:1", "b:31.1"}]
}, Open  ]],

Cell[CellGroupData[{
Cell[30428, 800, 171, 3, 43, "Input",
  CellTags->{"Controllability & Observability", "i:1", "b:31.1"}],
Cell[30602, 805, 147, 3, 41, "Output",
  CellTags->{"Controllability & Observability", "i:1", "b:31.1"}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[30798, 814, 108, 1, 53, "Subsection",
  CellTags->{"Controllability & Observability", "i:17", "b:31.2"}],

Cell[CellGroupData[{
Cell[30931, 819, 148, 3, 43, "Input",
  CellTags->{"Controllability & Observability", "i:17", "b:31.2"}],
Cell[31082, 824, 554, 8, 246, "Print",
  CellTags->{"Info3266691083-1465963", "b:31.2"}]
}, Open  ]],
Cell[31651, 835, 345, 7, 103, "Input",
  CellTags->{"Controllability & Observability", "i:17", "b:31.2"}],

Cell[CellGroupData[{
Cell[32021, 846, 170, 3, 43, "Input",
  CellTags->{"Controllability & Observability", "i:17", "b:31.2"}],
Cell[32194, 851, 279, 5, 60, "Output",
  CellTags->{"Controllability & Observability", "i:17", "b:31.2"}]
}, Open  ]],

Cell[CellGroupData[{
Cell[32510, 861, 256, 6, 103, "Input",
  CellTags->{"Controllability & Observability", "i:17", "b:31.2"}],
Cell[32769, 869, 130, 3, 41, "Output",
  CellTags->{"Controllability & Observability", "i:17", "b:31.2"}]
}, Open  ]],

Cell[CellGroupData[{
Cell[32936, 877, 187, 4, 43, "Input",
  CellTags->{"Controllability & Observability", "i:17", "b:31.2"}],
Cell[33126, 883, 160, 3, 37, "Print",
  CellTags->{"Controllability & Observability", "i:17", "b:31.2"}],
Cell[33289, 888, 200, 4, 41, "Output",
  CellTags->{"Controllability & Observability", "i:17", "b:31.2"}]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[33550, 899, 110, 1, 70, "Section",
  CellTags->{"i:2", "b:32.0", "Exact Feedback Linearization"}],
Cell[33663, 902, 437, 8, 73, "Text",
  Evaluatable->False,
  CellTags->{"Exact Feedback Linearization", "i:18", "i:2", "b:32.0"}],
Cell[34103, 912, 147, 2, 39, "Text",
  Evaluatable->False,
  CellTags->{"Exact Feedback Linearization", "i:18", "i:2", "b:32.0"}],

Cell[CellGroupData[{
Cell[34275, 918, 472, 13, 104, "Input",
  CellTags->{"Exact Feedback Linearization", "i:18", "i:2", "b:32.0"}],
Cell[34750, 933, 134, 3, 41, "Output",
  CellTags->{"Exact Feedback Linearization", "i:18", "i:2", "b:32.0"}]
}, Open  ]],
Cell[34899, 939, 259, 5, 39, "Text",
  Evaluatable->False,
  CellTags->{"Exact Feedback Linearization", "i:18", "i:2", "b:32.0"}],

Cell[CellGroupData[{
Cell[35183, 948, 315, 9, 43, "Input",
  CellTags->{"Exact Feedback Linearization", "i:18", "i:2", "b:32.0"}],
Cell[35501, 959, 292, 6, 37, "Print",
  CellTags->{"Exact Feedback Linearization", "i:18", "i:2", "b:32.0"}],
Cell[35796, 967, 374, 7, 37, "Print",
  CellTags->{"Exact Feedback Linearization", "i:18", "i:2", "b:32.0"}],
Cell[36173, 976, 300, 6, 37, "Print",
  CellTags->{"Exact Feedback Linearization", "i:18", "i:2", "b:32.0"}],
Cell[36476, 984, 389, 9, 37, "Print",
  CellTags->{"Exact Feedback Linearization", "i:18", "i:2", "b:32.0"}],
Cell[36868, 995, 506, 12, 37, "Print",
  CellTags->{"Exact Feedback Linearization", "i:18", "i:2", "b:32.0"}],
Cell[37377, 1009, 207, 4, 41, "Output",
  CellTags->{"Exact Feedback Linearization", "i:18", "i:2", "b:32.0"}]
}, Open  ]],
Cell[37599, 1016, 330, 6, 56, "Text",
  Evaluatable->False,
  CellTags->{"Exact Feedback Linearization", "i:18", "i:2", "b:32.0"}],

Cell[CellGroupData[{
Cell[37954, 1026, 214, 5, 43, "Input",
  CellTags->{"Exact Feedback Linearization", "i:18", "i:2", "b:32.0"}],
Cell[38171, 1033, 591, 13, 37, "Print",
  CellTags->{"Exact Feedback Linearization", "i:18", "i:2", "b:32.0"}],
Cell[38765, 1048, 191, 4, 41, "Output",
  CellTags->{"Exact Feedback Linearization", "i:18", "i:2", "b:32.0"}]
}, Open  ]],

Cell[CellGroupData[{
Cell[38993, 1057, 222, 5, 43, "Input",
  CellTags->{"Exact Feedback Linearization", "i:18", "i:2", "b:32.0"}],
Cell[39218, 1064, 199, 4, 41, "Output",
  CellTags->{"Exact Feedback Linearization", "i:18", "i:2", "b:32.0"}]
}, Open  ]],
Cell[39432, 1071, 211, 6, 89, "Text",
  Evaluatable->False,
  CellTags->{"Exact Feedback Linearization", "i:18", "i:2", "b:32.0"}],
Cell[39646, 1079, 332, 7, 83, "Input",
  CellTags->{"Exact Feedback Linearization", "i:18", "i:2", "b:32.0"}],

Cell[CellGroupData[{
Cell[40003, 1090, 189, 4, 43, "Input",
  CellTags->{"Exact Feedback Linearization", "i:18", "i:2", "b:32.0"}],
Cell[40195, 1096, 135, 3, 41, "Output",
  CellTags->{"Exact Feedback Linearization", "i:18", "i:2", "b:32.0"}]
}, Open  ]],
Cell[40345, 1102, 286, 6, 56, "Text",
  Evaluatable->False,
  CellTags->{"Exact Feedback Linearization", "i:18", "i:2", "b:32.0"}],

Cell[CellGroupData[{
Cell[40656, 1112, 184, 4, 43, "Input",
  CellTags->{"Exact Feedback Linearization", "i:18", "i:2", "b:32.0"}],
Cell[40843, 1118, 134, 3, 41, "Output",
  CellTags->{"Exact Feedback Linearization", "i:18", "i:2", "b:32.0"}]
}, Open  ]],
Cell[40992, 1124, 237, 5, 39, "Text",
  Evaluatable->False,
  CellTags->{"Exact Feedback Linearization", "i:18", "i:2", "b:32.0"}],

Cell[CellGroupData[{
Cell[41254, 1133, 228, 5, 63, "Input",
  CellTags->{"Exact Feedback Linearization", "i:18", "i:2", "b:32.0"}],
Cell[41485, 1140, 135, 3, 41, "Output",
  CellTags->{"Exact Feedback Linearization", "i:18", "i:2", "b:32.0"}]
}, Open  ]],

Cell[CellGroupData[{
Cell[41657, 1148, 226, 5, 43, "Input",
  CellTags->{"Exact Feedback Linearization", "i:18", "i:2", "b:32.0"}],
Cell[41886, 1155, 134, 3, 41, "Output",
  CellTags->{"Exact Feedback Linearization", "i:18", "i:2", "b:32.0"}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[42069, 1164, 186, 3, 70, "Section",
  Evaluatable->False,
  CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],

Cell[CellGroupData[{
Cell[42280, 1171, 156, 2, 53, "Subsection",
  Evaluatable->False,
  CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
Cell[42439, 1175, 1256, 26, 124, "Text",
  Evaluatable->False,
  CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
Cell[43698, 1203, 426, 14, 39, "Text",
  Evaluatable->False,
  CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],

Cell[CellGroupData[{
Cell[44149, 1221, 515, 12, 104, "Input",
  CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
Cell[44667, 1235, 191, 4, 54, "Output",
  CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}]
}, Open  ]],

Cell[CellGroupData[{
Cell[44895, 1244, 365, 10, 63, "Input",
  CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
Cell[45263, 1256, 730, 19, 46, "Print",
  CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
Cell[45996, 1277, 182, 4, 50, "Output",
  CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}]
}, Open  ]],
Cell[46193, 1284, 364, 11, 43, "Input",
  CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
Cell[46560, 1297, 273, 6, 56, "Text",
  Evaluatable->False,
  CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],

Cell[CellGroupData[{
Cell[46858, 1307, 363, 7, 43, "Input",
  CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
Cell[47224, 1316, 594, 14, 54, "Output",
  CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}]
}, Open  ]],
Cell[47833, 1333, 158, 2, 39, "Text",
  Evaluatable->False,
  CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
Cell[47994, 1337, 398, 11, 63, "Input",
  CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],

Cell[CellGroupData[{
Cell[48417, 1352, 317, 9, 43, "Input",
  CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
Cell[48737, 1363, 460, 8, 49, "Message",
  CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
Cell[49200, 1373, 168, 3, 41, "Output",
  CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}]
}, Open  ]],

Cell[CellGroupData[{
Cell[49405, 1381, 285, 9, 43, "Input",
  CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
Cell[49693, 1392, 164, 3, 41, "Output",
  CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}]
}, Open  ]],

Cell[CellGroupData[{
Cell[49894, 1400, 321, 9, 43, "Input",
  CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
Cell[50218, 1411, 501, 8, 51, "Message",
  CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
Cell[50722, 1421, 460, 8, 49, "Message",
  CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
Cell[51185, 1431, 472, 10, 37, "Print",
  CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
Cell[51660, 1443, 164, 3, 41, "Output",
  CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}]
}, Open  ]],
Cell[51839, 1449, 357, 7, 56, "Text",
  Evaluatable->False,
  CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],

Cell[CellGroupData[{
Cell[52221, 1460, 302, 9, 43, "Input",
  CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
Cell[52526, 1471, 159, 3, 41, "Output",
  CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}]
}, Open  ]],
Cell[52700, 1477, 153, 2, 39, "Text",
  Evaluatable->False,
  CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],

Cell[CellGroupData[{
Cell[52878, 1483, 348, 11, 43, "Input",
  CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
Cell[53229, 1496, 285, 6, 41, "Output",
  CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}]
}, Open  ]],

Cell[CellGroupData[{
Cell[53551, 1507, 420, 11, 43, "Input",
  CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
Cell[53974, 1520, 300, 8, 41, "Output",
  CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[54323, 1534, 168, 3, 53, "Subsection",
  Evaluatable->False,
  CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
Cell[54494, 1539, 475, 8, 73, "Text",
  Evaluatable->False,
  CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],

Cell[CellGroupData[{
Cell[54994, 1551, 178, 4, 43, "Input",
  CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
Cell[55175, 1557, 122, 3, 41, "Output",
  CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}]
}, Open  ]],

Cell[CellGroupData[{
Cell[55334, 1565, 300, 9, 43, "Input",
  CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
Cell[55637, 1576, 122, 3, 41, "Output",
  CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}]
}, Open  ]],
Cell[55774, 1582, 337, 6, 56, "Text",
  Evaluatable->False,
  CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],

Cell[CellGroupData[{
Cell[56136, 1592, 306, 9, 43, "Input",
  CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
Cell[56445, 1603, 124, 3, 41, "Output",
  CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}]
}, Open  ]],
Cell[56584, 1609, 630, 18, 56, "Text",
  Evaluatable->False,
  CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
Cell[57217, 1629, 315, 7, 123, "Input",
  CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
Cell[57535, 1638, 472, 16, 39, "Text",
  Evaluatable->False,
  CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],

Cell[CellGroupData[{
Cell[58032, 1658, 211, 5, 43, "Input",
  CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
Cell[58246, 1665, 124, 3, 41, "Output",
  CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}]
}, Open  ]],

Cell[CellGroupData[{
Cell[58407, 1673, 207, 5, 43, "Input",
  CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
Cell[58617, 1680, 178, 3, 41, "Output",
  CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}]
}, Open  ]],
Cell[58810, 1686, 239, 5, 39, "Text",
  Evaluatable->False,
  CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],

Cell[CellGroupData[{
Cell[59074, 1695, 226, 5, 43, "Input",
  CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
Cell[59303, 1702, 154, 3, 37, "Print",
  CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
Cell[59460, 1707, 167, 3, 37, "Print",
  CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
Cell[59630, 1712, 342, 6, 58, "Output",
  CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}]
}, Open  ]],
Cell[59987, 1721, 178, 4, 39, "Text",
  Evaluatable->False,
  CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],

Cell[CellGroupData[{
Cell[60190, 1729, 212, 5, 43, "Input",
  CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
Cell[60405, 1736, 151, 3, 41, "Output",
  CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}]
}, Open  ]],
Cell[60571, 1742, 190, 5, 39, "Text",
  Evaluatable->False,
  CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],

Cell[CellGroupData[{
Cell[60786, 1751, 199, 5, 43, "Input",
  CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
Cell[60988, 1758, 211, 4, 58, "Output",
  CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}]
}, Open  ]],

Cell[CellGroupData[{
Cell[61236, 1767, 211, 5, 43, "Input",
  CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
Cell[61450, 1774, 165, 3, 37, "Print",
  CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
Cell[61618, 1779, 154, 3, 37, "Print",
  CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}],
Cell[61775, 1784, 123, 3, 41, "Output",
  CellTags->{"Input-Output Linearization", "i:19", "b:32.1"}]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[61959, 1794, 137, 3, 70, "Section",
  Evaluatable->False,
  CellTags->{"Dynamic extension", "i:20", "b:32.2"}],
Cell[62099, 1799, 337, 7, 56, "Text",
  Evaluatable->False,
  CellTags->{"Dynamic extension", "i:20", "b:32.2"}],
Cell[62439, 1808, 299, 7, 123, "Input",
  CellTags->{"Dynamic extension", "i:20", "b:32.2"}],

Cell[CellGroupData[{
Cell[62763, 1819, 198, 5, 43, "Input",
  CellTags->{"Dynamic extension", "i:20", "b:32.2"}],
Cell[62964, 1826, 145, 3, 37, "Print",
  CellTags->{"Dynamic extension", "i:20", "b:32.2"}],
Cell[63112, 1831, 226, 5, 41, "Output",
  CellTags->{"Dynamic extension", "i:20", "b:32.2"}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[63387, 1842, 85, 1, 70, "Section",
  CellTags->{"Dynamic Inverse", "i:21", "b:32.3"}],
Cell[63475, 1845, 492, 8, 73, "Text",
  CellTags->{"Dynamic Inverse", "i:21", "b:32.3"}],
Cell[63970, 1855, 245, 5, 83, "Input",
  CellTags->{"Dynamic Inverse", "i:21", "b:32.3"}],

Cell[CellGroupData[{
Cell[64240, 1864, 161, 3, 43, "Input",
  CellTags->{"Dynamic Inverse", "i:21", "b:32.3"}],
Cell[64404, 1869, 1051, 27, 41, "Output",
  CellTags->{"Dynamic Inverse", "i:21", "b:32.3"}]
}, Open  ]],
Cell[65470, 1899, 112, 1, 39, "Text",
  CellTags->{"Dynamic Inverse", "i:21", "b:32.3"}],

Cell[CellGroupData[{
Cell[65607, 1904, 150, 3, 43, "Input",
  CellTags->{"Dynamic Inverse", "i:21", "b:32.3"}],
Cell[65760, 1909, 758, 19, 56, "Output",
  CellTags->{"Dynamic Inverse", "i:21", "b:32.3"}]
}, Open  ]],

Cell[CellGroupData[{
Cell[66555, 1933, 118, 3, 43, "Input",
  CellTags->{"Dynamic Inverse", "i:21", "b:32.3"}],
Cell[66676, 1938, 973, 25, 56, "Output",
  CellTags->{"Dynamic Inverse", "i:21", "b:32.3"}]
}, Open  ]],
Cell[67664, 1966, 127, 1, 39, "Text",
  CellTags->{"Dynamic Inverse", "i:21", "b:32.3"}],

Cell[CellGroupData[{
Cell[67816, 1971, 132, 3, 43, "Input",
  CellTags->{"Dynamic Inverse", "i:21", "b:32.3"}],
Cell[67951, 1976, 143, 3, 37, "Print",
  CellTags->{"Dynamic Inverse", "i:21", "b:32.3"}],
Cell[68097, 1981, 146, 3, 37, "Print",
  CellTags->{"Dynamic Inverse", "i:21", "b:32.3"}]
}, Open  ]],

Cell[CellGroupData[{
Cell[68280, 1989, 164, 3, 43, "Input",
  CellTags->{"Dynamic Inverse", "i:21", "b:32.3"}],
Cell[68447, 1994, 143, 3, 37, "Print",
  CellTags->{"Dynamic Inverse", "i:21", "b:32.3"}],
Cell[68593, 1999, 231, 5, 41, "Output",
  CellTags->{"Dynamic Inverse", "i:21", "b:32.3"}]
}, Open  ]],

Cell[CellGroupData[{
Cell[68861, 2009, 166, 3, 43, "Input",
  CellTags->{"Dynamic Inverse", "i:21", "b:32.3"}],
Cell[69030, 2014, 143, 3, 37, "Print",
  CellTags->{"Dynamic Inverse", "i:21", "b:32.3"}],
Cell[69176, 2019, 156, 3, 37, "Print",
  CellTags->{"Dynamic Inverse", "i:21", "b:32.3"}],
Cell[69335, 2024, 196, 4, 54, "Output",
  CellTags->{"Dynamic Inverse", "i:21", "b:32.3"}]
}, Open  ]],

Cell[CellGroupData[{
Cell[69568, 2033, 266, 5, 63, "Input",
  CellTags->{"Dynamic Inverse", "i:21", "b:32.3"}],
Cell[69837, 2040, 1402, 40, 124, "Output",
  CellTags->{"Dynamic Inverse", "i:21", "b:32.3"}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[71288, 2086, 125, 3, 70, "Section",
  Evaluatable->False,
  CellTags->{"Adaptive Control", "i:22"}],

Cell[CellGroupData[{
Cell[71438, 2093, 115, 2, 53, "Subsection",
  Evaluatable->False,
  CellTags->{"Adaptive Control", "i:22", "b:33.0"}],
Cell[71556, 2097, 191, 5, 39, "Text",
  Evaluatable->False,
  CellTags->{"Adaptive Control", "i:22", "b:33.0"}],
Cell[71750, 2104, 341, 7, 123, "Input",
  CellTags->{"Adaptive Control", "i:22", "b:33.0"}],
Cell[72094, 2113, 243, 5, 39, "Text",
  Evaluatable->False,
  CellTags->{"Adaptive Control", "i:22", "b:33.0"}],

Cell[CellGroupData[{
Cell[72362, 2122, 328, 10, 43, "Input",
  CellTags->{"Adaptive Control", "i:22", "b:33.0"}],
Cell[72693, 2134, 115, 3, 41, "Output",
  CellTags->{"Adaptive Control", "i:22", "b:33.0"}]
}, Open  ]],
Cell[72823, 2140, 313, 10, 43, "Input",
  CellTags->{"Adaptive Control", "i:22", "b:33.0"}],
Cell[73139, 2152, 123, 2, 39, "Text",
  Evaluatable->False,
  CellTags->{"Adaptive Control", "i:22", "b:33.0"}],

Cell[CellGroupData[{
Cell[73287, 2158, 351, 11, 43, "Input",
  CellTags->{"Adaptive Control", "i:22", "b:33.0"}],
Cell[73641, 2171, 145, 3, 37, "Print",
  CellTags->{"Adaptive Control", "i:22", "b:33.0"}],
Cell[73789, 2176, 158, 3, 37, "Print",
  CellTags->{"Adaptive Control", "i:22", "b:33.0"}],
Cell[73950, 2181, 146, 3, 37, "Print",
  CellTags->{"Adaptive Control", "i:22", "b:33.0"}],
Cell[74099, 2186, 254, 5, 37, "Print",
  CellTags->{"Adaptive Control", "i:22", "b:33.0"}],
Cell[74356, 2193, 146, 3, 37, "Print",
  CellTags->{"Adaptive Control", "i:22", "b:33.0"}],
Cell[74505, 2198, 148, 3, 37, "Print",
  CellTags->{"Adaptive Control", "i:22", "b:33.0"}],
Cell[74656, 2203, 144, 3, 37, "Print",
  CellTags->{"Adaptive Control", "i:22", "b:33.0"}],
Cell[74803, 2208, 147, 3, 37, "Print",
  CellTags->{"Adaptive Control", "i:22", "b:33.0"}],
Cell[74953, 2213, 542, 9, 123, "Output",
  CellTags->{"Adaptive Control", "i:22", "b:33.0"}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[75544, 2228, 108, 1, 53, "Subsection",
  CellTags->{"Adaptive Control", "i:4", "b:33.1"}],
Cell[75655, 2231, 1072, 25, 157, "Text",
  Evaluatable->False,
  CellTags->{"Adaptive Control", "i:4", "b:33.1"}],
Cell[76730, 2258, 357, 11, 64, "Input",
  CellTags->{"Adaptive Control", "i:4", "b:33.1"}],

Cell[CellGroupData[{
Cell[77112, 2273, 307, 9, 43, "Input",
  CellTags->{"Adaptive Control", "i:4", "b:33.1"}],
Cell[77422, 2284, 555, 9, 170, "Print",
  CellTags->{
  "Info3266691090-8486293", "i:3", "i:4", "b:33.1", "Adaptive Control"}]
}, Open  ]],

Cell[CellGroupData[{
Cell[78014, 2298, 323, 10, 43, "Input",
  CellTags->{"Adaptive Control", "i:4", "b:33.1"}],
Cell[78340, 2310, 283, 6, 37, "Print",
  CellTags->{"Adaptive Control", "i:4", "b:33.1"}],
Cell[78626, 2318, 299, 6, 37, "Print",
  CellTags->{"Adaptive Control", "i:4", "b:33.1"}],
Cell[78928, 2326, 299, 6, 37, "Print",
  CellTags->{"Adaptive Control", "i:4", "b:33.1"}],
Cell[79230, 2334, 160, 3, 56, "Print",
  CellTags->{"Adaptive Control", "i:4", "b:33.1"}],
Cell[79393, 2339, 273, 6, 37, "Print",
  CellTags->{"Adaptive Control", "i:4", "b:33.1"}],
Cell[79669, 2347, 317, 6, 56, "Print",
  CellTags->{"Adaptive Control", "i:4", "b:33.1"}],
Cell[79989, 2355, 281, 6, 37, "Print",
  CellTags->{"Adaptive Control", "i:4", "b:33.1"}],
Cell[80273, 2363, 281, 6, 37, "Print",
  CellTags->{"Adaptive Control", "i:4", "b:33.1"}],
Cell[80557, 2371, 281, 6, 37, "Print",
  CellTags->{"Adaptive Control", "i:4", "b:33.1"}],
Cell[80841, 2379, 164, 3, 41, "Output",
  CellTags->{"Adaptive Control", "i:4", "b:33.1"}]
}, Open  ]],
Cell[81020, 2385, 491, 15, 39, "Text",
  Evaluatable->False,
  CellTags->{"Adaptive Control", "i:4", "b:33.1"}],

Cell[CellGroupData[{
Cell[81536, 2404, 356, 11, 43, "Input",
  CellTags->{"Adaptive Control", "i:4", "b:33.1"}],
Cell[81895, 2417, 508, 7, 151, "Print",
  CellTags->{"Info3266691090-6166343", "i:4", "b:33.1", "Adaptive Control"}]
}, Open  ]],
Cell[82418, 2427, 398, 12, 43, "Input",
  CellTags->{"Adaptive Control", "i:4", "b:33.1"}],

Cell[CellGroupData[{
Cell[82841, 2443, 135, 4, 43, "Input",
  CellTags->{"Adaptive Control", "i:4", "b:33.1"}],
Cell[82979, 2449, 2603, 43, 383, "Output",
  CellTags->{"Adaptive Control", "i:4", "b:33.1"}]
}, Open  ]],

Cell[CellGroupData[{
Cell[85619, 2497, 135, 4, 43, "Input",
  CellTags->{"Adaptive Control", "i:4", "b:33.1"}],
Cell[85757, 2503, 1066, 17, 155, "Output",
  CellTags->{"Adaptive Control", "i:4", "b:33.1"}]
}, Open  ]],

Cell[CellGroupData[{
Cell[86860, 2525, 135, 4, 43, "Input",
  CellTags->{"Adaptive Control", "i:4", "b:33.1"}],
Cell[86998, 2531, 508, 10, 79, "Output",
  CellTags->{"Adaptive Control", "i:4", "b:33.1"}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[87555, 2547, 113, 2, 53, "Subsection",
  Evaluatable->False,
  CellTags->{"Adaptive Control", "i:22", "b:33.2"}],
Cell[87671, 2551, 236, 6, 39, "Text",
  Evaluatable->False,
  CellTags->{"Adaptive Control", "i:22", "b:33.2"}],
Cell[87910, 2559, 511, 11, 223, "Input",
  CellTags->{"Adaptive Control", "i:22", "b:33.2"}],
Cell[88424, 2572, 148, 3, 39, "Text",
  Evaluatable->False,
  CellTags->{"Adaptive Control", "i:22", "b:33.2"}],

Cell[CellGroupData[{
Cell[88597, 2579, 267, 7, 43, "Input",
  CellTags->{"Adaptive Control", "i:22", "b:33.2"}],
Cell[88867, 2588, 128, 3, 41, "Output",
  CellTags->{"Adaptive Control", "i:22", "b:33.2"}]
}, Open  ]],
Cell[89010, 2594, 163, 3, 39, "Text",
  Evaluatable->False,
  CellTags->{"Adaptive Control", "i:22", "b:33.2"}],
Cell[89176, 2599, 217, 5, 43, "Input",
  CellTags->{"Adaptive Control", "i:22", "b:33.2"}],
Cell[89396, 2606, 153, 3, 39, "Text",
  Evaluatable->False,
  CellTags->{"Adaptive Control", "i:22", "b:33.2"}],

Cell[CellGroupData[{
Cell[89574, 2613, 236, 6, 43, "Input",
  CellTags->{"Adaptive Control", "i:22", "b:33.2"}],
Cell[89813, 2621, 145, 3, 37, "Print",
  CellTags->{"Adaptive Control", "i:22", "b:33.2"}],
Cell[89961, 2626, 244, 5, 37, "Print",
  CellTags->{"Adaptive Control", "i:22", "b:33.2"}],
Cell[90208, 2633, 135, 3, 37, "Print",
  CellTags->{"Adaptive Control", "i:22", "b:33.2"}],
Cell[90346, 2638, 148, 3, 37, "Print",
  CellTags->{"Adaptive Control", "i:22", "b:33.2"}],
Cell[90497, 2643, 160, 3, 37, "Print",
  CellTags->{"Adaptive Control", "i:22", "b:33.2"}],
Cell[90660, 2648, 173, 3, 37, "Print",
  CellTags->{"Adaptive Control", "i:22", "b:33.2"}],
Cell[90836, 2653, 24573, 470, 790, "Output",
  CellTags->{"Adaptive Control", "i:22", "b:33.2"}]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[115470, 3130, 133, 2, 70, "Section",
  Evaluatable->False,
  CellTags->{"Creating SIMULINK S-Functions", "i:23", "b:34"}],

Cell[CellGroupData[{
Cell[115628, 3136, 185, 5, 63, "Input",
  CellTags->"b:34"],
Cell[115816, 3143, 711, 11, 417, "Print",
  CellTags->"b:34"]
}, Open  ]],
Cell[116542, 3157, 1022, 16, 149, "Text",
  Evaluatable->False,
  CellTags->{"Creating SIMULINK S-Functions", "i:23", "b:34"}],
Cell[117567, 3175, 619, 17, 155, "Input",
  CellTags->{"Creating SIMULINK S-Functions", "i:23", "b:34"}],

Cell[CellGroupData[{
Cell[118211, 3196, 294, 9, 43, "Input",
  CellTags->{"Creating SIMULINK S-Functions", "i:23", "b:34"}],
Cell[118508, 3207, 262, 5, 58, "Output",
  CellTags->{"Creating SIMULINK S-Functions", "i:23", "b:34"}]
}, Open  ]],
Cell[118785, 3215, 199, 5, 39, "Text",
  Evaluatable->False,
  CellTags->{"Creating SIMULINK S-Functions", "i:23", "b:34"}],

Cell[CellGroupData[{
Cell[119009, 3224, 358, 10, 43, "Input",
  CellTags->{"Creating SIMULINK S-Functions", "i:23", "b:34"}],
Cell[119370, 3236, 167, 3, 37, "Print",
  CellTags->{"Creating SIMULINK S-Functions", "i:23", "b:34"}],
Cell[119540, 3241, 154, 3, 37, "Print",
  CellTags->{"Creating SIMULINK S-Functions", "i:23", "b:34"}],
Cell[119697, 3246, 174, 3, 37, "Print",
  CellTags->{"Creating SIMULINK S-Functions", "i:23", "b:34"}],
Cell[119874, 3251, 173, 3, 37, "Print",
  CellTags->{"Creating SIMULINK S-Functions", "i:23", "b:34"}],
Cell[120050, 3256, 155, 3, 37, "Print",
  CellTags->{"Creating SIMULINK S-Functions", "i:23", "b:34"}],
Cell[120208, 3261, 169, 3, 37, "Print",
  CellTags->{"Creating SIMULINK S-Functions", "i:23", "b:34"}],
Cell[120380, 3266, 164, 3, 37, "Print",
  CellTags->{"Creating SIMULINK S-Functions", "i:23", "b:34"}],
Cell[120547, 3271, 163, 3, 37, "Print",
  CellTags->{"Creating SIMULINK S-Functions", "i:23", "b:34"}],
Cell[120713, 3276, 164, 3, 37, "Print",
  CellTags->{"Creating SIMULINK S-Functions", "i:23", "b:34"}]
}, Open  ]],
Cell[120892, 3282, 503, 9, 73, "Text",
  Evaluatable->False,
  CellTags->{"Creating SIMULINK S-Functions", "i:23", "b:34"}],

Cell[CellGroupData[{
Cell[121420, 3295, 361, 10, 43, "Input",
  CellTags->{"Creating SIMULINK S-Functions", "i:23", "b:34"}],
Cell[121784, 3307, 154, 3, 37, "Print",
  CellTags->{"Creating SIMULINK S-Functions", "i:23", "b:34"}],
Cell[121941, 3312, 174, 3, 37, "Print",
  CellTags->{"Creating SIMULINK S-Functions", "i:23", "b:34"}],
Cell[122118, 3317, 173, 3, 37, "Print",
  CellTags->{"Creating SIMULINK S-Functions", "i:23", "b:34"}],
Cell[122294, 3322, 155, 3, 37, "Print",
  CellTags->{"Creating SIMULINK S-Functions", "i:23", "b:34"}],
Cell[122452, 3327, 169, 3, 37, "Print",
  CellTags->{"Creating SIMULINK S-Functions", "i:23", "b:34"}],
Cell[122624, 3332, 164, 3, 37, "Print",
  CellTags->{"Creating SIMULINK S-Functions", "i:23", "b:34"}],
Cell[122791, 3337, 163, 3, 37, "Print",
  CellTags->{"Creating SIMULINK S-Functions", "i:23", "b:34"}],
Cell[122957, 3342, 165, 3, 37, "Print",
  CellTags->{"Creating SIMULINK S-Functions", "i:23", "b:34"}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[123171, 3351, 69, 1, 70, "Section",
  CellTags->{"Bibliography", "b:35"}],
Cell[123243, 3354, 850, 17, 256, "Text",
  CellTags->"Bibliography"],
Cell[124096, 3373, 1025, 20, 264, "Text",
  CellTags->{"Bibliography", "b:35"}]
}, Open  ]]
}
]
*)



(*******************************************************************
End of Mathematica Notebook file.
*******************************************************************)

